<?php
// Not inluded within the standard distribution

function gb2312($string)
{
	static $transform = array(
		"\xA1\xA1" => "\xE3\x80\x80",
		"\xA1\xA2" => "\xE3\x80\x81",
		"\xA1\xA3" => "\xE3\x80\x82",
		"\xA1\xA4" => "\xE3\x83\xBB",
		"\xA1\xA5" => "\xCB\x89",
		"\xA1\xA6" => "\xCB\x87",
		"\xA1\xA7" => "\xC2\xA8",
		"\xA1\xA8" => "\xE3\x80\x83",
		"\xA1\xA9" => "\xE3\x80\x85",
		"\xA1\xAA" => "\xE2\x80\x95",
		"\xA1\xAB" => "\xEF\xBD\x9E",
		"\xA1\xAC" => "\xE2\x80\x96",
		"\xA1\xAD" => "\xE2\x80\xA6",
		"\xA1\xAE" => "\xE2\x80\x98",
		"\xA1\xAF" => "\xE2\x80\x99",
		"\xA1\xB0" => "\xE2\x80\x9C",
		"\xA1\xB1" => "\xE2\x80\x9D",
		"\xA1\xB2" => "\xE3\x80\x94",
		"\xA1\xB3" => "\xE3\x80\x95",
		"\xA1\xB4" => "\xE3\x80\x88",
		"\xA1\xB5" => "\xE3\x80\x89",
		"\xA1\xB6" => "\xE3\x80\x8A",
		"\xA1\xB7" => "\xE3\x80\x8B",
		"\xA1\xB8" => "\xE3\x80\x8C",
		"\xA1\xB9" => "\xE3\x80\x8D",
		"\xA1\xBA" => "\xE3\x80\x8E",
		"\xA1\xBB" => "\xE3\x80\x8F",
		"\xA1\xBC" => "\xE3\x80\x96",
		"\xA1\xBD" => "\xE3\x80\x97",
		"\xA1\xBE" => "\xE3\x80\x90",
		"\xA1\xBF" => "\xE3\x80\x91",
		"\xA1\xC0" => "\xC2\xB1",
		"\xA1\xC1" => "\xC3\x97",
		"\xA1\xC2" => "\xC3\xB7",
		"\xA1\xC3" => "\xE2\x88\xB6",
		"\xA1\xC4" => "\xE2\x88\xA7",
		"\xA1\xC5" => "\xE2\x88\xA8",
		"\xA1\xC6" => "\xE2\x88\x91",
		"\xA1\xC7" => "\xE2\x88\x8F",
		"\xA1\xC8" => "\xE2\x88\xAA",
		"\xA1\xC9" => "\xE2\x88\xA9",
		"\xA1\xCA" => "\xE2\x88\x88",
		"\xA1\xCB" => "\xE2\x88\xB7",
		"\xA1\xCC" => "\xE2\x88\x9A",
		"\xA1\xCD" => "\xE2\x8A\xA5",
		"\xA1\xCE" => "\xE2\x88\xA5",
		"\xA1\xCF" => "\xE2\x88\xA0",
		"\xA1\xD0" => "\xE2\x8C\x92",
		"\xA1\xD1" => "\xE2\x8A\x99",
		"\xA1\xD2" => "\xE2\x88\xAB",
		"\xA1\xD3" => "\xE2\x88\xAE",
		"\xA1\xD4" => "\xE2\x89\xA1",
		"\xA1\xD5" => "\xE2\x89\x8C",
		"\xA1\xD6" => "\xE2\x89\x88",
		"\xA1\xD7" => "\xE2\x88\xBD",
		"\xA1\xD8" => "\xE2\x88\x9D",
		"\xA1\xD9" => "\xE2\x89\xA0",
		"\xA1\xDA" => "\xE2\x89\xAE",
		"\xA1\xDB" => "\xE2\x89\xAF",
		"\xA1\xDC" => "\xE2\x89\xA4",
		"\xA1\xDD" => "\xE2\x89\xA5",
		"\xA1\xDE" => "\xE2\x88\x9E",
		"\xA1\xDF" => "\xE2\x88\xB5",
		"\xA1\xE0" => "\xE2\x88\xB4",
		"\xA1\xE1" => "\xE2\x99\x82",
		"\xA1\xE2" => "\xE2\x99\x80",
		"\xA1\xE3" => "\xC2\xB0",
		"\xA1\xE4" => "\xE2\x80\xB2",
		"\xA1\xE5" => "\xE2\x80\xB3",
		"\xA1\xE6" => "\xE2\x84\x83",
		"\xA1\xE7" => "\xEF\xBC\x84",
		"\xA1\xE8" => "\xC2\xA4",
		"\xA1\xE9" => "\xEF\xBF\xA0",
		"\xA1\xEA" => "\xEF\xBF\xA1",
		"\xA1\xEB" => "\xE2\x80\xB0",
		"\xA1\xEC" => "\xC2\xA7",
		"\xA1\xED" => "\xE2\x84\x96",
		"\xA1\xEE" => "\xE2\x98\x86",
		"\xA1\xEF" => "\xE2\x98\x85",
		"\xA1\xF0" => "\xE2\x97\x8B",
		"\xA1\xF1" => "\xE2\x97\x8F",
		"\xA1\xF2" => "\xE2\x97\x8E",
		"\xA1\xF3" => "\xE2\x97\x87",
		"\xA1\xF4" => "\xE2\x97\x86",
		"\xA1\xF5" => "\xE2\x96\xA1",
		"\xA1\xF6" => "\xE2\x96\xA0",
		"\xA1\xF7" => "\xE2\x96\xB3",
		"\xA1\xF8" => "\xE2\x96\xB2",
		"\xA1\xF9" => "\xE2\x80\xBB",
		"\xA1\xFA" => "\xE2\x86\x92",
		"\xA1\xFB" => "\xE2\x86\x90",
		"\xA1\xFC" => "\xE2\x86\x91",
		"\xA1\xFD" => "\xE2\x86\x93",
		"\xA1\xFE" => "\xE3\x80\x93",
		"\xA2\xB1" => "\xE2\x92\x88",
		"\xA2\xB2" => "\xE2\x92\x89",
		"\xA2\xB3" => "\xE2\x92\x8A",
		"\xA2\xB4" => "\xE2\x92\x8B",
		"\xA2\xB5" => "\xE2\x92\x8C",
		"\xA2\xB6" => "\xE2\x92\x8D",
		"\xA2\xB7" => "\xE2\x92\x8E",
		"\xA2\xB8" => "\xE2\x92\x8F",
		"\xA2\xB9" => "\xE2\x92\x90",
		"\xA2\xBA" => "\xE2\x92\x91",
		"\xA2\xBB" => "\xE2\x92\x92",
		"\xA2\xBC" => "\xE2\x92\x93",
		"\xA2\xBD" => "\xE2\x92\x94",
		"\xA2\xBE" => "\xE2\x92\x95",
		"\xA2\xBF" => "\xE2\x92\x96",
		"\xA2\xC0" => "\xE2\x92\x97",
		"\xA2\xC1" => "\xE2\x92\x98",
		"\xA2\xC2" => "\xE2\x92\x99",
		"\xA2\xC3" => "\xE2\x92\x9A",
		"\xA2\xC4" => "\xE2\x92\x9B",
		"\xA2\xC5" => "\xE2\x91\xB4",
		"\xA2\xC6" => "\xE2\x91\xB5",
		"\xA2\xC7" => "\xE2\x91\xB6",
		"\xA2\xC8" => "\xE2\x91\xB7",
		"\xA2\xC9" => "\xE2\x91\xB8",
		"\xA2\xCA" => "\xE2\x91\xB9",
		"\xA2\xCB" => "\xE2\x91\xBA",
		"\xA2\xCC" => "\xE2\x91\xBB",
		"\xA2\xCD" => "\xE2\x91\xBC",
		"\xA2\xCE" => "\xE2\x91\xBD",
		"\xA2\xCF" => "\xE2\x91\xBE",
		"\xA2\xD0" => "\xE2\x91\xBF",
		"\xA2\xD1" => "\xE2\x92\x80",
		"\xA2\xD2" => "\xE2\x92\x81",
		"\xA2\xD3" => "\xE2\x92\x82",
		"\xA2\xD4" => "\xE2\x92\x83",
		"\xA2\xD5" => "\xE2\x92\x84",
		"\xA2\xD6" => "\xE2\x92\x85",
		"\xA2\xD7" => "\xE2\x92\x86",
		"\xA2\xD8" => "\xE2\x92\x87",
		"\xA2\xD9" => "\xE2\x91\xA0",
		"\xA2\xDA" => "\xE2\x91\xA1",
		"\xA2\xDB" => "\xE2\x91\xA2",
		"\xA2\xDC" => "\xE2\x91\xA3",
		"\xA2\xDD" => "\xE2\x91\xA4",
		"\xA2\xDE" => "\xE2\x91\xA5",
		"\xA2\xDF" => "\xE2\x91\xA6",
		"\xA2\xE0" => "\xE2\x91\xA7",
		"\xA2\xE1" => "\xE2\x91\xA8",
		"\xA2\xE2" => "\xE2\x91\xA9",
		"\xA2\xE5" => "\xE3\x88\xA0",
		"\xA2\xE6" => "\xE3\x88\xA1",
		"\xA2\xE7" => "\xE3\x88\xA2",
		"\xA2\xE8" => "\xE3\x88\xA3",
		"\xA2\xE9" => "\xE3\x88\xA4",
		"\xA2\xEA" => "\xE3\x88\xA5",
		"\xA2\xEB" => "\xE3\x88\xA6",
		"\xA2\xEC" => "\xE3\x88\xA7",
		"\xA2\xED" => "\xE3\x88\xA8",
		"\xA2\xEE" => "\xE3\x88\xA9",
		"\xA2\xF1" => "\xE2\x85\xA0",
		"\xA2\xF2" => "\xE2\x85\xA1",
		"\xA2\xF3" => "\xE2\x85\xA2",
		"\xA2\xF4" => "\xE2\x85\xA3",
		"\xA2\xF5" => "\xE2\x85\xA4",
		"\xA2\xF6" => "\xE2\x85\xA5",
		"\xA2\xF7" => "\xE2\x85\xA6",
		"\xA2\xF8" => "\xE2\x85\xA7",
		"\xA2\xF9" => "\xE2\x85\xA8",
		"\xA2\xFA" => "\xE2\x85\xA9",
		"\xA2\xFB" => "\xE2\x85\xAA",
		"\xA2\xFC" => "\xE2\x85\xAB",
		"\xA3\xA1" => "\xEF\xBC\x81",
		"\xA3\xA2" => "\xEF\xBC\x82",
		"\xA3\xA3" => "\xEF\xBC\x83",
		"\xA3\xA4" => "\xEF\xBF\xA5",
		"\xA3\xA5" => "\xEF\xBC\x85",
		"\xA3\xA6" => "\xEF\xBC\x86",
		"\xA3\xA7" => "\xEF\xBC\x87",
		"\xA3\xA8" => "\xEF\xBC\x88",
		"\xA3\xA9" => "\xEF\xBC\x89",
		"\xA3\xAA" => "\xEF\xBC\x8A",
		"\xA3\xAB" => "\xEF\xBC\x8B",
		"\xA3\xAC" => "\xEF\xBC\x8C",
		"\xA3\xAD" => "\xEF\xBC\x8D",
		"\xA3\xAE" => "\xEF\xBC\x8E",
		"\xA3\xAF" => "\xEF\xBC\x8F",
		"\xA3\xB0" => "\xEF\xBC\x90",
		"\xA3\xB1" => "\xEF\xBC\x91",
		"\xA3\xB2" => "\xEF\xBC\x92",
		"\xA3\xB3" => "\xEF\xBC\x93",
		"\xA3\xB4" => "\xEF\xBC\x94",
		"\xA3\xB5" => "\xEF\xBC\x95",
		"\xA3\xB6" => "\xEF\xBC\x96",
		"\xA3\xB7" => "\xEF\xBC\x97",
		"\xA3\xB8" => "\xEF\xBC\x98",
		"\xA3\xB9" => "\xEF\xBC\x99",
		"\xA3\xBA" => "\xEF\xBC\x9A",
		"\xA3\xBB" => "\xEF\xBC\x9B",
		"\xA3\xBC" => "\xEF\xBC\x9C",
		"\xA3\xBD" => "\xEF\xBC\x9D",
		"\xA3\xBE" => "\xEF\xBC\x9E",
		"\xA3\xBF" => "\xEF\xBC\x9F",
		"\xA3\xC0" => "\xEF\xBC\xA0",
		"\xA3\xC1" => "\xEF\xBC\xA1",
		"\xA3\xC2" => "\xEF\xBC\xA2",
		"\xA3\xC3" => "\xEF\xBC\xA3",
		"\xA3\xC4" => "\xEF\xBC\xA4",
		"\xA3\xC5" => "\xEF\xBC\xA5",
		"\xA3\xC6" => "\xEF\xBC\xA6",
		"\xA3\xC7" => "\xEF\xBC\xA7",
		"\xA3\xC8" => "\xEF\xBC\xA8",
		"\xA3\xC9" => "\xEF\xBC\xA9",
		"\xA3\xCA" => "\xEF\xBC\xAA",
		"\xA3\xCB" => "\xEF\xBC\xAB",
		"\xA3\xCC" => "\xEF\xBC\xAC",
		"\xA3\xCD" => "\xEF\xBC\xAD",
		"\xA3\xCE" => "\xEF\xBC\xAE",
		"\xA3\xCF" => "\xEF\xBC\xAF",
		"\xA3\xD0" => "\xEF\xBC\xB0",
		"\xA3\xD1" => "\xEF\xBC\xB1",
		"\xA3\xD2" => "\xEF\xBC\xB2",
		"\xA3\xD3" => "\xEF\xBC\xB3",
		"\xA3\xD4" => "\xEF\xBC\xB4",
		"\xA3\xD5" => "\xEF\xBC\xB5",
		"\xA3\xD6" => "\xEF\xBC\xB6",
		"\xA3\xD7" => "\xEF\xBC\xB7",
		"\xA3\xD8" => "\xEF\xBC\xB8",
		"\xA3\xD9" => "\xEF\xBC\xB9",
		"\xA3\xDA" => "\xEF\xBC\xBA",
		"\xA3\xDB" => "\xEF\xBC\xBB",
		"\xA3\xDC" => "\xEF\xBC\xBC",
		"\xA3\xDD" => "\xEF\xBC\xBD",
		"\xA3\xDE" => "\xEF\xBC\xBE",
		"\xA3\xDF" => "\xEF\xBC\xBF",
		"\xA3\xE0" => "\xEF\xBD\x80",
		"\xA3\xE1" => "\xEF\xBD\x81",
		"\xA3\xE2" => "\xEF\xBD\x82",
		"\xA3\xE3" => "\xEF\xBD\x83",
		"\xA3\xE4" => "\xEF\xBD\x84",
		"\xA3\xE5" => "\xEF\xBD\x85",
		"\xA3\xE6" => "\xEF\xBD\x86",
		"\xA3\xE7" => "\xEF\xBD\x87",
		"\xA3\xE8" => "\xEF\xBD\x88",
		"\xA3\xE9" => "\xEF\xBD\x89",
		"\xA3\xEA" => "\xEF\xBD\x8A",
		"\xA3\xEB" => "\xEF\xBD\x8B",
		"\xA3\xEC" => "\xEF\xBD\x8C",
		"\xA3\xED" => "\xEF\xBD\x8D",
		"\xA3\xEE" => "\xEF\xBD\x8E",
		"\xA3\xEF" => "\xEF\xBD\x8F",
		"\xA3\xF0" => "\xEF\xBD\x90",
		"\xA3\xF1" => "\xEF\xBD\x91",
		"\xA3\xF2" => "\xEF\xBD\x92",
		"\xA3\xF3" => "\xEF\xBD\x93",
		"\xA3\xF4" => "\xEF\xBD\x94",
		"\xA3\xF5" => "\xEF\xBD\x95",
		"\xA3\xF6" => "\xEF\xBD\x96",
		"\xA3\xF7" => "\xEF\xBD\x97",
		"\xA3\xF8" => "\xEF\xBD\x98",
		"\xA3\xF9" => "\xEF\xBD\x99",
		"\xA3\xFA" => "\xEF\xBD\x9A",
		"\xA3\xFB" => "\xEF\xBD\x9B",
		"\xA3\xFC" => "\xEF\xBD\x9C",
		"\xA3\xFD" => "\xEF\xBD\x9D",
		"\xA3\xFE" => "\xEF\xBF\xA3",
		"\xA4\xA1" => "\xE3\x81\x81",
		"\xA4\xA2" => "\xE3\x81\x82",
		"\xA4\xA3" => "\xE3\x81\x83",
		"\xA4\xA4" => "\xE3\x81\x84",
		"\xA4\xA5" => "\xE3\x81\x85",
		"\xA4\xA6" => "\xE3\x81\x86",
		"\xA4\xA7" => "\xE3\x81\x87",
		"\xA4\xA8" => "\xE3\x81\x88",
		"\xA4\xA9" => "\xE3\x81\x89",
		"\xA4\xAA" => "\xE3\x81\x8A",
		"\xA4\xAB" => "\xE3\x81\x8B",
		"\xA4\xAC" => "\xE3\x81\x8C",
		"\xA4\xAD" => "\xE3\x81\x8D",
		"\xA4\xAE" => "\xE3\x81\x8E",
		"\xA4\xAF" => "\xE3\x81\x8F",
		"\xA4\xB0" => "\xE3\x81\x90",
		"\xA4\xB1" => "\xE3\x81\x91",
		"\xA4\xB2" => "\xE3\x81\x92",
		"\xA4\xB3" => "\xE3\x81\x93",
		"\xA4\xB4" => "\xE3\x81\x94",
		"\xA4\xB5" => "\xE3\x81\x95",
		"\xA4\xB6" => "\xE3\x81\x96",
		"\xA4\xB7" => "\xE3\x81\x97",
		"\xA4\xB8" => "\xE3\x81\x98",
		"\xA4\xB9" => "\xE3\x81\x99",
		"\xA4\xBA" => "\xE3\x81\x9A",
		"\xA4\xBB" => "\xE3\x81\x9B",
		"\xA4\xBC" => "\xE3\x81\x9C",
		"\xA4\xBD" => "\xE3\x81\x9D",
		"\xA4\xBE" => "\xE3\x81\x9E",
		"\xA4\xBF" => "\xE3\x81\x9F",
		"\xA4\xC0" => "\xE3\x81\xA0",
		"\xA4\xC1" => "\xE3\x81\xA1",
		"\xA4\xC2" => "\xE3\x81\xA2",
		"\xA4\xC3" => "\xE3\x81\xA3",
		"\xA4\xC4" => "\xE3\x81\xA4",
		"\xA4\xC5" => "\xE3\x81\xA5",
		"\xA4\xC6" => "\xE3\x81\xA6",
		"\xA4\xC7" => "\xE3\x81\xA7",
		"\xA4\xC8" => "\xE3\x81\xA8",
		"\xA4\xC9" => "\xE3\x81\xA9",
		"\xA4\xCA" => "\xE3\x81\xAA",
		"\xA4\xCB" => "\xE3\x81\xAB",
		"\xA4\xCC" => "\xE3\x81\xAC",
		"\xA4\xCD" => "\xE3\x81\xAD",
		"\xA4\xCE" => "\xE3\x81\xAE",
		"\xA4\xCF" => "\xE3\x81\xAF",
		"\xA4\xD0" => "\xE3\x81\xB0",
		"\xA4\xD1" => "\xE3\x81\xB1",
		"\xA4\xD2" => "\xE3\x81\xB2",
		"\xA4\xD3" => "\xE3\x81\xB3",
		"\xA4\xD4" => "\xE3\x81\xB4",
		"\xA4\xD5" => "\xE3\x81\xB5",
		"\xA4\xD6" => "\xE3\x81\xB6",
		"\xA4\xD7" => "\xE3\x81\xB7",
		"\xA4\xD8" => "\xE3\x81\xB8",
		"\xA4\xD9" => "\xE3\x81\xB9",
		"\xA4\xDA" => "\xE3\x81\xBA",
		"\xA4\xDB" => "\xE3\x81\xBB",
		"\xA4\xDC" => "\xE3\x81\xBC",
		"\xA4\xDD" => "\xE3\x81\xBD",
		"\xA4\xDE" => "\xE3\x81\xBE",
		"\xA4\xDF" => "\xE3\x81\xBF",
		"\xA4\xE0" => "\xE3\x82\x80",
		"\xA4\xE1" => "\xE3\x82\x81",
		"\xA4\xE2" => "\xE3\x82\x82",
		"\xA4\xE3" => "\xE3\x82\x83",
		"\xA4\xE4" => "\xE3\x82\x84",
		"\xA4\xE5" => "\xE3\x82\x85",
		"\xA4\xE6" => "\xE3\x82\x86",
		"\xA4\xE7" => "\xE3\x82\x87",
		"\xA4\xE8" => "\xE3\x82\x88",
		"\xA4\xE9" => "\xE3\x82\x89",
		"\xA4\xEA" => "\xE3\x82\x8A",
		"\xA4\xEB" => "\xE3\x82\x8B",
		"\xA4\xEC" => "\xE3\x82\x8C",
		"\xA4\xED" => "\xE3\x82\x8D",
		"\xA4\xEE" => "\xE3\x82\x8E",
		"\xA4\xEF" => "\xE3\x82\x8F",
		"\xA4\xF0" => "\xE3\x82\x90",
		"\xA4\xF1" => "\xE3\x82\x91",
		"\xA4\xF2" => "\xE3\x82\x92",
		"\xA4\xF3" => "\xE3\x82\x93",
		"\xA5\xA1" => "\xE3\x82\xA1",
		"\xA5\xA2" => "\xE3\x82\xA2",
		"\xA5\xA3" => "\xE3\x82\xA3",
		"\xA5\xA4" => "\xE3\x82\xA4",
		"\xA5\xA5" => "\xE3\x82\xA5",
		"\xA5\xA6" => "\xE3\x82\xA6",
		"\xA5\xA7" => "\xE3\x82\xA7",
		"\xA5\xA8" => "\xE3\x82\xA8",
		"\xA5\xA9" => "\xE3\x82\xA9",
		"\xA5\xAA" => "\xE3\x82\xAA",
		"\xA5\xAB" => "\xE3\x82\xAB",
		"\xA5\xAC" => "\xE3\x82\xAC",
		"\xA5\xAD" => "\xE3\x82\xAD",
		"\xA5\xAE" => "\xE3\x82\xAE",
		"\xA5\xAF" => "\xE3\x82\xAF",
		"\xA5\xB0" => "\xE3\x82\xB0",
		"\xA5\xB1" => "\xE3\x82\xB1",
		"\xA5\xB2" => "\xE3\x82\xB2",
		"\xA5\xB3" => "\xE3\x82\xB3",
		"\xA5\xB4" => "\xE3\x82\xB4",
		"\xA5\xB5" => "\xE3\x82\xB5",
		"\xA5\xB6" => "\xE3\x82\xB6",
		"\xA5\xB7" => "\xE3\x82\xB7",
		"\xA5\xB8" => "\xE3\x82\xB8",
		"\xA5\xB9" => "\xE3\x82\xB9",
		"\xA5\xBA" => "\xE3\x82\xBA",
		"\xA5\xBB" => "\xE3\x82\xBB",
		"\xA5\xBC" => "\xE3\x82\xBC",
		"\xA5\xBD" => "\xE3\x82\xBD",
		"\xA5\xBE" => "\xE3\x82\xBE",
		"\xA5\xBF" => "\xE3\x82\xBF",
		"\xA5\xC0" => "\xE3\x83\x80",
		"\xA5\xC1" => "\xE3\x83\x81",
		"\xA5\xC2" => "\xE3\x83\x82",
		"\xA5\xC3" => "\xE3\x83\x83",
		"\xA5\xC4" => "\xE3\x83\x84",
		"\xA5\xC5" => "\xE3\x83\x85",
		"\xA5\xC6" => "\xE3\x83\x86",
		"\xA5\xC7" => "\xE3\x83\x87",
		"\xA5\xC8" => "\xE3\x83\x88",
		"\xA5\xC9" => "\xE3\x83\x89",
		"\xA5\xCA" => "\xE3\x83\x8A",
		"\xA5\xCB" => "\xE3\x83\x8B",
		"\xA5\xCC" => "\xE3\x83\x8C",
		"\xA5\xCD" => "\xE3\x83\x8D",
		"\xA5\xCE" => "\xE3\x83\x8E",
		"\xA5\xCF" => "\xE3\x83\x8F",
		"\xA5\xD0" => "\xE3\x83\x90",
		"\xA5\xD1" => "\xE3\x83\x91",
		"\xA5\xD2" => "\xE3\x83\x92",
		"\xA5\xD3" => "\xE3\x83\x93",
		"\xA5\xD4" => "\xE3\x83\x94",
		"\xA5\xD5" => "\xE3\x83\x95",
		"\xA5\xD6" => "\xE3\x83\x96",
		"\xA5\xD7" => "\xE3\x83\x97",
		"\xA5\xD8" => "\xE3\x83\x98",
		"\xA5\xD9" => "\xE3\x83\x99",
		"\xA5\xDA" => "\xE3\x83\x9A",
		"\xA5\xDB" => "\xE3\x83\x9B",
		"\xA5\xDC" => "\xE3\x83\x9C",
		"\xA5\xDD" => "\xE3\x83\x9D",
		"\xA5\xDE" => "\xE3\x83\x9E",
		"\xA5\xDF" => "\xE3\x83\x9F",
		"\xA5\xE0" => "\xE3\x83\xA0",
		"\xA5\xE1" => "\xE3\x83\xA1",
		"\xA5\xE2" => "\xE3\x83\xA2",
		"\xA5\xE3" => "\xE3\x83\xA3",
		"\xA5\xE4" => "\xE3\x83\xA4",
		"\xA5\xE5" => "\xE3\x83\xA5",
		"\xA5\xE6" => "\xE3\x83\xA6",
		"\xA5\xE7" => "\xE3\x83\xA7",
		"\xA5\xE8" => "\xE3\x83\xA8",
		"\xA5\xE9" => "\xE3\x83\xA9",
		"\xA5\xEA" => "\xE3\x83\xAA",
		"\xA5\xEB" => "\xE3\x83\xAB",
		"\xA5\xEC" => "\xE3\x83\xAC",
		"\xA5\xED" => "\xE3\x83\xAD",
		"\xA5\xEE" => "\xE3\x83\xAE",
		"\xA5\xEF" => "\xE3\x83\xAF",
		"\xA5\xF0" => "\xE3\x83\xB0",
		"\xA5\xF1" => "\xE3\x83\xB1",
		"\xA5\xF2" => "\xE3\x83\xB2",
		"\xA5\xF3" => "\xE3\x83\xB3",
		"\xA5\xF4" => "\xE3\x83\xB4",
		"\xA5\xF5" => "\xE3\x83\xB5",
		"\xA5\xF6" => "\xE3\x83\xB6",
		"\xA6\xA1" => "\xCE\x91",
		"\xA6\xA2" => "\xCE\x92",
		"\xA6\xA3" => "\xCE\x93",
		"\xA6\xA4" => "\xCE\x94",
		"\xA6\xA5" => "\xCE\x95",
		"\xA6\xA6" => "\xCE\x96",
		"\xA6\xA7" => "\xCE\x97",
		"\xA6\xA8" => "\xCE\x98",
		"\xA6\xA9" => "\xCE\x99",
		"\xA6\xAA" => "\xCE\x9A",
		"\xA6\xAB" => "\xCE\x9B",
		"\xA6\xAC" => "\xCE\x9C",
		"\xA6\xAD" => "\xCE\x9D",
		"\xA6\xAE" => "\xCE\x9E",
		"\xA6\xAF" => "\xCE\x9F",
		"\xA6\xB0" => "\xCE\xA0",
		"\xA6\xB1" => "\xCE\xA1",
		"\xA6\xB2" => "\xCE\xA3",
		"\xA6\xB3" => "\xCE\xA4",
		"\xA6\xB4" => "\xCE\xA5",
		"\xA6\xB5" => "\xCE\xA6",
		"\xA6\xB6" => "\xCE\xA7",
		"\xA6\xB7" => "\xCE\xA8",
		"\xA6\xB8" => "\xCE\xA9",
		"\xA6\xC1" => "\xCE\xB1",
		"\xA6\xC2" => "\xCE\xB2",
		"\xA6\xC3" => "\xCE\xB3",
		"\xA6\xC4" => "\xCE\xB4",
		"\xA6\xC5" => "\xCE\xB5",
		"\xA6\xC6" => "\xCE\xB6",
		"\xA6\xC7" => "\xCE\xB7",
		"\xA6\xC8" => "\xCE\xB8",
		"\xA6\xC9" => "\xCE\xB9",
		"\xA6\xCA" => "\xCE\xBA",
		"\xA6\xCB" => "\xCE\xBB",
		"\xA6\xCC" => "\xCE\xBC",
		"\xA6\xCD" => "\xCE\xBD",
		"\xA6\xCE" => "\xCE\xBE",
		"\xA6\xCF" => "\xCE\xBF",
		"\xA6\xD0" => "\xCF\x80",
		"\xA6\xD1" => "\xCF\x81",
		"\xA6\xD2" => "\xCF\x83",
		"\xA6\xD3" => "\xCF\x84",
		"\xA6\xD4" => "\xCF\x85",
		"\xA6\xD5" => "\xCF\x86",
		"\xA6\xD6" => "\xCF\x87",
		"\xA6\xD7" => "\xCF\x88",
		"\xA6\xD8" => "\xCF\x89",
		"\xA7\xA1" => "\xD0\x90",
		"\xA7\xA2" => "\xD0\x91",
		"\xA7\xA3" => "\xD0\x92",
		"\xA7\xA4" => "\xD0\x93",
		"\xA7\xA5" => "\xD0\x94",
		"\xA7\xA6" => "\xD0\x95",
		"\xA7\xA7" => "\xD0\x81",
		"\xA7\xA8" => "\xD0\x96",
		"\xA7\xA9" => "\xD0\x97",
		"\xA7\xAA" => "\xD0\x98",
		"\xA7\xAB" => "\xD0\x99",
		"\xA7\xAC" => "\xD0\x9A",
		"\xA7\xAD" => "\xD0\x9B",
		"\xA7\xAE" => "\xD0\x9C",
		"\xA7\xAF" => "\xD0\x9D",
		"\xA7\xB0" => "\xD0\x9E",
		"\xA7\xB1" => "\xD0\x9F",
		"\xA7\xB2" => "\xD0\xA0",
		"\xA7\xB3" => "\xD0\xA1",
		"\xA7\xB4" => "\xD0\xA2",
		"\xA7\xB5" => "\xD0\xA3",
		"\xA7\xB6" => "\xD0\xA4",
		"\xA7\xB7" => "\xD0\xA5",
		"\xA7\xB8" => "\xD0\xA6",
		"\xA7\xB9" => "\xD0\xA7",
		"\xA7\xBA" => "\xD0\xA8",
		"\xA7\xBB" => "\xD0\xA9",
		"\xA7\xBC" => "\xD0\xAA",
		"\xA7\xBD" => "\xD0\xAB",
		"\xA7\xBE" => "\xD0\xAC",
		"\xA7\xBF" => "\xD0\xAD",
		"\xA7\xC0" => "\xD0\xAE",
		"\xA7\xC1" => "\xD0\xAF",
		"\xA7\xD1" => "\xD0\xB0",
		"\xA7\xD2" => "\xD0\xB1",
		"\xA7\xD3" => "\xD0\xB2",
		"\xA7\xD4" => "\xD0\xB3",
		"\xA7\xD5" => "\xD0\xB4",
		"\xA7\xD6" => "\xD0\xB5",
		"\xA7\xD7" => "\xD1\x91",
		"\xA7\xD8" => "\xD0\xB6",
		"\xA7\xD9" => "\xD0\xB7",
		"\xA7\xDA" => "\xD0\xB8",
		"\xA7\xDB" => "\xD0\xB9",
		"\xA7\xDC" => "\xD0\xBA",
		"\xA7\xDD" => "\xD0\xBB",
		"\xA7\xDE" => "\xD0\xBC",
		"\xA7\xDF" => "\xD0\xBD",
		"\xA7\xE0" => "\xD0\xBE",
		"\xA7\xE1" => "\xD0\xBF",
		"\xA7\xE2" => "\xD1\x80",
		"\xA7\xE3" => "\xD1\x81",
		"\xA7\xE4" => "\xD1\x82",
		"\xA7\xE5" => "\xD1\x83",
		"\xA7\xE6" => "\xD1\x84",
		"\xA7\xE7" => "\xD1\x85",
		"\xA7\xE8" => "\xD1\x86",
		"\xA7\xE9" => "\xD1\x87",
		"\xA7\xEA" => "\xD1\x88",
		"\xA7\xEB" => "\xD1\x89",
		"\xA7\xEC" => "\xD1\x8A",
		"\xA7\xED" => "\xD1\x8B",
		"\xA7\xEE" => "\xD1\x8C",
		"\xA7\xEF" => "\xD1\x8D",
		"\xA7\xF0" => "\xD1\x8E",
		"\xA7\xF1" => "\xD1\x8F",
		"\xA8\xA1" => "\xC4\x81",
		"\xA8\xA2" => "\xC3\xA1",
		"\xA8\xA3" => "\xC7\x8E",
		"\xA8\xA4" => "\xC3\xA0",
		"\xA8\xA5" => "\xC4\x93",
		"\xA8\xA6" => "\xC3\xA9",
		"\xA8\xA7" => "\xC4\x9B",
		"\xA8\xA8" => "\xC3\xA8",
		"\xA8\xA9" => "\xC4\xAB",
		"\xA8\xAA" => "\xC3\xAD",
		"\xA8\xAB" => "\xC7\x90",
		"\xA8\xAC" => "\xC3\xAC",
		"\xA8\xAD" => "\xC5\x8D",
		"\xA8\xAE" => "\xC3\xB3",
		"\xA8\xAF" => "\xC7\x92",
		"\xA8\xB0" => "\xC3\xB2",
		"\xA8\xB1" => "\xC5\xAB",
		"\xA8\xB2" => "\xC3\xBA",
		"\xA8\xB3" => "\xC7\x94",
		"\xA8\xB4" => "\xC3\xB9",
		"\xA8\xB5" => "\xC7\x96",
		"\xA8\xB6" => "\xC7\x98",
		"\xA8\xB7" => "\xC7\x9A",
		"\xA8\xB8" => "\xC7\x9C",
		"\xA8\xB9" => "\xC3\xBC",
		"\xA8\xBA" => "\xC3\xAA",
		"\xA8\xC5" => "\xE3\x84\x85",
		"\xA8\xC6" => "\xE3\x84\x86",
		"\xA8\xC7" => "\xE3\x84\x87",
		"\xA8\xC8" => "\xE3\x84\x88",
		"\xA8\xC9" => "\xE3\x84\x89",
		"\xA8\xCA" => "\xE3\x84\x8A",
		"\xA8\xCB" => "\xE3\x84\x8B",
		"\xA8\xCC" => "\xE3\x84\x8C",
		"\xA8\xCD" => "\xE3\x84\x8D",
		"\xA8\xCE" => "\xE3\x84\x8E",
		"\xA8\xCF" => "\xE3\x84\x8F",
		"\xA8\xD0" => "\xE3\x84\x90",
		"\xA8\xD1" => "\xE3\x84\x91",
		"\xA8\xD2" => "\xE3\x84\x92",
		"\xA8\xD3" => "\xE3\x84\x93",
		"\xA8\xD4" => "\xE3\x84\x94",
		"\xA8\xD5" => "\xE3\x84\x95",
		"\xA8\xD6" => "\xE3\x84\x96",
		"\xA8\xD7" => "\xE3\x84\x97",
		"\xA8\xD8" => "\xE3\x84\x98",
		"\xA8\xD9" => "\xE3\x84\x99",
		"\xA8\xDA" => "\xE3\x84\x9A",
		"\xA8\xDB" => "\xE3\x84\x9B",
		"\xA8\xDC" => "\xE3\x84\x9C",
		"\xA8\xDD" => "\xE3\x84\x9D",
		"\xA8\xDE" => "\xE3\x84\x9E",
		"\xA8\xDF" => "\xE3\x84\x9F",
		"\xA8\xE0" => "\xE3\x84\xA0",
		"\xA8\xE1" => "\xE3\x84\xA1",
		"\xA8\xE2" => "\xE3\x84\xA2",
		"\xA8\xE3" => "\xE3\x84\xA3",
		"\xA8\xE4" => "\xE3\x84\xA4",
		"\xA8\xE5" => "\xE3\x84\xA5",
		"\xA8\xE6" => "\xE3\x84\xA6",
		"\xA8\xE7" => "\xE3\x84\xA7",
		"\xA8\xE8" => "\xE3\x84\xA8",
		"\xA8\xE9" => "\xE3\x84\xA9",
		"\xA9\xA4" => "\xE2\x94\x80",
		"\xA9\xA5" => "\xE2\x94\x81",
		"\xA9\xA6" => "\xE2\x94\x82",
		"\xA9\xA7" => "\xE2\x94\x83",
		"\xA9\xA8" => "\xE2\x94\x84",
		"\xA9\xA9" => "\xE2\x94\x85",
		"\xA9\xAA" => "\xE2\x94\x86",
		"\xA9\xAB" => "\xE2\x94\x87",
		"\xA9\xAC" => "\xE2\x94\x88",
		"\xA9\xAD" => "\xE2\x94\x89",
		"\xA9\xAE" => "\xE2\x94\x8A",
		"\xA9\xAF" => "\xE2\x94\x8B",
		"\xA9\xB0" => "\xE2\x94\x8C",
		"\xA9\xB1" => "\xE2\x94\x8D",
		"\xA9\xB2" => "\xE2\x94\x8E",
		"\xA9\xB3" => "\xE2\x94\x8F",
		"\xA9\xB4" => "\xE2\x94\x90",
		"\xA9\xB5" => "\xE2\x94\x91",
		"\xA9\xB6" => "\xE2\x94\x92",
		"\xA9\xB7" => "\xE2\x94\x93",
		"\xA9\xB8" => "\xE2\x94\x94",
		"\xA9\xB9" => "\xE2\x94\x95",
		"\xA9\xBA" => "\xE2\x94\x96",
		"\xA9\xBB" => "\xE2\x94\x97",
		"\xA9\xBC" => "\xE2\x94\x98",
		"\xA9\xBD" => "\xE2\x94\x99",
		"\xA9\xBE" => "\xE2\x94\x9A",
		"\xA9\xBF" => "\xE2\x94\x9B",
		"\xA9\xC0" => "\xE2\x94\x9C",
		"\xA9\xC1" => "\xE2\x94\x9D",
		"\xA9\xC2" => "\xE2\x94\x9E",
		"\xA9\xC3" => "\xE2\x94\x9F",
		"\xA9\xC4" => "\xE2\x94\xA0",
		"\xA9\xC5" => "\xE2\x94\xA1",
		"\xA9\xC6" => "\xE2\x94\xA2",
		"\xA9\xC7" => "\xE2\x94\xA3",
		"\xA9\xC8" => "\xE2\x94\xA4",
		"\xA9\xC9" => "\xE2\x94\xA5",
		"\xA9\xCA" => "\xE2\x94\xA6",
		"\xA9\xCB" => "\xE2\x94\xA7",
		"\xA9\xCC" => "\xE2\x94\xA8",
		"\xA9\xCD" => "\xE2\x94\xA9",
		"\xA9\xCE" => "\xE2\x94\xAA",
		"\xA9\xCF" => "\xE2\x94\xAB",
		"\xA9\xD0" => "\xE2\x94\xAC",
		"\xA9\xD1" => "\xE2\x94\xAD",
		"\xA9\xD2" => "\xE2\x94\xAE",
		"\xA9\xD3" => "\xE2\x94\xAF",
		"\xA9\xD4" => "\xE2\x94\xB0",
		"\xA9\xD5" => "\xE2\x94\xB1",
		"\xA9\xD6" => "\xE2\x94\xB2",
		"\xA9\xD7" => "\xE2\x94\xB3",
		"\xA9\xD8" => "\xE2\x94\xB4",
		"\xA9\xD9" => "\xE2\x94\xB5",
		"\xA9\xDA" => "\xE2\x94\xB6",
		"\xA9\xDB" => "\xE2\x94\xB7",
		"\xA9\xDC" => "\xE2\x94\xB8",
		"\xA9\xDD" => "\xE2\x94\xB9",
		"\xA9\xDE" => "\xE2\x94\xBA",
		"\xA9\xDF" => "\xE2\x94\xBB",
		"\xA9\xE0" => "\xE2\x94\xBC",
		"\xA9\xE1" => "\xE2\x94\xBD",
		"\xA9\xE2" => "\xE2\x94\xBE",
		"\xA9\xE3" => "\xE2\x94\xBF",
		"\xA9\xE4" => "\xE2\x95\x80",
		"\xA9\xE5" => "\xE2\x95\x81",
		"\xA9\xE6" => "\xE2\x95\x82",
		"\xA9\xE7" => "\xE2\x95\x83",
		"\xA9\xE8" => "\xE2\x95\x84",
		"\xA9\xE9" => "\xE2\x95\x85",
		"\xA9\xEA" => "\xE2\x95\x86",
		"\xA9\xEB" => "\xE2\x95\x87",
		"\xA9\xEC" => "\xE2\x95\x88",
		"\xA9\xED" => "\xE2\x95\x89",
		"\xA9\xEE" => "\xE2\x95\x8A",
		"\xA9\xEF" => "\xE2\x95\x8B",
		"\xB0\xA1" => "\xE5\x95\x8A",
		"\xB0\xA2" => "\xE9\x98\xBF",
		"\xB0\xA3" => "\xE5\x9F\x83",
		"\xB0\xA4" => "\xE6\x8C\xA8",
		"\xB0\xA5" => "\xE5\x93\x8E",
		"\xB0\xA6" => "\xE5\x94\x89",
		"\xB0\xA7" => "\xE5\x93\x80",
		"\xB0\xA8" => "\xE7\x9A\x91",
		"\xB0\xA9" => "\xE7\x99\x8C",
		"\xB0\xAA" => "\xE8\x94\xBC",
		"\xB0\xAB" => "\xE7\x9F\xAE",
		"\xB0\xAC" => "\xE8\x89\xBE",
		"\xB0\xAD" => "\xE7\xA2\x8D",
		"\xB0\xAE" => "\xE7\x88\xB1",
		"\xB0\xAF" => "\xE9\x9A\x98",
		"\xB0\xB0" => "\xE9\x9E\x8D",
		"\xB0\xB1" => "\xE6\xB0\xA8",
		"\xB0\xB2" => "\xE5\xAE\x89",
		"\xB0\xB3" => "\xE4\xBF\xBA",
		"\xB0\xB4" => "\xE6\x8C\x89",
		"\xB0\xB5" => "\xE6\x9A\x97",
		"\xB0\xB6" => "\xE5\xB2\xB8",
		"\xB0\xB7" => "\xE8\x83\xBA",
		"\xB0\xB8" => "\xE6\xA1\x88",
		"\xB0\xB9" => "\xE8\x82\xAE",
		"\xB0\xBA" => "\xE6\x98\x82",
		"\xB0\xBB" => "\xE7\x9B\x8E",
		"\xB0\xBC" => "\xE5\x87\xB9",
		"\xB0\xBD" => "\xE6\x95\x96",
		"\xB0\xBE" => "\xE7\x86\xAC",
		"\xB0\xBF" => "\xE7\xBF\xB1",
		"\xB0\xC0" => "\xE8\xA2\x84",
		"\xB0\xC1" => "\xE5\x82\xB2",
		"\xB0\xC2" => "\xE5\xA5\xA5",
		"\xB0\xC3" => "\xE6\x87\x8A",
		"\xB0\xC4" => "\xE6\xBE\xB3",
		"\xB0\xC5" => "\xE8\x8A\xAD",
		"\xB0\xC6" => "\xE6\x8D\x8C",
		"\xB0\xC7" => "\xE6\x89\x92",
		"\xB0\xC8" => "\xE5\x8F\xAD",
		"\xB0\xC9" => "\xE5\x90\xA7",
		"\xB0\xCA" => "\xE7\xAC\x86",
		"\xB0\xCB" => "\xE5\x85\xAB",
		"\xB0\xCC" => "\xE7\x96\xA4",
		"\xB0\xCD" => "\xE5\xB7\xB4",
		"\xB0\xCE" => "\xE6\x8B\x94",
		"\xB0\xCF" => "\xE8\xB7\x8B",
		"\xB0\xD0" => "\xE9\x9D\xB6",
		"\xB0\xD1" => "\xE6\x8A\x8A",
		"\xB0\xD2" => "\xE8\x80\x99",
		"\xB0\xD3" => "\xE5\x9D\x9D",
		"\xB0\xD4" => "\xE9\x9C\xB8",
		"\xB0\xD5" => "\xE7\xBD\xA2",
		"\xB0\xD6" => "\xE7\x88\xB8",
		"\xB0\xD7" => "\xE7\x99\xBD",
		"\xB0\xD8" => "\xE6\x9F\x8F",
		"\xB0\xD9" => "\xE7\x99\xBE",
		"\xB0\xDA" => "\xE6\x91\x86",
		"\xB0\xDB" => "\xE4\xBD\xB0",
		"\xB0\xDC" => "\xE8\xB4\xA5",
		"\xB0\xDD" => "\xE6\x8B\x9C",
		"\xB0\xDE" => "\xE7\xA8\x97",
		"\xB0\xDF" => "\xE6\x96\x91",
		"\xB0\xE0" => "\xE7\x8F\xAD",
		"\xB0\xE1" => "\xE6\x90\xAC",
		"\xB0\xE2" => "\xE6\x89\xB3",
		"\xB0\xE3" => "\xE8\x88\xAC",
		"\xB0\xE4" => "\xE9\xA2\x81",
		"\xB0\xE5" => "\xE6\x9D\xBF",
		"\xB0\xE6" => "\xE7\x89\x88",
		"\xB0\xE7" => "\xE6\x89\xAE",
		"\xB0\xE8" => "\xE6\x8B\x8C",
		"\xB0\xE9" => "\xE4\xBC\xB4",
		"\xB0\xEA" => "\xE7\x93\xA3",
		"\xB0\xEB" => "\xE5\x8D\x8A",
		"\xB0\xEC" => "\xE5\x8A\x9E",
		"\xB0\xED" => "\xE7\xBB\x8A",
		"\xB0\xEE" => "\xE9\x82\xA6",
		"\xB0\xEF" => "\xE5\xB8\xAE",
		"\xB0\xF0" => "\xE6\xA2\x86",
		"\xB0\xF1" => "\xE6\xA6\x9C",
		"\xB0\xF2" => "\xE8\x86\x80",
		"\xB0\xF3" => "\xE7\xBB\x91",
		"\xB0\xF4" => "\xE6\xA3\x92",
		"\xB0\xF5" => "\xE7\xA3\x85",
		"\xB0\xF6" => "\xE8\x9A\x8C",
		"\xB0\xF7" => "\xE9\x95\x91",
		"\xB0\xF8" => "\xE5\x82\x8D",
		"\xB0\xF9" => "\xE8\xB0\xA4",
		"\xB0\xFA" => "\xE8\x8B\x9E",
		"\xB0\xFB" => "\xE8\x83\x9E",
		"\xB0\xFC" => "\xE5\x8C\x85",
		"\xB0\xFD" => "\xE8\xA4\x92",
		"\xB0\xFE" => "\xE5\x89\xA5",
		"\xB1\xA1" => "\xE8\x96\x84",
		"\xB1\xA2" => "\xE9\x9B\xB9",
		"\xB1\xA3" => "\xE4\xBF\x9D",
		"\xB1\xA4" => "\xE5\xA0\xA1",
		"\xB1\xA5" => "\xE9\xA5\xB1",
		"\xB1\xA6" => "\xE5\xAE\x9D",
		"\xB1\xA7" => "\xE6\x8A\xB1",
		"\xB1\xA8" => "\xE6\x8A\xA5",
		"\xB1\xA9" => "\xE6\x9A\xB4",
		"\xB1\xAA" => "\xE8\xB1\xB9",
		"\xB1\xAB" => "\xE9\xB2\x8D",
		"\xB1\xAC" => "\xE7\x88\x86",
		"\xB1\xAD" => "\xE6\x9D\xAF",
		"\xB1\xAE" => "\xE7\xA2\x91",
		"\xB1\xAF" => "\xE6\x82\xB2",
		"\xB1\xB0" => "\xE5\x8D\x91",
		"\xB1\xB1" => "\xE5\x8C\x97",
		"\xB1\xB2" => "\xE8\xBE\x88",
		"\xB1\xB3" => "\xE8\x83\x8C",
		"\xB1\xB4" => "\xE8\xB4\x9D",
		"\xB1\xB5" => "\xE9\x92\xA1",
		"\xB1\xB6" => "\xE5\x80\x8D",
		"\xB1\xB7" => "\xE7\x8B\x88",
		"\xB1\xB8" => "\xE5\xA4\x87",
		"\xB1\xB9" => "\xE6\x83\xAB",
		"\xB1\xBA" => "\xE7\x84\x99",
		"\xB1\xBB" => "\xE8\xA2\xAB",
		"\xB1\xBC" => "\xE5\xA5\x94",
		"\xB1\xBD" => "\xE8\x8B\xAF",
		"\xB1\xBE" => "\xE6\x9C\xAC",
		"\xB1\xBF" => "\xE7\xAC\xA8",
		"\xB1\xC0" => "\xE5\xB4\xA9",
		"\xB1\xC1" => "\xE7\xBB\xB7",
		"\xB1\xC2" => "\xE7\x94\xAD",
		"\xB1\xC3" => "\xE6\xB3\xB5",
		"\xB1\xC4" => "\xE8\xB9\xA6",
		"\xB1\xC5" => "\xE8\xBF\xB8",
		"\xB1\xC6" => "\xE9\x80\xBC",
		"\xB1\xC7" => "\xE9\xBC\xBB",
		"\xB1\xC8" => "\xE6\xAF\x94",
		"\xB1\xC9" => "\xE9\x84\x99",
		"\xB1\xCA" => "\xE7\xAC\x94",
		"\xB1\xCB" => "\xE5\xBD\xBC",
		"\xB1\xCC" => "\xE7\xA2\xA7",
		"\xB1\xCD" => "\xE8\x93\x96",
		"\xB1\xCE" => "\xE8\x94\xBD",
		"\xB1\xCF" => "\xE6\xAF\x95",
		"\xB1\xD0" => "\xE6\xAF\x99",
		"\xB1\xD1" => "\xE6\xAF\x96",
		"\xB1\xD2" => "\xE5\xB8\x81",
		"\xB1\xD3" => "\xE5\xBA\x87",
		"\xB1\xD4" => "\xE7\x97\xB9",
		"\xB1\xD5" => "\xE9\x97\xAD",
		"\xB1\xD6" => "\xE6\x95\x9D",
		"\xB1\xD7" => "\xE5\xBC\x8A",
		"\xB1\xD8" => "\xE5\xBF\x85",
		"\xB1\xD9" => "\xE8\xBE\x9F",
		"\xB1\xDA" => "\xE5\xA3\x81",
		"\xB1\xDB" => "\xE8\x87\x82",
		"\xB1\xDC" => "\xE9\x81\xBF",
		"\xB1\xDD" => "\xE9\x99\x9B",
		"\xB1\xDE" => "\xE9\x9E\xAD",
		"\xB1\xDF" => "\xE8\xBE\xB9",
		"\xB1\xE0" => "\xE7\xBC\x96",
		"\xB1\xE1" => "\xE8\xB4\xAC",
		"\xB1\xE2" => "\xE6\x89\x81",
		"\xB1\xE3" => "\xE4\xBE\xBF",
		"\xB1\xE4" => "\xE5\x8F\x98",
		"\xB1\xE5" => "\xE5\x8D\x9E",
		"\xB1\xE6" => "\xE8\xBE\xA8",
		"\xB1\xE7" => "\xE8\xBE\xA9",
		"\xB1\xE8" => "\xE8\xBE\xAB",
		"\xB1\xE9" => "\xE9\x81\x8D",
		"\xB1\xEA" => "\xE6\xA0\x87",
		"\xB1\xEB" => "\xE5\xBD\xAA",
		"\xB1\xEC" => "\xE8\x86\x98",
		"\xB1\xED" => "\xE8\xA1\xA8",
		"\xB1\xEE" => "\xE9\xB3\x96",
		"\xB1\xEF" => "\xE6\x86\x8B",
		"\xB1\xF0" => "\xE5\x88\xAB",
		"\xB1\xF1" => "\xE7\x98\xAA",
		"\xB1\xF2" => "\xE5\xBD\xAC",
		"\xB1\xF3" => "\xE6\x96\x8C",
		"\xB1\xF4" => "\xE6\xBF\x92",
		"\xB1\xF5" => "\xE6\xBB\xA8",
		"\xB1\xF6" => "\xE5\xAE\xBE",
		"\xB1\xF7" => "\xE6\x91\x88",
		"\xB1\xF8" => "\xE5\x85\xB5",
		"\xB1\xF9" => "\xE5\x86\xB0",
		"\xB1\xFA" => "\xE6\x9F\x84",
		"\xB1\xFB" => "\xE4\xB8\x99",
		"\xB1\xFC" => "\xE7\xA7\x89",
		"\xB1\xFD" => "\xE9\xA5\xBC",
		"\xB1\xFE" => "\xE7\x82\xB3",
		"\xB2\xA1" => "\xE7\x97\x85",
		"\xB2\xA2" => "\xE5\xB9\xB6",
		"\xB2\xA3" => "\xE7\x8E\xBB",
		"\xB2\xA4" => "\xE8\x8F\xA0",
		"\xB2\xA5" => "\xE6\x92\xAD",
		"\xB2\xA6" => "\xE6\x8B\xA8",
		"\xB2\xA7" => "\xE9\x92\xB5",
		"\xB2\xA8" => "\xE6\xB3\xA2",
		"\xB2\xA9" => "\xE5\x8D\x9A",
		"\xB2\xAA" => "\xE5\x8B\x83",
		"\xB2\xAB" => "\xE6\x90\x8F",
		"\xB2\xAC" => "\xE9\x93\x82",
		"\xB2\xAD" => "\xE7\xAE\x94",
		"\xB2\xAE" => "\xE4\xBC\xAF",
		"\xB2\xAF" => "\xE5\xB8\x9B",
		"\xB2\xB0" => "\xE8\x88\xB6",
		"\xB2\xB1" => "\xE8\x84\x96",
		"\xB2\xB2" => "\xE8\x86\x8A",
		"\xB2\xB3" => "\xE6\xB8\xA4",
		"\xB2\xB4" => "\xE6\xB3\x8A",
		"\xB2\xB5" => "\xE9\xA9\xB3",
		"\xB2\xB6" => "\xE6\x8D\x95",
		"\xB2\xB7" => "\xE5\x8D\x9C",
		"\xB2\xB8" => "\xE5\x93\xBA",
		"\xB2\xB9" => "\xE8\xA1\xA5",
		"\xB2\xBA" => "\xE5\x9F\xA0",
		"\xB2\xBB" => "\xE4\xB8\x8D",
		"\xB2\xBC" => "\xE5\xB8\x83",
		"\xB2\xBD" => "\xE6\xAD\xA5",
		"\xB2\xBE" => "\xE7\xB0\xBF",
		"\xB2\xBF" => "\xE9\x83\xA8",
		"\xB2\xC0" => "\xE6\x80\x96",
		"\xB2\xC1" => "\xE6\x93\xA6",
		"\xB2\xC2" => "\xE7\x8C\x9C",
		"\xB2\xC3" => "\xE8\xA3\x81",
		"\xB2\xC4" => "\xE6\x9D\x90",
		"\xB2\xC5" => "\xE6\x89\x8D",
		"\xB2\xC6" => "\xE8\xB4\xA2",
		"\xB2\xC7" => "\xE7\x9D\xAC",
		"\xB2\xC8" => "\xE8\xB8\xA9",
		"\xB2\xC9" => "\xE9\x87\x87",
		"\xB2\xCA" => "\xE5\xBD\xA9",
		"\xB2\xCB" => "\xE8\x8F\x9C",
		"\xB2\xCC" => "\xE8\x94\xA1",
		"\xB2\xCD" => "\xE9\xA4\x90",
		"\xB2\xCE" => "\xE5\x8F\x82",
		"\xB2\xCF" => "\xE8\x9A\x95",
		"\xB2\xD0" => "\xE6\xAE\x8B",
		"\xB2\xD1" => "\xE6\x83\xAD",
		"\xB2\xD2" => "\xE6\x83\xA8",
		"\xB2\xD3" => "\xE7\x81\xBF",
		"\xB2\xD4" => "\xE8\x8B\x8D",
		"\xB2\xD5" => "\xE8\x88\xB1",
		"\xB2\xD6" => "\xE4\xBB\x93",
		"\xB2\xD7" => "\xE6\xB2\xA7",
		"\xB2\xD8" => "\xE8\x97\x8F",
		"\xB2\xD9" => "\xE6\x93\x8D",
		"\xB2\xDA" => "\xE7\xB3\x99",
		"\xB2\xDB" => "\xE6\xA7\xBD",
		"\xB2\xDC" => "\xE6\x9B\xB9",
		"\xB2\xDD" => "\xE8\x8D\x89",
		"\xB2\xDE" => "\xE5\x8E\x95",
		"\xB2\xDF" => "\xE7\xAD\x96",
		"\xB2\xE0" => "\xE4\xBE\xA7",
		"\xB2\xE1" => "\xE5\x86\x8C",
		"\xB2\xE2" => "\xE6\xB5\x8B",
		"\xB2\xE3" => "\xE5\xB1\x82",
		"\xB2\xE4" => "\xE8\xB9\xAD",
		"\xB2\xE5" => "\xE6\x8F\x92",
		"\xB2\xE6" => "\xE5\x8F\x89",
		"\xB2\xE7" => "\xE8\x8C\xAC",
		"\xB2\xE8" => "\xE8\x8C\xB6",
		"\xB2\xE9" => "\xE6\x9F\xA5",
		"\xB2\xEA" => "\xE7\xA2\xB4",
		"\xB2\xEB" => "\xE6\x90\xBD",
		"\xB2\xEC" => "\xE5\xAF\x9F",
		"\xB2\xED" => "\xE5\xB2\x94",
		"\xB2\xEE" => "\xE5\xB7\xAE",
		"\xB2\xEF" => "\xE8\xAF\xA7",
		"\xB2\xF0" => "\xE6\x8B\x86",
		"\xB2\xF1" => "\xE6\x9F\xB4",
		"\xB2\xF2" => "\xE8\xB1\xBA",
		"\xB2\xF3" => "\xE6\x90\x80",
		"\xB2\xF4" => "\xE6\x8E\xBA",
		"\xB2\xF5" => "\xE8\x9D\x89",
		"\xB2\xF6" => "\xE9\xA6\x8B",
		"\xB2\xF7" => "\xE8\xB0\x97",
		"\xB2\xF8" => "\xE7\xBC\xA0",
		"\xB2\xF9" => "\xE9\x93\xB2",
		"\xB2\xFA" => "\xE4\xBA\xA7",
		"\xB2\xFB" => "\xE9\x98\x90",
		"\xB2\xFC" => "\xE9\xA2\xA4",
		"\xB2\xFD" => "\xE6\x98\x8C",
		"\xB2\xFE" => "\xE7\x8C\x96",
		"\xB3\xA1" => "\xE5\x9C\xBA",
		"\xB3\xA2" => "\xE5\xB0\x9D",
		"\xB3\xA3" => "\xE5\xB8\xB8",
		"\xB3\xA4" => "\xE9\x95\xBF",
		"\xB3\xA5" => "\xE5\x81\xBF",
		"\xB3\xA6" => "\xE8\x82\xA0",
		"\xB3\xA7" => "\xE5\x8E\x82",
		"\xB3\xA8" => "\xE6\x95\x9E",
		"\xB3\xA9" => "\xE7\x95\x85",
		"\xB3\xAA" => "\xE5\x94\xB1",
		"\xB3\xAB" => "\xE5\x80\xA1",
		"\xB3\xAC" => "\xE8\xB6\x85",
		"\xB3\xAD" => "\xE6\x8A\x84",
		"\xB3\xAE" => "\xE9\x92\x9E",
		"\xB3\xAF" => "\xE6\x9C\x9D",
		"\xB3\xB0" => "\xE5\x98\xB2",
		"\xB3\xB1" => "\xE6\xBD\xAE",
		"\xB3\xB2" => "\xE5\xB7\xA2",
		"\xB3\xB3" => "\xE5\x90\xB5",
		"\xB3\xB4" => "\xE7\x82\x92",
		"\xB3\xB5" => "\xE8\xBD\xA6",
		"\xB3\xB6" => "\xE6\x89\xAF",
		"\xB3\xB7" => "\xE6\x92\xA4",
		"\xB3\xB8" => "\xE6\x8E\xA3",
		"\xB3\xB9" => "\xE5\xBD\xBB",
		"\xB3\xBA" => "\xE6\xBE\x88",
		"\xB3\xBB" => "\xE9\x83\xB4",
		"\xB3\xBC" => "\xE8\x87\xA3",
		"\xB3\xBD" => "\xE8\xBE\xB0",
		"\xB3\xBE" => "\xE5\xB0\x98",
		"\xB3\xBF" => "\xE6\x99\xA8",
		"\xB3\xC0" => "\xE5\xBF\xB1",
		"\xB3\xC1" => "\xE6\xB2\x89",
		"\xB3\xC2" => "\xE9\x99\x88",
		"\xB3\xC3" => "\xE8\xB6\x81",
		"\xB3\xC4" => "\xE8\xA1\xAC",
		"\xB3\xC5" => "\xE6\x92\x91",
		"\xB3\xC6" => "\xE7\xA7\xB0",
		"\xB3\xC7" => "\xE5\x9F\x8E",
		"\xB3\xC8" => "\xE6\xA9\x99",
		"\xB3\xC9" => "\xE6\x88\x90",
		"\xB3\xCA" => "\xE5\x91\x88",
		"\xB3\xCB" => "\xE4\xB9\x98",
		"\xB3\xCC" => "\xE7\xA8\x8B",
		"\xB3\xCD" => "\xE6\x83\xA9",
		"\xB3\xCE" => "\xE6\xBE\x84",
		"\xB3\xCF" => "\xE8\xAF\x9A",
		"\xB3\xD0" => "\xE6\x89\xBF",
		"\xB3\xD1" => "\xE9\x80\x9E",
		"\xB3\xD2" => "\xE9\xAA\x8B",
		"\xB3\xD3" => "\xE7\xA7\xA4",
		"\xB3\xD4" => "\xE5\x90\x83",
		"\xB3\xD5" => "\xE7\x97\xB4",
		"\xB3\xD6" => "\xE6\x8C\x81",
		"\xB3\xD7" => "\xE5\x8C\x99",
		"\xB3\xD8" => "\xE6\xB1\xA0",
		"\xB3\xD9" => "\xE8\xBF\x9F",
		"\xB3\xDA" => "\xE5\xBC\x9B",
		"\xB3\xDB" => "\xE9\xA9\xB0",
		"\xB3\xDC" => "\xE8\x80\xBB",
		"\xB3\xDD" => "\xE9\xBD\xBF",
		"\xB3\xDE" => "\xE4\xBE\x88",
		"\xB3\xDF" => "\xE5\xB0\xBA",
		"\xB3\xE0" => "\xE8\xB5\xA4",
		"\xB3\xE1" => "\xE7\xBF\x85",
		"\xB3\xE2" => "\xE6\x96\xA5",
		"\xB3\xE3" => "\xE7\x82\xBD",
		"\xB3\xE4" => "\xE5\x85\x85",
		"\xB3\xE5" => "\xE5\x86\xB2",
		"\xB3\xE6" => "\xE8\x99\xAB",
		"\xB3\xE7" => "\xE5\xB4\x87",
		"\xB3\xE8" => "\xE5\xAE\xA0",
		"\xB3\xE9" => "\xE6\x8A\xBD",
		"\xB3\xEA" => "\xE9\x85\xAC",
		"\xB3\xEB" => "\xE7\x95\xB4",
		"\xB3\xEC" => "\xE8\xB8\x8C",
		"\xB3\xED" => "\xE7\xA8\xA0",
		"\xB3\xEE" => "\xE6\x84\x81",
		"\xB3\xEF" => "\xE7\xAD\xB9",
		"\xB3\xF0" => "\xE4\xBB\x87",
		"\xB3\xF1" => "\xE7\xBB\xB8",
		"\xB3\xF2" => "\xE7\x9E\x85",
		"\xB3\xF3" => "\xE4\xB8\x91",
		"\xB3\xF4" => "\xE8\x87\xAD",
		"\xB3\xF5" => "\xE5\x88\x9D",
		"\xB3\xF6" => "\xE5\x87\xBA",
		"\xB3\xF7" => "\xE6\xA9\xB1",
		"\xB3\xF8" => "\xE5\x8E\xA8",
		"\xB3\xF9" => "\xE8\xBA\x87",
		"\xB3\xFA" => "\xE9\x94\x84",
		"\xB3\xFB" => "\xE9\x9B\x8F",
		"\xB3\xFC" => "\xE6\xBB\x81",
		"\xB3\xFD" => "\xE9\x99\xA4",
		"\xB3\xFE" => "\xE6\xA5\x9A",
		"\xB4\xA1" => "\xE7\xA1\x80",
		"\xB4\xA2" => "\xE5\x82\xA8",
		"\xB4\xA3" => "\xE7\x9F\x97",
		"\xB4\xA4" => "\xE6\x90\x90",
		"\xB4\xA5" => "\xE8\xA7\xA6",
		"\xB4\xA6" => "\xE5\xA4\x84",
		"\xB4\xA7" => "\xE6\x8F\xA3",
		"\xB4\xA8" => "\xE5\xB7\x9D",
		"\xB4\xA9" => "\xE7\xA9\xBF",
		"\xB4\xAA" => "\xE6\xA4\xBD",
		"\xB4\xAB" => "\xE4\xBC\xA0",
		"\xB4\xAC" => "\xE8\x88\xB9",
		"\xB4\xAD" => "\xE5\x96\x98",
		"\xB4\xAE" => "\xE4\xB8\xB2",
		"\xB4\xAF" => "\xE7\x96\xAE",
		"\xB4\xB0" => "\xE7\xAA\x97",
		"\xB4\xB1" => "\xE5\xB9\xA2",
		"\xB4\xB2" => "\xE5\xBA\x8A",
		"\xB4\xB3" => "\xE9\x97\xAF",
		"\xB4\xB4" => "\xE5\x88\x9B",
		"\xB4\xB5" => "\xE5\x90\xB9",
		"\xB4\xB6" => "\xE7\x82\x8A",
		"\xB4\xB7" => "\xE6\x8D\xB6",
		"\xB4\xB8" => "\xE9\x94\xA4",
		"\xB4\xB9" => "\xE5\x9E\x82",
		"\xB4\xBA" => "\xE6\x98\xA5",
		"\xB4\xBB" => "\xE6\xA4\xBF",
		"\xB4\xBC" => "\xE9\x86\x87",
		"\xB4\xBD" => "\xE5\x94\x87",
		"\xB4\xBE" => "\xE6\xB7\xB3",
		"\xB4\xBF" => "\xE7\xBA\xAF",
		"\xB4\xC0" => "\xE8\xA0\xA2",
		"\xB4\xC1" => "\xE6\x88\xB3",
		"\xB4\xC2" => "\xE7\xBB\xB0",
		"\xB4\xC3" => "\xE7\x96\xB5",
		"\xB4\xC4" => "\xE8\x8C\xA8",
		"\xB4\xC5" => "\xE7\xA3\x81",
		"\xB4\xC6" => "\xE9\x9B\x8C",
		"\xB4\xC7" => "\xE8\xBE\x9E",
		"\xB4\xC8" => "\xE6\x85\x88",
		"\xB4\xC9" => "\xE7\x93\xB7",
		"\xB4\xCA" => "\xE8\xAF\x8D",
		"\xB4\xCB" => "\xE6\xAD\xA4",
		"\xB4\xCC" => "\xE5\x88\xBA",
		"\xB4\xCD" => "\xE8\xB5\x90",
		"\xB4\xCE" => "\xE6\xAC\xA1",
		"\xB4\xCF" => "\xE8\x81\xAA",
		"\xB4\xD0" => "\xE8\x91\xB1",
		"\xB4\xD1" => "\xE5\x9B\xB1",
		"\xB4\xD2" => "\xE5\x8C\x86",
		"\xB4\xD3" => "\xE4\xBB\x8E",
		"\xB4\xD4" => "\xE4\xB8\x9B",
		"\xB4\xD5" => "\xE5\x87\x91",
		"\xB4\xD6" => "\xE7\xB2\x97",
		"\xB4\xD7" => "\xE9\x86\x8B",
		"\xB4\xD8" => "\xE7\xB0\x87",
		"\xB4\xD9" => "\xE4\xBF\x83",
		"\xB4\xDA" => "\xE8\xB9\xBF",
		"\xB4\xDB" => "\xE7\xAF\xA1",
		"\xB4\xDC" => "\xE7\xAA\x9C",
		"\xB4\xDD" => "\xE6\x91\xA7",
		"\xB4\xDE" => "\xE5\xB4\x94",
		"\xB4\xDF" => "\xE5\x82\xAC",
		"\xB4\xE0" => "\xE8\x84\x86",
		"\xB4\xE1" => "\xE7\x98\x81",
		"\xB4\xE2" => "\xE7\xB2\xB9",
		"\xB4\xE3" => "\xE6\xB7\xAC",
		"\xB4\xE4" => "\xE7\xBF\xA0",
		"\xB4\xE5" => "\xE6\x9D\x91",
		"\xB4\xE6" => "\xE5\xAD\x98",
		"\xB4\xE7" => "\xE5\xAF\xB8",
		"\xB4\xE8" => "\xE7\xA3\x8B",
		"\xB4\xE9" => "\xE6\x92\xAE",
		"\xB4\xEA" => "\xE6\x90\x93",
		"\xB4\xEB" => "\xE6\x8E\xAA",
		"\xB4\xEC" => "\xE6\x8C\xAB",
		"\xB4\xED" => "\xE9\x94\x99",
		"\xB4\xEE" => "\xE6\x90\xAD",
		"\xB4\xEF" => "\xE8\xBE\xBE",
		"\xB4\xF0" => "\xE7\xAD\x94",
		"\xB4\xF1" => "\xE7\x98\xA9",
		"\xB4\xF2" => "\xE6\x89\x93",
		"\xB4\xF3" => "\xE5\xA4\xA7",
		"\xB4\xF4" => "\xE5\x91\x86",
		"\xB4\xF5" => "\xE6\xAD\xB9",
		"\xB4\xF6" => "\xE5\x82\xA3",
		"\xB4\xF7" => "\xE6\x88\xB4",
		"\xB4\xF8" => "\xE5\xB8\xA6",
		"\xB4\xF9" => "\xE6\xAE\x86",
		"\xB4\xFA" => "\xE4\xBB\xA3",
		"\xB4\xFB" => "\xE8\xB4\xB7",
		"\xB4\xFC" => "\xE8\xA2\x8B",
		"\xB4\xFD" => "\xE5\xBE\x85",
		"\xB4\xFE" => "\xE9\x80\xAE",
		"\xB5\xA1" => "\xE6\x80\xA0",
		"\xB5\xA2" => "\xE8\x80\xBD",
		"\xB5\xA3" => "\xE6\x8B\x85",
		"\xB5\xA4" => "\xE4\xB8\xB9",
		"\xB5\xA5" => "\xE5\x8D\x95",
		"\xB5\xA6" => "\xE9\x83\xB8",
		"\xB5\xA7" => "\xE6\x8E\xB8",
		"\xB5\xA8" => "\xE8\x83\x86",
		"\xB5\xA9" => "\xE6\x97\xA6",
		"\xB5\xAA" => "\xE6\xB0\xAE",
		"\xB5\xAB" => "\xE4\xBD\x86",
		"\xB5\xAC" => "\xE6\x83\xAE",
		"\xB5\xAD" => "\xE6\xB7\xA1",
		"\xB5\xAE" => "\xE8\xAF\x9E",
		"\xB5\xAF" => "\xE5\xBC\xB9",
		"\xB5\xB0" => "\xE8\x9B\x8B",
		"\xB5\xB1" => "\xE5\xBD\x93",
		"\xB5\xB2" => "\xE6\x8C\xA1",
		"\xB5\xB3" => "\xE5\x85\x9A",
		"\xB5\xB4" => "\xE8\x8D\xA1",
		"\xB5\xB5" => "\xE6\xA1\xA3",
		"\xB5\xB6" => "\xE5\x88\x80",
		"\xB5\xB7" => "\xE6\x8D\xA3",
		"\xB5\xB8" => "\xE8\xB9\x88",
		"\xB5\xB9" => "\xE5\x80\x92",
		"\xB5\xBA" => "\xE5\xB2\x9B",
		"\xB5\xBB" => "\xE7\xA5\xB7",
		"\xB5\xBC" => "\xE5\xAF\xBC",
		"\xB5\xBD" => "\xE5\x88\xB0",
		"\xB5\xBE" => "\xE7\xA8\xBB",
		"\xB5\xBF" => "\xE6\x82\xBC",
		"\xB5\xC0" => "\xE9\x81\x93",
		"\xB5\xC1" => "\xE7\x9B\x97",
		"\xB5\xC2" => "\xE5\xBE\xB7",
		"\xB5\xC3" => "\xE5\xBE\x97",
		"\xB5\xC4" => "\xE7\x9A\x84",
		"\xB5\xC5" => "\xE8\xB9\xAC",
		"\xB5\xC6" => "\xE7\x81\xAF",
		"\xB5\xC7" => "\xE7\x99\xBB",
		"\xB5\xC8" => "\xE7\xAD\x89",
		"\xB5\xC9" => "\xE7\x9E\xAA",
		"\xB5\xCA" => "\xE5\x87\xB3",
		"\xB5\xCB" => "\xE9\x82\x93",
		"\xB5\xCC" => "\xE5\xA0\xA4",
		"\xB5\xCD" => "\xE4\xBD\x8E",
		"\xB5\xCE" => "\xE6\xBB\xB4",
		"\xB5\xCF" => "\xE8\xBF\xAA",
		"\xB5\xD0" => "\xE6\x95\x8C",
		"\xB5\xD1" => "\xE7\xAC\x9B",
		"\xB5\xD2" => "\xE7\x8B\x84",
		"\xB5\xD3" => "\xE6\xB6\xA4",
		"\xB5\xD4" => "\xE7\xBF\x9F",
		"\xB5\xD5" => "\xE5\xAB\xA1",
		"\xB5\xD6" => "\xE6\x8A\xB5",
		"\xB5\xD7" => "\xE5\xBA\x95",
		"\xB5\xD8" => "\xE5\x9C\xB0",
		"\xB5\xD9" => "\xE8\x92\x82",
		"\xB5\xDA" => "\xE7\xAC\xAC",
		"\xB5\xDB" => "\xE5\xB8\x9D",
		"\xB5\xDC" => "\xE5\xBC\x9F",
		"\xB5\xDD" => "\xE9\x80\x92",
		"\xB5\xDE" => "\xE7\xBC\x94",
		"\xB5\xDF" => "\xE9\xA2\xA0",
		"\xB5\xE0" => "\xE6\x8E\x82",
		"\xB5\xE1" => "\xE6\xBB\x87",
		"\xB5\xE2" => "\xE7\xA2\x98",
		"\xB5\xE3" => "\xE7\x82\xB9",
		"\xB5\xE4" => "\xE5\x85\xB8",
		"\xB5\xE5" => "\xE9\x9D\x9B",
		"\xB5\xE6" => "\xE5\x9E\xAB",
		"\xB5\xE7" => "\xE7\x94\xB5",
		"\xB5\xE8" => "\xE4\xBD\x83",
		"\xB5\xE9" => "\xE7\x94\xB8",
		"\xB5\xEA" => "\xE5\xBA\x97",
		"\xB5\xEB" => "\xE6\x83\xA6",
		"\xB5\xEC" => "\xE5\xA5\xA0",
		"\xB5\xED" => "\xE6\xB7\x80",
		"\xB5\xEE" => "\xE6\xAE\xBF",
		"\xB5\xEF" => "\xE7\xA2\x89",
		"\xB5\xF0" => "\xE5\x8F\xBC",
		"\xB5\xF1" => "\xE9\x9B\x95",
		"\xB5\xF2" => "\xE5\x87\x8B",
		"\xB5\xF3" => "\xE5\x88\x81",
		"\xB5\xF4" => "\xE6\x8E\x89",
		"\xB5\xF5" => "\xE5\x90\x8A",
		"\xB5\xF6" => "\xE9\x92\x93",
		"\xB5\xF7" => "\xE8\xB0\x83",
		"\xB5\xF8" => "\xE8\xB7\x8C",
		"\xB5\xF9" => "\xE7\x88\xB9",
		"\xB5\xFA" => "\xE7\xA2\x9F",
		"\xB5\xFB" => "\xE8\x9D\xB6",
		"\xB5\xFC" => "\xE8\xBF\xAD",
		"\xB5\xFD" => "\xE8\xB0\x8D",
		"\xB5\xFE" => "\xE5\x8F\xA0",
		"\xB6\xA1" => "\xE4\xB8\x81",
		"\xB6\xA2" => "\xE7\x9B\xAF",
		"\xB6\xA3" => "\xE5\x8F\xAE",
		"\xB6\xA4" => "\xE9\x92\x89",
		"\xB6\xA5" => "\xE9\xA1\xB6",
		"\xB6\xA6" => "\xE9\xBC\x8E",
		"\xB6\xA7" => "\xE9\x94\xAD",
		"\xB6\xA8" => "\xE5\xAE\x9A",
		"\xB6\xA9" => "\xE8\xAE\xA2",
		"\xB6\xAA" => "\xE4\xB8\xA2",
		"\xB6\xAB" => "\xE4\xB8\x9C",
		"\xB6\xAC" => "\xE5\x86\xAC",
		"\xB6\xAD" => "\xE8\x91\xA3",
		"\xB6\xAE" => "\xE6\x87\x82",
		"\xB6\xAF" => "\xE5\x8A\xA8",
		"\xB6\xB0" => "\xE6\xA0\x8B",
		"\xB6\xB1" => "\xE4\xBE\x97",
		"\xB6\xB2" => "\xE6\x81\xAB",
		"\xB6\xB3" => "\xE5\x86\xBB",
		"\xB6\xB4" => "\xE6\xB4\x9E",
		"\xB6\xB5" => "\xE5\x85\x9C",
		"\xB6\xB6" => "\xE6\x8A\x96",
		"\xB6\xB7" => "\xE6\x96\x97",
		"\xB6\xB8" => "\xE9\x99\xA1",
		"\xB6\xB9" => "\xE8\xB1\x86",
		"\xB6\xBA" => "\xE9\x80\x97",
		"\xB6\xBB" => "\xE7\x97\x98",
		"\xB6\xBC" => "\xE9\x83\xBD",
		"\xB6\xBD" => "\xE7\x9D\xA3",
		"\xB6\xBE" => "\xE6\xAF\x92",
		"\xB6\xBF" => "\xE7\x8A\x8A",
		"\xB6\xC0" => "\xE7\x8B\xAC",
		"\xB6\xC1" => "\xE8\xAF\xBB",
		"\xB6\xC2" => "\xE5\xA0\xB5",
		"\xB6\xC3" => "\xE7\x9D\xB9",
		"\xB6\xC4" => "\xE8\xB5\x8C",
		"\xB6\xC5" => "\xE6\x9D\x9C",
		"\xB6\xC6" => "\xE9\x95\x80",
		"\xB6\xC7" => "\xE8\x82\x9A",
		"\xB6\xC8" => "\xE5\xBA\xA6",
		"\xB6\xC9" => "\xE6\xB8\xA1",
		"\xB6\xCA" => "\xE5\xA6\x92",
		"\xB6\xCB" => "\xE7\xAB\xAF",
		"\xB6\xCC" => "\xE7\x9F\xAD",
		"\xB6\xCD" => "\xE9\x94\xBB",
		"\xB6\xCE" => "\xE6\xAE\xB5",
		"\xB6\xCF" => "\xE6\x96\xAD",
		"\xB6\xD0" => "\xE7\xBC\x8E",
		"\xB6\xD1" => "\xE5\xA0\x86",
		"\xB6\xD2" => "\xE5\x85\x91",
		"\xB6\xD3" => "\xE9\x98\x9F",
		"\xB6\xD4" => "\xE5\xAF\xB9",
		"\xB6\xD5" => "\xE5\xA2\xA9",
		"\xB6\xD6" => "\xE5\x90\xA8",
		"\xB6\xD7" => "\xE8\xB9\xB2",
		"\xB6\xD8" => "\xE6\x95\xA6",
		"\xB6\xD9" => "\xE9\xA1\xBF",
		"\xB6\xDA" => "\xE5\x9B\xA4",
		"\xB6\xDB" => "\xE9\x92\x9D",
		"\xB6\xDC" => "\xE7\x9B\xBE",
		"\xB6\xDD" => "\xE9\x81\x81",
		"\xB6\xDE" => "\xE6\x8E\x87",
		"\xB6\xDF" => "\xE5\x93\x86",
		"\xB6\xE0" => "\xE5\xA4\x9A",
		"\xB6\xE1" => "\xE5\xA4\xBA",
		"\xB6\xE2" => "\xE5\x9E\x9B",
		"\xB6\xE3" => "\xE8\xBA\xB2",
		"\xB6\xE4" => "\xE6\x9C\xB5",
		"\xB6\xE5" => "\xE8\xB7\xBA",
		"\xB6\xE6" => "\xE8\x88\xB5",
		"\xB6\xE7" => "\xE5\x89\x81",
		"\xB6\xE8" => "\xE6\x83\xB0",
		"\xB6\xE9" => "\xE5\xA0\x95",
		"\xB6\xEA" => "\xE8\x9B\xBE",
		"\xB6\xEB" => "\xE5\xB3\xA8",
		"\xB6\xEC" => "\xE9\xB9\x85",
		"\xB6\xED" => "\xE4\xBF\x84",
		"\xB6\xEE" => "\xE9\xA2\x9D",
		"\xB6\xEF" => "\xE8\xAE\xB9",
		"\xB6\xF0" => "\xE5\xA8\xA5",
		"\xB6\xF1" => "\xE6\x81\xB6",
		"\xB6\xF2" => "\xE5\x8E\x84",
		"\xB6\xF3" => "\xE6\x89\xBC",
		"\xB6\xF4" => "\xE9\x81\x8F",
		"\xB6\xF5" => "\xE9\x84\x82",
		"\xB6\xF6" => "\xE9\xA5\xBF",
		"\xB6\xF7" => "\xE6\x81\xA9",
		"\xB6\xF8" => "\xE8\x80\x8C",
		"\xB6\xF9" => "\xE5\x84\xBF",
		"\xB6\xFA" => "\xE8\x80\xB3",
		"\xB6\xFB" => "\xE5\xB0\x94",
		"\xB6\xFC" => "\xE9\xA5\xB5",
		"\xB6\xFD" => "\xE6\xB4\xB1",
		"\xB6\xFE" => "\xE4\xBA\x8C",
		"\xB7\xA1" => "\xE8\xB4\xB0",
		"\xB7\xA2" => "\xE5\x8F\x91",
		"\xB7\xA3" => "\xE7\xBD\x9A",
		"\xB7\xA4" => "\xE7\xAD\x8F",
		"\xB7\xA5" => "\xE4\xBC\x90",
		"\xB7\xA6" => "\xE4\xB9\x8F",
		"\xB7\xA7" => "\xE9\x98\x80",
		"\xB7\xA8" => "\xE6\xB3\x95",
		"\xB7\xA9" => "\xE7\x8F\x90",
		"\xB7\xAA" => "\xE8\x97\xA9",
		"\xB7\xAB" => "\xE5\xB8\x86",
		"\xB7\xAC" => "\xE7\x95\xAA",
		"\xB7\xAD" => "\xE7\xBF\xBB",
		"\xB7\xAE" => "\xE6\xA8\x8A",
		"\xB7\xAF" => "\xE7\x9F\xBE",
		"\xB7\xB0" => "\xE9\x92\x92",
		"\xB7\xB1" => "\xE7\xB9\x81",
		"\xB7\xB2" => "\xE5\x87\xA1",
		"\xB7\xB3" => "\xE7\x83\xA6",
		"\xB7\xB4" => "\xE5\x8F\x8D",
		"\xB7\xB5" => "\xE8\xBF\x94",
		"\xB7\xB6" => "\xE8\x8C\x83",
		"\xB7\xB7" => "\xE8\xB4\xA9",
		"\xB7\xB8" => "\xE7\x8A\xAF",
		"\xB7\xB9" => "\xE9\xA5\xAD",
		"\xB7\xBA" => "\xE6\xB3\x9B",
		"\xB7\xBB" => "\xE5\x9D\x8A",
		"\xB7\xBC" => "\xE8\x8A\xB3",
		"\xB7\xBD" => "\xE6\x96\xB9",
		"\xB7\xBE" => "\xE8\x82\xAA",
		"\xB7\xBF" => "\xE6\x88\xBF",
		"\xB7\xC0" => "\xE9\x98\xB2",
		"\xB7\xC1" => "\xE5\xA6\xA8",
		"\xB7\xC2" => "\xE4\xBB\xBF",
		"\xB7\xC3" => "\xE8\xAE\xBF",
		"\xB7\xC4" => "\xE7\xBA\xBA",
		"\xB7\xC5" => "\xE6\x94\xBE",
		"\xB7\xC6" => "\xE8\x8F\xB2",
		"\xB7\xC7" => "\xE9\x9D\x9E",
		"\xB7\xC8" => "\xE5\x95\xA1",
		"\xB7\xC9" => "\xE9\xA3\x9E",
		"\xB7\xCA" => "\xE8\x82\xA5",
		"\xB7\xCB" => "\xE5\x8C\xAA",
		"\xB7\xCC" => "\xE8\xAF\xBD",
		"\xB7\xCD" => "\xE5\x90\xA0",
		"\xB7\xCE" => "\xE8\x82\xBA",
		"\xB7\xCF" => "\xE5\xBA\x9F",
		"\xB7\xD0" => "\xE6\xB2\xB8",
		"\xB7\xD1" => "\xE8\xB4\xB9",
		"\xB7\xD2" => "\xE8\x8A\xAC",
		"\xB7\xD3" => "\xE9\x85\x9A",
		"\xB7\xD4" => "\xE5\x90\xA9",
		"\xB7\xD5" => "\xE6\xB0\x9B",
		"\xB7\xD6" => "\xE5\x88\x86",
		"\xB7\xD7" => "\xE7\xBA\xB7",
		"\xB7\xD8" => "\xE5\x9D\x9F",
		"\xB7\xD9" => "\xE7\x84\x9A",
		"\xB7\xDA" => "\xE6\xB1\xBE",
		"\xB7\xDB" => "\xE7\xB2\x89",
		"\xB7\xDC" => "\xE5\xA5\x8B",
		"\xB7\xDD" => "\xE4\xBB\xBD",
		"\xB7\xDE" => "\xE5\xBF\xBF",
		"\xB7\xDF" => "\xE6\x84\xA4",
		"\xB7\xE0" => "\xE7\xB2\xAA",
		"\xB7\xE1" => "\xE4\xB8\xB0",
		"\xB7\xE2" => "\xE5\xB0\x81",
		"\xB7\xE3" => "\xE6\x9E\xAB",
		"\xB7\xE4" => "\xE8\x9C\x82",
		"\xB7\xE5" => "\xE5\xB3\xB0",
		"\xB7\xE6" => "\xE9\x94\x8B",
		"\xB7\xE7" => "\xE9\xA3\x8E",
		"\xB7\xE8" => "\xE7\x96\xAF",
		"\xB7\xE9" => "\xE7\x83\xBD",
		"\xB7\xEA" => "\xE9\x80\xA2",
		"\xB7\xEB" => "\xE5\x86\xAF",
		"\xB7\xEC" => "\xE7\xBC\x9D",
		"\xB7\xED" => "\xE8\xAE\xBD",
		"\xB7\xEE" => "\xE5\xA5\x89",
		"\xB7\xEF" => "\xE5\x87\xA4",
		"\xB7\xF0" => "\xE4\xBD\x9B",
		"\xB7\xF1" => "\xE5\x90\xA6",
		"\xB7\xF2" => "\xE5\xA4\xAB",
		"\xB7\xF3" => "\xE6\x95\xB7",
		"\xB7\xF4" => "\xE8\x82\xA4",
		"\xB7\xF5" => "\xE5\xAD\xB5",
		"\xB7\xF6" => "\xE6\x89\xB6",
		"\xB7\xF7" => "\xE6\x8B\x82",
		"\xB7\xF8" => "\xE8\xBE\x90",
		"\xB7\xF9" => "\xE5\xB9\x85",
		"\xB7\xFA" => "\xE6\xB0\x9F",
		"\xB7\xFB" => "\xE7\xAC\xA6",
		"\xB7\xFC" => "\xE4\xBC\x8F",
		"\xB7\xFD" => "\xE4\xBF\x98",
		"\xB7\xFE" => "\xE6\x9C\x8D",
		"\xB8\xA1" => "\xE6\xB5\xAE",
		"\xB8\xA2" => "\xE6\xB6\xAA",
		"\xB8\xA3" => "\xE7\xA6\x8F",
		"\xB8\xA4" => "\xE8\xA2\xB1",
		"\xB8\xA5" => "\xE5\xBC\x97",
		"\xB8\xA6" => "\xE7\x94\xAB",
		"\xB8\xA7" => "\xE6\x8A\x9A",
		"\xB8\xA8" => "\xE8\xBE\x85",
		"\xB8\xA9" => "\xE4\xBF\xAF",
		"\xB8\xAA" => "\xE9\x87\x9C",
		"\xB8\xAB" => "\xE6\x96\xA7",
		"\xB8\xAC" => "\xE8\x84\xAF",
		"\xB8\xAD" => "\xE8\x85\x91",
		"\xB8\xAE" => "\xE5\xBA\x9C",
		"\xB8\xAF" => "\xE8\x85\x90",
		"\xB8\xB0" => "\xE8\xB5\xB4",
		"\xB8\xB1" => "\xE5\x89\xAF",
		"\xB8\xB2" => "\xE8\xA6\x86",
		"\xB8\xB3" => "\xE8\xB5\x8B",
		"\xB8\xB4" => "\xE5\xA4\x8D",
		"\xB8\xB5" => "\xE5\x82\x85",
		"\xB8\xB6" => "\xE4\xBB\x98",
		"\xB8\xB7" => "\xE9\x98\x9C",
		"\xB8\xB8" => "\xE7\x88\xB6",
		"\xB8\xB9" => "\xE8\x85\xB9",
		"\xB8\xBA" => "\xE8\xB4\x9F",
		"\xB8\xBB" => "\xE5\xAF\x8C",
		"\xB8\xBC" => "\xE8\xAE\xA3",
		"\xB8\xBD" => "\xE9\x99\x84",
		"\xB8\xBE" => "\xE5\xA6\x87",
		"\xB8\xBF" => "\xE7\xBC\x9A",
		"\xB8\xC0" => "\xE5\x92\x90",
		"\xB8\xC1" => "\xE5\x99\xB6",
		"\xB8\xC2" => "\xE5\x98\x8E",
		"\xB8\xC3" => "\xE8\xAF\xA5",
		"\xB8\xC4" => "\xE6\x94\xB9",
		"\xB8\xC5" => "\xE6\xA6\x82",
		"\xB8\xC6" => "\xE9\x92\x99",
		"\xB8\xC7" => "\xE7\x9B\x96",
		"\xB8\xC8" => "\xE6\xBA\x89",
		"\xB8\xC9" => "\xE5\xB9\xB2",
		"\xB8\xCA" => "\xE7\x94\x98",
		"\xB8\xCB" => "\xE6\x9D\x86",
		"\xB8\xCC" => "\xE6\x9F\x91",
		"\xB8\xCD" => "\xE7\xAB\xBF",
		"\xB8\xCE" => "\xE8\x82\x9D",
		"\xB8\xCF" => "\xE8\xB5\xB6",
		"\xB8\xD0" => "\xE6\x84\x9F",
		"\xB8\xD1" => "\xE7\xA7\x86",
		"\xB8\xD2" => "\xE6\x95\xA2",
		"\xB8\xD3" => "\xE8\xB5\xA3",
		"\xB8\xD4" => "\xE5\x86\x88",
		"\xB8\xD5" => "\xE5\x88\x9A",
		"\xB8\xD6" => "\xE9\x92\xA2",
		"\xB8\xD7" => "\xE7\xBC\xB8",
		"\xB8\xD8" => "\xE8\x82\x9B",
		"\xB8\xD9" => "\xE7\xBA\xB2",
		"\xB8\xDA" => "\xE5\xB2\x97",
		"\xB8\xDB" => "\xE6\xB8\xAF",
		"\xB8\xDC" => "\xE6\x9D\xA0",
		"\xB8\xDD" => "\xE7\xAF\x99",
		"\xB8\xDE" => "\xE7\x9A\x8B",
		"\xB8\xDF" => "\xE9\xAB\x98",
		"\xB8\xE0" => "\xE8\x86\x8F",
		"\xB8\xE1" => "\xE7\xBE\x94",
		"\xB8\xE2" => "\xE7\xB3\x95",
		"\xB8\xE3" => "\xE6\x90\x9E",
		"\xB8\xE4" => "\xE9\x95\x90",
		"\xB8\xE5" => "\xE7\xA8\xBF",
		"\xB8\xE6" => "\xE5\x91\x8A",
		"\xB8\xE7" => "\xE5\x93\xA5",
		"\xB8\xE8" => "\xE6\xAD\x8C",
		"\xB8\xE9" => "\xE6\x90\x81",
		"\xB8\xEA" => "\xE6\x88\x88",
		"\xB8\xEB" => "\xE9\xB8\xBD",
		"\xB8\xEC" => "\xE8\x83\xB3",
		"\xB8\xED" => "\xE7\x96\x99",
		"\xB8\xEE" => "\xE5\x89\xB2",
		"\xB8\xEF" => "\xE9\x9D\xA9",
		"\xB8\xF0" => "\xE8\x91\x9B",
		"\xB8\xF1" => "\xE6\xA0\xBC",
		"\xB8\xF2" => "\xE8\x9B\xA4",
		"\xB8\xF3" => "\xE9\x98\x81",
		"\xB8\xF4" => "\xE9\x9A\x94",
		"\xB8\xF5" => "\xE9\x93\xAC",
		"\xB8\xF6" => "\xE4\xB8\xAA",
		"\xB8\xF7" => "\xE5\x90\x84",
		"\xB8\xF8" => "\xE7\xBB\x99",
		"\xB8\xF9" => "\xE6\xA0\xB9",
		"\xB8\xFA" => "\xE8\xB7\x9F",
		"\xB8\xFB" => "\xE8\x80\x95",
		"\xB8\xFC" => "\xE6\x9B\xB4",
		"\xB8\xFD" => "\xE5\xBA\x9A",
		"\xB8\xFE" => "\xE7\xBE\xB9",
		"\xB9\xA1" => "\xE5\x9F\x82",
		"\xB9\xA2" => "\xE8\x80\xBF",
		"\xB9\xA3" => "\xE6\xA2\x97",
		"\xB9\xA4" => "\xE5\xB7\xA5",
		"\xB9\xA5" => "\xE6\x94\xBB",
		"\xB9\xA6" => "\xE5\x8A\x9F",
		"\xB9\xA7" => "\xE6\x81\xAD",
		"\xB9\xA8" => "\xE9\xBE\x9A",
		"\xB9\xA9" => "\xE4\xBE\x9B",
		"\xB9\xAA" => "\xE8\xBA\xAC",
		"\xB9\xAB" => "\xE5\x85\xAC",
		"\xB9\xAC" => "\xE5\xAE\xAB",
		"\xB9\xAD" => "\xE5\xBC\x93",
		"\xB9\xAE" => "\xE5\xB7\xA9",
		"\xB9\xAF" => "\xE6\xB1\x9E",
		"\xB9\xB0" => "\xE6\x8B\xB1",
		"\xB9\xB1" => "\xE8\xB4\xA1",
		"\xB9\xB2" => "\xE5\x85\xB1",
		"\xB9\xB3" => "\xE9\x92\xA9",
		"\xB9\xB4" => "\xE5\x8B\xBE",
		"\xB9\xB5" => "\xE6\xB2\x9F",
		"\xB9\xB6" => "\xE8\x8B\x9F",
		"\xB9\xB7" => "\xE7\x8B\x97",
		"\xB9\xB8" => "\xE5\x9E\xA2",
		"\xB9\xB9" => "\xE6\x9E\x84",
		"\xB9\xBA" => "\xE8\xB4\xAD",
		"\xB9\xBB" => "\xE5\xA4\x9F",
		"\xB9\xBC" => "\xE8\xBE\x9C",
		"\xB9\xBD" => "\xE8\x8F\x87",
		"\xB9\xBE" => "\xE5\x92\x95",
		"\xB9\xBF" => "\xE7\xAE\x8D",
		"\xB9\xC0" => "\xE4\xBC\xB0",
		"\xB9\xC1" => "\xE6\xB2\xBD",
		"\xB9\xC2" => "\xE5\xAD\xA4",
		"\xB9\xC3" => "\xE5\xA7\x91",
		"\xB9\xC4" => "\xE9\xBC\x93",
		"\xB9\xC5" => "\xE5\x8F\xA4",
		"\xB9\xC6" => "\xE8\x9B\x8A",
		"\xB9\xC7" => "\xE9\xAA\xA8",
		"\xB9\xC8" => "\xE8\xB0\xB7",
		"\xB9\xC9" => "\xE8\x82\xA1",
		"\xB9\xCA" => "\xE6\x95\x85",
		"\xB9\xCB" => "\xE9\xA1\xBE",
		"\xB9\xCC" => "\xE5\x9B\xBA",
		"\xB9\xCD" => "\xE9\x9B\x87",
		"\xB9\xCE" => "\xE5\x88\xAE",
		"\xB9\xCF" => "\xE7\x93\x9C",
		"\xB9\xD0" => "\xE5\x89\x90",
		"\xB9\xD1" => "\xE5\xAF\xA1",
		"\xB9\xD2" => "\xE6\x8C\x82",
		"\xB9\xD3" => "\xE8\xA4\x82",
		"\xB9\xD4" => "\xE4\xB9\x96",
		"\xB9\xD5" => "\xE6\x8B\x90",
		"\xB9\xD6" => "\xE6\x80\xAA",
		"\xB9\xD7" => "\xE6\xA3\xBA",
		"\xB9\xD8" => "\xE5\x85\xB3",
		"\xB9\xD9" => "\xE5\xAE\x98",
		"\xB9\xDA" => "\xE5\x86\xA0",
		"\xB9\xDB" => "\xE8\xA7\x82",
		"\xB9\xDC" => "\xE7\xAE\xA1",
		"\xB9\xDD" => "\xE9\xA6\x86",
		"\xB9\xDE" => "\xE7\xBD\x90",
		"\xB9\xDF" => "\xE6\x83\xAF",
		"\xB9\xE0" => "\xE7\x81\x8C",
		"\xB9\xE1" => "\xE8\xB4\xAF",
		"\xB9\xE2" => "\xE5\x85\x89",
		"\xB9\xE3" => "\xE5\xB9\xBF",
		"\xB9\xE4" => "\xE9\x80\x9B",
		"\xB9\xE5" => "\xE7\x91\xB0",
		"\xB9\xE6" => "\xE8\xA7\x84",
		"\xB9\xE7" => "\xE5\x9C\xAD",
		"\xB9\xE8" => "\xE7\xA1\x85",
		"\xB9\xE9" => "\xE5\xBD\x92",
		"\xB9\xEA" => "\xE9\xBE\x9F",
		"\xB9\xEB" => "\xE9\x97\xBA",
		"\xB9\xEC" => "\xE8\xBD\xA8",
		"\xB9\xED" => "\xE9\xAC\xBC",
		"\xB9\xEE" => "\xE8\xAF\xA1",
		"\xB9\xEF" => "\xE7\x99\xB8",
		"\xB9\xF0" => "\xE6\xA1\x82",
		"\xB9\xF1" => "\xE6\x9F\x9C",
		"\xB9\xF2" => "\xE8\xB7\xAA",
		"\xB9\xF3" => "\xE8\xB4\xB5",
		"\xB9\xF4" => "\xE5\x88\xBD",
		"\xB9\xF5" => "\xE8\xBE\x8A",
		"\xB9\xF6" => "\xE6\xBB\x9A",
		"\xB9\xF7" => "\xE6\xA3\x8D",
		"\xB9\xF8" => "\xE9\x94\x85",
		"\xB9\xF9" => "\xE9\x83\xAD",
		"\xB9\xFA" => "\xE5\x9B\xBD",
		"\xB9\xFB" => "\xE6\x9E\x9C",
		"\xB9\xFC" => "\xE8\xA3\xB9",
		"\xB9\xFD" => "\xE8\xBF\x87",
		"\xB9\xFE" => "\xE5\x93\x88",
		"\xBA\xA1" => "\xE9\xAA\xB8",
		"\xBA\xA2" => "\xE5\xAD\xA9",
		"\xBA\xA3" => "\xE6\xB5\xB7",
		"\xBA\xA4" => "\xE6\xB0\xA6",
		"\xBA\xA5" => "\xE4\xBA\xA5",
		"\xBA\xA6" => "\xE5\xAE\xB3",
		"\xBA\xA7" => "\xE9\xAA\x87",
		"\xBA\xA8" => "\xE9\x85\xA3",
		"\xBA\xA9" => "\xE6\x86\xA8",
		"\xBA\xAA" => "\xE9\x82\xAF",
		"\xBA\xAB" => "\xE9\x9F\xA9",
		"\xBA\xAC" => "\xE5\x90\xAB",
		"\xBA\xAD" => "\xE6\xB6\xB5",
		"\xBA\xAE" => "\xE5\xAF\x92",
		"\xBA\xAF" => "\xE5\x87\xBD",
		"\xBA\xB0" => "\xE5\x96\x8A",
		"\xBA\xB1" => "\xE7\xBD\x95",
		"\xBA\xB2" => "\xE7\xBF\xB0",
		"\xBA\xB3" => "\xE6\x92\xBC",
		"\xBA\xB4" => "\xE6\x8D\x8D",
		"\xBA\xB5" => "\xE6\x97\xB1",
		"\xBA\xB6" => "\xE6\x86\xBE",
		"\xBA\xB7" => "\xE6\x82\x8D",
		"\xBA\xB8" => "\xE7\x84\x8A",
		"\xBA\xB9" => "\xE6\xB1\x97",
		"\xBA\xBA" => "\xE6\xB1\x89",
		"\xBA\xBB" => "\xE5\xA4\xAF",
		"\xBA\xBC" => "\xE6\x9D\xAD",
		"\xBA\xBD" => "\xE8\x88\xAA",
		"\xBA\xBE" => "\xE5\xA3\x95",
		"\xBA\xBF" => "\xE5\x9A\x8E",
		"\xBA\xC0" => "\xE8\xB1\xAA",
		"\xBA\xC1" => "\xE6\xAF\xAB",
		"\xBA\xC2" => "\xE9\x83\x9D",
		"\xBA\xC3" => "\xE5\xA5\xBD",
		"\xBA\xC4" => "\xE8\x80\x97",
		"\xBA\xC5" => "\xE5\x8F\xB7",
		"\xBA\xC6" => "\xE6\xB5\xA9",
		"\xBA\xC7" => "\xE5\x91\xB5",
		"\xBA\xC8" => "\xE5\x96\x9D",
		"\xBA\xC9" => "\xE8\x8D\xB7",
		"\xBA\xCA" => "\xE8\x8F\x8F",
		"\xBA\xCB" => "\xE6\xA0\xB8",
		"\xBA\xCC" => "\xE7\xA6\xBE",
		"\xBA\xCD" => "\xE5\x92\x8C",
		"\xBA\xCE" => "\xE4\xBD\x95",
		"\xBA\xCF" => "\xE5\x90\x88",
		"\xBA\xD0" => "\xE7\x9B\x92",
		"\xBA\xD1" => "\xE8\xB2\x89",
		"\xBA\xD2" => "\xE9\x98\x82",
		"\xBA\xD3" => "\xE6\xB2\xB3",
		"\xBA\xD4" => "\xE6\xB6\xB8",
		"\xBA\xD5" => "\xE8\xB5\xAB",
		"\xBA\xD6" => "\xE8\xA4\x90",
		"\xBA\xD7" => "\xE9\xB9\xA4",
		"\xBA\xD8" => "\xE8\xB4\xBA",
		"\xBA\xD9" => "\xE5\x98\xBF",
		"\xBA\xDA" => "\xE9\xBB\x91",
		"\xBA\xDB" => "\xE7\x97\x95",
		"\xBA\xDC" => "\xE5\xBE\x88",
		"\xBA\xDD" => "\xE7\x8B\xA0",
		"\xBA\xDE" => "\xE6\x81\xA8",
		"\xBA\xDF" => "\xE5\x93\xBC",
		"\xBA\xE0" => "\xE4\xBA\xA8",
		"\xBA\xE1" => "\xE6\xA8\xAA",
		"\xBA\xE2" => "\xE8\xA1\xA1",
		"\xBA\xE3" => "\xE6\x81\x92",
		"\xBA\xE4" => "\xE8\xBD\xB0",
		"\xBA\xE5" => "\xE5\x93\x84",
		"\xBA\xE6" => "\xE7\x83\x98",
		"\xBA\xE7" => "\xE8\x99\xB9",
		"\xBA\xE8" => "\xE9\xB8\xBF",
		"\xBA\xE9" => "\xE6\xB4\xAA",
		"\xBA\xEA" => "\xE5\xAE\x8F",
		"\xBA\xEB" => "\xE5\xBC\x98",
		"\xBA\xEC" => "\xE7\xBA\xA2",
		"\xBA\xED" => "\xE5\x96\x89",
		"\xBA\xEE" => "\xE4\xBE\xAF",
		"\xBA\xEF" => "\xE7\x8C\xB4",
		"\xBA\xF0" => "\xE5\x90\xBC",
		"\xBA\xF1" => "\xE5\x8E\x9A",
		"\xBA\xF2" => "\xE5\x80\x99",
		"\xBA\xF3" => "\xE5\x90\x8E",
		"\xBA\xF4" => "\xE5\x91\xBC",
		"\xBA\xF5" => "\xE4\xB9\x8E",
		"\xBA\xF6" => "\xE5\xBF\xBD",
		"\xBA\xF7" => "\xE7\x91\x9A",
		"\xBA\xF8" => "\xE5\xA3\xB6",
		"\xBA\xF9" => "\xE8\x91\xAB",
		"\xBA\xFA" => "\xE8\x83\xA1",
		"\xBA\xFB" => "\xE8\x9D\xB4",
		"\xBA\xFC" => "\xE7\x8B\x90",
		"\xBA\xFD" => "\xE7\xB3\x8A",
		"\xBA\xFE" => "\xE6\xB9\x96",
		"\xBB\xA1" => "\xE5\xBC\xA7",
		"\xBB\xA2" => "\xE8\x99\x8E",
		"\xBB\xA3" => "\xE5\x94\xAC",
		"\xBB\xA4" => "\xE6\x8A\xA4",
		"\xBB\xA5" => "\xE4\xBA\x92",
		"\xBB\xA6" => "\xE6\xB2\xAA",
		"\xBB\xA7" => "\xE6\x88\xB7",
		"\xBB\xA8" => "\xE8\x8A\xB1",
		"\xBB\xA9" => "\xE5\x93\x97",
		"\xBB\xAA" => "\xE5\x8D\x8E",
		"\xBB\xAB" => "\xE7\x8C\xBE",
		"\xBB\xAC" => "\xE6\xBB\x91",
		"\xBB\xAD" => "\xE7\x94\xBB",
		"\xBB\xAE" => "\xE5\x88\x92",
		"\xBB\xAF" => "\xE5\x8C\x96",
		"\xBB\xB0" => "\xE8\xAF\x9D",
		"\xBB\xB1" => "\xE6\xA7\x90",
		"\xBB\xB2" => "\xE5\xBE\x8A",
		"\xBB\xB3" => "\xE6\x80\x80",
		"\xBB\xB4" => "\xE6\xB7\xAE",
		"\xBB\xB5" => "\xE5\x9D\x8F",
		"\xBB\xB6" => "\xE6\xAC\xA2",
		"\xBB\xB7" => "\xE7\x8E\xAF",
		"\xBB\xB8" => "\xE6\xA1\x93",
		"\xBB\xB9" => "\xE8\xBF\x98",
		"\xBB\xBA" => "\xE7\xBC\x93",
		"\xBB\xBB" => "\xE6\x8D\xA2",
		"\xBB\xBC" => "\xE6\x82\xA3",
		"\xBB\xBD" => "\xE5\x94\xA4",
		"\xBB\xBE" => "\xE7\x97\xAA",
		"\xBB\xBF" => "\xE8\xB1\xA2",
		"\xBB\xC0" => "\xE7\x84\x95",
		"\xBB\xC1" => "\xE6\xB6\xA3",
		"\xBB\xC2" => "\xE5\xAE\xA6",
		"\xBB\xC3" => "\xE5\xB9\xBB",
		"\xBB\xC4" => "\xE8\x8D\x92",
		"\xBB\xC5" => "\xE6\x85\x8C",
		"\xBB\xC6" => "\xE9\xBB\x84",
		"\xBB\xC7" => "\xE7\xA3\xBA",
		"\xBB\xC8" => "\xE8\x9D\x97",
		"\xBB\xC9" => "\xE7\xB0\xA7",
		"\xBB\xCA" => "\xE7\x9A\x87",
		"\xBB\xCB" => "\xE5\x87\xB0",
		"\xBB\xCC" => "\xE6\x83\xB6",
		"\xBB\xCD" => "\xE7\x85\x8C",
		"\xBB\xCE" => "\xE6\x99\x83",
		"\xBB\xCF" => "\xE5\xB9\x8C",
		"\xBB\xD0" => "\xE6\x81\x8D",
		"\xBB\xD1" => "\xE8\xB0\x8E",
		"\xBB\xD2" => "\xE7\x81\xB0",
		"\xBB\xD3" => "\xE6\x8C\xA5",
		"\xBB\xD4" => "\xE8\xBE\x89",
		"\xBB\xD5" => "\xE5\xBE\xBD",
		"\xBB\xD6" => "\xE6\x81\xA2",
		"\xBB\xD7" => "\xE8\x9B\x94",
		"\xBB\xD8" => "\xE5\x9B\x9E",
		"\xBB\xD9" => "\xE6\xAF\x81",
		"\xBB\xDA" => "\xE6\x82\x94",
		"\xBB\xDB" => "\xE6\x85\xA7",
		"\xBB\xDC" => "\xE5\x8D\x89",
		"\xBB\xDD" => "\xE6\x83\xA0",
		"\xBB\xDE" => "\xE6\x99\xA6",
		"\xBB\xDF" => "\xE8\xB4\xBF",
		"\xBB\xE0" => "\xE7\xA7\xBD",
		"\xBB\xE1" => "\xE4\xBC\x9A",
		"\xBB\xE2" => "\xE7\x83\xA9",
		"\xBB\xE3" => "\xE6\xB1\x87",
		"\xBB\xE4" => "\xE8\xAE\xB3",
		"\xBB\xE5" => "\xE8\xAF\xB2",
		"\xBB\xE6" => "\xE7\xBB\x98",
		"\xBB\xE7" => "\xE8\x8D\xA4",
		"\xBB\xE8" => "\xE6\x98\x8F",
		"\xBB\xE9" => "\xE5\xA9\x9A",
		"\xBB\xEA" => "\xE9\xAD\x82",
		"\xBB\xEB" => "\xE6\xB5\x91",
		"\xBB\xEC" => "\xE6\xB7\xB7",
		"\xBB\xED" => "\xE8\xB1\x81",
		"\xBB\xEE" => "\xE6\xB4\xBB",
		"\xBB\xEF" => "\xE4\xBC\x99",
		"\xBB\xF0" => "\xE7\x81\xAB",
		"\xBB\xF1" => "\xE8\x8E\xB7",
		"\xBB\xF2" => "\xE6\x88\x96",
		"\xBB\xF3" => "\xE6\x83\x91",
		"\xBB\xF4" => "\xE9\x9C\x8D",
		"\xBB\xF5" => "\xE8\xB4\xA7",
		"\xBB\xF6" => "\xE7\xA5\xB8",
		"\xBB\xF7" => "\xE5\x87\xBB",
		"\xBB\xF8" => "\xE5\x9C\xBE",
		"\xBB\xF9" => "\xE5\x9F\xBA",
		"\xBB\xFA" => "\xE6\x9C\xBA",
		"\xBB\xFB" => "\xE7\x95\xB8",
		"\xBB\xFC" => "\xE7\xA8\xBD",
		"\xBB\xFD" => "\xE7\xA7\xAF",
		"\xBB\xFE" => "\xE7\xAE\x95",
		"\xBC\xA1" => "\xE8\x82\x8C",
		"\xBC\xA2" => "\xE9\xA5\xA5",
		"\xBC\xA3" => "\xE8\xBF\xB9",
		"\xBC\xA4" => "\xE6\xBF\x80",
		"\xBC\xA5" => "\xE8\xAE\xA5",
		"\xBC\xA6" => "\xE9\xB8\xA1",
		"\xBC\xA7" => "\xE5\xA7\xAC",
		"\xBC\xA8" => "\xE7\xBB\xA9",
		"\xBC\xA9" => "\xE7\xBC\x89",
		"\xBC\xAA" => "\xE5\x90\x89",
		"\xBC\xAB" => "\xE6\x9E\x81",
		"\xBC\xAC" => "\xE6\xA3\x98",
		"\xBC\xAD" => "\xE8\xBE\x91",
		"\xBC\xAE" => "\xE7\xB1\x8D",
		"\xBC\xAF" => "\xE9\x9B\x86",
		"\xBC\xB0" => "\xE5\x8F\x8A",
		"\xBC\xB1" => "\xE6\x80\xA5",
		"\xBC\xB2" => "\xE7\x96\xBE",
		"\xBC\xB3" => "\xE6\xB1\xB2",
		"\xBC\xB4" => "\xE5\x8D\xB3",
		"\xBC\xB5" => "\xE5\xAB\x89",
		"\xBC\xB6" => "\xE7\xBA\xA7",
		"\xBC\xB7" => "\xE6\x8C\xA4",
		"\xBC\xB8" => "\xE5\x87\xA0",
		"\xBC\xB9" => "\xE8\x84\x8A",
		"\xBC\xBA" => "\xE5\xB7\xB1",
		"\xBC\xBB" => "\xE8\x93\x9F",
		"\xBC\xBC" => "\xE6\x8A\x80",
		"\xBC\xBD" => "\xE5\x86\x80",
		"\xBC\xBE" => "\xE5\xAD\xA3",
		"\xBC\xBF" => "\xE4\xBC\x8E",
		"\xBC\xC0" => "\xE7\xA5\xAD",
		"\xBC\xC1" => "\xE5\x89\x82",
		"\xBC\xC2" => "\xE6\x82\xB8",
		"\xBC\xC3" => "\xE6\xB5\x8E",
		"\xBC\xC4" => "\xE5\xAF\x84",
		"\xBC\xC5" => "\xE5\xAF\x82",
		"\xBC\xC6" => "\xE8\xAE\xA1",
		"\xBC\xC7" => "\xE8\xAE\xB0",
		"\xBC\xC8" => "\xE6\x97\xA2",
		"\xBC\xC9" => "\xE5\xBF\x8C",
		"\xBC\xCA" => "\xE9\x99\x85",
		"\xBC\xCB" => "\xE5\xA6\x93",
		"\xBC\xCC" => "\xE7\xBB\xA7",
		"\xBC\xCD" => "\xE7\xBA\xAA",
		"\xBC\xCE" => "\xE5\x98\x89",
		"\xBC\xCF" => "\xE6\x9E\xB7",
		"\xBC\xD0" => "\xE5\xA4\xB9",
		"\xBC\xD1" => "\xE4\xBD\xB3",
		"\xBC\xD2" => "\xE5\xAE\xB6",
		"\xBC\xD3" => "\xE5\x8A\xA0",
		"\xBC\xD4" => "\xE8\x8D\x9A",
		"\xBC\xD5" => "\xE9\xA2\x8A",
		"\xBC\xD6" => "\xE8\xB4\xBE",
		"\xBC\xD7" => "\xE7\x94\xB2",
		"\xBC\xD8" => "\xE9\x92\xBE",
		"\xBC\xD9" => "\xE5\x81\x87",
		"\xBC\xDA" => "\xE7\xA8\xBC",
		"\xBC\xDB" => "\xE4\xBB\xB7",
		"\xBC\xDC" => "\xE6\x9E\xB6",
		"\xBC\xDD" => "\xE9\xA9\xBE",
		"\xBC\xDE" => "\xE5\xAB\x81",
		"\xBC\xDF" => "\xE6\xAD\xBC",
		"\xBC\xE0" => "\xE7\x9B\x91",
		"\xBC\xE1" => "\xE5\x9D\x9A",
		"\xBC\xE2" => "\xE5\xB0\x96",
		"\xBC\xE3" => "\xE7\xAC\xBA",
		"\xBC\xE4" => "\xE9\x97\xB4",
		"\xBC\xE5" => "\xE7\x85\x8E",
		"\xBC\xE6" => "\xE5\x85\xBC",
		"\xBC\xE7" => "\xE8\x82\xA9",
		"\xBC\xE8" => "\xE8\x89\xB0",
		"\xBC\xE9" => "\xE5\xA5\xB8",
		"\xBC\xEA" => "\xE7\xBC\x84",
		"\xBC\xEB" => "\xE8\x8C\xA7",
		"\xBC\xEC" => "\xE6\xA3\x80",
		"\xBC\xED" => "\xE6\x9F\xAC",
		"\xBC\xEE" => "\xE7\xA2\xB1",
		"\xBC\xEF" => "\xE7\xA1\xB7",
		"\xBC\xF0" => "\xE6\x8B\xA3",
		"\xBC\xF1" => "\xE6\x8D\xA1",
		"\xBC\xF2" => "\xE7\xAE\x80",
		"\xBC\xF3" => "\xE4\xBF\xAD",
		"\xBC\xF4" => "\xE5\x89\xAA",
		"\xBC\xF5" => "\xE5\x87\x8F",
		"\xBC\xF6" => "\xE8\x8D\x90",
		"\xBC\xF7" => "\xE6\xA7\x9B",
		"\xBC\xF8" => "\xE9\x89\xB4",
		"\xBC\xF9" => "\xE8\xB7\xB5",
		"\xBC\xFA" => "\xE8\xB4\xB1",
		"\xBC\xFB" => "\xE8\xA7\x81",
		"\xBC\xFC" => "\xE9\x94\xAE",
		"\xBC\xFD" => "\xE7\xAE\xAD",
		"\xBC\xFE" => "\xE4\xBB\xB6",
		"\xBD\xA1" => "\xE5\x81\xA5",
		"\xBD\xA2" => "\xE8\x88\xB0",
		"\xBD\xA3" => "\xE5\x89\x91",
		"\xBD\xA4" => "\xE9\xA5\xAF",
		"\xBD\xA5" => "\xE6\xB8\x90",
		"\xBD\xA6" => "\xE6\xBA\x85",
		"\xBD\xA7" => "\xE6\xB6\xA7",
		"\xBD\xA8" => "\xE5\xBB\xBA",
		"\xBD\xA9" => "\xE5\x83\xB5",
		"\xBD\xAA" => "\xE5\xA7\x9C",
		"\xBD\xAB" => "\xE5\xB0\x86",
		"\xBD\xAC" => "\xE6\xB5\x86",
		"\xBD\xAD" => "\xE6\xB1\x9F",
		"\xBD\xAE" => "\xE7\x96\x86",
		"\xBD\xAF" => "\xE8\x92\x8B",
		"\xBD\xB0" => "\xE6\xA1\xA8",
		"\xBD\xB1" => "\xE5\xA5\x96",
		"\xBD\xB2" => "\xE8\xAE\xB2",
		"\xBD\xB3" => "\xE5\x8C\xA0",
		"\xBD\xB4" => "\xE9\x85\xB1",
		"\xBD\xB5" => "\xE9\x99\x8D",
		"\xBD\xB6" => "\xE8\x95\x89",
		"\xBD\xB7" => "\xE6\xA4\x92",
		"\xBD\xB8" => "\xE7\xA4\x81",
		"\xBD\xB9" => "\xE7\x84\xA6",
		"\xBD\xBA" => "\xE8\x83\xB6",
		"\xBD\xBB" => "\xE4\xBA\xA4",
		"\xBD\xBC" => "\xE9\x83\x8A",
		"\xBD\xBD" => "\xE6\xB5\x87",
		"\xBD\xBE" => "\xE9\xAA\x84",
		"\xBD\xBF" => "\xE5\xA8\x87",
		"\xBD\xC0" => "\xE5\x9A\xBC",
		"\xBD\xC1" => "\xE6\x90\x85",
		"\xBD\xC2" => "\xE9\x93\xB0",
		"\xBD\xC3" => "\xE7\x9F\xAB",
		"\xBD\xC4" => "\xE4\xBE\xA5",
		"\xBD\xC5" => "\xE8\x84\x9A",
		"\xBD\xC6" => "\xE7\x8B\xA1",
		"\xBD\xC7" => "\xE8\xA7\x92",
		"\xBD\xC8" => "\xE9\xA5\xBA",
		"\xBD\xC9" => "\xE7\xBC\xB4",
		"\xBD\xCA" => "\xE7\xBB\x9E",
		"\xBD\xCB" => "\xE5\x89\xBF",
		"\xBD\xCC" => "\xE6\x95\x99",
		"\xBD\xCD" => "\xE9\x85\xB5",
		"\xBD\xCE" => "\xE8\xBD\xBF",
		"\xBD\xCF" => "\xE8\xBE\x83",
		"\xBD\xD0" => "\xE5\x8F\xAB",
		"\xBD\xD1" => "\xE7\xAA\x96",
		"\xBD\xD2" => "\xE6\x8F\xAD",
		"\xBD\xD3" => "\xE6\x8E\xA5",
		"\xBD\xD4" => "\xE7\x9A\x86",
		"\xBD\xD5" => "\xE7\xA7\xB8",
		"\xBD\xD6" => "\xE8\xA1\x97",
		"\xBD\xD7" => "\xE9\x98\xB6",
		"\xBD\xD8" => "\xE6\x88\xAA",
		"\xBD\xD9" => "\xE5\x8A\xAB",
		"\xBD\xDA" => "\xE8\x8A\x82",
		"\xBD\xDB" => "\xE6\xA1\x94",
		"\xBD\xDC" => "\xE6\x9D\xB0",
		"\xBD\xDD" => "\xE6\x8D\xB7",
		"\xBD\xDE" => "\xE7\x9D\xAB",
		"\xBD\xDF" => "\xE7\xAB\xAD",
		"\xBD\xE0" => "\xE6\xB4\x81",
		"\xBD\xE1" => "\xE7\xBB\x93",
		"\xBD\xE2" => "\xE8\xA7\xA3",
		"\xBD\xE3" => "\xE5\xA7\x90",
		"\xBD\xE4" => "\xE6\x88\x92",
		"\xBD\xE5" => "\xE8\x97\x89",
		"\xBD\xE6" => "\xE8\x8A\xA5",
		"\xBD\xE7" => "\xE7\x95\x8C",
		"\xBD\xE8" => "\xE5\x80\x9F",
		"\xBD\xE9" => "\xE4\xBB\x8B",
		"\xBD\xEA" => "\xE7\x96\xA5",
		"\xBD\xEB" => "\xE8\xAF\xAB",
		"\xBD\xEC" => "\xE5\xB1\x8A",
		"\xBD\xED" => "\xE5\xB7\xBE",
		"\xBD\xEE" => "\xE7\xAD\x8B",
		"\xBD\xEF" => "\xE6\x96\xA4",
		"\xBD\xF0" => "\xE9\x87\x91",
		"\xBD\xF1" => "\xE4\xBB\x8A",
		"\xBD\xF2" => "\xE6\xB4\xA5",
		"\xBD\xF3" => "\xE8\xA5\x9F",
		"\xBD\xF4" => "\xE7\xB4\xA7",
		"\xBD\xF5" => "\xE9\x94\xA6",
		"\xBD\xF6" => "\xE4\xBB\x85",
		"\xBD\xF7" => "\xE8\xB0\xA8",
		"\xBD\xF8" => "\xE8\xBF\x9B",
		"\xBD\xF9" => "\xE9\x9D\xB3",
		"\xBD\xFA" => "\xE6\x99\x8B",
		"\xBD\xFB" => "\xE7\xA6\x81",
		"\xBD\xFC" => "\xE8\xBF\x91",
		"\xBD\xFD" => "\xE7\x83\xAC",
		"\xBD\xFE" => "\xE6\xB5\xB8",
		"\xBE\xA1" => "\xE5\xB0\xBD",
		"\xBE\xA2" => "\xE5\x8A\xB2",
		"\xBE\xA3" => "\xE8\x8D\x86",
		"\xBE\xA4" => "\xE5\x85\xA2",
		"\xBE\xA5" => "\xE8\x8C\x8E",
		"\xBE\xA6" => "\xE7\x9D\x9B",
		"\xBE\xA7" => "\xE6\x99\xB6",
		"\xBE\xA8" => "\xE9\xB2\xB8",
		"\xBE\xA9" => "\xE4\xBA\xAC",
		"\xBE\xAA" => "\xE6\x83\x8A",
		"\xBE\xAB" => "\xE7\xB2\xBE",
		"\xBE\xAC" => "\xE7\xB2\xB3",
		"\xBE\xAD" => "\xE7\xBB\x8F",
		"\xBE\xAE" => "\xE4\xBA\x95",
		"\xBE\xAF" => "\xE8\xAD\xA6",
		"\xBE\xB0" => "\xE6\x99\xAF",
		"\xBE\xB1" => "\xE9\xA2\x88",
		"\xBE\xB2" => "\xE9\x9D\x99",
		"\xBE\xB3" => "\xE5\xA2\x83",
		"\xBE\xB4" => "\xE6\x95\xAC",
		"\xBE\xB5" => "\xE9\x95\x9C",
		"\xBE\xB6" => "\xE5\xBE\x84",
		"\xBE\xB7" => "\xE7\x97\x89",
		"\xBE\xB8" => "\xE9\x9D\x96",
		"\xBE\xB9" => "\xE7\xAB\x9F",
		"\xBE\xBA" => "\xE7\xAB\x9E",
		"\xBE\xBB" => "\xE5\x87\x80",
		"\xBE\xBC" => "\xE7\x82\xAF",
		"\xBE\xBD" => "\xE7\xAA\x98",
		"\xBE\xBE" => "\xE6\x8F\xAA",
		"\xBE\xBF" => "\xE7\xA9\xB6",
		"\xBE\xC0" => "\xE7\xBA\xA0",
		"\xBE\xC1" => "\xE7\x8E\x96",
		"\xBE\xC2" => "\xE9\x9F\xAD",
		"\xBE\xC3" => "\xE4\xB9\x85",
		"\xBE\xC4" => "\xE7\x81\xB8",
		"\xBE\xC5" => "\xE4\xB9\x9D",
		"\xBE\xC6" => "\xE9\x85\x92",
		"\xBE\xC7" => "\xE5\x8E\xA9",
		"\xBE\xC8" => "\xE6\x95\x91",
		"\xBE\xC9" => "\xE6\x97\xA7",
		"\xBE\xCA" => "\xE8\x87\xBC",
		"\xBE\xCB" => "\xE8\x88\x85",
		"\xBE\xCC" => "\xE5\x92\x8E",
		"\xBE\xCD" => "\xE5\xB0\xB1",
		"\xBE\xCE" => "\xE7\x96\x9A",
		"\xBE\xCF" => "\xE9\x9E\xA0",
		"\xBE\xD0" => "\xE6\x8B\x98",
		"\xBE\xD1" => "\xE7\x8B\x99",
		"\xBE\xD2" => "\xE7\x96\xBD",
		"\xBE\xD3" => "\xE5\xB1\x85",
		"\xBE\xD4" => "\xE9\xA9\xB9",
		"\xBE\xD5" => "\xE8\x8F\x8A",
		"\xBE\xD6" => "\xE5\xB1\x80",
		"\xBE\xD7" => "\xE5\x92\x80",
		"\xBE\xD8" => "\xE7\x9F\xA9",
		"\xBE\xD9" => "\xE4\xB8\xBE",
		"\xBE\xDA" => "\xE6\xB2\xAE",
		"\xBE\xDB" => "\xE8\x81\x9A",
		"\xBE\xDC" => "\xE6\x8B\x92",
		"\xBE\xDD" => "\xE6\x8D\xAE",
		"\xBE\xDE" => "\xE5\xB7\xA8",
		"\xBE\xDF" => "\xE5\x85\xB7",
		"\xBE\xE0" => "\xE8\xB7\x9D",
		"\xBE\xE1" => "\xE8\xB8\x9E",
		"\xBE\xE2" => "\xE9\x94\xAF",
		"\xBE\xE3" => "\xE4\xBF\xB1",
		"\xBE\xE4" => "\xE5\x8F\xA5",
		"\xBE\xE5" => "\xE6\x83\xA7",
		"\xBE\xE6" => "\xE7\x82\xAC",
		"\xBE\xE7" => "\xE5\x89\xA7",
		"\xBE\xE8" => "\xE6\x8D\x90",
		"\xBE\xE9" => "\xE9\xB9\x83",
		"\xBE\xEA" => "\xE5\xA8\x9F",
		"\xBE\xEB" => "\xE5\x80\xA6",
		"\xBE\xEC" => "\xE7\x9C\xB7",
		"\xBE\xED" => "\xE5\x8D\xB7",
		"\xBE\xEE" => "\xE7\xBB\xA2",
		"\xBE\xEF" => "\xE6\x92\x85",
		"\xBE\xF0" => "\xE6\x94\xAB",
		"\xBE\xF1" => "\xE6\x8A\x89",
		"\xBE\xF2" => "\xE6\x8E\x98",
		"\xBE\xF3" => "\xE5\x80\x94",
		"\xBE\xF4" => "\xE7\x88\xB5",
		"\xBE\xF5" => "\xE8\xA7\x89",
		"\xBE\xF6" => "\xE5\x86\xB3",
		"\xBE\xF7" => "\xE8\xAF\x80",
		"\xBE\xF8" => "\xE7\xBB\x9D",
		"\xBE\xF9" => "\xE5\x9D\x87",
		"\xBE\xFA" => "\xE8\x8F\x8C",
		"\xBE\xFB" => "\xE9\x92\xA7",
		"\xBE\xFC" => "\xE5\x86\x9B",
		"\xBE\xFD" => "\xE5\x90\x9B",
		"\xBE\xFE" => "\xE5\xB3\xBB",
		"\xBF\xA1" => "\xE4\xBF\x8A",
		"\xBF\xA2" => "\xE7\xAB\xA3",
		"\xBF\xA3" => "\xE6\xB5\x9A",
		"\xBF\xA4" => "\xE9\x83\xA1",
		"\xBF\xA5" => "\xE9\xAA\x8F",
		"\xBF\xA6" => "\xE5\x96\x80",
		"\xBF\xA7" => "\xE5\x92\x96",
		"\xBF\xA8" => "\xE5\x8D\xA1",
		"\xBF\xA9" => "\xE5\x92\xAF",
		"\xBF\xAA" => "\xE5\xBC\x80",
		"\xBF\xAB" => "\xE6\x8F\xA9",
		"\xBF\xAC" => "\xE6\xA5\xB7",
		"\xBF\xAD" => "\xE5\x87\xAF",
		"\xBF\xAE" => "\xE6\x85\xA8",
		"\xBF\xAF" => "\xE5\x88\x8A",
		"\xBF\xB0" => "\xE5\xA0\xAA",
		"\xBF\xB1" => "\xE5\x8B\x98",
		"\xBF\xB2" => "\xE5\x9D\x8E",
		"\xBF\xB3" => "\xE7\xA0\x8D",
		"\xBF\xB4" => "\xE7\x9C\x8B",
		"\xBF\xB5" => "\xE5\xBA\xB7",
		"\xBF\xB6" => "\xE6\x85\xB7",
		"\xBF\xB7" => "\xE7\xB3\xA0",
		"\xBF\xB8" => "\xE6\x89\x9B",
		"\xBF\xB9" => "\xE6\x8A\x97",
		"\xBF\xBA" => "\xE4\xBA\xA2",
		"\xBF\xBB" => "\xE7\x82\x95",
		"\xBF\xBC" => "\xE8\x80\x83",
		"\xBF\xBD" => "\xE6\x8B\xB7",
		"\xBF\xBE" => "\xE7\x83\xA4",
		"\xBF\xBF" => "\xE9\x9D\xA0",
		"\xBF\xC0" => "\xE5\x9D\xB7",
		"\xBF\xC1" => "\xE8\x8B\x9B",
		"\xBF\xC2" => "\xE6\x9F\xAF",
		"\xBF\xC3" => "\xE6\xA3\xB5",
		"\xBF\xC4" => "\xE7\xA3\x95",
		"\xBF\xC5" => "\xE9\xA2\x97",
		"\xBF\xC6" => "\xE7\xA7\x91",
		"\xBF\xC7" => "\xE5\xA3\xB3",
		"\xBF\xC8" => "\xE5\x92\xB3",
		"\xBF\xC9" => "\xE5\x8F\xAF",
		"\xBF\xCA" => "\xE6\xB8\xB4",
		"\xBF\xCB" => "\xE5\x85\x8B",
		"\xBF\xCC" => "\xE5\x88\xBB",
		"\xBF\xCD" => "\xE5\xAE\xA2",
		"\xBF\xCE" => "\xE8\xAF\xBE",
		"\xBF\xCF" => "\xE8\x82\xAF",
		"\xBF\xD0" => "\xE5\x95\x83",
		"\xBF\xD1" => "\xE5\x9E\xA6",
		"\xBF\xD2" => "\xE6\x81\xB3",
		"\xBF\xD3" => "\xE5\x9D\x91",
		"\xBF\xD4" => "\xE5\x90\xAD",
		"\xBF\xD5" => "\xE7\xA9\xBA",
		"\xBF\xD6" => "\xE6\x81\x90",
		"\xBF\xD7" => "\xE5\xAD\x94",
		"\xBF\xD8" => "\xE6\x8E\xA7",
		"\xBF\xD9" => "\xE6\x8A\xA0",
		"\xBF\xDA" => "\xE5\x8F\xA3",
		"\xBF\xDB" => "\xE6\x89\xA3",
		"\xBF\xDC" => "\xE5\xAF\x87",
		"\xBF\xDD" => "\xE6\x9E\xAF",
		"\xBF\xDE" => "\xE5\x93\xAD",
		"\xBF\xDF" => "\xE7\xAA\x9F",
		"\xBF\xE0" => "\xE8\x8B\xA6",
		"\xBF\xE1" => "\xE9\x85\xB7",
		"\xBF\xE2" => "\xE5\xBA\x93",
		"\xBF\xE3" => "\xE8\xA3\xA4",
		"\xBF\xE4" => "\xE5\xA4\xB8",
		"\xBF\xE5" => "\xE5\x9E\xAE",
		"\xBF\xE6" => "\xE6\x8C\x8E",
		"\xBF\xE7" => "\xE8\xB7\xA8",
		"\xBF\xE8" => "\xE8\x83\xAF",
		"\xBF\xE9" => "\xE5\x9D\x97",
		"\xBF\xEA" => "\xE7\xAD\xB7",
		"\xBF\xEB" => "\xE4\xBE\xA9",
		"\xBF\xEC" => "\xE5\xBF\xAB",
		"\xBF\xED" => "\xE5\xAE\xBD",
		"\xBF\xEE" => "\xE6\xAC\xBE",
		"\xBF\xEF" => "\xE5\x8C\xA1",
		"\xBF\xF0" => "\xE7\xAD\x90",
		"\xBF\xF1" => "\xE7\x8B\x82",
		"\xBF\xF2" => "\xE6\xA1\x86",
		"\xBF\xF3" => "\xE7\x9F\xBF",
		"\xBF\xF4" => "\xE7\x9C\xB6",
		"\xBF\xF5" => "\xE6\x97\xB7",
		"\xBF\xF6" => "\xE5\x86\xB5",
		"\xBF\xF7" => "\xE4\xBA\x8F",
		"\xBF\xF8" => "\xE7\x9B\x94",
		"\xBF\xF9" => "\xE5\xB2\xBF",
		"\xBF\xFA" => "\xE7\xAA\xA5",
		"\xBF\xFB" => "\xE8\x91\xB5",
		"\xBF\xFC" => "\xE5\xA5\x8E",
		"\xBF\xFD" => "\xE9\xAD\x81",
		"\xBF\xFE" => "\xE5\x82\x80",
		"\xC0\xA1" => "\xE9\xA6\x88",
		"\xC0\xA2" => "\xE6\x84\xA7",
		"\xC0\xA3" => "\xE6\xBA\x83",
		"\xC0\xA4" => "\xE5\x9D\xA4",
		"\xC0\xA5" => "\xE6\x98\x86",
		"\xC0\xA6" => "\xE6\x8D\x86",
		"\xC0\xA7" => "\xE5\x9B\xB0",
		"\xC0\xA8" => "\xE6\x8B\xAC",
		"\xC0\xA9" => "\xE6\x89\xA9",
		"\xC0\xAA" => "\xE5\xBB\x93",
		"\xC0\xAB" => "\xE9\x98\x94",
		"\xC0\xAC" => "\xE5\x9E\x83",
		"\xC0\xAD" => "\xE6\x8B\x89",
		"\xC0\xAE" => "\xE5\x96\x87",
		"\xC0\xAF" => "\xE8\x9C\xA1",
		"\xC0\xB0" => "\xE8\x85\x8A",
		"\xC0\xB1" => "\xE8\xBE\xA3",
		"\xC0\xB2" => "\xE5\x95\xA6",
		"\xC0\xB3" => "\xE8\x8E\xB1",
		"\xC0\xB4" => "\xE6\x9D\xA5",
		"\xC0\xB5" => "\xE8\xB5\x96",
		"\xC0\xB6" => "\xE8\x93\x9D",
		"\xC0\xB7" => "\xE5\xA9\xAA",
		"\xC0\xB8" => "\xE6\xA0\x8F",
		"\xC0\xB9" => "\xE6\x8B\xA6",
		"\xC0\xBA" => "\xE7\xAF\xAE",
		"\xC0\xBB" => "\xE9\x98\x91",
		"\xC0\xBC" => "\xE5\x85\xB0",
		"\xC0\xBD" => "\xE6\xBE\x9C",
		"\xC0\xBE" => "\xE8\xB0\xB0",
		"\xC0\xBF" => "\xE6\x8F\xBD",
		"\xC0\xC0" => "\xE8\xA7\x88",
		"\xC0\xC1" => "\xE6\x87\x92",
		"\xC0\xC2" => "\xE7\xBC\x86",
		"\xC0\xC3" => "\xE7\x83\x82",
		"\xC0\xC4" => "\xE6\xBB\xA5",
		"\xC0\xC5" => "\xE7\x90\x85",
		"\xC0\xC6" => "\xE6\xA6\x94",
		"\xC0\xC7" => "\xE7\x8B\xBC",
		"\xC0\xC8" => "\xE5\xBB\x8A",
		"\xC0\xC9" => "\xE9\x83\x8E",
		"\xC0\xCA" => "\xE6\x9C\x97",
		"\xC0\xCB" => "\xE6\xB5\xAA",
		"\xC0\xCC" => "\xE6\x8D\x9E",
		"\xC0\xCD" => "\xE5\x8A\xB3",
		"\xC0\xCE" => "\xE7\x89\xA2",
		"\xC0\xCF" => "\xE8\x80\x81",
		"\xC0\xD0" => "\xE4\xBD\xAC",
		"\xC0\xD1" => "\xE5\xA7\xA5",
		"\xC0\xD2" => "\xE9\x85\xAA",
		"\xC0\xD3" => "\xE7\x83\x99",
		"\xC0\xD4" => "\xE6\xB6\x9D",
		"\xC0\xD5" => "\xE5\x8B\x92",
		"\xC0\xD6" => "\xE4\xB9\x90",
		"\xC0\xD7" => "\xE9\x9B\xB7",
		"\xC0\xD8" => "\xE9\x95\xAD",
		"\xC0\xD9" => "\xE8\x95\xBE",
		"\xC0\xDA" => "\xE7\xA3\x8A",
		"\xC0\xDB" => "\xE7\xB4\xAF",
		"\xC0\xDC" => "\xE5\x84\xA1",
		"\xC0\xDD" => "\xE5\x9E\x92",
		"\xC0\xDE" => "\xE6\x93\x82",
		"\xC0\xDF" => "\xE8\x82\x8B",
		"\xC0\xE0" => "\xE7\xB1\xBB",
		"\xC0\xE1" => "\xE6\xB3\xAA",
		"\xC0\xE2" => "\xE6\xA3\xB1",
		"\xC0\xE3" => "\xE6\xA5\x9E",
		"\xC0\xE4" => "\xE5\x86\xB7",
		"\xC0\xE5" => "\xE5\x8E\x98",
		"\xC0\xE6" => "\xE6\xA2\xA8",
		"\xC0\xE7" => "\xE7\x8A\x81",
		"\xC0\xE8" => "\xE9\xBB\x8E",
		"\xC0\xE9" => "\xE7\xAF\xB1",
		"\xC0\xEA" => "\xE7\x8B\xB8",
		"\xC0\xEB" => "\xE7\xA6\xBB",
		"\xC0\xEC" => "\xE6\xBC\x93",
		"\xC0\xED" => "\xE7\x90\x86",
		"\xC0\xEE" => "\xE6\x9D\x8E",
		"\xC0\xEF" => "\xE9\x87\x8C",
		"\xC0\xF0" => "\xE9\xB2\xA4",
		"\xC0\xF1" => "\xE7\xA4\xBC",
		"\xC0\xF2" => "\xE8\x8E\x89",
		"\xC0\xF3" => "\xE8\x8D\x94",
		"\xC0\xF4" => "\xE5\x90\x8F",
		"\xC0\xF5" => "\xE6\xA0\x97",
		"\xC0\xF6" => "\xE4\xB8\xBD",
		"\xC0\xF7" => "\xE5\x8E\x89",
		"\xC0\xF8" => "\xE5\x8A\xB1",
		"\xC0\xF9" => "\xE7\xA0\xBE",
		"\xC0\xFA" => "\xE5\x8E\x86",
		"\xC0\xFB" => "\xE5\x88\xA9",
		"\xC0\xFC" => "\xE5\x82\x88",
		"\xC0\xFD" => "\xE4\xBE\x8B",
		"\xC0\xFE" => "\xE4\xBF\x90",
		"\xC1\xA1" => "\xE7\x97\xA2",
		"\xC1\xA2" => "\xE7\xAB\x8B",
		"\xC1\xA3" => "\xE7\xB2\x92",
		"\xC1\xA4" => "\xE6\xB2\xA5",
		"\xC1\xA5" => "\xE9\x9A\xB6",
		"\xC1\xA6" => "\xE5\x8A\x9B",
		"\xC1\xA7" => "\xE7\x92\x83",
		"\xC1\xA8" => "\xE5\x93\xA9",
		"\xC1\xA9" => "\xE4\xBF\xA9",
		"\xC1\xAA" => "\xE8\x81\x94",
		"\xC1\xAB" => "\xE8\x8E\xB2",
		"\xC1\xAC" => "\xE8\xBF\x9E",
		"\xC1\xAD" => "\xE9\x95\xB0",
		"\xC1\xAE" => "\xE5\xBB\x89",
		"\xC1\xAF" => "\xE6\x80\x9C",
		"\xC1\xB0" => "\xE6\xB6\x9F",
		"\xC1\xB1" => "\xE5\xB8\x98",
		"\xC1\xB2" => "\xE6\x95\x9B",
		"\xC1\xB3" => "\xE8\x84\xB8",
		"\xC1\xB4" => "\xE9\x93\xBE",
		"\xC1\xB5" => "\xE6\x81\x8B",
		"\xC1\xB6" => "\xE7\x82\xBC",
		"\xC1\xB7" => "\xE7\xBB\x83",
		"\xC1\xB8" => "\xE7\xB2\xAE",
		"\xC1\xB9" => "\xE5\x87\x89",
		"\xC1\xBA" => "\xE6\xA2\x81",
		"\xC1\xBB" => "\xE7\xB2\xB1",
		"\xC1\xBC" => "\xE8\x89\xAF",
		"\xC1\xBD" => "\xE4\xB8\xA4",
		"\xC1\xBE" => "\xE8\xBE\x86",
		"\xC1\xBF" => "\xE9\x87\x8F",
		"\xC1\xC0" => "\xE6\x99\xBE",
		"\xC1\xC1" => "\xE4\xBA\xAE",
		"\xC1\xC2" => "\xE8\xB0\x85",
		"\xC1\xC3" => "\xE6\x92\xA9",
		"\xC1\xC4" => "\xE8\x81\x8A",
		"\xC1\xC5" => "\xE5\x83\x9A",
		"\xC1\xC6" => "\xE7\x96\x97",
		"\xC1\xC7" => "\xE7\x87\x8E",
		"\xC1\xC8" => "\xE5\xAF\xA5",
		"\xC1\xC9" => "\xE8\xBE\xBD",
		"\xC1\xCA" => "\xE6\xBD\xA6",
		"\xC1\xCB" => "\xE4\xBA\x86",
		"\xC1\xCC" => "\xE6\x92\x82",
		"\xC1\xCD" => "\xE9\x95\xA3",
		"\xC1\xCE" => "\xE5\xBB\x96",
		"\xC1\xCF" => "\xE6\x96\x99",
		"\xC1\xD0" => "\xE5\x88\x97",
		"\xC1\xD1" => "\xE8\xA3\x82",
		"\xC1\xD2" => "\xE7\x83\x88",
		"\xC1\xD3" => "\xE5\x8A\xA3",
		"\xC1\xD4" => "\xE7\x8C\x8E",
		"\xC1\xD5" => "\xE7\x90\xB3",
		"\xC1\xD6" => "\xE6\x9E\x97",
		"\xC1\xD7" => "\xE7\xA3\xB7",
		"\xC1\xD8" => "\xE9\x9C\x96",
		"\xC1\xD9" => "\xE4\xB8\xB4",
		"\xC1\xDA" => "\xE9\x82\xBB",
		"\xC1\xDB" => "\xE9\xB3\x9E",
		"\xC1\xDC" => "\xE6\xB7\x8B",
		"\xC1\xDD" => "\xE5\x87\x9B",
		"\xC1\xDE" => "\xE8\xB5\x81",
		"\xC1\xDF" => "\xE5\x90\x9D",
		"\xC1\xE0" => "\xE6\x8B\x8E",
		"\xC1\xE1" => "\xE7\x8E\xB2",
		"\xC1\xE2" => "\xE8\x8F\xB1",
		"\xC1\xE3" => "\xE9\x9B\xB6",
		"\xC1\xE4" => "\xE9\xBE\x84",
		"\xC1\xE5" => "\xE9\x93\x83",
		"\xC1\xE6" => "\xE4\xBC\xB6",
		"\xC1\xE7" => "\xE7\xBE\x9A",
		"\xC1\xE8" => "\xE5\x87\x8C",
		"\xC1\xE9" => "\xE7\x81\xB5",
		"\xC1\xEA" => "\xE9\x99\xB5",
		"\xC1\xEB" => "\xE5\xB2\xAD",
		"\xC1\xEC" => "\xE9\xA2\x86",
		"\xC1\xED" => "\xE5\x8F\xA6",
		"\xC1\xEE" => "\xE4\xBB\xA4",
		"\xC1\xEF" => "\xE6\xBA\x9C",
		"\xC1\xF0" => "\xE7\x90\x89",
		"\xC1\xF1" => "\xE6\xA6\xB4",
		"\xC1\xF2" => "\xE7\xA1\xAB",
		"\xC1\xF3" => "\xE9\xA6\x8F",
		"\xC1\xF4" => "\xE7\x95\x99",
		"\xC1\xF5" => "\xE5\x88\x98",
		"\xC1\xF6" => "\xE7\x98\xA4",
		"\xC1\xF7" => "\xE6\xB5\x81",
		"\xC1\xF8" => "\xE6\x9F\xB3",
		"\xC1\xF9" => "\xE5\x85\xAD",
		"\xC1\xFA" => "\xE9\xBE\x99",
		"\xC1\xFB" => "\xE8\x81\x8B",
		"\xC1\xFC" => "\xE5\x92\x99",
		"\xC1\xFD" => "\xE7\xAC\xBC",
		"\xC1\xFE" => "\xE7\xAA\xBF",
		"\xC2\xA1" => "\xE9\x9A\x86",
		"\xC2\xA2" => "\xE5\x9E\x84",
		"\xC2\xA3" => "\xE6\x8B\xA2",
		"\xC2\xA4" => "\xE9\x99\x87",
		"\xC2\xA5" => "\xE6\xA5\xBC",
		"\xC2\xA6" => "\xE5\xA8\x84",
		"\xC2\xA7" => "\xE6\x90\x82",
		"\xC2\xA8" => "\xE7\xAF\x93",
		"\xC2\xA9" => "\xE6\xBC\x8F",
		"\xC2\xAA" => "\xE9\x99\x8B",
		"\xC2\xAB" => "\xE8\x8A\xA6",
		"\xC2\xAC" => "\xE5\x8D\xA2",
		"\xC2\xAD" => "\xE9\xA2\x85",
		"\xC2\xAE" => "\xE5\xBA\x90",
		"\xC2\xAF" => "\xE7\x82\x89",
		"\xC2\xB0" => "\xE6\x8E\xB3",
		"\xC2\xB1" => "\xE5\x8D\xA4",
		"\xC2\xB2" => "\xE8\x99\x8F",
		"\xC2\xB3" => "\xE9\xB2\x81",
		"\xC2\xB4" => "\xE9\xBA\x93",
		"\xC2\xB5" => "\xE7\xA2\x8C",
		"\xC2\xB6" => "\xE9\x9C\xB2",
		"\xC2\xB7" => "\xE8\xB7\xAF",
		"\xC2\xB8" => "\xE8\xB5\x82",
		"\xC2\xB9" => "\xE9\xB9\xBF",
		"\xC2\xBA" => "\xE6\xBD\x9E",
		"\xC2\xBB" => "\xE7\xA6\x84",
		"\xC2\xBC" => "\xE5\xBD\x95",
		"\xC2\xBD" => "\xE9\x99\x86",
		"\xC2\xBE" => "\xE6\x88\xAE",
		"\xC2\xBF" => "\xE9\xA9\xB4",
		"\xC2\xC0" => "\xE5\x90\x95",
		"\xC2\xC1" => "\xE9\x93\x9D",
		"\xC2\xC2" => "\xE4\xBE\xA3",
		"\xC2\xC3" => "\xE6\x97\x85",
		"\xC2\xC4" => "\xE5\xB1\xA5",
		"\xC2\xC5" => "\xE5\xB1\xA1",
		"\xC2\xC6" => "\xE7\xBC\x95",
		"\xC2\xC7" => "\xE8\x99\x91",
		"\xC2\xC8" => "\xE6\xB0\xAF",
		"\xC2\xC9" => "\xE5\xBE\x8B",
		"\xC2\xCA" => "\xE7\x8E\x87",
		"\xC2\xCB" => "\xE6\xBB\xA4",
		"\xC2\xCC" => "\xE7\xBB\xBF",
		"\xC2\xCD" => "\xE5\xB3\xA6",
		"\xC2\xCE" => "\xE6\x8C\x9B",
		"\xC2\xCF" => "\xE5\xAD\xAA",
		"\xC2\xD0" => "\xE6\xBB\xA6",
		"\xC2\xD1" => "\xE5\x8D\xB5",
		"\xC2\xD2" => "\xE4\xB9\xB1",
		"\xC2\xD3" => "\xE6\x8E\xA0",
		"\xC2\xD4" => "\xE7\x95\xA5",
		"\xC2\xD5" => "\xE6\x8A\xA1",
		"\xC2\xD6" => "\xE8\xBD\xAE",
		"\xC2\xD7" => "\xE4\xBC\xA6",
		"\xC2\xD8" => "\xE4\xBB\x91",
		"\xC2\xD9" => "\xE6\xB2\xA6",
		"\xC2\xDA" => "\xE7\xBA\xB6",
		"\xC2\xDB" => "\xE8\xAE\xBA",
		"\xC2\xDC" => "\xE8\x90\x9D",
		"\xC2\xDD" => "\xE8\x9E\xBA",
		"\xC2\xDE" => "\xE7\xBD\x97",
		"\xC2\xDF" => "\xE9\x80\xBB",
		"\xC2\xE0" => "\xE9\x94\xA3",
		"\xC2\xE1" => "\xE7\xAE\xA9",
		"\xC2\xE2" => "\xE9\xAA\xA1",
		"\xC2\xE3" => "\xE8\xA3\xB8",
		"\xC2\xE4" => "\xE8\x90\xBD",
		"\xC2\xE5" => "\xE6\xB4\x9B",
		"\xC2\xE6" => "\xE9\xAA\x86",
		"\xC2\xE7" => "\xE7\xBB\x9C",
		"\xC2\xE8" => "\xE5\xA6\x88",
		"\xC2\xE9" => "\xE9\xBA\xBB",
		"\xC2\xEA" => "\xE7\x8E\x9B",
		"\xC2\xEB" => "\xE7\xA0\x81",
		"\xC2\xEC" => "\xE8\x9A\x82",
		"\xC2\xED" => "\xE9\xA9\xAC",
		"\xC2\xEE" => "\xE9\xAA\x82",
		"\xC2\xEF" => "\xE5\x98\x9B",
		"\xC2\xF0" => "\xE5\x90\x97",
		"\xC2\xF1" => "\xE5\x9F\x8B",
		"\xC2\xF2" => "\xE4\xB9\xB0",
		"\xC2\xF3" => "\xE9\xBA\xA6",
		"\xC2\xF4" => "\xE5\x8D\x96",
		"\xC2\xF5" => "\xE8\xBF\x88",
		"\xC2\xF6" => "\xE8\x84\x89",
		"\xC2\xF7" => "\xE7\x9E\x92",
		"\xC2\xF8" => "\xE9\xA6\x92",
		"\xC2\xF9" => "\xE8\x9B\xAE",
		"\xC2\xFA" => "\xE6\xBB\xA1",
		"\xC2\xFB" => "\xE8\x94\x93",
		"\xC2\xFC" => "\xE6\x9B\xBC",
		"\xC2\xFD" => "\xE6\x85\xA2",
		"\xC2\xFE" => "\xE6\xBC\xAB",
		"\xC3\xA1" => "\xE8\xB0\xA9",
		"\xC3\xA2" => "\xE8\x8A\x92",
		"\xC3\xA3" => "\xE8\x8C\xAB",
		"\xC3\xA4" => "\xE7\x9B\xB2",
		"\xC3\xA5" => "\xE6\xB0\x93",
		"\xC3\xA6" => "\xE5\xBF\x99",
		"\xC3\xA7" => "\xE8\x8E\xBD",
		"\xC3\xA8" => "\xE7\x8C\xAB",
		"\xC3\xA9" => "\xE8\x8C\x85",
		"\xC3\xAA" => "\xE9\x94\x9A",
		"\xC3\xAB" => "\xE6\xAF\x9B",
		"\xC3\xAC" => "\xE7\x9F\x9B",
		"\xC3\xAD" => "\xE9\x93\x86",
		"\xC3\xAE" => "\xE5\x8D\xAF",
		"\xC3\xAF" => "\xE8\x8C\x82",
		"\xC3\xB0" => "\xE5\x86\x92",
		"\xC3\xB1" => "\xE5\xB8\xBD",
		"\xC3\xB2" => "\xE8\xB2\x8C",
		"\xC3\xB3" => "\xE8\xB4\xB8",
		"\xC3\xB4" => "\xE4\xB9\x88",
		"\xC3\xB5" => "\xE7\x8E\xAB",
		"\xC3\xB6" => "\xE6\x9E\x9A",
		"\xC3\xB7" => "\xE6\xA2\x85",
		"\xC3\xB8" => "\xE9\x85\xB6",
		"\xC3\xB9" => "\xE9\x9C\x89",
		"\xC3\xBA" => "\xE7\x85\xA4",
		"\xC3\xBB" => "\xE6\xB2\xA1",
		"\xC3\xBC" => "\xE7\x9C\x89",
		"\xC3\xBD" => "\xE5\xAA\x92",
		"\xC3\xBE" => "\xE9\x95\x81",
		"\xC3\xBF" => "\xE6\xAF\x8F",
		"\xC3\xC0" => "\xE7\xBE\x8E",
		"\xC3\xC1" => "\xE6\x98\xA7",
		"\xC3\xC2" => "\xE5\xAF\x90",
		"\xC3\xC3" => "\xE5\xA6\xB9",
		"\xC3\xC4" => "\xE5\xAA\x9A",
		"\xC3\xC5" => "\xE9\x97\xA8",
		"\xC3\xC6" => "\xE9\x97\xB7",
		"\xC3\xC7" => "\xE4\xBB\xAC",
		"\xC3\xC8" => "\xE8\x90\x8C",
		"\xC3\xC9" => "\xE8\x92\x99",
		"\xC3\xCA" => "\xE6\xAA\xAC",
		"\xC3\xCB" => "\xE7\x9B\x9F",
		"\xC3\xCC" => "\xE9\x94\xB0",
		"\xC3\xCD" => "\xE7\x8C\x9B",
		"\xC3\xCE" => "\xE6\xA2\xA6",
		"\xC3\xCF" => "\xE5\xAD\x9F",
		"\xC3\xD0" => "\xE7\x9C\xAF",
		"\xC3\xD1" => "\xE9\x86\x9A",
		"\xC3\xD2" => "\xE9\x9D\xA1",
		"\xC3\xD3" => "\xE7\xB3\x9C",
		"\xC3\xD4" => "\xE8\xBF\xB7",
		"\xC3\xD5" => "\xE8\xB0\x9C",
		"\xC3\xD6" => "\xE5\xBC\xA5",
		"\xC3\xD7" => "\xE7\xB1\xB3",
		"\xC3\xD8" => "\xE7\xA7\x98",
		"\xC3\xD9" => "\xE8\xA7\x85",
		"\xC3\xDA" => "\xE6\xB3\x8C",
		"\xC3\xDB" => "\xE8\x9C\x9C",
		"\xC3\xDC" => "\xE5\xAF\x86",
		"\xC3\xDD" => "\xE5\xB9\x82",
		"\xC3\xDE" => "\xE6\xA3\x89",
		"\xC3\xDF" => "\xE7\x9C\xA0",
		"\xC3\xE0" => "\xE7\xBB\xB5",
		"\xC3\xE1" => "\xE5\x86\x95",
		"\xC3\xE2" => "\xE5\x85\x8D",
		"\xC3\xE3" => "\xE5\x8B\x89",
		"\xC3\xE4" => "\xE5\xA8\xA9",
		"\xC3\xE5" => "\xE7\xBC\x85",
		"\xC3\xE6" => "\xE9\x9D\xA2",
		"\xC3\xE7" => "\xE8\x8B\x97",
		"\xC3\xE8" => "\xE6\x8F\x8F",
		"\xC3\xE9" => "\xE7\x9E\x84",
		"\xC3\xEA" => "\xE8\x97\x90",
		"\xC3\xEB" => "\xE7\xA7\x92",
		"\xC3\xEC" => "\xE6\xB8\xBA",
		"\xC3\xED" => "\xE5\xBA\x99",
		"\xC3\xEE" => "\xE5\xA6\x99",
		"\xC3\xEF" => "\xE8\x94\x91",
		"\xC3\xF0" => "\xE7\x81\xAD",
		"\xC3\xF1" => "\xE6\xB0\x91",
		"\xC3\xF2" => "\xE6\x8A\xBF",
		"\xC3\xF3" => "\xE7\x9A\xBF",
		"\xC3\xF4" => "\xE6\x95\x8F",
		"\xC3\xF5" => "\xE6\x82\xAF",
		"\xC3\xF6" => "\xE9\x97\xBD",
		"\xC3\xF7" => "\xE6\x98\x8E",
		"\xC3\xF8" => "\xE8\x9E\x9F",
		"\xC3\xF9" => "\xE9\xB8\xA3",
		"\xC3\xFA" => "\xE9\x93\xAD",
		"\xC3\xFB" => "\xE5\x90\x8D",
		"\xC3\xFC" => "\xE5\x91\xBD",
		"\xC3\xFD" => "\xE8\xB0\xAC",
		"\xC3\xFE" => "\xE6\x91\xB8",
		"\xC4\xA1" => "\xE6\x91\xB9",
		"\xC4\xA2" => "\xE8\x98\x91",
		"\xC4\xA3" => "\xE6\xA8\xA1",
		"\xC4\xA4" => "\xE8\x86\x9C",
		"\xC4\xA5" => "\xE7\xA3\xA8",
		"\xC4\xA6" => "\xE6\x91\xA9",
		"\xC4\xA7" => "\xE9\xAD\x94",
		"\xC4\xA8" => "\xE6\x8A\xB9",
		"\xC4\xA9" => "\xE6\x9C\xAB",
		"\xC4\xAA" => "\xE8\x8E\xAB",
		"\xC4\xAB" => "\xE5\xA2\xA8",
		"\xC4\xAC" => "\xE9\xBB\x98",
		"\xC4\xAD" => "\xE6\xB2\xAB",
		"\xC4\xAE" => "\xE6\xBC\xA0",
		"\xC4\xAF" => "\xE5\xAF\x9E",
		"\xC4\xB0" => "\xE9\x99\x8C",
		"\xC4\xB1" => "\xE8\xB0\x8B",
		"\xC4\xB2" => "\xE7\x89\x9F",
		"\xC4\xB3" => "\xE6\x9F\x90",
		"\xC4\xB4" => "\xE6\x8B\x87",
		"\xC4\xB5" => "\xE7\x89\xA1",
		"\xC4\xB6" => "\xE4\xBA\xA9",
		"\xC4\xB7" => "\xE5\xA7\x86",
		"\xC4\xB8" => "\xE6\xAF\x8D",
		"\xC4\xB9" => "\xE5\xA2\x93",
		"\xC4\xBA" => "\xE6\x9A\xAE",
		"\xC4\xBB" => "\xE5\xB9\x95",
		"\xC4\xBC" => "\xE5\x8B\x9F",
		"\xC4\xBD" => "\xE6\x85\x95",
		"\xC4\xBE" => "\xE6\x9C\xA8",
		"\xC4\xBF" => "\xE7\x9B\xAE",
		"\xC4\xC0" => "\xE7\x9D\xA6",
		"\xC4\xC1" => "\xE7\x89\xA7",
		"\xC4\xC2" => "\xE7\xA9\x86",
		"\xC4\xC3" => "\xE6\x8B\xBF",
		"\xC4\xC4" => "\xE5\x93\xAA",
		"\xC4\xC5" => "\xE5\x91\x90",
		"\xC4\xC6" => "\xE9\x92\xA0",
		"\xC4\xC7" => "\xE9\x82\xA3",
		"\xC4\xC8" => "\xE5\xA8\x9C",
		"\xC4\xC9" => "\xE7\xBA\xB3",
		"\xC4\xCA" => "\xE6\xB0\x96",
		"\xC4\xCB" => "\xE4\xB9\x83",
		"\xC4\xCC" => "\xE5\xA5\xB6",
		"\xC4\xCD" => "\xE8\x80\x90",
		"\xC4\xCE" => "\xE5\xA5\x88",
		"\xC4\xCF" => "\xE5\x8D\x97",
		"\xC4\xD0" => "\xE7\x94\xB7",
		"\xC4\xD1" => "\xE9\x9A\xBE",
		"\xC4\xD2" => "\xE5\x9B\x8A",
		"\xC4\xD3" => "\xE6\x8C\xA0",
		"\xC4\xD4" => "\xE8\x84\x91",
		"\xC4\xD5" => "\xE6\x81\xBC",
		"\xC4\xD6" => "\xE9\x97\xB9",
		"\xC4\xD7" => "\xE6\xB7\x96",
		"\xC4\xD8" => "\xE5\x91\xA2",
		"\xC4\xD9" => "\xE9\xA6\x81",
		"\xC4\xDA" => "\xE5\x86\x85",
		"\xC4\xDB" => "\xE5\xAB\xA9",
		"\xC4\xDC" => "\xE8\x83\xBD",
		"\xC4\xDD" => "\xE5\xA6\xAE",
		"\xC4\xDE" => "\xE9\x9C\x93",
		"\xC4\xDF" => "\xE5\x80\xAA",
		"\xC4\xE0" => "\xE6\xB3\xA5",
		"\xC4\xE1" => "\xE5\xB0\xBC",
		"\xC4\xE2" => "\xE6\x8B\x9F",
		"\xC4\xE3" => "\xE4\xBD\xA0",
		"\xC4\xE4" => "\xE5\x8C\xBF",
		"\xC4\xE5" => "\xE8\x85\xBB",
		"\xC4\xE6" => "\xE9\x80\x86",
		"\xC4\xE7" => "\xE6\xBA\xBA",
		"\xC4\xE8" => "\xE8\x94\xAB",
		"\xC4\xE9" => "\xE6\x8B\x88",
		"\xC4\xEA" => "\xE5\xB9\xB4",
		"\xC4\xEB" => "\xE7\xA2\xBE",
		"\xC4\xEC" => "\xE6\x92\xB5",
		"\xC4\xED" => "\xE6\x8D\xBB",
		"\xC4\xEE" => "\xE5\xBF\xB5",
		"\xC4\xEF" => "\xE5\xA8\x98",
		"\xC4\xF0" => "\xE9\x85\xBF",
		"\xC4\xF1" => "\xE9\xB8\x9F",
		"\xC4\xF2" => "\xE5\xB0\xBF",
		"\xC4\xF3" => "\xE6\x8D\x8F",
		"\xC4\xF4" => "\xE8\x81\x82",
		"\xC4\xF5" => "\xE5\xAD\xBD",
		"\xC4\xF6" => "\xE5\x95\xAE",
		"\xC4\xF7" => "\xE9\x95\x8A",
		"\xC4\xF8" => "\xE9\x95\x8D",
		"\xC4\xF9" => "\xE6\xB6\x85",
		"\xC4\xFA" => "\xE6\x82\xA8",
		"\xC4\xFB" => "\xE6\x9F\xA0",
		"\xC4\xFC" => "\xE7\x8B\x9E",
		"\xC4\xFD" => "\xE5\x87\x9D",
		"\xC4\xFE" => "\xE5\xAE\x81",
		"\xC5\xA1" => "\xE6\x8B\xA7",
		"\xC5\xA2" => "\xE6\xB3\x9E",
		"\xC5\xA3" => "\xE7\x89\x9B",
		"\xC5\xA4" => "\xE6\x89\xAD",
		"\xC5\xA5" => "\xE9\x92\xAE",
		"\xC5\xA6" => "\xE7\xBA\xBD",
		"\xC5\xA7" => "\xE8\x84\x93",
		"\xC5\xA8" => "\xE6\xB5\x93",
		"\xC5\xA9" => "\xE5\x86\x9C",
		"\xC5\xAA" => "\xE5\xBC\x84",
		"\xC5\xAB" => "\xE5\xA5\xB4",
		"\xC5\xAC" => "\xE5\x8A\xAA",
		"\xC5\xAD" => "\xE6\x80\x92",
		"\xC5\xAE" => "\xE5\xA5\xB3",
		"\xC5\xAF" => "\xE6\x9A\x96",
		"\xC5\xB0" => "\xE8\x99\x90",
		"\xC5\xB1" => "\xE7\x96\x9F",
		"\xC5\xB2" => "\xE6\x8C\xAA",
		"\xC5\xB3" => "\xE6\x87\xA6",
		"\xC5\xB4" => "\xE7\xB3\xAF",
		"\xC5\xB5" => "\xE8\xAF\xBA",
		"\xC5\xB6" => "\xE5\x93\xA6",
		"\xC5\xB7" => "\xE6\xAC\xA7",
		"\xC5\xB8" => "\xE9\xB8\xA5",
		"\xC5\xB9" => "\xE6\xAE\xB4",
		"\xC5\xBA" => "\xE8\x97\x95",
		"\xC5\xBB" => "\xE5\x91\x95",
		"\xC5\xBC" => "\xE5\x81\xB6",
		"\xC5\xBD" => "\xE6\xB2\xA4",
		"\xC5\xBE" => "\xE5\x95\xAA",
		"\xC5\xBF" => "\xE8\xB6\xB4",
		"\xC5\xC0" => "\xE7\x88\xAC",
		"\xC5\xC1" => "\xE5\xB8\x95",
		"\xC5\xC2" => "\xE6\x80\x95",
		"\xC5\xC3" => "\xE7\x90\xB6",
		"\xC5\xC4" => "\xE6\x8B\x8D",
		"\xC5\xC5" => "\xE6\x8E\x92",
		"\xC5\xC6" => "\xE7\x89\x8C",
		"\xC5\xC7" => "\xE5\xBE\x98",
		"\xC5\xC8" => "\xE6\xB9\x83",
		"\xC5\xC9" => "\xE6\xB4\xBE",
		"\xC5\xCA" => "\xE6\x94\x80",
		"\xC5\xCB" => "\xE6\xBD\x98",
		"\xC5\xCC" => "\xE7\x9B\x98",
		"\xC5\xCD" => "\xE7\xA3\x90",
		"\xC5\xCE" => "\xE7\x9B\xBC",
		"\xC5\xCF" => "\xE7\x95\x94",
		"\xC5\xD0" => "\xE5\x88\xA4",
		"\xC5\xD1" => "\xE5\x8F\x9B",
		"\xC5\xD2" => "\xE4\xB9\x93",
		"\xC5\xD3" => "\xE5\xBA\x9E",
		"\xC5\xD4" => "\xE6\x97\x81",
		"\xC5\xD5" => "\xE8\x80\xAA",
		"\xC5\xD6" => "\xE8\x83\x96",
		"\xC5\xD7" => "\xE6\x8A\x9B",
		"\xC5\xD8" => "\xE5\x92\x86",
		"\xC5\xD9" => "\xE5\x88\xA8",
		"\xC5\xDA" => "\xE7\x82\xAE",
		"\xC5\xDB" => "\xE8\xA2\x8D",
		"\xC5\xDC" => "\xE8\xB7\x91",
		"\xC5\xDD" => "\xE6\xB3\xA1",
		"\xC5\xDE" => "\xE5\x91\xB8",
		"\xC5\xDF" => "\xE8\x83\x9A",
		"\xC5\xE0" => "\xE5\x9F\xB9",
		"\xC5\xE1" => "\xE8\xA3\xB4",
		"\xC5\xE2" => "\xE8\xB5\x94",
		"\xC5\xE3" => "\xE9\x99\xAA",
		"\xC5\xE4" => "\xE9\x85\x8D",
		"\xC5\xE5" => "\xE4\xBD\xA9",
		"\xC5\xE6" => "\xE6\xB2\x9B",
		"\xC5\xE7" => "\xE5\x96\xB7",
		"\xC5\xE8" => "\xE7\x9B\x86",
		"\xC5\xE9" => "\xE7\xA0\xB0",
		"\xC5\xEA" => "\xE6\x8A\xA8",
		"\xC5\xEB" => "\xE7\x83\xB9",
		"\xC5\xEC" => "\xE6\xBE\x8E",
		"\xC5\xED" => "\xE5\xBD\xAD",
		"\xC5\xEE" => "\xE8\x93\xAC",
		"\xC5\xEF" => "\xE6\xA3\x9A",
		"\xC5\xF0" => "\xE7\xA1\xBC",
		"\xC5\xF1" => "\xE7\xAF\xB7",
		"\xC5\xF2" => "\xE8\x86\xA8",
		"\xC5\xF3" => "\xE6\x9C\x8B",
		"\xC5\xF4" => "\xE9\xB9\x8F",
		"\xC5\xF5" => "\xE6\x8D\xA7",
		"\xC5\xF6" => "\xE7\xA2\xB0",
		"\xC5\xF7" => "\xE5\x9D\xAF",
		"\xC5\xF8" => "\xE7\xA0\x92",
		"\xC5\xF9" => "\xE9\x9C\xB9",
		"\xC5\xFA" => "\xE6\x89\xB9",
		"\xC5\xFB" => "\xE6\x8A\xAB",
		"\xC5\xFC" => "\xE5\x8A\x88",
		"\xC5\xFD" => "\xE7\x90\xB5",
		"\xC5\xFE" => "\xE6\xAF\x97",
		"\xC6\xA1" => "\xE5\x95\xA4",
		"\xC6\xA2" => "\xE8\x84\xBE",
		"\xC6\xA3" => "\xE7\x96\xB2",
		"\xC6\xA4" => "\xE7\x9A\xAE",
		"\xC6\xA5" => "\xE5\x8C\xB9",
		"\xC6\xA6" => "\xE7\x97\x9E",
		"\xC6\xA7" => "\xE5\x83\xBB",
		"\xC6\xA8" => "\xE5\xB1\x81",
		"\xC6\xA9" => "\xE8\xAD\xAC",
		"\xC6\xAA" => "\xE7\xAF\x87",
		"\xC6\xAB" => "\xE5\x81\x8F",
		"\xC6\xAC" => "\xE7\x89\x87",
		"\xC6\xAD" => "\xE9\xAA\x97",
		"\xC6\xAE" => "\xE9\xA3\x98",
		"\xC6\xAF" => "\xE6\xBC\x82",
		"\xC6\xB0" => "\xE7\x93\xA2",
		"\xC6\xB1" => "\xE7\xA5\xA8",
		"\xC6\xB2" => "\xE6\x92\x87",
		"\xC6\xB3" => "\xE7\x9E\xA5",
		"\xC6\xB4" => "\xE6\x8B\xBC",
		"\xC6\xB5" => "\xE9\xA2\x91",
		"\xC6\xB6" => "\xE8\xB4\xAB",
		"\xC6\xB7" => "\xE5\x93\x81",
		"\xC6\xB8" => "\xE8\x81\x98",
		"\xC6\xB9" => "\xE4\xB9\x92",
		"\xC6\xBA" => "\xE5\x9D\xAA",
		"\xC6\xBB" => "\xE8\x8B\xB9",
		"\xC6\xBC" => "\xE8\x90\x8D",
		"\xC6\xBD" => "\xE5\xB9\xB3",
		"\xC6\xBE" => "\xE5\x87\xAD",
		"\xC6\xBF" => "\xE7\x93\xB6",
		"\xC6\xC0" => "\xE8\xAF\x84",
		"\xC6\xC1" => "\xE5\xB1\x8F",
		"\xC6\xC2" => "\xE5\x9D\xA1",
		"\xC6\xC3" => "\xE6\xB3\xBC",
		"\xC6\xC4" => "\xE9\xA2\x87",
		"\xC6\xC5" => "\xE5\xA9\x86",
		"\xC6\xC6" => "\xE7\xA0\xB4",
		"\xC6\xC7" => "\xE9\xAD\x84",
		"\xC6\xC8" => "\xE8\xBF\xAB",
		"\xC6\xC9" => "\xE7\xB2\x95",
		"\xC6\xCA" => "\xE5\x89\x96",
		"\xC6\xCB" => "\xE6\x89\x91",
		"\xC6\xCC" => "\xE9\x93\xBA",
		"\xC6\xCD" => "\xE4\xBB\x86",
		"\xC6\xCE" => "\xE8\x8E\x86",
		"\xC6\xCF" => "\xE8\x91\xA1",
		"\xC6\xD0" => "\xE8\x8F\xA9",
		"\xC6\xD1" => "\xE8\x92\xB2",
		"\xC6\xD2" => "\xE5\x9F\x94",
		"\xC6\xD3" => "\xE6\x9C\xB4",
		"\xC6\xD4" => "\xE5\x9C\x83",
		"\xC6\xD5" => "\xE6\x99\xAE",
		"\xC6\xD6" => "\xE6\xB5\xA6",
		"\xC6\xD7" => "\xE8\xB0\xB1",
		"\xC6\xD8" => "\xE6\x9B\x9D",
		"\xC6\xD9" => "\xE7\x80\x91",
		"\xC6\xDA" => "\xE6\x9C\x9F",
		"\xC6\xDB" => "\xE6\xAC\xBA",
		"\xC6\xDC" => "\xE6\xA0\x96",
		"\xC6\xDD" => "\xE6\x88\x9A",
		"\xC6\xDE" => "\xE5\xA6\xBB",
		"\xC6\xDF" => "\xE4\xB8\x83",
		"\xC6\xE0" => "\xE5\x87\x84",
		"\xC6\xE1" => "\xE6\xBC\x86",
		"\xC6\xE2" => "\xE6\x9F\x92",
		"\xC6\xE3" => "\xE6\xB2\x8F",
		"\xC6\xE4" => "\xE5\x85\xB6",
		"\xC6\xE5" => "\xE6\xA3\x8B",
		"\xC6\xE6" => "\xE5\xA5\x87",
		"\xC6\xE7" => "\xE6\xAD\xA7",
		"\xC6\xE8" => "\xE7\x95\xA6",
		"\xC6\xE9" => "\xE5\xB4\x8E",
		"\xC6\xEA" => "\xE8\x84\x90",
		"\xC6\xEB" => "\xE9\xBD\x90",
		"\xC6\xEC" => "\xE6\x97\x97",
		"\xC6\xED" => "\xE7\xA5\x88",
		"\xC6\xEE" => "\xE7\xA5\x81",
		"\xC6\xEF" => "\xE9\xAA\x91",
		"\xC6\xF0" => "\xE8\xB5\xB7",
		"\xC6\xF1" => "\xE5\xB2\x82",
		"\xC6\xF2" => "\xE4\xB9\x9E",
		"\xC6\xF3" => "\xE4\xBC\x81",
		"\xC6\xF4" => "\xE5\x90\xAF",
		"\xC6\xF5" => "\xE5\xA5\x91",
		"\xC6\xF6" => "\xE7\xA0\x8C",
		"\xC6\xF7" => "\xE5\x99\xA8",
		"\xC6\xF8" => "\xE6\xB0\x94",
		"\xC6\xF9" => "\xE8\xBF\x84",
		"\xC6\xFA" => "\xE5\xBC\x83",
		"\xC6\xFB" => "\xE6\xB1\xBD",
		"\xC6\xFC" => "\xE6\xB3\xA3",
		"\xC6\xFD" => "\xE8\xAE\xAB",
		"\xC6\xFE" => "\xE6\x8E\x90",
		"\xC7\xA1" => "\xE6\x81\xB0",
		"\xC7\xA2" => "\xE6\xB4\xBD",
		"\xC7\xA3" => "\xE7\x89\xB5",
		"\xC7\xA4" => "\xE6\x89\xA6",
		"\xC7\xA5" => "\xE9\x92\x8E",
		"\xC7\xA6" => "\xE9\x93\x85",
		"\xC7\xA7" => "\xE5\x8D\x83",
		"\xC7\xA8" => "\xE8\xBF\x81",
		"\xC7\xA9" => "\xE7\xAD\xBE",
		"\xC7\xAA" => "\xE4\xBB\x9F",
		"\xC7\xAB" => "\xE8\xB0\xA6",
		"\xC7\xAC" => "\xE4\xB9\xBE",
		"\xC7\xAD" => "\xE9\xBB\x94",
		"\xC7\xAE" => "\xE9\x92\xB1",
		"\xC7\xAF" => "\xE9\x92\xB3",
		"\xC7\xB0" => "\xE5\x89\x8D",
		"\xC7\xB1" => "\xE6\xBD\x9C",
		"\xC7\xB2" => "\xE9\x81\xA3",
		"\xC7\xB3" => "\xE6\xB5\x85",
		"\xC7\xB4" => "\xE8\xB0\xB4",
		"\xC7\xB5" => "\xE5\xA0\x91",
		"\xC7\xB6" => "\xE5\xB5\x8C",
		"\xC7\xB7" => "\xE6\xAC\xA0",
		"\xC7\xB8" => "\xE6\xAD\x89",
		"\xC7\xB9" => "\xE6\x9E\xAA",
		"\xC7\xBA" => "\xE5\x91\x9B",
		"\xC7\xBB" => "\xE8\x85\x94",
		"\xC7\xBC" => "\xE7\xBE\x8C",
		"\xC7\xBD" => "\xE5\xA2\x99",
		"\xC7\xBE" => "\xE8\x94\xB7",
		"\xC7\xBF" => "\xE5\xBC\xBA",
		"\xC7\xC0" => "\xE6\x8A\xA2",
		"\xC7\xC1" => "\xE6\xA9\x87",
		"\xC7\xC2" => "\xE9\x94\xB9",
		"\xC7\xC3" => "\xE6\x95\xB2",
		"\xC7\xC4" => "\xE6\x82\x84",
		"\xC7\xC5" => "\xE6\xA1\xA5",
		"\xC7\xC6" => "\xE7\x9E\xA7",
		"\xC7\xC7" => "\xE4\xB9\x94",
		"\xC7\xC8" => "\xE4\xBE\xA8",
		"\xC7\xC9" => "\xE5\xB7\xA7",
		"\xC7\xCA" => "\xE9\x9E\x98",
		"\xC7\xCB" => "\xE6\x92\xAC",
		"\xC7\xCC" => "\xE7\xBF\x98",
		"\xC7\xCD" => "\xE5\xB3\xAD",
		"\xC7\xCE" => "\xE4\xBF\x8F",
		"\xC7\xCF" => "\xE7\xAA\x8D",
		"\xC7\xD0" => "\xE5\x88\x87",
		"\xC7\xD1" => "\xE8\x8C\x84",
		"\xC7\xD2" => "\xE4\xB8\x94",
		"\xC7\xD3" => "\xE6\x80\xAF",
		"\xC7\xD4" => "\xE7\xAA\x83",
		"\xC7\xD5" => "\xE9\x92\xA6",
		"\xC7\xD6" => "\xE4\xBE\xB5",
		"\xC7\xD7" => "\xE4\xBA\xB2",
		"\xC7\xD8" => "\xE7\xA7\xA6",
		"\xC7\xD9" => "\xE7\x90\xB4",
		"\xC7\xDA" => "\xE5\x8B\xA4",
		"\xC7\xDB" => "\xE8\x8A\xB9",
		"\xC7\xDC" => "\xE6\x93\x92",
		"\xC7\xDD" => "\xE7\xA6\xBD",
		"\xC7\xDE" => "\xE5\xAF\x9D",
		"\xC7\xDF" => "\xE6\xB2\x81",
		"\xC7\xE0" => "\xE9\x9D\x92",
		"\xC7\xE1" => "\xE8\xBD\xBB",
		"\xC7\xE2" => "\xE6\xB0\xA2",
		"\xC7\xE3" => "\xE5\x80\xBE",
		"\xC7\xE4" => "\xE5\x8D\xBF",
		"\xC7\xE5" => "\xE6\xB8\x85",
		"\xC7\xE6" => "\xE6\x93\x8E",
		"\xC7\xE7" => "\xE6\x99\xB4",
		"\xC7\xE8" => "\xE6\xB0\xB0",
		"\xC7\xE9" => "\xE6\x83\x85",
		"\xC7\xEA" => "\xE9\xA1\xB7",
		"\xC7\xEB" => "\xE8\xAF\xB7",
		"\xC7\xEC" => "\xE5\xBA\x86",
		"\xC7\xED" => "\xE7\x90\xBC",
		"\xC7\xEE" => "\xE7\xA9\xB7",
		"\xC7\xEF" => "\xE7\xA7\x8B",
		"\xC7\xF0" => "\xE4\xB8\x98",
		"\xC7\xF1" => "\xE9\x82\xB1",
		"\xC7\xF2" => "\xE7\x90\x83",
		"\xC7\xF3" => "\xE6\xB1\x82",
		"\xC7\xF4" => "\xE5\x9B\x9A",
		"\xC7\xF5" => "\xE9\x85\x8B",
		"\xC7\xF6" => "\xE6\xB3\x85",
		"\xC7\xF7" => "\xE8\xB6\x8B",
		"\xC7\xF8" => "\xE5\x8C\xBA",
		"\xC7\xF9" => "\xE8\x9B\x86",
		"\xC7\xFA" => "\xE6\x9B\xB2",
		"\xC7\xFB" => "\xE8\xBA\xAF",
		"\xC7\xFC" => "\xE5\xB1\x88",
		"\xC7\xFD" => "\xE9\xA9\xB1",
		"\xC7\xFE" => "\xE6\xB8\xA0",
		"\xC8\xA1" => "\xE5\x8F\x96",
		"\xC8\xA2" => "\xE5\xA8\xB6",
		"\xC8\xA3" => "\xE9\xBE\x8B",
		"\xC8\xA4" => "\xE8\xB6\xA3",
		"\xC8\xA5" => "\xE5\x8E\xBB",
		"\xC8\xA6" => "\xE5\x9C\x88",
		"\xC8\xA7" => "\xE9\xA2\xA7",
		"\xC8\xA8" => "\xE6\x9D\x83",
		"\xC8\xA9" => "\xE9\x86\x9B",
		"\xC8\xAA" => "\xE6\xB3\x89",
		"\xC8\xAB" => "\xE5\x85\xA8",
		"\xC8\xAC" => "\xE7\x97\x8A",
		"\xC8\xAD" => "\xE6\x8B\xB3",
		"\xC8\xAE" => "\xE7\x8A\xAC",
		"\xC8\xAF" => "\xE5\x88\xB8",
		"\xC8\xB0" => "\xE5\x8A\x9D",
		"\xC8\xB1" => "\xE7\xBC\xBA",
		"\xC8\xB2" => "\xE7\x82\x94",
		"\xC8\xB3" => "\xE7\x98\xB8",
		"\xC8\xB4" => "\xE5\x8D\xB4",
		"\xC8\xB5" => "\xE9\xB9\x8A",
		"\xC8\xB6" => "\xE6\xA6\xB7",
		"\xC8\xB7" => "\xE7\xA1\xAE",
		"\xC8\xB8" => "\xE9\x9B\x80",
		"\xC8\xB9" => "\xE8\xA3\x99",
		"\xC8\xBA" => "\xE7\xBE\xA4",
		"\xC8\xBB" => "\xE7\x84\xB6",
		"\xC8\xBC" => "\xE7\x87\x83",
		"\xC8\xBD" => "\xE5\x86\x89",
		"\xC8\xBE" => "\xE6\x9F\x93",
		"\xC8\xBF" => "\xE7\x93\xA4",
		"\xC8\xC0" => "\xE5\xA3\xA4",
		"\xC8\xC1" => "\xE6\x94\x98",
		"\xC8\xC2" => "\xE5\x9A\xB7",
		"\xC8\xC3" => "\xE8\xAE\xA9",
		"\xC8\xC4" => "\xE9\xA5\xB6",
		"\xC8\xC5" => "\xE6\x89\xB0",
		"\xC8\xC6" => "\xE7\xBB\x95",
		"\xC8\xC7" => "\xE6\x83\xB9",
		"\xC8\xC8" => "\xE7\x83\xAD",
		"\xC8\xC9" => "\xE5\xA3\xAC",
		"\xC8\xCA" => "\xE4\xBB\x81",
		"\xC8\xCB" => "\xE4\xBA\xBA",
		"\xC8\xCC" => "\xE5\xBF\x8D",
		"\xC8\xCD" => "\xE9\x9F\xA7",
		"\xC8\xCE" => "\xE4\xBB\xBB",
		"\xC8\xCF" => "\xE8\xAE\xA4",
		"\xC8\xD0" => "\xE5\x88\x83",
		"\xC8\xD1" => "\xE5\xA6\x8A",
		"\xC8\xD2" => "\xE7\xBA\xAB",
		"\xC8\xD3" => "\xE6\x89\x94",
		"\xC8\xD4" => "\xE4\xBB\x8D",
		"\xC8\xD5" => "\xE6\x97\xA5",
		"\xC8\xD6" => "\xE6\x88\x8E",
		"\xC8\xD7" => "\xE8\x8C\xB8",
		"\xC8\xD8" => "\xE8\x93\x89",
		"\xC8\xD9" => "\xE8\x8D\xA3",
		"\xC8\xDA" => "\xE8\x9E\x8D",
		"\xC8\xDB" => "\xE7\x86\x94",
		"\xC8\xDC" => "\xE6\xBA\xB6",
		"\xC8\xDD" => "\xE5\xAE\xB9",
		"\xC8\xDE" => "\xE7\xBB\x92",
		"\xC8\xDF" => "\xE5\x86\x97",
		"\xC8\xE0" => "\xE6\x8F\x89",
		"\xC8\xE1" => "\xE6\x9F\x94",
		"\xC8\xE2" => "\xE8\x82\x89",
		"\xC8\xE3" => "\xE8\x8C\xB9",
		"\xC8\xE4" => "\xE8\xA0\x95",
		"\xC8\xE5" => "\xE5\x84\x92",
		"\xC8\xE6" => "\xE5\xAD\xBA",
		"\xC8\xE7" => "\xE5\xA6\x82",
		"\xC8\xE8" => "\xE8\xBE\xB1",
		"\xC8\xE9" => "\xE4\xB9\xB3",
		"\xC8\xEA" => "\xE6\xB1\x9D",
		"\xC8\xEB" => "\xE5\x85\xA5",
		"\xC8\xEC" => "\xE8\xA4\xA5",
		"\xC8\xED" => "\xE8\xBD\xAF",
		"\xC8\xEE" => "\xE9\x98\xAE",
		"\xC8\xEF" => "\xE8\x95\x8A",
		"\xC8\xF0" => "\xE7\x91\x9E",
		"\xC8\xF1" => "\xE9\x94\x90",
		"\xC8\xF2" => "\xE9\x97\xB0",
		"\xC8\xF3" => "\xE6\xB6\xA6",
		"\xC8\xF4" => "\xE8\x8B\xA5",
		"\xC8\xF5" => "\xE5\xBC\xB1",
		"\xC8\xF6" => "\xE6\x92\x92",
		"\xC8\xF7" => "\xE6\xB4\x92",
		"\xC8\xF8" => "\xE8\x90\xA8",
		"\xC8\xF9" => "\xE8\x85\xAE",
		"\xC8\xFA" => "\xE9\xB3\x83",
		"\xC8\xFB" => "\xE5\xA1\x9E",
		"\xC8\xFC" => "\xE8\xB5\x9B",
		"\xC8\xFD" => "\xE4\xB8\x89",
		"\xC8\xFE" => "\xE5\x8F\x81",
		"\xC9\xA1" => "\xE4\xBC\x9E",
		"\xC9\xA2" => "\xE6\x95\xA3",
		"\xC9\xA3" => "\xE6\xA1\x91",
		"\xC9\xA4" => "\xE5\x97\x93",
		"\xC9\xA5" => "\xE4\xB8\xA7",
		"\xC9\xA6" => "\xE6\x90\x94",
		"\xC9\xA7" => "\xE9\xAA\x9A",
		"\xC9\xA8" => "\xE6\x89\xAB",
		"\xC9\xA9" => "\xE5\xAB\x82",
		"\xC9\xAA" => "\xE7\x91\x9F",
		"\xC9\xAB" => "\xE8\x89\xB2",
		"\xC9\xAC" => "\xE6\xB6\xA9",
		"\xC9\xAD" => "\xE6\xA3\xAE",
		"\xC9\xAE" => "\xE5\x83\xA7",
		"\xC9\xAF" => "\xE8\x8E\x8E",
		"\xC9\xB0" => "\xE7\xA0\x82",
		"\xC9\xB1" => "\xE6\x9D\x80",
		"\xC9\xB2" => "\xE5\x88\xB9",
		"\xC9\xB3" => "\xE6\xB2\x99",
		"\xC9\xB4" => "\xE7\xBA\xB1",
		"\xC9\xB5" => "\xE5\x82\xBB",
		"\xC9\xB6" => "\xE5\x95\xA5",
		"\xC9\xB7" => "\xE7\x85\x9E",
		"\xC9\xB8" => "\xE7\xAD\x9B",
		"\xC9\xB9" => "\xE6\x99\x92",
		"\xC9\xBA" => "\xE7\x8F\x8A",
		"\xC9\xBB" => "\xE8\x8B\xAB",
		"\xC9\xBC" => "\xE6\x9D\x89",
		"\xC9\xBD" => "\xE5\xB1\xB1",
		"\xC9\xBE" => "\xE5\x88\xA0",
		"\xC9\xBF" => "\xE7\x85\xBD",
		"\xC9\xC0" => "\xE8\xA1\xAB",
		"\xC9\xC1" => "\xE9\x97\xAA",
		"\xC9\xC2" => "\xE9\x99\x95",
		"\xC9\xC3" => "\xE6\x93\x85",
		"\xC9\xC4" => "\xE8\xB5\xA1",
		"\xC9\xC5" => "\xE8\x86\xB3",
		"\xC9\xC6" => "\xE5\x96\x84",
		"\xC9\xC7" => "\xE6\xB1\x95",
		"\xC9\xC8" => "\xE6\x89\x87",
		"\xC9\xC9" => "\xE7\xBC\xAE",
		"\xC9\xCA" => "\xE5\xA2\x92",
		"\xC9\xCB" => "\xE4\xBC\xA4",
		"\xC9\xCC" => "\xE5\x95\x86",
		"\xC9\xCD" => "\xE8\xB5\x8F",
		"\xC9\xCE" => "\xE6\x99\x8C",
		"\xC9\xCF" => "\xE4\xB8\x8A",
		"\xC9\xD0" => "\xE5\xB0\x9A",
		"\xC9\xD1" => "\xE8\xA3\xB3",
		"\xC9\xD2" => "\xE6\xA2\xA2",
		"\xC9\xD3" => "\xE6\x8D\x8E",
		"\xC9\xD4" => "\xE7\xA8\x8D",
		"\xC9\xD5" => "\xE7\x83\xA7",
		"\xC9\xD6" => "\xE8\x8A\x8D",
		"\xC9\xD7" => "\xE5\x8B\xBA",
		"\xC9\xD8" => "\xE9\x9F\xB6",
		"\xC9\xD9" => "\xE5\xB0\x91",
		"\xC9\xDA" => "\xE5\x93\xA8",
		"\xC9\xDB" => "\xE9\x82\xB5",
		"\xC9\xDC" => "\xE7\xBB\x8D",
		"\xC9\xDD" => "\xE5\xA5\xA2",
		"\xC9\xDE" => "\xE8\xB5\x8A",
		"\xC9\xDF" => "\xE8\x9B\x87",
		"\xC9\xE0" => "\xE8\x88\x8C",
		"\xC9\xE1" => "\xE8\x88\x8D",
		"\xC9\xE2" => "\xE8\xB5\xA6",
		"\xC9\xE3" => "\xE6\x91\x84",
		"\xC9\xE4" => "\xE5\xB0\x84",
		"\xC9\xE5" => "\xE6\x85\x91",
		"\xC9\xE6" => "\xE6\xB6\x89",
		"\xC9\xE7" => "\xE7\xA4\xBE",
		"\xC9\xE8" => "\xE8\xAE\xBE",
		"\xC9\xE9" => "\xE7\xA0\xB7",
		"\xC9\xEA" => "\xE7\x94\xB3",
		"\xC9\xEB" => "\xE5\x91\xBB",
		"\xC9\xEC" => "\xE4\xBC\xB8",
		"\xC9\xED" => "\xE8\xBA\xAB",
		"\xC9\xEE" => "\xE6\xB7\xB1",
		"\xC9\xEF" => "\xE5\xA8\xA0",
		"\xC9\xF0" => "\xE7\xBB\x85",
		"\xC9\xF1" => "\xE7\xA5\x9E",
		"\xC9\xF2" => "\xE6\xB2\x88",
		"\xC9\xF3" => "\xE5\xAE\xA1",
		"\xC9\xF4" => "\xE5\xA9\xB6",
		"\xC9\xF5" => "\xE7\x94\x9A",
		"\xC9\xF6" => "\xE8\x82\xBE",
		"\xC9\xF7" => "\xE6\x85\x8E",
		"\xC9\xF8" => "\xE6\xB8\x97",
		"\xC9\xF9" => "\xE5\xA3\xB0",
		"\xC9\xFA" => "\xE7\x94\x9F",
		"\xC9\xFB" => "\xE7\x94\xA5",
		"\xC9\xFC" => "\xE7\x89\xB2",
		"\xC9\xFD" => "\xE5\x8D\x87",
		"\xC9\xFE" => "\xE7\xBB\xB3",
		"\xCA\xA1" => "\xE7\x9C\x81",
		"\xCA\xA2" => "\xE7\x9B\x9B",
		"\xCA\xA3" => "\xE5\x89\xA9",
		"\xCA\xA4" => "\xE8\x83\x9C",
		"\xCA\xA5" => "\xE5\x9C\xA3",
		"\xCA\xA6" => "\xE5\xB8\x88",
		"\xCA\xA7" => "\xE5\xA4\xB1",
		"\xCA\xA8" => "\xE7\x8B\xAE",
		"\xCA\xA9" => "\xE6\x96\xBD",
		"\xCA\xAA" => "\xE6\xB9\xBF",
		"\xCA\xAB" => "\xE8\xAF\x97",
		"\xCA\xAC" => "\xE5\xB0\xB8",
		"\xCA\xAD" => "\xE8\x99\xB1",
		"\xCA\xAE" => "\xE5\x8D\x81",
		"\xCA\xAF" => "\xE7\x9F\xB3",
		"\xCA\xB0" => "\xE6\x8B\xBE",
		"\xCA\xB1" => "\xE6\x97\xB6",
		"\xCA\xB2" => "\xE4\xBB\x80",
		"\xCA\xB3" => "\xE9\xA3\x9F",
		"\xCA\xB4" => "\xE8\x9A\x80",
		"\xCA\xB5" => "\xE5\xAE\x9E",
		"\xCA\xB6" => "\xE8\xAF\x86",
		"\xCA\xB7" => "\xE5\x8F\xB2",
		"\xCA\xB8" => "\xE7\x9F\xA2",
		"\xCA\xB9" => "\xE4\xBD\xBF",
		"\xCA\xBA" => "\xE5\xB1\x8E",
		"\xCA\xBB" => "\xE9\xA9\xB6",
		"\xCA\xBC" => "\xE5\xA7\x8B",
		"\xCA\xBD" => "\xE5\xBC\x8F",
		"\xCA\xBE" => "\xE7\xA4\xBA",
		"\xCA\xBF" => "\xE5\xA3\xAB",
		"\xCA\xC0" => "\xE4\xB8\x96",
		"\xCA\xC1" => "\xE6\x9F\xBF",
		"\xCA\xC2" => "\xE4\xBA\x8B",
		"\xCA\xC3" => "\xE6\x8B\xAD",
		"\xCA\xC4" => "\xE8\xAA\x93",
		"\xCA\xC5" => "\xE9\x80\x9D",
		"\xCA\xC6" => "\xE5\x8A\xBF",
		"\xCA\xC7" => "\xE6\x98\xAF",
		"\xCA\xC8" => "\xE5\x97\x9C",
		"\xCA\xC9" => "\xE5\x99\xAC",
		"\xCA\xCA" => "\xE9\x80\x82",
		"\xCA\xCB" => "\xE4\xBB\x95",
		"\xCA\xCC" => "\xE4\xBE\x8D",
		"\xCA\xCD" => "\xE9\x87\x8A",
		"\xCA\xCE" => "\xE9\xA5\xB0",
		"\xCA\xCF" => "\xE6\xB0\x8F",
		"\xCA\xD0" => "\xE5\xB8\x82",
		"\xCA\xD1" => "\xE6\x81\x83",
		"\xCA\xD2" => "\xE5\xAE\xA4",
		"\xCA\xD3" => "\xE8\xA7\x86",
		"\xCA\xD4" => "\xE8\xAF\x95",
		"\xCA\xD5" => "\xE6\x94\xB6",
		"\xCA\xD6" => "\xE6\x89\x8B",
		"\xCA\xD7" => "\xE9\xA6\x96",
		"\xCA\xD8" => "\xE5\xAE\x88",
		"\xCA\xD9" => "\xE5\xAF\xBF",
		"\xCA\xDA" => "\xE6\x8E\x88",
		"\xCA\xDB" => "\xE5\x94\xAE",
		"\xCA\xDC" => "\xE5\x8F\x97",
		"\xCA\xDD" => "\xE7\x98\xA6",
		"\xCA\xDE" => "\xE5\x85\xBD",
		"\xCA\xDF" => "\xE8\x94\xAC",
		"\xCA\xE0" => "\xE6\x9E\xA2",
		"\xCA\xE1" => "\xE6\xA2\xB3",
		"\xCA\xE2" => "\xE6\xAE\x8A",
		"\xCA\xE3" => "\xE6\x8A\x92",
		"\xCA\xE4" => "\xE8\xBE\x93",
		"\xCA\xE5" => "\xE5\x8F\x94",
		"\xCA\xE6" => "\xE8\x88\x92",
		"\xCA\xE7" => "\xE6\xB7\x91",
		"\xCA\xE8" => "\xE7\x96\x8F",
		"\xCA\xE9" => "\xE4\xB9\xA6",
		"\xCA\xEA" => "\xE8\xB5\x8E",
		"\xCA\xEB" => "\xE5\xAD\xB0",
		"\xCA\xEC" => "\xE7\x86\x9F",
		"\xCA\xED" => "\xE8\x96\xAF",
		"\xCA\xEE" => "\xE6\x9A\x91",
		"\xCA\xEF" => "\xE6\x9B\x99",
		"\xCA\xF0" => "\xE7\xBD\xB2",
		"\xCA\xF1" => "\xE8\x9C\x80",
		"\xCA\xF2" => "\xE9\xBB\x8D",
		"\xCA\xF3" => "\xE9\xBC\xA0",
		"\xCA\xF4" => "\xE5\xB1\x9E",
		"\xCA\xF5" => "\xE6\x9C\xAF",
		"\xCA\xF6" => "\xE8\xBF\xB0",
		"\xCA\xF7" => "\xE6\xA0\x91",
		"\xCA\xF8" => "\xE6\x9D\x9F",
		"\xCA\xF9" => "\xE6\x88\x8D",
		"\xCA\xFA" => "\xE7\xAB\x96",
		"\xCA\xFB" => "\xE5\xA2\x85",
		"\xCA\xFC" => "\xE5\xBA\xB6",
		"\xCA\xFD" => "\xE6\x95\xB0",
		"\xCA\xFE" => "\xE6\xBC\xB1",
		"\xCB\xA1" => "\xE6\x81\x95",
		"\xCB\xA2" => "\xE5\x88\xB7",
		"\xCB\xA3" => "\xE8\x80\x8D",
		"\xCB\xA4" => "\xE6\x91\x94",
		"\xCB\xA5" => "\xE8\xA1\xB0",
		"\xCB\xA6" => "\xE7\x94\xA9",
		"\xCB\xA7" => "\xE5\xB8\x85",
		"\xCB\xA8" => "\xE6\xA0\x93",
		"\xCB\xA9" => "\xE6\x8B\xB4",
		"\xCB\xAA" => "\xE9\x9C\x9C",
		"\xCB\xAB" => "\xE5\x8F\x8C",
		"\xCB\xAC" => "\xE7\x88\xBD",
		"\xCB\xAD" => "\xE8\xB0\x81",
		"\xCB\xAE" => "\xE6\xB0\xB4",
		"\xCB\xAF" => "\xE7\x9D\xA1",
		"\xCB\xB0" => "\xE7\xA8\x8E",
		"\xCB\xB1" => "\xE5\x90\xAE",
		"\xCB\xB2" => "\xE7\x9E\xAC",
		"\xCB\xB3" => "\xE9\xA1\xBA",
		"\xCB\xB4" => "\xE8\x88\x9C",
		"\xCB\xB5" => "\xE8\xAF\xB4",
		"\xCB\xB6" => "\xE7\xA1\x95",
		"\xCB\xB7" => "\xE6\x9C\x94",
		"\xCB\xB8" => "\xE7\x83\x81",
		"\xCB\xB9" => "\xE6\x96\xAF",
		"\xCB\xBA" => "\xE6\x92\x95",
		"\xCB\xBB" => "\xE5\x98\xB6",
		"\xCB\xBC" => "\xE6\x80\x9D",
		"\xCB\xBD" => "\xE7\xA7\x81",
		"\xCB\xBE" => "\xE5\x8F\xB8",
		"\xCB\xBF" => "\xE4\xB8\x9D",
		"\xCB\xC0" => "\xE6\xAD\xBB",
		"\xCB\xC1" => "\xE8\x82\x86",
		"\xCB\xC2" => "\xE5\xAF\xBA",
		"\xCB\xC3" => "\xE5\x97\xA3",
		"\xCB\xC4" => "\xE5\x9B\x9B",
		"\xCB\xC5" => "\xE4\xBC\xBA",
		"\xCB\xC6" => "\xE4\xBC\xBC",
		"\xCB\xC7" => "\xE9\xA5\xB2",
		"\xCB\xC8" => "\xE5\xB7\xB3",
		"\xCB\xC9" => "\xE6\x9D\xBE",
		"\xCB\xCA" => "\xE8\x80\xB8",
		"\xCB\xCB" => "\xE6\x80\x82",
		"\xCB\xCC" => "\xE9\xA2\x82",
		"\xCB\xCD" => "\xE9\x80\x81",
		"\xCB\xCE" => "\xE5\xAE\x8B",
		"\xCB\xCF" => "\xE8\xAE\xBC",
		"\xCB\xD0" => "\xE8\xAF\xB5",
		"\xCB\xD1" => "\xE6\x90\x9C",
		"\xCB\xD2" => "\xE8\x89\x98",
		"\xCB\xD3" => "\xE6\x93\x9E",
		"\xCB\xD4" => "\xE5\x97\xBD",
		"\xCB\xD5" => "\xE8\x8B\x8F",
		"\xCB\xD6" => "\xE9\x85\xA5",
		"\xCB\xD7" => "\xE4\xBF\x97",
		"\xCB\xD8" => "\xE7\xB4\xA0",
		"\xCB\xD9" => "\xE9\x80\x9F",
		"\xCB\xDA" => "\xE7\xB2\x9F",
		"\xCB\xDB" => "\xE5\x83\xB3",
		"\xCB\xDC" => "\xE5\xA1\x91",
		"\xCB\xDD" => "\xE6\xBA\xAF",
		"\xCB\xDE" => "\xE5\xAE\xBF",
		"\xCB\xDF" => "\xE8\xAF\x89",
		"\xCB\xE0" => "\xE8\x82\x83",
		"\xCB\xE1" => "\xE9\x85\xB8",
		"\xCB\xE2" => "\xE8\x92\x9C",
		"\xCB\xE3" => "\xE7\xAE\x97",
		"\xCB\xE4" => "\xE8\x99\xBD",
		"\xCB\xE5" => "\xE9\x9A\x8B",
		"\xCB\xE6" => "\xE9\x9A\x8F",
		"\xCB\xE7" => "\xE7\xBB\xA5",
		"\xCB\xE8" => "\xE9\xAB\x93",
		"\xCB\xE9" => "\xE7\xA2\x8E",
		"\xCB\xEA" => "\xE5\xB2\x81",
		"\xCB\xEB" => "\xE7\xA9\x97",
		"\xCB\xEC" => "\xE9\x81\x82",
		"\xCB\xED" => "\xE9\x9A\xA7",
		"\xCB\xEE" => "\xE7\xA5\x9F",
		"\xCB\xEF" => "\xE5\xAD\x99",
		"\xCB\xF0" => "\xE6\x8D\x9F",
		"\xCB\xF1" => "\xE7\xAC\x8B",
		"\xCB\xF2" => "\xE8\x93\x91",
		"\xCB\xF3" => "\xE6\xA2\xAD",
		"\xCB\xF4" => "\xE5\x94\x86",
		"\xCB\xF5" => "\xE7\xBC\xA9",
		"\xCB\xF6" => "\xE7\x90\x90",
		"\xCB\xF7" => "\xE7\xB4\xA2",
		"\xCB\xF8" => "\xE9\x94\x81",
		"\xCB\xF9" => "\xE6\x89\x80",
		"\xCB\xFA" => "\xE5\xA1\x8C",
		"\xCB\xFB" => "\xE4\xBB\x96",
		"\xCB\xFC" => "\xE5\xAE\x83",
		"\xCB\xFD" => "\xE5\xA5\xB9",
		"\xCB\xFE" => "\xE5\xA1\x94",
		"\xCC\xA1" => "\xE7\x8D\xAD",
		"\xCC\xA2" => "\xE6\x8C\x9E",
		"\xCC\xA3" => "\xE8\xB9\x8B",
		"\xCC\xA4" => "\xE8\xB8\x8F",
		"\xCC\xA5" => "\xE8\x83\x8E",
		"\xCC\xA6" => "\xE8\x8B\x94",
		"\xCC\xA7" => "\xE6\x8A\xAC",
		"\xCC\xA8" => "\xE5\x8F\xB0",
		"\xCC\xA9" => "\xE6\xB3\xB0",
		"\xCC\xAA" => "\xE9\x85\x9E",
		"\xCC\xAB" => "\xE5\xA4\xAA",
		"\xCC\xAC" => "\xE6\x80\x81",
		"\xCC\xAD" => "\xE6\xB1\xB0",
		"\xCC\xAE" => "\xE5\x9D\x8D",
		"\xCC\xAF" => "\xE6\x91\x8A",
		"\xCC\xB0" => "\xE8\xB4\xAA",
		"\xCC\xB1" => "\xE7\x98\xAB",
		"\xCC\xB2" => "\xE6\xBB\xA9",
		"\xCC\xB3" => "\xE5\x9D\x9B",
		"\xCC\xB4" => "\xE6\xAA\x80",
		"\xCC\xB5" => "\xE7\x97\xB0",
		"\xCC\xB6" => "\xE6\xBD\xAD",
		"\xCC\xB7" => "\xE8\xB0\xAD",
		"\xCC\xB8" => "\xE8\xB0\x88",
		"\xCC\xB9" => "\xE5\x9D\xA6",
		"\xCC\xBA" => "\xE6\xAF\xAF",
		"\xCC\xBB" => "\xE8\xA2\x92",
		"\xCC\xBC" => "\xE7\xA2\xB3",
		"\xCC\xBD" => "\xE6\x8E\xA2",
		"\xCC\xBE" => "\xE5\x8F\xB9",
		"\xCC\xBF" => "\xE7\x82\xAD",
		"\xCC\xC0" => "\xE6\xB1\xA4",
		"\xCC\xC1" => "\xE5\xA1\x98",
		"\xCC\xC2" => "\xE6\x90\xAA",
		"\xCC\xC3" => "\xE5\xA0\x82",
		"\xCC\xC4" => "\xE6\xA3\xA0",
		"\xCC\xC5" => "\xE8\x86\x9B",
		"\xCC\xC6" => "\xE5\x94\x90",
		"\xCC\xC7" => "\xE7\xB3\x96",
		"\xCC\xC8" => "\xE5\x80\x98",
		"\xCC\xC9" => "\xE8\xBA\xBA",
		"\xCC\xCA" => "\xE6\xB7\x8C",
		"\xCC\xCB" => "\xE8\xB6\x9F",
		"\xCC\xCC" => "\xE7\x83\xAB",
		"\xCC\xCD" => "\xE6\x8E\x8F",
		"\xCC\xCE" => "\xE6\xB6\x9B",
		"\xCC\xCF" => "\xE6\xBB\x94",
		"\xCC\xD0" => "\xE7\xBB\xA6",
		"\xCC\xD1" => "\xE8\x90\x84",
		"\xCC\xD2" => "\xE6\xA1\x83",
		"\xCC\xD3" => "\xE9\x80\x83",
		"\xCC\xD4" => "\xE6\xB7\x98",
		"\xCC\xD5" => "\xE9\x99\xB6",
		"\xCC\xD6" => "\xE8\xAE\xA8",
		"\xCC\xD7" => "\xE5\xA5\x97",
		"\xCC\xD8" => "\xE7\x89\xB9",
		"\xCC\xD9" => "\xE8\x97\xA4",
		"\xCC\xDA" => "\xE8\x85\xBE",
		"\xCC\xDB" => "\xE7\x96\xBC",
		"\xCC\xDC" => "\xE8\xAA\x8A",
		"\xCC\xDD" => "\xE6\xA2\xAF",
		"\xCC\xDE" => "\xE5\x89\x94",
		"\xCC\xDF" => "\xE8\xB8\xA2",
		"\xCC\xE0" => "\xE9\x94\x91",
		"\xCC\xE1" => "\xE6\x8F\x90",
		"\xCC\xE2" => "\xE9\xA2\x98",
		"\xCC\xE3" => "\xE8\xB9\x84",
		"\xCC\xE4" => "\xE5\x95\xBC",
		"\xCC\xE5" => "\xE4\xBD\x93",
		"\xCC\xE6" => "\xE6\x9B\xBF",
		"\xCC\xE7" => "\xE5\x9A\x8F",
		"\xCC\xE8" => "\xE6\x83\x95",
		"\xCC\xE9" => "\xE6\xB6\x95",
		"\xCC\xEA" => "\xE5\x89\x83",
		"\xCC\xEB" => "\xE5\xB1\x89",
		"\xCC\xEC" => "\xE5\xA4\xA9",
		"\xCC\xED" => "\xE6\xB7\xBB",
		"\xCC\xEE" => "\xE5\xA1\xAB",
		"\xCC\xEF" => "\xE7\x94\xB0",
		"\xCC\xF0" => "\xE7\x94\x9C",
		"\xCC\xF1" => "\xE6\x81\xAC",
		"\xCC\xF2" => "\xE8\x88\x94",
		"\xCC\xF3" => "\xE8\x85\x86",
		"\xCC\xF4" => "\xE6\x8C\x91",
		"\xCC\xF5" => "\xE6\x9D\xA1",
		"\xCC\xF6" => "\xE8\xBF\xA2",
		"\xCC\xF7" => "\xE7\x9C\xBA",
		"\xCC\xF8" => "\xE8\xB7\xB3",
		"\xCC\xF9" => "\xE8\xB4\xB4",
		"\xCC\xFA" => "\xE9\x93\x81",
		"\xCC\xFB" => "\xE5\xB8\x96",
		"\xCC\xFC" => "\xE5\x8E\x85",
		"\xCC\xFD" => "\xE5\x90\xAC",
		"\xCC\xFE" => "\xE7\x83\x83",
		"\xCD\xA1" => "\xE6\xB1\x80",
		"\xCD\xA2" => "\xE5\xBB\xB7",
		"\xCD\xA3" => "\xE5\x81\x9C",
		"\xCD\xA4" => "\xE4\xBA\xAD",
		"\xCD\xA5" => "\xE5\xBA\xAD",
		"\xCD\xA6" => "\xE6\x8C\xBA",
		"\xCD\xA7" => "\xE8\x89\x87",
		"\xCD\xA8" => "\xE9\x80\x9A",
		"\xCD\xA9" => "\xE6\xA1\x90",
		"\xCD\xAA" => "\xE9\x85\xAE",
		"\xCD\xAB" => "\xE7\x9E\xB3",
		"\xCD\xAC" => "\xE5\x90\x8C",
		"\xCD\xAD" => "\xE9\x93\x9C",
		"\xCD\xAE" => "\xE5\xBD\xA4",
		"\xCD\xAF" => "\xE7\xAB\xA5",
		"\xCD\xB0" => "\xE6\xA1\xB6",
		"\xCD\xB1" => "\xE6\x8D\x85",
		"\xCD\xB2" => "\xE7\xAD\x92",
		"\xCD\xB3" => "\xE7\xBB\x9F",
		"\xCD\xB4" => "\xE7\x97\x9B",
		"\xCD\xB5" => "\xE5\x81\xB7",
		"\xCD\xB6" => "\xE6\x8A\x95",
		"\xCD\xB7" => "\xE5\xA4\xB4",
		"\xCD\xB8" => "\xE9\x80\x8F",
		"\xCD\xB9" => "\xE5\x87\xB8",
		"\xCD\xBA" => "\xE7\xA7\x83",
		"\xCD\xBB" => "\xE7\xAA\x81",
		"\xCD\xBC" => "\xE5\x9B\xBE",
		"\xCD\xBD" => "\xE5\xBE\x92",
		"\xCD\xBE" => "\xE9\x80\x94",
		"\xCD\xBF" => "\xE6\xB6\x82",
		"\xCD\xC0" => "\xE5\xB1\xA0",
		"\xCD\xC1" => "\xE5\x9C\x9F",
		"\xCD\xC2" => "\xE5\x90\x90",
		"\xCD\xC3" => "\xE5\x85\x94",
		"\xCD\xC4" => "\xE6\xB9\x8D",
		"\xCD\xC5" => "\xE5\x9B\xA2",
		"\xCD\xC6" => "\xE6\x8E\xA8",
		"\xCD\xC7" => "\xE9\xA2\x93",
		"\xCD\xC8" => "\xE8\x85\xBF",
		"\xCD\xC9" => "\xE8\x9C\x95",
		"\xCD\xCA" => "\xE8\xA4\xAA",
		"\xCD\xCB" => "\xE9\x80\x80",
		"\xCD\xCC" => "\xE5\x90\x9E",
		"\xCD\xCD" => "\xE5\xB1\xAF",
		"\xCD\xCE" => "\xE8\x87\x80",
		"\xCD\xCF" => "\xE6\x8B\x96",
		"\xCD\xD0" => "\xE6\x89\x98",
		"\xCD\xD1" => "\xE8\x84\xB1",
		"\xCD\xD2" => "\xE9\xB8\xB5",
		"\xCD\xD3" => "\xE9\x99\x80",
		"\xCD\xD4" => "\xE9\xA9\xAE",
		"\xCD\xD5" => "\xE9\xA9\xBC",
		"\xCD\xD6" => "\xE6\xA4\xAD",
		"\xCD\xD7" => "\xE5\xA6\xA5",
		"\xCD\xD8" => "\xE6\x8B\x93",
		"\xCD\xD9" => "\xE5\x94\xBE",
		"\xCD\xDA" => "\xE6\x8C\x96",
		"\xCD\xDB" => "\xE5\x93\x87",
		"\xCD\xDC" => "\xE8\x9B\x99",
		"\xCD\xDD" => "\xE6\xB4\xBC",
		"\xCD\xDE" => "\xE5\xA8\x83",
		"\xCD\xDF" => "\xE7\x93\xA6",
		"\xCD\xE0" => "\xE8\xA2\x9C",
		"\xCD\xE1" => "\xE6\xAD\xAA",
		"\xCD\xE2" => "\xE5\xA4\x96",
		"\xCD\xE3" => "\xE8\xB1\x8C",
		"\xCD\xE4" => "\xE5\xBC\xAF",
		"\xCD\xE5" => "\xE6\xB9\xBE",
		"\xCD\xE6" => "\xE7\x8E\xA9",
		"\xCD\xE7" => "\xE9\xA1\xBD",
		"\xCD\xE8" => "\xE4\xB8\xB8",
		"\xCD\xE9" => "\xE7\x83\xB7",
		"\xCD\xEA" => "\xE5\xAE\x8C",
		"\xCD\xEB" => "\xE7\xA2\x97",
		"\xCD\xEC" => "\xE6\x8C\xBD",
		"\xCD\xED" => "\xE6\x99\x9A",
		"\xCD\xEE" => "\xE7\x9A\x96",
		"\xCD\xEF" => "\xE6\x83\x8B",
		"\xCD\xF0" => "\xE5\xAE\x9B",
		"\xCD\xF1" => "\xE5\xA9\x89",
		"\xCD\xF2" => "\xE4\xB8\x87",
		"\xCD\xF3" => "\xE8\x85\x95",
		"\xCD\xF4" => "\xE6\xB1\xAA",
		"\xCD\xF5" => "\xE7\x8E\x8B",
		"\xCD\xF6" => "\xE4\xBA\xA1",
		"\xCD\xF7" => "\xE6\x9E\x89",
		"\xCD\xF8" => "\xE7\xBD\x91",
		"\xCD\xF9" => "\xE5\xBE\x80",
		"\xCD\xFA" => "\xE6\x97\xBA",
		"\xCD\xFB" => "\xE6\x9C\x9B",
		"\xCD\xFC" => "\xE5\xBF\x98",
		"\xCD\xFD" => "\xE5\xA6\x84",
		"\xCD\xFE" => "\xE5\xA8\x81",
		"\xCE\xA1" => "\xE5\xB7\x8D",
		"\xCE\xA2" => "\xE5\xBE\xAE",
		"\xCE\xA3" => "\xE5\x8D\xB1",
		"\xCE\xA4" => "\xE9\x9F\xA6",
		"\xCE\xA5" => "\xE8\xBF\x9D",
		"\xCE\xA6" => "\xE6\xA1\x85",
		"\xCE\xA7" => "\xE5\x9B\xB4",
		"\xCE\xA8" => "\xE5\x94\xAF",
		"\xCE\xA9" => "\xE6\x83\x9F",
		"\xCE\xAA" => "\xE4\xB8\xBA",
		"\xCE\xAB" => "\xE6\xBD\x8D",
		"\xCE\xAC" => "\xE7\xBB\xB4",
		"\xCE\xAD" => "\xE8\x8B\x87",
		"\xCE\xAE" => "\xE8\x90\x8E",
		"\xCE\xAF" => "\xE5\xA7\x94",
		"\xCE\xB0" => "\xE4\xBC\x9F",
		"\xCE\xB1" => "\xE4\xBC\xAA",
		"\xCE\xB2" => "\xE5\xB0\xBE",
		"\xCE\xB3" => "\xE7\xBA\xAC",
		"\xCE\xB4" => "\xE6\x9C\xAA",
		"\xCE\xB5" => "\xE8\x94\x9A",
		"\xCE\xB6" => "\xE5\x91\xB3",
		"\xCE\xB7" => "\xE7\x95\x8F",
		"\xCE\xB8" => "\xE8\x83\x83",
		"\xCE\xB9" => "\xE5\x96\x82",
		"\xCE\xBA" => "\xE9\xAD\x8F",
		"\xCE\xBB" => "\xE4\xBD\x8D",
		"\xCE\xBC" => "\xE6\xB8\xAD",
		"\xCE\xBD" => "\xE8\xB0\x93",
		"\xCE\xBE" => "\xE5\xB0\x89",
		"\xCE\xBF" => "\xE6\x85\xB0",
		"\xCE\xC0" => "\xE5\x8D\xAB",
		"\xCE\xC1" => "\xE7\x98\x9F",
		"\xCE\xC2" => "\xE6\xB8\xA9",
		"\xCE\xC3" => "\xE8\x9A\x8A",
		"\xCE\xC4" => "\xE6\x96\x87",
		"\xCE\xC5" => "\xE9\x97\xBB",
		"\xCE\xC6" => "\xE7\xBA\xB9",
		"\xCE\xC7" => "\xE5\x90\xBB",
		"\xCE\xC8" => "\xE7\xA8\xB3",
		"\xCE\xC9" => "\xE7\xB4\x8A",
		"\xCE\xCA" => "\xE9\x97\xAE",
		"\xCE\xCB" => "\xE5\x97\xA1",
		"\xCE\xCC" => "\xE7\xBF\x81",
		"\xCE\xCD" => "\xE7\x93\xAE",
		"\xCE\xCE" => "\xE6\x8C\x9D",
		"\xCE\xCF" => "\xE8\x9C\x97",
		"\xCE\xD0" => "\xE6\xB6\xA1",
		"\xCE\xD1" => "\xE7\xAA\x9D",
		"\xCE\xD2" => "\xE6\x88\x91",
		"\xCE\xD3" => "\xE6\x96\xA1",
		"\xCE\xD4" => "\xE5\x8D\xA7",
		"\xCE\xD5" => "\xE6\x8F\xA1",
		"\xCE\xD6" => "\xE6\xB2\x83",
		"\xCE\xD7" => "\xE5\xB7\xAB",
		"\xCE\xD8" => "\xE5\x91\x9C",
		"\xCE\xD9" => "\xE9\x92\xA8",
		"\xCE\xDA" => "\xE4\xB9\x8C",
		"\xCE\xDB" => "\xE6\xB1\xA1",
		"\xCE\xDC" => "\xE8\xAF\xAC",
		"\xCE\xDD" => "\xE5\xB1\x8B",
		"\xCE\xDE" => "\xE6\x97\xA0",
		"\xCE\xDF" => "\xE8\x8A\x9C",
		"\xCE\xE0" => "\xE6\xA2\xA7",
		"\xCE\xE1" => "\xE5\x90\xBE",
		"\xCE\xE2" => "\xE5\x90\xB4",
		"\xCE\xE3" => "\xE6\xAF\x8B",
		"\xCE\xE4" => "\xE6\xAD\xA6",
		"\xCE\xE5" => "\xE4\xBA\x94",
		"\xCE\xE6" => "\xE6\x8D\x82",
		"\xCE\xE7" => "\xE5\x8D\x88",
		"\xCE\xE8" => "\xE8\x88\x9E",
		"\xCE\xE9" => "\xE4\xBC\x8D",
		"\xCE\xEA" => "\xE4\xBE\xAE",
		"\xCE\xEB" => "\xE5\x9D\x9E",
		"\xCE\xEC" => "\xE6\x88\x8A",
		"\xCE\xED" => "\xE9\x9B\xBE",
		"\xCE\xEE" => "\xE6\x99\xA4",
		"\xCE\xEF" => "\xE7\x89\xA9",
		"\xCE\xF0" => "\xE5\x8B\xBF",
		"\xCE\xF1" => "\xE5\x8A\xA1",
		"\xCE\xF2" => "\xE6\x82\x9F",
		"\xCE\xF3" => "\xE8\xAF\xAF",
		"\xCE\xF4" => "\xE6\x98\x94",
		"\xCE\xF5" => "\xE7\x86\x99",
		"\xCE\xF6" => "\xE6\x9E\x90",
		"\xCE\xF7" => "\xE8\xA5\xBF",
		"\xCE\xF8" => "\xE7\xA1\x92",
		"\xCE\xF9" => "\xE7\x9F\xBD",
		"\xCE\xFA" => "\xE6\x99\xB0",
		"\xCE\xFB" => "\xE5\x98\xBB",
		"\xCE\xFC" => "\xE5\x90\xB8",
		"\xCE\xFD" => "\xE9\x94\xA1",
		"\xCE\xFE" => "\xE7\x89\xBA",
		"\xCF\xA1" => "\xE7\xA8\x80",
		"\xCF\xA2" => "\xE6\x81\xAF",
		"\xCF\xA3" => "\xE5\xB8\x8C",
		"\xCF\xA4" => "\xE6\x82\x89",
		"\xCF\xA5" => "\xE8\x86\x9D",
		"\xCF\xA6" => "\xE5\xA4\x95",
		"\xCF\xA7" => "\xE6\x83\x9C",
		"\xCF\xA8" => "\xE7\x86\x84",
		"\xCF\xA9" => "\xE7\x83\xAF",
		"\xCF\xAA" => "\xE6\xBA\xAA",
		"\xCF\xAB" => "\xE6\xB1\x90",
		"\xCF\xAC" => "\xE7\x8A\x80",
		"\xCF\xAD" => "\xE6\xAA\x84",
		"\xCF\xAE" => "\xE8\xA2\xAD",
		"\xCF\xAF" => "\xE5\xB8\xAD",
		"\xCF\xB0" => "\xE4\xB9\xA0",
		"\xCF\xB1" => "\xE5\xAA\xB3",
		"\xCF\xB2" => "\xE5\x96\x9C",
		"\xCF\xB3" => "\xE9\x93\xA3",
		"\xCF\xB4" => "\xE6\xB4\x97",
		"\xCF\xB5" => "\xE7\xB3\xBB",
		"\xCF\xB6" => "\xE9\x9A\x99",
		"\xCF\xB7" => "\xE6\x88\x8F",
		"\xCF\xB8" => "\xE7\xBB\x86",
		"\xCF\xB9" => "\xE7\x9E\x8E",
		"\xCF\xBA" => "\xE8\x99\xBE",
		"\xCF\xBB" => "\xE5\x8C\xA3",
		"\xCF\xBC" => "\xE9\x9C\x9E",
		"\xCF\xBD" => "\xE8\xBE\x96",
		"\xCF\xBE" => "\xE6\x9A\x87",
		"\xCF\xBF" => "\xE5\xB3\xA1",
		"\xCF\xC0" => "\xE4\xBE\xA0",
		"\xCF\xC1" => "\xE7\x8B\xAD",
		"\xCF\xC2" => "\xE4\xB8\x8B",
		"\xCF\xC3" => "\xE5\x8E\xA6",
		"\xCF\xC4" => "\xE5\xA4\x8F",
		"\xCF\xC5" => "\xE5\x90\x93",
		"\xCF\xC6" => "\xE6\x8E\x80",
		"\xCF\xC7" => "\xE9\x94\xA8",
		"\xCF\xC8" => "\xE5\x85\x88",
		"\xCF\xC9" => "\xE4\xBB\x99",
		"\xCF\xCA" => "\xE9\xB2\x9C",
		"\xCF\xCB" => "\xE7\xBA\xA4",
		"\xCF\xCC" => "\xE5\x92\xB8",
		"\xCF\xCD" => "\xE8\xB4\xA4",
		"\xCF\xCE" => "\xE8\xA1\x94",
		"\xCF\xCF" => "\xE8\x88\xB7",
		"\xCF\xD0" => "\xE9\x97\xB2",
		"\xCF\xD1" => "\xE6\xB6\x8E",
		"\xCF\xD2" => "\xE5\xBC\xA6",
		"\xCF\xD3" => "\xE5\xAB\x8C",
		"\xCF\xD4" => "\xE6\x98\xBE",
		"\xCF\xD5" => "\xE9\x99\xA9",
		"\xCF\xD6" => "\xE7\x8E\xB0",
		"\xCF\xD7" => "\xE7\x8C\xAE",
		"\xCF\xD8" => "\xE5\x8E\xBF",
		"\xCF\xD9" => "\xE8\x85\xBA",
		"\xCF\xDA" => "\xE9\xA6\x85",
		"\xCF\xDB" => "\xE7\xBE\xA1",
		"\xCF\xDC" => "\xE5\xAE\xAA",
		"\xCF\xDD" => "\xE9\x99\xB7",
		"\xCF\xDE" => "\xE9\x99\x90",
		"\xCF\xDF" => "\xE7\xBA\xBF",
		"\xCF\xE0" => "\xE7\x9B\xB8",
		"\xCF\xE1" => "\xE5\x8E\xA2",
		"\xCF\xE2" => "\xE9\x95\xB6",
		"\xCF\xE3" => "\xE9\xA6\x99",
		"\xCF\xE4" => "\xE7\xAE\xB1",
		"\xCF\xE5" => "\xE8\xA5\x84",
		"\xCF\xE6" => "\xE6\xB9\x98",
		"\xCF\xE7" => "\xE4\xB9\xA1",
		"\xCF\xE8" => "\xE7\xBF\x94",
		"\xCF\xE9" => "\xE7\xA5\xA5",
		"\xCF\xEA" => "\xE8\xAF\xA6",
		"\xCF\xEB" => "\xE6\x83\xB3",
		"\xCF\xEC" => "\xE5\x93\x8D",
		"\xCF\xED" => "\xE4\xBA\xAB",
		"\xCF\xEE" => "\xE9\xA1\xB9",
		"\xCF\xEF" => "\xE5\xB7\xB7",
		"\xCF\xF0" => "\xE6\xA9\xA1",
		"\xCF\xF1" => "\xE5\x83\x8F",
		"\xCF\xF2" => "\xE5\x90\x91",
		"\xCF\xF3" => "\xE8\xB1\xA1",
		"\xCF\xF4" => "\xE8\x90\xA7",
		"\xCF\xF5" => "\xE7\xA1\x9D",
		"\xCF\xF6" => "\xE9\x9C\x84",
		"\xCF\xF7" => "\xE5\x89\x8A",
		"\xCF\xF8" => "\xE5\x93\xAE",
		"\xCF\xF9" => "\xE5\x9A\xA3",
		"\xCF\xFA" => "\xE9\x94\x80",
		"\xCF\xFB" => "\xE6\xB6\x88",
		"\xCF\xFC" => "\xE5\xAE\xB5",
		"\xCF\xFD" => "\xE6\xB7\x86",
		"\xCF\xFE" => "\xE6\x99\x93",
		"\xD0\xA1" => "\xE5\xB0\x8F",
		"\xD0\xA2" => "\xE5\xAD\x9D",
		"\xD0\xA3" => "\xE6\xA0\xA1",
		"\xD0\xA4" => "\xE8\x82\x96",
		"\xD0\xA5" => "\xE5\x95\xB8",
		"\xD0\xA6" => "\xE7\xAC\x91",
		"\xD0\xA7" => "\xE6\x95\x88",
		"\xD0\xA8" => "\xE6\xA5\x94",
		"\xD0\xA9" => "\xE4\xBA\x9B",
		"\xD0\xAA" => "\xE6\xAD\x87",
		"\xD0\xAB" => "\xE8\x9D\x8E",
		"\xD0\xAC" => "\xE9\x9E\x8B",
		"\xD0\xAD" => "\xE5\x8D\x8F",
		"\xD0\xAE" => "\xE6\x8C\x9F",
		"\xD0\xAF" => "\xE6\x90\xBA",
		"\xD0\xB0" => "\xE9\x82\xAA",
		"\xD0\xB1" => "\xE6\x96\x9C",
		"\xD0\xB2" => "\xE8\x83\x81",
		"\xD0\xB3" => "\xE8\xB0\x90",
		"\xD0\xB4" => "\xE5\x86\x99",
		"\xD0\xB5" => "\xE6\xA2\xB0",
		"\xD0\xB6" => "\xE5\x8D\xB8",
		"\xD0\xB7" => "\xE8\x9F\xB9",
		"\xD0\xB8" => "\xE6\x87\x88",
		"\xD0\xB9" => "\xE6\xB3\x84",
		"\xD0\xBA" => "\xE6\xB3\xBB",
		"\xD0\xBB" => "\xE8\xB0\xA2",
		"\xD0\xBC" => "\xE5\xB1\x91",
		"\xD0\xBD" => "\xE8\x96\xAA",
		"\xD0\xBE" => "\xE8\x8A\xAF",
		"\xD0\xBF" => "\xE9\x94\x8C",
		"\xD0\xC0" => "\xE6\xAC\xA3",
		"\xD0\xC1" => "\xE8\xBE\x9B",
		"\xD0\xC2" => "\xE6\x96\xB0",
		"\xD0\xC3" => "\xE5\xBF\xBB",
		"\xD0\xC4" => "\xE5\xBF\x83",
		"\xD0\xC5" => "\xE4\xBF\xA1",
		"\xD0\xC6" => "\xE8\xA1\x85",
		"\xD0\xC7" => "\xE6\x98\x9F",
		"\xD0\xC8" => "\xE8\x85\xA5",
		"\xD0\xC9" => "\xE7\x8C\xA9",
		"\xD0\xCA" => "\xE6\x83\xBA",
		"\xD0\xCB" => "\xE5\x85\xB4",
		"\xD0\xCC" => "\xE5\x88\x91",
		"\xD0\xCD" => "\xE5\x9E\x8B",
		"\xD0\xCE" => "\xE5\xBD\xA2",
		"\xD0\xCF" => "\xE9\x82\xA2",
		"\xD0\xD0" => "\xE8\xA1\x8C",
		"\xD0\xD1" => "\xE9\x86\x92",
		"\xD0\xD2" => "\xE5\xB9\xB8",
		"\xD0\xD3" => "\xE6\x9D\x8F",
		"\xD0\xD4" => "\xE6\x80\xA7",
		"\xD0\xD5" => "\xE5\xA7\x93",
		"\xD0\xD6" => "\xE5\x85\x84",
		"\xD0\xD7" => "\xE5\x87\xB6",
		"\xD0\xD8" => "\xE8\x83\xB8",
		"\xD0\xD9" => "\xE5\x8C\x88",
		"\xD0\xDA" => "\xE6\xB1\xB9",
		"\xD0\xDB" => "\xE9\x9B\x84",
		"\xD0\xDC" => "\xE7\x86\x8A",
		"\xD0\xDD" => "\xE4\xBC\x91",
		"\xD0\xDE" => "\xE4\xBF\xAE",
		"\xD0\xDF" => "\xE7\xBE\x9E",
		"\xD0\xE0" => "\xE6\x9C\xBD",
		"\xD0\xE1" => "\xE5\x97\x85",
		"\xD0\xE2" => "\xE9\x94\x88",
		"\xD0\xE3" => "\xE7\xA7\x80",
		"\xD0\xE4" => "\xE8\xA2\x96",
		"\xD0\xE5" => "\xE7\xBB\xA3",
		"\xD0\xE6" => "\xE5\xA2\x9F",
		"\xD0\xE7" => "\xE6\x88\x8C",
		"\xD0\xE8" => "\xE9\x9C\x80",
		"\xD0\xE9" => "\xE8\x99\x9A",
		"\xD0\xEA" => "\xE5\x98\x98",
		"\xD0\xEB" => "\xE9\xA1\xBB",
		"\xD0\xEC" => "\xE5\xBE\x90",
		"\xD0\xED" => "\xE8\xAE\xB8",
		"\xD0\xEE" => "\xE8\x93\x84",
		"\xD0\xEF" => "\xE9\x85\x97",
		"\xD0\xF0" => "\xE5\x8F\x99",
		"\xD0\xF1" => "\xE6\x97\xAD",
		"\xD0\xF2" => "\xE5\xBA\x8F",
		"\xD0\xF3" => "\xE7\x95\x9C",
		"\xD0\xF4" => "\xE6\x81\xA4",
		"\xD0\xF5" => "\xE7\xB5\xAE",
		"\xD0\xF6" => "\xE5\xA9\xBF",
		"\xD0\xF7" => "\xE7\xBB\xAA",
		"\xD0\xF8" => "\xE7\xBB\xAD",
		"\xD0\xF9" => "\xE8\xBD\xA9",
		"\xD0\xFA" => "\xE5\x96\xA7",
		"\xD0\xFB" => "\xE5\xAE\xA3",
		"\xD0\xFC" => "\xE6\x82\xAC",
		"\xD0\xFD" => "\xE6\x97\x8B",
		"\xD0\xFE" => "\xE7\x8E\x84",
		"\xD1\xA1" => "\xE9\x80\x89",
		"\xD1\xA2" => "\xE7\x99\xA3",
		"\xD1\xA3" => "\xE7\x9C\xA9",
		"\xD1\xA4" => "\xE7\xBB\x9A",
		"\xD1\xA5" => "\xE9\x9D\xB4",
		"\xD1\xA6" => "\xE8\x96\x9B",
		"\xD1\xA7" => "\xE5\xAD\xA6",
		"\xD1\xA8" => "\xE7\xA9\xB4",
		"\xD1\xA9" => "\xE9\x9B\xAA",
		"\xD1\xAA" => "\xE8\xA1\x80",
		"\xD1\xAB" => "\xE5\x8B\x8B",
		"\xD1\xAC" => "\xE7\x86\x8F",
		"\xD1\xAD" => "\xE5\xBE\xAA",
		"\xD1\xAE" => "\xE6\x97\xAC",
		"\xD1\xAF" => "\xE8\xAF\xA2",
		"\xD1\xB0" => "\xE5\xAF\xBB",
		"\xD1\xB1" => "\xE9\xA9\xAF",
		"\xD1\xB2" => "\xE5\xB7\xA1",
		"\xD1\xB3" => "\xE6\xAE\x89",
		"\xD1\xB4" => "\xE6\xB1\x9B",
		"\xD1\xB5" => "\xE8\xAE\xAD",
		"\xD1\xB6" => "\xE8\xAE\xAF",
		"\xD1\xB7" => "\xE9\x80\x8A",
		"\xD1\xB8" => "\xE8\xBF\x85",
		"\xD1\xB9" => "\xE5\x8E\x8B",
		"\xD1\xBA" => "\xE6\x8A\xBC",
		"\xD1\xBB" => "\xE9\xB8\xA6",
		"\xD1\xBC" => "\xE9\xB8\xAD",
		"\xD1\xBD" => "\xE5\x91\x80",
		"\xD1\xBE" => "\xE4\xB8\xAB",
		"\xD1\xBF" => "\xE8\x8A\xBD",
		"\xD1\xC0" => "\xE7\x89\x99",
		"\xD1\xC1" => "\xE8\x9A\x9C",
		"\xD1\xC2" => "\xE5\xB4\x96",
		"\xD1\xC3" => "\xE8\xA1\x99",
		"\xD1\xC4" => "\xE6\xB6\xAF",
		"\xD1\xC5" => "\xE9\x9B\x85",
		"\xD1\xC6" => "\xE5\x93\x91",
		"\xD1\xC7" => "\xE4\xBA\x9A",
		"\xD1\xC8" => "\xE8\xAE\xB6",
		"\xD1\xC9" => "\xE7\x84\x89",
		"\xD1\xCA" => "\xE5\x92\xBD",
		"\xD1\xCB" => "\xE9\x98\x89",
		"\xD1\xCC" => "\xE7\x83\x9F",
		"\xD1\xCD" => "\xE6\xB7\xB9",
		"\xD1\xCE" => "\xE7\x9B\x90",
		"\xD1\xCF" => "\xE4\xB8\xA5",
		"\xD1\xD0" => "\xE7\xA0\x94",
		"\xD1\xD1" => "\xE8\x9C\x92",
		"\xD1\xD2" => "\xE5\xB2\xA9",
		"\xD1\xD3" => "\xE5\xBB\xB6",
		"\xD1\xD4" => "\xE8\xA8\x80",
		"\xD1\xD5" => "\xE9\xA2\x9C",
		"\xD1\xD6" => "\xE9\x98\x8E",
		"\xD1\xD7" => "\xE7\x82\x8E",
		"\xD1\xD8" => "\xE6\xB2\xBF",
		"\xD1\xD9" => "\xE5\xA5\x84",
		"\xD1\xDA" => "\xE6\x8E\xA9",
		"\xD1\xDB" => "\xE7\x9C\xBC",
		"\xD1\xDC" => "\xE8\xA1\x8D",
		"\xD1\xDD" => "\xE6\xBC\x94",
		"\xD1\xDE" => "\xE8\x89\xB3",
		"\xD1\xDF" => "\xE5\xA0\xB0",
		"\xD1\xE0" => "\xE7\x87\x95",
		"\xD1\xE1" => "\xE5\x8E\x8C",
		"\xD1\xE2" => "\xE7\xA0\x9A",
		"\xD1\xE3" => "\xE9\x9B\x81",
		"\xD1\xE4" => "\xE5\x94\x81",
		"\xD1\xE5" => "\xE5\xBD\xA6",
		"\xD1\xE6" => "\xE7\x84\xB0",
		"\xD1\xE7" => "\xE5\xAE\xB4",
		"\xD1\xE8" => "\xE8\xB0\x9A",
		"\xD1\xE9" => "\xE9\xAA\x8C",
		"\xD1\xEA" => "\xE6\xAE\x83",
		"\xD1\xEB" => "\xE5\xA4\xAE",
		"\xD1\xEC" => "\xE9\xB8\xAF",
		"\xD1\xED" => "\xE7\xA7\xA7",
		"\xD1\xEE" => "\xE6\x9D\xA8",
		"\xD1\xEF" => "\xE6\x89\xAC",
		"\xD1\xF0" => "\xE4\xBD\xAF",
		"\xD1\xF1" => "\xE7\x96\xA1",
		"\xD1\xF2" => "\xE7\xBE\x8A",
		"\xD1\xF3" => "\xE6\xB4\x8B",
		"\xD1\xF4" => "\xE9\x98\xB3",
		"\xD1\xF5" => "\xE6\xB0\xA7",
		"\xD1\xF6" => "\xE4\xBB\xB0",
		"\xD1\xF7" => "\xE7\x97\x92",
		"\xD1\xF8" => "\xE5\x85\xBB",
		"\xD1\xF9" => "\xE6\xA0\xB7",
		"\xD1\xFA" => "\xE6\xBC\xBE",
		"\xD1\xFB" => "\xE9\x82\x80",
		"\xD1\xFC" => "\xE8\x85\xB0",
		"\xD1\xFD" => "\xE5\xA6\x96",
		"\xD1\xFE" => "\xE7\x91\xB6",
		"\xD2\xA1" => "\xE6\x91\x87",
		"\xD2\xA2" => "\xE5\xB0\xA7",
		"\xD2\xA3" => "\xE9\x81\xA5",
		"\xD2\xA4" => "\xE7\xAA\x91",
		"\xD2\xA5" => "\xE8\xB0\xA3",
		"\xD2\xA6" => "\xE5\xA7\x9A",
		"\xD2\xA7" => "\xE5\x92\xAC",
		"\xD2\xA8" => "\xE8\x88\x80",
		"\xD2\xA9" => "\xE8\x8D\xAF",
		"\xD2\xAA" => "\xE8\xA6\x81",
		"\xD2\xAB" => "\xE8\x80\x80",
		"\xD2\xAC" => "\xE6\xA4\xB0",
		"\xD2\xAD" => "\xE5\x99\x8E",
		"\xD2\xAE" => "\xE8\x80\xB6",
		"\xD2\xAF" => "\xE7\x88\xB7",
		"\xD2\xB0" => "\xE9\x87\x8E",
		"\xD2\xB1" => "\xE5\x86\xB6",
		"\xD2\xB2" => "\xE4\xB9\x9F",
		"\xD2\xB3" => "\xE9\xA1\xB5",
		"\xD2\xB4" => "\xE6\x8E\x96",
		"\xD2\xB5" => "\xE4\xB8\x9A",
		"\xD2\xB6" => "\xE5\x8F\xB6",
		"\xD2\xB7" => "\xE6\x9B\xB3",
		"\xD2\xB8" => "\xE8\x85\x8B",
		"\xD2\xB9" => "\xE5\xA4\x9C",
		"\xD2\xBA" => "\xE6\xB6\xB2",
		"\xD2\xBB" => "\xE4\xB8\x80",
		"\xD2\xBC" => "\xE5\xA3\xB9",
		"\xD2\xBD" => "\xE5\x8C\xBB",
		"\xD2\xBE" => "\xE6\x8F\x96",
		"\xD2\xBF" => "\xE9\x93\xB1",
		"\xD2\xC0" => "\xE4\xBE\x9D",
		"\xD2\xC1" => "\xE4\xBC\x8A",
		"\xD2\xC2" => "\xE8\xA1\xA3",
		"\xD2\xC3" => "\xE9\xA2\x90",
		"\xD2\xC4" => "\xE5\xA4\xB7",
		"\xD2\xC5" => "\xE9\x81\x97",
		"\xD2\xC6" => "\xE7\xA7\xBB",
		"\xD2\xC7" => "\xE4\xBB\xAA",
		"\xD2\xC8" => "\xE8\x83\xB0",
		"\xD2\xC9" => "\xE7\x96\x91",
		"\xD2\xCA" => "\xE6\xB2\x82",
		"\xD2\xCB" => "\xE5\xAE\x9C",
		"\xD2\xCC" => "\xE5\xA7\xA8",
		"\xD2\xCD" => "\xE5\xBD\x9D",
		"\xD2\xCE" => "\xE6\xA4\x85",
		"\xD2\xCF" => "\xE8\x9A\x81",
		"\xD2\xD0" => "\xE5\x80\x9A",
		"\xD2\xD1" => "\xE5\xB7\xB2",
		"\xD2\xD2" => "\xE4\xB9\x99",
		"\xD2\xD3" => "\xE7\x9F\xA3",
		"\xD2\xD4" => "\xE4\xBB\xA5",
		"\xD2\xD5" => "\xE8\x89\xBA",
		"\xD2\xD6" => "\xE6\x8A\x91",
		"\xD2\xD7" => "\xE6\x98\x93",
		"\xD2\xD8" => "\xE9\x82\x91",
		"\xD2\xD9" => "\xE5\xB1\xB9",
		"\xD2\xDA" => "\xE4\xBA\xBF",
		"\xD2\xDB" => "\xE5\xBD\xB9",
		"\xD2\xDC" => "\xE8\x87\x86",
		"\xD2\xDD" => "\xE9\x80\xB8",
		"\xD2\xDE" => "\xE8\x82\x84",
		"\xD2\xDF" => "\xE7\x96\xAB",
		"\xD2\xE0" => "\xE4\xBA\xA6",
		"\xD2\xE1" => "\xE8\xA3\x94",
		"\xD2\xE2" => "\xE6\x84\x8F",
		"\xD2\xE3" => "\xE6\xAF\x85",
		"\xD2\xE4" => "\xE5\xBF\x86",
		"\xD2\xE5" => "\xE4\xB9\x89",
		"\xD2\xE6" => "\xE7\x9B\x8A",
		"\xD2\xE7" => "\xE6\xBA\xA2",
		"\xD2\xE8" => "\xE8\xAF\xA3",
		"\xD2\xE9" => "\xE8\xAE\xAE",
		"\xD2\xEA" => "\xE8\xB0\x8A",
		"\xD2\xEB" => "\xE8\xAF\x91",
		"\xD2\xEC" => "\xE5\xBC\x82",
		"\xD2\xED" => "\xE7\xBF\xBC",
		"\xD2\xEE" => "\xE7\xBF\x8C",
		"\xD2\xEF" => "\xE7\xBB\x8E",
		"\xD2\xF0" => "\xE8\x8C\xB5",
		"\xD2\xF1" => "\xE8\x8D\xAB",
		"\xD2\xF2" => "\xE5\x9B\xA0",
		"\xD2\xF3" => "\xE6\xAE\xB7",
		"\xD2\xF4" => "\xE9\x9F\xB3",
		"\xD2\xF5" => "\xE9\x98\xB4",
		"\xD2\xF6" => "\xE5\xA7\xBB",
		"\xD2\xF7" => "\xE5\x90\x9F",
		"\xD2\xF8" => "\xE9\x93\xB6",
		"\xD2\xF9" => "\xE6\xB7\xAB",
		"\xD2\xFA" => "\xE5\xAF\x85",
		"\xD2\xFB" => "\xE9\xA5\xAE",
		"\xD2\xFC" => "\xE5\xB0\xB9",
		"\xD2\xFD" => "\xE5\xBC\x95",
		"\xD2\xFE" => "\xE9\x9A\x90",
		"\xD3\xA1" => "\xE5\x8D\xB0",
		"\xD3\xA2" => "\xE8\x8B\xB1",
		"\xD3\xA3" => "\xE6\xA8\xB1",
		"\xD3\xA4" => "\xE5\xA9\xB4",
		"\xD3\xA5" => "\xE9\xB9\xB0",
		"\xD3\xA6" => "\xE5\xBA\x94",
		"\xD3\xA7" => "\xE7\xBC\xA8",
		"\xD3\xA8" => "\xE8\x8E\xB9",
		"\xD3\xA9" => "\xE8\x90\xA4",
		"\xD3\xAA" => "\xE8\x90\xA5",
		"\xD3\xAB" => "\xE8\x8D\xA7",
		"\xD3\xAC" => "\xE8\x9D\x87",
		"\xD3\xAD" => "\xE8\xBF\x8E",
		"\xD3\xAE" => "\xE8\xB5\xA2",
		"\xD3\xAF" => "\xE7\x9B\x88",
		"\xD3\xB0" => "\xE5\xBD\xB1",
		"\xD3\xB1" => "\xE9\xA2\x96",
		"\xD3\xB2" => "\xE7\xA1\xAC",
		"\xD3\xB3" => "\xE6\x98\xA0",
		"\xD3\xB4" => "\xE5\x93\x9F",
		"\xD3\xB5" => "\xE6\x8B\xA5",
		"\xD3\xB6" => "\xE4\xBD\xA3",
		"\xD3\xB7" => "\xE8\x87\x83",
		"\xD3\xB8" => "\xE7\x97\x88",
		"\xD3\xB9" => "\xE5\xBA\xB8",
		"\xD3\xBA" => "\xE9\x9B\x8D",
		"\xD3\xBB" => "\xE8\xB8\x8A",
		"\xD3\xBC" => "\xE8\x9B\xB9",
		"\xD3\xBD" => "\xE5\x92\x8F",
		"\xD3\xBE" => "\xE6\xB3\xB3",
		"\xD3\xBF" => "\xE6\xB6\x8C",
		"\xD3\xC0" => "\xE6\xB0\xB8",
		"\xD3\xC1" => "\xE6\x81\xBF",
		"\xD3\xC2" => "\xE5\x8B\x87",
		"\xD3\xC3" => "\xE7\x94\xA8",
		"\xD3\xC4" => "\xE5\xB9\xBD",
		"\xD3\xC5" => "\xE4\xBC\x98",
		"\xD3\xC6" => "\xE6\x82\xA0",
		"\xD3\xC7" => "\xE5\xBF\xA7",
		"\xD3\xC8" => "\xE5\xB0\xA4",
		"\xD3\xC9" => "\xE7\x94\xB1",
		"\xD3\xCA" => "\xE9\x82\xAE",
		"\xD3\xCB" => "\xE9\x93\x80",
		"\xD3\xCC" => "\xE7\x8A\xB9",
		"\xD3\xCD" => "\xE6\xB2\xB9",
		"\xD3\xCE" => "\xE6\xB8\xB8",
		"\xD3\xCF" => "\xE9\x85\x89",
		"\xD3\xD0" => "\xE6\x9C\x89",
		"\xD3\xD1" => "\xE5\x8F\x8B",
		"\xD3\xD2" => "\xE5\x8F\xB3",
		"\xD3\xD3" => "\xE4\xBD\x91",
		"\xD3\xD4" => "\xE9\x87\x89",
		"\xD3\xD5" => "\xE8\xAF\xB1",
		"\xD3\xD6" => "\xE5\x8F\x88",
		"\xD3\xD7" => "\xE5\xB9\xBC",
		"\xD3\xD8" => "\xE8\xBF\x82",
		"\xD3\xD9" => "\xE6\xB7\xA4",
		"\xD3\xDA" => "\xE4\xBA\x8E",
		"\xD3\xDB" => "\xE7\x9B\x82",
		"\xD3\xDC" => "\xE6\xA6\x86",
		"\xD3\xDD" => "\xE8\x99\x9E",
		"\xD3\xDE" => "\xE6\x84\x9A",
		"\xD3\xDF" => "\xE8\x88\x86",
		"\xD3\xE0" => "\xE4\xBD\x99",
		"\xD3\xE1" => "\xE4\xBF\x9E",
		"\xD3\xE2" => "\xE9\x80\xBE",
		"\xD3\xE3" => "\xE9\xB1\xBC",
		"\xD3\xE4" => "\xE6\x84\x89",
		"\xD3\xE5" => "\xE6\xB8\x9D",
		"\xD3\xE6" => "\xE6\xB8\x94",
		"\xD3\xE7" => "\xE9\x9A\x85",
		"\xD3\xE8" => "\xE4\xBA\x88",
		"\xD3\xE9" => "\xE5\xA8\xB1",
		"\xD3\xEA" => "\xE9\x9B\xA8",
		"\xD3\xEB" => "\xE4\xB8\x8E",
		"\xD3\xEC" => "\xE5\xB1\xBF",
		"\xD3\xED" => "\xE7\xA6\xB9",
		"\xD3\xEE" => "\xE5\xAE\x87",
		"\xD3\xEF" => "\xE8\xAF\xAD",
		"\xD3\xF0" => "\xE7\xBE\xBD",
		"\xD3\xF1" => "\xE7\x8E\x89",
		"\xD3\xF2" => "\xE5\x9F\x9F",
		"\xD3\xF3" => "\xE8\x8A\x8B",
		"\xD3\xF4" => "\xE9\x83\x81",
		"\xD3\xF5" => "\xE5\x90\x81",
		"\xD3\xF6" => "\xE9\x81\x87",
		"\xD3\xF7" => "\xE5\x96\xBB",
		"\xD3\xF8" => "\xE5\xB3\xAA",
		"\xD3\xF9" => "\xE5\xBE\xA1",
		"\xD3\xFA" => "\xE6\x84\x88",
		"\xD3\xFB" => "\xE6\xAC\xB2",
		"\xD3\xFC" => "\xE7\x8B\xB1",
		"\xD3\xFD" => "\xE8\x82\xB2",
		"\xD3\xFE" => "\xE8\xAA\x89",
		"\xD4\xA1" => "\xE6\xB5\xB4",
		"\xD4\xA2" => "\xE5\xAF\x93",
		"\xD4\xA3" => "\xE8\xA3\x95",
		"\xD4\xA4" => "\xE9\xA2\x84",
		"\xD4\xA5" => "\xE8\xB1\xAB",
		"\xD4\xA6" => "\xE9\xA9\xAD",
		"\xD4\xA7" => "\xE9\xB8\xB3",
		"\xD4\xA8" => "\xE6\xB8\x8A",
		"\xD4\xA9" => "\xE5\x86\xA4",
		"\xD4\xAA" => "\xE5\x85\x83",
		"\xD4\xAB" => "\xE5\x9E\xA3",
		"\xD4\xAC" => "\xE8\xA2\x81",
		"\xD4\xAD" => "\xE5\x8E\x9F",
		"\xD4\xAE" => "\xE6\x8F\xB4",
		"\xD4\xAF" => "\xE8\xBE\x95",
		"\xD4\xB0" => "\xE5\x9B\xAD",
		"\xD4\xB1" => "\xE5\x91\x98",
		"\xD4\xB2" => "\xE5\x9C\x86",
		"\xD4\xB3" => "\xE7\x8C\xBF",
		"\xD4\xB4" => "\xE6\xBA\x90",
		"\xD4\xB5" => "\xE7\xBC\x98",
		"\xD4\xB6" => "\xE8\xBF\x9C",
		"\xD4\xB7" => "\xE8\x8B\x91",
		"\xD4\xB8" => "\xE6\x84\xBF",
		"\xD4\xB9" => "\xE6\x80\xA8",
		"\xD4\xBA" => "\xE9\x99\xA2",
		"\xD4\xBB" => "\xE6\x9B\xB0",
		"\xD4\xBC" => "\xE7\xBA\xA6",
		"\xD4\xBD" => "\xE8\xB6\x8A",
		"\xD4\xBE" => "\xE8\xB7\x83",
		"\xD4\xBF" => "\xE9\x92\xA5",
		"\xD4\xC0" => "\xE5\xB2\xB3",
		"\xD4\xC1" => "\xE7\xB2\xA4",
		"\xD4\xC2" => "\xE6\x9C\x88",
		"\xD4\xC3" => "\xE6\x82\xA6",
		"\xD4\xC4" => "\xE9\x98\x85",
		"\xD4\xC5" => "\xE8\x80\x98",
		"\xD4\xC6" => "\xE4\xBA\x91",
		"\xD4\xC7" => "\xE9\x83\xA7",
		"\xD4\xC8" => "\xE5\x8C\x80",
		"\xD4\xC9" => "\xE9\x99\xA8",
		"\xD4\xCA" => "\xE5\x85\x81",
		"\xD4\xCB" => "\xE8\xBF\x90",
		"\xD4\xCC" => "\xE8\x95\xB4",
		"\xD4\xCD" => "\xE9\x85\x9D",
		"\xD4\xCE" => "\xE6\x99\x95",
		"\xD4\xCF" => "\xE9\x9F\xB5",
		"\xD4\xD0" => "\xE5\xAD\x95",
		"\xD4\xD1" => "\xE5\x8C\x9D",
		"\xD4\xD2" => "\xE7\xA0\xB8",
		"\xD4\xD3" => "\xE6\x9D\x82",
		"\xD4\xD4" => "\xE6\xA0\xBD",
		"\xD4\xD5" => "\xE5\x93\x89",
		"\xD4\xD6" => "\xE7\x81\xBE",
		"\xD4\xD7" => "\xE5\xAE\xB0",
		"\xD4\xD8" => "\xE8\xBD\xBD",
		"\xD4\xD9" => "\xE5\x86\x8D",
		"\xD4\xDA" => "\xE5\x9C\xA8",
		"\xD4\xDB" => "\xE5\x92\xB1",
		"\xD4\xDC" => "\xE6\x94\x92",
		"\xD4\xDD" => "\xE6\x9A\x82",
		"\xD4\xDE" => "\xE8\xB5\x9E",
		"\xD4\xDF" => "\xE8\xB5\x83",
		"\xD4\xE0" => "\xE8\x84\x8F",
		"\xD4\xE1" => "\xE8\x91\xAC",
		"\xD4\xE2" => "\xE9\x81\xAD",
		"\xD4\xE3" => "\xE7\xB3\x9F",
		"\xD4\xE4" => "\xE5\x87\xBF",
		"\xD4\xE5" => "\xE8\x97\xBB",
		"\xD4\xE6" => "\xE6\x9E\xA3",
		"\xD4\xE7" => "\xE6\x97\xA9",
		"\xD4\xE8" => "\xE6\xBE\xA1",
		"\xD4\xE9" => "\xE8\x9A\xA4",
		"\xD4\xEA" => "\xE8\xBA\x81",
		"\xD4\xEB" => "\xE5\x99\xAA",
		"\xD4\xEC" => "\xE9\x80\xA0",
		"\xD4\xED" => "\xE7\x9A\x82",
		"\xD4\xEE" => "\xE7\x81\xB6",
		"\xD4\xEF" => "\xE7\x87\xA5",
		"\xD4\xF0" => "\xE8\xB4\xA3",
		"\xD4\xF1" => "\xE6\x8B\xA9",
		"\xD4\xF2" => "\xE5\x88\x99",
		"\xD4\xF3" => "\xE6\xB3\xBD",
		"\xD4\xF4" => "\xE8\xB4\xBC",
		"\xD4\xF5" => "\xE6\x80\x8E",
		"\xD4\xF6" => "\xE5\xA2\x9E",
		"\xD4\xF7" => "\xE6\x86\x8E",
		"\xD4\xF8" => "\xE6\x9B\xBE",
		"\xD4\xF9" => "\xE8\xB5\xA0",
		"\xD4\xFA" => "\xE6\x89\x8E",
		"\xD4\xFB" => "\xE5\x96\xB3",
		"\xD4\xFC" => "\xE6\xB8\xA3",
		"\xD4\xFD" => "\xE6\x9C\xAD",
		"\xD4\xFE" => "\xE8\xBD\xA7",
		"\xD5\xA1" => "\xE9\x93\xA1",
		"\xD5\xA2" => "\xE9\x97\xB8",
		"\xD5\xA3" => "\xE7\x9C\xA8",
		"\xD5\xA4" => "\xE6\xA0\x85",
		"\xD5\xA5" => "\xE6\xA6\xA8",
		"\xD5\xA6" => "\xE5\x92\x8B",
		"\xD5\xA7" => "\xE4\xB9\x8D",
		"\xD5\xA8" => "\xE7\x82\xB8",
		"\xD5\xA9" => "\xE8\xAF\x88",
		"\xD5\xAA" => "\xE6\x91\x98",
		"\xD5\xAB" => "\xE6\x96\x8B",
		"\xD5\xAC" => "\xE5\xAE\x85",
		"\xD5\xAD" => "\xE7\xAA\x84",
		"\xD5\xAE" => "\xE5\x80\xBA",
		"\xD5\xAF" => "\xE5\xAF\xA8",
		"\xD5\xB0" => "\xE7\x9E\xBB",
		"\xD5\xB1" => "\xE6\xAF\xA1",
		"\xD5\xB2" => "\xE8\xA9\xB9",
		"\xD5\xB3" => "\xE7\xB2\x98",
		"\xD5\xB4" => "\xE6\xB2\xBE",
		"\xD5\xB5" => "\xE7\x9B\x8F",
		"\xD5\xB6" => "\xE6\x96\xA9",
		"\xD5\xB7" => "\xE8\xBE\x97",
		"\xD5\xB8" => "\xE5\xB4\xAD",
		"\xD5\xB9" => "\xE5\xB1\x95",
		"\xD5\xBA" => "\xE8\x98\xB8",
		"\xD5\xBB" => "\xE6\xA0\x88",
		"\xD5\xBC" => "\xE5\x8D\xA0",
		"\xD5\xBD" => "\xE6\x88\x98",
		"\xD5\xBE" => "\xE7\xAB\x99",
		"\xD5\xBF" => "\xE6\xB9\x9B",
		"\xD5\xC0" => "\xE7\xBB\xBD",
		"\xD5\xC1" => "\xE6\xA8\x9F",
		"\xD5\xC2" => "\xE7\xAB\xA0",
		"\xD5\xC3" => "\xE5\xBD\xB0",
		"\xD5\xC4" => "\xE6\xBC\xB3",
		"\xD5\xC5" => "\xE5\xBC\xA0",
		"\xD5\xC6" => "\xE6\x8E\x8C",
		"\xD5\xC7" => "\xE6\xB6\xA8",
		"\xD5\xC8" => "\xE6\x9D\x96",
		"\xD5\xC9" => "\xE4\xB8\x88",
		"\xD5\xCA" => "\xE5\xB8\x90",
		"\xD5\xCB" => "\xE8\xB4\xA6",
		"\xD5\xCC" => "\xE4\xBB\x97",
		"\xD5\xCD" => "\xE8\x83\x80",
		"\xD5\xCE" => "\xE7\x98\xB4",
		"\xD5\xCF" => "\xE9\x9A\x9C",
		"\xD5\xD0" => "\xE6\x8B\x9B",
		"\xD5\xD1" => "\xE6\x98\xAD",
		"\xD5\xD2" => "\xE6\x89\xBE",
		"\xD5\xD3" => "\xE6\xB2\xBC",
		"\xD5\xD4" => "\xE8\xB5\xB5",
		"\xD5\xD5" => "\xE7\x85\xA7",
		"\xD5\xD6" => "\xE7\xBD\xA9",
		"\xD5\xD7" => "\xE5\x85\x86",
		"\xD5\xD8" => "\xE8\x82\x87",
		"\xD5\xD9" => "\xE5\x8F\xAC",
		"\xD5\xDA" => "\xE9\x81\xAE",
		"\xD5\xDB" => "\xE6\x8A\x98",
		"\xD5\xDC" => "\xE5\x93\xB2",
		"\xD5\xDD" => "\xE8\x9B\xB0",
		"\xD5\xDE" => "\xE8\xBE\x99",
		"\xD5\xDF" => "\xE8\x80\x85",
		"\xD5\xE0" => "\xE9\x94\x97",
		"\xD5\xE1" => "\xE8\x94\x97",
		"\xD5\xE2" => "\xE8\xBF\x99",
		"\xD5\xE3" => "\xE6\xB5\x99",
		"\xD5\xE4" => "\xE7\x8F\x8D",
		"\xD5\xE5" => "\xE6\x96\x9F",
		"\xD5\xE6" => "\xE7\x9C\x9F",
		"\xD5\xE7" => "\xE7\x94\x84",
		"\xD5\xE8" => "\xE7\xA0\xA7",
		"\xD5\xE9" => "\xE8\x87\xBB",
		"\xD5\xEA" => "\xE8\xB4\x9E",
		"\xD5\xEB" => "\xE9\x92\x88",
		"\xD5\xEC" => "\xE4\xBE\xA6",
		"\xD5\xED" => "\xE6\x9E\x95",
		"\xD5\xEE" => "\xE7\x96\xB9",
		"\xD5\xEF" => "\xE8\xAF\x8A",
		"\xD5\xF0" => "\xE9\x9C\x87",
		"\xD5\xF1" => "\xE6\x8C\xAF",
		"\xD5\xF2" => "\xE9\x95\x87",
		"\xD5\xF3" => "\xE9\x98\xB5",
		"\xD5\xF4" => "\xE8\x92\xB8",
		"\xD5\xF5" => "\xE6\x8C\xA3",
		"\xD5\xF6" => "\xE7\x9D\x81",
		"\xD5\xF7" => "\xE5\xBE\x81",
		"\xD5\xF8" => "\xE7\x8B\xB0",
		"\xD5\xF9" => "\xE4\xBA\x89",
		"\xD5\xFA" => "\xE6\x80\x94",
		"\xD5\xFB" => "\xE6\x95\xB4",
		"\xD5\xFC" => "\xE6\x8B\xAF",
		"\xD5\xFD" => "\xE6\xAD\xA3",
		"\xD5\xFE" => "\xE6\x94\xBF",
		"\xD6\xA1" => "\xE5\xB8\xA7",
		"\xD6\xA2" => "\xE7\x97\x87",
		"\xD6\xA3" => "\xE9\x83\x91",
		"\xD6\xA4" => "\xE8\xAF\x81",
		"\xD6\xA5" => "\xE8\x8A\x9D",
		"\xD6\xA6" => "\xE6\x9E\x9D",
		"\xD6\xA7" => "\xE6\x94\xAF",
		"\xD6\xA8" => "\xE5\x90\xB1",
		"\xD6\xA9" => "\xE8\x9C\x98",
		"\xD6\xAA" => "\xE7\x9F\xA5",
		"\xD6\xAB" => "\xE8\x82\xA2",
		"\xD6\xAC" => "\xE8\x84\x82",
		"\xD6\xAD" => "\xE6\xB1\x81",
		"\xD6\xAE" => "\xE4\xB9\x8B",
		"\xD6\xAF" => "\xE7\xBB\x87",
		"\xD6\xB0" => "\xE8\x81\x8C",
		"\xD6\xB1" => "\xE7\x9B\xB4",
		"\xD6\xB2" => "\xE6\xA4\x8D",
		"\xD6\xB3" => "\xE6\xAE\x96",
		"\xD6\xB4" => "\xE6\x89\xA7",
		"\xD6\xB5" => "\xE5\x80\xBC",
		"\xD6\xB6" => "\xE4\xBE\x84",
		"\xD6\xB7" => "\xE5\x9D\x80",
		"\xD6\xB8" => "\xE6\x8C\x87",
		"\xD6\xB9" => "\xE6\xAD\xA2",
		"\xD6\xBA" => "\xE8\xB6\xBE",
		"\xD6\xBB" => "\xE5\x8F\xAA",
		"\xD6\xBC" => "\xE6\x97\xA8",
		"\xD6\xBD" => "\xE7\xBA\xB8",
		"\xD6\xBE" => "\xE5\xBF\x97",
		"\xD6\xBF" => "\xE6\x8C\x9A",
		"\xD6\xC0" => "\xE6\x8E\xB7",
		"\xD6\xC1" => "\xE8\x87\xB3",
		"\xD6\xC2" => "\xE8\x87\xB4",
		"\xD6\xC3" => "\xE7\xBD\xAE",
		"\xD6\xC4" => "\xE5\xB8\x9C",
		"\xD6\xC5" => "\xE5\xB3\x99",
		"\xD6\xC6" => "\xE5\x88\xB6",
		"\xD6\xC7" => "\xE6\x99\xBA",
		"\xD6\xC8" => "\xE7\xA7\xA9",
		"\xD6\xC9" => "\xE7\xA8\x9A",
		"\xD6\xCA" => "\xE8\xB4\xA8",
		"\xD6\xCB" => "\xE7\x82\x99",
		"\xD6\xCC" => "\xE7\x97\x94",
		"\xD6\xCD" => "\xE6\xBB\x9E",
		"\xD6\xCE" => "\xE6\xB2\xBB",
		"\xD6\xCF" => "\xE7\xAA\x92",
		"\xD6\xD0" => "\xE4\xB8\xAD",
		"\xD6\xD1" => "\xE7\x9B\x85",
		"\xD6\xD2" => "\xE5\xBF\xA0",
		"\xD6\xD3" => "\xE9\x92\x9F",
		"\xD6\xD4" => "\xE8\xA1\xB7",
		"\xD6\xD5" => "\xE7\xBB\x88",
		"\xD6\xD6" => "\xE7\xA7\x8D",
		"\xD6\xD7" => "\xE8\x82\xBF",
		"\xD6\xD8" => "\xE9\x87\x8D",
		"\xD6\xD9" => "\xE4\xBB\xB2",
		"\xD6\xDA" => "\xE4\xBC\x97",
		"\xD6\xDB" => "\xE8\x88\x9F",
		"\xD6\xDC" => "\xE5\x91\xA8",
		"\xD6\xDD" => "\xE5\xB7\x9E",
		"\xD6\xDE" => "\xE6\xB4\xB2",
		"\xD6\xDF" => "\xE8\xAF\x8C",
		"\xD6\xE0" => "\xE7\xB2\xA5",
		"\xD6\xE1" => "\xE8\xBD\xB4",
		"\xD6\xE2" => "\xE8\x82\x98",
		"\xD6\xE3" => "\xE5\xB8\x9A",
		"\xD6\xE4" => "\xE5\x92\x92",
		"\xD6\xE5" => "\xE7\x9A\xB1",
		"\xD6\xE6" => "\xE5\xAE\x99",
		"\xD6\xE7" => "\xE6\x98\xBC",
		"\xD6\xE8" => "\xE9\xAA\xA4",
		"\xD6\xE9" => "\xE7\x8F\xA0",
		"\xD6\xEA" => "\xE6\xA0\xAA",
		"\xD6\xEB" => "\xE8\x9B\x9B",
		"\xD6\xEC" => "\xE6\x9C\xB1",
		"\xD6\xED" => "\xE7\x8C\xAA",
		"\xD6\xEE" => "\xE8\xAF\xB8",
		"\xD6\xEF" => "\xE8\xAF\x9B",
		"\xD6\xF0" => "\xE9\x80\x90",
		"\xD6\xF1" => "\xE7\xAB\xB9",
		"\xD6\xF2" => "\xE7\x83\x9B",
		"\xD6\xF3" => "\xE7\x85\xAE",
		"\xD6\xF4" => "\xE6\x8B\x84",
		"\xD6\xF5" => "\xE7\x9E\xA9",
		"\xD6\xF6" => "\xE5\x98\xB1",
		"\xD6\xF7" => "\xE4\xB8\xBB",
		"\xD6\xF8" => "\xE8\x91\x97",
		"\xD6\xF9" => "\xE6\x9F\xB1",
		"\xD6\xFA" => "\xE5\x8A\xA9",
		"\xD6\xFB" => "\xE8\x9B\x80",
		"\xD6\xFC" => "\xE8\xB4\xAE",
		"\xD6\xFD" => "\xE9\x93\xB8",
		"\xD6\xFE" => "\xE7\xAD\x91",
		"\xD7\xA1" => "\xE4\xBD\x8F",
		"\xD7\xA2" => "\xE6\xB3\xA8",
		"\xD7\xA3" => "\xE7\xA5\x9D",
		"\xD7\xA4" => "\xE9\xA9\xBB",
		"\xD7\xA5" => "\xE6\x8A\x93",
		"\xD7\xA6" => "\xE7\x88\xAA",
		"\xD7\xA7" => "\xE6\x8B\xBD",
		"\xD7\xA8" => "\xE4\xB8\x93",
		"\xD7\xA9" => "\xE7\xA0\x96",
		"\xD7\xAA" => "\xE8\xBD\xAC",
		"\xD7\xAB" => "\xE6\x92\xB0",
		"\xD7\xAC" => "\xE8\xB5\x9A",
		"\xD7\xAD" => "\xE7\xAF\x86",
		"\xD7\xAE" => "\xE6\xA1\xA9",
		"\xD7\xAF" => "\xE5\xBA\x84",
		"\xD7\xB0" => "\xE8\xA3\x85",
		"\xD7\xB1" => "\xE5\xA6\x86",
		"\xD7\xB2" => "\xE6\x92\x9E",
		"\xD7\xB3" => "\xE5\xA3\xAE",
		"\xD7\xB4" => "\xE7\x8A\xB6",
		"\xD7\xB5" => "\xE6\xA4\x8E",
		"\xD7\xB6" => "\xE9\x94\xA5",
		"\xD7\xB7" => "\xE8\xBF\xBD",
		"\xD7\xB8" => "\xE8\xB5\x98",
		"\xD7\xB9" => "\xE5\x9D\xA0",
		"\xD7\xBA" => "\xE7\xBC\x80",
		"\xD7\xBB" => "\xE8\xB0\x86",
		"\xD7\xBC" => "\xE5\x87\x86",
		"\xD7\xBD" => "\xE6\x8D\x89",
		"\xD7\xBE" => "\xE6\x8B\x99",
		"\xD7\xBF" => "\xE5\x8D\x93",
		"\xD7\xC0" => "\xE6\xA1\x8C",
		"\xD7\xC1" => "\xE7\x90\xA2",
		"\xD7\xC2" => "\xE8\x8C\x81",
		"\xD7\xC3" => "\xE9\x85\x8C",
		"\xD7\xC4" => "\xE5\x95\x84",
		"\xD7\xC5" => "\xE7\x9D\x80",
		"\xD7\xC6" => "\xE7\x81\xBC",
		"\xD7\xC7" => "\xE6\xB5\x8A",
		"\xD7\xC8" => "\xE5\x85\xB9",
		"\xD7\xC9" => "\xE5\x92\xA8",
		"\xD7\xCA" => "\xE8\xB5\x84",
		"\xD7\xCB" => "\xE5\xA7\xBF",
		"\xD7\xCC" => "\xE6\xBB\x8B",
		"\xD7\xCD" => "\xE6\xB7\x84",
		"\xD7\xCE" => "\xE5\xAD\x9C",
		"\xD7\xCF" => "\xE7\xB4\xAB",
		"\xD7\xD0" => "\xE4\xBB\x94",
		"\xD7\xD1" => "\xE7\xB1\xBD",
		"\xD7\xD2" => "\xE6\xBB\x93",
		"\xD7\xD3" => "\xE5\xAD\x90",
		"\xD7\xD4" => "\xE8\x87\xAA",
		"\xD7\xD5" => "\xE6\xB8\x8D",
		"\xD7\xD6" => "\xE5\xAD\x97",
		"\xD7\xD7" => "\xE9\xAC\x83",
		"\xD7\xD8" => "\xE6\xA3\x95",
		"\xD7\xD9" => "\xE8\xB8\xAA",
		"\xD7\xDA" => "\xE5\xAE\x97",
		"\xD7\xDB" => "\xE7\xBB\xBC",
		"\xD7\xDC" => "\xE6\x80\xBB",
		"\xD7\xDD" => "\xE7\xBA\xB5",
		"\xD7\xDE" => "\xE9\x82\xB9",
		"\xD7\xDF" => "\xE8\xB5\xB0",
		"\xD7\xE0" => "\xE5\xA5\x8F",
		"\xD7\xE1" => "\xE6\x8F\x8D",
		"\xD7\xE2" => "\xE7\xA7\x9F",
		"\xD7\xE3" => "\xE8\xB6\xB3",
		"\xD7\xE4" => "\xE5\x8D\x92",
		"\xD7\xE5" => "\xE6\x97\x8F",
		"\xD7\xE6" => "\xE7\xA5\x96",
		"\xD7\xE7" => "\xE8\xAF\x85",
		"\xD7\xE8" => "\xE9\x98\xBB",
		"\xD7\xE9" => "\xE7\xBB\x84",
		"\xD7\xEA" => "\xE9\x92\xBB",
		"\xD7\xEB" => "\xE7\xBA\x82",
		"\xD7\xEC" => "\xE5\x98\xB4",
		"\xD7\xED" => "\xE9\x86\x89",
		"\xD7\xEE" => "\xE6\x9C\x80",
		"\xD7\xEF" => "\xE7\xBD\xAA",
		"\xD7\xF0" => "\xE5\xB0\x8A",
		"\xD7\xF1" => "\xE9\x81\xB5",
		"\xD7\xF2" => "\xE6\x98\xA8",
		"\xD7\xF3" => "\xE5\xB7\xA6",
		"\xD7\xF4" => "\xE4\xBD\x90",
		"\xD7\xF5" => "\xE6\x9F\x9E",
		"\xD7\xF6" => "\xE5\x81\x9A",
		"\xD7\xF7" => "\xE4\xBD\x9C",
		"\xD7\xF8" => "\xE5\x9D\x90",
		"\xD7\xF9" => "\xE5\xBA\xA7",
		"\xD8\xA1" => "\xE4\xBA\x8D",
		"\xD8\xA2" => "\xE4\xB8\x8C",
		"\xD8\xA3" => "\xE5\x85\x80",
		"\xD8\xA4" => "\xE4\xB8\x90",
		"\xD8\xA5" => "\xE5\xBB\xBF",
		"\xD8\xA6" => "\xE5\x8D\x85",
		"\xD8\xA7" => "\xE4\xB8\x95",
		"\xD8\xA8" => "\xE4\xBA\x98",
		"\xD8\xA9" => "\xE4\xB8\x9E",
		"\xD8\xAA" => "\xE9\xAC\xB2",
		"\xD8\xAB" => "\xE5\xAD\xAC",
		"\xD8\xAC" => "\xE5\x99\xA9",
		"\xD8\xAD" => "\xE4\xB8\xA8",
		"\xD8\xAE" => "\xE7\xA6\xBA",
		"\xD8\xAF" => "\xE4\xB8\xBF",
		"\xD8\xB0" => "\xE5\x8C\x95",
		"\xD8\xB1" => "\xE4\xB9\x87",
		"\xD8\xB2" => "\xE5\xA4\xAD",
		"\xD8\xB3" => "\xE7\x88\xBB",
		"\xD8\xB4" => "\xE5\x8D\xAE",
		"\xD8\xB5" => "\xE6\xB0\x90",
		"\xD8\xB6" => "\xE5\x9B\x9F",
		"\xD8\xB7" => "\xE8\x83\xA4",
		"\xD8\xB8" => "\xE9\xA6\x97",
		"\xD8\xB9" => "\xE6\xAF\x93",
		"\xD8\xBA" => "\xE7\x9D\xBE",
		"\xD8\xBB" => "\xE9\xBC\x97",
		"\xD8\xBC" => "\xE4\xB8\xB6",
		"\xD8\xBD" => "\xE4\xBA\x9F",
		"\xD8\xBE" => "\xE9\xBC\x90",
		"\xD8\xBF" => "\xE4\xB9\x9C",
		"\xD8\xC0" => "\xE4\xB9\xA9",
		"\xD8\xC1" => "\xE4\xBA\x93",
		"\xD8\xC2" => "\xE8\x8A\x88",
		"\xD8\xC3" => "\xE5\xAD\x9B",
		"\xD8\xC4" => "\xE5\x95\xAC",
		"\xD8\xC5" => "\xE5\x98\x8F",
		"\xD8\xC6" => "\xE4\xBB\x84",
		"\xD8\xC7" => "\xE5\x8E\x8D",
		"\xD8\xC8" => "\xE5\x8E\x9D",
		"\xD8\xC9" => "\xE5\x8E\xA3",
		"\xD8\xCA" => "\xE5\x8E\xA5",
		"\xD8\xCB" => "\xE5\x8E\xAE",
		"\xD8\xCC" => "\xE9\x9D\xA5",
		"\xD8\xCD" => "\xE8\xB5\x9D",
		"\xD8\xCE" => "\xE5\x8C\x9A",
		"\xD8\xCF" => "\xE5\x8F\xB5",
		"\xD8\xD0" => "\xE5\x8C\xA6",
		"\xD8\xD1" => "\xE5\x8C\xAE",
		"\xD8\xD2" => "\xE5\x8C\xBE",
		"\xD8\xD3" => "\xE8\xB5\x9C",
		"\xD8\xD4" => "\xE5\x8D\xA6",
		"\xD8\xD5" => "\xE5\x8D\xA3",
		"\xD8\xD6" => "\xE5\x88\x82",
		"\xD8\xD7" => "\xE5\x88\x88",
		"\xD8\xD8" => "\xE5\x88\x8E",
		"\xD8\xD9" => "\xE5\x88\xAD",
		"\xD8\xDA" => "\xE5\x88\xB3",
		"\xD8\xDB" => "\xE5\x88\xBF",
		"\xD8\xDC" => "\xE5\x89\x80",
		"\xD8\xDD" => "\xE5\x89\x8C",
		"\xD8\xDE" => "\xE5\x89\x9E",
		"\xD8\xDF" => "\xE5\x89\xA1",
		"\xD8\xE0" => "\xE5\x89\x9C",
		"\xD8\xE1" => "\xE8\x92\xAF",
		"\xD8\xE2" => "\xE5\x89\xBD",
		"\xD8\xE3" => "\xE5\x8A\x82",
		"\xD8\xE4" => "\xE5\x8A\x81",
		"\xD8\xE5" => "\xE5\x8A\x90",
		"\xD8\xE6" => "\xE5\x8A\x93",
		"\xD8\xE7" => "\xE5\x86\x82",
		"\xD8\xE8" => "\xE7\xBD\x94",
		"\xD8\xE9" => "\xE4\xBA\xBB",
		"\xD8\xEA" => "\xE4\xBB\x83",
		"\xD8\xEB" => "\xE4\xBB\x89",
		"\xD8\xEC" => "\xE4\xBB\x82",
		"\xD8\xED" => "\xE4\xBB\xA8",
		"\xD8\xEE" => "\xE4\xBB\xA1",
		"\xD8\xEF" => "\xE4\xBB\xAB",
		"\xD8\xF0" => "\xE4\xBB\x9E",
		"\xD8\xF1" => "\xE4\xBC\x9B",
		"\xD8\xF2" => "\xE4\xBB\xB3",
		"\xD8\xF3" => "\xE4\xBC\xA2",
		"\xD8\xF4" => "\xE4\xBD\xA4",
		"\xD8\xF5" => "\xE4\xBB\xB5",
		"\xD8\xF6" => "\xE4\xBC\xA5",
		"\xD8\xF7" => "\xE4\xBC\xA7",
		"\xD8\xF8" => "\xE4\xBC\x89",
		"\xD8\xF9" => "\xE4\xBC\xAB",
		"\xD8\xFA" => "\xE4\xBD\x9E",
		"\xD8\xFB" => "\xE4\xBD\xA7",
		"\xD8\xFC" => "\xE6\x94\xB8",
		"\xD8\xFD" => "\xE4\xBD\x9A",
		"\xD8\xFE" => "\xE4\xBD\x9D",
		"\xD9\xA1" => "\xE4\xBD\x9F",
		"\xD9\xA2" => "\xE4\xBD\x97",
		"\xD9\xA3" => "\xE4\xBC\xB2",
		"\xD9\xA4" => "\xE4\xBC\xBD",
		"\xD9\xA5" => "\xE4\xBD\xB6",
		"\xD9\xA6" => "\xE4\xBD\xB4",
		"\xD9\xA7" => "\xE4\xBE\x91",
		"\xD9\xA8" => "\xE4\xBE\x89",
		"\xD9\xA9" => "\xE4\xBE\x83",
		"\xD9\xAA" => "\xE4\xBE\x8F",
		"\xD9\xAB" => "\xE4\xBD\xBE",
		"\xD9\xAC" => "\xE4\xBD\xBB",
		"\xD9\xAD" => "\xE4\xBE\xAA",
		"\xD9\xAE" => "\xE4\xBD\xBC",
		"\xD9\xAF" => "\xE4\xBE\xAC",
		"\xD9\xB0" => "\xE4\xBE\x94",
		"\xD9\xB1" => "\xE4\xBF\xA6",
		"\xD9\xB2" => "\xE4\xBF\xA8",
		"\xD9\xB3" => "\xE4\xBF\xAA",
		"\xD9\xB4" => "\xE4\xBF\x85",
		"\xD9\xB5" => "\xE4\xBF\x9A",
		"\xD9\xB6" => "\xE4\xBF\xA3",
		"\xD9\xB7" => "\xE4\xBF\x9C",
		"\xD9\xB8" => "\xE4\xBF\x91",
		"\xD9\xB9" => "\xE4\xBF\x9F",
		"\xD9\xBA" => "\xE4\xBF\xB8",
		"\xD9\xBB" => "\xE5\x80\xA9",
		"\xD9\xBC" => "\xE5\x81\x8C",
		"\xD9\xBD" => "\xE4\xBF\xB3",
		"\xD9\xBE" => "\xE5\x80\xAC",
		"\xD9\xBF" => "\xE5\x80\x8F",
		"\xD9\xC0" => "\xE5\x80\xAE",
		"\xD9\xC1" => "\xE5\x80\xAD",
		"\xD9\xC2" => "\xE4\xBF\xBE",
		"\xD9\xC3" => "\xE5\x80\x9C",
		"\xD9\xC4" => "\xE5\x80\x8C",
		"\xD9\xC5" => "\xE5\x80\xA5",
		"\xD9\xC6" => "\xE5\x80\xA8",
		"\xD9\xC7" => "\xE5\x81\xBE",
		"\xD9\xC8" => "\xE5\x81\x83",
		"\xD9\xC9" => "\xE5\x81\x95",
		"\xD9\xCA" => "\xE5\x81\x88",
		"\xD9\xCB" => "\xE5\x81\x8E",
		"\xD9\xCC" => "\xE5\x81\xAC",
		"\xD9\xCD" => "\xE5\x81\xBB",
		"\xD9\xCE" => "\xE5\x82\xA5",
		"\xD9\xCF" => "\xE5\x82\xA7",
		"\xD9\xD0" => "\xE5\x82\xA9",
		"\xD9\xD1" => "\xE5\x82\xBA",
		"\xD9\xD2" => "\xE5\x83\x96",
		"\xD9\xD3" => "\xE5\x84\x86",
		"\xD9\xD4" => "\xE5\x83\xAD",
		"\xD9\xD5" => "\xE5\x83\xAC",
		"\xD9\xD6" => "\xE5\x83\xA6",
		"\xD9\xD7" => "\xE5\x83\xAE",
		"\xD9\xD8" => "\xE5\x84\x87",
		"\xD9\xD9" => "\xE5\x84\x8B",
		"\xD9\xDA" => "\xE4\xBB\x9D",
		"\xD9\xDB" => "\xE6\xB0\xBD",
		"\xD9\xDC" => "\xE4\xBD\x98",
		"\xD9\xDD" => "\xE4\xBD\xA5",
		"\xD9\xDE" => "\xE4\xBF\x8E",
		"\xD9\xDF" => "\xE9\xBE\xA0",
		"\xD9\xE0" => "\xE6\xB1\x86",
		"\xD9\xE1" => "\xE7\xB1\xB4",
		"\xD9\xE2" => "\xE5\x85\xAE",
		"\xD9\xE3" => "\xE5\xB7\xBD",
		"\xD9\xE4" => "\xE9\xBB\x89",
		"\xD9\xE5" => "\xE9\xA6\x98",
		"\xD9\xE6" => "\xE5\x86\x81",
		"\xD9\xE7" => "\xE5\xA4\x94",
		"\xD9\xE8" => "\xE5\x8B\xB9",
		"\xD9\xE9" => "\xE5\x8C\x8D",
		"\xD9\xEA" => "\xE8\xA8\x87",
		"\xD9\xEB" => "\xE5\x8C\x90",
		"\xD9\xEC" => "\xE5\x87\xAB",
		"\xD9\xED" => "\xE5\xA4\x99",
		"\xD9\xEE" => "\xE5\x85\x95",
		"\xD9\xEF" => "\xE4\xBA\xA0",
		"\xD9\xF0" => "\xE5\x85\x96",
		"\xD9\xF1" => "\xE4\xBA\xB3",
		"\xD9\xF2" => "\xE8\xA1\xAE",
		"\xD9\xF3" => "\xE8\xA2\xA4",
		"\xD9\xF4" => "\xE4\xBA\xB5",
		"\xD9\xF5" => "\xE8\x84\x94",
		"\xD9\xF6" => "\xE8\xA3\x92",
		"\xD9\xF7" => "\xE7\xA6\x80",
		"\xD9\xF8" => "\xE5\xAC\xB4",
		"\xD9\xF9" => "\xE8\xA0\x83",
		"\xD9\xFA" => "\xE7\xBE\xB8",
		"\xD9\xFB" => "\xE5\x86\xAB",
		"\xD9\xFC" => "\xE5\x86\xB1",
		"\xD9\xFD" => "\xE5\x86\xBD",
		"\xD9\xFE" => "\xE5\x86\xBC",
		"\xDA\xA1" => "\xE5\x87\x87",
		"\xDA\xA2" => "\xE5\x86\x96",
		"\xDA\xA3" => "\xE5\x86\xA2",
		"\xDA\xA4" => "\xE5\x86\xA5",
		"\xDA\xA5" => "\xE8\xAE\xA0",
		"\xDA\xA6" => "\xE8\xAE\xA6",
		"\xDA\xA7" => "\xE8\xAE\xA7",
		"\xDA\xA8" => "\xE8\xAE\xAA",
		"\xDA\xA9" => "\xE8\xAE\xB4",
		"\xDA\xAA" => "\xE8\xAE\xB5",
		"\xDA\xAB" => "\xE8\xAE\xB7",
		"\xDA\xAC" => "\xE8\xAF\x82",
		"\xDA\xAD" => "\xE8\xAF\x83",
		"\xDA\xAE" => "\xE8\xAF\x8B",
		"\xDA\xAF" => "\xE8\xAF\x8F",
		"\xDA\xB0" => "\xE8\xAF\x8E",
		"\xDA\xB1" => "\xE8\xAF\x92",
		"\xDA\xB2" => "\xE8\xAF\x93",
		"\xDA\xB3" => "\xE8\xAF\x94",
		"\xDA\xB4" => "\xE8\xAF\x96",
		"\xDA\xB5" => "\xE8\xAF\x98",
		"\xDA\xB6" => "\xE8\xAF\x99",
		"\xDA\xB7" => "\xE8\xAF\x9C",
		"\xDA\xB8" => "\xE8\xAF\x9F",
		"\xDA\xB9" => "\xE8\xAF\xA0",
		"\xDA\xBA" => "\xE8\xAF\xA4",
		"\xDA\xBB" => "\xE8\xAF\xA8",
		"\xDA\xBC" => "\xE8\xAF\xA9",
		"\xDA\xBD" => "\xE8\xAF\xAE",
		"\xDA\xBE" => "\xE8\xAF\xB0",
		"\xDA\xBF" => "\xE8\xAF\xB3",
		"\xDA\xC0" => "\xE8\xAF\xB6",
		"\xDA\xC1" => "\xE8\xAF\xB9",
		"\xDA\xC2" => "\xE8\xAF\xBC",
		"\xDA\xC3" => "\xE8\xAF\xBF",
		"\xDA\xC4" => "\xE8\xB0\x80",
		"\xDA\xC5" => "\xE8\xB0\x82",
		"\xDA\xC6" => "\xE8\xB0\x84",
		"\xDA\xC7" => "\xE8\xB0\x87",
		"\xDA\xC8" => "\xE8\xB0\x8C",
		"\xDA\xC9" => "\xE8\xB0\x8F",
		"\xDA\xCA" => "\xE8\xB0\x91",
		"\xDA\xCB" => "\xE8\xB0\x92",
		"\xDA\xCC" => "\xE8\xB0\x94",
		"\xDA\xCD" => "\xE8\xB0\x95",
		"\xDA\xCE" => "\xE8\xB0\x96",
		"\xDA\xCF" => "\xE8\xB0\x99",
		"\xDA\xD0" => "\xE8\xB0\x9B",
		"\xDA\xD1" => "\xE8\xB0\x98",
		"\xDA\xD2" => "\xE8\xB0\x9D",
		"\xDA\xD3" => "\xE8\xB0\x9F",
		"\xDA\xD4" => "\xE8\xB0\xA0",
		"\xDA\xD5" => "\xE8\xB0\xA1",
		"\xDA\xD6" => "\xE8\xB0\xA5",
		"\xDA\xD7" => "\xE8\xB0\xA7",
		"\xDA\xD8" => "\xE8\xB0\xAA",
		"\xDA\xD9" => "\xE8\xB0\xAB",
		"\xDA\xDA" => "\xE8\xB0\xAE",
		"\xDA\xDB" => "\xE8\xB0\xAF",
		"\xDA\xDC" => "\xE8\xB0\xB2",
		"\xDA\xDD" => "\xE8\xB0\xB3",
		"\xDA\xDE" => "\xE8\xB0\xB5",
		"\xDA\xDF" => "\xE8\xB0\xB6",
		"\xDA\xE0" => "\xE5\x8D\xA9",
		"\xDA\xE1" => "\xE5\x8D\xBA",
		"\xDA\xE2" => "\xE9\x98\x9D",
		"\xDA\xE3" => "\xE9\x98\xA2",
		"\xDA\xE4" => "\xE9\x98\xA1",
		"\xDA\xE5" => "\xE9\x98\xB1",
		"\xDA\xE6" => "\xE9\x98\xAA",
		"\xDA\xE7" => "\xE9\x98\xBD",
		"\xDA\xE8" => "\xE9\x98\xBC",
		"\xDA\xE9" => "\xE9\x99\x82",
		"\xDA\xEA" => "\xE9\x99\x89",
		"\xDA\xEB" => "\xE9\x99\x94",
		"\xDA\xEC" => "\xE9\x99\x9F",
		"\xDA\xED" => "\xE9\x99\xA7",
		"\xDA\xEE" => "\xE9\x99\xAC",
		"\xDA\xEF" => "\xE9\x99\xB2",
		"\xDA\xF0" => "\xE9\x99\xB4",
		"\xDA\xF1" => "\xE9\x9A\x88",
		"\xDA\xF2" => "\xE9\x9A\x8D",
		"\xDA\xF3" => "\xE9\x9A\x97",
		"\xDA\xF4" => "\xE9\x9A\xB0",
		"\xDA\xF5" => "\xE9\x82\x97",
		"\xDA\xF6" => "\xE9\x82\x9B",
		"\xDA\xF7" => "\xE9\x82\x9D",
		"\xDA\xF8" => "\xE9\x82\x99",
		"\xDA\xF9" => "\xE9\x82\xAC",
		"\xDA\xFA" => "\xE9\x82\xA1",
		"\xDA\xFB" => "\xE9\x82\xB4",
		"\xDA\xFC" => "\xE9\x82\xB3",
		"\xDA\xFD" => "\xE9\x82\xB6",
		"\xDA\xFE" => "\xE9\x82\xBA",
		"\xDB\xA1" => "\xE9\x82\xB8",
		"\xDB\xA2" => "\xE9\x82\xB0",
		"\xDB\xA3" => "\xE9\x83\x8F",
		"\xDB\xA4" => "\xE9\x83\x85",
		"\xDB\xA5" => "\xE9\x82\xBE",
		"\xDB\xA6" => "\xE9\x83\x90",
		"\xDB\xA7" => "\xE9\x83\x84",
		"\xDB\xA8" => "\xE9\x83\x87",
		"\xDB\xA9" => "\xE9\x83\x93",
		"\xDB\xAA" => "\xE9\x83\xA6",
		"\xDB\xAB" => "\xE9\x83\xA2",
		"\xDB\xAC" => "\xE9\x83\x9C",
		"\xDB\xAD" => "\xE9\x83\x97",
		"\xDB\xAE" => "\xE9\x83\x9B",
		"\xDB\xAF" => "\xE9\x83\xAB",
		"\xDB\xB0" => "\xE9\x83\xAF",
		"\xDB\xB1" => "\xE9\x83\xBE",
		"\xDB\xB2" => "\xE9\x84\x84",
		"\xDB\xB3" => "\xE9\x84\xA2",
		"\xDB\xB4" => "\xE9\x84\x9E",
		"\xDB\xB5" => "\xE9\x84\xA3",
		"\xDB\xB6" => "\xE9\x84\xB1",
		"\xDB\xB7" => "\xE9\x84\xAF",
		"\xDB\xB8" => "\xE9\x84\xB9",
		"\xDB\xB9" => "\xE9\x85\x83",
		"\xDB\xBA" => "\xE9\x85\x86",
		"\xDB\xBB" => "\xE5\x88\x8D",
		"\xDB\xBC" => "\xE5\xA5\x82",
		"\xDB\xBD" => "\xE5\x8A\xA2",
		"\xDB\xBE" => "\xE5\x8A\xAC",
		"\xDB\xBF" => "\xE5\x8A\xAD",
		"\xDB\xC0" => "\xE5\x8A\xBE",
		"\xDB\xC1" => "\xE5\x93\xBF",
		"\xDB\xC2" => "\xE5\x8B\x90",
		"\xDB\xC3" => "\xE5\x8B\x96",
		"\xDB\xC4" => "\xE5\x8B\xB0",
		"\xDB\xC5" => "\xE5\x8F\x9F",
		"\xDB\xC6" => "\xE7\x87\xAE",
		"\xDB\xC7" => "\xE7\x9F\x8D",
		"\xDB\xC8" => "\xE5\xBB\xB4",
		"\xDB\xC9" => "\xE5\x87\xB5",
		"\xDB\xCA" => "\xE5\x87\xBC",
		"\xDB\xCB" => "\xE9\xAC\xAF",
		"\xDB\xCC" => "\xE5\x8E\xB6",
		"\xDB\xCD" => "\xE5\xBC\x81",
		"\xDB\xCE" => "\xE7\x95\x9A",
		"\xDB\xCF" => "\xE5\xB7\xAF",
		"\xDB\xD0" => "\xE5\x9D\x8C",
		"\xDB\xD1" => "\xE5\x9E\xA9",
		"\xDB\xD2" => "\xE5\x9E\xA1",
		"\xDB\xD3" => "\xE5\xA1\xBE",
		"\xDB\xD4" => "\xE5\xA2\xBC",
		"\xDB\xD5" => "\xE5\xA3\x85",
		"\xDB\xD6" => "\xE5\xA3\x91",
		"\xDB\xD7" => "\xE5\x9C\xA9",
		"\xDB\xD8" => "\xE5\x9C\xAC",
		"\xDB\xD9" => "\xE5\x9C\xAA",
		"\xDB\xDA" => "\xE5\x9C\xB3",
		"\xDB\xDB" => "\xE5\x9C\xB9",
		"\xDB\xDC" => "\xE5\x9C\xAE",
		"\xDB\xDD" => "\xE5\x9C\xAF",
		"\xDB\xDE" => "\xE5\x9D\x9C",
		"\xDB\xDF" => "\xE5\x9C\xBB",
		"\xDB\xE0" => "\xE5\x9D\x82",
		"\xDB\xE1" => "\xE5\x9D\xA9",
		"\xDB\xE2" => "\xE5\x9E\x85",
		"\xDB\xE3" => "\xE5\x9D\xAB",
		"\xDB\xE4" => "\xE5\x9E\x86",
		"\xDB\xE5" => "\xE5\x9D\xBC",
		"\xDB\xE6" => "\xE5\x9D\xBB",
		"\xDB\xE7" => "\xE5\x9D\xA8",
		"\xDB\xE8" => "\xE5\x9D\xAD",
		"\xDB\xE9" => "\xE5\x9D\xB6",
		"\xDB\xEA" => "\xE5\x9D\xB3",
		"\xDB\xEB" => "\xE5\x9E\xAD",
		"\xDB\xEC" => "\xE5\x9E\xA4",
		"\xDB\xED" => "\xE5\x9E\x8C",
		"\xDB\xEE" => "\xE5\x9E\xB2",
		"\xDB\xEF" => "\xE5\x9F\x8F",
		"\xDB\xF0" => "\xE5\x9E\xA7",
		"\xDB\xF1" => "\xE5\x9E\xB4",
		"\xDB\xF2" => "\xE5\x9E\x93",
		"\xDB\xF3" => "\xE5\x9E\xA0",
		"\xDB\xF4" => "\xE5\x9F\x95",
		"\xDB\xF5" => "\xE5\x9F\x98",
		"\xDB\xF6" => "\xE5\x9F\x9A",
		"\xDB\xF7" => "\xE5\x9F\x99",
		"\xDB\xF8" => "\xE5\x9F\x92",
		"\xDB\xF9" => "\xE5\x9E\xB8",
		"\xDB\xFA" => "\xE5\x9F\xB4",
		"\xDB\xFB" => "\xE5\x9F\xAF",
		"\xDB\xFC" => "\xE5\x9F\xB8",
		"\xDB\xFD" => "\xE5\x9F\xA4",
		"\xDB\xFE" => "\xE5\x9F\x9D",
		"\xDC\xA1" => "\xE5\xA0\x8B",
		"\xDC\xA2" => "\xE5\xA0\x8D",
		"\xDC\xA3" => "\xE5\x9F\xBD",
		"\xDC\xA4" => "\xE5\x9F\xAD",
		"\xDC\xA5" => "\xE5\xA0\x80",
		"\xDC\xA6" => "\xE5\xA0\x9E",
		"\xDC\xA7" => "\xE5\xA0\x99",
		"\xDC\xA8" => "\xE5\xA1\x84",
		"\xDC\xA9" => "\xE5\xA0\xA0",
		"\xDC\xAA" => "\xE5\xA1\xA5",
		"\xDC\xAB" => "\xE5\xA1\xAC",
		"\xDC\xAC" => "\xE5\xA2\x81",
		"\xDC\xAD" => "\xE5\xA2\x89",
		"\xDC\xAE" => "\xE5\xA2\x9A",
		"\xDC\xAF" => "\xE5\xA2\x80",
		"\xDC\xB0" => "\xE9\xA6\xA8",
		"\xDC\xB1" => "\xE9\xBC\x99",
		"\xDC\xB2" => "\xE6\x87\xBF",
		"\xDC\xB3" => "\xE8\x89\xB9",
		"\xDC\xB4" => "\xE8\x89\xBD",
		"\xDC\xB5" => "\xE8\x89\xBF",
		"\xDC\xB6" => "\xE8\x8A\x8F",
		"\xDC\xB7" => "\xE8\x8A\x8A",
		"\xDC\xB8" => "\xE8\x8A\xA8",
		"\xDC\xB9" => "\xE8\x8A\x84",
		"\xDC\xBA" => "\xE8\x8A\x8E",
		"\xDC\xBB" => "\xE8\x8A\x91",
		"\xDC\xBC" => "\xE8\x8A\x97",
		"\xDC\xBD" => "\xE8\x8A\x99",
		"\xDC\xBE" => "\xE8\x8A\xAB",
		"\xDC\xBF" => "\xE8\x8A\xB8",
		"\xDC\xC0" => "\xE8\x8A\xBE",
		"\xDC\xC1" => "\xE8\x8A\xB0",
		"\xDC\xC2" => "\xE8\x8B\x88",
		"\xDC\xC3" => "\xE8\x8B\x8A",
		"\xDC\xC4" => "\xE8\x8B\xA3",
		"\xDC\xC5" => "\xE8\x8A\x98",
		"\xDC\xC6" => "\xE8\x8A\xB7",
		"\xDC\xC7" => "\xE8\x8A\xAE",
		"\xDC\xC8" => "\xE8\x8B\x8B",
		"\xDC\xC9" => "\xE8\x8B\x8C",
		"\xDC\xCA" => "\xE8\x8B\x81",
		"\xDC\xCB" => "\xE8\x8A\xA9",
		"\xDC\xCC" => "\xE8\x8A\xB4",
		"\xDC\xCD" => "\xE8\x8A\xA1",
		"\xDC\xCE" => "\xE8\x8A\xAA",
		"\xDC\xCF" => "\xE8\x8A\x9F",
		"\xDC\xD0" => "\xE8\x8B\x84",
		"\xDC\xD1" => "\xE8\x8B\x8E",
		"\xDC\xD2" => "\xE8\x8A\xA4",
		"\xDC\xD3" => "\xE8\x8B\xA1",
		"\xDC\xD4" => "\xE8\x8C\x89",
		"\xDC\xD5" => "\xE8\x8B\xB7",
		"\xDC\xD6" => "\xE8\x8B\xA4",
		"\xDC\xD7" => "\xE8\x8C\x8F",
		"\xDC\xD8" => "\xE8\x8C\x87",
		"\xDC\xD9" => "\xE8\x8B\x9C",
		"\xDC\xDA" => "\xE8\x8B\xB4",
		"\xDC\xDB" => "\xE8\x8B\x92",
		"\xDC\xDC" => "\xE8\x8B\x98",
		"\xDC\xDD" => "\xE8\x8C\x8C",
		"\xDC\xDE" => "\xE8\x8B\xBB",
		"\xDC\xDF" => "\xE8\x8B\x93",
		"\xDC\xE0" => "\xE8\x8C\x91",
		"\xDC\xE1" => "\xE8\x8C\x9A",
		"\xDC\xE2" => "\xE8\x8C\x86",
		"\xDC\xE3" => "\xE8\x8C\x94",
		"\xDC\xE4" => "\xE8\x8C\x95",
		"\xDC\xE5" => "\xE8\x8B\xA0",
		"\xDC\xE6" => "\xE8\x8B\x95",
		"\xDC\xE7" => "\xE8\x8C\x9C",
		"\xDC\xE8" => "\xE8\x8D\x91",
		"\xDC\xE9" => "\xE8\x8D\x9B",
		"\xDC\xEA" => "\xE8\x8D\x9C",
		"\xDC\xEB" => "\xE8\x8C\x88",
		"\xDC\xEC" => "\xE8\x8E\x92",
		"\xDC\xED" => "\xE8\x8C\xBC",
		"\xDC\xEE" => "\xE8\x8C\xB4",
		"\xDC\xEF" => "\xE8\x8C\xB1",
		"\xDC\xF0" => "\xE8\x8E\x9B",
		"\xDC\xF1" => "\xE8\x8D\x9E",
		"\xDC\xF2" => "\xE8\x8C\xAF",
		"\xDC\xF3" => "\xE8\x8D\x8F",
		"\xDC\xF4" => "\xE8\x8D\x87",
		"\xDC\xF5" => "\xE8\x8D\x83",
		"\xDC\xF6" => "\xE8\x8D\x9F",
		"\xDC\xF7" => "\xE8\x8D\x80",
		"\xDC\xF8" => "\xE8\x8C\x97",
		"\xDC\xF9" => "\xE8\x8D\xA0",
		"\xDC\xFA" => "\xE8\x8C\xAD",
		"\xDC\xFB" => "\xE8\x8C\xBA",
		"\xDC\xFC" => "\xE8\x8C\xB3",
		"\xDC\xFD" => "\xE8\x8D\xA6",
		"\xDC\xFE" => "\xE8\x8D\xA5",
		"\xDD\xA1" => "\xE8\x8D\xA8",
		"\xDD\xA2" => "\xE8\x8C\x9B",
		"\xDD\xA3" => "\xE8\x8D\xA9",
		"\xDD\xA4" => "\xE8\x8D\xAC",
		"\xDD\xA5" => "\xE8\x8D\xAA",
		"\xDD\xA6" => "\xE8\x8D\xAD",
		"\xDD\xA7" => "\xE8\x8D\xAE",
		"\xDD\xA8" => "\xE8\x8E\xB0",
		"\xDD\xA9" => "\xE8\x8D\xB8",
		"\xDD\xAA" => "\xE8\x8E\xB3",
		"\xDD\xAB" => "\xE8\x8E\xB4",
		"\xDD\xAC" => "\xE8\x8E\xA0",
		"\xDD\xAD" => "\xE8\x8E\xAA",
		"\xDD\xAE" => "\xE8\x8E\x93",
		"\xDD\xAF" => "\xE8\x8E\x9C",
		"\xDD\xB0" => "\xE8\x8E\x85",
		"\xDD\xB1" => "\xE8\x8D\xBC",
		"\xDD\xB2" => "\xE8\x8E\xB6",
		"\xDD\xB3" => "\xE8\x8E\xA9",
		"\xDD\xB4" => "\xE8\x8D\xBD",
		"\xDD\xB5" => "\xE8\x8E\xB8",
		"\xDD\xB6" => "\xE8\x8D\xBB",
		"\xDD\xB7" => "\xE8\x8E\x98",
		"\xDD\xB8" => "\xE8\x8E\x9E",
		"\xDD\xB9" => "\xE8\x8E\xA8",
		"\xDD\xBA" => "\xE8\x8E\xBA",
		"\xDD\xBB" => "\xE8\x8E\xBC",
		"\xDD\xBC" => "\xE8\x8F\x81",
		"\xDD\xBD" => "\xE8\x90\x81",
		"\xDD\xBE" => "\xE8\x8F\xA5",
		"\xDD\xBF" => "\xE8\x8F\x98",
		"\xDD\xC0" => "\xE5\xA0\x87",
		"\xDD\xC1" => "\xE8\x90\x98",
		"\xDD\xC2" => "\xE8\x90\x8B",
		"\xDD\xC3" => "\xE8\x8F\x9D",
		"\xDD\xC4" => "\xE8\x8F\xBD",
		"\xDD\xC5" => "\xE8\x8F\x96",
		"\xDD\xC6" => "\xE8\x90\x9C",
		"\xDD\xC7" => "\xE8\x90\xB8",
		"\xDD\xC8" => "\xE8\x90\x91",
		"\xDD\xC9" => "\xE8\x90\x86",
		"\xDD\xCA" => "\xE8\x8F\x94",
		"\xDD\xCB" => "\xE8\x8F\x9F",
		"\xDD\xCC" => "\xE8\x90\x8F",
		"\xDD\xCD" => "\xE8\x90\x83",
		"\xDD\xCE" => "\xE8\x8F\xB8",
		"\xDD\xCF" => "\xE8\x8F\xB9",
		"\xDD\xD0" => "\xE8\x8F\xAA",
		"\xDD\xD1" => "\xE8\x8F\x85",
		"\xDD\xD2" => "\xE8\x8F\x80",
		"\xDD\xD3" => "\xE8\x90\xA6",
		"\xDD\xD4" => "\xE8\x8F\xB0",
		"\xDD\xD5" => "\xE8\x8F\xA1",
		"\xDD\xD6" => "\xE8\x91\x9C",
		"\xDD\xD7" => "\xE8\x91\x91",
		"\xDD\xD8" => "\xE8\x91\x9A",
		"\xDD\xD9" => "\xE8\x91\x99",
		"\xDD\xDA" => "\xE8\x91\xB3",
		"\xDD\xDB" => "\xE8\x92\x87",
		"\xDD\xDC" => "\xE8\x92\x88",
		"\xDD\xDD" => "\xE8\x91\xBA",
		"\xDD\xDE" => "\xE8\x92\x89",
		"\xDD\xDF" => "\xE8\x91\xB8",
		"\xDD\xE0" => "\xE8\x90\xBC",
		"\xDD\xE1" => "\xE8\x91\x86",
		"\xDD\xE2" => "\xE8\x91\xA9",
		"\xDD\xE3" => "\xE8\x91\xB6",
		"\xDD\xE4" => "\xE8\x92\x8C",
		"\xDD\xE5" => "\xE8\x92\x8E",
		"\xDD\xE6" => "\xE8\x90\xB1",
		"\xDD\xE7" => "\xE8\x91\xAD",
		"\xDD\xE8" => "\xE8\x93\x81",
		"\xDD\xE9" => "\xE8\x93\x8D",
		"\xDD\xEA" => "\xE8\x93\x90",
		"\xDD\xEB" => "\xE8\x93\xA6",
		"\xDD\xEC" => "\xE8\x92\xBD",
		"\xDD\xED" => "\xE8\x93\x93",
		"\xDD\xEE" => "\xE8\x93\x8A",
		"\xDD\xEF" => "\xE8\x92\xBF",
		"\xDD\xF0" => "\xE8\x92\xBA",
		"\xDD\xF1" => "\xE8\x93\xA0",
		"\xDD\xF2" => "\xE8\x92\xA1",
		"\xDD\xF3" => "\xE8\x92\xB9",
		"\xDD\xF4" => "\xE8\x92\xB4",
		"\xDD\xF5" => "\xE8\x92\x97",
		"\xDD\xF6" => "\xE8\x93\xA5",
		"\xDD\xF7" => "\xE8\x93\xA3",
		"\xDD\xF8" => "\xE8\x94\x8C",
		"\xDD\xF9" => "\xE7\x94\x8D",
		"\xDD\xFA" => "\xE8\x94\xB8",
		"\xDD\xFB" => "\xE8\x93\xB0",
		"\xDD\xFC" => "\xE8\x94\xB9",
		"\xDD\xFD" => "\xE8\x94\x9F",
		"\xDD\xFE" => "\xE8\x94\xBA",
		"\xDE\xA1" => "\xE8\x95\x96",
		"\xDE\xA2" => "\xE8\x94\xBB",
		"\xDE\xA3" => "\xE8\x93\xBF",
		"\xDE\xA4" => "\xE8\x93\xBC",
		"\xDE\xA5" => "\xE8\x95\x99",
		"\xDE\xA6" => "\xE8\x95\x88",
		"\xDE\xA7" => "\xE8\x95\xA8",
		"\xDE\xA8" => "\xE8\x95\xA4",
		"\xDE\xA9" => "\xE8\x95\x9E",
		"\xDE\xAA" => "\xE8\x95\xBA",
		"\xDE\xAB" => "\xE7\x9E\xA2",
		"\xDE\xAC" => "\xE8\x95\x83",
		"\xDE\xAD" => "\xE8\x95\xB2",
		"\xDE\xAE" => "\xE8\x95\xBB",
		"\xDE\xAF" => "\xE8\x96\xA4",
		"\xDE\xB0" => "\xE8\x96\xA8",
		"\xDE\xB1" => "\xE8\x96\x87",
		"\xDE\xB2" => "\xE8\x96\x8F",
		"\xDE\xB3" => "\xE8\x95\xB9",
		"\xDE\xB4" => "\xE8\x96\xAE",
		"\xDE\xB5" => "\xE8\x96\x9C",
		"\xDE\xB6" => "\xE8\x96\x85",
		"\xDE\xB7" => "\xE8\x96\xB9",
		"\xDE\xB8" => "\xE8\x96\xB7",
		"\xDE\xB9" => "\xE8\x96\xB0",
		"\xDE\xBA" => "\xE8\x97\x93",
		"\xDE\xBB" => "\xE8\x97\x81",
		"\xDE\xBC" => "\xE8\x97\x9C",
		"\xDE\xBD" => "\xE8\x97\xBF",
		"\xDE\xBE" => "\xE8\x98\xA7",
		"\xDE\xBF" => "\xE8\x98\x85",
		"\xDE\xC0" => "\xE8\x98\xA9",
		"\xDE\xC1" => "\xE8\x98\x96",
		"\xDE\xC2" => "\xE8\x98\xBC",
		"\xDE\xC3" => "\xE5\xBB\xBE",
		"\xDE\xC4" => "\xE5\xBC\x88",
		"\xDE\xC5" => "\xE5\xA4\xBC",
		"\xDE\xC6" => "\xE5\xA5\x81",
		"\xDE\xC7" => "\xE8\x80\xB7",
		"\xDE\xC8" => "\xE5\xA5\x95",
		"\xDE\xC9" => "\xE5\xA5\x9A",
		"\xDE\xCA" => "\xE5\xA5\x98",
		"\xDE\xCB" => "\xE5\x8C\x8F",
		"\xDE\xCC" => "\xE5\xB0\xA2",
		"\xDE\xCD" => "\xE5\xB0\xA5",
		"\xDE\xCE" => "\xE5\xB0\xAC",
		"\xDE\xCF" => "\xE5\xB0\xB4",
		"\xDE\xD0" => "\xE6\x89\x8C",
		"\xDE\xD1" => "\xE6\x89\xAA",
		"\xDE\xD2" => "\xE6\x8A\x9F",
		"\xDE\xD3" => "\xE6\x8A\xBB",
		"\xDE\xD4" => "\xE6\x8B\x8A",
		"\xDE\xD5" => "\xE6\x8B\x9A",
		"\xDE\xD6" => "\xE6\x8B\x97",
		"\xDE\xD7" => "\xE6\x8B\xAE",
		"\xDE\xD8" => "\xE6\x8C\xA2",
		"\xDE\xD9" => "\xE6\x8B\xB6",
		"\xDE\xDA" => "\xE6\x8C\xB9",
		"\xDE\xDB" => "\xE6\x8D\x8B",
		"\xDE\xDC" => "\xE6\x8D\x83",
		"\xDE\xDD" => "\xE6\x8E\xAD",
		"\xDE\xDE" => "\xE6\x8F\xB6",
		"\xDE\xDF" => "\xE6\x8D\xB1",
		"\xDE\xE0" => "\xE6\x8D\xBA",
		"\xDE\xE1" => "\xE6\x8E\x8E",
		"\xDE\xE2" => "\xE6\x8E\xB4",
		"\xDE\xE3" => "\xE6\x8D\xAD",
		"\xDE\xE4" => "\xE6\x8E\xAC",
		"\xDE\xE5" => "\xE6\x8E\x8A",
		"\xDE\xE6" => "\xE6\x8D\xA9",
		"\xDE\xE7" => "\xE6\x8E\xAE",
		"\xDE\xE8" => "\xE6\x8E\xBC",
		"\xDE\xE9" => "\xE6\x8F\xB2",
		"\xDE\xEA" => "\xE6\x8F\xB8",
		"\xDE\xEB" => "\xE6\x8F\xA0",
		"\xDE\xEC" => "\xE6\x8F\xBF",
		"\xDE\xED" => "\xE6\x8F\x84",
		"\xDE\xEE" => "\xE6\x8F\x9E",
		"\xDE\xEF" => "\xE6\x8F\x8E",
		"\xDE\xF0" => "\xE6\x91\x92",
		"\xDE\xF1" => "\xE6\x8F\x86",
		"\xDE\xF2" => "\xE6\x8E\xBE",
		"\xDE\xF3" => "\xE6\x91\x85",
		"\xDE\xF4" => "\xE6\x91\x81",
		"\xDE\xF5" => "\xE6\x90\x8B",
		"\xDE\xF6" => "\xE6\x90\x9B",
		"\xDE\xF7" => "\xE6\x90\xA0",
		"\xDE\xF8" => "\xE6\x90\x8C",
		"\xDE\xF9" => "\xE6\x90\xA6",
		"\xDE\xFA" => "\xE6\x90\xA1",
		"\xDE\xFB" => "\xE6\x91\x9E",
		"\xDE\xFC" => "\xE6\x92\x84",
		"\xDE\xFD" => "\xE6\x91\xAD",
		"\xDE\xFE" => "\xE6\x92\x96",
		"\xDF\xA1" => "\xE6\x91\xBA",
		"\xDF\xA2" => "\xE6\x92\xB7",
		"\xDF\xA3" => "\xE6\x92\xB8",
		"\xDF\xA4" => "\xE6\x92\x99",
		"\xDF\xA5" => "\xE6\x92\xBA",
		"\xDF\xA6" => "\xE6\x93\x80",
		"\xDF\xA7" => "\xE6\x93\x90",
		"\xDF\xA8" => "\xE6\x93\x97",
		"\xDF\xA9" => "\xE6\x93\xA4",
		"\xDF\xAA" => "\xE6\x93\xA2",
		"\xDF\xAB" => "\xE6\x94\x89",
		"\xDF\xAC" => "\xE6\x94\xA5",
		"\xDF\xAD" => "\xE6\x94\xAE",
		"\xDF\xAE" => "\xE5\xBC\x8B",
		"\xDF\xAF" => "\xE5\xBF\x92",
		"\xDF\xB0" => "\xE7\x94\x99",
		"\xDF\xB1" => "\xE5\xBC\x91",
		"\xDF\xB2" => "\xE5\x8D\x9F",
		"\xDF\xB3" => "\xE5\x8F\xB1",
		"\xDF\xB4" => "\xE5\x8F\xBD",
		"\xDF\xB5" => "\xE5\x8F\xA9",
		"\xDF\xB6" => "\xE5\x8F\xA8",
		"\xDF\xB7" => "\xE5\x8F\xBB",
		"\xDF\xB8" => "\xE5\x90\x92",
		"\xDF\xB9" => "\xE5\x90\x96",
		"\xDF\xBA" => "\xE5\x90\x86",
		"\xDF\xBB" => "\xE5\x91\x8B",
		"\xDF\xBC" => "\xE5\x91\x92",
		"\xDF\xBD" => "\xE5\x91\x93",
		"\xDF\xBE" => "\xE5\x91\x94",
		"\xDF\xBF" => "\xE5\x91\x96",
		"\xDF\xC0" => "\xE5\x91\x83",
		"\xDF\xC1" => "\xE5\x90\xA1",
		"\xDF\xC2" => "\xE5\x91\x97",
		"\xDF\xC3" => "\xE5\x91\x99",
		"\xDF\xC4" => "\xE5\x90\xA3",
		"\xDF\xC5" => "\xE5\x90\xB2",
		"\xDF\xC6" => "\xE5\x92\x82",
		"\xDF\xC7" => "\xE5\x92\x94",
		"\xDF\xC8" => "\xE5\x91\xB7",
		"\xDF\xC9" => "\xE5\x91\xB1",
		"\xDF\xCA" => "\xE5\x91\xA4",
		"\xDF\xCB" => "\xE5\x92\x9A",
		"\xDF\xCC" => "\xE5\x92\x9B",
		"\xDF\xCD" => "\xE5\x92\x84",
		"\xDF\xCE" => "\xE5\x91\xB6",
		"\xDF\xCF" => "\xE5\x91\xA6",
		"\xDF\xD0" => "\xE5\x92\x9D",
		"\xDF\xD1" => "\xE5\x93\x90",
		"\xDF\xD2" => "\xE5\x92\xAD",
		"\xDF\xD3" => "\xE5\x93\x82",
		"\xDF\xD4" => "\xE5\x92\xB4",
		"\xDF\xD5" => "\xE5\x93\x92",
		"\xDF\xD6" => "\xE5\x92\xA7",
		"\xDF\xD7" => "\xE5\x92\xA6",
		"\xDF\xD8" => "\xE5\x93\x93",
		"\xDF\xD9" => "\xE5\x93\x94",
		"\xDF\xDA" => "\xE5\x91\xB2",
		"\xDF\xDB" => "\xE5\x92\xA3",
		"\xDF\xDC" => "\xE5\x93\x95",
		"\xDF\xDD" => "\xE5\x92\xBB",
		"\xDF\xDE" => "\xE5\x92\xBF",
		"\xDF\xDF" => "\xE5\x93\x8C",
		"\xDF\xE0" => "\xE5\x93\x99",
		"\xDF\xE1" => "\xE5\x93\x9A",
		"\xDF\xE2" => "\xE5\x93\x9C",
		"\xDF\xE3" => "\xE5\x92\xA9",
		"\xDF\xE4" => "\xE5\x92\xAA",
		"\xDF\xE5" => "\xE5\x92\xA4",
		"\xDF\xE6" => "\xE5\x93\x9D",
		"\xDF\xE7" => "\xE5\x93\x8F",
		"\xDF\xE8" => "\xE5\x93\x9E",
		"\xDF\xE9" => "\xE5\x94\x9B",
		"\xDF\xEA" => "\xE5\x93\xA7",
		"\xDF\xEB" => "\xE5\x94\xA0",
		"\xDF\xEC" => "\xE5\x93\xBD",
		"\xDF\xED" => "\xE5\x94\x94",
		"\xDF\xEE" => "\xE5\x93\xB3",
		"\xDF\xEF" => "\xE5\x94\xA2",
		"\xDF\xF0" => "\xE5\x94\xA3",
		"\xDF\xF1" => "\xE5\x94\x8F",
		"\xDF\xF2" => "\xE5\x94\x91",
		"\xDF\xF3" => "\xE5\x94\xA7",
		"\xDF\xF4" => "\xE5\x94\xAA",
		"\xDF\xF5" => "\xE5\x95\xA7",
		"\xDF\xF6" => "\xE5\x96\x8F",
		"\xDF\xF7" => "\xE5\x96\xB5",
		"\xDF\xF8" => "\xE5\x95\x89",
		"\xDF\xF9" => "\xE5\x95\xAD",
		"\xDF\xFA" => "\xE5\x95\x81",
		"\xDF\xFB" => "\xE5\x95\x95",
		"\xDF\xFC" => "\xE5\x94\xBF",
		"\xDF\xFD" => "\xE5\x95\x90",
		"\xDF\xFE" => "\xE5\x94\xBC",
		"\xE0\xA1" => "\xE5\x94\xB7",
		"\xE0\xA2" => "\xE5\x95\x96",
		"\xE0\xA3" => "\xE5\x95\xB5",
		"\xE0\xA4" => "\xE5\x95\xB6",
		"\xE0\xA5" => "\xE5\x95\xB7",
		"\xE0\xA6" => "\xE5\x94\xB3",
		"\xE0\xA7" => "\xE5\x94\xB0",
		"\xE0\xA8" => "\xE5\x95\x9C",
		"\xE0\xA9" => "\xE5\x96\x8B",
		"\xE0\xAA" => "\xE5\x97\x92",
		"\xE0\xAB" => "\xE5\x96\x83",
		"\xE0\xAC" => "\xE5\x96\xB1",
		"\xE0\xAD" => "\xE5\x96\xB9",
		"\xE0\xAE" => "\xE5\x96\x88",
		"\xE0\xAF" => "\xE5\x96\x81",
		"\xE0\xB0" => "\xE5\x96\x9F",
		"\xE0\xB1" => "\xE5\x95\xBE",
		"\xE0\xB2" => "\xE5\x97\x96",
		"\xE0\xB3" => "\xE5\x96\x91",
		"\xE0\xB4" => "\xE5\x95\xBB",
		"\xE0\xB5" => "\xE5\x97\x9F",
		"\xE0\xB6" => "\xE5\x96\xBD",
		"\xE0\xB7" => "\xE5\x96\xBE",
		"\xE0\xB8" => "\xE5\x96\x94",
		"\xE0\xB9" => "\xE5\x96\x99",
		"\xE0\xBA" => "\xE5\x97\xAA",
		"\xE0\xBB" => "\xE5\x97\xB7",
		"\xE0\xBC" => "\xE5\x97\x89",
		"\xE0\xBD" => "\xE5\x98\x9F",
		"\xE0\xBE" => "\xE5\x97\x91",
		"\xE0\xBF" => "\xE5\x97\xAB",
		"\xE0\xC0" => "\xE5\x97\xAC",
		"\xE0\xC1" => "\xE5\x97\x94",
		"\xE0\xC2" => "\xE5\x97\xA6",
		"\xE0\xC3" => "\xE5\x97\x9D",
		"\xE0\xC4" => "\xE5\x97\x84",
		"\xE0\xC5" => "\xE5\x97\xAF",
		"\xE0\xC6" => "\xE5\x97\xA5",
		"\xE0\xC7" => "\xE5\x97\xB2",
		"\xE0\xC8" => "\xE5\x97\xB3",
		"\xE0\xC9" => "\xE5\x97\x8C",
		"\xE0\xCA" => "\xE5\x97\x8D",
		"\xE0\xCB" => "\xE5\x97\xA8",
		"\xE0\xCC" => "\xE5\x97\xB5",
		"\xE0\xCD" => "\xE5\x97\xA4",
		"\xE0\xCE" => "\xE8\xBE\x94",
		"\xE0\xCF" => "\xE5\x98\x9E",
		"\xE0\xD0" => "\xE5\x98\x88",
		"\xE0\xD1" => "\xE5\x98\x8C",
		"\xE0\xD2" => "\xE5\x98\x81",
		"\xE0\xD3" => "\xE5\x98\xA4",
		"\xE0\xD4" => "\xE5\x98\xA3",
		"\xE0\xD5" => "\xE5\x97\xBE",
		"\xE0\xD6" => "\xE5\x98\x80",
		"\xE0\xD7" => "\xE5\x98\xA7",
		"\xE0\xD8" => "\xE5\x98\xAD",
		"\xE0\xD9" => "\xE5\x99\x98",
		"\xE0\xDA" => "\xE5\x98\xB9",
		"\xE0\xDB" => "\xE5\x99\x97",
		"\xE0\xDC" => "\xE5\x98\xAC",
		"\xE0\xDD" => "\xE5\x99\x8D",
		"\xE0\xDE" => "\xE5\x99\xA2",
		"\xE0\xDF" => "\xE5\x99\x99",
		"\xE0\xE0" => "\xE5\x99\x9C",
		"\xE0\xE1" => "\xE5\x99\x8C",
		"\xE0\xE2" => "\xE5\x99\x94",
		"\xE0\xE3" => "\xE5\x9A\x86",
		"\xE0\xE4" => "\xE5\x99\xA4",
		"\xE0\xE5" => "\xE5\x99\xB1",
		"\xE0\xE6" => "\xE5\x99\xAB",
		"\xE0\xE7" => "\xE5\x99\xBB",
		"\xE0\xE8" => "\xE5\x99\xBC",
		"\xE0\xE9" => "\xE5\x9A\x85",
		"\xE0\xEA" => "\xE5\x9A\x93",
		"\xE0\xEB" => "\xE5\x9A\xAF",
		"\xE0\xEC" => "\xE5\x9B\x94",
		"\xE0\xED" => "\xE5\x9B\x97",
		"\xE0\xEE" => "\xE5\x9B\x9D",
		"\xE0\xEF" => "\xE5\x9B\xA1",
		"\xE0\xF0" => "\xE5\x9B\xB5",
		"\xE0\xF1" => "\xE5\x9B\xAB",
		"\xE0\xF2" => "\xE5\x9B\xB9",
		"\xE0\xF3" => "\xE5\x9B\xBF",
		"\xE0\xF4" => "\xE5\x9C\x84",
		"\xE0\xF5" => "\xE5\x9C\x8A",
		"\xE0\xF6" => "\xE5\x9C\x89",
		"\xE0\xF7" => "\xE5\x9C\x9C",
		"\xE0\xF8" => "\xE5\xB8\x8F",
		"\xE0\xF9" => "\xE5\xB8\x99",
		"\xE0\xFA" => "\xE5\xB8\x94",
		"\xE0\xFB" => "\xE5\xB8\x91",
		"\xE0\xFC" => "\xE5\xB8\xB1",
		"\xE0\xFD" => "\xE5\xB8\xBB",
		"\xE0\xFE" => "\xE5\xB8\xBC",
		"\xE1\xA1" => "\xE5\xB8\xB7",
		"\xE1\xA2" => "\xE5\xB9\x84",
		"\xE1\xA3" => "\xE5\xB9\x94",
		"\xE1\xA4" => "\xE5\xB9\x9B",
		"\xE1\xA5" => "\xE5\xB9\x9E",
		"\xE1\xA6" => "\xE5\xB9\xA1",
		"\xE1\xA7" => "\xE5\xB2\x8C",
		"\xE1\xA8" => "\xE5\xB1\xBA",
		"\xE1\xA9" => "\xE5\xB2\x8D",
		"\xE1\xAA" => "\xE5\xB2\x90",
		"\xE1\xAB" => "\xE5\xB2\x96",
		"\xE1\xAC" => "\xE5\xB2\x88",
		"\xE1\xAD" => "\xE5\xB2\x98",
		"\xE1\xAE" => "\xE5\xB2\x99",
		"\xE1\xAF" => "\xE5\xB2\x91",
		"\xE1\xB0" => "\xE5\xB2\x9A",
		"\xE1\xB1" => "\xE5\xB2\x9C",
		"\xE1\xB2" => "\xE5\xB2\xB5",
		"\xE1\xB3" => "\xE5\xB2\xA2",
		"\xE1\xB4" => "\xE5\xB2\xBD",
		"\xE1\xB5" => "\xE5\xB2\xAC",
		"\xE1\xB6" => "\xE5\xB2\xAB",
		"\xE1\xB7" => "\xE5\xB2\xB1",
		"\xE1\xB8" => "\xE5\xB2\xA3",
		"\xE1\xB9" => "\xE5\xB3\x81",
		"\xE1\xBA" => "\xE5\xB2\xB7",
		"\xE1\xBB" => "\xE5\xB3\x84",
		"\xE1\xBC" => "\xE5\xB3\x92",
		"\xE1\xBD" => "\xE5\xB3\xA4",
		"\xE1\xBE" => "\xE5\xB3\x8B",
		"\xE1\xBF" => "\xE5\xB3\xA5",
		"\xE1\xC0" => "\xE5\xB4\x82",
		"\xE1\xC1" => "\xE5\xB4\x83",
		"\xE1\xC2" => "\xE5\xB4\xA7",
		"\xE1\xC3" => "\xE5\xB4\xA6",
		"\xE1\xC4" => "\xE5\xB4\xAE",
		"\xE1\xC5" => "\xE5\xB4\xA4",
		"\xE1\xC6" => "\xE5\xB4\x9E",
		"\xE1\xC7" => "\xE5\xB4\x86",
		"\xE1\xC8" => "\xE5\xB4\x9B",
		"\xE1\xC9" => "\xE5\xB5\x98",
		"\xE1\xCA" => "\xE5\xB4\xBE",
		"\xE1\xCB" => "\xE5\xB4\xB4",
		"\xE1\xCC" => "\xE5\xB4\xBD",
		"\xE1\xCD" => "\xE5\xB5\xAC",
		"\xE1\xCE" => "\xE5\xB5\x9B",
		"\xE1\xCF" => "\xE5\xB5\xAF",
		"\xE1\xD0" => "\xE5\xB5\x9D",
		"\xE1\xD1" => "\xE5\xB5\xAB",
		"\xE1\xD2" => "\xE5\xB5\x8B",
		"\xE1\xD3" => "\xE5\xB5\x8A",
		"\xE1\xD4" => "\xE5\xB5\xA9",
		"\xE1\xD5" => "\xE5\xB5\xB4",
		"\xE1\xD6" => "\xE5\xB6\x82",
		"\xE1\xD7" => "\xE5\xB6\x99",
		"\xE1\xD8" => "\xE5\xB6\x9D",
		"\xE1\xD9" => "\xE8\xB1\xB3",
		"\xE1\xDA" => "\xE5\xB6\xB7",
		"\xE1\xDB" => "\xE5\xB7\x85",
		"\xE1\xDC" => "\xE5\xBD\xB3",
		"\xE1\xDD" => "\xE5\xBD\xB7",
		"\xE1\xDE" => "\xE5\xBE\x82",
		"\xE1\xDF" => "\xE5\xBE\x87",
		"\xE1\xE0" => "\xE5\xBE\x89",
		"\xE1\xE1" => "\xE5\xBE\x8C",
		"\xE1\xE2" => "\xE5\xBE\x95",
		"\xE1\xE3" => "\xE5\xBE\x99",
		"\xE1\xE4" => "\xE5\xBE\x9C",
		"\xE1\xE5" => "\xE5\xBE\xA8",
		"\xE1\xE6" => "\xE5\xBE\xAD",
		"\xE1\xE7" => "\xE5\xBE\xB5",
		"\xE1\xE8" => "\xE5\xBE\xBC",
		"\xE1\xE9" => "\xE8\xA1\xA2",
		"\xE1\xEA" => "\xE5\xBD\xA1",
		"\xE1\xEB" => "\xE7\x8A\xAD",
		"\xE1\xEC" => "\xE7\x8A\xB0",
		"\xE1\xED" => "\xE7\x8A\xB4",
		"\xE1\xEE" => "\xE7\x8A\xB7",
		"\xE1\xEF" => "\xE7\x8A\xB8",
		"\xE1\xF0" => "\xE7\x8B\x83",
		"\xE1\xF1" => "\xE7\x8B\x81",
		"\xE1\xF2" => "\xE7\x8B\x8E",
		"\xE1\xF3" => "\xE7\x8B\x8D",
		"\xE1\xF4" => "\xE7\x8B\x92",
		"\xE1\xF5" => "\xE7\x8B\xA8",
		"\xE1\xF6" => "\xE7\x8B\xAF",
		"\xE1\xF7" => "\xE7\x8B\xA9",
		"\xE1\xF8" => "\xE7\x8B\xB2",
		"\xE1\xF9" => "\xE7\x8B\xB4",
		"\xE1\xFA" => "\xE7\x8B\xB7",
		"\xE1\xFB" => "\xE7\x8C\x81",
		"\xE1\xFC" => "\xE7\x8B\xB3",
		"\xE1\xFD" => "\xE7\x8C\x83",
		"\xE1\xFE" => "\xE7\x8B\xBA",
		"\xE2\xA1" => "\xE7\x8B\xBB",
		"\xE2\xA2" => "\xE7\x8C\x97",
		"\xE2\xA3" => "\xE7\x8C\x93",
		"\xE2\xA4" => "\xE7\x8C\xA1",
		"\xE2\xA5" => "\xE7\x8C\x8A",
		"\xE2\xA6" => "\xE7\x8C\x9E",
		"\xE2\xA7" => "\xE7\x8C\x9D",
		"\xE2\xA8" => "\xE7\x8C\x95",
		"\xE2\xA9" => "\xE7\x8C\xA2",
		"\xE2\xAA" => "\xE7\x8C\xB9",
		"\xE2\xAB" => "\xE7\x8C\xA5",
		"\xE2\xAC" => "\xE7\x8C\xAC",
		"\xE2\xAD" => "\xE7\x8C\xB8",
		"\xE2\xAE" => "\xE7\x8C\xB1",
		"\xE2\xAF" => "\xE7\x8D\x90",
		"\xE2\xB0" => "\xE7\x8D\x8D",
		"\xE2\xB1" => "\xE7\x8D\x97",
		"\xE2\xB2" => "\xE7\x8D\xA0",
		"\xE2\xB3" => "\xE7\x8D\xAC",
		"\xE2\xB4" => "\xE7\x8D\xAF",
		"\xE2\xB5" => "\xE7\x8D\xBE",
		"\xE2\xB6" => "\xE8\x88\x9B",
		"\xE2\xB7" => "\xE5\xA4\xA5",
		"\xE2\xB8" => "\xE9\xA3\xA7",
		"\xE2\xB9" => "\xE5\xA4\xA4",
		"\xE2\xBA" => "\xE5\xA4\x82",
		"\xE2\xBB" => "\xE9\xA5\xA3",
		"\xE2\xBC" => "\xE9\xA5\xA7",
		"\xE2\xBD" => "\xE9\xA5\xA8",
		"\xE2\xBE" => "\xE9\xA5\xA9",
		"\xE2\xBF" => "\xE9\xA5\xAA",
		"\xE2\xC0" => "\xE9\xA5\xAB",
		"\xE2\xC1" => "\xE9\xA5\xAC",
		"\xE2\xC2" => "\xE9\xA5\xB4",
		"\xE2\xC3" => "\xE9\xA5\xB7",
		"\xE2\xC4" => "\xE9\xA5\xBD",
		"\xE2\xC5" => "\xE9\xA6\x80",
		"\xE2\xC6" => "\xE9\xA6\x84",
		"\xE2\xC7" => "\xE9\xA6\x87",
		"\xE2\xC8" => "\xE9\xA6\x8A",
		"\xE2\xC9" => "\xE9\xA6\x8D",
		"\xE2\xCA" => "\xE9\xA6\x90",
		"\xE2\xCB" => "\xE9\xA6\x91",
		"\xE2\xCC" => "\xE9\xA6\x93",
		"\xE2\xCD" => "\xE9\xA6\x94",
		"\xE2\xCE" => "\xE9\xA6\x95",
		"\xE2\xCF" => "\xE5\xBA\x80",
		"\xE2\xD0" => "\xE5\xBA\x91",
		"\xE2\xD1" => "\xE5\xBA\x8B",
		"\xE2\xD2" => "\xE5\xBA\x96",
		"\xE2\xD3" => "\xE5\xBA\xA5",
		"\xE2\xD4" => "\xE5\xBA\xA0",
		"\xE2\xD5" => "\xE5\xBA\xB9",
		"\xE2\xD6" => "\xE5\xBA\xB5",
		"\xE2\xD7" => "\xE5\xBA\xBE",
		"\xE2\xD8" => "\xE5\xBA\xB3",
		"\xE2\xD9" => "\xE8\xB5\x93",
		"\xE2\xDA" => "\xE5\xBB\x92",
		"\xE2\xDB" => "\xE5\xBB\x91",
		"\xE2\xDC" => "\xE5\xBB\x9B",
		"\xE2\xDD" => "\xE5\xBB\xA8",
		"\xE2\xDE" => "\xE5\xBB\xAA",
		"\xE2\xDF" => "\xE8\x86\xBA",
		"\xE2\xE0" => "\xE5\xBF\x84",
		"\xE2\xE1" => "\xE5\xBF\x89",
		"\xE2\xE2" => "\xE5\xBF\x96",
		"\xE2\xE3" => "\xE5\xBF\x8F",
		"\xE2\xE4" => "\xE6\x80\x83",
		"\xE2\xE5" => "\xE5\xBF\xAE",
		"\xE2\xE6" => "\xE6\x80\x84",
		"\xE2\xE7" => "\xE5\xBF\xA1",
		"\xE2\xE8" => "\xE5\xBF\xA4",
		"\xE2\xE9" => "\xE5\xBF\xBE",
		"\xE2\xEA" => "\xE6\x80\x85",
		"\xE2\xEB" => "\xE6\x80\x86",
		"\xE2\xEC" => "\xE5\xBF\xAA",
		"\xE2\xED" => "\xE5\xBF\xAD",
		"\xE2\xEE" => "\xE5\xBF\xB8",
		"\xE2\xEF" => "\xE6\x80\x99",
		"\xE2\xF0" => "\xE6\x80\xB5",
		"\xE2\xF1" => "\xE6\x80\xA6",
		"\xE2\xF2" => "\xE6\x80\x9B",
		"\xE2\xF3" => "\xE6\x80\x8F",
		"\xE2\xF4" => "\xE6\x80\x8D",
		"\xE2\xF5" => "\xE6\x80\xA9",
		"\xE2\xF6" => "\xE6\x80\xAB",
		"\xE2\xF7" => "\xE6\x80\x8A",
		"\xE2\xF8" => "\xE6\x80\xBF",
		"\xE2\xF9" => "\xE6\x80\xA1",
		"\xE2\xFA" => "\xE6\x81\xB8",
		"\xE2\xFB" => "\xE6\x81\xB9",
		"\xE2\xFC" => "\xE6\x81\xBB",
		"\xE2\xFD" => "\xE6\x81\xBA",
		"\xE2\xFE" => "\xE6\x81\x82",
		"\xE3\xA1" => "\xE6\x81\xAA",
		"\xE3\xA2" => "\xE6\x81\xBD",
		"\xE3\xA3" => "\xE6\x82\x96",
		"\xE3\xA4" => "\xE6\x82\x9A",
		"\xE3\xA5" => "\xE6\x82\xAD",
		"\xE3\xA6" => "\xE6\x82\x9D",
		"\xE3\xA7" => "\xE6\x82\x83",
		"\xE3\xA8" => "\xE6\x82\x92",
		"\xE3\xA9" => "\xE6\x82\x8C",
		"\xE3\xAA" => "\xE6\x82\x9B",
		"\xE3\xAB" => "\xE6\x83\xAC",
		"\xE3\xAC" => "\xE6\x82\xBB",
		"\xE3\xAD" => "\xE6\x82\xB1",
		"\xE3\xAE" => "\xE6\x83\x9D",
		"\xE3\xAF" => "\xE6\x83\x98",
		"\xE3\xB0" => "\xE6\x83\x86",
		"\xE3\xB1" => "\xE6\x83\x9A",
		"\xE3\xB2" => "\xE6\x82\xB4",
		"\xE3\xB3" => "\xE6\x84\xA0",
		"\xE3\xB4" => "\xE6\x84\xA6",
		"\xE3\xB5" => "\xE6\x84\x95",
		"\xE3\xB6" => "\xE6\x84\xA3",
		"\xE3\xB7" => "\xE6\x83\xB4",
		"\xE3\xB8" => "\xE6\x84\x80",
		"\xE3\xB9" => "\xE6\x84\x8E",
		"\xE3\xBA" => "\xE6\x84\xAB",
		"\xE3\xBB" => "\xE6\x85\x8A",
		"\xE3\xBC" => "\xE6\x85\xB5",
		"\xE3\xBD" => "\xE6\x86\xAC",
		"\xE3\xBE" => "\xE6\x86\x94",
		"\xE3\xBF" => "\xE6\x86\xA7",
		"\xE3\xC0" => "\xE6\x86\xB7",
		"\xE3\xC1" => "\xE6\x87\x94",
		"\xE3\xC2" => "\xE6\x87\xB5",
		"\xE3\xC3" => "\xE5\xBF\x9D",
		"\xE3\xC4" => "\xE9\x9A\xB3",
		"\xE3\xC5" => "\xE9\x97\xA9",
		"\xE3\xC6" => "\xE9\x97\xAB",
		"\xE3\xC7" => "\xE9\x97\xB1",
		"\xE3\xC8" => "\xE9\x97\xB3",
		"\xE3\xC9" => "\xE9\x97\xB5",
		"\xE3\xCA" => "\xE9\x97\xB6",
		"\xE3\xCB" => "\xE9\x97\xBC",
		"\xE3\xCC" => "\xE9\x97\xBE",
		"\xE3\xCD" => "\xE9\x98\x83",
		"\xE3\xCE" => "\xE9\x98\x84",
		"\xE3\xCF" => "\xE9\x98\x86",
		"\xE3\xD0" => "\xE9\x98\x88",
		"\xE3\xD1" => "\xE9\x98\x8A",
		"\xE3\xD2" => "\xE9\x98\x8B",
		"\xE3\xD3" => "\xE9\x98\x8C",
		"\xE3\xD4" => "\xE9\x98\x8D",
		"\xE3\xD5" => "\xE9\x98\x8F",
		"\xE3\xD6" => "\xE9\x98\x92",
		"\xE3\xD7" => "\xE9\x98\x95",
		"\xE3\xD8" => "\xE9\x98\x96",
		"\xE3\xD9" => "\xE9\x98\x97",
		"\xE3\xDA" => "\xE9\x98\x99",
		"\xE3\xDB" => "\xE9\x98\x9A",
		"\xE3\xDC" => "\xE4\xB8\xAC",
		"\xE3\xDD" => "\xE7\x88\xBF",
		"\xE3\xDE" => "\xE6\x88\x95",
		"\xE3\xDF" => "\xE6\xB0\xB5",
		"\xE3\xE0" => "\xE6\xB1\x94",
		"\xE3\xE1" => "\xE6\xB1\x9C",
		"\xE3\xE2" => "\xE6\xB1\x8A",
		"\xE3\xE3" => "\xE6\xB2\xA3",
		"\xE3\xE4" => "\xE6\xB2\x85",
		"\xE3\xE5" => "\xE6\xB2\x90",
		"\xE3\xE6" => "\xE6\xB2\x94",
		"\xE3\xE7" => "\xE6\xB2\x8C",
		"\xE3\xE8" => "\xE6\xB1\xA8",
		"\xE3\xE9" => "\xE6\xB1\xA9",
		"\xE3\xEA" => "\xE6\xB1\xB4",
		"\xE3\xEB" => "\xE6\xB1\xB6",
		"\xE3\xEC" => "\xE6\xB2\x86",
		"\xE3\xED" => "\xE6\xB2\xA9",
		"\xE3\xEE" => "\xE6\xB3\x90",
		"\xE3\xEF" => "\xE6\xB3\x94",
		"\xE3\xF0" => "\xE6\xB2\xAD",
		"\xE3\xF1" => "\xE6\xB3\xB7",
		"\xE3\xF2" => "\xE6\xB3\xB8",
		"\xE3\xF3" => "\xE6\xB3\xB1",
		"\xE3\xF4" => "\xE6\xB3\x97",
		"\xE3\xF5" => "\xE6\xB2\xB2",
		"\xE3\xF6" => "\xE6\xB3\xA0",
		"\xE3\xF7" => "\xE6\xB3\x96",
		"\xE3\xF8" => "\xE6\xB3\xBA",
		"\xE3\xF9" => "\xE6\xB3\xAB",
		"\xE3\xFA" => "\xE6\xB3\xAE",
		"\xE3\xFB" => "\xE6\xB2\xB1",
		"\xE3\xFC" => "\xE6\xB3\x93",
		"\xE3\xFD" => "\xE6\xB3\xAF",
		"\xE3\xFE" => "\xE6\xB3\xBE",
		"\xE4\xA1" => "\xE6\xB4\xB9",
		"\xE4\xA2" => "\xE6\xB4\xA7",
		"\xE4\xA3" => "\xE6\xB4\x8C",
		"\xE4\xA4" => "\xE6\xB5\x83",
		"\xE4\xA5" => "\xE6\xB5\x88",
		"\xE4\xA6" => "\xE6\xB4\x87",
		"\xE4\xA7" => "\xE6\xB4\x84",
		"\xE4\xA8" => "\xE6\xB4\x99",
		"\xE4\xA9" => "\xE6\xB4\x8E",
		"\xE4\xAA" => "\xE6\xB4\xAB",
		"\xE4\xAB" => "\xE6\xB5\x8D",
		"\xE4\xAC" => "\xE6\xB4\xAE",
		"\xE4\xAD" => "\xE6\xB4\xB5",
		"\xE4\xAE" => "\xE6\xB4\x9A",
		"\xE4\xAF" => "\xE6\xB5\x8F",
		"\xE4\xB0" => "\xE6\xB5\x92",
		"\xE4\xB1" => "\xE6\xB5\x94",
		"\xE4\xB2" => "\xE6\xB4\xB3",
		"\xE4\xB3" => "\xE6\xB6\x91",
		"\xE4\xB4" => "\xE6\xB5\xAF",
		"\xE4\xB5" => "\xE6\xB6\x9E",
		"\xE4\xB6" => "\xE6\xB6\xA0",
		"\xE4\xB7" => "\xE6\xB5\x9E",
		"\xE4\xB8" => "\xE6\xB6\x93",
		"\xE4\xB9" => "\xE6\xB6\x94",
		"\xE4\xBA" => "\xE6\xB5\x9C",
		"\xE4\xBB" => "\xE6\xB5\xA0",
		"\xE4\xBC" => "\xE6\xB5\xBC",
		"\xE4\xBD" => "\xE6\xB5\xA3",
		"\xE4\xBE" => "\xE6\xB8\x9A",
		"\xE4\xBF" => "\xE6\xB7\x87",
		"\xE4\xC0" => "\xE6\xB7\x85",
		"\xE4\xC1" => "\xE6\xB7\x9E",
		"\xE4\xC2" => "\xE6\xB8\x8E",
		"\xE4\xC3" => "\xE6\xB6\xBF",
		"\xE4\xC4" => "\xE6\xB7\xA0",
		"\xE4\xC5" => "\xE6\xB8\x91",
		"\xE4\xC6" => "\xE6\xB7\xA6",
		"\xE4\xC7" => "\xE6\xB7\x9D",
		"\xE4\xC8" => "\xE6\xB7\x99",
		"\xE4\xC9" => "\xE6\xB8\x96",
		"\xE4\xCA" => "\xE6\xB6\xAB",
		"\xE4\xCB" => "\xE6\xB8\x8C",
		"\xE4\xCC" => "\xE6\xB6\xAE",
		"\xE4\xCD" => "\xE6\xB8\xAB",
		"\xE4\xCE" => "\xE6\xB9\xAE",
		"\xE4\xCF" => "\xE6\xB9\x8E",
		"\xE4\xD0" => "\xE6\xB9\xAB",
		"\xE4\xD1" => "\xE6\xBA\xB2",
		"\xE4\xD2" => "\xE6\xB9\x9F",
		"\xE4\xD3" => "\xE6\xBA\x86",
		"\xE4\xD4" => "\xE6\xB9\x93",
		"\xE4\xD5" => "\xE6\xB9\x94",
		"\xE4\xD6" => "\xE6\xB8\xB2",
		"\xE4\xD7" => "\xE6\xB8\xA5",
		"\xE4\xD8" => "\xE6\xB9\x84",
		"\xE4\xD9" => "\xE6\xBB\x9F",
		"\xE4\xDA" => "\xE6\xBA\xB1",
		"\xE4\xDB" => "\xE6\xBA\x98",
		"\xE4\xDC" => "\xE6\xBB\xA0",
		"\xE4\xDD" => "\xE6\xBC\xAD",
		"\xE4\xDE" => "\xE6\xBB\xA2",
		"\xE4\xDF" => "\xE6\xBA\xA5",
		"\xE4\xE0" => "\xE6\xBA\xA7",
		"\xE4\xE1" => "\xE6\xBA\xBD",
		"\xE4\xE2" => "\xE6\xBA\xBB",
		"\xE4\xE3" => "\xE6\xBA\xB7",
		"\xE4\xE4" => "\xE6\xBB\x97",
		"\xE4\xE5" => "\xE6\xBA\xB4",
		"\xE4\xE6" => "\xE6\xBB\x8F",
		"\xE4\xE7" => "\xE6\xBA\x8F",
		"\xE4\xE8" => "\xE6\xBB\x82",
		"\xE4\xE9" => "\xE6\xBA\x9F",
		"\xE4\xEA" => "\xE6\xBD\xA2",
		"\xE4\xEB" => "\xE6\xBD\x86",
		"\xE4\xEC" => "\xE6\xBD\x87",
		"\xE4\xED" => "\xE6\xBC\xA4",
		"\xE4\xEE" => "\xE6\xBC\x95",
		"\xE4\xEF" => "\xE6\xBB\xB9",
		"\xE4\xF0" => "\xE6\xBC\xAF",
		"\xE4\xF1" => "\xE6\xBC\xB6",
		"\xE4\xF2" => "\xE6\xBD\x8B",
		"\xE4\xF3" => "\xE6\xBD\xB4",
		"\xE4\xF4" => "\xE6\xBC\xAA",
		"\xE4\xF5" => "\xE6\xBC\x89",
		"\xE4\xF6" => "\xE6\xBC\xA9",
		"\xE4\xF7" => "\xE6\xBE\x89",
		"\xE4\xF8" => "\xE6\xBE\x8D",
		"\xE4\xF9" => "\xE6\xBE\x8C",
		"\xE4\xFA" => "\xE6\xBD\xB8",
		"\xE4\xFB" => "\xE6\xBD\xB2",
		"\xE4\xFC" => "\xE6\xBD\xBC",
		"\xE4\xFD" => "\xE6\xBD\xBA",
		"\xE4\xFE" => "\xE6\xBF\x91",
		"\xE5\xA1" => "\xE6\xBF\x89",
		"\xE5\xA2" => "\xE6\xBE\xA7",
		"\xE5\xA3" => "\xE6\xBE\xB9",
		"\xE5\xA4" => "\xE6\xBE\xB6",
		"\xE5\xA5" => "\xE6\xBF\x82",
		"\xE5\xA6" => "\xE6\xBF\xA1",
		"\xE5\xA7" => "\xE6\xBF\xAE",
		"\xE5\xA8" => "\xE6\xBF\x9E",
		"\xE5\xA9" => "\xE6\xBF\xA0",
		"\xE5\xAA" => "\xE6\xBF\xAF",
		"\xE5\xAB" => "\xE7\x80\x9A",
		"\xE5\xAC" => "\xE7\x80\xA3",
		"\xE5\xAD" => "\xE7\x80\x9B",
		"\xE5\xAE" => "\xE7\x80\xB9",
		"\xE5\xAF" => "\xE7\x80\xB5",
		"\xE5\xB0" => "\xE7\x81\x8F",
		"\xE5\xB1" => "\xE7\x81\x9E",
		"\xE5\xB2" => "\xE5\xAE\x80",
		"\xE5\xB3" => "\xE5\xAE\x84",
		"\xE5\xB4" => "\xE5\xAE\x95",
		"\xE5\xB5" => "\xE5\xAE\x93",
		"\xE5\xB6" => "\xE5\xAE\xA5",
		"\xE5\xB7" => "\xE5\xAE\xB8",
		"\xE5\xB8" => "\xE7\x94\xAF",
		"\xE5\xB9" => "\xE9\xAA\x9E",
		"\xE5\xBA" => "\xE6\x90\xB4",
		"\xE5\xBB" => "\xE5\xAF\xA4",
		"\xE5\xBC" => "\xE5\xAF\xAE",
		"\xE5\xBD" => "\xE8\xA4\xB0",
		"\xE5\xBE" => "\xE5\xAF\xB0",
		"\xE5\xBF" => "\xE8\xB9\x87",
		"\xE5\xC0" => "\xE8\xAC\x87",
		"\xE5\xC1" => "\xE8\xBE\xB6",
		"\xE5\xC2" => "\xE8\xBF\x93",
		"\xE5\xC3" => "\xE8\xBF\x95",
		"\xE5\xC4" => "\xE8\xBF\xA5",
		"\xE5\xC5" => "\xE8\xBF\xAE",
		"\xE5\xC6" => "\xE8\xBF\xA4",
		"\xE5\xC7" => "\xE8\xBF\xA9",
		"\xE5\xC8" => "\xE8\xBF\xA6",
		"\xE5\xC9" => "\xE8\xBF\xB3",
		"\xE5\xCA" => "\xE8\xBF\xA8",
		"\xE5\xCB" => "\xE9\x80\x85",
		"\xE5\xCC" => "\xE9\x80\x84",
		"\xE5\xCD" => "\xE9\x80\x8B",
		"\xE5\xCE" => "\xE9\x80\xA6",
		"\xE5\xCF" => "\xE9\x80\x91",
		"\xE5\xD0" => "\xE9\x80\x8D",
		"\xE5\xD1" => "\xE9\x80\x96",
		"\xE5\xD2" => "\xE9\x80\xA1",
		"\xE5\xD3" => "\xE9\x80\xB5",
		"\xE5\xD4" => "\xE9\x80\xB6",
		"\xE5\xD5" => "\xE9\x80\xAD",
		"\xE5\xD6" => "\xE9\x80\xAF",
		"\xE5\xD7" => "\xE9\x81\x84",
		"\xE5\xD8" => "\xE9\x81\x91",
		"\xE5\xD9" => "\xE9\x81\x92",
		"\xE5\xDA" => "\xE9\x81\x90",
		"\xE5\xDB" => "\xE9\x81\xA8",
		"\xE5\xDC" => "\xE9\x81\x98",
		"\xE5\xDD" => "\xE9\x81\xA2",
		"\xE5\xDE" => "\xE9\x81\x9B",
		"\xE5\xDF" => "\xE6\x9A\xB9",
		"\xE5\xE0" => "\xE9\x81\xB4",
		"\xE5\xE1" => "\xE9\x81\xBD",
		"\xE5\xE2" => "\xE9\x82\x82",
		"\xE5\xE3" => "\xE9\x82\x88",
		"\xE5\xE4" => "\xE9\x82\x83",
		"\xE5\xE5" => "\xE9\x82\x8B",
		"\xE5\xE6" => "\xE5\xBD\x90",
		"\xE5\xE7" => "\xE5\xBD\x97",
		"\xE5\xE8" => "\xE5\xBD\x96",
		"\xE5\xE9" => "\xE5\xBD\x98",
		"\xE5\xEA" => "\xE5\xB0\xBB",
		"\xE5\xEB" => "\xE5\x92\xAB",
		"\xE5\xEC" => "\xE5\xB1\x90",
		"\xE5\xED" => "\xE5\xB1\x99",
		"\xE5\xEE" => "\xE5\xAD\xB1",
		"\xE5\xEF" => "\xE5\xB1\xA3",
		"\xE5\xF0" => "\xE5\xB1\xA6",
		"\xE5\xF1" => "\xE7\xBE\xBC",
		"\xE5\xF2" => "\xE5\xBC\xAA",
		"\xE5\xF3" => "\xE5\xBC\xA9",
		"\xE5\xF4" => "\xE5\xBC\xAD",
		"\xE5\xF5" => "\xE8\x89\xB4",
		"\xE5\xF6" => "\xE5\xBC\xBC",
		"\xE5\xF7" => "\xE9\xAC\xBB",
		"\xE5\xF8" => "\xE5\xB1\xAE",
		"\xE5\xF9" => "\xE5\xA6\x81",
		"\xE5\xFA" => "\xE5\xA6\x83",
		"\xE5\xFB" => "\xE5\xA6\x8D",
		"\xE5\xFC" => "\xE5\xA6\xA9",
		"\xE5\xFD" => "\xE5\xA6\xAA",
		"\xE5\xFE" => "\xE5\xA6\xA3",
		"\xE6\xA1" => "\xE5\xA6\x97",
		"\xE6\xA2" => "\xE5\xA7\x8A",
		"\xE6\xA3" => "\xE5\xA6\xAB",
		"\xE6\xA4" => "\xE5\xA6\x9E",
		"\xE6\xA5" => "\xE5\xA6\xA4",
		"\xE6\xA6" => "\xE5\xA7\x92",
		"\xE6\xA7" => "\xE5\xA6\xB2",
		"\xE6\xA8" => "\xE5\xA6\xAF",
		"\xE6\xA9" => "\xE5\xA7\x97",
		"\xE6\xAA" => "\xE5\xA6\xBE",
		"\xE6\xAB" => "\xE5\xA8\x85",
		"\xE6\xAC" => "\xE5\xA8\x86",
		"\xE6\xAD" => "\xE5\xA7\x9D",
		"\xE6\xAE" => "\xE5\xA8\x88",
		"\xE6\xAF" => "\xE5\xA7\xA3",
		"\xE6\xB0" => "\xE5\xA7\x98",
		"\xE6\xB1" => "\xE5\xA7\xB9",
		"\xE6\xB2" => "\xE5\xA8\x8C",
		"\xE6\xB3" => "\xE5\xA8\x89",
		"\xE6\xB4" => "\xE5\xA8\xB2",
		"\xE6\xB5" => "\xE5\xA8\xB4",
		"\xE6\xB6" => "\xE5\xA8\x91",
		"\xE6\xB7" => "\xE5\xA8\xA3",
		"\xE6\xB8" => "\xE5\xA8\x93",
		"\xE6\xB9" => "\xE5\xA9\x80",
		"\xE6\xBA" => "\xE5\xA9\xA7",
		"\xE6\xBB" => "\xE5\xA9\x8A",
		"\xE6\xBC" => "\xE5\xA9\x95",
		"\xE6\xBD" => "\xE5\xA8\xBC",
		"\xE6\xBE" => "\xE5\xA9\xA2",
		"\xE6\xBF" => "\xE5\xA9\xB5",
		"\xE6\xC0" => "\xE8\x83\xAC",
		"\xE6\xC1" => "\xE5\xAA\xAA",
		"\xE6\xC2" => "\xE5\xAA\x9B",
		"\xE6\xC3" => "\xE5\xA9\xB7",
		"\xE6\xC4" => "\xE5\xA9\xBA",
		"\xE6\xC5" => "\xE5\xAA\xBE",
		"\xE6\xC6" => "\xE5\xAB\xAB",
		"\xE6\xC7" => "\xE5\xAA\xB2",
		"\xE6\xC8" => "\xE5\xAB\x92",
		"\xE6\xC9" => "\xE5\xAB\x94",
		"\xE6\xCA" => "\xE5\xAA\xB8",
		"\xE6\xCB" => "\xE5\xAB\xA0",
		"\xE6\xCC" => "\xE5\xAB\xA3",
		"\xE6\xCD" => "\xE5\xAB\xB1",
		"\xE6\xCE" => "\xE5\xAB\x96",
		"\xE6\xCF" => "\xE5\xAB\xA6",
		"\xE6\xD0" => "\xE5\xAB\x98",
		"\xE6\xD1" => "\xE5\xAB\x9C",
		"\xE6\xD2" => "\xE5\xAC\x89",
		"\xE6\xD3" => "\xE5\xAC\x97",
		"\xE6\xD4" => "\xE5\xAC\x96",
		"\xE6\xD5" => "\xE5\xAC\xB2",
		"\xE6\xD6" => "\xE5\xAC\xB7",
		"\xE6\xD7" => "\xE5\xAD\x80",
		"\xE6\xD8" => "\xE5\xB0\x95",
		"\xE6\xD9" => "\xE5\xB0\x9C",
		"\xE6\xDA" => "\xE5\xAD\x9A",
		"\xE6\xDB" => "\xE5\xAD\xA5",
		"\xE6\xDC" => "\xE5\xAD\xB3",
		"\xE6\xDD" => "\xE5\xAD\x91",
		"\xE6\xDE" => "\xE5\xAD\x93",
		"\xE6\xDF" => "\xE5\xAD\xA2",
		"\xE6\xE0" => "\xE9\xA9\xB5",
		"\xE6\xE1" => "\xE9\xA9\xB7",
		"\xE6\xE2" => "\xE9\xA9\xB8",
		"\xE6\xE3" => "\xE9\xA9\xBA",
		"\xE6\xE4" => "\xE9\xA9\xBF",
		"\xE6\xE5" => "\xE9\xA9\xBD",
		"\xE6\xE6" => "\xE9\xAA\x80",
		"\xE6\xE7" => "\xE9\xAA\x81",
		"\xE6\xE8" => "\xE9\xAA\x85",
		"\xE6\xE9" => "\xE9\xAA\x88",
		"\xE6\xEA" => "\xE9\xAA\x8A",
		"\xE6\xEB" => "\xE9\xAA\x90",
		"\xE6\xEC" => "\xE9\xAA\x92",
		"\xE6\xED" => "\xE9\xAA\x93",
		"\xE6\xEE" => "\xE9\xAA\x96",
		"\xE6\xEF" => "\xE9\xAA\x98",
		"\xE6\xF0" => "\xE9\xAA\x9B",
		"\xE6\xF1" => "\xE9\xAA\x9C",
		"\xE6\xF2" => "\xE9\xAA\x9D",
		"\xE6\xF3" => "\xE9\xAA\x9F",
		"\xE6\xF4" => "\xE9\xAA\xA0",
		"\xE6\xF5" => "\xE9\xAA\xA2",
		"\xE6\xF6" => "\xE9\xAA\xA3",
		"\xE6\xF7" => "\xE9\xAA\xA5",
		"\xE6\xF8" => "\xE9\xAA\xA7",
		"\xE6\xF9" => "\xE7\xBA\x9F",
		"\xE6\xFA" => "\xE7\xBA\xA1",
		"\xE6\xFB" => "\xE7\xBA\xA3",
		"\xE6\xFC" => "\xE7\xBA\xA5",
		"\xE6\xFD" => "\xE7\xBA\xA8",
		"\xE6\xFE" => "\xE7\xBA\xA9",
		"\xE7\xA1" => "\xE7\xBA\xAD",
		"\xE7\xA2" => "\xE7\xBA\xB0",
		"\xE7\xA3" => "\xE7\xBA\xBE",
		"\xE7\xA4" => "\xE7\xBB\x80",
		"\xE7\xA5" => "\xE7\xBB\x81",
		"\xE7\xA6" => "\xE7\xBB\x82",
		"\xE7\xA7" => "\xE7\xBB\x89",
		"\xE7\xA8" => "\xE7\xBB\x8B",
		"\xE7\xA9" => "\xE7\xBB\x8C",
		"\xE7\xAA" => "\xE7\xBB\x90",
		"\xE7\xAB" => "\xE7\xBB\x94",
		"\xE7\xAC" => "\xE7\xBB\x97",
		"\xE7\xAD" => "\xE7\xBB\x9B",
		"\xE7\xAE" => "\xE7\xBB\xA0",
		"\xE7\xAF" => "\xE7\xBB\xA1",
		"\xE7\xB0" => "\xE7\xBB\xA8",
		"\xE7\xB1" => "\xE7\xBB\xAB",
		"\xE7\xB2" => "\xE7\xBB\xAE",
		"\xE7\xB3" => "\xE7\xBB\xAF",
		"\xE7\xB4" => "\xE7\xBB\xB1",
		"\xE7\xB5" => "\xE7\xBB\xB2",
		"\xE7\xB6" => "\xE7\xBC\x8D",
		"\xE7\xB7" => "\xE7\xBB\xB6",
		"\xE7\xB8" => "\xE7\xBB\xBA",
		"\xE7\xB9" => "\xE7\xBB\xBB",
		"\xE7\xBA" => "\xE7\xBB\xBE",
		"\xE7\xBB" => "\xE7\xBC\x81",
		"\xE7\xBC" => "\xE7\xBC\x82",
		"\xE7\xBD" => "\xE7\xBC\x83",
		"\xE7\xBE" => "\xE7\xBC\x87",
		"\xE7\xBF" => "\xE7\xBC\x88",
		"\xE7\xC0" => "\xE7\xBC\x8B",
		"\xE7\xC1" => "\xE7\xBC\x8C",
		"\xE7\xC2" => "\xE7\xBC\x8F",
		"\xE7\xC3" => "\xE7\xBC\x91",
		"\xE7\xC4" => "\xE7\xBC\x92",
		"\xE7\xC5" => "\xE7\xBC\x97",
		"\xE7\xC6" => "\xE7\xBC\x99",
		"\xE7\xC7" => "\xE7\xBC\x9C",
		"\xE7\xC8" => "\xE7\xBC\x9B",
		"\xE7\xC9" => "\xE7\xBC\x9F",
		"\xE7\xCA" => "\xE7\xBC\xA1",
		"\xE7\xCB" => "\xE7\xBC\xA2",
		"\xE7\xCC" => "\xE7\xBC\xA3",
		"\xE7\xCD" => "\xE7\xBC\xA4",
		"\xE7\xCE" => "\xE7\xBC\xA5",
		"\xE7\xCF" => "\xE7\xBC\xA6",
		"\xE7\xD0" => "\xE7\xBC\xA7",
		"\xE7\xD1" => "\xE7\xBC\xAA",
		"\xE7\xD2" => "\xE7\xBC\xAB",
		"\xE7\xD3" => "\xE7\xBC\xAC",
		"\xE7\xD4" => "\xE7\xBC\xAD",
		"\xE7\xD5" => "\xE7\xBC\xAF",
		"\xE7\xD6" => "\xE7\xBC\xB0",
		"\xE7\xD7" => "\xE7\xBC\xB1",
		"\xE7\xD8" => "\xE7\xBC\xB2",
		"\xE7\xD9" => "\xE7\xBC\xB3",
		"\xE7\xDA" => "\xE7\xBC\xB5",
		"\xE7\xDB" => "\xE5\xB9\xBA",
		"\xE7\xDC" => "\xE7\x95\xBF",
		"\xE7\xDD" => "\xE5\xB7\x9B",
		"\xE7\xDE" => "\xE7\x94\xBE",
		"\xE7\xDF" => "\xE9\x82\x95",
		"\xE7\xE0" => "\xE7\x8E\x8E",
		"\xE7\xE1" => "\xE7\x8E\x91",
		"\xE7\xE2" => "\xE7\x8E\xAE",
		"\xE7\xE3" => "\xE7\x8E\xA2",
		"\xE7\xE4" => "\xE7\x8E\x9F",
		"\xE7\xE5" => "\xE7\x8F\x8F",
		"\xE7\xE6" => "\xE7\x8F\x82",
		"\xE7\xE7" => "\xE7\x8F\x91",
		"\xE7\xE8" => "\xE7\x8E\xB7",
		"\xE7\xE9" => "\xE7\x8E\xB3",
		"\xE7\xEA" => "\xE7\x8F\x80",
		"\xE7\xEB" => "\xE7\x8F\x89",
		"\xE7\xEC" => "\xE7\x8F\x88",
		"\xE7\xED" => "\xE7\x8F\xA5",
		"\xE7\xEE" => "\xE7\x8F\x99",
		"\xE7\xEF" => "\xE9\xA1\xBC",
		"\xE7\xF0" => "\xE7\x90\x8A",
		"\xE7\xF1" => "\xE7\x8F\xA9",
		"\xE7\xF2" => "\xE7\x8F\xA7",
		"\xE7\xF3" => "\xE7\x8F\x9E",
		"\xE7\xF4" => "\xE7\x8E\xBA",
		"\xE7\xF5" => "\xE7\x8F\xB2",
		"\xE7\xF6" => "\xE7\x90\x8F",
		"\xE7\xF7" => "\xE7\x90\xAA",
		"\xE7\xF8" => "\xE7\x91\x9B",
		"\xE7\xF9" => "\xE7\x90\xA6",
		"\xE7\xFA" => "\xE7\x90\xA5",
		"\xE7\xFB" => "\xE7\x90\xA8",
		"\xE7\xFC" => "\xE7\x90\xB0",
		"\xE7\xFD" => "\xE7\x90\xAE",
		"\xE7\xFE" => "\xE7\x90\xAC",
		"\xE8\xA1" => "\xE7\x90\x9B",
		"\xE8\xA2" => "\xE7\x90\x9A",
		"\xE8\xA3" => "\xE7\x91\x81",
		"\xE8\xA4" => "\xE7\x91\x9C",
		"\xE8\xA5" => "\xE7\x91\x97",
		"\xE8\xA6" => "\xE7\x91\x95",
		"\xE8\xA7" => "\xE7\x91\x99",
		"\xE8\xA8" => "\xE7\x91\xB7",
		"\xE8\xA9" => "\xE7\x91\xAD",
		"\xE8\xAA" => "\xE7\x91\xBE",
		"\xE8\xAB" => "\xE7\x92\x9C",
		"\xE8\xAC" => "\xE7\x92\x8E",
		"\xE8\xAD" => "\xE7\x92\x80",
		"\xE8\xAE" => "\xE7\x92\x81",
		"\xE8\xAF" => "\xE7\x92\x87",
		"\xE8\xB0" => "\xE7\x92\x8B",
		"\xE8\xB1" => "\xE7\x92\x9E",
		"\xE8\xB2" => "\xE7\x92\xA8",
		"\xE8\xB3" => "\xE7\x92\xA9",
		"\xE8\xB4" => "\xE7\x92\x90",
		"\xE8\xB5" => "\xE7\x92\xA7",
		"\xE8\xB6" => "\xE7\x93\x92",
		"\xE8\xB7" => "\xE7\x92\xBA",
		"\xE8\xB8" => "\xE9\x9F\xAA",
		"\xE8\xB9" => "\xE9\x9F\xAB",
		"\xE8\xBA" => "\xE9\x9F\xAC",
		"\xE8\xBB" => "\xE6\x9D\x8C",
		"\xE8\xBC" => "\xE6\x9D\x93",
		"\xE8\xBD" => "\xE6\x9D\x9E",
		"\xE8\xBE" => "\xE6\x9D\x88",
		"\xE8\xBF" => "\xE6\x9D\xA9",
		"\xE8\xC0" => "\xE6\x9E\xA5",
		"\xE8\xC1" => "\xE6\x9E\x87",
		"\xE8\xC2" => "\xE6\x9D\xAA",
		"\xE8\xC3" => "\xE6\x9D\xB3",
		"\xE8\xC4" => "\xE6\x9E\x98",
		"\xE8\xC5" => "\xE6\x9E\xA7",
		"\xE8\xC6" => "\xE6\x9D\xB5",
		"\xE8\xC7" => "\xE6\x9E\xA8",
		"\xE8\xC8" => "\xE6\x9E\x9E",
		"\xE8\xC9" => "\xE6\x9E\xAD",
		"\xE8\xCA" => "\xE6\x9E\x8B",
		"\xE8\xCB" => "\xE6\x9D\xB7",
		"\xE8\xCC" => "\xE6\x9D\xBC",
		"\xE8\xCD" => "\xE6\x9F\xB0",
		"\xE8\xCE" => "\xE6\xA0\x89",
		"\xE8\xCF" => "\xE6\x9F\x98",
		"\xE8\xD0" => "\xE6\xA0\x8A",
		"\xE8\xD1" => "\xE6\x9F\xA9",
		"\xE8\xD2" => "\xE6\x9E\xB0",
		"\xE8\xD3" => "\xE6\xA0\x8C",
		"\xE8\xD4" => "\xE6\x9F\x99",
		"\xE8\xD5" => "\xE6\x9E\xB5",
		"\xE8\xD6" => "\xE6\x9F\x9A",
		"\xE8\xD7" => "\xE6\x9E\xB3",
		"\xE8\xD8" => "\xE6\x9F\x9D",
		"\xE8\xD9" => "\xE6\xA0\x80",
		"\xE8\xDA" => "\xE6\x9F\x83",
		"\xE8\xDB" => "\xE6\x9E\xB8",
		"\xE8\xDC" => "\xE6\x9F\xA2",
		"\xE8\xDD" => "\xE6\xA0\x8E",
		"\xE8\xDE" => "\xE6\x9F\x81",
		"\xE8\xDF" => "\xE6\x9F\xBD",
		"\xE8\xE0" => "\xE6\xA0\xB2",
		"\xE8\xE1" => "\xE6\xA0\xB3",
		"\xE8\xE2" => "\xE6\xA1\xA0",
		"\xE8\xE3" => "\xE6\xA1\xA1",
		"\xE8\xE4" => "\xE6\xA1\x8E",
		"\xE8\xE5" => "\xE6\xA1\xA2",
		"\xE8\xE6" => "\xE6\xA1\x84",
		"\xE8\xE7" => "\xE6\xA1\xA4",
		"\xE8\xE8" => "\xE6\xA2\x83",
		"\xE8\xE9" => "\xE6\xA0\x9D",
		"\xE8\xEA" => "\xE6\xA1\x95",
		"\xE8\xEB" => "\xE6\xA1\xA6",
		"\xE8\xEC" => "\xE6\xA1\x81",
		"\xE8\xED" => "\xE6\xA1\xA7",
		"\xE8\xEE" => "\xE6\xA1\x80",
		"\xE8\xEF" => "\xE6\xA0\xBE",
		"\xE8\xF0" => "\xE6\xA1\x8A",
		"\xE8\xF1" => "\xE6\xA1\x89",
		"\xE8\xF2" => "\xE6\xA0\xA9",
		"\xE8\xF3" => "\xE6\xA2\xB5",
		"\xE8\xF4" => "\xE6\xA2\x8F",
		"\xE8\xF5" => "\xE6\xA1\xB4",
		"\xE8\xF6" => "\xE6\xA1\xB7",
		"\xE8\xF7" => "\xE6\xA2\x93",
		"\xE8\xF8" => "\xE6\xA1\xAB",
		"\xE8\xF9" => "\xE6\xA3\x82",
		"\xE8\xFA" => "\xE6\xA5\xAE",
		"\xE8\xFB" => "\xE6\xA3\xBC",
		"\xE8\xFC" => "\xE6\xA4\x9F",
		"\xE8\xFD" => "\xE6\xA4\xA0",
		"\xE8\xFE" => "\xE6\xA3\xB9",
		"\xE9\xA1" => "\xE6\xA4\xA4",
		"\xE9\xA2" => "\xE6\xA3\xB0",
		"\xE9\xA3" => "\xE6\xA4\x8B",
		"\xE9\xA4" => "\xE6\xA4\x81",
		"\xE9\xA5" => "\xE6\xA5\x97",
		"\xE9\xA6" => "\xE6\xA3\xA3",
		"\xE9\xA7" => "\xE6\xA4\x90",
		"\xE9\xA8" => "\xE6\xA5\xB1",
		"\xE9\xA9" => "\xE6\xA4\xB9",
		"\xE9\xAA" => "\xE6\xA5\xA0",
		"\xE9\xAB" => "\xE6\xA5\x82",
		"\xE9\xAC" => "\xE6\xA5\x9D",
		"\xE9\xAD" => "\xE6\xA6\x84",
		"\xE9\xAE" => "\xE6\xA5\xAB",
		"\xE9\xAF" => "\xE6\xA6\x80",
		"\xE9\xB0" => "\xE6\xA6\x98",
		"\xE9\xB1" => "\xE6\xA5\xB8",
		"\xE9\xB2" => "\xE6\xA4\xB4",
		"\xE9\xB3" => "\xE6\xA7\x8C",
		"\xE9\xB4" => "\xE6\xA6\x87",
		"\xE9\xB5" => "\xE6\xA6\x88",
		"\xE9\xB6" => "\xE6\xA7\x8E",
		"\xE9\xB7" => "\xE6\xA6\x89",
		"\xE9\xB8" => "\xE6\xA5\xA6",
		"\xE9\xB9" => "\xE6\xA5\xA3",
		"\xE9\xBA" => "\xE6\xA5\xB9",
		"\xE9\xBB" => "\xE6\xA6\x9B",
		"\xE9\xBC" => "\xE6\xA6\xA7",
		"\xE9\xBD" => "\xE6\xA6\xBB",
		"\xE9\xBE" => "\xE6\xA6\xAB",
		"\xE9\xBF" => "\xE6\xA6\xAD",
		"\xE9\xC0" => "\xE6\xA7\x94",
		"\xE9\xC1" => "\xE6\xA6\xB1",
		"\xE9\xC2" => "\xE6\xA7\x81",
		"\xE9\xC3" => "\xE6\xA7\x8A",
		"\xE9\xC4" => "\xE6\xA7\x9F",
		"\xE9\xC5" => "\xE6\xA6\x95",
		"\xE9\xC6" => "\xE6\xA7\xA0",
		"\xE9\xC7" => "\xE6\xA6\x8D",
		"\xE9\xC8" => "\xE6\xA7\xBF",
		"\xE9\xC9" => "\xE6\xA8\xAF",
		"\xE9\xCA" => "\xE6\xA7\xAD",
		"\xE9\xCB" => "\xE6\xA8\x97",
		"\xE9\xCC" => "\xE6\xA8\x98",
		"\xE9\xCD" => "\xE6\xA9\xA5",
		"\xE9\xCE" => "\xE6\xA7\xB2",
		"\xE9\xCF" => "\xE6\xA9\x84",
		"\xE9\xD0" => "\xE6\xA8\xBE",
		"\xE9\xD1" => "\xE6\xAA\xA0",
		"\xE9\xD2" => "\xE6\xA9\x90",
		"\xE9\xD3" => "\xE6\xA9\x9B",
		"\xE9\xD4" => "\xE6\xA8\xB5",
		"\xE9\xD5" => "\xE6\xAA\x8E",
		"\xE9\xD6" => "\xE6\xA9\xB9",
		"\xE9\xD7" => "\xE6\xA8\xBD",
		"\xE9\xD8" => "\xE6\xA8\xA8",
		"\xE9\xD9" => "\xE6\xA9\x98",
		"\xE9\xDA" => "\xE6\xA9\xBC",
		"\xE9\xDB" => "\xE6\xAA\x91",
		"\xE9\xDC" => "\xE6\xAA\x90",
		"\xE9\xDD" => "\xE6\xAA\xA9",
		"\xE9\xDE" => "\xE6\xAA\x97",
		"\xE9\xDF" => "\xE6\xAA\xAB",
		"\xE9\xE0" => "\xE7\x8C\xB7",
		"\xE9\xE1" => "\xE7\x8D\x92",
		"\xE9\xE2" => "\xE6\xAE\x81",
		"\xE9\xE3" => "\xE6\xAE\x82",
		"\xE9\xE4" => "\xE6\xAE\x87",
		"\xE9\xE5" => "\xE6\xAE\x84",
		"\xE9\xE6" => "\xE6\xAE\x92",
		"\xE9\xE7" => "\xE6\xAE\x93",
		"\xE9\xE8" => "\xE6\xAE\x8D",
		"\xE9\xE9" => "\xE6\xAE\x9A",
		"\xE9\xEA" => "\xE6\xAE\x9B",
		"\xE9\xEB" => "\xE6\xAE\xA1",
		"\xE9\xEC" => "\xE6\xAE\xAA",
		"\xE9\xED" => "\xE8\xBD\xAB",
		"\xE9\xEE" => "\xE8\xBD\xAD",
		"\xE9\xEF" => "\xE8\xBD\xB1",
		"\xE9\xF0" => "\xE8\xBD\xB2",
		"\xE9\xF1" => "\xE8\xBD\xB3",
		"\xE9\xF2" => "\xE8\xBD\xB5",
		"\xE9\xF3" => "\xE8\xBD\xB6",
		"\xE9\xF4" => "\xE8\xBD\xB8",
		"\xE9\xF5" => "\xE8\xBD\xB7",
		"\xE9\xF6" => "\xE8\xBD\xB9",
		"\xE9\xF7" => "\xE8\xBD\xBA",
		"\xE9\xF8" => "\xE8\xBD\xBC",
		"\xE9\xF9" => "\xE8\xBD\xBE",
		"\xE9\xFA" => "\xE8\xBE\x81",
		"\xE9\xFB" => "\xE8\xBE\x82",
		"\xE9\xFC" => "\xE8\xBE\x84",
		"\xE9\xFD" => "\xE8\xBE\x87",
		"\xE9\xFE" => "\xE8\xBE\x8B",
		"\xEA\xA1" => "\xE8\xBE\x8D",
		"\xEA\xA2" => "\xE8\xBE\x8E",
		"\xEA\xA3" => "\xE8\xBE\x8F",
		"\xEA\xA4" => "\xE8\xBE\x98",
		"\xEA\xA5" => "\xE8\xBE\x9A",
		"\xEA\xA6" => "\xE8\xBB\x8E",
		"\xEA\xA7" => "\xE6\x88\x8B",
		"\xEA\xA8" => "\xE6\x88\x97",
		"\xEA\xA9" => "\xE6\x88\x9B",
		"\xEA\xAA" => "\xE6\x88\x9F",
		"\xEA\xAB" => "\xE6\x88\xA2",
		"\xEA\xAC" => "\xE6\x88\xA1",
		"\xEA\xAD" => "\xE6\x88\xA5",
		"\xEA\xAE" => "\xE6\x88\xA4",
		"\xEA\xAF" => "\xE6\x88\xAC",
		"\xEA\xB0" => "\xE8\x87\xA7",
		"\xEA\xB1" => "\xE7\x93\xAF",
		"\xEA\xB2" => "\xE7\x93\xB4",
		"\xEA\xB3" => "\xE7\x93\xBF",
		"\xEA\xB4" => "\xE7\x94\x8F",
		"\xEA\xB5" => "\xE7\x94\x91",
		"\xEA\xB6" => "\xE7\x94\x93",
		"\xEA\xB7" => "\xE6\x94\xB4",
		"\xEA\xB8" => "\xE6\x97\xAE",
		"\xEA\xB9" => "\xE6\x97\xAF",
		"\xEA\xBA" => "\xE6\x97\xB0",
		"\xEA\xBB" => "\xE6\x98\x8A",
		"\xEA\xBC" => "\xE6\x98\x99",
		"\xEA\xBD" => "\xE6\x9D\xB2",
		"\xEA\xBE" => "\xE6\x98\x83",
		"\xEA\xBF" => "\xE6\x98\x95",
		"\xEA\xC0" => "\xE6\x98\x80",
		"\xEA\xC1" => "\xE7\x82\x85",
		"\xEA\xC2" => "\xE6\x9B\xB7",
		"\xEA\xC3" => "\xE6\x98\x9D",
		"\xEA\xC4" => "\xE6\x98\xB4",
		"\xEA\xC5" => "\xE6\x98\xB1",
		"\xEA\xC6" => "\xE6\x98\xB6",
		"\xEA\xC7" => "\xE6\x98\xB5",
		"\xEA\xC8" => "\xE8\x80\x86",
		"\xEA\xC9" => "\xE6\x99\x9F",
		"\xEA\xCA" => "\xE6\x99\x94",
		"\xEA\xCB" => "\xE6\x99\x81",
		"\xEA\xCC" => "\xE6\x99\x8F",
		"\xEA\xCD" => "\xE6\x99\x96",
		"\xEA\xCE" => "\xE6\x99\xA1",
		"\xEA\xCF" => "\xE6\x99\x97",
		"\xEA\xD0" => "\xE6\x99\xB7",
		"\xEA\xD1" => "\xE6\x9A\x84",
		"\xEA\xD2" => "\xE6\x9A\x8C",
		"\xEA\xD3" => "\xE6\x9A\xA7",
		"\xEA\xD4" => "\xE6\x9A\x9D",
		"\xEA\xD5" => "\xE6\x9A\xBE",
		"\xEA\xD6" => "\xE6\x9B\x9B",
		"\xEA\xD7" => "\xE6\x9B\x9C",
		"\xEA\xD8" => "\xE6\x9B\xA6",
		"\xEA\xD9" => "\xE6\x9B\xA9",
		"\xEA\xDA" => "\xE8\xB4\xB2",
		"\xEA\xDB" => "\xE8\xB4\xB3",
		"\xEA\xDC" => "\xE8\xB4\xB6",
		"\xEA\xDD" => "\xE8\xB4\xBB",
		"\xEA\xDE" => "\xE8\xB4\xBD",
		"\xEA\xDF" => "\xE8\xB5\x80",
		"\xEA\xE0" => "\xE8\xB5\x85",
		"\xEA\xE1" => "\xE8\xB5\x86",
		"\xEA\xE2" => "\xE8\xB5\x88",
		"\xEA\xE3" => "\xE8\xB5\x89",
		"\xEA\xE4" => "\xE8\xB5\x87",
		"\xEA\xE5" => "\xE8\xB5\x8D",
		"\xEA\xE6" => "\xE8\xB5\x95",
		"\xEA\xE7" => "\xE8\xB5\x99",
		"\xEA\xE8" => "\xE8\xA7\x87",
		"\xEA\xE9" => "\xE8\xA7\x8A",
		"\xEA\xEA" => "\xE8\xA7\x8B",
		"\xEA\xEB" => "\xE8\xA7\x8C",
		"\xEA\xEC" => "\xE8\xA7\x8E",
		"\xEA\xED" => "\xE8\xA7\x8F",
		"\xEA\xEE" => "\xE8\xA7\x90",
		"\xEA\xEF" => "\xE8\xA7\x91",
		"\xEA\xF0" => "\xE7\x89\xAE",
		"\xEA\xF1" => "\xE7\x8A\x9F",
		"\xEA\xF2" => "\xE7\x89\x9D",
		"\xEA\xF3" => "\xE7\x89\xA6",
		"\xEA\xF4" => "\xE7\x89\xAF",
		"\xEA\xF5" => "\xE7\x89\xBE",
		"\xEA\xF6" => "\xE7\x89\xBF",
		"\xEA\xF7" => "\xE7\x8A\x84",
		"\xEA\xF8" => "\xE7\x8A\x8B",
		"\xEA\xF9" => "\xE7\x8A\x8D",
		"\xEA\xFA" => "\xE7\x8A\x8F",
		"\xEA\xFB" => "\xE7\x8A\x92",
		"\xEA\xFC" => "\xE6\x8C\x88",
		"\xEA\xFD" => "\xE6\x8C\xB2",
		"\xEA\xFE" => "\xE6\x8E\xB0",
		"\xEB\xA1" => "\xE6\x90\xBF",
		"\xEB\xA2" => "\xE6\x93\x98",
		"\xEB\xA3" => "\xE8\x80\x84",
		"\xEB\xA4" => "\xE6\xAF\xAA",
		"\xEB\xA5" => "\xE6\xAF\xB3",
		"\xEB\xA6" => "\xE6\xAF\xBD",
		"\xEB\xA7" => "\xE6\xAF\xB5",
		"\xEB\xA8" => "\xE6\xAF\xB9",
		"\xEB\xA9" => "\xE6\xB0\x85",
		"\xEB\xAA" => "\xE6\xB0\x87",
		"\xEB\xAB" => "\xE6\xB0\x86",
		"\xEB\xAC" => "\xE6\xB0\x8D",
		"\xEB\xAD" => "\xE6\xB0\x95",
		"\xEB\xAE" => "\xE6\xB0\x98",
		"\xEB\xAF" => "\xE6\xB0\x99",
		"\xEB\xB0" => "\xE6\xB0\x9A",
		"\xEB\xB1" => "\xE6\xB0\xA1",
		"\xEB\xB2" => "\xE6\xB0\xA9",
		"\xEB\xB3" => "\xE6\xB0\xA4",
		"\xEB\xB4" => "\xE6\xB0\xAA",
		"\xEB\xB5" => "\xE6\xB0\xB2",
		"\xEB\xB6" => "\xE6\x94\xB5",
		"\xEB\xB7" => "\xE6\x95\x95",
		"\xEB\xB8" => "\xE6\x95\xAB",
		"\xEB\xB9" => "\xE7\x89\x8D",
		"\xEB\xBA" => "\xE7\x89\x92",
		"\xEB\xBB" => "\xE7\x89\x96",
		"\xEB\xBC" => "\xE7\x88\xB0",
		"\xEB\xBD" => "\xE8\x99\xA2",
		"\xEB\xBE" => "\xE5\x88\x96",
		"\xEB\xBF" => "\xE8\x82\x9F",
		"\xEB\xC0" => "\xE8\x82\x9C",
		"\xEB\xC1" => "\xE8\x82\x93",
		"\xEB\xC2" => "\xE8\x82\xBC",
		"\xEB\xC3" => "\xE6\x9C\x8A",
		"\xEB\xC4" => "\xE8\x82\xBD",
		"\xEB\xC5" => "\xE8\x82\xB1",
		"\xEB\xC6" => "\xE8\x82\xAB",
		"\xEB\xC7" => "\xE8\x82\xAD",
		"\xEB\xC8" => "\xE8\x82\xB4",
		"\xEB\xC9" => "\xE8\x82\xB7",
		"\xEB\xCA" => "\xE8\x83\xA7",
		"\xEB\xCB" => "\xE8\x83\xA8",
		"\xEB\xCC" => "\xE8\x83\xA9",
		"\xEB\xCD" => "\xE8\x83\xAA",
		"\xEB\xCE" => "\xE8\x83\x9B",
		"\xEB\xCF" => "\xE8\x83\x82",
		"\xEB\xD0" => "\xE8\x83\x84",
		"\xEB\xD1" => "\xE8\x83\x99",
		"\xEB\xD2" => "\xE8\x83\x8D",
		"\xEB\xD3" => "\xE8\x83\x97",
		"\xEB\xD4" => "\xE6\x9C\x90",
		"\xEB\xD5" => "\xE8\x83\x9D",
		"\xEB\xD6" => "\xE8\x83\xAB",
		"\xEB\xD7" => "\xE8\x83\xB1",
		"\xEB\xD8" => "\xE8\x83\xB4",
		"\xEB\xD9" => "\xE8\x83\xAD",
		"\xEB\xDA" => "\xE8\x84\x8D",
		"\xEB\xDB" => "\xE8\x84\x8E",
		"\xEB\xDC" => "\xE8\x83\xB2",
		"\xEB\xDD" => "\xE8\x83\xBC",
		"\xEB\xDE" => "\xE6\x9C\x95",
		"\xEB\xDF" => "\xE8\x84\x92",
		"\xEB\xE0" => "\xE8\xB1\x9A",
		"\xEB\xE1" => "\xE8\x84\xB6",
		"\xEB\xE2" => "\xE8\x84\x9E",
		"\xEB\xE3" => "\xE8\x84\xAC",
		"\xEB\xE4" => "\xE8\x84\x98",
		"\xEB\xE5" => "\xE8\x84\xB2",
		"\xEB\xE6" => "\xE8\x85\x88",
		"\xEB\xE7" => "\xE8\x85\x8C",
		"\xEB\xE8" => "\xE8\x85\x93",
		"\xEB\xE9" => "\xE8\x85\xB4",
		"\xEB\xEA" => "\xE8\x85\x99",
		"\xEB\xEB" => "\xE8\x85\x9A",
		"\xEB\xEC" => "\xE8\x85\xB1",
		"\xEB\xED" => "\xE8\x85\xA0",
		"\xEB\xEE" => "\xE8\x85\xA9",
		"\xEB\xEF" => "\xE8\x85\xBC",
		"\xEB\xF0" => "\xE8\x85\xBD",
		"\xEB\xF1" => "\xE8\x85\xAD",
		"\xEB\xF2" => "\xE8\x85\xA7",
		"\xEB\xF3" => "\xE5\xA1\x8D",
		"\xEB\xF4" => "\xE5\xAA\xB5",
		"\xEB\xF5" => "\xE8\x86\x88",
		"\xEB\xF6" => "\xE8\x86\x82",
		"\xEB\xF7" => "\xE8\x86\x91",
		"\xEB\xF8" => "\xE6\xBB\x95",
		"\xEB\xF9" => "\xE8\x86\xA3",
		"\xEB\xFA" => "\xE8\x86\xAA",
		"\xEB\xFB" => "\xE8\x87\x8C",
		"\xEB\xFC" => "\xE6\x9C\xA6",
		"\xEB\xFD" => "\xE8\x87\x8A",
		"\xEB\xFE" => "\xE8\x86\xBB",
		"\xEC\xA1" => "\xE8\x87\x81",
		"\xEC\xA2" => "\xE8\x86\xA6",
		"\xEC\xA3" => "\xE6\xAC\xA4",
		"\xEC\xA4" => "\xE6\xAC\xB7",
		"\xEC\xA5" => "\xE6\xAC\xB9",
		"\xEC\xA6" => "\xE6\xAD\x83",
		"\xEC\xA7" => "\xE6\xAD\x86",
		"\xEC\xA8" => "\xE6\xAD\x99",
		"\xEC\xA9" => "\xE9\xA3\x91",
		"\xEC\xAA" => "\xE9\xA3\x92",
		"\xEC\xAB" => "\xE9\xA3\x93",
		"\xEC\xAC" => "\xE9\xA3\x95",
		"\xEC\xAD" => "\xE9\xA3\x99",
		"\xEC\xAE" => "\xE9\xA3\x9A",
		"\xEC\xAF" => "\xE6\xAE\xB3",
		"\xEC\xB0" => "\xE5\xBD\x80",
		"\xEC\xB1" => "\xE6\xAF\x82",
		"\xEC\xB2" => "\xE8\xA7\xB3",
		"\xEC\xB3" => "\xE6\x96\x90",
		"\xEC\xB4" => "\xE9\xBD\x91",
		"\xEC\xB5" => "\xE6\x96\x93",
		"\xEC\xB6" => "\xE6\x96\xBC",
		"\xEC\xB7" => "\xE6\x97\x86",
		"\xEC\xB8" => "\xE6\x97\x84",
		"\xEC\xB9" => "\xE6\x97\x83",
		"\xEC\xBA" => "\xE6\x97\x8C",
		"\xEC\xBB" => "\xE6\x97\x8E",
		"\xEC\xBC" => "\xE6\x97\x92",
		"\xEC\xBD" => "\xE6\x97\x96",
		"\xEC\xBE" => "\xE7\x82\x80",
		"\xEC\xBF" => "\xE7\x82\x9C",
		"\xEC\xC0" => "\xE7\x82\x96",
		"\xEC\xC1" => "\xE7\x82\x9D",
		"\xEC\xC2" => "\xE7\x82\xBB",
		"\xEC\xC3" => "\xE7\x83\x80",
		"\xEC\xC4" => "\xE7\x82\xB7",
		"\xEC\xC5" => "\xE7\x82\xAB",
		"\xEC\xC6" => "\xE7\x82\xB1",
		"\xEC\xC7" => "\xE7\x83\xA8",
		"\xEC\xC8" => "\xE7\x83\x8A",
		"\xEC\xC9" => "\xE7\x84\x90",
		"\xEC\xCA" => "\xE7\x84\x93",
		"\xEC\xCB" => "\xE7\x84\x96",
		"\xEC\xCC" => "\xE7\x84\xAF",
		"\xEC\xCD" => "\xE7\x84\xB1",
		"\xEC\xCE" => "\xE7\x85\xB3",
		"\xEC\xCF" => "\xE7\x85\x9C",
		"\xEC\xD0" => "\xE7\x85\xA8",
		"\xEC\xD1" => "\xE7\x85\x85",
		"\xEC\xD2" => "\xE7\x85\xB2",
		"\xEC\xD3" => "\xE7\x85\x8A",
		"\xEC\xD4" => "\xE7\x85\xB8",
		"\xEC\xD5" => "\xE7\x85\xBA",
		"\xEC\xD6" => "\xE7\x86\x98",
		"\xEC\xD7" => "\xE7\x86\xB3",
		"\xEC\xD8" => "\xE7\x86\xB5",
		"\xEC\xD9" => "\xE7\x86\xA8",
		"\xEC\xDA" => "\xE7\x86\xA0",
		"\xEC\xDB" => "\xE7\x87\xA0",
		"\xEC\xDC" => "\xE7\x87\x94",
		"\xEC\xDD" => "\xE7\x87\xA7",
		"\xEC\xDE" => "\xE7\x87\xB9",
		"\xEC\xDF" => "\xE7\x88\x9D",
		"\xEC\xE0" => "\xE7\x88\xA8",
		"\xEC\xE1" => "\xE7\x81\xAC",
		"\xEC\xE2" => "\xE7\x84\x98",
		"\xEC\xE3" => "\xE7\x85\xA6",
		"\xEC\xE4" => "\xE7\x86\xB9",
		"\xEC\xE5" => "\xE6\x88\xBE",
		"\xEC\xE6" => "\xE6\x88\xBD",
		"\xEC\xE7" => "\xE6\x89\x83",
		"\xEC\xE8" => "\xE6\x89\x88",
		"\xEC\xE9" => "\xE6\x89\x89",
		"\xEC\xEA" => "\xE7\xA4\xBB",
		"\xEC\xEB" => "\xE7\xA5\x80",
		"\xEC\xEC" => "\xE7\xA5\x86",
		"\xEC\xED" => "\xE7\xA5\x89",
		"\xEC\xEE" => "\xE7\xA5\x9B",
		"\xEC\xEF" => "\xE7\xA5\x9C",
		"\xEC\xF0" => "\xE7\xA5\x93",
		"\xEC\xF1" => "\xE7\xA5\x9A",
		"\xEC\xF2" => "\xE7\xA5\xA2",
		"\xEC\xF3" => "\xE7\xA5\x97",
		"\xEC\xF4" => "\xE7\xA5\xA0",
		"\xEC\xF5" => "\xE7\xA5\xAF",
		"\xEC\xF6" => "\xE7\xA5\xA7",
		"\xEC\xF7" => "\xE7\xA5\xBA",
		"\xEC\xF8" => "\xE7\xA6\x85",
		"\xEC\xF9" => "\xE7\xA6\x8A",
		"\xEC\xFA" => "\xE7\xA6\x9A",
		"\xEC\xFB" => "\xE7\xA6\xA7",
		"\xEC\xFC" => "\xE7\xA6\xB3",
		"\xEC\xFD" => "\xE5\xBF\x91",
		"\xEC\xFE" => "\xE5\xBF\x90",
		"\xED\xA1" => "\xE6\x80\xBC",
		"\xED\xA2" => "\xE6\x81\x9D",
		"\xED\xA3" => "\xE6\x81\x9A",
		"\xED\xA4" => "\xE6\x81\xA7",
		"\xED\xA5" => "\xE6\x81\x81",
		"\xED\xA6" => "\xE6\x81\x99",
		"\xED\xA7" => "\xE6\x81\xA3",
		"\xED\xA8" => "\xE6\x82\xAB",
		"\xED\xA9" => "\xE6\x84\x86",
		"\xED\xAA" => "\xE6\x84\x8D",
		"\xED\xAB" => "\xE6\x85\x9D",
		"\xED\xAC" => "\xE6\x86\xA9",
		"\xED\xAD" => "\xE6\x86\x9D",
		"\xED\xAE" => "\xE6\x87\x8B",
		"\xED\xAF" => "\xE6\x87\x91",
		"\xED\xB0" => "\xE6\x88\x86",
		"\xED\xB1" => "\xE8\x82\x80",
		"\xED\xB2" => "\xE8\x81\xBF",
		"\xED\xB3" => "\xE6\xB2\x93",
		"\xED\xB4" => "\xE6\xB3\xB6",
		"\xED\xB5" => "\xE6\xB7\xBC",
		"\xED\xB6" => "\xE7\x9F\xB6",
		"\xED\xB7" => "\xE7\x9F\xB8",
		"\xED\xB8" => "\xE7\xA0\x80",
		"\xED\xB9" => "\xE7\xA0\x89",
		"\xED\xBA" => "\xE7\xA0\x97",
		"\xED\xBB" => "\xE7\xA0\x98",
		"\xED\xBC" => "\xE7\xA0\x91",
		"\xED\xBD" => "\xE6\x96\xAB",
		"\xED\xBE" => "\xE7\xA0\xAD",
		"\xED\xBF" => "\xE7\xA0\x9C",
		"\xED\xC0" => "\xE7\xA0\x9D",
		"\xED\xC1" => "\xE7\xA0\xB9",
		"\xED\xC2" => "\xE7\xA0\xBA",
		"\xED\xC3" => "\xE7\xA0\xBB",
		"\xED\xC4" => "\xE7\xA0\x9F",
		"\xED\xC5" => "\xE7\xA0\xBC",
		"\xED\xC6" => "\xE7\xA0\xA5",
		"\xED\xC7" => "\xE7\xA0\xAC",
		"\xED\xC8" => "\xE7\xA0\xA3",
		"\xED\xC9" => "\xE7\xA0\xA9",
		"\xED\xCA" => "\xE7\xA1\x8E",
		"\xED\xCB" => "\xE7\xA1\xAD",
		"\xED\xCC" => "\xE7\xA1\x96",
		"\xED\xCD" => "\xE7\xA1\x97",
		"\xED\xCE" => "\xE7\xA0\xA6",
		"\xED\xCF" => "\xE7\xA1\x90",
		"\xED\xD0" => "\xE7\xA1\x87",
		"\xED\xD1" => "\xE7\xA1\x8C",
		"\xED\xD2" => "\xE7\xA1\xAA",
		"\xED\xD3" => "\xE7\xA2\x9B",
		"\xED\xD4" => "\xE7\xA2\x93",
		"\xED\xD5" => "\xE7\xA2\x9A",
		"\xED\xD6" => "\xE7\xA2\x87",
		"\xED\xD7" => "\xE7\xA2\x9C",
		"\xED\xD8" => "\xE7\xA2\xA1",
		"\xED\xD9" => "\xE7\xA2\xA3",
		"\xED\xDA" => "\xE7\xA2\xB2",
		"\xED\xDB" => "\xE7\xA2\xB9",
		"\xED\xDC" => "\xE7\xA2\xA5",
		"\xED\xDD" => "\xE7\xA3\x94",
		"\xED\xDE" => "\xE7\xA3\x99",
		"\xED\xDF" => "\xE7\xA3\x89",
		"\xED\xE0" => "\xE7\xA3\xAC",
		"\xED\xE1" => "\xE7\xA3\xB2",
		"\xED\xE2" => "\xE7\xA4\x85",
		"\xED\xE3" => "\xE7\xA3\xB4",
		"\xED\xE4" => "\xE7\xA4\x93",
		"\xED\xE5" => "\xE7\xA4\xA4",
		"\xED\xE6" => "\xE7\xA4\x9E",
		"\xED\xE7" => "\xE7\xA4\xB4",
		"\xED\xE8" => "\xE9\xBE\x9B",
		"\xED\xE9" => "\xE9\xBB\xB9",
		"\xED\xEA" => "\xE9\xBB\xBB",
		"\xED\xEB" => "\xE9\xBB\xBC",
		"\xED\xEC" => "\xE7\x9B\xB1",
		"\xED\xED" => "\xE7\x9C\x84",
		"\xED\xEE" => "\xE7\x9C\x8D",
		"\xED\xEF" => "\xE7\x9B\xB9",
		"\xED\xF0" => "\xE7\x9C\x87",
		"\xED\xF1" => "\xE7\x9C\x88",
		"\xED\xF2" => "\xE7\x9C\x9A",
		"\xED\xF3" => "\xE7\x9C\xA2",
		"\xED\xF4" => "\xE7\x9C\x99",
		"\xED\xF5" => "\xE7\x9C\xAD",
		"\xED\xF6" => "\xE7\x9C\xA6",
		"\xED\xF7" => "\xE7\x9C\xB5",
		"\xED\xF8" => "\xE7\x9C\xB8",
		"\xED\xF9" => "\xE7\x9D\x90",
		"\xED\xFA" => "\xE7\x9D\x91",
		"\xED\xFB" => "\xE7\x9D\x87",
		"\xED\xFC" => "\xE7\x9D\x83",
		"\xED\xFD" => "\xE7\x9D\x9A",
		"\xED\xFE" => "\xE7\x9D\xA8",
		"\xEE\xA1" => "\xE7\x9D\xA2",
		"\xEE\xA2" => "\xE7\x9D\xA5",
		"\xEE\xA3" => "\xE7\x9D\xBF",
		"\xEE\xA4" => "\xE7\x9E\x8D",
		"\xEE\xA5" => "\xE7\x9D\xBD",
		"\xEE\xA6" => "\xE7\x9E\x80",
		"\xEE\xA7" => "\xE7\x9E\x8C",
		"\xEE\xA8" => "\xE7\x9E\x91",
		"\xEE\xA9" => "\xE7\x9E\x9F",
		"\xEE\xAA" => "\xE7\x9E\xA0",
		"\xEE\xAB" => "\xE7\x9E\xB0",
		"\xEE\xAC" => "\xE7\x9E\xB5",
		"\xEE\xAD" => "\xE7\x9E\xBD",
		"\xEE\xAE" => "\xE7\x94\xBA",
		"\xEE\xAF" => "\xE7\x95\x80",
		"\xEE\xB0" => "\xE7\x95\x8E",
		"\xEE\xB1" => "\xE7\x95\x8B",
		"\xEE\xB2" => "\xE7\x95\x88",
		"\xEE\xB3" => "\xE7\x95\x9B",
		"\xEE\xB4" => "\xE7\x95\xB2",
		"\xEE\xB5" => "\xE7\x95\xB9",
		"\xEE\xB6" => "\xE7\x96\x83",
		"\xEE\xB7" => "\xE7\xBD\x98",
		"\xEE\xB8" => "\xE7\xBD\xA1",
		"\xEE\xB9" => "\xE7\xBD\x9F",
		"\xEE\xBA" => "\xE8\xA9\x88",
		"\xEE\xBB" => "\xE7\xBD\xA8",
		"\xEE\xBC" => "\xE7\xBD\xB4",
		"\xEE\xBD" => "\xE7\xBD\xB1",
		"\xEE\xBE" => "\xE7\xBD\xB9",
		"\xEE\xBF" => "\xE7\xBE\x81",
		"\xEE\xC0" => "\xE7\xBD\xBE",
		"\xEE\xC1" => "\xE7\x9B\x8D",
		"\xEE\xC2" => "\xE7\x9B\xA5",
		"\xEE\xC3" => "\xE8\xA0\xB2",
		"\xEE\xC4" => "\xE9\x92\x85",
		"\xEE\xC5" => "\xE9\x92\x86",
		"\xEE\xC6" => "\xE9\x92\x87",
		"\xEE\xC7" => "\xE9\x92\x8B",
		"\xEE\xC8" => "\xE9\x92\x8A",
		"\xEE\xC9" => "\xE9\x92\x8C",
		"\xEE\xCA" => "\xE9\x92\x8D",
		"\xEE\xCB" => "\xE9\x92\x8F",
		"\xEE\xCC" => "\xE9\x92\x90",
		"\xEE\xCD" => "\xE9\x92\x94",
		"\xEE\xCE" => "\xE9\x92\x97",
		"\xEE\xCF" => "\xE9\x92\x95",
		"\xEE\xD0" => "\xE9\x92\x9A",
		"\xEE\xD1" => "\xE9\x92\x9B",
		"\xEE\xD2" => "\xE9\x92\x9C",
		"\xEE\xD3" => "\xE9\x92\xA3",
		"\xEE\xD4" => "\xE9\x92\xA4",
		"\xEE\xD5" => "\xE9\x92\xAB",
		"\xEE\xD6" => "\xE9\x92\xAA",
		"\xEE\xD7" => "\xE9\x92\xAD",
		"\xEE\xD8" => "\xE9\x92\xAC",
		"\xEE\xD9" => "\xE9\x92\xAF",
		"\xEE\xDA" => "\xE9\x92\xB0",
		"\xEE\xDB" => "\xE9\x92\xB2",
		"\xEE\xDC" => "\xE9\x92\xB4",
		"\xEE\xDD" => "\xE9\x92\xB6",
		"\xEE\xDE" => "\xE9\x92\xB7",
		"\xEE\xDF" => "\xE9\x92\xB8",
		"\xEE\xE0" => "\xE9\x92\xB9",
		"\xEE\xE1" => "\xE9\x92\xBA",
		"\xEE\xE2" => "\xE9\x92\xBC",
		"\xEE\xE3" => "\xE9\x92\xBD",
		"\xEE\xE4" => "\xE9\x92\xBF",
		"\xEE\xE5" => "\xE9\x93\x84",
		"\xEE\xE6" => "\xE9\x93\x88",
		"\xEE\xE7" => "\xE9\x93\x89",
		"\xEE\xE8" => "\xE9\x93\x8A",
		"\xEE\xE9" => "\xE9\x93\x8B",
		"\xEE\xEA" => "\xE9\x93\x8C",
		"\xEE\xEB" => "\xE9\x93\x8D",
		"\xEE\xEC" => "\xE9\x93\x8E",
		"\xEE\xED" => "\xE9\x93\x90",
		"\xEE\xEE" => "\xE9\x93\x91",
		"\xEE\xEF" => "\xE9\x93\x92",
		"\xEE\xF0" => "\xE9\x93\x95",
		"\xEE\xF1" => "\xE9\x93\x96",
		"\xEE\xF2" => "\xE9\x93\x97",
		"\xEE\xF3" => "\xE9\x93\x99",
		"\xEE\xF4" => "\xE9\x93\x98",
		"\xEE\xF5" => "\xE9\x93\x9B",
		"\xEE\xF6" => "\xE9\x93\x9E",
		"\xEE\xF7" => "\xE9\x93\x9F",
		"\xEE\xF8" => "\xE9\x93\xA0",
		"\xEE\xF9" => "\xE9\x93\xA2",
		"\xEE\xFA" => "\xE9\x93\xA4",
		"\xEE\xFB" => "\xE9\x93\xA5",
		"\xEE\xFC" => "\xE9\x93\xA7",
		"\xEE\xFD" => "\xE9\x93\xA8",
		"\xEE\xFE" => "\xE9\x93\xAA",
		"\xEF\xA1" => "\xE9\x93\xA9",
		"\xEF\xA2" => "\xE9\x93\xAB",
		"\xEF\xA3" => "\xE9\x93\xAE",
		"\xEF\xA4" => "\xE9\x93\xAF",
		"\xEF\xA5" => "\xE9\x93\xB3",
		"\xEF\xA6" => "\xE9\x93\xB4",
		"\xEF\xA7" => "\xE9\x93\xB5",
		"\xEF\xA8" => "\xE9\x93\xB7",
		"\xEF\xA9" => "\xE9\x93\xB9",
		"\xEF\xAA" => "\xE9\x93\xBC",
		"\xEF\xAB" => "\xE9\x93\xBD",
		"\xEF\xAC" => "\xE9\x93\xBF",
		"\xEF\xAD" => "\xE9\x94\x83",
		"\xEF\xAE" => "\xE9\x94\x82",
		"\xEF\xAF" => "\xE9\x94\x86",
		"\xEF\xB0" => "\xE9\x94\x87",
		"\xEF\xB1" => "\xE9\x94\x89",
		"\xEF\xB2" => "\xE9\x94\x8A",
		"\xEF\xB3" => "\xE9\x94\x8D",
		"\xEF\xB4" => "\xE9\x94\x8E",
		"\xEF\xB5" => "\xE9\x94\x8F",
		"\xEF\xB6" => "\xE9\x94\x92",
		"\xEF\xB7" => "\xE9\x94\x93",
		"\xEF\xB8" => "\xE9\x94\x94",
		"\xEF\xB9" => "\xE9\x94\x95",
		"\xEF\xBA" => "\xE9\x94\x96",
		"\xEF\xBB" => "\xE9\x94\x98",
		"\xEF\xBC" => "\xE9\x94\x9B",
		"\xEF\xBD" => "\xE9\x94\x9D",
		"\xEF\xBE" => "\xE9\x94\x9E",
		"\xEF\xBF" => "\xE9\x94\x9F",
		"\xEF\xC0" => "\xE9\x94\xA2",
		"\xEF\xC1" => "\xE9\x94\xAA",
		"\xEF\xC2" => "\xE9\x94\xAB",
		"\xEF\xC3" => "\xE9\x94\xA9",
		"\xEF\xC4" => "\xE9\x94\xAC",
		"\xEF\xC5" => "\xE9\x94\xB1",
		"\xEF\xC6" => "\xE9\x94\xB2",
		"\xEF\xC7" => "\xE9\x94\xB4",
		"\xEF\xC8" => "\xE9\x94\xB6",
		"\xEF\xC9" => "\xE9\x94\xB7",
		"\xEF\xCA" => "\xE9\x94\xB8",
		"\xEF\xCB" => "\xE9\x94\xBC",
		"\xEF\xCC" => "\xE9\x94\xBE",
		"\xEF\xCD" => "\xE9\x94\xBF",
		"\xEF\xCE" => "\xE9\x95\x82",
		"\xEF\xCF" => "\xE9\x94\xB5",
		"\xEF\xD0" => "\xE9\x95\x84",
		"\xEF\xD1" => "\xE9\x95\x85",
		"\xEF\xD2" => "\xE9\x95\x86",
		"\xEF\xD3" => "\xE9\x95\x89",
		"\xEF\xD4" => "\xE9\x95\x8C",
		"\xEF\xD5" => "\xE9\x95\x8E",
		"\xEF\xD6" => "\xE9\x95\x8F",
		"\xEF\xD7" => "\xE9\x95\x92",
		"\xEF\xD8" => "\xE9\x95\x93",
		"\xEF\xD9" => "\xE9\x95\x94",
		"\xEF\xDA" => "\xE9\x95\x96",
		"\xEF\xDB" => "\xE9\x95\x97",
		"\xEF\xDC" => "\xE9\x95\x98",
		"\xEF\xDD" => "\xE9\x95\x99",
		"\xEF\xDE" => "\xE9\x95\x9B",
		"\xEF\xDF" => "\xE9\x95\x9E",
		"\xEF\xE0" => "\xE9\x95\x9F",
		"\xEF\xE1" => "\xE9\x95\x9D",
		"\xEF\xE2" => "\xE9\x95\xA1",
		"\xEF\xE3" => "\xE9\x95\xA2",
		"\xEF\xE4" => "\xE9\x95\xA4",
		"\xEF\xE5" => "\xE9\x95\xA5",
		"\xEF\xE6" => "\xE9\x95\xA6",
		"\xEF\xE7" => "\xE9\x95\xA7",
		"\xEF\xE8" => "\xE9\x95\xA8",
		"\xEF\xE9" => "\xE9\x95\xA9",
		"\xEF\xEA" => "\xE9\x95\xAA",
		"\xEF\xEB" => "\xE9\x95\xAB",
		"\xEF\xEC" => "\xE9\x95\xAC",
		"\xEF\xED" => "\xE9\x95\xAF",
		"\xEF\xEE" => "\xE9\x95\xB1",
		"\xEF\xEF" => "\xE9\x95\xB2",
		"\xEF\xF0" => "\xE9\x95\xB3",
		"\xEF\xF1" => "\xE9\x94\xBA",
		"\xEF\xF2" => "\xE7\x9F\xA7",
		"\xEF\xF3" => "\xE7\x9F\xAC",
		"\xEF\xF4" => "\xE9\x9B\x89",
		"\xEF\xF5" => "\xE7\xA7\x95",
		"\xEF\xF6" => "\xE7\xA7\xAD",
		"\xEF\xF7" => "\xE7\xA7\xA3",
		"\xEF\xF8" => "\xE7\xA7\xAB",
		"\xEF\xF9" => "\xE7\xA8\x86",
		"\xEF\xFA" => "\xE5\xB5\x87",
		"\xEF\xFB" => "\xE7\xA8\x83",
		"\xEF\xFC" => "\xE7\xA8\x82",
		"\xEF\xFD" => "\xE7\xA8\x9E",
		"\xEF\xFE" => "\xE7\xA8\x94",
		"\xF0\xA1" => "\xE7\xA8\xB9",
		"\xF0\xA2" => "\xE7\xA8\xB7",
		"\xF0\xA3" => "\xE7\xA9\x91",
		"\xF0\xA4" => "\xE9\xBB\x8F",
		"\xF0\xA5" => "\xE9\xA6\xA5",
		"\xF0\xA6" => "\xE7\xA9\xB0",
		"\xF0\xA7" => "\xE7\x9A\x88",
		"\xF0\xA8" => "\xE7\x9A\x8E",
		"\xF0\xA9" => "\xE7\x9A\x93",
		"\xF0\xAA" => "\xE7\x9A\x99",
		"\xF0\xAB" => "\xE7\x9A\xA4",
		"\xF0\xAC" => "\xE7\x93\x9E",
		"\xF0\xAD" => "\xE7\x93\xA0",
		"\xF0\xAE" => "\xE7\x94\xAC",
		"\xF0\xAF" => "\xE9\xB8\xA0",
		"\xF0\xB0" => "\xE9\xB8\xA2",
		"\xF0\xB1" => "\xE9\xB8\xA8",
		"\xF0\xB2" => "\xE9\xB8\xA9",
		"\xF0\xB3" => "\xE9\xB8\xAA",
		"\xF0\xB4" => "\xE9\xB8\xAB",
		"\xF0\xB5" => "\xE9\xB8\xAC",
		"\xF0\xB6" => "\xE9\xB8\xB2",
		"\xF0\xB7" => "\xE9\xB8\xB1",
		"\xF0\xB8" => "\xE9\xB8\xB6",
		"\xF0\xB9" => "\xE9\xB8\xB8",
		"\xF0\xBA" => "\xE9\xB8\xB7",
		"\xF0\xBB" => "\xE9\xB8\xB9",
		"\xF0\xBC" => "\xE9\xB8\xBA",
		"\xF0\xBD" => "\xE9\xB8\xBE",
		"\xF0\xBE" => "\xE9\xB9\x81",
		"\xF0\xBF" => "\xE9\xB9\x82",
		"\xF0\xC0" => "\xE9\xB9\x84",
		"\xF0\xC1" => "\xE9\xB9\x86",
		"\xF0\xC2" => "\xE9\xB9\x87",
		"\xF0\xC3" => "\xE9\xB9\x88",
		"\xF0\xC4" => "\xE9\xB9\x89",
		"\xF0\xC5" => "\xE9\xB9\x8B",
		"\xF0\xC6" => "\xE9\xB9\x8C",
		"\xF0\xC7" => "\xE9\xB9\x8E",
		"\xF0\xC8" => "\xE9\xB9\x91",
		"\xF0\xC9" => "\xE9\xB9\x95",
		"\xF0\xCA" => "\xE9\xB9\x97",
		"\xF0\xCB" => "\xE9\xB9\x9A",
		"\xF0\xCC" => "\xE9\xB9\x9B",
		"\xF0\xCD" => "\xE9\xB9\x9C",
		"\xF0\xCE" => "\xE9\xB9\x9E",
		"\xF0\xCF" => "\xE9\xB9\xA3",
		"\xF0\xD0" => "\xE9\xB9\xA6",
		"\xF0\xD1" => "\xE9\xB9\xA7",
		"\xF0\xD2" => "\xE9\xB9\xA8",
		"\xF0\xD3" => "\xE9\xB9\xA9",
		"\xF0\xD4" => "\xE9\xB9\xAA",
		"\xF0\xD5" => "\xE9\xB9\xAB",
		"\xF0\xD6" => "\xE9\xB9\xAC",
		"\xF0\xD7" => "\xE9\xB9\xB1",
		"\xF0\xD8" => "\xE9\xB9\xAD",
		"\xF0\xD9" => "\xE9\xB9\xB3",
		"\xF0\xDA" => "\xE7\x96\x92",
		"\xF0\xDB" => "\xE7\x96\x94",
		"\xF0\xDC" => "\xE7\x96\x96",
		"\xF0\xDD" => "\xE7\x96\xA0",
		"\xF0\xDE" => "\xE7\x96\x9D",
		"\xF0\xDF" => "\xE7\x96\xAC",
		"\xF0\xE0" => "\xE7\x96\xA3",
		"\xF0\xE1" => "\xE7\x96\xB3",
		"\xF0\xE2" => "\xE7\x96\xB4",
		"\xF0\xE3" => "\xE7\x96\xB8",
		"\xF0\xE4" => "\xE7\x97\x84",
		"\xF0\xE5" => "\xE7\x96\xB1",
		"\xF0\xE6" => "\xE7\x96\xB0",
		"\xF0\xE7" => "\xE7\x97\x83",
		"\xF0\xE8" => "\xE7\x97\x82",
		"\xF0\xE9" => "\xE7\x97\x96",
		"\xF0\xEA" => "\xE7\x97\x8D",
		"\xF0\xEB" => "\xE7\x97\xA3",
		"\xF0\xEC" => "\xE7\x97\xA8",
		"\xF0\xED" => "\xE7\x97\xA6",
		"\xF0\xEE" => "\xE7\x97\xA4",
		"\xF0\xEF" => "\xE7\x97\xAB",
		"\xF0\xF0" => "\xE7\x97\xA7",
		"\xF0\xF1" => "\xE7\x98\x83",
		"\xF0\xF2" => "\xE7\x97\xB1",
		"\xF0\xF3" => "\xE7\x97\xBC",
		"\xF0\xF4" => "\xE7\x97\xBF",
		"\xF0\xF5" => "\xE7\x98\x90",
		"\xF0\xF6" => "\xE7\x98\x80",
		"\xF0\xF7" => "\xE7\x98\x85",
		"\xF0\xF8" => "\xE7\x98\x8C",
		"\xF0\xF9" => "\xE7\x98\x97",
		"\xF0\xFA" => "\xE7\x98\x8A",
		"\xF0\xFB" => "\xE7\x98\xA5",
		"\xF0\xFC" => "\xE7\x98\x98",
		"\xF0\xFD" => "\xE7\x98\x95",
		"\xF0\xFE" => "\xE7\x98\x99",
		"\xF1\xA1" => "\xE7\x98\x9B",
		"\xF1\xA2" => "\xE7\x98\xBC",
		"\xF1\xA3" => "\xE7\x98\xA2",
		"\xF1\xA4" => "\xE7\x98\xA0",
		"\xF1\xA5" => "\xE7\x99\x80",
		"\xF1\xA6" => "\xE7\x98\xAD",
		"\xF1\xA7" => "\xE7\x98\xB0",
		"\xF1\xA8" => "\xE7\x98\xBF",
		"\xF1\xA9" => "\xE7\x98\xB5",
		"\xF1\xAA" => "\xE7\x99\x83",
		"\xF1\xAB" => "\xE7\x98\xBE",
		"\xF1\xAC" => "\xE7\x98\xB3",
		"\xF1\xAD" => "\xE7\x99\x8D",
		"\xF1\xAE" => "\xE7\x99\x9E",
		"\xF1\xAF" => "\xE7\x99\x94",
		"\xF1\xB0" => "\xE7\x99\x9C",
		"\xF1\xB1" => "\xE7\x99\x96",
		"\xF1\xB2" => "\xE7\x99\xAB",
		"\xF1\xB3" => "\xE7\x99\xAF",
		"\xF1\xB4" => "\xE7\xBF\x8A",
		"\xF1\xB5" => "\xE7\xAB\xA6",
		"\xF1\xB6" => "\xE7\xA9\xB8",
		"\xF1\xB7" => "\xE7\xA9\xB9",
		"\xF1\xB8" => "\xE7\xAA\x80",
		"\xF1\xB9" => "\xE7\xAA\x86",
		"\xF1\xBA" => "\xE7\xAA\x88",
		"\xF1\xBB" => "\xE7\xAA\x95",
		"\xF1\xBC" => "\xE7\xAA\xA6",
		"\xF1\xBD" => "\xE7\xAA\xA0",
		"\xF1\xBE" => "\xE7\xAA\xAC",
		"\xF1\xBF" => "\xE7\xAA\xA8",
		"\xF1\xC0" => "\xE7\xAA\xAD",
		"\xF1\xC1" => "\xE7\xAA\xB3",
		"\xF1\xC2" => "\xE8\xA1\xA4",
		"\xF1\xC3" => "\xE8\xA1\xA9",
		"\xF1\xC4" => "\xE8\xA1\xB2",
		"\xF1\xC5" => "\xE8\xA1\xBD",
		"\xF1\xC6" => "\xE8\xA1\xBF",
		"\xF1\xC7" => "\xE8\xA2\x82",
		"\xF1\xC8" => "\xE8\xA2\xA2",
		"\xF1\xC9" => "\xE8\xA3\x86",
		"\xF1\xCA" => "\xE8\xA2\xB7",
		"\xF1\xCB" => "\xE8\xA2\xBC",
		"\xF1\xCC" => "\xE8\xA3\x89",
		"\xF1\xCD" => "\xE8\xA3\xA2",
		"\xF1\xCE" => "\xE8\xA3\x8E",
		"\xF1\xCF" => "\xE8\xA3\xA3",
		"\xF1\xD0" => "\xE8\xA3\xA5",
		"\xF1\xD1" => "\xE8\xA3\xB1",
		"\xF1\xD2" => "\xE8\xA4\x9A",
		"\xF1\xD3" => "\xE8\xA3\xBC",
		"\xF1\xD4" => "\xE8\xA3\xA8",
		"\xF1\xD5" => "\xE8\xA3\xBE",
		"\xF1\xD6" => "\xE8\xA3\xB0",
		"\xF1\xD7" => "\xE8\xA4\xA1",
		"\xF1\xD8" => "\xE8\xA4\x99",
		"\xF1\xD9" => "\xE8\xA4\x93",
		"\xF1\xDA" => "\xE8\xA4\x9B",
		"\xF1\xDB" => "\xE8\xA4\x8A",
		"\xF1\xDC" => "\xE8\xA4\xB4",
		"\xF1\xDD" => "\xE8\xA4\xAB",
		"\xF1\xDE" => "\xE8\xA4\xB6",
		"\xF1\xDF" => "\xE8\xA5\x81",
		"\xF1\xE0" => "\xE8\xA5\xA6",
		"\xF1\xE1" => "\xE8\xA5\xBB",
		"\xF1\xE2" => "\xE7\x96\x8B",
		"\xF1\xE3" => "\xE8\x83\xA5",
		"\xF1\xE4" => "\xE7\x9A\xB2",
		"\xF1\xE5" => "\xE7\x9A\xB4",
		"\xF1\xE6" => "\xE7\x9F\x9C",
		"\xF1\xE7" => "\xE8\x80\x92",
		"\xF1\xE8" => "\xE8\x80\x94",
		"\xF1\xE9" => "\xE8\x80\x96",
		"\xF1\xEA" => "\xE8\x80\x9C",
		"\xF1\xEB" => "\xE8\x80\xA0",
		"\xF1\xEC" => "\xE8\x80\xA2",
		"\xF1\xED" => "\xE8\x80\xA5",
		"\xF1\xEE" => "\xE8\x80\xA6",
		"\xF1\xEF" => "\xE8\x80\xA7",
		"\xF1\xF0" => "\xE8\x80\xA9",
		"\xF1\xF1" => "\xE8\x80\xA8",
		"\xF1\xF2" => "\xE8\x80\xB1",
		"\xF1\xF3" => "\xE8\x80\x8B",
		"\xF1\xF4" => "\xE8\x80\xB5",
		"\xF1\xF5" => "\xE8\x81\x83",
		"\xF1\xF6" => "\xE8\x81\x86",
		"\xF1\xF7" => "\xE8\x81\x8D",
		"\xF1\xF8" => "\xE8\x81\x92",
		"\xF1\xF9" => "\xE8\x81\xA9",
		"\xF1\xFA" => "\xE8\x81\xB1",
		"\xF1\xFB" => "\xE8\xA6\x83",
		"\xF1\xFC" => "\xE9\xA1\xB8",
		"\xF1\xFD" => "\xE9\xA2\x80",
		"\xF1\xFE" => "\xE9\xA2\x83",
		"\xF2\xA1" => "\xE9\xA2\x89",
		"\xF2\xA2" => "\xE9\xA2\x8C",
		"\xF2\xA3" => "\xE9\xA2\x8D",
		"\xF2\xA4" => "\xE9\xA2\x8F",
		"\xF2\xA5" => "\xE9\xA2\x94",
		"\xF2\xA6" => "\xE9\xA2\x9A",
		"\xF2\xA7" => "\xE9\xA2\x9B",
		"\xF2\xA8" => "\xE9\xA2\x9E",
		"\xF2\xA9" => "\xE9\xA2\x9F",
		"\xF2\xAA" => "\xE9\xA2\xA1",
		"\xF2\xAB" => "\xE9\xA2\xA2",
		"\xF2\xAC" => "\xE9\xA2\xA5",
		"\xF2\xAD" => "\xE9\xA2\xA6",
		"\xF2\xAE" => "\xE8\x99\x8D",
		"\xF2\xAF" => "\xE8\x99\x94",
		"\xF2\xB0" => "\xE8\x99\xAC",
		"\xF2\xB1" => "\xE8\x99\xAE",
		"\xF2\xB2" => "\xE8\x99\xBF",
		"\xF2\xB3" => "\xE8\x99\xBA",
		"\xF2\xB4" => "\xE8\x99\xBC",
		"\xF2\xB5" => "\xE8\x99\xBB",
		"\xF2\xB6" => "\xE8\x9A\xA8",
		"\xF2\xB7" => "\xE8\x9A\x8D",
		"\xF2\xB8" => "\xE8\x9A\x8B",
		"\xF2\xB9" => "\xE8\x9A\xAC",
		"\xF2\xBA" => "\xE8\x9A\x9D",
		"\xF2\xBB" => "\xE8\x9A\xA7",
		"\xF2\xBC" => "\xE8\x9A\xA3",
		"\xF2\xBD" => "\xE8\x9A\xAA",
		"\xF2\xBE" => "\xE8\x9A\x93",
		"\xF2\xBF" => "\xE8\x9A\xA9",
		"\xF2\xC0" => "\xE8\x9A\xB6",
		"\xF2\xC1" => "\xE8\x9B\x84",
		"\xF2\xC2" => "\xE8\x9A\xB5",
		"\xF2\xC3" => "\xE8\x9B\x8E",
		"\xF2\xC4" => "\xE8\x9A\xB0",
		"\xF2\xC5" => "\xE8\x9A\xBA",
		"\xF2\xC6" => "\xE8\x9A\xB1",
		"\xF2\xC7" => "\xE8\x9A\xAF",
		"\xF2\xC8" => "\xE8\x9B\x89",
		"\xF2\xC9" => "\xE8\x9B\x8F",
		"\xF2\xCA" => "\xE8\x9A\xB4",
		"\xF2\xCB" => "\xE8\x9B\xA9",
		"\xF2\xCC" => "\xE8\x9B\xB1",
		"\xF2\xCD" => "\xE8\x9B\xB2",
		"\xF2\xCE" => "\xE8\x9B\xAD",
		"\xF2\xCF" => "\xE8\x9B\xB3",
		"\xF2\xD0" => "\xE8\x9B\x90",
		"\xF2\xD1" => "\xE8\x9C\x93",
		"\xF2\xD2" => "\xE8\x9B\x9E",
		"\xF2\xD3" => "\xE8\x9B\xB4",
		"\xF2\xD4" => "\xE8\x9B\x9F",
		"\xF2\xD5" => "\xE8\x9B\x98",
		"\xF2\xD6" => "\xE8\x9B\x91",
		"\xF2\xD7" => "\xE8\x9C\x83",
		"\xF2\xD8" => "\xE8\x9C\x87",
		"\xF2\xD9" => "\xE8\x9B\xB8",
		"\xF2\xDA" => "\xE8\x9C\x88",
		"\xF2\xDB" => "\xE8\x9C\x8A",
		"\xF2\xDC" => "\xE8\x9C\x8D",
		"\xF2\xDD" => "\xE8\x9C\x89",
		"\xF2\xDE" => "\xE8\x9C\xA3",
		"\xF2\xDF" => "\xE8\x9C\xBB",
		"\xF2\xE0" => "\xE8\x9C\x9E",
		"\xF2\xE1" => "\xE8\x9C\xA5",
		"\xF2\xE2" => "\xE8\x9C\xAE",
		"\xF2\xE3" => "\xE8\x9C\x9A",
		"\xF2\xE4" => "\xE8\x9C\xBE",
		"\xF2\xE5" => "\xE8\x9D\x88",
		"\xF2\xE6" => "\xE8\x9C\xB4",
		"\xF2\xE7" => "\xE8\x9C\xB1",
		"\xF2\xE8" => "\xE8\x9C\xA9",
		"\xF2\xE9" => "\xE8\x9C\xB7",
		"\xF2\xEA" => "\xE8\x9C\xBF",
		"\xF2\xEB" => "\xE8\x9E\x82",
		"\xF2\xEC" => "\xE8\x9C\xA2",
		"\xF2\xED" => "\xE8\x9D\xBD",
		"\xF2\xEE" => "\xE8\x9D\xBE",
		"\xF2\xEF" => "\xE8\x9D\xBB",
		"\xF2\xF0" => "\xE8\x9D\xA0",
		"\xF2\xF1" => "\xE8\x9D\xB0",
		"\xF2\xF2" => "\xE8\x9D\x8C",
		"\xF2\xF3" => "\xE8\x9D\xAE",
		"\xF2\xF4" => "\xE8\x9E\x8B",
		"\xF2\xF5" => "\xE8\x9D\x93",
		"\xF2\xF6" => "\xE8\x9D\xA3",
		"\xF2\xF7" => "\xE8\x9D\xBC",
		"\xF2\xF8" => "\xE8\x9D\xA4",
		"\xF2\xF9" => "\xE8\x9D\x99",
		"\xF2\xFA" => "\xE8\x9D\xA5",
		"\xF2\xFB" => "\xE8\x9E\x93",
		"\xF2\xFC" => "\xE8\x9E\xAF",
		"\xF2\xFD" => "\xE8\x9E\xA8",
		"\xF2\xFE" => "\xE8\x9F\x92",
		"\xF3\xA1" => "\xE8\x9F\x86",
		"\xF3\xA2" => "\xE8\x9E\x88",
		"\xF3\xA3" => "\xE8\x9E\x85",
		"\xF3\xA4" => "\xE8\x9E\xAD",
		"\xF3\xA5" => "\xE8\x9E\x97",
		"\xF3\xA6" => "\xE8\x9E\x83",
		"\xF3\xA7" => "\xE8\x9E\xAB",
		"\xF3\xA8" => "\xE8\x9F\xA5",
		"\xF3\xA9" => "\xE8\x9E\xAC",
		"\xF3\xAA" => "\xE8\x9E\xB5",
		"\xF3\xAB" => "\xE8\x9E\xB3",
		"\xF3\xAC" => "\xE8\x9F\x8B",
		"\xF3\xAD" => "\xE8\x9F\x93",
		"\xF3\xAE" => "\xE8\x9E\xBD",
		"\xF3\xAF" => "\xE8\x9F\x91",
		"\xF3\xB0" => "\xE8\x9F\x80",
		"\xF3\xB1" => "\xE8\x9F\x8A",
		"\xF3\xB2" => "\xE8\x9F\x9B",
		"\xF3\xB3" => "\xE8\x9F\xAA",
		"\xF3\xB4" => "\xE8\x9F\xA0",
		"\xF3\xB5" => "\xE8\x9F\xAE",
		"\xF3\xB6" => "\xE8\xA0\x96",
		"\xF3\xB7" => "\xE8\xA0\x93",
		"\xF3\xB8" => "\xE8\x9F\xBE",
		"\xF3\xB9" => "\xE8\xA0\x8A",
		"\xF3\xBA" => "\xE8\xA0\x9B",
		"\xF3\xBB" => "\xE8\xA0\xA1",
		"\xF3\xBC" => "\xE8\xA0\xB9",
		"\xF3\xBD" => "\xE8\xA0\xBC",
		"\xF3\xBE" => "\xE7\xBC\xB6",
		"\xF3\xBF" => "\xE7\xBD\x82",
		"\xF3\xC0" => "\xE7\xBD\x84",
		"\xF3\xC1" => "\xE7\xBD\x85",
		"\xF3\xC2" => "\xE8\x88\x90",
		"\xF3\xC3" => "\xE7\xAB\xBA",
		"\xF3\xC4" => "\xE7\xAB\xBD",
		"\xF3\xC5" => "\xE7\xAC\x88",
		"\xF3\xC6" => "\xE7\xAC\x83",
		"\xF3\xC7" => "\xE7\xAC\x84",
		"\xF3\xC8" => "\xE7\xAC\x95",
		"\xF3\xC9" => "\xE7\xAC\x8A",
		"\xF3\xCA" => "\xE7\xAC\xAB",
		"\xF3\xCB" => "\xE7\xAC\x8F",
		"\xF3\xCC" => "\xE7\xAD\x87",
		"\xF3\xCD" => "\xE7\xAC\xB8",
		"\xF3\xCE" => "\xE7\xAC\xAA",
		"\xF3\xCF" => "\xE7\xAC\x99",
		"\xF3\xD0" => "\xE7\xAC\xAE",
		"\xF3\xD1" => "\xE7\xAC\xB1",
		"\xF3\xD2" => "\xE7\xAC\xA0",
		"\xF3\xD3" => "\xE7\xAC\xA5",
		"\xF3\xD4" => "\xE7\xAC\xA4",
		"\xF3\xD5" => "\xE7\xAC\xB3",
		"\xF3\xD6" => "\xE7\xAC\xBE",
		"\xF3\xD7" => "\xE7\xAC\x9E",
		"\xF3\xD8" => "\xE7\xAD\x98",
		"\xF3\xD9" => "\xE7\xAD\x9A",
		"\xF3\xDA" => "\xE7\xAD\x85",
		"\xF3\xDB" => "\xE7\xAD\xB5",
		"\xF3\xDC" => "\xE7\xAD\x8C",
		"\xF3\xDD" => "\xE7\xAD\x9D",
		"\xF3\xDE" => "\xE7\xAD\xA0",
		"\xF3\xDF" => "\xE7\xAD\xAE",
		"\xF3\xE0" => "\xE7\xAD\xBB",
		"\xF3\xE1" => "\xE7\xAD\xA2",
		"\xF3\xE2" => "\xE7\xAD\xB2",
		"\xF3\xE3" => "\xE7\xAD\xB1",
		"\xF3\xE4" => "\xE7\xAE\x90",
		"\xF3\xE5" => "\xE7\xAE\xA6",
		"\xF3\xE6" => "\xE7\xAE\xA7",
		"\xF3\xE7" => "\xE7\xAE\xB8",
		"\xF3\xE8" => "\xE7\xAE\xAC",
		"\xF3\xE9" => "\xE7\xAE\x9D",
		"\xF3\xEA" => "\xE7\xAE\xA8",
		"\xF3\xEB" => "\xE7\xAE\x85",
		"\xF3\xEC" => "\xE7\xAE\xAA",
		"\xF3\xED" => "\xE7\xAE\x9C",
		"\xF3\xEE" => "\xE7\xAE\xA2",
		"\xF3\xEF" => "\xE7\xAE\xAB",
		"\xF3\xF0" => "\xE7\xAE\xB4",
		"\xF3\xF1" => "\xE7\xAF\x91",
		"\xF3\xF2" => "\xE7\xAF\x81",
		"\xF3\xF3" => "\xE7\xAF\x8C",
		"\xF3\xF4" => "\xE7\xAF\x9D",
		"\xF3\xF5" => "\xE7\xAF\x9A",
		"\xF3\xF6" => "\xE7\xAF\xA5",
		"\xF3\xF7" => "\xE7\xAF\xA6",
		"\xF3\xF8" => "\xE7\xAF\xAA",
		"\xF3\xF9" => "\xE7\xB0\x8C",
		"\xF3\xFA" => "\xE7\xAF\xBE",
		"\xF3\xFB" => "\xE7\xAF\xBC",
		"\xF3\xFC" => "\xE7\xB0\x8F",
		"\xF3\xFD" => "\xE7\xB0\x96",
		"\xF3\xFE" => "\xE7\xB0\x8B",
		"\xF4\xA1" => "\xE7\xB0\x9F",
		"\xF4\xA2" => "\xE7\xB0\xAA",
		"\xF4\xA3" => "\xE7\xB0\xA6",
		"\xF4\xA4" => "\xE7\xB0\xB8",
		"\xF4\xA5" => "\xE7\xB1\x81",
		"\xF4\xA6" => "\xE7\xB1\x80",
		"\xF4\xA7" => "\xE8\x87\xBE",
		"\xF4\xA8" => "\xE8\x88\x81",
		"\xF4\xA9" => "\xE8\x88\x82",
		"\xF4\xAA" => "\xE8\x88\x84",
		"\xF4\xAB" => "\xE8\x87\xAC",
		"\xF4\xAC" => "\xE8\xA1\x84",
		"\xF4\xAD" => "\xE8\x88\xA1",
		"\xF4\xAE" => "\xE8\x88\xA2",
		"\xF4\xAF" => "\xE8\x88\xA3",
		"\xF4\xB0" => "\xE8\x88\xAD",
		"\xF4\xB1" => "\xE8\x88\xAF",
		"\xF4\xB2" => "\xE8\x88\xA8",
		"\xF4\xB3" => "\xE8\x88\xAB",
		"\xF4\xB4" => "\xE8\x88\xB8",
		"\xF4\xB5" => "\xE8\x88\xBB",
		"\xF4\xB6" => "\xE8\x88\xB3",
		"\xF4\xB7" => "\xE8\x88\xB4",
		"\xF4\xB8" => "\xE8\x88\xBE",
		"\xF4\xB9" => "\xE8\x89\x84",
		"\xF4\xBA" => "\xE8\x89\x89",
		"\xF4\xBB" => "\xE8\x89\x8B",
		"\xF4\xBC" => "\xE8\x89\x8F",
		"\xF4\xBD" => "\xE8\x89\x9A",
		"\xF4\xBE" => "\xE8\x89\x9F",
		"\xF4\xBF" => "\xE8\x89\xA8",
		"\xF4\xC0" => "\xE8\xA1\xBE",
		"\xF4\xC1" => "\xE8\xA2\x85",
		"\xF4\xC2" => "\xE8\xA2\x88",
		"\xF4\xC3" => "\xE8\xA3\x98",
		"\xF4\xC4" => "\xE8\xA3\x9F",
		"\xF4\xC5" => "\xE8\xA5\x9E",
		"\xF4\xC6" => "\xE7\xBE\x9D",
		"\xF4\xC7" => "\xE7\xBE\x9F",
		"\xF4\xC8" => "\xE7\xBE\xA7",
		"\xF4\xC9" => "\xE7\xBE\xAF",
		"\xF4\xCA" => "\xE7\xBE\xB0",
		"\xF4\xCB" => "\xE7\xBE\xB2",
		"\xF4\xCC" => "\xE7\xB1\xBC",
		"\xF4\xCD" => "\xE6\x95\x89",
		"\xF4\xCE" => "\xE7\xB2\x91",
		"\xF4\xCF" => "\xE7\xB2\x9D",
		"\xF4\xD0" => "\xE7\xB2\x9C",
		"\xF4\xD1" => "\xE7\xB2\x9E",
		"\xF4\xD2" => "\xE7\xB2\xA2",
		"\xF4\xD3" => "\xE7\xB2\xB2",
		"\xF4\xD4" => "\xE7\xB2\xBC",
		"\xF4\xD5" => "\xE7\xB2\xBD",
		"\xF4\xD6" => "\xE7\xB3\x81",
		"\xF4\xD7" => "\xE7\xB3\x87",
		"\xF4\xD8" => "\xE7\xB3\x8C",
		"\xF4\xD9" => "\xE7\xB3\x8D",
		"\xF4\xDA" => "\xE7\xB3\x88",
		"\xF4\xDB" => "\xE7\xB3\x85",
		"\xF4\xDC" => "\xE7\xB3\x97",
		"\xF4\xDD" => "\xE7\xB3\xA8",
		"\xF4\xDE" => "\xE8\x89\xAE",
		"\xF4\xDF" => "\xE6\x9A\xA8",
		"\xF4\xE0" => "\xE7\xBE\xBF",
		"\xF4\xE1" => "\xE7\xBF\x8E",
		"\xF4\xE2" => "\xE7\xBF\x95",
		"\xF4\xE3" => "\xE7\xBF\xA5",
		"\xF4\xE4" => "\xE7\xBF\xA1",
		"\xF4\xE5" => "\xE7\xBF\xA6",
		"\xF4\xE6" => "\xE7\xBF\xA9",
		"\xF4\xE7" => "\xE7\xBF\xAE",
		"\xF4\xE8" => "\xE7\xBF\xB3",
		"\xF4\xE9" => "\xE7\xB3\xB8",
		"\xF4\xEA" => "\xE7\xB5\xB7",
		"\xF4\xEB" => "\xE7\xB6\xA6",
		"\xF4\xEC" => "\xE7\xB6\xAE",
		"\xF4\xED" => "\xE7\xB9\x87",
		"\xF4\xEE" => "\xE7\xBA\x9B",
		"\xF4\xEF" => "\xE9\xBA\xB8",
		"\xF4\xF0" => "\xE9\xBA\xB4",
		"\xF4\xF1" => "\xE8\xB5\xB3",
		"\xF4\xF2" => "\xE8\xB6\x84",
		"\xF4\xF3" => "\xE8\xB6\x94",
		"\xF4\xF4" => "\xE8\xB6\x91",
		"\xF4\xF5" => "\xE8\xB6\xB1",
		"\xF4\xF6" => "\xE8\xB5\xA7",
		"\xF4\xF7" => "\xE8\xB5\xAD",
		"\xF4\xF8" => "\xE8\xB1\x87",
		"\xF4\xF9" => "\xE8\xB1\x89",
		"\xF4\xFA" => "\xE9\x85\x8A",
		"\xF4\xFB" => "\xE9\x85\x90",
		"\xF4\xFC" => "\xE9\x85\x8E",
		"\xF4\xFD" => "\xE9\x85\x8F",
		"\xF4\xFE" => "\xE9\x85\xA4",
		"\xF5\xA1" => "\xE9\x85\xA2",
		"\xF5\xA2" => "\xE9\x85\xA1",
		"\xF5\xA3" => "\xE9\x85\xB0",
		"\xF5\xA4" => "\xE9\x85\xA9",
		"\xF5\xA5" => "\xE9\x85\xAF",
		"\xF5\xA6" => "\xE9\x85\xBD",
		"\xF5\xA7" => "\xE9\x85\xBE",
		"\xF5\xA8" => "\xE9\x85\xB2",
		"\xF5\xA9" => "\xE9\x85\xB4",
		"\xF5\xAA" => "\xE9\x85\xB9",
		"\xF5\xAB" => "\xE9\x86\x8C",
		"\xF5\xAC" => "\xE9\x86\x85",
		"\xF5\xAD" => "\xE9\x86\x90",
		"\xF5\xAE" => "\xE9\x86\x8D",
		"\xF5\xAF" => "\xE9\x86\x91",
		"\xF5\xB0" => "\xE9\x86\xA2",
		"\xF5\xB1" => "\xE9\x86\xA3",
		"\xF5\xB2" => "\xE9\x86\xAA",
		"\xF5\xB3" => "\xE9\x86\xAD",
		"\xF5\xB4" => "\xE9\x86\xAE",
		"\xF5\xB5" => "\xE9\x86\xAF",
		"\xF5\xB6" => "\xE9\x86\xB5",
		"\xF5\xB7" => "\xE9\x86\xB4",
		"\xF5\xB8" => "\xE9\x86\xBA",
		"\xF5\xB9" => "\xE8\xB1\x95",
		"\xF5\xBA" => "\xE9\xB9\xBE",
		"\xF5\xBB" => "\xE8\xB6\xB8",
		"\xF5\xBC" => "\xE8\xB7\xAB",
		"\xF5\xBD" => "\xE8\xB8\x85",
		"\xF5\xBE" => "\xE8\xB9\x99",
		"\xF5\xBF" => "\xE8\xB9\xA9",
		"\xF5\xC0" => "\xE8\xB6\xB5",
		"\xF5\xC1" => "\xE8\xB6\xBF",
		"\xF5\xC2" => "\xE8\xB6\xBC",
		"\xF5\xC3" => "\xE8\xB6\xBA",
		"\xF5\xC4" => "\xE8\xB7\x84",
		"\xF5\xC5" => "\xE8\xB7\x96",
		"\xF5\xC6" => "\xE8\xB7\x97",
		"\xF5\xC7" => "\xE8\xB7\x9A",
		"\xF5\xC8" => "\xE8\xB7\x9E",
		"\xF5\xC9" => "\xE8\xB7\x8E",
		"\xF5\xCA" => "\xE8\xB7\x8F",
		"\xF5\xCB" => "\xE8\xB7\x9B",
		"\xF5\xCC" => "\xE8\xB7\x86",
		"\xF5\xCD" => "\xE8\xB7\xAC",
		"\xF5\xCE" => "\xE8\xB7\xB7",
		"\xF5\xCF" => "\xE8\xB7\xB8",
		"\xF5\xD0" => "\xE8\xB7\xA3",
		"\xF5\xD1" => "\xE8\xB7\xB9",
		"\xF5\xD2" => "\xE8\xB7\xBB",
		"\xF5\xD3" => "\xE8\xB7\xA4",
		"\xF5\xD4" => "\xE8\xB8\x89",
		"\xF5\xD5" => "\xE8\xB7\xBD",
		"\xF5\xD6" => "\xE8\xB8\x94",
		"\xF5\xD7" => "\xE8\xB8\x9D",
		"\xF5\xD8" => "\xE8\xB8\x9F",
		"\xF5\xD9" => "\xE8\xB8\xAC",
		"\xF5\xDA" => "\xE8\xB8\xAE",
		"\xF5\xDB" => "\xE8\xB8\xA3",
		"\xF5\xDC" => "\xE8\xB8\xAF",
		"\xF5\xDD" => "\xE8\xB8\xBA",
		"\xF5\xDE" => "\xE8\xB9\x80",
		"\xF5\xDF" => "\xE8\xB8\xB9",
		"\xF5\xE0" => "\xE8\xB8\xB5",
		"\xF5\xE1" => "\xE8\xB8\xBD",
		"\xF5\xE2" => "\xE8\xB8\xB1",
		"\xF5\xE3" => "\xE8\xB9\x89",
		"\xF5\xE4" => "\xE8\xB9\x81",
		"\xF5\xE5" => "\xE8\xB9\x82",
		"\xF5\xE6" => "\xE8\xB9\x91",
		"\xF5\xE7" => "\xE8\xB9\x92",
		"\xF5\xE8" => "\xE8\xB9\x8A",
		"\xF5\xE9" => "\xE8\xB9\xB0",
		"\xF5\xEA" => "\xE8\xB9\xB6",
		"\xF5\xEB" => "\xE8\xB9\xBC",
		"\xF5\xEC" => "\xE8\xB9\xAF",
		"\xF5\xED" => "\xE8\xB9\xB4",
		"\xF5\xEE" => "\xE8\xBA\x85",
		"\xF5\xEF" => "\xE8\xBA\x8F",
		"\xF5\xF0" => "\xE8\xBA\x94",
		"\xF5\xF1" => "\xE8\xBA\x90",
		"\xF5\xF2" => "\xE8\xBA\x9C",
		"\xF5\xF3" => "\xE8\xBA\x9E",
		"\xF5\xF4" => "\xE8\xB1\xB8",
		"\xF5\xF5" => "\xE8\xB2\x82",
		"\xF5\xF6" => "\xE8\xB2\x8A",
		"\xF5\xF7" => "\xE8\xB2\x85",
		"\xF5\xF8" => "\xE8\xB2\x98",
		"\xF5\xF9" => "\xE8\xB2\x94",
		"\xF5\xFA" => "\xE6\x96\x9B",
		"\xF5\xFB" => "\xE8\xA7\x96",
		"\xF5\xFC" => "\xE8\xA7\x9E",
		"\xF5\xFD" => "\xE8\xA7\x9A",
		"\xF5\xFE" => "\xE8\xA7\x9C",
		"\xF6\xA1" => "\xE8\xA7\xA5",
		"\xF6\xA2" => "\xE8\xA7\xAB",
		"\xF6\xA3" => "\xE8\xA7\xAF",
		"\xF6\xA4" => "\xE8\xA8\xBE",
		"\xF6\xA5" => "\xE8\xAC\xA6",
		"\xF6\xA6" => "\xE9\x9D\x93",
		"\xF6\xA7" => "\xE9\x9B\xA9",
		"\xF6\xA8" => "\xE9\x9B\xB3",
		"\xF6\xA9" => "\xE9\x9B\xAF",
		"\xF6\xAA" => "\xE9\x9C\x86",
		"\xF6\xAB" => "\xE9\x9C\x81",
		"\xF6\xAC" => "\xE9\x9C\x88",
		"\xF6\xAD" => "\xE9\x9C\x8F",
		"\xF6\xAE" => "\xE9\x9C\x8E",
		"\xF6\xAF" => "\xE9\x9C\xAA",
		"\xF6\xB0" => "\xE9\x9C\xAD",
		"\xF6\xB1" => "\xE9\x9C\xB0",
		"\xF6\xB2" => "\xE9\x9C\xBE",
		"\xF6\xB3" => "\xE9\xBE\x80",
		"\xF6\xB4" => "\xE9\xBE\x83",
		"\xF6\xB5" => "\xE9\xBE\x85",
		"\xF6\xB6" => "\xE9\xBE\x86",
		"\xF6\xB7" => "\xE9\xBE\x87",
		"\xF6\xB8" => "\xE9\xBE\x88",
		"\xF6\xB9" => "\xE9\xBE\x89",
		"\xF6\xBA" => "\xE9\xBE\x8A",
		"\xF6\xBB" => "\xE9\xBE\x8C",
		"\xF6\xBC" => "\xE9\xBB\xBE",
		"\xF6\xBD" => "\xE9\xBC\x8B",
		"\xF6\xBE" => "\xE9\xBC\x8D",
		"\xF6\xBF" => "\xE9\x9A\xB9",
		"\xF6\xC0" => "\xE9\x9A\xBC",
		"\xF6\xC1" => "\xE9\x9A\xBD",
		"\xF6\xC2" => "\xE9\x9B\x8E",
		"\xF6\xC3" => "\xE9\x9B\x92",
		"\xF6\xC4" => "\xE7\x9E\xBF",
		"\xF6\xC5" => "\xE9\x9B\xA0",
		"\xF6\xC6" => "\xE9\x8A\x8E",
		"\xF6\xC7" => "\xE9\x8A\xAE",
		"\xF6\xC8" => "\xE9\x8B\x88",
		"\xF6\xC9" => "\xE9\x8C\xBE",
		"\xF6\xCA" => "\xE9\x8D\xAA",
		"\xF6\xCB" => "\xE9\x8F\x8A",
		"\xF6\xCC" => "\xE9\x8E\x8F",
		"\xF6\xCD" => "\xE9\x90\xBE",
		"\xF6\xCE" => "\xE9\x91\xAB",
		"\xF6\xCF" => "\xE9\xB1\xBF",
		"\xF6\xD0" => "\xE9\xB2\x82",
		"\xF6\xD1" => "\xE9\xB2\x85",
		"\xF6\xD2" => "\xE9\xB2\x86",
		"\xF6\xD3" => "\xE9\xB2\x87",
		"\xF6\xD4" => "\xE9\xB2\x88",
		"\xF6\xD5" => "\xE7\xA8\xA3",
		"\xF6\xD6" => "\xE9\xB2\x8B",
		"\xF6\xD7" => "\xE9\xB2\x8E",
		"\xF6\xD8" => "\xE9\xB2\x90",
		"\xF6\xD9" => "\xE9\xB2\x91",
		"\xF6\xDA" => "\xE9\xB2\x92",
		"\xF6\xDB" => "\xE9\xB2\x94",
		"\xF6\xDC" => "\xE9\xB2\x95",
		"\xF6\xDD" => "\xE9\xB2\x9A",
		"\xF6\xDE" => "\xE9\xB2\x9B",
		"\xF6\xDF" => "\xE9\xB2\x9E",
		"\xF6\xE0" => "\xE9\xB2\x9F",
		"\xF6\xE1" => "\xE9\xB2\xA0",
		"\xF6\xE2" => "\xE9\xB2\xA1",
		"\xF6\xE3" => "\xE9\xB2\xA2",
		"\xF6\xE4" => "\xE9\xB2\xA3",
		"\xF6\xE5" => "\xE9\xB2\xA5",
		"\xF6\xE6" => "\xE9\xB2\xA6",
		"\xF6\xE7" => "\xE9\xB2\xA7",
		"\xF6\xE8" => "\xE9\xB2\xA8",
		"\xF6\xE9" => "\xE9\xB2\xA9",
		"\xF6\xEA" => "\xE9\xB2\xAB",
		"\xF6\xEB" => "\xE9\xB2\xAD",
		"\xF6\xEC" => "\xE9\xB2\xAE",
		"\xF6\xED" => "\xE9\xB2\xB0",
		"\xF6\xEE" => "\xE9\xB2\xB1",
		"\xF6\xEF" => "\xE9\xB2\xB2",
		"\xF6\xF0" => "\xE9\xB2\xB3",
		"\xF6\xF1" => "\xE9\xB2\xB4",
		"\xF6\xF2" => "\xE9\xB2\xB5",
		"\xF6\xF3" => "\xE9\xB2\xB6",
		"\xF6\xF4" => "\xE9\xB2\xB7",
		"\xF6\xF5" => "\xE9\xB2\xBA",
		"\xF6\xF6" => "\xE9\xB2\xBB",
		"\xF6\xF7" => "\xE9\xB2\xBC",
		"\xF6\xF8" => "\xE9\xB2\xBD",
		"\xF6\xF9" => "\xE9\xB3\x84",
		"\xF6\xFA" => "\xE9\xB3\x85",
		"\xF6\xFB" => "\xE9\xB3\x86",
		"\xF6\xFC" => "\xE9\xB3\x87",
		"\xF6\xFD" => "\xE9\xB3\x8A",
		"\xF6\xFE" => "\xE9\xB3\x8B",
		"\xF7\xA1" => "\xE9\xB3\x8C",
		"\xF7\xA2" => "\xE9\xB3\x8D",
		"\xF7\xA3" => "\xE9\xB3\x8E",
		"\xF7\xA4" => "\xE9\xB3\x8F",
		"\xF7\xA5" => "\xE9\xB3\x90",
		"\xF7\xA6" => "\xE9\xB3\x93",
		"\xF7\xA7" => "\xE9\xB3\x94",
		"\xF7\xA8" => "\xE9\xB3\x95",
		"\xF7\xA9" => "\xE9\xB3\x97",
		"\xF7\xAA" => "\xE9\xB3\x98",
		"\xF7\xAB" => "\xE9\xB3\x99",
		"\xF7\xAC" => "\xE9\xB3\x9C",
		"\xF7\xAD" => "\xE9\xB3\x9D",
		"\xF7\xAE" => "\xE9\xB3\x9F",
		"\xF7\xAF" => "\xE9\xB3\xA2",
		"\xF7\xB0" => "\xE9\x9D\xBC",
		"\xF7\xB1" => "\xE9\x9E\x85",
		"\xF7\xB2" => "\xE9\x9E\x91",
		"\xF7\xB3" => "\xE9\x9E\x92",
		"\xF7\xB4" => "\xE9\x9E\x94",
		"\xF7\xB5" => "\xE9\x9E\xAF",
		"\xF7\xB6" => "\xE9\x9E\xAB",
		"\xF7\xB7" => "\xE9\x9E\xA3",
		"\xF7\xB8" => "\xE9\x9E\xB2",
		"\xF7\xB9" => "\xE9\x9E\xB4",
		"\xF7\xBA" => "\xE9\xAA\xB1",
		"\xF7\xBB" => "\xE9\xAA\xB0",
		"\xF7\xBC" => "\xE9\xAA\xB7",
		"\xF7\xBD" => "\xE9\xB9\x98",
		"\xF7\xBE" => "\xE9\xAA\xB6",
		"\xF7\xBF" => "\xE9\xAA\xBA",
		"\xF7\xC0" => "\xE9\xAA\xBC",
		"\xF7\xC1" => "\xE9\xAB\x81",
		"\xF7\xC2" => "\xE9\xAB\x80",
		"\xF7\xC3" => "\xE9\xAB\x85",
		"\xF7\xC4" => "\xE9\xAB\x82",
		"\xF7\xC5" => "\xE9\xAB\x8B",
		"\xF7\xC6" => "\xE9\xAB\x8C",
		"\xF7\xC7" => "\xE9\xAB\x91",
		"\xF7\xC8" => "\xE9\xAD\x85",
		"\xF7\xC9" => "\xE9\xAD\x83",
		"\xF7\xCA" => "\xE9\xAD\x87",
		"\xF7\xCB" => "\xE9\xAD\x89",
		"\xF7\xCC" => "\xE9\xAD\x88",
		"\xF7\xCD" => "\xE9\xAD\x8D",
		"\xF7\xCE" => "\xE9\xAD\x91",
		"\xF7\xCF" => "\xE9\xA3\xA8",
		"\xF7\xD0" => "\xE9\xA4\x8D",
		"\xF7\xD1" => "\xE9\xA4\xAE",
		"\xF7\xD2" => "\xE9\xA5\x95",
		"\xF7\xD3" => "\xE9\xA5\x94",
		"\xF7\xD4" => "\xE9\xAB\x9F",
		"\xF7\xD5" => "\xE9\xAB\xA1",
		"\xF7\xD6" => "\xE9\xAB\xA6",
		"\xF7\xD7" => "\xE9\xAB\xAF",
		"\xF7\xD8" => "\xE9\xAB\xAB",
		"\xF7\xD9" => "\xE9\xAB\xBB",
		"\xF7\xDA" => "\xE9\xAB\xAD",
		"\xF7\xDB" => "\xE9\xAB\xB9",
		"\xF7\xDC" => "\xE9\xAC\x88",
		"\xF7\xDD" => "\xE9\xAC\x8F",
		"\xF7\xDE" => "\xE9\xAC\x93",
		"\xF7\xDF" => "\xE9\xAC\x9F",
		"\xF7\xE0" => "\xE9\xAC\xA3",
		"\xF7\xE1" => "\xE9\xBA\xBD",
		"\xF7\xE2" => "\xE9\xBA\xBE",
		"\xF7\xE3" => "\xE7\xB8\xBB",
		"\xF7\xE4" => "\xE9\xBA\x82",
		"\xF7\xE5" => "\xE9\xBA\x87",
		"\xF7\xE6" => "\xE9\xBA\x88",
		"\xF7\xE7" => "\xE9\xBA\x8B",
		"\xF7\xE8" => "\xE9\xBA\x92",
		"\xF7\xE9" => "\xE9\x8F\x96",
		"\xF7\xEA" => "\xE9\xBA\x9D",
		"\xF7\xEB" => "\xE9\xBA\x9F",
		"\xF7\xEC" => "\xE9\xBB\x9B",
		"\xF7\xED" => "\xE9\xBB\x9C",
		"\xF7\xEE" => "\xE9\xBB\x9D",
		"\xF7\xEF" => "\xE9\xBB\xA0",
		"\xF7\xF0" => "\xE9\xBB\x9F",
		"\xF7\xF1" => "\xE9\xBB\xA2",
		"\xF7\xF2" => "\xE9\xBB\xA9",
		"\xF7\xF3" => "\xE9\xBB\xA7",
		"\xF7\xF4" => "\xE9\xBB\xA5",
		"\xF7\xF5" => "\xE9\xBB\xAA",
		"\xF7\xF6" => "\xE9\xBB\xAF",
		"\xF7\xF7" => "\xE9\xBC\xA2",
		"\xF7\xF8" => "\xE9\xBC\xAC",
		"\xF7\xF9" => "\xE9\xBC\xAF",
		"\xF7\xFA" => "\xE9\xBC\xB9",
		"\xF7\xFB" => "\xE9\xBC\xB7",
		"\xF7\xFC" => "\xE9\xBC\xBD",
		"\xF7\xFD" => "\xE9\xBC\xBE",
		"\xF7\xFE" => "\xE9\xBD\x84",
	);
	return strtr($string, $transform);
}

function sjis($string)
{
	static $transform = array(
		"\x5C"=>"\xC2\xA5",
		"\x7E"=>"\xE2\x80\xBE",
		"\x81\x40"=>"\xE3\x80\x80",
		"\x81\x41"=>"\xE3\x80\x81",
		"\x81\x42"=>"\xE3\x80\x82",
		"\x81\x43"=>"\xEF\xBC\x8C",
		"\x81\x44"=>"\xEF\xBC\x8E",
		"\x81\x45"=>"\xE3\x83\xBB",
		"\x81\x46"=>"\xEF\xBC\x9A",
		"\x81\x47"=>"\xEF\xBC\x9B",
		"\x81\x48"=>"\xEF\xBC\x9F",
		"\x81\x49"=>"\xEF\xBC\x81",
		"\x81\x4A"=>"\xE3\x82\x9B",
		"\x81\x4B"=>"\xE3\x82\x9C",
		"\x81\x4C"=>"\xC2\xB4",
		"\x81\x4D"=>"\xEF\xBD\x80",
		"\x81\x4E"=>"\xC2\xA8",
		"\x81\x4F"=>"\xEF\xBC\xBE",
		"\x81\x50"=>"\xEF\xBF\xA3",
		"\x81\x51"=>"\xEF\xBC\xBF",
		"\x81\x52"=>"\xE3\x83\xBD",
		"\x81\x53"=>"\xE3\x83\xBE",
		"\x81\x54"=>"\xE3\x82\x9D",
		"\x81\x55"=>"\xE3\x82\x9E",
		"\x81\x56"=>"\xE3\x80\x83",
		"\x81\x57"=>"\xE4\xBB\x9D",
		"\x81\x58"=>"\xE3\x80\x85",
		"\x81\x59"=>"\xE3\x80\x86",
		"\x81\x5A"=>"\xE3\x80\x87",
		"\x81\x5B"=>"\xE3\x83\xBC",
		"\x81\x5C"=>"\xE2\x80\x95", // set as U+2015 but could be U+2014
		"\x81\x5D"=>"\xE2\x80\x90",
		"\x81\x5E"=>"\xEF\xBC\x8F",
		"\x81\x5F"=>"\xEF\xBC\xBC", // or U+005C
		"\x81\x60"=>"\xE3\x80\x9C",
		"\x81\x61"=>"\xE2\x80\x96",
		"\x81\x62"=>"\xEF\xBD\x9C",
		"\x81\x63"=>"\xE2\x80\xA6",
		"\x81\x64"=>"\xE2\x80\xA5",
		"\x81\x65"=>"\xE2\x80\x98",
		"\x81\x66"=>"\xE2\x80\x99",
		"\x81\x67"=>"\xE2\x80\x9C",
		"\x81\x68"=>"\xE2\x80\x9D",
		"\x81\x69"=>"\xEF\xBC\x88",
		"\x81\x6A"=>"\xEF\xBC\x89",
		"\x81\x6B"=>"\xE3\x80\x94",
		"\x81\x6C"=>"\xE3\x80\x95",
		"\x81\x6D"=>"\xEF\xBC\xBB",
		"\x81\x6E"=>"\xEF\xBC\xBD",
		"\x81\x6F"=>"\xEF\xBD\x9B",
		"\x81\x70"=>"\xEF\xBD\x9D",
		"\x81\x71"=>"\xE3\x80\x88",
		"\x81\x72"=>"\xE3\x80\x89",
		"\x81\x73"=>"\xE3\x80\x8A",
		"\x81\x74"=>"\xE3\x80\x8B",
		"\x81\x75"=>"\xE3\x80\x8C",
		"\x81\x76"=>"\xE3\x80\x8D",
		"\x81\x77"=>"\xE3\x80\x8E",
		"\x81\x78"=>"\xE3\x80\x8F",
		"\x81\x79"=>"\xE3\x80\x90",
		"\x81\x7A"=>"\xE3\x80\x91",
		"\x81\x7B"=>"\xEF\xBC\x8B",
		"\x81\x7C"=>"\xE2\x88\x92",
		"\x81\x7D"=>"\xC2\xB1",
		"\x81\x7E"=>"\xC3\x97",
		"\x81\x80"=>"\xC3\xB7",
		"\x81\x81"=>"\xEF\xBC\x9D",
		"\x81\x82"=>"\xE2\x89\xA0",
		"\x81\x83"=>"\xEF\xBC\x9C",
		"\x81\x84"=>"\xEF\xBC\x9E",
		"\x81\x85"=>"\xE2\x89\xA6",
		"\x81\x86"=>"\xE2\x89\xA7",
		"\x81\x87"=>"\xE2\x88\x9E",
		"\x81\x88"=>"\xE2\x88\xB4",
		"\x81\x89"=>"\xE2\x99\x82",
		"\x81\x8A"=>"\xE2\x99\x80",
		"\x81\x8B"=>"\xC2\xB0",
		"\x81\x8C"=>"\xE2\x80\xB2",
		"\x81\x8D"=>"\xE2\x80\xB3",
		"\x81\x8E"=>"\xE2\x84\x83",
		"\x81\x8F"=>"\xEF\xBF\xA5",
		"\x81\x90"=>"\xEF\xBC\x84",
		"\x81\x91"=>"\xC2\xA2",
		"\x81\x92"=>"\xC2\xA3",
		"\x81\x93"=>"\xEF\xBC\x85",
		"\x81\x94"=>"\xEF\xBC\x83",
		"\x81\x95"=>"\xEF\xBC\x86",
		"\x81\x96"=>"\xEF\xBC\x8A",
		"\x81\x97"=>"\xEF\xBC\xA0",
		"\x81\x98"=>"\xC2\xA7",
		"\x81\x99"=>"\xE2\x98\x86",
		"\x81\x9A"=>"\xE2\x98\x85",
		"\x81\x9B"=>"\xE2\x97\x8B",
		"\x81\x9C"=>"\xE2\x97\x8F",
		"\x81\x9D"=>"\xE2\x97\x8E",
		"\x81\x9E"=>"\xE2\x97\x87",
		"\x81\x9F"=>"\xE2\x97\x86",
		"\x81\xA0"=>"\xE2\x96\xA1",
		"\x81\xA1"=>"\xE2\x96\xA0",
		"\x81\xA2"=>"\xE2\x96\xB3",
		"\x81\xA3"=>"\xE2\x96\xB2",
		"\x81\xA4"=>"\xE2\x96\xBD",
		"\x81\xA5"=>"\xE2\x96\xBC",
		"\x81\xA6"=>"\xE2\x80\xBB",
		"\x81\xA7"=>"\xE3\x80\x92",
		"\x81\xA8"=>"\xE2\x86\x92",
		"\x81\xA9"=>"\xE2\x86\x90",
		"\x81\xAA"=>"\xE2\x86\x91",
		"\x81\xAB"=>"\xE2\x86\x93",
		"\x81\xAC"=>"\xE3\x80\x93",
		"\x81\xAD"=>"\xEF\xBC\x87", // extra?!
		"\x81\xB8"=>"\xE2\x88\x88",
		"\x81\xB9"=>"\xE2\x88\x8B",
		"\x81\xBA"=>"\xE2\x8A\x86",
		"\x81\xBB"=>"\xE2\x8A\x87",
		"\x81\xBC"=>"\xE2\x8A\x82",
		"\x81\xBD"=>"\xE2\x8A\x83",
		"\x81\xBE"=>"\xE2\x88\xAA",
		"\x81\xBF"=>"\xE2\x88\xA9",
		"\x81\xC8"=>"\xE2\x88\xA7",
		"\x81\xC9"=>"\xE2\x88\xA8",
		"\x81\xCA"=>"\xC2\xAC",
		"\x81\xCB"=>"\xE2\x87\x92",
		"\x81\xCC"=>"\xE2\x87\x94",
		"\x81\xCD"=>"\xE2\x88\x80",
		"\x81\xCE"=>"\xE2\x88\x83",
		"\x81\xDA"=>"\xE2\x88\xA0",
		"\x81\xDB"=>"\xE2\x8A\xA5",
		"\x81\xDC"=>"\xE2\x8C\x92",
		"\x81\xDD"=>"\xE2\x88\x82",
		"\x81\xDE"=>"\xE2\x88\x87",
		"\x81\xDF"=>"\xE2\x89\xA1",
		"\x81\xE0"=>"\xE2\x89\x92",
		"\x81\xE1"=>"\xE2\x89\xAA",
		"\x81\xE2"=>"\xE2\x89\xAB",
		"\x81\xE3"=>"\xE2\x88\x9A",
		"\x81\xE4"=>"\xE2\x88\xBD",
		"\x81\xE5"=>"\xE2\x88\x9D",
		"\x81\xE6"=>"\xE2\x88\xB5",
		"\x81\xE7"=>"\xE2\x88\xAB",
		"\x81\xE8"=>"\xE2\x88\xAC",
		"\x81\xF0"=>"\xE2\x84\xAB",
		"\x81\xF1"=>"\xE2\x80\xB0",
		"\x81\xF2"=>"\xE2\x99\xAF",
		"\x81\xF3"=>"\xE2\x99\xAD",
		"\x81\xF4"=>"\xE2\x99\xAA",
		"\x81\xF5"=>"\xE2\x80\xA0",
		"\x81\xF6"=>"\xE2\x80\xA1",
		"\x81\xF7"=>"\xC2\xB6",
		"\x81\xFC"=>"\xE2\x97\xAF",
		"\x82\x4F"=>"\xEF\xBC\x90",
		"\x82\x50"=>"\xEF\xBC\x91",
		"\x82\x51"=>"\xEF\xBC\x92",
		"\x82\x52"=>"\xEF\xBC\x93",
		"\x82\x53"=>"\xEF\xBC\x94",
		"\x82\x54"=>"\xEF\xBC\x95",
		"\x82\x55"=>"\xEF\xBC\x96",
		"\x82\x56"=>"\xEF\xBC\x97",
		"\x82\x57"=>"\xEF\xBC\x98",
		"\x82\x58"=>"\xEF\xBC\x99",
		"\x82\x60"=>"\xEF\xBC\xA1",
		"\x82\x61"=>"\xEF\xBC\xA2",
		"\x82\x62"=>"\xEF\xBC\xA3",
		"\x82\x63"=>"\xEF\xBC\xA4",
		"\x82\x64"=>"\xEF\xBC\xA5",
		"\x82\x65"=>"\xEF\xBC\xA6",
		"\x82\x66"=>"\xEF\xBC\xA7",
		"\x82\x67"=>"\xEF\xBC\xA8",
		"\x82\x68"=>"\xEF\xBC\xA9",
		"\x82\x69"=>"\xEF\xBC\xAA",
		"\x82\x6A"=>"\xEF\xBC\xAB",
		"\x82\x6B"=>"\xEF\xBC\xAC",
		"\x82\x6C"=>"\xEF\xBC\xAD",
		"\x82\x6D"=>"\xEF\xBC\xAE",
		"\x82\x6E"=>"\xEF\xBC\xAF",
		"\x82\x6F"=>"\xEF\xBC\xB0",
		"\x82\x70"=>"\xEF\xBC\xB1",
		"\x82\x71"=>"\xEF\xBC\xB2",
		"\x82\x72"=>"\xEF\xBC\xB3",
		"\x82\x73"=>"\xEF\xBC\xB4",
		"\x82\x74"=>"\xEF\xBC\xB5",
		"\x82\x75"=>"\xEF\xBC\xB6",
		"\x82\x76"=>"\xEF\xBC\xB7",
		"\x82\x77"=>"\xEF\xBC\xB8",
		"\x82\x78"=>"\xEF\xBC\xB9",
		"\x82\x79"=>"\xEF\xBC\xBA",
		"\x82\x81"=>"\xEF\xBD\x81",
		"\x82\x82"=>"\xEF\xBD\x82",
		"\x82\x83"=>"\xEF\xBD\x83",
		"\x82\x84"=>"\xEF\xBD\x84",
		"\x82\x85"=>"\xEF\xBD\x85",
		"\x82\x86"=>"\xEF\xBD\x86",
		"\x82\x87"=>"\xEF\xBD\x87",
		"\x82\x88"=>"\xEF\xBD\x88",
		"\x82\x89"=>"\xEF\xBD\x89",
		"\x82\x8A"=>"\xEF\xBD\x8A",
		"\x82\x8B"=>"\xEF\xBD\x8B",
		"\x82\x8C"=>"\xEF\xBD\x8C",
		"\x82\x8D"=>"\xEF\xBD\x8D",
		"\x82\x8E"=>"\xEF\xBD\x8E",
		"\x82\x8F"=>"\xEF\xBD\x8F",
		"\x82\x90"=>"\xEF\xBD\x90",
		"\x82\x91"=>"\xEF\xBD\x91",
		"\x82\x92"=>"\xEF\xBD\x92",
		"\x82\x93"=>"\xEF\xBD\x93",
		"\x82\x94"=>"\xEF\xBD\x94",
		"\x82\x95"=>"\xEF\xBD\x95",
		"\x82\x96"=>"\xEF\xBD\x96",
		"\x82\x97"=>"\xEF\xBD\x97",
		"\x82\x98"=>"\xEF\xBD\x98",
		"\x82\x99"=>"\xEF\xBD\x99",
		"\x82\x9A"=>"\xEF\xBD\x9A",
		"\x82\x9F"=>"\xE3\x81\x81",
		"\x82\xA0"=>"\xE3\x81\x82",
		"\x82\xA1"=>"\xE3\x81\x83",
		"\x82\xA2"=>"\xE3\x81\x84",
		"\x82\xA3"=>"\xE3\x81\x85",
		"\x82\xA4"=>"\xE3\x81\x86",
		"\x82\xA5"=>"\xE3\x81\x87",
		"\x82\xA6"=>"\xE3\x81\x88",
		"\x82\xA7"=>"\xE3\x81\x89",
		"\x82\xA8"=>"\xE3\x81\x8A",
		"\x82\xA9"=>"\xE3\x81\x8B",
		"\x82\xAA"=>"\xE3\x81\x8C",
		"\x82\xAB"=>"\xE3\x81\x8D",
		"\x82\xAC"=>"\xE3\x81\x8E",
		"\x82\xAD"=>"\xE3\x81\x8F",
		"\x82\xAE"=>"\xE3\x81\x90",
		"\x82\xAF"=>"\xE3\x81\x91",
		"\x82\xB0"=>"\xE3\x81\x92",
		"\x82\xB1"=>"\xE3\x81\x93",
		"\x82\xB2"=>"\xE3\x81\x94",
		"\x82\xB3"=>"\xE3\x81\x95",
		"\x82\xB4"=>"\xE3\x81\x96",
		"\x82\xB5"=>"\xE3\x81\x97",
		"\x82\xB6"=>"\xE3\x81\x98",
		"\x82\xB7"=>"\xE3\x81\x99",
		"\x82\xB8"=>"\xE3\x81\x9A",
		"\x82\xB9"=>"\xE3\x81\x9B",
		"\x82\xBA"=>"\xE3\x81\x9C",
		"\x82\xBB"=>"\xE3\x81\x9D",
		"\x82\xBC"=>"\xE3\x81\x9E",
		"\x82\xBD"=>"\xE3\x81\x9F",
		"\x82\xBE"=>"\xE3\x81\xA0",
		"\x82\xBF"=>"\xE3\x81\xA1",
		"\x82\xC0"=>"\xE3\x81\xA2",
		"\x82\xC1"=>"\xE3\x81\xA3",
		"\x82\xC2"=>"\xE3\x81\xA4",
		"\x82\xC3"=>"\xE3\x81\xA5",
		"\x82\xC4"=>"\xE3\x81\xA6",
		"\x82\xC5"=>"\xE3\x81\xA7",
		"\x82\xC6"=>"\xE3\x81\xA8",
		"\x82\xC7"=>"\xE3\x81\xA9",
		"\x82\xC8"=>"\xE3\x81\xAA",
		"\x82\xC9"=>"\xE3\x81\xAB",
		"\x82\xCA"=>"\xE3\x81\xAC",
		"\x82\xCB"=>"\xE3\x81\xAD",
		"\x82\xCC"=>"\xE3\x81\xAE",
		"\x82\xCD"=>"\xE3\x81\xAF",
		"\x82\xCE"=>"\xE3\x81\xB0",
		"\x82\xCF"=>"\xE3\x81\xB1",
		"\x82\xD0"=>"\xE3\x81\xB2",
		"\x82\xD1"=>"\xE3\x81\xB3",
		"\x82\xD2"=>"\xE3\x81\xB4",
		"\x82\xD3"=>"\xE3\x81\xB5",
		"\x82\xD4"=>"\xE3\x81\xB6",
		"\x82\xD5"=>"\xE3\x81\xB7",
		"\x82\xD6"=>"\xE3\x81\xB8",
		"\x82\xD7"=>"\xE3\x81\xB9",
		"\x82\xD8"=>"\xE3\x81\xBA",
		"\x82\xD9"=>"\xE3\x81\xBB",
		"\x82\xDA"=>"\xE3\x81\xBC",
		"\x82\xDB"=>"\xE3\x81\xBD",
		"\x82\xDC"=>"\xE3\x81\xBE",
		"\x82\xDD"=>"\xE3\x81\xBF",
		"\x82\xDE"=>"\xE3\x82\x80",
		"\x82\xDF"=>"\xE3\x82\x81",
		"\x82\xE0"=>"\xE3\x82\x82",
		"\x82\xE1"=>"\xE3\x82\x83",
		"\x82\xE2"=>"\xE3\x82\x84",
		"\x82\xE3"=>"\xE3\x82\x85",
		"\x82\xE4"=>"\xE3\x82\x86",
		"\x82\xE5"=>"\xE3\x82\x87",
		"\x82\xE6"=>"\xE3\x82\x88",
		"\x82\xE7"=>"\xE3\x82\x89",
		"\x82\xE8"=>"\xE3\x82\x8A",
		"\x82\xE9"=>"\xE3\x82\x8B",
		"\x82\xEA"=>"\xE3\x82\x8C",
		"\x82\xEB"=>"\xE3\x82\x8D",
		"\x82\xEC"=>"\xE3\x82\x8E",
		"\x82\xED"=>"\xE3\x82\x8F",
		"\x82\xEE"=>"\xE3\x82\x90",
		"\x82\xEF"=>"\xE3\x82\x91",
		"\x82\xF0"=>"\xE3\x82\x92",
		"\x82\xF1"=>"\xE3\x82\x93",
		"\x83\x40"=>"\xE3\x82\xA1",
		"\x83\x41"=>"\xE3\x82\xA2",
		"\x83\x42"=>"\xE3\x82\xA3",
		"\x83\x43"=>"\xE3\x82\xA4",
		"\x83\x44"=>"\xE3\x82\xA5",
		"\x83\x45"=>"\xE3\x82\xA6",
		"\x83\x46"=>"\xE3\x82\xA7",
		"\x83\x47"=>"\xE3\x82\xA8",
		"\x83\x48"=>"\xE3\x82\xA9",
		"\x83\x49"=>"\xE3\x82\xAA",
		"\x83\x4A"=>"\xE3\x82\xAB",
		"\x83\x4B"=>"\xE3\x82\xAC",
		"\x83\x4C"=>"\xE3\x82\xAD",
		"\x83\x4D"=>"\xE3\x82\xAE",
		"\x83\x4E"=>"\xE3\x82\xAF",
		"\x83\x4F"=>"\xE3\x82\xB0",
		"\x83\x50"=>"\xE3\x82\xB1",
		"\x83\x51"=>"\xE3\x82\xB2",
		"\x83\x52"=>"\xE3\x82\xB3",
		"\x83\x53"=>"\xE3\x82\xB4",
		"\x83\x54"=>"\xE3\x82\xB5",
		"\x83\x55"=>"\xE3\x82\xB6",
		"\x83\x56"=>"\xE3\x82\xB7",
		"\x83\x57"=>"\xE3\x82\xB8",
		"\x83\x58"=>"\xE3\x82\xB9",
		"\x83\x59"=>"\xE3\x82\xBA",
		"\x83\x5A"=>"\xE3\x82\xBB",
		"\x83\x5B"=>"\xE3\x82\xBC",
		"\x83\x5C"=>"\xE3\x82\xBD",
		"\x83\x5D"=>"\xE3\x82\xBE",
		"\x83\x5E"=>"\xE3\x82\xBF",
		"\x83\x5F"=>"\xE3\x83\x80",
		"\x83\x60"=>"\xE3\x83\x81",
		"\x83\x61"=>"\xE3\x83\x82",
		"\x83\x62"=>"\xE3\x83\x83",
		"\x83\x63"=>"\xE3\x83\x84",
		"\x83\x64"=>"\xE3\x83\x85",
		"\x83\x65"=>"\xE3\x83\x86",
		"\x83\x66"=>"\xE3\x83\x87",
		"\x83\x67"=>"\xE3\x83\x88",
		"\x83\x68"=>"\xE3\x83\x89",
		"\x83\x69"=>"\xE3\x83\x8A",
		"\x83\x6A"=>"\xE3\x83\x8B",
		"\x83\x6B"=>"\xE3\x83\x8C",
		"\x83\x6C"=>"\xE3\x83\x8D",
		"\x83\x6D"=>"\xE3\x83\x8E",
		"\x83\x6E"=>"\xE3\x83\x8F",
		"\x83\x6F"=>"\xE3\x83\x90",
		"\x83\x70"=>"\xE3\x83\x91",
		"\x83\x71"=>"\xE3\x83\x92",
		"\x83\x72"=>"\xE3\x83\x93",
		"\x83\x73"=>"\xE3\x83\x94",
		"\x83\x74"=>"\xE3\x83\x95",
		"\x83\x75"=>"\xE3\x83\x96",
		"\x83\x76"=>"\xE3\x83\x97",
		"\x83\x77"=>"\xE3\x83\x98",
		"\x83\x78"=>"\xE3\x83\x99",
		"\x83\x79"=>"\xE3\x83\x9A",
		"\x83\x7A"=>"\xE3\x83\x9B",
		"\x83\x7B"=>"\xE3\x83\x9C",
		"\x83\x7C"=>"\xE3\x83\x9D",
		"\x83\x7D"=>"\xE3\x83\x9E",
		"\x83\x7E"=>"\xE3\x83\x9F",
		"\x83\x80"=>"\xE3\x83\xA0",
		"\x83\x81"=>"\xE3\x83\xA1",
		"\x83\x82"=>"\xE3\x83\xA2",
		"\x83\x83"=>"\xE3\x83\xA3",
		"\x83\x84"=>"\xE3\x83\xA4",
		"\x83\x85"=>"\xE3\x83\xA5",
		"\x83\x86"=>"\xE3\x83\xA6",
		"\x83\x87"=>"\xE3\x83\xA7",
		"\x83\x88"=>"\xE3\x83\xA8",
		"\x83\x89"=>"\xE3\x83\xA9",
		"\x83\x8A"=>"\xE3\x83\xAA",
		"\x83\x8B"=>"\xE3\x83\xAB",
		"\x83\x8C"=>"\xE3\x83\xAC",
		"\x83\x8D"=>"\xE3\x83\xAD",
		"\x83\x8E"=>"\xE3\x83\xAE",
		"\x83\x8F"=>"\xE3\x83\xAF",
		"\x83\x90"=>"\xE3\x83\xB0",
		"\x83\x91"=>"\xE3\x83\xB1",
		"\x83\x92"=>"\xE3\x83\xB2",
		"\x83\x93"=>"\xE3\x83\xB3",
		"\x83\x94"=>"\xE3\x83\xB4",
		"\x83\x95"=>"\xE3\x83\xB5",
		"\x83\x96"=>"\xE3\x83\xB6",
		"\x83\x9F"=>"\xCE\x91",
		"\x83\xA0"=>"\xCE\x92",
		"\x83\xA1"=>"\xCE\x93",
		"\x83\xA2"=>"\xCE\x94",
		"\x83\xA3"=>"\xCE\x95",
		"\x83\xA4"=>"\xCE\x96",
		"\x83\xA5"=>"\xCE\x97",
		"\x83\xA6"=>"\xCE\x98",
		"\x83\xA7"=>"\xCE\x99",
		"\x83\xA8"=>"\xCE\x9A",
		"\x83\xA9"=>"\xCE\x9B",
		"\x83\xAA"=>"\xCE\x9C",
		"\x83\xAB"=>"\xCE\x9D",
		"\x83\xAC"=>"\xCE\x9E",
		"\x83\xAD"=>"\xCE\x9F",
		"\x83\xAE"=>"\xCE\xA0",
		"\x83\xAF"=>"\xCE\xA1",
		"\x83\xB0"=>"\xCE\xA3",
		"\x83\xB1"=>"\xCE\xA4",
		"\x83\xB2"=>"\xCE\xA5",
		"\x83\xB3"=>"\xCE\xA6",
		"\x83\xB4"=>"\xCE\xA7",
		"\x83\xB5"=>"\xCE\xA8",
		"\x83\xB6"=>"\xCE\xA9",
		"\x83\xBF"=>"\xCE\xB1",
		"\x83\xC0"=>"\xCE\xB2",
		"\x83\xC1"=>"\xCE\xB3",
		"\x83\xC2"=>"\xCE\xB4",
		"\x83\xC3"=>"\xCE\xB5",
		"\x83\xC4"=>"\xCE\xB6",
		"\x83\xC5"=>"\xCE\xB7",
		"\x83\xC6"=>"\xCE\xB8",
		"\x83\xC7"=>"\xCE\xB9",
		"\x83\xC8"=>"\xCE\xBA",
		"\x83\xC9"=>"\xCE\xBB",
		"\x83\xCA"=>"\xCE\xBC",
		"\x83\xCB"=>"\xCE\xBD",
		"\x83\xCC"=>"\xCE\xBE",
		"\x83\xCD"=>"\xCE\xBF",
		"\x83\xCE"=>"\xCF\x80",
		"\x83\xCF"=>"\xCF\x81",
		"\x83\xD0"=>"\xCF\x83",
		"\x83\xD1"=>"\xCF\x84",
		"\x83\xD2"=>"\xCF\x85",
		"\x83\xD3"=>"\xCF\x86",
		"\x83\xD4"=>"\xCF\x87",
		"\x83\xD5"=>"\xCF\x88",
		"\x83\xD6"=>"\xCF\x89",
		"\x84\x40"=>"\xD0\x90",
		"\x84\x41"=>"\xD0\x91",
		"\x84\x42"=>"\xD0\x92",
		"\x84\x43"=>"\xD0\x93",
		"\x84\x44"=>"\xD0\x94",
		"\x84\x45"=>"\xD0\x95",
		"\x84\x46"=>"\xD0\x81",
		"\x84\x47"=>"\xD0\x96",
		"\x84\x48"=>"\xD0\x97",
		"\x84\x49"=>"\xD0\x98",
		"\x84\x4A"=>"\xD0\x99",
		"\x84\x4B"=>"\xD0\x9A",
		"\x84\x4C"=>"\xD0\x9B",
		"\x84\x4D"=>"\xD0\x9C",
		"\x84\x4E"=>"\xD0\x9D",
		"\x84\x4F"=>"\xD0\x9E",
		"\x84\x50"=>"\xD0\x9F",
		"\x84\x51"=>"\xD0\xA0",
		"\x84\x52"=>"\xD0\xA1",
		"\x84\x53"=>"\xD0\xA2",
		"\x84\x54"=>"\xD0\xA3",
		"\x84\x55"=>"\xD0\xA4",
		"\x84\x56"=>"\xD0\xA5",
		"\x84\x57"=>"\xD0\xA6",
		"\x84\x58"=>"\xD0\xA7",
		"\x84\x59"=>"\xD0\xA8",
		"\x84\x5A"=>"\xD0\xA9",
		"\x84\x5B"=>"\xD0\xAA",
		"\x84\x5C"=>"\xD0\xAB",
		"\x84\x5D"=>"\xD0\xAC",
		"\x84\x5E"=>"\xD0\xAD",
		"\x84\x5F"=>"\xD0\xAE",
		"\x84\x60"=>"\xD0\xAF",
		"\x84\x70"=>"\xD0\xB0",
		"\x84\x71"=>"\xD0\xB1",
		"\x84\x72"=>"\xD0\xB2",
		"\x84\x73"=>"\xD0\xB3",
		"\x84\x74"=>"\xD0\xB4",
		"\x84\x75"=>"\xD0\xB5",
		"\x84\x76"=>"\xD1\x91",
		"\x84\x77"=>"\xD0\xB6",
		"\x84\x78"=>"\xD0\xB7",
		"\x84\x79"=>"\xD0\xB8",
		"\x84\x7A"=>"\xD0\xB9",
		"\x84\x7B"=>"\xD0\xBA",
		"\x84\x7C"=>"\xD0\xBB",
		"\x84\x7D"=>"\xD0\xBC",
		"\x84\x7E"=>"\xD0\xBD",
		"\x84\x80"=>"\xD0\xBE",
		"\x84\x81"=>"\xD0\xBF",
		"\x84\x82"=>"\xD1\x80",
		"\x84\x83"=>"\xD1\x81",
		"\x84\x84"=>"\xD1\x82",
		"\x84\x85"=>"\xD1\x83",
		"\x84\x86"=>"\xD1\x84",
		"\x84\x87"=>"\xD1\x85",
		"\x84\x88"=>"\xD1\x86",
		"\x84\x89"=>"\xD1\x87",
		"\x84\x8A"=>"\xD1\x88",
		"\x84\x8B"=>"\xD1\x89",
		"\x84\x8C"=>"\xD1\x8A",
		"\x84\x8D"=>"\xD1\x8B",
		"\x84\x8E"=>"\xD1\x8C",
		"\x84\x8F"=>"\xD1\x8D",
		"\x84\x90"=>"\xD1\x8E",
		"\x84\x91"=>"\xD1\x8F",
		"\x84\x9F"=>"\xE2\x94\x80",
		"\x84\xA0"=>"\xE2\x94\x82",
		"\x84\xA1"=>"\xE2\x94\x8C",
		"\x84\xA2"=>"\xE2\x94\x90",
		"\x84\xA3"=>"\xE2\x94\x98",
		"\x84\xA4"=>"\xE2\x94\x94",
		"\x84\xA5"=>"\xE2\x94\x9C",
		"\x84\xA6"=>"\xE2\x94\xAC",
		"\x84\xA7"=>"\xE2\x94\xA4",
		"\x84\xA8"=>"\xE2\x94\xB4",
		"\x84\xA9"=>"\xE2\x94\xBC",
		"\x84\xAA"=>"\xE2\x94\x81",
		"\x84\xAB"=>"\xE2\x94\x83",
		"\x84\xAC"=>"\xE2\x94\x8F",
		"\x84\xAD"=>"\xE2\x94\x93",
		"\x84\xAE"=>"\xE2\x94\x9B",
		"\x84\xAF"=>"\xE2\x94\x97",
		"\x84\xB0"=>"\xE2\x94\xA3",
		"\x84\xB1"=>"\xE2\x94\xB3",
		"\x84\xB2"=>"\xE2\x94\xAB",
		"\x84\xB3"=>"\xE2\x94\xBB",
		"\x84\xB4"=>"\xE2\x95\x8B",
		"\x84\xB5"=>"\xE2\x94\xA0",
		"\x84\xB6"=>"\xE2\x94\xAF",
		"\x84\xB7"=>"\xE2\x94\xA8",
		"\x84\xB8"=>"\xE2\x94\xB7",
		"\x84\xB9"=>"\xE2\x94\xBF",
		"\x84\xBA"=>"\xE2\x94\x9D",
		"\x84\xBB"=>"\xE2\x94\xB0",
		"\x84\xBC"=>"\xE2\x94\xA5",
		"\x84\xBD"=>"\xE2\x94\xB8",
		"\x84\xBE"=>"\xE2\x95\x82",
		"\x88\x9F"=>"\xE4\xBA\x9C",
		"\x88\xA0"=>"\xE5\x94\x96",
		"\x88\xA1"=>"\xE5\xA8\x83",
		"\x88\xA2"=>"\xE9\x98\xBF",
		"\x88\xA3"=>"\xE5\x93\x80",
		"\x88\xA4"=>"\xE6\x84\x9B",
		"\x88\xA5"=>"\xE6\x8C\xA8",
		"\x88\xA6"=>"\xE5\xA7\xB6",
		"\x88\xA7"=>"\xE9\x80\xA2",
		"\x88\xA8"=>"\xE8\x91\xB5",
		"\x88\xA9"=>"\xE8\x8C\x9C",
		"\x88\xAA"=>"\xE7\xA9\x90",
		"\x88\xAB"=>"\xE6\x82\xAA",
		"\x88\xAC"=>"\xE6\x8F\xA1",
		"\x88\xAD"=>"\xE6\xB8\xA5",
		"\x88\xAE"=>"\xE6\x97\xAD",
		"\x88\xAF"=>"\xE8\x91\xA6",
		"\x88\xB0"=>"\xE8\x8A\xA6",
		"\x88\xB1"=>"\xE9\xAF\xB5",
		"\x88\xB2"=>"\xE6\xA2\x93",
		"\x88\xB3"=>"\xE5\x9C\xA7",
		"\x88\xB4"=>"\xE6\x96\xA1",
		"\x88\xB5"=>"\xE6\x89\xB1",
		"\x88\xB6"=>"\xE5\xAE\x9B",
		"\x88\xB7"=>"\xE5\xA7\x90",
		"\x88\xB8"=>"\xE8\x99\xBB",
		"\x88\xB9"=>"\xE9\xA3\xB4",
		"\x88\xBA"=>"\xE7\xB5\xA2",
		"\x88\xBB"=>"\xE7\xB6\xBE",
		"\x88\xBC"=>"\xE9\xAE\x8E",
		"\x88\xBD"=>"\xE6\x88\x96",
		"\x88\xBE"=>"\xE7\xB2\x9F",
		"\x88\xBF"=>"\xE8\xA2\xB7",
		"\x88\xC0"=>"\xE5\xAE\x89",
		"\x88\xC1"=>"\xE5\xBA\xB5",
		"\x88\xC2"=>"\xE6\x8C\x89",
		"\x88\xC3"=>"\xE6\x9A\x97",
		"\x88\xC4"=>"\xE6\xA1\x88",
		"\x88\xC5"=>"\xE9\x97\x87",
		"\x88\xC6"=>"\xE9\x9E\x8D",
		"\x88\xC7"=>"\xE6\x9D\x8F",
		"\x88\xC8"=>"\xE4\xBB\xA5",
		"\x88\xC9"=>"\xE4\xBC\x8A",
		"\x88\xCA"=>"\xE4\xBD\x8D",
		"\x88\xCB"=>"\xE4\xBE\x9D",
		"\x88\xCC"=>"\xE5\x81\x89",
		"\x88\xCD"=>"\xE5\x9B\xB2",
		"\x88\xCE"=>"\xE5\xA4\xB7",
		"\x88\xCF"=>"\xE5\xA7\x94",
		"\x88\xD0"=>"\xE5\xA8\x81",
		"\x88\xD1"=>"\xE5\xB0\x89",
		"\x88\xD2"=>"\xE6\x83\x9F",
		"\x88\xD3"=>"\xE6\x84\x8F",
		"\x88\xD4"=>"\xE6\x85\xB0",
		"\x88\xD5"=>"\xE6\x98\x93",
		"\x88\xD6"=>"\xE6\xA4\x85",
		"\x88\xD7"=>"\xE7\x82\xBA",
		"\x88\xD8"=>"\xE7\x95\x8F",
		"\x88\xD9"=>"\xE7\x95\xB0",
		"\x88\xDA"=>"\xE7\xA7\xBB",
		"\x88\xDB"=>"\xE7\xB6\xAD",
		"\x88\xDC"=>"\xE7\xB7\xAF",
		"\x88\xDD"=>"\xE8\x83\x83",
		"\x88\xDE"=>"\xE8\x90\x8E",
		"\x88\xDF"=>"\xE8\xA1\xA3",
		"\x88\xE0"=>"\xE8\xAC\x82",
		"\x88\xE1"=>"\xE9\x81\x95",
		"\x88\xE2"=>"\xE9\x81\xBA",
		"\x88\xE3"=>"\xE5\x8C\xBB",
		"\x88\xE4"=>"\xE4\xBA\x95",
		"\x88\xE5"=>"\xE4\xBA\xA5",
		"\x88\xE6"=>"\xE5\x9F\x9F",
		"\x88\xE7"=>"\xE8\x82\xB2",
		"\x88\xE8"=>"\xE9\x83\x81",
		"\x88\xE9"=>"\xE7\xA3\xAF",
		"\x88\xEA"=>"\xE4\xB8\x80",
		"\x88\xEB"=>"\xE5\xA3\xB1",
		"\x88\xEC"=>"\xE6\xBA\xA2",
		"\x88\xED"=>"\xE9\x80\xB8",
		"\x88\xEE"=>"\xE7\xA8\xB2",
		"\x88\xEF"=>"\xE8\x8C\xA8",
		"\x88\xF0"=>"\xE8\x8A\x8B",
		"\x88\xF1"=>"\xE9\xB0\xAF",
		"\x88\xF2"=>"\xE5\x85\x81",
		"\x88\xF3"=>"\xE5\x8D\xB0",
		"\x88\xF4"=>"\xE5\x92\xBD",
		"\x88\xF5"=>"\xE5\x93\xA1",
		"\x88\xF6"=>"\xE5\x9B\xA0",
		"\x88\xF7"=>"\xE5\xA7\xBB",
		"\x88\xF8"=>"\xE5\xBC\x95",
		"\x88\xF9"=>"\xE9\xA3\xB2",
		"\x88\xFA"=>"\xE6\xB7\xAB",
		"\x88\xFB"=>"\xE8\x83\xA4",
		"\x88\xFC"=>"\xE8\x94\xAD",
		"\x89\x40"=>"\xE9\x99\xA2",
		"\x89\x41"=>"\xE9\x99\xB0",
		"\x89\x42"=>"\xE9\x9A\xA0",
		"\x89\x43"=>"\xE9\x9F\xBB",
		"\x89\x44"=>"\xE5\x90\x8B",
		"\x89\x45"=>"\xE5\x8F\xB3",
		"\x89\x46"=>"\xE5\xAE\x87",
		"\x89\x47"=>"\xE7\x83\x8F",
		"\x89\x48"=>"\xE7\xBE\xBD",
		"\x89\x49"=>"\xE8\xBF\x82",
		"\x89\x4A"=>"\xE9\x9B\xA8",
		"\x89\x4B"=>"\xE5\x8D\xAF",
		"\x89\x4C"=>"\xE9\xB5\x9C",
		"\x89\x4D"=>"\xE7\xAA\xBA",
		"\x89\x4E"=>"\xE4\xB8\x91",
		"\x89\x4F"=>"\xE7\xA2\x93",
		"\x89\x50"=>"\xE8\x87\xBC",
		"\x89\x51"=>"\xE6\xB8\xA6",
		"\x89\x52"=>"\xE5\x98\x98",
		"\x89\x53"=>"\xE5\x94\x84",
		"\x89\x54"=>"\xE6\xAC\x9D",
		"\x89\x55"=>"\xE8\x94\x9A",
		"\x89\x56"=>"\xE9\xB0\xBB",
		"\x89\x57"=>"\xE5\xA7\xA5",
		"\x89\x58"=>"\xE5\x8E\xA9",
		"\x89\x59"=>"\xE6\xB5\xA6",
		"\x89\x5A"=>"\xE7\x93\x9C",
		"\x89\x5B"=>"\xE9\x96\x8F",
		"\x89\x5C"=>"\xE5\x99\x82",
		"\x89\x5D"=>"\xE4\xBA\x91",
		"\x89\x5E"=>"\xE9\x81\x8B",
		"\x89\x5F"=>"\xE9\x9B\xB2",
		"\x89\x60"=>"\xE8\x8D\x8F",
		"\x89\x61"=>"\xE9\xA4\x8C",
		"\x89\x62"=>"\xE5\x8F\xA1",
		"\x89\x63"=>"\xE5\x96\xB6",
		"\x89\x64"=>"\xE5\xAC\xB0",
		"\x89\x65"=>"\xE5\xBD\xB1",
		"\x89\x66"=>"\xE6\x98\xA0",
		"\x89\x67"=>"\xE6\x9B\xB3",
		"\x89\x68"=>"\xE6\xA0\x84",
		"\x89\x69"=>"\xE6\xB0\xB8",
		"\x89\x6A"=>"\xE6\xB3\xB3",
		"\x89\x6B"=>"\xE6\xB4\xA9",
		"\x89\x6C"=>"\xE7\x91\x9B",
		"\x89\x6D"=>"\xE7\x9B\x88",
		"\x89\x6E"=>"\xE7\xA9\x8E",
		"\x89\x6F"=>"\xE9\xA0\xB4",
		"\x89\x70"=>"\xE8\x8B\xB1",
		"\x89\x71"=>"\xE8\xA1\x9B",
		"\x89\x72"=>"\xE8\xA9\xA0",
		"\x89\x73"=>"\xE9\x8B\xAD",
		"\x89\x74"=>"\xE6\xB6\xB2",
		"\x89\x75"=>"\xE7\x96\xAB",
		"\x89\x76"=>"\xE7\x9B\x8A",
		"\x89\x77"=>"\xE9\xA7\x85",
		"\x89\x78"=>"\xE6\x82\xA6",
		"\x89\x79"=>"\xE8\xAC\x81",
		"\x89\x7A"=>"\xE8\xB6\x8A",
		"\x89\x7B"=>"\xE9\x96\xB2",
		"\x89\x7C"=>"\xE6\xA6\x8E",
		"\x89\x7D"=>"\xE5\x8E\xAD",
		"\x89\x7E"=>"\xE5\x86\x86",
		"\x89\x80"=>"\xE5\x9C\x92",
		"\x89\x81"=>"\xE5\xA0\xB0",
		"\x89\x82"=>"\xE5\xA5\x84",
		"\x89\x83"=>"\xE5\xAE\xB4",
		"\x89\x84"=>"\xE5\xBB\xB6",
		"\x89\x85"=>"\xE6\x80\xA8",
		"\x89\x86"=>"\xE6\x8E\xA9",
		"\x89\x87"=>"\xE6\x8F\xB4",
		"\x89\x88"=>"\xE6\xB2\xBF",
		"\x89\x89"=>"\xE6\xBC\x94",
		"\x89\x8A"=>"\xE7\x82\x8E",
		"\x89\x8B"=>"\xE7\x84\x94",
		"\x89\x8C"=>"\xE7\x85\x99",
		"\x89\x8D"=>"\xE7\x87\x95",
		"\x89\x8E"=>"\xE7\x8C\xBF",
		"\x89\x8F"=>"\xE7\xB8\x81",
		"\x89\x90"=>"\xE8\x89\xB6",
		"\x89\x91"=>"\xE8\x8B\x91",
		"\x89\x92"=>"\xE8\x96\x97",
		"\x89\x93"=>"\xE9\x81\xA0",
		"\x89\x94"=>"\xE9\x89\x9B",
		"\x89\x95"=>"\xE9\xB4\x9B",
		"\x89\x96"=>"\xE5\xA1\xA9",
		"\x89\x97"=>"\xE6\x96\xBC",
		"\x89\x98"=>"\xE6\xB1\x9A",
		"\x89\x99"=>"\xE7\x94\xA5",
		"\x89\x9A"=>"\xE5\x87\xB9",
		"\x89\x9B"=>"\xE5\xA4\xAE",
		"\x89\x9C"=>"\xE5\xA5\xA5",
		"\x89\x9D"=>"\xE5\xBE\x80",
		"\x89\x9E"=>"\xE5\xBF\x9C",
		"\x89\x9F"=>"\xE6\x8A\xBC",
		"\x89\xA0"=>"\xE6\x97\xBA",
		"\x89\xA1"=>"\xE6\xA8\xAA",
		"\x89\xA2"=>"\xE6\xAC\xA7",
		"\x89\xA3"=>"\xE6\xAE\xB4",
		"\x89\xA4"=>"\xE7\x8E\x8B",
		"\x89\xA5"=>"\xE7\xBF\x81",
		"\x89\xA6"=>"\xE8\xA5\x96",
		"\x89\xA7"=>"\xE9\xB4\xAC",
		"\x89\xA8"=>"\xE9\xB4\x8E",
		"\x89\xA9"=>"\xE9\xBB\x84",
		"\x89\xAA"=>"\xE5\xB2\xA1",
		"\x89\xAB"=>"\xE6\xB2\x96",
		"\x89\xAC"=>"\xE8\x8D\xBB",
		"\x89\xAD"=>"\xE5\x84\x84",
		"\x89\xAE"=>"\xE5\xB1\x8B",
		"\x89\xAF"=>"\xE6\x86\xB6",
		"\x89\xB0"=>"\xE8\x87\x86",
		"\x89\xB1"=>"\xE6\xA1\xB6",
		"\x89\xB2"=>"\xE7\x89\xA1",
		"\x89\xB3"=>"\xE4\xB9\x99",
		"\x89\xB4"=>"\xE4\xBF\xBA",
		"\x89\xB5"=>"\xE5\x8D\xB8",
		"\x89\xB6"=>"\xE6\x81\xA9",
		"\x89\xB7"=>"\xE6\xB8\xA9",
		"\x89\xB8"=>"\xE7\xA9\x8F",
		"\x89\xB9"=>"\xE9\x9F\xB3",
		"\x89\xBA"=>"\xE4\xB8\x8B",
		"\x89\xBB"=>"\xE5\x8C\x96",
		"\x89\xBC"=>"\xE4\xBB\xAE",
		"\x89\xBD"=>"\xE4\xBD\x95",
		"\x89\xBE"=>"\xE4\xBC\xBD",
		"\x89\xBF"=>"\xE4\xBE\xA1",
		"\x89\xC0"=>"\xE4\xBD\xB3",
		"\x89\xC1"=>"\xE5\x8A\xA0",
		"\x89\xC2"=>"\xE5\x8F\xAF",
		"\x89\xC3"=>"\xE5\x98\x89",
		"\x89\xC4"=>"\xE5\xA4\x8F",
		"\x89\xC5"=>"\xE5\xAB\x81",
		"\x89\xC6"=>"\xE5\xAE\xB6",
		"\x89\xC7"=>"\xE5\xAF\xA1",
		"\x89\xC8"=>"\xE7\xA7\x91",
		"\x89\xC9"=>"\xE6\x9A\x87",
		"\x89\xCA"=>"\xE6\x9E\x9C",
		"\x89\xCB"=>"\xE6\x9E\xB6",
		"\x89\xCC"=>"\xE6\xAD\x8C",
		"\x89\xCD"=>"\xE6\xB2\xB3",
		"\x89\xCE"=>"\xE7\x81\xAB",
		"\x89\xCF"=>"\xE7\x8F\x82",
		"\x89\xD0"=>"\xE7\xA6\x8D",
		"\x89\xD1"=>"\xE7\xA6\xBE",
		"\x89\xD2"=>"\xE7\xA8\xBC",
		"\x89\xD3"=>"\xE7\xAE\x87",
		"\x89\xD4"=>"\xE8\x8A\xB1",
		"\x89\xD5"=>"\xE8\x8B\x9B",
		"\x89\xD6"=>"\xE8\x8C\x84",
		"\x89\xD7"=>"\xE8\x8D\xB7",
		"\x89\xD8"=>"\xE8\x8F\xAF",
		"\x89\xD9"=>"\xE8\x8F\x93",
		"\x89\xDA"=>"\xE8\x9D\xA6",
		"\x89\xDB"=>"\xE8\xAA\xB2",
		"\x89\xDC"=>"\xE5\x98\xA9",
		"\x89\xDD"=>"\xE8\xB2\xA8",
		"\x89\xDE"=>"\xE8\xBF\xA6",
		"\x89\xDF"=>"\xE9\x81\x8E",
		"\x89\xE0"=>"\xE9\x9C\x9E",
		"\x89\xE1"=>"\xE8\x9A\x8A",
		"\x89\xE2"=>"\xE4\xBF\x84",
		"\x89\xE3"=>"\xE5\xB3\xA8",
		"\x89\xE4"=>"\xE6\x88\x91",
		"\x89\xE5"=>"\xE7\x89\x99",
		"\x89\xE6"=>"\xE7\x94\xBB",
		"\x89\xE7"=>"\xE8\x87\xA5",
		"\x89\xE8"=>"\xE8\x8A\xBD",
		"\x89\xE9"=>"\xE8\x9B\xBE",
		"\x89\xEA"=>"\xE8\xB3\x80",
		"\x89\xEB"=>"\xE9\x9B\x85",
		"\x89\xEC"=>"\xE9\xA4\x93",
		"\x89\xED"=>"\xE9\xA7\x95",
		"\x89\xEE"=>"\xE4\xBB\x8B",
		"\x89\xEF"=>"\xE4\xBC\x9A",
		"\x89\xF0"=>"\xE8\xA7\xA3",
		"\x89\xF1"=>"\xE5\x9B\x9E",
		"\x89\xF2"=>"\xE5\xA1\x8A",
		"\x89\xF3"=>"\xE5\xA3\x8A",
		"\x89\xF4"=>"\xE5\xBB\xBB",
		"\x89\xF5"=>"\xE5\xBF\xAB",
		"\x89\xF6"=>"\xE6\x80\xAA",
		"\x89\xF7"=>"\xE6\x82\x94",
		"\x89\xF8"=>"\xE6\x81\xA2",
		"\x89\xF9"=>"\xE6\x87\x90",
		"\x89\xFA"=>"\xE6\x88\x92",
		"\x89\xFB"=>"\xE6\x8B\x90",
		"\x89\xFC"=>"\xE6\x94\xB9",
		"\x8A\x40"=>"\xE9\xAD\x81",
		"\x8A\x41"=>"\xE6\x99\xA6",
		"\x8A\x42"=>"\xE6\xA2\xB0",
		"\x8A\x43"=>"\xE6\xB5\xB7",
		"\x8A\x44"=>"\xE7\x81\xB0",
		"\x8A\x45"=>"\xE7\x95\x8C",
		"\x8A\x46"=>"\xE7\x9A\x86",
		"\x8A\x47"=>"\xE7\xB5\xB5",
		"\x8A\x48"=>"\xE8\x8A\xA5",
		"\x8A\x49"=>"\xE8\x9F\xB9",
		"\x8A\x4A"=>"\xE9\x96\x8B",
		"\x8A\x4B"=>"\xE9\x9A\x8E",
		"\x8A\x4C"=>"\xE8\xB2\x9D",
		"\x8A\x4D"=>"\xE5\x87\xB1",
		"\x8A\x4E"=>"\xE5\x8A\xBE",
		"\x8A\x4F"=>"\xE5\xA4\x96",
		"\x8A\x50"=>"\xE5\x92\xB3",
		"\x8A\x51"=>"\xE5\xAE\xB3",
		"\x8A\x52"=>"\xE5\xB4\x96",
		"\x8A\x53"=>"\xE6\x85\xA8",
		"\x8A\x54"=>"\xE6\xA6\x82",
		"\x8A\x55"=>"\xE6\xB6\xAF",
		"\x8A\x56"=>"\xE7\xA2\x8D",
		"\x8A\x57"=>"\xE8\x93\x8B",
		"\x8A\x58"=>"\xE8\xA1\x97",
		"\x8A\x59"=>"\xE8\xA9\xB2",
		"\x8A\x5A"=>"\xE9\x8E\xA7",
		"\x8A\x5B"=>"\xE9\xAA\xB8",
		"\x8A\x5C"=>"\xE6\xB5\xAC",
		"\x8A\x5D"=>"\xE9\xA6\xA8",
		"\x8A\x5E"=>"\xE8\x9B\x99",
		"\x8A\x5F"=>"\xE5\x9E\xA3",
		"\x8A\x60"=>"\xE6\x9F\xBF",
		"\x8A\x61"=>"\xE8\x9B\x8E",
		"\x8A\x62"=>"\xE9\x88\x8E",
		"\x8A\x63"=>"\xE5\x8A\x83",
		"\x8A\x64"=>"\xE5\x9A\x87",
		"\x8A\x65"=>"\xE5\x90\x84",
		"\x8A\x66"=>"\xE5\xBB\x93",
		"\x8A\x67"=>"\xE6\x8B\xA1",
		"\x8A\x68"=>"\xE6\x92\xB9",
		"\x8A\x69"=>"\xE6\xA0\xBC",
		"\x8A\x6A"=>"\xE6\xA0\xB8",
		"\x8A\x6B"=>"\xE6\xAE\xBB",
		"\x8A\x6C"=>"\xE7\x8D\xB2",
		"\x8A\x6D"=>"\xE7\xA2\xBA",
		"\x8A\x6E"=>"\xE7\xA9\xAB",
		"\x8A\x6F"=>"\xE8\xA6\x9A",
		"\x8A\x70"=>"\xE8\xA7\x92",
		"\x8A\x71"=>"\xE8\xB5\xAB",
		"\x8A\x72"=>"\xE8\xBC\x83",
		"\x8A\x73"=>"\xE9\x83\xAD",
		"\x8A\x74"=>"\xE9\x96\xA3",
		"\x8A\x75"=>"\xE9\x9A\x94",
		"\x8A\x76"=>"\xE9\x9D\xA9",
		"\x8A\x77"=>"\xE5\xAD\xA6",
		"\x8A\x78"=>"\xE5\xB2\xB3",
		"\x8A\x79"=>"\xE6\xA5\xBD",
		"\x8A\x7A"=>"\xE9\xA1\x8D",
		"\x8A\x7B"=>"\xE9\xA1\x8E",
		"\x8A\x7C"=>"\xE6\x8E\x9B",
		"\x8A\x7D"=>"\xE7\xAC\xA0",
		"\x8A\x7E"=>"\xE6\xA8\xAB",
		"\x8A\x80"=>"\xE6\xA9\xBF",
		"\x8A\x81"=>"\xE6\xA2\xB6",
		"\x8A\x82"=>"\xE9\xB0\x8D",
		"\x8A\x83"=>"\xE6\xBD\x9F",
		"\x8A\x84"=>"\xE5\x89\xB2",
		"\x8A\x85"=>"\xE5\x96\x9D",
		"\x8A\x86"=>"\xE6\x81\xB0",
		"\x8A\x87"=>"\xE6\x8B\xAC",
		"\x8A\x88"=>"\xE6\xB4\xBB",
		"\x8A\x89"=>"\xE6\xB8\x87",
		"\x8A\x8A"=>"\xE6\xBB\x91",
		"\x8A\x8B"=>"\xE8\x91\x9B",
		"\x8A\x8C"=>"\xE8\xA4\x90",
		"\x8A\x8D"=>"\xE8\xBD\x84",
		"\x8A\x8E"=>"\xE4\xB8\x94",
		"\x8A\x8F"=>"\xE9\xB0\xB9",
		"\x8A\x90"=>"\xE5\x8F\xB6",
		"\x8A\x91"=>"\xE6\xA4\x9B",
		"\x8A\x92"=>"\xE6\xA8\xBA",
		"\x8A\x93"=>"\xE9\x9E\x84",
		"\x8A\x94"=>"\xE6\xA0\xAA",
		"\x8A\x95"=>"\xE5\x85\x9C",
		"\x8A\x96"=>"\xE7\xAB\x83",
		"\x8A\x97"=>"\xE8\x92\xB2",
		"\x8A\x98"=>"\xE9\x87\x9C",
		"\x8A\x99"=>"\xE9\x8E\x8C",
		"\x8A\x9A"=>"\xE5\x99\x9B",
		"\x8A\x9B"=>"\xE9\xB4\xA8",
		"\x8A\x9C"=>"\xE6\xA0\xA2",
		"\x8A\x9D"=>"\xE8\x8C\x85",
		"\x8A\x9E"=>"\xE8\x90\xB1",
		"\x8A\x9F"=>"\xE7\xB2\xA5",
		"\x8A\xA0"=>"\xE5\x88\x88",
		"\x8A\xA1"=>"\xE8\x8B\x85",
		"\x8A\xA2"=>"\xE7\x93\xA6",
		"\x8A\xA3"=>"\xE4\xB9\xBE",
		"\x8A\xA4"=>"\xE4\xBE\x83",
		"\x8A\xA5"=>"\xE5\x86\xA0",
		"\x8A\xA6"=>"\xE5\xAF\x92",
		"\x8A\xA7"=>"\xE5\x88\x8A",
		"\x8A\xA8"=>"\xE5\x8B\x98",
		"\x8A\xA9"=>"\xE5\x8B\xA7",
		"\x8A\xAA"=>"\xE5\xB7\xBB",
		"\x8A\xAB"=>"\xE5\x96\x9A",
		"\x8A\xAC"=>"\xE5\xA0\xAA",
		"\x8A\xAD"=>"\xE5\xA7\xA6",
		"\x8A\xAE"=>"\xE5\xAE\x8C",
		"\x8A\xAF"=>"\xE5\xAE\x98",
		"\x8A\xB0"=>"\xE5\xAF\x9B",
		"\x8A\xB1"=>"\xE5\xB9\xB2",
		"\x8A\xB2"=>"\xE5\xB9\xB9",
		"\x8A\xB3"=>"\xE6\x82\xA3",
		"\x8A\xB4"=>"\xE6\x84\x9F",
		"\x8A\xB5"=>"\xE6\x85\xA3",
		"\x8A\xB6"=>"\xE6\x86\xBE",
		"\x8A\xB7"=>"\xE6\x8F\x9B",
		"\x8A\xB8"=>"\xE6\x95\xA2",
		"\x8A\xB9"=>"\xE6\x9F\x91",
		"\x8A\xBA"=>"\xE6\xA1\x93",
		"\x8A\xBB"=>"\xE6\xA3\xBA",
		"\x8A\xBC"=>"\xE6\xAC\xBE",
		"\x8A\xBD"=>"\xE6\xAD\x93",
		"\x8A\xBE"=>"\xE6\xB1\x97",
		"\x8A\xBF"=>"\xE6\xBC\xA2",
		"\x8A\xC0"=>"\xE6\xBE\x97",
		"\x8A\xC1"=>"\xE6\xBD\x85",
		"\x8A\xC2"=>"\xE7\x92\xB0",
		"\x8A\xC3"=>"\xE7\x94\x98",
		"\x8A\xC4"=>"\xE7\x9B\xA3",
		"\x8A\xC5"=>"\xE7\x9C\x8B",
		"\x8A\xC6"=>"\xE7\xAB\xBF",
		"\x8A\xC7"=>"\xE7\xAE\xA1",
		"\x8A\xC8"=>"\xE7\xB0\xA1",
		"\x8A\xC9"=>"\xE7\xB7\xA9",
		"\x8A\xCA"=>"\xE7\xBC\xB6",
		"\x8A\xCB"=>"\xE7\xBF\xB0",
		"\x8A\xCC"=>"\xE8\x82\x9D",
		"\x8A\xCD"=>"\xE8\x89\xA6",
		"\x8A\xCE"=>"\xE8\x8E\x9E",
		"\x8A\xCF"=>"\xE8\xA6\xB3",
		"\x8A\xD0"=>"\xE8\xAB\x8C",
		"\x8A\xD1"=>"\xE8\xB2\xAB",
		"\x8A\xD2"=>"\xE9\x82\x84",
		"\x8A\xD3"=>"\xE9\x91\x91",
		"\x8A\xD4"=>"\xE9\x96\x93",
		"\x8A\xD5"=>"\xE9\x96\x91",
		"\x8A\xD6"=>"\xE9\x96\xA2",
		"\x8A\xD7"=>"\xE9\x99\xA5",
		"\x8A\xD8"=>"\xE9\x9F\x93",
		"\x8A\xD9"=>"\xE9\xA4\xA8",
		"\x8A\xDA"=>"\xE8\x88\x98",
		"\x8A\xDB"=>"\xE4\xB8\xB8",
		"\x8A\xDC"=>"\xE5\x90\xAB",
		"\x8A\xDD"=>"\xE5\xB2\xB8",
		"\x8A\xDE"=>"\xE5\xB7\x8C",
		"\x8A\xDF"=>"\xE7\x8E\xA9",
		"\x8A\xE0"=>"\xE7\x99\x8C",
		"\x8A\xE1"=>"\xE7\x9C\xBC",
		"\x8A\xE2"=>"\xE5\xB2\xA9",
		"\x8A\xE3"=>"\xE7\xBF\xAB",
		"\x8A\xE4"=>"\xE8\xB4\x8B",
		"\x8A\xE5"=>"\xE9\x9B\x81",
		"\x8A\xE6"=>"\xE9\xA0\x91",
		"\x8A\xE7"=>"\xE9\xA1\x94",
		"\x8A\xE8"=>"\xE9\xA1\x98",
		"\x8A\xE9"=>"\xE4\xBC\x81",
		"\x8A\xEA"=>"\xE4\xBC\x8E",
		"\x8A\xEB"=>"\xE5\x8D\xB1",
		"\x8A\xEC"=>"\xE5\x96\x9C",
		"\x8A\xED"=>"\xE5\x99\xA8",
		"\x8A\xEE"=>"\xE5\x9F\xBA",
		"\x8A\xEF"=>"\xE5\xA5\x87",
		"\x8A\xF0"=>"\xE5\xAC\x89",
		"\x8A\xF1"=>"\xE5\xAF\x84",
		"\x8A\xF2"=>"\xE5\xB2\x90",
		"\x8A\xF3"=>"\xE5\xB8\x8C",
		"\x8A\xF4"=>"\xE5\xB9\xBE",
		"\x8A\xF5"=>"\xE5\xBF\x8C",
		"\x8A\xF6"=>"\xE6\x8F\xAE",
		"\x8A\xF7"=>"\xE6\x9C\xBA",
		"\x8A\xF8"=>"\xE6\x97\x97",
		"\x8A\xF9"=>"\xE6\x97\xA2",
		"\x8A\xFA"=>"\xE6\x9C\x9F",
		"\x8A\xFB"=>"\xE6\xA3\x8B",
		"\x8A\xFC"=>"\xE6\xA3\x84",
		"\x8B\x40"=>"\xE6\xA9\x9F",
		"\x8B\x41"=>"\xE5\xB8\xB0",
		"\x8B\x42"=>"\xE6\xAF\x85",
		"\x8B\x43"=>"\xE6\xB0\x97",
		"\x8B\x44"=>"\xE6\xB1\xBD",
		"\x8B\x45"=>"\xE7\x95\xBF",
		"\x8B\x46"=>"\xE7\xA5\x88",
		"\x8B\x47"=>"\xE5\xAD\xA3",
		"\x8B\x48"=>"\xE7\xA8\x80",
		"\x8B\x49"=>"\xE7\xB4\x80",
		"\x8B\x4A"=>"\xE5\xBE\xBD",
		"\x8B\x4B"=>"\xE8\xA6\x8F",
		"\x8B\x4C"=>"\xE8\xA8\x98",
		"\x8B\x4D"=>"\xE8\xB2\xB4",
		"\x8B\x4E"=>"\xE8\xB5\xB7",
		"\x8B\x4F"=>"\xE8\xBB\x8C",
		"\x8B\x50"=>"\xE8\xBC\x9D",
		"\x8B\x51"=>"\xE9\xA3\xA2",
		"\x8B\x52"=>"\xE9\xA8\x8E",
		"\x8B\x53"=>"\xE9\xAC\xBC",
		"\x8B\x54"=>"\xE4\xBA\x80",
		"\x8B\x55"=>"\xE5\x81\xBD",
		"\x8B\x56"=>"\xE5\x84\x80",
		"\x8B\x57"=>"\xE5\xA6\x93",
		"\x8B\x58"=>"\xE5\xAE\x9C",
		"\x8B\x59"=>"\xE6\x88\xAF",
		"\x8B\x5A"=>"\xE6\x8A\x80",
		"\x8B\x5B"=>"\xE6\x93\xAC",
		"\x8B\x5C"=>"\xE6\xAC\xBA",
		"\x8B\x5D"=>"\xE7\x8A\xA0",
		"\x8B\x5E"=>"\xE7\x96\x91",
		"\x8B\x5F"=>"\xE7\xA5\x87",
		"\x8B\x60"=>"\xE7\xBE\xA9",
		"\x8B\x61"=>"\xE8\x9F\xBB",
		"\x8B\x62"=>"\xE8\xAA\xBC",
		"\x8B\x63"=>"\xE8\xAD\xB0",
		"\x8B\x64"=>"\xE6\x8E\xAC",
		"\x8B\x65"=>"\xE8\x8F\x8A",
		"\x8B\x66"=>"\xE9\x9E\xA0",
		"\x8B\x67"=>"\xE5\x90\x89",
		"\x8B\x68"=>"\xE5\x90\x83",
		"\x8B\x69"=>"\xE5\x96\xAB",
		"\x8B\x6A"=>"\xE6\xA1\x94",
		"\x8B\x6B"=>"\xE6\xA9\x98",
		"\x8B\x6C"=>"\xE8\xA9\xB0",
		"\x8B\x6D"=>"\xE7\xA0\xA7",
		"\x8B\x6E"=>"\xE6\x9D\xB5",
		"\x8B\x6F"=>"\xE9\xBB\x8D",
		"\x8B\x70"=>"\xE5\x8D\xB4",
		"\x8B\x71"=>"\xE5\xAE\xA2",
		"\x8B\x72"=>"\xE8\x84\x9A",
		"\x8B\x73"=>"\xE8\x99\x90",
		"\x8B\x74"=>"\xE9\x80\x86",
		"\x8B\x75"=>"\xE4\xB8\x98",
		"\x8B\x76"=>"\xE4\xB9\x85",
		"\x8B\x77"=>"\xE4\xBB\x87",
		"\x8B\x78"=>"\xE4\xBC\x91",
		"\x8B\x79"=>"\xE5\x8F\x8A",
		"\x8B\x7A"=>"\xE5\x90\xB8",
		"\x8B\x7B"=>"\xE5\xAE\xAE",
		"\x8B\x7C"=>"\xE5\xBC\x93",
		"\x8B\x7D"=>"\xE6\x80\xA5",
		"\x8B\x7E"=>"\xE6\x95\x91",
		"\x8B\x80"=>"\xE6\x9C\xBD",
		"\x8B\x81"=>"\xE6\xB1\x82",
		"\x8B\x82"=>"\xE6\xB1\xB2",
		"\x8B\x83"=>"\xE6\xB3\xA3",
		"\x8B\x84"=>"\xE7\x81\xB8",
		"\x8B\x85"=>"\xE7\x90\x83",
		"\x8B\x86"=>"\xE7\xA9\xB6",
		"\x8B\x87"=>"\xE7\xAA\xAE",
		"\x8B\x88"=>"\xE7\xAC\x88",
		"\x8B\x89"=>"\xE7\xB4\x9A",
		"\x8B\x8A"=>"\xE7\xB3\xBE",
		"\x8B\x8B"=>"\xE7\xB5\xA6",
		"\x8B\x8C"=>"\xE6\x97\xA7",
		"\x8B\x8D"=>"\xE7\x89\x9B",
		"\x8B\x8E"=>"\xE5\x8E\xBB",
		"\x8B\x8F"=>"\xE5\xB1\x85",
		"\x8B\x90"=>"\xE5\xB7\xA8",
		"\x8B\x91"=>"\xE6\x8B\x92",
		"\x8B\x92"=>"\xE6\x8B\xA0",
		"\x8B\x93"=>"\xE6\x8C\x99",
		"\x8B\x94"=>"\xE6\xB8\xA0",
		"\x8B\x95"=>"\xE8\x99\x9A",
		"\x8B\x96"=>"\xE8\xA8\xB1",
		"\x8B\x97"=>"\xE8\xB7\x9D",
		"\x8B\x98"=>"\xE9\x8B\xB8",
		"\x8B\x99"=>"\xE6\xBC\x81",
		"\x8B\x9A"=>"\xE7\xA6\xA6",
		"\x8B\x9B"=>"\xE9\xAD\x9A",
		"\x8B\x9C"=>"\xE4\xBA\xA8",
		"\x8B\x9D"=>"\xE4\xBA\xAB",
		"\x8B\x9E"=>"\xE4\xBA\xAC",
		"\x8B\x9F"=>"\xE4\xBE\x9B",
		"\x8B\xA0"=>"\xE4\xBE\xA0",
		"\x8B\xA1"=>"\xE5\x83\x91",
		"\x8B\xA2"=>"\xE5\x85\x87",
		"\x8B\xA3"=>"\xE7\xAB\xB6",
		"\x8B\xA4"=>"\xE5\x85\xB1",
		"\x8B\xA5"=>"\xE5\x87\xB6",
		"\x8B\xA6"=>"\xE5\x8D\x94",
		"\x8B\xA7"=>"\xE5\x8C\xA1",
		"\x8B\xA8"=>"\xE5\x8D\xBF",
		"\x8B\xA9"=>"\xE5\x8F\xAB",
		"\x8B\xAA"=>"\xE5\x96\xAC",
		"\x8B\xAB"=>"\xE5\xA2\x83",
		"\x8B\xAC"=>"\xE5\xB3\xA1",
		"\x8B\xAD"=>"\xE5\xBC\xB7",
		"\x8B\xAE"=>"\xE5\xBD\x8A",
		"\x8B\xAF"=>"\xE6\x80\xAF",
		"\x8B\xB0"=>"\xE6\x81\x90",
		"\x8B\xB1"=>"\xE6\x81\xAD",
		"\x8B\xB2"=>"\xE6\x8C\x9F",
		"\x8B\xB3"=>"\xE6\x95\x99",
		"\x8B\xB4"=>"\xE6\xA9\x8B",
		"\x8B\xB5"=>"\xE6\xB3\x81",
		"\x8B\xB6"=>"\xE7\x8B\x82",
		"\x8B\xB7"=>"\xE7\x8B\xAD",
		"\x8B\xB8"=>"\xE7\x9F\xAF",
		"\x8B\xB9"=>"\xE8\x83\xB8",
		"\x8B\xBA"=>"\xE8\x84\x85",
		"\x8B\xBB"=>"\xE8\x88\x88",
		"\x8B\xBC"=>"\xE8\x95\x8E",
		"\x8B\xBD"=>"\xE9\x83\xB7",
		"\x8B\xBE"=>"\xE9\x8F\xA1",
		"\x8B\xBF"=>"\xE9\x9F\xBF",
		"\x8B\xC0"=>"\xE9\xA5\x97",
		"\x8B\xC1"=>"\xE9\xA9\x9A",
		"\x8B\xC2"=>"\xE4\xBB\xB0",
		"\x8B\xC3"=>"\xE5\x87\x9D",
		"\x8B\xC4"=>"\xE5\xB0\xAD",
		"\x8B\xC5"=>"\xE6\x9A\x81",
		"\x8B\xC6"=>"\xE6\xA5\xAD",
		"\x8B\xC7"=>"\xE5\xB1\x80",
		"\x8B\xC8"=>"\xE6\x9B\xB2",
		"\x8B\xC9"=>"\xE6\xA5\xB5",
		"\x8B\xCA"=>"\xE7\x8E\x89",
		"\x8B\xCB"=>"\xE6\xA1\x90",
		"\x8B\xCC"=>"\xE7\xB2\x81",
		"\x8B\xCD"=>"\xE5\x83\x85",
		"\x8B\xCE"=>"\xE5\x8B\xA4",
		"\x8B\xCF"=>"\xE5\x9D\x87",
		"\x8B\xD0"=>"\xE5\xB7\xBE",
		"\x8B\xD1"=>"\xE9\x8C\xA6",
		"\x8B\xD2"=>"\xE6\x96\xA4",
		"\x8B\xD3"=>"\xE6\xAC\xA3",
		"\x8B\xD4"=>"\xE6\xAC\xBD",
		"\x8B\xD5"=>"\xE7\x90\xB4",
		"\x8B\xD6"=>"\xE7\xA6\x81",
		"\x8B\xD7"=>"\xE7\xA6\xBD",
		"\x8B\xD8"=>"\xE7\xAD\x8B",
		"\x8B\xD9"=>"\xE7\xB7\x8A",
		"\x8B\xDA"=>"\xE8\x8A\xB9",
		"\x8B\xDB"=>"\xE8\x8F\x8C",
		"\x8B\xDC"=>"\xE8\xA1\xBF",
		"\x8B\xDD"=>"\xE8\xA5\x9F",
		"\x8B\xDE"=>"\xE8\xAC\xB9",
		"\x8B\xDF"=>"\xE8\xBF\x91",
		"\x8B\xE0"=>"\xE9\x87\x91",
		"\x8B\xE1"=>"\xE5\x90\x9F",
		"\x8B\xE2"=>"\xE9\x8A\x80",
		"\x8B\xE3"=>"\xE4\xB9\x9D",
		"\x8B\xE4"=>"\xE5\x80\xB6",
		"\x8B\xE5"=>"\xE5\x8F\xA5",
		"\x8B\xE6"=>"\xE5\x8C\xBA",
		"\x8B\xE7"=>"\xE7\x8B\x97",
		"\x8B\xE8"=>"\xE7\x8E\x96",
		"\x8B\xE9"=>"\xE7\x9F\xA9",
		"\x8B\xEA"=>"\xE8\x8B\xA6",
		"\x8B\xEB"=>"\xE8\xBA\xAF",
		"\x8B\xEC"=>"\xE9\xA7\x86",
		"\x8B\xED"=>"\xE9\xA7\x88",
		"\x8B\xEE"=>"\xE9\xA7\x92",
		"\x8B\xEF"=>"\xE5\x85\xB7",
		"\x8B\xF0"=>"\xE6\x84\x9A",
		"\x8B\xF1"=>"\xE8\x99\x9E",
		"\x8B\xF2"=>"\xE5\x96\xB0",
		"\x8B\xF3"=>"\xE7\xA9\xBA",
		"\x8B\xF4"=>"\xE5\x81\xB6",
		"\x8B\xF5"=>"\xE5\xAF\x93",
		"\x8B\xF6"=>"\xE9\x81\x87",
		"\x8B\xF7"=>"\xE9\x9A\x85",
		"\x8B\xF8"=>"\xE4\xB8\xB2",
		"\x8B\xF9"=>"\xE6\xAB\x9B",
		"\x8B\xFA"=>"\xE9\x87\xA7",
		"\x8B\xFB"=>"\xE5\xB1\x91",
		"\x8B\xFC"=>"\xE5\xB1\x88",
		"\x8C\x40"=>"\xE6\x8E\x98",
		"\x8C\x41"=>"\xE7\xAA\x9F",
		"\x8C\x42"=>"\xE6\xB2\x93",
		"\x8C\x43"=>"\xE9\x9D\xB4",
		"\x8C\x44"=>"\xE8\xBD\xA1",
		"\x8C\x45"=>"\xE7\xAA\xAA",
		"\x8C\x46"=>"\xE7\x86\x8A",
		"\x8C\x47"=>"\xE9\x9A\x88",
		"\x8C\x48"=>"\xE7\xB2\x82",
		"\x8C\x49"=>"\xE6\xA0\x97",
		"\x8C\x4A"=>"\xE7\xB9\xB0",
		"\x8C\x4B"=>"\xE6\xA1\x91",
		"\x8C\x4C"=>"\xE9\x8D\xAC",
		"\x8C\x4D"=>"\xE5\x8B\xB2",
		"\x8C\x4E"=>"\xE5\x90\x9B",
		"\x8C\x4F"=>"\xE8\x96\xAB",
		"\x8C\x50"=>"\xE8\xA8\x93",
		"\x8C\x51"=>"\xE7\xBE\xA4",
		"\x8C\x52"=>"\xE8\xBB\x8D",
		"\x8C\x53"=>"\xE9\x83\xA1",
		"\x8C\x54"=>"\xE5\x8D\xA6",
		"\x8C\x55"=>"\xE8\xA2\x88",
		"\x8C\x56"=>"\xE7\xA5\x81",
		"\x8C\x57"=>"\xE4\xBF\x82",
		"\x8C\x58"=>"\xE5\x82\xBE",
		"\x8C\x59"=>"\xE5\x88\x91",
		"\x8C\x5A"=>"\xE5\x85\x84",
		"\x8C\x5B"=>"\xE5\x95\x93",
		"\x8C\x5C"=>"\xE5\x9C\xAD",
		"\x8C\x5D"=>"\xE7\x8F\xAA",
		"\x8C\x5E"=>"\xE5\x9E\x8B",
		"\x8C\x5F"=>"\xE5\xA5\x91",
		"\x8C\x60"=>"\xE5\xBD\xA2",
		"\x8C\x61"=>"\xE5\xBE\x84",
		"\x8C\x62"=>"\xE6\x81\xB5",
		"\x8C\x63"=>"\xE6\x85\xB6",
		"\x8C\x64"=>"\xE6\x85\xA7",
		"\x8C\x65"=>"\xE6\x86\xA9",
		"\x8C\x66"=>"\xE6\x8E\xB2",
		"\x8C\x67"=>"\xE6\x90\xBA",
		"\x8C\x68"=>"\xE6\x95\xAC",
		"\x8C\x69"=>"\xE6\x99\xAF",
		"\x8C\x6A"=>"\xE6\xA1\x82",
		"\x8C\x6B"=>"\xE6\xB8\x93",
		"\x8C\x6C"=>"\xE7\x95\xA6",
		"\x8C\x6D"=>"\xE7\xA8\xBD",
		"\x8C\x6E"=>"\xE7\xB3\xBB",
		"\x8C\x6F"=>"\xE7\xB5\x8C",
		"\x8C\x70"=>"\xE7\xB6\x99",
		"\x8C\x71"=>"\xE7\xB9\x8B",
		"\x8C\x72"=>"\xE7\xBD\xAB",
		"\x8C\x73"=>"\xE8\x8C\x8E",
		"\x8C\x74"=>"\xE8\x8D\x8A",
		"\x8C\x75"=>"\xE8\x9B\x8D",
		"\x8C\x76"=>"\xE8\xA8\x88",
		"\x8C\x77"=>"\xE8\xA9\xA3",
		"\x8C\x78"=>"\xE8\xAD\xA6",
		"\x8C\x79"=>"\xE8\xBB\xBD",
		"\x8C\x7A"=>"\xE9\xA0\x9A",
		"\x8C\x7B"=>"\xE9\xB6\x8F",
		"\x8C\x7C"=>"\xE8\x8A\xB8",
		"\x8C\x7D"=>"\xE8\xBF\x8E",
		"\x8C\x7E"=>"\xE9\xAF\xA8",
		"\x8C\x80"=>"\xE5\x8A\x87",
		"\x8C\x81"=>"\xE6\x88\x9F",
		"\x8C\x82"=>"\xE6\x92\x83",
		"\x8C\x83"=>"\xE6\xBF\x80",
		"\x8C\x84"=>"\xE9\x9A\x99",
		"\x8C\x85"=>"\xE6\xA1\x81",
		"\x8C\x86"=>"\xE5\x82\x91",
		"\x8C\x87"=>"\xE6\xAC\xA0",
		"\x8C\x88"=>"\xE6\xB1\xBA",
		"\x8C\x89"=>"\xE6\xBD\x94",
		"\x8C\x8A"=>"\xE7\xA9\xB4",
		"\x8C\x8B"=>"\xE7\xB5\x90",
		"\x8C\x8C"=>"\xE8\xA1\x80",
		"\x8C\x8D"=>"\xE8\xA8\xA3",
		"\x8C\x8E"=>"\xE6\x9C\x88",
		"\x8C\x8F"=>"\xE4\xBB\xB6",
		"\x8C\x90"=>"\xE5\x80\xB9",
		"\x8C\x91"=>"\xE5\x80\xA6",
		"\x8C\x92"=>"\xE5\x81\xA5",
		"\x8C\x93"=>"\xE5\x85\xBC",
		"\x8C\x94"=>"\xE5\x88\xB8",
		"\x8C\x95"=>"\xE5\x89\xA3",
		"\x8C\x96"=>"\xE5\x96\xA7",
		"\x8C\x97"=>"\xE5\x9C\x8F",
		"\x8C\x98"=>"\xE5\xA0\x85",
		"\x8C\x99"=>"\xE5\xAB\x8C",
		"\x8C\x9A"=>"\xE5\xBB\xBA",
		"\x8C\x9B"=>"\xE6\x86\xB2",
		"\x8C\x9C"=>"\xE6\x87\xB8",
		"\x8C\x9D"=>"\xE6\x8B\xB3",
		"\x8C\x9E"=>"\xE6\x8D\xB2",
		"\x8C\x9F"=>"\xE6\xA4\x9C",
		"\x8C\xA0"=>"\xE6\xA8\xA9",
		"\x8C\xA1"=>"\xE7\x89\xBD",
		"\x8C\xA2"=>"\xE7\x8A\xAC",
		"\x8C\xA3"=>"\xE7\x8C\xAE",
		"\x8C\xA4"=>"\xE7\xA0\x94",
		"\x8C\xA5"=>"\xE7\xA1\xAF",
		"\x8C\xA6"=>"\xE7\xB5\xB9",
		"\x8C\xA7"=>"\xE7\x9C\x8C",
		"\x8C\xA8"=>"\xE8\x82\xA9",
		"\x8C\xA9"=>"\xE8\xA6\x8B",
		"\x8C\xAA"=>"\xE8\xAC\x99",
		"\x8C\xAB"=>"\xE8\xB3\xA2",
		"\x8C\xAC"=>"\xE8\xBB\x92",
		"\x8C\xAD"=>"\xE9\x81\xA3",
		"\x8C\xAE"=>"\xE9\x8D\xB5",
		"\x8C\xAF"=>"\xE9\x99\xBA",
		"\x8C\xB0"=>"\xE9\xA1\x95",
		"\x8C\xB1"=>"\xE9\xA8\x93",
		"\x8C\xB2"=>"\xE9\xB9\xB8",
		"\x8C\xB3"=>"\xE5\x85\x83",
		"\x8C\xB4"=>"\xE5\x8E\x9F",
		"\x8C\xB5"=>"\xE5\x8E\xB3",
		"\x8C\xB6"=>"\xE5\xB9\xBB",
		"\x8C\xB7"=>"\xE5\xBC\xA6",
		"\x8C\xB8"=>"\xE6\xB8\x9B",
		"\x8C\xB9"=>"\xE6\xBA\x90",
		"\x8C\xBA"=>"\xE7\x8E\x84",
		"\x8C\xBB"=>"\xE7\x8F\xBE",
		"\x8C\xBC"=>"\xE7\xB5\x83",
		"\x8C\xBD"=>"\xE8\x88\xB7",
		"\x8C\xBE"=>"\xE8\xA8\x80",
		"\x8C\xBF"=>"\xE8\xAB\xBA",
		"\x8C\xC0"=>"\xE9\x99\x90",
		"\x8C\xC1"=>"\xE4\xB9\x8E",
		"\x8C\xC2"=>"\xE5\x80\x8B",
		"\x8C\xC3"=>"\xE5\x8F\xA4",
		"\x8C\xC4"=>"\xE5\x91\xBC",
		"\x8C\xC5"=>"\xE5\x9B\xBA",
		"\x8C\xC6"=>"\xE5\xA7\x91",
		"\x8C\xC7"=>"\xE5\xAD\xA4",
		"\x8C\xC8"=>"\xE5\xB7\xB1",
		"\x8C\xC9"=>"\xE5\xBA\xAB",
		"\x8C\xCA"=>"\xE5\xBC\xA7",
		"\x8C\xCB"=>"\xE6\x88\xB8",
		"\x8C\xCC"=>"\xE6\x95\x85",
		"\x8C\xCD"=>"\xE6\x9E\xAF",
		"\x8C\xCE"=>"\xE6\xB9\x96",
		"\x8C\xCF"=>"\xE7\x8B\x90",
		"\x8C\xD0"=>"\xE7\xB3\x8A",
		"\x8C\xD1"=>"\xE8\xA2\xB4",
		"\x8C\xD2"=>"\xE8\x82\xA1",
		"\x8C\xD3"=>"\xE8\x83\xA1",
		"\x8C\xD4"=>"\xE8\x8F\xB0",
		"\x8C\xD5"=>"\xE8\x99\x8E",
		"\x8C\xD6"=>"\xE8\xAA\x87",
		"\x8C\xD7"=>"\xE8\xB7\xA8",
		"\x8C\xD8"=>"\xE9\x88\xB7",
		"\x8C\xD9"=>"\xE9\x9B\x87",
		"\x8C\xDA"=>"\xE9\xA1\xA7",
		"\x8C\xDB"=>"\xE9\xBC\x93",
		"\x8C\xDC"=>"\xE4\xBA\x94",
		"\x8C\xDD"=>"\xE4\xBA\x92",
		"\x8C\xDE"=>"\xE4\xBC\x8D",
		"\x8C\xDF"=>"\xE5\x8D\x88",
		"\x8C\xE0"=>"\xE5\x91\x89",
		"\x8C\xE1"=>"\xE5\x90\xBE",
		"\x8C\xE2"=>"\xE5\xA8\xAF",
		"\x8C\xE3"=>"\xE5\xBE\x8C",
		"\x8C\xE4"=>"\xE5\xBE\xA1",
		"\x8C\xE5"=>"\xE6\x82\x9F",
		"\x8C\xE6"=>"\xE6\xA2\xA7",
		"\x8C\xE7"=>"\xE6\xAA\x8E",
		"\x8C\xE8"=>"\xE7\x91\x9A",
		"\x8C\xE9"=>"\xE7\xA2\x81",
		"\x8C\xEA"=>"\xE8\xAA\x9E",
		"\x8C\xEB"=>"\xE8\xAA\xA4",
		"\x8C\xEC"=>"\xE8\xAD\xB7",
		"\x8C\xED"=>"\xE9\x86\x90",
		"\x8C\xEE"=>"\xE4\xB9\x9E",
		"\x8C\xEF"=>"\xE9\xAF\x89",
		"\x8C\xF0"=>"\xE4\xBA\xA4",
		"\x8C\xF1"=>"\xE4\xBD\xBC",
		"\x8C\xF2"=>"\xE4\xBE\xAF",
		"\x8C\xF3"=>"\xE5\x80\x99",
		"\x8C\xF4"=>"\xE5\x80\x96",
		"\x8C\xF5"=>"\xE5\x85\x89",
		"\x8C\xF6"=>"\xE5\x85\xAC",
		"\x8C\xF7"=>"\xE5\x8A\x9F",
		"\x8C\xF8"=>"\xE5\x8A\xB9",
		"\x8C\xF9"=>"\xE5\x8B\xBE",
		"\x8C\xFA"=>"\xE5\x8E\x9A",
		"\x8C\xFB"=>"\xE5\x8F\xA3",
		"\x8C\xFC"=>"\xE5\x90\x91",
		"\x8D\x40"=>"\xE5\x90\x8E",
		"\x8D\x41"=>"\xE5\x96\x89",
		"\x8D\x42"=>"\xE5\x9D\x91",
		"\x8D\x43"=>"\xE5\x9E\xA2",
		"\x8D\x44"=>"\xE5\xA5\xBD",
		"\x8D\x45"=>"\xE5\xAD\x94",
		"\x8D\x46"=>"\xE5\xAD\x9D",
		"\x8D\x47"=>"\xE5\xAE\x8F",
		"\x8D\x48"=>"\xE5\xB7\xA5",
		"\x8D\x49"=>"\xE5\xB7\xA7",
		"\x8D\x4A"=>"\xE5\xB7\xB7",
		"\x8D\x4B"=>"\xE5\xB9\xB8",
		"\x8D\x4C"=>"\xE5\xBA\x83",
		"\x8D\x4D"=>"\xE5\xBA\x9A",
		"\x8D\x4E"=>"\xE5\xBA\xB7",
		"\x8D\x4F"=>"\xE5\xBC\x98",
		"\x8D\x50"=>"\xE6\x81\x92",
		"\x8D\x51"=>"\xE6\x85\x8C",
		"\x8D\x52"=>"\xE6\x8A\x97",
		"\x8D\x53"=>"\xE6\x8B\x98",
		"\x8D\x54"=>"\xE6\x8E\xA7",
		"\x8D\x55"=>"\xE6\x94\xBB",
		"\x8D\x56"=>"\xE6\x98\x82",
		"\x8D\x57"=>"\xE6\x99\x83",
		"\x8D\x58"=>"\xE6\x9B\xB4",
		"\x8D\x59"=>"\xE6\x9D\xAD",
		"\x8D\x5A"=>"\xE6\xA0\xA1",
		"\x8D\x5B"=>"\xE6\xA2\x97",
		"\x8D\x5C"=>"\xE6\xA7\x8B",
		"\x8D\x5D"=>"\xE6\xB1\x9F",
		"\x8D\x5E"=>"\xE6\xB4\xAA",
		"\x8D\x5F"=>"\xE6\xB5\xA9",
		"\x8D\x60"=>"\xE6\xB8\xAF",
		"\x8D\x61"=>"\xE6\xBA\x9D",
		"\x8D\x62"=>"\xE7\x94\xB2",
		"\x8D\x63"=>"\xE7\x9A\x87",
		"\x8D\x64"=>"\xE7\xA1\xAC",
		"\x8D\x65"=>"\xE7\xA8\xBF",
		"\x8D\x66"=>"\xE7\xB3\xA0",
		"\x8D\x67"=>"\xE7\xB4\x85",
		"\x8D\x68"=>"\xE7\xB4\x98",
		"\x8D\x69"=>"\xE7\xB5\x9E",
		"\x8D\x6A"=>"\xE7\xB6\xB1",
		"\x8D\x6B"=>"\xE8\x80\x95",
		"\x8D\x6C"=>"\xE8\x80\x83",
		"\x8D\x6D"=>"\xE8\x82\xAF",
		"\x8D\x6E"=>"\xE8\x82\xB1",
		"\x8D\x6F"=>"\xE8\x85\x94",
		"\x8D\x70"=>"\xE8\x86\x8F",
		"\x8D\x71"=>"\xE8\x88\xAA",
		"\x8D\x72"=>"\xE8\x8D\x92",
		"\x8D\x73"=>"\xE8\xA1\x8C",
		"\x8D\x74"=>"\xE8\xA1\xA1",
		"\x8D\x75"=>"\xE8\xAC\x9B",
		"\x8D\x76"=>"\xE8\xB2\xA2",
		"\x8D\x77"=>"\xE8\xB3\xBC",
		"\x8D\x78"=>"\xE9\x83\x8A",
		"\x8D\x79"=>"\xE9\x85\xB5",
		"\x8D\x7A"=>"\xE9\x89\xB1",
		"\x8D\x7B"=>"\xE7\xA0\xBF",
		"\x8D\x7C"=>"\xE9\x8B\xBC",
		"\x8D\x7D"=>"\xE9\x96\xA4",
		"\x8D\x7E"=>"\xE9\x99\x8D",
		"\x8D\x80"=>"\xE9\xA0\x85",
		"\x8D\x81"=>"\xE9\xA6\x99",
		"\x8D\x82"=>"\xE9\xAB\x98",
		"\x8D\x83"=>"\xE9\xB4\xBB",
		"\x8D\x84"=>"\xE5\x89\x9B",
		"\x8D\x85"=>"\xE5\x8A\xAB",
		"\x8D\x86"=>"\xE5\x8F\xB7",
		"\x8D\x87"=>"\xE5\x90\x88",
		"\x8D\x88"=>"\xE5\xA3\x95",
		"\x8D\x89"=>"\xE6\x8B\xB7",
		"\x8D\x8A"=>"\xE6\xBF\xA0",
		"\x8D\x8B"=>"\xE8\xB1\xAA",
		"\x8D\x8C"=>"\xE8\xBD\x9F",
		"\x8D\x8D"=>"\xE9\xBA\xB9",
		"\x8D\x8E"=>"\xE5\x85\x8B",
		"\x8D\x8F"=>"\xE5\x88\xBB",
		"\x8D\x90"=>"\xE5\x91\x8A",
		"\x8D\x91"=>"\xE5\x9B\xBD",
		"\x8D\x92"=>"\xE7\xA9\x80",
		"\x8D\x93"=>"\xE9\x85\xB7",
		"\x8D\x94"=>"\xE9\xB5\xA0",
		"\x8D\x95"=>"\xE9\xBB\x92",
		"\x8D\x96"=>"\xE7\x8D\x84",
		"\x8D\x97"=>"\xE6\xBC\x89",
		"\x8D\x98"=>"\xE8\x85\xB0",
		"\x8D\x99"=>"\xE7\x94\x91",
		"\x8D\x9A"=>"\xE5\xBF\xBD",
		"\x8D\x9B"=>"\xE6\x83\x9A",
		"\x8D\x9C"=>"\xE9\xAA\xA8",
		"\x8D\x9D"=>"\xE7\x8B\x9B",
		"\x8D\x9E"=>"\xE8\xBE\xBC",
		"\x8D\x9F"=>"\xE6\xAD\xA4",
		"\x8D\xA0"=>"\xE9\xA0\x83",
		"\x8D\xA1"=>"\xE4\xBB\x8A",
		"\x8D\xA2"=>"\xE5\x9B\xB0",
		"\x8D\xA3"=>"\xE5\x9D\xA4",
		"\x8D\xA4"=>"\xE5\xA2\xBE",
		"\x8D\xA5"=>"\xE5\xA9\x9A",
		"\x8D\xA6"=>"\xE6\x81\xA8",
		"\x8D\xA7"=>"\xE6\x87\x87",
		"\x8D\xA8"=>"\xE6\x98\x8F",
		"\x8D\xA9"=>"\xE6\x98\x86",
		"\x8D\xAA"=>"\xE6\xA0\xB9",
		"\x8D\xAB"=>"\xE6\xA2\xB1",
		"\x8D\xAC"=>"\xE6\xB7\xB7",
		"\x8D\xAD"=>"\xE7\x97\x95",
		"\x8D\xAE"=>"\xE7\xB4\xBA",
		"\x8D\xAF"=>"\xE8\x89\xAE",
		"\x8D\xB0"=>"\xE9\xAD\x82",
		"\x8D\xB1"=>"\xE4\xBA\x9B",
		"\x8D\xB2"=>"\xE4\xBD\x90",
		"\x8D\xB3"=>"\xE5\x8F\x89",
		"\x8D\xB4"=>"\xE5\x94\x86",
		"\x8D\xB5"=>"\xE5\xB5\xAF",
		"\x8D\xB6"=>"\xE5\xB7\xA6",
		"\x8D\xB7"=>"\xE5\xB7\xAE",
		"\x8D\xB8"=>"\xE6\x9F\xBB",
		"\x8D\xB9"=>"\xE6\xB2\x99",
		"\x8D\xBA"=>"\xE7\x91\xB3",
		"\x8D\xBB"=>"\xE7\xA0\x82",
		"\x8D\xBC"=>"\xE8\xA9\x90",
		"\x8D\xBD"=>"\xE9\x8E\x96",
		"\x8D\xBE"=>"\xE8\xA3\x9F",
		"\x8D\xBF"=>"\xE5\x9D\x90",
		"\x8D\xC0"=>"\xE5\xBA\xA7",
		"\x8D\xC1"=>"\xE6\x8C\xAB",
		"\x8D\xC2"=>"\xE5\x82\xB5",
		"\x8D\xC3"=>"\xE5\x82\xAC",
		"\x8D\xC4"=>"\xE5\x86\x8D",
		"\x8D\xC5"=>"\xE6\x9C\x80",
		"\x8D\xC6"=>"\xE5\x93\x89",
		"\x8D\xC7"=>"\xE5\xA1\x9E",
		"\x8D\xC8"=>"\xE5\xA6\xBB",
		"\x8D\xC9"=>"\xE5\xAE\xB0",
		"\x8D\xCA"=>"\xE5\xBD\xA9",
		"\x8D\xCB"=>"\xE6\x89\x8D",
		"\x8D\xCC"=>"\xE6\x8E\xA1",
		"\x8D\xCD"=>"\xE6\xA0\xBD",
		"\x8D\xCE"=>"\xE6\xAD\xB3",
		"\x8D\xCF"=>"\xE6\xB8\x88",
		"\x8D\xD0"=>"\xE7\x81\xBD",
		"\x8D\xD1"=>"\xE9\x87\x87",
		"\x8D\xD2"=>"\xE7\x8A\x80",
		"\x8D\xD3"=>"\xE7\xA0\x95",
		"\x8D\xD4"=>"\xE7\xA0\xA6",
		"\x8D\xD5"=>"\xE7\xA5\xAD",
		"\x8D\xD6"=>"\xE6\x96\x8E",
		"\x8D\xD7"=>"\xE7\xB4\xB0",
		"\x8D\xD8"=>"\xE8\x8F\x9C",
		"\x8D\xD9"=>"\xE8\xA3\x81",
		"\x8D\xDA"=>"\xE8\xBC\x89",
		"\x8D\xDB"=>"\xE9\x9A\x9B",
		"\x8D\xDC"=>"\xE5\x89\xA4",
		"\x8D\xDD"=>"\xE5\x9C\xA8",
		"\x8D\xDE"=>"\xE6\x9D\x90",
		"\x8D\xDF"=>"\xE7\xBD\xAA",
		"\x8D\xE0"=>"\xE8\xB2\xA1",
		"\x8D\xE1"=>"\xE5\x86\xB4",
		"\x8D\xE2"=>"\xE5\x9D\x82",
		"\x8D\xE3"=>"\xE9\x98\xAA",
		"\x8D\xE4"=>"\xE5\xA0\xBA",
		"\x8D\xE5"=>"\xE6\xA6\x8A",
		"\x8D\xE6"=>"\xE8\x82\xB4",
		"\x8D\xE7"=>"\xE5\x92\xB2",
		"\x8D\xE8"=>"\xE5\xB4\x8E",
		"\x8D\xE9"=>"\xE5\x9F\xBC",
		"\x8D\xEA"=>"\xE7\xA2\x95",
		"\x8D\xEB"=>"\xE9\xB7\xBA",
		"\x8D\xEC"=>"\xE4\xBD\x9C",
		"\x8D\xED"=>"\xE5\x89\x8A",
		"\x8D\xEE"=>"\xE5\x92\x8B",
		"\x8D\xEF"=>"\xE6\x90\xBE",
		"\x8D\xF0"=>"\xE6\x98\xA8",
		"\x8D\xF1"=>"\xE6\x9C\x94",
		"\x8D\xF2"=>"\xE6\x9F\xB5",
		"\x8D\xF3"=>"\xE7\xAA\x84",
		"\x8D\xF4"=>"\xE7\xAD\x96",
		"\x8D\xF5"=>"\xE7\xB4\xA2",
		"\x8D\xF6"=>"\xE9\x8C\xAF",
		"\x8D\xF7"=>"\xE6\xA1\x9C",
		"\x8D\xF8"=>"\xE9\xAE\xAD",
		"\x8D\xF9"=>"\xE7\xAC\xB9",
		"\x8D\xFA"=>"\xE5\x8C\x99",
		"\x8D\xFB"=>"\xE5\x86\x8A",
		"\x8D\xFC"=>"\xE5\x88\xB7",
		"\x8E\x40"=>"\xE5\xAF\x9F",
		"\x8E\x41"=>"\xE6\x8B\xB6",
		"\x8E\x42"=>"\xE6\x92\xAE",
		"\x8E\x43"=>"\xE6\x93\xA6",
		"\x8E\x44"=>"\xE6\x9C\xAD",
		"\x8E\x45"=>"\xE6\xAE\xBA",
		"\x8E\x46"=>"\xE8\x96\xA9",
		"\x8E\x47"=>"\xE9\x9B\x91",
		"\x8E\x48"=>"\xE7\x9A\x90",
		"\x8E\x49"=>"\xE9\xAF\x96",
		"\x8E\x4A"=>"\xE6\x8D\x8C",
		"\x8E\x4B"=>"\xE9\x8C\x86",
		"\x8E\x4C"=>"\xE9\xAE\xAB",
		"\x8E\x4D"=>"\xE7\x9A\xBF",
		"\x8E\x4E"=>"\xE6\x99\x92",
		"\x8E\x4F"=>"\xE4\xB8\x89",
		"\x8E\x50"=>"\xE5\x82\x98",
		"\x8E\x51"=>"\xE5\x8F\x82",
		"\x8E\x52"=>"\xE5\xB1\xB1",
		"\x8E\x53"=>"\xE6\x83\xA8",
		"\x8E\x54"=>"\xE6\x92\x92",
		"\x8E\x55"=>"\xE6\x95\xA3",
		"\x8E\x56"=>"\xE6\xA1\x9F",
		"\x8E\x57"=>"\xE7\x87\xA6",
		"\x8E\x58"=>"\xE7\x8F\x8A",
		"\x8E\x59"=>"\xE7\x94\xA3",
		"\x8E\x5A"=>"\xE7\xAE\x97",
		"\x8E\x5B"=>"\xE7\xBA\x82",
		"\x8E\x5C"=>"\xE8\x9A\x95",
		"\x8E\x5D"=>"\xE8\xAE\x83",
		"\x8E\x5E"=>"\xE8\xB3\x9B",
		"\x8E\x5F"=>"\xE9\x85\xB8",
		"\x8E\x60"=>"\xE9\xA4\x90",
		"\x8E\x61"=>"\xE6\x96\xAC",
		"\x8E\x62"=>"\xE6\x9A\xAB",
		"\x8E\x63"=>"\xE6\xAE\x8B",
		"\x8E\x64"=>"\xE4\xBB\x95",
		"\x8E\x65"=>"\xE4\xBB\x94",
		"\x8E\x66"=>"\xE4\xBC\xBA",
		"\x8E\x67"=>"\xE4\xBD\xBF",
		"\x8E\x68"=>"\xE5\x88\xBA",
		"\x8E\x69"=>"\xE5\x8F\xB8",
		"\x8E\x6A"=>"\xE5\x8F\xB2",
		"\x8E\x6B"=>"\xE5\x97\xA3",
		"\x8E\x6C"=>"\xE5\x9B\x9B",
		"\x8E\x6D"=>"\xE5\xA3\xAB",
		"\x8E\x6E"=>"\xE5\xA7\x8B",
		"\x8E\x6F"=>"\xE5\xA7\x89",
		"\x8E\x70"=>"\xE5\xA7\xBF",
		"\x8E\x71"=>"\xE5\xAD\x90",
		"\x8E\x72"=>"\xE5\xB1\x8D",
		"\x8E\x73"=>"\xE5\xB8\x82",
		"\x8E\x74"=>"\xE5\xB8\xAB",
		"\x8E\x75"=>"\xE5\xBF\x97",
		"\x8E\x76"=>"\xE6\x80\x9D",
		"\x8E\x77"=>"\xE6\x8C\x87",
		"\x8E\x78"=>"\xE6\x94\xAF",
		"\x8E\x79"=>"\xE5\xAD\x9C",
		"\x8E\x7A"=>"\xE6\x96\xAF",
		"\x8E\x7B"=>"\xE6\x96\xBD",
		"\x8E\x7C"=>"\xE6\x97\xA8",
		"\x8E\x7D"=>"\xE6\x9E\x9D",
		"\x8E\x7E"=>"\xE6\xAD\xA2",
		"\x8E\x80"=>"\xE6\xAD\xBB",
		"\x8E\x81"=>"\xE6\xB0\x8F",
		"\x8E\x82"=>"\xE7\x8D\x85",
		"\x8E\x83"=>"\xE7\xA5\x89",
		"\x8E\x84"=>"\xE7\xA7\x81",
		"\x8E\x85"=>"\xE7\xB3\xB8",
		"\x8E\x86"=>"\xE7\xB4\x99",
		"\x8E\x87"=>"\xE7\xB4\xAB",
		"\x8E\x88"=>"\xE8\x82\xA2",
		"\x8E\x89"=>"\xE8\x84\x82",
		"\x8E\x8A"=>"\xE8\x87\xB3",
		"\x8E\x8B"=>"\xE8\xA6\x96",
		"\x8E\x8C"=>"\xE8\xA9\x9E",
		"\x8E\x8D"=>"\xE8\xA9\xA9",
		"\x8E\x8E"=>"\xE8\xA9\xA6",
		"\x8E\x8F"=>"\xE8\xAA\x8C",
		"\x8E\x90"=>"\xE8\xAB\xAE",
		"\x8E\x91"=>"\xE8\xB3\x87",
		"\x8E\x92"=>"\xE8\xB3\x9C",
		"\x8E\x93"=>"\xE9\x9B\x8C",
		"\x8E\x94"=>"\xE9\xA3\xBC",
		"\x8E\x95"=>"\xE6\xAD\xAF",
		"\x8E\x96"=>"\xE4\xBA\x8B",
		"\x8E\x97"=>"\xE4\xBC\xBC",
		"\x8E\x98"=>"\xE4\xBE\x8D",
		"\x8E\x99"=>"\xE5\x85\x90",
		"\x8E\x9A"=>"\xE5\xAD\x97",
		"\x8E\x9B"=>"\xE5\xAF\xBA",
		"\x8E\x9C"=>"\xE6\x85\x88",
		"\x8E\x9D"=>"\xE6\x8C\x81",
		"\x8E\x9E"=>"\xE6\x99\x82",
		"\x8E\x9F"=>"\xE6\xAC\xA1",
		"\x8E\xA0"=>"\xE6\xBB\x8B",
		"\x8E\xA1"=>"\xE6\xB2\xBB",
		"\x8E\xA2"=>"\xE7\x88\xBE",
		"\x8E\xA3"=>"\xE7\x92\xBD",
		"\x8E\xA4"=>"\xE7\x97\x94",
		"\x8E\xA5"=>"\xE7\xA3\x81",
		"\x8E\xA6"=>"\xE7\xA4\xBA",
		"\x8E\xA7"=>"\xE8\x80\x8C",
		"\x8E\xA8"=>"\xE8\x80\xB3",
		"\x8E\xA9"=>"\xE8\x87\xAA",
		"\x8E\xAA"=>"\xE8\x92\x94",
		"\x8E\xAB"=>"\xE8\xBE\x9E",
		"\x8E\xAC"=>"\xE6\xB1\x90",
		"\x8E\xAD"=>"\xE9\xB9\xBF",
		"\x8E\xAE"=>"\xE5\xBC\x8F",
		"\x8E\xAF"=>"\xE8\xAD\x98",
		"\x8E\xB0"=>"\xE9\xB4\xAB",
		"\x8E\xB1"=>"\xE7\xAB\xBA",
		"\x8E\xB2"=>"\xE8\xBB\xB8",
		"\x8E\xB3"=>"\xE5\xAE\x8D",
		"\x8E\xB4"=>"\xE9\x9B\xAB",
		"\x8E\xB5"=>"\xE4\xB8\x83",
		"\x8E\xB6"=>"\xE5\x8F\xB1",
		"\x8E\xB7"=>"\xE5\x9F\xB7",
		"\x8E\xB8"=>"\xE5\xA4\xB1",
		"\x8E\xB9"=>"\xE5\xAB\x89",
		"\x8E\xBA"=>"\xE5\xAE\xA4",
		"\x8E\xBB"=>"\xE6\x82\x89",
		"\x8E\xBC"=>"\xE6\xB9\xBF",
		"\x8E\xBD"=>"\xE6\xBC\x86",
		"\x8E\xBE"=>"\xE7\x96\xBE",
		"\x8E\xBF"=>"\xE8\xB3\xAA",
		"\x8E\xC0"=>"\xE5\xAE\x9F",
		"\x8E\xC1"=>"\xE8\x94\x80",
		"\x8E\xC2"=>"\xE7\xAF\xA0",
		"\x8E\xC3"=>"\xE5\x81\xB2",
		"\x8E\xC4"=>"\xE6\x9F\xB4",
		"\x8E\xC5"=>"\xE8\x8A\x9D",
		"\x8E\xC6"=>"\xE5\xB1\xA1",
		"\x8E\xC7"=>"\xE8\x95\x8A",
		"\x8E\xC8"=>"\xE7\xB8\x9E",
		"\x8E\xC9"=>"\xE8\x88\x8E",
		"\x8E\xCA"=>"\xE5\x86\x99",
		"\x8E\xCB"=>"\xE5\xB0\x84",
		"\x8E\xCC"=>"\xE6\x8D\xA8",
		"\x8E\xCD"=>"\xE8\xB5\xA6",
		"\x8E\xCE"=>"\xE6\x96\x9C",
		"\x8E\xCF"=>"\xE7\x85\xAE",
		"\x8E\xD0"=>"\xE7\xA4\xBE",
		"\x8E\xD1"=>"\xE7\xB4\x97",
		"\x8E\xD2"=>"\xE8\x80\x85",
		"\x8E\xD3"=>"\xE8\xAC\x9D",
		"\x8E\xD4"=>"\xE8\xBB\x8A",
		"\x8E\xD5"=>"\xE9\x81\xAE",
		"\x8E\xD6"=>"\xE8\x9B\x87",
		"\x8E\xD7"=>"\xE9\x82\xAA",
		"\x8E\xD8"=>"\xE5\x80\x9F",
		"\x8E\xD9"=>"\xE5\x8B\xBA",
		"\x8E\xDA"=>"\xE5\xB0\xBA",
		"\x8E\xDB"=>"\xE6\x9D\x93",
		"\x8E\xDC"=>"\xE7\x81\xBC",
		"\x8E\xDD"=>"\xE7\x88\xB5",
		"\x8E\xDE"=>"\xE9\x85\x8C",
		"\x8E\xDF"=>"\xE9\x87\x88",
		"\x8E\xE0"=>"\xE9\x8C\xAB",
		"\x8E\xE1"=>"\xE8\x8B\xA5",
		"\x8E\xE2"=>"\xE5\xAF\x82",
		"\x8E\xE3"=>"\xE5\xBC\xB1",
		"\x8E\xE4"=>"\xE6\x83\xB9",
		"\x8E\xE5"=>"\xE4\xB8\xBB",
		"\x8E\xE6"=>"\xE5\x8F\x96",
		"\x8E\xE7"=>"\xE5\xAE\x88",
		"\x8E\xE8"=>"\xE6\x89\x8B",
		"\x8E\xE9"=>"\xE6\x9C\xB1",
		"\x8E\xEA"=>"\xE6\xAE\x8A",
		"\x8E\xEB"=>"\xE7\x8B\xA9",
		"\x8E\xEC"=>"\xE7\x8F\xA0",
		"\x8E\xED"=>"\xE7\xA8\xAE",
		"\x8E\xEE"=>"\xE8\x85\xAB",
		"\x8E\xEF"=>"\xE8\xB6\xA3",
		"\x8E\xF0"=>"\xE9\x85\x92",
		"\x8E\xF1"=>"\xE9\xA6\x96",
		"\x8E\xF2"=>"\xE5\x84\x92",
		"\x8E\xF3"=>"\xE5\x8F\x97",
		"\x8E\xF4"=>"\xE5\x91\xAA",
		"\x8E\xF5"=>"\xE5\xAF\xBF",
		"\x8E\xF6"=>"\xE6\x8E\x88",
		"\x8E\xF7"=>"\xE6\xA8\xB9",
		"\x8E\xF8"=>"\xE7\xB6\xAC",
		"\x8E\xF9"=>"\xE9\x9C\x80",
		"\x8E\xFA"=>"\xE5\x9B\x9A",
		"\x8E\xFB"=>"\xE5\x8F\x8E",
		"\x8E\xFC"=>"\xE5\x91\xA8",
		"\x8F\x40"=>"\xE5\xAE\x97",
		"\x8F\x41"=>"\xE5\xB0\xB1",
		"\x8F\x42"=>"\xE5\xB7\x9E",
		"\x8F\x43"=>"\xE4\xBF\xAE",
		"\x8F\x44"=>"\xE6\x84\x81",
		"\x8F\x45"=>"\xE6\x8B\xBE",
		"\x8F\x46"=>"\xE6\xB4\xB2",
		"\x8F\x47"=>"\xE7\xA7\x80",
		"\x8F\x48"=>"\xE7\xA7\x8B",
		"\x8F\x49"=>"\xE7\xB5\x82",
		"\x8F\x4A"=>"\xE7\xB9\x8D",
		"\x8F\x4B"=>"\xE7\xBF\x92",
		"\x8F\x4C"=>"\xE8\x87\xAD",
		"\x8F\x4D"=>"\xE8\x88\x9F",
		"\x8F\x4E"=>"\xE8\x92\x90",
		"\x8F\x4F"=>"\xE8\xA1\x86",
		"\x8F\x50"=>"\xE8\xA5\xB2",
		"\x8F\x51"=>"\xE8\xAE\x90",
		"\x8F\x52"=>"\xE8\xB9\xB4",
		"\x8F\x53"=>"\xE8\xBC\xAF",
		"\x8F\x54"=>"\xE9\x80\xB1",
		"\x8F\x55"=>"\xE9\x85\x8B",
		"\x8F\x56"=>"\xE9\x85\xAC",
		"\x8F\x57"=>"\xE9\x9B\x86",
		"\x8F\x58"=>"\xE9\x86\x9C",
		"\x8F\x59"=>"\xE4\xBB\x80",
		"\x8F\x5A"=>"\xE4\xBD\x8F",
		"\x8F\x5B"=>"\xE5\x85\x85",
		"\x8F\x5C"=>"\xE5\x8D\x81",
		"\x8F\x5D"=>"\xE5\xBE\x93",
		"\x8F\x5E"=>"\xE6\x88\x8E",
		"\x8F\x5F"=>"\xE6\x9F\x94",
		"\x8F\x60"=>"\xE6\xB1\x81",
		"\x8F\x61"=>"\xE6\xB8\x8B",
		"\x8F\x62"=>"\xE7\x8D\xA3",
		"\x8F\x63"=>"\xE7\xB8\xA6",
		"\x8F\x64"=>"\xE9\x87\x8D",
		"\x8F\x65"=>"\xE9\x8A\x83",
		"\x8F\x66"=>"\xE5\x8F\x94",
		"\x8F\x67"=>"\xE5\xA4\x99",
		"\x8F\x68"=>"\xE5\xAE\xBF",
		"\x8F\x69"=>"\xE6\xB7\x91",
		"\x8F\x6A"=>"\xE7\xA5\x9D",
		"\x8F\x6B"=>"\xE7\xB8\xAE",
		"\x8F\x6C"=>"\xE7\xB2\x9B",
		"\x8F\x6D"=>"\xE5\xA1\xBE",
		"\x8F\x6E"=>"\xE7\x86\x9F",
		"\x8F\x6F"=>"\xE5\x87\xBA",
		"\x8F\x70"=>"\xE8\xA1\x93",
		"\x8F\x71"=>"\xE8\xBF\xB0",
		"\x8F\x72"=>"\xE4\xBF\x8A",
		"\x8F\x73"=>"\xE5\xB3\xBB",
		"\x8F\x74"=>"\xE6\x98\xA5",
		"\x8F\x75"=>"\xE7\x9E\xAC",
		"\x8F\x76"=>"\xE7\xAB\xA3",
		"\x8F\x77"=>"\xE8\x88\x9C",
		"\x8F\x78"=>"\xE9\xA7\xBF",
		"\x8F\x79"=>"\xE5\x87\x86",
		"\x8F\x7A"=>"\xE5\xBE\xAA",
		"\x8F\x7B"=>"\xE6\x97\xAC",
		"\x8F\x7C"=>"\xE6\xA5\xAF",
		"\x8F\x7D"=>"\xE6\xAE\x89",
		"\x8F\x7E"=>"\xE6\xB7\xB3",
		"\x8F\x80"=>"\xE6\xBA\x96",
		"\x8F\x81"=>"\xE6\xBD\xA4",
		"\x8F\x82"=>"\xE7\x9B\xBE",
		"\x8F\x83"=>"\xE7\xB4\x94",
		"\x8F\x84"=>"\xE5\xB7\xA1",
		"\x8F\x85"=>"\xE9\x81\xB5",
		"\x8F\x86"=>"\xE9\x86\x87",
		"\x8F\x87"=>"\xE9\xA0\x86",
		"\x8F\x88"=>"\xE5\x87\xA6",
		"\x8F\x89"=>"\xE5\x88\x9D",
		"\x8F\x8A"=>"\xE6\x89\x80",
		"\x8F\x8B"=>"\xE6\x9A\x91",
		"\x8F\x8C"=>"\xE6\x9B\x99",
		"\x8F\x8D"=>"\xE6\xB8\x9A",
		"\x8F\x8E"=>"\xE5\xBA\xB6",
		"\x8F\x8F"=>"\xE7\xB7\x92",
		"\x8F\x90"=>"\xE7\xBD\xB2",
		"\x8F\x91"=>"\xE6\x9B\xB8",
		"\x8F\x92"=>"\xE8\x96\xAF",
		"\x8F\x93"=>"\xE8\x97\xB7",
		"\x8F\x94"=>"\xE8\xAB\xB8",
		"\x8F\x95"=>"\xE5\x8A\xA9",
		"\x8F\x96"=>"\xE5\x8F\x99",
		"\x8F\x97"=>"\xE5\xA5\xB3",
		"\x8F\x98"=>"\xE5\xBA\x8F",
		"\x8F\x99"=>"\xE5\xBE\x90",
		"\x8F\x9A"=>"\xE6\x81\x95",
		"\x8F\x9B"=>"\xE9\x8B\xA4",
		"\x8F\x9C"=>"\xE9\x99\xA4",
		"\x8F\x9D"=>"\xE5\x82\xB7",
		"\x8F\x9E"=>"\xE5\x84\x9F",
		"\x8F\x9F"=>"\xE5\x8B\x9D",
		"\x8F\xA0"=>"\xE5\x8C\xA0",
		"\x8F\xA1"=>"\xE5\x8D\x87",
		"\x8F\xA2"=>"\xE5\x8F\xAC",
		"\x8F\xA3"=>"\xE5\x93\xA8",
		"\x8F\xA4"=>"\xE5\x95\x86",
		"\x8F\xA5"=>"\xE5\x94\xB1",
		"\x8F\xA6"=>"\xE5\x98\x97",
		"\x8F\xA7"=>"\xE5\xA5\xA8",
		"\x8F\xA8"=>"\xE5\xA6\xBE",
		"\x8F\xA9"=>"\xE5\xA8\xBC",
		"\x8F\xAA"=>"\xE5\xAE\xB5",
		"\x8F\xAB"=>"\xE5\xB0\x86",
		"\x8F\xAC"=>"\xE5\xB0\x8F",
		"\x8F\xAD"=>"\xE5\xB0\x91",
		"\x8F\xAE"=>"\xE5\xB0\x9A",
		"\x8F\xAF"=>"\xE5\xBA\x84",
		"\x8F\xB0"=>"\xE5\xBA\x8A",
		"\x8F\xB1"=>"\xE5\xBB\xA0",
		"\x8F\xB2"=>"\xE5\xBD\xB0",
		"\x8F\xB3"=>"\xE6\x89\xBF",
		"\x8F\xB4"=>"\xE6\x8A\x84",
		"\x8F\xB5"=>"\xE6\x8B\x9B",
		"\x8F\xB6"=>"\xE6\x8E\x8C",
		"\x8F\xB7"=>"\xE6\x8D\xB7",
		"\x8F\xB8"=>"\xE6\x98\x87",
		"\x8F\xB9"=>"\xE6\x98\x8C",
		"\x8F\xBA"=>"\xE6\x98\xAD",
		"\x8F\xBB"=>"\xE6\x99\xB6",
		"\x8F\xBC"=>"\xE6\x9D\xBE",
		"\x8F\xBD"=>"\xE6\xA2\xA2",
		"\x8F\xBE"=>"\xE6\xA8\x9F",
		"\x8F\xBF"=>"\xE6\xA8\xB5",
		"\x8F\xC0"=>"\xE6\xB2\xBC",
		"\x8F\xC1"=>"\xE6\xB6\x88",
		"\x8F\xC2"=>"\xE6\xB8\x89",
		"\x8F\xC3"=>"\xE6\xB9\x98",
		"\x8F\xC4"=>"\xE7\x84\xBC",
		"\x8F\xC5"=>"\xE7\x84\xA6",
		"\x8F\xC6"=>"\xE7\x85\xA7",
		"\x8F\xC7"=>"\xE7\x97\x87",
		"\x8F\xC8"=>"\xE7\x9C\x81",
		"\x8F\xC9"=>"\xE7\xA1\x9D",
		"\x8F\xCA"=>"\xE7\xA4\x81",
		"\x8F\xCB"=>"\xE7\xA5\xA5",
		"\x8F\xCC"=>"\xE7\xA7\xB0",
		"\x8F\xCD"=>"\xE7\xAB\xA0",
		"\x8F\xCE"=>"\xE7\xAC\x91",
		"\x8F\xCF"=>"\xE7\xB2\xA7",
		"\x8F\xD0"=>"\xE7\xB4\xB9",
		"\x8F\xD1"=>"\xE8\x82\x96",
		"\x8F\xD2"=>"\xE8\x8F\x96",
		"\x8F\xD3"=>"\xE8\x92\x8B",
		"\x8F\xD4"=>"\xE8\x95\x89",
		"\x8F\xD5"=>"\xE8\xA1\x9D",
		"\x8F\xD6"=>"\xE8\xA3\xB3",
		"\x8F\xD7"=>"\xE8\xA8\x9F",
		"\x8F\xD8"=>"\xE8\xA8\xBC",
		"\x8F\xD9"=>"\xE8\xA9\x94",
		"\x8F\xDA"=>"\xE8\xA9\xB3",
		"\x8F\xDB"=>"\xE8\xB1\xA1",
		"\x8F\xDC"=>"\xE8\xB3\x9E",
		"\x8F\xDD"=>"\xE9\x86\xA4",
		"\x8F\xDE"=>"\xE9\x89\xA6",
		"\x8F\xDF"=>"\xE9\x8D\xBE",
		"\x8F\xE0"=>"\xE9\x90\x98",
		"\x8F\xE1"=>"\xE9\x9A\x9C",
		"\x8F\xE2"=>"\xE9\x9E\x98",
		"\x8F\xE3"=>"\xE4\xB8\x8A",
		"\x8F\xE4"=>"\xE4\xB8\x88",
		"\x8F\xE5"=>"\xE4\xB8\x9E",
		"\x8F\xE6"=>"\xE4\xB9\x97",
		"\x8F\xE7"=>"\xE5\x86\x97",
		"\x8F\xE8"=>"\xE5\x89\xB0",
		"\x8F\xE9"=>"\xE5\x9F\x8E",
		"\x8F\xEA"=>"\xE5\xA0\xB4",
		"\x8F\xEB"=>"\xE5\xA3\x8C",
		"\x8F\xEC"=>"\xE5\xAC\xA2",
		"\x8F\xED"=>"\xE5\xB8\xB8",
		"\x8F\xEE"=>"\xE6\x83\x85",
		"\x8F\xEF"=>"\xE6\x93\xBE",
		"\x8F\xF0"=>"\xE6\x9D\xA1",
		"\x8F\xF1"=>"\xE6\x9D\x96",
		"\x8F\xF2"=>"\xE6\xB5\x84",
		"\x8F\xF3"=>"\xE7\x8A\xB6",
		"\x8F\xF4"=>"\xE7\x95\xB3",
		"\x8F\xF5"=>"\xE7\xA9\xA3",
		"\x8F\xF6"=>"\xE8\x92\xB8",
		"\x8F\xF7"=>"\xE8\xAD\xB2",
		"\x8F\xF8"=>"\xE9\x86\xB8",
		"\x8F\xF9"=>"\xE9\x8C\xA0",
		"\x8F\xFA"=>"\xE5\x98\xB1",
		"\x8F\xFB"=>"\xE5\x9F\xB4",
		"\x8F\xFC"=>"\xE9\xA3\xBE",
		"\x90\x40"=>"\xE6\x8B\xAD",
		"\x90\x41"=>"\xE6\xA4\x8D",
		"\x90\x42"=>"\xE6\xAE\x96",
		"\x90\x43"=>"\xE7\x87\xAD",
		"\x90\x44"=>"\xE7\xB9\x94",
		"\x90\x45"=>"\xE8\x81\xB7",
		"\x90\x46"=>"\xE8\x89\xB2",
		"\x90\x47"=>"\xE8\xA7\xA6",
		"\x90\x48"=>"\xE9\xA3\x9F",
		"\x90\x49"=>"\xE8\x9D\x95",
		"\x90\x4A"=>"\xE8\xBE\xB1",
		"\x90\x4B"=>"\xE5\xB0\xBB",
		"\x90\x4C"=>"\xE4\xBC\xB8",
		"\x90\x4D"=>"\xE4\xBF\xA1",
		"\x90\x4E"=>"\xE4\xBE\xB5",
		"\x90\x4F"=>"\xE5\x94\x87",
		"\x90\x50"=>"\xE5\xA8\xA0",
		"\x90\x51"=>"\xE5\xAF\x9D",
		"\x90\x52"=>"\xE5\xAF\xA9",
		"\x90\x53"=>"\xE5\xBF\x83",
		"\x90\x54"=>"\xE6\x85\x8E",
		"\x90\x55"=>"\xE6\x8C\xAF",
		"\x90\x56"=>"\xE6\x96\xB0",
		"\x90\x57"=>"\xE6\x99\x8B",
		"\x90\x58"=>"\xE6\xA3\xAE",
		"\x90\x59"=>"\xE6\xA6\x9B",
		"\x90\x5A"=>"\xE6\xB5\xB8",
		"\x90\x5B"=>"\xE6\xB7\xB1",
		"\x90\x5C"=>"\xE7\x94\xB3",
		"\x90\x5D"=>"\xE7\x96\xB9",
		"\x90\x5E"=>"\xE7\x9C\x9F",
		"\x90\x5F"=>"\xE7\xA5\x9E",
		"\x90\x60"=>"\xE7\xA7\xA6",
		"\x90\x61"=>"\xE7\xB4\xB3",
		"\x90\x62"=>"\xE8\x87\xA3",
		"\x90\x63"=>"\xE8\x8A\xAF",
		"\x90\x64"=>"\xE8\x96\xAA",
		"\x90\x65"=>"\xE8\xA6\xAA",
		"\x90\x66"=>"\xE8\xA8\xBA",
		"\x90\x67"=>"\xE8\xBA\xAB",
		"\x90\x68"=>"\xE8\xBE\x9B",
		"\x90\x69"=>"\xE9\x80\xB2",
		"\x90\x6A"=>"\xE9\x87\x9D",
		"\x90\x6B"=>"\xE9\x9C\x87",
		"\x90\x6C"=>"\xE4\xBA\xBA",
		"\x90\x6D"=>"\xE4\xBB\x81",
		"\x90\x6E"=>"\xE5\x88\x83",
		"\x90\x6F"=>"\xE5\xA1\xB5",
		"\x90\x70"=>"\xE5\xA3\xAC",
		"\x90\x71"=>"\xE5\xB0\x8B",
		"\x90\x72"=>"\xE7\x94\x9A",
		"\x90\x73"=>"\xE5\xB0\xBD",
		"\x90\x74"=>"\xE8\x85\x8E",
		"\x90\x75"=>"\xE8\xA8\x8A",
		"\x90\x76"=>"\xE8\xBF\x85",
		"\x90\x77"=>"\xE9\x99\xA3",
		"\x90\x78"=>"\xE9\x9D\xAD",
		"\x90\x79"=>"\xE7\xAC\xA5",
		"\x90\x7A"=>"\xE8\xAB\x8F",
		"\x90\x7B"=>"\xE9\xA0\x88",
		"\x90\x7C"=>"\xE9\x85\xA2",
		"\x90\x7D"=>"\xE5\x9B\xB3",
		"\x90\x7E"=>"\xE5\x8E\xA8",
		"\x90\x80"=>"\xE9\x80\x97",
		"\x90\x81"=>"\xE5\x90\xB9",
		"\x90\x82"=>"\xE5\x9E\x82",
		"\x90\x83"=>"\xE5\xB8\xA5",
		"\x90\x84"=>"\xE6\x8E\xA8",
		"\x90\x85"=>"\xE6\xB0\xB4",
		"\x90\x86"=>"\xE7\x82\x8A",
		"\x90\x87"=>"\xE7\x9D\xA1",
		"\x90\x88"=>"\xE7\xB2\x8B",
		"\x90\x89"=>"\xE7\xBF\xA0",
		"\x90\x8A"=>"\xE8\xA1\xB0",
		"\x90\x8B"=>"\xE9\x81\x82",
		"\x90\x8C"=>"\xE9\x85\x94",
		"\x90\x8D"=>"\xE9\x8C\x90",
		"\x90\x8E"=>"\xE9\x8C\x98",
		"\x90\x8F"=>"\xE9\x9A\x8F",
		"\x90\x90"=>"\xE7\x91\x9E",
		"\x90\x91"=>"\xE9\xAB\x84",
		"\x90\x92"=>"\xE5\xB4\x87",
		"\x90\x93"=>"\xE5\xB5\xA9",
		"\x90\x94"=>"\xE6\x95\xB0",
		"\x90\x95"=>"\xE6\x9E\xA2",
		"\x90\x96"=>"\xE8\xB6\xA8",
		"\x90\x97"=>"\xE9\x9B\x9B",
		"\x90\x98"=>"\xE6\x8D\xAE",
		"\x90\x99"=>"\xE6\x9D\x89",
		"\x90\x9A"=>"\xE6\xA4\x99",
		"\x90\x9B"=>"\xE8\x8F\x85",
		"\x90\x9C"=>"\xE9\xA0\x97",
		"\x90\x9D"=>"\xE9\x9B\x80",
		"\x90\x9E"=>"\xE8\xA3\xBE",
		"\x90\x9F"=>"\xE6\xBE\x84",
		"\x90\xA0"=>"\xE6\x91\xBA",
		"\x90\xA1"=>"\xE5\xAF\xB8",
		"\x90\xA2"=>"\xE4\xB8\x96",
		"\x90\xA3"=>"\xE7\x80\xAC",
		"\x90\xA4"=>"\xE7\x95\x9D",
		"\x90\xA5"=>"\xE6\x98\xAF",
		"\x90\xA6"=>"\xE5\x87\x84",
		"\x90\xA7"=>"\xE5\x88\xB6",
		"\x90\xA8"=>"\xE5\x8B\xA2",
		"\x90\xA9"=>"\xE5\xA7\x93",
		"\x90\xAA"=>"\xE5\xBE\x81",
		"\x90\xAB"=>"\xE6\x80\xA7",
		"\x90\xAC"=>"\xE6\x88\x90",
		"\x90\xAD"=>"\xE6\x94\xBF",
		"\x90\xAE"=>"\xE6\x95\xB4",
		"\x90\xAF"=>"\xE6\x98\x9F",
		"\x90\xB0"=>"\xE6\x99\xB4",
		"\x90\xB1"=>"\xE6\xA3\xB2",
		"\x90\xB2"=>"\xE6\xA0\x96",
		"\x90\xB3"=>"\xE6\xAD\xA3",
		"\x90\xB4"=>"\xE6\xB8\x85",
		"\x90\xB5"=>"\xE7\x89\xB2",
		"\x90\xB6"=>"\xE7\x94\x9F",
		"\x90\xB7"=>"\xE7\x9B\x9B",
		"\x90\xB8"=>"\xE7\xB2\xBE",
		"\x90\xB9"=>"\xE8\x81\x96",
		"\x90\xBA"=>"\xE5\xA3\xB0",
		"\x90\xBB"=>"\xE8\xA3\xBD",
		"\x90\xBC"=>"\xE8\xA5\xBF",
		"\x90\xBD"=>"\xE8\xAA\xA0",
		"\x90\xBE"=>"\xE8\xAA\x93",
		"\x90\xBF"=>"\xE8\xAB\x8B",
		"\x90\xC0"=>"\xE9\x80\x9D",
		"\x90\xC1"=>"\xE9\x86\x92",
		"\x90\xC2"=>"\xE9\x9D\x92",
		"\x90\xC3"=>"\xE9\x9D\x99",
		"\x90\xC4"=>"\xE6\x96\x89",
		"\x90\xC5"=>"\xE7\xA8\x8E",
		"\x90\xC6"=>"\xE8\x84\x86",
		"\x90\xC7"=>"\xE9\x9A\xBB",
		"\x90\xC8"=>"\xE5\xB8\xAD",
		"\x90\xC9"=>"\xE6\x83\x9C",
		"\x90\xCA"=>"\xE6\x88\x9A",
		"\x90\xCB"=>"\xE6\x96\xA5",
		"\x90\xCC"=>"\xE6\x98\x94",
		"\x90\xCD"=>"\xE6\x9E\x90",
		"\x90\xCE"=>"\xE7\x9F\xB3",
		"\x90\xCF"=>"\xE7\xA9\x8D",
		"\x90\xD0"=>"\xE7\xB1\x8D",
		"\x90\xD1"=>"\xE7\xB8\xBE",
		"\x90\xD2"=>"\xE8\x84\x8A",
		"\x90\xD3"=>"\xE8\xB2\xAC",
		"\x90\xD4"=>"\xE8\xB5\xA4",
		"\x90\xD5"=>"\xE8\xB7\xA1",
		"\x90\xD6"=>"\xE8\xB9\x9F",
		"\x90\xD7"=>"\xE7\xA2\xA9",
		"\x90\xD8"=>"\xE5\x88\x87",
		"\x90\xD9"=>"\xE6\x8B\x99",
		"\x90\xDA"=>"\xE6\x8E\xA5",
		"\x90\xDB"=>"\xE6\x91\x82",
		"\x90\xDC"=>"\xE6\x8A\x98",
		"\x90\xDD"=>"\xE8\xA8\xAD",
		"\x90\xDE"=>"\xE7\xAA\x83",
		"\x90\xDF"=>"\xE7\xAF\x80",
		"\x90\xE0"=>"\xE8\xAA\xAC",
		"\x90\xE1"=>"\xE9\x9B\xAA",
		"\x90\xE2"=>"\xE7\xB5\xB6",
		"\x90\xE3"=>"\xE8\x88\x8C",
		"\x90\xE4"=>"\xE8\x9D\x89",
		"\x90\xE5"=>"\xE4\xBB\x99",
		"\x90\xE6"=>"\xE5\x85\x88",
		"\x90\xE7"=>"\xE5\x8D\x83",
		"\x90\xE8"=>"\xE5\x8D\xA0",
		"\x90\xE9"=>"\xE5\xAE\xA3",
		"\x90\xEA"=>"\xE5\xB0\x82",
		"\x90\xEB"=>"\xE5\xB0\x96",
		"\x90\xEC"=>"\xE5\xB7\x9D",
		"\x90\xED"=>"\xE6\x88\xA6",
		"\x90\xEE"=>"\xE6\x89\x87",
		"\x90\xEF"=>"\xE6\x92\xB0",
		"\x90\xF0"=>"\xE6\xA0\x93",
		"\x90\xF1"=>"\xE6\xA0\xB4",
		"\x90\xF2"=>"\xE6\xB3\x89",
		"\x90\xF3"=>"\xE6\xB5\x85",
		"\x90\xF4"=>"\xE6\xB4\x97",
		"\x90\xF5"=>"\xE6\x9F\x93",
		"\x90\xF6"=>"\xE6\xBD\x9C",
		"\x90\xF7"=>"\xE7\x85\x8E",
		"\x90\xF8"=>"\xE7\x85\xBD",
		"\x90\xF9"=>"\xE6\x97\x8B",
		"\x90\xFA"=>"\xE7\xA9\xBF",
		"\x90\xFB"=>"\xE7\xAE\xAD",
		"\x90\xFC"=>"\xE7\xB7\x9A",
		"\x91\x40"=>"\xE7\xB9\x8A",
		"\x91\x41"=>"\xE7\xBE\xA8",
		"\x91\x42"=>"\xE8\x85\xBA",
		"\x91\x43"=>"\xE8\x88\x9B",
		"\x91\x44"=>"\xE8\x88\xB9",
		"\x91\x45"=>"\xE8\x96\xA6",
		"\x91\x46"=>"\xE8\xA9\xAE",
		"\x91\x47"=>"\xE8\xB3\x8E",
		"\x91\x48"=>"\xE8\xB7\xB5",
		"\x91\x49"=>"\xE9\x81\xB8",
		"\x91\x4A"=>"\xE9\x81\xB7",
		"\x91\x4B"=>"\xE9\x8A\xAD",
		"\x91\x4C"=>"\xE9\x8A\x91",
		"\x91\x4D"=>"\xE9\x96\x83",
		"\x91\x4E"=>"\xE9\xAE\xAE",
		"\x91\x4F"=>"\xE5\x89\x8D",
		"\x91\x50"=>"\xE5\x96\x84",
		"\x91\x51"=>"\xE6\xBC\xB8",
		"\x91\x52"=>"\xE7\x84\xB6",
		"\x91\x53"=>"\xE5\x85\xA8",
		"\x91\x54"=>"\xE7\xA6\x85",
		"\x91\x55"=>"\xE7\xB9\x95",
		"\x91\x56"=>"\xE8\x86\xB3",
		"\x91\x57"=>"\xE7\xB3\x8E",
		"\x91\x58"=>"\xE5\x99\x8C",
		"\x91\x59"=>"\xE5\xA1\x91",
		"\x91\x5A"=>"\xE5\xB2\xA8",
		"\x91\x5B"=>"\xE6\x8E\xAA",
		"\x91\x5C"=>"\xE6\x9B\xBE",
		"\x91\x5D"=>"\xE6\x9B\xBD",
		"\x91\x5E"=>"\xE6\xA5\x9A",
		"\x91\x5F"=>"\xE7\x8B\x99",
		"\x91\x60"=>"\xE7\x96\x8F",
		"\x91\x61"=>"\xE7\x96\x8E",
		"\x91\x62"=>"\xE7\xA4\x8E",
		"\x91\x63"=>"\xE7\xA5\x96",
		"\x91\x64"=>"\xE7\xA7\x9F",
		"\x91\x65"=>"\xE7\xB2\x97",
		"\x91\x66"=>"\xE7\xB4\xA0",
		"\x91\x67"=>"\xE7\xB5\x84",
		"\x91\x68"=>"\xE8\x98\x87",
		"\x91\x69"=>"\xE8\xA8\xB4",
		"\x91\x6A"=>"\xE9\x98\xBB",
		"\x91\x6B"=>"\xE9\x81\xA1",
		"\x91\x6C"=>"\xE9\xBC\xA0",
		"\x91\x6D"=>"\xE5\x83\xA7",
		"\x91\x6E"=>"\xE5\x89\xB5",
		"\x91\x6F"=>"\xE5\x8F\x8C",
		"\x91\x70"=>"\xE5\x8F\xA2",
		"\x91\x71"=>"\xE5\x80\x89",
		"\x91\x72"=>"\xE5\x96\xAA",
		"\x91\x73"=>"\xE5\xA3\xAE",
		"\x91\x74"=>"\xE5\xA5\x8F",
		"\x91\x75"=>"\xE7\x88\xBD",
		"\x91\x76"=>"\xE5\xAE\x8B",
		"\x91\x77"=>"\xE5\xB1\xA4",
		"\x91\x78"=>"\xE5\x8C\x9D",
		"\x91\x79"=>"\xE6\x83\xA3",
		"\x91\x7A"=>"\xE6\x83\xB3",
		"\x91\x7B"=>"\xE6\x8D\x9C",
		"\x91\x7C"=>"\xE6\x8E\x83",
		"\x91\x7D"=>"\xE6\x8C\xBF",
		"\x91\x7E"=>"\xE6\x8E\xBB",
		"\x91\x80"=>"\xE6\x93\x8D",
		"\x91\x81"=>"\xE6\x97\xA9",
		"\x91\x82"=>"\xE6\x9B\xB9",
		"\x91\x83"=>"\xE5\xB7\xA3",
		"\x91\x84"=>"\xE6\xA7\x8D",
		"\x91\x85"=>"\xE6\xA7\xBD",
		"\x91\x86"=>"\xE6\xBC\x95",
		"\x91\x87"=>"\xE7\x87\xA5",
		"\x91\x88"=>"\xE4\xBA\x89",
		"\x91\x89"=>"\xE7\x97\xA9",
		"\x91\x8A"=>"\xE7\x9B\xB8",
		"\x91\x8B"=>"\xE7\xAA\x93",
		"\x91\x8C"=>"\xE7\xB3\x9F",
		"\x91\x8D"=>"\xE7\xB7\x8F",
		"\x91\x8E"=>"\xE7\xB6\x9C",
		"\x91\x8F"=>"\xE8\x81\xA1",
		"\x91\x90"=>"\xE8\x8D\x89",
		"\x91\x91"=>"\xE8\x8D\x98",
		"\x91\x92"=>"\xE8\x91\xAC",
		"\x91\x93"=>"\xE8\x92\xBC",
		"\x91\x94"=>"\xE8\x97\xBB",
		"\x91\x95"=>"\xE8\xA3\x85",
		"\x91\x96"=>"\xE8\xB5\xB0",
		"\x91\x97"=>"\xE9\x80\x81",
		"\x91\x98"=>"\xE9\x81\xAD",
		"\x91\x99"=>"\xE9\x8E\x97",
		"\x91\x9A"=>"\xE9\x9C\x9C",
		"\x91\x9B"=>"\xE9\xA8\x92",
		"\x91\x9C"=>"\xE5\x83\x8F",
		"\x91\x9D"=>"\xE5\xA2\x97",
		"\x91\x9E"=>"\xE6\x86\x8E",
		"\x91\x9F"=>"\xE8\x87\x93",
		"\x91\xA0"=>"\xE8\x94\xB5",
		"\x91\xA1"=>"\xE8\xB4\x88",
		"\x91\xA2"=>"\xE9\x80\xA0",
		"\x91\xA3"=>"\xE4\xBF\x83",
		"\x91\xA4"=>"\xE5\x81\xB4",
		"\x91\xA5"=>"\xE5\x89\x87",
		"\x91\xA6"=>"\xE5\x8D\xB3",
		"\x91\xA7"=>"\xE6\x81\xAF",
		"\x91\xA8"=>"\xE6\x8D\x89",
		"\x91\xA9"=>"\xE6\x9D\x9F",
		"\x91\xAA"=>"\xE6\xB8\xAC",
		"\x91\xAB"=>"\xE8\xB6\xB3",
		"\x91\xAC"=>"\xE9\x80\x9F",
		"\x91\xAD"=>"\xE4\xBF\x97",
		"\x91\xAE"=>"\xE5\xB1\x9E",
		"\x91\xAF"=>"\xE8\xB3\x8A",
		"\x91\xB0"=>"\xE6\x97\x8F",
		"\x91\xB1"=>"\xE7\xB6\x9A",
		"\x91\xB2"=>"\xE5\x8D\x92",
		"\x91\xB3"=>"\xE8\xA2\x96",
		"\x91\xB4"=>"\xE5\x85\xB6",
		"\x91\xB5"=>"\xE6\x8F\x83",
		"\x91\xB6"=>"\xE5\xAD\x98",
		"\x91\xB7"=>"\xE5\xAD\xAB",
		"\x91\xB8"=>"\xE5\xB0\x8A",
		"\x91\xB9"=>"\xE6\x90\x8D",
		"\x91\xBA"=>"\xE6\x9D\x91",
		"\x91\xBB"=>"\xE9\x81\x9C",
		"\x91\xBC"=>"\xE4\xBB\x96",
		"\x91\xBD"=>"\xE5\xA4\x9A",
		"\x91\xBE"=>"\xE5\xA4\xAA",
		"\x91\xBF"=>"\xE6\xB1\xB0",
		"\x91\xC0"=>"\xE8\xA9\x91",
		"\x91\xC1"=>"\xE5\x94\xBE",
		"\x91\xC2"=>"\xE5\xA0\x95",
		"\x91\xC3"=>"\xE5\xA6\xA5",
		"\x91\xC4"=>"\xE6\x83\xB0",
		"\x91\xC5"=>"\xE6\x89\x93",
		"\x91\xC6"=>"\xE6\x9F\x81",
		"\x91\xC7"=>"\xE8\x88\xB5",
		"\x91\xC8"=>"\xE6\xA5\x95",
		"\x91\xC9"=>"\xE9\x99\x80",
		"\x91\xCA"=>"\xE9\xA7\x84",
		"\x91\xCB"=>"\xE9\xA8\xA8",
		"\x91\xCC"=>"\xE4\xBD\x93",
		"\x91\xCD"=>"\xE5\xA0\x86",
		"\x91\xCE"=>"\xE5\xAF\xBE",
		"\x91\xCF"=>"\xE8\x80\x90",
		"\x91\xD0"=>"\xE5\xB2\xB1",
		"\x91\xD1"=>"\xE5\xB8\xAF",
		"\x91\xD2"=>"\xE5\xBE\x85",
		"\x91\xD3"=>"\xE6\x80\xA0",
		"\x91\xD4"=>"\xE6\x85\x8B",
		"\x91\xD5"=>"\xE6\x88\xB4",
		"\x91\xD6"=>"\xE6\x9B\xBF",
		"\x91\xD7"=>"\xE6\xB3\xB0",
		"\x91\xD8"=>"\xE6\xBB\x9E",
		"\x91\xD9"=>"\xE8\x83\x8E",
		"\x91\xDA"=>"\xE8\x85\xBF",
		"\x91\xDB"=>"\xE8\x8B\x94",
		"\x91\xDC"=>"\xE8\xA2\x8B",
		"\x91\xDD"=>"\xE8\xB2\xB8",
		"\x91\xDE"=>"\xE9\x80\x80",
		"\x91\xDF"=>"\xE9\x80\xAE",
		"\x91\xE0"=>"\xE9\x9A\x8A",
		"\x91\xE1"=>"\xE9\xBB\x9B",
		"\x91\xE2"=>"\xE9\xAF\x9B",
		"\x91\xE3"=>"\xE4\xBB\xA3",
		"\x91\xE4"=>"\xE5\x8F\xB0",
		"\x91\xE5"=>"\xE5\xA4\xA7",
		"\x91\xE6"=>"\xE7\xAC\xAC",
		"\x91\xE7"=>"\xE9\x86\x8D",
		"\x91\xE8"=>"\xE9\xA1\x8C",
		"\x91\xE9"=>"\xE9\xB7\xB9",
		"\x91\xEA"=>"\xE6\xBB\x9D",
		"\x91\xEB"=>"\xE7\x80\xA7",
		"\x91\xEC"=>"\xE5\x8D\x93",
		"\x91\xED"=>"\xE5\x95\x84",
		"\x91\xEE"=>"\xE5\xAE\x85",
		"\x91\xEF"=>"\xE6\x89\x98",
		"\x91\xF0"=>"\xE6\x8A\x9E",
		"\x91\xF1"=>"\xE6\x8B\x93",
		"\x91\xF2"=>"\xE6\xB2\xA2",
		"\x91\xF3"=>"\xE6\xBF\xAF",
		"\x91\xF4"=>"\xE7\x90\xA2",
		"\x91\xF5"=>"\xE8\xA8\x97",
		"\x91\xF6"=>"\xE9\x90\xB8",
		"\x91\xF7"=>"\xE6\xBF\x81",
		"\x91\xF8"=>"\xE8\xAB\xBE",
		"\x91\xF9"=>"\xE8\x8C\xB8",
		"\x91\xFA"=>"\xE5\x87\xA7",
		"\x91\xFB"=>"\xE8\x9B\xB8",
		"\x91\xFC"=>"\xE5\x8F\xAA",
		"\x92\x40"=>"\xE5\x8F\xA9",
		"\x92\x41"=>"\xE4\xBD\x86",
		"\x92\x42"=>"\xE9\x81\x94",
		"\x92\x43"=>"\xE8\xBE\xB0",
		"\x92\x44"=>"\xE5\xA5\xAA",
		"\x92\x45"=>"\xE8\x84\xB1",
		"\x92\x46"=>"\xE5\xB7\xBD",
		"\x92\x47"=>"\xE7\xAB\xAA",
		"\x92\x48"=>"\xE8\xBE\xBF",
		"\x92\x49"=>"\xE6\xA3\x9A",
		"\x92\x4A"=>"\xE8\xB0\xB7",
		"\x92\x4B"=>"\xE7\x8B\xB8",
		"\x92\x4C"=>"\xE9\xB1\x88",
		"\x92\x4D"=>"\xE6\xA8\xBD",
		"\x92\x4E"=>"\xE8\xAA\xB0",
		"\x92\x4F"=>"\xE4\xB8\xB9",
		"\x92\x50"=>"\xE5\x8D\x98",
		"\x92\x51"=>"\xE5\x98\x86",
		"\x92\x52"=>"\xE5\x9D\xA6",
		"\x92\x53"=>"\xE6\x8B\x85",
		"\x92\x54"=>"\xE6\x8E\xA2",
		"\x92\x55"=>"\xE6\x97\xA6",
		"\x92\x56"=>"\xE6\xAD\x8E",
		"\x92\x57"=>"\xE6\xB7\xA1",
		"\x92\x58"=>"\xE6\xB9\x9B",
		"\x92\x59"=>"\xE7\x82\xAD",
		"\x92\x5A"=>"\xE7\x9F\xAD",
		"\x92\x5B"=>"\xE7\xAB\xAF",
		"\x92\x5C"=>"\xE7\xAE\xAA",
		"\x92\x5D"=>"\xE7\xB6\xBB",
		"\x92\x5E"=>"\xE8\x80\xBD",
		"\x92\x5F"=>"\xE8\x83\x86",
		"\x92\x60"=>"\xE8\x9B\x8B",
		"\x92\x61"=>"\xE8\xAA\x95",
		"\x92\x62"=>"\xE9\x8D\x9B",
		"\x92\x63"=>"\xE5\x9B\xA3",
		"\x92\x64"=>"\xE5\xA3\x87",
		"\x92\x65"=>"\xE5\xBC\xBE",
		"\x92\x66"=>"\xE6\x96\xAD",
		"\x92\x67"=>"\xE6\x9A\x96",
		"\x92\x68"=>"\xE6\xAA\x80",
		"\x92\x69"=>"\xE6\xAE\xB5",
		"\x92\x6A"=>"\xE7\x94\xB7",
		"\x92\x6B"=>"\xE8\xAB\x87",
		"\x92\x6C"=>"\xE5\x80\xA4",
		"\x92\x6D"=>"\xE7\x9F\xA5",
		"\x92\x6E"=>"\xE5\x9C\xB0",
		"\x92\x6F"=>"\xE5\xBC\x9B",
		"\x92\x70"=>"\xE6\x81\xA5",
		"\x92\x71"=>"\xE6\x99\xBA",
		"\x92\x72"=>"\xE6\xB1\xA0",
		"\x92\x73"=>"\xE7\x97\xB4",
		"\x92\x74"=>"\xE7\xA8\x9A",
		"\x92\x75"=>"\xE7\xBD\xAE",
		"\x92\x76"=>"\xE8\x87\xB4",
		"\x92\x77"=>"\xE8\x9C\x98",
		"\x92\x78"=>"\xE9\x81\x85",
		"\x92\x79"=>"\xE9\xA6\xB3",
		"\x92\x7A"=>"\xE7\xAF\x89",
		"\x92\x7B"=>"\xE7\x95\x9C",
		"\x92\x7C"=>"\xE7\xAB\xB9",
		"\x92\x7D"=>"\xE7\xAD\x91",
		"\x92\x7E"=>"\xE8\x93\x84",
		"\x92\x80"=>"\xE9\x80\x90",
		"\x92\x81"=>"\xE7\xA7\xA9",
		"\x92\x82"=>"\xE7\xAA\x92",
		"\x92\x83"=>"\xE8\x8C\xB6",
		"\x92\x84"=>"\xE5\xAB\xA1",
		"\x92\x85"=>"\xE7\x9D\x80",
		"\x92\x86"=>"\xE4\xB8\xAD",
		"\x92\x87"=>"\xE4\xBB\xB2",
		"\x92\x88"=>"\xE5\xAE\x99",
		"\x92\x89"=>"\xE5\xBF\xA0",
		"\x92\x8A"=>"\xE6\x8A\xBD",
		"\x92\x8B"=>"\xE6\x98\xBC",
		"\x92\x8C"=>"\xE6\x9F\xB1",
		"\x92\x8D"=>"\xE6\xB3\xA8",
		"\x92\x8E"=>"\xE8\x99\xAB",
		"\x92\x8F"=>"\xE8\xA1\xB7",
		"\x92\x90"=>"\xE8\xA8\xBB",
		"\x92\x91"=>"\xE9\x85\x8E",
		"\x92\x92"=>"\xE9\x8B\xB3",
		"\x92\x93"=>"\xE9\xA7\x90",
		"\x92\x94"=>"\xE6\xA8\x97",
		"\x92\x95"=>"\xE7\x80\xA6",
		"\x92\x96"=>"\xE7\x8C\xAA",
		"\x92\x97"=>"\xE8\x8B\xA7",
		"\x92\x98"=>"\xE8\x91\x97",
		"\x92\x99"=>"\xE8\xB2\xAF",
		"\x92\x9A"=>"\xE4\xB8\x81",
		"\x92\x9B"=>"\xE5\x85\x86",
		"\x92\x9C"=>"\xE5\x87\x8B",
		"\x92\x9D"=>"\xE5\x96\x8B",
		"\x92\x9E"=>"\xE5\xAF\xB5",
		"\x92\x9F"=>"\xE5\xB8\x96",
		"\x92\xA0"=>"\xE5\xB8\xB3",
		"\x92\xA1"=>"\xE5\xBA\x81",
		"\x92\xA2"=>"\xE5\xBC\x94",
		"\x92\xA3"=>"\xE5\xBC\xB5",
		"\x92\xA4"=>"\xE5\xBD\xAB",
		"\x92\xA5"=>"\xE5\xBE\xB4",
		"\x92\xA6"=>"\xE6\x87\xB2",
		"\x92\xA7"=>"\xE6\x8C\x91",
		"\x92\xA8"=>"\xE6\x9A\xA2",
		"\x92\xA9"=>"\xE6\x9C\x9D",
		"\x92\xAA"=>"\xE6\xBD\xAE",
		"\x92\xAB"=>"\xE7\x89\x92",
		"\x92\xAC"=>"\xE7\x94\xBA",
		"\x92\xAD"=>"\xE7\x9C\xBA",
		"\x92\xAE"=>"\xE8\x81\xB4",
		"\x92\xAF"=>"\xE8\x84\xB9",
		"\x92\xB0"=>"\xE8\x85\xB8",
		"\x92\xB1"=>"\xE8\x9D\xB6",
		"\x92\xB2"=>"\xE8\xAA\xBF",
		"\x92\xB3"=>"\xE8\xAB\x9C",
		"\x92\xB4"=>"\xE8\xB6\x85",
		"\x92\xB5"=>"\xE8\xB7\xB3",
		"\x92\xB6"=>"\xE9\x8A\x9A",
		"\x92\xB7"=>"\xE9\x95\xB7",
		"\x92\xB8"=>"\xE9\xA0\x82",
		"\x92\xB9"=>"\xE9\xB3\xA5",
		"\x92\xBA"=>"\xE5\x8B\x85",
		"\x92\xBB"=>"\xE6\x8D\x97",
		"\x92\xBC"=>"\xE7\x9B\xB4",
		"\x92\xBD"=>"\xE6\x9C\x95",
		"\x92\xBE"=>"\xE6\xB2\x88",
		"\x92\xBF"=>"\xE7\x8F\x8D",
		"\x92\xC0"=>"\xE8\xB3\x83",
		"\x92\xC1"=>"\xE9\x8E\xAE",
		"\x92\xC2"=>"\xE9\x99\xB3",
		"\x92\xC3"=>"\xE6\xB4\xA5",
		"\x92\xC4"=>"\xE5\xA2\x9C",
		"\x92\xC5"=>"\xE6\xA4\x8E",
		"\x92\xC6"=>"\xE6\xA7\x8C",
		"\x92\xC7"=>"\xE8\xBF\xBD",
		"\x92\xC8"=>"\xE9\x8E\x9A",
		"\x92\xC9"=>"\xE7\x97\x9B",
		"\x92\xCA"=>"\xE9\x80\x9A",
		"\x92\xCB"=>"\xE5\xA1\x9A",
		"\x92\xCC"=>"\xE6\xA0\x82",
		"\x92\xCD"=>"\xE6\x8E\xB4",
		"\x92\xCE"=>"\xE6\xA7\xBB",
		"\x92\xCF"=>"\xE4\xBD\x83",
		"\x92\xD0"=>"\xE6\xBC\xAC",
		"\x92\xD1"=>"\xE6\x9F\x98",
		"\x92\xD2"=>"\xE8\xBE\xBB",
		"\x92\xD3"=>"\xE8\x94\xA6",
		"\x92\xD4"=>"\xE7\xB6\xB4",
		"\x92\xD5"=>"\xE9\x8D\x94",
		"\x92\xD6"=>"\xE6\xA4\xBF",
		"\x92\xD7"=>"\xE6\xBD\xB0",
		"\x92\xD8"=>"\xE5\x9D\xAA",
		"\x92\xD9"=>"\xE5\xA3\xB7",
		"\x92\xDA"=>"\xE5\xAC\xAC",
		"\x92\xDB"=>"\xE7\xB4\xAC",
		"\x92\xDC"=>"\xE7\x88\xAA",
		"\x92\xDD"=>"\xE5\x90\x8A",
		"\x92\xDE"=>"\xE9\x87\xA3",
		"\x92\xDF"=>"\xE9\xB6\xB4",
		"\x92\xE0"=>"\xE4\xBA\xAD",
		"\x92\xE1"=>"\xE4\xBD\x8E",
		"\x92\xE2"=>"\xE5\x81\x9C",
		"\x92\xE3"=>"\xE5\x81\xB5",
		"\x92\xE4"=>"\xE5\x89\x83",
		"\x92\xE5"=>"\xE8\xB2\x9E",
		"\x92\xE6"=>"\xE5\x91\x88",
		"\x92\xE7"=>"\xE5\xA0\xA4",
		"\x92\xE8"=>"\xE5\xAE\x9A",
		"\x92\xE9"=>"\xE5\xB8\x9D",
		"\x92\xEA"=>"\xE5\xBA\x95",
		"\x92\xEB"=>"\xE5\xBA\xAD",
		"\x92\xEC"=>"\xE5\xBB\xB7",
		"\x92\xED"=>"\xE5\xBC\x9F",
		"\x92\xEE"=>"\xE6\x82\x8C",
		"\x92\xEF"=>"\xE6\x8A\xB5",
		"\x92\xF0"=>"\xE6\x8C\xBA",
		"\x92\xF1"=>"\xE6\x8F\x90",
		"\x92\xF2"=>"\xE6\xA2\xAF",
		"\x92\xF3"=>"\xE6\xB1\x80",
		"\x92\xF4"=>"\xE7\xA2\x87",
		"\x92\xF5"=>"\xE7\xA6\x8E",
		"\x92\xF6"=>"\xE7\xA8\x8B",
		"\x92\xF7"=>"\xE7\xB7\xA0",
		"\x92\xF8"=>"\xE8\x89\x87",
		"\x92\xF9"=>"\xE8\xA8\x82",
		"\x92\xFA"=>"\xE8\xAB\xA6",
		"\x92\xFB"=>"\xE8\xB9\x84",
		"\x92\xFC"=>"\xE9\x80\x93",
		"\x93\x40"=>"\xE9\x82\xB8",
		"\x93\x41"=>"\xE9\x84\xAD",
		"\x93\x42"=>"\xE9\x87\x98",
		"\x93\x43"=>"\xE9\xBC\x8E",
		"\x93\x44"=>"\xE6\xB3\xA5",
		"\x93\x45"=>"\xE6\x91\x98",
		"\x93\x46"=>"\xE6\x93\xA2",
		"\x93\x47"=>"\xE6\x95\xB5",
		"\x93\x48"=>"\xE6\xBB\xB4",
		"\x93\x49"=>"\xE7\x9A\x84",
		"\x93\x4A"=>"\xE7\xAC\x9B",
		"\x93\x4B"=>"\xE9\x81\xA9",
		"\x93\x4C"=>"\xE9\x8F\x91",
		"\x93\x4D"=>"\xE6\xBA\xBA",
		"\x93\x4E"=>"\xE5\x93\xB2",
		"\x93\x4F"=>"\xE5\xBE\xB9",
		"\x93\x50"=>"\xE6\x92\xA4",
		"\x93\x51"=>"\xE8\xBD\x8D",
		"\x93\x52"=>"\xE8\xBF\xAD",
		"\x93\x53"=>"\xE9\x89\x84",
		"\x93\x54"=>"\xE5\x85\xB8",
		"\x93\x55"=>"\xE5\xA1\xAB",
		"\x93\x56"=>"\xE5\xA4\xA9",
		"\x93\x57"=>"\xE5\xB1\x95",
		"\x93\x58"=>"\xE5\xBA\x97",
		"\x93\x59"=>"\xE6\xB7\xBB",
		"\x93\x5A"=>"\xE7\xBA\x8F",
		"\x93\x5B"=>"\xE7\x94\x9C",
		"\x93\x5C"=>"\xE8\xB2\xBC",
		"\x93\x5D"=>"\xE8\xBB\xA2",
		"\x93\x5E"=>"\xE9\xA1\x9B",
		"\x93\x5F"=>"\xE7\x82\xB9",
		"\x93\x60"=>"\xE4\xBC\x9D",
		"\x93\x61"=>"\xE6\xAE\xBF",
		"\x93\x62"=>"\xE6\xBE\xB1",
		"\x93\x63"=>"\xE7\x94\xB0",
		"\x93\x64"=>"\xE9\x9B\xBB",
		"\x93\x65"=>"\xE5\x85\x8E",
		"\x93\x66"=>"\xE5\x90\x90",
		"\x93\x67"=>"\xE5\xA0\xB5",
		"\x93\x68"=>"\xE5\xA1\x97",
		"\x93\x69"=>"\xE5\xA6\xAC",
		"\x93\x6A"=>"\xE5\xB1\xA0",
		"\x93\x6B"=>"\xE5\xBE\x92",
		"\x93\x6C"=>"\xE6\x96\x97",
		"\x93\x6D"=>"\xE6\x9D\x9C",
		"\x93\x6E"=>"\xE6\xB8\xA1",
		"\x93\x6F"=>"\xE7\x99\xBB",
		"\x93\x70"=>"\xE8\x8F\x9F",
		"\x93\x71"=>"\xE8\xB3\xAD",
		"\x93\x72"=>"\xE9\x80\x94",
		"\x93\x73"=>"\xE9\x83\xBD",
		"\x93\x74"=>"\xE9\x8D\x8D",
		"\x93\x75"=>"\xE7\xA0\xA5",
		"\x93\x76"=>"\xE7\xA0\xBA",
		"\x93\x77"=>"\xE5\x8A\xAA",
		"\x93\x78"=>"\xE5\xBA\xA6",
		"\x93\x79"=>"\xE5\x9C\x9F",
		"\x93\x7A"=>"\xE5\xA5\xB4",
		"\x93\x7B"=>"\xE6\x80\x92",
		"\x93\x7C"=>"\xE5\x80\x92",
		"\x93\x7D"=>"\xE5\x85\x9A",
		"\x93\x7E"=>"\xE5\x86\xAC",
		"\x93\x80"=>"\xE5\x87\x8D",
		"\x93\x81"=>"\xE5\x88\x80",
		"\x93\x82"=>"\xE5\x94\x90",
		"\x93\x83"=>"\xE5\xA1\x94",
		"\x93\x84"=>"\xE5\xA1\x98",
		"\x93\x85"=>"\xE5\xA5\x97",
		"\x93\x86"=>"\xE5\xAE\x95",
		"\x93\x87"=>"\xE5\xB3\xB6",
		"\x93\x88"=>"\xE5\xB6\x8B",
		"\x93\x89"=>"\xE6\x82\xBC",
		"\x93\x8A"=>"\xE6\x8A\x95",
		"\x93\x8B"=>"\xE6\x90\xAD",
		"\x93\x8C"=>"\xE6\x9D\xB1",
		"\x93\x8D"=>"\xE6\xA1\x83",
		"\x93\x8E"=>"\xE6\xA2\xBC",
		"\x93\x8F"=>"\xE6\xA3\x9F",
		"\x93\x90"=>"\xE7\x9B\x97",
		"\x93\x91"=>"\xE6\xB7\x98",
		"\x93\x92"=>"\xE6\xB9\xAF",
		"\x93\x93"=>"\xE6\xB6\x9B",
		"\x93\x94"=>"\xE7\x81\xAF",
		"\x93\x95"=>"\xE7\x87\x88",
		"\x93\x96"=>"\xE5\xBD\x93",
		"\x93\x97"=>"\xE7\x97\x98",
		"\x93\x98"=>"\xE7\xA5\xB7",
		"\x93\x99"=>"\xE7\xAD\x89",
		"\x93\x9A"=>"\xE7\xAD\x94",
		"\x93\x9B"=>"\xE7\xAD\x92",
		"\x93\x9C"=>"\xE7\xB3\x96",
		"\x93\x9D"=>"\xE7\xB5\xB1",
		"\x93\x9E"=>"\xE5\x88\xB0",
		"\x93\x9F"=>"\xE8\x91\xA3",
		"\x93\xA0"=>"\xE8\x95\xA9",
		"\x93\xA1"=>"\xE8\x97\xA4",
		"\x93\xA2"=>"\xE8\xA8\x8E",
		"\x93\xA3"=>"\xE8\xAC\x84",
		"\x93\xA4"=>"\xE8\xB1\x86",
		"\x93\xA5"=>"\xE8\xB8\x8F",
		"\x93\xA6"=>"\xE9\x80\x83",
		"\x93\xA7"=>"\xE9\x80\x8F",
		"\x93\xA8"=>"\xE9\x90\x99",
		"\x93\xA9"=>"\xE9\x99\xB6",
		"\x93\xAA"=>"\xE9\xA0\xAD",
		"\x93\xAB"=>"\xE9\xA8\xB0",
		"\x93\xAC"=>"\xE9\x97\x98",
		"\x93\xAD"=>"\xE5\x83\x8D",
		"\x93\xAE"=>"\xE5\x8B\x95",
		"\x93\xAF"=>"\xE5\x90\x8C",
		"\x93\xB0"=>"\xE5\xA0\x82",
		"\x93\xB1"=>"\xE5\xB0\x8E",
		"\x93\xB2"=>"\xE6\x86\xA7",
		"\x93\xB3"=>"\xE6\x92\x9E",
		"\x93\xB4"=>"\xE6\xB4\x9E",
		"\x93\xB5"=>"\xE7\x9E\xB3",
		"\x93\xB6"=>"\xE7\xAB\xA5",
		"\x93\xB7"=>"\xE8\x83\xB4",
		"\x93\xB8"=>"\xE8\x90\x84",
		"\x93\xB9"=>"\xE9\x81\x93",
		"\x93\xBA"=>"\xE9\x8A\x85",
		"\x93\xBB"=>"\xE5\xB3\xA0",
		"\x93\xBC"=>"\xE9\xB4\x87",
		"\x93\xBD"=>"\xE5\x8C\xBF",
		"\x93\xBE"=>"\xE5\xBE\x97",
		"\x93\xBF"=>"\xE5\xBE\xB3",
		"\x93\xC0"=>"\xE6\xB6\x9C",
		"\x93\xC1"=>"\xE7\x89\xB9",
		"\x93\xC2"=>"\xE7\x9D\xA3",
		"\x93\xC3"=>"\xE7\xA6\xBF",
		"\x93\xC4"=>"\xE7\xAF\xA4",
		"\x93\xC5"=>"\xE6\xAF\x92",
		"\x93\xC6"=>"\xE7\x8B\xAC",
		"\x93\xC7"=>"\xE8\xAA\xAD",
		"\x93\xC8"=>"\xE6\xA0\x83",
		"\x93\xC9"=>"\xE6\xA9\xA1",
		"\x93\xCA"=>"\xE5\x87\xB8",
		"\x93\xCB"=>"\xE7\xAA\x81",
		"\x93\xCC"=>"\xE6\xA4\xB4",
		"\x93\xCD"=>"\xE5\xB1\x8A",
		"\x93\xCE"=>"\xE9\xB3\xB6",
		"\x93\xCF"=>"\xE8\x8B\xAB",
		"\x93\xD0"=>"\xE5\xAF\x85",
		"\x93\xD1"=>"\xE9\x85\x89",
		"\x93\xD2"=>"\xE7\x80\x9E",
		"\x93\xD3"=>"\xE5\x99\xB8",
		"\x93\xD4"=>"\xE5\xB1\xAF",
		"\x93\xD5"=>"\xE6\x83\x87",
		"\x93\xD6"=>"\xE6\x95\xA6",
		"\x93\xD7"=>"\xE6\xB2\x8C",
		"\x93\xD8"=>"\xE8\xB1\x9A",
		"\x93\xD9"=>"\xE9\x81\x81",
		"\x93\xDA"=>"\xE9\xA0\x93",
		"\x93\xDB"=>"\xE5\x91\x91",
		"\x93\xDC"=>"\xE6\x9B\x87",
		"\x93\xDD"=>"\xE9\x88\x8D",
		"\x93\xDE"=>"\xE5\xA5\x88",
		"\x93\xDF"=>"\xE9\x82\xA3",
		"\x93\xE0"=>"\xE5\x86\x85",
		"\x93\xE1"=>"\xE4\xB9\x8D",
		"\x93\xE2"=>"\xE5\x87\xAA",
		"\x93\xE3"=>"\xE8\x96\x99",
		"\x93\xE4"=>"\xE8\xAC\x8E",
		"\x93\xE5"=>"\xE7\x81\x98",
		"\x93\xE6"=>"\xE6\x8D\xBA",
		"\x93\xE7"=>"\xE9\x8D\x8B",
		"\x93\xE8"=>"\xE6\xA5\xA2",
		"\x93\xE9"=>"\xE9\xA6\xB4",
		"\x93\xEA"=>"\xE7\xB8\x84",
		"\x93\xEB"=>"\xE7\x95\xB7",
		"\x93\xEC"=>"\xE5\x8D\x97",
		"\x93\xED"=>"\xE6\xA5\xA0",
		"\x93\xEE"=>"\xE8\xBB\x9F",
		"\x93\xEF"=>"\xE9\x9B\xA3",
		"\x93\xF0"=>"\xE6\xB1\x9D",
		"\x93\xF1"=>"\xE4\xBA\x8C",
		"\x93\xF2"=>"\xE5\xB0\xBC",
		"\x93\xF3"=>"\xE5\xBC\x90",
		"\x93\xF4"=>"\xE8\xBF\xA9",
		"\x93\xF5"=>"\xE5\x8C\x82",
		"\x93\xF6"=>"\xE8\xB3\x91",
		"\x93\xF7"=>"\xE8\x82\x89",
		"\x93\xF8"=>"\xE8\x99\xB9",
		"\x93\xF9"=>"\xE5\xBB\xBF",
		"\x93\xFA"=>"\xE6\x97\xA5",
		"\x93\xFB"=>"\xE4\xB9\xB3",
		"\x93\xFC"=>"\xE5\x85\xA5",
		"\x94\x40"=>"\xE5\xA6\x82",
		"\x94\x41"=>"\xE5\xB0\xBF",
		"\x94\x42"=>"\xE9\x9F\xAE",
		"\x94\x43"=>"\xE4\xBB\xBB",
		"\x94\x44"=>"\xE5\xA6\x8A",
		"\x94\x45"=>"\xE5\xBF\x8D",
		"\x94\x46"=>"\xE8\xAA\x8D",
		"\x94\x47"=>"\xE6\xBF\xA1",
		"\x94\x48"=>"\xE7\xA6\xB0",
		"\x94\x49"=>"\xE7\xA5\xA2",
		"\x94\x4A"=>"\xE5\xAF\xA7",
		"\x94\x4B"=>"\xE8\x91\xB1",
		"\x94\x4C"=>"\xE7\x8C\xAB",
		"\x94\x4D"=>"\xE7\x86\xB1",
		"\x94\x4E"=>"\xE5\xB9\xB4",
		"\x94\x4F"=>"\xE5\xBF\xB5",
		"\x94\x50"=>"\xE6\x8D\xBB",
		"\x94\x51"=>"\xE6\x92\x9A",
		"\x94\x52"=>"\xE7\x87\x83",
		"\x94\x53"=>"\xE7\xB2\x98",
		"\x94\x54"=>"\xE4\xB9\x83",
		"\x94\x55"=>"\xE5\xBB\xBC",
		"\x94\x56"=>"\xE4\xB9\x8B",
		"\x94\x57"=>"\xE5\x9F\x9C",
		"\x94\x58"=>"\xE5\x9A\xA2",
		"\x94\x59"=>"\xE6\x82\xA9",
		"\x94\x5A"=>"\xE6\xBF\x83",
		"\x94\x5B"=>"\xE7\xB4\x8D",
		"\x94\x5C"=>"\xE8\x83\xBD",
		"\x94\x5D"=>"\xE8\x84\xB3",
		"\x94\x5E"=>"\xE8\x86\xBF",
		"\x94\x5F"=>"\xE8\xBE\xB2",
		"\x94\x60"=>"\xE8\xA6\x97",
		"\x94\x61"=>"\xE8\x9A\xA4",
		"\x94\x62"=>"\xE5\xB7\xB4",
		"\x94\x63"=>"\xE6\x8A\x8A",
		"\x94\x64"=>"\xE6\x92\xAD",
		"\x94\x65"=>"\xE8\xA6\x87",
		"\x94\x66"=>"\xE6\x9D\xB7",
		"\x94\x67"=>"\xE6\xB3\xA2",
		"\x94\x68"=>"\xE6\xB4\xBE",
		"\x94\x69"=>"\xE7\x90\xB6",
		"\x94\x6A"=>"\xE7\xA0\xB4",
		"\x94\x6B"=>"\xE5\xA9\x86",
		"\x94\x6C"=>"\xE7\xBD\xB5",
		"\x94\x6D"=>"\xE8\x8A\xAD",
		"\x94\x6E"=>"\xE9\xA6\xAC",
		"\x94\x6F"=>"\xE4\xBF\xB3",
		"\x94\x70"=>"\xE5\xBB\x83",
		"\x94\x71"=>"\xE6\x8B\x9D",
		"\x94\x72"=>"\xE6\x8E\x92",
		"\x94\x73"=>"\xE6\x95\x97",
		"\x94\x74"=>"\xE6\x9D\xAF",
		"\x94\x75"=>"\xE7\x9B\x83",
		"\x94\x76"=>"\xE7\x89\x8C",
		"\x94\x77"=>"\xE8\x83\x8C",
		"\x94\x78"=>"\xE8\x82\xBA",
		"\x94\x79"=>"\xE8\xBC\xA9",
		"\x94\x7A"=>"\xE9\x85\x8D",
		"\x94\x7B"=>"\xE5\x80\x8D",
		"\x94\x7C"=>"\xE5\x9F\xB9",
		"\x94\x7D"=>"\xE5\xAA\x92",
		"\x94\x7E"=>"\xE6\xA2\x85",
		"\x94\x80"=>"\xE6\xA5\xB3",
		"\x94\x81"=>"\xE7\x85\xA4",
		"\x94\x82"=>"\xE7\x8B\xBD",
		"\x94\x83"=>"\xE8\xB2\xB7",
		"\x94\x84"=>"\xE5\xA3\xB2",
		"\x94\x85"=>"\xE8\xB3\xA0",
		"\x94\x86"=>"\xE9\x99\xAA",
		"\x94\x87"=>"\xE9\x80\x99",
		"\x94\x88"=>"\xE8\x9D\xBF",
		"\x94\x89"=>"\xE7\xA7\xA4",
		"\x94\x8A"=>"\xE7\x9F\xA7",
		"\x94\x8B"=>"\xE8\x90\xA9",
		"\x94\x8C"=>"\xE4\xBC\xAF",
		"\x94\x8D"=>"\xE5\x89\xA5",
		"\x94\x8E"=>"\xE5\x8D\x9A",
		"\x94\x8F"=>"\xE6\x8B\x8D",
		"\x94\x90"=>"\xE6\x9F\x8F",
		"\x94\x91"=>"\xE6\xB3\x8A",
		"\x94\x92"=>"\xE7\x99\xBD",
		"\x94\x93"=>"\xE7\xAE\x94",
		"\x94\x94"=>"\xE7\xB2\x95",
		"\x94\x95"=>"\xE8\x88\xB6",
		"\x94\x96"=>"\xE8\x96\x84",
		"\x94\x97"=>"\xE8\xBF\xAB",
		"\x94\x98"=>"\xE6\x9B\x9D",
		"\x94\x99"=>"\xE6\xBC\xA0",
		"\x94\x9A"=>"\xE7\x88\x86",
		"\x94\x9B"=>"\xE7\xB8\x9B",
		"\x94\x9C"=>"\xE8\x8E\xAB",
		"\x94\x9D"=>"\xE9\xA7\x81",
		"\x94\x9E"=>"\xE9\xBA\xA6",
		"\x94\x9F"=>"\xE5\x87\xBD",
		"\x94\xA0"=>"\xE7\xAE\xB1",
		"\x94\xA1"=>"\xE7\xA1\xB2",
		"\x94\xA2"=>"\xE7\xAE\xB8",
		"\x94\xA3"=>"\xE8\x82\x87",
		"\x94\xA4"=>"\xE7\xAD\x88",
		"\x94\xA5"=>"\xE6\xAB\xA8",
		"\x94\xA6"=>"\xE5\xB9\xA1",
		"\x94\xA7"=>"\xE8\x82\x8C",
		"\x94\xA8"=>"\xE7\x95\x91",
		"\x94\xA9"=>"\xE7\x95\xA0",
		"\x94\xAA"=>"\xE5\x85\xAB",
		"\x94\xAB"=>"\xE9\x89\xA2",
		"\x94\xAC"=>"\xE6\xBA\x8C",
		"\x94\xAD"=>"\xE7\x99\xBA",
		"\x94\xAE"=>"\xE9\x86\x97",
		"\x94\xAF"=>"\xE9\xAB\xAA",
		"\x94\xB0"=>"\xE4\xBC\x90",
		"\x94\xB1"=>"\xE7\xBD\xB0",
		"\x94\xB2"=>"\xE6\x8A\x9C",
		"\x94\xB3"=>"\xE7\xAD\x8F",
		"\x94\xB4"=>"\xE9\x96\xA5",
		"\x94\xB5"=>"\xE9\xB3\xA9",
		"\x94\xB6"=>"\xE5\x99\xBA",
		"\x94\xB7"=>"\xE5\xA1\x99",
		"\x94\xB8"=>"\xE8\x9B\xA4",
		"\x94\xB9"=>"\xE9\x9A\xBC",
		"\x94\xBA"=>"\xE4\xBC\xB4",
		"\x94\xBB"=>"\xE5\x88\xA4",
		"\x94\xBC"=>"\xE5\x8D\x8A",
		"\x94\xBD"=>"\xE5\x8F\x8D",
		"\x94\xBE"=>"\xE5\x8F\x9B",
		"\x94\xBF"=>"\xE5\xB8\x86",
		"\x94\xC0"=>"\xE6\x90\xAC",
		"\x94\xC1"=>"\xE6\x96\x91",
		"\x94\xC2"=>"\xE6\x9D\xBF",
		"\x94\xC3"=>"\xE6\xB0\xBE",
		"\x94\xC4"=>"\xE6\xB1\x8E",
		"\x94\xC5"=>"\xE7\x89\x88",
		"\x94\xC6"=>"\xE7\x8A\xAF",
		"\x94\xC7"=>"\xE7\x8F\xAD",
		"\x94\xC8"=>"\xE7\x95\x94",
		"\x94\xC9"=>"\xE7\xB9\x81",
		"\x94\xCA"=>"\xE8\x88\xAC",
		"\x94\xCB"=>"\xE8\x97\xA9",
		"\x94\xCC"=>"\xE8\xB2\xA9",
		"\x94\xCD"=>"\xE7\xAF\x84",
		"\x94\xCE"=>"\xE9\x87\x86",
		"\x94\xCF"=>"\xE7\x85\xA9",
		"\x94\xD0"=>"\xE9\xA0\x92",
		"\x94\xD1"=>"\xE9\xA3\xAF",
		"\x94\xD2"=>"\xE6\x8C\xBD",
		"\x94\xD3"=>"\xE6\x99\xA9",
		"\x94\xD4"=>"\xE7\x95\xAA",
		"\x94\xD5"=>"\xE7\x9B\xA4",
		"\x94\xD6"=>"\xE7\xA3\x90",
		"\x94\xD7"=>"\xE8\x95\x83",
		"\x94\xD8"=>"\xE8\x9B\xAE",
		"\x94\xD9"=>"\xE5\x8C\xAA",
		"\x94\xDA"=>"\xE5\x8D\x91",
		"\x94\xDB"=>"\xE5\x90\xA6",
		"\x94\xDC"=>"\xE5\xA6\x83",
		"\x94\xDD"=>"\xE5\xBA\x87",
		"\x94\xDE"=>"\xE5\xBD\xBC",
		"\x94\xDF"=>"\xE6\x82\xB2",
		"\x94\xE0"=>"\xE6\x89\x89",
		"\x94\xE1"=>"\xE6\x89\xB9",
		"\x94\xE2"=>"\xE6\x8A\xAB",
		"\x94\xE3"=>"\xE6\x96\x90",
		"\x94\xE4"=>"\xE6\xAF\x94",
		"\x94\xE5"=>"\xE6\xB3\x8C",
		"\x94\xE6"=>"\xE7\x96\xB2",
		"\x94\xE7"=>"\xE7\x9A\xAE",
		"\x94\xE8"=>"\xE7\xA2\x91",
		"\x94\xE9"=>"\xE7\xA7\x98",
		"\x94\xEA"=>"\xE7\xB7\x8B",
		"\x94\xEB"=>"\xE7\xBD\xB7",
		"\x94\xEC"=>"\xE8\x82\xA5",
		"\x94\xED"=>"\xE8\xA2\xAB",
		"\x94\xEE"=>"\xE8\xAA\xB9",
		"\x94\xEF"=>"\xE8\xB2\xBB",
		"\x94\xF0"=>"\xE9\x81\xBF",
		"\x94\xF1"=>"\xE9\x9D\x9E",
		"\x94\xF2"=>"\xE9\xA3\x9B",
		"\x94\xF3"=>"\xE6\xA8\x8B",
		"\x94\xF4"=>"\xE7\xB0\xB8",
		"\x94\xF5"=>"\xE5\x82\x99",
		"\x94\xF6"=>"\xE5\xB0\xBE",
		"\x94\xF7"=>"\xE5\xBE\xAE",
		"\x94\xF8"=>"\xE6\x9E\x87",
		"\x94\xF9"=>"\xE6\xAF\x98",
		"\x94\xFA"=>"\xE7\x90\xB5",
		"\x94\xFB"=>"\xE7\x9C\x89",
		"\x94\xFC"=>"\xE7\xBE\x8E",
		"\x95\x40"=>"\xE9\xBC\xBB",
		"\x95\x41"=>"\xE6\x9F\x8A",
		"\x95\x42"=>"\xE7\xA8\x97",
		"\x95\x43"=>"\xE5\x8C\xB9",
		"\x95\x44"=>"\xE7\x96\x8B",
		"\x95\x45"=>"\xE9\xAB\xAD",
		"\x95\x46"=>"\xE5\xBD\xA6",
		"\x95\x47"=>"\xE8\x86\x9D",
		"\x95\x48"=>"\xE8\x8F\xB1",
		"\x95\x49"=>"\xE8\x82\x98",
		"\x95\x4A"=>"\xE5\xBC\xBC",
		"\x95\x4B"=>"\xE5\xBF\x85",
		"\x95\x4C"=>"\xE7\x95\xA2",
		"\x95\x4D"=>"\xE7\xAD\x86",
		"\x95\x4E"=>"\xE9\x80\xBC",
		"\x95\x4F"=>"\xE6\xA1\xA7",
		"\x95\x50"=>"\xE5\xA7\xAB",
		"\x95\x51"=>"\xE5\xAA\x9B",
		"\x95\x52"=>"\xE7\xB4\x90",
		"\x95\x53"=>"\xE7\x99\xBE",
		"\x95\x54"=>"\xE8\xAC\xAC",
		"\x95\x55"=>"\xE4\xBF\xB5",
		"\x95\x56"=>"\xE5\xBD\xAA",
		"\x95\x57"=>"\xE6\xA8\x99",
		"\x95\x58"=>"\xE6\xB0\xB7",
		"\x95\x59"=>"\xE6\xBC\x82",
		"\x95\x5A"=>"\xE7\x93\xA2",
		"\x95\x5B"=>"\xE7\xA5\xA8",
		"\x95\x5C"=>"\xE8\xA1\xA8",
		"\x95\x5D"=>"\xE8\xA9\x95",
		"\x95\x5E"=>"\xE8\xB1\xB9",
		"\x95\x5F"=>"\xE5\xBB\x9F",
		"\x95\x60"=>"\xE6\x8F\x8F",
		"\x95\x61"=>"\xE7\x97\x85",
		"\x95\x62"=>"\xE7\xA7\x92",
		"\x95\x63"=>"\xE8\x8B\x97",
		"\x95\x64"=>"\xE9\x8C\xA8",
		"\x95\x65"=>"\xE9\x8B\xB2",
		"\x95\x66"=>"\xE8\x92\x9C",
		"\x95\x67"=>"\xE8\x9B\xAD",
		"\x95\x68"=>"\xE9\xB0\xAD",
		"\x95\x69"=>"\xE5\x93\x81",
		"\x95\x6A"=>"\xE5\xBD\xAC",
		"\x95\x6B"=>"\xE6\x96\x8C",
		"\x95\x6C"=>"\xE6\xB5\x9C",
		"\x95\x6D"=>"\xE7\x80\x95",
		"\x95\x6E"=>"\xE8\xB2\xA7",
		"\x95\x6F"=>"\xE8\xB3\x93",
		"\x95\x70"=>"\xE9\xA0\xBB",
		"\x95\x71"=>"\xE6\x95\x8F",
		"\x95\x72"=>"\xE7\x93\xB6",
		"\x95\x73"=>"\xE4\xB8\x8D",
		"\x95\x74"=>"\xE4\xBB\x98",
		"\x95\x75"=>"\xE5\x9F\xA0",
		"\x95\x76"=>"\xE5\xA4\xAB",
		"\x95\x77"=>"\xE5\xA9\xA6",
		"\x95\x78"=>"\xE5\xAF\x8C",
		"\x95\x79"=>"\xE5\x86\xA8",
		"\x95\x7A"=>"\xE5\xB8\x83",
		"\x95\x7B"=>"\xE5\xBA\x9C",
		"\x95\x7C"=>"\xE6\x80\x96",
		"\x95\x7D"=>"\xE6\x89\xB6",
		"\x95\x7E"=>"\xE6\x95\xB7",
		"\x95\x80"=>"\xE6\x96\xA7",
		"\x95\x81"=>"\xE6\x99\xAE",
		"\x95\x82"=>"\xE6\xB5\xAE",
		"\x95\x83"=>"\xE7\x88\xB6",
		"\x95\x84"=>"\xE7\xAC\xA6",
		"\x95\x85"=>"\xE8\x85\x90",
		"\x95\x86"=>"\xE8\x86\x9A",
		"\x95\x87"=>"\xE8\x8A\x99",
		"\x95\x88"=>"\xE8\xAD\x9C",
		"\x95\x89"=>"\xE8\xB2\xA0",
		"\x95\x8A"=>"\xE8\xB3\xA6",
		"\x95\x8B"=>"\xE8\xB5\xB4",
		"\x95\x8C"=>"\xE9\x98\x9C",
		"\x95\x8D"=>"\xE9\x99\x84",
		"\x95\x8E"=>"\xE4\xBE\xAE",
		"\x95\x8F"=>"\xE6\x92\xAB",
		"\x95\x90"=>"\xE6\xAD\xA6",
		"\x95\x91"=>"\xE8\x88\x9E",
		"\x95\x92"=>"\xE8\x91\xA1",
		"\x95\x93"=>"\xE8\x95\xAA",
		"\x95\x94"=>"\xE9\x83\xA8",
		"\x95\x95"=>"\xE5\xB0\x81",
		"\x95\x96"=>"\xE6\xA5\x93",
		"\x95\x97"=>"\xE9\xA2\xA8",
		"\x95\x98"=>"\xE8\x91\xBA",
		"\x95\x99"=>"\xE8\x95\x97",
		"\x95\x9A"=>"\xE4\xBC\x8F",
		"\x95\x9B"=>"\xE5\x89\xAF",
		"\x95\x9C"=>"\xE5\xBE\xA9",
		"\x95\x9D"=>"\xE5\xB9\x85",
		"\x95\x9E"=>"\xE6\x9C\x8D",
		"\x95\x9F"=>"\xE7\xA6\x8F",
		"\x95\xA0"=>"\xE8\x85\xB9",
		"\x95\xA1"=>"\xE8\xA4\x87",
		"\x95\xA2"=>"\xE8\xA6\x86",
		"\x95\xA3"=>"\xE6\xB7\xB5",
		"\x95\xA4"=>"\xE5\xBC\x97",
		"\x95\xA5"=>"\xE6\x89\x95",
		"\x95\xA6"=>"\xE6\xB2\xB8",
		"\x95\xA7"=>"\xE4\xBB\x8F",
		"\x95\xA8"=>"\xE7\x89\xA9",
		"\x95\xA9"=>"\xE9\xAE\x92",
		"\x95\xAA"=>"\xE5\x88\x86",
		"\x95\xAB"=>"\xE5\x90\xBB",
		"\x95\xAC"=>"\xE5\x99\xB4",
		"\x95\xAD"=>"\xE5\xA2\xB3",
		"\x95\xAE"=>"\xE6\x86\xA4",
		"\x95\xAF"=>"\xE6\x89\xAE",
		"\x95\xB0"=>"\xE7\x84\x9A",
		"\x95\xB1"=>"\xE5\xA5\xAE",
		"\x95\xB2"=>"\xE7\xB2\x89",
		"\x95\xB3"=>"\xE7\xB3\x9E",
		"\x95\xB4"=>"\xE7\xB4\x9B",
		"\x95\xB5"=>"\xE9\x9B\xB0",
		"\x95\xB6"=>"\xE6\x96\x87",
		"\x95\xB7"=>"\xE8\x81\x9E",
		"\x95\xB8"=>"\xE4\xB8\x99",
		"\x95\xB9"=>"\xE4\xBD\xB5",
		"\x95\xBA"=>"\xE5\x85\xB5",
		"\x95\xBB"=>"\xE5\xA1\x80",
		"\x95\xBC"=>"\xE5\xB9\xA3",
		"\x95\xBD"=>"\xE5\xB9\xB3",
		"\x95\xBE"=>"\xE5\xBC\x8A",
		"\x95\xBF"=>"\xE6\x9F\x84",
		"\x95\xC0"=>"\xE4\xB8\xA6",
		"\x95\xC1"=>"\xE8\x94\xBD",
		"\x95\xC2"=>"\xE9\x96\x89",
		"\x95\xC3"=>"\xE9\x99\x9B",
		"\x95\xC4"=>"\xE7\xB1\xB3",
		"\x95\xC5"=>"\xE9\xA0\x81",
		"\x95\xC6"=>"\xE5\x83\xBB",
		"\x95\xC7"=>"\xE5\xA3\x81",
		"\x95\xC8"=>"\xE7\x99\x96",
		"\x95\xC9"=>"\xE7\xA2\xA7",
		"\x95\xCA"=>"\xE5\x88\xA5",
		"\x95\xCB"=>"\xE7\x9E\xA5",
		"\x95\xCC"=>"\xE8\x94\x91",
		"\x95\xCD"=>"\xE7\xAE\x86",
		"\x95\xCE"=>"\xE5\x81\x8F",
		"\x95\xCF"=>"\xE5\xA4\x89",
		"\x95\xD0"=>"\xE7\x89\x87",
		"\x95\xD1"=>"\xE7\xAF\x87",
		"\x95\xD2"=>"\xE7\xB7\xA8",
		"\x95\xD3"=>"\xE8\xBE\xBA",
		"\x95\xD4"=>"\xE8\xBF\x94",
		"\x95\xD5"=>"\xE9\x81\x8D",
		"\x95\xD6"=>"\xE4\xBE\xBF",
		"\x95\xD7"=>"\xE5\x8B\x89",
		"\x95\xD8"=>"\xE5\xA8\xA9",
		"\x95\xD9"=>"\xE5\xBC\x81",
		"\x95\xDA"=>"\xE9\x9E\xAD",
		"\x95\xDB"=>"\xE4\xBF\x9D",
		"\x95\xDC"=>"\xE8\x88\x97",
		"\x95\xDD"=>"\xE9\x8B\xAA",
		"\x95\xDE"=>"\xE5\x9C\x83",
		"\x95\xDF"=>"\xE6\x8D\x95",
		"\x95\xE0"=>"\xE6\xAD\xA9",
		"\x95\xE1"=>"\xE7\x94\xAB",
		"\x95\xE2"=>"\xE8\xA3\x9C",
		"\x95\xE3"=>"\xE8\xBC\x94",
		"\x95\xE4"=>"\xE7\xA9\x82",
		"\x95\xE5"=>"\xE5\x8B\x9F",
		"\x95\xE6"=>"\xE5\xA2\x93",
		"\x95\xE7"=>"\xE6\x85\x95",
		"\x95\xE8"=>"\xE6\x88\x8A",
		"\x95\xE9"=>"\xE6\x9A\xAE",
		"\x95\xEA"=>"\xE6\xAF\x8D",
		"\x95\xEB"=>"\xE7\xB0\xBF",
		"\x95\xEC"=>"\xE8\x8F\xA9",
		"\x95\xED"=>"\xE5\x80\xA3",
		"\x95\xEE"=>"\xE4\xBF\xB8",
		"\x95\xEF"=>"\xE5\x8C\x85",
		"\x95\xF0"=>"\xE5\x91\x86",
		"\x95\xF1"=>"\xE5\xA0\xB1",
		"\x95\xF2"=>"\xE5\xA5\x89",
		"\x95\xF3"=>"\xE5\xAE\x9D",
		"\x95\xF4"=>"\xE5\xB3\xB0",
		"\x95\xF5"=>"\xE5\xB3\xAF",
		"\x95\xF6"=>"\xE5\xB4\xA9",
		"\x95\xF7"=>"\xE5\xBA\x96",
		"\x95\xF8"=>"\xE6\x8A\xB1",
		"\x95\xF9"=>"\xE6\x8D\xA7",
		"\x95\xFA"=>"\xE6\x94\xBE",
		"\x95\xFB"=>"\xE6\x96\xB9",
		"\x95\xFC"=>"\xE6\x9C\x8B",
		"\x96\x40"=>"\xE6\xB3\x95",
		"\x96\x41"=>"\xE6\xB3\xA1",
		"\x96\x42"=>"\xE7\x83\xB9",
		"\x96\x43"=>"\xE7\xA0\xB2",
		"\x96\x44"=>"\xE7\xB8\xAB",
		"\x96\x45"=>"\xE8\x83\x9E",
		"\x96\x46"=>"\xE8\x8A\xB3",
		"\x96\x47"=>"\xE8\x90\x8C",
		"\x96\x48"=>"\xE8\x93\xAC",
		"\x96\x49"=>"\xE8\x9C\x82",
		"\x96\x4A"=>"\xE8\xA4\x92",
		"\x96\x4B"=>"\xE8\xA8\xAA",
		"\x96\x4C"=>"\xE8\xB1\x8A",
		"\x96\x4D"=>"\xE9\x82\xA6",
		"\x96\x4E"=>"\xE9\x8B\x92",
		"\x96\x4F"=>"\xE9\xA3\xBD",
		"\x96\x50"=>"\xE9\xB3\xB3",
		"\x96\x51"=>"\xE9\xB5\xAC",
		"\x96\x52"=>"\xE4\xB9\x8F",
		"\x96\x53"=>"\xE4\xBA\xA1",
		"\x96\x54"=>"\xE5\x82\x8D",
		"\x96\x55"=>"\xE5\x89\x96",
		"\x96\x56"=>"\xE5\x9D\x8A",
		"\x96\x57"=>"\xE5\xA6\xA8",
		"\x96\x58"=>"\xE5\xB8\xBD",
		"\x96\x59"=>"\xE5\xBF\x98",
		"\x96\x5A"=>"\xE5\xBF\x99",
		"\x96\x5B"=>"\xE6\x88\xBF",
		"\x96\x5C"=>"\xE6\x9A\xB4",
		"\x96\x5D"=>"\xE6\x9C\x9B",
		"\x96\x5E"=>"\xE6\x9F\x90",
		"\x96\x5F"=>"\xE6\xA3\x92",
		"\x96\x60"=>"\xE5\x86\x92",
		"\x96\x61"=>"\xE7\xB4\xA1",
		"\x96\x62"=>"\xE8\x82\xAA",
		"\x96\x63"=>"\xE8\x86\xA8",
		"\x96\x64"=>"\xE8\xAC\x80",
		"\x96\x65"=>"\xE8\xB2\x8C",
		"\x96\x66"=>"\xE8\xB2\xBF",
		"\x96\x67"=>"\xE9\x89\xBE",
		"\x96\x68"=>"\xE9\x98\xB2",
		"\x96\x69"=>"\xE5\x90\xA0",
		"\x96\x6A"=>"\xE9\xA0\xAC",
		"\x96\x6B"=>"\xE5\x8C\x97",
		"\x96\x6C"=>"\xE5\x83\x95",
		"\x96\x6D"=>"\xE5\x8D\x9C",
		"\x96\x6E"=>"\xE5\xA2\xA8",
		"\x96\x6F"=>"\xE6\x92\xB2",
		"\x96\x70"=>"\xE6\x9C\xB4",
		"\x96\x71"=>"\xE7\x89\xA7",
		"\x96\x72"=>"\xE7\x9D\xA6",
		"\x96\x73"=>"\xE7\xA9\x86",
		"\x96\x74"=>"\xE9\x87\xA6",
		"\x96\x75"=>"\xE5\x8B\x83",
		"\x96\x76"=>"\xE6\xB2\xA1",
		"\x96\x77"=>"\xE6\xAE\x86",
		"\x96\x78"=>"\xE5\xA0\x80",
		"\x96\x79"=>"\xE5\xB9\x8C",
		"\x96\x7A"=>"\xE5\xA5\x94",
		"\x96\x7B"=>"\xE6\x9C\xAC",
		"\x96\x7C"=>"\xE7\xBF\xBB",
		"\x96\x7D"=>"\xE5\x87\xA1",
		"\x96\x7E"=>"\xE7\x9B\x86",
		"\x96\x80"=>"\xE6\x91\xA9",
		"\x96\x81"=>"\xE7\xA3\xA8",
		"\x96\x82"=>"\xE9\xAD\x94",
		"\x96\x83"=>"\xE9\xBA\xBB",
		"\x96\x84"=>"\xE5\x9F\x8B",
		"\x96\x85"=>"\xE5\xA6\xB9",
		"\x96\x86"=>"\xE6\x98\xA7",
		"\x96\x87"=>"\xE6\x9E\x9A",
		"\x96\x88"=>"\xE6\xAF\x8E",
		"\x96\x89"=>"\xE5\x93\xA9",
		"\x96\x8A"=>"\xE6\xA7\x99",
		"\x96\x8B"=>"\xE5\xB9\x95",
		"\x96\x8C"=>"\xE8\x86\x9C",
		"\x96\x8D"=>"\xE6\x9E\x95",
		"\x96\x8E"=>"\xE9\xAE\xAA",
		"\x96\x8F"=>"\xE6\x9F\xBE",
		"\x96\x90"=>"\xE9\xB1\x92",
		"\x96\x91"=>"\xE6\xA1\x9D",
		"\x96\x92"=>"\xE4\xBA\xA6",
		"\x96\x93"=>"\xE4\xBF\xA3",
		"\x96\x94"=>"\xE5\x8F\x88",
		"\x96\x95"=>"\xE6\x8A\xB9",
		"\x96\x96"=>"\xE6\x9C\xAB",
		"\x96\x97"=>"\xE6\xB2\xAB",
		"\x96\x98"=>"\xE8\xBF\x84",
		"\x96\x99"=>"\xE4\xBE\xAD",
		"\x96\x9A"=>"\xE7\xB9\xAD",
		"\x96\x9B"=>"\xE9\xBA\xBF",
		"\x96\x9C"=>"\xE4\xB8\x87",
		"\x96\x9D"=>"\xE6\x85\xA2",
		"\x96\x9E"=>"\xE6\xBA\x80",
		"\x96\x9F"=>"\xE6\xBC\xAB",
		"\x96\xA0"=>"\xE8\x94\x93",
		"\x96\xA1"=>"\xE5\x91\xB3",
		"\x96\xA2"=>"\xE6\x9C\xAA",
		"\x96\xA3"=>"\xE9\xAD\x85",
		"\x96\xA4"=>"\xE5\xB7\xB3",
		"\x96\xA5"=>"\xE7\xAE\x95",
		"\x96\xA6"=>"\xE5\xB2\xAC",
		"\x96\xA7"=>"\xE5\xAF\x86",
		"\x96\xA8"=>"\xE8\x9C\x9C",
		"\x96\xA9"=>"\xE6\xB9\x8A",
		"\x96\xAA"=>"\xE8\x93\x91",
		"\x96\xAB"=>"\xE7\xA8\x94",
		"\x96\xAC"=>"\xE8\x84\x88",
		"\x96\xAD"=>"\xE5\xA6\x99",
		"\x96\xAE"=>"\xE7\xB2\x8D",
		"\x96\xAF"=>"\xE6\xB0\x91",
		"\x96\xB0"=>"\xE7\x9C\xA0",
		"\x96\xB1"=>"\xE5\x8B\x99",
		"\x96\xB2"=>"\xE5\xA4\xA2",
		"\x96\xB3"=>"\xE7\x84\xA1",
		"\x96\xB4"=>"\xE7\x89\x9F",
		"\x96\xB5"=>"\xE7\x9F\x9B",
		"\x96\xB6"=>"\xE9\x9C\xA7",
		"\x96\xB7"=>"\xE9\xB5\xA1",
		"\x96\xB8"=>"\xE6\xA4\x8B",
		"\x96\xB9"=>"\xE5\xA9\xBF",
		"\x96\xBA"=>"\xE5\xA8\x98",
		"\x96\xBB"=>"\xE5\x86\xA5",
		"\x96\xBC"=>"\xE5\x90\x8D",
		"\x96\xBD"=>"\xE5\x91\xBD",
		"\x96\xBE"=>"\xE6\x98\x8E",
		"\x96\xBF"=>"\xE7\x9B\x9F",
		"\x96\xC0"=>"\xE8\xBF\xB7",
		"\x96\xC1"=>"\xE9\x8A\x98",
		"\x96\xC2"=>"\xE9\xB3\xB4",
		"\x96\xC3"=>"\xE5\xA7\xAA",
		"\x96\xC4"=>"\xE7\x89\x9D",
		"\x96\xC5"=>"\xE6\xBB\x85",
		"\x96\xC6"=>"\xE5\x85\x8D",
		"\x96\xC7"=>"\xE6\xA3\x89",
		"\x96\xC8"=>"\xE7\xB6\xBF",
		"\x96\xC9"=>"\xE7\xB7\xAC",
		"\x96\xCA"=>"\xE9\x9D\xA2",
		"\x96\xCB"=>"\xE9\xBA\xBA",
		"\x96\xCC"=>"\xE6\x91\xB8",
		"\x96\xCD"=>"\xE6\xA8\xA1",
		"\x96\xCE"=>"\xE8\x8C\x82",
		"\x96\xCF"=>"\xE5\xA6\x84",
		"\x96\xD0"=>"\xE5\xAD\x9F",
		"\x96\xD1"=>"\xE6\xAF\x9B",
		"\x96\xD2"=>"\xE7\x8C\x9B",
		"\x96\xD3"=>"\xE7\x9B\xB2",
		"\x96\xD4"=>"\xE7\xB6\xB2",
		"\x96\xD5"=>"\xE8\x80\x97",
		"\x96\xD6"=>"\xE8\x92\x99",
		"\x96\xD7"=>"\xE5\x84\xB2",
		"\x96\xD8"=>"\xE6\x9C\xA8",
		"\x96\xD9"=>"\xE9\xBB\x99",
		"\x96\xDA"=>"\xE7\x9B\xAE",
		"\x96\xDB"=>"\xE6\x9D\xA2",
		"\x96\xDC"=>"\xE5\x8B\xBF",
		"\x96\xDD"=>"\xE9\xA4\x85",
		"\x96\xDE"=>"\xE5\xB0\xA4",
		"\x96\xDF"=>"\xE6\x88\xBB",
		"\x96\xE0"=>"\xE7\xB1\xBE",
		"\x96\xE1"=>"\xE8\xB2\xB0",
		"\x96\xE2"=>"\xE5\x95\x8F",
		"\x96\xE3"=>"\xE6\x82\xB6",
		"\x96\xE4"=>"\xE7\xB4\x8B",
		"\x96\xE5"=>"\xE9\x96\x80",
		"\x96\xE6"=>"\xE5\x8C\x81",
		"\x96\xE7"=>"\xE4\xB9\x9F",
		"\x96\xE8"=>"\xE5\x86\xB6",
		"\x96\xE9"=>"\xE5\xA4\x9C",
		"\x96\xEA"=>"\xE7\x88\xBA",
		"\x96\xEB"=>"\xE8\x80\xB6",
		"\x96\xEC"=>"\xE9\x87\x8E",
		"\x96\xED"=>"\xE5\xBC\xA5",
		"\x96\xEE"=>"\xE7\x9F\xA2",
		"\x96\xEF"=>"\xE5\x8E\x84",
		"\x96\xF0"=>"\xE5\xBD\xB9",
		"\x96\xF1"=>"\xE7\xB4\x84",
		"\x96\xF2"=>"\xE8\x96\xAC",
		"\x96\xF3"=>"\xE8\xA8\xB3",
		"\x96\xF4"=>"\xE8\xBA\x8D",
		"\x96\xF5"=>"\xE9\x9D\x96",
		"\x96\xF6"=>"\xE6\x9F\xB3",
		"\x96\xF7"=>"\xE8\x96\xAE",
		"\x96\xF8"=>"\xE9\x91\x93",
		"\x96\xF9"=>"\xE6\x84\x89",
		"\x96\xFA"=>"\xE6\x84\x88",
		"\x96\xFB"=>"\xE6\xB2\xB9",
		"\x96\xFC"=>"\xE7\x99\x92",
		"\x97\x40"=>"\xE8\xAB\xAD",
		"\x97\x41"=>"\xE8\xBC\xB8",
		"\x97\x42"=>"\xE5\x94\xAF",
		"\x97\x43"=>"\xE4\xBD\x91",
		"\x97\x44"=>"\xE5\x84\xAA",
		"\x97\x45"=>"\xE5\x8B\x87",
		"\x97\x46"=>"\xE5\x8F\x8B",
		"\x97\x47"=>"\xE5\xAE\xA5",
		"\x97\x48"=>"\xE5\xB9\xBD",
		"\x97\x49"=>"\xE6\x82\xA0",
		"\x97\x4A"=>"\xE6\x86\x82",
		"\x97\x4B"=>"\xE6\x8F\x96",
		"\x97\x4C"=>"\xE6\x9C\x89",
		"\x97\x4D"=>"\xE6\x9F\x9A",
		"\x97\x4E"=>"\xE6\xB9\xA7",
		"\x97\x4F"=>"\xE6\xB6\x8C",
		"\x97\x50"=>"\xE7\x8C\xB6",
		"\x97\x51"=>"\xE7\x8C\xB7",
		"\x97\x52"=>"\xE7\x94\xB1",
		"\x97\x53"=>"\xE7\xA5\x90",
		"\x97\x54"=>"\xE8\xA3\x95",
		"\x97\x55"=>"\xE8\xAA\x98",
		"\x97\x56"=>"\xE9\x81\x8A",
		"\x97\x57"=>"\xE9\x82\x91",
		"\x97\x58"=>"\xE9\x83\xB5",
		"\x97\x59"=>"\xE9\x9B\x84",
		"\x97\x5A"=>"\xE8\x9E\x8D",
		"\x97\x5B"=>"\xE5\xA4\x95",
		"\x97\x5C"=>"\xE4\xBA\x88",
		"\x97\x5D"=>"\xE4\xBD\x99",
		"\x97\x5E"=>"\xE4\xB8\x8E",
		"\x97\x5F"=>"\xE8\xAA\x89",
		"\x97\x60"=>"\xE8\xBC\xBF",
		"\x97\x61"=>"\xE9\xA0\x90",
		"\x97\x62"=>"\xE5\x82\xAD",
		"\x97\x63"=>"\xE5\xB9\xBC",
		"\x97\x64"=>"\xE5\xA6\x96",
		"\x97\x65"=>"\xE5\xAE\xB9",
		"\x97\x66"=>"\xE5\xBA\xB8",
		"\x97\x67"=>"\xE6\x8F\x9A",
		"\x97\x68"=>"\xE6\x8F\xBA",
		"\x97\x69"=>"\xE6\x93\x81",
		"\x97\x6A"=>"\xE6\x9B\x9C",
		"\x97\x6B"=>"\xE6\xA5\x8A",
		"\x97\x6C"=>"\xE6\xA7\x98",
		"\x97\x6D"=>"\xE6\xB4\x8B",
		"\x97\x6E"=>"\xE6\xBA\xB6",
		"\x97\x6F"=>"\xE7\x86\x94",
		"\x97\x70"=>"\xE7\x94\xA8",
		"\x97\x71"=>"\xE7\xAA\xAF",
		"\x97\x72"=>"\xE7\xBE\x8A",
		"\x97\x73"=>"\xE8\x80\x80",
		"\x97\x74"=>"\xE8\x91\x89",
		"\x97\x75"=>"\xE8\x93\x89",
		"\x97\x76"=>"\xE8\xA6\x81",
		"\x97\x77"=>"\xE8\xAC\xA1",
		"\x97\x78"=>"\xE8\xB8\x8A",
		"\x97\x79"=>"\xE9\x81\xA5",
		"\x97\x7A"=>"\xE9\x99\xBD",
		"\x97\x7B"=>"\xE9\xA4\x8A",
		"\x97\x7C"=>"\xE6\x85\xBE",
		"\x97\x7D"=>"\xE6\x8A\x91",
		"\x97\x7E"=>"\xE6\xAC\xB2",
		"\x97\x80"=>"\xE6\xB2\x83",
		"\x97\x81"=>"\xE6\xB5\xB4",
		"\x97\x82"=>"\xE7\xBF\x8C",
		"\x97\x83"=>"\xE7\xBF\xBC",
		"\x97\x84"=>"\xE6\xB7\x80",
		"\x97\x85"=>"\xE7\xBE\x85",
		"\x97\x86"=>"\xE8\x9E\xBA",
		"\x97\x87"=>"\xE8\xA3\xB8",
		"\x97\x88"=>"\xE6\x9D\xA5",
		"\x97\x89"=>"\xE8\x8E\xB1",
		"\x97\x8A"=>"\xE9\xA0\xBC",
		"\x97\x8B"=>"\xE9\x9B\xB7",
		"\x97\x8C"=>"\xE6\xB4\x9B",
		"\x97\x8D"=>"\xE7\xB5\xA1",
		"\x97\x8E"=>"\xE8\x90\xBD",
		"\x97\x8F"=>"\xE9\x85\xAA",
		"\x97\x90"=>"\xE4\xB9\xB1",
		"\x97\x91"=>"\xE5\x8D\xB5",
		"\x97\x92"=>"\xE5\xB5\x90",
		"\x97\x93"=>"\xE6\xAC\x84",
		"\x97\x94"=>"\xE6\xBF\xAB",
		"\x97\x95"=>"\xE8\x97\x8D",
		"\x97\x96"=>"\xE8\x98\xAD",
		"\x97\x97"=>"\xE8\xA6\xA7",
		"\x97\x98"=>"\xE5\x88\xA9",
		"\x97\x99"=>"\xE5\x90\x8F",
		"\x97\x9A"=>"\xE5\xB1\xA5",
		"\x97\x9B"=>"\xE6\x9D\x8E",
		"\x97\x9C"=>"\xE6\xA2\xA8",
		"\x97\x9D"=>"\xE7\x90\x86",
		"\x97\x9E"=>"\xE7\x92\x83",
		"\x97\x9F"=>"\xE7\x97\xA2",
		"\x97\xA0"=>"\xE8\xA3\x8F",
		"\x97\xA1"=>"\xE8\xA3\xA1",
		"\x97\xA2"=>"\xE9\x87\x8C",
		"\x97\xA3"=>"\xE9\x9B\xA2",
		"\x97\xA4"=>"\xE9\x99\xB8",
		"\x97\xA5"=>"\xE5\xBE\x8B",
		"\x97\xA6"=>"\xE7\x8E\x87",
		"\x97\xA7"=>"\xE7\xAB\x8B",
		"\x97\xA8"=>"\xE8\x91\x8E",
		"\x97\xA9"=>"\xE6\x8E\xA0",
		"\x97\xAA"=>"\xE7\x95\xA5",
		"\x97\xAB"=>"\xE5\x8A\x89",
		"\x97\xAC"=>"\xE6\xB5\x81",
		"\x97\xAD"=>"\xE6\xBA\x9C",
		"\x97\xAE"=>"\xE7\x90\x89",
		"\x97\xAF"=>"\xE7\x95\x99",
		"\x97\xB0"=>"\xE7\xA1\xAB",
		"\x97\xB1"=>"\xE7\xB2\x92",
		"\x97\xB2"=>"\xE9\x9A\x86",
		"\x97\xB3"=>"\xE7\xAB\x9C",
		"\x97\xB4"=>"\xE9\xBE\x8D",
		"\x97\xB5"=>"\xE4\xBE\xB6",
		"\x97\xB6"=>"\xE6\x85\xAE",
		"\x97\xB7"=>"\xE6\x97\x85",
		"\x97\xB8"=>"\xE8\x99\x9C",
		"\x97\xB9"=>"\xE4\xBA\x86",
		"\x97\xBA"=>"\xE4\xBA\xAE",
		"\x97\xBB"=>"\xE5\x83\x9A",
		"\x97\xBC"=>"\xE4\xB8\xA1",
		"\x97\xBD"=>"\xE5\x87\x8C",
		"\x97\xBE"=>"\xE5\xAF\xAE",
		"\x97\xBF"=>"\xE6\x96\x99",
		"\x97\xC0"=>"\xE6\xA2\x81",
		"\x97\xC1"=>"\xE6\xB6\xBC",
		"\x97\xC2"=>"\xE7\x8C\x9F",
		"\x97\xC3"=>"\xE7\x99\x82",
		"\x97\xC4"=>"\xE7\x9E\xAD",
		"\x97\xC5"=>"\xE7\xA8\x9C",
		"\x97\xC6"=>"\xE7\xB3\xA7",
		"\x97\xC7"=>"\xE8\x89\xAF",
		"\x97\xC8"=>"\xE8\xAB\x92",
		"\x97\xC9"=>"\xE9\x81\xBC",
		"\x97\xCA"=>"\xE9\x87\x8F",
		"\x97\xCB"=>"\xE9\x99\xB5",
		"\x97\xCC"=>"\xE9\xA0\x98",
		"\x97\xCD"=>"\xE5\x8A\x9B",
		"\x97\xCE"=>"\xE7\xB7\x91",
		"\x97\xCF"=>"\xE5\x80\xAB",
		"\x97\xD0"=>"\xE5\x8E\x98",
		"\x97\xD1"=>"\xE6\x9E\x97",
		"\x97\xD2"=>"\xE6\xB7\x8B",
		"\x97\xD3"=>"\xE7\x87\x90",
		"\x97\xD4"=>"\xE7\x90\xB3",
		"\x97\xD5"=>"\xE8\x87\xA8",
		"\x97\xD6"=>"\xE8\xBC\xAA",
		"\x97\xD7"=>"\xE9\x9A\xA3",
		"\x97\xD8"=>"\xE9\xB1\x97",
		"\x97\xD9"=>"\xE9\xBA\x9F",
		"\x97\xDA"=>"\xE7\x91\xA0",
		"\x97\xDB"=>"\xE5\xA1\x81",
		"\x97\xDC"=>"\xE6\xB6\x99",
		"\x97\xDD"=>"\xE7\xB4\xAF",
		"\x97\xDE"=>"\xE9\xA1\x9E",
		"\x97\xDF"=>"\xE4\xBB\xA4",
		"\x97\xE0"=>"\xE4\xBC\xB6",
		"\x97\xE1"=>"\xE4\xBE\x8B",
		"\x97\xE2"=>"\xE5\x86\xB7",
		"\x97\xE3"=>"\xE5\x8A\xB1",
		"\x97\xE4"=>"\xE5\xB6\xBA",
		"\x97\xE5"=>"\xE6\x80\x9C",
		"\x97\xE6"=>"\xE7\x8E\xB2",
		"\x97\xE7"=>"\xE7\xA4\xBC",
		"\x97\xE8"=>"\xE8\x8B\x93",
		"\x97\xE9"=>"\xE9\x88\xB4",
		"\x97\xEA"=>"\xE9\x9A\xB7",
		"\x97\xEB"=>"\xE9\x9B\xB6",
		"\x97\xEC"=>"\xE9\x9C\x8A",
		"\x97\xED"=>"\xE9\xBA\x97",
		"\x97\xEE"=>"\xE9\xBD\xA2",
		"\x97\xEF"=>"\xE6\x9A\xA6",
		"\x97\xF0"=>"\xE6\xAD\xB4",
		"\x97\xF1"=>"\xE5\x88\x97",
		"\x97\xF2"=>"\xE5\x8A\xA3",
		"\x97\xF3"=>"\xE7\x83\x88",
		"\x97\xF4"=>"\xE8\xA3\x82",
		"\x97\xF5"=>"\xE5\xBB\x89",
		"\x97\xF6"=>"\xE6\x81\x8B",
		"\x97\xF7"=>"\xE6\x86\x90",
		"\x97\xF8"=>"\xE6\xBC\xA3",
		"\x97\xF9"=>"\xE7\x85\x89",
		"\x97\xFA"=>"\xE7\xB0\xBE",
		"\x97\xFB"=>"\xE7\xB7\xB4",
		"\x97\xFC"=>"\xE8\x81\xAF",
		"\x98\x40"=>"\xE8\x93\xAE",
		"\x98\x41"=>"\xE9\x80\xA3",
		"\x98\x42"=>"\xE9\x8C\xAC",
		"\x98\x43"=>"\xE5\x91\x82",
		"\x98\x44"=>"\xE9\xAD\xAF",
		"\x98\x45"=>"\xE6\xAB\x93",
		"\x98\x46"=>"\xE7\x82\x89",
		"\x98\x47"=>"\xE8\xB3\x82",
		"\x98\x48"=>"\xE8\xB7\xAF",
		"\x98\x49"=>"\xE9\x9C\xB2",
		"\x98\x4A"=>"\xE5\x8A\xB4",
		"\x98\x4B"=>"\xE5\xA9\x81",
		"\x98\x4C"=>"\xE5\xBB\x8A",
		"\x98\x4D"=>"\xE5\xBC\x84",
		"\x98\x4E"=>"\xE6\x9C\x97",
		"\x98\x4F"=>"\xE6\xA5\xBC",
		"\x98\x50"=>"\xE6\xA6\x94",
		"\x98\x51"=>"\xE6\xB5\xAA",
		"\x98\x52"=>"\xE6\xBC\x8F",
		"\x98\x53"=>"\xE7\x89\xA2",
		"\x98\x54"=>"\xE7\x8B\xBC",
		"\x98\x55"=>"\xE7\xAF\xAD",
		"\x98\x56"=>"\xE8\x80\x81",
		"\x98\x57"=>"\xE8\x81\xBE",
		"\x98\x58"=>"\xE8\x9D\x8B",
		"\x98\x59"=>"\xE9\x83\x8E",
		"\x98\x5A"=>"\xE5\x85\xAD",
		"\x98\x5B"=>"\xE9\xBA\x93",
		"\x98\x5C"=>"\xE7\xA6\x84",
		"\x98\x5D"=>"\xE8\x82\x8B",
		"\x98\x5E"=>"\xE9\x8C\xB2",
		"\x98\x5F"=>"\xE8\xAB\x96",
		"\x98\x60"=>"\xE5\x80\xAD",
		"\x98\x61"=>"\xE5\x92\x8C",
		"\x98\x62"=>"\xE8\xA9\xB1",
		"\x98\x63"=>"\xE6\xAD\xAA",
		"\x98\x64"=>"\xE8\xB3\x84",
		"\x98\x65"=>"\xE8\x84\x87",
		"\x98\x66"=>"\xE6\x83\x91",
		"\x98\x67"=>"\xE6\x9E\xA0",
		"\x98\x68"=>"\xE9\xB7\xB2",
		"\x98\x69"=>"\xE4\xBA\x99",
		"\x98\x6A"=>"\xE4\xBA\x98",
		"\x98\x6B"=>"\xE9\xB0\x90",
		"\x98\x6C"=>"\xE8\xA9\xAB",
		"\x98\x6D"=>"\xE8\x97\x81",
		"\x98\x6E"=>"\xE8\x95\xA8",
		"\x98\x6F"=>"\xE6\xA4\x80",
		"\x98\x70"=>"\xE6\xB9\xBE",
		"\x98\x71"=>"\xE7\xA2\x97",
		"\x98\x72"=>"\xE8\x85\x95",
		"\x98\x9F"=>"\xE5\xBC\x8C",
		"\x98\xA0"=>"\xE4\xB8\x90",
		"\x98\xA1"=>"\xE4\xB8\x95",
		"\x98\xA2"=>"\xE4\xB8\xAA",
		"\x98\xA3"=>"\xE4\xB8\xB1",
		"\x98\xA4"=>"\xE4\xB8\xB6",
		"\x98\xA5"=>"\xE4\xB8\xBC",
		"\x98\xA6"=>"\xE4\xB8\xBF",
		"\x98\xA7"=>"\xE4\xB9\x82",
		"\x98\xA8"=>"\xE4\xB9\x96",
		"\x98\xA9"=>"\xE4\xB9\x98",
		"\x98\xAA"=>"\xE4\xBA\x82",
		"\x98\xAB"=>"\xE4\xBA\x85",
		"\x98\xAC"=>"\xE8\xB1\xAB",
		"\x98\xAD"=>"\xE4\xBA\x8A",
		"\x98\xAE"=>"\xE8\x88\x92",
		"\x98\xAF"=>"\xE5\xBC\x8D",
		"\x98\xB0"=>"\xE4\xBA\x8E",
		"\x98\xB1"=>"\xE4\xBA\x9E",
		"\x98\xB2"=>"\xE4\xBA\x9F",
		"\x98\xB3"=>"\xE4\xBA\xA0",
		"\x98\xB4"=>"\xE4\xBA\xA2",
		"\x98\xB5"=>"\xE4\xBA\xB0",
		"\x98\xB6"=>"\xE4\xBA\xB3",
		"\x98\xB7"=>"\xE4\xBA\xB6",
		"\x98\xB8"=>"\xE4\xBB\x8E",
		"\x98\xB9"=>"\xE4\xBB\x8D",
		"\x98\xBA"=>"\xE4\xBB\x84",
		"\x98\xBB"=>"\xE4\xBB\x86",
		"\x98\xBC"=>"\xE4\xBB\x82",
		"\x98\xBD"=>"\xE4\xBB\x97",
		"\x98\xBE"=>"\xE4\xBB\x9E",
		"\x98\xBF"=>"\xE4\xBB\xAD",
		"\x98\xC0"=>"\xE4\xBB\x9F",
		"\x98\xC1"=>"\xE4\xBB\xB7",
		"\x98\xC2"=>"\xE4\xBC\x89",
		"\x98\xC3"=>"\xE4\xBD\x9A",
		"\x98\xC4"=>"\xE4\xBC\xB0",
		"\x98\xC5"=>"\xE4\xBD\x9B",
		"\x98\xC6"=>"\xE4\xBD\x9D",
		"\x98\xC7"=>"\xE4\xBD\x97",
		"\x98\xC8"=>"\xE4\xBD\x87",
		"\x98\xC9"=>"\xE4\xBD\xB6",
		"\x98\xCA"=>"\xE4\xBE\x88",
		"\x98\xCB"=>"\xE4\xBE\x8F",
		"\x98\xCC"=>"\xE4\xBE\x98",
		"\x98\xCD"=>"\xE4\xBD\xBB",
		"\x98\xCE"=>"\xE4\xBD\xA9",
		"\x98\xCF"=>"\xE4\xBD\xB0",
		"\x98\xD0"=>"\xE4\xBE\x91",
		"\x98\xD1"=>"\xE4\xBD\xAF",
		"\x98\xD2"=>"\xE4\xBE\x86",
		"\x98\xD3"=>"\xE4\xBE\x96",
		"\x98\xD4"=>"\xE5\x84\x98",
		"\x98\xD5"=>"\xE4\xBF\x94",
		"\x98\xD6"=>"\xE4\xBF\x9F",
		"\x98\xD7"=>"\xE4\xBF\x8E",
		"\x98\xD8"=>"\xE4\xBF\x98",
		"\x98\xD9"=>"\xE4\xBF\x9B",
		"\x98\xDA"=>"\xE4\xBF\x91",
		"\x98\xDB"=>"\xE4\xBF\x9A",
		"\x98\xDC"=>"\xE4\xBF\x90",
		"\x98\xDD"=>"\xE4\xBF\xA4",
		"\x98\xDE"=>"\xE4\xBF\xA5",
		"\x98\xDF"=>"\xE5\x80\x9A",
		"\x98\xE0"=>"\xE5\x80\xA8",
		"\x98\xE1"=>"\xE5\x80\x94",
		"\x98\xE2"=>"\xE5\x80\xAA",
		"\x98\xE3"=>"\xE5\x80\xA5",
		"\x98\xE4"=>"\xE5\x80\x85",
		"\x98\xE5"=>"\xE4\xBC\x9C",
		"\x98\xE6"=>"\xE4\xBF\xB6",
		"\x98\xE7"=>"\xE5\x80\xA1",
		"\x98\xE8"=>"\xE5\x80\xA9",
		"\x98\xE9"=>"\xE5\x80\xAC",
		"\x98\xEA"=>"\xE4\xBF\xBE",
		"\x98\xEB"=>"\xE4\xBF\xAF",
		"\x98\xEC"=>"\xE5\x80\x91",
		"\x98\xED"=>"\xE5\x80\x86",
		"\x98\xEE"=>"\xE5\x81\x83",
		"\x98\xEF"=>"\xE5\x81\x87",
		"\x98\xF0"=>"\xE6\x9C\x83",
		"\x98\xF1"=>"\xE5\x81\x95",
		"\x98\xF2"=>"\xE5\x81\x90",
		"\x98\xF3"=>"\xE5\x81\x88",
		"\x98\xF4"=>"\xE5\x81\x9A",
		"\x98\xF5"=>"\xE5\x81\x96",
		"\x98\xF6"=>"\xE5\x81\xAC",
		"\x98\xF7"=>"\xE5\x81\xB8",
		"\x98\xF8"=>"\xE5\x82\x80",
		"\x98\xF9"=>"\xE5\x82\x9A",
		"\x98\xFA"=>"\xE5\x82\x85",
		"\x98\xFB"=>"\xE5\x82\xB4",
		"\x98\xFC"=>"\xE5\x82\xB2",
		"\x99\x40"=>"\xE5\x83\x89",
		"\x99\x41"=>"\xE5\x83\x8A",
		"\x99\x42"=>"\xE5\x82\xB3",
		"\x99\x43"=>"\xE5\x83\x82",
		"\x99\x44"=>"\xE5\x83\x96",
		"\x99\x45"=>"\xE5\x83\x9E",
		"\x99\x46"=>"\xE5\x83\xA5",
		"\x99\x47"=>"\xE5\x83\xAD",
		"\x99\x48"=>"\xE5\x83\xA3",
		"\x99\x49"=>"\xE5\x83\xAE",
		"\x99\x4A"=>"\xE5\x83\xB9",
		"\x99\x4B"=>"\xE5\x83\xB5",
		"\x99\x4C"=>"\xE5\x84\x89",
		"\x99\x4D"=>"\xE5\x84\x81",
		"\x99\x4E"=>"\xE5\x84\x82",
		"\x99\x4F"=>"\xE5\x84\x96",
		"\x99\x50"=>"\xE5\x84\x95",
		"\x99\x51"=>"\xE5\x84\x94",
		"\x99\x52"=>"\xE5\x84\x9A",
		"\x99\x53"=>"\xE5\x84\xA1",
		"\x99\x54"=>"\xE5\x84\xBA",
		"\x99\x55"=>"\xE5\x84\xB7",
		"\x99\x56"=>"\xE5\x84\xBC",
		"\x99\x57"=>"\xE5\x84\xBB",
		"\x99\x58"=>"\xE5\x84\xBF",
		"\x99\x59"=>"\xE5\x85\x80",
		"\x99\x5A"=>"\xE5\x85\x92",
		"\x99\x5B"=>"\xE5\x85\x8C",
		"\x99\x5C"=>"\xE5\x85\x94",
		"\x99\x5D"=>"\xE5\x85\xA2",
		"\x99\x5E"=>"\xE7\xAB\xB8",
		"\x99\x5F"=>"\xE5\x85\xA9",
		"\x99\x60"=>"\xE5\x85\xAA",
		"\x99\x61"=>"\xE5\x85\xAE",
		"\x99\x62"=>"\xE5\x86\x80",
		"\x99\x63"=>"\xE5\x86\x82",
		"\x99\x64"=>"\xE5\x9B\x98",
		"\x99\x65"=>"\xE5\x86\x8C",
		"\x99\x66"=>"\xE5\x86\x89",
		"\x99\x67"=>"\xE5\x86\x8F",
		"\x99\x68"=>"\xE5\x86\x91",
		"\x99\x69"=>"\xE5\x86\x93",
		"\x99\x6A"=>"\xE5\x86\x95",
		"\x99\x6B"=>"\xE5\x86\x96",
		"\x99\x6C"=>"\xE5\x86\xA4",
		"\x99\x6D"=>"\xE5\x86\xA6",
		"\x99\x6E"=>"\xE5\x86\xA2",
		"\x99\x6F"=>"\xE5\x86\xA9",
		"\x99\x70"=>"\xE5\x86\xAA",
		"\x99\x71"=>"\xE5\x86\xAB",
		"\x99\x72"=>"\xE5\x86\xB3",
		"\x99\x73"=>"\xE5\x86\xB1",
		"\x99\x74"=>"\xE5\x86\xB2",
		"\x99\x75"=>"\xE5\x86\xB0",
		"\x99\x76"=>"\xE5\x86\xB5",
		"\x99\x77"=>"\xE5\x86\xBD",
		"\x99\x78"=>"\xE5\x87\x85",
		"\x99\x79"=>"\xE5\x87\x89",
		"\x99\x7A"=>"\xE5\x87\x9B",
		"\x99\x7B"=>"\xE5\x87\xA0",
		"\x99\x7C"=>"\xE8\x99\x95",
		"\x99\x7D"=>"\xE5\x87\xA9",
		"\x99\x7E"=>"\xE5\x87\xAD",
		"\x99\x80"=>"\xE5\x87\xB0",
		"\x99\x81"=>"\xE5\x87\xB5",
		"\x99\x82"=>"\xE5\x87\xBE",
		"\x99\x83"=>"\xE5\x88\x84",
		"\x99\x84"=>"\xE5\x88\x8B",
		"\x99\x85"=>"\xE5\x88\x94",
		"\x99\x86"=>"\xE5\x88\x8E",
		"\x99\x87"=>"\xE5\x88\xA7",
		"\x99\x88"=>"\xE5\x88\xAA",
		"\x99\x89"=>"\xE5\x88\xAE",
		"\x99\x8A"=>"\xE5\x88\xB3",
		"\x99\x8B"=>"\xE5\x88\xB9",
		"\x99\x8C"=>"\xE5\x89\x8F",
		"\x99\x8D"=>"\xE5\x89\x84",
		"\x99\x8E"=>"\xE5\x89\x8B",
		"\x99\x8F"=>"\xE5\x89\x8C",
		"\x99\x90"=>"\xE5\x89\x9E",
		"\x99\x91"=>"\xE5\x89\x94",
		"\x99\x92"=>"\xE5\x89\xAA",
		"\x99\x93"=>"\xE5\x89\xB4",
		"\x99\x94"=>"\xE5\x89\xA9",
		"\x99\x95"=>"\xE5\x89\xB3",
		"\x99\x96"=>"\xE5\x89\xBF",
		"\x99\x97"=>"\xE5\x89\xBD",
		"\x99\x98"=>"\xE5\x8A\x8D",
		"\x99\x99"=>"\xE5\x8A\x94",
		"\x99\x9A"=>"\xE5\x8A\x92",
		"\x99\x9B"=>"\xE5\x89\xB1",
		"\x99\x9C"=>"\xE5\x8A\x88",
		"\x99\x9D"=>"\xE5\x8A\x91",
		"\x99\x9E"=>"\xE8\xBE\xA8",
		"\x99\x9F"=>"\xE8\xBE\xA7",
		"\x99\xA0"=>"\xE5\x8A\xAC",
		"\x99\xA1"=>"\xE5\x8A\xAD",
		"\x99\xA2"=>"\xE5\x8A\xBC",
		"\x99\xA3"=>"\xE5\x8A\xB5",
		"\x99\xA4"=>"\xE5\x8B\x81",
		"\x99\xA5"=>"\xE5\x8B\x8D",
		"\x99\xA6"=>"\xE5\x8B\x97",
		"\x99\xA7"=>"\xE5\x8B\x9E",
		"\x99\xA8"=>"\xE5\x8B\xA3",
		"\x99\xA9"=>"\xE5\x8B\xA6",
		"\x99\xAA"=>"\xE9\xA3\xAD",
		"\x99\xAB"=>"\xE5\x8B\xA0",
		"\x99\xAC"=>"\xE5\x8B\xB3",
		"\x99\xAD"=>"\xE5\x8B\xB5",
		"\x99\xAE"=>"\xE5\x8B\xB8",
		"\x99\xAF"=>"\xE5\x8B\xB9",
		"\x99\xB0"=>"\xE5\x8C\x86",
		"\x99\xB1"=>"\xE5\x8C\x88",
		"\x99\xB2"=>"\xE7\x94\xB8",
		"\x99\xB3"=>"\xE5\x8C\x8D",
		"\x99\xB4"=>"\xE5\x8C\x90",
		"\x99\xB5"=>"\xE5\x8C\x8F",
		"\x99\xB6"=>"\xE5\x8C\x95",
		"\x99\xB7"=>"\xE5\x8C\x9A",
		"\x99\xB8"=>"\xE5\x8C\xA3",
		"\x99\xB9"=>"\xE5\x8C\xAF",
		"\x99\xBA"=>"\xE5\x8C\xB1",
		"\x99\xBB"=>"\xE5\x8C\xB3",
		"\x99\xBC"=>"\xE5\x8C\xB8",
		"\x99\xBD"=>"\xE5\x8D\x80",
		"\x99\xBE"=>"\xE5\x8D\x86",
		"\x99\xBF"=>"\xE5\x8D\x85",
		"\x99\xC0"=>"\xE4\xB8\x97",
		"\x99\xC1"=>"\xE5\x8D\x89",
		"\x99\xC2"=>"\xE5\x8D\x8D",
		"\x99\xC3"=>"\xE5\x87\x96",
		"\x99\xC4"=>"\xE5\x8D\x9E",
		"\x99\xC5"=>"\xE5\x8D\xA9",
		"\x99\xC6"=>"\xE5\x8D\xAE",
		"\x99\xC7"=>"\xE5\xA4\x98",
		"\x99\xC8"=>"\xE5\x8D\xBB",
		"\x99\xC9"=>"\xE5\x8D\xB7",
		"\x99\xCA"=>"\xE5\x8E\x82",
		"\x99\xCB"=>"\xE5\x8E\x96",
		"\x99\xCC"=>"\xE5\x8E\xA0",
		"\x99\xCD"=>"\xE5\x8E\xA6",
		"\x99\xCE"=>"\xE5\x8E\xA5",
		"\x99\xCF"=>"\xE5\x8E\xAE",
		"\x99\xD0"=>"\xE5\x8E\xB0",
		"\x99\xD1"=>"\xE5\x8E\xB6",
		"\x99\xD2"=>"\xE5\x8F\x83",
		"\x99\xD3"=>"\xE7\xB0\x92",
		"\x99\xD4"=>"\xE9\x9B\x99",
		"\x99\xD5"=>"\xE5\x8F\x9F",
		"\x99\xD6"=>"\xE6\x9B\xBC",
		"\x99\xD7"=>"\xE7\x87\xAE",
		"\x99\xD8"=>"\xE5\x8F\xAE",
		"\x99\xD9"=>"\xE5\x8F\xA8",
		"\x99\xDA"=>"\xE5\x8F\xAD",
		"\x99\xDB"=>"\xE5\x8F\xBA",
		"\x99\xDC"=>"\xE5\x90\x81",
		"\x99\xDD"=>"\xE5\x90\xBD",
		"\x99\xDE"=>"\xE5\x91\x80",
		"\x99\xDF"=>"\xE5\x90\xAC",
		"\x99\xE0"=>"\xE5\x90\xAD",
		"\x99\xE1"=>"\xE5\x90\xBC",
		"\x99\xE2"=>"\xE5\x90\xAE",
		"\x99\xE3"=>"\xE5\x90\xB6",
		"\x99\xE4"=>"\xE5\x90\xA9",
		"\x99\xE5"=>"\xE5\x90\x9D",
		"\x99\xE6"=>"\xE5\x91\x8E",
		"\x99\xE7"=>"\xE5\x92\x8F",
		"\x99\xE8"=>"\xE5\x91\xB5",
		"\x99\xE9"=>"\xE5\x92\x8E",
		"\x99\xEA"=>"\xE5\x91\x9F",
		"\x99\xEB"=>"\xE5\x91\xB1",
		"\x99\xEC"=>"\xE5\x91\xB7",
		"\x99\xED"=>"\xE5\x91\xB0",
		"\x99\xEE"=>"\xE5\x92\x92",
		"\x99\xEF"=>"\xE5\x91\xBB",
		"\x99\xF0"=>"\xE5\x92\x80",
		"\x99\xF1"=>"\xE5\x91\xB6",
		"\x99\xF2"=>"\xE5\x92\x84",
		"\x99\xF3"=>"\xE5\x92\x90",
		"\x99\xF4"=>"\xE5\x92\x86",
		"\x99\xF5"=>"\xE5\x93\x87",
		"\x99\xF6"=>"\xE5\x92\xA2",
		"\x99\xF7"=>"\xE5\x92\xB8",
		"\x99\xF8"=>"\xE5\x92\xA5",
		"\x99\xF9"=>"\xE5\x92\xAC",
		"\x99\xFA"=>"\xE5\x93\x84",
		"\x99\xFB"=>"\xE5\x93\x88",
		"\x99\xFC"=>"\xE5\x92\xA8",
		"\x9A\x40"=>"\xE5\x92\xAB",
		"\x9A\x41"=>"\xE5\x93\x82",
		"\x9A\x42"=>"\xE5\x92\xA4",
		"\x9A\x43"=>"\xE5\x92\xBE",
		"\x9A\x44"=>"\xE5\x92\xBC",
		"\x9A\x45"=>"\xE5\x93\x98",
		"\x9A\x46"=>"\xE5\x93\xA5",
		"\x9A\x47"=>"\xE5\x93\xA6",
		"\x9A\x48"=>"\xE5\x94\x8F",
		"\x9A\x49"=>"\xE5\x94\x94",
		"\x9A\x4A"=>"\xE5\x93\xBD",
		"\x9A\x4B"=>"\xE5\x93\xAE",
		"\x9A\x4C"=>"\xE5\x93\xAD",
		"\x9A\x4D"=>"\xE5\x93\xBA",
		"\x9A\x4E"=>"\xE5\x93\xA2",
		"\x9A\x4F"=>"\xE5\x94\xB9",
		"\x9A\x50"=>"\xE5\x95\x80",
		"\x9A\x51"=>"\xE5\x95\xA3",
		"\x9A\x52"=>"\xE5\x95\x8C",
		"\x9A\x53"=>"\xE5\x94\xAE",
		"\x9A\x54"=>"\xE5\x95\x9C",
		"\x9A\x55"=>"\xE5\x95\x85",
		"\x9A\x56"=>"\xE5\x95\x96",
		"\x9A\x57"=>"\xE5\x95\x97",
		"\x9A\x58"=>"\xE5\x94\xB8",
		"\x9A\x59"=>"\xE5\x94\xB3",
		"\x9A\x5A"=>"\xE5\x95\x9D",
		"\x9A\x5B"=>"\xE5\x96\x99",
		"\x9A\x5C"=>"\xE5\x96\x80",
		"\x9A\x5D"=>"\xE5\x92\xAF",
		"\x9A\x5E"=>"\xE5\x96\x8A",
		"\x9A\x5F"=>"\xE5\x96\x9F",
		"\x9A\x60"=>"\xE5\x95\xBB",
		"\x9A\x61"=>"\xE5\x95\xBE",
		"\x9A\x62"=>"\xE5\x96\x98",
		"\x9A\x63"=>"\xE5\x96\x9E",
		"\x9A\x64"=>"\xE5\x96\xAE",
		"\x9A\x65"=>"\xE5\x95\xBC",
		"\x9A\x66"=>"\xE5\x96\x83",
		"\x9A\x67"=>"\xE5\x96\xA9",
		"\x9A\x68"=>"\xE5\x96\x87",
		"\x9A\x69"=>"\xE5\x96\xA8",
		"\x9A\x6A"=>"\xE5\x97\x9A",
		"\x9A\x6B"=>"\xE5\x97\x85",
		"\x9A\x6C"=>"\xE5\x97\x9F",
		"\x9A\x6D"=>"\xE5\x97\x84",
		"\x9A\x6E"=>"\xE5\x97\x9C",
		"\x9A\x6F"=>"\xE5\x97\xA4",
		"\x9A\x70"=>"\xE5\x97\x94",
		"\x9A\x71"=>"\xE5\x98\x94",
		"\x9A\x72"=>"\xE5\x97\xB7",
		"\x9A\x73"=>"\xE5\x98\x96",
		"\x9A\x74"=>"\xE5\x97\xBE",
		"\x9A\x75"=>"\xE5\x97\xBD",
		"\x9A\x76"=>"\xE5\x98\x9B",
		"\x9A\x77"=>"\xE5\x97\xB9",
		"\x9A\x78"=>"\xE5\x99\x8E",
		"\x9A\x79"=>"\xE5\x99\x90",
		"\x9A\x7A"=>"\xE7\x87\x9F",
		"\x9A\x7B"=>"\xE5\x98\xB4",
		"\x9A\x7C"=>"\xE5\x98\xB6",
		"\x9A\x7D"=>"\xE5\x98\xB2",
		"\x9A\x7E"=>"\xE5\x98\xB8",
		"\x9A\x80"=>"\xE5\x99\xAB",
		"\x9A\x81"=>"\xE5\x99\xA4",
		"\x9A\x82"=>"\xE5\x98\xAF",
		"\x9A\x83"=>"\xE5\x99\xAC",
		"\x9A\x84"=>"\xE5\x99\xAA",
		"\x9A\x85"=>"\xE5\x9A\x86",
		"\x9A\x86"=>"\xE5\x9A\x80",
		"\x9A\x87"=>"\xE5\x9A\x8A",
		"\x9A\x88"=>"\xE5\x9A\xA0",
		"\x9A\x89"=>"\xE5\x9A\x94",
		"\x9A\x8A"=>"\xE5\x9A\x8F",
		"\x9A\x8B"=>"\xE5\x9A\xA5",
		"\x9A\x8C"=>"\xE5\x9A\xAE",
		"\x9A\x8D"=>"\xE5\x9A\xB6",
		"\x9A\x8E"=>"\xE5\x9A\xB4",
		"\x9A\x8F"=>"\xE5\x9B\x82",
		"\x9A\x90"=>"\xE5\x9A\xBC",
		"\x9A\x91"=>"\xE5\x9B\x81",
		"\x9A\x92"=>"\xE5\x9B\x83",
		"\x9A\x93"=>"\xE5\x9B\x80",
		"\x9A\x94"=>"\xE5\x9B\x88",
		"\x9A\x95"=>"\xE5\x9B\x8E",
		"\x9A\x96"=>"\xE5\x9B\x91",
		"\x9A\x97"=>"\xE5\x9B\x93",
		"\x9A\x98"=>"\xE5\x9B\x97",
		"\x9A\x99"=>"\xE5\x9B\xAE",
		"\x9A\x9A"=>"\xE5\x9B\xB9",
		"\x9A\x9B"=>"\xE5\x9C\x80",
		"\x9A\x9C"=>"\xE5\x9B\xBF",
		"\x9A\x9D"=>"\xE5\x9C\x84",
		"\x9A\x9E"=>"\xE5\x9C\x89",
		"\x9A\x9F"=>"\xE5\x9C\x88",
		"\x9A\xA0"=>"\xE5\x9C\x8B",
		"\x9A\xA1"=>"\xE5\x9C\x8D",
		"\x9A\xA2"=>"\xE5\x9C\x93",
		"\x9A\xA3"=>"\xE5\x9C\x98",
		"\x9A\xA4"=>"\xE5\x9C\x96",
		"\x9A\xA5"=>"\xE5\x97\x87",
		"\x9A\xA6"=>"\xE5\x9C\x9C",
		"\x9A\xA7"=>"\xE5\x9C\xA6",
		"\x9A\xA8"=>"\xE5\x9C\xB7",
		"\x9A\xA9"=>"\xE5\x9C\xB8",
		"\x9A\xAA"=>"\xE5\x9D\x8E",
		"\x9A\xAB"=>"\xE5\x9C\xBB",
		"\x9A\xAC"=>"\xE5\x9D\x80",
		"\x9A\xAD"=>"\xE5\x9D\x8F",
		"\x9A\xAE"=>"\xE5\x9D\xA9",
		"\x9A\xAF"=>"\xE5\x9F\x80",
		"\x9A\xB0"=>"\xE5\x9E\x88",
		"\x9A\xB1"=>"\xE5\x9D\xA1",
		"\x9A\xB2"=>"\xE5\x9D\xBF",
		"\x9A\xB3"=>"\xE5\x9E\x89",
		"\x9A\xB4"=>"\xE5\x9E\x93",
		"\x9A\xB5"=>"\xE5\x9E\xA0",
		"\x9A\xB6"=>"\xE5\x9E\xB3",
		"\x9A\xB7"=>"\xE5\x9E\xA4",
		"\x9A\xB8"=>"\xE5\x9E\xAA",
		"\x9A\xB9"=>"\xE5\x9E\xB0",
		"\x9A\xBA"=>"\xE5\x9F\x83",
		"\x9A\xBB"=>"\xE5\x9F\x86",
		"\x9A\xBC"=>"\xE5\x9F\x94",
		"\x9A\xBD"=>"\xE5\x9F\x92",
		"\x9A\xBE"=>"\xE5\x9F\x93",
		"\x9A\xBF"=>"\xE5\xA0\x8A",
		"\x9A\xC0"=>"\xE5\x9F\x96",
		"\x9A\xC1"=>"\xE5\x9F\xA3",
		"\x9A\xC2"=>"\xE5\xA0\x8B",
		"\x9A\xC3"=>"\xE5\xA0\x99",
		"\x9A\xC4"=>"\xE5\xA0\x9D",
		"\x9A\xC5"=>"\xE5\xA1\xB2",
		"\x9A\xC6"=>"\xE5\xA0\xA1",
		"\x9A\xC7"=>"\xE5\xA1\xA2",
		"\x9A\xC8"=>"\xE5\xA1\x8B",
		"\x9A\xC9"=>"\xE5\xA1\xB0",
		"\x9A\xCA"=>"\xE6\xAF\x80",
		"\x9A\xCB"=>"\xE5\xA1\x92",
		"\x9A\xCC"=>"\xE5\xA0\xBD",
		"\x9A\xCD"=>"\xE5\xA1\xB9",
		"\x9A\xCE"=>"\xE5\xA2\x85",
		"\x9A\xCF"=>"\xE5\xA2\xB9",
		"\x9A\xD0"=>"\xE5\xA2\x9F",
		"\x9A\xD1"=>"\xE5\xA2\xAB",
		"\x9A\xD2"=>"\xE5\xA2\xBA",
		"\x9A\xD3"=>"\xE5\xA3\x9E",
		"\x9A\xD4"=>"\xE5\xA2\xBB",
		"\x9A\xD5"=>"\xE5\xA2\xB8",
		"\x9A\xD6"=>"\xE5\xA2\xAE",
		"\x9A\xD7"=>"\xE5\xA3\x85",
		"\x9A\xD8"=>"\xE5\xA3\x93",
		"\x9A\xD9"=>"\xE5\xA3\x91",
		"\x9A\xDA"=>"\xE5\xA3\x97",
		"\x9A\xDB"=>"\xE5\xA3\x99",
		"\x9A\xDC"=>"\xE5\xA3\x98",
		"\x9A\xDD"=>"\xE5\xA3\xA5",
		"\x9A\xDE"=>"\xE5\xA3\x9C",
		"\x9A\xDF"=>"\xE5\xA3\xA4",
		"\x9A\xE0"=>"\xE5\xA3\x9F",
		"\x9A\xE1"=>"\xE5\xA3\xAF",
		"\x9A\xE2"=>"\xE5\xA3\xBA",
		"\x9A\xE3"=>"\xE5\xA3\xB9",
		"\x9A\xE4"=>"\xE5\xA3\xBB",
		"\x9A\xE5"=>"\xE5\xA3\xBC",
		"\x9A\xE6"=>"\xE5\xA3\xBD",
		"\x9A\xE7"=>"\xE5\xA4\x82",
		"\x9A\xE8"=>"\xE5\xA4\x8A",
		"\x9A\xE9"=>"\xE5\xA4\x90",
		"\x9A\xEA"=>"\xE5\xA4\x9B",
		"\x9A\xEB"=>"\xE6\xA2\xA6",
		"\x9A\xEC"=>"\xE5\xA4\xA5",
		"\x9A\xED"=>"\xE5\xA4\xAC",
		"\x9A\xEE"=>"\xE5\xA4\xAD",
		"\x9A\xEF"=>"\xE5\xA4\xB2",
		"\x9A\xF0"=>"\xE5\xA4\xB8",
		"\x9A\xF1"=>"\xE5\xA4\xBE",
		"\x9A\xF2"=>"\xE7\xAB\x92",
		"\x9A\xF3"=>"\xE5\xA5\x95",
		"\x9A\xF4"=>"\xE5\xA5\x90",
		"\x9A\xF5"=>"\xE5\xA5\x8E",
		"\x9A\xF6"=>"\xE5\xA5\x9A",
		"\x9A\xF7"=>"\xE5\xA5\x98",
		"\x9A\xF8"=>"\xE5\xA5\xA2",
		"\x9A\xF9"=>"\xE5\xA5\xA0",
		"\x9A\xFA"=>"\xE5\xA5\xA7",
		"\x9A\xFB"=>"\xE5\xA5\xAC",
		"\x9A\xFC"=>"\xE5\xA5\xA9",
		"\x9B\x40"=>"\xE5\xA5\xB8",
		"\x9B\x41"=>"\xE5\xA6\x81",
		"\x9B\x42"=>"\xE5\xA6\x9D",
		"\x9B\x43"=>"\xE4\xBD\x9E",
		"\x9B\x44"=>"\xE4\xBE\xAB",
		"\x9B\x45"=>"\xE5\xA6\xA3",
		"\x9B\x46"=>"\xE5\xA6\xB2",
		"\x9B\x47"=>"\xE5\xA7\x86",
		"\x9B\x48"=>"\xE5\xA7\xA8",
		"\x9B\x49"=>"\xE5\xA7\x9C",
		"\x9B\x4A"=>"\xE5\xA6\x8D",
		"\x9B\x4B"=>"\xE5\xA7\x99",
		"\x9B\x4C"=>"\xE5\xA7\x9A",
		"\x9B\x4D"=>"\xE5\xA8\xA5",
		"\x9B\x4E"=>"\xE5\xA8\x9F",
		"\x9B\x4F"=>"\xE5\xA8\x91",
		"\x9B\x50"=>"\xE5\xA8\x9C",
		"\x9B\x51"=>"\xE5\xA8\x89",
		"\x9B\x52"=>"\xE5\xA8\x9A",
		"\x9B\x53"=>"\xE5\xA9\x80",
		"\x9B\x54"=>"\xE5\xA9\xAC",
		"\x9B\x55"=>"\xE5\xA9\x89",
		"\x9B\x56"=>"\xE5\xA8\xB5",
		"\x9B\x57"=>"\xE5\xA8\xB6",
		"\x9B\x58"=>"\xE5\xA9\xA2",
		"\x9B\x59"=>"\xE5\xA9\xAA",
		"\x9B\x5A"=>"\xE5\xAA\x9A",
		"\x9B\x5B"=>"\xE5\xAA\xBC",
		"\x9B\x5C"=>"\xE5\xAA\xBE",
		"\x9B\x5D"=>"\xE5\xAB\x8B",
		"\x9B\x5E"=>"\xE5\xAB\x82",
		"\x9B\x5F"=>"\xE5\xAA\xBD",
		"\x9B\x60"=>"\xE5\xAB\xA3",
		"\x9B\x61"=>"\xE5\xAB\x97",
		"\x9B\x62"=>"\xE5\xAB\xA6",
		"\x9B\x63"=>"\xE5\xAB\xA9",
		"\x9B\x64"=>"\xE5\xAB\x96",
		"\x9B\x65"=>"\xE5\xAB\xBA",
		"\x9B\x66"=>"\xE5\xAB\xBB",
		"\x9B\x67"=>"\xE5\xAC\x8C",
		"\x9B\x68"=>"\xE5\xAC\x8B",
		"\x9B\x69"=>"\xE5\xAC\x96",
		"\x9B\x6A"=>"\xE5\xAC\xB2",
		"\x9B\x6B"=>"\xE5\xAB\x90",
		"\x9B\x6C"=>"\xE5\xAC\xAA",
		"\x9B\x6D"=>"\xE5\xAC\xB6",
		"\x9B\x6E"=>"\xE5\xAC\xBE",
		"\x9B\x6F"=>"\xE5\xAD\x83",
		"\x9B\x70"=>"\xE5\xAD\x85",
		"\x9B\x71"=>"\xE5\xAD\x80",
		"\x9B\x72"=>"\xE5\xAD\x91",
		"\x9B\x73"=>"\xE5\xAD\x95",
		"\x9B\x74"=>"\xE5\xAD\x9A",
		"\x9B\x75"=>"\xE5\xAD\x9B",
		"\x9B\x76"=>"\xE5\xAD\xA5",
		"\x9B\x77"=>"\xE5\xAD\xA9",
		"\x9B\x78"=>"\xE5\xAD\xB0",
		"\x9B\x79"=>"\xE5\xAD\xB3",
		"\x9B\x7A"=>"\xE5\xAD\xB5",
		"\x9B\x7B"=>"\xE5\xAD\xB8",
		"\x9B\x7C"=>"\xE6\x96\x88",
		"\x9B\x7D"=>"\xE5\xAD\xBA",
		"\x9B\x7E"=>"\xE5\xAE\x80",
		"\x9B\x80"=>"\xE5\xAE\x83",
		"\x9B\x81"=>"\xE5\xAE\xA6",
		"\x9B\x82"=>"\xE5\xAE\xB8",
		"\x9B\x83"=>"\xE5\xAF\x83",
		"\x9B\x84"=>"\xE5\xAF\x87",
		"\x9B\x85"=>"\xE5\xAF\x89",
		"\x9B\x86"=>"\xE5\xAF\x94",
		"\x9B\x87"=>"\xE5\xAF\x90",
		"\x9B\x88"=>"\xE5\xAF\xA4",
		"\x9B\x89"=>"\xE5\xAF\xA6",
		"\x9B\x8A"=>"\xE5\xAF\xA2",
		"\x9B\x8B"=>"\xE5\xAF\x9E",
		"\x9B\x8C"=>"\xE5\xAF\xA5",
		"\x9B\x8D"=>"\xE5\xAF\xAB",
		"\x9B\x8E"=>"\xE5\xAF\xB0",
		"\x9B\x8F"=>"\xE5\xAF\xB6",
		"\x9B\x90"=>"\xE5\xAF\xB3",
		"\x9B\x91"=>"\xE5\xB0\x85",
		"\x9B\x92"=>"\xE5\xB0\x87",
		"\x9B\x93"=>"\xE5\xB0\x88",
		"\x9B\x94"=>"\xE5\xB0\x8D",
		"\x9B\x95"=>"\xE5\xB0\x93",
		"\x9B\x96"=>"\xE5\xB0\xA0",
		"\x9B\x97"=>"\xE5\xB0\xA2",
		"\x9B\x98"=>"\xE5\xB0\xA8",
		"\x9B\x99"=>"\xE5\xB0\xB8",
		"\x9B\x9A"=>"\xE5\xB0\xB9",
		"\x9B\x9B"=>"\xE5\xB1\x81",
		"\x9B\x9C"=>"\xE5\xB1\x86",
		"\x9B\x9D"=>"\xE5\xB1\x8E",
		"\x9B\x9E"=>"\xE5\xB1\x93",
		"\x9B\x9F"=>"\xE5\xB1\x90",
		"\x9B\xA0"=>"\xE5\xB1\x8F",
		"\x9B\xA1"=>"\xE5\xAD\xB1",
		"\x9B\xA2"=>"\xE5\xB1\xAC",
		"\x9B\xA3"=>"\xE5\xB1\xAE",
		"\x9B\xA4"=>"\xE4\xB9\xA2",
		"\x9B\xA5"=>"\xE5\xB1\xB6",
		"\x9B\xA6"=>"\xE5\xB1\xB9",
		"\x9B\xA7"=>"\xE5\xB2\x8C",
		"\x9B\xA8"=>"\xE5\xB2\x91",
		"\x9B\xA9"=>"\xE5\xB2\x94",
		"\x9B\xAA"=>"\xE5\xA6\x9B",
		"\x9B\xAB"=>"\xE5\xB2\xAB",
		"\x9B\xAC"=>"\xE5\xB2\xBB",
		"\x9B\xAD"=>"\xE5\xB2\xB6",
		"\x9B\xAE"=>"\xE5\xB2\xBC",
		"\x9B\xAF"=>"\xE5\xB2\xB7",
		"\x9B\xB0"=>"\xE5\xB3\x85",
		"\x9B\xB1"=>"\xE5\xB2\xBE",
		"\x9B\xB2"=>"\xE5\xB3\x87",
		"\x9B\xB3"=>"\xE5\xB3\x99",
		"\x9B\xB4"=>"\xE5\xB3\xA9",
		"\x9B\xB5"=>"\xE5\xB3\xBD",
		"\x9B\xB6"=>"\xE5\xB3\xBA",
		"\x9B\xB7"=>"\xE5\xB3\xAD",
		"\x9B\xB8"=>"\xE5\xB6\x8C",
		"\x9B\xB9"=>"\xE5\xB3\xAA",
		"\x9B\xBA"=>"\xE5\xB4\x8B",
		"\x9B\xBB"=>"\xE5\xB4\x95",
		"\x9B\xBC"=>"\xE5\xB4\x97",
		"\x9B\xBD"=>"\xE5\xB5\x9C",
		"\x9B\xBE"=>"\xE5\xB4\x9F",
		"\x9B\xBF"=>"\xE5\xB4\x9B",
		"\x9B\xC0"=>"\xE5\xB4\x91",
		"\x9B\xC1"=>"\xE5\xB4\x94",
		"\x9B\xC2"=>"\xE5\xB4\xA2",
		"\x9B\xC3"=>"\xE5\xB4\x9A",
		"\x9B\xC4"=>"\xE5\xB4\x99",
		"\x9B\xC5"=>"\xE5\xB4\x98",
		"\x9B\xC6"=>"\xE5\xB5\x8C",
		"\x9B\xC7"=>"\xE5\xB5\x92",
		"\x9B\xC8"=>"\xE5\xB5\x8E",
		"\x9B\xC9"=>"\xE5\xB5\x8B",
		"\x9B\xCA"=>"\xE5\xB5\xAC",
		"\x9B\xCB"=>"\xE5\xB5\xB3",
		"\x9B\xCC"=>"\xE5\xB5\xB6",
		"\x9B\xCD"=>"\xE5\xB6\x87",
		"\x9B\xCE"=>"\xE5\xB6\x84",
		"\x9B\xCF"=>"\xE5\xB6\x82",
		"\x9B\xD0"=>"\xE5\xB6\xA2",
		"\x9B\xD1"=>"\xE5\xB6\x9D",
		"\x9B\xD2"=>"\xE5\xB6\xAC",
		"\x9B\xD3"=>"\xE5\xB6\xAE",
		"\x9B\xD4"=>"\xE5\xB6\xBD",
		"\x9B\xD5"=>"\xE5\xB6\x90",
		"\x9B\xD6"=>"\xE5\xB6\xB7",
		"\x9B\xD7"=>"\xE5\xB6\xBC",
		"\x9B\xD8"=>"\xE5\xB7\x89",
		"\x9B\xD9"=>"\xE5\xB7\x8D",
		"\x9B\xDA"=>"\xE5\xB7\x93",
		"\x9B\xDB"=>"\xE5\xB7\x92",
		"\x9B\xDC"=>"\xE5\xB7\x96",
		"\x9B\xDD"=>"\xE5\xB7\x9B",
		"\x9B\xDE"=>"\xE5\xB7\xAB",
		"\x9B\xDF"=>"\xE5\xB7\xB2",
		"\x9B\xE0"=>"\xE5\xB7\xB5",
		"\x9B\xE1"=>"\xE5\xB8\x8B",
		"\x9B\xE2"=>"\xE5\xB8\x9A",
		"\x9B\xE3"=>"\xE5\xB8\x99",
		"\x9B\xE4"=>"\xE5\xB8\x91",
		"\x9B\xE5"=>"\xE5\xB8\x9B",
		"\x9B\xE6"=>"\xE5\xB8\xB6",
		"\x9B\xE7"=>"\xE5\xB8\xB7",
		"\x9B\xE8"=>"\xE5\xB9\x84",
		"\x9B\xE9"=>"\xE5\xB9\x83",
		"\x9B\xEA"=>"\xE5\xB9\x80",
		"\x9B\xEB"=>"\xE5\xB9\x8E",
		"\x9B\xEC"=>"\xE5\xB9\x97",
		"\x9B\xED"=>"\xE5\xB9\x94",
		"\x9B\xEE"=>"\xE5\xB9\x9F",
		"\x9B\xEF"=>"\xE5\xB9\xA2",
		"\x9B\xF0"=>"\xE5\xB9\xA4",
		"\x9B\xF1"=>"\xE5\xB9\x87",
		"\x9B\xF2"=>"\xE5\xB9\xB5",
		"\x9B\xF3"=>"\xE5\xB9\xB6",
		"\x9B\xF4"=>"\xE5\xB9\xBA",
		"\x9B\xF5"=>"\xE9\xBA\xBC",
		"\x9B\xF6"=>"\xE5\xB9\xBF",
		"\x9B\xF7"=>"\xE5\xBA\xA0",
		"\x9B\xF8"=>"\xE5\xBB\x81",
		"\x9B\xF9"=>"\xE5\xBB\x82",
		"\x9B\xFA"=>"\xE5\xBB\x88",
		"\x9B\xFB"=>"\xE5\xBB\x90",
		"\x9B\xFC"=>"\xE5\xBB\x8F",
		"\x9C\x40"=>"\xE5\xBB\x96",
		"\x9C\x41"=>"\xE5\xBB\xA3",
		"\x9C\x42"=>"\xE5\xBB\x9D",
		"\x9C\x43"=>"\xE5\xBB\x9A",
		"\x9C\x44"=>"\xE5\xBB\x9B",
		"\x9C\x45"=>"\xE5\xBB\xA2",
		"\x9C\x46"=>"\xE5\xBB\xA1",
		"\x9C\x47"=>"\xE5\xBB\xA8",
		"\x9C\x48"=>"\xE5\xBB\xA9",
		"\x9C\x49"=>"\xE5\xBB\xAC",
		"\x9C\x4A"=>"\xE5\xBB\xB1",
		"\x9C\x4B"=>"\xE5\xBB\xB3",
		"\x9C\x4C"=>"\xE5\xBB\xB0",
		"\x9C\x4D"=>"\xE5\xBB\xB4",
		"\x9C\x4E"=>"\xE5\xBB\xB8",
		"\x9C\x4F"=>"\xE5\xBB\xBE",
		"\x9C\x50"=>"\xE5\xBC\x83",
		"\x9C\x51"=>"\xE5\xBC\x89",
		"\x9C\x52"=>"\xE5\xBD\x9D",
		"\x9C\x53"=>"\xE5\xBD\x9C",
		"\x9C\x54"=>"\xE5\xBC\x8B",
		"\x9C\x55"=>"\xE5\xBC\x91",
		"\x9C\x56"=>"\xE5\xBC\x96",
		"\x9C\x57"=>"\xE5\xBC\xA9",
		"\x9C\x58"=>"\xE5\xBC\xAD",
		"\x9C\x59"=>"\xE5\xBC\xB8",
		"\x9C\x5A"=>"\xE5\xBD\x81",
		"\x9C\x5B"=>"\xE5\xBD\x88",
		"\x9C\x5C"=>"\xE5\xBD\x8C",
		"\x9C\x5D"=>"\xE5\xBD\x8E",
		"\x9C\x5E"=>"\xE5\xBC\xAF",
		"\x9C\x5F"=>"\xE5\xBD\x91",
		"\x9C\x60"=>"\xE5\xBD\x96",
		"\x9C\x61"=>"\xE5\xBD\x97",
		"\x9C\x62"=>"\xE5\xBD\x99",
		"\x9C\x63"=>"\xE5\xBD\xA1",
		"\x9C\x64"=>"\xE5\xBD\xAD",
		"\x9C\x65"=>"\xE5\xBD\xB3",
		"\x9C\x66"=>"\xE5\xBD\xB7",
		"\x9C\x67"=>"\xE5\xBE\x83",
		"\x9C\x68"=>"\xE5\xBE\x82",
		"\x9C\x69"=>"\xE5\xBD\xBF",
		"\x9C\x6A"=>"\xE5\xBE\x8A",
		"\x9C\x6B"=>"\xE5\xBE\x88",
		"\x9C\x6C"=>"\xE5\xBE\x91",
		"\x9C\x6D"=>"\xE5\xBE\x87",
		"\x9C\x6E"=>"\xE5\xBE\x9E",
		"\x9C\x6F"=>"\xE5\xBE\x99",
		"\x9C\x70"=>"\xE5\xBE\x98",
		"\x9C\x71"=>"\xE5\xBE\xA0",
		"\x9C\x72"=>"\xE5\xBE\xA8",
		"\x9C\x73"=>"\xE5\xBE\xAD",
		"\x9C\x74"=>"\xE5\xBE\xBC",
		"\x9C\x75"=>"\xE5\xBF\x96",
		"\x9C\x76"=>"\xE5\xBF\xBB",
		"\x9C\x77"=>"\xE5\xBF\xA4",
		"\x9C\x78"=>"\xE5\xBF\xB8",
		"\x9C\x79"=>"\xE5\xBF\xB1",
		"\x9C\x7A"=>"\xE5\xBF\x9D",
		"\x9C\x7B"=>"\xE6\x82\xB3",
		"\x9C\x7C"=>"\xE5\xBF\xBF",
		"\x9C\x7D"=>"\xE6\x80\xA1",
		"\x9C\x7E"=>"\xE6\x81\xA0",
		"\x9C\x80"=>"\xE6\x80\x99",
		"\x9C\x81"=>"\xE6\x80\x90",
		"\x9C\x82"=>"\xE6\x80\xA9",
		"\x9C\x83"=>"\xE6\x80\x8E",
		"\x9C\x84"=>"\xE6\x80\xB1",
		"\x9C\x85"=>"\xE6\x80\x9B",
		"\x9C\x86"=>"\xE6\x80\x95",
		"\x9C\x87"=>"\xE6\x80\xAB",
		"\x9C\x88"=>"\xE6\x80\xA6",
		"\x9C\x89"=>"\xE6\x80\x8F",
		"\x9C\x8A"=>"\xE6\x80\xBA",
		"\x9C\x8B"=>"\xE6\x81\x9A",
		"\x9C\x8C"=>"\xE6\x81\x81",
		"\x9C\x8D"=>"\xE6\x81\xAA",
		"\x9C\x8E"=>"\xE6\x81\xB7",
		"\x9C\x8F"=>"\xE6\x81\x9F",
		"\x9C\x90"=>"\xE6\x81\x8A",
		"\x9C\x91"=>"\xE6\x81\x86",
		"\x9C\x92"=>"\xE6\x81\x8D",
		"\x9C\x93"=>"\xE6\x81\xA3",
		"\x9C\x94"=>"\xE6\x81\x83",
		"\x9C\x95"=>"\xE6\x81\xA4",
		"\x9C\x96"=>"\xE6\x81\x82",
		"\x9C\x97"=>"\xE6\x81\xAC",
		"\x9C\x98"=>"\xE6\x81\xAB",
		"\x9C\x99"=>"\xE6\x81\x99",
		"\x9C\x9A"=>"\xE6\x82\x81",
		"\x9C\x9B"=>"\xE6\x82\x8D",
		"\x9C\x9C"=>"\xE6\x83\xA7",
		"\x9C\x9D"=>"\xE6\x82\x83",
		"\x9C\x9E"=>"\xE6\x82\x9A",
		"\x9C\x9F"=>"\xE6\x82\x84",
		"\x9C\xA0"=>"\xE6\x82\x9B",
		"\x9C\xA1"=>"\xE6\x82\x96",
		"\x9C\xA2"=>"\xE6\x82\x97",
		"\x9C\xA3"=>"\xE6\x82\x92",
		"\x9C\xA4"=>"\xE6\x82\xA7",
		"\x9C\xA5"=>"\xE6\x82\x8B",
		"\x9C\xA6"=>"\xE6\x83\xA1",
		"\x9C\xA7"=>"\xE6\x82\xB8",
		"\x9C\xA8"=>"\xE6\x83\xA0",
		"\x9C\xA9"=>"\xE6\x83\x93",
		"\x9C\xAA"=>"\xE6\x82\xB4",
		"\x9C\xAB"=>"\xE5\xBF\xB0",
		"\x9C\xAC"=>"\xE6\x82\xBD",
		"\x9C\xAD"=>"\xE6\x83\x86",
		"\x9C\xAE"=>"\xE6\x82\xB5",
		"\x9C\xAF"=>"\xE6\x83\x98",
		"\x9C\xB0"=>"\xE6\x85\x8D",
		"\x9C\xB1"=>"\xE6\x84\x95",
		"\x9C\xB2"=>"\xE6\x84\x86",
		"\x9C\xB3"=>"\xE6\x83\xB6",
		"\x9C\xB4"=>"\xE6\x83\xB7",
		"\x9C\xB5"=>"\xE6\x84\x80",
		"\x9C\xB6"=>"\xE6\x83\xB4",
		"\x9C\xB7"=>"\xE6\x83\xBA",
		"\x9C\xB8"=>"\xE6\x84\x83",
		"\x9C\xB9"=>"\xE6\x84\xA1",
		"\x9C\xBA"=>"\xE6\x83\xBB",
		"\x9C\xBB"=>"\xE6\x83\xB1",
		"\x9C\xBC"=>"\xE6\x84\x8D",
		"\x9C\xBD"=>"\xE6\x84\x8E",
		"\x9C\xBE"=>"\xE6\x85\x87",
		"\x9C\xBF"=>"\xE6\x84\xBE",
		"\x9C\xC0"=>"\xE6\x84\xA8",
		"\x9C\xC1"=>"\xE6\x84\xA7",
		"\x9C\xC2"=>"\xE6\x85\x8A",
		"\x9C\xC3"=>"\xE6\x84\xBF",
		"\x9C\xC4"=>"\xE6\x84\xBC",
		"\x9C\xC5"=>"\xE6\x84\xAC",
		"\x9C\xC6"=>"\xE6\x84\xB4",
		"\x9C\xC7"=>"\xE6\x84\xBD",
		"\x9C\xC8"=>"\xE6\x85\x82",
		"\x9C\xC9"=>"\xE6\x85\x84",
		"\x9C\xCA"=>"\xE6\x85\xB3",
		"\x9C\xCB"=>"\xE6\x85\xB7",
		"\x9C\xCC"=>"\xE6\x85\x98",
		"\x9C\xCD"=>"\xE6\x85\x99",
		"\x9C\xCE"=>"\xE6\x85\x9A",
		"\x9C\xCF"=>"\xE6\x85\xAB",
		"\x9C\xD0"=>"\xE6\x85\xB4",
		"\x9C\xD1"=>"\xE6\x85\xAF",
		"\x9C\xD2"=>"\xE6\x85\xA5",
		"\x9C\xD3"=>"\xE6\x85\xB1",
		"\x9C\xD4"=>"\xE6\x85\x9F",
		"\x9C\xD5"=>"\xE6\x85\x9D",
		"\x9C\xD6"=>"\xE6\x85\x93",
		"\x9C\xD7"=>"\xE6\x85\xB5",
		"\x9C\xD8"=>"\xE6\x86\x99",
		"\x9C\xD9"=>"\xE6\x86\x96",
		"\x9C\xDA"=>"\xE6\x86\x87",
		"\x9C\xDB"=>"\xE6\x86\xAC",
		"\x9C\xDC"=>"\xE6\x86\x94",
		"\x9C\xDD"=>"\xE6\x86\x9A",
		"\x9C\xDE"=>"\xE6\x86\x8A",
		"\x9C\xDF"=>"\xE6\x86\x91",
		"\x9C\xE0"=>"\xE6\x86\xAB",
		"\x9C\xE1"=>"\xE6\x86\xAE",
		"\x9C\xE2"=>"\xE6\x87\x8C",
		"\x9C\xE3"=>"\xE6\x87\x8A",
		"\x9C\xE4"=>"\xE6\x87\x89",
		"\x9C\xE5"=>"\xE6\x87\xB7",
		"\x9C\xE6"=>"\xE6\x87\x88",
		"\x9C\xE7"=>"\xE6\x87\x83",
		"\x9C\xE8"=>"\xE6\x87\x86",
		"\x9C\xE9"=>"\xE6\x86\xBA",
		"\x9C\xEA"=>"\xE6\x87\x8B",
		"\x9C\xEB"=>"\xE7\xBD\xB9",
		"\x9C\xEC"=>"\xE6\x87\x8D",
		"\x9C\xED"=>"\xE6\x87\xA6",
		"\x9C\xEE"=>"\xE6\x87\xA3",
		"\x9C\xEF"=>"\xE6\x87\xB6",
		"\x9C\xF0"=>"\xE6\x87\xBA",
		"\x9C\xF1"=>"\xE6\x87\xB4",
		"\x9C\xF2"=>"\xE6\x87\xBF",
		"\x9C\xF3"=>"\xE6\x87\xBD",
		"\x9C\xF4"=>"\xE6\x87\xBC",
		"\x9C\xF5"=>"\xE6\x87\xBE",
		"\x9C\xF6"=>"\xE6\x88\x80",
		"\x9C\xF7"=>"\xE6\x88\x88",
		"\x9C\xF8"=>"\xE6\x88\x89",
		"\x9C\xF9"=>"\xE6\x88\x8D",
		"\x9C\xFA"=>"\xE6\x88\x8C",
		"\x9C\xFB"=>"\xE6\x88\x94",
		"\x9C\xFC"=>"\xE6\x88\x9B",
		"\x9D\x40"=>"\xE6\x88\x9E",
		"\x9D\x41"=>"\xE6\x88\xA1",
		"\x9D\x42"=>"\xE6\x88\xAA",
		"\x9D\x43"=>"\xE6\x88\xAE",
		"\x9D\x44"=>"\xE6\x88\xB0",
		"\x9D\x45"=>"\xE6\x88\xB2",
		"\x9D\x46"=>"\xE6\x88\xB3",
		"\x9D\x47"=>"\xE6\x89\x81",
		"\x9D\x48"=>"\xE6\x89\x8E",
		"\x9D\x49"=>"\xE6\x89\x9E",
		"\x9D\x4A"=>"\xE6\x89\xA3",
		"\x9D\x4B"=>"\xE6\x89\x9B",
		"\x9D\x4C"=>"\xE6\x89\xA0",
		"\x9D\x4D"=>"\xE6\x89\xA8",
		"\x9D\x4E"=>"\xE6\x89\xBC",
		"\x9D\x4F"=>"\xE6\x8A\x82",
		"\x9D\x50"=>"\xE6\x8A\x89",
		"\x9D\x51"=>"\xE6\x89\xBE",
		"\x9D\x52"=>"\xE6\x8A\x92",
		"\x9D\x53"=>"\xE6\x8A\x93",
		"\x9D\x54"=>"\xE6\x8A\x96",
		"\x9D\x55"=>"\xE6\x8B\x94",
		"\x9D\x56"=>"\xE6\x8A\x83",
		"\x9D\x57"=>"\xE6\x8A\x94",
		"\x9D\x58"=>"\xE6\x8B\x97",
		"\x9D\x59"=>"\xE6\x8B\x91",
		"\x9D\x5A"=>"\xE6\x8A\xBB",
		"\x9D\x5B"=>"\xE6\x8B\x8F",
		"\x9D\x5C"=>"\xE6\x8B\xBF",
		"\x9D\x5D"=>"\xE6\x8B\x86",
		"\x9D\x5E"=>"\xE6\x93\x94",
		"\x9D\x5F"=>"\xE6\x8B\x88",
		"\x9D\x60"=>"\xE6\x8B\x9C",
		"\x9D\x61"=>"\xE6\x8B\x8C",
		"\x9D\x62"=>"\xE6\x8B\x8A",
		"\x9D\x63"=>"\xE6\x8B\x82",
		"\x9D\x64"=>"\xE6\x8B\x87",
		"\x9D\x65"=>"\xE6\x8A\x9B",
		"\x9D\x66"=>"\xE6\x8B\x89",
		"\x9D\x67"=>"\xE6\x8C\x8C",
		"\x9D\x68"=>"\xE6\x8B\xAE",
		"\x9D\x69"=>"\xE6\x8B\xB1",
		"\x9D\x6A"=>"\xE6\x8C\xA7",
		"\x9D\x6B"=>"\xE6\x8C\x82",
		"\x9D\x6C"=>"\xE6\x8C\x88",
		"\x9D\x6D"=>"\xE6\x8B\xAF",
		"\x9D\x6E"=>"\xE6\x8B\xB5",
		"\x9D\x6F"=>"\xE6\x8D\x90",
		"\x9D\x70"=>"\xE6\x8C\xBE",
		"\x9D\x71"=>"\xE6\x8D\x8D",
		"\x9D\x72"=>"\xE6\x90\x9C",
		"\x9D\x73"=>"\xE6\x8D\x8F",
		"\x9D\x74"=>"\xE6\x8E\x96",
		"\x9D\x75"=>"\xE6\x8E\x8E",
		"\x9D\x76"=>"\xE6\x8E\x80",
		"\x9D\x77"=>"\xE6\x8E\xAB",
		"\x9D\x78"=>"\xE6\x8D\xB6",
		"\x9D\x79"=>"\xE6\x8E\xA3",
		"\x9D\x7A"=>"\xE6\x8E\x8F",
		"\x9D\x7B"=>"\xE6\x8E\x89",
		"\x9D\x7C"=>"\xE6\x8E\x9F",
		"\x9D\x7D"=>"\xE6\x8E\xB5",
		"\x9D\x7E"=>"\xE6\x8D\xAB",
		"\x9D\x80"=>"\xE6\x8D\xA9",
		"\x9D\x81"=>"\xE6\x8E\xBE",
		"\x9D\x82"=>"\xE6\x8F\xA9",
		"\x9D\x83"=>"\xE6\x8F\x80",
		"\x9D\x84"=>"\xE6\x8F\x86",
		"\x9D\x85"=>"\xE6\x8F\xA3",
		"\x9D\x86"=>"\xE6\x8F\x89",
		"\x9D\x87"=>"\xE6\x8F\x92",
		"\x9D\x88"=>"\xE6\x8F\xB6",
		"\x9D\x89"=>"\xE6\x8F\x84",
		"\x9D\x8A"=>"\xE6\x90\x96",
		"\x9D\x8B"=>"\xE6\x90\xB4",
		"\x9D\x8C"=>"\xE6\x90\x86",
		"\x9D\x8D"=>"\xE6\x90\x93",
		"\x9D\x8E"=>"\xE6\x90\xA6",
		"\x9D\x8F"=>"\xE6\x90\xB6",
		"\x9D\x90"=>"\xE6\x94\x9D",
		"\x9D\x91"=>"\xE6\x90\x97",
		"\x9D\x92"=>"\xE6\x90\xA8",
		"\x9D\x93"=>"\xE6\x90\x8F",
		"\x9D\x94"=>"\xE6\x91\xA7",
		"\x9D\x95"=>"\xE6\x91\xAF",
		"\x9D\x96"=>"\xE6\x91\xB6",
		"\x9D\x97"=>"\xE6\x91\x8E",
		"\x9D\x98"=>"\xE6\x94\xAA",
		"\x9D\x99"=>"\xE6\x92\x95",
		"\x9D\x9A"=>"\xE6\x92\x93",
		"\x9D\x9B"=>"\xE6\x92\xA5",
		"\x9D\x9C"=>"\xE6\x92\xA9",
		"\x9D\x9D"=>"\xE6\x92\x88",
		"\x9D\x9E"=>"\xE6\x92\xBC",
		"\x9D\x9F"=>"\xE6\x93\x9A",
		"\x9D\xA0"=>"\xE6\x93\x92",
		"\x9D\xA1"=>"\xE6\x93\x85",
		"\x9D\xA2"=>"\xE6\x93\x87",
		"\x9D\xA3"=>"\xE6\x92\xBB",
		"\x9D\xA4"=>"\xE6\x93\x98",
		"\x9D\xA5"=>"\xE6\x93\x82",
		"\x9D\xA6"=>"\xE6\x93\xB1",
		"\x9D\xA7"=>"\xE6\x93\xA7",
		"\x9D\xA8"=>"\xE8\x88\x89",
		"\x9D\xA9"=>"\xE6\x93\xA0",
		"\x9D\xAA"=>"\xE6\x93\xA1",
		"\x9D\xAB"=>"\xE6\x8A\xAC",
		"\x9D\xAC"=>"\xE6\x93\xA3",
		"\x9D\xAD"=>"\xE6\x93\xAF",
		"\x9D\xAE"=>"\xE6\x94\xAC",
		"\x9D\xAF"=>"\xE6\x93\xB6",
		"\x9D\xB0"=>"\xE6\x93\xB4",
		"\x9D\xB1"=>"\xE6\x93\xB2",
		"\x9D\xB2"=>"\xE6\x93\xBA",
		"\x9D\xB3"=>"\xE6\x94\x80",
		"\x9D\xB4"=>"\xE6\x93\xBD",
		"\x9D\xB5"=>"\xE6\x94\x98",
		"\x9D\xB6"=>"\xE6\x94\x9C",
		"\x9D\xB7"=>"\xE6\x94\x85",
		"\x9D\xB8"=>"\xE6\x94\xA4",
		"\x9D\xB9"=>"\xE6\x94\xA3",
		"\x9D\xBA"=>"\xE6\x94\xAB",
		"\x9D\xBB"=>"\xE6\x94\xB4",
		"\x9D\xBC"=>"\xE6\x94\xB5",
		"\x9D\xBD"=>"\xE6\x94\xB7",
		"\x9D\xBE"=>"\xE6\x94\xB6",
		"\x9D\xBF"=>"\xE6\x94\xB8",
		"\x9D\xC0"=>"\xE7\x95\x8B",
		"\x9D\xC1"=>"\xE6\x95\x88",
		"\x9D\xC2"=>"\xE6\x95\x96",
		"\x9D\xC3"=>"\xE6\x95\x95",
		"\x9D\xC4"=>"\xE6\x95\x8D",
		"\x9D\xC5"=>"\xE6\x95\x98",
		"\x9D\xC6"=>"\xE6\x95\x9E",
		"\x9D\xC7"=>"\xE6\x95\x9D",
		"\x9D\xC8"=>"\xE6\x95\xB2",
		"\x9D\xC9"=>"\xE6\x95\xB8",
		"\x9D\xCA"=>"\xE6\x96\x82",
		"\x9D\xCB"=>"\xE6\x96\x83",
		"\x9D\xCC"=>"\xE8\xAE\x8A",
		"\x9D\xCD"=>"\xE6\x96\x9B",
		"\x9D\xCE"=>"\xE6\x96\x9F",
		"\x9D\xCF"=>"\xE6\x96\xAB",
		"\x9D\xD0"=>"\xE6\x96\xB7",
		"\x9D\xD1"=>"\xE6\x97\x83",
		"\x9D\xD2"=>"\xE6\x97\x86",
		"\x9D\xD3"=>"\xE6\x97\x81",
		"\x9D\xD4"=>"\xE6\x97\x84",
		"\x9D\xD5"=>"\xE6\x97\x8C",
		"\x9D\xD6"=>"\xE6\x97\x92",
		"\x9D\xD7"=>"\xE6\x97\x9B",
		"\x9D\xD8"=>"\xE6\x97\x99",
		"\x9D\xD9"=>"\xE6\x97\xA0",
		"\x9D\xDA"=>"\xE6\x97\xA1",
		"\x9D\xDB"=>"\xE6\x97\xB1",
		"\x9D\xDC"=>"\xE6\x9D\xB2",
		"\x9D\xDD"=>"\xE6\x98\x8A",
		"\x9D\xDE"=>"\xE6\x98\x83",
		"\x9D\xDF"=>"\xE6\x97\xBB",
		"\x9D\xE0"=>"\xE6\x9D\xB3",
		"\x9D\xE1"=>"\xE6\x98\xB5",
		"\x9D\xE2"=>"\xE6\x98\xB6",
		"\x9D\xE3"=>"\xE6\x98\xB4",
		"\x9D\xE4"=>"\xE6\x98\x9C",
		"\x9D\xE5"=>"\xE6\x99\x8F",
		"\x9D\xE6"=>"\xE6\x99\x84",
		"\x9D\xE7"=>"\xE6\x99\x89",
		"\x9D\xE8"=>"\xE6\x99\x81",
		"\x9D\xE9"=>"\xE6\x99\x9E",
		"\x9D\xEA"=>"\xE6\x99\x9D",
		"\x9D\xEB"=>"\xE6\x99\xA4",
		"\x9D\xEC"=>"\xE6\x99\xA7",
		"\x9D\xED"=>"\xE6\x99\xA8",
		"\x9D\xEE"=>"\xE6\x99\x9F",
		"\x9D\xEF"=>"\xE6\x99\xA2",
		"\x9D\xF0"=>"\xE6\x99\xB0",
		"\x9D\xF1"=>"\xE6\x9A\x83",
		"\x9D\xF2"=>"\xE6\x9A\x88",
		"\x9D\xF3"=>"\xE6\x9A\x8E",
		"\x9D\xF4"=>"\xE6\x9A\x89",
		"\x9D\xF5"=>"\xE6\x9A\x84",
		"\x9D\xF6"=>"\xE6\x9A\x98",
		"\x9D\xF7"=>"\xE6\x9A\x9D",
		"\x9D\xF8"=>"\xE6\x9B\x81",
		"\x9D\xF9"=>"\xE6\x9A\xB9",
		"\x9D\xFA"=>"\xE6\x9B\x89",
		"\x9D\xFB"=>"\xE6\x9A\xBE",
		"\x9D\xFC"=>"\xE6\x9A\xBC",
		"\x9E\x40"=>"\xE6\x9B\x84",
		"\x9E\x41"=>"\xE6\x9A\xB8",
		"\x9E\x42"=>"\xE6\x9B\x96",
		"\x9E\x43"=>"\xE6\x9B\x9A",
		"\x9E\x44"=>"\xE6\x9B\xA0",
		"\x9E\x45"=>"\xE6\x98\xBF",
		"\x9E\x46"=>"\xE6\x9B\xA6",
		"\x9E\x47"=>"\xE6\x9B\xA9",
		"\x9E\x48"=>"\xE6\x9B\xB0",
		"\x9E\x49"=>"\xE6\x9B\xB5",
		"\x9E\x4A"=>"\xE6\x9B\xB7",
		"\x9E\x4B"=>"\xE6\x9C\x8F",
		"\x9E\x4C"=>"\xE6\x9C\x96",
		"\x9E\x4D"=>"\xE6\x9C\x9E",
		"\x9E\x4E"=>"\xE6\x9C\xA6",
		"\x9E\x4F"=>"\xE6\x9C\xA7",
		"\x9E\x50"=>"\xE9\x9C\xB8",
		"\x9E\x51"=>"\xE6\x9C\xAE",
		"\x9E\x52"=>"\xE6\x9C\xBF",
		"\x9E\x53"=>"\xE6\x9C\xB6",
		"\x9E\x54"=>"\xE6\x9D\x81",
		"\x9E\x55"=>"\xE6\x9C\xB8",
		"\x9E\x56"=>"\xE6\x9C\xB7",
		"\x9E\x57"=>"\xE6\x9D\x86",
		"\x9E\x58"=>"\xE6\x9D\x9E",
		"\x9E\x59"=>"\xE6\x9D\xA0",
		"\x9E\x5A"=>"\xE6\x9D\x99",
		"\x9E\x5B"=>"\xE6\x9D\xA3",
		"\x9E\x5C"=>"\xE6\x9D\xA4",
		"\x9E\x5D"=>"\xE6\x9E\x89",
		"\x9E\x5E"=>"\xE6\x9D\xB0",
		"\x9E\x5F"=>"\xE6\x9E\xA9",
		"\x9E\x60"=>"\xE6\x9D\xBC",
		"\x9E\x61"=>"\xE6\x9D\xAA",
		"\x9E\x62"=>"\xE6\x9E\x8C",
		"\x9E\x63"=>"\xE6\x9E\x8B",
		"\x9E\x64"=>"\xE6\x9E\xA6",
		"\x9E\x65"=>"\xE6\x9E\xA1",
		"\x9E\x66"=>"\xE6\x9E\x85",
		"\x9E\x67"=>"\xE6\x9E\xB7",
		"\x9E\x68"=>"\xE6\x9F\xAF",
		"\x9E\x69"=>"\xE6\x9E\xB4",
		"\x9E\x6A"=>"\xE6\x9F\xAC",
		"\x9E\x6B"=>"\xE6\x9E\xB3",
		"\x9E\x6C"=>"\xE6\x9F\xA9",
		"\x9E\x6D"=>"\xE6\x9E\xB8",
		"\x9E\x6E"=>"\xE6\x9F\xA4",
		"\x9E\x6F"=>"\xE6\x9F\x9E",
		"\x9E\x70"=>"\xE6\x9F\x9D",
		"\x9E\x71"=>"\xE6\x9F\xA2",
		"\x9E\x72"=>"\xE6\x9F\xAE",
		"\x9E\x73"=>"\xE6\x9E\xB9",
		"\x9E\x74"=>"\xE6\x9F\x8E",
		"\x9E\x75"=>"\xE6\x9F\x86",
		"\x9E\x76"=>"\xE6\x9F\xA7",
		"\x9E\x77"=>"\xE6\xAA\x9C",
		"\x9E\x78"=>"\xE6\xA0\x9E",
		"\x9E\x79"=>"\xE6\xA1\x86",
		"\x9E\x7A"=>"\xE6\xA0\xA9",
		"\x9E\x7B"=>"\xE6\xA1\x80",
		"\x9E\x7C"=>"\xE6\xA1\x8D",
		"\x9E\x7D"=>"\xE6\xA0\xB2",
		"\x9E\x7E"=>"\xE6\xA1\x8E",
		"\x9E\x80"=>"\xE6\xA2\xB3",
		"\x9E\x81"=>"\xE6\xA0\xAB",
		"\x9E\x82"=>"\xE6\xA1\x99",
		"\x9E\x83"=>"\xE6\xA1\xA3",
		"\x9E\x84"=>"\xE6\xA1\xB7",
		"\x9E\x85"=>"\xE6\xA1\xBF",
		"\x9E\x86"=>"\xE6\xA2\x9F",
		"\x9E\x87"=>"\xE6\xA2\x8F",
		"\x9E\x88"=>"\xE6\xA2\xAD",
		"\x9E\x89"=>"\xE6\xA2\x94",
		"\x9E\x8A"=>"\xE6\xA2\x9D",
		"\x9E\x8B"=>"\xE6\xA2\x9B",
		"\x9E\x8C"=>"\xE6\xA2\x83",
		"\x9E\x8D"=>"\xE6\xAA\xAE",
		"\x9E\x8E"=>"\xE6\xA2\xB9",
		"\x9E\x8F"=>"\xE6\xA1\xB4",
		"\x9E\x90"=>"\xE6\xA2\xB5",
		"\x9E\x91"=>"\xE6\xA2\xA0",
		"\x9E\x92"=>"\xE6\xA2\xBA",
		"\x9E\x93"=>"\xE6\xA4\x8F",
		"\x9E\x94"=>"\xE6\xA2\x8D",
		"\x9E\x95"=>"\xE6\xA1\xBE",
		"\x9E\x96"=>"\xE6\xA4\x81",
		"\x9E\x97"=>"\xE6\xA3\x8A",
		"\x9E\x98"=>"\xE6\xA4\x88",
		"\x9E\x99"=>"\xE6\xA3\x98",
		"\x9E\x9A"=>"\xE6\xA4\xA2",
		"\x9E\x9B"=>"\xE6\xA4\xA6",
		"\x9E\x9C"=>"\xE6\xA3\xA1",
		"\x9E\x9D"=>"\xE6\xA4\x8C",
		"\x9E\x9E"=>"\xE6\xA3\x8D",
		"\x9E\x9F"=>"\xE6\xA3\x94",
		"\x9E\xA0"=>"\xE6\xA3\xA7",
		"\x9E\xA1"=>"\xE6\xA3\x95",
		"\x9E\xA2"=>"\xE6\xA4\xB6",
		"\x9E\xA3"=>"\xE6\xA4\x92",
		"\x9E\xA4"=>"\xE6\xA4\x84",
		"\x9E\xA5"=>"\xE6\xA3\x97",
		"\x9E\xA6"=>"\xE6\xA3\xA3",
		"\x9E\xA7"=>"\xE6\xA4\xA5",
		"\x9E\xA8"=>"\xE6\xA3\xB9",
		"\x9E\xA9"=>"\xE6\xA3\xA0",
		"\x9E\xAA"=>"\xE6\xA3\xAF",
		"\x9E\xAB"=>"\xE6\xA4\xA8",
		"\x9E\xAC"=>"\xE6\xA4\xAA",
		"\x9E\xAD"=>"\xE6\xA4\x9A",
		"\x9E\xAE"=>"\xE6\xA4\xA3",
		"\x9E\xAF"=>"\xE6\xA4\xA1",
		"\x9E\xB0"=>"\xE6\xA3\x86",
		"\x9E\xB1"=>"\xE6\xA5\xB9",
		"\x9E\xB2"=>"\xE6\xA5\xB7",
		"\x9E\xB3"=>"\xE6\xA5\x9C",
		"\x9E\xB4"=>"\xE6\xA5\xB8",
		"\x9E\xB5"=>"\xE6\xA5\xAB",
		"\x9E\xB6"=>"\xE6\xA5\x94",
		"\x9E\xB7"=>"\xE6\xA5\xBE",
		"\x9E\xB8"=>"\xE6\xA5\xAE",
		"\x9E\xB9"=>"\xE6\xA4\xB9",
		"\x9E\xBA"=>"\xE6\xA5\xB4",
		"\x9E\xBB"=>"\xE6\xA4\xBD",
		"\x9E\xBC"=>"\xE6\xA5\x99",
		"\x9E\xBD"=>"\xE6\xA4\xB0",
		"\x9E\xBE"=>"\xE6\xA5\xA1",
		"\x9E\xBF"=>"\xE6\xA5\x9E",
		"\x9E\xC0"=>"\xE6\xA5\x9D",
		"\x9E\xC1"=>"\xE6\xA6\x81",
		"\x9E\xC2"=>"\xE6\xA5\xAA",
		"\x9E\xC3"=>"\xE6\xA6\xB2",
		"\x9E\xC4"=>"\xE6\xA6\xAE",
		"\x9E\xC5"=>"\xE6\xA7\x90",
		"\x9E\xC6"=>"\xE6\xA6\xBF",
		"\x9E\xC7"=>"\xE6\xA7\x81",
		"\x9E\xC8"=>"\xE6\xA7\x93",
		"\x9E\xC9"=>"\xE6\xA6\xBE",
		"\x9E\xCA"=>"\xE6\xA7\x8E",
		"\x9E\xCB"=>"\xE5\xAF\xA8",
		"\x9E\xCC"=>"\xE6\xA7\x8A",
		"\x9E\xCD"=>"\xE6\xA7\x9D",
		"\x9E\xCE"=>"\xE6\xA6\xBB",
		"\x9E\xCF"=>"\xE6\xA7\x83",
		"\x9E\xD0"=>"\xE6\xA6\xA7",
		"\x9E\xD1"=>"\xE6\xA8\xAE",
		"\x9E\xD2"=>"\xE6\xA6\x91",
		"\x9E\xD3"=>"\xE6\xA6\xA0",
		"\x9E\xD4"=>"\xE6\xA6\x9C",
		"\x9E\xD5"=>"\xE6\xA6\x95",
		"\x9E\xD6"=>"\xE6\xA6\xB4",
		"\x9E\xD7"=>"\xE6\xA7\x9E",
		"\x9E\xD8"=>"\xE6\xA7\xA8",
		"\x9E\xD9"=>"\xE6\xA8\x82",
		"\x9E\xDA"=>"\xE6\xA8\x9B",
		"\x9E\xDB"=>"\xE6\xA7\xBF",
		"\x9E\xDC"=>"\xE6\xAC\x8A",
		"\x9E\xDD"=>"\xE6\xA7\xB9",
		"\x9E\xDE"=>"\xE6\xA7\xB2",
		"\x9E\xDF"=>"\xE6\xA7\xA7",
		"\x9E\xE0"=>"\xE6\xA8\x85",
		"\x9E\xE1"=>"\xE6\xA6\xB1",
		"\x9E\xE2"=>"\xE6\xA8\x9E",
		"\x9E\xE3"=>"\xE6\xA7\xAD",
		"\x9E\xE4"=>"\xE6\xA8\x94",
		"\x9E\xE5"=>"\xE6\xA7\xAB",
		"\x9E\xE6"=>"\xE6\xA8\x8A",
		"\x9E\xE7"=>"\xE6\xA8\x92",
		"\x9E\xE8"=>"\xE6\xAB\x81",
		"\x9E\xE9"=>"\xE6\xA8\xA3",
		"\x9E\xEA"=>"\xE6\xA8\x93",
		"\x9E\xEB"=>"\xE6\xA9\x84",
		"\x9E\xEC"=>"\xE6\xA8\x8C",
		"\x9E\xED"=>"\xE6\xA9\xB2",
		"\x9E\xEE"=>"\xE6\xA8\xB6",
		"\x9E\xEF"=>"\xE6\xA9\xB8",
		"\x9E\xF0"=>"\xE6\xA9\x87",
		"\x9E\xF1"=>"\xE6\xA9\xA2",
		"\x9E\xF2"=>"\xE6\xA9\x99",
		"\x9E\xF3"=>"\xE6\xA9\xA6",
		"\x9E\xF4"=>"\xE6\xA9\x88",
		"\x9E\xF5"=>"\xE6\xA8\xB8",
		"\x9E\xF6"=>"\xE6\xA8\xA2",
		"\x9E\xF7"=>"\xE6\xAA\x90",
		"\x9E\xF8"=>"\xE6\xAA\x8D",
		"\x9E\xF9"=>"\xE6\xAA\xA0",
		"\x9E\xFA"=>"\xE6\xAA\x84",
		"\x9E\xFB"=>"\xE6\xAA\xA2",
		"\x9E\xFC"=>"\xE6\xAA\xA3",
		"\x9F\x40"=>"\xE6\xAA\x97",
		"\x9F\x41"=>"\xE8\x98\x97",
		"\x9F\x42"=>"\xE6\xAA\xBB",
		"\x9F\x43"=>"\xE6\xAB\x83",
		"\x9F\x44"=>"\xE6\xAB\x82",
		"\x9F\x45"=>"\xE6\xAA\xB8",
		"\x9F\x46"=>"\xE6\xAA\xB3",
		"\x9F\x47"=>"\xE6\xAA\xAC",
		"\x9F\x48"=>"\xE6\xAB\x9E",
		"\x9F\x49"=>"\xE6\xAB\x91",
		"\x9F\x4A"=>"\xE6\xAB\x9F",
		"\x9F\x4B"=>"\xE6\xAA\xAA",
		"\x9F\x4C"=>"\xE6\xAB\x9A",
		"\x9F\x4D"=>"\xE6\xAB\xAA",
		"\x9F\x4E"=>"\xE6\xAB\xBB",
		"\x9F\x4F"=>"\xE6\xAC\x85",
		"\x9F\x50"=>"\xE8\x98\x96",
		"\x9F\x51"=>"\xE6\xAB\xBA",
		"\x9F\x52"=>"\xE6\xAC\x92",
		"\x9F\x53"=>"\xE6\xAC\x96",
		"\x9F\x54"=>"\xE9\xAC\xB1",
		"\x9F\x55"=>"\xE6\xAC\x9F",
		"\x9F\x56"=>"\xE6\xAC\xB8",
		"\x9F\x57"=>"\xE6\xAC\xB7",
		"\x9F\x58"=>"\xE7\x9B\x9C",
		"\x9F\x59"=>"\xE6\xAC\xB9",
		"\x9F\x5A"=>"\xE9\xA3\xAE",
		"\x9F\x5B"=>"\xE6\xAD\x87",
		"\x9F\x5C"=>"\xE6\xAD\x83",
		"\x9F\x5D"=>"\xE6\xAD\x89",
		"\x9F\x5E"=>"\xE6\xAD\x90",
		"\x9F\x5F"=>"\xE6\xAD\x99",
		"\x9F\x60"=>"\xE6\xAD\x94",
		"\x9F\x61"=>"\xE6\xAD\x9B",
		"\x9F\x62"=>"\xE6\xAD\x9F",
		"\x9F\x63"=>"\xE6\xAD\xA1",
		"\x9F\x64"=>"\xE6\xAD\xB8",
		"\x9F\x65"=>"\xE6\xAD\xB9",
		"\x9F\x66"=>"\xE6\xAD\xBF",
		"\x9F\x67"=>"\xE6\xAE\x80",
		"\x9F\x68"=>"\xE6\xAE\x84",
		"\x9F\x69"=>"\xE6\xAE\x83",
		"\x9F\x6A"=>"\xE6\xAE\x8D",
		"\x9F\x6B"=>"\xE6\xAE\x98",
		"\x9F\x6C"=>"\xE6\xAE\x95",
		"\x9F\x6D"=>"\xE6\xAE\x9E",
		"\x9F\x6E"=>"\xE6\xAE\xA4",
		"\x9F\x6F"=>"\xE6\xAE\xAA",
		"\x9F\x70"=>"\xE6\xAE\xAB",
		"\x9F\x71"=>"\xE6\xAE\xAF",
		"\x9F\x72"=>"\xE6\xAE\xB2",
		"\x9F\x73"=>"\xE6\xAE\xB1",
		"\x9F\x74"=>"\xE6\xAE\xB3",
		"\x9F\x75"=>"\xE6\xAE\xB7",
		"\x9F\x76"=>"\xE6\xAE\xBC",
		"\x9F\x77"=>"\xE6\xAF\x86",
		"\x9F\x78"=>"\xE6\xAF\x8B",
		"\x9F\x79"=>"\xE6\xAF\x93",
		"\x9F\x7A"=>"\xE6\xAF\x9F",
		"\x9F\x7B"=>"\xE6\xAF\xAC",
		"\x9F\x7C"=>"\xE6\xAF\xAB",
		"\x9F\x7D"=>"\xE6\xAF\xB3",
		"\x9F\x7E"=>"\xE6\xAF\xAF",
		"\x9F\x80"=>"\xE9\xBA\xBE",
		"\x9F\x81"=>"\xE6\xB0\x88",
		"\x9F\x82"=>"\xE6\xB0\x93",
		"\x9F\x83"=>"\xE6\xB0\x94",
		"\x9F\x84"=>"\xE6\xB0\x9B",
		"\x9F\x85"=>"\xE6\xB0\xA4",
		"\x9F\x86"=>"\xE6\xB0\xA3",
		"\x9F\x87"=>"\xE6\xB1\x9E",
		"\x9F\x88"=>"\xE6\xB1\x95",
		"\x9F\x89"=>"\xE6\xB1\xA2",
		"\x9F\x8A"=>"\xE6\xB1\xAA",
		"\x9F\x8B"=>"\xE6\xB2\x82",
		"\x9F\x8C"=>"\xE6\xB2\x8D",
		"\x9F\x8D"=>"\xE6\xB2\x9A",
		"\x9F\x8E"=>"\xE6\xB2\x81",
		"\x9F\x8F"=>"\xE6\xB2\x9B",
		"\x9F\x90"=>"\xE6\xB1\xBE",
		"\x9F\x91"=>"\xE6\xB1\xA8",
		"\x9F\x92"=>"\xE6\xB1\xB3",
		"\x9F\x93"=>"\xE6\xB2\x92",
		"\x9F\x94"=>"\xE6\xB2\x90",
		"\x9F\x95"=>"\xE6\xB3\x84",
		"\x9F\x96"=>"\xE6\xB3\xB1",
		"\x9F\x97"=>"\xE6\xB3\x93",
		"\x9F\x98"=>"\xE6\xB2\xBD",
		"\x9F\x99"=>"\xE6\xB3\x97",
		"\x9F\x9A"=>"\xE6\xB3\x85",
		"\x9F\x9B"=>"\xE6\xB3\x9D",
		"\x9F\x9C"=>"\xE6\xB2\xAE",
		"\x9F\x9D"=>"\xE6\xB2\xB1",
		"\x9F\x9E"=>"\xE6\xB2\xBE",
		"\x9F\x9F"=>"\xE6\xB2\xBA",
		"\x9F\xA0"=>"\xE6\xB3\x9B",
		"\x9F\xA1"=>"\xE6\xB3\xAF",
		"\x9F\xA2"=>"\xE6\xB3\x99",
		"\x9F\xA3"=>"\xE6\xB3\xAA",
		"\x9F\xA4"=>"\xE6\xB4\x9F",
		"\x9F\xA5"=>"\xE8\xA1\x8D",
		"\x9F\xA6"=>"\xE6\xB4\xB6",
		"\x9F\xA7"=>"\xE6\xB4\xAB",
		"\x9F\xA8"=>"\xE6\xB4\xBD",
		"\x9F\xA9"=>"\xE6\xB4\xB8",
		"\x9F\xAA"=>"\xE6\xB4\x99",
		"\x9F\xAB"=>"\xE6\xB4\xB5",
		"\x9F\xAC"=>"\xE6\xB4\xB3",
		"\x9F\xAD"=>"\xE6\xB4\x92",
		"\x9F\xAE"=>"\xE6\xB4\x8C",
		"\x9F\xAF"=>"\xE6\xB5\xA3",
		"\x9F\xB0"=>"\xE6\xB6\x93",
		"\x9F\xB1"=>"\xE6\xB5\xA4",
		"\x9F\xB2"=>"\xE6\xB5\x9A",
		"\x9F\xB3"=>"\xE6\xB5\xB9",
		"\x9F\xB4"=>"\xE6\xB5\x99",
		"\x9F\xB5"=>"\xE6\xB6\x8E",
		"\x9F\xB6"=>"\xE6\xB6\x95",
		"\x9F\xB7"=>"\xE6\xBF\xA4",
		"\x9F\xB8"=>"\xE6\xB6\x85",
		"\x9F\xB9"=>"\xE6\xB7\xB9",
		"\x9F\xBA"=>"\xE6\xB8\x95",
		"\x9F\xBB"=>"\xE6\xB8\x8A",
		"\x9F\xBC"=>"\xE6\xB6\xB5",
		"\x9F\xBD"=>"\xE6\xB7\x87",
		"\x9F\xBE"=>"\xE6\xB7\xA6",
		"\x9F\xBF"=>"\xE6\xB6\xB8",
		"\x9F\xC0"=>"\xE6\xB7\x86",
		"\x9F\xC1"=>"\xE6\xB7\xAC",
		"\x9F\xC2"=>"\xE6\xB7\x9E",
		"\x9F\xC3"=>"\xE6\xB7\x8C",
		"\x9F\xC4"=>"\xE6\xB7\xA8",
		"\x9F\xC5"=>"\xE6\xB7\x92",
		"\x9F\xC6"=>"\xE6\xB7\x85",
		"\x9F\xC7"=>"\xE6\xB7\xBA",
		"\x9F\xC8"=>"\xE6\xB7\x99",
		"\x9F\xC9"=>"\xE6\xB7\xA4",
		"\x9F\xCA"=>"\xE6\xB7\x95",
		"\x9F\xCB"=>"\xE6\xB7\xAA",
		"\x9F\xCC"=>"\xE6\xB7\xAE",
		"\x9F\xCD"=>"\xE6\xB8\xAD",
		"\x9F\xCE"=>"\xE6\xB9\xAE",
		"\x9F\xCF"=>"\xE6\xB8\xAE",
		"\x9F\xD0"=>"\xE6\xB8\x99",
		"\x9F\xD1"=>"\xE6\xB9\xB2",
		"\x9F\xD2"=>"\xE6\xB9\x9F",
		"\x9F\xD3"=>"\xE6\xB8\xBE",
		"\x9F\xD4"=>"\xE6\xB8\xA3",
		"\x9F\xD5"=>"\xE6\xB9\xAB",
		"\x9F\xD6"=>"\xE6\xB8\xAB",
		"\x9F\xD7"=>"\xE6\xB9\xB6",
		"\x9F\xD8"=>"\xE6\xB9\x8D",
		"\x9F\xD9"=>"\xE6\xB8\x9F",
		"\x9F\xDA"=>"\xE6\xB9\x83",
		"\x9F\xDB"=>"\xE6\xB8\xBA",
		"\x9F\xDC"=>"\xE6\xB9\x8E",
		"\x9F\xDD"=>"\xE6\xB8\xA4",
		"\x9F\xDE"=>"\xE6\xBB\xBF",
		"\x9F\xDF"=>"\xE6\xB8\x9D",
		"\x9F\xE0"=>"\xE6\xB8\xB8",
		"\x9F\xE1"=>"\xE6\xBA\x82",
		"\x9F\xE2"=>"\xE6\xBA\xAA",
		"\x9F\xE3"=>"\xE6\xBA\x98",
		"\x9F\xE4"=>"\xE6\xBB\x89",
		"\x9F\xE5"=>"\xE6\xBA\xB7",
		"\x9F\xE6"=>"\xE6\xBB\x93",
		"\x9F\xE7"=>"\xE6\xBA\xBD",
		"\x9F\xE8"=>"\xE6\xBA\xAF",
		"\x9F\xE9"=>"\xE6\xBB\x84",
		"\x9F\xEA"=>"\xE6\xBA\xB2",
		"\x9F\xEB"=>"\xE6\xBB\x94",
		"\x9F\xEC"=>"\xE6\xBB\x95",
		"\x9F\xED"=>"\xE6\xBA\x8F",
		"\x9F\xEE"=>"\xE6\xBA\xA5",
		"\x9F\xEF"=>"\xE6\xBB\x82",
		"\x9F\xF0"=>"\xE6\xBA\x9F",
		"\x9F\xF1"=>"\xE6\xBD\x81",
		"\x9F\xF2"=>"\xE6\xBC\x91",
		"\x9F\xF3"=>"\xE7\x81\x8C",
		"\x9F\xF4"=>"\xE6\xBB\xAC",
		"\x9F\xF5"=>"\xE6\xBB\xB8",
		"\x9F\xF6"=>"\xE6\xBB\xBE",
		"\x9F\xF7"=>"\xE6\xBC\xBF",
		"\x9F\xF8"=>"\xE6\xBB\xB2",
		"\x9F\xF9"=>"\xE6\xBC\xB1",
		"\x9F\xFA"=>"\xE6\xBB\xAF",
		"\x9F\xFB"=>"\xE6\xBC\xB2",
		"\x9F\xFC"=>"\xE6\xBB\x8C",
		"\xA1"=>"\xEF\xBD\xA1",
		"\xA2"=>"\xEF\xBD\xA2",
		"\xA3"=>"\xEF\xBD\xA3",
		"\xA4"=>"\xEF\xBD\xA4",
		"\xA5"=>"\xEF\xBD\xA5",
		"\xA6"=>"\xEF\xBD\xA6",
		"\xA7"=>"\xEF\xBD\xA7",
		"\xA8"=>"\xEF\xBD\xA8",
		"\xA9"=>"\xEF\xBD\xA9",
		"\xAA"=>"\xEF\xBD\xAA",
		"\xAB"=>"\xEF\xBD\xAB",
		"\xAC"=>"\xEF\xBD\xAC",
		"\xAD"=>"\xEF\xBD\xAD",
		"\xAE"=>"\xEF\xBD\xAE",
		"\xAF"=>"\xEF\xBD\xAF",
		"\xB0"=>"\xEF\xBD\xB0",
		"\xB1"=>"\xEF\xBD\xB1",
		"\xB2"=>"\xEF\xBD\xB2",
		"\xB3"=>"\xEF\xBD\xB3",
		"\xB4"=>"\xEF\xBD\xB4",
		"\xB5"=>"\xEF\xBD\xB5",
		"\xB6"=>"\xEF\xBD\xB6",
		"\xB7"=>"\xEF\xBD\xB7",
		"\xB8"=>"\xEF\xBD\xB8",
		"\xB9"=>"\xEF\xBD\xB9",
		"\xBA"=>"\xEF\xBD\xBA",
		"\xBB"=>"\xEF\xBD\xBB",
		"\xBC"=>"\xEF\xBD\xBC",
		"\xBD"=>"\xEF\xBD\xBD",
		"\xBE"=>"\xEF\xBD\xBE",
		"\xBF"=>"\xEF\xBD\xBF",
		"\xC0"=>"\xEF\xBE\x80",
		"\xC1"=>"\xEF\xBE\x81",
		"\xC2"=>"\xEF\xBE\x82",
		"\xC3"=>"\xEF\xBE\x83",
		"\xC4"=>"\xEF\xBE\x84",
		"\xC5"=>"\xEF\xBE\x85",
		"\xC6"=>"\xEF\xBE\x86",
		"\xC7"=>"\xEF\xBE\x87",
		"\xC8"=>"\xEF\xBE\x88",
		"\xC9"=>"\xEF\xBE\x89",
		"\xCA"=>"\xEF\xBE\x8A",
		"\xCB"=>"\xEF\xBE\x8B",
		"\xCC"=>"\xEF\xBE\x8C",
		"\xCD"=>"\xEF\xBE\x8D",
		"\xCE"=>"\xEF\xBE\x8E",
		"\xCF"=>"\xEF\xBE\x8F",
		"\xD0"=>"\xEF\xBE\x90",
		"\xD1"=>"\xEF\xBE\x91",
		"\xD2"=>"\xEF\xBE\x92",
		"\xD3"=>"\xEF\xBE\x93",
		"\xD4"=>"\xEF\xBE\x94",
		"\xD5"=>"\xEF\xBE\x95",
		"\xD6"=>"\xEF\xBE\x96",
		"\xD7"=>"\xEF\xBE\x97",
		"\xD8"=>"\xEF\xBE\x98",
		"\xD9"=>"\xEF\xBE\x99",
		"\xDA"=>"\xEF\xBE\x9A",
		"\xDB"=>"\xEF\xBE\x9B",
		"\xDC"=>"\xEF\xBE\x9C",
		"\xDD"=>"\xEF\xBE\x9D",
		"\xDE"=>"\xEF\xBE\x9E",
		"\xDF"=>"\xEF\xBE\x9F",
		"\xE0\x40"=>"\xE6\xBC\xBE",
		"\xE0\x41"=>"\xE6\xBC\x93",
		"\xE0\x42"=>"\xE6\xBB\xB7",
		"\xE0\x43"=>"\xE6\xBE\x86",
		"\xE0\x44"=>"\xE6\xBD\xBA",
		"\xE0\x45"=>"\xE6\xBD\xB8",
		"\xE0\x46"=>"\xE6\xBE\x81",
		"\xE0\x47"=>"\xE6\xBE\x80",
		"\xE0\x48"=>"\xE6\xBD\xAF",
		"\xE0\x49"=>"\xE6\xBD\x9B",
		"\xE0\x4A"=>"\xE6\xBF\xB3",
		"\xE0\x4B"=>"\xE6\xBD\xAD",
		"\xE0\x4C"=>"\xE6\xBE\x82",
		"\xE0\x4D"=>"\xE6\xBD\xBC",
		"\xE0\x4E"=>"\xE6\xBD\x98",
		"\xE0\x4F"=>"\xE6\xBE\x8E",
		"\xE0\x50"=>"\xE6\xBE\x91",
		"\xE0\x51"=>"\xE6\xBF\x82",
		"\xE0\x52"=>"\xE6\xBD\xA6",
		"\xE0\x53"=>"\xE6\xBE\xB3",
		"\xE0\x54"=>"\xE6\xBE\xA3",
		"\xE0\x55"=>"\xE6\xBE\xA1",
		"\xE0\x56"=>"\xE6\xBE\xA4",
		"\xE0\x57"=>"\xE6\xBE\xB9",
		"\xE0\x58"=>"\xE6\xBF\x86",
		"\xE0\x59"=>"\xE6\xBE\xAA",
		"\xE0\x5A"=>"\xE6\xBF\x9F",
		"\xE0\x5B"=>"\xE6\xBF\x95",
		"\xE0\x5C"=>"\xE6\xBF\xAC",
		"\xE0\x5D"=>"\xE6\xBF\x94",
		"\xE0\x5E"=>"\xE6\xBF\x98",
		"\xE0\x5F"=>"\xE6\xBF\xB1",
		"\xE0\x60"=>"\xE6\xBF\xAE",
		"\xE0\x61"=>"\xE6\xBF\x9B",
		"\xE0\x62"=>"\xE7\x80\x89",
		"\xE0\x63"=>"\xE7\x80\x8B",
		"\xE0\x64"=>"\xE6\xBF\xBA",
		"\xE0\x65"=>"\xE7\x80\x91",
		"\xE0\x66"=>"\xE7\x80\x81",
		"\xE0\x67"=>"\xE7\x80\x8F",
		"\xE0\x68"=>"\xE6\xBF\xBE",
		"\xE0\x69"=>"\xE7\x80\x9B",
		"\xE0\x6A"=>"\xE7\x80\x9A",
		"\xE0\x6B"=>"\xE6\xBD\xB4",
		"\xE0\x6C"=>"\xE7\x80\x9D",
		"\xE0\x6D"=>"\xE7\x80\x98",
		"\xE0\x6E"=>"\xE7\x80\x9F",
		"\xE0\x6F"=>"\xE7\x80\xB0",
		"\xE0\x70"=>"\xE7\x80\xBE",
		"\xE0\x71"=>"\xE7\x80\xB2",
		"\xE0\x72"=>"\xE7\x81\x91",
		"\xE0\x73"=>"\xE7\x81\xA3",
		"\xE0\x74"=>"\xE7\x82\x99",
		"\xE0\x75"=>"\xE7\x82\x92",
		"\xE0\x76"=>"\xE7\x82\xAF",
		"\xE0\x77"=>"\xE7\x83\xB1",
		"\xE0\x78"=>"\xE7\x82\xAC",
		"\xE0\x79"=>"\xE7\x82\xB8",
		"\xE0\x7A"=>"\xE7\x82\xB3",
		"\xE0\x7B"=>"\xE7\x82\xAE",
		"\xE0\x7C"=>"\xE7\x83\x9F",
		"\xE0\x7D"=>"\xE7\x83\x8B",
		"\xE0\x7E"=>"\xE7\x83\x9D",
		"\xE0\x80"=>"\xE7\x83\x99",
		"\xE0\x81"=>"\xE7\x84\x89",
		"\xE0\x82"=>"\xE7\x83\xBD",
		"\xE0\x83"=>"\xE7\x84\x9C",
		"\xE0\x84"=>"\xE7\x84\x99",
		"\xE0\x85"=>"\xE7\x85\xA5",
		"\xE0\x86"=>"\xE7\x85\x95",
		"\xE0\x87"=>"\xE7\x86\x88",
		"\xE0\x88"=>"\xE7\x85\xA6",
		"\xE0\x89"=>"\xE7\x85\xA2",
		"\xE0\x8A"=>"\xE7\x85\x8C",
		"\xE0\x8B"=>"\xE7\x85\x96",
		"\xE0\x8C"=>"\xE7\x85\xAC",
		"\xE0\x8D"=>"\xE7\x86\x8F",
		"\xE0\x8E"=>"\xE7\x87\xBB",
		"\xE0\x8F"=>"\xE7\x86\x84",
		"\xE0\x90"=>"\xE7\x86\x95",
		"\xE0\x91"=>"\xE7\x86\xA8",
		"\xE0\x92"=>"\xE7\x86\xAC",
		"\xE0\x93"=>"\xE7\x87\x97",
		"\xE0\x94"=>"\xE7\x86\xB9",
		"\xE0\x95"=>"\xE7\x86\xBE",
		"\xE0\x96"=>"\xE7\x87\x92",
		"\xE0\x97"=>"\xE7\x87\x89",
		"\xE0\x98"=>"\xE7\x87\x94",
		"\xE0\x99"=>"\xE7\x87\x8E",
		"\xE0\x9A"=>"\xE7\x87\xA0",
		"\xE0\x9B"=>"\xE7\x87\xAC",
		"\xE0\x9C"=>"\xE7\x87\xA7",
		"\xE0\x9D"=>"\xE7\x87\xB5",
		"\xE0\x9E"=>"\xE7\x87\xBC",
		"\xE0\x9F"=>"\xE7\x87\xB9",
		"\xE0\xA0"=>"\xE7\x87\xBF",
		"\xE0\xA1"=>"\xE7\x88\x8D",
		"\xE0\xA2"=>"\xE7\x88\x90",
		"\xE0\xA3"=>"\xE7\x88\x9B",
		"\xE0\xA4"=>"\xE7\x88\xA8",
		"\xE0\xA5"=>"\xE7\x88\xAD",
		"\xE0\xA6"=>"\xE7\x88\xAC",
		"\xE0\xA7"=>"\xE7\x88\xB0",
		"\xE0\xA8"=>"\xE7\x88\xB2",
		"\xE0\xA9"=>"\xE7\x88\xBB",
		"\xE0\xAA"=>"\xE7\x88\xBC",
		"\xE0\xAB"=>"\xE7\x88\xBF",
		"\xE0\xAC"=>"\xE7\x89\x80",
		"\xE0\xAD"=>"\xE7\x89\x86",
		"\xE0\xAE"=>"\xE7\x89\x8B",
		"\xE0\xAF"=>"\xE7\x89\x98",
		"\xE0\xB0"=>"\xE7\x89\xB4",
		"\xE0\xB1"=>"\xE7\x89\xBE",
		"\xE0\xB2"=>"\xE7\x8A\x82",
		"\xE0\xB3"=>"\xE7\x8A\x81",
		"\xE0\xB4"=>"\xE7\x8A\x87",
		"\xE0\xB5"=>"\xE7\x8A\x92",
		"\xE0\xB6"=>"\xE7\x8A\x96",
		"\xE0\xB7"=>"\xE7\x8A\xA2",
		"\xE0\xB8"=>"\xE7\x8A\xA7",
		"\xE0\xB9"=>"\xE7\x8A\xB9",
		"\xE0\xBA"=>"\xE7\x8A\xB2",
		"\xE0\xBB"=>"\xE7\x8B\x83",
		"\xE0\xBC"=>"\xE7\x8B\x86",
		"\xE0\xBD"=>"\xE7\x8B\x84",
		"\xE0\xBE"=>"\xE7\x8B\x8E",
		"\xE0\xBF"=>"\xE7\x8B\x92",
		"\xE0\xC0"=>"\xE7\x8B\xA2",
		"\xE0\xC1"=>"\xE7\x8B\xA0",
		"\xE0\xC2"=>"\xE7\x8B\xA1",
		"\xE0\xC3"=>"\xE7\x8B\xB9",
		"\xE0\xC4"=>"\xE7\x8B\xB7",
		"\xE0\xC5"=>"\xE5\x80\x8F",
		"\xE0\xC6"=>"\xE7\x8C\x97",
		"\xE0\xC7"=>"\xE7\x8C\x8A",
		"\xE0\xC8"=>"\xE7\x8C\x9C",
		"\xE0\xC9"=>"\xE7\x8C\x96",
		"\xE0\xCA"=>"\xE7\x8C\x9D",
		"\xE0\xCB"=>"\xE7\x8C\xB4",
		"\xE0\xCC"=>"\xE7\x8C\xAF",
		"\xE0\xCD"=>"\xE7\x8C\xA9",
		"\xE0\xCE"=>"\xE7\x8C\xA5",
		"\xE0\xCF"=>"\xE7\x8C\xBE",
		"\xE0\xD0"=>"\xE7\x8D\x8E",
		"\xE0\xD1"=>"\xE7\x8D\x8F",
		"\xE0\xD2"=>"\xE9\xBB\x98",
		"\xE0\xD3"=>"\xE7\x8D\x97",
		"\xE0\xD4"=>"\xE7\x8D\xAA",
		"\xE0\xD5"=>"\xE7\x8D\xA8",
		"\xE0\xD6"=>"\xE7\x8D\xB0",
		"\xE0\xD7"=>"\xE7\x8D\xB8",
		"\xE0\xD8"=>"\xE7\x8D\xB5",
		"\xE0\xD9"=>"\xE7\x8D\xBB",
		"\xE0\xDA"=>"\xE7\x8D\xBA",
		"\xE0\xDB"=>"\xE7\x8F\x88",
		"\xE0\xDC"=>"\xE7\x8E\xB3",
		"\xE0\xDD"=>"\xE7\x8F\x8E",
		"\xE0\xDE"=>"\xE7\x8E\xBB",
		"\xE0\xDF"=>"\xE7\x8F\x80",
		"\xE0\xE0"=>"\xE7\x8F\xA5",
		"\xE0\xE1"=>"\xE7\x8F\xAE",
		"\xE0\xE2"=>"\xE7\x8F\x9E",
		"\xE0\xE3"=>"\xE7\x92\xA2",
		"\xE0\xE4"=>"\xE7\x90\x85",
		"\xE0\xE5"=>"\xE7\x91\xAF",
		"\xE0\xE6"=>"\xE7\x90\xA5",
		"\xE0\xE7"=>"\xE7\x8F\xB8",
		"\xE0\xE8"=>"\xE7\x90\xB2",
		"\xE0\xE9"=>"\xE7\x90\xBA",
		"\xE0\xEA"=>"\xE7\x91\x95",
		"\xE0\xEB"=>"\xE7\x90\xBF",
		"\xE0\xEC"=>"\xE7\x91\x9F",
		"\xE0\xED"=>"\xE7\x91\x99",
		"\xE0\xEE"=>"\xE7\x91\x81",
		"\xE0\xEF"=>"\xE7\x91\x9C",
		"\xE0\xF0"=>"\xE7\x91\xA9",
		"\xE0\xF1"=>"\xE7\x91\xB0",
		"\xE0\xF2"=>"\xE7\x91\xA3",
		"\xE0\xF3"=>"\xE7\x91\xAA",
		"\xE0\xF4"=>"\xE7\x91\xB6",
		"\xE0\xF5"=>"\xE7\x91\xBE",
		"\xE0\xF6"=>"\xE7\x92\x8B",
		"\xE0\xF7"=>"\xE7\x92\x9E",
		"\xE0\xF8"=>"\xE7\x92\xA7",
		"\xE0\xF9"=>"\xE7\x93\x8A",
		"\xE0\xFA"=>"\xE7\x93\x8F",
		"\xE0\xFB"=>"\xE7\x93\x94",
		"\xE0\xFC"=>"\xE7\x8F\xB1",
		"\xE1\x40"=>"\xE7\x93\xA0",
		"\xE1\x41"=>"\xE7\x93\xA3",
		"\xE1\x42"=>"\xE7\x93\xA7",
		"\xE1\x43"=>"\xE7\x93\xA9",
		"\xE1\x44"=>"\xE7\x93\xAE",
		"\xE1\x45"=>"\xE7\x93\xB2",
		"\xE1\x46"=>"\xE7\x93\xB0",
		"\xE1\x47"=>"\xE7\x93\xB1",
		"\xE1\x48"=>"\xE7\x93\xB8",
		"\xE1\x49"=>"\xE7\x93\xB7",
		"\xE1\x4A"=>"\xE7\x94\x84",
		"\xE1\x4B"=>"\xE7\x94\x83",
		"\xE1\x4C"=>"\xE7\x94\x85",
		"\xE1\x4D"=>"\xE7\x94\x8C",
		"\xE1\x4E"=>"\xE7\x94\x8E",
		"\xE1\x4F"=>"\xE7\x94\x8D",
		"\xE1\x50"=>"\xE7\x94\x95",
		"\xE1\x51"=>"\xE7\x94\x93",
		"\xE1\x52"=>"\xE7\x94\x9E",
		"\xE1\x53"=>"\xE7\x94\xA6",
		"\xE1\x54"=>"\xE7\x94\xAC",
		"\xE1\x55"=>"\xE7\x94\xBC",
		"\xE1\x56"=>"\xE7\x95\x84",
		"\xE1\x57"=>"\xE7\x95\x8D",
		"\xE1\x58"=>"\xE7\x95\x8A",
		"\xE1\x59"=>"\xE7\x95\x89",
		"\xE1\x5A"=>"\xE7\x95\x9B",
		"\xE1\x5B"=>"\xE7\x95\x86",
		"\xE1\x5C"=>"\xE7\x95\x9A",
		"\xE1\x5D"=>"\xE7\x95\xA9",
		"\xE1\x5E"=>"\xE7\x95\xA4",
		"\xE1\x5F"=>"\xE7\x95\xA7",
		"\xE1\x60"=>"\xE7\x95\xAB",
		"\xE1\x61"=>"\xE7\x95\xAD",
		"\xE1\x62"=>"\xE7\x95\xB8",
		"\xE1\x63"=>"\xE7\x95\xB6",
		"\xE1\x64"=>"\xE7\x96\x86",
		"\xE1\x65"=>"\xE7\x96\x87",
		"\xE1\x66"=>"\xE7\x95\xB4",
		"\xE1\x67"=>"\xE7\x96\x8A",
		"\xE1\x68"=>"\xE7\x96\x89",
		"\xE1\x69"=>"\xE7\x96\x82",
		"\xE1\x6A"=>"\xE7\x96\x94",
		"\xE1\x6B"=>"\xE7\x96\x9A",
		"\xE1\x6C"=>"\xE7\x96\x9D",
		"\xE1\x6D"=>"\xE7\x96\xA5",
		"\xE1\x6E"=>"\xE7\x96\xA3",
		"\xE1\x6F"=>"\xE7\x97\x82",
		"\xE1\x70"=>"\xE7\x96\xB3",
		"\xE1\x71"=>"\xE7\x97\x83",
		"\xE1\x72"=>"\xE7\x96\xB5",
		"\xE1\x73"=>"\xE7\x96\xBD",
		"\xE1\x74"=>"\xE7\x96\xB8",
		"\xE1\x75"=>"\xE7\x96\xBC",
		"\xE1\x76"=>"\xE7\x96\xB1",
		"\xE1\x77"=>"\xE7\x97\x8D",
		"\xE1\x78"=>"\xE7\x97\x8A",
		"\xE1\x79"=>"\xE7\x97\x92",
		"\xE1\x7A"=>"\xE7\x97\x99",
		"\xE1\x7B"=>"\xE7\x97\xA3",
		"\xE1\x7C"=>"\xE7\x97\x9E",
		"\xE1\x7D"=>"\xE7\x97\xBE",
		"\xE1\x7E"=>"\xE7\x97\xBF",
		"\xE1\x80"=>"\xE7\x97\xBC",
		"\xE1\x81"=>"\xE7\x98\x81",
		"\xE1\x82"=>"\xE7\x97\xB0",
		"\xE1\x83"=>"\xE7\x97\xBA",
		"\xE1\x84"=>"\xE7\x97\xB2",
		"\xE1\x85"=>"\xE7\x97\xB3",
		"\xE1\x86"=>"\xE7\x98\x8B",
		"\xE1\x87"=>"\xE7\x98\x8D",
		"\xE1\x88"=>"\xE7\x98\x89",
		"\xE1\x89"=>"\xE7\x98\x9F",
		"\xE1\x8A"=>"\xE7\x98\xA7",
		"\xE1\x8B"=>"\xE7\x98\xA0",
		"\xE1\x8C"=>"\xE7\x98\xA1",
		"\xE1\x8D"=>"\xE7\x98\xA2",
		"\xE1\x8E"=>"\xE7\x98\xA4",
		"\xE1\x8F"=>"\xE7\x98\xB4",
		"\xE1\x90"=>"\xE7\x98\xB0",
		"\xE1\x91"=>"\xE7\x98\xBB",
		"\xE1\x92"=>"\xE7\x99\x87",
		"\xE1\x93"=>"\xE7\x99\x88",
		"\xE1\x94"=>"\xE7\x99\x86",
		"\xE1\x95"=>"\xE7\x99\x9C",
		"\xE1\x96"=>"\xE7\x99\x98",
		"\xE1\x97"=>"\xE7\x99\xA1",
		"\xE1\x98"=>"\xE7\x99\xA2",
		"\xE1\x99"=>"\xE7\x99\xA8",
		"\xE1\x9A"=>"\xE7\x99\xA9",
		"\xE1\x9B"=>"\xE7\x99\xAA",
		"\xE1\x9C"=>"\xE7\x99\xA7",
		"\xE1\x9D"=>"\xE7\x99\xAC",
		"\xE1\x9E"=>"\xE7\x99\xB0",
		"\xE1\x9F"=>"\xE7\x99\xB2",
		"\xE1\xA0"=>"\xE7\x99\xB6",
		"\xE1\xA1"=>"\xE7\x99\xB8",
		"\xE1\xA2"=>"\xE7\x99\xBC",
		"\xE1\xA3"=>"\xE7\x9A\x80",
		"\xE1\xA4"=>"\xE7\x9A\x83",
		"\xE1\xA5"=>"\xE7\x9A\x88",
		"\xE1\xA6"=>"\xE7\x9A\x8B",
		"\xE1\xA7"=>"\xE7\x9A\x8E",
		"\xE1\xA8"=>"\xE7\x9A\x96",
		"\xE1\xA9"=>"\xE7\x9A\x93",
		"\xE1\xAA"=>"\xE7\x9A\x99",
		"\xE1\xAB"=>"\xE7\x9A\x9A",
		"\xE1\xAC"=>"\xE7\x9A\xB0",
		"\xE1\xAD"=>"\xE7\x9A\xB4",
		"\xE1\xAE"=>"\xE7\x9A\xB8",
		"\xE1\xAF"=>"\xE7\x9A\xB9",
		"\xE1\xB0"=>"\xE7\x9A\xBA",
		"\xE1\xB1"=>"\xE7\x9B\x82",
		"\xE1\xB2"=>"\xE7\x9B\x8D",
		"\xE1\xB3"=>"\xE7\x9B\x96",
		"\xE1\xB4"=>"\xE7\x9B\x92",
		"\xE1\xB5"=>"\xE7\x9B\x9E",
		"\xE1\xB6"=>"\xE7\x9B\xA1",
		"\xE1\xB7"=>"\xE7\x9B\xA5",
		"\xE1\xB8"=>"\xE7\x9B\xA7",
		"\xE1\xB9"=>"\xE7\x9B\xAA",
		"\xE1\xBA"=>"\xE8\x98\xAF",
		"\xE1\xBB"=>"\xE7\x9B\xBB",
		"\xE1\xBC"=>"\xE7\x9C\x88",
		"\xE1\xBD"=>"\xE7\x9C\x87",
		"\xE1\xBE"=>"\xE7\x9C\x84",
		"\xE1\xBF"=>"\xE7\x9C\xA9",
		"\xE1\xC0"=>"\xE7\x9C\xA4",
		"\xE1\xC1"=>"\xE7\x9C\x9E",
		"\xE1\xC2"=>"\xE7\x9C\xA5",
		"\xE1\xC3"=>"\xE7\x9C\xA6",
		"\xE1\xC4"=>"\xE7\x9C\x9B",
		"\xE1\xC5"=>"\xE7\x9C\xB7",
		"\xE1\xC6"=>"\xE7\x9C\xB8",
		"\xE1\xC7"=>"\xE7\x9D\x87",
		"\xE1\xC8"=>"\xE7\x9D\x9A",
		"\xE1\xC9"=>"\xE7\x9D\xA8",
		"\xE1\xCA"=>"\xE7\x9D\xAB",
		"\xE1\xCB"=>"\xE7\x9D\x9B",
		"\xE1\xCC"=>"\xE7\x9D\xA5",
		"\xE1\xCD"=>"\xE7\x9D\xBF",
		"\xE1\xCE"=>"\xE7\x9D\xBE",
		"\xE1\xCF"=>"\xE7\x9D\xB9",
		"\xE1\xD0"=>"\xE7\x9E\x8E",
		"\xE1\xD1"=>"\xE7\x9E\x8B",
		"\xE1\xD2"=>"\xE7\x9E\x91",
		"\xE1\xD3"=>"\xE7\x9E\xA0",
		"\xE1\xD4"=>"\xE7\x9E\x9E",
		"\xE1\xD5"=>"\xE7\x9E\xB0",
		"\xE1\xD6"=>"\xE7\x9E\xB6",
		"\xE1\xD7"=>"\xE7\x9E\xB9",
		"\xE1\xD8"=>"\xE7\x9E\xBF",
		"\xE1\xD9"=>"\xE7\x9E\xBC",
		"\xE1\xDA"=>"\xE7\x9E\xBD",
		"\xE1\xDB"=>"\xE7\x9E\xBB",
		"\xE1\xDC"=>"\xE7\x9F\x87",
		"\xE1\xDD"=>"\xE7\x9F\x8D",
		"\xE1\xDE"=>"\xE7\x9F\x97",
		"\xE1\xDF"=>"\xE7\x9F\x9A",
		"\xE1\xE0"=>"\xE7\x9F\x9C",
		"\xE1\xE1"=>"\xE7\x9F\xA3",
		"\xE1\xE2"=>"\xE7\x9F\xAE",
		"\xE1\xE3"=>"\xE7\x9F\xBC",
		"\xE1\xE4"=>"\xE7\xA0\x8C",
		"\xE1\xE5"=>"\xE7\xA0\x92",
		"\xE1\xE6"=>"\xE7\xA4\xA6",
		"\xE1\xE7"=>"\xE7\xA0\xA0",
		"\xE1\xE8"=>"\xE7\xA4\xAA",
		"\xE1\xE9"=>"\xE7\xA1\x85",
		"\xE1\xEA"=>"\xE7\xA2\x8E",
		"\xE1\xEB"=>"\xE7\xA1\xB4",
		"\xE1\xEC"=>"\xE7\xA2\x86",
		"\xE1\xED"=>"\xE7\xA1\xBC",
		"\xE1\xEE"=>"\xE7\xA2\x9A",
		"\xE1\xEF"=>"\xE7\xA2\x8C",
		"\xE1\xF0"=>"\xE7\xA2\xA3",
		"\xE1\xF1"=>"\xE7\xA2\xB5",
		"\xE1\xF2"=>"\xE7\xA2\xAA",
		"\xE1\xF3"=>"\xE7\xA2\xAF",
		"\xE1\xF4"=>"\xE7\xA3\x91",
		"\xE1\xF5"=>"\xE7\xA3\x86",
		"\xE1\xF6"=>"\xE7\xA3\x8B",
		"\xE1\xF7"=>"\xE7\xA3\x94",
		"\xE1\xF8"=>"\xE7\xA2\xBE",
		"\xE1\xF9"=>"\xE7\xA2\xBC",
		"\xE1\xFA"=>"\xE7\xA3\x85",
		"\xE1\xFB"=>"\xE7\xA3\x8A",
		"\xE1\xFC"=>"\xE7\xA3\xAC",
		"\xE2\x40"=>"\xE7\xA3\xA7",
		"\xE2\x41"=>"\xE7\xA3\x9A",
		"\xE2\x42"=>"\xE7\xA3\xBD",
		"\xE2\x43"=>"\xE7\xA3\xB4",
		"\xE2\x44"=>"\xE7\xA4\x87",
		"\xE2\x45"=>"\xE7\xA4\x92",
		"\xE2\x46"=>"\xE7\xA4\x91",
		"\xE2\x47"=>"\xE7\xA4\x99",
		"\xE2\x48"=>"\xE7\xA4\xAC",
		"\xE2\x49"=>"\xE7\xA4\xAB",
		"\xE2\x4A"=>"\xE7\xA5\x80",
		"\xE2\x4B"=>"\xE7\xA5\xA0",
		"\xE2\x4C"=>"\xE7\xA5\x97",
		"\xE2\x4D"=>"\xE7\xA5\x9F",
		"\xE2\x4E"=>"\xE7\xA5\x9A",
		"\xE2\x4F"=>"\xE7\xA5\x95",
		"\xE2\x50"=>"\xE7\xA5\x93",
		"\xE2\x51"=>"\xE7\xA5\xBA",
		"\xE2\x52"=>"\xE7\xA5\xBF",
		"\xE2\x53"=>"\xE7\xA6\x8A",
		"\xE2\x54"=>"\xE7\xA6\x9D",
		"\xE2\x55"=>"\xE7\xA6\xA7",
		"\xE2\x56"=>"\xE9\xBD\x8B",
		"\xE2\x57"=>"\xE7\xA6\xAA",
		"\xE2\x58"=>"\xE7\xA6\xAE",
		"\xE2\x59"=>"\xE7\xA6\xB3",
		"\xE2\x5A"=>"\xE7\xA6\xB9",
		"\xE2\x5B"=>"\xE7\xA6\xBA",
		"\xE2\x5C"=>"\xE7\xA7\x89",
		"\xE2\x5D"=>"\xE7\xA7\x95",
		"\xE2\x5E"=>"\xE7\xA7\xA7",
		"\xE2\x5F"=>"\xE7\xA7\xAC",
		"\xE2\x60"=>"\xE7\xA7\xA1",
		"\xE2\x61"=>"\xE7\xA7\xA3",
		"\xE2\x62"=>"\xE7\xA8\x88",
		"\xE2\x63"=>"\xE7\xA8\x8D",
		"\xE2\x64"=>"\xE7\xA8\x98",
		"\xE2\x65"=>"\xE7\xA8\x99",
		"\xE2\x66"=>"\xE7\xA8\xA0",
		"\xE2\x67"=>"\xE7\xA8\x9F",
		"\xE2\x68"=>"\xE7\xA6\x80",
		"\xE2\x69"=>"\xE7\xA8\xB1",
		"\xE2\x6A"=>"\xE7\xA8\xBB",
		"\xE2\x6B"=>"\xE7\xA8\xBE",
		"\xE2\x6C"=>"\xE7\xA8\xB7",
		"\xE2\x6D"=>"\xE7\xA9\x83",
		"\xE2\x6E"=>"\xE7\xA9\x97",
		"\xE2\x6F"=>"\xE7\xA9\x89",
		"\xE2\x70"=>"\xE7\xA9\xA1",
		"\xE2\x71"=>"\xE7\xA9\xA2",
		"\xE2\x72"=>"\xE7\xA9\xA9",
		"\xE2\x73"=>"\xE9\xBE\x9D",
		"\xE2\x74"=>"\xE7\xA9\xB0",
		"\xE2\x75"=>"\xE7\xA9\xB9",
		"\xE2\x76"=>"\xE7\xA9\xBD",
		"\xE2\x77"=>"\xE7\xAA\x88",
		"\xE2\x78"=>"\xE7\xAA\x97",
		"\xE2\x79"=>"\xE7\xAA\x95",
		"\xE2\x7A"=>"\xE7\xAA\x98",
		"\xE2\x7B"=>"\xE7\xAA\x96",
		"\xE2\x7C"=>"\xE7\xAA\xA9",
		"\xE2\x7D"=>"\xE7\xAB\x88",
		"\xE2\x7E"=>"\xE7\xAA\xB0",
		"\xE2\x80"=>"\xE7\xAA\xB6",
		"\xE2\x81"=>"\xE7\xAB\x85",
		"\xE2\x82"=>"\xE7\xAB\x84",
		"\xE2\x83"=>"\xE7\xAA\xBF",
		"\xE2\x84"=>"\xE9\x82\x83",
		"\xE2\x85"=>"\xE7\xAB\x87",
		"\xE2\x86"=>"\xE7\xAB\x8A",
		"\xE2\x87"=>"\xE7\xAB\x8D",
		"\xE2\x88"=>"\xE7\xAB\x8F",
		"\xE2\x89"=>"\xE7\xAB\x95",
		"\xE2\x8A"=>"\xE7\xAB\x93",
		"\xE2\x8B"=>"\xE7\xAB\x99",
		"\xE2\x8C"=>"\xE7\xAB\x9A",
		"\xE2\x8D"=>"\xE7\xAB\x9D",
		"\xE2\x8E"=>"\xE7\xAB\xA1",
		"\xE2\x8F"=>"\xE7\xAB\xA2",
		"\xE2\x90"=>"\xE7\xAB\xA6",
		"\xE2\x91"=>"\xE7\xAB\xAD",
		"\xE2\x92"=>"\xE7\xAB\xB0",
		"\xE2\x93"=>"\xE7\xAC\x82",
		"\xE2\x94"=>"\xE7\xAC\x8F",
		"\xE2\x95"=>"\xE7\xAC\x8A",
		"\xE2\x96"=>"\xE7\xAC\x86",
		"\xE2\x97"=>"\xE7\xAC\xB3",
		"\xE2\x98"=>"\xE7\xAC\x98",
		"\xE2\x99"=>"\xE7\xAC\x99",
		"\xE2\x9A"=>"\xE7\xAC\x9E",
		"\xE2\x9B"=>"\xE7\xAC\xB5",
		"\xE2\x9C"=>"\xE7\xAC\xA8",
		"\xE2\x9D"=>"\xE7\xAC\xB6",
		"\xE2\x9E"=>"\xE7\xAD\x90",
		"\xE2\x9F"=>"\xE7\xAD\xBA",
		"\xE2\xA0"=>"\xE7\xAC\x84",
		"\xE2\xA1"=>"\xE7\xAD\x8D",
		"\xE2\xA2"=>"\xE7\xAC\x8B",
		"\xE2\xA3"=>"\xE7\xAD\x8C",
		"\xE2\xA4"=>"\xE7\xAD\x85",
		"\xE2\xA5"=>"\xE7\xAD\xB5",
		"\xE2\xA6"=>"\xE7\xAD\xA5",
		"\xE2\xA7"=>"\xE7\xAD\xB4",
		"\xE2\xA8"=>"\xE7\xAD\xA7",
		"\xE2\xA9"=>"\xE7\xAD\xB0",
		"\xE2\xAA"=>"\xE7\xAD\xB1",
		"\xE2\xAB"=>"\xE7\xAD\xAC",
		"\xE2\xAC"=>"\xE7\xAD\xAE",
		"\xE2\xAD"=>"\xE7\xAE\x9D",
		"\xE2\xAE"=>"\xE7\xAE\x98",
		"\xE2\xAF"=>"\xE7\xAE\x9F",
		"\xE2\xB0"=>"\xE7\xAE\x8D",
		"\xE2\xB1"=>"\xE7\xAE\x9C",
		"\xE2\xB2"=>"\xE7\xAE\x9A",
		"\xE2\xB3"=>"\xE7\xAE\x8B",
		"\xE2\xB4"=>"\xE7\xAE\x92",
		"\xE2\xB5"=>"\xE7\xAE\x8F",
		"\xE2\xB6"=>"\xE7\xAD\x9D",
		"\xE2\xB7"=>"\xE7\xAE\x99",
		"\xE2\xB8"=>"\xE7\xAF\x8B",
		"\xE2\xB9"=>"\xE7\xAF\x81",
		"\xE2\xBA"=>"\xE7\xAF\x8C",
		"\xE2\xBB"=>"\xE7\xAF\x8F",
		"\xE2\xBC"=>"\xE7\xAE\xB4",
		"\xE2\xBD"=>"\xE7\xAF\x86",
		"\xE2\xBE"=>"\xE7\xAF\x9D",
		"\xE2\xBF"=>"\xE7\xAF\xA9",
		"\xE2\xC0"=>"\xE7\xB0\x91",
		"\xE2\xC1"=>"\xE7\xB0\x94",
		"\xE2\xC2"=>"\xE7\xAF\xA6",
		"\xE2\xC3"=>"\xE7\xAF\xA5",
		"\xE2\xC4"=>"\xE7\xB1\xA0",
		"\xE2\xC5"=>"\xE7\xB0\x80",
		"\xE2\xC6"=>"\xE7\xB0\x87",
		"\xE2\xC7"=>"\xE7\xB0\x93",
		"\xE2\xC8"=>"\xE7\xAF\xB3",
		"\xE2\xC9"=>"\xE7\xAF\xB7",
		"\xE2\xCA"=>"\xE7\xB0\x97",
		"\xE2\xCB"=>"\xE7\xB0\x8D",
		"\xE2\xCC"=>"\xE7\xAF\xB6",
		"\xE2\xCD"=>"\xE7\xB0\xA3",
		"\xE2\xCE"=>"\xE7\xB0\xA7",
		"\xE2\xCF"=>"\xE7\xB0\xAA",
		"\xE2\xD0"=>"\xE7\xB0\x9F",
		"\xE2\xD1"=>"\xE7\xB0\xB7",
		"\xE2\xD2"=>"\xE7\xB0\xAB",
		"\xE2\xD3"=>"\xE7\xB0\xBD",
		"\xE2\xD4"=>"\xE7\xB1\x8C",
		"\xE2\xD5"=>"\xE7\xB1\x83",
		"\xE2\xD6"=>"\xE7\xB1\x94",
		"\xE2\xD7"=>"\xE7\xB1\x8F",
		"\xE2\xD8"=>"\xE7\xB1\x80",
		"\xE2\xD9"=>"\xE7\xB1\x90",
		"\xE2\xDA"=>"\xE7\xB1\x98",
		"\xE2\xDB"=>"\xE7\xB1\x9F",
		"\xE2\xDC"=>"\xE7\xB1\xA4",
		"\xE2\xDD"=>"\xE7\xB1\x96",
		"\xE2\xDE"=>"\xE7\xB1\xA5",
		"\xE2\xDF"=>"\xE7\xB1\xAC",
		"\xE2\xE0"=>"\xE7\xB1\xB5",
		"\xE2\xE1"=>"\xE7\xB2\x83",
		"\xE2\xE2"=>"\xE7\xB2\x90",
		"\xE2\xE3"=>"\xE7\xB2\xA4",
		"\xE2\xE4"=>"\xE7\xB2\xAD",
		"\xE2\xE5"=>"\xE7\xB2\xA2",
		"\xE2\xE6"=>"\xE7\xB2\xAB",
		"\xE2\xE7"=>"\xE7\xB2\xA1",
		"\xE2\xE8"=>"\xE7\xB2\xA8",
		"\xE2\xE9"=>"\xE7\xB2\xB3",
		"\xE2\xEA"=>"\xE7\xB2\xB2",
		"\xE2\xEB"=>"\xE7\xB2\xB1",
		"\xE2\xEC"=>"\xE7\xB2\xAE",
		"\xE2\xED"=>"\xE7\xB2\xB9",
		"\xE2\xEE"=>"\xE7\xB2\xBD",
		"\xE2\xEF"=>"\xE7\xB3\x80",
		"\xE2\xF0"=>"\xE7\xB3\x85",
		"\xE2\xF1"=>"\xE7\xB3\x82",
		"\xE2\xF2"=>"\xE7\xB3\x98",
		"\xE2\xF3"=>"\xE7\xB3\x92",
		"\xE2\xF4"=>"\xE7\xB3\x9C",
		"\xE2\xF5"=>"\xE7\xB3\xA2",
		"\xE2\xF6"=>"\xE9\xAC\xBB",
		"\xE2\xF7"=>"\xE7\xB3\xAF",
		"\xE2\xF8"=>"\xE7\xB3\xB2",
		"\xE2\xF9"=>"\xE7\xB3\xB4",
		"\xE2\xFA"=>"\xE7\xB3\xB6",
		"\xE2\xFB"=>"\xE7\xB3\xBA",
		"\xE2\xFC"=>"\xE7\xB4\x86",
		"\xE3\x40"=>"\xE7\xB4\x82",
		"\xE3\x41"=>"\xE7\xB4\x9C",
		"\xE3\x42"=>"\xE7\xB4\x95",
		"\xE3\x43"=>"\xE7\xB4\x8A",
		"\xE3\x44"=>"\xE7\xB5\x85",
		"\xE3\x45"=>"\xE7\xB5\x8B",
		"\xE3\x46"=>"\xE7\xB4\xAE",
		"\xE3\x47"=>"\xE7\xB4\xB2",
		"\xE3\x48"=>"\xE7\xB4\xBF",
		"\xE3\x49"=>"\xE7\xB4\xB5",
		"\xE3\x4A"=>"\xE7\xB5\x86",
		"\xE3\x4B"=>"\xE7\xB5\xB3",
		"\xE3\x4C"=>"\xE7\xB5\x96",
		"\xE3\x4D"=>"\xE7\xB5\x8E",
		"\xE3\x4E"=>"\xE7\xB5\xB2",
		"\xE3\x4F"=>"\xE7\xB5\xA8",
		"\xE3\x50"=>"\xE7\xB5\xAE",
		"\xE3\x51"=>"\xE7\xB5\x8F",
		"\xE3\x52"=>"\xE7\xB5\xA3",
		"\xE3\x53"=>"\xE7\xB6\x93",
		"\xE3\x54"=>"\xE7\xB6\x89",
		"\xE3\x55"=>"\xE7\xB5\x9B",
		"\xE3\x56"=>"\xE7\xB6\x8F",
		"\xE3\x57"=>"\xE7\xB5\xBD",
		"\xE3\x58"=>"\xE7\xB6\x9B",
		"\xE3\x59"=>"\xE7\xB6\xBA",
		"\xE3\x5A"=>"\xE7\xB6\xAE",
		"\xE3\x5B"=>"\xE7\xB6\xA3",
		"\xE3\x5C"=>"\xE7\xB6\xB5",
		"\xE3\x5D"=>"\xE7\xB7\x87",
		"\xE3\x5E"=>"\xE7\xB6\xBD",
		"\xE3\x5F"=>"\xE7\xB6\xAB",
		"\xE3\x60"=>"\xE7\xB8\xBD",
		"\xE3\x61"=>"\xE7\xB6\xA2",
		"\xE3\x62"=>"\xE7\xB6\xAF",
		"\xE3\x63"=>"\xE7\xB7\x9C",
		"\xE3\x64"=>"\xE7\xB6\xB8",
		"\xE3\x65"=>"\xE7\xB6\x9F",
		"\xE3\x66"=>"\xE7\xB6\xB0",
		"\xE3\x67"=>"\xE7\xB7\x98",
		"\xE3\x68"=>"\xE7\xB7\x9D",
		"\xE3\x69"=>"\xE7\xB7\xA4",
		"\xE3\x6A"=>"\xE7\xB7\x9E",
		"\xE3\x6B"=>"\xE7\xB7\xBB",
		"\xE3\x6C"=>"\xE7\xB7\xB2",
		"\xE3\x6D"=>"\xE7\xB7\xA1",
		"\xE3\x6E"=>"\xE7\xB8\x85",
		"\xE3\x6F"=>"\xE7\xB8\x8A",
		"\xE3\x70"=>"\xE7\xB8\xA3",
		"\xE3\x71"=>"\xE7\xB8\xA1",
		"\xE3\x72"=>"\xE7\xB8\x92",
		"\xE3\x73"=>"\xE7\xB8\xB1",
		"\xE3\x74"=>"\xE7\xB8\x9F",
		"\xE3\x75"=>"\xE7\xB8\x89",
		"\xE3\x76"=>"\xE7\xB8\x8B",
		"\xE3\x77"=>"\xE7\xB8\xA2",
		"\xE3\x78"=>"\xE7\xB9\x86",
		"\xE3\x79"=>"\xE7\xB9\xA6",
		"\xE3\x7A"=>"\xE7\xB8\xBB",
		"\xE3\x7B"=>"\xE7\xB8\xB5",
		"\xE3\x7C"=>"\xE7\xB8\xB9",
		"\xE3\x7D"=>"\xE7\xB9\x83",
		"\xE3\x7E"=>"\xE7\xB8\xB7",
		"\xE3\x80"=>"\xE7\xB8\xB2",
		"\xE3\x81"=>"\xE7\xB8\xBA",
		"\xE3\x82"=>"\xE7\xB9\xA7",
		"\xE3\x83"=>"\xE7\xB9\x9D",
		"\xE3\x84"=>"\xE7\xB9\x96",
		"\xE3\x85"=>"\xE7\xB9\x9E",
		"\xE3\x86"=>"\xE7\xB9\x99",
		"\xE3\x87"=>"\xE7\xB9\x9A",
		"\xE3\x88"=>"\xE7\xB9\xB9",
		"\xE3\x89"=>"\xE7\xB9\xAA",
		"\xE3\x8A"=>"\xE7\xB9\xA9",
		"\xE3\x8B"=>"\xE7\xB9\xBC",
		"\xE3\x8C"=>"\xE7\xB9\xBB",
		"\xE3\x8D"=>"\xE7\xBA\x83",
		"\xE3\x8E"=>"\xE7\xB7\x95",
		"\xE3\x8F"=>"\xE7\xB9\xBD",
		"\xE3\x90"=>"\xE8\xBE\xAE",
		"\xE3\x91"=>"\xE7\xB9\xBF",
		"\xE3\x92"=>"\xE7\xBA\x88",
		"\xE3\x93"=>"\xE7\xBA\x89",
		"\xE3\x94"=>"\xE7\xBA\x8C",
		"\xE3\x95"=>"\xE7\xBA\x92",
		"\xE3\x96"=>"\xE7\xBA\x90",
		"\xE3\x97"=>"\xE7\xBA\x93",
		"\xE3\x98"=>"\xE7\xBA\x94",
		"\xE3\x99"=>"\xE7\xBA\x96",
		"\xE3\x9A"=>"\xE7\xBA\x8E",
		"\xE3\x9B"=>"\xE7\xBA\x9B",
		"\xE3\x9C"=>"\xE7\xBA\x9C",
		"\xE3\x9D"=>"\xE7\xBC\xB8",
		"\xE3\x9E"=>"\xE7\xBC\xBA",
		"\xE3\x9F"=>"\xE7\xBD\x85",
		"\xE3\xA0"=>"\xE7\xBD\x8C",
		"\xE3\xA1"=>"\xE7\xBD\x8D",
		"\xE3\xA2"=>"\xE7\xBD\x8E",
		"\xE3\xA3"=>"\xE7\xBD\x90",
		"\xE3\xA4"=>"\xE7\xBD\x91",
		"\xE3\xA5"=>"\xE7\xBD\x95",
		"\xE3\xA6"=>"\xE7\xBD\x94",
		"\xE3\xA7"=>"\xE7\xBD\x98",
		"\xE3\xA8"=>"\xE7\xBD\x9F",
		"\xE3\xA9"=>"\xE7\xBD\xA0",
		"\xE3\xAA"=>"\xE7\xBD\xA8",
		"\xE3\xAB"=>"\xE7\xBD\xA9",
		"\xE3\xAC"=>"\xE7\xBD\xA7",
		"\xE3\xAD"=>"\xE7\xBD\xB8",
		"\xE3\xAE"=>"\xE7\xBE\x82",
		"\xE3\xAF"=>"\xE7\xBE\x86",
		"\xE3\xB0"=>"\xE7\xBE\x83",
		"\xE3\xB1"=>"\xE7\xBE\x88",
		"\xE3\xB2"=>"\xE7\xBE\x87",
		"\xE3\xB3"=>"\xE7\xBE\x8C",
		"\xE3\xB4"=>"\xE7\xBE\x94",
		"\xE3\xB5"=>"\xE7\xBE\x9E",
		"\xE3\xB6"=>"\xE7\xBE\x9D",
		"\xE3\xB7"=>"\xE7\xBE\x9A",
		"\xE3\xB8"=>"\xE7\xBE\xA3",
		"\xE3\xB9"=>"\xE7\xBE\xAF",
		"\xE3\xBA"=>"\xE7\xBE\xB2",
		"\xE3\xBB"=>"\xE7\xBE\xB9",
		"\xE3\xBC"=>"\xE7\xBE\xAE",
		"\xE3\xBD"=>"\xE7\xBE\xB6",
		"\xE3\xBE"=>"\xE7\xBE\xB8",
		"\xE3\xBF"=>"\xE8\xAD\xB1",
		"\xE3\xC0"=>"\xE7\xBF\x85",
		"\xE3\xC1"=>"\xE7\xBF\x86",
		"\xE3\xC2"=>"\xE7\xBF\x8A",
		"\xE3\xC3"=>"\xE7\xBF\x95",
		"\xE3\xC4"=>"\xE7\xBF\x94",
		"\xE3\xC5"=>"\xE7\xBF\xA1",
		"\xE3\xC6"=>"\xE7\xBF\xA6",
		"\xE3\xC7"=>"\xE7\xBF\xA9",
		"\xE3\xC8"=>"\xE7\xBF\xB3",
		"\xE3\xC9"=>"\xE7\xBF\xB9",
		"\xE3\xCA"=>"\xE9\xA3\x9C",
		"\xE3\xCB"=>"\xE8\x80\x86",
		"\xE3\xCC"=>"\xE8\x80\x84",
		"\xE3\xCD"=>"\xE8\x80\x8B",
		"\xE3\xCE"=>"\xE8\x80\x92",
		"\xE3\xCF"=>"\xE8\x80\x98",
		"\xE3\xD0"=>"\xE8\x80\x99",
		"\xE3\xD1"=>"\xE8\x80\x9C",
		"\xE3\xD2"=>"\xE8\x80\xA1",
		"\xE3\xD3"=>"\xE8\x80\xA8",
		"\xE3\xD4"=>"\xE8\x80\xBF",
		"\xE3\xD5"=>"\xE8\x80\xBB",
		"\xE3\xD6"=>"\xE8\x81\x8A",
		"\xE3\xD7"=>"\xE8\x81\x86",
		"\xE3\xD8"=>"\xE8\x81\x92",
		"\xE3\xD9"=>"\xE8\x81\x98",
		"\xE3\xDA"=>"\xE8\x81\x9A",
		"\xE3\xDB"=>"\xE8\x81\x9F",
		"\xE3\xDC"=>"\xE8\x81\xA2",
		"\xE3\xDD"=>"\xE8\x81\xA8",
		"\xE3\xDE"=>"\xE8\x81\xB3",
		"\xE3\xDF"=>"\xE8\x81\xB2",
		"\xE3\xE0"=>"\xE8\x81\xB0",
		"\xE3\xE1"=>"\xE8\x81\xB6",
		"\xE3\xE2"=>"\xE8\x81\xB9",
		"\xE3\xE3"=>"\xE8\x81\xBD",
		"\xE3\xE4"=>"\xE8\x81\xBF",
		"\xE3\xE5"=>"\xE8\x82\x84",
		"\xE3\xE6"=>"\xE8\x82\x86",
		"\xE3\xE7"=>"\xE8\x82\x85",
		"\xE3\xE8"=>"\xE8\x82\x9B",
		"\xE3\xE9"=>"\xE8\x82\x93",
		"\xE3\xEA"=>"\xE8\x82\x9A",
		"\xE3\xEB"=>"\xE8\x82\xAD",
		"\xE3\xEC"=>"\xE5\x86\x90",
		"\xE3\xED"=>"\xE8\x82\xAC",
		"\xE3\xEE"=>"\xE8\x83\x9B",
		"\xE3\xEF"=>"\xE8\x83\xA5",
		"\xE3\xF0"=>"\xE8\x83\x99",
		"\xE3\xF1"=>"\xE8\x83\x9D",
		"\xE3\xF2"=>"\xE8\x83\x84",
		"\xE3\xF3"=>"\xE8\x83\x9A",
		"\xE3\xF4"=>"\xE8\x83\x96",
		"\xE3\xF5"=>"\xE8\x84\x89",
		"\xE3\xF6"=>"\xE8\x83\xAF",
		"\xE3\xF7"=>"\xE8\x83\xB1",
		"\xE3\xF8"=>"\xE8\x84\x9B",
		"\xE3\xF9"=>"\xE8\x84\xA9",
		"\xE3\xFA"=>"\xE8\x84\xA3",
		"\xE3\xFB"=>"\xE8\x84\xAF",
		"\xE3\xFC"=>"\xE8\x85\x8B",
		"\xE4\x40"=>"\xE9\x9A\x8B",
		"\xE4\x41"=>"\xE8\x85\x86",
		"\xE4\x42"=>"\xE8\x84\xBE",
		"\xE4\x43"=>"\xE8\x85\x93",
		"\xE4\x44"=>"\xE8\x85\x91",
		"\xE4\x45"=>"\xE8\x83\xBC",
		"\xE4\x46"=>"\xE8\x85\xB1",
		"\xE4\x47"=>"\xE8\x85\xAE",
		"\xE4\x48"=>"\xE8\x85\xA5",
		"\xE4\x49"=>"\xE8\x85\xA6",
		"\xE4\x4A"=>"\xE8\x85\xB4",
		"\xE4\x4B"=>"\xE8\x86\x83",
		"\xE4\x4C"=>"\xE8\x86\x88",
		"\xE4\x4D"=>"\xE8\x86\x8A",
		"\xE4\x4E"=>"\xE8\x86\x80",
		"\xE4\x4F"=>"\xE8\x86\x82",
		"\xE4\x50"=>"\xE8\x86\xA0",
		"\xE4\x51"=>"\xE8\x86\x95",
		"\xE4\x52"=>"\xE8\x86\xA4",
		"\xE4\x53"=>"\xE8\x86\xA3",
		"\xE4\x54"=>"\xE8\x85\x9F",
		"\xE4\x55"=>"\xE8\x86\x93",
		"\xE4\x56"=>"\xE8\x86\xA9",
		"\xE4\x57"=>"\xE8\x86\xB0",
		"\xE4\x58"=>"\xE8\x86\xB5",
		"\xE4\x59"=>"\xE8\x86\xBE",
		"\xE4\x5A"=>"\xE8\x86\xB8",
		"\xE4\x5B"=>"\xE8\x86\xBD",
		"\xE4\x5C"=>"\xE8\x87\x80",
		"\xE4\x5D"=>"\xE8\x87\x82",
		"\xE4\x5E"=>"\xE8\x86\xBA",
		"\xE4\x5F"=>"\xE8\x87\x89",
		"\xE4\x60"=>"\xE8\x87\x8D",
		"\xE4\x61"=>"\xE8\x87\x91",
		"\xE4\x62"=>"\xE8\x87\x99",
		"\xE4\x63"=>"\xE8\x87\x98",
		"\xE4\x64"=>"\xE8\x87\x88",
		"\xE4\x65"=>"\xE8\x87\x9A",
		"\xE4\x66"=>"\xE8\x87\x9F",
		"\xE4\x67"=>"\xE8\x87\xA0",
		"\xE4\x68"=>"\xE8\x87\xA7",
		"\xE4\x69"=>"\xE8\x87\xBA",
		"\xE4\x6A"=>"\xE8\x87\xBB",
		"\xE4\x6B"=>"\xE8\x87\xBE",
		"\xE4\x6C"=>"\xE8\x88\x81",
		"\xE4\x6D"=>"\xE8\x88\x82",
		"\xE4\x6E"=>"\xE8\x88\x85",
		"\xE4\x6F"=>"\xE8\x88\x87",
		"\xE4\x70"=>"\xE8\x88\x8A",
		"\xE4\x71"=>"\xE8\x88\x8D",
		"\xE4\x72"=>"\xE8\x88\x90",
		"\xE4\x73"=>"\xE8\x88\x96",
		"\xE4\x74"=>"\xE8\x88\xA9",
		"\xE4\x75"=>"\xE8\x88\xAB",
		"\xE4\x76"=>"\xE8\x88\xB8",
		"\xE4\x77"=>"\xE8\x88\xB3",
		"\xE4\x78"=>"\xE8\x89\x80",
		"\xE4\x79"=>"\xE8\x89\x99",
		"\xE4\x7A"=>"\xE8\x89\x98",
		"\xE4\x7B"=>"\xE8\x89\x9D",
		"\xE4\x7C"=>"\xE8\x89\x9A",
		"\xE4\x7D"=>"\xE8\x89\x9F",
		"\xE4\x7E"=>"\xE8\x89\xA4",
		"\xE4\x80"=>"\xE8\x89\xA2",
		"\xE4\x81"=>"\xE8\x89\xA8",
		"\xE4\x82"=>"\xE8\x89\xAA",
		"\xE4\x83"=>"\xE8\x89\xAB",
		"\xE4\x84"=>"\xE8\x88\xAE",
		"\xE4\x85"=>"\xE8\x89\xB1",
		"\xE4\x86"=>"\xE8\x89\xB7",
		"\xE4\x87"=>"\xE8\x89\xB8",
		"\xE4\x88"=>"\xE8\x89\xBE",
		"\xE4\x89"=>"\xE8\x8A\x8D",
		"\xE4\x8A"=>"\xE8\x8A\x92",
		"\xE4\x8B"=>"\xE8\x8A\xAB",
		"\xE4\x8C"=>"\xE8\x8A\x9F",
		"\xE4\x8D"=>"\xE8\x8A\xBB",
		"\xE4\x8E"=>"\xE8\x8A\xAC",
		"\xE4\x8F"=>"\xE8\x8B\xA1",
		"\xE4\x90"=>"\xE8\x8B\xA3",
		"\xE4\x91"=>"\xE8\x8B\x9F",
		"\xE4\x92"=>"\xE8\x8B\x92",
		"\xE4\x93"=>"\xE8\x8B\xB4",
		"\xE4\x94"=>"\xE8\x8B\xB3",
		"\xE4\x95"=>"\xE8\x8B\xBA",
		"\xE4\x96"=>"\xE8\x8E\x93",
		"\xE4\x97"=>"\xE8\x8C\x83",
		"\xE4\x98"=>"\xE8\x8B\xBB",
		"\xE4\x99"=>"\xE8\x8B\xB9",
		"\xE4\x9A"=>"\xE8\x8B\x9E",
		"\xE4\x9B"=>"\xE8\x8C\x86",
		"\xE4\x9C"=>"\xE8\x8B\x9C",
		"\xE4\x9D"=>"\xE8\x8C\x89",
		"\xE4\x9E"=>"\xE8\x8B\x99",
		"\xE4\x9F"=>"\xE8\x8C\xB5",
		"\xE4\xA0"=>"\xE8\x8C\xB4",
		"\xE4\xA1"=>"\xE8\x8C\x96",
		"\xE4\xA2"=>"\xE8\x8C\xB2",
		"\xE4\xA3"=>"\xE8\x8C\xB1",
		"\xE4\xA4"=>"\xE8\x8D\x80",
		"\xE4\xA5"=>"\xE8\x8C\xB9",
		"\xE4\xA6"=>"\xE8\x8D\x90",
		"\xE4\xA7"=>"\xE8\x8D\x85",
		"\xE4\xA8"=>"\xE8\x8C\xAF",
		"\xE4\xA9"=>"\xE8\x8C\xAB",
		"\xE4\xAA"=>"\xE8\x8C\x97",
		"\xE4\xAB"=>"\xE8\x8C\x98",
		"\xE4\xAC"=>"\xE8\x8E\x85",
		"\xE4\xAD"=>"\xE8\x8E\x9A",
		"\xE4\xAE"=>"\xE8\x8E\xAA",
		"\xE4\xAF"=>"\xE8\x8E\x9F",
		"\xE4\xB0"=>"\xE8\x8E\xA2",
		"\xE4\xB1"=>"\xE8\x8E\x96",
		"\xE4\xB2"=>"\xE8\x8C\xA3",
		"\xE4\xB3"=>"\xE8\x8E\x8E",
		"\xE4\xB4"=>"\xE8\x8E\x87",
		"\xE4\xB5"=>"\xE8\x8E\x8A",
		"\xE4\xB6"=>"\xE8\x8D\xBC",
		"\xE4\xB7"=>"\xE8\x8E\xB5",
		"\xE4\xB8"=>"\xE8\x8D\xB3",
		"\xE4\xB9"=>"\xE8\x8D\xB5",
		"\xE4\xBA"=>"\xE8\x8E\xA0",
		"\xE4\xBB"=>"\xE8\x8E\x89",
		"\xE4\xBC"=>"\xE8\x8E\xA8",
		"\xE4\xBD"=>"\xE8\x8F\xB4",
		"\xE4\xBE"=>"\xE8\x90\x93",
		"\xE4\xBF"=>"\xE8\x8F\xAB",
		"\xE4\xC0"=>"\xE8\x8F\x8E",
		"\xE4\xC1"=>"\xE8\x8F\xBD",
		"\xE4\xC2"=>"\xE8\x90\x83",
		"\xE4\xC3"=>"\xE8\x8F\x98",
		"\xE4\xC4"=>"\xE8\x90\x8B",
		"\xE4\xC5"=>"\xE8\x8F\x81",
		"\xE4\xC6"=>"\xE8\x8F\xB7",
		"\xE4\xC7"=>"\xE8\x90\x87",
		"\xE4\xC8"=>"\xE8\x8F\xA0",
		"\xE4\xC9"=>"\xE8\x8F\xB2",
		"\xE4\xCA"=>"\xE8\x90\x8D",
		"\xE4\xCB"=>"\xE8\x90\xA2",
		"\xE4\xCC"=>"\xE8\x90\xA0",
		"\xE4\xCD"=>"\xE8\x8E\xBD",
		"\xE4\xCE"=>"\xE8\x90\xB8",
		"\xE4\xCF"=>"\xE8\x94\x86",
		"\xE4\xD0"=>"\xE8\x8F\xBB",
		"\xE4\xD1"=>"\xE8\x91\xAD",
		"\xE4\xD2"=>"\xE8\x90\xAA",
		"\xE4\xD3"=>"\xE8\x90\xBC",
		"\xE4\xD4"=>"\xE8\x95\x9A",
		"\xE4\xD5"=>"\xE8\x92\x84",
		"\xE4\xD6"=>"\xE8\x91\xB7",
		"\xE4\xD7"=>"\xE8\x91\xAB",
		"\xE4\xD8"=>"\xE8\x92\xAD",
		"\xE4\xD9"=>"\xE8\x91\xAE",
		"\xE4\xDA"=>"\xE8\x92\x82",
		"\xE4\xDB"=>"\xE8\x91\xA9",
		"\xE4\xDC"=>"\xE8\x91\x86",
		"\xE4\xDD"=>"\xE8\x90\xAC",
		"\xE4\xDE"=>"\xE8\x91\xAF",
		"\xE4\xDF"=>"\xE8\x91\xB9",
		"\xE4\xE0"=>"\xE8\x90\xB5",
		"\xE4\xE1"=>"\xE8\x93\x8A",
		"\xE4\xE2"=>"\xE8\x91\xA2",
		"\xE4\xE3"=>"\xE8\x92\xB9",
		"\xE4\xE4"=>"\xE8\x92\xBF",
		"\xE4\xE5"=>"\xE8\x92\x9F",
		"\xE4\xE6"=>"\xE8\x93\x99",
		"\xE4\xE7"=>"\xE8\x93\x8D",
		"\xE4\xE8"=>"\xE8\x92\xBB",
		"\xE4\xE9"=>"\xE8\x93\x9A",
		"\xE4\xEA"=>"\xE8\x93\x90",
		"\xE4\xEB"=>"\xE8\x93\x81",
		"\xE4\xEC"=>"\xE8\x93\x86",
		"\xE4\xED"=>"\xE8\x93\x96",
		"\xE4\xEE"=>"\xE8\x92\xA1",
		"\xE4\xEF"=>"\xE8\x94\xA1",
		"\xE4\xF0"=>"\xE8\x93\xBF",
		"\xE4\xF1"=>"\xE8\x93\xB4",
		"\xE4\xF2"=>"\xE8\x94\x97",
		"\xE4\xF3"=>"\xE8\x94\x98",
		"\xE4\xF4"=>"\xE8\x94\xAC",
		"\xE4\xF5"=>"\xE8\x94\x9F",
		"\xE4\xF6"=>"\xE8\x94\x95",
		"\xE4\xF7"=>"\xE8\x94\x94",
		"\xE4\xF8"=>"\xE8\x93\xBC",
		"\xE4\xF9"=>"\xE8\x95\x80",
		"\xE4\xFA"=>"\xE8\x95\xA3",
		"\xE4\xFB"=>"\xE8\x95\x98",
		"\xE4\xFC"=>"\xE8\x95\x88",
		"\xE5\x40"=>"\xE8\x95\x81",
		"\xE5\x41"=>"\xE8\x98\x82",
		"\xE5\x42"=>"\xE8\x95\x8B",
		"\xE5\x43"=>"\xE8\x95\x95",
		"\xE5\x44"=>"\xE8\x96\x80",
		"\xE5\x45"=>"\xE8\x96\xA4",
		"\xE5\x46"=>"\xE8\x96\x88",
		"\xE5\x47"=>"\xE8\x96\x91",
		"\xE5\x48"=>"\xE8\x96\x8A",
		"\xE5\x49"=>"\xE8\x96\xA8",
		"\xE5\x4A"=>"\xE8\x95\xAD",
		"\xE5\x4B"=>"\xE8\x96\x94",
		"\xE5\x4C"=>"\xE8\x96\x9B",
		"\xE5\x4D"=>"\xE8\x97\xAA",
		"\xE5\x4E"=>"\xE8\x96\x87",
		"\xE5\x4F"=>"\xE8\x96\x9C",
		"\xE5\x50"=>"\xE8\x95\xB7",
		"\xE5\x51"=>"\xE8\x95\xBE",
		"\xE5\x52"=>"\xE8\x96\x90",
		"\xE5\x53"=>"\xE8\x97\x89",
		"\xE5\x54"=>"\xE8\x96\xBA",
		"\xE5\x55"=>"\xE8\x97\x8F",
		"\xE5\x56"=>"\xE8\x96\xB9",
		"\xE5\x57"=>"\xE8\x97\x90",
		"\xE5\x58"=>"\xE8\x97\x95",
		"\xE5\x59"=>"\xE8\x97\x9D",
		"\xE5\x5A"=>"\xE8\x97\xA5",
		"\xE5\x5B"=>"\xE8\x97\x9C",
		"\xE5\x5C"=>"\xE8\x97\xB9",
		"\xE5\x5D"=>"\xE8\x98\x8A",
		"\xE5\x5E"=>"\xE8\x98\x93",
		"\xE5\x5F"=>"\xE8\x98\x8B",
		"\xE5\x60"=>"\xE8\x97\xBE",
		"\xE5\x61"=>"\xE8\x97\xBA",
		"\xE5\x62"=>"\xE8\x98\x86",
		"\xE5\x63"=>"\xE8\x98\xA2",
		"\xE5\x64"=>"\xE8\x98\x9A",
		"\xE5\x65"=>"\xE8\x98\xB0",
		"\xE5\x66"=>"\xE8\x98\xBF",
		"\xE5\x67"=>"\xE8\x99\x8D",
		"\xE5\x68"=>"\xE4\xB9\x95",
		"\xE5\x69"=>"\xE8\x99\x94",
		"\xE5\x6A"=>"\xE8\x99\x9F",
		"\xE5\x6B"=>"\xE8\x99\xA7",
		"\xE5\x6C"=>"\xE8\x99\xB1",
		"\xE5\x6D"=>"\xE8\x9A\x93",
		"\xE5\x6E"=>"\xE8\x9A\xA3",
		"\xE5\x6F"=>"\xE8\x9A\xA9",
		"\xE5\x70"=>"\xE8\x9A\xAA",
		"\xE5\x71"=>"\xE8\x9A\x8B",
		"\xE5\x72"=>"\xE8\x9A\x8C",
		"\xE5\x73"=>"\xE8\x9A\xB6",
		"\xE5\x74"=>"\xE8\x9A\xAF",
		"\xE5\x75"=>"\xE8\x9B\x84",
		"\xE5\x76"=>"\xE8\x9B\x86",
		"\xE5\x77"=>"\xE8\x9A\xB0",
		"\xE5\x78"=>"\xE8\x9B\x89",
		"\xE5\x79"=>"\xE8\xA0\xA3",
		"\xE5\x7A"=>"\xE8\x9A\xAB",
		"\xE5\x7B"=>"\xE8\x9B\x94",
		"\xE5\x7C"=>"\xE8\x9B\x9E",
		"\xE5\x7D"=>"\xE8\x9B\xA9",
		"\xE5\x7E"=>"\xE8\x9B\xAC",
		"\xE5\x80"=>"\xE8\x9B\x9F",
		"\xE5\x81"=>"\xE8\x9B\x9B",
		"\xE5\x82"=>"\xE8\x9B\xAF",
		"\xE5\x83"=>"\xE8\x9C\x92",
		"\xE5\x84"=>"\xE8\x9C\x86",
		"\xE5\x85"=>"\xE8\x9C\x88",
		"\xE5\x86"=>"\xE8\x9C\x80",
		"\xE5\x87"=>"\xE8\x9C\x83",
		"\xE5\x88"=>"\xE8\x9B\xBB",
		"\xE5\x89"=>"\xE8\x9C\x91",
		"\xE5\x8A"=>"\xE8\x9C\x89",
		"\xE5\x8B"=>"\xE8\x9C\x8D",
		"\xE5\x8C"=>"\xE8\x9B\xB9",
		"\xE5\x8D"=>"\xE8\x9C\x8A",
		"\xE5\x8E"=>"\xE8\x9C\xB4",
		"\xE5\x8F"=>"\xE8\x9C\xBF",
		"\xE5\x90"=>"\xE8\x9C\xB7",
		"\xE5\x91"=>"\xE8\x9C\xBB",
		"\xE5\x92"=>"\xE8\x9C\xA5",
		"\xE5\x93"=>"\xE8\x9C\xA9",
		"\xE5\x94"=>"\xE8\x9C\x9A",
		"\xE5\x95"=>"\xE8\x9D\xA0",
		"\xE5\x96"=>"\xE8\x9D\x9F",
		"\xE5\x97"=>"\xE8\x9D\xB8",
		"\xE5\x98"=>"\xE8\x9D\x8C",
		"\xE5\x99"=>"\xE8\x9D\x8E",
		"\xE5\x9A"=>"\xE8\x9D\xB4",
		"\xE5\x9B"=>"\xE8\x9D\x97",
		"\xE5\x9C"=>"\xE8\x9D\xA8",
		"\xE5\x9D"=>"\xE8\x9D\xAE",
		"\xE5\x9E"=>"\xE8\x9D\x99",
		"\xE5\x9F"=>"\xE8\x9D\x93",
		"\xE5\xA0"=>"\xE8\x9D\xA3",
		"\xE5\xA1"=>"\xE8\x9D\xAA",
		"\xE5\xA2"=>"\xE8\xA0\x85",
		"\xE5\xA3"=>"\xE8\x9E\xA2",
		"\xE5\xA4"=>"\xE8\x9E\x9F",
		"\xE5\xA5"=>"\xE8\x9E\x82",
		"\xE5\xA6"=>"\xE8\x9E\xAF",
		"\xE5\xA7"=>"\xE8\x9F\x8B",
		"\xE5\xA8"=>"\xE8\x9E\xBD",
		"\xE5\xA9"=>"\xE8\x9F\x80",
		"\xE5\xAA"=>"\xE8\x9F\x90",
		"\xE5\xAB"=>"\xE9\x9B\x96",
		"\xE5\xAC"=>"\xE8\x9E\xAB",
		"\xE5\xAD"=>"\xE8\x9F\x84",
		"\xE5\xAE"=>"\xE8\x9E\xB3",
		"\xE5\xAF"=>"\xE8\x9F\x87",
		"\xE5\xB0"=>"\xE8\x9F\x86",
		"\xE5\xB1"=>"\xE8\x9E\xBB",
		"\xE5\xB2"=>"\xE8\x9F\xAF",
		"\xE5\xB3"=>"\xE8\x9F\xB2",
		"\xE5\xB4"=>"\xE8\x9F\xA0",
		"\xE5\xB5"=>"\xE8\xA0\x8F",
		"\xE5\xB6"=>"\xE8\xA0\x8D",
		"\xE5\xB7"=>"\xE8\x9F\xBE",
		"\xE5\xB8"=>"\xE8\x9F\xB6",
		"\xE5\xB9"=>"\xE8\x9F\xB7",
		"\xE5\xBA"=>"\xE8\xA0\x8E",
		"\xE5\xBB"=>"\xE8\x9F\x92",
		"\xE5\xBC"=>"\xE8\xA0\x91",
		"\xE5\xBD"=>"\xE8\xA0\x96",
		"\xE5\xBE"=>"\xE8\xA0\x95",
		"\xE5\xBF"=>"\xE8\xA0\xA2",
		"\xE5\xC0"=>"\xE8\xA0\xA1",
		"\xE5\xC1"=>"\xE8\xA0\xB1",
		"\xE5\xC2"=>"\xE8\xA0\xB6",
		"\xE5\xC3"=>"\xE8\xA0\xB9",
		"\xE5\xC4"=>"\xE8\xA0\xA7",
		"\xE5\xC5"=>"\xE8\xA0\xBB",
		"\xE5\xC6"=>"\xE8\xA1\x84",
		"\xE5\xC7"=>"\xE8\xA1\x82",
		"\xE5\xC8"=>"\xE8\xA1\x92",
		"\xE5\xC9"=>"\xE8\xA1\x99",
		"\xE5\xCA"=>"\xE8\xA1\x9E",
		"\xE5\xCB"=>"\xE8\xA1\xA2",
		"\xE5\xCC"=>"\xE8\xA1\xAB",
		"\xE5\xCD"=>"\xE8\xA2\x81",
		"\xE5\xCE"=>"\xE8\xA1\xBE",
		"\xE5\xCF"=>"\xE8\xA2\x9E",
		"\xE5\xD0"=>"\xE8\xA1\xB5",
		"\xE5\xD1"=>"\xE8\xA1\xBD",
		"\xE5\xD2"=>"\xE8\xA2\xB5",
		"\xE5\xD3"=>"\xE8\xA1\xB2",
		"\xE5\xD4"=>"\xE8\xA2\x82",
		"\xE5\xD5"=>"\xE8\xA2\x97",
		"\xE5\xD6"=>"\xE8\xA2\x92",
		"\xE5\xD7"=>"\xE8\xA2\xAE",
		"\xE5\xD8"=>"\xE8\xA2\x99",
		"\xE5\xD9"=>"\xE8\xA2\xA2",
		"\xE5\xDA"=>"\xE8\xA2\x8D",
		"\xE5\xDB"=>"\xE8\xA2\xA4",
		"\xE5\xDC"=>"\xE8\xA2\xB0",
		"\xE5\xDD"=>"\xE8\xA2\xBF",
		"\xE5\xDE"=>"\xE8\xA2\xB1",
		"\xE5\xDF"=>"\xE8\xA3\x83",
		"\xE5\xE0"=>"\xE8\xA3\x84",
		"\xE5\xE1"=>"\xE8\xA3\x94",
		"\xE5\xE2"=>"\xE8\xA3\x98",
		"\xE5\xE3"=>"\xE8\xA3\x99",
		"\xE5\xE4"=>"\xE8\xA3\x9D",
		"\xE5\xE5"=>"\xE8\xA3\xB9",
		"\xE5\xE6"=>"\xE8\xA4\x82",
		"\xE5\xE7"=>"\xE8\xA3\xBC",
		"\xE5\xE8"=>"\xE8\xA3\xB4",
		"\xE5\xE9"=>"\xE8\xA3\xA8",
		"\xE5\xEA"=>"\xE8\xA3\xB2",
		"\xE5\xEB"=>"\xE8\xA4\x84",
		"\xE5\xEC"=>"\xE8\xA4\x8C",
		"\xE5\xED"=>"\xE8\xA4\x8A",
		"\xE5\xEE"=>"\xE8\xA4\x93",
		"\xE5\xEF"=>"\xE8\xA5\x83",
		"\xE5\xF0"=>"\xE8\xA4\x9E",
		"\xE5\xF1"=>"\xE8\xA4\xA5",
		"\xE5\xF2"=>"\xE8\xA4\xAA",
		"\xE5\xF3"=>"\xE8\xA4\xAB",
		"\xE5\xF4"=>"\xE8\xA5\x81",
		"\xE5\xF5"=>"\xE8\xA5\x84",
		"\xE5\xF6"=>"\xE8\xA4\xBB",
		"\xE5\xF7"=>"\xE8\xA4\xB6",
		"\xE5\xF8"=>"\xE8\xA4\xB8",
		"\xE5\xF9"=>"\xE8\xA5\x8C",
		"\xE5\xFA"=>"\xE8\xA4\x9D",
		"\xE5\xFB"=>"\xE8\xA5\xA0",
		"\xE5\xFC"=>"\xE8\xA5\x9E",
		"\xE6\x40"=>"\xE8\xA5\xA6",
		"\xE6\x41"=>"\xE8\xA5\xA4",
		"\xE6\x42"=>"\xE8\xA5\xAD",
		"\xE6\x43"=>"\xE8\xA5\xAA",
		"\xE6\x44"=>"\xE8\xA5\xAF",
		"\xE6\x45"=>"\xE8\xA5\xB4",
		"\xE6\x46"=>"\xE8\xA5\xB7",
		"\xE6\x47"=>"\xE8\xA5\xBE",
		"\xE6\x48"=>"\xE8\xA6\x83",
		"\xE6\x49"=>"\xE8\xA6\x88",
		"\xE6\x4A"=>"\xE8\xA6\x8A",
		"\xE6\x4B"=>"\xE8\xA6\x93",
		"\xE6\x4C"=>"\xE8\xA6\x98",
		"\xE6\x4D"=>"\xE8\xA6\xA1",
		"\xE6\x4E"=>"\xE8\xA6\xA9",
		"\xE6\x4F"=>"\xE8\xA6\xA6",
		"\xE6\x50"=>"\xE8\xA6\xAC",
		"\xE6\x51"=>"\xE8\xA6\xAF",
		"\xE6\x52"=>"\xE8\xA6\xB2",
		"\xE6\x53"=>"\xE8\xA6\xBA",
		"\xE6\x54"=>"\xE8\xA6\xBD",
		"\xE6\x55"=>"\xE8\xA6\xBF",
		"\xE6\x56"=>"\xE8\xA7\x80",
		"\xE6\x57"=>"\xE8\xA7\x9A",
		"\xE6\x58"=>"\xE8\xA7\x9C",
		"\xE6\x59"=>"\xE8\xA7\x9D",
		"\xE6\x5A"=>"\xE8\xA7\xA7",
		"\xE6\x5B"=>"\xE8\xA7\xB4",
		"\xE6\x5C"=>"\xE8\xA7\xB8",
		"\xE6\x5D"=>"\xE8\xA8\x83",
		"\xE6\x5E"=>"\xE8\xA8\x96",
		"\xE6\x5F"=>"\xE8\xA8\x90",
		"\xE6\x60"=>"\xE8\xA8\x8C",
		"\xE6\x61"=>"\xE8\xA8\x9B",
		"\xE6\x62"=>"\xE8\xA8\x9D",
		"\xE6\x63"=>"\xE8\xA8\xA5",
		"\xE6\x64"=>"\xE8\xA8\xB6",
		"\xE6\x65"=>"\xE8\xA9\x81",
		"\xE6\x66"=>"\xE8\xA9\x9B",
		"\xE6\x67"=>"\xE8\xA9\x92",
		"\xE6\x68"=>"\xE8\xA9\x86",
		"\xE6\x69"=>"\xE8\xA9\x88",
		"\xE6\x6A"=>"\xE8\xA9\xBC",
		"\xE6\x6B"=>"\xE8\xA9\xAD",
		"\xE6\x6C"=>"\xE8\xA9\xAC",
		"\xE6\x6D"=>"\xE8\xA9\xA2",
		"\xE6\x6E"=>"\xE8\xAA\x85",
		"\xE6\x6F"=>"\xE8\xAA\x82",
		"\xE6\x70"=>"\xE8\xAA\x84",
		"\xE6\x71"=>"\xE8\xAA\xA8",
		"\xE6\x72"=>"\xE8\xAA\xA1",
		"\xE6\x73"=>"\xE8\xAA\x91",
		"\xE6\x74"=>"\xE8\xAA\xA5",
		"\xE6\x75"=>"\xE8\xAA\xA6",
		"\xE6\x76"=>"\xE8\xAA\x9A",
		"\xE6\x77"=>"\xE8\xAA\xA3",
		"\xE6\x78"=>"\xE8\xAB\x84",
		"\xE6\x79"=>"\xE8\xAB\x8D",
		"\xE6\x7A"=>"\xE8\xAB\x82",
		"\xE6\x7B"=>"\xE8\xAB\x9A",
		"\xE6\x7C"=>"\xE8\xAB\xAB",
		"\xE6\x7D"=>"\xE8\xAB\xB3",
		"\xE6\x7E"=>"\xE8\xAB\xA7",
		"\xE6\x80"=>"\xE8\xAB\xA4",
		"\xE6\x81"=>"\xE8\xAB\xB1",
		"\xE6\x82"=>"\xE8\xAC\x94",
		"\xE6\x83"=>"\xE8\xAB\xA0",
		"\xE6\x84"=>"\xE8\xAB\xA2",
		"\xE6\x85"=>"\xE8\xAB\xB7",
		"\xE6\x86"=>"\xE8\xAB\x9E",
		"\xE6\x87"=>"\xE8\xAB\x9B",
		"\xE6\x88"=>"\xE8\xAC\x8C",
		"\xE6\x89"=>"\xE8\xAC\x87",
		"\xE6\x8A"=>"\xE8\xAC\x9A",
		"\xE6\x8B"=>"\xE8\xAB\xA1",
		"\xE6\x8C"=>"\xE8\xAC\x96",
		"\xE6\x8D"=>"\xE8\xAC\x90",
		"\xE6\x8E"=>"\xE8\xAC\x97",
		"\xE6\x8F"=>"\xE8\xAC\xA0",
		"\xE6\x90"=>"\xE8\xAC\xB3",
		"\xE6\x91"=>"\xE9\x9E\xAB",
		"\xE6\x92"=>"\xE8\xAC\xA6",
		"\xE6\x93"=>"\xE8\xAC\xAB",
		"\xE6\x94"=>"\xE8\xAC\xBE",
		"\xE6\x95"=>"\xE8\xAC\xA8",
		"\xE6\x96"=>"\xE8\xAD\x81",
		"\xE6\x97"=>"\xE8\xAD\x8C",
		"\xE6\x98"=>"\xE8\xAD\x8F",
		"\xE6\x99"=>"\xE8\xAD\x8E",
		"\xE6\x9A"=>"\xE8\xAD\x89",
		"\xE6\x9B"=>"\xE8\xAD\x96",
		"\xE6\x9C"=>"\xE8\xAD\x9B",
		"\xE6\x9D"=>"\xE8\xAD\x9A",
		"\xE6\x9E"=>"\xE8\xAD\xAB",
		"\xE6\x9F"=>"\xE8\xAD\x9F",
		"\xE6\xA0"=>"\xE8\xAD\xAC",
		"\xE6\xA1"=>"\xE8\xAD\xAF",
		"\xE6\xA2"=>"\xE8\xAD\xB4",
		"\xE6\xA3"=>"\xE8\xAD\xBD",
		"\xE6\xA4"=>"\xE8\xAE\x80",
		"\xE6\xA5"=>"\xE8\xAE\x8C",
		"\xE6\xA6"=>"\xE8\xAE\x8E",
		"\xE6\xA7"=>"\xE8\xAE\x92",
		"\xE6\xA8"=>"\xE8\xAE\x93",
		"\xE6\xA9"=>"\xE8\xAE\x96",
		"\xE6\xAA"=>"\xE8\xAE\x99",
		"\xE6\xAB"=>"\xE8\xAE\x9A",
		"\xE6\xAC"=>"\xE8\xB0\xBA",
		"\xE6\xAD"=>"\xE8\xB1\x81",
		"\xE6\xAE"=>"\xE8\xB0\xBF",
		"\xE6\xAF"=>"\xE8\xB1\x88",
		"\xE6\xB0"=>"\xE8\xB1\x8C",
		"\xE6\xB1"=>"\xE8\xB1\x8E",
		"\xE6\xB2"=>"\xE8\xB1\x90",
		"\xE6\xB3"=>"\xE8\xB1\x95",
		"\xE6\xB4"=>"\xE8\xB1\xA2",
		"\xE6\xB5"=>"\xE8\xB1\xAC",
		"\xE6\xB6"=>"\xE8\xB1\xB8",
		"\xE6\xB7"=>"\xE8\xB1\xBA",
		"\xE6\xB8"=>"\xE8\xB2\x82",
		"\xE6\xB9"=>"\xE8\xB2\x89",
		"\xE6\xBA"=>"\xE8\xB2\x85",
		"\xE6\xBB"=>"\xE8\xB2\x8A",
		"\xE6\xBC"=>"\xE8\xB2\x8D",
		"\xE6\xBD"=>"\xE8\xB2\x8E",
		"\xE6\xBE"=>"\xE8\xB2\x94",
		"\xE6\xBF"=>"\xE8\xB1\xBC",
		"\xE6\xC0"=>"\xE8\xB2\x98",
		"\xE6\xC1"=>"\xE6\x88\x9D",
		"\xE6\xC2"=>"\xE8\xB2\xAD",
		"\xE6\xC3"=>"\xE8\xB2\xAA",
		"\xE6\xC4"=>"\xE8\xB2\xBD",
		"\xE6\xC5"=>"\xE8\xB2\xB2",
		"\xE6\xC6"=>"\xE8\xB2\xB3",
		"\xE6\xC7"=>"\xE8\xB2\xAE",
		"\xE6\xC8"=>"\xE8\xB2\xB6",
		"\xE6\xC9"=>"\xE8\xB3\x88",
		"\xE6\xCA"=>"\xE8\xB3\x81",
		"\xE6\xCB"=>"\xE8\xB3\xA4",
		"\xE6\xCC"=>"\xE8\xB3\xA3",
		"\xE6\xCD"=>"\xE8\xB3\x9A",
		"\xE6\xCE"=>"\xE8\xB3\xBD",
		"\xE6\xCF"=>"\xE8\xB3\xBA",
		"\xE6\xD0"=>"\xE8\xB3\xBB",
		"\xE6\xD1"=>"\xE8\xB4\x84",
		"\xE6\xD2"=>"\xE8\xB4\x85",
		"\xE6\xD3"=>"\xE8\xB4\x8A",
		"\xE6\xD4"=>"\xE8\xB4\x87",
		"\xE6\xD5"=>"\xE8\xB4\x8F",
		"\xE6\xD6"=>"\xE8\xB4\x8D",
		"\xE6\xD7"=>"\xE8\xB4\x90",
		"\xE6\xD8"=>"\xE9\xBD\x8E",
		"\xE6\xD9"=>"\xE8\xB4\x93",
		"\xE6\xDA"=>"\xE8\xB3\x8D",
		"\xE6\xDB"=>"\xE8\xB4\x94",
		"\xE6\xDC"=>"\xE8\xB4\x96",
		"\xE6\xDD"=>"\xE8\xB5\xA7",
		"\xE6\xDE"=>"\xE8\xB5\xAD",
		"\xE6\xDF"=>"\xE8\xB5\xB1",
		"\xE6\xE0"=>"\xE8\xB5\xB3",
		"\xE6\xE1"=>"\xE8\xB6\x81",
		"\xE6\xE2"=>"\xE8\xB6\x99",
		"\xE6\xE3"=>"\xE8\xB7\x82",
		"\xE6\xE4"=>"\xE8\xB6\xBE",
		"\xE6\xE5"=>"\xE8\xB6\xBA",
		"\xE6\xE6"=>"\xE8\xB7\x8F",
		"\xE6\xE7"=>"\xE8\xB7\x9A",
		"\xE6\xE8"=>"\xE8\xB7\x96",
		"\xE6\xE9"=>"\xE8\xB7\x8C",
		"\xE6\xEA"=>"\xE8\xB7\x9B",
		"\xE6\xEB"=>"\xE8\xB7\x8B",
		"\xE6\xEC"=>"\xE8\xB7\xAA",
		"\xE6\xED"=>"\xE8\xB7\xAB",
		"\xE6\xEE"=>"\xE8\xB7\x9F",
		"\xE6\xEF"=>"\xE8\xB7\xA3",
		"\xE6\xF0"=>"\xE8\xB7\xBC",
		"\xE6\xF1"=>"\xE8\xB8\x88",
		"\xE6\xF2"=>"\xE8\xB8\x89",
		"\xE6\xF3"=>"\xE8\xB7\xBF",
		"\xE6\xF4"=>"\xE8\xB8\x9D",
		"\xE6\xF5"=>"\xE8\xB8\x9E",
		"\xE6\xF6"=>"\xE8\xB8\x90",
		"\xE6\xF7"=>"\xE8\xB8\x9F",
		"\xE6\xF8"=>"\xE8\xB9\x82",
		"\xE6\xF9"=>"\xE8\xB8\xB5",
		"\xE6\xFA"=>"\xE8\xB8\xB0",
		"\xE6\xFB"=>"\xE8\xB8\xB4",
		"\xE6\xFC"=>"\xE8\xB9\x8A",
		"\xE7\x40"=>"\xE8\xB9\x87",
		"\xE7\x41"=>"\xE8\xB9\x89",
		"\xE7\x42"=>"\xE8\xB9\x8C",
		"\xE7\x43"=>"\xE8\xB9\x90",
		"\xE7\x44"=>"\xE8\xB9\x88",
		"\xE7\x45"=>"\xE8\xB9\x99",
		"\xE7\x46"=>"\xE8\xB9\xA4",
		"\xE7\x47"=>"\xE8\xB9\xA0",
		"\xE7\x48"=>"\xE8\xB8\xAA",
		"\xE7\x49"=>"\xE8\xB9\xA3",
		"\xE7\x4A"=>"\xE8\xB9\x95",
		"\xE7\x4B"=>"\xE8\xB9\xB6",
		"\xE7\x4C"=>"\xE8\xB9\xB2",
		"\xE7\x4D"=>"\xE8\xB9\xBC",
		"\xE7\x4E"=>"\xE8\xBA\x81",
		"\xE7\x4F"=>"\xE8\xBA\x87",
		"\xE7\x50"=>"\xE8\xBA\x85",
		"\xE7\x51"=>"\xE8\xBA\x84",
		"\xE7\x52"=>"\xE8\xBA\x8B",
		"\xE7\x53"=>"\xE8\xBA\x8A",
		"\xE7\x54"=>"\xE8\xBA\x93",
		"\xE7\x55"=>"\xE8\xBA\x91",
		"\xE7\x56"=>"\xE8\xBA\x94",
		"\xE7\x57"=>"\xE8\xBA\x99",
		"\xE7\x58"=>"\xE8\xBA\xAA",
		"\xE7\x59"=>"\xE8\xBA\xA1",
		"\xE7\x5A"=>"\xE8\xBA\xAC",
		"\xE7\x5B"=>"\xE8\xBA\xB0",
		"\xE7\x5C"=>"\xE8\xBB\x86",
		"\xE7\x5D"=>"\xE8\xBA\xB1",
		"\xE7\x5E"=>"\xE8\xBA\xBE",
		"\xE7\x5F"=>"\xE8\xBB\x85",
		"\xE7\x60"=>"\xE8\xBB\x88",
		"\xE7\x61"=>"\xE8\xBB\x8B",
		"\xE7\x62"=>"\xE8\xBB\x9B",
		"\xE7\x63"=>"\xE8\xBB\xA3",
		"\xE7\x64"=>"\xE8\xBB\xBC",
		"\xE7\x65"=>"\xE8\xBB\xBB",
		"\xE7\x66"=>"\xE8\xBB\xAB",
		"\xE7\x67"=>"\xE8\xBB\xBE",
		"\xE7\x68"=>"\xE8\xBC\x8A",
		"\xE7\x69"=>"\xE8\xBC\x85",
		"\xE7\x6A"=>"\xE8\xBC\x95",
		"\xE7\x6B"=>"\xE8\xBC\x92",
		"\xE7\x6C"=>"\xE8\xBC\x99",
		"\xE7\x6D"=>"\xE8\xBC\x93",
		"\xE7\x6E"=>"\xE8\xBC\x9C",
		"\xE7\x6F"=>"\xE8\xBC\x9F",
		"\xE7\x70"=>"\xE8\xBC\x9B",
		"\xE7\x71"=>"\xE8\xBC\x8C",
		"\xE7\x72"=>"\xE8\xBC\xA6",
		"\xE7\x73"=>"\xE8\xBC\xB3",
		"\xE7\x74"=>"\xE8\xBC\xBB",
		"\xE7\x75"=>"\xE8\xBC\xB9",
		"\xE7\x76"=>"\xE8\xBD\x85",
		"\xE7\x77"=>"\xE8\xBD\x82",
		"\xE7\x78"=>"\xE8\xBC\xBE",
		"\xE7\x79"=>"\xE8\xBD\x8C",
		"\xE7\x7A"=>"\xE8\xBD\x89",
		"\xE7\x7B"=>"\xE8\xBD\x86",
		"\xE7\x7C"=>"\xE8\xBD\x8E",
		"\xE7\x7D"=>"\xE8\xBD\x97",
		"\xE7\x7E"=>"\xE8\xBD\x9C",
		"\xE7\x80"=>"\xE8\xBD\xA2",
		"\xE7\x81"=>"\xE8\xBD\xA3",
		"\xE7\x82"=>"\xE8\xBD\xA4",
		"\xE7\x83"=>"\xE8\xBE\x9C",
		"\xE7\x84"=>"\xE8\xBE\x9F",
		"\xE7\x85"=>"\xE8\xBE\xA3",
		"\xE7\x86"=>"\xE8\xBE\xAD",
		"\xE7\x87"=>"\xE8\xBE\xAF",
		"\xE7\x88"=>"\xE8\xBE\xB7",
		"\xE7\x89"=>"\xE8\xBF\x9A",
		"\xE7\x8A"=>"\xE8\xBF\xA5",
		"\xE7\x8B"=>"\xE8\xBF\xA2",
		"\xE7\x8C"=>"\xE8\xBF\xAA",
		"\xE7\x8D"=>"\xE8\xBF\xAF",
		"\xE7\x8E"=>"\xE9\x82\x87",
		"\xE7\x8F"=>"\xE8\xBF\xB4",
		"\xE7\x90"=>"\xE9\x80\x85",
		"\xE7\x91"=>"\xE8\xBF\xB9",
		"\xE7\x92"=>"\xE8\xBF\xBA",
		"\xE7\x93"=>"\xE9\x80\x91",
		"\xE7\x94"=>"\xE9\x80\x95",
		"\xE7\x95"=>"\xE9\x80\xA1",
		"\xE7\x96"=>"\xE9\x80\x8D",
		"\xE7\x97"=>"\xE9\x80\x9E",
		"\xE7\x98"=>"\xE9\x80\x96",
		"\xE7\x99"=>"\xE9\x80\x8B",
		"\xE7\x9A"=>"\xE9\x80\xA7",
		"\xE7\x9B"=>"\xE9\x80\xB6",
		"\xE7\x9C"=>"\xE9\x80\xB5",
		"\xE7\x9D"=>"\xE9\x80\xB9",
		"\xE7\x9E"=>"\xE8\xBF\xB8",
		"\xE7\x9F"=>"\xE9\x81\x8F",
		"\xE7\xA0"=>"\xE9\x81\x90",
		"\xE7\xA1"=>"\xE9\x81\x91",
		"\xE7\xA2"=>"\xE9\x81\x92",
		"\xE7\xA3"=>"\xE9\x80\x8E",
		"\xE7\xA4"=>"\xE9\x81\x89",
		"\xE7\xA5"=>"\xE9\x80\xBE",
		"\xE7\xA6"=>"\xE9\x81\x96",
		"\xE7\xA7"=>"\xE9\x81\x98",
		"\xE7\xA8"=>"\xE9\x81\x9E",
		"\xE7\xA9"=>"\xE9\x81\xA8",
		"\xE7\xAA"=>"\xE9\x81\xAF",
		"\xE7\xAB"=>"\xE9\x81\xB6",
		"\xE7\xAC"=>"\xE9\x9A\xA8",
		"\xE7\xAD"=>"\xE9\x81\xB2",
		"\xE7\xAE"=>"\xE9\x82\x82",
		"\xE7\xAF"=>"\xE9\x81\xBD",
		"\xE7\xB0"=>"\xE9\x82\x81",
		"\xE7\xB1"=>"\xE9\x82\x80",
		"\xE7\xB2"=>"\xE9\x82\x8A",
		"\xE7\xB3"=>"\xE9\x82\x89",
		"\xE7\xB4"=>"\xE9\x82\x8F",
		"\xE7\xB5"=>"\xE9\x82\xA8",
		"\xE7\xB6"=>"\xE9\x82\xAF",
		"\xE7\xB7"=>"\xE9\x82\xB1",
		"\xE7\xB8"=>"\xE9\x82\xB5",
		"\xE7\xB9"=>"\xE9\x83\xA2",
		"\xE7\xBA"=>"\xE9\x83\xA4",
		"\xE7\xBB"=>"\xE6\x89\x88",
		"\xE7\xBC"=>"\xE9\x83\x9B",
		"\xE7\xBD"=>"\xE9\x84\x82",
		"\xE7\xBE"=>"\xE9\x84\x92",
		"\xE7\xBF"=>"\xE9\x84\x99",
		"\xE7\xC0"=>"\xE9\x84\xB2",
		"\xE7\xC1"=>"\xE9\x84\xB0",
		"\xE7\xC2"=>"\xE9\x85\x8A",
		"\xE7\xC3"=>"\xE9\x85\x96",
		"\xE7\xC4"=>"\xE9\x85\x98",
		"\xE7\xC5"=>"\xE9\x85\xA3",
		"\xE7\xC6"=>"\xE9\x85\xA5",
		"\xE7\xC7"=>"\xE9\x85\xA9",
		"\xE7\xC8"=>"\xE9\x85\xB3",
		"\xE7\xC9"=>"\xE9\x85\xB2",
		"\xE7\xCA"=>"\xE9\x86\x8B",
		"\xE7\xCB"=>"\xE9\x86\x89",
		"\xE7\xCC"=>"\xE9\x86\x82",
		"\xE7\xCD"=>"\xE9\x86\xA2",
		"\xE7\xCE"=>"\xE9\x86\xAB",
		"\xE7\xCF"=>"\xE9\x86\xAF",
		"\xE7\xD0"=>"\xE9\x86\xAA",
		"\xE7\xD1"=>"\xE9\x86\xB5",
		"\xE7\xD2"=>"\xE9\x86\xB4",
		"\xE7\xD3"=>"\xE9\x86\xBA",
		"\xE7\xD4"=>"\xE9\x87\x80",
		"\xE7\xD5"=>"\xE9\x87\x81",
		"\xE7\xD6"=>"\xE9\x87\x89",
		"\xE7\xD7"=>"\xE9\x87\x8B",
		"\xE7\xD8"=>"\xE9\x87\x90",
		"\xE7\xD9"=>"\xE9\x87\x96",
		"\xE7\xDA"=>"\xE9\x87\x9F",
		"\xE7\xDB"=>"\xE9\x87\xA1",
		"\xE7\xDC"=>"\xE9\x87\x9B",
		"\xE7\xDD"=>"\xE9\x87\xBC",
		"\xE7\xDE"=>"\xE9\x87\xB5",
		"\xE7\xDF"=>"\xE9\x87\xB6",
		"\xE7\xE0"=>"\xE9\x88\x9E",
		"\xE7\xE1"=>"\xE9\x87\xBF",
		"\xE7\xE2"=>"\xE9\x88\x94",
		"\xE7\xE3"=>"\xE9\x88\xAC",
		"\xE7\xE4"=>"\xE9\x88\x95",
		"\xE7\xE5"=>"\xE9\x88\x91",
		"\xE7\xE6"=>"\xE9\x89\x9E",
		"\xE7\xE7"=>"\xE9\x89\x97",
		"\xE7\xE8"=>"\xE9\x89\x85",
		"\xE7\xE9"=>"\xE9\x89\x89",
		"\xE7\xEA"=>"\xE9\x89\xA4",
		"\xE7\xEB"=>"\xE9\x89\x88",
		"\xE7\xEC"=>"\xE9\x8A\x95",
		"\xE7\xED"=>"\xE9\x88\xBF",
		"\xE7\xEE"=>"\xE9\x89\x8B",
		"\xE7\xEF"=>"\xE9\x89\x90",
		"\xE7\xF0"=>"\xE9\x8A\x9C",
		"\xE7\xF1"=>"\xE9\x8A\x96",
		"\xE7\xF2"=>"\xE9\x8A\x93",
		"\xE7\xF3"=>"\xE9\x8A\x9B",
		"\xE7\xF4"=>"\xE9\x89\x9A",
		"\xE7\xF5"=>"\xE9\x8B\x8F",
		"\xE7\xF6"=>"\xE9\x8A\xB9",
		"\xE7\xF7"=>"\xE9\x8A\xB7",
		"\xE7\xF8"=>"\xE9\x8B\xA9",
		"\xE7\xF9"=>"\xE9\x8C\x8F",
		"\xE7\xFA"=>"\xE9\x8B\xBA",
		"\xE7\xFB"=>"\xE9\x8D\x84",
		"\xE7\xFC"=>"\xE9\x8C\xAE",
		"\xE8\x40"=>"\xE9\x8C\x99",
		"\xE8\x41"=>"\xE9\x8C\xA2",
		"\xE8\x42"=>"\xE9\x8C\x9A",
		"\xE8\x43"=>"\xE9\x8C\xA3",
		"\xE8\x44"=>"\xE9\x8C\xBA",
		"\xE8\x45"=>"\xE9\x8C\xB5",
		"\xE8\x46"=>"\xE9\x8C\xBB",
		"\xE8\x47"=>"\xE9\x8D\x9C",
		"\xE8\x48"=>"\xE9\x8D\xA0",
		"\xE8\x49"=>"\xE9\x8D\xBC",
		"\xE8\x4A"=>"\xE9\x8D\xAE",
		"\xE8\x4B"=>"\xE9\x8D\x96",
		"\xE8\x4C"=>"\xE9\x8E\xB0",
		"\xE8\x4D"=>"\xE9\x8E\xAC",
		"\xE8\x4E"=>"\xE9\x8E\xAD",
		"\xE8\x4F"=>"\xE9\x8E\x94",
		"\xE8\x50"=>"\xE9\x8E\xB9",
		"\xE8\x51"=>"\xE9\x8F\x96",
		"\xE8\x52"=>"\xE9\x8F\x97",
		"\xE8\x53"=>"\xE9\x8F\xA8",
		"\xE8\x54"=>"\xE9\x8F\xA5",
		"\xE8\x55"=>"\xE9\x8F\x98",
		"\xE8\x56"=>"\xE9\x8F\x83",
		"\xE8\x57"=>"\xE9\x8F\x9D",
		"\xE8\x58"=>"\xE9\x8F\x90",
		"\xE8\x59"=>"\xE9\x8F\x88",
		"\xE8\x5A"=>"\xE9\x8F\xA4",
		"\xE8\x5B"=>"\xE9\x90\x9A",
		"\xE8\x5C"=>"\xE9\x90\x94",
		"\xE8\x5D"=>"\xE9\x90\x93",
		"\xE8\x5E"=>"\xE9\x90\x83",
		"\xE8\x5F"=>"\xE9\x90\x87",
		"\xE8\x60"=>"\xE9\x90\x90",
		"\xE8\x61"=>"\xE9\x90\xB6",
		"\xE8\x62"=>"\xE9\x90\xAB",
		"\xE8\x63"=>"\xE9\x90\xB5",
		"\xE8\x64"=>"\xE9\x90\xA1",
		"\xE8\x65"=>"\xE9\x90\xBA",
		"\xE8\x66"=>"\xE9\x91\x81",
		"\xE8\x67"=>"\xE9\x91\x92",
		"\xE8\x68"=>"\xE9\x91\x84",
		"\xE8\x69"=>"\xE9\x91\x9B",
		"\xE8\x6A"=>"\xE9\x91\xA0",
		"\xE8\x6B"=>"\xE9\x91\xA2",
		"\xE8\x6C"=>"\xE9\x91\x9E",
		"\xE8\x6D"=>"\xE9\x91\xAA",
		"\xE8\x6E"=>"\xE9\x88\xA9",
		"\xE8\x6F"=>"\xE9\x91\xB0",
		"\xE8\x70"=>"\xE9\x91\xB5",
		"\xE8\x71"=>"\xE9\x91\xB7",
		"\xE8\x72"=>"\xE9\x91\xBD",
		"\xE8\x73"=>"\xE9\x91\x9A",
		"\xE8\x74"=>"\xE9\x91\xBC",
		"\xE8\x75"=>"\xE9\x91\xBE",
		"\xE8\x76"=>"\xE9\x92\x81",
		"\xE8\x77"=>"\xE9\x91\xBF",
		"\xE8\x78"=>"\xE9\x96\x82",
		"\xE8\x79"=>"\xE9\x96\x87",
		"\xE8\x7A"=>"\xE9\x96\x8A",
		"\xE8\x7B"=>"\xE9\x96\x94",
		"\xE8\x7C"=>"\xE9\x96\x96",
		"\xE8\x7D"=>"\xE9\x96\x98",
		"\xE8\x7E"=>"\xE9\x96\x99",
		"\xE8\x80"=>"\xE9\x96\xA0",
		"\xE8\x81"=>"\xE9\x96\xA8",
		"\xE8\x82"=>"\xE9\x96\xA7",
		"\xE8\x83"=>"\xE9\x96\xAD",
		"\xE8\x84"=>"\xE9\x96\xBC",
		"\xE8\x85"=>"\xE9\x96\xBB",
		"\xE8\x86"=>"\xE9\x96\xB9",
		"\xE8\x87"=>"\xE9\x96\xBE",
		"\xE8\x88"=>"\xE9\x97\x8A",
		"\xE8\x89"=>"\xE6\xBF\xB6",
		"\xE8\x8A"=>"\xE9\x97\x83",
		"\xE8\x8B"=>"\xE9\x97\x8D",
		"\xE8\x8C"=>"\xE9\x97\x8C",
		"\xE8\x8D"=>"\xE9\x97\x95",
		"\xE8\x8E"=>"\xE9\x97\x94",
		"\xE8\x8F"=>"\xE9\x97\x96",
		"\xE8\x90"=>"\xE9\x97\x9C",
		"\xE8\x91"=>"\xE9\x97\xA1",
		"\xE8\x92"=>"\xE9\x97\xA5",
		"\xE8\x93"=>"\xE9\x97\xA2",
		"\xE8\x94"=>"\xE9\x98\xA1",
		"\xE8\x95"=>"\xE9\x98\xA8",
		"\xE8\x96"=>"\xE9\x98\xAE",
		"\xE8\x97"=>"\xE9\x98\xAF",
		"\xE8\x98"=>"\xE9\x99\x82",
		"\xE8\x99"=>"\xE9\x99\x8C",
		"\xE8\x9A"=>"\xE9\x99\x8F",
		"\xE8\x9B"=>"\xE9\x99\x8B",
		"\xE8\x9C"=>"\xE9\x99\xB7",
		"\xE8\x9D"=>"\xE9\x99\x9C",
		"\xE8\x9E"=>"\xE9\x99\x9E",
		"\xE8\x9F"=>"\xE9\x99\x9D",
		"\xE8\xA0"=>"\xE9\x99\x9F",
		"\xE8\xA1"=>"\xE9\x99\xA6",
		"\xE8\xA2"=>"\xE9\x99\xB2",
		"\xE8\xA3"=>"\xE9\x99\xAC",
		"\xE8\xA4"=>"\xE9\x9A\x8D",
		"\xE8\xA5"=>"\xE9\x9A\x98",
		"\xE8\xA6"=>"\xE9\x9A\x95",
		"\xE8\xA7"=>"\xE9\x9A\x97",
		"\xE8\xA8"=>"\xE9\x9A\xAA",
		"\xE8\xA9"=>"\xE9\x9A\xA7",
		"\xE8\xAA"=>"\xE9\x9A\xB1",
		"\xE8\xAB"=>"\xE9\x9A\xB2",
		"\xE8\xAC"=>"\xE9\x9A\xB0",
		"\xE8\xAD"=>"\xE9\x9A\xB4",
		"\xE8\xAE"=>"\xE9\x9A\xB6",
		"\xE8\xAF"=>"\xE9\x9A\xB8",
		"\xE8\xB0"=>"\xE9\x9A\xB9",
		"\xE8\xB1"=>"\xE9\x9B\x8E",
		"\xE8\xB2"=>"\xE9\x9B\x8B",
		"\xE8\xB3"=>"\xE9\x9B\x89",
		"\xE8\xB4"=>"\xE9\x9B\x8D",
		"\xE8\xB5"=>"\xE8\xA5\x8D",
		"\xE8\xB6"=>"\xE9\x9B\x9C",
		"\xE8\xB7"=>"\xE9\x9C\x8D",
		"\xE8\xB8"=>"\xE9\x9B\x95",
		"\xE8\xB9"=>"\xE9\x9B\xB9",
		"\xE8\xBA"=>"\xE9\x9C\x84",
		"\xE8\xBB"=>"\xE9\x9C\x86",
		"\xE8\xBC"=>"\xE9\x9C\x88",
		"\xE8\xBD"=>"\xE9\x9C\x93",
		"\xE8\xBE"=>"\xE9\x9C\x8E",
		"\xE8\xBF"=>"\xE9\x9C\x91",
		"\xE8\xC0"=>"\xE9\x9C\x8F",
		"\xE8\xC1"=>"\xE9\x9C\x96",
		"\xE8\xC2"=>"\xE9\x9C\x99",
		"\xE8\xC3"=>"\xE9\x9C\xA4",
		"\xE8\xC4"=>"\xE9\x9C\xAA",
		"\xE8\xC5"=>"\xE9\x9C\xB0",
		"\xE8\xC6"=>"\xE9\x9C\xB9",
		"\xE8\xC7"=>"\xE9\x9C\xBD",
		"\xE8\xC8"=>"\xE9\x9C\xBE",
		"\xE8\xC9"=>"\xE9\x9D\x84",
		"\xE8\xCA"=>"\xE9\x9D\x86",
		"\xE8\xCB"=>"\xE9\x9D\x88",
		"\xE8\xCC"=>"\xE9\x9D\x82",
		"\xE8\xCD"=>"\xE9\x9D\x89",
		"\xE8\xCE"=>"\xE9\x9D\x9C",
		"\xE8\xCF"=>"\xE9\x9D\xA0",
		"\xE8\xD0"=>"\xE9\x9D\xA4",
		"\xE8\xD1"=>"\xE9\x9D\xA6",
		"\xE8\xD2"=>"\xE9\x9D\xA8",
		"\xE8\xD3"=>"\xE5\x8B\x92",
		"\xE8\xD4"=>"\xE9\x9D\xAB",
		"\xE8\xD5"=>"\xE9\x9D\xB1",
		"\xE8\xD6"=>"\xE9\x9D\xB9",
		"\xE8\xD7"=>"\xE9\x9E\x85",
		"\xE8\xD8"=>"\xE9\x9D\xBC",
		"\xE8\xD9"=>"\xE9\x9E\x81",
		"\xE8\xDA"=>"\xE9\x9D\xBA",
		"\xE8\xDB"=>"\xE9\x9E\x86",
		"\xE8\xDC"=>"\xE9\x9E\x8B",
		"\xE8\xDD"=>"\xE9\x9E\x8F",
		"\xE8\xDE"=>"\xE9\x9E\x90",
		"\xE8\xDF"=>"\xE9\x9E\x9C",
		"\xE8\xE0"=>"\xE9\x9E\xA8",
		"\xE8\xE1"=>"\xE9\x9E\xA6",
		"\xE8\xE2"=>"\xE9\x9E\xA3",
		"\xE8\xE3"=>"\xE9\x9E\xB3",
		"\xE8\xE4"=>"\xE9\x9E\xB4",
		"\xE8\xE5"=>"\xE9\x9F\x83",
		"\xE8\xE6"=>"\xE9\x9F\x86",
		"\xE8\xE7"=>"\xE9\x9F\x88",
		"\xE8\xE8"=>"\xE9\x9F\x8B",
		"\xE8\xE9"=>"\xE9\x9F\x9C",
		"\xE8\xEA"=>"\xE9\x9F\xAD",
		"\xE8\xEB"=>"\xE9\xBD\x8F",
		"\xE8\xEC"=>"\xE9\x9F\xB2",
		"\xE8\xED"=>"\xE7\xAB\x9F",
		"\xE8\xEE"=>"\xE9\x9F\xB6",
		"\xE8\xEF"=>"\xE9\x9F\xB5",
		"\xE8\xF0"=>"\xE9\xA0\x8F",
		"\xE8\xF1"=>"\xE9\xA0\x8C",
		"\xE8\xF2"=>"\xE9\xA0\xB8",
		"\xE8\xF3"=>"\xE9\xA0\xA4",
		"\xE8\xF4"=>"\xE9\xA0\xA1",
		"\xE8\xF5"=>"\xE9\xA0\xB7",
		"\xE8\xF6"=>"\xE9\xA0\xBD",
		"\xE8\xF7"=>"\xE9\xA1\x86",
		"\xE8\xF8"=>"\xE9\xA1\x8F",
		"\xE8\xF9"=>"\xE9\xA1\x8B",
		"\xE8\xFA"=>"\xE9\xA1\xAB",
		"\xE8\xFB"=>"\xE9\xA1\xAF",
		"\xE8\xFC"=>"\xE9\xA1\xB0",
		"\xE9\x40"=>"\xE9\xA1\xB1",
		"\xE9\x41"=>"\xE9\xA1\xB4",
		"\xE9\x42"=>"\xE9\xA1\xB3",
		"\xE9\x43"=>"\xE9\xA2\xAA",
		"\xE9\x44"=>"\xE9\xA2\xAF",
		"\xE9\x45"=>"\xE9\xA2\xB1",
		"\xE9\x46"=>"\xE9\xA2\xB6",
		"\xE9\x47"=>"\xE9\xA3\x84",
		"\xE9\x48"=>"\xE9\xA3\x83",
		"\xE9\x49"=>"\xE9\xA3\x86",
		"\xE9\x4A"=>"\xE9\xA3\xA9",
		"\xE9\x4B"=>"\xE9\xA3\xAB",
		"\xE9\x4C"=>"\xE9\xA4\x83",
		"\xE9\x4D"=>"\xE9\xA4\x89",
		"\xE9\x4E"=>"\xE9\xA4\x92",
		"\xE9\x4F"=>"\xE9\xA4\x94",
		"\xE9\x50"=>"\xE9\xA4\x98",
		"\xE9\x51"=>"\xE9\xA4\xA1",
		"\xE9\x52"=>"\xE9\xA4\x9D",
		"\xE9\x53"=>"\xE9\xA4\x9E",
		"\xE9\x54"=>"\xE9\xA4\xA4",
		"\xE9\x55"=>"\xE9\xA4\xA0",
		"\xE9\x56"=>"\xE9\xA4\xAC",
		"\xE9\x57"=>"\xE9\xA4\xAE",
		"\xE9\x58"=>"\xE9\xA4\xBD",
		"\xE9\x59"=>"\xE9\xA4\xBE",
		"\xE9\x5A"=>"\xE9\xA5\x82",
		"\xE9\x5B"=>"\xE9\xA5\x89",
		"\xE9\x5C"=>"\xE9\xA5\x85",
		"\xE9\x5D"=>"\xE9\xA5\x90",
		"\xE9\x5E"=>"\xE9\xA5\x8B",
		"\xE9\x5F"=>"\xE9\xA5\x91",
		"\xE9\x60"=>"\xE9\xA5\x92",
		"\xE9\x61"=>"\xE9\xA5\x8C",
		"\xE9\x62"=>"\xE9\xA5\x95",
		"\xE9\x63"=>"\xE9\xA6\x97",
		"\xE9\x64"=>"\xE9\xA6\x98",
		"\xE9\x65"=>"\xE9\xA6\xA5",
		"\xE9\x66"=>"\xE9\xA6\xAD",
		"\xE9\x67"=>"\xE9\xA6\xAE",
		"\xE9\x68"=>"\xE9\xA6\xBC",
		"\xE9\x69"=>"\xE9\xA7\x9F",
		"\xE9\x6A"=>"\xE9\xA7\x9B",
		"\xE9\x6B"=>"\xE9\xA7\x9D",
		"\xE9\x6C"=>"\xE9\xA7\x98",
		"\xE9\x6D"=>"\xE9\xA7\x91",
		"\xE9\x6E"=>"\xE9\xA7\xAD",
		"\xE9\x6F"=>"\xE9\xA7\xAE",
		"\xE9\x70"=>"\xE9\xA7\xB1",
		"\xE9\x71"=>"\xE9\xA7\xB2",
		"\xE9\x72"=>"\xE9\xA7\xBB",
		"\xE9\x73"=>"\xE9\xA7\xB8",
		"\xE9\x74"=>"\xE9\xA8\x81",
		"\xE9\x75"=>"\xE9\xA8\x8F",
		"\xE9\x76"=>"\xE9\xA8\x85",
		"\xE9\x77"=>"\xE9\xA7\xA2",
		"\xE9\x78"=>"\xE9\xA8\x99",
		"\xE9\x79"=>"\xE9\xA8\xAB",
		"\xE9\x7A"=>"\xE9\xA8\xB7",
		"\xE9\x7B"=>"\xE9\xA9\x85",
		"\xE9\x7C"=>"\xE9\xA9\x82",
		"\xE9\x7D"=>"\xE9\xA9\x80",
		"\xE9\x7E"=>"\xE9\xA9\x83",
		"\xE9\x80"=>"\xE9\xA8\xBE",
		"\xE9\x81"=>"\xE9\xA9\x95",
		"\xE9\x82"=>"\xE9\xA9\x8D",
		"\xE9\x83"=>"\xE9\xA9\x9B",
		"\xE9\x84"=>"\xE9\xA9\x97",
		"\xE9\x85"=>"\xE9\xA9\x9F",
		"\xE9\x86"=>"\xE9\xA9\xA2",
		"\xE9\x87"=>"\xE9\xA9\xA5",
		"\xE9\x88"=>"\xE9\xA9\xA4",
		"\xE9\x89"=>"\xE9\xA9\xA9",
		"\xE9\x8A"=>"\xE9\xA9\xAB",
		"\xE9\x8B"=>"\xE9\xA9\xAA",
		"\xE9\x8C"=>"\xE9\xAA\xAD",
		"\xE9\x8D"=>"\xE9\xAA\xB0",
		"\xE9\x8E"=>"\xE9\xAA\xBC",
		"\xE9\x8F"=>"\xE9\xAB\x80",
		"\xE9\x90"=>"\xE9\xAB\x8F",
		"\xE9\x91"=>"\xE9\xAB\x91",
		"\xE9\x92"=>"\xE9\xAB\x93",
		"\xE9\x93"=>"\xE9\xAB\x94",
		"\xE9\x94"=>"\xE9\xAB\x9E",
		"\xE9\x95"=>"\xE9\xAB\x9F",
		"\xE9\x96"=>"\xE9\xAB\xA2",
		"\xE9\x97"=>"\xE9\xAB\xA3",
		"\xE9\x98"=>"\xE9\xAB\xA6",
		"\xE9\x99"=>"\xE9\xAB\xAF",
		"\xE9\x9A"=>"\xE9\xAB\xAB",
		"\xE9\x9B"=>"\xE9\xAB\xAE",
		"\xE9\x9C"=>"\xE9\xAB\xB4",
		"\xE9\x9D"=>"\xE9\xAB\xB1",
		"\xE9\x9E"=>"\xE9\xAB\xB7",
		"\xE9\x9F"=>"\xE9\xAB\xBB",
		"\xE9\xA0"=>"\xE9\xAC\x86",
		"\xE9\xA1"=>"\xE9\xAC\x98",
		"\xE9\xA2"=>"\xE9\xAC\x9A",
		"\xE9\xA3"=>"\xE9\xAC\x9F",
		"\xE9\xA4"=>"\xE9\xAC\xA2",
		"\xE9\xA5"=>"\xE9\xAC\xA3",
		"\xE9\xA6"=>"\xE9\xAC\xA5",
		"\xE9\xA7"=>"\xE9\xAC\xA7",
		"\xE9\xA8"=>"\xE9\xAC\xA8",
		"\xE9\xA9"=>"\xE9\xAC\xA9",
		"\xE9\xAA"=>"\xE9\xAC\xAA",
		"\xE9\xAB"=>"\xE9\xAC\xAE",
		"\xE9\xAC"=>"\xE9\xAC\xAF",
		"\xE9\xAD"=>"\xE9\xAC\xB2",
		"\xE9\xAE"=>"\xE9\xAD\x84",
		"\xE9\xAF"=>"\xE9\xAD\x83",
		"\xE9\xB0"=>"\xE9\xAD\x8F",
		"\xE9\xB1"=>"\xE9\xAD\x8D",
		"\xE9\xB2"=>"\xE9\xAD\x8E",
		"\xE9\xB3"=>"\xE9\xAD\x91",
		"\xE9\xB4"=>"\xE9\xAD\x98",
		"\xE9\xB5"=>"\xE9\xAD\xB4",
		"\xE9\xB6"=>"\xE9\xAE\x93",
		"\xE9\xB7"=>"\xE9\xAE\x83",
		"\xE9\xB8"=>"\xE9\xAE\x91",
		"\xE9\xB9"=>"\xE9\xAE\x96",
		"\xE9\xBA"=>"\xE9\xAE\x97",
		"\xE9\xBB"=>"\xE9\xAE\x9F",
		"\xE9\xBC"=>"\xE9\xAE\xA0",
		"\xE9\xBD"=>"\xE9\xAE\xA8",
		"\xE9\xBE"=>"\xE9\xAE\xB4",
		"\xE9\xBF"=>"\xE9\xAF\x80",
		"\xE9\xC0"=>"\xE9\xAF\x8A",
		"\xE9\xC1"=>"\xE9\xAE\xB9",
		"\xE9\xC2"=>"\xE9\xAF\x86",
		"\xE9\xC3"=>"\xE9\xAF\x8F",
		"\xE9\xC4"=>"\xE9\xAF\x91",
		"\xE9\xC5"=>"\xE9\xAF\x92",
		"\xE9\xC6"=>"\xE9\xAF\xA3",
		"\xE9\xC7"=>"\xE9\xAF\xA2",
		"\xE9\xC8"=>"\xE9\xAF\xA4",
		"\xE9\xC9"=>"\xE9\xAF\x94",
		"\xE9\xCA"=>"\xE9\xAF\xA1",
		"\xE9\xCB"=>"\xE9\xB0\xBA",
		"\xE9\xCC"=>"\xE9\xAF\xB2",
		"\xE9\xCD"=>"\xE9\xAF\xB1",
		"\xE9\xCE"=>"\xE9\xAF\xB0",
		"\xE9\xCF"=>"\xE9\xB0\x95",
		"\xE9\xD0"=>"\xE9\xB0\x94",
		"\xE9\xD1"=>"\xE9\xB0\x89",
		"\xE9\xD2"=>"\xE9\xB0\x93",
		"\xE9\xD3"=>"\xE9\xB0\x8C",
		"\xE9\xD4"=>"\xE9\xB0\x86",
		"\xE9\xD5"=>"\xE9\xB0\x88",
		"\xE9\xD6"=>"\xE9\xB0\x92",
		"\xE9\xD7"=>"\xE9\xB0\x8A",
		"\xE9\xD8"=>"\xE9\xB0\x84",
		"\xE9\xD9"=>"\xE9\xB0\xAE",
		"\xE9\xDA"=>"\xE9\xB0\x9B",
		"\xE9\xDB"=>"\xE9\xB0\xA5",
		"\xE9\xDC"=>"\xE9\xB0\xA4",
		"\xE9\xDD"=>"\xE9\xB0\xA1",
		"\xE9\xDE"=>"\xE9\xB0\xB0",
		"\xE9\xDF"=>"\xE9\xB1\x87",
		"\xE9\xE0"=>"\xE9\xB0\xB2",
		"\xE9\xE1"=>"\xE9\xB1\x86",
		"\xE9\xE2"=>"\xE9\xB0\xBE",
		"\xE9\xE3"=>"\xE9\xB1\x9A",
		"\xE9\xE4"=>"\xE9\xB1\xA0",
		"\xE9\xE5"=>"\xE9\xB1\xA7",
		"\xE9\xE6"=>"\xE9\xB1\xB6",
		"\xE9\xE7"=>"\xE9\xB1\xB8",
		"\xE9\xE8"=>"\xE9\xB3\xA7",
		"\xE9\xE9"=>"\xE9\xB3\xAC",
		"\xE9\xEA"=>"\xE9\xB3\xB0",
		"\xE9\xEB"=>"\xE9\xB4\x89",
		"\xE9\xEC"=>"\xE9\xB4\x88",
		"\xE9\xED"=>"\xE9\xB3\xAB",
		"\xE9\xEE"=>"\xE9\xB4\x83",
		"\xE9\xEF"=>"\xE9\xB4\x86",
		"\xE9\xF0"=>"\xE9\xB4\xAA",
		"\xE9\xF1"=>"\xE9\xB4\xA6",
		"\xE9\xF2"=>"\xE9\xB6\xAF",
		"\xE9\xF3"=>"\xE9\xB4\xA3",
		"\xE9\xF4"=>"\xE9\xB4\x9F",
		"\xE9\xF5"=>"\xE9\xB5\x84",
		"\xE9\xF6"=>"\xE9\xB4\x95",
		"\xE9\xF7"=>"\xE9\xB4\x92",
		"\xE9\xF8"=>"\xE9\xB5\x81",
		"\xE9\xF9"=>"\xE9\xB4\xBF",
		"\xE9\xFA"=>"\xE9\xB4\xBE",
		"\xE9\xFB"=>"\xE9\xB5\x86",
		"\xE9\xFC"=>"\xE9\xB5\x88",
		"\xEA\x40"=>"\xE9\xB5\x9D",
		"\xEA\x41"=>"\xE9\xB5\x9E",
		"\xEA\x42"=>"\xE9\xB5\xA4",
		"\xEA\x43"=>"\xE9\xB5\x91",
		"\xEA\x44"=>"\xE9\xB5\x90",
		"\xEA\x45"=>"\xE9\xB5\x99",
		"\xEA\x46"=>"\xE9\xB5\xB2",
		"\xEA\x47"=>"\xE9\xB6\x89",
		"\xEA\x48"=>"\xE9\xB6\x87",
		"\xEA\x49"=>"\xE9\xB6\xAB",
		"\xEA\x4A"=>"\xE9\xB5\xAF",
		"\xEA\x4B"=>"\xE9\xB5\xBA",
		"\xEA\x4C"=>"\xE9\xB6\x9A",
		"\xEA\x4D"=>"\xE9\xB6\xA4",
		"\xEA\x4E"=>"\xE9\xB6\xA9",
		"\xEA\x4F"=>"\xE9\xB6\xB2",
		"\xEA\x50"=>"\xE9\xB7\x84",
		"\xEA\x51"=>"\xE9\xB7\x81",
		"\xEA\x52"=>"\xE9\xB6\xBB",
		"\xEA\x53"=>"\xE9\xB6\xB8",
		"\xEA\x54"=>"\xE9\xB6\xBA",
		"\xEA\x55"=>"\xE9\xB7\x86",
		"\xEA\x56"=>"\xE9\xB7\x8F",
		"\xEA\x57"=>"\xE9\xB7\x82",
		"\xEA\x58"=>"\xE9\xB7\x99",
		"\xEA\x59"=>"\xE9\xB7\x93",
		"\xEA\x5A"=>"\xE9\xB7\xB8",
		"\xEA\x5B"=>"\xE9\xB7\xA6",
		"\xEA\x5C"=>"\xE9\xB7\xAD",
		"\xEA\x5D"=>"\xE9\xB7\xAF",
		"\xEA\x5E"=>"\xE9\xB7\xBD",
		"\xEA\x5F"=>"\xE9\xB8\x9A",
		"\xEA\x60"=>"\xE9\xB8\x9B",
		"\xEA\x61"=>"\xE9\xB8\x9E",
		"\xEA\x62"=>"\xE9\xB9\xB5",
		"\xEA\x63"=>"\xE9\xB9\xB9",
		"\xEA\x64"=>"\xE9\xB9\xBD",
		"\xEA\x65"=>"\xE9\xBA\x81",
		"\xEA\x66"=>"\xE9\xBA\x88",
		"\xEA\x67"=>"\xE9\xBA\x8B",
		"\xEA\x68"=>"\xE9\xBA\x8C",
		"\xEA\x69"=>"\xE9\xBA\x92",
		"\xEA\x6A"=>"\xE9\xBA\x95",
		"\xEA\x6B"=>"\xE9\xBA\x91",
		"\xEA\x6C"=>"\xE9\xBA\x9D",
		"\xEA\x6D"=>"\xE9\xBA\xA5",
		"\xEA\x6E"=>"\xE9\xBA\xA9",
		"\xEA\x6F"=>"\xE9\xBA\xB8",
		"\xEA\x70"=>"\xE9\xBA\xAA",
		"\xEA\x71"=>"\xE9\xBA\xAD",
		"\xEA\x72"=>"\xE9\x9D\xA1",
		"\xEA\x73"=>"\xE9\xBB\x8C",
		"\xEA\x74"=>"\xE9\xBB\x8E",
		"\xEA\x75"=>"\xE9\xBB\x8F",
		"\xEA\x76"=>"\xE9\xBB\x90",
		"\xEA\x77"=>"\xE9\xBB\x94",
		"\xEA\x78"=>"\xE9\xBB\x9C",
		"\xEA\x79"=>"\xE9\xBB\x9E",
		"\xEA\x7A"=>"\xE9\xBB\x9D",
		"\xEA\x7B"=>"\xE9\xBB\xA0",
		"\xEA\x7C"=>"\xE9\xBB\xA5",
		"\xEA\x7D"=>"\xE9\xBB\xA8",
		"\xEA\x7E"=>"\xE9\xBB\xAF",
		"\xEA\x80"=>"\xE9\xBB\xB4",
		"\xEA\x81"=>"\xE9\xBB\xB6",
		"\xEA\x82"=>"\xE9\xBB\xB7",
		"\xEA\x83"=>"\xE9\xBB\xB9",
		"\xEA\x84"=>"\xE9\xBB\xBB",
		"\xEA\x85"=>"\xE9\xBB\xBC",
		"\xEA\x86"=>"\xE9\xBB\xBD",
		"\xEA\x87"=>"\xE9\xBC\x87",
		"\xEA\x88"=>"\xE9\xBC\x88",
		"\xEA\x89"=>"\xE7\x9A\xB7",
		"\xEA\x8A"=>"\xE9\xBC\x95",
		"\xEA\x8B"=>"\xE9\xBC\xA1",
		"\xEA\x8C"=>"\xE9\xBC\xAC",
		"\xEA\x8D"=>"\xE9\xBC\xBE",
		"\xEA\x8E"=>"\xE9\xBD\x8A",
		"\xEA\x8F"=>"\xE9\xBD\x92",
		"\xEA\x90"=>"\xE9\xBD\x94",
		"\xEA\x91"=>"\xE9\xBD\xA3",
		"\xEA\x92"=>"\xE9\xBD\x9F",
		"\xEA\x93"=>"\xE9\xBD\xA0",
		"\xEA\x94"=>"\xE9\xBD\xA1",
		"\xEA\x95"=>"\xE9\xBD\xA6",
		"\xEA\x96"=>"\xE9\xBD\xA7",
		"\xEA\x97"=>"\xE9\xBD\xAC",
		"\xEA\x98"=>"\xE9\xBD\xAA",
		"\xEA\x99"=>"\xE9\xBD\xB7",
		"\xEA\x9A"=>"\xE9\xBD\xB2",
		"\xEA\x9B"=>"\xE9\xBD\xB6",
		"\xEA\x9C"=>"\xE9\xBE\x95",
		"\xEA\x9D"=>"\xE9\xBE\x9C",
		"\xEA\x9E"=>"\xE9\xBE\xA0",
		"\xEA\x9F"=>"\xE5\xA0\xAF",
		"\xEA\xA0"=>"\xE6\xA7\x87",
		"\xEA\xA1"=>"\xE9\x81\x99",
		"\xEA\xA2"=>"\xE7\x91\xA4",
		"\xEA\xA3"=>"\xE5\x87\x9C",
		"\xEA\xA4"=>"\xE7\x86\x99"
	);
	return strtr($string, $transform);
}

function euc_kr($string)
{
	static $transform = array(
		"\x5c" => "\xE2\x82\xA9", // KX X 1001
		"\x81\x41" => "\xEA\xB0\x82",
		"\x81\x42" => "\xEA\xB0\x83",
		"\x81\x43" => "\xEA\xB0\x85",
		"\x81\x44" => "\xEA\xB0\x86",
		"\x81\x45" => "\xEA\xB0\x8B",
		"\x81\x46" => "\xEA\xB0\x8C",
		"\x81\x47" => "\xEA\xB0\x8D",
		"\x81\x48" => "\xEA\xB0\x8E",
		"\x81\x49" => "\xEA\xB0\x8F",
		"\x81\x4A" => "\xEA\xB0\x98",
		"\x81\x4B" => "\xEA\xB0\x9E",
		"\x81\x4C" => "\xEA\xB0\x9F",
		"\x81\x4D" => "\xEA\xB0\xA1",
		"\x81\x4E" => "\xEA\xB0\xA2",
		"\x81\x4F" => "\xEA\xB0\xA3",
		"\x81\x50" => "\xEA\xB0\xA5",
		"\x81\x51" => "\xEA\xB0\xA6",
		"\x81\x52" => "\xEA\xB0\xA7",
		"\x81\x53" => "\xEA\xB0\xA8",
		"\x81\x54" => "\xEA\xB0\xA9",
		"\x81\x55" => "\xEA\xB0\xAA",
		"\x81\x56" => "\xEA\xB0\xAB",
		"\x81\x57" => "\xEA\xB0\xAE",
		"\x81\x58" => "\xEA\xB0\xB2",
		"\x81\x59" => "\xEA\xB0\xB3",
		"\x81\x5A" => "\xEA\xB0\xB4",
		"\x81\x61" => "\xEA\xB0\xB5",
		"\x81\x62" => "\xEA\xB0\xB6",
		"\x81\x63" => "\xEA\xB0\xB7",
		"\x81\x64" => "\xEA\xB0\xBA",
		"\x81\x65" => "\xEA\xB0\xBB",
		"\x81\x66" => "\xEA\xB0\xBD",
		"\x81\x67" => "\xEA\xB0\xBE",
		"\x81\x68" => "\xEA\xB0\xBF",
		"\x81\x69" => "\xEA\xB1\x81",
		"\x81\x6A" => "\xEA\xB1\x82",
		"\x81\x6B" => "\xEA\xB1\x83",
		"\x81\x6C" => "\xEA\xB1\x84",
		"\x81\x6D" => "\xEA\xB1\x85",
		"\x81\x6E" => "\xEA\xB1\x86",
		"\x81\x6F" => "\xEA\xB1\x87",
		"\x81\x70" => "\xEA\xB1\x88",
		"\x81\x71" => "\xEA\xB1\x89",
		"\x81\x72" => "\xEA\xB1\x8A",
		"\x81\x73" => "\xEA\xB1\x8C",
		"\x81\x74" => "\xEA\xB1\x8E",
		"\x81\x75" => "\xEA\xB1\x8F",
		"\x81\x76" => "\xEA\xB1\x90",
		"\x81\x77" => "\xEA\xB1\x91",
		"\x81\x78" => "\xEA\xB1\x92",
		"\x81\x79" => "\xEA\xB1\x93",
		"\x81\x7A" => "\xEA\xB1\x95",
		"\x81\x81" => "\xEA\xB1\x96",
		"\x81\x82" => "\xEA\xB1\x97",
		"\x81\x83" => "\xEA\xB1\x99",
		"\x81\x84" => "\xEA\xB1\x9A",
		"\x81\x85" => "\xEA\xB1\x9B",
		"\x81\x86" => "\xEA\xB1\x9D",
		"\x81\x87" => "\xEA\xB1\x9E",
		"\x81\x88" => "\xEA\xB1\x9F",
		"\x81\x89" => "\xEA\xB1\xA0",
		"\x81\x8A" => "\xEA\xB1\xA1",
		"\x81\x8B" => "\xEA\xB1\xA2",
		"\x81\x8C" => "\xEA\xB1\xA3",
		"\x81\x8D" => "\xEA\xB1\xA4",
		"\x81\x8E" => "\xEA\xB1\xA5",
		"\x81\x8F" => "\xEA\xB1\xA6",
		"\x81\x90" => "\xEA\xB1\xA7",
		"\x81\x91" => "\xEA\xB1\xA8",
		"\x81\x92" => "\xEA\xB1\xA9",
		"\x81\x93" => "\xEA\xB1\xAA",
		"\x81\x94" => "\xEA\xB1\xAB",
		"\x81\x95" => "\xEA\xB1\xAC",
		"\x81\x96" => "\xEA\xB1\xAD",
		"\x81\x97" => "\xEA\xB1\xAE",
		"\x81\x98" => "\xEA\xB1\xAF",
		"\x81\x99" => "\xEA\xB1\xB2",
		"\x81\x9A" => "\xEA\xB1\xB3",
		"\x81\x9B" => "\xEA\xB1\xB5",
		"\x81\x9C" => "\xEA\xB1\xB6",
		"\x81\x9D" => "\xEA\xB1\xB9",
		"\x81\x9E" => "\xEA\xB1\xBB",
		"\x81\x9F" => "\xEA\xB1\xBC",
		"\x81\xA0" => "\xEA\xB1\xBD",
		"\x81\xA1" => "\xEA\xB1\xBE",
		"\x81\xA2" => "\xEA\xB1\xBF",
		"\x81\xA3" => "\xEA\xB2\x82",
		"\x81\xA4" => "\xEA\xB2\x87",
		"\x81\xA5" => "\xEA\xB2\x88",
		"\x81\xA6" => "\xEA\xB2\x8D",
		"\x81\xA7" => "\xEA\xB2\x8E",
		"\x81\xA8" => "\xEA\xB2\x8F",
		"\x81\xA9" => "\xEA\xB2\x91",
		"\x81\xAA" => "\xEA\xB2\x92",
		"\x81\xAB" => "\xEA\xB2\x93",
		"\x81\xAC" => "\xEA\xB2\x95",
		"\x81\xAD" => "\xEA\xB2\x96",
		"\x81\xAE" => "\xEA\xB2\x97",
		"\x81\xAF" => "\xEA\xB2\x98",
		"\x81\xB0" => "\xEA\xB2\x99",
		"\x81\xB1" => "\xEA\xB2\x9A",
		"\x81\xB2" => "\xEA\xB2\x9B",
		"\x81\xB3" => "\xEA\xB2\x9E",
		"\x81\xB4" => "\xEA\xB2\xA2",
		"\x81\xB5" => "\xEA\xB2\xA3",
		"\x81\xB6" => "\xEA\xB2\xA4",
		"\x81\xB7" => "\xEA\xB2\xA5",
		"\x81\xB8" => "\xEA\xB2\xA6",
		"\x81\xB9" => "\xEA\xB2\xA7",
		"\x81\xBA" => "\xEA\xB2\xAB",
		"\x81\xBB" => "\xEA\xB2\xAD",
		"\x81\xBC" => "\xEA\xB2\xAE",
		"\x81\xBD" => "\xEA\xB2\xB1",
		"\x81\xBE" => "\xEA\xB2\xB2",
		"\x81\xBF" => "\xEA\xB2\xB3",
		"\x81\xC0" => "\xEA\xB2\xB4",
		"\x81\xC1" => "\xEA\xB2\xB5",
		"\x81\xC2" => "\xEA\xB2\xB6",
		"\x81\xC3" => "\xEA\xB2\xB7",
		"\x81\xC4" => "\xEA\xB2\xBA",
		"\x81\xC5" => "\xEA\xB2\xBE",
		"\x81\xC6" => "\xEA\xB2\xBF",
		"\x81\xC7" => "\xEA\xB3\x80",
		"\x81\xC8" => "\xEA\xB3\x82",
		"\x81\xC9" => "\xEA\xB3\x83",
		"\x81\xCA" => "\xEA\xB3\x85",
		"\x81\xCB" => "\xEA\xB3\x86",
		"\x81\xCC" => "\xEA\xB3\x87",
		"\x81\xCD" => "\xEA\xB3\x89",
		"\x81\xCE" => "\xEA\xB3\x8A",
		"\x81\xCF" => "\xEA\xB3\x8B",
		"\x81\xD0" => "\xEA\xB3\x8D",
		"\x81\xD1" => "\xEA\xB3\x8E",
		"\x81\xD2" => "\xEA\xB3\x8F",
		"\x81\xD3" => "\xEA\xB3\x90",
		"\x81\xD4" => "\xEA\xB3\x91",
		"\x81\xD5" => "\xEA\xB3\x92",
		"\x81\xD6" => "\xEA\xB3\x93",
		"\x81\xD7" => "\xEA\xB3\x94",
		"\x81\xD8" => "\xEA\xB3\x96",
		"\x81\xD9" => "\xEA\xB3\x98",
		"\x81\xDA" => "\xEA\xB3\x99",
		"\x81\xDB" => "\xEA\xB3\x9A",
		"\x81\xDC" => "\xEA\xB3\x9B",
		"\x81\xDD" => "\xEA\xB3\x9C",
		"\x81\xDE" => "\xEA\xB3\x9D",
		"\x81\xDF" => "\xEA\xB3\x9E",
		"\x81\xE0" => "\xEA\xB3\x9F",
		"\x81\xE1" => "\xEA\xB3\xA2",
		"\x81\xE2" => "\xEA\xB3\xA3",
		"\x81\xE3" => "\xEA\xB3\xA5",
		"\x81\xE4" => "\xEA\xB3\xA6",
		"\x81\xE5" => "\xEA\xB3\xA9",
		"\x81\xE6" => "\xEA\xB3\xAB",
		"\x81\xE7" => "\xEA\xB3\xAD",
		"\x81\xE8" => "\xEA\xB3\xAE",
		"\x81\xE9" => "\xEA\xB3\xB2",
		"\x81\xEA" => "\xEA\xB3\xB4",
		"\x81\xEB" => "\xEA\xB3\xB7",
		"\x81\xEC" => "\xEA\xB3\xB8",
		"\x81\xED" => "\xEA\xB3\xB9",
		"\x81\xEE" => "\xEA\xB3\xBA",
		"\x81\xEF" => "\xEA\xB3\xBB",
		"\x81\xF0" => "\xEA\xB3\xBE",
		"\x81\xF1" => "\xEA\xB3\xBF",
		"\x81\xF2" => "\xEA\xB4\x81",
		"\x81\xF3" => "\xEA\xB4\x82",
		"\x81\xF4" => "\xEA\xB4\x83",
		"\x81\xF5" => "\xEA\xB4\x85",
		"\x81\xF6" => "\xEA\xB4\x87",
		"\x81\xF7" => "\xEA\xB4\x88",
		"\x81\xF8" => "\xEA\xB4\x89",
		"\x81\xF9" => "\xEA\xB4\x8A",
		"\x81\xFA" => "\xEA\xB4\x8B",
		"\x81\xFB" => "\xEA\xB4\x8E",
		"\x81\xFC" => "\xEA\xB4\x90",
		"\x81\xFD" => "\xEA\xB4\x92",
		"\x81\xFE" => "\xEA\xB4\x93",
		"\x82\x41" => "\xEA\xB4\x94",
		"\x82\x42" => "\xEA\xB4\x95",
		"\x82\x43" => "\xEA\xB4\x96",
		"\x82\x44" => "\xEA\xB4\x97",
		"\x82\x45" => "\xEA\xB4\x99",
		"\x82\x46" => "\xEA\xB4\x9A",
		"\x82\x47" => "\xEA\xB4\x9B",
		"\x82\x48" => "\xEA\xB4\x9D",
		"\x82\x49" => "\xEA\xB4\x9E",
		"\x82\x4A" => "\xEA\xB4\x9F",
		"\x82\x4B" => "\xEA\xB4\xA1",
		"\x82\x4C" => "\xEA\xB4\xA2",
		"\x82\x4D" => "\xEA\xB4\xA3",
		"\x82\x4E" => "\xEA\xB4\xA4",
		"\x82\x4F" => "\xEA\xB4\xA5",
		"\x82\x50" => "\xEA\xB4\xA6",
		"\x82\x51" => "\xEA\xB4\xA7",
		"\x82\x52" => "\xEA\xB4\xA8",
		"\x82\x53" => "\xEA\xB4\xAA",
		"\x82\x54" => "\xEA\xB4\xAB",
		"\x82\x55" => "\xEA\xB4\xAE",
		"\x82\x56" => "\xEA\xB4\xAF",
		"\x82\x57" => "\xEA\xB4\xB0",
		"\x82\x58" => "\xEA\xB4\xB1",
		"\x82\x59" => "\xEA\xB4\xB2",
		"\x82\x5A" => "\xEA\xB4\xB3",
		"\x82\x61" => "\xEA\xB4\xB6",
		"\x82\x62" => "\xEA\xB4\xB7",
		"\x82\x63" => "\xEA\xB4\xB9",
		"\x82\x64" => "\xEA\xB4\xBA",
		"\x82\x65" => "\xEA\xB4\xBB",
		"\x82\x66" => "\xEA\xB4\xBD",
		"\x82\x67" => "\xEA\xB4\xBE",
		"\x82\x68" => "\xEA\xB4\xBF",
		"\x82\x69" => "\xEA\xB5\x80",
		"\x82\x6A" => "\xEA\xB5\x81",
		"\x82\x6B" => "\xEA\xB5\x82",
		"\x82\x6C" => "\xEA\xB5\x83",
		"\x82\x6D" => "\xEA\xB5\x86",
		"\x82\x6E" => "\xEA\xB5\x88",
		"\x82\x6F" => "\xEA\xB5\x8A",
		"\x82\x70" => "\xEA\xB5\x8B",
		"\x82\x71" => "\xEA\xB5\x8C",
		"\x82\x72" => "\xEA\xB5\x8D",
		"\x82\x73" => "\xEA\xB5\x8E",
		"\x82\x74" => "\xEA\xB5\x8F",
		"\x82\x75" => "\xEA\xB5\x91",
		"\x82\x76" => "\xEA\xB5\x92",
		"\x82\x77" => "\xEA\xB5\x93",
		"\x82\x78" => "\xEA\xB5\x95",
		"\x82\x79" => "\xEA\xB5\x96",
		"\x82\x7A" => "\xEA\xB5\x97",
		"\x82\x81" => "\xEA\xB5\x99",
		"\x82\x82" => "\xEA\xB5\x9A",
		"\x82\x83" => "\xEA\xB5\x9B",
		"\x82\x84" => "\xEA\xB5\x9C",
		"\x82\x85" => "\xEA\xB5\x9D",
		"\x82\x86" => "\xEA\xB5\x9E",
		"\x82\x87" => "\xEA\xB5\x9F",
		"\x82\x88" => "\xEA\xB5\xA0",
		"\x82\x89" => "\xEA\xB5\xA2",
		"\x82\x8A" => "\xEA\xB5\xA4",
		"\x82\x8B" => "\xEA\xB5\xA5",
		"\x82\x8C" => "\xEA\xB5\xA6",
		"\x82\x8D" => "\xEA\xB5\xA7",
		"\x82\x8E" => "\xEA\xB5\xA8",
		"\x82\x8F" => "\xEA\xB5\xA9",
		"\x82\x90" => "\xEA\xB5\xAA",
		"\x82\x91" => "\xEA\xB5\xAB",
		"\x82\x92" => "\xEA\xB5\xAE",
		"\x82\x93" => "\xEA\xB5\xAF",
		"\x82\x94" => "\xEA\xB5\xB1",
		"\x82\x95" => "\xEA\xB5\xB2",
		"\x82\x96" => "\xEA\xB5\xB7",
		"\x82\x97" => "\xEA\xB5\xB8",
		"\x82\x98" => "\xEA\xB5\xB9",
		"\x82\x99" => "\xEA\xB5\xBA",
		"\x82\x9A" => "\xEA\xB5\xBE",
		"\x82\x9B" => "\xEA\xB6\x80",
		"\x82\x9C" => "\xEA\xB6\x83",
		"\x82\x9D" => "\xEA\xB6\x84",
		"\x82\x9E" => "\xEA\xB6\x85",
		"\x82\x9F" => "\xEA\xB6\x86",
		"\x82\xA0" => "\xEA\xB6\x87",
		"\x82\xA1" => "\xEA\xB6\x8A",
		"\x82\xA2" => "\xEA\xB6\x8B",
		"\x82\xA3" => "\xEA\xB6\x8D",
		"\x82\xA4" => "\xEA\xB6\x8E",
		"\x82\xA5" => "\xEA\xB6\x8F",
		"\x82\xA6" => "\xEA\xB6\x91",
		"\x82\xA7" => "\xEA\xB6\x92",
		"\x82\xA8" => "\xEA\xB6\x93",
		"\x82\xA9" => "\xEA\xB6\x94",
		"\x82\xAA" => "\xEA\xB6\x95",
		"\x82\xAB" => "\xEA\xB6\x96",
		"\x82\xAC" => "\xEA\xB6\x97",
		"\x82\xAD" => "\xEA\xB6\x98",
		"\x82\xAE" => "\xEA\xB6\x99",
		"\x82\xAF" => "\xEA\xB6\x9A",
		"\x82\xB0" => "\xEA\xB6\x9B",
		"\x82\xB1" => "\xEA\xB6\x9E",
		"\x82\xB2" => "\xEA\xB6\x9F",
		"\x82\xB3" => "\xEA\xB6\xA0",
		"\x82\xB4" => "\xEA\xB6\xA1",
		"\x82\xB5" => "\xEA\xB6\xA2",
		"\x82\xB6" => "\xEA\xB6\xA3",
		"\x82\xB7" => "\xEA\xB6\xA5",
		"\x82\xB8" => "\xEA\xB6\xA6",
		"\x82\xB9" => "\xEA\xB6\xA7",
		"\x82\xBA" => "\xEA\xB6\xA8",
		"\x82\xBB" => "\xEA\xB6\xA9",
		"\x82\xBC" => "\xEA\xB6\xAA",
		"\x82\xBD" => "\xEA\xB6\xAB",
		"\x82\xBE" => "\xEA\xB6\xAC",
		"\x82\xBF" => "\xEA\xB6\xAD",
		"\x82\xC0" => "\xEA\xB6\xAE",
		"\x82\xC1" => "\xEA\xB6\xAF",
		"\x82\xC2" => "\xEA\xB6\xB0",
		"\x82\xC3" => "\xEA\xB6\xB1",
		"\x82\xC4" => "\xEA\xB6\xB2",
		"\x82\xC5" => "\xEA\xB6\xB3",
		"\x82\xC6" => "\xEA\xB6\xB4",
		"\x82\xC7" => "\xEA\xB6\xB5",
		"\x82\xC8" => "\xEA\xB6\xB6",
		"\x82\xC9" => "\xEA\xB6\xB8",
		"\x82\xCA" => "\xEA\xB6\xB9",
		"\x82\xCB" => "\xEA\xB6\xBA",
		"\x82\xCC" => "\xEA\xB6\xBB",
		"\x82\xCD" => "\xEA\xB6\xBC",
		"\x82\xCE" => "\xEA\xB6\xBD",
		"\x82\xCF" => "\xEA\xB6\xBE",
		"\x82\xD0" => "\xEA\xB6\xBF",
		"\x82\xD1" => "\xEA\xB7\x82",
		"\x82\xD2" => "\xEA\xB7\x83",
		"\x82\xD3" => "\xEA\xB7\x85",
		"\x82\xD4" => "\xEA\xB7\x86",
		"\x82\xD5" => "\xEA\xB7\x87",
		"\x82\xD6" => "\xEA\xB7\x89",
		"\x82\xD7" => "\xEA\xB7\x8A",
		"\x82\xD8" => "\xEA\xB7\x8B",
		"\x82\xD9" => "\xEA\xB7\x8C",
		"\x82\xDA" => "\xEA\xB7\x8D",
		"\x82\xDB" => "\xEA\xB7\x8E",
		"\x82\xDC" => "\xEA\xB7\x8F",
		"\x82\xDD" => "\xEA\xB7\x92",
		"\x82\xDE" => "\xEA\xB7\x94",
		"\x82\xDF" => "\xEA\xB7\x95",
		"\x82\xE0" => "\xEA\xB7\x96",
		"\x82\xE1" => "\xEA\xB7\x97",
		"\x82\xE2" => "\xEA\xB7\x98",
		"\x82\xE3" => "\xEA\xB7\x99",
		"\x82\xE4" => "\xEA\xB7\x9A",
		"\x82\xE5" => "\xEA\xB7\x9B",
		"\x82\xE6" => "\xEA\xB7\x9D",
		"\x82\xE7" => "\xEA\xB7\x9E",
		"\x82\xE8" => "\xEA\xB7\x9F",
		"\x82\xE9" => "\xEA\xB7\xA1",
		"\x82\xEA" => "\xEA\xB7\xA2",
		"\x82\xEB" => "\xEA\xB7\xA3",
		"\x82\xEC" => "\xEA\xB7\xA5",
		"\x82\xED" => "\xEA\xB7\xA6",
		"\x82\xEE" => "\xEA\xB7\xA7",
		"\x82\xEF" => "\xEA\xB7\xA8",
		"\x82\xF0" => "\xEA\xB7\xA9",
		"\x82\xF1" => "\xEA\xB7\xAA",
		"\x82\xF2" => "\xEA\xB7\xAB",
		"\x82\xF3" => "\xEA\xB7\xAC",
		"\x82\xF4" => "\xEA\xB7\xAD",
		"\x82\xF5" => "\xEA\xB7\xAE",
		"\x82\xF6" => "\xEA\xB7\xAF",
		"\x82\xF7" => "\xEA\xB7\xB0",
		"\x82\xF8" => "\xEA\xB7\xB1",
		"\x82\xF9" => "\xEA\xB7\xB2",
		"\x82\xFA" => "\xEA\xB7\xB3",
		"\x82\xFB" => "\xEA\xB7\xB4",
		"\x82\xFC" => "\xEA\xB7\xB5",
		"\x82\xFD" => "\xEA\xB7\xB6",
		"\x82\xFE" => "\xEA\xB7\xB7",
		"\x83\x41" => "\xEA\xB7\xBA",
		"\x83\x42" => "\xEA\xB7\xBB",
		"\x83\x43" => "\xEA\xB7\xBD",
		"\x83\x44" => "\xEA\xB7\xBE",
		"\x83\x45" => "\xEA\xB8\x82",
		"\x83\x46" => "\xEA\xB8\x83",
		"\x83\x47" => "\xEA\xB8\x84",
		"\x83\x48" => "\xEA\xB8\x85",
		"\x83\x49" => "\xEA\xB8\x86",
		"\x83\x4A" => "\xEA\xB8\x87",
		"\x83\x4B" => "\xEA\xB8\x8A",
		"\x83\x4C" => "\xEA\xB8\x8C",
		"\x83\x4D" => "\xEA\xB8\x8E",
		"\x83\x4E" => "\xEA\xB8\x8F",
		"\x83\x4F" => "\xEA\xB8\x90",
		"\x83\x50" => "\xEA\xB8\x91",
		"\x83\x51" => "\xEA\xB8\x92",
		"\x83\x52" => "\xEA\xB8\x93",
		"\x83\x53" => "\xEA\xB8\x95",
		"\x83\x54" => "\xEA\xB8\x96",
		"\x83\x55" => "\xEA\xB8\x97",
		"\x83\x56" => "\xEA\xB8\x98",
		"\x83\x57" => "\xEA\xB8\x99",
		"\x83\x58" => "\xEA\xB8\x9A",
		"\x83\x59" => "\xEA\xB8\x9B",
		"\x83\x5A" => "\xEA\xB8\x9C",
		"\x83\x61" => "\xEA\xB8\x9D",
		"\x83\x62" => "\xEA\xB8\x9E",
		"\x83\x63" => "\xEA\xB8\x9F",
		"\x83\x64" => "\xEA\xB8\xA0",
		"\x83\x65" => "\xEA\xB8\xA1",
		"\x83\x66" => "\xEA\xB8\xA2",
		"\x83\x67" => "\xEA\xB8\xA3",
		"\x83\x68" => "\xEA\xB8\xA4",
		"\x83\x69" => "\xEA\xB8\xA5",
		"\x83\x6A" => "\xEA\xB8\xA6",
		"\x83\x6B" => "\xEA\xB8\xA7",
		"\x83\x6C" => "\xEA\xB8\xA8",
		"\x83\x6D" => "\xEA\xB8\xA9",
		"\x83\x6E" => "\xEA\xB8\xAA",
		"\x83\x6F" => "\xEA\xB8\xAB",
		"\x83\x70" => "\xEA\xB8\xAC",
		"\x83\x71" => "\xEA\xB8\xAD",
		"\x83\x72" => "\xEA\xB8\xAE",
		"\x83\x73" => "\xEA\xB8\xAF",
		"\x83\x74" => "\xEA\xB8\xB2",
		"\x83\x75" => "\xEA\xB8\xB3",
		"\x83\x76" => "\xEA\xB8\xB5",
		"\x83\x77" => "\xEA\xB8\xB6",
		"\x83\x78" => "\xEA\xB8\xB9",
		"\x83\x79" => "\xEA\xB8\xBB",
		"\x83\x7A" => "\xEA\xB8\xBC",
		"\x83\x81" => "\xEA\xB8\xBD",
		"\x83\x82" => "\xEA\xB8\xBE",
		"\x83\x83" => "\xEA\xB8\xBF",
		"\x83\x84" => "\xEA\xB9\x82",
		"\x83\x85" => "\xEA\xB9\x84",
		"\x83\x86" => "\xEA\xB9\x87",
		"\x83\x87" => "\xEA\xB9\x88",
		"\x83\x88" => "\xEA\xB9\x89",
		"\x83\x89" => "\xEA\xB9\x8B",
		"\x83\x8A" => "\xEA\xB9\x8F",
		"\x83\x8B" => "\xEA\xB9\x91",
		"\x83\x8C" => "\xEA\xB9\x92",
		"\x83\x8D" => "\xEA\xB9\x93",
		"\x83\x8E" => "\xEA\xB9\x95",
		"\x83\x8F" => "\xEA\xB9\x97",
		"\x83\x90" => "\xEA\xB9\x98",
		"\x83\x91" => "\xEA\xB9\x99",
		"\x83\x92" => "\xEA\xB9\x9A",
		"\x83\x93" => "\xEA\xB9\x9B",
		"\x83\x94" => "\xEA\xB9\x9E",
		"\x83\x95" => "\xEA\xB9\xA2",
		"\x83\x96" => "\xEA\xB9\xA3",
		"\x83\x97" => "\xEA\xB9\xA4",
		"\x83\x98" => "\xEA\xB9\xA6",
		"\x83\x99" => "\xEA\xB9\xA7",
		"\x83\x9A" => "\xEA\xB9\xAA",
		"\x83\x9B" => "\xEA\xB9\xAB",
		"\x83\x9C" => "\xEA\xB9\xAD",
		"\x83\x9D" => "\xEA\xB9\xAE",
		"\x83\x9E" => "\xEA\xB9\xAF",
		"\x83\x9F" => "\xEA\xB9\xB1",
		"\x83\xA0" => "\xEA\xB9\xB2",
		"\x83\xA1" => "\xEA\xB9\xB3",
		"\x83\xA2" => "\xEA\xB9\xB4",
		"\x83\xA3" => "\xEA\xB9\xB5",
		"\x83\xA4" => "\xEA\xB9\xB6",
		"\x83\xA5" => "\xEA\xB9\xB7",
		"\x83\xA6" => "\xEA\xB9\xBA",
		"\x83\xA7" => "\xEA\xB9\xBE",
		"\x83\xA8" => "\xEA\xB9\xBF",
		"\x83\xA9" => "\xEA\xBA\x80",
		"\x83\xAA" => "\xEA\xBA\x81",
		"\x83\xAB" => "\xEA\xBA\x82",
		"\x83\xAC" => "\xEA\xBA\x83",
		"\x83\xAD" => "\xEA\xBA\x86",
		"\x83\xAE" => "\xEA\xBA\x87",
		"\x83\xAF" => "\xEA\xBA\x88",
		"\x83\xB0" => "\xEA\xBA\x89",
		"\x83\xB1" => "\xEA\xBA\x8A",
		"\x83\xB2" => "\xEA\xBA\x8B",
		"\x83\xB3" => "\xEA\xBA\x8D",
		"\x83\xB4" => "\xEA\xBA\x8E",
		"\x83\xB5" => "\xEA\xBA\x8F",
		"\x83\xB6" => "\xEA\xBA\x90",
		"\x83\xB7" => "\xEA\xBA\x91",
		"\x83\xB8" => "\xEA\xBA\x92",
		"\x83\xB9" => "\xEA\xBA\x93",
		"\x83\xBA" => "\xEA\xBA\x94",
		"\x83\xBB" => "\xEA\xBA\x95",
		"\x83\xBC" => "\xEA\xBA\x96",
		"\x83\xBD" => "\xEA\xBA\x97",
		"\x83\xBE" => "\xEA\xBA\x98",
		"\x83\xBF" => "\xEA\xBA\x99",
		"\x83\xC0" => "\xEA\xBA\x9A",
		"\x83\xC1" => "\xEA\xBA\x9B",
		"\x83\xC2" => "\xEA\xBA\x9C",
		"\x83\xC3" => "\xEA\xBA\x9D",
		"\x83\xC4" => "\xEA\xBA\x9E",
		"\x83\xC5" => "\xEA\xBA\x9F",
		"\x83\xC6" => "\xEA\xBA\xA0",
		"\x83\xC7" => "\xEA\xBA\xA1",
		"\x83\xC8" => "\xEA\xBA\xA2",
		"\x83\xC9" => "\xEA\xBA\xA3",
		"\x83\xCA" => "\xEA\xBA\xA4",
		"\x83\xCB" => "\xEA\xBA\xA5",
		"\x83\xCC" => "\xEA\xBA\xA6",
		"\x83\xCD" => "\xEA\xBA\xA7",
		"\x83\xCE" => "\xEA\xBA\xA8",
		"\x83\xCF" => "\xEA\xBA\xA9",
		"\x83\xD0" => "\xEA\xBA\xAA",
		"\x83\xD1" => "\xEA\xBA\xAB",
		"\x83\xD2" => "\xEA\xBA\xAC",
		"\x83\xD3" => "\xEA\xBA\xAD",
		"\x83\xD4" => "\xEA\xBA\xAE",
		"\x83\xD5" => "\xEA\xBA\xAF",
		"\x83\xD6" => "\xEA\xBA\xB0",
		"\x83\xD7" => "\xEA\xBA\xB1",
		"\x83\xD8" => "\xEA\xBA\xB2",
		"\x83\xD9" => "\xEA\xBA\xB3",
		"\x83\xDA" => "\xEA\xBA\xB4",
		"\x83\xDB" => "\xEA\xBA\xB5",
		"\x83\xDC" => "\xEA\xBA\xB6",
		"\x83\xDD" => "\xEA\xBA\xB7",
		"\x83\xDE" => "\xEA\xBA\xB8",
		"\x83\xDF" => "\xEA\xBA\xB9",
		"\x83\xE0" => "\xEA\xBA\xBA",
		"\x83\xE1" => "\xEA\xBA\xBB",
		"\x83\xE2" => "\xEA\xBA\xBF",
		"\x83\xE3" => "\xEA\xBB\x81",
		"\x83\xE4" => "\xEA\xBB\x82",
		"\x83\xE5" => "\xEA\xBB\x83",
		"\x83\xE6" => "\xEA\xBB\x85",
		"\x83\xE7" => "\xEA\xBB\x86",
		"\x83\xE8" => "\xEA\xBB\x87",
		"\x83\xE9" => "\xEA\xBB\x88",
		"\x83\xEA" => "\xEA\xBB\x89",
		"\x83\xEB" => "\xEA\xBB\x8A",
		"\x83\xEC" => "\xEA\xBB\x8B",
		"\x83\xED" => "\xEA\xBB\x8E",
		"\x83\xEE" => "\xEA\xBB\x92",
		"\x83\xEF" => "\xEA\xBB\x93",
		"\x83\xF0" => "\xEA\xBB\x94",
		"\x83\xF1" => "\xEA\xBB\x95",
		"\x83\xF2" => "\xEA\xBB\x96",
		"\x83\xF3" => "\xEA\xBB\x97",
		"\x83\xF4" => "\xEA\xBB\x9A",
		"\x83\xF5" => "\xEA\xBB\x9B",
		"\x83\xF6" => "\xEA\xBB\x9D",
		"\x83\xF7" => "\xEA\xBB\x9E",
		"\x83\xF8" => "\xEA\xBB\x9F",
		"\x83\xF9" => "\xEA\xBB\xA0",
		"\x83\xFA" => "\xEA\xBB\xA1",
		"\x83\xFB" => "\xEA\xBB\xA2",
		"\x83\xFC" => "\xEA\xBB\xA3",
		"\x83\xFD" => "\xEA\xBB\xA4",
		"\x83\xFE" => "\xEA\xBB\xA5",
		"\x84\x41" => "\xEA\xBB\xA6",
		"\x84\x42" => "\xEA\xBB\xA7",
		"\x84\x43" => "\xEA\xBB\xA9",
		"\x84\x44" => "\xEA\xBB\xAA",
		"\x84\x45" => "\xEA\xBB\xAC",
		"\x84\x46" => "\xEA\xBB\xAE",
		"\x84\x47" => "\xEA\xBB\xAF",
		"\x84\x48" => "\xEA\xBB\xB0",
		"\x84\x49" => "\xEA\xBB\xB1",
		"\x84\x4A" => "\xEA\xBB\xB2",
		"\x84\x4B" => "\xEA\xBB\xB3",
		"\x84\x4C" => "\xEA\xBB\xB5",
		"\x84\x4D" => "\xEA\xBB\xB6",
		"\x84\x4E" => "\xEA\xBB\xB7",
		"\x84\x4F" => "\xEA\xBB\xB9",
		"\x84\x50" => "\xEA\xBB\xBA",
		"\x84\x51" => "\xEA\xBB\xBB",
		"\x84\x52" => "\xEA\xBB\xBD",
		"\x84\x53" => "\xEA\xBB\xBE",
		"\x84\x54" => "\xEA\xBB\xBF",
		"\x84\x55" => "\xEA\xBC\x80",
		"\x84\x56" => "\xEA\xBC\x81",
		"\x84\x57" => "\xEA\xBC\x82",
		"\x84\x58" => "\xEA\xBC\x83",
		"\x84\x59" => "\xEA\xBC\x84",
		"\x84\x5A" => "\xEA\xBC\x85",
		"\x84\x61" => "\xEA\xBC\x86",
		"\x84\x62" => "\xEA\xBC\x89",
		"\x84\x63" => "\xEA\xBC\x8A",
		"\x84\x64" => "\xEA\xBC\x8B",
		"\x84\x65" => "\xEA\xBC\x8C",
		"\x84\x66" => "\xEA\xBC\x8E",
		"\x84\x67" => "\xEA\xBC\x8F",
		"\x84\x68" => "\xEA\xBC\x91",
		"\x84\x69" => "\xEA\xBC\x92",
		"\x84\x6A" => "\xEA\xBC\x93",
		"\x84\x6B" => "\xEA\xBC\x94",
		"\x84\x6C" => "\xEA\xBC\x95",
		"\x84\x6D" => "\xEA\xBC\x96",
		"\x84\x6E" => "\xEA\xBC\x97",
		"\x84\x6F" => "\xEA\xBC\x98",
		"\x84\x70" => "\xEA\xBC\x99",
		"\x84\x71" => "\xEA\xBC\x9A",
		"\x84\x72" => "\xEA\xBC\x9B",
		"\x84\x73" => "\xEA\xBC\x9C",
		"\x84\x74" => "\xEA\xBC\x9D",
		"\x84\x75" => "\xEA\xBC\x9E",
		"\x84\x76" => "\xEA\xBC\x9F",
		"\x84\x77" => "\xEA\xBC\xA0",
		"\x84\x78" => "\xEA\xBC\xA1",
		"\x84\x79" => "\xEA\xBC\xA2",
		"\x84\x7A" => "\xEA\xBC\xA3",
		"\x84\x81" => "\xEA\xBC\xA4",
		"\x84\x82" => "\xEA\xBC\xA5",
		"\x84\x83" => "\xEA\xBC\xA6",
		"\x84\x84" => "\xEA\xBC\xA7",
		"\x84\x85" => "\xEA\xBC\xA8",
		"\x84\x86" => "\xEA\xBC\xA9",
		"\x84\x87" => "\xEA\xBC\xAA",
		"\x84\x88" => "\xEA\xBC\xAB",
		"\x84\x89" => "\xEA\xBC\xAE",
		"\x84\x8A" => "\xEA\xBC\xAF",
		"\x84\x8B" => "\xEA\xBC\xB1",
		"\x84\x8C" => "\xEA\xBC\xB3",
		"\x84\x8D" => "\xEA\xBC\xB5",
		"\x84\x8E" => "\xEA\xBC\xB6",
		"\x84\x8F" => "\xEA\xBC\xB7",
		"\x84\x90" => "\xEA\xBC\xB8",
		"\x84\x91" => "\xEA\xBC\xB9",
		"\x84\x92" => "\xEA\xBC\xBA",
		"\x84\x93" => "\xEA\xBC\xBB",
		"\x84\x94" => "\xEA\xBC\xBE",
		"\x84\x95" => "\xEA\xBD\x80",
		"\x84\x96" => "\xEA\xBD\x84",
		"\x84\x97" => "\xEA\xBD\x85",
		"\x84\x98" => "\xEA\xBD\x86",
		"\x84\x99" => "\xEA\xBD\x87",
		"\x84\x9A" => "\xEA\xBD\x8A",
		"\x84\x9B" => "\xEA\xBD\x8B",
		"\x84\x9C" => "\xEA\xBD\x8C",
		"\x84\x9D" => "\xEA\xBD\x8D",
		"\x84\x9E" => "\xEA\xBD\x8E",
		"\x84\x9F" => "\xEA\xBD\x8F",
		"\x84\xA0" => "\xEA\xBD\x91",
		"\x84\xA1" => "\xEA\xBD\x92",
		"\x84\xA2" => "\xEA\xBD\x93",
		"\x84\xA3" => "\xEA\xBD\x94",
		"\x84\xA4" => "\xEA\xBD\x95",
		"\x84\xA5" => "\xEA\xBD\x96",
		"\x84\xA6" => "\xEA\xBD\x97",
		"\x84\xA7" => "\xEA\xBD\x98",
		"\x84\xA8" => "\xEA\xBD\x99",
		"\x84\xA9" => "\xEA\xBD\x9A",
		"\x84\xAA" => "\xEA\xBD\x9B",
		"\x84\xAB" => "\xEA\xBD\x9E",
		"\x84\xAC" => "\xEA\xBD\x9F",
		"\x84\xAD" => "\xEA\xBD\xA0",
		"\x84\xAE" => "\xEA\xBD\xA1",
		"\x84\xAF" => "\xEA\xBD\xA2",
		"\x84\xB0" => "\xEA\xBD\xA3",
		"\x84\xB1" => "\xEA\xBD\xA6",
		"\x84\xB2" => "\xEA\xBD\xA7",
		"\x84\xB3" => "\xEA\xBD\xA8",
		"\x84\xB4" => "\xEA\xBD\xA9",
		"\x84\xB5" => "\xEA\xBD\xAA",
		"\x84\xB6" => "\xEA\xBD\xAB",
		"\x84\xB7" => "\xEA\xBD\xAC",
		"\x84\xB8" => "\xEA\xBD\xAD",
		"\x84\xB9" => "\xEA\xBD\xAE",
		"\x84\xBA" => "\xEA\xBD\xAF",
		"\x84\xBB" => "\xEA\xBD\xB0",
		"\x84\xBC" => "\xEA\xBD\xB1",
		"\x84\xBD" => "\xEA\xBD\xB2",
		"\x84\xBE" => "\xEA\xBD\xB3",
		"\x84\xBF" => "\xEA\xBD\xB4",
		"\x84\xC0" => "\xEA\xBD\xB5",
		"\x84\xC1" => "\xEA\xBD\xB6",
		"\x84\xC2" => "\xEA\xBD\xB7",
		"\x84\xC3" => "\xEA\xBD\xB8",
		"\x84\xC4" => "\xEA\xBD\xBA",
		"\x84\xC5" => "\xEA\xBD\xBB",
		"\x84\xC6" => "\xEA\xBD\xBC",
		"\x84\xC7" => "\xEA\xBD\xBD",
		"\x84\xC8" => "\xEA\xBD\xBE",
		"\x84\xC9" => "\xEA\xBD\xBF",
		"\x84\xCA" => "\xEA\xBE\x81",
		"\x84\xCB" => "\xEA\xBE\x82",
		"\x84\xCC" => "\xEA\xBE\x83",
		"\x84\xCD" => "\xEA\xBE\x85",
		"\x84\xCE" => "\xEA\xBE\x86",
		"\x84\xCF" => "\xEA\xBE\x87",
		"\x84\xD0" => "\xEA\xBE\x89",
		"\x84\xD1" => "\xEA\xBE\x8A",
		"\x84\xD2" => "\xEA\xBE\x8B",
		"\x84\xD3" => "\xEA\xBE\x8C",
		"\x84\xD4" => "\xEA\xBE\x8D",
		"\x84\xD5" => "\xEA\xBE\x8E",
		"\x84\xD6" => "\xEA\xBE\x8F",
		"\x84\xD7" => "\xEA\xBE\x92",
		"\x84\xD8" => "\xEA\xBE\x93",
		"\x84\xD9" => "\xEA\xBE\x94",
		"\x84\xDA" => "\xEA\xBE\x96",
		"\x84\xDB" => "\xEA\xBE\x97",
		"\x84\xDC" => "\xEA\xBE\x98",
		"\x84\xDD" => "\xEA\xBE\x99",
		"\x84\xDE" => "\xEA\xBE\x9A",
		"\x84\xDF" => "\xEA\xBE\x9B",
		"\x84\xE0" => "\xEA\xBE\x9D",
		"\x84\xE1" => "\xEA\xBE\x9E",
		"\x84\xE2" => "\xEA\xBE\x9F",
		"\x84\xE3" => "\xEA\xBE\xA0",
		"\x84\xE4" => "\xEA\xBE\xA1",
		"\x84\xE5" => "\xEA\xBE\xA2",
		"\x84\xE6" => "\xEA\xBE\xA3",
		"\x84\xE7" => "\xEA\xBE\xA4",
		"\x84\xE8" => "\xEA\xBE\xA5",
		"\x84\xE9" => "\xEA\xBE\xA6",
		"\x84\xEA" => "\xEA\xBE\xA7",
		"\x84\xEB" => "\xEA\xBE\xA8",
		"\x84\xEC" => "\xEA\xBE\xA9",
		"\x84\xED" => "\xEA\xBE\xAA",
		"\x84\xEE" => "\xEA\xBE\xAB",
		"\x84\xEF" => "\xEA\xBE\xAC",
		"\x84\xF0" => "\xEA\xBE\xAD",
		"\x84\xF1" => "\xEA\xBE\xAE",
		"\x84\xF2" => "\xEA\xBE\xAF",
		"\x84\xF3" => "\xEA\xBE\xB0",
		"\x84\xF4" => "\xEA\xBE\xB1",
		"\x84\xF5" => "\xEA\xBE\xB2",
		"\x84\xF6" => "\xEA\xBE\xB3",
		"\x84\xF7" => "\xEA\xBE\xB4",
		"\x84\xF8" => "\xEA\xBE\xB5",
		"\x84\xF9" => "\xEA\xBE\xB6",
		"\x84\xFA" => "\xEA\xBE\xB7",
		"\x84\xFB" => "\xEA\xBE\xBA",
		"\x84\xFC" => "\xEA\xBE\xBB",
		"\x84\xFD" => "\xEA\xBE\xBD",
		"\x84\xFE" => "\xEA\xBE\xBE",
		"\x85\x41" => "\xEA\xBE\xBF",
		"\x85\x42" => "\xEA\xBF\x81",
		"\x85\x43" => "\xEA\xBF\x82",
		"\x85\x44" => "\xEA\xBF\x83",
		"\x85\x45" => "\xEA\xBF\x84",
		"\x85\x46" => "\xEA\xBF\x85",
		"\x85\x47" => "\xEA\xBF\x86",
		"\x85\x48" => "\xEA\xBF\x8A",
		"\x85\x49" => "\xEA\xBF\x8C",
		"\x85\x4A" => "\xEA\xBF\x8F",
		"\x85\x4B" => "\xEA\xBF\x90",
		"\x85\x4C" => "\xEA\xBF\x91",
		"\x85\x4D" => "\xEA\xBF\x92",
		"\x85\x4E" => "\xEA\xBF\x93",
		"\x85\x4F" => "\xEA\xBF\x95",
		"\x85\x50" => "\xEA\xBF\x96",
		"\x85\x51" => "\xEA\xBF\x97",
		"\x85\x52" => "\xEA\xBF\x98",
		"\x85\x53" => "\xEA\xBF\x99",
		"\x85\x54" => "\xEA\xBF\x9A",
		"\x85\x55" => "\xEA\xBF\x9B",
		"\x85\x56" => "\xEA\xBF\x9D",
		"\x85\x57" => "\xEA\xBF\x9E",
		"\x85\x58" => "\xEA\xBF\x9F",
		"\x85\x59" => "\xEA\xBF\xA0",
		"\x85\x5A" => "\xEA\xBF\xA1",
		"\x85\x61" => "\xEA\xBF\xA2",
		"\x85\x62" => "\xEA\xBF\xA3",
		"\x85\x63" => "\xEA\xBF\xA4",
		"\x85\x64" => "\xEA\xBF\xA5",
		"\x85\x65" => "\xEA\xBF\xA6",
		"\x85\x66" => "\xEA\xBF\xA7",
		"\x85\x67" => "\xEA\xBF\xAA",
		"\x85\x68" => "\xEA\xBF\xAB",
		"\x85\x69" => "\xEA\xBF\xAC",
		"\x85\x6A" => "\xEA\xBF\xAD",
		"\x85\x6B" => "\xEA\xBF\xAE",
		"\x85\x6C" => "\xEA\xBF\xAF",
		"\x85\x6D" => "\xEA\xBF\xB2",
		"\x85\x6E" => "\xEA\xBF\xB3",
		"\x85\x6F" => "\xEA\xBF\xB5",
		"\x85\x70" => "\xEA\xBF\xB6",
		"\x85\x71" => "\xEA\xBF\xB7",
		"\x85\x72" => "\xEA\xBF\xB9",
		"\x85\x73" => "\xEA\xBF\xBA",
		"\x85\x74" => "\xEA\xBF\xBB",
		"\x85\x75" => "\xEA\xBF\xBC",
		"\x85\x76" => "\xEA\xBF\xBD",
		"\x85\x77" => "\xEA\xBF\xBE",
		"\x85\x78" => "\xEA\xBF\xBF",
		"\x85\x79" => "\xEB\x80\x82",
		"\x85\x7A" => "\xEB\x80\x83",
		"\x85\x81" => "\xEB\x80\x85",
		"\x85\x82" => "\xEB\x80\x86",
		"\x85\x83" => "\xEB\x80\x87",
		"\x85\x84" => "\xEB\x80\x88",
		"\x85\x85" => "\xEB\x80\x89",
		"\x85\x86" => "\xEB\x80\x8A",
		"\x85\x87" => "\xEB\x80\x8B",
		"\x85\x88" => "\xEB\x80\x8D",
		"\x85\x89" => "\xEB\x80\x8E",
		"\x85\x8A" => "\xEB\x80\x8F",
		"\x85\x8B" => "\xEB\x80\x91",
		"\x85\x8C" => "\xEB\x80\x92",
		"\x85\x8D" => "\xEB\x80\x93",
		"\x85\x8E" => "\xEB\x80\x95",
		"\x85\x8F" => "\xEB\x80\x96",
		"\x85\x90" => "\xEB\x80\x97",
		"\x85\x91" => "\xEB\x80\x98",
		"\x85\x92" => "\xEB\x80\x99",
		"\x85\x93" => "\xEB\x80\x9A",
		"\x85\x94" => "\xEB\x80\x9B",
		"\x85\x95" => "\xEB\x80\x9E",
		"\x85\x96" => "\xEB\x80\x9F",
		"\x85\x97" => "\xEB\x80\xA0",
		"\x85\x98" => "\xEB\x80\xA1",
		"\x85\x99" => "\xEB\x80\xA2",
		"\x85\x9A" => "\xEB\x80\xA3",
		"\x85\x9B" => "\xEB\x80\xA4",
		"\x85\x9C" => "\xEB\x80\xA5",
		"\x85\x9D" => "\xEB\x80\xA6",
		"\x85\x9E" => "\xEB\x80\xA7",
		"\x85\x9F" => "\xEB\x80\xA9",
		"\x85\xA0" => "\xEB\x80\xAA",
		"\x85\xA1" => "\xEB\x80\xAB",
		"\x85\xA2" => "\xEB\x80\xAC",
		"\x85\xA3" => "\xEB\x80\xAD",
		"\x85\xA4" => "\xEB\x80\xAE",
		"\x85\xA5" => "\xEB\x80\xAF",
		"\x85\xA6" => "\xEB\x80\xB0",
		"\x85\xA7" => "\xEB\x80\xB1",
		"\x85\xA8" => "\xEB\x80\xB2",
		"\x85\xA9" => "\xEB\x80\xB3",
		"\x85\xAA" => "\xEB\x80\xB4",
		"\x85\xAB" => "\xEB\x80\xB5",
		"\x85\xAC" => "\xEB\x80\xB6",
		"\x85\xAD" => "\xEB\x80\xB7",
		"\x85\xAE" => "\xEB\x80\xB8",
		"\x85\xAF" => "\xEB\x80\xB9",
		"\x85\xB0" => "\xEB\x80\xBA",
		"\x85\xB1" => "\xEB\x80\xBB",
		"\x85\xB2" => "\xEB\x80\xBC",
		"\x85\xB3" => "\xEB\x80\xBD",
		"\x85\xB4" => "\xEB\x80\xBE",
		"\x85\xB5" => "\xEB\x80\xBF",
		"\x85\xB6" => "\xEB\x81\x80",
		"\x85\xB7" => "\xEB\x81\x81",
		"\x85\xB8" => "\xEB\x81\x82",
		"\x85\xB9" => "\xEB\x81\x83",
		"\x85\xBA" => "\xEB\x81\x86",
		"\x85\xBB" => "\xEB\x81\x87",
		"\x85\xBC" => "\xEB\x81\x89",
		"\x85\xBD" => "\xEB\x81\x8B",
		"\x85\xBE" => "\xEB\x81\x8D",
		"\x85\xBF" => "\xEB\x81\x8F",
		"\x85\xC0" => "\xEB\x81\x90",
		"\x85\xC1" => "\xEB\x81\x91",
		"\x85\xC2" => "\xEB\x81\x92",
		"\x85\xC3" => "\xEB\x81\x96",
		"\x85\xC4" => "\xEB\x81\x98",
		"\x85\xC5" => "\xEB\x81\x9A",
		"\x85\xC6" => "\xEB\x81\x9B",
		"\x85\xC7" => "\xEB\x81\x9C",
		"\x85\xC8" => "\xEB\x81\x9E",
		"\x85\xC9" => "\xEB\x81\x9F",
		"\x85\xCA" => "\xEB\x81\xA0",
		"\x85\xCB" => "\xEB\x81\xA1",
		"\x85\xCC" => "\xEB\x81\xA2",
		"\x85\xCD" => "\xEB\x81\xA3",
		"\x85\xCE" => "\xEB\x81\xA4",
		"\x85\xCF" => "\xEB\x81\xA5",
		"\x85\xD0" => "\xEB\x81\xA6",
		"\x85\xD1" => "\xEB\x81\xA7",
		"\x85\xD2" => "\xEB\x81\xA8",
		"\x85\xD3" => "\xEB\x81\xA9",
		"\x85\xD4" => "\xEB\x81\xAA",
		"\x85\xD5" => "\xEB\x81\xAB",
		"\x85\xD6" => "\xEB\x81\xAC",
		"\x85\xD7" => "\xEB\x81\xAD",
		"\x85\xD8" => "\xEB\x81\xAE",
		"\x85\xD9" => "\xEB\x81\xAF",
		"\x85\xDA" => "\xEB\x81\xB0",
		"\x85\xDB" => "\xEB\x81\xB1",
		"\x85\xDC" => "\xEB\x81\xB2",
		"\x85\xDD" => "\xEB\x81\xB3",
		"\x85\xDE" => "\xEB\x81\xB4",
		"\x85\xDF" => "\xEB\x81\xB5",
		"\x85\xE0" => "\xEB\x81\xB6",
		"\x85\xE1" => "\xEB\x81\xB7",
		"\x85\xE2" => "\xEB\x81\xB8",
		"\x85\xE3" => "\xEB\x81\xB9",
		"\x85\xE4" => "\xEB\x81\xBA",
		"\x85\xE5" => "\xEB\x81\xBB",
		"\x85\xE6" => "\xEB\x81\xBE",
		"\x85\xE7" => "\xEB\x81\xBF",
		"\x85\xE8" => "\xEB\x82\x81",
		"\x85\xE9" => "\xEB\x82\x82",
		"\x85\xEA" => "\xEB\x82\x83",
		"\x85\xEB" => "\xEB\x82\x85",
		"\x85\xEC" => "\xEB\x82\x86",
		"\x85\xED" => "\xEB\x82\x87",
		"\x85\xEE" => "\xEB\x82\x88",
		"\x85\xEF" => "\xEB\x82\x89",
		"\x85\xF0" => "\xEB\x82\x8A",
		"\x85\xF1" => "\xEB\x82\x8B",
		"\x85\xF2" => "\xEB\x82\x8E",
		"\x85\xF3" => "\xEB\x82\x90",
		"\x85\xF4" => "\xEB\x82\x92",
		"\x85\xF5" => "\xEB\x82\x93",
		"\x85\xF6" => "\xEB\x82\x94",
		"\x85\xF7" => "\xEB\x82\x95",
		"\x85\xF8" => "\xEB\x82\x96",
		"\x85\xF9" => "\xEB\x82\x97",
		"\x85\xFA" => "\xEB\x82\x9B",
		"\x85\xFB" => "\xEB\x82\x9D",
		"\x85\xFC" => "\xEB\x82\x9E",
		"\x85\xFD" => "\xEB\x82\xA3",
		"\x85\xFE" => "\xEB\x82\xA4",
		"\x86\x41" => "\xEB\x82\xA5",
		"\x86\x42" => "\xEB\x82\xA6",
		"\x86\x43" => "\xEB\x82\xA7",
		"\x86\x44" => "\xEB\x82\xAA",
		"\x86\x45" => "\xEB\x82\xB0",
		"\x86\x46" => "\xEB\x82\xB2",
		"\x86\x47" => "\xEB\x82\xB6",
		"\x86\x48" => "\xEB\x82\xB7",
		"\x86\x49" => "\xEB\x82\xB9",
		"\x86\x4A" => "\xEB\x82\xBA",
		"\x86\x4B" => "\xEB\x82\xBB",
		"\x86\x4C" => "\xEB\x82\xBD",
		"\x86\x4D" => "\xEB\x82\xBE",
		"\x86\x4E" => "\xEB\x82\xBF",
		"\x86\x4F" => "\xEB\x83\x80",
		"\x86\x50" => "\xEB\x83\x81",
		"\x86\x51" => "\xEB\x83\x82",
		"\x86\x52" => "\xEB\x83\x83",
		"\x86\x53" => "\xEB\x83\x86",
		"\x86\x54" => "\xEB\x83\x8A",
		"\x86\x55" => "\xEB\x83\x8B",
		"\x86\x56" => "\xEB\x83\x8C",
		"\x86\x57" => "\xEB\x83\x8D",
		"\x86\x58" => "\xEB\x83\x8E",
		"\x86\x59" => "\xEB\x83\x8F",
		"\x86\x5A" => "\xEB\x83\x92",
		"\x86\x61" => "\xEB\x83\x93",
		"\x86\x62" => "\xEB\x83\x95",
		"\x86\x63" => "\xEB\x83\x96",
		"\x86\x64" => "\xEB\x83\x97",
		"\x86\x65" => "\xEB\x83\x99",
		"\x86\x66" => "\xEB\x83\x9A",
		"\x86\x67" => "\xEB\x83\x9B",
		"\x86\x68" => "\xEB\x83\x9C",
		"\x86\x69" => "\xEB\x83\x9D",
		"\x86\x6A" => "\xEB\x83\x9E",
		"\x86\x6B" => "\xEB\x83\x9F",
		"\x86\x6C" => "\xEB\x83\xA1",
		"\x86\x6D" => "\xEB\x83\xA2",
		"\x86\x6E" => "\xEB\x83\xA3",
		"\x86\x6F" => "\xEB\x83\xA4",
		"\x86\x70" => "\xEB\x83\xA6",
		"\x86\x71" => "\xEB\x83\xA7",
		"\x86\x72" => "\xEB\x83\xA8",
		"\x86\x73" => "\xEB\x83\xA9",
		"\x86\x74" => "\xEB\x83\xAA",
		"\x86\x75" => "\xEB\x83\xAB",
		"\x86\x76" => "\xEB\x83\xAC",
		"\x86\x77" => "\xEB\x83\xAD",
		"\x86\x78" => "\xEB\x83\xAE",
		"\x86\x79" => "\xEB\x83\xAF",
		"\x86\x7A" => "\xEB\x83\xB0",
		"\x86\x81" => "\xEB\x83\xB1",
		"\x86\x82" => "\xEB\x83\xB2",
		"\x86\x83" => "\xEB\x83\xB3",
		"\x86\x84" => "\xEB\x83\xB4",
		"\x86\x85" => "\xEB\x83\xB5",
		"\x86\x86" => "\xEB\x83\xB6",
		"\x86\x87" => "\xEB\x83\xB7",
		"\x86\x88" => "\xEB\x83\xB8",
		"\x86\x89" => "\xEB\x83\xB9",
		"\x86\x8A" => "\xEB\x83\xBA",
		"\x86\x8B" => "\xEB\x83\xBB",
		"\x86\x8C" => "\xEB\x83\xBC",
		"\x86\x8D" => "\xEB\x83\xBD",
		"\x86\x8E" => "\xEB\x83\xBE",
		"\x86\x8F" => "\xEB\x83\xBF",
		"\x86\x90" => "\xEB\x84\x80",
		"\x86\x91" => "\xEB\x84\x81",
		"\x86\x92" => "\xEB\x84\x82",
		"\x86\x93" => "\xEB\x84\x83",
		"\x86\x94" => "\xEB\x84\x84",
		"\x86\x95" => "\xEB\x84\x85",
		"\x86\x96" => "\xEB\x84\x86",
		"\x86\x97" => "\xEB\x84\x87",
		"\x86\x98" => "\xEB\x84\x8A",
		"\x86\x99" => "\xEB\x84\x8D",
		"\x86\x9A" => "\xEB\x84\x8E",
		"\x86\x9B" => "\xEB\x84\x8F",
		"\x86\x9C" => "\xEB\x84\x91",
		"\x86\x9D" => "\xEB\x84\x94",
		"\x86\x9E" => "\xEB\x84\x95",
		"\x86\x9F" => "\xEB\x84\x96",
		"\x86\xA0" => "\xEB\x84\x97",
		"\x86\xA1" => "\xEB\x84\x9A",
		"\x86\xA2" => "\xEB\x84\x9E",
		"\x86\xA3" => "\xEB\x84\x9F",
		"\x86\xA4" => "\xEB\x84\xA0",
		"\x86\xA5" => "\xEB\x84\xA1",
		"\x86\xA6" => "\xEB\x84\xA2",
		"\x86\xA7" => "\xEB\x84\xA6",
		"\x86\xA8" => "\xEB\x84\xA7",
		"\x86\xA9" => "\xEB\x84\xA9",
		"\x86\xAA" => "\xEB\x84\xAA",
		"\x86\xAB" => "\xEB\x84\xAB",
		"\x86\xAC" => "\xEB\x84\xAD",
		"\x86\xAD" => "\xEB\x84\xAE",
		"\x86\xAE" => "\xEB\x84\xAF",
		"\x86\xAF" => "\xEB\x84\xB0",
		"\x86\xB0" => "\xEB\x84\xB1",
		"\x86\xB1" => "\xEB\x84\xB2",
		"\x86\xB2" => "\xEB\x84\xB3",
		"\x86\xB3" => "\xEB\x84\xB6",
		"\x86\xB4" => "\xEB\x84\xBA",
		"\x86\xB5" => "\xEB\x84\xBB",
		"\x86\xB6" => "\xEB\x84\xBC",
		"\x86\xB7" => "\xEB\x84\xBD",
		"\x86\xB8" => "\xEB\x84\xBE",
		"\x86\xB9" => "\xEB\x84\xBF",
		"\x86\xBA" => "\xEB\x85\x82",
		"\x86\xBB" => "\xEB\x85\x83",
		"\x86\xBC" => "\xEB\x85\x85",
		"\x86\xBD" => "\xEB\x85\x86",
		"\x86\xBE" => "\xEB\x85\x87",
		"\x86\xBF" => "\xEB\x85\x89",
		"\x86\xC0" => "\xEB\x85\x8A",
		"\x86\xC1" => "\xEB\x85\x8B",
		"\x86\xC2" => "\xEB\x85\x8C",
		"\x86\xC3" => "\xEB\x85\x8D",
		"\x86\xC4" => "\xEB\x85\x8E",
		"\x86\xC5" => "\xEB\x85\x8F",
		"\x86\xC6" => "\xEB\x85\x92",
		"\x86\xC7" => "\xEB\x85\x93",
		"\x86\xC8" => "\xEB\x85\x96",
		"\x86\xC9" => "\xEB\x85\x97",
		"\x86\xCA" => "\xEB\x85\x99",
		"\x86\xCB" => "\xEB\x85\x9A",
		"\x86\xCC" => "\xEB\x85\x9B",
		"\x86\xCD" => "\xEB\x85\x9D",
		"\x86\xCE" => "\xEB\x85\x9E",
		"\x86\xCF" => "\xEB\x85\x9F",
		"\x86\xD0" => "\xEB\x85\xA1",
		"\x86\xD1" => "\xEB\x85\xA2",
		"\x86\xD2" => "\xEB\x85\xA3",
		"\x86\xD3" => "\xEB\x85\xA4",
		"\x86\xD4" => "\xEB\x85\xA5",
		"\x86\xD5" => "\xEB\x85\xA6",
		"\x86\xD6" => "\xEB\x85\xA7",
		"\x86\xD7" => "\xEB\x85\xA8",
		"\x86\xD8" => "\xEB\x85\xA9",
		"\x86\xD9" => "\xEB\x85\xAA",
		"\x86\xDA" => "\xEB\x85\xAB",
		"\x86\xDB" => "\xEB\x85\xAC",
		"\x86\xDC" => "\xEB\x85\xAD",
		"\x86\xDD" => "\xEB\x85\xAE",
		"\x86\xDE" => "\xEB\x85\xAF",
		"\x86\xDF" => "\xEB\x85\xB0",
		"\x86\xE0" => "\xEB\x85\xB1",
		"\x86\xE1" => "\xEB\x85\xB2",
		"\x86\xE2" => "\xEB\x85\xB3",
		"\x86\xE3" => "\xEB\x85\xB4",
		"\x86\xE4" => "\xEB\x85\xB5",
		"\x86\xE5" => "\xEB\x85\xB6",
		"\x86\xE6" => "\xEB\x85\xB7",
		"\x86\xE7" => "\xEB\x85\xBA",
		"\x86\xE8" => "\xEB\x85\xBB",
		"\x86\xE9" => "\xEB\x85\xBD",
		"\x86\xEA" => "\xEB\x85\xBE",
		"\x86\xEB" => "\xEB\x85\xBF",
		"\x86\xEC" => "\xEB\x86\x81",
		"\x86\xED" => "\xEB\x86\x83",
		"\x86\xEE" => "\xEB\x86\x84",
		"\x86\xEF" => "\xEB\x86\x85",
		"\x86\xF0" => "\xEB\x86\x86",
		"\x86\xF1" => "\xEB\x86\x87",
		"\x86\xF2" => "\xEB\x86\x8A",
		"\x86\xF3" => "\xEB\x86\x8C",
		"\x86\xF4" => "\xEB\x86\x8E",
		"\x86\xF5" => "\xEB\x86\x8F",
		"\x86\xF6" => "\xEB\x86\x90",
		"\x86\xF7" => "\xEB\x86\x91",
		"\x86\xF8" => "\xEB\x86\x95",
		"\x86\xF9" => "\xEB\x86\x96",
		"\x86\xFA" => "\xEB\x86\x97",
		"\x86\xFB" => "\xEB\x86\x99",
		"\x86\xFC" => "\xEB\x86\x9A",
		"\x86\xFD" => "\xEB\x86\x9B",
		"\x86\xFE" => "\xEB\x86\x9D",
		"\x87\x41" => "\xEB\x86\x9E",
		"\x87\x42" => "\xEB\x86\x9F",
		"\x87\x43" => "\xEB\x86\xA0",
		"\x87\x44" => "\xEB\x86\xA1",
		"\x87\x45" => "\xEB\x86\xA2",
		"\x87\x46" => "\xEB\x86\xA3",
		"\x87\x47" => "\xEB\x86\xA4",
		"\x87\x48" => "\xEB\x86\xA5",
		"\x87\x49" => "\xEB\x86\xA6",
		"\x87\x4A" => "\xEB\x86\xA7",
		"\x87\x4B" => "\xEB\x86\xA9",
		"\x87\x4C" => "\xEB\x86\xAA",
		"\x87\x4D" => "\xEB\x86\xAB",
		"\x87\x4E" => "\xEB\x86\xAC",
		"\x87\x4F" => "\xEB\x86\xAD",
		"\x87\x50" => "\xEB\x86\xAE",
		"\x87\x51" => "\xEB\x86\xAF",
		"\x87\x52" => "\xEB\x86\xB0",
		"\x87\x53" => "\xEB\x86\xB1",
		"\x87\x54" => "\xEB\x86\xB2",
		"\x87\x55" => "\xEB\x86\xB3",
		"\x87\x56" => "\xEB\x86\xB4",
		"\x87\x57" => "\xEB\x86\xB5",
		"\x87\x58" => "\xEB\x86\xB6",
		"\x87\x59" => "\xEB\x86\xB7",
		"\x87\x5A" => "\xEB\x86\xB8",
		"\x87\x61" => "\xEB\x86\xB9",
		"\x87\x62" => "\xEB\x86\xBA",
		"\x87\x63" => "\xEB\x86\xBB",
		"\x87\x64" => "\xEB\x86\xBC",
		"\x87\x65" => "\xEB\x86\xBD",
		"\x87\x66" => "\xEB\x86\xBE",
		"\x87\x67" => "\xEB\x86\xBF",
		"\x87\x68" => "\xEB\x87\x80",
		"\x87\x69" => "\xEB\x87\x81",
		"\x87\x6A" => "\xEB\x87\x82",
		"\x87\x6B" => "\xEB\x87\x83",
		"\x87\x6C" => "\xEB\x87\x84",
		"\x87\x6D" => "\xEB\x87\x85",
		"\x87\x6E" => "\xEB\x87\x86",
		"\x87\x6F" => "\xEB\x87\x87",
		"\x87\x70" => "\xEB\x87\x88",
		"\x87\x71" => "\xEB\x87\x89",
		"\x87\x72" => "\xEB\x87\x8A",
		"\x87\x73" => "\xEB\x87\x8B",
		"\x87\x74" => "\xEB\x87\x8D",
		"\x87\x75" => "\xEB\x87\x8E",
		"\x87\x76" => "\xEB\x87\x8F",
		"\x87\x77" => "\xEB\x87\x91",
		"\x87\x78" => "\xEB\x87\x92",
		"\x87\x79" => "\xEB\x87\x93",
		"\x87\x7A" => "\xEB\x87\x95",
		"\x87\x81" => "\xEB\x87\x96",
		"\x87\x82" => "\xEB\x87\x97",
		"\x87\x83" => "\xEB\x87\x98",
		"\x87\x84" => "\xEB\x87\x99",
		"\x87\x85" => "\xEB\x87\x9A",
		"\x87\x86" => "\xEB\x87\x9B",
		"\x87\x87" => "\xEB\x87\x9E",
		"\x87\x88" => "\xEB\x87\xA0",
		"\x87\x89" => "\xEB\x87\xA1",
		"\x87\x8A" => "\xEB\x87\xA2",
		"\x87\x8B" => "\xEB\x87\xA3",
		"\x87\x8C" => "\xEB\x87\xA4",
		"\x87\x8D" => "\xEB\x87\xA5",
		"\x87\x8E" => "\xEB\x87\xA6",
		"\x87\x8F" => "\xEB\x87\xA7",
		"\x87\x90" => "\xEB\x87\xAA",
		"\x87\x91" => "\xEB\x87\xAB",
		"\x87\x92" => "\xEB\x87\xAD",
		"\x87\x93" => "\xEB\x87\xAE",
		"\x87\x94" => "\xEB\x87\xAF",
		"\x87\x95" => "\xEB\x87\xB1",
		"\x87\x96" => "\xEB\x87\xB2",
		"\x87\x97" => "\xEB\x87\xB3",
		"\x87\x98" => "\xEB\x87\xB4",
		"\x87\x99" => "\xEB\x87\xB5",
		"\x87\x9A" => "\xEB\x87\xB6",
		"\x87\x9B" => "\xEB\x87\xB7",
		"\x87\x9C" => "\xEB\x87\xB8",
		"\x87\x9D" => "\xEB\x87\xBA",
		"\x87\x9E" => "\xEB\x87\xBC",
		"\x87\x9F" => "\xEB\x87\xBE",
		"\x87\xA0" => "\xEB\x87\xBF",
		"\x87\xA1" => "\xEB\x88\x80",
		"\x87\xA2" => "\xEB\x88\x81",
		"\x87\xA3" => "\xEB\x88\x82",
		"\x87\xA4" => "\xEB\x88\x83",
		"\x87\xA5" => "\xEB\x88\x86",
		"\x87\xA6" => "\xEB\x88\x87",
		"\x87\xA7" => "\xEB\x88\x89",
		"\x87\xA8" => "\xEB\x88\x8A",
		"\x87\xA9" => "\xEB\x88\x8D",
		"\x87\xAA" => "\xEB\x88\x8E",
		"\x87\xAB" => "\xEB\x88\x8F",
		"\x87\xAC" => "\xEB\x88\x90",
		"\x87\xAD" => "\xEB\x88\x91",
		"\x87\xAE" => "\xEB\x88\x92",
		"\x87\xAF" => "\xEB\x88\x93",
		"\x87\xB0" => "\xEB\x88\x96",
		"\x87\xB1" => "\xEB\x88\x98",
		"\x87\xB2" => "\xEB\x88\x9A",
		"\x87\xB3" => "\xEB\x88\x9B",
		"\x87\xB4" => "\xEB\x88\x9C",
		"\x87\xB5" => "\xEB\x88\x9D",
		"\x87\xB6" => "\xEB\x88\x9E",
		"\x87\xB7" => "\xEB\x88\x9F",
		"\x87\xB8" => "\xEB\x88\xA1",
		"\x87\xB9" => "\xEB\x88\xA2",
		"\x87\xBA" => "\xEB\x88\xA3",
		"\x87\xBB" => "\xEB\x88\xA4",
		"\x87\xBC" => "\xEB\x88\xA5",
		"\x87\xBD" => "\xEB\x88\xA6",
		"\x87\xBE" => "\xEB\x88\xA7",
		"\x87\xBF" => "\xEB\x88\xA8",
		"\x87\xC0" => "\xEB\x88\xA9",
		"\x87\xC1" => "\xEB\x88\xAA",
		"\x87\xC2" => "\xEB\x88\xAB",
		"\x87\xC3" => "\xEB\x88\xAC",
		"\x87\xC4" => "\xEB\x88\xAD",
		"\x87\xC5" => "\xEB\x88\xAE",
		"\x87\xC6" => "\xEB\x88\xAF",
		"\x87\xC7" => "\xEB\x88\xB0",
		"\x87\xC8" => "\xEB\x88\xB1",
		"\x87\xC9" => "\xEB\x88\xB2",
		"\x87\xCA" => "\xEB\x88\xB3",
		"\x87\xCB" => "\xEB\x88\xB5",
		"\x87\xCC" => "\xEB\x88\xB6",
		"\x87\xCD" => "\xEB\x88\xB7",
		"\x87\xCE" => "\xEB\x88\xB8",
		"\x87\xCF" => "\xEB\x88\xB9",
		"\x87\xD0" => "\xEB\x88\xBA",
		"\x87\xD1" => "\xEB\x88\xBB",
		"\x87\xD2" => "\xEB\x88\xBD",
		"\x87\xD3" => "\xEB\x88\xBE",
		"\x87\xD4" => "\xEB\x88\xBF",
		"\x87\xD5" => "\xEB\x89\x80",
		"\x87\xD6" => "\xEB\x89\x81",
		"\x87\xD7" => "\xEB\x89\x82",
		"\x87\xD8" => "\xEB\x89\x83",
		"\x87\xD9" => "\xEB\x89\x84",
		"\x87\xDA" => "\xEB\x89\x85",
		"\x87\xDB" => "\xEB\x89\x86",
		"\x87\xDC" => "\xEB\x89\x87",
		"\x87\xDD" => "\xEB\x89\x88",
		"\x87\xDE" => "\xEB\x89\x89",
		"\x87\xDF" => "\xEB\x89\x8A",
		"\x87\xE0" => "\xEB\x89\x8B",
		"\x87\xE1" => "\xEB\x89\x8C",
		"\x87\xE2" => "\xEB\x89\x8D",
		"\x87\xE3" => "\xEB\x89\x8E",
		"\x87\xE4" => "\xEB\x89\x8F",
		"\x87\xE5" => "\xEB\x89\x90",
		"\x87\xE6" => "\xEB\x89\x91",
		"\x87\xE7" => "\xEB\x89\x92",
		"\x87\xE8" => "\xEB\x89\x93",
		"\x87\xE9" => "\xEB\x89\x94",
		"\x87\xEA" => "\xEB\x89\x95",
		"\x87\xEB" => "\xEB\x89\x96",
		"\x87\xEC" => "\xEB\x89\x97",
		"\x87\xED" => "\xEB\x89\x99",
		"\x87\xEE" => "\xEB\x89\x9A",
		"\x87\xEF" => "\xEB\x89\x9B",
		"\x87\xF0" => "\xEB\x89\x9D",
		"\x87\xF1" => "\xEB\x89\x9E",
		"\x87\xF2" => "\xEB\x89\x9F",
		"\x87\xF3" => "\xEB\x89\xA1",
		"\x87\xF4" => "\xEB\x89\xA2",
		"\x87\xF5" => "\xEB\x89\xA3",
		"\x87\xF6" => "\xEB\x89\xA4",
		"\x87\xF7" => "\xEB\x89\xA5",
		"\x87\xF8" => "\xEB\x89\xA6",
		"\x87\xF9" => "\xEB\x89\xA7",
		"\x87\xFA" => "\xEB\x89\xAA",
		"\x87\xFB" => "\xEB\x89\xAB",
		"\x87\xFC" => "\xEB\x89\xAC",
		"\x87\xFD" => "\xEB\x89\xAD",
		"\x87\xFE" => "\xEB\x89\xAE",
		"\x88\x41" => "\xEB\x89\xAF",
		"\x88\x42" => "\xEB\x89\xB0",
		"\x88\x43" => "\xEB\x89\xB1",
		"\x88\x44" => "\xEB\x89\xB2",
		"\x88\x45" => "\xEB\x89\xB3",
		"\x88\x46" => "\xEB\x89\xB6",
		"\x88\x47" => "\xEB\x89\xB7",
		"\x88\x48" => "\xEB\x89\xB8",
		"\x88\x49" => "\xEB\x89\xB9",
		"\x88\x4A" => "\xEB\x89\xBA",
		"\x88\x4B" => "\xEB\x89\xBB",
		"\x88\x4C" => "\xEB\x89\xBD",
		"\x88\x4D" => "\xEB\x89\xBE",
		"\x88\x4E" => "\xEB\x89\xBF",
		"\x88\x4F" => "\xEB\x8A\x80",
		"\x88\x50" => "\xEB\x8A\x81",
		"\x88\x51" => "\xEB\x8A\x82",
		"\x88\x52" => "\xEB\x8A\x83",
		"\x88\x53" => "\xEB\x8A\x86",
		"\x88\x54" => "\xEB\x8A\x87",
		"\x88\x55" => "\xEB\x8A\x88",
		"\x88\x56" => "\xEB\x8A\x8A",
		"\x88\x57" => "\xEB\x8A\x8B",
		"\x88\x58" => "\xEB\x8A\x8C",
		"\x88\x59" => "\xEB\x8A\x8D",
		"\x88\x5A" => "\xEB\x8A\x8E",
		"\x88\x61" => "\xEB\x8A\x8F",
		"\x88\x62" => "\xEB\x8A\x92",
		"\x88\x63" => "\xEB\x8A\x93",
		"\x88\x64" => "\xEB\x8A\x95",
		"\x88\x65" => "\xEB\x8A\x96",
		"\x88\x66" => "\xEB\x8A\x97",
		"\x88\x67" => "\xEB\x8A\x9B",
		"\x88\x68" => "\xEB\x8A\x9C",
		"\x88\x69" => "\xEB\x8A\x9D",
		"\x88\x6A" => "\xEB\x8A\x9E",
		"\x88\x6B" => "\xEB\x8A\x9F",
		"\x88\x6C" => "\xEB\x8A\xA2",
		"\x88\x6D" => "\xEB\x8A\xA4",
		"\x88\x6E" => "\xEB\x8A\xA7",
		"\x88\x6F" => "\xEB\x8A\xA8",
		"\x88\x70" => "\xEB\x8A\xA9",
		"\x88\x71" => "\xEB\x8A\xAB",
		"\x88\x72" => "\xEB\x8A\xAD",
		"\x88\x73" => "\xEB\x8A\xAE",
		"\x88\x74" => "\xEB\x8A\xAF",
		"\x88\x75" => "\xEB\x8A\xB1",
		"\x88\x76" => "\xEB\x8A\xB2",
		"\x88\x77" => "\xEB\x8A\xB3",
		"\x88\x78" => "\xEB\x8A\xB5",
		"\x88\x79" => "\xEB\x8A\xB6",
		"\x88\x7A" => "\xEB\x8A\xB7",
		"\x88\x81" => "\xEB\x8A\xB8",
		"\x88\x82" => "\xEB\x8A\xB9",
		"\x88\x83" => "\xEB\x8A\xBA",
		"\x88\x84" => "\xEB\x8A\xBB",
		"\x88\x85" => "\xEB\x8A\xBC",
		"\x88\x86" => "\xEB\x8A\xBD",
		"\x88\x87" => "\xEB\x8A\xBE",
		"\x88\x88" => "\xEB\x8A\xBF",
		"\x88\x89" => "\xEB\x8B\x80",
		"\x88\x8A" => "\xEB\x8B\x81",
		"\x88\x8B" => "\xEB\x8B\x82",
		"\x88\x8C" => "\xEB\x8B\x83",
		"\x88\x8D" => "\xEB\x8B\x84",
		"\x88\x8E" => "\xEB\x8B\x85",
		"\x88\x8F" => "\xEB\x8B\x86",
		"\x88\x90" => "\xEB\x8B\x87",
		"\x88\x91" => "\xEB\x8B\x8A",
		"\x88\x92" => "\xEB\x8B\x8B",
		"\x88\x93" => "\xEB\x8B\x8D",
		"\x88\x94" => "\xEB\x8B\x8E",
		"\x88\x95" => "\xEB\x8B\x8F",
		"\x88\x96" => "\xEB\x8B\x91",
		"\x88\x97" => "\xEB\x8B\x93",
		"\x88\x98" => "\xEB\x8B\x94",
		"\x88\x99" => "\xEB\x8B\x95",
		"\x88\x9A" => "\xEB\x8B\x96",
		"\x88\x9B" => "\xEB\x8B\x97",
		"\x88\x9C" => "\xEB\x8B\x9A",
		"\x88\x9D" => "\xEB\x8B\x9C",
		"\x88\x9E" => "\xEB\x8B\x9E",
		"\x88\x9F" => "\xEB\x8B\x9F",
		"\x88\xA0" => "\xEB\x8B\xA0",
		"\x88\xA1" => "\xEB\x8B\xA1",
		"\x88\xA2" => "\xEB\x8B\xA3",
		"\x88\xA3" => "\xEB\x8B\xA7",
		"\x88\xA4" => "\xEB\x8B\xA9",
		"\x88\xA5" => "\xEB\x8B\xAA",
		"\x88\xA6" => "\xEB\x8B\xB0",
		"\x88\xA7" => "\xEB\x8B\xB1",
		"\x88\xA8" => "\xEB\x8B\xB2",
		"\x88\xA9" => "\xEB\x8B\xB6",
		"\x88\xAA" => "\xEB\x8B\xBC",
		"\x88\xAB" => "\xEB\x8B\xBD",
		"\x88\xAC" => "\xEB\x8B\xBE",
		"\x88\xAD" => "\xEB\x8C\x82",
		"\x88\xAE" => "\xEB\x8C\x83",
		"\x88\xAF" => "\xEB\x8C\x85",
		"\x88\xB0" => "\xEB\x8C\x86",
		"\x88\xB1" => "\xEB\x8C\x87",
		"\x88\xB2" => "\xEB\x8C\x89",
		"\x88\xB3" => "\xEB\x8C\x8A",
		"\x88\xB4" => "\xEB\x8C\x8B",
		"\x88\xB5" => "\xEB\x8C\x8C",
		"\x88\xB6" => "\xEB\x8C\x8D",
		"\x88\xB7" => "\xEB\x8C\x8E",
		"\x88\xB8" => "\xEB\x8C\x8F",
		"\x88\xB9" => "\xEB\x8C\x92",
		"\x88\xBA" => "\xEB\x8C\x96",
		"\x88\xBB" => "\xEB\x8C\x97",
		"\x88\xBC" => "\xEB\x8C\x98",
		"\x88\xBD" => "\xEB\x8C\x99",
		"\x88\xBE" => "\xEB\x8C\x9A",
		"\x88\xBF" => "\xEB\x8C\x9B",
		"\x88\xC0" => "\xEB\x8C\x9D",
		"\x88\xC1" => "\xEB\x8C\x9E",
		"\x88\xC2" => "\xEB\x8C\x9F",
		"\x88\xC3" => "\xEB\x8C\xA0",
		"\x88\xC4" => "\xEB\x8C\xA1",
		"\x88\xC5" => "\xEB\x8C\xA2",
		"\x88\xC6" => "\xEB\x8C\xA3",
		"\x88\xC7" => "\xEB\x8C\xA4",
		"\x88\xC8" => "\xEB\x8C\xA5",
		"\x88\xC9" => "\xEB\x8C\xA6",
		"\x88\xCA" => "\xEB\x8C\xA7",
		"\x88\xCB" => "\xEB\x8C\xA8",
		"\x88\xCC" => "\xEB\x8C\xA9",
		"\x88\xCD" => "\xEB\x8C\xAA",
		"\x88\xCE" => "\xEB\x8C\xAB",
		"\x88\xCF" => "\xEB\x8C\xAC",
		"\x88\xD0" => "\xEB\x8C\xAD",
		"\x88\xD1" => "\xEB\x8C\xAE",
		"\x88\xD2" => "\xEB\x8C\xAF",
		"\x88\xD3" => "\xEB\x8C\xB0",
		"\x88\xD4" => "\xEB\x8C\xB1",
		"\x88\xD5" => "\xEB\x8C\xB2",
		"\x88\xD6" => "\xEB\x8C\xB3",
		"\x88\xD7" => "\xEB\x8C\xB4",
		"\x88\xD8" => "\xEB\x8C\xB5",
		"\x88\xD9" => "\xEB\x8C\xB6",
		"\x88\xDA" => "\xEB\x8C\xB7",
		"\x88\xDB" => "\xEB\x8C\xB8",
		"\x88\xDC" => "\xEB\x8C\xB9",
		"\x88\xDD" => "\xEB\x8C\xBA",
		"\x88\xDE" => "\xEB\x8C\xBB",
		"\x88\xDF" => "\xEB\x8C\xBC",
		"\x88\xE0" => "\xEB\x8C\xBD",
		"\x88\xE1" => "\xEB\x8C\xBE",
		"\x88\xE2" => "\xEB\x8C\xBF",
		"\x88\xE3" => "\xEB\x8D\x80",
		"\x88\xE4" => "\xEB\x8D\x81",
		"\x88\xE5" => "\xEB\x8D\x82",
		"\x88\xE6" => "\xEB\x8D\x83",
		"\x88\xE7" => "\xEB\x8D\x84",
		"\x88\xE8" => "\xEB\x8D\x85",
		"\x88\xE9" => "\xEB\x8D\x86",
		"\x88\xEA" => "\xEB\x8D\x87",
		"\x88\xEB" => "\xEB\x8D\x88",
		"\x88\xEC" => "\xEB\x8D\x89",
		"\x88\xED" => "\xEB\x8D\x8A",
		"\x88\xEE" => "\xEB\x8D\x8B",
		"\x88\xEF" => "\xEB\x8D\x8C",
		"\x88\xF0" => "\xEB\x8D\x8D",
		"\x88\xF1" => "\xEB\x8D\x8E",
		"\x88\xF2" => "\xEB\x8D\x8F",
		"\x88\xF3" => "\xEB\x8D\x90",
		"\x88\xF4" => "\xEB\x8D\x91",
		"\x88\xF5" => "\xEB\x8D\x92",
		"\x88\xF6" => "\xEB\x8D\x93",
		"\x88\xF7" => "\xEB\x8D\x97",
		"\x88\xF8" => "\xEB\x8D\x99",
		"\x88\xF9" => "\xEB\x8D\x9A",
		"\x88\xFA" => "\xEB\x8D\x9D",
		"\x88\xFB" => "\xEB\x8D\xA0",
		"\x88\xFC" => "\xEB\x8D\xA1",
		"\x88\xFD" => "\xEB\x8D\xA2",
		"\x88\xFE" => "\xEB\x8D\xA3",
		"\x89\x41" => "\xEB\x8D\xA6",
		"\x89\x42" => "\xEB\x8D\xA8",
		"\x89\x43" => "\xEB\x8D\xAA",
		"\x89\x44" => "\xEB\x8D\xAC",
		"\x89\x45" => "\xEB\x8D\xAD",
		"\x89\x46" => "\xEB\x8D\xAF",
		"\x89\x47" => "\xEB\x8D\xB2",
		"\x89\x48" => "\xEB\x8D\xB3",
		"\x89\x49" => "\xEB\x8D\xB5",
		"\x89\x4A" => "\xEB\x8D\xB6",
		"\x89\x4B" => "\xEB\x8D\xB7",
		"\x89\x4C" => "\xEB\x8D\xB9",
		"\x89\x4D" => "\xEB\x8D\xBA",
		"\x89\x4E" => "\xEB\x8D\xBB",
		"\x89\x4F" => "\xEB\x8D\xBC",
		"\x89\x50" => "\xEB\x8D\xBD",
		"\x89\x51" => "\xEB\x8D\xBE",
		"\x89\x52" => "\xEB\x8D\xBF",
		"\x89\x53" => "\xEB\x8E\x82",
		"\x89\x54" => "\xEB\x8E\x86",
		"\x89\x55" => "\xEB\x8E\x87",
		"\x89\x56" => "\xEB\x8E\x88",
		"\x89\x57" => "\xEB\x8E\x89",
		"\x89\x58" => "\xEB\x8E\x8A",
		"\x89\x59" => "\xEB\x8E\x8B",
		"\x89\x5A" => "\xEB\x8E\x8D",
		"\x89\x61" => "\xEB\x8E\x8E",
		"\x89\x62" => "\xEB\x8E\x8F",
		"\x89\x63" => "\xEB\x8E\x91",
		"\x89\x64" => "\xEB\x8E\x92",
		"\x89\x65" => "\xEB\x8E\x93",
		"\x89\x66" => "\xEB\x8E\x95",
		"\x89\x67" => "\xEB\x8E\x96",
		"\x89\x68" => "\xEB\x8E\x97",
		"\x89\x69" => "\xEB\x8E\x98",
		"\x89\x6A" => "\xEB\x8E\x99",
		"\x89\x6B" => "\xEB\x8E\x9A",
		"\x89\x6C" => "\xEB\x8E\x9B",
		"\x89\x6D" => "\xEB\x8E\x9C",
		"\x89\x6E" => "\xEB\x8E\x9D",
		"\x89\x6F" => "\xEB\x8E\x9E",
		"\x89\x70" => "\xEB\x8E\x9F",
		"\x89\x71" => "\xEB\x8E\xA2",
		"\x89\x72" => "\xEB\x8E\xA3",
		"\x89\x73" => "\xEB\x8E\xA4",
		"\x89\x74" => "\xEB\x8E\xA5",
		"\x89\x75" => "\xEB\x8E\xA6",
		"\x89\x76" => "\xEB\x8E\xA7",
		"\x89\x77" => "\xEB\x8E\xA9",
		"\x89\x78" => "\xEB\x8E\xAA",
		"\x89\x79" => "\xEB\x8E\xAB",
		"\x89\x7A" => "\xEB\x8E\xAD",
		"\x89\x81" => "\xEB\x8E\xAE",
		"\x89\x82" => "\xEB\x8E\xAF",
		"\x89\x83" => "\xEB\x8E\xB0",
		"\x89\x84" => "\xEB\x8E\xB1",
		"\x89\x85" => "\xEB\x8E\xB2",
		"\x89\x86" => "\xEB\x8E\xB3",
		"\x89\x87" => "\xEB\x8E\xB4",
		"\x89\x88" => "\xEB\x8E\xB5",
		"\x89\x89" => "\xEB\x8E\xB6",
		"\x89\x8A" => "\xEB\x8E\xB7",
		"\x89\x8B" => "\xEB\x8E\xB8",
		"\x89\x8C" => "\xEB\x8E\xB9",
		"\x89\x8D" => "\xEB\x8E\xBA",
		"\x89\x8E" => "\xEB\x8E\xBB",
		"\x89\x8F" => "\xEB\x8E\xBC",
		"\x89\x90" => "\xEB\x8E\xBD",
		"\x89\x91" => "\xEB\x8E\xBE",
		"\x89\x92" => "\xEB\x8E\xBF",
		"\x89\x93" => "\xEB\x8F\x80",
		"\x89\x94" => "\xEB\x8F\x81",
		"\x89\x95" => "\xEB\x8F\x82",
		"\x89\x96" => "\xEB\x8F\x83",
		"\x89\x97" => "\xEB\x8F\x86",
		"\x89\x98" => "\xEB\x8F\x87",
		"\x89\x99" => "\xEB\x8F\x89",
		"\x89\x9A" => "\xEB\x8F\x8A",
		"\x89\x9B" => "\xEB\x8F\x8D",
		"\x89\x9C" => "\xEB\x8F\x8F",
		"\x89\x9D" => "\xEB\x8F\x91",
		"\x89\x9E" => "\xEB\x8F\x92",
		"\x89\x9F" => "\xEB\x8F\x93",
		"\x89\xA0" => "\xEB\x8F\x96",
		"\x89\xA1" => "\xEB\x8F\x98",
		"\x89\xA2" => "\xEB\x8F\x9A",
		"\x89\xA3" => "\xEB\x8F\x9C",
		"\x89\xA4" => "\xEB\x8F\x9E",
		"\x89\xA5" => "\xEB\x8F\x9F",
		"\x89\xA6" => "\xEB\x8F\xA1",
		"\x89\xA7" => "\xEB\x8F\xA2",
		"\x89\xA8" => "\xEB\x8F\xA3",
		"\x89\xA9" => "\xEB\x8F\xA5",
		"\x89\xAA" => "\xEB\x8F\xA6",
		"\x89\xAB" => "\xEB\x8F\xA7",
		"\x89\xAC" => "\xEB\x8F\xA9",
		"\x89\xAD" => "\xEB\x8F\xAA",
		"\x89\xAE" => "\xEB\x8F\xAB",
		"\x89\xAF" => "\xEB\x8F\xAC",
		"\x89\xB0" => "\xEB\x8F\xAD",
		"\x89\xB1" => "\xEB\x8F\xAE",
		"\x89\xB2" => "\xEB\x8F\xAF",
		"\x89\xB3" => "\xEB\x8F\xB0",
		"\x89\xB4" => "\xEB\x8F\xB1",
		"\x89\xB5" => "\xEB\x8F\xB2",
		"\x89\xB6" => "\xEB\x8F\xB3",
		"\x89\xB7" => "\xEB\x8F\xB4",
		"\x89\xB8" => "\xEB\x8F\xB5",
		"\x89\xB9" => "\xEB\x8F\xB6",
		"\x89\xBA" => "\xEB\x8F\xB7",
		"\x89\xBB" => "\xEB\x8F\xB8",
		"\x89\xBC" => "\xEB\x8F\xB9",
		"\x89\xBD" => "\xEB\x8F\xBA",
		"\x89\xBE" => "\xEB\x8F\xBB",
		"\x89\xBF" => "\xEB\x8F\xBD",
		"\x89\xC0" => "\xEB\x8F\xBE",
		"\x89\xC1" => "\xEB\x8F\xBF",
		"\x89\xC2" => "\xEB\x90\x80",
		"\x89\xC3" => "\xEB\x90\x81",
		"\x89\xC4" => "\xEB\x90\x82",
		"\x89\xC5" => "\xEB\x90\x83",
		"\x89\xC6" => "\xEB\x90\x84",
		"\x89\xC7" => "\xEB\x90\x85",
		"\x89\xC8" => "\xEB\x90\x86",
		"\x89\xC9" => "\xEB\x90\x87",
		"\x89\xCA" => "\xEB\x90\x88",
		"\x89\xCB" => "\xEB\x90\x89",
		"\x89\xCC" => "\xEB\x90\x8A",
		"\x89\xCD" => "\xEB\x90\x8B",
		"\x89\xCE" => "\xEB\x90\x8C",
		"\x89\xCF" => "\xEB\x90\x8D",
		"\x89\xD0" => "\xEB\x90\x8E",
		"\x89\xD1" => "\xEB\x90\x8F",
		"\x89\xD2" => "\xEB\x90\x91",
		"\x89\xD3" => "\xEB\x90\x92",
		"\x89\xD4" => "\xEB\x90\x93",
		"\x89\xD5" => "\xEB\x90\x94",
		"\x89\xD6" => "\xEB\x90\x95",
		"\x89\xD7" => "\xEB\x90\x96",
		"\x89\xD8" => "\xEB\x90\x97",
		"\x89\xD9" => "\xEB\x90\x99",
		"\x89\xDA" => "\xEB\x90\x9A",
		"\x89\xDB" => "\xEB\x90\x9B",
		"\x89\xDC" => "\xEB\x90\x9D",
		"\x89\xDD" => "\xEB\x90\x9E",
		"\x89\xDE" => "\xEB\x90\x9F",
		"\x89\xDF" => "\xEB\x90\xA1",
		"\x89\xE0" => "\xEB\x90\xA2",
		"\x89\xE1" => "\xEB\x90\xA3",
		"\x89\xE2" => "\xEB\x90\xA4",
		"\x89\xE3" => "\xEB\x90\xA5",
		"\x89\xE4" => "\xEB\x90\xA6",
		"\x89\xE5" => "\xEB\x90\xA7",
		"\x89\xE6" => "\xEB\x90\xAA",
		"\x89\xE7" => "\xEB\x90\xAC",
		"\x89\xE8" => "\xEB\x90\xAD",
		"\x89\xE9" => "\xEB\x90\xAE",
		"\x89\xEA" => "\xEB\x90\xAF",
		"\x89\xEB" => "\xEB\x90\xB0",
		"\x89\xEC" => "\xEB\x90\xB1",
		"\x89\xED" => "\xEB\x90\xB2",
		"\x89\xEE" => "\xEB\x90\xB3",
		"\x89\xEF" => "\xEB\x90\xB5",
		"\x89\xF0" => "\xEB\x90\xB6",
		"\x89\xF1" => "\xEB\x90\xB7",
		"\x89\xF2" => "\xEB\x90\xB8",
		"\x89\xF3" => "\xEB\x90\xB9",
		"\x89\xF4" => "\xEB\x90\xBA",
		"\x89\xF5" => "\xEB\x90\xBB",
		"\x89\xF6" => "\xEB\x90\xBC",
		"\x89\xF7" => "\xEB\x90\xBD",
		"\x89\xF8" => "\xEB\x90\xBE",
		"\x89\xF9" => "\xEB\x90\xBF",
		"\x89\xFA" => "\xEB\x91\x80",
		"\x89\xFB" => "\xEB\x91\x81",
		"\x89\xFC" => "\xEB\x91\x82",
		"\x89\xFD" => "\xEB\x91\x83",
		"\x89\xFE" => "\xEB\x91\x84",
		"\x8A\x41" => "\xEB\x91\x85",
		"\x8A\x42" => "\xEB\x91\x86",
		"\x8A\x43" => "\xEB\x91\x87",
		"\x8A\x44" => "\xEB\x91\x88",
		"\x8A\x45" => "\xEB\x91\x89",
		"\x8A\x46" => "\xEB\x91\x8A",
		"\x8A\x47" => "\xEB\x91\x8B",
		"\x8A\x48" => "\xEB\x91\x8C",
		"\x8A\x49" => "\xEB\x91\x8D",
		"\x8A\x4A" => "\xEB\x91\x8E",
		"\x8A\x4B" => "\xEB\x91\x8F",
		"\x8A\x4C" => "\xEB\x91\x92",
		"\x8A\x4D" => "\xEB\x91\x93",
		"\x8A\x4E" => "\xEB\x91\x95",
		"\x8A\x4F" => "\xEB\x91\x96",
		"\x8A\x50" => "\xEB\x91\x97",
		"\x8A\x51" => "\xEB\x91\x99",
		"\x8A\x52" => "\xEB\x91\x9A",
		"\x8A\x53" => "\xEB\x91\x9B",
		"\x8A\x54" => "\xEB\x91\x9C",
		"\x8A\x55" => "\xEB\x91\x9D",
		"\x8A\x56" => "\xEB\x91\x9E",
		"\x8A\x57" => "\xEB\x91\x9F",
		"\x8A\x58" => "\xEB\x91\xA2",
		"\x8A\x59" => "\xEB\x91\xA4",
		"\x8A\x5A" => "\xEB\x91\xA6",
		"\x8A\x61" => "\xEB\x91\xA7",
		"\x8A\x62" => "\xEB\x91\xA8",
		"\x8A\x63" => "\xEB\x91\xA9",
		"\x8A\x64" => "\xEB\x91\xAA",
		"\x8A\x65" => "\xEB\x91\xAB",
		"\x8A\x66" => "\xEB\x91\xAD",
		"\x8A\x67" => "\xEB\x91\xAE",
		"\x8A\x68" => "\xEB\x91\xAF",
		"\x8A\x69" => "\xEB\x91\xB0",
		"\x8A\x6A" => "\xEB\x91\xB1",
		"\x8A\x6B" => "\xEB\x91\xB2",
		"\x8A\x6C" => "\xEB\x91\xB3",
		"\x8A\x6D" => "\xEB\x91\xB4",
		"\x8A\x6E" => "\xEB\x91\xB5",
		"\x8A\x6F" => "\xEB\x91\xB6",
		"\x8A\x70" => "\xEB\x91\xB7",
		"\x8A\x71" => "\xEB\x91\xB8",
		"\x8A\x72" => "\xEB\x91\xB9",
		"\x8A\x73" => "\xEB\x91\xBA",
		"\x8A\x74" => "\xEB\x91\xBB",
		"\x8A\x75" => "\xEB\x91\xBC",
		"\x8A\x76" => "\xEB\x91\xBD",
		"\x8A\x77" => "\xEB\x91\xBE",
		"\x8A\x78" => "\xEB\x91\xBF",
		"\x8A\x79" => "\xEB\x92\x81",
		"\x8A\x7A" => "\xEB\x92\x82",
		"\x8A\x81" => "\xEB\x92\x83",
		"\x8A\x82" => "\xEB\x92\x84",
		"\x8A\x83" => "\xEB\x92\x85",
		"\x8A\x84" => "\xEB\x92\x86",
		"\x8A\x85" => "\xEB\x92\x87",
		"\x8A\x86" => "\xEB\x92\x89",
		"\x8A\x87" => "\xEB\x92\x8A",
		"\x8A\x88" => "\xEB\x92\x8B",
		"\x8A\x89" => "\xEB\x92\x8C",
		"\x8A\x8A" => "\xEB\x92\x8D",
		"\x8A\x8B" => "\xEB\x92\x8E",
		"\x8A\x8C" => "\xEB\x92\x8F",
		"\x8A\x8D" => "\xEB\x92\x90",
		"\x8A\x8E" => "\xEB\x92\x91",
		"\x8A\x8F" => "\xEB\x92\x92",
		"\x8A\x90" => "\xEB\x92\x93",
		"\x8A\x91" => "\xEB\x92\x94",
		"\x8A\x92" => "\xEB\x92\x95",
		"\x8A\x93" => "\xEB\x92\x96",
		"\x8A\x94" => "\xEB\x92\x97",
		"\x8A\x95" => "\xEB\x92\x98",
		"\x8A\x96" => "\xEB\x92\x99",
		"\x8A\x97" => "\xEB\x92\x9A",
		"\x8A\x98" => "\xEB\x92\x9B",
		"\x8A\x99" => "\xEB\x92\x9C",
		"\x8A\x9A" => "\xEB\x92\x9E",
		"\x8A\x9B" => "\xEB\x92\x9F",
		"\x8A\x9C" => "\xEB\x92\xA0",
		"\x8A\x9D" => "\xEB\x92\xA1",
		"\x8A\x9E" => "\xEB\x92\xA2",
		"\x8A\x9F" => "\xEB\x92\xA3",
		"\x8A\xA0" => "\xEB\x92\xA5",
		"\x8A\xA1" => "\xEB\x92\xA6",
		"\x8A\xA2" => "\xEB\x92\xA7",
		"\x8A\xA3" => "\xEB\x92\xA9",
		"\x8A\xA4" => "\xEB\x92\xAA",
		"\x8A\xA5" => "\xEB\x92\xAB",
		"\x8A\xA6" => "\xEB\x92\xAD",
		"\x8A\xA7" => "\xEB\x92\xAE",
		"\x8A\xA8" => "\xEB\x92\xAF",
		"\x8A\xA9" => "\xEB\x92\xB0",
		"\x8A\xAA" => "\xEB\x92\xB1",
		"\x8A\xAB" => "\xEB\x92\xB2",
		"\x8A\xAC" => "\xEB\x92\xB3",
		"\x8A\xAD" => "\xEB\x92\xB4",
		"\x8A\xAE" => "\xEB\x92\xB6",
		"\x8A\xAF" => "\xEB\x92\xB8",
		"\x8A\xB0" => "\xEB\x92\xBA",
		"\x8A\xB1" => "\xEB\x92\xBB",
		"\x8A\xB2" => "\xEB\x92\xBC",
		"\x8A\xB3" => "\xEB\x92\xBD",
		"\x8A\xB4" => "\xEB\x92\xBE",
		"\x8A\xB5" => "\xEB\x92\xBF",
		"\x8A\xB6" => "\xEB\x93\x81",
		"\x8A\xB7" => "\xEB\x93\x82",
		"\x8A\xB8" => "\xEB\x93\x83",
		"\x8A\xB9" => "\xEB\x93\x85",
		"\x8A\xBA" => "\xEB\x93\x86",
		"\x8A\xBB" => "\xEB\x93\x87",
		"\x8A\xBC" => "\xEB\x93\x89",
		"\x8A\xBD" => "\xEB\x93\x8A",
		"\x8A\xBE" => "\xEB\x93\x8B",
		"\x8A\xBF" => "\xEB\x93\x8C",
		"\x8A\xC0" => "\xEB\x93\x8D",
		"\x8A\xC1" => "\xEB\x93\x8E",
		"\x8A\xC2" => "\xEB\x93\x8F",
		"\x8A\xC3" => "\xEB\x93\x91",
		"\x8A\xC4" => "\xEB\x93\x92",
		"\x8A\xC5" => "\xEB\x93\x93",
		"\x8A\xC6" => "\xEB\x93\x94",
		"\x8A\xC7" => "\xEB\x93\x96",
		"\x8A\xC8" => "\xEB\x93\x97",
		"\x8A\xC9" => "\xEB\x93\x98",
		"\x8A\xCA" => "\xEB\x93\x99",
		"\x8A\xCB" => "\xEB\x93\x9A",
		"\x8A\xCC" => "\xEB\x93\x9B",
		"\x8A\xCD" => "\xEB\x93\x9E",
		"\x8A\xCE" => "\xEB\x93\x9F",
		"\x8A\xCF" => "\xEB\x93\xA1",
		"\x8A\xD0" => "\xEB\x93\xA2",
		"\x8A\xD1" => "\xEB\x93\xA5",
		"\x8A\xD2" => "\xEB\x93\xA7",
		"\x8A\xD3" => "\xEB\x93\xA8",
		"\x8A\xD4" => "\xEB\x93\xA9",
		"\x8A\xD5" => "\xEB\x93\xAA",
		"\x8A\xD6" => "\xEB\x93\xAB",
		"\x8A\xD7" => "\xEB\x93\xAE",
		"\x8A\xD8" => "\xEB\x93\xB0",
		"\x8A\xD9" => "\xEB\x93\xB2",
		"\x8A\xDA" => "\xEB\x93\xB3",
		"\x8A\xDB" => "\xEB\x93\xB4",
		"\x8A\xDC" => "\xEB\x93\xB5",
		"\x8A\xDD" => "\xEB\x93\xB6",
		"\x8A\xDE" => "\xEB\x93\xB7",
		"\x8A\xDF" => "\xEB\x93\xB9",
		"\x8A\xE0" => "\xEB\x93\xBA",
		"\x8A\xE1" => "\xEB\x93\xBB",
		"\x8A\xE2" => "\xEB\x93\xBC",
		"\x8A\xE3" => "\xEB\x93\xBD",
		"\x8A\xE4" => "\xEB\x93\xBE",
		"\x8A\xE5" => "\xEB\x93\xBF",
		"\x8A\xE6" => "\xEB\x94\x80",
		"\x8A\xE7" => "\xEB\x94\x81",
		"\x8A\xE8" => "\xEB\x94\x82",
		"\x8A\xE9" => "\xEB\x94\x83",
		"\x8A\xEA" => "\xEB\x94\x84",
		"\x8A\xEB" => "\xEB\x94\x85",
		"\x8A\xEC" => "\xEB\x94\x86",
		"\x8A\xED" => "\xEB\x94\x87",
		"\x8A\xEE" => "\xEB\x94\x88",
		"\x8A\xEF" => "\xEB\x94\x89",
		"\x8A\xF0" => "\xEB\x94\x8A",
		"\x8A\xF1" => "\xEB\x94\x8B",
		"\x8A\xF2" => "\xEB\x94\x8C",
		"\x8A\xF3" => "\xEB\x94\x8D",
		"\x8A\xF4" => "\xEB\x94\x8E",
		"\x8A\xF5" => "\xEB\x94\x8F",
		"\x8A\xF6" => "\xEB\x94\x90",
		"\x8A\xF7" => "\xEB\x94\x91",
		"\x8A\xF8" => "\xEB\x94\x92",
		"\x8A\xF9" => "\xEB\x94\x93",
		"\x8A\xFA" => "\xEB\x94\x96",
		"\x8A\xFB" => "\xEB\x94\x97",
		"\x8A\xFC" => "\xEB\x94\x99",
		"\x8A\xFD" => "\xEB\x94\x9A",
		"\x8A\xFE" => "\xEB\x94\x9D",
		"\x8B\x41" => "\xEB\x94\x9E",
		"\x8B\x42" => "\xEB\x94\x9F",
		"\x8B\x43" => "\xEB\x94\xA0",
		"\x8B\x44" => "\xEB\x94\xA1",
		"\x8B\x45" => "\xEB\x94\xA2",
		"\x8B\x46" => "\xEB\x94\xA3",
		"\x8B\x47" => "\xEB\x94\xA6",
		"\x8B\x48" => "\xEB\x94\xAB",
		"\x8B\x49" => "\xEB\x94\xAC",
		"\x8B\x4A" => "\xEB\x94\xAD",
		"\x8B\x4B" => "\xEB\x94\xAE",
		"\x8B\x4C" => "\xEB\x94\xAF",
		"\x8B\x4D" => "\xEB\x94\xB2",
		"\x8B\x4E" => "\xEB\x94\xB3",
		"\x8B\x4F" => "\xEB\x94\xB5",
		"\x8B\x50" => "\xEB\x94\xB6",
		"\x8B\x51" => "\xEB\x94\xB7",
		"\x8B\x52" => "\xEB\x94\xB9",
		"\x8B\x53" => "\xEB\x94\xBA",
		"\x8B\x54" => "\xEB\x94\xBB",
		"\x8B\x55" => "\xEB\x94\xBC",
		"\x8B\x56" => "\xEB\x94\xBD",
		"\x8B\x57" => "\xEB\x94\xBE",
		"\x8B\x58" => "\xEB\x94\xBF",
		"\x8B\x59" => "\xEB\x95\x82",
		"\x8B\x5A" => "\xEB\x95\x86",
		"\x8B\x61" => "\xEB\x95\x87",
		"\x8B\x62" => "\xEB\x95\x88",
		"\x8B\x63" => "\xEB\x95\x89",
		"\x8B\x64" => "\xEB\x95\x8A",
		"\x8B\x65" => "\xEB\x95\x8E",
		"\x8B\x66" => "\xEB\x95\x8F",
		"\x8B\x67" => "\xEB\x95\x91",
		"\x8B\x68" => "\xEB\x95\x92",
		"\x8B\x69" => "\xEB\x95\x93",
		"\x8B\x6A" => "\xEB\x95\x95",
		"\x8B\x6B" => "\xEB\x95\x96",
		"\x8B\x6C" => "\xEB\x95\x97",
		"\x8B\x6D" => "\xEB\x95\x98",
		"\x8B\x6E" => "\xEB\x95\x99",
		"\x8B\x6F" => "\xEB\x95\x9A",
		"\x8B\x70" => "\xEB\x95\x9B",
		"\x8B\x71" => "\xEB\x95\x9E",
		"\x8B\x72" => "\xEB\x95\xA2",
		"\x8B\x73" => "\xEB\x95\xA3",
		"\x8B\x74" => "\xEB\x95\xA4",
		"\x8B\x75" => "\xEB\x95\xA5",
		"\x8B\x76" => "\xEB\x95\xA6",
		"\x8B\x77" => "\xEB\x95\xA7",
		"\x8B\x78" => "\xEB\x95\xA8",
		"\x8B\x79" => "\xEB\x95\xA9",
		"\x8B\x7A" => "\xEB\x95\xAA",
		"\x8B\x81" => "\xEB\x95\xAB",
		"\x8B\x82" => "\xEB\x95\xAC",
		"\x8B\x83" => "\xEB\x95\xAD",
		"\x8B\x84" => "\xEB\x95\xAE",
		"\x8B\x85" => "\xEB\x95\xAF",
		"\x8B\x86" => "\xEB\x95\xB0",
		"\x8B\x87" => "\xEB\x95\xB1",
		"\x8B\x88" => "\xEB\x95\xB2",
		"\x8B\x89" => "\xEB\x95\xB3",
		"\x8B\x8A" => "\xEB\x95\xB4",
		"\x8B\x8B" => "\xEB\x95\xB5",
		"\x8B\x8C" => "\xEB\x95\xB6",
		"\x8B\x8D" => "\xEB\x95\xB7",
		"\x8B\x8E" => "\xEB\x95\xB8",
		"\x8B\x8F" => "\xEB\x95\xB9",
		"\x8B\x90" => "\xEB\x95\xBA",
		"\x8B\x91" => "\xEB\x95\xBB",
		"\x8B\x92" => "\xEB\x95\xBC",
		"\x8B\x93" => "\xEB\x95\xBD",
		"\x8B\x94" => "\xEB\x95\xBE",
		"\x8B\x95" => "\xEB\x95\xBF",
		"\x8B\x96" => "\xEB\x96\x80",
		"\x8B\x97" => "\xEB\x96\x81",
		"\x8B\x98" => "\xEB\x96\x82",
		"\x8B\x99" => "\xEB\x96\x83",
		"\x8B\x9A" => "\xEB\x96\x84",
		"\x8B\x9B" => "\xEB\x96\x85",
		"\x8B\x9C" => "\xEB\x96\x86",
		"\x8B\x9D" => "\xEB\x96\x87",
		"\x8B\x9E" => "\xEB\x96\x88",
		"\x8B\x9F" => "\xEB\x96\x89",
		"\x8B\xA0" => "\xEB\x96\x8A",
		"\x8B\xA1" => "\xEB\x96\x8B",
		"\x8B\xA2" => "\xEB\x96\x8C",
		"\x8B\xA3" => "\xEB\x96\x8D",
		"\x8B\xA4" => "\xEB\x96\x8E",
		"\x8B\xA5" => "\xEB\x96\x8F",
		"\x8B\xA6" => "\xEB\x96\x90",
		"\x8B\xA7" => "\xEB\x96\x91",
		"\x8B\xA8" => "\xEB\x96\x92",
		"\x8B\xA9" => "\xEB\x96\x93",
		"\x8B\xAA" => "\xEB\x96\x94",
		"\x8B\xAB" => "\xEB\x96\x95",
		"\x8B\xAC" => "\xEB\x96\x96",
		"\x8B\xAD" => "\xEB\x96\x97",
		"\x8B\xAE" => "\xEB\x96\x98",
		"\x8B\xAF" => "\xEB\x96\x99",
		"\x8B\xB0" => "\xEB\x96\x9A",
		"\x8B\xB1" => "\xEB\x96\x9B",
		"\x8B\xB2" => "\xEB\x96\x9C",
		"\x8B\xB3" => "\xEB\x96\x9D",
		"\x8B\xB4" => "\xEB\x96\x9E",
		"\x8B\xB5" => "\xEB\x96\x9F",
		"\x8B\xB6" => "\xEB\x96\xA2",
		"\x8B\xB7" => "\xEB\x96\xA3",
		"\x8B\xB8" => "\xEB\x96\xA5",
		"\x8B\xB9" => "\xEB\x96\xA6",
		"\x8B\xBA" => "\xEB\x96\xA7",
		"\x8B\xBB" => "\xEB\x96\xA9",
		"\x8B\xBC" => "\xEB\x96\xAC",
		"\x8B\xBD" => "\xEB\x96\xAD",
		"\x8B\xBE" => "\xEB\x96\xAE",
		"\x8B\xBF" => "\xEB\x96\xAF",
		"\x8B\xC0" => "\xEB\x96\xB2",
		"\x8B\xC1" => "\xEB\x96\xB6",
		"\x8B\xC2" => "\xEB\x96\xB7",
		"\x8B\xC3" => "\xEB\x96\xB8",
		"\x8B\xC4" => "\xEB\x96\xB9",
		"\x8B\xC5" => "\xEB\x96\xBA",
		"\x8B\xC6" => "\xEB\x96\xBE",
		"\x8B\xC7" => "\xEB\x96\xBF",
		"\x8B\xC8" => "\xEB\x97\x81",
		"\x8B\xC9" => "\xEB\x97\x82",
		"\x8B\xCA" => "\xEB\x97\x83",
		"\x8B\xCB" => "\xEB\x97\x85",
		"\x8B\xCC" => "\xEB\x97\x86",
		"\x8B\xCD" => "\xEB\x97\x87",
		"\x8B\xCE" => "\xEB\x97\x88",
		"\x8B\xCF" => "\xEB\x97\x89",
		"\x8B\xD0" => "\xEB\x97\x8A",
		"\x8B\xD1" => "\xEB\x97\x8B",
		"\x8B\xD2" => "\xEB\x97\x8E",
		"\x8B\xD3" => "\xEB\x97\x92",
		"\x8B\xD4" => "\xEB\x97\x93",
		"\x8B\xD5" => "\xEB\x97\x94",
		"\x8B\xD6" => "\xEB\x97\x95",
		"\x8B\xD7" => "\xEB\x97\x96",
		"\x8B\xD8" => "\xEB\x97\x97",
		"\x8B\xD9" => "\xEB\x97\x99",
		"\x8B\xDA" => "\xEB\x97\x9A",
		"\x8B\xDB" => "\xEB\x97\x9B",
		"\x8B\xDC" => "\xEB\x97\x9C",
		"\x8B\xDD" => "\xEB\x97\x9D",
		"\x8B\xDE" => "\xEB\x97\x9E",
		"\x8B\xDF" => "\xEB\x97\x9F",
		"\x8B\xE0" => "\xEB\x97\xA0",
		"\x8B\xE1" => "\xEB\x97\xA1",
		"\x8B\xE2" => "\xEB\x97\xA2",
		"\x8B\xE3" => "\xEB\x97\xA3",
		"\x8B\xE4" => "\xEB\x97\xA4",
		"\x8B\xE5" => "\xEB\x97\xA5",
		"\x8B\xE6" => "\xEB\x97\xA6",
		"\x8B\xE7" => "\xEB\x97\xA7",
		"\x8B\xE8" => "\xEB\x97\xA8",
		"\x8B\xE9" => "\xEB\x97\xA9",
		"\x8B\xEA" => "\xEB\x97\xAA",
		"\x8B\xEB" => "\xEB\x97\xAB",
		"\x8B\xEC" => "\xEB\x97\xAD",
		"\x8B\xED" => "\xEB\x97\xAE",
		"\x8B\xEE" => "\xEB\x97\xAF",
		"\x8B\xEF" => "\xEB\x97\xB0",
		"\x8B\xF0" => "\xEB\x97\xB1",
		"\x8B\xF1" => "\xEB\x97\xB2",
		"\x8B\xF2" => "\xEB\x97\xB3",
		"\x8B\xF3" => "\xEB\x97\xB4",
		"\x8B\xF4" => "\xEB\x97\xB5",
		"\x8B\xF5" => "\xEB\x97\xB6",
		"\x8B\xF6" => "\xEB\x97\xB7",
		"\x8B\xF7" => "\xEB\x97\xB8",
		"\x8B\xF8" => "\xEB\x97\xB9",
		"\x8B\xF9" => "\xEB\x97\xBA",
		"\x8B\xFA" => "\xEB\x97\xBB",
		"\x8B\xFB" => "\xEB\x97\xBC",
		"\x8B\xFC" => "\xEB\x97\xBD",
		"\x8B\xFD" => "\xEB\x97\xBE",
		"\x8B\xFE" => "\xEB\x97\xBF",
		"\x8C\x41" => "\xEB\x98\x80",
		"\x8C\x42" => "\xEB\x98\x81",
		"\x8C\x43" => "\xEB\x98\x82",
		"\x8C\x44" => "\xEB\x98\x83",
		"\x8C\x45" => "\xEB\x98\x84",
		"\x8C\x46" => "\xEB\x98\x85",
		"\x8C\x47" => "\xEB\x98\x86",
		"\x8C\x48" => "\xEB\x98\x87",
		"\x8C\x49" => "\xEB\x98\x88",
		"\x8C\x4A" => "\xEB\x98\x89",
		"\x8C\x4B" => "\xEB\x98\x8A",
		"\x8C\x4C" => "\xEB\x98\x8B",
		"\x8C\x4D" => "\xEB\x98\x8C",
		"\x8C\x4E" => "\xEB\x98\x8D",
		"\x8C\x4F" => "\xEB\x98\x8E",
		"\x8C\x50" => "\xEB\x98\x8F",
		"\x8C\x51" => "\xEB\x98\x92",
		"\x8C\x52" => "\xEB\x98\x93",
		"\x8C\x53" => "\xEB\x98\x95",
		"\x8C\x54" => "\xEB\x98\x96",
		"\x8C\x55" => "\xEB\x98\x97",
		"\x8C\x56" => "\xEB\x98\x99",
		"\x8C\x57" => "\xEB\x98\x9A",
		"\x8C\x58" => "\xEB\x98\x9B",
		"\x8C\x59" => "\xEB\x98\x9C",
		"\x8C\x5A" => "\xEB\x98\x9D",
		"\x8C\x61" => "\xEB\x98\x9E",
		"\x8C\x62" => "\xEB\x98\x9F",
		"\x8C\x63" => "\xEB\x98\xA0",
		"\x8C\x64" => "\xEB\x98\xA1",
		"\x8C\x65" => "\xEB\x98\xA2",
		"\x8C\x66" => "\xEB\x98\xA3",
		"\x8C\x67" => "\xEB\x98\xA4",
		"\x8C\x68" => "\xEB\x98\xA6",
		"\x8C\x69" => "\xEB\x98\xA7",
		"\x8C\x6A" => "\xEB\x98\xA8",
		"\x8C\x6B" => "\xEB\x98\xA9",
		"\x8C\x6C" => "\xEB\x98\xAA",
		"\x8C\x6D" => "\xEB\x98\xAB",
		"\x8C\x6E" => "\xEB\x98\xAD",
		"\x8C\x6F" => "\xEB\x98\xAE",
		"\x8C\x70" => "\xEB\x98\xAF",
		"\x8C\x71" => "\xEB\x98\xB0",
		"\x8C\x72" => "\xEB\x98\xB1",
		"\x8C\x73" => "\xEB\x98\xB2",
		"\x8C\x74" => "\xEB\x98\xB3",
		"\x8C\x75" => "\xEB\x98\xB5",
		"\x8C\x76" => "\xEB\x98\xB6",
		"\x8C\x77" => "\xEB\x98\xB7",
		"\x8C\x78" => "\xEB\x98\xB8",
		"\x8C\x79" => "\xEB\x98\xB9",
		"\x8C\x7A" => "\xEB\x98\xBA",
		"\x8C\x81" => "\xEB\x98\xBB",
		"\x8C\x82" => "\xEB\x98\xBC",
		"\x8C\x83" => "\xEB\x98\xBD",
		"\x8C\x84" => "\xEB\x98\xBE",
		"\x8C\x85" => "\xEB\x98\xBF",
		"\x8C\x86" => "\xEB\x99\x80",
		"\x8C\x87" => "\xEB\x99\x81",
		"\x8C\x88" => "\xEB\x99\x82",
		"\x8C\x89" => "\xEB\x99\x83",
		"\x8C\x8A" => "\xEB\x99\x84",
		"\x8C\x8B" => "\xEB\x99\x85",
		"\x8C\x8C" => "\xEB\x99\x86",
		"\x8C\x8D" => "\xEB\x99\x87",
		"\x8C\x8E" => "\xEB\x99\x89",
		"\x8C\x8F" => "\xEB\x99\x8A",
		"\x8C\x90" => "\xEB\x99\x8B",
		"\x8C\x91" => "\xEB\x99\x8C",
		"\x8C\x92" => "\xEB\x99\x8D",
		"\x8C\x93" => "\xEB\x99\x8E",
		"\x8C\x94" => "\xEB\x99\x8F",
		"\x8C\x95" => "\xEB\x99\x90",
		"\x8C\x96" => "\xEB\x99\x91",
		"\x8C\x97" => "\xEB\x99\x92",
		"\x8C\x98" => "\xEB\x99\x93",
		"\x8C\x99" => "\xEB\x99\x94",
		"\x8C\x9A" => "\xEB\x99\x95",
		"\x8C\x9B" => "\xEB\x99\x96",
		"\x8C\x9C" => "\xEB\x99\x97",
		"\x8C\x9D" => "\xEB\x99\x98",
		"\x8C\x9E" => "\xEB\x99\x99",
		"\x8C\x9F" => "\xEB\x99\x9A",
		"\x8C\xA0" => "\xEB\x99\x9B",
		"\x8C\xA1" => "\xEB\x99\x9C",
		"\x8C\xA2" => "\xEB\x99\x9D",
		"\x8C\xA3" => "\xEB\x99\x9E",
		"\x8C\xA4" => "\xEB\x99\x9F",
		"\x8C\xA5" => "\xEB\x99\xA0",
		"\x8C\xA6" => "\xEB\x99\xA1",
		"\x8C\xA7" => "\xEB\x99\xA2",
		"\x8C\xA8" => "\xEB\x99\xA3",
		"\x8C\xA9" => "\xEB\x99\xA5",
		"\x8C\xAA" => "\xEB\x99\xA6",
		"\x8C\xAB" => "\xEB\x99\xA7",
		"\x8C\xAC" => "\xEB\x99\xA9",
		"\x8C\xAD" => "\xEB\x99\xAA",
		"\x8C\xAE" => "\xEB\x99\xAB",
		"\x8C\xAF" => "\xEB\x99\xAC",
		"\x8C\xB0" => "\xEB\x99\xAD",
		"\x8C\xB1" => "\xEB\x99\xAE",
		"\x8C\xB2" => "\xEB\x99\xAF",
		"\x8C\xB3" => "\xEB\x99\xB0",
		"\x8C\xB4" => "\xEB\x99\xB1",
		"\x8C\xB5" => "\xEB\x99\xB2",
		"\x8C\xB6" => "\xEB\x99\xB3",
		"\x8C\xB7" => "\xEB\x99\xB4",
		"\x8C\xB8" => "\xEB\x99\xB5",
		"\x8C\xB9" => "\xEB\x99\xB6",
		"\x8C\xBA" => "\xEB\x99\xB7",
		"\x8C\xBB" => "\xEB\x99\xB8",
		"\x8C\xBC" => "\xEB\x99\xB9",
		"\x8C\xBD" => "\xEB\x99\xBA",
		"\x8C\xBE" => "\xEB\x99\xBB",
		"\x8C\xBF" => "\xEB\x99\xBC",
		"\x8C\xC0" => "\xEB\x99\xBD",
		"\x8C\xC1" => "\xEB\x99\xBE",
		"\x8C\xC2" => "\xEB\x99\xBF",
		"\x8C\xC3" => "\xEB\x9A\x80",
		"\x8C\xC4" => "\xEB\x9A\x81",
		"\x8C\xC5" => "\xEB\x9A\x82",
		"\x8C\xC6" => "\xEB\x9A\x83",
		"\x8C\xC7" => "\xEB\x9A\x84",
		"\x8C\xC8" => "\xEB\x9A\x85",
		"\x8C\xC9" => "\xEB\x9A\x86",
		"\x8C\xCA" => "\xEB\x9A\x87",
		"\x8C\xCB" => "\xEB\x9A\x88",
		"\x8C\xCC" => "\xEB\x9A\x89",
		"\x8C\xCD" => "\xEB\x9A\x8A",
		"\x8C\xCE" => "\xEB\x9A\x8B",
		"\x8C\xCF" => "\xEB\x9A\x8C",
		"\x8C\xD0" => "\xEB\x9A\x8D",
		"\x8C\xD1" => "\xEB\x9A\x8E",
		"\x8C\xD2" => "\xEB\x9A\x8F",
		"\x8C\xD3" => "\xEB\x9A\x90",
		"\x8C\xD4" => "\xEB\x9A\x91",
		"\x8C\xD5" => "\xEB\x9A\x92",
		"\x8C\xD6" => "\xEB\x9A\x93",
		"\x8C\xD7" => "\xEB\x9A\x94",
		"\x8C\xD8" => "\xEB\x9A\x95",
		"\x8C\xD9" => "\xEB\x9A\x96",
		"\x8C\xDA" => "\xEB\x9A\x97",
		"\x8C\xDB" => "\xEB\x9A\x98",
		"\x8C\xDC" => "\xEB\x9A\x99",
		"\x8C\xDD" => "\xEB\x9A\x9A",
		"\x8C\xDE" => "\xEB\x9A\x9B",
		"\x8C\xDF" => "\xEB\x9A\x9E",
		"\x8C\xE0" => "\xEB\x9A\x9F",
		"\x8C\xE1" => "\xEB\x9A\xA1",
		"\x8C\xE2" => "\xEB\x9A\xA2",
		"\x8C\xE3" => "\xEB\x9A\xA3",
		"\x8C\xE4" => "\xEB\x9A\xA5",
		"\x8C\xE5" => "\xEB\x9A\xA6",
		"\x8C\xE6" => "\xEB\x9A\xA7",
		"\x8C\xE7" => "\xEB\x9A\xA8",
		"\x8C\xE8" => "\xEB\x9A\xA9",
		"\x8C\xE9" => "\xEB\x9A\xAA",
		"\x8C\xEA" => "\xEB\x9A\xAD",
		"\x8C\xEB" => "\xEB\x9A\xAE",
		"\x8C\xEC" => "\xEB\x9A\xAF",
		"\x8C\xED" => "\xEB\x9A\xB0",
		"\x8C\xEE" => "\xEB\x9A\xB2",
		"\x8C\xEF" => "\xEB\x9A\xB3",
		"\x8C\xF0" => "\xEB\x9A\xB4",
		"\x8C\xF1" => "\xEB\x9A\xB5",
		"\x8C\xF2" => "\xEB\x9A\xB6",
		"\x8C\xF3" => "\xEB\x9A\xB7",
		"\x8C\xF4" => "\xEB\x9A\xB8",
		"\x8C\xF5" => "\xEB\x9A\xB9",
		"\x8C\xF6" => "\xEB\x9A\xBA",
		"\x8C\xF7" => "\xEB\x9A\xBB",
		"\x8C\xF8" => "\xEB\x9A\xBC",
		"\x8C\xF9" => "\xEB\x9A\xBD",
		"\x8C\xFA" => "\xEB\x9A\xBE",
		"\x8C\xFB" => "\xEB\x9A\xBF",
		"\x8C\xFC" => "\xEB\x9B\x80",
		"\x8C\xFD" => "\xEB\x9B\x81",
		"\x8C\xFE" => "\xEB\x9B\x82",
		"\x8D\x41" => "\xEB\x9B\x83",
		"\x8D\x42" => "\xEB\x9B\x84",
		"\x8D\x43" => "\xEB\x9B\x85",
		"\x8D\x44" => "\xEB\x9B\x86",
		"\x8D\x45" => "\xEB\x9B\x87",
		"\x8D\x46" => "\xEB\x9B\x88",
		"\x8D\x47" => "\xEB\x9B\x89",
		"\x8D\x48" => "\xEB\x9B\x8A",
		"\x8D\x49" => "\xEB\x9B\x8B",
		"\x8D\x4A" => "\xEB\x9B\x8C",
		"\x8D\x4B" => "\xEB\x9B\x8D",
		"\x8D\x4C" => "\xEB\x9B\x8E",
		"\x8D\x4D" => "\xEB\x9B\x8F",
		"\x8D\x4E" => "\xEB\x9B\x90",
		"\x8D\x4F" => "\xEB\x9B\x91",
		"\x8D\x50" => "\xEB\x9B\x92",
		"\x8D\x51" => "\xEB\x9B\x93",
		"\x8D\x52" => "\xEB\x9B\x95",
		"\x8D\x53" => "\xEB\x9B\x96",
		"\x8D\x54" => "\xEB\x9B\x97",
		"\x8D\x55" => "\xEB\x9B\x98",
		"\x8D\x56" => "\xEB\x9B\x99",
		"\x8D\x57" => "\xEB\x9B\x9A",
		"\x8D\x58" => "\xEB\x9B\x9B",
		"\x8D\x59" => "\xEB\x9B\x9C",
		"\x8D\x5A" => "\xEB\x9B\x9D",
		"\x8D\x61" => "\xEB\x9B\x9E",
		"\x8D\x62" => "\xEB\x9B\x9F",
		"\x8D\x63" => "\xEB\x9B\xA0",
		"\x8D\x64" => "\xEB\x9B\xA1",
		"\x8D\x65" => "\xEB\x9B\xA2",
		"\x8D\x66" => "\xEB\x9B\xA3",
		"\x8D\x67" => "\xEB\x9B\xA4",
		"\x8D\x68" => "\xEB\x9B\xA5",
		"\x8D\x69" => "\xEB\x9B\xA6",
		"\x8D\x6A" => "\xEB\x9B\xA7",
		"\x8D\x6B" => "\xEB\x9B\xA8",
		"\x8D\x6C" => "\xEB\x9B\xA9",
		"\x8D\x6D" => "\xEB\x9B\xAA",
		"\x8D\x6E" => "\xEB\x9B\xAB",
		"\x8D\x6F" => "\xEB\x9B\xAC",
		"\x8D\x70" => "\xEB\x9B\xAD",
		"\x8D\x71" => "\xEB\x9B\xAE",
		"\x8D\x72" => "\xEB\x9B\xAF",
		"\x8D\x73" => "\xEB\x9B\xB1",
		"\x8D\x74" => "\xEB\x9B\xB2",
		"\x8D\x75" => "\xEB\x9B\xB3",
		"\x8D\x76" => "\xEB\x9B\xB5",
		"\x8D\x77" => "\xEB\x9B\xB6",
		"\x8D\x78" => "\xEB\x9B\xB7",
		"\x8D\x79" => "\xEB\x9B\xB9",
		"\x8D\x7A" => "\xEB\x9B\xBA",
		"\x8D\x81" => "\xEB\x9B\xBB",
		"\x8D\x82" => "\xEB\x9B\xBC",
		"\x8D\x83" => "\xEB\x9B\xBD",
		"\x8D\x84" => "\xEB\x9B\xBE",
		"\x8D\x85" => "\xEB\x9B\xBF",
		"\x8D\x86" => "\xEB\x9C\x82",
		"\x8D\x87" => "\xEB\x9C\x83",
		"\x8D\x88" => "\xEB\x9C\x84",
		"\x8D\x89" => "\xEB\x9C\x86",
		"\x8D\x8A" => "\xEB\x9C\x87",
		"\x8D\x8B" => "\xEB\x9C\x88",
		"\x8D\x8C" => "\xEB\x9C\x89",
		"\x8D\x8D" => "\xEB\x9C\x8A",
		"\x8D\x8E" => "\xEB\x9C\x8B",
		"\x8D\x8F" => "\xEB\x9C\x8C",
		"\x8D\x90" => "\xEB\x9C\x8D",
		"\x8D\x91" => "\xEB\x9C\x8E",
		"\x8D\x92" => "\xEB\x9C\x8F",
		"\x8D\x93" => "\xEB\x9C\x90",
		"\x8D\x94" => "\xEB\x9C\x91",
		"\x8D\x95" => "\xEB\x9C\x92",
		"\x8D\x96" => "\xEB\x9C\x93",
		"\x8D\x97" => "\xEB\x9C\x94",
		"\x8D\x98" => "\xEB\x9C\x95",
		"\x8D\x99" => "\xEB\x9C\x96",
		"\x8D\x9A" => "\xEB\x9C\x97",
		"\x8D\x9B" => "\xEB\x9C\x98",
		"\x8D\x9C" => "\xEB\x9C\x99",
		"\x8D\x9D" => "\xEB\x9C\x9A",
		"\x8D\x9E" => "\xEB\x9C\x9B",
		"\x8D\x9F" => "\xEB\x9C\x9C",
		"\x8D\xA0" => "\xEB\x9C\x9D",
		"\x8D\xA1" => "\xEB\x9C\x9E",
		"\x8D\xA2" => "\xEB\x9C\x9F",
		"\x8D\xA3" => "\xEB\x9C\xA0",
		"\x8D\xA4" => "\xEB\x9C\xA1",
		"\x8D\xA5" => "\xEB\x9C\xA2",
		"\x8D\xA6" => "\xEB\x9C\xA3",
		"\x8D\xA7" => "\xEB\x9C\xA4",
		"\x8D\xA8" => "\xEB\x9C\xA5",
		"\x8D\xA9" => "\xEB\x9C\xA6",
		"\x8D\xAA" => "\xEB\x9C\xA7",
		"\x8D\xAB" => "\xEB\x9C\xAA",
		"\x8D\xAC" => "\xEB\x9C\xAB",
		"\x8D\xAD" => "\xEB\x9C\xAD",
		"\x8D\xAE" => "\xEB\x9C\xAE",
		"\x8D\xAF" => "\xEB\x9C\xB1",
		"\x8D\xB0" => "\xEB\x9C\xB2",
		"\x8D\xB1" => "\xEB\x9C\xB3",
		"\x8D\xB2" => "\xEB\x9C\xB4",
		"\x8D\xB3" => "\xEB\x9C\xB5",
		"\x8D\xB4" => "\xEB\x9C\xB6",
		"\x8D\xB5" => "\xEB\x9C\xB7",
		"\x8D\xB6" => "\xEB\x9C\xBA",
		"\x8D\xB7" => "\xEB\x9C\xBC",
		"\x8D\xB8" => "\xEB\x9C\xBD",
		"\x8D\xB9" => "\xEB\x9C\xBE",
		"\x8D\xBA" => "\xEB\x9C\xBF",
		"\x8D\xBB" => "\xEB\x9D\x80",
		"\x8D\xBC" => "\xEB\x9D\x81",
		"\x8D\xBD" => "\xEB\x9D\x82",
		"\x8D\xBE" => "\xEB\x9D\x83",
		"\x8D\xBF" => "\xEB\x9D\x85",
		"\x8D\xC0" => "\xEB\x9D\x86",
		"\x8D\xC1" => "\xEB\x9D\x87",
		"\x8D\xC2" => "\xEB\x9D\x89",
		"\x8D\xC3" => "\xEB\x9D\x8A",
		"\x8D\xC4" => "\xEB\x9D\x8B",
		"\x8D\xC5" => "\xEB\x9D\x8D",
		"\x8D\xC6" => "\xEB\x9D\x8E",
		"\x8D\xC7" => "\xEB\x9D\x8F",
		"\x8D\xC8" => "\xEB\x9D\x90",
		"\x8D\xC9" => "\xEB\x9D\x91",
		"\x8D\xCA" => "\xEB\x9D\x92",
		"\x8D\xCB" => "\xEB\x9D\x93",
		"\x8D\xCC" => "\xEB\x9D\x96",
		"\x8D\xCD" => "\xEB\x9D\x97",
		"\x8D\xCE" => "\xEB\x9D\x98",
		"\x8D\xCF" => "\xEB\x9D\x99",
		"\x8D\xD0" => "\xEB\x9D\x9A",
		"\x8D\xD1" => "\xEB\x9D\x9B",
		"\x8D\xD2" => "\xEB\x9D\x9C",
		"\x8D\xD3" => "\xEB\x9D\x9D",
		"\x8D\xD4" => "\xEB\x9D\x9E",
		"\x8D\xD5" => "\xEB\x9D\x9F",
		"\x8D\xD6" => "\xEB\x9D\xA1",
		"\x8D\xD7" => "\xEB\x9D\xA2",
		"\x8D\xD8" => "\xEB\x9D\xA3",
		"\x8D\xD9" => "\xEB\x9D\xA5",
		"\x8D\xDA" => "\xEB\x9D\xA6",
		"\x8D\xDB" => "\xEB\x9D\xA7",
		"\x8D\xDC" => "\xEB\x9D\xA9",
		"\x8D\xDD" => "\xEB\x9D\xAA",
		"\x8D\xDE" => "\xEB\x9D\xAB",
		"\x8D\xDF" => "\xEB\x9D\xAC",
		"\x8D\xE0" => "\xEB\x9D\xAD",
		"\x8D\xE1" => "\xEB\x9D\xAE",
		"\x8D\xE2" => "\xEB\x9D\xAF",
		"\x8D\xE3" => "\xEB\x9D\xB2",
		"\x8D\xE4" => "\xEB\x9D\xB4",
		"\x8D\xE5" => "\xEB\x9D\xB6",
		"\x8D\xE6" => "\xEB\x9D\xB7",
		"\x8D\xE7" => "\xEB\x9D\xB8",
		"\x8D\xE8" => "\xEB\x9D\xB9",
		"\x8D\xE9" => "\xEB\x9D\xBA",
		"\x8D\xEA" => "\xEB\x9D\xBB",
		"\x8D\xEB" => "\xEB\x9D\xBE",
		"\x8D\xEC" => "\xEB\x9D\xBF",
		"\x8D\xED" => "\xEB\x9E\x81",
		"\x8D\xEE" => "\xEB\x9E\x82",
		"\x8D\xEF" => "\xEB\x9E\x83",
		"\x8D\xF0" => "\xEB\x9E\x85",
		"\x8D\xF1" => "\xEB\x9E\x86",
		"\x8D\xF2" => "\xEB\x9E\x87",
		"\x8D\xF3" => "\xEB\x9E\x88",
		"\x8D\xF4" => "\xEB\x9E\x89",
		"\x8D\xF5" => "\xEB\x9E\x8A",
		"\x8D\xF6" => "\xEB\x9E\x8B",
		"\x8D\xF7" => "\xEB\x9E\x8E",
		"\x8D\xF8" => "\xEB\x9E\x93",
		"\x8D\xF9" => "\xEB\x9E\x94",
		"\x8D\xFA" => "\xEB\x9E\x95",
		"\x8D\xFB" => "\xEB\x9E\x9A",
		"\x8D\xFC" => "\xEB\x9E\x9B",
		"\x8D\xFD" => "\xEB\x9E\x9D",
		"\x8D\xFE" => "\xEB\x9E\x9E",
		"\x8E\x41" => "\xEB\x9E\x9F",
		"\x8E\x42" => "\xEB\x9E\xA1",
		"\x8E\x43" => "\xEB\x9E\xA2",
		"\x8E\x44" => "\xEB\x9E\xA3",
		"\x8E\x45" => "\xEB\x9E\xA4",
		"\x8E\x46" => "\xEB\x9E\xA5",
		"\x8E\x47" => "\xEB\x9E\xA6",
		"\x8E\x48" => "\xEB\x9E\xA7",
		"\x8E\x49" => "\xEB\x9E\xAA",
		"\x8E\x4A" => "\xEB\x9E\xAE",
		"\x8E\x4B" => "\xEB\x9E\xAF",
		"\x8E\x4C" => "\xEB\x9E\xB0",
		"\x8E\x4D" => "\xEB\x9E\xB1",
		"\x8E\x4E" => "\xEB\x9E\xB2",
		"\x8E\x4F" => "\xEB\x9E\xB3",
		"\x8E\x50" => "\xEB\x9E\xB6",
		"\x8E\x51" => "\xEB\x9E\xB7",
		"\x8E\x52" => "\xEB\x9E\xB9",
		"\x8E\x53" => "\xEB\x9E\xBA",
		"\x8E\x54" => "\xEB\x9E\xBB",
		"\x8E\x55" => "\xEB\x9E\xBC",
		"\x8E\x56" => "\xEB\x9E\xBD",
		"\x8E\x57" => "\xEB\x9E\xBE",
		"\x8E\x58" => "\xEB\x9E\xBF",
		"\x8E\x59" => "\xEB\x9F\x80",
		"\x8E\x5A" => "\xEB\x9F\x81",
		"\x8E\x61" => "\xEB\x9F\x82",
		"\x8E\x62" => "\xEB\x9F\x83",
		"\x8E\x63" => "\xEB\x9F\x84",
		"\x8E\x64" => "\xEB\x9F\x85",
		"\x8E\x65" => "\xEB\x9F\x86",
		"\x8E\x66" => "\xEB\x9F\x88",
		"\x8E\x67" => "\xEB\x9F\x8A",
		"\x8E\x68" => "\xEB\x9F\x8B",
		"\x8E\x69" => "\xEB\x9F\x8C",
		"\x8E\x6A" => "\xEB\x9F\x8D",
		"\x8E\x6B" => "\xEB\x9F\x8E",
		"\x8E\x6C" => "\xEB\x9F\x8F",
		"\x8E\x6D" => "\xEB\x9F\x90",
		"\x8E\x6E" => "\xEB\x9F\x91",
		"\x8E\x6F" => "\xEB\x9F\x92",
		"\x8E\x70" => "\xEB\x9F\x93",
		"\x8E\x71" => "\xEB\x9F\x94",
		"\x8E\x72" => "\xEB\x9F\x95",
		"\x8E\x73" => "\xEB\x9F\x96",
		"\x8E\x74" => "\xEB\x9F\x97",
		"\x8E\x75" => "\xEB\x9F\x98",
		"\x8E\x76" => "\xEB\x9F\x99",
		"\x8E\x77" => "\xEB\x9F\x9A",
		"\x8E\x78" => "\xEB\x9F\x9B",
		"\x8E\x79" => "\xEB\x9F\x9C",
		"\x8E\x7A" => "\xEB\x9F\x9D",
		"\x8E\x81" => "\xEB\x9F\x9E",
		"\x8E\x82" => "\xEB\x9F\x9F",
		"\x8E\x83" => "\xEB\x9F\xA0",
		"\x8E\x84" => "\xEB\x9F\xA1",
		"\x8E\x85" => "\xEB\x9F\xA2",
		"\x8E\x86" => "\xEB\x9F\xA3",
		"\x8E\x87" => "\xEB\x9F\xA4",
		"\x8E\x88" => "\xEB\x9F\xA5",
		"\x8E\x89" => "\xEB\x9F\xA6",
		"\x8E\x8A" => "\xEB\x9F\xA7",
		"\x8E\x8B" => "\xEB\x9F\xA8",
		"\x8E\x8C" => "\xEB\x9F\xA9",
		"\x8E\x8D" => "\xEB\x9F\xAA",
		"\x8E\x8E" => "\xEB\x9F\xAB",
		"\x8E\x8F" => "\xEB\x9F\xAE",
		"\x8E\x90" => "\xEB\x9F\xAF",
		"\x8E\x91" => "\xEB\x9F\xB1",
		"\x8E\x92" => "\xEB\x9F\xB2",
		"\x8E\x93" => "\xEB\x9F\xB3",
		"\x8E\x94" => "\xEB\x9F\xB5",
		"\x8E\x95" => "\xEB\x9F\xB6",
		"\x8E\x96" => "\xEB\x9F\xB7",
		"\x8E\x97" => "\xEB\x9F\xB8",
		"\x8E\x98" => "\xEB\x9F\xB9",
		"\x8E\x99" => "\xEB\x9F\xBA",
		"\x8E\x9A" => "\xEB\x9F\xBB",
		"\x8E\x9B" => "\xEB\x9F\xBE",
		"\x8E\x9C" => "\xEB\xA0\x82",
		"\x8E\x9D" => "\xEB\xA0\x83",
		"\x8E\x9E" => "\xEB\xA0\x84",
		"\x8E\x9F" => "\xEB\xA0\x85",
		"\x8E\xA0" => "\xEB\xA0\x86",
		"\x8E\xA1" => "\xEB\xA0\x8A",
		"\x8E\xA2" => "\xEB\xA0\x8B",
		"\x8E\xA3" => "\xEB\xA0\x8D",
		"\x8E\xA4" => "\xEB\xA0\x8E",
		"\x8E\xA5" => "\xEB\xA0\x8F",
		"\x8E\xA6" => "\xEB\xA0\x91",
		"\x8E\xA7" => "\xEB\xA0\x92",
		"\x8E\xA8" => "\xEB\xA0\x93",
		"\x8E\xA9" => "\xEB\xA0\x94",
		"\x8E\xAA" => "\xEB\xA0\x95",
		"\x8E\xAB" => "\xEB\xA0\x96",
		"\x8E\xAC" => "\xEB\xA0\x97",
		"\x8E\xAD" => "\xEB\xA0\x9A",
		"\x8E\xAE" => "\xEB\xA0\x9C",
		"\x8E\xAF" => "\xEB\xA0\x9E",
		"\x8E\xB0" => "\xEB\xA0\x9F",
		"\x8E\xB1" => "\xEB\xA0\xA0",
		"\x8E\xB2" => "\xEB\xA0\xA1",
		"\x8E\xB3" => "\xEB\xA0\xA2",
		"\x8E\xB4" => "\xEB\xA0\xA3",
		"\x8E\xB5" => "\xEB\xA0\xA6",
		"\x8E\xB6" => "\xEB\xA0\xA7",
		"\x8E\xB7" => "\xEB\xA0\xA9",
		"\x8E\xB8" => "\xEB\xA0\xAA",
		"\x8E\xB9" => "\xEB\xA0\xAB",
		"\x8E\xBA" => "\xEB\xA0\xAD",
		"\x8E\xBB" => "\xEB\xA0\xAE",
		"\x8E\xBC" => "\xEB\xA0\xAF",
		"\x8E\xBD" => "\xEB\xA0\xB0",
		"\x8E\xBE" => "\xEB\xA0\xB1",
		"\x8E\xBF" => "\xEB\xA0\xB2",
		"\x8E\xC0" => "\xEB\xA0\xB3",
		"\x8E\xC1" => "\xEB\xA0\xB6",
		"\x8E\xC2" => "\xEB\xA0\xBA",
		"\x8E\xC3" => "\xEB\xA0\xBB",
		"\x8E\xC4" => "\xEB\xA0\xBC",
		"\x8E\xC5" => "\xEB\xA0\xBD",
		"\x8E\xC6" => "\xEB\xA0\xBE",
		"\x8E\xC7" => "\xEB\xA0\xBF",
		"\x8E\xC8" => "\xEB\xA1\x81",
		"\x8E\xC9" => "\xEB\xA1\x82",
		"\x8E\xCA" => "\xEB\xA1\x83",
		"\x8E\xCB" => "\xEB\xA1\x85",
		"\x8E\xCC" => "\xEB\xA1\x86",
		"\x8E\xCD" => "\xEB\xA1\x87",
		"\x8E\xCE" => "\xEB\xA1\x88",
		"\x8E\xCF" => "\xEB\xA1\x89",
		"\x8E\xD0" => "\xEB\xA1\x8A",
		"\x8E\xD1" => "\xEB\xA1\x8B",
		"\x8E\xD2" => "\xEB\xA1\x8C",
		"\x8E\xD3" => "\xEB\xA1\x8D",
		"\x8E\xD4" => "\xEB\xA1\x8E",
		"\x8E\xD5" => "\xEB\xA1\x8F",
		"\x8E\xD6" => "\xEB\xA1\x90",
		"\x8E\xD7" => "\xEB\xA1\x92",
		"\x8E\xD8" => "\xEB\xA1\x94",
		"\x8E\xD9" => "\xEB\xA1\x95",
		"\x8E\xDA" => "\xEB\xA1\x96",
		"\x8E\xDB" => "\xEB\xA1\x97",
		"\x8E\xDC" => "\xEB\xA1\x98",
		"\x8E\xDD" => "\xEB\xA1\x99",
		"\x8E\xDE" => "\xEB\xA1\x9A",
		"\x8E\xDF" => "\xEB\xA1\x9B",
		"\x8E\xE0" => "\xEB\xA1\x9E",
		"\x8E\xE1" => "\xEB\xA1\x9F",
		"\x8E\xE2" => "\xEB\xA1\xA1",
		"\x8E\xE3" => "\xEB\xA1\xA2",
		"\x8E\xE4" => "\xEB\xA1\xA3",
		"\x8E\xE5" => "\xEB\xA1\xA5",
		"\x8E\xE6" => "\xEB\xA1\xA6",
		"\x8E\xE7" => "\xEB\xA1\xA7",
		"\x8E\xE8" => "\xEB\xA1\xA8",
		"\x8E\xE9" => "\xEB\xA1\xA9",
		"\x8E\xEA" => "\xEB\xA1\xAA",
		"\x8E\xEB" => "\xEB\xA1\xAB",
		"\x8E\xEC" => "\xEB\xA1\xAE",
		"\x8E\xED" => "\xEB\xA1\xB0",
		"\x8E\xEE" => "\xEB\xA1\xB2",
		"\x8E\xEF" => "\xEB\xA1\xB3",
		"\x8E\xF0" => "\xEB\xA1\xB4",
		"\x8E\xF1" => "\xEB\xA1\xB5",
		"\x8E\xF2" => "\xEB\xA1\xB6",
		"\x8E\xF3" => "\xEB\xA1\xB7",
		"\x8E\xF4" => "\xEB\xA1\xB9",
		"\x8E\xF5" => "\xEB\xA1\xBA",
		"\x8E\xF6" => "\xEB\xA1\xBB",
		"\x8E\xF7" => "\xEB\xA1\xBD",
		"\x8E\xF8" => "\xEB\xA1\xBE",
		"\x8E\xF9" => "\xEB\xA1\xBF",
		"\x8E\xFA" => "\xEB\xA2\x80",
		"\x8E\xFB" => "\xEB\xA2\x81",
		"\x8E\xFC" => "\xEB\xA2\x82",
		"\x8E\xFD" => "\xEB\xA2\x83",
		"\x8E\xFE" => "\xEB\xA2\x84",
		"\x8F\x41" => "\xEB\xA2\x85",
		"\x8F\x42" => "\xEB\xA2\x86",
		"\x8F\x43" => "\xEB\xA2\x87",
		"\x8F\x44" => "\xEB\xA2\x88",
		"\x8F\x45" => "\xEB\xA2\x89",
		"\x8F\x46" => "\xEB\xA2\x8A",
		"\x8F\x47" => "\xEB\xA2\x8B",
		"\x8F\x48" => "\xEB\xA2\x8C",
		"\x8F\x49" => "\xEB\xA2\x8E",
		"\x8F\x4A" => "\xEB\xA2\x8F",
		"\x8F\x4B" => "\xEB\xA2\x90",
		"\x8F\x4C" => "\xEB\xA2\x91",
		"\x8F\x4D" => "\xEB\xA2\x92",
		"\x8F\x4E" => "\xEB\xA2\x93",
		"\x8F\x4F" => "\xEB\xA2\x94",
		"\x8F\x50" => "\xEB\xA2\x95",
		"\x8F\x51" => "\xEB\xA2\x96",
		"\x8F\x52" => "\xEB\xA2\x97",
		"\x8F\x53" => "\xEB\xA2\x98",
		"\x8F\x54" => "\xEB\xA2\x99",
		"\x8F\x55" => "\xEB\xA2\x9A",
		"\x8F\x56" => "\xEB\xA2\x9B",
		"\x8F\x57" => "\xEB\xA2\x9C",
		"\x8F\x58" => "\xEB\xA2\x9D",
		"\x8F\x59" => "\xEB\xA2\x9E",
		"\x8F\x5A" => "\xEB\xA2\x9F",
		"\x8F\x61" => "\xEB\xA2\xA0",
		"\x8F\x62" => "\xEB\xA2\xA1",
		"\x8F\x63" => "\xEB\xA2\xA2",
		"\x8F\x64" => "\xEB\xA2\xA3",
		"\x8F\x65" => "\xEB\xA2\xA4",
		"\x8F\x66" => "\xEB\xA2\xA5",
		"\x8F\x67" => "\xEB\xA2\xA6",
		"\x8F\x68" => "\xEB\xA2\xA7",
		"\x8F\x69" => "\xEB\xA2\xA9",
		"\x8F\x6A" => "\xEB\xA2\xAA",
		"\x8F\x6B" => "\xEB\xA2\xAB",
		"\x8F\x6C" => "\xEB\xA2\xAC",
		"\x8F\x6D" => "\xEB\xA2\xAD",
		"\x8F\x6E" => "\xEB\xA2\xAE",
		"\x8F\x6F" => "\xEB\xA2\xAF",
		"\x8F\x70" => "\xEB\xA2\xB1",
		"\x8F\x71" => "\xEB\xA2\xB2",
		"\x8F\x72" => "\xEB\xA2\xB3",
		"\x8F\x73" => "\xEB\xA2\xB5",
		"\x8F\x74" => "\xEB\xA2\xB6",
		"\x8F\x75" => "\xEB\xA2\xB7",
		"\x8F\x76" => "\xEB\xA2\xB9",
		"\x8F\x77" => "\xEB\xA2\xBA",
		"\x8F\x78" => "\xEB\xA2\xBB",
		"\x8F\x79" => "\xEB\xA2\xBC",
		"\x8F\x7A" => "\xEB\xA2\xBD",
		"\x8F\x81" => "\xEB\xA2\xBE",
		"\x8F\x82" => "\xEB\xA2\xBF",
		"\x8F\x83" => "\xEB\xA3\x82",
		"\x8F\x84" => "\xEB\xA3\x84",
		"\x8F\x85" => "\xEB\xA3\x86",
		"\x8F\x86" => "\xEB\xA3\x87",
		"\x8F\x87" => "\xEB\xA3\x88",
		"\x8F\x88" => "\xEB\xA3\x89",
		"\x8F\x89" => "\xEB\xA3\x8A",
		"\x8F\x8A" => "\xEB\xA3\x8B",
		"\x8F\x8B" => "\xEB\xA3\x8D",
		"\x8F\x8C" => "\xEB\xA3\x8E",
		"\x8F\x8D" => "\xEB\xA3\x8F",
		"\x8F\x8E" => "\xEB\xA3\x91",
		"\x8F\x8F" => "\xEB\xA3\x92",
		"\x8F\x90" => "\xEB\xA3\x93",
		"\x8F\x91" => "\xEB\xA3\x95",
		"\x8F\x92" => "\xEB\xA3\x96",
		"\x8F\x93" => "\xEB\xA3\x97",
		"\x8F\x94" => "\xEB\xA3\x98",
		"\x8F\x95" => "\xEB\xA3\x99",
		"\x8F\x96" => "\xEB\xA3\x9A",
		"\x8F\x97" => "\xEB\xA3\x9B",
		"\x8F\x98" => "\xEB\xA3\x9C",
		"\x8F\x99" => "\xEB\xA3\x9E",
		"\x8F\x9A" => "\xEB\xA3\xA0",
		"\x8F\x9B" => "\xEB\xA3\xA2",
		"\x8F\x9C" => "\xEB\xA3\xA3",
		"\x8F\x9D" => "\xEB\xA3\xA4",
		"\x8F\x9E" => "\xEB\xA3\xA5",
		"\x8F\x9F" => "\xEB\xA3\xA6",
		"\x8F\xA0" => "\xEB\xA3\xA7",
		"\x8F\xA1" => "\xEB\xA3\xAA",
		"\x8F\xA2" => "\xEB\xA3\xAB",
		"\x8F\xA3" => "\xEB\xA3\xAD",
		"\x8F\xA4" => "\xEB\xA3\xAE",
		"\x8F\xA5" => "\xEB\xA3\xAF",
		"\x8F\xA6" => "\xEB\xA3\xB1",
		"\x8F\xA7" => "\xEB\xA3\xB2",
		"\x8F\xA8" => "\xEB\xA3\xB3",
		"\x8F\xA9" => "\xEB\xA3\xB4",
		"\x8F\xAA" => "\xEB\xA3\xB5",
		"\x8F\xAB" => "\xEB\xA3\xB6",
		"\x8F\xAC" => "\xEB\xA3\xB7",
		"\x8F\xAD" => "\xEB\xA3\xBA",
		"\x8F\xAE" => "\xEB\xA3\xBC",
		"\x8F\xAF" => "\xEB\xA3\xBE",
		"\x8F\xB0" => "\xEB\xA3\xBF",
		"\x8F\xB1" => "\xEB\xA4\x80",
		"\x8F\xB2" => "\xEB\xA4\x81",
		"\x8F\xB3" => "\xEB\xA4\x82",
		"\x8F\xB4" => "\xEB\xA4\x83",
		"\x8F\xB5" => "\xEB\xA4\x85",
		"\x8F\xB6" => "\xEB\xA4\x86",
		"\x8F\xB7" => "\xEB\xA4\x87",
		"\x8F\xB8" => "\xEB\xA4\x88",
		"\x8F\xB9" => "\xEB\xA4\x89",
		"\x8F\xBA" => "\xEB\xA4\x8A",
		"\x8F\xBB" => "\xEB\xA4\x8B",
		"\x8F\xBC" => "\xEB\xA4\x8C",
		"\x8F\xBD" => "\xEB\xA4\x8D",
		"\x8F\xBE" => "\xEB\xA4\x8E",
		"\x8F\xBF" => "\xEB\xA4\x8F",
		"\x8F\xC0" => "\xEB\xA4\x90",
		"\x8F\xC1" => "\xEB\xA4\x91",
		"\x8F\xC2" => "\xEB\xA4\x92",
		"\x8F\xC3" => "\xEB\xA4\x93",
		"\x8F\xC4" => "\xEB\xA4\x94",
		"\x8F\xC5" => "\xEB\xA4\x95",
		"\x8F\xC6" => "\xEB\xA4\x96",
		"\x8F\xC7" => "\xEB\xA4\x97",
		"\x8F\xC8" => "\xEB\xA4\x99",
		"\x8F\xC9" => "\xEB\xA4\x9A",
		"\x8F\xCA" => "\xEB\xA4\x9B",
		"\x8F\xCB" => "\xEB\xA4\x9C",
		"\x8F\xCC" => "\xEB\xA4\x9D",
		"\x8F\xCD" => "\xEB\xA4\x9E",
		"\x8F\xCE" => "\xEB\xA4\x9F",
		"\x8F\xCF" => "\xEB\xA4\xA1",
		"\x8F\xD0" => "\xEB\xA4\xA2",
		"\x8F\xD1" => "\xEB\xA4\xA3",
		"\x8F\xD2" => "\xEB\xA4\xA4",
		"\x8F\xD3" => "\xEB\xA4\xA5",
		"\x8F\xD4" => "\xEB\xA4\xA6",
		"\x8F\xD5" => "\xEB\xA4\xA7",
		"\x8F\xD6" => "\xEB\xA4\xA8",
		"\x8F\xD7" => "\xEB\xA4\xA9",
		"\x8F\xD8" => "\xEB\xA4\xAA",
		"\x8F\xD9" => "\xEB\xA4\xAB",
		"\x8F\xDA" => "\xEB\xA4\xAC",
		"\x8F\xDB" => "\xEB\xA4\xAD",
		"\x8F\xDC" => "\xEB\xA4\xAE",
		"\x8F\xDD" => "\xEB\xA4\xAF",
		"\x8F\xDE" => "\xEB\xA4\xB0",
		"\x8F\xDF" => "\xEB\xA4\xB1",
		"\x8F\xE0" => "\xEB\xA4\xB2",
		"\x8F\xE1" => "\xEB\xA4\xB3",
		"\x8F\xE2" => "\xEB\xA4\xB4",
		"\x8F\xE3" => "\xEB\xA4\xB5",
		"\x8F\xE4" => "\xEB\xA4\xB6",
		"\x8F\xE5" => "\xEB\xA4\xB7",
		"\x8F\xE6" => "\xEB\xA4\xB8",
		"\x8F\xE7" => "\xEB\xA4\xB9",
		"\x8F\xE8" => "\xEB\xA4\xBA",
		"\x8F\xE9" => "\xEB\xA4\xBB",
		"\x8F\xEA" => "\xEB\xA4\xBE",
		"\x8F\xEB" => "\xEB\xA4\xBF",
		"\x8F\xEC" => "\xEB\xA5\x81",
		"\x8F\xED" => "\xEB\xA5\x82",
		"\x8F\xEE" => "\xEB\xA5\x83",
		"\x8F\xEF" => "\xEB\xA5\x85",
		"\x8F\xF0" => "\xEB\xA5\x86",
		"\x8F\xF1" => "\xEB\xA5\x87",
		"\x8F\xF2" => "\xEB\xA5\x88",
		"\x8F\xF3" => "\xEB\xA5\x89",
		"\x8F\xF4" => "\xEB\xA5\x8A",
		"\x8F\xF5" => "\xEB\xA5\x8B",
		"\x8F\xF6" => "\xEB\xA5\x8D",
		"\x8F\xF7" => "\xEB\xA5\x8E",
		"\x8F\xF8" => "\xEB\xA5\x90",
		"\x8F\xF9" => "\xEB\xA5\x92",
		"\x8F\xFA" => "\xEB\xA5\x93",
		"\x8F\xFB" => "\xEB\xA5\x94",
		"\x8F\xFC" => "\xEB\xA5\x95",
		"\x8F\xFD" => "\xEB\xA5\x96",
		"\x8F\xFE" => "\xEB\xA5\x97",
		"\x90\x41" => "\xEB\xA5\x9A",
		"\x90\x42" => "\xEB\xA5\x9B",
		"\x90\x43" => "\xEB\xA5\x9D",
		"\x90\x44" => "\xEB\xA5\x9E",
		"\x90\x45" => "\xEB\xA5\x9F",
		"\x90\x46" => "\xEB\xA5\xA1",
		"\x90\x47" => "\xEB\xA5\xA2",
		"\x90\x48" => "\xEB\xA5\xA3",
		"\x90\x49" => "\xEB\xA5\xA4",
		"\x90\x4A" => "\xEB\xA5\xA5",
		"\x90\x4B" => "\xEB\xA5\xA6",
		"\x90\x4C" => "\xEB\xA5\xA7",
		"\x90\x4D" => "\xEB\xA5\xAA",
		"\x90\x4E" => "\xEB\xA5\xAC",
		"\x90\x4F" => "\xEB\xA5\xAE",
		"\x90\x50" => "\xEB\xA5\xAF",
		"\x90\x51" => "\xEB\xA5\xB0",
		"\x90\x52" => "\xEB\xA5\xB1",
		"\x90\x53" => "\xEB\xA5\xB2",
		"\x90\x54" => "\xEB\xA5\xB3",
		"\x90\x55" => "\xEB\xA5\xB6",
		"\x90\x56" => "\xEB\xA5\xB7",
		"\x90\x57" => "\xEB\xA5\xB9",
		"\x90\x58" => "\xEB\xA5\xBA",
		"\x90\x59" => "\xEB\xA5\xBB",
		"\x90\x5A" => "\xEB\xA5\xBD",
		"\x90\x61" => "\xEB\xA5\xBE",
		"\x90\x62" => "\xEB\xA5\xBF",
		"\x90\x63" => "\xEB\xA6\x80",
		"\x90\x64" => "\xEB\xA6\x81",
		"\x90\x65" => "\xEB\xA6\x82",
		"\x90\x66" => "\xEB\xA6\x83",
		"\x90\x67" => "\xEB\xA6\x86",
		"\x90\x68" => "\xEB\xA6\x88",
		"\x90\x69" => "\xEB\xA6\x8B",
		"\x90\x6A" => "\xEB\xA6\x8C",
		"\x90\x6B" => "\xEB\xA6\x8F",
		"\x90\x6C" => "\xEB\xA6\x90",
		"\x90\x6D" => "\xEB\xA6\x91",
		"\x90\x6E" => "\xEB\xA6\x92",
		"\x90\x6F" => "\xEB\xA6\x93",
		"\x90\x70" => "\xEB\xA6\x94",
		"\x90\x71" => "\xEB\xA6\x95",
		"\x90\x72" => "\xEB\xA6\x96",
		"\x90\x73" => "\xEB\xA6\x97",
		"\x90\x74" => "\xEB\xA6\x98",
		"\x90\x75" => "\xEB\xA6\x99",
		"\x90\x76" => "\xEB\xA6\x9A",
		"\x90\x77" => "\xEB\xA6\x9B",
		"\x90\x78" => "\xEB\xA6\x9C",
		"\x90\x79" => "\xEB\xA6\x9D",
		"\x90\x7A" => "\xEB\xA6\x9E",
		"\x90\x81" => "\xEB\xA6\x9F",
		"\x90\x82" => "\xEB\xA6\xA0",
		"\x90\x83" => "\xEB\xA6\xA1",
		"\x90\x84" => "\xEB\xA6\xA2",
		"\x90\x85" => "\xEB\xA6\xA3",
		"\x90\x86" => "\xEB\xA6\xA4",
		"\x90\x87" => "\xEB\xA6\xA5",
		"\x90\x88" => "\xEB\xA6\xA6",
		"\x90\x89" => "\xEB\xA6\xA7",
		"\x90\x8A" => "\xEB\xA6\xA8",
		"\x90\x8B" => "\xEB\xA6\xA9",
		"\x90\x8C" => "\xEB\xA6\xAA",
		"\x90\x8D" => "\xEB\xA6\xAB",
		"\x90\x8E" => "\xEB\xA6\xAE",
		"\x90\x8F" => "\xEB\xA6\xAF",
		"\x90\x90" => "\xEB\xA6\xB1",
		"\x90\x91" => "\xEB\xA6\xB2",
		"\x90\x92" => "\xEB\xA6\xB3",
		"\x90\x93" => "\xEB\xA6\xB5",
		"\x90\x94" => "\xEB\xA6\xB6",
		"\x90\x95" => "\xEB\xA6\xB7",
		"\x90\x96" => "\xEB\xA6\xB8",
		"\x90\x97" => "\xEB\xA6\xB9",
		"\x90\x98" => "\xEB\xA6\xBA",
		"\x90\x99" => "\xEB\xA6\xBB",
		"\x90\x9A" => "\xEB\xA6\xBE",
		"\x90\x9B" => "\xEB\xA7\x80",
		"\x90\x9C" => "\xEB\xA7\x82",
		"\x90\x9D" => "\xEB\xA7\x83",
		"\x90\x9E" => "\xEB\xA7\x84",
		"\x90\x9F" => "\xEB\xA7\x85",
		"\x90\xA0" => "\xEB\xA7\x86",
		"\x90\xA1" => "\xEB\xA7\x87",
		"\x90\xA2" => "\xEB\xA7\x8A",
		"\x90\xA3" => "\xEB\xA7\x8B",
		"\x90\xA4" => "\xEB\xA7\x8D",
		"\x90\xA5" => "\xEB\xA7\x93",
		"\x90\xA6" => "\xEB\xA7\x94",
		"\x90\xA7" => "\xEB\xA7\x95",
		"\x90\xA8" => "\xEB\xA7\x96",
		"\x90\xA9" => "\xEB\xA7\x97",
		"\x90\xAA" => "\xEB\xA7\x9A",
		"\x90\xAB" => "\xEB\xA7\x9C",
		"\x90\xAC" => "\xEB\xA7\x9F",
		"\x90\xAD" => "\xEB\xA7\xA0",
		"\x90\xAE" => "\xEB\xA7\xA2",
		"\x90\xAF" => "\xEB\xA7\xA6",
		"\x90\xB0" => "\xEB\xA7\xA7",
		"\x90\xB1" => "\xEB\xA7\xA9",
		"\x90\xB2" => "\xEB\xA7\xAA",
		"\x90\xB3" => "\xEB\xA7\xAB",
		"\x90\xB4" => "\xEB\xA7\xAD",
		"\x90\xB5" => "\xEB\xA7\xAE",
		"\x90\xB6" => "\xEB\xA7\xAF",
		"\x90\xB7" => "\xEB\xA7\xB0",
		"\x90\xB8" => "\xEB\xA7\xB1",
		"\x90\xB9" => "\xEB\xA7\xB2",
		"\x90\xBA" => "\xEB\xA7\xB3",
		"\x90\xBB" => "\xEB\xA7\xB6",
		"\x90\xBC" => "\xEB\xA7\xBB",
		"\x90\xBD" => "\xEB\xA7\xBC",
		"\x90\xBE" => "\xEB\xA7\xBD",
		"\x90\xBF" => "\xEB\xA7\xBE",
		"\x90\xC0" => "\xEB\xA7\xBF",
		"\x90\xC1" => "\xEB\xA8\x82",
		"\x90\xC2" => "\xEB\xA8\x83",
		"\x90\xC3" => "\xEB\xA8\x84",
		"\x90\xC4" => "\xEB\xA8\x85",
		"\x90\xC5" => "\xEB\xA8\x86",
		"\x90\xC6" => "\xEB\xA8\x87",
		"\x90\xC7" => "\xEB\xA8\x89",
		"\x90\xC8" => "\xEB\xA8\x8A",
		"\x90\xC9" => "\xEB\xA8\x8B",
		"\x90\xCA" => "\xEB\xA8\x8C",
		"\x90\xCB" => "\xEB\xA8\x8D",
		"\x90\xCC" => "\xEB\xA8\x8E",
		"\x90\xCD" => "\xEB\xA8\x8F",
		"\x90\xCE" => "\xEB\xA8\x90",
		"\x90\xCF" => "\xEB\xA8\x91",
		"\x90\xD0" => "\xEB\xA8\x92",
		"\x90\xD1" => "\xEB\xA8\x93",
		"\x90\xD2" => "\xEB\xA8\x94",
		"\x90\xD3" => "\xEB\xA8\x96",
		"\x90\xD4" => "\xEB\xA8\x97",
		"\x90\xD5" => "\xEB\xA8\x98",
		"\x90\xD6" => "\xEB\xA8\x99",
		"\x90\xD7" => "\xEB\xA8\x9A",
		"\x90\xD8" => "\xEB\xA8\x9B",
		"\x90\xD9" => "\xEB\xA8\x9C",
		"\x90\xDA" => "\xEB\xA8\x9D",
		"\x90\xDB" => "\xEB\xA8\x9E",
		"\x90\xDC" => "\xEB\xA8\x9F",
		"\x90\xDD" => "\xEB\xA8\xA0",
		"\x90\xDE" => "\xEB\xA8\xA1",
		"\x90\xDF" => "\xEB\xA8\xA2",
		"\x90\xE0" => "\xEB\xA8\xA3",
		"\x90\xE1" => "\xEB\xA8\xA4",
		"\x90\xE2" => "\xEB\xA8\xA5",
		"\x90\xE3" => "\xEB\xA8\xA6",
		"\x90\xE4" => "\xEB\xA8\xA7",
		"\x90\xE5" => "\xEB\xA8\xA8",
		"\x90\xE6" => "\xEB\xA8\xA9",
		"\x90\xE7" => "\xEB\xA8\xAA",
		"\x90\xE8" => "\xEB\xA8\xAB",
		"\x90\xE9" => "\xEB\xA8\xAC",
		"\x90\xEA" => "\xEB\xA8\xAD",
		"\x90\xEB" => "\xEB\xA8\xAE",
		"\x90\xEC" => "\xEB\xA8\xAF",
		"\x90\xED" => "\xEB\xA8\xB0",
		"\x90\xEE" => "\xEB\xA8\xB1",
		"\x90\xEF" => "\xEB\xA8\xB2",
		"\x90\xF0" => "\xEB\xA8\xB3",
		"\x90\xF1" => "\xEB\xA8\xB4",
		"\x90\xF2" => "\xEB\xA8\xB5",
		"\x90\xF3" => "\xEB\xA8\xB6",
		"\x90\xF4" => "\xEB\xA8\xB7",
		"\x90\xF5" => "\xEB\xA8\xBA",
		"\x90\xF6" => "\xEB\xA8\xBB",
		"\x90\xF7" => "\xEB\xA8\xBD",
		"\x90\xF8" => "\xEB\xA8\xBE",
		"\x90\xF9" => "\xEB\xA8\xBF",
		"\x90\xFA" => "\xEB\xA9\x81",
		"\x90\xFB" => "\xEB\xA9\x83",
		"\x90\xFC" => "\xEB\xA9\x84",
		"\x90\xFD" => "\xEB\xA9\x85",
		"\x90\xFE" => "\xEB\xA9\x86",
		"\x91\x41" => "\xEB\xA9\x87",
		"\x91\x42" => "\xEB\xA9\x8A",
		"\x91\x43" => "\xEB\xA9\x8C",
		"\x91\x44" => "\xEB\xA9\x8F",
		"\x91\x45" => "\xEB\xA9\x90",
		"\x91\x46" => "\xEB\xA9\x91",
		"\x91\x47" => "\xEB\xA9\x92",
		"\x91\x48" => "\xEB\xA9\x96",
		"\x91\x49" => "\xEB\xA9\x97",
		"\x91\x4A" => "\xEB\xA9\x99",
		"\x91\x4B" => "\xEB\xA9\x9A",
		"\x91\x4C" => "\xEB\xA9\x9B",
		"\x91\x4D" => "\xEB\xA9\x9D",
		"\x91\x4E" => "\xEB\xA9\x9E",
		"\x91\x4F" => "\xEB\xA9\x9F",
		"\x91\x50" => "\xEB\xA9\xA0",
		"\x91\x51" => "\xEB\xA9\xA1",
		"\x91\x52" => "\xEB\xA9\xA2",
		"\x91\x53" => "\xEB\xA9\xA3",
		"\x91\x54" => "\xEB\xA9\xA6",
		"\x91\x55" => "\xEB\xA9\xAA",
		"\x91\x56" => "\xEB\xA9\xAB",
		"\x91\x57" => "\xEB\xA9\xAC",
		"\x91\x58" => "\xEB\xA9\xAD",
		"\x91\x59" => "\xEB\xA9\xAE",
		"\x91\x5A" => "\xEB\xA9\xAF",
		"\x91\x61" => "\xEB\xA9\xB2",
		"\x91\x62" => "\xEB\xA9\xB3",
		"\x91\x63" => "\xEB\xA9\xB5",
		"\x91\x64" => "\xEB\xA9\xB6",
		"\x91\x65" => "\xEB\xA9\xB7",
		"\x91\x66" => "\xEB\xA9\xB9",
		"\x91\x67" => "\xEB\xA9\xBA",
		"\x91\x68" => "\xEB\xA9\xBB",
		"\x91\x69" => "\xEB\xA9\xBC",
		"\x91\x6A" => "\xEB\xA9\xBD",
		"\x91\x6B" => "\xEB\xA9\xBE",
		"\x91\x6C" => "\xEB\xA9\xBF",
		"\x91\x6D" => "\xEB\xAA\x80",
		"\x91\x6E" => "\xEB\xAA\x81",
		"\x91\x6F" => "\xEB\xAA\x82",
		"\x91\x70" => "\xEB\xAA\x86",
		"\x91\x71" => "\xEB\xAA\x88",
		"\x91\x72" => "\xEB\xAA\x89",
		"\x91\x73" => "\xEB\xAA\x8A",
		"\x91\x74" => "\xEB\xAA\x8B",
		"\x91\x75" => "\xEB\xAA\x8D",
		"\x91\x76" => "\xEB\xAA\x8E",
		"\x91\x77" => "\xEB\xAA\x8F",
		"\x91\x78" => "\xEB\xAA\x90",
		"\x91\x79" => "\xEB\xAA\x91",
		"\x91\x7A" => "\xEB\xAA\x92",
		"\x91\x81" => "\xEB\xAA\x93",
		"\x91\x82" => "\xEB\xAA\x94",
		"\x91\x83" => "\xEB\xAA\x95",
		"\x91\x84" => "\xEB\xAA\x96",
		"\x91\x85" => "\xEB\xAA\x97",
		"\x91\x86" => "\xEB\xAA\x98",
		"\x91\x87" => "\xEB\xAA\x99",
		"\x91\x88" => "\xEB\xAA\x9A",
		"\x91\x89" => "\xEB\xAA\x9B",
		"\x91\x8A" => "\xEB\xAA\x9C",
		"\x91\x8B" => "\xEB\xAA\x9D",
		"\x91\x8C" => "\xEB\xAA\x9E",
		"\x91\x8D" => "\xEB\xAA\x9F",
		"\x91\x8E" => "\xEB\xAA\xA0",
		"\x91\x8F" => "\xEB\xAA\xA1",
		"\x91\x90" => "\xEB\xAA\xA2",
		"\x91\x91" => "\xEB\xAA\xA3",
		"\x91\x92" => "\xEB\xAA\xA4",
		"\x91\x93" => "\xEB\xAA\xA5",
		"\x91\x94" => "\xEB\xAA\xA6",
		"\x91\x95" => "\xEB\xAA\xA7",
		"\x91\x96" => "\xEB\xAA\xAA",
		"\x91\x97" => "\xEB\xAA\xAD",
		"\x91\x98" => "\xEB\xAA\xAE",
		"\x91\x99" => "\xEB\xAA\xAF",
		"\x91\x9A" => "\xEB\xAA\xB1",
		"\x91\x9B" => "\xEB\xAA\xB3",
		"\x91\x9C" => "\xEB\xAA\xB4",
		"\x91\x9D" => "\xEB\xAA\xB5",
		"\x91\x9E" => "\xEB\xAA\xB6",
		"\x91\x9F" => "\xEB\xAA\xB7",
		"\x91\xA0" => "\xEB\xAA\xBA",
		"\x91\xA1" => "\xEB\xAA\xBC",
		"\x91\xA2" => "\xEB\xAA\xBE",
		"\x91\xA3" => "\xEB\xAA\xBF",
		"\x91\xA4" => "\xEB\xAB\x80",
		"\x91\xA5" => "\xEB\xAB\x81",
		"\x91\xA6" => "\xEB\xAB\x82",
		"\x91\xA7" => "\xEB\xAB\x83",
		"\x91\xA8" => "\xEB\xAB\x85",
		"\x91\xA9" => "\xEB\xAB\x86",
		"\x91\xAA" => "\xEB\xAB\x87",
		"\x91\xAB" => "\xEB\xAB\x89",
		"\x91\xAC" => "\xEB\xAB\x8A",
		"\x91\xAD" => "\xEB\xAB\x8B",
		"\x91\xAE" => "\xEB\xAB\x8C",
		"\x91\xAF" => "\xEB\xAB\x8D",
		"\x91\xB0" => "\xEB\xAB\x8E",
		"\x91\xB1" => "\xEB\xAB\x8F",
		"\x91\xB2" => "\xEB\xAB\x90",
		"\x91\xB3" => "\xEB\xAB\x91",
		"\x91\xB4" => "\xEB\xAB\x92",
		"\x91\xB5" => "\xEB\xAB\x93",
		"\x91\xB6" => "\xEB\xAB\x94",
		"\x91\xB7" => "\xEB\xAB\x95",
		"\x91\xB8" => "\xEB\xAB\x96",
		"\x91\xB9" => "\xEB\xAB\x97",
		"\x91\xBA" => "\xEB\xAB\x9A",
		"\x91\xBB" => "\xEB\xAB\x9B",
		"\x91\xBC" => "\xEB\xAB\x9C",
		"\x91\xBD" => "\xEB\xAB\x9D",
		"\x91\xBE" => "\xEB\xAB\x9E",
		"\x91\xBF" => "\xEB\xAB\x9F",
		"\x91\xC0" => "\xEB\xAB\xA0",
		"\x91\xC1" => "\xEB\xAB\xA1",
		"\x91\xC2" => "\xEB\xAB\xA2",
		"\x91\xC3" => "\xEB\xAB\xA3",
		"\x91\xC4" => "\xEB\xAB\xA4",
		"\x91\xC5" => "\xEB\xAB\xA5",
		"\x91\xC6" => "\xEB\xAB\xA6",
		"\x91\xC7" => "\xEB\xAB\xA7",
		"\x91\xC8" => "\xEB\xAB\xA8",
		"\x91\xC9" => "\xEB\xAB\xA9",
		"\x91\xCA" => "\xEB\xAB\xAA",
		"\x91\xCB" => "\xEB\xAB\xAB",
		"\x91\xCC" => "\xEB\xAB\xAC",
		"\x91\xCD" => "\xEB\xAB\xAD",
		"\x91\xCE" => "\xEB\xAB\xAE",
		"\x91\xCF" => "\xEB\xAB\xAF",
		"\x91\xD0" => "\xEB\xAB\xB0",
		"\x91\xD1" => "\xEB\xAB\xB1",
		"\x91\xD2" => "\xEB\xAB\xB2",
		"\x91\xD3" => "\xEB\xAB\xB3",
		"\x91\xD4" => "\xEB\xAB\xB4",
		"\x91\xD5" => "\xEB\xAB\xB5",
		"\x91\xD6" => "\xEB\xAB\xB6",
		"\x91\xD7" => "\xEB\xAB\xB7",
		"\x91\xD8" => "\xEB\xAB\xB8",
		"\x91\xD9" => "\xEB\xAB\xB9",
		"\x91\xDA" => "\xEB\xAB\xBA",
		"\x91\xDB" => "\xEB\xAB\xBB",
		"\x91\xDC" => "\xEB\xAB\xBD",
		"\x91\xDD" => "\xEB\xAB\xBE",
		"\x91\xDE" => "\xEB\xAB\xBF",
		"\x91\xDF" => "\xEB\xAC\x81",
		"\x91\xE0" => "\xEB\xAC\x82",
		"\x91\xE1" => "\xEB\xAC\x83",
		"\x91\xE2" => "\xEB\xAC\x85",
		"\x91\xE3" => "\xEB\xAC\x86",
		"\x91\xE4" => "\xEB\xAC\x87",
		"\x91\xE5" => "\xEB\xAC\x88",
		"\x91\xE6" => "\xEB\xAC\x89",
		"\x91\xE7" => "\xEB\xAC\x8A",
		"\x91\xE8" => "\xEB\xAC\x8B",
		"\x91\xE9" => "\xEB\xAC\x8C",
		"\x91\xEA" => "\xEB\xAC\x8E",
		"\x91\xEB" => "\xEB\xAC\x90",
		"\x91\xEC" => "\xEB\xAC\x92",
		"\x91\xED" => "\xEB\xAC\x93",
		"\x91\xEE" => "\xEB\xAC\x94",
		"\x91\xEF" => "\xEB\xAC\x95",
		"\x91\xF0" => "\xEB\xAC\x96",
		"\x91\xF1" => "\xEB\xAC\x97",
		"\x91\xF2" => "\xEB\xAC\x99",
		"\x91\xF3" => "\xEB\xAC\x9A",
		"\x91\xF4" => "\xEB\xAC\x9B",
		"\x91\xF5" => "\xEB\xAC\x9D",
		"\x91\xF6" => "\xEB\xAC\x9E",
		"\x91\xF7" => "\xEB\xAC\x9F",
		"\x91\xF8" => "\xEB\xAC\xA1",
		"\x91\xF9" => "\xEB\xAC\xA2",
		"\x91\xFA" => "\xEB\xAC\xA3",
		"\x91\xFB" => "\xEB\xAC\xA4",
		"\x91\xFC" => "\xEB\xAC\xA5",
		"\x91\xFD" => "\xEB\xAC\xA6",
		"\x91\xFE" => "\xEB\xAC\xA7",
		"\x92\x41" => "\xEB\xAC\xA8",
		"\x92\x42" => "\xEB\xAC\xAA",
		"\x92\x43" => "\xEB\xAC\xAC",
		"\x92\x44" => "\xEB\xAC\xAD",
		"\x92\x45" => "\xEB\xAC\xAE",
		"\x92\x46" => "\xEB\xAC\xAF",
		"\x92\x47" => "\xEB\xAC\xB0",
		"\x92\x48" => "\xEB\xAC\xB1",
		"\x92\x49" => "\xEB\xAC\xB2",
		"\x92\x4A" => "\xEB\xAC\xB3",
		"\x92\x4B" => "\xEB\xAC\xB7",
		"\x92\x4C" => "\xEB\xAC\xB9",
		"\x92\x4D" => "\xEB\xAC\xBA",
		"\x92\x4E" => "\xEB\xAC\xBF",
		"\x92\x4F" => "\xEB\xAD\x80",
		"\x92\x50" => "\xEB\xAD\x81",
		"\x92\x51" => "\xEB\xAD\x82",
		"\x92\x52" => "\xEB\xAD\x83",
		"\x92\x53" => "\xEB\xAD\x86",
		"\x92\x54" => "\xEB\xAD\x88",
		"\x92\x55" => "\xEB\xAD\x8A",
		"\x92\x56" => "\xEB\xAD\x8B",
		"\x92\x57" => "\xEB\xAD\x8C",
		"\x92\x58" => "\xEB\xAD\x8E",
		"\x92\x59" => "\xEB\xAD\x91",
		"\x92\x5A" => "\xEB\xAD\x92",
		"\x92\x61" => "\xEB\xAD\x93",
		"\x92\x62" => "\xEB\xAD\x95",
		"\x92\x63" => "\xEB\xAD\x96",
		"\x92\x64" => "\xEB\xAD\x97",
		"\x92\x65" => "\xEB\xAD\x99",
		"\x92\x66" => "\xEB\xAD\x9A",
		"\x92\x67" => "\xEB\xAD\x9B",
		"\x92\x68" => "\xEB\xAD\x9C",
		"\x92\x69" => "\xEB\xAD\x9D",
		"\x92\x6A" => "\xEB\xAD\x9E",
		"\x92\x6B" => "\xEB\xAD\x9F",
		"\x92\x6C" => "\xEB\xAD\xA0",
		"\x92\x6D" => "\xEB\xAD\xA2",
		"\x92\x6E" => "\xEB\xAD\xA4",
		"\x92\x6F" => "\xEB\xAD\xA5",
		"\x92\x70" => "\xEB\xAD\xA6",
		"\x92\x71" => "\xEB\xAD\xA7",
		"\x92\x72" => "\xEB\xAD\xA8",
		"\x92\x73" => "\xEB\xAD\xA9",
		"\x92\x74" => "\xEB\xAD\xAA",
		"\x92\x75" => "\xEB\xAD\xAB",
		"\x92\x76" => "\xEB\xAD\xAD",
		"\x92\x77" => "\xEB\xAD\xAE",
		"\x92\x78" => "\xEB\xAD\xAF",
		"\x92\x79" => "\xEB\xAD\xB0",
		"\x92\x7A" => "\xEB\xAD\xB1",
		"\x92\x81" => "\xEB\xAD\xB2",
		"\x92\x82" => "\xEB\xAD\xB3",
		"\x92\x83" => "\xEB\xAD\xB4",
		"\x92\x84" => "\xEB\xAD\xB5",
		"\x92\x85" => "\xEB\xAD\xB6",
		"\x92\x86" => "\xEB\xAD\xB7",
		"\x92\x87" => "\xEB\xAD\xB8",
		"\x92\x88" => "\xEB\xAD\xB9",
		"\x92\x89" => "\xEB\xAD\xBA",
		"\x92\x8A" => "\xEB\xAD\xBB",
		"\x92\x8B" => "\xEB\xAD\xBC",
		"\x92\x8C" => "\xEB\xAD\xBD",
		"\x92\x8D" => "\xEB\xAD\xBE",
		"\x92\x8E" => "\xEB\xAD\xBF",
		"\x92\x8F" => "\xEB\xAE\x80",
		"\x92\x90" => "\xEB\xAE\x81",
		"\x92\x91" => "\xEB\xAE\x82",
		"\x92\x92" => "\xEB\xAE\x83",
		"\x92\x93" => "\xEB\xAE\x84",
		"\x92\x94" => "\xEB\xAE\x85",
		"\x92\x95" => "\xEB\xAE\x86",
		"\x92\x96" => "\xEB\xAE\x87",
		"\x92\x97" => "\xEB\xAE\x89",
		"\x92\x98" => "\xEB\xAE\x8A",
		"\x92\x99" => "\xEB\xAE\x8B",
		"\x92\x9A" => "\xEB\xAE\x8D",
		"\x92\x9B" => "\xEB\xAE\x8E",
		"\x92\x9C" => "\xEB\xAE\x8F",
		"\x92\x9D" => "\xEB\xAE\x91",
		"\x92\x9E" => "\xEB\xAE\x92",
		"\x92\x9F" => "\xEB\xAE\x93",
		"\x92\xA0" => "\xEB\xAE\x94",
		"\x92\xA1" => "\xEB\xAE\x95",
		"\x92\xA2" => "\xEB\xAE\x96",
		"\x92\xA3" => "\xEB\xAE\x97",
		"\x92\xA4" => "\xEB\xAE\x98",
		"\x92\xA5" => "\xEB\xAE\x99",
		"\x92\xA6" => "\xEB\xAE\x9A",
		"\x92\xA7" => "\xEB\xAE\x9B",
		"\x92\xA8" => "\xEB\xAE\x9C",
		"\x92\xA9" => "\xEB\xAE\x9D",
		"\x92\xAA" => "\xEB\xAE\x9E",
		"\x92\xAB" => "\xEB\xAE\x9F",
		"\x92\xAC" => "\xEB\xAE\xA0",
		"\x92\xAD" => "\xEB\xAE\xA1",
		"\x92\xAE" => "\xEB\xAE\xA2",
		"\x92\xAF" => "\xEB\xAE\xA3",
		"\x92\xB0" => "\xEB\xAE\xA5",
		"\x92\xB1" => "\xEB\xAE\xA6",
		"\x92\xB2" => "\xEB\xAE\xA7",
		"\x92\xB3" => "\xEB\xAE\xA9",
		"\x92\xB4" => "\xEB\xAE\xAA",
		"\x92\xB5" => "\xEB\xAE\xAB",
		"\x92\xB6" => "\xEB\xAE\xAD",
		"\x92\xB7" => "\xEB\xAE\xAE",
		"\x92\xB8" => "\xEB\xAE\xAF",
		"\x92\xB9" => "\xEB\xAE\xB0",
		"\x92\xBA" => "\xEB\xAE\xB1",
		"\x92\xBB" => "\xEB\xAE\xB2",
		"\x92\xBC" => "\xEB\xAE\xB3",
		"\x92\xBD" => "\xEB\xAE\xB5",
		"\x92\xBE" => "\xEB\xAE\xB6",
		"\x92\xBF" => "\xEB\xAE\xB8",
		"\x92\xC0" => "\xEB\xAE\xB9",
		"\x92\xC1" => "\xEB\xAE\xBA",
		"\x92\xC2" => "\xEB\xAE\xBB",
		"\x92\xC3" => "\xEB\xAE\xBC",
		"\x92\xC4" => "\xEB\xAE\xBD",
		"\x92\xC5" => "\xEB\xAE\xBE",
		"\x92\xC6" => "\xEB\xAE\xBF",
		"\x92\xC7" => "\xEB\xAF\x81",
		"\x92\xC8" => "\xEB\xAF\x82",
		"\x92\xC9" => "\xEB\xAF\x83",
		"\x92\xCA" => "\xEB\xAF\x85",
		"\x92\xCB" => "\xEB\xAF\x86",
		"\x92\xCC" => "\xEB\xAF\x87",
		"\x92\xCD" => "\xEB\xAF\x89",
		"\x92\xCE" => "\xEB\xAF\x8A",
		"\x92\xCF" => "\xEB\xAF\x8B",
		"\x92\xD0" => "\xEB\xAF\x8C",
		"\x92\xD1" => "\xEB\xAF\x8D",
		"\x92\xD2" => "\xEB\xAF\x8E",
		"\x92\xD3" => "\xEB\xAF\x8F",
		"\x92\xD4" => "\xEB\xAF\x91",
		"\x92\xD5" => "\xEB\xAF\x92",
		"\x92\xD6" => "\xEB\xAF\x94",
		"\x92\xD7" => "\xEB\xAF\x95",
		"\x92\xD8" => "\xEB\xAF\x96",
		"\x92\xD9" => "\xEB\xAF\x97",
		"\x92\xDA" => "\xEB\xAF\x98",
		"\x92\xDB" => "\xEB\xAF\x99",
		"\x92\xDC" => "\xEB\xAF\x9A",
		"\x92\xDD" => "\xEB\xAF\x9B",
		"\x92\xDE" => "\xEB\xAF\x9C",
		"\x92\xDF" => "\xEB\xAF\x9D",
		"\x92\xE0" => "\xEB\xAF\x9E",
		"\x92\xE1" => "\xEB\xAF\x9F",
		"\x92\xE2" => "\xEB\xAF\xA0",
		"\x92\xE3" => "\xEB\xAF\xA1",
		"\x92\xE4" => "\xEB\xAF\xA2",
		"\x92\xE5" => "\xEB\xAF\xA3",
		"\x92\xE6" => "\xEB\xAF\xA4",
		"\x92\xE7" => "\xEB\xAF\xA5",
		"\x92\xE8" => "\xEB\xAF\xA6",
		"\x92\xE9" => "\xEB\xAF\xA7",
		"\x92\xEA" => "\xEB\xAF\xA8",
		"\x92\xEB" => "\xEB\xAF\xA9",
		"\x92\xEC" => "\xEB\xAF\xAA",
		"\x92\xED" => "\xEB\xAF\xAB",
		"\x92\xEE" => "\xEB\xAF\xAC",
		"\x92\xEF" => "\xEB\xAF\xAD",
		"\x92\xF0" => "\xEB\xAF\xAE",
		"\x92\xF1" => "\xEB\xAF\xAF",
		"\x92\xF2" => "\xEB\xAF\xB0",
		"\x92\xF3" => "\xEB\xAF\xB1",
		"\x92\xF4" => "\xEB\xAF\xB2",
		"\x92\xF5" => "\xEB\xAF\xB3",
		"\x92\xF6" => "\xEB\xAF\xB4",
		"\x92\xF7" => "\xEB\xAF\xB5",
		"\x92\xF8" => "\xEB\xAF\xB6",
		"\x92\xF9" => "\xEB\xAF\xB7",
		"\x92\xFA" => "\xEB\xAF\xBA",
		"\x92\xFB" => "\xEB\xAF\xBB",
		"\x92\xFC" => "\xEB\xAF\xBD",
		"\x92\xFD" => "\xEB\xAF\xBE",
		"\x92\xFE" => "\xEB\xB0\x81",
		"\x93\x41" => "\xEB\xB0\x83",
		"\x93\x42" => "\xEB\xB0\x84",
		"\x93\x43" => "\xEB\xB0\x85",
		"\x93\x44" => "\xEB\xB0\x86",
		"\x93\x45" => "\xEB\xB0\x87",
		"\x93\x46" => "\xEB\xB0\x8A",
		"\x93\x47" => "\xEB\xB0\x8E",
		"\x93\x48" => "\xEB\xB0\x90",
		"\x93\x49" => "\xEB\xB0\x92",
		"\x93\x4A" => "\xEB\xB0\x93",
		"\x93\x4B" => "\xEB\xB0\x99",
		"\x93\x4C" => "\xEB\xB0\x9A",
		"\x93\x4D" => "\xEB\xB0\xA0",
		"\x93\x4E" => "\xEB\xB0\xA1",
		"\x93\x4F" => "\xEB\xB0\xA2",
		"\x93\x50" => "\xEB\xB0\xA3",
		"\x93\x51" => "\xEB\xB0\xA6",
		"\x93\x52" => "\xEB\xB0\xA8",
		"\x93\x53" => "\xEB\xB0\xAA",
		"\x93\x54" => "\xEB\xB0\xAB",
		"\x93\x55" => "\xEB\xB0\xAC",
		"\x93\x56" => "\xEB\xB0\xAE",
		"\x93\x57" => "\xEB\xB0\xAF",
		"\x93\x58" => "\xEB\xB0\xB2",
		"\x93\x59" => "\xEB\xB0\xB3",
		"\x93\x5A" => "\xEB\xB0\xB5",
		"\x93\x61" => "\xEB\xB0\xB6",
		"\x93\x62" => "\xEB\xB0\xB7",
		"\x93\x63" => "\xEB\xB0\xB9",
		"\x93\x64" => "\xEB\xB0\xBA",
		"\x93\x65" => "\xEB\xB0\xBB",
		"\x93\x66" => "\xEB\xB0\xBC",
		"\x93\x67" => "\xEB\xB0\xBD",
		"\x93\x68" => "\xEB\xB0\xBE",
		"\x93\x69" => "\xEB\xB0\xBF",
		"\x93\x6A" => "\xEB\xB1\x82",
		"\x93\x6B" => "\xEB\xB1\x86",
		"\x93\x6C" => "\xEB\xB1\x87",
		"\x93\x6D" => "\xEB\xB1\x88",
		"\x93\x6E" => "\xEB\xB1\x8A",
		"\x93\x6F" => "\xEB\xB1\x8B",
		"\x93\x70" => "\xEB\xB1\x8E",
		"\x93\x71" => "\xEB\xB1\x8F",
		"\x93\x72" => "\xEB\xB1\x91",
		"\x93\x73" => "\xEB\xB1\x92",
		"\x93\x74" => "\xEB\xB1\x93",
		"\x93\x75" => "\xEB\xB1\x94",
		"\x93\x76" => "\xEB\xB1\x95",
		"\x93\x77" => "\xEB\xB1\x96",
		"\x93\x78" => "\xEB\xB1\x97",
		"\x93\x79" => "\xEB\xB1\x98",
		"\x93\x7A" => "\xEB\xB1\x99",
		"\x93\x81" => "\xEB\xB1\x9A",
		"\x93\x82" => "\xEB\xB1\x9B",
		"\x93\x83" => "\xEB\xB1\x9C",
		"\x93\x84" => "\xEB\xB1\x9E",
		"\x93\x85" => "\xEB\xB1\x9F",
		"\x93\x86" => "\xEB\xB1\xA0",
		"\x93\x87" => "\xEB\xB1\xA1",
		"\x93\x88" => "\xEB\xB1\xA2",
		"\x93\x89" => "\xEB\xB1\xA3",
		"\x93\x8A" => "\xEB\xB1\xA4",
		"\x93\x8B" => "\xEB\xB1\xA5",
		"\x93\x8C" => "\xEB\xB1\xA6",
		"\x93\x8D" => "\xEB\xB1\xA7",
		"\x93\x8E" => "\xEB\xB1\xA8",
		"\x93\x8F" => "\xEB\xB1\xA9",
		"\x93\x90" => "\xEB\xB1\xAA",
		"\x93\x91" => "\xEB\xB1\xAB",
		"\x93\x92" => "\xEB\xB1\xAC",
		"\x93\x93" => "\xEB\xB1\xAD",
		"\x93\x94" => "\xEB\xB1\xAE",
		"\x93\x95" => "\xEB\xB1\xAF",
		"\x93\x96" => "\xEB\xB1\xB0",
		"\x93\x97" => "\xEB\xB1\xB1",
		"\x93\x98" => "\xEB\xB1\xB2",
		"\x93\x99" => "\xEB\xB1\xB3",
		"\x93\x9A" => "\xEB\xB1\xB4",
		"\x93\x9B" => "\xEB\xB1\xB5",
		"\x93\x9C" => "\xEB\xB1\xB6",
		"\x93\x9D" => "\xEB\xB1\xB7",
		"\x93\x9E" => "\xEB\xB1\xB8",
		"\x93\x9F" => "\xEB\xB1\xB9",
		"\x93\xA0" => "\xEB\xB1\xBA",
		"\x93\xA1" => "\xEB\xB1\xBB",
		"\x93\xA2" => "\xEB\xB1\xBC",
		"\x93\xA3" => "\xEB\xB1\xBD",
		"\x93\xA4" => "\xEB\xB1\xBE",
		"\x93\xA5" => "\xEB\xB1\xBF",
		"\x93\xA6" => "\xEB\xB2\x80",
		"\x93\xA7" => "\xEB\xB2\x81",
		"\x93\xA8" => "\xEB\xB2\x82",
		"\x93\xA9" => "\xEB\xB2\x83",
		"\x93\xAA" => "\xEB\xB2\x86",
		"\x93\xAB" => "\xEB\xB2\x87",
		"\x93\xAC" => "\xEB\xB2\x89",
		"\x93\xAD" => "\xEB\xB2\x8A",
		"\x93\xAE" => "\xEB\xB2\x8D",
		"\x93\xAF" => "\xEB\xB2\x8F",
		"\x93\xB0" => "\xEB\xB2\x90",
		"\x93\xB1" => "\xEB\xB2\x91",
		"\x93\xB2" => "\xEB\xB2\x92",
		"\x93\xB3" => "\xEB\xB2\x93",
		"\x93\xB4" => "\xEB\xB2\x96",
		"\x93\xB5" => "\xEB\xB2\x98",
		"\x93\xB6" => "\xEB\xB2\x9B",
		"\x93\xB7" => "\xEB\xB2\x9C",
		"\x93\xB8" => "\xEB\xB2\x9D",
		"\x93\xB9" => "\xEB\xB2\x9E",
		"\x93\xBA" => "\xEB\xB2\x9F",
		"\x93\xBB" => "\xEB\xB2\xA2",
		"\x93\xBC" => "\xEB\xB2\xA3",
		"\x93\xBD" => "\xEB\xB2\xA5",
		"\x93\xBE" => "\xEB\xB2\xA6",
		"\x93\xBF" => "\xEB\xB2\xA9",
		"\x93\xC0" => "\xEB\xB2\xAA",
		"\x93\xC1" => "\xEB\xB2\xAB",
		"\x93\xC2" => "\xEB\xB2\xAC",
		"\x93\xC3" => "\xEB\xB2\xAD",
		"\x93\xC4" => "\xEB\xB2\xAE",
		"\x93\xC5" => "\xEB\xB2\xAF",
		"\x93\xC6" => "\xEB\xB2\xB2",
		"\x93\xC7" => "\xEB\xB2\xB6",
		"\x93\xC8" => "\xEB\xB2\xB7",
		"\x93\xC9" => "\xEB\xB2\xB8",
		"\x93\xCA" => "\xEB\xB2\xB9",
		"\x93\xCB" => "\xEB\xB2\xBA",
		"\x93\xCC" => "\xEB\xB2\xBB",
		"\x93\xCD" => "\xEB\xB2\xBE",
		"\x93\xCE" => "\xEB\xB2\xBF",
		"\x93\xCF" => "\xEB\xB3\x81",
		"\x93\xD0" => "\xEB\xB3\x82",
		"\x93\xD1" => "\xEB\xB3\x83",
		"\x93\xD2" => "\xEB\xB3\x85",
		"\x93\xD3" => "\xEB\xB3\x86",
		"\x93\xD4" => "\xEB\xB3\x87",
		"\x93\xD5" => "\xEB\xB3\x88",
		"\x93\xD6" => "\xEB\xB3\x89",
		"\x93\xD7" => "\xEB\xB3\x8A",
		"\x93\xD8" => "\xEB\xB3\x8B",
		"\x93\xD9" => "\xEB\xB3\x8C",
		"\x93\xDA" => "\xEB\xB3\x8E",
		"\x93\xDB" => "\xEB\xB3\x92",
		"\x93\xDC" => "\xEB\xB3\x93",
		"\x93\xDD" => "\xEB\xB3\x94",
		"\x93\xDE" => "\xEB\xB3\x96",
		"\x93\xDF" => "\xEB\xB3\x97",
		"\x93\xE0" => "\xEB\xB3\x99",
		"\x93\xE1" => "\xEB\xB3\x9A",
		"\x93\xE2" => "\xEB\xB3\x9B",
		"\x93\xE3" => "\xEB\xB3\x9D",
		"\x93\xE4" => "\xEB\xB3\x9E",
		"\x93\xE5" => "\xEB\xB3\x9F",
		"\x93\xE6" => "\xEB\xB3\xA0",
		"\x93\xE7" => "\xEB\xB3\xA1",
		"\x93\xE8" => "\xEB\xB3\xA2",
		"\x93\xE9" => "\xEB\xB3\xA3",
		"\x93\xEA" => "\xEB\xB3\xA4",
		"\x93\xEB" => "\xEB\xB3\xA5",
		"\x93\xEC" => "\xEB\xB3\xA6",
		"\x93\xED" => "\xEB\xB3\xA7",
		"\x93\xEE" => "\xEB\xB3\xA8",
		"\x93\xEF" => "\xEB\xB3\xA9",
		"\x93\xF0" => "\xEB\xB3\xAA",
		"\x93\xF1" => "\xEB\xB3\xAB",
		"\x93\xF2" => "\xEB\xB3\xAC",
		"\x93\xF3" => "\xEB\xB3\xAD",
		"\x93\xF4" => "\xEB\xB3\xAE",
		"\x93\xF5" => "\xEB\xB3\xAF",
		"\x93\xF6" => "\xEB\xB3\xB0",
		"\x93\xF7" => "\xEB\xB3\xB1",
		"\x93\xF8" => "\xEB\xB3\xB2",
		"\x93\xF9" => "\xEB\xB3\xB3",
		"\x93\xFA" => "\xEB\xB3\xB7",
		"\x93\xFB" => "\xEB\xB3\xB9",
		"\x93\xFC" => "\xEB\xB3\xBA",
		"\x93\xFD" => "\xEB\xB3\xBB",
		"\x93\xFE" => "\xEB\xB3\xBD",
		"\x94\x41" => "\xEB\xB3\xBE",
		"\x94\x42" => "\xEB\xB3\xBF",
		"\x94\x43" => "\xEB\xB4\x80",
		"\x94\x44" => "\xEB\xB4\x81",
		"\x94\x45" => "\xEB\xB4\x82",
		"\x94\x46" => "\xEB\xB4\x83",
		"\x94\x47" => "\xEB\xB4\x86",
		"\x94\x48" => "\xEB\xB4\x88",
		"\x94\x49" => "\xEB\xB4\x8A",
		"\x94\x4A" => "\xEB\xB4\x8B",
		"\x94\x4B" => "\xEB\xB4\x8C",
		"\x94\x4C" => "\xEB\xB4\x8D",
		"\x94\x4D" => "\xEB\xB4\x8E",
		"\x94\x4E" => "\xEB\xB4\x8F",
		"\x94\x4F" => "\xEB\xB4\x91",
		"\x94\x50" => "\xEB\xB4\x92",
		"\x94\x51" => "\xEB\xB4\x93",
		"\x94\x52" => "\xEB\xB4\x95",
		"\x94\x53" => "\xEB\xB4\x96",
		"\x94\x54" => "\xEB\xB4\x97",
		"\x94\x55" => "\xEB\xB4\x98",
		"\x94\x56" => "\xEB\xB4\x99",
		"\x94\x57" => "\xEB\xB4\x9A",
		"\x94\x58" => "\xEB\xB4\x9B",
		"\x94\x59" => "\xEB\xB4\x9C",
		"\x94\x5A" => "\xEB\xB4\x9D",
		"\x94\x61" => "\xEB\xB4\x9E",
		"\x94\x62" => "\xEB\xB4\x9F",
		"\x94\x63" => "\xEB\xB4\xA0",
		"\x94\x64" => "\xEB\xB4\xA1",
		"\x94\x65" => "\xEB\xB4\xA2",
		"\x94\x66" => "\xEB\xB4\xA3",
		"\x94\x67" => "\xEB\xB4\xA5",
		"\x94\x68" => "\xEB\xB4\xA6",
		"\x94\x69" => "\xEB\xB4\xA7",
		"\x94\x6A" => "\xEB\xB4\xA8",
		"\x94\x6B" => "\xEB\xB4\xA9",
		"\x94\x6C" => "\xEB\xB4\xAA",
		"\x94\x6D" => "\xEB\xB4\xAB",
		"\x94\x6E" => "\xEB\xB4\xAD",
		"\x94\x6F" => "\xEB\xB4\xAE",
		"\x94\x70" => "\xEB\xB4\xAF",
		"\x94\x71" => "\xEB\xB4\xB0",
		"\x94\x72" => "\xEB\xB4\xB1",
		"\x94\x73" => "\xEB\xB4\xB2",
		"\x94\x74" => "\xEB\xB4\xB3",
		"\x94\x75" => "\xEB\xB4\xB4",
		"\x94\x76" => "\xEB\xB4\xB5",
		"\x94\x77" => "\xEB\xB4\xB6",
		"\x94\x78" => "\xEB\xB4\xB7",
		"\x94\x79" => "\xEB\xB4\xB8",
		"\x94\x7A" => "\xEB\xB4\xB9",
		"\x94\x81" => "\xEB\xB4\xBA",
		"\x94\x82" => "\xEB\xB4\xBB",
		"\x94\x83" => "\xEB\xB4\xBC",
		"\x94\x84" => "\xEB\xB4\xBD",
		"\x94\x85" => "\xEB\xB4\xBE",
		"\x94\x86" => "\xEB\xB4\xBF",
		"\x94\x87" => "\xEB\xB5\x81",
		"\x94\x88" => "\xEB\xB5\x82",
		"\x94\x89" => "\xEB\xB5\x83",
		"\x94\x8A" => "\xEB\xB5\x84",
		"\x94\x8B" => "\xEB\xB5\x85",
		"\x94\x8C" => "\xEB\xB5\x86",
		"\x94\x8D" => "\xEB\xB5\x87",
		"\x94\x8E" => "\xEB\xB5\x8A",
		"\x94\x8F" => "\xEB\xB5\x8B",
		"\x94\x90" => "\xEB\xB5\x8D",
		"\x94\x91" => "\xEB\xB5\x8E",
		"\x94\x92" => "\xEB\xB5\x8F",
		"\x94\x93" => "\xEB\xB5\x91",
		"\x94\x94" => "\xEB\xB5\x92",
		"\x94\x95" => "\xEB\xB5\x93",
		"\x94\x96" => "\xEB\xB5\x94",
		"\x94\x97" => "\xEB\xB5\x95",
		"\x94\x98" => "\xEB\xB5\x96",
		"\x94\x99" => "\xEB\xB5\x97",
		"\x94\x9A" => "\xEB\xB5\x9A",
		"\x94\x9B" => "\xEB\xB5\x9B",
		"\x94\x9C" => "\xEB\xB5\x9C",
		"\x94\x9D" => "\xEB\xB5\x9D",
		"\x94\x9E" => "\xEB\xB5\x9E",
		"\x94\x9F" => "\xEB\xB5\x9F",
		"\x94\xA0" => "\xEB\xB5\xA0",
		"\x94\xA1" => "\xEB\xB5\xA1",
		"\x94\xA2" => "\xEB\xB5\xA2",
		"\x94\xA3" => "\xEB\xB5\xA3",
		"\x94\xA4" => "\xEB\xB5\xA5",
		"\x94\xA5" => "\xEB\xB5\xA6",
		"\x94\xA6" => "\xEB\xB5\xA7",
		"\x94\xA7" => "\xEB\xB5\xA9",
		"\x94\xA8" => "\xEB\xB5\xAA",
		"\x94\xA9" => "\xEB\xB5\xAB",
		"\x94\xAA" => "\xEB\xB5\xAC",
		"\x94\xAB" => "\xEB\xB5\xAD",
		"\x94\xAC" => "\xEB\xB5\xAE",
		"\x94\xAD" => "\xEB\xB5\xAF",
		"\x94\xAE" => "\xEB\xB5\xB0",
		"\x94\xAF" => "\xEB\xB5\xB1",
		"\x94\xB0" => "\xEB\xB5\xB2",
		"\x94\xB1" => "\xEB\xB5\xB3",
		"\x94\xB2" => "\xEB\xB5\xB4",
		"\x94\xB3" => "\xEB\xB5\xB5",
		"\x94\xB4" => "\xEB\xB5\xB6",
		"\x94\xB5" => "\xEB\xB5\xB7",
		"\x94\xB6" => "\xEB\xB5\xB8",
		"\x94\xB7" => "\xEB\xB5\xB9",
		"\x94\xB8" => "\xEB\xB5\xBA",
		"\x94\xB9" => "\xEB\xB5\xBB",
		"\x94\xBA" => "\xEB\xB5\xBC",
		"\x94\xBB" => "\xEB\xB5\xBD",
		"\x94\xBC" => "\xEB\xB5\xBE",
		"\x94\xBD" => "\xEB\xB5\xBF",
		"\x94\xBE" => "\xEB\xB6\x82",
		"\x94\xBF" => "\xEB\xB6\x83",
		"\x94\xC0" => "\xEB\xB6\x85",
		"\x94\xC1" => "\xEB\xB6\x86",
		"\x94\xC2" => "\xEB\xB6\x8B",
		"\x94\xC3" => "\xEB\xB6\x8C",
		"\x94\xC4" => "\xEB\xB6\x8D",
		"\x94\xC5" => "\xEB\xB6\x8E",
		"\x94\xC6" => "\xEB\xB6\x8F",
		"\x94\xC7" => "\xEB\xB6\x92",
		"\x94\xC8" => "\xEB\xB6\x94",
		"\x94\xC9" => "\xEB\xB6\x96",
		"\x94\xCA" => "\xEB\xB6\x97",
		"\x94\xCB" => "\xEB\xB6\x98",
		"\x94\xCC" => "\xEB\xB6\x9B",
		"\x94\xCD" => "\xEB\xB6\x9D",
		"\x94\xCE" => "\xEB\xB6\x9E",
		"\x94\xCF" => "\xEB\xB6\x9F",
		"\x94\xD0" => "\xEB\xB6\xA0",
		"\x94\xD1" => "\xEB\xB6\xA1",
		"\x94\xD2" => "\xEB\xB6\xA2",
		"\x94\xD3" => "\xEB\xB6\xA3",
		"\x94\xD4" => "\xEB\xB6\xA5",
		"\x94\xD5" => "\xEB\xB6\xA6",
		"\x94\xD6" => "\xEB\xB6\xA7",
		"\x94\xD7" => "\xEB\xB6\xA8",
		"\x94\xD8" => "\xEB\xB6\xA9",
		"\x94\xD9" => "\xEB\xB6\xAA",
		"\x94\xDA" => "\xEB\xB6\xAB",
		"\x94\xDB" => "\xEB\xB6\xAC",
		"\x94\xDC" => "\xEB\xB6\xAD",
		"\x94\xDD" => "\xEB\xB6\xAE",
		"\x94\xDE" => "\xEB\xB6\xAF",
		"\x94\xDF" => "\xEB\xB6\xB1",
		"\x94\xE0" => "\xEB\xB6\xB2",
		"\x94\xE1" => "\xEB\xB6\xB3",
		"\x94\xE2" => "\xEB\xB6\xB4",
		"\x94\xE3" => "\xEB\xB6\xB5",
		"\x94\xE4" => "\xEB\xB6\xB6",
		"\x94\xE5" => "\xEB\xB6\xB7",
		"\x94\xE6" => "\xEB\xB6\xB9",
		"\x94\xE7" => "\xEB\xB6\xBA",
		"\x94\xE8" => "\xEB\xB6\xBB",
		"\x94\xE9" => "\xEB\xB6\xBC",
		"\x94\xEA" => "\xEB\xB6\xBD",
		"\x94\xEB" => "\xEB\xB6\xBE",
		"\x94\xEC" => "\xEB\xB6\xBF",
		"\x94\xED" => "\xEB\xB7\x80",
		"\x94\xEE" => "\xEB\xB7\x81",
		"\x94\xEF" => "\xEB\xB7\x82",
		"\x94\xF0" => "\xEB\xB7\x83",
		"\x94\xF1" => "\xEB\xB7\x84",
		"\x94\xF2" => "\xEB\xB7\x85",
		"\x94\xF3" => "\xEB\xB7\x86",
		"\x94\xF4" => "\xEB\xB7\x87",
		"\x94\xF5" => "\xEB\xB7\x88",
		"\x94\xF6" => "\xEB\xB7\x89",
		"\x94\xF7" => "\xEB\xB7\x8A",
		"\x94\xF8" => "\xEB\xB7\x8B",
		"\x94\xF9" => "\xEB\xB7\x8C",
		"\x94\xFA" => "\xEB\xB7\x8D",
		"\x94\xFB" => "\xEB\xB7\x8E",
		"\x94\xFC" => "\xEB\xB7\x8F",
		"\x94\xFD" => "\xEB\xB7\x90",
		"\x94\xFE" => "\xEB\xB7\x91",
		"\x95\x41" => "\xEB\xB7\x92",
		"\x95\x42" => "\xEB\xB7\x93",
		"\x95\x43" => "\xEB\xB7\x96",
		"\x95\x44" => "\xEB\xB7\x97",
		"\x95\x45" => "\xEB\xB7\x99",
		"\x95\x46" => "\xEB\xB7\x9A",
		"\x95\x47" => "\xEB\xB7\x9B",
		"\x95\x48" => "\xEB\xB7\x9D",
		"\x95\x49" => "\xEB\xB7\x9E",
		"\x95\x4A" => "\xEB\xB7\x9F",
		"\x95\x4B" => "\xEB\xB7\xA0",
		"\x95\x4C" => "\xEB\xB7\xA1",
		"\x95\x4D" => "\xEB\xB7\xA2",
		"\x95\x4E" => "\xEB\xB7\xA3",
		"\x95\x4F" => "\xEB\xB7\xA4",
		"\x95\x50" => "\xEB\xB7\xA5",
		"\x95\x51" => "\xEB\xB7\xA6",
		"\x95\x52" => "\xEB\xB7\xA7",
		"\x95\x53" => "\xEB\xB7\xA8",
		"\x95\x54" => "\xEB\xB7\xAA",
		"\x95\x55" => "\xEB\xB7\xAB",
		"\x95\x56" => "\xEB\xB7\xAC",
		"\x95\x57" => "\xEB\xB7\xAD",
		"\x95\x58" => "\xEB\xB7\xAE",
		"\x95\x59" => "\xEB\xB7\xAF",
		"\x95\x5A" => "\xEB\xB7\xB1",
		"\x95\x61" => "\xEB\xB7\xB2",
		"\x95\x62" => "\xEB\xB7\xB3",
		"\x95\x63" => "\xEB\xB7\xB5",
		"\x95\x64" => "\xEB\xB7\xB6",
		"\x95\x65" => "\xEB\xB7\xB7",
		"\x95\x66" => "\xEB\xB7\xB9",
		"\x95\x67" => "\xEB\xB7\xBA",
		"\x95\x68" => "\xEB\xB7\xBB",
		"\x95\x69" => "\xEB\xB7\xBC",
		"\x95\x6A" => "\xEB\xB7\xBD",
		"\x95\x6B" => "\xEB\xB7\xBE",
		"\x95\x6C" => "\xEB\xB7\xBF",
		"\x95\x6D" => "\xEB\xB8\x81",
		"\x95\x6E" => "\xEB\xB8\x82",
		"\x95\x6F" => "\xEB\xB8\x84",
		"\x95\x70" => "\xEB\xB8\x86",
		"\x95\x71" => "\xEB\xB8\x87",
		"\x95\x72" => "\xEB\xB8\x88",
		"\x95\x73" => "\xEB\xB8\x89",
		"\x95\x74" => "\xEB\xB8\x8A",
		"\x95\x75" => "\xEB\xB8\x8B",
		"\x95\x76" => "\xEB\xB8\x8E",
		"\x95\x77" => "\xEB\xB8\x8F",
		"\x95\x78" => "\xEB\xB8\x91",
		"\x95\x79" => "\xEB\xB8\x92",
		"\x95\x7A" => "\xEB\xB8\x93",
		"\x95\x81" => "\xEB\xB8\x95",
		"\x95\x82" => "\xEB\xB8\x96",
		"\x95\x83" => "\xEB\xB8\x97",
		"\x95\x84" => "\xEB\xB8\x98",
		"\x95\x85" => "\xEB\xB8\x99",
		"\x95\x86" => "\xEB\xB8\x9A",
		"\x95\x87" => "\xEB\xB8\x9B",
		"\x95\x88" => "\xEB\xB8\x9E",
		"\x95\x89" => "\xEB\xB8\xA0",
		"\x95\x8A" => "\xEB\xB8\xA1",
		"\x95\x8B" => "\xEB\xB8\xA2",
		"\x95\x8C" => "\xEB\xB8\xA3",
		"\x95\x8D" => "\xEB\xB8\xA4",
		"\x95\x8E" => "\xEB\xB8\xA5",
		"\x95\x8F" => "\xEB\xB8\xA6",
		"\x95\x90" => "\xEB\xB8\xA7",
		"\x95\x91" => "\xEB\xB8\xA8",
		"\x95\x92" => "\xEB\xB8\xA9",
		"\x95\x93" => "\xEB\xB8\xAA",
		"\x95\x94" => "\xEB\xB8\xAB",
		"\x95\x95" => "\xEB\xB8\xAC",
		"\x95\x96" => "\xEB\xB8\xAD",
		"\x95\x97" => "\xEB\xB8\xAE",
		"\x95\x98" => "\xEB\xB8\xAF",
		"\x95\x99" => "\xEB\xB8\xB0",
		"\x95\x9A" => "\xEB\xB8\xB1",
		"\x95\x9B" => "\xEB\xB8\xB2",
		"\x95\x9C" => "\xEB\xB8\xB3",
		"\x95\x9D" => "\xEB\xB8\xB4",
		"\x95\x9E" => "\xEB\xB8\xB5",
		"\x95\x9F" => "\xEB\xB8\xB6",
		"\x95\xA0" => "\xEB\xB8\xB7",
		"\x95\xA1" => "\xEB\xB8\xB8",
		"\x95\xA2" => "\xEB\xB8\xB9",
		"\x95\xA3" => "\xEB\xB8\xBA",
		"\x95\xA4" => "\xEB\xB8\xBB",
		"\x95\xA5" => "\xEB\xB8\xBC",
		"\x95\xA6" => "\xEB\xB8\xBD",
		"\x95\xA7" => "\xEB\xB8\xBE",
		"\x95\xA8" => "\xEB\xB8\xBF",
		"\x95\xA9" => "\xEB\xB9\x80",
		"\x95\xAA" => "\xEB\xB9\x81",
		"\x95\xAB" => "\xEB\xB9\x82",
		"\x95\xAC" => "\xEB\xB9\x83",
		"\x95\xAD" => "\xEB\xB9\x86",
		"\x95\xAE" => "\xEB\xB9\x87",
		"\x95\xAF" => "\xEB\xB9\x89",
		"\x95\xB0" => "\xEB\xB9\x8A",
		"\x95\xB1" => "\xEB\xB9\x8B",
		"\x95\xB2" => "\xEB\xB9\x8D",
		"\x95\xB3" => "\xEB\xB9\x8F",
		"\x95\xB4" => "\xEB\xB9\x90",
		"\x95\xB5" => "\xEB\xB9\x91",
		"\x95\xB6" => "\xEB\xB9\x92",
		"\x95\xB7" => "\xEB\xB9\x93",
		"\x95\xB8" => "\xEB\xB9\x96",
		"\x95\xB9" => "\xEB\xB9\x98",
		"\x95\xBA" => "\xEB\xB9\x9C",
		"\x95\xBB" => "\xEB\xB9\x9D",
		"\x95\xBC" => "\xEB\xB9\x9E",
		"\x95\xBD" => "\xEB\xB9\x9F",
		"\x95\xBE" => "\xEB\xB9\xA2",
		"\x95\xBF" => "\xEB\xB9\xA3",
		"\x95\xC0" => "\xEB\xB9\xA5",
		"\x95\xC1" => "\xEB\xB9\xA6",
		"\x95\xC2" => "\xEB\xB9\xA7",
		"\x95\xC3" => "\xEB\xB9\xA9",
		"\x95\xC4" => "\xEB\xB9\xAB",
		"\x95\xC5" => "\xEB\xB9\xAC",
		"\x95\xC6" => "\xEB\xB9\xAD",
		"\x95\xC7" => "\xEB\xB9\xAE",
		"\x95\xC8" => "\xEB\xB9\xAF",
		"\x95\xC9" => "\xEB\xB9\xB2",
		"\x95\xCA" => "\xEB\xB9\xB6",
		"\x95\xCB" => "\xEB\xB9\xB7",
		"\x95\xCC" => "\xEB\xB9\xB8",
		"\x95\xCD" => "\xEB\xB9\xB9",
		"\x95\xCE" => "\xEB\xB9\xBA",
		"\x95\xCF" => "\xEB\xB9\xBE",
		"\x95\xD0" => "\xEB\xB9\xBF",
		"\x95\xD1" => "\xEB\xBA\x81",
		"\x95\xD2" => "\xEB\xBA\x82",
		"\x95\xD3" => "\xEB\xBA\x83",
		"\x95\xD4" => "\xEB\xBA\x85",
		"\x95\xD5" => "\xEB\xBA\x86",
		"\x95\xD6" => "\xEB\xBA\x87",
		"\x95\xD7" => "\xEB\xBA\x88",
		"\x95\xD8" => "\xEB\xBA\x89",
		"\x95\xD9" => "\xEB\xBA\x8A",
		"\x95\xDA" => "\xEB\xBA\x8B",
		"\x95\xDB" => "\xEB\xBA\x8E",
		"\x95\xDC" => "\xEB\xBA\x92",
		"\x95\xDD" => "\xEB\xBA\x93",
		"\x95\xDE" => "\xEB\xBA\x94",
		"\x95\xDF" => "\xEB\xBA\x95",
		"\x95\xE0" => "\xEB\xBA\x96",
		"\x95\xE1" => "\xEB\xBA\x97",
		"\x95\xE2" => "\xEB\xBA\x9A",
		"\x95\xE3" => "\xEB\xBA\x9B",
		"\x95\xE4" => "\xEB\xBA\x9C",
		"\x95\xE5" => "\xEB\xBA\x9D",
		"\x95\xE6" => "\xEB\xBA\x9E",
		"\x95\xE7" => "\xEB\xBA\x9F",
		"\x95\xE8" => "\xEB\xBA\xA0",
		"\x95\xE9" => "\xEB\xBA\xA1",
		"\x95\xEA" => "\xEB\xBA\xA2",
		"\x95\xEB" => "\xEB\xBA\xA3",
		"\x95\xEC" => "\xEB\xBA\xA4",
		"\x95\xED" => "\xEB\xBA\xA5",
		"\x95\xEE" => "\xEB\xBA\xA6",
		"\x95\xEF" => "\xEB\xBA\xA7",
		"\x95\xF0" => "\xEB\xBA\xA9",
		"\x95\xF1" => "\xEB\xBA\xAA",
		"\x95\xF2" => "\xEB\xBA\xAB",
		"\x95\xF3" => "\xEB\xBA\xAC",
		"\x95\xF4" => "\xEB\xBA\xAD",
		"\x95\xF5" => "\xEB\xBA\xAE",
		"\x95\xF6" => "\xEB\xBA\xAF",
		"\x95\xF7" => "\xEB\xBA\xB0",
		"\x95\xF8" => "\xEB\xBA\xB1",
		"\x95\xF9" => "\xEB\xBA\xB2",
		"\x95\xFA" => "\xEB\xBA\xB3",
		"\x95\xFB" => "\xEB\xBA\xB4",
		"\x95\xFC" => "\xEB\xBA\xB5",
		"\x95\xFD" => "\xEB\xBA\xB6",
		"\x95\xFE" => "\xEB\xBA\xB7",
		"\x96\x41" => "\xEB\xBA\xB8",
		"\x96\x42" => "\xEB\xBA\xB9",
		"\x96\x43" => "\xEB\xBA\xBA",
		"\x96\x44" => "\xEB\xBA\xBB",
		"\x96\x45" => "\xEB\xBA\xBC",
		"\x96\x46" => "\xEB\xBA\xBD",
		"\x96\x47" => "\xEB\xBA\xBE",
		"\x96\x48" => "\xEB\xBA\xBF",
		"\x96\x49" => "\xEB\xBB\x80",
		"\x96\x4A" => "\xEB\xBB\x81",
		"\x96\x4B" => "\xEB\xBB\x82",
		"\x96\x4C" => "\xEB\xBB\x83",
		"\x96\x4D" => "\xEB\xBB\x84",
		"\x96\x4E" => "\xEB\xBB\x85",
		"\x96\x4F" => "\xEB\xBB\x86",
		"\x96\x50" => "\xEB\xBB\x87",
		"\x96\x51" => "\xEB\xBB\x88",
		"\x96\x52" => "\xEB\xBB\x89",
		"\x96\x53" => "\xEB\xBB\x8A",
		"\x96\x54" => "\xEB\xBB\x8B",
		"\x96\x55" => "\xEB\xBB\x8C",
		"\x96\x56" => "\xEB\xBB\x8D",
		"\x96\x57" => "\xEB\xBB\x8E",
		"\x96\x58" => "\xEB\xBB\x8F",
		"\x96\x59" => "\xEB\xBB\x92",
		"\x96\x5A" => "\xEB\xBB\x93",
		"\x96\x61" => "\xEB\xBB\x95",
		"\x96\x62" => "\xEB\xBB\x96",
		"\x96\x63" => "\xEB\xBB\x99",
		"\x96\x64" => "\xEB\xBB\x9A",
		"\x96\x65" => "\xEB\xBB\x9B",
		"\x96\x66" => "\xEB\xBB\x9C",
		"\x96\x67" => "\xEB\xBB\x9D",
		"\x96\x68" => "\xEB\xBB\x9E",
		"\x96\x69" => "\xEB\xBB\x9F",
		"\x96\x6A" => "\xEB\xBB\xA1",
		"\x96\x6B" => "\xEB\xBB\xA2",
		"\x96\x6C" => "\xEB\xBB\xA6",
		"\x96\x6D" => "\xEB\xBB\xA7",
		"\x96\x6E" => "\xEB\xBB\xA8",
		"\x96\x6F" => "\xEB\xBB\xA9",
		"\x96\x70" => "\xEB\xBB\xAA",
		"\x96\x71" => "\xEB\xBB\xAB",
		"\x96\x72" => "\xEB\xBB\xAD",
		"\x96\x73" => "\xEB\xBB\xAE",
		"\x96\x74" => "\xEB\xBB\xAF",
		"\x96\x75" => "\xEB\xBB\xB0",
		"\x96\x76" => "\xEB\xBB\xB1",
		"\x96\x77" => "\xEB\xBB\xB2",
		"\x96\x78" => "\xEB\xBB\xB3",
		"\x96\x79" => "\xEB\xBB\xB4",
		"\x96\x7A" => "\xEB\xBB\xB5",
		"\x96\x81" => "\xEB\xBB\xB6",
		"\x96\x82" => "\xEB\xBB\xB7",
		"\x96\x83" => "\xEB\xBB\xB8",
		"\x96\x84" => "\xEB\xBB\xB9",
		"\x96\x85" => "\xEB\xBB\xBA",
		"\x96\x86" => "\xEB\xBB\xBB",
		"\x96\x87" => "\xEB\xBB\xBC",
		"\x96\x88" => "\xEB\xBB\xBD",
		"\x96\x89" => "\xEB\xBB\xBE",
		"\x96\x8A" => "\xEB\xBB\xBF",
		"\x96\x8B" => "\xEB\xBC\x80",
		"\x96\x8C" => "\xEB\xBC\x82",
		"\x96\x8D" => "\xEB\xBC\x83",
		"\x96\x8E" => "\xEB\xBC\x84",
		"\x96\x8F" => "\xEB\xBC\x85",
		"\x96\x90" => "\xEB\xBC\x86",
		"\x96\x91" => "\xEB\xBC\x87",
		"\x96\x92" => "\xEB\xBC\x8A",
		"\x96\x93" => "\xEB\xBC\x8B",
		"\x96\x94" => "\xEB\xBC\x8C",
		"\x96\x95" => "\xEB\xBC\x8D",
		"\x96\x96" => "\xEB\xBC\x8E",
		"\x96\x97" => "\xEB\xBC\x8F",
		"\x96\x98" => "\xEB\xBC\x90",
		"\x96\x99" => "\xEB\xBC\x91",
		"\x96\x9A" => "\xEB\xBC\x92",
		"\x96\x9B" => "\xEB\xBC\x93",
		"\x96\x9C" => "\xEB\xBC\x94",
		"\x96\x9D" => "\xEB\xBC\x95",
		"\x96\x9E" => "\xEB\xBC\x96",
		"\x96\x9F" => "\xEB\xBC\x97",
		"\x96\xA0" => "\xEB\xBC\x9A",
		"\x96\xA1" => "\xEB\xBC\x9E",
		"\x96\xA2" => "\xEB\xBC\x9F",
		"\x96\xA3" => "\xEB\xBC\xA0",
		"\x96\xA4" => "\xEB\xBC\xA1",
		"\x96\xA5" => "\xEB\xBC\xA2",
		"\x96\xA6" => "\xEB\xBC\xA3",
		"\x96\xA7" => "\xEB\xBC\xA4",
		"\x96\xA8" => "\xEB\xBC\xA5",
		"\x96\xA9" => "\xEB\xBC\xA6",
		"\x96\xAA" => "\xEB\xBC\xA7",
		"\x96\xAB" => "\xEB\xBC\xA8",
		"\x96\xAC" => "\xEB\xBC\xA9",
		"\x96\xAD" => "\xEB\xBC\xAA",
		"\x96\xAE" => "\xEB\xBC\xAB",
		"\x96\xAF" => "\xEB\xBC\xAC",
		"\x96\xB0" => "\xEB\xBC\xAD",
		"\x96\xB1" => "\xEB\xBC\xAE",
		"\x96\xB2" => "\xEB\xBC\xAF",
		"\x96\xB3" => "\xEB\xBC\xB0",
		"\x96\xB4" => "\xEB\xBC\xB1",
		"\x96\xB5" => "\xEB\xBC\xB2",
		"\x96\xB6" => "\xEB\xBC\xB3",
		"\x96\xB7" => "\xEB\xBC\xB4",
		"\x96\xB8" => "\xEB\xBC\xB5",
		"\x96\xB9" => "\xEB\xBC\xB6",
		"\x96\xBA" => "\xEB\xBC\xB7",
		"\x96\xBB" => "\xEB\xBC\xB8",
		"\x96\xBC" => "\xEB\xBC\xB9",
		"\x96\xBD" => "\xEB\xBC\xBA",
		"\x96\xBE" => "\xEB\xBC\xBB",
		"\x96\xBF" => "\xEB\xBC\xBC",
		"\x96\xC0" => "\xEB\xBC\xBD",
		"\x96\xC1" => "\xEB\xBC\xBE",
		"\x96\xC2" => "\xEB\xBC\xBF",
		"\x96\xC3" => "\xEB\xBD\x82",
		"\x96\xC4" => "\xEB\xBD\x83",
		"\x96\xC5" => "\xEB\xBD\x85",
		"\x96\xC6" => "\xEB\xBD\x86",
		"\x96\xC7" => "\xEB\xBD\x87",
		"\x96\xC8" => "\xEB\xBD\x89",
		"\x96\xC9" => "\xEB\xBD\x8A",
		"\x96\xCA" => "\xEB\xBD\x8B",
		"\x96\xCB" => "\xEB\xBD\x8C",
		"\x96\xCC" => "\xEB\xBD\x8D",
		"\x96\xCD" => "\xEB\xBD\x8E",
		"\x96\xCE" => "\xEB\xBD\x8F",
		"\x96\xCF" => "\xEB\xBD\x92",
		"\x96\xD0" => "\xEB\xBD\x93",
		"\x96\xD1" => "\xEB\xBD\x94",
		"\x96\xD2" => "\xEB\xBD\x96",
		"\x96\xD3" => "\xEB\xBD\x97",
		"\x96\xD4" => "\xEB\xBD\x98",
		"\x96\xD5" => "\xEB\xBD\x99",
		"\x96\xD6" => "\xEB\xBD\x9A",
		"\x96\xD7" => "\xEB\xBD\x9B",
		"\x96\xD8" => "\xEB\xBD\x9C",
		"\x96\xD9" => "\xEB\xBD\x9D",
		"\x96\xDA" => "\xEB\xBD\x9E",
		"\x96\xDB" => "\xEB\xBD\x9F",
		"\x96\xDC" => "\xEB\xBD\xA0",
		"\x96\xDD" => "\xEB\xBD\xA1",
		"\x96\xDE" => "\xEB\xBD\xA2",
		"\x96\xDF" => "\xEB\xBD\xA3",
		"\x96\xE0" => "\xEB\xBD\xA4",
		"\x96\xE1" => "\xEB\xBD\xA5",
		"\x96\xE2" => "\xEB\xBD\xA6",
		"\x96\xE3" => "\xEB\xBD\xA7",
		"\x96\xE4" => "\xEB\xBD\xA8",
		"\x96\xE5" => "\xEB\xBD\xA9",
		"\x96\xE6" => "\xEB\xBD\xAA",
		"\x96\xE7" => "\xEB\xBD\xAB",
		"\x96\xE8" => "\xEB\xBD\xAC",
		"\x96\xE9" => "\xEB\xBD\xAD",
		"\x96\xEA" => "\xEB\xBD\xAE",
		"\x96\xEB" => "\xEB\xBD\xAF",
		"\x96\xEC" => "\xEB\xBD\xB0",
		"\x96\xED" => "\xEB\xBD\xB1",
		"\x96\xEE" => "\xEB\xBD\xB2",
		"\x96\xEF" => "\xEB\xBD\xB3",
		"\x96\xF0" => "\xEB\xBD\xB4",
		"\x96\xF1" => "\xEB\xBD\xB5",
		"\x96\xF2" => "\xEB\xBD\xB6",
		"\x96\xF3" => "\xEB\xBD\xB7",
		"\x96\xF4" => "\xEB\xBD\xB8",
		"\x96\xF5" => "\xEB\xBD\xB9",
		"\x96\xF6" => "\xEB\xBD\xBA",
		"\x96\xF7" => "\xEB\xBD\xBB",
		"\x96\xF8" => "\xEB\xBD\xBC",
		"\x96\xF9" => "\xEB\xBD\xBD",
		"\x96\xFA" => "\xEB\xBD\xBE",
		"\x96\xFB" => "\xEB\xBD\xBF",
		"\x96\xFC" => "\xEB\xBE\x80",
		"\x96\xFD" => "\xEB\xBE\x81",
		"\x96\xFE" => "\xEB\xBE\x82",
		"\x97\x41" => "\xEB\xBE\x83",
		"\x97\x42" => "\xEB\xBE\x84",
		"\x97\x43" => "\xEB\xBE\x85",
		"\x97\x44" => "\xEB\xBE\x86",
		"\x97\x45" => "\xEB\xBE\x87",
		"\x97\x46" => "\xEB\xBE\x88",
		"\x97\x47" => "\xEB\xBE\x89",
		"\x97\x48" => "\xEB\xBE\x8A",
		"\x97\x49" => "\xEB\xBE\x8B",
		"\x97\x4A" => "\xEB\xBE\x8C",
		"\x97\x4B" => "\xEB\xBE\x8D",
		"\x97\x4C" => "\xEB\xBE\x8E",
		"\x97\x4D" => "\xEB\xBE\x8F",
		"\x97\x4E" => "\xEB\xBE\x90",
		"\x97\x4F" => "\xEB\xBE\x91",
		"\x97\x50" => "\xEB\xBE\x92",
		"\x97\x51" => "\xEB\xBE\x93",
		"\x97\x52" => "\xEB\xBE\x95",
		"\x97\x53" => "\xEB\xBE\x96",
		"\x97\x54" => "\xEB\xBE\x97",
		"\x97\x55" => "\xEB\xBE\x98",
		"\x97\x56" => "\xEB\xBE\x99",
		"\x97\x57" => "\xEB\xBE\x9A",
		"\x97\x58" => "\xEB\xBE\x9B",
		"\x97\x59" => "\xEB\xBE\x9C",
		"\x97\x5A" => "\xEB\xBE\x9D",
		"\x97\x61" => "\xEB\xBE\x9E",
		"\x97\x62" => "\xEB\xBE\x9F",
		"\x97\x63" => "\xEB\xBE\xA0",
		"\x97\x64" => "\xEB\xBE\xA1",
		"\x97\x65" => "\xEB\xBE\xA2",
		"\x97\x66" => "\xEB\xBE\xA3",
		"\x97\x67" => "\xEB\xBE\xA4",
		"\x97\x68" => "\xEB\xBE\xA5",
		"\x97\x69" => "\xEB\xBE\xA6",
		"\x97\x6A" => "\xEB\xBE\xA7",
		"\x97\x6B" => "\xEB\xBE\xA8",
		"\x97\x6C" => "\xEB\xBE\xA9",
		"\x97\x6D" => "\xEB\xBE\xAA",
		"\x97\x6E" => "\xEB\xBE\xAB",
		"\x97\x6F" => "\xEB\xBE\xAC",
		"\x97\x70" => "\xEB\xBE\xAD",
		"\x97\x71" => "\xEB\xBE\xAE",
		"\x97\x72" => "\xEB\xBE\xAF",
		"\x97\x73" => "\xEB\xBE\xB1",
		"\x97\x74" => "\xEB\xBE\xB2",
		"\x97\x75" => "\xEB\xBE\xB3",
		"\x97\x76" => "\xEB\xBE\xB4",
		"\x97\x77" => "\xEB\xBE\xB5",
		"\x97\x78" => "\xEB\xBE\xB6",
		"\x97\x79" => "\xEB\xBE\xB7",
		"\x97\x7A" => "\xEB\xBE\xB8",
		"\x97\x81" => "\xEB\xBE\xB9",
		"\x97\x82" => "\xEB\xBE\xBA",
		"\x97\x83" => "\xEB\xBE\xBB",
		"\x97\x84" => "\xEB\xBE\xBC",
		"\x97\x85" => "\xEB\xBE\xBD",
		"\x97\x86" => "\xEB\xBE\xBE",
		"\x97\x87" => "\xEB\xBE\xBF",
		"\x97\x88" => "\xEB\xBF\x80",
		"\x97\x89" => "\xEB\xBF\x81",
		"\x97\x8A" => "\xEB\xBF\x82",
		"\x97\x8B" => "\xEB\xBF\x83",
		"\x97\x8C" => "\xEB\xBF\x84",
		"\x97\x8D" => "\xEB\xBF\x86",
		"\x97\x8E" => "\xEB\xBF\x87",
		"\x97\x8F" => "\xEB\xBF\x88",
		"\x97\x90" => "\xEB\xBF\x89",
		"\x97\x91" => "\xEB\xBF\x8A",
		"\x97\x92" => "\xEB\xBF\x8B",
		"\x97\x93" => "\xEB\xBF\x8E",
		"\x97\x94" => "\xEB\xBF\x8F",
		"\x97\x95" => "\xEB\xBF\x91",
		"\x97\x96" => "\xEB\xBF\x92",
		"\x97\x97" => "\xEB\xBF\x93",
		"\x97\x98" => "\xEB\xBF\x95",
		"\x97\x99" => "\xEB\xBF\x96",
		"\x97\x9A" => "\xEB\xBF\x97",
		"\x97\x9B" => "\xEB\xBF\x98",
		"\x97\x9C" => "\xEB\xBF\x99",
		"\x97\x9D" => "\xEB\xBF\x9A",
		"\x97\x9E" => "\xEB\xBF\x9B",
		"\x97\x9F" => "\xEB\xBF\x9D",
		"\x97\xA0" => "\xEB\xBF\x9E",
		"\x97\xA1" => "\xEB\xBF\xA0",
		"\x97\xA2" => "\xEB\xBF\xA2",
		"\x97\xA3" => "\xEB\xBF\xA3",
		"\x97\xA4" => "\xEB\xBF\xA4",
		"\x97\xA5" => "\xEB\xBF\xA5",
		"\x97\xA6" => "\xEB\xBF\xA6",
		"\x97\xA7" => "\xEB\xBF\xA7",
		"\x97\xA8" => "\xEB\xBF\xA8",
		"\x97\xA9" => "\xEB\xBF\xA9",
		"\x97\xAA" => "\xEB\xBF\xAA",
		"\x97\xAB" => "\xEB\xBF\xAB",
		"\x97\xAC" => "\xEB\xBF\xAC",
		"\x97\xAD" => "\xEB\xBF\xAD",
		"\x97\xAE" => "\xEB\xBF\xAE",
		"\x97\xAF" => "\xEB\xBF\xAF",
		"\x97\xB0" => "\xEB\xBF\xB0",
		"\x97\xB1" => "\xEB\xBF\xB1",
		"\x97\xB2" => "\xEB\xBF\xB2",
		"\x97\xB3" => "\xEB\xBF\xB3",
		"\x97\xB4" => "\xEB\xBF\xB4",
		"\x97\xB5" => "\xEB\xBF\xB5",
		"\x97\xB6" => "\xEB\xBF\xB6",
		"\x97\xB7" => "\xEB\xBF\xB7",
		"\x97\xB8" => "\xEB\xBF\xB8",
		"\x97\xB9" => "\xEB\xBF\xB9",
		"\x97\xBA" => "\xEB\xBF\xBA",
		"\x97\xBB" => "\xEB\xBF\xBB",
		"\x97\xBC" => "\xEB\xBF\xBC",
		"\x97\xBD" => "\xEB\xBF\xBD",
		"\x97\xBE" => "\xEB\xBF\xBE",
		"\x97\xBF" => "\xEB\xBF\xBF",
		"\x97\xC0" => "\xEC\x80\x80",
		"\x97\xC1" => "\xEC\x80\x81",
		"\x97\xC2" => "\xEC\x80\x82",
		"\x97\xC3" => "\xEC\x80\x83",
		"\x97\xC4" => "\xEC\x80\x84",
		"\x97\xC5" => "\xEC\x80\x85",
		"\x97\xC6" => "\xEC\x80\x86",
		"\x97\xC7" => "\xEC\x80\x87",
		"\x97\xC8" => "\xEC\x80\x88",
		"\x97\xC9" => "\xEC\x80\x89",
		"\x97\xCA" => "\xEC\x80\x8A",
		"\x97\xCB" => "\xEC\x80\x8B",
		"\x97\xCC" => "\xEC\x80\x8C",
		"\x97\xCD" => "\xEC\x80\x8D",
		"\x97\xCE" => "\xEC\x80\x8E",
		"\x97\xCF" => "\xEC\x80\x8F",
		"\x97\xD0" => "\xEC\x80\x90",
		"\x97\xD1" => "\xEC\x80\x91",
		"\x97\xD2" => "\xEC\x80\x92",
		"\x97\xD3" => "\xEC\x80\x93",
		"\x97\xD4" => "\xEC\x80\x94",
		"\x97\xD5" => "\xEC\x80\x95",
		"\x97\xD6" => "\xEC\x80\x96",
		"\x97\xD7" => "\xEC\x80\x97",
		"\x97\xD8" => "\xEC\x80\x98",
		"\x97\xD9" => "\xEC\x80\x99",
		"\x97\xDA" => "\xEC\x80\x9A",
		"\x97\xDB" => "\xEC\x80\x9B",
		"\x97\xDC" => "\xEC\x80\x9C",
		"\x97\xDD" => "\xEC\x80\x9D",
		"\x97\xDE" => "\xEC\x80\x9E",
		"\x97\xDF" => "\xEC\x80\x9F",
		"\x97\xE0" => "\xEC\x80\xA0",
		"\x97\xE1" => "\xEC\x80\xA1",
		"\x97\xE2" => "\xEC\x80\xA2",
		"\x97\xE3" => "\xEC\x80\xA3",
		"\x97\xE4" => "\xEC\x80\xA4",
		"\x97\xE5" => "\xEC\x80\xA5",
		"\x97\xE6" => "\xEC\x80\xA6",
		"\x97\xE7" => "\xEC\x80\xA7",
		"\x97\xE8" => "\xEC\x80\xA8",
		"\x97\xE9" => "\xEC\x80\xA9",
		"\x97\xEA" => "\xEC\x80\xAA",
		"\x97\xEB" => "\xEC\x80\xAB",
		"\x97\xEC" => "\xEC\x80\xAC",
		"\x97\xED" => "\xEC\x80\xAD",
		"\x97\xEE" => "\xEC\x80\xAE",
		"\x97\xEF" => "\xEC\x80\xAF",
		"\x97\xF0" => "\xEC\x80\xB0",
		"\x97\xF1" => "\xEC\x80\xB1",
		"\x97\xF2" => "\xEC\x80\xB2",
		"\x97\xF3" => "\xEC\x80\xB3",
		"\x97\xF4" => "\xEC\x80\xB4",
		"\x97\xF5" => "\xEC\x80\xB5",
		"\x97\xF6" => "\xEC\x80\xB6",
		"\x97\xF7" => "\xEC\x80\xB7",
		"\x97\xF8" => "\xEC\x80\xB8",
		"\x97\xF9" => "\xEC\x80\xB9",
		"\x97\xFA" => "\xEC\x80\xBA",
		"\x97\xFB" => "\xEC\x80\xBB",
		"\x97\xFC" => "\xEC\x80\xBD",
		"\x97\xFD" => "\xEC\x80\xBE",
		"\x97\xFE" => "\xEC\x80\xBF",
		"\x98\x41" => "\xEC\x81\x80",
		"\x98\x42" => "\xEC\x81\x81",
		"\x98\x43" => "\xEC\x81\x82",
		"\x98\x44" => "\xEC\x81\x83",
		"\x98\x45" => "\xEC\x81\x84",
		"\x98\x46" => "\xEC\x81\x85",
		"\x98\x47" => "\xEC\x81\x86",
		"\x98\x48" => "\xEC\x81\x87",
		"\x98\x49" => "\xEC\x81\x88",
		"\x98\x4A" => "\xEC\x81\x89",
		"\x98\x4B" => "\xEC\x81\x8A",
		"\x98\x4C" => "\xEC\x81\x8B",
		"\x98\x4D" => "\xEC\x81\x8C",
		"\x98\x4E" => "\xEC\x81\x8D",
		"\x98\x4F" => "\xEC\x81\x8E",
		"\x98\x50" => "\xEC\x81\x8F",
		"\x98\x51" => "\xEC\x81\x90",
		"\x98\x52" => "\xEC\x81\x92",
		"\x98\x53" => "\xEC\x81\x93",
		"\x98\x54" => "\xEC\x81\x94",
		"\x98\x55" => "\xEC\x81\x95",
		"\x98\x56" => "\xEC\x81\x96",
		"\x98\x57" => "\xEC\x81\x97",
		"\x98\x58" => "\xEC\x81\x99",
		"\x98\x59" => "\xEC\x81\x9A",
		"\x98\x5A" => "\xEC\x81\x9B",
		"\x98\x61" => "\xEC\x81\x9D",
		"\x98\x62" => "\xEC\x81\x9E",
		"\x98\x63" => "\xEC\x81\x9F",
		"\x98\x64" => "\xEC\x81\xA1",
		"\x98\x65" => "\xEC\x81\xA2",
		"\x98\x66" => "\xEC\x81\xA3",
		"\x98\x67" => "\xEC\x81\xA4",
		"\x98\x68" => "\xEC\x81\xA5",
		"\x98\x69" => "\xEC\x81\xA6",
		"\x98\x6A" => "\xEC\x81\xA7",
		"\x98\x6B" => "\xEC\x81\xAA",
		"\x98\x6C" => "\xEC\x81\xAB",
		"\x98\x6D" => "\xEC\x81\xAC",
		"\x98\x6E" => "\xEC\x81\xAD",
		"\x98\x6F" => "\xEC\x81\xAE",
		"\x98\x70" => "\xEC\x81\xAF",
		"\x98\x71" => "\xEC\x81\xB0",
		"\x98\x72" => "\xEC\x81\xB1",
		"\x98\x73" => "\xEC\x81\xB2",
		"\x98\x74" => "\xEC\x81\xB3",
		"\x98\x75" => "\xEC\x81\xB4",
		"\x98\x76" => "\xEC\x81\xB5",
		"\x98\x77" => "\xEC\x81\xB6",
		"\x98\x78" => "\xEC\x81\xB7",
		"\x98\x79" => "\xEC\x81\xB8",
		"\x98\x7A" => "\xEC\x81\xB9",
		"\x98\x81" => "\xEC\x81\xBA",
		"\x98\x82" => "\xEC\x81\xBB",
		"\x98\x83" => "\xEC\x81\xBC",
		"\x98\x84" => "\xEC\x81\xBD",
		"\x98\x85" => "\xEC\x81\xBE",
		"\x98\x86" => "\xEC\x81\xBF",
		"\x98\x87" => "\xEC\x82\x80",
		"\x98\x88" => "\xEC\x82\x81",
		"\x98\x89" => "\xEC\x82\x82",
		"\x98\x8A" => "\xEC\x82\x83",
		"\x98\x8B" => "\xEC\x82\x84",
		"\x98\x8C" => "\xEC\x82\x85",
		"\x98\x8D" => "\xEC\x82\x86",
		"\x98\x8E" => "\xEC\x82\x87",
		"\x98\x8F" => "\xEC\x82\x88",
		"\x98\x90" => "\xEC\x82\x89",
		"\x98\x91" => "\xEC\x82\x8A",
		"\x98\x92" => "\xEC\x82\x8B",
		"\x98\x93" => "\xEC\x82\x8C",
		"\x98\x94" => "\xEC\x82\x8D",
		"\x98\x95" => "\xEC\x82\x8E",
		"\x98\x96" => "\xEC\x82\x8F",
		"\x98\x97" => "\xEC\x82\x92",
		"\x98\x98" => "\xEC\x82\x93",
		"\x98\x99" => "\xEC\x82\x95",
		"\x98\x9A" => "\xEC\x82\x96",
		"\x98\x9B" => "\xEC\x82\x97",
		"\x98\x9C" => "\xEC\x82\x99",
		"\x98\x9D" => "\xEC\x82\x9A",
		"\x98\x9E" => "\xEC\x82\x9B",
		"\x98\x9F" => "\xEC\x82\x9C",
		"\x98\xA0" => "\xEC\x82\x9D",
		"\x98\xA1" => "\xEC\x82\x9E",
		"\x98\xA2" => "\xEC\x82\x9F",
		"\x98\xA3" => "\xEC\x82\xA2",
		"\x98\xA4" => "\xEC\x82\xA4",
		"\x98\xA5" => "\xEC\x82\xA6",
		"\x98\xA6" => "\xEC\x82\xA7",
		"\x98\xA7" => "\xEC\x82\xA8",
		"\x98\xA8" => "\xEC\x82\xA9",
		"\x98\xA9" => "\xEC\x82\xAA",
		"\x98\xAA" => "\xEC\x82\xAB",
		"\x98\xAB" => "\xEC\x82\xAE",
		"\x98\xAC" => "\xEC\x82\xB1",
		"\x98\xAD" => "\xEC\x82\xB2",
		"\x98\xAE" => "\xEC\x82\xB7",
		"\x98\xAF" => "\xEC\x82\xB8",
		"\x98\xB0" => "\xEC\x82\xB9",
		"\x98\xB1" => "\xEC\x82\xBA",
		"\x98\xB2" => "\xEC\x82\xBB",
		"\x98\xB3" => "\xEC\x82\xBE",
		"\x98\xB4" => "\xEC\x83\x82",
		"\x98\xB5" => "\xEC\x83\x83",
		"\x98\xB6" => "\xEC\x83\x84",
		"\x98\xB7" => "\xEC\x83\x86",
		"\x98\xB8" => "\xEC\x83\x87",
		"\x98\xB9" => "\xEC\x83\x8A",
		"\x98\xBA" => "\xEC\x83\x8B",
		"\x98\xBB" => "\xEC\x83\x8D",
		"\x98\xBC" => "\xEC\x83\x8E",
		"\x98\xBD" => "\xEC\x83\x8F",
		"\x98\xBE" => "\xEC\x83\x91",
		"\x98\xBF" => "\xEC\x83\x92",
		"\x98\xC0" => "\xEC\x83\x93",
		"\x98\xC1" => "\xEC\x83\x94",
		"\x98\xC2" => "\xEC\x83\x95",
		"\x98\xC3" => "\xEC\x83\x96",
		"\x98\xC4" => "\xEC\x83\x97",
		"\x98\xC5" => "\xEC\x83\x9A",
		"\x98\xC6" => "\xEC\x83\x9E",
		"\x98\xC7" => "\xEC\x83\x9F",
		"\x98\xC8" => "\xEC\x83\xA0",
		"\x98\xC9" => "\xEC\x83\xA1",
		"\x98\xCA" => "\xEC\x83\xA2",
		"\x98\xCB" => "\xEC\x83\xA3",
		"\x98\xCC" => "\xEC\x83\xA6",
		"\x98\xCD" => "\xEC\x83\xA7",
		"\x98\xCE" => "\xEC\x83\xA9",
		"\x98\xCF" => "\xEC\x83\xAA",
		"\x98\xD0" => "\xEC\x83\xAB",
		"\x98\xD1" => "\xEC\x83\xAD",
		"\x98\xD2" => "\xEC\x83\xAE",
		"\x98\xD3" => "\xEC\x83\xAF",
		"\x98\xD4" => "\xEC\x83\xB0",
		"\x98\xD5" => "\xEC\x83\xB1",
		"\x98\xD6" => "\xEC\x83\xB2",
		"\x98\xD7" => "\xEC\x83\xB3",
		"\x98\xD8" => "\xEC\x83\xB6",
		"\x98\xD9" => "\xEC\x83\xB8",
		"\x98\xDA" => "\xEC\x83\xBA",
		"\x98\xDB" => "\xEC\x83\xBB",
		"\x98\xDC" => "\xEC\x83\xBC",
		"\x98\xDD" => "\xEC\x83\xBD",
		"\x98\xDE" => "\xEC\x83\xBE",
		"\x98\xDF" => "\xEC\x83\xBF",
		"\x98\xE0" => "\xEC\x84\x81",
		"\x98\xE1" => "\xEC\x84\x82",
		"\x98\xE2" => "\xEC\x84\x83",
		"\x98\xE3" => "\xEC\x84\x85",
		"\x98\xE4" => "\xEC\x84\x86",
		"\x98\xE5" => "\xEC\x84\x87",
		"\x98\xE6" => "\xEC\x84\x89",
		"\x98\xE7" => "\xEC\x84\x8A",
		"\x98\xE8" => "\xEC\x84\x8B",
		"\x98\xE9" => "\xEC\x84\x8C",
		"\x98\xEA" => "\xEC\x84\x8D",
		"\x98\xEB" => "\xEC\x84\x8E",
		"\x98\xEC" => "\xEC\x84\x8F",
		"\x98\xED" => "\xEC\x84\x91",
		"\x98\xEE" => "\xEC\x84\x92",
		"\x98\xEF" => "\xEC\x84\x93",
		"\x98\xF0" => "\xEC\x84\x94",
		"\x98\xF1" => "\xEC\x84\x96",
		"\x98\xF2" => "\xEC\x84\x97",
		"\x98\xF3" => "\xEC\x84\x98",
		"\x98\xF4" => "\xEC\x84\x99",
		"\x98\xF5" => "\xEC\x84\x9A",
		"\x98\xF6" => "\xEC\x84\x9B",
		"\x98\xF7" => "\xEC\x84\xA1",
		"\x98\xF8" => "\xEC\x84\xA2",
		"\x98\xF9" => "\xEC\x84\xA5",
		"\x98\xFA" => "\xEC\x84\xA8",
		"\x98\xFB" => "\xEC\x84\xA9",
		"\x98\xFC" => "\xEC\x84\xAA",
		"\x98\xFD" => "\xEC\x84\xAB",
		"\x98\xFE" => "\xEC\x84\xAE",
		"\x99\x41" => "\xEC\x84\xB2",
		"\x99\x42" => "\xEC\x84\xB3",
		"\x99\x43" => "\xEC\x84\xB4",
		"\x99\x44" => "\xEC\x84\xB5",
		"\x99\x45" => "\xEC\x84\xB7",
		"\x99\x46" => "\xEC\x84\xBA",
		"\x99\x47" => "\xEC\x84\xBB",
		"\x99\x48" => "\xEC\x84\xBD",
		"\x99\x49" => "\xEC\x84\xBE",
		"\x99\x4A" => "\xEC\x84\xBF",
		"\x99\x4B" => "\xEC\x85\x81",
		"\x99\x4C" => "\xEC\x85\x82",
		"\x99\x4D" => "\xEC\x85\x83",
		"\x99\x4E" => "\xEC\x85\x84",
		"\x99\x4F" => "\xEC\x85\x85",
		"\x99\x50" => "\xEC\x85\x86",
		"\x99\x51" => "\xEC\x85\x87",
		"\x99\x52" => "\xEC\x85\x8A",
		"\x99\x53" => "\xEC\x85\x8E",
		"\x99\x54" => "\xEC\x85\x8F",
		"\x99\x55" => "\xEC\x85\x90",
		"\x99\x56" => "\xEC\x85\x91",
		"\x99\x57" => "\xEC\x85\x92",
		"\x99\x58" => "\xEC\x85\x93",
		"\x99\x59" => "\xEC\x85\x96",
		"\x99\x5A" => "\xEC\x85\x97",
		"\x99\x61" => "\xEC\x85\x99",
		"\x99\x62" => "\xEC\x85\x9A",
		"\x99\x63" => "\xEC\x85\x9B",
		"\x99\x64" => "\xEC\x85\x9D",
		"\x99\x65" => "\xEC\x85\x9E",
		"\x99\x66" => "\xEC\x85\x9F",
		"\x99\x67" => "\xEC\x85\xA0",
		"\x99\x68" => "\xEC\x85\xA1",
		"\x99\x69" => "\xEC\x85\xA2",
		"\x99\x6A" => "\xEC\x85\xA3",
		"\x99\x6B" => "\xEC\x85\xA6",
		"\x99\x6C" => "\xEC\x85\xAA",
		"\x99\x6D" => "\xEC\x85\xAB",
		"\x99\x6E" => "\xEC\x85\xAC",
		"\x99\x6F" => "\xEC\x85\xAD",
		"\x99\x70" => "\xEC\x85\xAE",
		"\x99\x71" => "\xEC\x85\xAF",
		"\x99\x72" => "\xEC\x85\xB1",
		"\x99\x73" => "\xEC\x85\xB2",
		"\x99\x74" => "\xEC\x85\xB3",
		"\x99\x75" => "\xEC\x85\xB5",
		"\x99\x76" => "\xEC\x85\xB6",
		"\x99\x77" => "\xEC\x85\xB7",
		"\x99\x78" => "\xEC\x85\xB9",
		"\x99\x79" => "\xEC\x85\xBA",
		"\x99\x7A" => "\xEC\x85\xBB",
		"\x99\x81" => "\xEC\x85\xBC",
		"\x99\x82" => "\xEC\x85\xBD",
		"\x99\x83" => "\xEC\x85\xBE",
		"\x99\x84" => "\xEC\x85\xBF",
		"\x99\x85" => "\xEC\x86\x80",
		"\x99\x86" => "\xEC\x86\x81",
		"\x99\x87" => "\xEC\x86\x82",
		"\x99\x88" => "\xEC\x86\x83",
		"\x99\x89" => "\xEC\x86\x84",
		"\x99\x8A" => "\xEC\x86\x86",
		"\x99\x8B" => "\xEC\x86\x87",
		"\x99\x8C" => "\xEC\x86\x88",
		"\x99\x8D" => "\xEC\x86\x89",
		"\x99\x8E" => "\xEC\x86\x8A",
		"\x99\x8F" => "\xEC\x86\x8B",
		"\x99\x90" => "\xEC\x86\x8F",
		"\x99\x91" => "\xEC\x86\x91",
		"\x99\x92" => "\xEC\x86\x92",
		"\x99\x93" => "\xEC\x86\x93",
		"\x99\x94" => "\xEC\x86\x95",
		"\x99\x95" => "\xEC\x86\x97",
		"\x99\x96" => "\xEC\x86\x98",
		"\x99\x97" => "\xEC\x86\x99",
		"\x99\x98" => "\xEC\x86\x9A",
		"\x99\x99" => "\xEC\x86\x9B",
		"\x99\x9A" => "\xEC\x86\x9E",
		"\x99\x9B" => "\xEC\x86\xA0",
		"\x99\x9C" => "\xEC\x86\xA2",
		"\x99\x9D" => "\xEC\x86\xA3",
		"\x99\x9E" => "\xEC\x86\xA4",
		"\x99\x9F" => "\xEC\x86\xA6",
		"\x99\xA0" => "\xEC\x86\xA7",
		"\x99\xA1" => "\xEC\x86\xAA",
		"\x99\xA2" => "\xEC\x86\xAB",
		"\x99\xA3" => "\xEC\x86\xAD",
		"\x99\xA4" => "\xEC\x86\xAE",
		"\x99\xA5" => "\xEC\x86\xAF",
		"\x99\xA6" => "\xEC\x86\xB1",
		"\x99\xA7" => "\xEC\x86\xB2",
		"\x99\xA8" => "\xEC\x86\xB3",
		"\x99\xA9" => "\xEC\x86\xB4",
		"\x99\xAA" => "\xEC\x86\xB5",
		"\x99\xAB" => "\xEC\x86\xB6",
		"\x99\xAC" => "\xEC\x86\xB7",
		"\x99\xAD" => "\xEC\x86\xB8",
		"\x99\xAE" => "\xEC\x86\xB9",
		"\x99\xAF" => "\xEC\x86\xBA",
		"\x99\xB0" => "\xEC\x86\xBB",
		"\x99\xB1" => "\xEC\x86\xBC",
		"\x99\xB2" => "\xEC\x86\xBE",
		"\x99\xB3" => "\xEC\x86\xBF",
		"\x99\xB4" => "\xEC\x87\x80",
		"\x99\xB5" => "\xEC\x87\x81",
		"\x99\xB6" => "\xEC\x87\x82",
		"\x99\xB7" => "\xEC\x87\x83",
		"\x99\xB8" => "\xEC\x87\x85",
		"\x99\xB9" => "\xEC\x87\x86",
		"\x99\xBA" => "\xEC\x87\x87",
		"\x99\xBB" => "\xEC\x87\x89",
		"\x99\xBC" => "\xEC\x87\x8A",
		"\x99\xBD" => "\xEC\x87\x8B",
		"\x99\xBE" => "\xEC\x87\x8D",
		"\x99\xBF" => "\xEC\x87\x8E",
		"\x99\xC0" => "\xEC\x87\x8F",
		"\x99\xC1" => "\xEC\x87\x90",
		"\x99\xC2" => "\xEC\x87\x91",
		"\x99\xC3" => "\xEC\x87\x92",
		"\x99\xC4" => "\xEC\x87\x93",
		"\x99\xC5" => "\xEC\x87\x95",
		"\x99\xC6" => "\xEC\x87\x96",
		"\x99\xC7" => "\xEC\x87\x99",
		"\x99\xC8" => "\xEC\x87\x9A",
		"\x99\xC9" => "\xEC\x87\x9B",
		"\x99\xCA" => "\xEC\x87\x9C",
		"\x99\xCB" => "\xEC\x87\x9D",
		"\x99\xCC" => "\xEC\x87\x9E",
		"\x99\xCD" => "\xEC\x87\x9F",
		"\x99\xCE" => "\xEC\x87\xA1",
		"\x99\xCF" => "\xEC\x87\xA2",
		"\x99\xD0" => "\xEC\x87\xA3",
		"\x99\xD1" => "\xEC\x87\xA5",
		"\x99\xD2" => "\xEC\x87\xA6",
		"\x99\xD3" => "\xEC\x87\xA7",
		"\x99\xD4" => "\xEC\x87\xA9",
		"\x99\xD5" => "\xEC\x87\xAA",
		"\x99\xD6" => "\xEC\x87\xAB",
		"\x99\xD7" => "\xEC\x87\xAC",
		"\x99\xD8" => "\xEC\x87\xAD",
		"\x99\xD9" => "\xEC\x87\xAE",
		"\x99\xDA" => "\xEC\x87\xAF",
		"\x99\xDB" => "\xEC\x87\xB2",
		"\x99\xDC" => "\xEC\x87\xB4",
		"\x99\xDD" => "\xEC\x87\xB5",
		"\x99\xDE" => "\xEC\x87\xB6",
		"\x99\xDF" => "\xEC\x87\xB7",
		"\x99\xE0" => "\xEC\x87\xB8",
		"\x99\xE1" => "\xEC\x87\xB9",
		"\x99\xE2" => "\xEC\x87\xBA",
		"\x99\xE3" => "\xEC\x87\xBB",
		"\x99\xE4" => "\xEC\x87\xBE",
		"\x99\xE5" => "\xEC\x87\xBF",
		"\x99\xE6" => "\xEC\x88\x81",
		"\x99\xE7" => "\xEC\x88\x82",
		"\x99\xE8" => "\xEC\x88\x83",
		"\x99\xE9" => "\xEC\x88\x85",
		"\x99\xEA" => "\xEC\x88\x86",
		"\x99\xEB" => "\xEC\x88\x87",
		"\x99\xEC" => "\xEC\x88\x88",
		"\x99\xED" => "\xEC\x88\x89",
		"\x99\xEE" => "\xEC\x88\x8A",
		"\x99\xEF" => "\xEC\x88\x8B",
		"\x99\xF0" => "\xEC\x88\x8E",
		"\x99\xF1" => "\xEC\x88\x90",
		"\x99\xF2" => "\xEC\x88\x92",
		"\x99\xF3" => "\xEC\x88\x93",
		"\x99\xF4" => "\xEC\x88\x94",
		"\x99\xF5" => "\xEC\x88\x95",
		"\x99\xF6" => "\xEC\x88\x96",
		"\x99\xF7" => "\xEC\x88\x97",
		"\x99\xF8" => "\xEC\x88\x9A",
		"\x99\xF9" => "\xEC\x88\x9B",
		"\x99\xFA" => "\xEC\x88\x9D",
		"\x99\xFB" => "\xEC\x88\x9E",
		"\x99\xFC" => "\xEC\x88\xA1",
		"\x99\xFD" => "\xEC\x88\xA2",
		"\x99\xFE" => "\xEC\x88\xA3",
		"\x9A\x41" => "\xEC\x88\xA4",
		"\x9A\x42" => "\xEC\x88\xA5",
		"\x9A\x43" => "\xEC\x88\xA6",
		"\x9A\x44" => "\xEC\x88\xA7",
		"\x9A\x45" => "\xEC\x88\xAA",
		"\x9A\x46" => "\xEC\x88\xAC",
		"\x9A\x47" => "\xEC\x88\xAE",
		"\x9A\x48" => "\xEC\x88\xB0",
		"\x9A\x49" => "\xEC\x88\xB3",
		"\x9A\x4A" => "\xEC\x88\xB5",
		"\x9A\x4B" => "\xEC\x88\xB6",
		"\x9A\x4C" => "\xEC\x88\xB7",
		"\x9A\x4D" => "\xEC\x88\xB8",
		"\x9A\x4E" => "\xEC\x88\xB9",
		"\x9A\x4F" => "\xEC\x88\xBA",
		"\x9A\x50" => "\xEC\x88\xBB",
		"\x9A\x51" => "\xEC\x88\xBC",
		"\x9A\x52" => "\xEC\x88\xBD",
		"\x9A\x53" => "\xEC\x88\xBE",
		"\x9A\x54" => "\xEC\x88\xBF",
		"\x9A\x55" => "\xEC\x89\x80",
		"\x9A\x56" => "\xEC\x89\x81",
		"\x9A\x57" => "\xEC\x89\x82",
		"\x9A\x58" => "\xEC\x89\x83",
		"\x9A\x59" => "\xEC\x89\x84",
		"\x9A\x5A" => "\xEC\x89\x85",
		"\x9A\x61" => "\xEC\x89\x86",
		"\x9A\x62" => "\xEC\x89\x87",
		"\x9A\x63" => "\xEC\x89\x89",
		"\x9A\x64" => "\xEC\x89\x8A",
		"\x9A\x65" => "\xEC\x89\x8B",
		"\x9A\x66" => "\xEC\x89\x8C",
		"\x9A\x67" => "\xEC\x89\x8D",
		"\x9A\x68" => "\xEC\x89\x8E",
		"\x9A\x69" => "\xEC\x89\x8F",
		"\x9A\x6A" => "\xEC\x89\x92",
		"\x9A\x6B" => "\xEC\x89\x93",
		"\x9A\x6C" => "\xEC\x89\x95",
		"\x9A\x6D" => "\xEC\x89\x96",
		"\x9A\x6E" => "\xEC\x89\x97",
		"\x9A\x6F" => "\xEC\x89\x99",
		"\x9A\x70" => "\xEC\x89\x9A",
		"\x9A\x71" => "\xEC\x89\x9B",
		"\x9A\x72" => "\xEC\x89\x9C",
		"\x9A\x73" => "\xEC\x89\x9D",
		"\x9A\x74" => "\xEC\x89\x9E",
		"\x9A\x75" => "\xEC\x89\x9F",
		"\x9A\x76" => "\xEC\x89\xA1",
		"\x9A\x77" => "\xEC\x89\xA2",
		"\x9A\x78" => "\xEC\x89\xA3",
		"\x9A\x79" => "\xEC\x89\xA4",
		"\x9A\x7A" => "\xEC\x89\xA6",
		"\x9A\x81" => "\xEC\x89\xA7",
		"\x9A\x82" => "\xEC\x89\xA8",
		"\x9A\x83" => "\xEC\x89\xA9",
		"\x9A\x84" => "\xEC\x89\xAA",
		"\x9A\x85" => "\xEC\x89\xAB",
		"\x9A\x86" => "\xEC\x89\xAE",
		"\x9A\x87" => "\xEC\x89\xAF",
		"\x9A\x88" => "\xEC\x89\xB1",
		"\x9A\x89" => "\xEC\x89\xB2",
		"\x9A\x8A" => "\xEC\x89\xB3",
		"\x9A\x8B" => "\xEC\x89\xB5",
		"\x9A\x8C" => "\xEC\x89\xB6",
		"\x9A\x8D" => "\xEC\x89\xB7",
		"\x9A\x8E" => "\xEC\x89\xB8",
		"\x9A\x8F" => "\xEC\x89\xB9",
		"\x9A\x90" => "\xEC\x89\xBA",
		"\x9A\x91" => "\xEC\x89\xBB",
		"\x9A\x92" => "\xEC\x89\xBE",
		"\x9A\x93" => "\xEC\x8A\x80",
		"\x9A\x94" => "\xEC\x8A\x82",
		"\x9A\x95" => "\xEC\x8A\x83",
		"\x9A\x96" => "\xEC\x8A\x84",
		"\x9A\x97" => "\xEC\x8A\x85",
		"\x9A\x98" => "\xEC\x8A\x86",
		"\x9A\x99" => "\xEC\x8A\x87",
		"\x9A\x9A" => "\xEC\x8A\x8A",
		"\x9A\x9B" => "\xEC\x8A\x8B",
		"\x9A\x9C" => "\xEC\x8A\x8C",
		"\x9A\x9D" => "\xEC\x8A\x8D",
		"\x9A\x9E" => "\xEC\x8A\x8E",
		"\x9A\x9F" => "\xEC\x8A\x8F",
		"\x9A\xA0" => "\xEC\x8A\x91",
		"\x9A\xA1" => "\xEC\x8A\x92",
		"\x9A\xA2" => "\xEC\x8A\x93",
		"\x9A\xA3" => "\xEC\x8A\x94",
		"\x9A\xA4" => "\xEC\x8A\x95",
		"\x9A\xA5" => "\xEC\x8A\x96",
		"\x9A\xA6" => "\xEC\x8A\x97",
		"\x9A\xA7" => "\xEC\x8A\x99",
		"\x9A\xA8" => "\xEC\x8A\x9A",
		"\x9A\xA9" => "\xEC\x8A\x9C",
		"\x9A\xAA" => "\xEC\x8A\x9E",
		"\x9A\xAB" => "\xEC\x8A\x9F",
		"\x9A\xAC" => "\xEC\x8A\xA0",
		"\x9A\xAD" => "\xEC\x8A\xA1",
		"\x9A\xAE" => "\xEC\x8A\xA2",
		"\x9A\xAF" => "\xEC\x8A\xA3",
		"\x9A\xB0" => "\xEC\x8A\xA6",
		"\x9A\xB1" => "\xEC\x8A\xA7",
		"\x9A\xB2" => "\xEC\x8A\xA9",
		"\x9A\xB3" => "\xEC\x8A\xAA",
		"\x9A\xB4" => "\xEC\x8A\xAB",
		"\x9A\xB5" => "\xEC\x8A\xAE",
		"\x9A\xB6" => "\xEC\x8A\xAF",
		"\x9A\xB7" => "\xEC\x8A\xB0",
		"\x9A\xB8" => "\xEC\x8A\xB1",
		"\x9A\xB9" => "\xEC\x8A\xB2",
		"\x9A\xBA" => "\xEC\x8A\xB3",
		"\x9A\xBB" => "\xEC\x8A\xB6",
		"\x9A\xBC" => "\xEC\x8A\xB8",
		"\x9A\xBD" => "\xEC\x8A\xBA",
		"\x9A\xBE" => "\xEC\x8A\xBB",
		"\x9A\xBF" => "\xEC\x8A\xBC",
		"\x9A\xC0" => "\xEC\x8A\xBD",
		"\x9A\xC1" => "\xEC\x8A\xBE",
		"\x9A\xC2" => "\xEC\x8A\xBF",
		"\x9A\xC3" => "\xEC\x8B\x80",
		"\x9A\xC4" => "\xEC\x8B\x81",
		"\x9A\xC5" => "\xEC\x8B\x82",
		"\x9A\xC6" => "\xEC\x8B\x83",
		"\x9A\xC7" => "\xEC\x8B\x84",
		"\x9A\xC8" => "\xEC\x8B\x85",
		"\x9A\xC9" => "\xEC\x8B\x86",
		"\x9A\xCA" => "\xEC\x8B\x87",
		"\x9A\xCB" => "\xEC\x8B\x88",
		"\x9A\xCC" => "\xEC\x8B\x89",
		"\x9A\xCD" => "\xEC\x8B\x8A",
		"\x9A\xCE" => "\xEC\x8B\x8B",
		"\x9A\xCF" => "\xEC\x8B\x8C",
		"\x9A\xD0" => "\xEC\x8B\x8D",
		"\x9A\xD1" => "\xEC\x8B\x8E",
		"\x9A\xD2" => "\xEC\x8B\x8F",
		"\x9A\xD3" => "\xEC\x8B\x90",
		"\x9A\xD4" => "\xEC\x8B\x91",
		"\x9A\xD5" => "\xEC\x8B\x92",
		"\x9A\xD6" => "\xEC\x8B\x93",
		"\x9A\xD7" => "\xEC\x8B\x94",
		"\x9A\xD8" => "\xEC\x8B\x95",
		"\x9A\xD9" => "\xEC\x8B\x96",
		"\x9A\xDA" => "\xEC\x8B\x97",
		"\x9A\xDB" => "\xEC\x8B\x98",
		"\x9A\xDC" => "\xEC\x8B\x99",
		"\x9A\xDD" => "\xEC\x8B\x9A",
		"\x9A\xDE" => "\xEC\x8B\x9B",
		"\x9A\xDF" => "\xEC\x8B\x9E",
		"\x9A\xE0" => "\xEC\x8B\x9F",
		"\x9A\xE1" => "\xEC\x8B\xA1",
		"\x9A\xE2" => "\xEC\x8B\xA2",
		"\x9A\xE3" => "\xEC\x8B\xA5",
		"\x9A\xE4" => "\xEC\x8B\xA6",
		"\x9A\xE5" => "\xEC\x8B\xA7",
		"\x9A\xE6" => "\xEC\x8B\xA8",
		"\x9A\xE7" => "\xEC\x8B\xA9",
		"\x9A\xE8" => "\xEC\x8B\xAA",
		"\x9A\xE9" => "\xEC\x8B\xAE",
		"\x9A\xEA" => "\xEC\x8B\xB0",
		"\x9A\xEB" => "\xEC\x8B\xB2",
		"\x9A\xEC" => "\xEC\x8B\xB3",
		"\x9A\xED" => "\xEC\x8B\xB4",
		"\x9A\xEE" => "\xEC\x8B\xB5",
		"\x9A\xEF" => "\xEC\x8B\xB7",
		"\x9A\xF0" => "\xEC\x8B\xBA",
		"\x9A\xF1" => "\xEC\x8B\xBD",
		"\x9A\xF2" => "\xEC\x8B\xBE",
		"\x9A\xF3" => "\xEC\x8B\xBF",
		"\x9A\xF4" => "\xEC\x8C\x81",
		"\x9A\xF5" => "\xEC\x8C\x82",
		"\x9A\xF6" => "\xEC\x8C\x83",
		"\x9A\xF7" => "\xEC\x8C\x84",
		"\x9A\xF8" => "\xEC\x8C\x85",
		"\x9A\xF9" => "\xEC\x8C\x86",
		"\x9A\xFA" => "\xEC\x8C\x87",
		"\x9A\xFB" => "\xEC\x8C\x8A",
		"\x9A\xFC" => "\xEC\x8C\x8B",
		"\x9A\xFD" => "\xEC\x8C\x8E",
		"\x9A\xFE" => "\xEC\x8C\x8F",
		"\x9B\x41" => "\xEC\x8C\x90",
		"\x9B\x42" => "\xEC\x8C\x91",
		"\x9B\x43" => "\xEC\x8C\x92",
		"\x9B\x44" => "\xEC\x8C\x96",
		"\x9B\x45" => "\xEC\x8C\x97",
		"\x9B\x46" => "\xEC\x8C\x99",
		"\x9B\x47" => "\xEC\x8C\x9A",
		"\x9B\x48" => "\xEC\x8C\x9B",
		"\x9B\x49" => "\xEC\x8C\x9D",
		"\x9B\x4A" => "\xEC\x8C\x9E",
		"\x9B\x4B" => "\xEC\x8C\x9F",
		"\x9B\x4C" => "\xEC\x8C\xA0",
		"\x9B\x4D" => "\xEC\x8C\xA1",
		"\x9B\x4E" => "\xEC\x8C\xA2",
		"\x9B\x4F" => "\xEC\x8C\xA3",
		"\x9B\x50" => "\xEC\x8C\xA6",
		"\x9B\x51" => "\xEC\x8C\xA7",
		"\x9B\x52" => "\xEC\x8C\xAA",
		"\x9B\x53" => "\xEC\x8C\xAB",
		"\x9B\x54" => "\xEC\x8C\xAC",
		"\x9B\x55" => "\xEC\x8C\xAD",
		"\x9B\x56" => "\xEC\x8C\xAE",
		"\x9B\x57" => "\xEC\x8C\xAF",
		"\x9B\x58" => "\xEC\x8C\xB0",
		"\x9B\x59" => "\xEC\x8C\xB1",
		"\x9B\x5A" => "\xEC\x8C\xB2",
		"\x9B\x61" => "\xEC\x8C\xB3",
		"\x9B\x62" => "\xEC\x8C\xB4",
		"\x9B\x63" => "\xEC\x8C\xB5",
		"\x9B\x64" => "\xEC\x8C\xB6",
		"\x9B\x65" => "\xEC\x8C\xB7",
		"\x9B\x66" => "\xEC\x8C\xB8",
		"\x9B\x67" => "\xEC\x8C\xB9",
		"\x9B\x68" => "\xEC\x8C\xBA",
		"\x9B\x69" => "\xEC\x8C\xBB",
		"\x9B\x6A" => "\xEC\x8C\xBC",
		"\x9B\x6B" => "\xEC\x8C\xBD",
		"\x9B\x6C" => "\xEC\x8C\xBE",
		"\x9B\x6D" => "\xEC\x8C\xBF",
		"\x9B\x6E" => "\xEC\x8D\x80",
		"\x9B\x6F" => "\xEC\x8D\x81",
		"\x9B\x70" => "\xEC\x8D\x82",
		"\x9B\x71" => "\xEC\x8D\x83",
		"\x9B\x72" => "\xEC\x8D\x84",
		"\x9B\x73" => "\xEC\x8D\x86",
		"\x9B\x74" => "\xEC\x8D\x87",
		"\x9B\x75" => "\xEC\x8D\x88",
		"\x9B\x76" => "\xEC\x8D\x89",
		"\x9B\x77" => "\xEC\x8D\x8A",
		"\x9B\x78" => "\xEC\x8D\x8B",
		"\x9B\x79" => "\xEC\x8D\x8C",
		"\x9B\x7A" => "\xEC\x8D\x8D",
		"\x9B\x81" => "\xEC\x8D\x8E",
		"\x9B\x82" => "\xEC\x8D\x8F",
		"\x9B\x83" => "\xEC\x8D\x90",
		"\x9B\x84" => "\xEC\x8D\x91",
		"\x9B\x85" => "\xEC\x8D\x92",
		"\x9B\x86" => "\xEC\x8D\x93",
		"\x9B\x87" => "\xEC\x8D\x94",
		"\x9B\x88" => "\xEC\x8D\x95",
		"\x9B\x89" => "\xEC\x8D\x96",
		"\x9B\x8A" => "\xEC\x8D\x97",
		"\x9B\x8B" => "\xEC\x8D\x98",
		"\x9B\x8C" => "\xEC\x8D\x99",
		"\x9B\x8D" => "\xEC\x8D\x9A",
		"\x9B\x8E" => "\xEC\x8D\x9B",
		"\x9B\x8F" => "\xEC\x8D\x9C",
		"\x9B\x90" => "\xEC\x8D\x9D",
		"\x9B\x91" => "\xEC\x8D\x9E",
		"\x9B\x92" => "\xEC\x8D\x9F",
		"\x9B\x93" => "\xEC\x8D\xA0",
		"\x9B\x94" => "\xEC\x8D\xA1",
		"\x9B\x95" => "\xEC\x8D\xA2",
		"\x9B\x96" => "\xEC\x8D\xA3",
		"\x9B\x97" => "\xEC\x8D\xA4",
		"\x9B\x98" => "\xEC\x8D\xA5",
		"\x9B\x99" => "\xEC\x8D\xA6",
		"\x9B\x9A" => "\xEC\x8D\xA7",
		"\x9B\x9B" => "\xEC\x8D\xAA",
		"\x9B\x9C" => "\xEC\x8D\xAB",
		"\x9B\x9D" => "\xEC\x8D\xAD",
		"\x9B\x9E" => "\xEC\x8D\xAE",
		"\x9B\x9F" => "\xEC\x8D\xAF",
		"\x9B\xA0" => "\xEC\x8D\xB1",
		"\x9B\xA1" => "\xEC\x8D\xB3",
		"\x9B\xA2" => "\xEC\x8D\xB4",
		"\x9B\xA3" => "\xEC\x8D\xB5",
		"\x9B\xA4" => "\xEC\x8D\xB6",
		"\x9B\xA5" => "\xEC\x8D\xB7",
		"\x9B\xA6" => "\xEC\x8D\xBA",
		"\x9B\xA7" => "\xEC\x8D\xBB",
		"\x9B\xA8" => "\xEC\x8D\xBE",
		"\x9B\xA9" => "\xEC\x8D\xBF",
		"\x9B\xAA" => "\xEC\x8E\x80",
		"\x9B\xAB" => "\xEC\x8E\x81",
		"\x9B\xAC" => "\xEC\x8E\x82",
		"\x9B\xAD" => "\xEC\x8E\x83",
		"\x9B\xAE" => "\xEC\x8E\x85",
		"\x9B\xAF" => "\xEC\x8E\x86",
		"\x9B\xB0" => "\xEC\x8E\x87",
		"\x9B\xB1" => "\xEC\x8E\x89",
		"\x9B\xB2" => "\xEC\x8E\x8A",
		"\x9B\xB3" => "\xEC\x8E\x8B",
		"\x9B\xB4" => "\xEC\x8E\x8D",
		"\x9B\xB5" => "\xEC\x8E\x8E",
		"\x9B\xB6" => "\xEC\x8E\x8F",
		"\x9B\xB7" => "\xEC\x8E\x90",
		"\x9B\xB8" => "\xEC\x8E\x91",
		"\x9B\xB9" => "\xEC\x8E\x92",
		"\x9B\xBA" => "\xEC\x8E\x93",
		"\x9B\xBB" => "\xEC\x8E\x94",
		"\x9B\xBC" => "\xEC\x8E\x95",
		"\x9B\xBD" => "\xEC\x8E\x96",
		"\x9B\xBE" => "\xEC\x8E\x97",
		"\x9B\xBF" => "\xEC\x8E\x98",
		"\x9B\xC0" => "\xEC\x8E\x99",
		"\x9B\xC1" => "\xEC\x8E\x9A",
		"\x9B\xC2" => "\xEC\x8E\x9B",
		"\x9B\xC3" => "\xEC\x8E\x9C",
		"\x9B\xC4" => "\xEC\x8E\x9D",
		"\x9B\xC5" => "\xEC\x8E\x9E",
		"\x9B\xC6" => "\xEC\x8E\x9F",
		"\x9B\xC7" => "\xEC\x8E\xA0",
		"\x9B\xC8" => "\xEC\x8E\xA1",
		"\x9B\xC9" => "\xEC\x8E\xA2",
		"\x9B\xCA" => "\xEC\x8E\xA3",
		"\x9B\xCB" => "\xEC\x8E\xA4",
		"\x9B\xCC" => "\xEC\x8E\xA5",
		"\x9B\xCD" => "\xEC\x8E\xA6",
		"\x9B\xCE" => "\xEC\x8E\xA7",
		"\x9B\xCF" => "\xEC\x8E\xA8",
		"\x9B\xD0" => "\xEC\x8E\xA9",
		"\x9B\xD1" => "\xEC\x8E\xAA",
		"\x9B\xD2" => "\xEC\x8E\xAB",
		"\x9B\xD3" => "\xEC\x8E\xAC",
		"\x9B\xD4" => "\xEC\x8E\xAD",
		"\x9B\xD5" => "\xEC\x8E\xAE",
		"\x9B\xD6" => "\xEC\x8E\xAF",
		"\x9B\xD7" => "\xEC\x8E\xB0",
		"\x9B\xD8" => "\xEC\x8E\xB1",
		"\x9B\xD9" => "\xEC\x8E\xB2",
		"\x9B\xDA" => "\xEC\x8E\xB3",
		"\x9B\xDB" => "\xEC\x8E\xB4",
		"\x9B\xDC" => "\xEC\x8E\xB5",
		"\x9B\xDD" => "\xEC\x8E\xB6",
		"\x9B\xDE" => "\xEC\x8E\xB7",
		"\x9B\xDF" => "\xEC\x8E\xB8",
		"\x9B\xE0" => "\xEC\x8E\xB9",
		"\x9B\xE1" => "\xEC\x8E\xBA",
		"\x9B\xE2" => "\xEC\x8E\xBB",
		"\x9B\xE3" => "\xEC\x8E\xBC",
		"\x9B\xE4" => "\xEC\x8E\xBD",
		"\x9B\xE5" => "\xEC\x8E\xBE",
		"\x9B\xE6" => "\xEC\x8E\xBF",
		"\x9B\xE7" => "\xEC\x8F\x81",
		"\x9B\xE8" => "\xEC\x8F\x82",
		"\x9B\xE9" => "\xEC\x8F\x83",
		"\x9B\xEA" => "\xEC\x8F\x84",
		"\x9B\xEB" => "\xEC\x8F\x85",
		"\x9B\xEC" => "\xEC\x8F\x86",
		"\x9B\xED" => "\xEC\x8F\x87",
		"\x9B\xEE" => "\xEC\x8F\x88",
		"\x9B\xEF" => "\xEC\x8F\x89",
		"\x9B\xF0" => "\xEC\x8F\x8A",
		"\x9B\xF1" => "\xEC\x8F\x8B",
		"\x9B\xF2" => "\xEC\x8F\x8C",
		"\x9B\xF3" => "\xEC\x8F\x8D",
		"\x9B\xF4" => "\xEC\x8F\x8E",
		"\x9B\xF5" => "\xEC\x8F\x8F",
		"\x9B\xF6" => "\xEC\x8F\x90",
		"\x9B\xF7" => "\xEC\x8F\x91",
		"\x9B\xF8" => "\xEC\x8F\x92",
		"\x9B\xF9" => "\xEC\x8F\x93",
		"\x9B\xFA" => "\xEC\x8F\x94",
		"\x9B\xFB" => "\xEC\x8F\x95",
		"\x9B\xFC" => "\xEC\x8F\x96",
		"\x9B\xFD" => "\xEC\x8F\x97",
		"\x9B\xFE" => "\xEC\x8F\x9A",
		"\x9C\x41" => "\xEC\x8F\x9B",
		"\x9C\x42" => "\xEC\x8F\x9D",
		"\x9C\x43" => "\xEC\x8F\x9E",
		"\x9C\x44" => "\xEC\x8F\xA1",
		"\x9C\x45" => "\xEC\x8F\xA3",
		"\x9C\x46" => "\xEC\x8F\xA4",
		"\x9C\x47" => "\xEC\x8F\xA5",
		"\x9C\x48" => "\xEC\x8F\xA6",
		"\x9C\x49" => "\xEC\x8F\xA7",
		"\x9C\x4A" => "\xEC\x8F\xAA",
		"\x9C\x4B" => "\xEC\x8F\xAB",
		"\x9C\x4C" => "\xEC\x8F\xAC",
		"\x9C\x4D" => "\xEC\x8F\xAE",
		"\x9C\x4E" => "\xEC\x8F\xAF",
		"\x9C\x4F" => "\xEC\x8F\xB0",
		"\x9C\x50" => "\xEC\x8F\xB1",
		"\x9C\x51" => "\xEC\x8F\xB2",
		"\x9C\x52" => "\xEC\x8F\xB3",
		"\x9C\x53" => "\xEC\x8F\xB6",
		"\x9C\x54" => "\xEC\x8F\xB7",
		"\x9C\x55" => "\xEC\x8F\xB9",
		"\x9C\x56" => "\xEC\x8F\xBA",
		"\x9C\x57" => "\xEC\x8F\xBB",
		"\x9C\x58" => "\xEC\x8F\xBC",
		"\x9C\x59" => "\xEC\x8F\xBD",
		"\x9C\x5A" => "\xEC\x8F\xBE",
		"\x9C\x61" => "\xEC\x8F\xBF",
		"\x9C\x62" => "\xEC\x90\x80",
		"\x9C\x63" => "\xEC\x90\x81",
		"\x9C\x64" => "\xEC\x90\x82",
		"\x9C\x65" => "\xEC\x90\x83",
		"\x9C\x66" => "\xEC\x90\x84",
		"\x9C\x67" => "\xEC\x90\x85",
		"\x9C\x68" => "\xEC\x90\x86",
		"\x9C\x69" => "\xEC\x90\x87",
		"\x9C\x6A" => "\xEC\x90\x89",
		"\x9C\x6B" => "\xEC\x90\x8A",
		"\x9C\x6C" => "\xEC\x90\x8B",
		"\x9C\x6D" => "\xEC\x90\x8C",
		"\x9C\x6E" => "\xEC\x90\x8D",
		"\x9C\x6F" => "\xEC\x90\x8E",
		"\x9C\x70" => "\xEC\x90\x8F",
		"\x9C\x71" => "\xEC\x90\x91",
		"\x9C\x72" => "\xEC\x90\x92",
		"\x9C\x73" => "\xEC\x90\x93",
		"\x9C\x74" => "\xEC\x90\x94",
		"\x9C\x75" => "\xEC\x90\x95",
		"\x9C\x76" => "\xEC\x90\x96",
		"\x9C\x77" => "\xEC\x90\x97",
		"\x9C\x78" => "\xEC\x90\x98",
		"\x9C\x79" => "\xEC\x90\x99",
		"\x9C\x7A" => "\xEC\x90\x9A",
		"\x9C\x81" => "\xEC\x90\x9B",
		"\x9C\x82" => "\xEC\x90\x9C",
		"\x9C\x83" => "\xEC\x90\x9D",
		"\x9C\x84" => "\xEC\x90\x9E",
		"\x9C\x85" => "\xEC\x90\x9F",
		"\x9C\x86" => "\xEC\x90\xA0",
		"\x9C\x87" => "\xEC\x90\xA1",
		"\x9C\x88" => "\xEC\x90\xA2",
		"\x9C\x89" => "\xEC\x90\xA3",
		"\x9C\x8A" => "\xEC\x90\xA5",
		"\x9C\x8B" => "\xEC\x90\xA6",
		"\x9C\x8C" => "\xEC\x90\xA7",
		"\x9C\x8D" => "\xEC\x90\xA8",
		"\x9C\x8E" => "\xEC\x90\xA9",
		"\x9C\x8F" => "\xEC\x90\xAA",
		"\x9C\x90" => "\xEC\x90\xAB",
		"\x9C\x91" => "\xEC\x90\xAD",
		"\x9C\x92" => "\xEC\x90\xAE",
		"\x9C\x93" => "\xEC\x90\xAF",
		"\x9C\x94" => "\xEC\x90\xB1",
		"\x9C\x95" => "\xEC\x90\xB2",
		"\x9C\x96" => "\xEC\x90\xB3",
		"\x9C\x97" => "\xEC\x90\xB5",
		"\x9C\x98" => "\xEC\x90\xB6",
		"\x9C\x99" => "\xEC\x90\xB7",
		"\x9C\x9A" => "\xEC\x90\xB8",
		"\x9C\x9B" => "\xEC\x90\xB9",
		"\x9C\x9C" => "\xEC\x90\xBA",
		"\x9C\x9D" => "\xEC\x90\xBB",
		"\x9C\x9E" => "\xEC\x90\xBE",
		"\x9C\x9F" => "\xEC\x90\xBF",
		"\x9C\xA0" => "\xEC\x91\x80",
		"\x9C\xA1" => "\xEC\x91\x81",
		"\x9C\xA2" => "\xEC\x91\x82",
		"\x9C\xA3" => "\xEC\x91\x83",
		"\x9C\xA4" => "\xEC\x91\x84",
		"\x9C\xA5" => "\xEC\x91\x85",
		"\x9C\xA6" => "\xEC\x91\x86",
		"\x9C\xA7" => "\xEC\x91\x87",
		"\x9C\xA8" => "\xEC\x91\x89",
		"\x9C\xA9" => "\xEC\x91\x8A",
		"\x9C\xAA" => "\xEC\x91\x8B",
		"\x9C\xAB" => "\xEC\x91\x8C",
		"\x9C\xAC" => "\xEC\x91\x8D",
		"\x9C\xAD" => "\xEC\x91\x8E",
		"\x9C\xAE" => "\xEC\x91\x8F",
		"\x9C\xAF" => "\xEC\x91\x90",
		"\x9C\xB0" => "\xEC\x91\x91",
		"\x9C\xB1" => "\xEC\x91\x92",
		"\x9C\xB2" => "\xEC\x91\x93",
		"\x9C\xB3" => "\xEC\x91\x94",
		"\x9C\xB4" => "\xEC\x91\x95",
		"\x9C\xB5" => "\xEC\x91\x96",
		"\x9C\xB6" => "\xEC\x91\x97",
		"\x9C\xB7" => "\xEC\x91\x98",
		"\x9C\xB8" => "\xEC\x91\x99",
		"\x9C\xB9" => "\xEC\x91\x9A",
		"\x9C\xBA" => "\xEC\x91\x9B",
		"\x9C\xBB" => "\xEC\x91\x9C",
		"\x9C\xBC" => "\xEC\x91\x9D",
		"\x9C\xBD" => "\xEC\x91\x9E",
		"\x9C\xBE" => "\xEC\x91\x9F",
		"\x9C\xBF" => "\xEC\x91\xA0",
		"\x9C\xC0" => "\xEC\x91\xA1",
		"\x9C\xC1" => "\xEC\x91\xA2",
		"\x9C\xC2" => "\xEC\x91\xA3",
		"\x9C\xC3" => "\xEC\x91\xA6",
		"\x9C\xC4" => "\xEC\x91\xA7",
		"\x9C\xC5" => "\xEC\x91\xA9",
		"\x9C\xC6" => "\xEC\x91\xAA",
		"\x9C\xC7" => "\xEC\x91\xAB",
		"\x9C\xC8" => "\xEC\x91\xAD",
		"\x9C\xC9" => "\xEC\x91\xAE",
		"\x9C\xCA" => "\xEC\x91\xAF",
		"\x9C\xCB" => "\xEC\x91\xB0",
		"\x9C\xCC" => "\xEC\x91\xB1",
		"\x9C\xCD" => "\xEC\x91\xB2",
		"\x9C\xCE" => "\xEC\x91\xB3",
		"\x9C\xCF" => "\xEC\x91\xB6",
		"\x9C\xD0" => "\xEC\x91\xB7",
		"\x9C\xD1" => "\xEC\x91\xB8",
		"\x9C\xD2" => "\xEC\x91\xBA",
		"\x9C\xD3" => "\xEC\x91\xBB",
		"\x9C\xD4" => "\xEC\x91\xBC",
		"\x9C\xD5" => "\xEC\x91\xBD",
		"\x9C\xD6" => "\xEC\x91\xBE",
		"\x9C\xD7" => "\xEC\x91\xBF",
		"\x9C\xD8" => "\xEC\x92\x81",
		"\x9C\xD9" => "\xEC\x92\x82",
		"\x9C\xDA" => "\xEC\x92\x83",
		"\x9C\xDB" => "\xEC\x92\x84",
		"\x9C\xDC" => "\xEC\x92\x85",
		"\x9C\xDD" => "\xEC\x92\x86",
		"\x9C\xDE" => "\xEC\x92\x87",
		"\x9C\xDF" => "\xEC\x92\x88",
		"\x9C\xE0" => "\xEC\x92\x89",
		"\x9C\xE1" => "\xEC\x92\x8A",
		"\x9C\xE2" => "\xEC\x92\x8B",
		"\x9C\xE3" => "\xEC\x92\x8C",
		"\x9C\xE4" => "\xEC\x92\x8D",
		"\x9C\xE5" => "\xEC\x92\x8E",
		"\x9C\xE6" => "\xEC\x92\x8F",
		"\x9C\xE7" => "\xEC\x92\x90",
		"\x9C\xE8" => "\xEC\x92\x91",
		"\x9C\xE9" => "\xEC\x92\x92",
		"\x9C\xEA" => "\xEC\x92\x93",
		"\x9C\xEB" => "\xEC\x92\x95",
		"\x9C\xEC" => "\xEC\x92\x96",
		"\x9C\xED" => "\xEC\x92\x97",
		"\x9C\xEE" => "\xEC\x92\x98",
		"\x9C\xEF" => "\xEC\x92\x99",
		"\x9C\xF0" => "\xEC\x92\x9A",
		"\x9C\xF1" => "\xEC\x92\x9B",
		"\x9C\xF2" => "\xEC\x92\x9D",
		"\x9C\xF3" => "\xEC\x92\x9E",
		"\x9C\xF4" => "\xEC\x92\x9F",
		"\x9C\xF5" => "\xEC\x92\xA0",
		"\x9C\xF6" => "\xEC\x92\xA1",
		"\x9C\xF7" => "\xEC\x92\xA2",
		"\x9C\xF8" => "\xEC\x92\xA3",
		"\x9C\xF9" => "\xEC\x92\xA4",
		"\x9C\xFA" => "\xEC\x92\xA5",
		"\x9C\xFB" => "\xEC\x92\xA6",
		"\x9C\xFC" => "\xEC\x92\xA7",
		"\x9C\xFD" => "\xEC\x92\xA8",
		"\x9C\xFE" => "\xEC\x92\xA9",
		"\x9D\x41" => "\xEC\x92\xAA",
		"\x9D\x42" => "\xEC\x92\xAB",
		"\x9D\x43" => "\xEC\x92\xAC",
		"\x9D\x44" => "\xEC\x92\xAD",
		"\x9D\x45" => "\xEC\x92\xAE",
		"\x9D\x46" => "\xEC\x92\xAF",
		"\x9D\x47" => "\xEC\x92\xB0",
		"\x9D\x48" => "\xEC\x92\xB1",
		"\x9D\x49" => "\xEC\x92\xB2",
		"\x9D\x4A" => "\xEC\x92\xB3",
		"\x9D\x4B" => "\xEC\x92\xB4",
		"\x9D\x4C" => "\xEC\x92\xB5",
		"\x9D\x4D" => "\xEC\x92\xB6",
		"\x9D\x4E" => "\xEC\x92\xB7",
		"\x9D\x4F" => "\xEC\x92\xB9",
		"\x9D\x50" => "\xEC\x92\xBA",
		"\x9D\x51" => "\xEC\x92\xBB",
		"\x9D\x52" => "\xEC\x92\xBD",
		"\x9D\x53" => "\xEC\x92\xBE",
		"\x9D\x54" => "\xEC\x92\xBF",
		"\x9D\x55" => "\xEC\x93\x80",
		"\x9D\x56" => "\xEC\x93\x81",
		"\x9D\x57" => "\xEC\x93\x82",
		"\x9D\x58" => "\xEC\x93\x83",
		"\x9D\x59" => "\xEC\x93\x84",
		"\x9D\x5A" => "\xEC\x93\x85",
		"\x9D\x61" => "\xEC\x93\x86",
		"\x9D\x62" => "\xEC\x93\x87",
		"\x9D\x63" => "\xEC\x93\x88",
		"\x9D\x64" => "\xEC\x93\x89",
		"\x9D\x65" => "\xEC\x93\x8A",
		"\x9D\x66" => "\xEC\x93\x8B",
		"\x9D\x67" => "\xEC\x93\x8C",
		"\x9D\x68" => "\xEC\x93\x8D",
		"\x9D\x69" => "\xEC\x93\x8E",
		"\x9D\x6A" => "\xEC\x93\x8F",
		"\x9D\x6B" => "\xEC\x93\x90",
		"\x9D\x6C" => "\xEC\x93\x91",
		"\x9D\x6D" => "\xEC\x93\x92",
		"\x9D\x6E" => "\xEC\x93\x93",
		"\x9D\x6F" => "\xEC\x93\x94",
		"\x9D\x70" => "\xEC\x93\x95",
		"\x9D\x71" => "\xEC\x93\x96",
		"\x9D\x72" => "\xEC\x93\x97",
		"\x9D\x73" => "\xEC\x93\x98",
		"\x9D\x74" => "\xEC\x93\x99",
		"\x9D\x75" => "\xEC\x93\x9A",
		"\x9D\x76" => "\xEC\x93\x9B",
		"\x9D\x77" => "\xEC\x93\x9C",
		"\x9D\x78" => "\xEC\x93\x9D",
		"\x9D\x79" => "\xEC\x93\x9E",
		"\x9D\x7A" => "\xEC\x93\x9F",
		"\x9D\x81" => "\xEC\x93\xA0",
		"\x9D\x82" => "\xEC\x93\xA1",
		"\x9D\x83" => "\xEC\x93\xA2",
		"\x9D\x84" => "\xEC\x93\xA3",
		"\x9D\x85" => "\xEC\x93\xA4",
		"\x9D\x86" => "\xEC\x93\xA5",
		"\x9D\x87" => "\xEC\x93\xA6",
		"\x9D\x88" => "\xEC\x93\xA7",
		"\x9D\x89" => "\xEC\x93\xA8",
		"\x9D\x8A" => "\xEC\x93\xAA",
		"\x9D\x8B" => "\xEC\x93\xAB",
		"\x9D\x8C" => "\xEC\x93\xAC",
		"\x9D\x8D" => "\xEC\x93\xAD",
		"\x9D\x8E" => "\xEC\x93\xAE",
		"\x9D\x8F" => "\xEC\x93\xAF",
		"\x9D\x90" => "\xEC\x93\xB2",
		"\x9D\x91" => "\xEC\x93\xB3",
		"\x9D\x92" => "\xEC\x93\xB5",
		"\x9D\x93" => "\xEC\x93\xB6",
		"\x9D\x94" => "\xEC\x93\xB7",
		"\x9D\x95" => "\xEC\x93\xB9",
		"\x9D\x96" => "\xEC\x93\xBB",
		"\x9D\x97" => "\xEC\x93\xBC",
		"\x9D\x98" => "\xEC\x93\xBD",
		"\x9D\x99" => "\xEC\x93\xBE",
		"\x9D\x9A" => "\xEC\x94\x82",
		"\x9D\x9B" => "\xEC\x94\x83",
		"\x9D\x9C" => "\xEC\x94\x84",
		"\x9D\x9D" => "\xEC\x94\x85",
		"\x9D\x9E" => "\xEC\x94\x86",
		"\x9D\x9F" => "\xEC\x94\x87",
		"\x9D\xA0" => "\xEC\x94\x88",
		"\x9D\xA1" => "\xEC\x94\x89",
		"\x9D\xA2" => "\xEC\x94\x8A",
		"\x9D\xA3" => "\xEC\x94\x8B",
		"\x9D\xA4" => "\xEC\x94\x8D",
		"\x9D\xA5" => "\xEC\x94\x8E",
		"\x9D\xA6" => "\xEC\x94\x8F",
		"\x9D\xA7" => "\xEC\x94\x91",
		"\x9D\xA8" => "\xEC\x94\x92",
		"\x9D\xA9" => "\xEC\x94\x93",
		"\x9D\xAA" => "\xEC\x94\x95",
		"\x9D\xAB" => "\xEC\x94\x96",
		"\x9D\xAC" => "\xEC\x94\x97",
		"\x9D\xAD" => "\xEC\x94\x98",
		"\x9D\xAE" => "\xEC\x94\x99",
		"\x9D\xAF" => "\xEC\x94\x9A",
		"\x9D\xB0" => "\xEC\x94\x9B",
		"\x9D\xB1" => "\xEC\x94\x9D",
		"\x9D\xB2" => "\xEC\x94\x9E",
		"\x9D\xB3" => "\xEC\x94\x9F",
		"\x9D\xB4" => "\xEC\x94\xA0",
		"\x9D\xB5" => "\xEC\x94\xA1",
		"\x9D\xB6" => "\xEC\x94\xA2",
		"\x9D\xB7" => "\xEC\x94\xA3",
		"\x9D\xB8" => "\xEC\x94\xA4",
		"\x9D\xB9" => "\xEC\x94\xA5",
		"\x9D\xBA" => "\xEC\x94\xA6",
		"\x9D\xBB" => "\xEC\x94\xA7",
		"\x9D\xBC" => "\xEC\x94\xAA",
		"\x9D\xBD" => "\xEC\x94\xAB",
		"\x9D\xBE" => "\xEC\x94\xAD",
		"\x9D\xBF" => "\xEC\x94\xAE",
		"\x9D\xC0" => "\xEC\x94\xAF",
		"\x9D\xC1" => "\xEC\x94\xB1",
		"\x9D\xC2" => "\xEC\x94\xB2",
		"\x9D\xC3" => "\xEC\x94\xB3",
		"\x9D\xC4" => "\xEC\x94\xB4",
		"\x9D\xC5" => "\xEC\x94\xB5",
		"\x9D\xC6" => "\xEC\x94\xB6",
		"\x9D\xC7" => "\xEC\x94\xB7",
		"\x9D\xC8" => "\xEC\x94\xBA",
		"\x9D\xC9" => "\xEC\x94\xBC",
		"\x9D\xCA" => "\xEC\x94\xBE",
		"\x9D\xCB" => "\xEC\x94\xBF",
		"\x9D\xCC" => "\xEC\x95\x80",
		"\x9D\xCD" => "\xEC\x95\x81",
		"\x9D\xCE" => "\xEC\x95\x82",
		"\x9D\xCF" => "\xEC\x95\x83",
		"\x9D\xD0" => "\xEC\x95\x86",
		"\x9D\xD1" => "\xEC\x95\x87",
		"\x9D\xD2" => "\xEC\x95\x8B",
		"\x9D\xD3" => "\xEC\x95\x8F",
		"\x9D\xD4" => "\xEC\x95\x90",
		"\x9D\xD5" => "\xEC\x95\x91",
		"\x9D\xD6" => "\xEC\x95\x92",
		"\x9D\xD7" => "\xEC\x95\x96",
		"\x9D\xD8" => "\xEC\x95\x9A",
		"\x9D\xD9" => "\xEC\x95\x9B",
		"\x9D\xDA" => "\xEC\x95\x9C",
		"\x9D\xDB" => "\xEC\x95\x9F",
		"\x9D\xDC" => "\xEC\x95\xA2",
		"\x9D\xDD" => "\xEC\x95\xA3",
		"\x9D\xDE" => "\xEC\x95\xA5",
		"\x9D\xDF" => "\xEC\x95\xA6",
		"\x9D\xE0" => "\xEC\x95\xA7",
		"\x9D\xE1" => "\xEC\x95\xA9",
		"\x9D\xE2" => "\xEC\x95\xAA",
		"\x9D\xE3" => "\xEC\x95\xAB",
		"\x9D\xE4" => "\xEC\x95\xAC",
		"\x9D\xE5" => "\xEC\x95\xAD",
		"\x9D\xE6" => "\xEC\x95\xAE",
		"\x9D\xE7" => "\xEC\x95\xAF",
		"\x9D\xE8" => "\xEC\x95\xB2",
		"\x9D\xE9" => "\xEC\x95\xB6",
		"\x9D\xEA" => "\xEC\x95\xB7",
		"\x9D\xEB" => "\xEC\x95\xB8",
		"\x9D\xEC" => "\xEC\x95\xB9",
		"\x9D\xED" => "\xEC\x95\xBA",
		"\x9D\xEE" => "\xEC\x95\xBB",
		"\x9D\xEF" => "\xEC\x95\xBE",
		"\x9D\xF0" => "\xEC\x95\xBF",
		"\x9D\xF1" => "\xEC\x96\x81",
		"\x9D\xF2" => "\xEC\x96\x82",
		"\x9D\xF3" => "\xEC\x96\x83",
		"\x9D\xF4" => "\xEC\x96\x85",
		"\x9D\xF5" => "\xEC\x96\x86",
		"\x9D\xF6" => "\xEC\x96\x88",
		"\x9D\xF7" => "\xEC\x96\x89",
		"\x9D\xF8" => "\xEC\x96\x8A",
		"\x9D\xF9" => "\xEC\x96\x8B",
		"\x9D\xFA" => "\xEC\x96\x8E",
		"\x9D\xFB" => "\xEC\x96\x90",
		"\x9D\xFC" => "\xEC\x96\x92",
		"\x9D\xFD" => "\xEC\x96\x93",
		"\x9D\xFE" => "\xEC\x96\x94",
		"\x9E\x41" => "\xEC\x96\x96",
		"\x9E\x42" => "\xEC\x96\x99",
		"\x9E\x43" => "\xEC\x96\x9A",
		"\x9E\x44" => "\xEC\x96\x9B",
		"\x9E\x45" => "\xEC\x96\x9D",
		"\x9E\x46" => "\xEC\x96\x9E",
		"\x9E\x47" => "\xEC\x96\x9F",
		"\x9E\x48" => "\xEC\x96\xA1",
		"\x9E\x49" => "\xEC\x96\xA2",
		"\x9E\x4A" => "\xEC\x96\xA3",
		"\x9E\x4B" => "\xEC\x96\xA4",
		"\x9E\x4C" => "\xEC\x96\xA5",
		"\x9E\x4D" => "\xEC\x96\xA6",
		"\x9E\x4E" => "\xEC\x96\xA7",
		"\x9E\x4F" => "\xEC\x96\xA8",
		"\x9E\x50" => "\xEC\x96\xAA",
		"\x9E\x51" => "\xEC\x96\xAB",
		"\x9E\x52" => "\xEC\x96\xAC",
		"\x9E\x53" => "\xEC\x96\xAD",
		"\x9E\x54" => "\xEC\x96\xAE",
		"\x9E\x55" => "\xEC\x96\xAF",
		"\x9E\x56" => "\xEC\x96\xB0",
		"\x9E\x57" => "\xEC\x96\xB1",
		"\x9E\x58" => "\xEC\x96\xB2",
		"\x9E\x59" => "\xEC\x96\xB3",
		"\x9E\x5A" => "\xEC\x96\xB6",
		"\x9E\x61" => "\xEC\x96\xB7",
		"\x9E\x62" => "\xEC\x96\xBA",
		"\x9E\x63" => "\xEC\x96\xBF",
		"\x9E\x64" => "\xEC\x97\x80",
		"\x9E\x65" => "\xEC\x97\x81",
		"\x9E\x66" => "\xEC\x97\x82",
		"\x9E\x67" => "\xEC\x97\x83",
		"\x9E\x68" => "\xEC\x97\x8B",
		"\x9E\x69" => "\xEC\x97\x8D",
		"\x9E\x6A" => "\xEC\x97\x8F",
		"\x9E\x6B" => "\xEC\x97\x92",
		"\x9E\x6C" => "\xEC\x97\x93",
		"\x9E\x6D" => "\xEC\x97\x95",
		"\x9E\x6E" => "\xEC\x97\x96",
		"\x9E\x6F" => "\xEC\x97\x97",
		"\x9E\x70" => "\xEC\x97\x99",
		"\x9E\x71" => "\xEC\x97\x9A",
		"\x9E\x72" => "\xEC\x97\x9B",
		"\x9E\x73" => "\xEC\x97\x9C",
		"\x9E\x74" => "\xEC\x97\x9D",
		"\x9E\x75" => "\xEC\x97\x9E",
		"\x9E\x76" => "\xEC\x97\x9F",
		"\x9E\x77" => "\xEC\x97\xA2",
		"\x9E\x78" => "\xEC\x97\xA4",
		"\x9E\x79" => "\xEC\x97\xA6",
		"\x9E\x7A" => "\xEC\x97\xA7",
		"\x9E\x81" => "\xEC\x97\xA8",
		"\x9E\x82" => "\xEC\x97\xA9",
		"\x9E\x83" => "\xEC\x97\xAA",
		"\x9E\x84" => "\xEC\x97\xAB",
		"\x9E\x85" => "\xEC\x97\xAF",
		"\x9E\x86" => "\xEC\x97\xB1",
		"\x9E\x87" => "\xEC\x97\xB2",
		"\x9E\x88" => "\xEC\x97\xB3",
		"\x9E\x89" => "\xEC\x97\xB5",
		"\x9E\x8A" => "\xEC\x97\xB8",
		"\x9E\x8B" => "\xEC\x97\xB9",
		"\x9E\x8C" => "\xEC\x97\xBA",
		"\x9E\x8D" => "\xEC\x97\xBB",
		"\x9E\x8E" => "\xEC\x98\x82",
		"\x9E\x8F" => "\xEC\x98\x83",
		"\x9E\x90" => "\xEC\x98\x84",
		"\x9E\x91" => "\xEC\x98\x89",
		"\x9E\x92" => "\xEC\x98\x8A",
		"\x9E\x93" => "\xEC\x98\x8B",
		"\x9E\x94" => "\xEC\x98\x8D",
		"\x9E\x95" => "\xEC\x98\x8E",
		"\x9E\x96" => "\xEC\x98\x8F",
		"\x9E\x97" => "\xEC\x98\x91",
		"\x9E\x98" => "\xEC\x98\x92",
		"\x9E\x99" => "\xEC\x98\x93",
		"\x9E\x9A" => "\xEC\x98\x94",
		"\x9E\x9B" => "\xEC\x98\x95",
		"\x9E\x9C" => "\xEC\x98\x96",
		"\x9E\x9D" => "\xEC\x98\x97",
		"\x9E\x9E" => "\xEC\x98\x9A",
		"\x9E\x9F" => "\xEC\x98\x9D",
		"\x9E\xA0" => "\xEC\x98\x9E",
		"\x9E\xA1" => "\xEC\x98\x9F",
		"\x9E\xA2" => "\xEC\x98\xA0",
		"\x9E\xA3" => "\xEC\x98\xA1",
		"\x9E\xA4" => "\xEC\x98\xA2",
		"\x9E\xA5" => "\xEC\x98\xA3",
		"\x9E\xA6" => "\xEC\x98\xA6",
		"\x9E\xA7" => "\xEC\x98\xA7",
		"\x9E\xA8" => "\xEC\x98\xA9",
		"\x9E\xA9" => "\xEC\x98\xAA",
		"\x9E\xAA" => "\xEC\x98\xAB",
		"\x9E\xAB" => "\xEC\x98\xAF",
		"\x9E\xAC" => "\xEC\x98\xB1",
		"\x9E\xAD" => "\xEC\x98\xB2",
		"\x9E\xAE" => "\xEC\x98\xB6",
		"\x9E\xAF" => "\xEC\x98\xB8",
		"\x9E\xB0" => "\xEC\x98\xBA",
		"\x9E\xB1" => "\xEC\x98\xBC",
		"\x9E\xB2" => "\xEC\x98\xBD",
		"\x9E\xB3" => "\xEC\x98\xBE",
		"\x9E\xB4" => "\xEC\x98\xBF",
		"\x9E\xB5" => "\xEC\x99\x82",
		"\x9E\xB6" => "\xEC\x99\x83",
		"\x9E\xB7" => "\xEC\x99\x85",
		"\x9E\xB8" => "\xEC\x99\x86",
		"\x9E\xB9" => "\xEC\x99\x87",
		"\x9E\xBA" => "\xEC\x99\x89",
		"\x9E\xBB" => "\xEC\x99\x8A",
		"\x9E\xBC" => "\xEC\x99\x8B",
		"\x9E\xBD" => "\xEC\x99\x8C",
		"\x9E\xBE" => "\xEC\x99\x8D",
		"\x9E\xBF" => "\xEC\x99\x8E",
		"\x9E\xC0" => "\xEC\x99\x8F",
		"\x9E\xC1" => "\xEC\x99\x92",
		"\x9E\xC2" => "\xEC\x99\x96",
		"\x9E\xC3" => "\xEC\x99\x97",
		"\x9E\xC4" => "\xEC\x99\x98",
		"\x9E\xC5" => "\xEC\x99\x99",
		"\x9E\xC6" => "\xEC\x99\x9A",
		"\x9E\xC7" => "\xEC\x99\x9B",
		"\x9E\xC8" => "\xEC\x99\x9E",
		"\x9E\xC9" => "\xEC\x99\x9F",
		"\x9E\xCA" => "\xEC\x99\xA1",
		"\x9E\xCB" => "\xEC\x99\xA2",
		"\x9E\xCC" => "\xEC\x99\xA3",
		"\x9E\xCD" => "\xEC\x99\xA4",
		"\x9E\xCE" => "\xEC\x99\xA5",
		"\x9E\xCF" => "\xEC\x99\xA6",
		"\x9E\xD0" => "\xEC\x99\xA7",
		"\x9E\xD1" => "\xEC\x99\xA8",
		"\x9E\xD2" => "\xEC\x99\xA9",
		"\x9E\xD3" => "\xEC\x99\xAA",
		"\x9E\xD4" => "\xEC\x99\xAB",
		"\x9E\xD5" => "\xEC\x99\xAD",
		"\x9E\xD6" => "\xEC\x99\xAE",
		"\x9E\xD7" => "\xEC\x99\xB0",
		"\x9E\xD8" => "\xEC\x99\xB2",
		"\x9E\xD9" => "\xEC\x99\xB3",
		"\x9E\xDA" => "\xEC\x99\xB4",
		"\x9E\xDB" => "\xEC\x99\xB5",
		"\x9E\xDC" => "\xEC\x99\xB6",
		"\x9E\xDD" => "\xEC\x99\xB7",
		"\x9E\xDE" => "\xEC\x99\xBA",
		"\x9E\xDF" => "\xEC\x99\xBB",
		"\x9E\xE0" => "\xEC\x99\xBD",
		"\x9E\xE1" => "\xEC\x99\xBE",
		"\x9E\xE2" => "\xEC\x99\xBF",
		"\x9E\xE3" => "\xEC\x9A\x81",
		"\x9E\xE4" => "\xEC\x9A\x82",
		"\x9E\xE5" => "\xEC\x9A\x83",
		"\x9E\xE6" => "\xEC\x9A\x84",
		"\x9E\xE7" => "\xEC\x9A\x85",
		"\x9E\xE8" => "\xEC\x9A\x86",
		"\x9E\xE9" => "\xEC\x9A\x87",
		"\x9E\xEA" => "\xEC\x9A\x8A",
		"\x9E\xEB" => "\xEC\x9A\x8C",
		"\x9E\xEC" => "\xEC\x9A\x8E",
		"\x9E\xED" => "\xEC\x9A\x8F",
		"\x9E\xEE" => "\xEC\x9A\x90",
		"\x9E\xEF" => "\xEC\x9A\x91",
		"\x9E\xF0" => "\xEC\x9A\x92",
		"\x9E\xF1" => "\xEC\x9A\x93",
		"\x9E\xF2" => "\xEC\x9A\x96",
		"\x9E\xF3" => "\xEC\x9A\x97",
		"\x9E\xF4" => "\xEC\x9A\x99",
		"\x9E\xF5" => "\xEC\x9A\x9A",
		"\x9E\xF6" => "\xEC\x9A\x9B",
		"\x9E\xF7" => "\xEC\x9A\x9D",
		"\x9E\xF8" => "\xEC\x9A\x9E",
		"\x9E\xF9" => "\xEC\x9A\x9F",
		"\x9E\xFA" => "\xEC\x9A\xA0",
		"\x9E\xFB" => "\xEC\x9A\xA1",
		"\x9E\xFC" => "\xEC\x9A\xA2",
		"\x9E\xFD" => "\xEC\x9A\xA3",
		"\x9E\xFE" => "\xEC\x9A\xA6",
		"\x9F\x41" => "\xEC\x9A\xA8",
		"\x9F\x42" => "\xEC\x9A\xAA",
		"\x9F\x43" => "\xEC\x9A\xAB",
		"\x9F\x44" => "\xEC\x9A\xAC",
		"\x9F\x45" => "\xEC\x9A\xAD",
		"\x9F\x46" => "\xEC\x9A\xAE",
		"\x9F\x47" => "\xEC\x9A\xAF",
		"\x9F\x48" => "\xEC\x9A\xB2",
		"\x9F\x49" => "\xEC\x9A\xB3",
		"\x9F\x4A" => "\xEC\x9A\xB5",
		"\x9F\x4B" => "\xEC\x9A\xB6",
		"\x9F\x4C" => "\xEC\x9A\xB7",
		"\x9F\x4D" => "\xEC\x9A\xBB",
		"\x9F\x4E" => "\xEC\x9A\xBC",
		"\x9F\x4F" => "\xEC\x9A\xBD",
		"\x9F\x50" => "\xEC\x9A\xBE",
		"\x9F\x51" => "\xEC\x9A\xBF",
		"\x9F\x52" => "\xEC\x9B\x82",
		"\x9F\x53" => "\xEC\x9B\x84",
		"\x9F\x54" => "\xEC\x9B\x86",
		"\x9F\x55" => "\xEC\x9B\x87",
		"\x9F\x56" => "\xEC\x9B\x88",
		"\x9F\x57" => "\xEC\x9B\x89",
		"\x9F\x58" => "\xEC\x9B\x8A",
		"\x9F\x59" => "\xEC\x9B\x8B",
		"\x9F\x5A" => "\xEC\x9B\x8E",
		"\x9F\x61" => "\xEC\x9B\x8F",
		"\x9F\x62" => "\xEC\x9B\x91",
		"\x9F\x63" => "\xEC\x9B\x92",
		"\x9F\x64" => "\xEC\x9B\x93",
		"\x9F\x65" => "\xEC\x9B\x95",
		"\x9F\x66" => "\xEC\x9B\x96",
		"\x9F\x67" => "\xEC\x9B\x97",
		"\x9F\x68" => "\xEC\x9B\x98",
		"\x9F\x69" => "\xEC\x9B\x99",
		"\x9F\x6A" => "\xEC\x9B\x9A",
		"\x9F\x6B" => "\xEC\x9B\x9B",
		"\x9F\x6C" => "\xEC\x9B\x9E",
		"\x9F\x6D" => "\xEC\x9B\x9F",
		"\x9F\x6E" => "\xEC\x9B\xA2",
		"\x9F\x6F" => "\xEC\x9B\xA3",
		"\x9F\x70" => "\xEC\x9B\xA4",
		"\x9F\x71" => "\xEC\x9B\xA5",
		"\x9F\x72" => "\xEC\x9B\xA6",
		"\x9F\x73" => "\xEC\x9B\xA7",
		"\x9F\x74" => "\xEC\x9B\xAA",
		"\x9F\x75" => "\xEC\x9B\xAB",
		"\x9F\x76" => "\xEC\x9B\xAD",
		"\x9F\x77" => "\xEC\x9B\xAE",
		"\x9F\x78" => "\xEC\x9B\xAF",
		"\x9F\x79" => "\xEC\x9B\xB1",
		"\x9F\x7A" => "\xEC\x9B\xB2",
		"\x9F\x81" => "\xEC\x9B\xB3",
		"\x9F\x82" => "\xEC\x9B\xB4",
		"\x9F\x83" => "\xEC\x9B\xB5",
		"\x9F\x84" => "\xEC\x9B\xB6",
		"\x9F\x85" => "\xEC\x9B\xB7",
		"\x9F\x86" => "\xEC\x9B\xBA",
		"\x9F\x87" => "\xEC\x9B\xBB",
		"\x9F\x88" => "\xEC\x9B\xBC",
		"\x9F\x89" => "\xEC\x9B\xBE",
		"\x9F\x8A" => "\xEC\x9B\xBF",
		"\x9F\x8B" => "\xEC\x9C\x80",
		"\x9F\x8C" => "\xEC\x9C\x81",
		"\x9F\x8D" => "\xEC\x9C\x82",
		"\x9F\x8E" => "\xEC\x9C\x83",
		"\x9F\x8F" => "\xEC\x9C\x86",
		"\x9F\x90" => "\xEC\x9C\x87",
		"\x9F\x91" => "\xEC\x9C\x89",
		"\x9F\x92" => "\xEC\x9C\x8A",
		"\x9F\x93" => "\xEC\x9C\x8B",
		"\x9F\x94" => "\xEC\x9C\x8D",
		"\x9F\x95" => "\xEC\x9C\x8E",
		"\x9F\x96" => "\xEC\x9C\x8F",
		"\x9F\x97" => "\xEC\x9C\x90",
		"\x9F\x98" => "\xEC\x9C\x91",
		"\x9F\x99" => "\xEC\x9C\x92",
		"\x9F\x9A" => "\xEC\x9C\x93",
		"\x9F\x9B" => "\xEC\x9C\x96",
		"\x9F\x9C" => "\xEC\x9C\x98",
		"\x9F\x9D" => "\xEC\x9C\x9A",
		"\x9F\x9E" => "\xEC\x9C\x9B",
		"\x9F\x9F" => "\xEC\x9C\x9C",
		"\x9F\xA0" => "\xEC\x9C\x9D",
		"\x9F\xA1" => "\xEC\x9C\x9E",
		"\x9F\xA2" => "\xEC\x9C\x9F",
		"\x9F\xA3" => "\xEC\x9C\xA2",
		"\x9F\xA4" => "\xEC\x9C\xA3",
		"\x9F\xA5" => "\xEC\x9C\xA5",
		"\x9F\xA6" => "\xEC\x9C\xA6",
		"\x9F\xA7" => "\xEC\x9C\xA7",
		"\x9F\xA8" => "\xEC\x9C\xA9",
		"\x9F\xA9" => "\xEC\x9C\xAA",
		"\x9F\xAA" => "\xEC\x9C\xAB",
		"\x9F\xAB" => "\xEC\x9C\xAC",
		"\x9F\xAC" => "\xEC\x9C\xAD",
		"\x9F\xAD" => "\xEC\x9C\xAE",
		"\x9F\xAE" => "\xEC\x9C\xAF",
		"\x9F\xAF" => "\xEC\x9C\xB2",
		"\x9F\xB0" => "\xEC\x9C\xB4",
		"\x9F\xB1" => "\xEC\x9C\xB6",
		"\x9F\xB2" => "\xEC\x9C\xB8",
		"\x9F\xB3" => "\xEC\x9C\xB9",
		"\x9F\xB4" => "\xEC\x9C\xBA",
		"\x9F\xB5" => "\xEC\x9C\xBB",
		"\x9F\xB6" => "\xEC\x9C\xBE",
		"\x9F\xB7" => "\xEC\x9C\xBF",
		"\x9F\xB8" => "\xEC\x9D\x81",
		"\x9F\xB9" => "\xEC\x9D\x82",
		"\x9F\xBA" => "\xEC\x9D\x83",
		"\x9F\xBB" => "\xEC\x9D\x85",
		"\x9F\xBC" => "\xEC\x9D\x86",
		"\x9F\xBD" => "\xEC\x9D\x87",
		"\x9F\xBE" => "\xEC\x9D\x88",
		"\x9F\xBF" => "\xEC\x9D\x89",
		"\x9F\xC0" => "\xEC\x9D\x8B",
		"\x9F\xC1" => "\xEC\x9D\x8E",
		"\x9F\xC2" => "\xEC\x9D\x90",
		"\x9F\xC3" => "\xEC\x9D\x99",
		"\x9F\xC4" => "\xEC\x9D\x9A",
		"\x9F\xC5" => "\xEC\x9D\x9B",
		"\x9F\xC6" => "\xEC\x9D\x9D",
		"\x9F\xC7" => "\xEC\x9D\x9E",
		"\x9F\xC8" => "\xEC\x9D\x9F",
		"\x9F\xC9" => "\xEC\x9D\xA1",
		"\x9F\xCA" => "\xEC\x9D\xA2",
		"\x9F\xCB" => "\xEC\x9D\xA3",
		"\x9F\xCC" => "\xEC\x9D\xA4",
		"\x9F\xCD" => "\xEC\x9D\xA5",
		"\x9F\xCE" => "\xEC\x9D\xA6",
		"\x9F\xCF" => "\xEC\x9D\xA7",
		"\x9F\xD0" => "\xEC\x9D\xA9",
		"\x9F\xD1" => "\xEC\x9D\xAA",
		"\x9F\xD2" => "\xEC\x9D\xAC",
		"\x9F\xD3" => "\xEC\x9D\xAD",
		"\x9F\xD4" => "\xEC\x9D\xAE",
		"\x9F\xD5" => "\xEC\x9D\xAF",
		"\x9F\xD6" => "\xEC\x9D\xB0",
		"\x9F\xD7" => "\xEC\x9D\xB1",
		"\x9F\xD8" => "\xEC\x9D\xB2",
		"\x9F\xD9" => "\xEC\x9D\xB3",
		"\x9F\xDA" => "\xEC\x9D\xB6",
		"\x9F\xDB" => "\xEC\x9D\xB7",
		"\x9F\xDC" => "\xEC\x9D\xB9",
		"\x9F\xDD" => "\xEC\x9D\xBA",
		"\x9F\xDE" => "\xEC\x9D\xBB",
		"\x9F\xDF" => "\xEC\x9D\xBF",
		"\x9F\xE0" => "\xEC\x9E\x80",
		"\x9F\xE1" => "\xEC\x9E\x81",
		"\x9F\xE2" => "\xEC\x9E\x82",
		"\x9F\xE3" => "\xEC\x9E\x86",
		"\x9F\xE4" => "\xEC\x9E\x8B",
		"\x9F\xE5" => "\xEC\x9E\x8C",
		"\x9F\xE6" => "\xEC\x9E\x8D",
		"\x9F\xE7" => "\xEC\x9E\x8F",
		"\x9F\xE8" => "\xEC\x9E\x92",
		"\x9F\xE9" => "\xEC\x9E\x93",
		"\x9F\xEA" => "\xEC\x9E\x95",
		"\x9F\xEB" => "\xEC\x9E\x99",
		"\x9F\xEC" => "\xEC\x9E\x9B",
		"\x9F\xED" => "\xEC\x9E\x9C",
		"\x9F\xEE" => "\xEC\x9E\x9D",
		"\x9F\xEF" => "\xEC\x9E\x9E",
		"\x9F\xF0" => "\xEC\x9E\x9F",
		"\x9F\xF1" => "\xEC\x9E\xA2",
		"\x9F\xF2" => "\xEC\x9E\xA7",
		"\x9F\xF3" => "\xEC\x9E\xA8",
		"\x9F\xF4" => "\xEC\x9E\xA9",
		"\x9F\xF5" => "\xEC\x9E\xAA",
		"\x9F\xF6" => "\xEC\x9E\xAB",
		"\x9F\xF7" => "\xEC\x9E\xAE",
		"\x9F\xF8" => "\xEC\x9E\xAF",
		"\x9F\xF9" => "\xEC\x9E\xB1",
		"\x9F\xFA" => "\xEC\x9E\xB2",
		"\x9F\xFB" => "\xEC\x9E\xB3",
		"\x9F\xFC" => "\xEC\x9E\xB5",
		"\x9F\xFD" => "\xEC\x9E\xB6",
		"\x9F\xFE" => "\xEC\x9E\xB7",
		"\xA0\x41" => "\xEC\x9E\xB8",
		"\xA0\x42" => "\xEC\x9E\xB9",
		"\xA0\x43" => "\xEC\x9E\xBA",
		"\xA0\x44" => "\xEC\x9E\xBB",
		"\xA0\x45" => "\xEC\x9E\xBE",
		"\xA0\x46" => "\xEC\x9F\x82",
		"\xA0\x47" => "\xEC\x9F\x83",
		"\xA0\x48" => "\xEC\x9F\x84",
		"\xA0\x49" => "\xEC\x9F\x85",
		"\xA0\x4A" => "\xEC\x9F\x86",
		"\xA0\x4B" => "\xEC\x9F\x87",
		"\xA0\x4C" => "\xEC\x9F\x8A",
		"\xA0\x4D" => "\xEC\x9F\x8B",
		"\xA0\x4E" => "\xEC\x9F\x8D",
		"\xA0\x4F" => "\xEC\x9F\x8F",
		"\xA0\x50" => "\xEC\x9F\x91",
		"\xA0\x51" => "\xEC\x9F\x92",
		"\xA0\x52" => "\xEC\x9F\x93",
		"\xA0\x53" => "\xEC\x9F\x94",
		"\xA0\x54" => "\xEC\x9F\x95",
		"\xA0\x55" => "\xEC\x9F\x96",
		"\xA0\x56" => "\xEC\x9F\x97",
		"\xA0\x57" => "\xEC\x9F\x99",
		"\xA0\x58" => "\xEC\x9F\x9A",
		"\xA0\x59" => "\xEC\x9F\x9B",
		"\xA0\x5A" => "\xEC\x9F\x9C",
		"\xA0\x61" => "\xEC\x9F\x9E",
		"\xA0\x62" => "\xEC\x9F\x9F",
		"\xA0\x63" => "\xEC\x9F\xA0",
		"\xA0\x64" => "\xEC\x9F\xA1",
		"\xA0\x65" => "\xEC\x9F\xA2",
		"\xA0\x66" => "\xEC\x9F\xA3",
		"\xA0\x67" => "\xEC\x9F\xA5",
		"\xA0\x68" => "\xEC\x9F\xA6",
		"\xA0\x69" => "\xEC\x9F\xA7",
		"\xA0\x6A" => "\xEC\x9F\xA9",
		"\xA0\x6B" => "\xEC\x9F\xAA",
		"\xA0\x6C" => "\xEC\x9F\xAB",
		"\xA0\x6D" => "\xEC\x9F\xAD",
		"\xA0\x6E" => "\xEC\x9F\xAE",
		"\xA0\x6F" => "\xEC\x9F\xAF",
		"\xA0\x70" => "\xEC\x9F\xB0",
		"\xA0\x71" => "\xEC\x9F\xB1",
		"\xA0\x72" => "\xEC\x9F\xB2",
		"\xA0\x73" => "\xEC\x9F\xB3",
		"\xA0\x74" => "\xEC\x9F\xB4",
		"\xA0\x75" => "\xEC\x9F\xB5",
		"\xA0\x76" => "\xEC\x9F\xB6",
		"\xA0\x77" => "\xEC\x9F\xB7",
		"\xA0\x78" => "\xEC\x9F\xB8",
		"\xA0\x79" => "\xEC\x9F\xB9",
		"\xA0\x7A" => "\xEC\x9F\xBA",
		"\xA0\x81" => "\xEC\x9F\xBB",
		"\xA0\x82" => "\xEC\x9F\xBC",
		"\xA0\x83" => "\xEC\x9F\xBD",
		"\xA0\x84" => "\xEC\x9F\xBE",
		"\xA0\x85" => "\xEC\x9F\xBF",
		"\xA0\x86" => "\xEC\xA0\x82",
		"\xA0\x87" => "\xEC\xA0\x83",
		"\xA0\x88" => "\xEC\xA0\x85",
		"\xA0\x89" => "\xEC\xA0\x86",
		"\xA0\x8A" => "\xEC\xA0\x87",
		"\xA0\x8B" => "\xEC\xA0\x89",
		"\xA0\x8C" => "\xEC\xA0\x8B",
		"\xA0\x8D" => "\xEC\xA0\x8C",
		"\xA0\x8E" => "\xEC\xA0\x8D",
		"\xA0\x8F" => "\xEC\xA0\x8E",
		"\xA0\x90" => "\xEC\xA0\x8F",
		"\xA0\x91" => "\xEC\xA0\x92",
		"\xA0\x92" => "\xEC\xA0\x94",
		"\xA0\x93" => "\xEC\xA0\x97",
		"\xA0\x94" => "\xEC\xA0\x98",
		"\xA0\x95" => "\xEC\xA0\x99",
		"\xA0\x96" => "\xEC\xA0\x9A",
		"\xA0\x97" => "\xEC\xA0\x9B",
		"\xA0\x98" => "\xEC\xA0\x9E",
		"\xA0\x99" => "\xEC\xA0\x9F",
		"\xA0\x9A" => "\xEC\xA0\xA1",
		"\xA0\x9B" => "\xEC\xA0\xA2",
		"\xA0\x9C" => "\xEC\xA0\xA3",
		"\xA0\x9D" => "\xEC\xA0\xA5",
		"\xA0\x9E" => "\xEC\xA0\xA6",
		"\xA0\x9F" => "\xEC\xA0\xA7",
		"\xA0\xA0" => "\xEC\xA0\xA8",
		"\xA0\xA1" => "\xEC\xA0\xA9",
		"\xA0\xA2" => "\xEC\xA0\xAA",
		"\xA0\xA3" => "\xEC\xA0\xAB",
		"\xA0\xA4" => "\xEC\xA0\xAE",
		"\xA0\xA5" => "\xEC\xA0\xB0",
		"\xA0\xA6" => "\xEC\xA0\xB2",
		"\xA0\xA7" => "\xEC\xA0\xB3",
		"\xA0\xA8" => "\xEC\xA0\xB4",
		"\xA0\xA9" => "\xEC\xA0\xB5",
		"\xA0\xAA" => "\xEC\xA0\xB6",
		"\xA0\xAB" => "\xEC\xA0\xB7",
		"\xA0\xAC" => "\xEC\xA0\xB9",
		"\xA0\xAD" => "\xEC\xA0\xBA",
		"\xA0\xAE" => "\xEC\xA0\xBB",
		"\xA0\xAF" => "\xEC\xA0\xBD",
		"\xA0\xB0" => "\xEC\xA0\xBE",
		"\xA0\xB1" => "\xEC\xA0\xBF",
		"\xA0\xB2" => "\xEC\xA1\x81",
		"\xA0\xB3" => "\xEC\xA1\x82",
		"\xA0\xB4" => "\xEC\xA1\x83",
		"\xA0\xB5" => "\xEC\xA1\x84",
		"\xA0\xB6" => "\xEC\xA1\x85",
		"\xA0\xB7" => "\xEC\xA1\x86",
		"\xA0\xB8" => "\xEC\xA1\x87",
		"\xA0\xB9" => "\xEC\xA1\x8A",
		"\xA0\xBA" => "\xEC\xA1\x8B",
		"\xA0\xBB" => "\xEC\xA1\x8E",
		"\xA0\xBC" => "\xEC\xA1\x8F",
		"\xA0\xBD" => "\xEC\xA1\x90",
		"\xA0\xBE" => "\xEC\xA1\x91",
		"\xA0\xBF" => "\xEC\xA1\x92",
		"\xA0\xC0" => "\xEC\xA1\x93",
		"\xA0\xC1" => "\xEC\xA1\x95",
		"\xA0\xC2" => "\xEC\xA1\x96",
		"\xA0\xC3" => "\xEC\xA1\x97",
		"\xA0\xC4" => "\xEC\xA1\x98",
		"\xA0\xC5" => "\xEC\xA1\x99",
		"\xA0\xC6" => "\xEC\xA1\x9A",
		"\xA0\xC7" => "\xEC\xA1\x9B",
		"\xA0\xC8" => "\xEC\xA1\x9C",
		"\xA0\xC9" => "\xEC\xA1\x9D",
		"\xA0\xCA" => "\xEC\xA1\x9E",
		"\xA0\xCB" => "\xEC\xA1\x9F",
		"\xA0\xCC" => "\xEC\xA1\xA0",
		"\xA0\xCD" => "\xEC\xA1\xA1",
		"\xA0\xCE" => "\xEC\xA1\xA2",
		"\xA0\xCF" => "\xEC\xA1\xA3",
		"\xA0\xD0" => "\xEC\xA1\xA4",
		"\xA0\xD1" => "\xEC\xA1\xA5",
		"\xA0\xD2" => "\xEC\xA1\xA6",
		"\xA0\xD3" => "\xEC\xA1\xA7",
		"\xA0\xD4" => "\xEC\xA1\xA8",
		"\xA0\xD5" => "\xEC\xA1\xA9",
		"\xA0\xD6" => "\xEC\xA1\xAA",
		"\xA0\xD7" => "\xEC\xA1\xAB",
		"\xA0\xD8" => "\xEC\xA1\xAC",
		"\xA0\xD9" => "\xEC\xA1\xAD",
		"\xA0\xDA" => "\xEC\xA1\xAE",
		"\xA0\xDB" => "\xEC\xA1\xAF",
		"\xA0\xDC" => "\xEC\xA1\xB2",
		"\xA0\xDD" => "\xEC\xA1\xB3",
		"\xA0\xDE" => "\xEC\xA1\xB5",
		"\xA0\xDF" => "\xEC\xA1\xB6",
		"\xA0\xE0" => "\xEC\xA1\xB7",
		"\xA0\xE1" => "\xEC\xA1\xB9",
		"\xA0\xE2" => "\xEC\xA1\xBB",
		"\xA0\xE3" => "\xEC\xA1\xBC",
		"\xA0\xE4" => "\xEC\xA1\xBD",
		"\xA0\xE5" => "\xEC\xA1\xBE",
		"\xA0\xE6" => "\xEC\xA1\xBF",
		"\xA0\xE7" => "\xEC\xA2\x82",
		"\xA0\xE8" => "\xEC\xA2\x84",
		"\xA0\xE9" => "\xEC\xA2\x88",
		"\xA0\xEA" => "\xEC\xA2\x89",
		"\xA0\xEB" => "\xEC\xA2\x8A",
		"\xA0\xEC" => "\xEC\xA2\x8E",
		"\xA0\xED" => "\xEC\xA2\x8F",
		"\xA0\xEE" => "\xEC\xA2\x90",
		"\xA0\xEF" => "\xEC\xA2\x91",
		"\xA0\xF0" => "\xEC\xA2\x92",
		"\xA0\xF1" => "\xEC\xA2\x93",
		"\xA0\xF2" => "\xEC\xA2\x95",
		"\xA0\xF3" => "\xEC\xA2\x96",
		"\xA0\xF4" => "\xEC\xA2\x97",
		"\xA0\xF5" => "\xEC\xA2\x98",
		"\xA0\xF6" => "\xEC\xA2\x99",
		"\xA0\xF7" => "\xEC\xA2\x9A",
		"\xA0\xF8" => "\xEC\xA2\x9B",
		"\xA0\xF9" => "\xEC\xA2\x9C",
		"\xA0\xFA" => "\xEC\xA2\x9E",
		"\xA0\xFB" => "\xEC\xA2\xA0",
		"\xA0\xFC" => "\xEC\xA2\xA2",
		"\xA0\xFD" => "\xEC\xA2\xA3",
		"\xA0\xFE" => "\xEC\xA2\xA4",
		"\xA1\x41" => "\xEC\xA2\xA5",
		"\xA1\x42" => "\xEC\xA2\xA6",
		"\xA1\x43" => "\xEC\xA2\xA7",
		"\xA1\x44" => "\xEC\xA2\xA9",
		"\xA1\x45" => "\xEC\xA2\xAA",
		"\xA1\x46" => "\xEC\xA2\xAB",
		"\xA1\x47" => "\xEC\xA2\xAC",
		"\xA1\x48" => "\xEC\xA2\xAD",
		"\xA1\x49" => "\xEC\xA2\xAE",
		"\xA1\x4A" => "\xEC\xA2\xAF",
		"\xA1\x4B" => "\xEC\xA2\xB0",
		"\xA1\x4C" => "\xEC\xA2\xB1",
		"\xA1\x4D" => "\xEC\xA2\xB2",
		"\xA1\x4E" => "\xEC\xA2\xB3",
		"\xA1\x4F" => "\xEC\xA2\xB4",
		"\xA1\x50" => "\xEC\xA2\xB5",
		"\xA1\x51" => "\xEC\xA2\xB6",
		"\xA1\x52" => "\xEC\xA2\xB7",
		"\xA1\x53" => "\xEC\xA2\xB8",
		"\xA1\x54" => "\xEC\xA2\xB9",
		"\xA1\x55" => "\xEC\xA2\xBA",
		"\xA1\x56" => "\xEC\xA2\xBB",
		"\xA1\x57" => "\xEC\xA2\xBE",
		"\xA1\x58" => "\xEC\xA2\xBF",
		"\xA1\x59" => "\xEC\xA3\x80",
		"\xA1\x5A" => "\xEC\xA3\x81",
		"\xA1\x61" => "\xEC\xA3\x82",
		"\xA1\x62" => "\xEC\xA3\x83",
		"\xA1\x63" => "\xEC\xA3\x85",
		"\xA1\x64" => "\xEC\xA3\x86",
		"\xA1\x65" => "\xEC\xA3\x87",
		"\xA1\x66" => "\xEC\xA3\x89",
		"\xA1\x67" => "\xEC\xA3\x8A",
		"\xA1\x68" => "\xEC\xA3\x8B",
		"\xA1\x69" => "\xEC\xA3\x8D",
		"\xA1\x6A" => "\xEC\xA3\x8E",
		"\xA1\x6B" => "\xEC\xA3\x8F",
		"\xA1\x6C" => "\xEC\xA3\x90",
		"\xA1\x6D" => "\xEC\xA3\x91",
		"\xA1\x6E" => "\xEC\xA3\x92",
		"\xA1\x6F" => "\xEC\xA3\x93",
		"\xA1\x70" => "\xEC\xA3\x96",
		"\xA1\x71" => "\xEC\xA3\x98",
		"\xA1\x72" => "\xEC\xA3\x9A",
		"\xA1\x73" => "\xEC\xA3\x9B",
		"\xA1\x74" => "\xEC\xA3\x9C",
		"\xA1\x75" => "\xEC\xA3\x9D",
		"\xA1\x76" => "\xEC\xA3\x9E",
		"\xA1\x77" => "\xEC\xA3\x9F",
		"\xA1\x78" => "\xEC\xA3\xA2",
		"\xA1\x79" => "\xEC\xA3\xA3",
		"\xA1\x7A" => "\xEC\xA3\xA5",
		"\xA1\x81" => "\xEC\xA3\xA6",
		"\xA1\x82" => "\xEC\xA3\xA7",
		"\xA1\x83" => "\xEC\xA3\xA8",
		"\xA1\x84" => "\xEC\xA3\xA9",
		"\xA1\x85" => "\xEC\xA3\xAA",
		"\xA1\x86" => "\xEC\xA3\xAB",
		"\xA1\x87" => "\xEC\xA3\xAC",
		"\xA1\x88" => "\xEC\xA3\xAD",
		"\xA1\x89" => "\xEC\xA3\xAE",
		"\xA1\x8A" => "\xEC\xA3\xAF",
		"\xA1\x8B" => "\xEC\xA3\xB0",
		"\xA1\x8C" => "\xEC\xA3\xB1",
		"\xA1\x8D" => "\xEC\xA3\xB2",
		"\xA1\x8E" => "\xEC\xA3\xB3",
		"\xA1\x8F" => "\xEC\xA3\xB4",
		"\xA1\x90" => "\xEC\xA3\xB6",
		"\xA1\x91" => "\xEC\xA3\xB7",
		"\xA1\x92" => "\xEC\xA3\xB8",
		"\xA1\x93" => "\xEC\xA3\xB9",
		"\xA1\x94" => "\xEC\xA3\xBA",
		"\xA1\x95" => "\xEC\xA3\xBB",
		"\xA1\x96" => "\xEC\xA3\xBE",
		"\xA1\x97" => "\xEC\xA3\xBF",
		"\xA1\x98" => "\xEC\xA4\x81",
		"\xA1\x99" => "\xEC\xA4\x82",
		"\xA1\x9A" => "\xEC\xA4\x83",
		"\xA1\x9B" => "\xEC\xA4\x87",
		"\xA1\x9C" => "\xEC\xA4\x88",
		"\xA1\x9D" => "\xEC\xA4\x89",
		"\xA1\x9E" => "\xEC\xA4\x8A",
		"\xA1\x9F" => "\xEC\xA4\x8B",
		"\xA1\xA0" => "\xEC\xA4\x8E",
		"\xA1\xA1" => "\xE3\x80\x80",
		"\xA1\xA2" => "\xE3\x80\x81",
		"\xA1\xA3" => "\xE3\x80\x82",
		"\xA1\xA4" => "\xC2\xB7",
		"\xA1\xA5" => "\xE2\x80\xA5",
		"\xA1\xA6" => "\xE2\x80\xA6",
		"\xA1\xA7" => "\xC2\xA8",
		"\xA1\xA8" => "\xE3\x80\x83",
		"\xA1\xA9" => "\xC2\xAD",
		"\xA1\xAA" => "\xE2\x80\x95",
		"\xA1\xAB" => "\xE2\x88\xA5",
		"\xA1\xAC" => "\xEF\xBC\xBC",
		"\xA1\xAD" => "\xE2\x88\xBC",
		"\xA1\xAE" => "\xE2\x80\x98",
		"\xA1\xAF" => "\xE2\x80\x99",
		"\xA1\xB0" => "\xE2\x80\x9C",
		"\xA1\xB1" => "\xE2\x80\x9D",
		"\xA1\xB2" => "\xE3\x80\x94",
		"\xA1\xB3" => "\xE3\x80\x95",
		"\xA1\xB4" => "\xE3\x80\x88",
		"\xA1\xB5" => "\xE3\x80\x89",
		"\xA1\xB6" => "\xE3\x80\x8A",
		"\xA1\xB7" => "\xE3\x80\x8B",
		"\xA1\xB8" => "\xE3\x80\x8C",
		"\xA1\xB9" => "\xE3\x80\x8D",
		"\xA1\xBA" => "\xE3\x80\x8E",
		"\xA1\xBB" => "\xE3\x80\x8F",
		"\xA1\xBC" => "\xE3\x80\x90",
		"\xA1\xBD" => "\xE3\x80\x91",
		"\xA1\xBE" => "\xC2\xB1",
		"\xA1\xBF" => "\xC3\x97",
		"\xA1\xC0" => "\xC3\xB7",
		"\xA1\xC1" => "\xE2\x89\xA0",
		"\xA1\xC2" => "\xE2\x89\xA4",
		"\xA1\xC3" => "\xE2\x89\xA5",
		"\xA1\xC4" => "\xE2\x88\x9E",
		"\xA1\xC5" => "\xE2\x88\xB4",
		"\xA1\xC6" => "\xC2\xB0",
		"\xA1\xC7" => "\xE2\x80\xB2",
		"\xA1\xC8" => "\xE2\x80\xB3",
		"\xA1\xC9" => "\xE2\x84\x83",
		"\xA1\xCA" => "\xE2\x84\xAB",
		"\xA1\xCB" => "\xEF\xBF\xA0",
		"\xA1\xCC" => "\xEF\xBF\xA1",
		"\xA1\xCD" => "\xEF\xBF\xA5",
		"\xA1\xCE" => "\xE2\x99\x82",
		"\xA1\xCF" => "\xE2\x99\x80",
		"\xA1\xD0" => "\xE2\x88\xA0",
		"\xA1\xD1" => "\xE2\x8A\xA5",
		"\xA1\xD2" => "\xE2\x8C\x92",
		"\xA1\xD3" => "\xE2\x88\x82",
		"\xA1\xD4" => "\xE2\x88\x87",
		"\xA1\xD5" => "\xE2\x89\xA1",
		"\xA1\xD6" => "\xE2\x89\x92",
		"\xA1\xD7" => "\xC2\xA7",
		"\xA1\xD8" => "\xE2\x80\xBB",
		"\xA1\xD9" => "\xE2\x98\x86",
		"\xA1\xDA" => "\xE2\x98\x85",
		"\xA1\xDB" => "\xE2\x97\x8B",
		"\xA1\xDC" => "\xE2\x97\x8F",
		"\xA1\xDD" => "\xE2\x97\x8E",
		"\xA1\xDE" => "\xE2\x97\x87",
		"\xA1\xDF" => "\xE2\x97\x86",
		"\xA1\xE0" => "\xE2\x96\xA1",
		"\xA1\xE1" => "\xE2\x96\xA0",
		"\xA1\xE2" => "\xE2\x96\xB3",
		"\xA1\xE3" => "\xE2\x96\xB2",
		"\xA1\xE4" => "\xE2\x96\xBD",
		"\xA1\xE5" => "\xE2\x96\xBC",
		"\xA1\xE6" => "\xE2\x86\x92",
		"\xA1\xE7" => "\xE2\x86\x90",
		"\xA1\xE8" => "\xE2\x86\x91",
		"\xA1\xE9" => "\xE2\x86\x93",
		"\xA1\xEA" => "\xE2\x86\x94",
		"\xA1\xEB" => "\xE3\x80\x93",
		"\xA1\xEC" => "\xE2\x89\xAA",
		"\xA1\xED" => "\xE2\x89\xAB",
		"\xA1\xEE" => "\xE2\x88\x9A",
		"\xA1\xEF" => "\xE2\x88\xBD",
		"\xA1\xF0" => "\xE2\x88\x9D",
		"\xA1\xF1" => "\xE2\x88\xB5",
		"\xA1\xF2" => "\xE2\x88\xAB",
		"\xA1\xF3" => "\xE2\x88\xAC",
		"\xA1\xF4" => "\xE2\x88\x88",
		"\xA1\xF5" => "\xE2\x88\x8B",
		"\xA1\xF6" => "\xE2\x8A\x86",
		"\xA1\xF7" => "\xE2\x8A\x87",
		"\xA1\xF8" => "\xE2\x8A\x82",
		"\xA1\xF9" => "\xE2\x8A\x83",
		"\xA1\xFA" => "\xE2\x88\xAA",
		"\xA1\xFB" => "\xE2\x88\xA9",
		"\xA1\xFC" => "\xE2\x88\xA7",
		"\xA1\xFD" => "\xE2\x88\xA8",
		"\xA1\xFE" => "\xEF\xBF\xA2",
		"\xA2\x41" => "\xEC\xA4\x90",
		"\xA2\x42" => "\xEC\xA4\x92",
		"\xA2\x43" => "\xEC\xA4\x93",
		"\xA2\x44" => "\xEC\xA4\x94",
		"\xA2\x45" => "\xEC\xA4\x95",
		"\xA2\x46" => "\xEC\xA4\x96",
		"\xA2\x47" => "\xEC\xA4\x97",
		"\xA2\x48" => "\xEC\xA4\x99",
		"\xA2\x49" => "\xEC\xA4\x9A",
		"\xA2\x4A" => "\xEC\xA4\x9B",
		"\xA2\x4B" => "\xEC\xA4\x9C",
		"\xA2\x4C" => "\xEC\xA4\x9D",
		"\xA2\x4D" => "\xEC\xA4\x9E",
		"\xA2\x4E" => "\xEC\xA4\x9F",
		"\xA2\x4F" => "\xEC\xA4\xA0",
		"\xA2\x50" => "\xEC\xA4\xA1",
		"\xA2\x51" => "\xEC\xA4\xA2",
		"\xA2\x52" => "\xEC\xA4\xA3",
		"\xA2\x53" => "\xEC\xA4\xA4",
		"\xA2\x54" => "\xEC\xA4\xA5",
		"\xA2\x55" => "\xEC\xA4\xA6",
		"\xA2\x56" => "\xEC\xA4\xA7",
		"\xA2\x57" => "\xEC\xA4\xA8",
		"\xA2\x58" => "\xEC\xA4\xA9",
		"\xA2\x59" => "\xEC\xA4\xAA",
		"\xA2\x5A" => "\xEC\xA4\xAB",
		"\xA2\x61" => "\xEC\xA4\xAD",
		"\xA2\x62" => "\xEC\xA4\xAE",
		"\xA2\x63" => "\xEC\xA4\xAF",
		"\xA2\x64" => "\xEC\xA4\xB0",
		"\xA2\x65" => "\xEC\xA4\xB1",
		"\xA2\x66" => "\xEC\xA4\xB2",
		"\xA2\x67" => "\xEC\xA4\xB3",
		"\xA2\x68" => "\xEC\xA4\xB5",
		"\xA2\x69" => "\xEC\xA4\xB6",
		"\xA2\x6A" => "\xEC\xA4\xB7",
		"\xA2\x6B" => "\xEC\xA4\xB8",
		"\xA2\x6C" => "\xEC\xA4\xB9",
		"\xA2\x6D" => "\xEC\xA4\xBA",
		"\xA2\x6E" => "\xEC\xA4\xBB",
		"\xA2\x6F" => "\xEC\xA4\xBC",
		"\xA2\x70" => "\xEC\xA4\xBD",
		"\xA2\x71" => "\xEC\xA4\xBE",
		"\xA2\x72" => "\xEC\xA4\xBF",
		"\xA2\x73" => "\xEC\xA5\x80",
		"\xA2\x74" => "\xEC\xA5\x81",
		"\xA2\x75" => "\xEC\xA5\x82",
		"\xA2\x76" => "\xEC\xA5\x83",
		"\xA2\x77" => "\xEC\xA5\x84",
		"\xA2\x78" => "\xEC\xA5\x85",
		"\xA2\x79" => "\xEC\xA5\x86",
		"\xA2\x7A" => "\xEC\xA5\x87",
		"\xA2\x81" => "\xEC\xA5\x88",
		"\xA2\x82" => "\xEC\xA5\x89",
		"\xA2\x83" => "\xEC\xA5\x8A",
		"\xA2\x84" => "\xEC\xA5\x8B",
		"\xA2\x85" => "\xEC\xA5\x8C",
		"\xA2\x86" => "\xEC\xA5\x8D",
		"\xA2\x87" => "\xEC\xA5\x8E",
		"\xA2\x88" => "\xEC\xA5\x8F",
		"\xA2\x89" => "\xEC\xA5\x92",
		"\xA2\x8A" => "\xEC\xA5\x93",
		"\xA2\x8B" => "\xEC\xA5\x95",
		"\xA2\x8C" => "\xEC\xA5\x96",
		"\xA2\x8D" => "\xEC\xA5\x97",
		"\xA2\x8E" => "\xEC\xA5\x99",
		"\xA2\x8F" => "\xEC\xA5\x9A",
		"\xA2\x90" => "\xEC\xA5\x9B",
		"\xA2\x91" => "\xEC\xA5\x9C",
		"\xA2\x92" => "\xEC\xA5\x9D",
		"\xA2\x93" => "\xEC\xA5\x9E",
		"\xA2\x94" => "\xEC\xA5\x9F",
		"\xA2\x95" => "\xEC\xA5\xA2",
		"\xA2\x96" => "\xEC\xA5\xA4",
		"\xA2\x97" => "\xEC\xA5\xA5",
		"\xA2\x98" => "\xEC\xA5\xA6",
		"\xA2\x99" => "\xEC\xA5\xA7",
		"\xA2\x9A" => "\xEC\xA5\xA8",
		"\xA2\x9B" => "\xEC\xA5\xA9",
		"\xA2\x9C" => "\xEC\xA5\xAA",
		"\xA2\x9D" => "\xEC\xA5\xAB",
		"\xA2\x9E" => "\xEC\xA5\xAD",
		"\xA2\x9F" => "\xEC\xA5\xAE",
		"\xA2\xA0" => "\xEC\xA5\xAF",
		"\xA2\xA1" => "\xE2\x87\x92",
		"\xA2\xA2" => "\xE2\x87\x94",
		"\xA2\xA3" => "\xE2\x88\x80",
		"\xA2\xA4" => "\xE2\x88\x83",
		"\xA2\xA5" => "\xC2\xB4",
		"\xA2\xA6" => "\xEF\xBD\x9E",
		"\xA2\xA7" => "\xCB\x87",
		"\xA2\xA8" => "\xCB\x98",
		"\xA2\xA9" => "\xCB\x9D",
		"\xA2\xAA" => "\xCB\x9A",
		"\xA2\xAB" => "\xCB\x99",
		"\xA2\xAC" => "\xC2\xB8",
		"\xA2\xAD" => "\xCB\x9B",
		"\xA2\xAE" => "\xC2\xA1",
		"\xA2\xAF" => "\xC2\xBF",
		"\xA2\xB0" => "\xCB\x90",
		"\xA2\xB1" => "\xE2\x88\xAE",
		"\xA2\xB2" => "\xE2\x88\x91",
		"\xA2\xB3" => "\xE2\x88\x8F",
		"\xA2\xB4" => "\xC2\xA4",
		"\xA2\xB5" => "\xE2\x84\x89",
		"\xA2\xB6" => "\xE2\x80\xB0",
		"\xA2\xB7" => "\xE2\x97\x81",
		"\xA2\xB8" => "\xE2\x97\x80",
		"\xA2\xB9" => "\xE2\x96\xB7",
		"\xA2\xBA" => "\xE2\x96\xB6",
		"\xA2\xBB" => "\xE2\x99\xA4",
		"\xA2\xBC" => "\xE2\x99\xA0",
		"\xA2\xBD" => "\xE2\x99\xA1",
		"\xA2\xBE" => "\xE2\x99\xA5",
		"\xA2\xBF" => "\xE2\x99\xA7",
		"\xA2\xC0" => "\xE2\x99\xA3",
		"\xA2\xC1" => "\xE2\x8A\x99",
		"\xA2\xC2" => "\xE2\x97\x88",
		"\xA2\xC3" => "\xE2\x96\xA3",
		"\xA2\xC4" => "\xE2\x97\x90",
		"\xA2\xC5" => "\xE2\x97\x91",
		"\xA2\xC6" => "\xE2\x96\x92",
		"\xA2\xC7" => "\xE2\x96\xA4",
		"\xA2\xC8" => "\xE2\x96\xA5",
		"\xA2\xC9" => "\xE2\x96\xA8",
		"\xA2\xCA" => "\xE2\x96\xA7",
		"\xA2\xCB" => "\xE2\x96\xA6",
		"\xA2\xCC" => "\xE2\x96\xA9",
		"\xA2\xCD" => "\xE2\x99\xA8",
		"\xA2\xCE" => "\xE2\x98\x8F",
		"\xA2\xCF" => "\xE2\x98\x8E",
		"\xA2\xD0" => "\xE2\x98\x9C",
		"\xA2\xD1" => "\xE2\x98\x9E",
		"\xA2\xD2" => "\xC2\xB6",
		"\xA2\xD3" => "\xE2\x80\xA0",
		"\xA2\xD4" => "\xE2\x80\xA1",
		"\xA2\xD5" => "\xE2\x86\x95",
		"\xA2\xD6" => "\xE2\x86\x97",
		"\xA2\xD7" => "\xE2\x86\x99",
		"\xA2\xD8" => "\xE2\x86\x96",
		"\xA2\xD9" => "\xE2\x86\x98",
		"\xA2\xDA" => "\xE2\x99\xAD",
		"\xA2\xDB" => "\xE2\x99\xA9",
		"\xA2\xDC" => "\xE2\x99\xAA",
		"\xA2\xDD" => "\xE2\x99\xAC",
		"\xA2\xDE" => "\xE3\x89\xBF",
		"\xA2\xDF" => "\xE3\x88\x9C",
		"\xA2\xE0" => "\xE2\x84\x96",
		"\xA2\xE1" => "\xE3\x8F\x87",
		"\xA2\xE2" => "\xE2\x84\xA2",
		"\xA2\xE3" => "\xE3\x8F\x82",
		"\xA2\xE4" => "\xE3\x8F\x98",
		"\xA2\xE5" => "\xE2\x84\xA1",
		"\xA3\x41" => "\xEC\xA5\xB1",
		"\xA3\x42" => "\xEC\xA5\xB2",
		"\xA3\x43" => "\xEC\xA5\xB3",
		"\xA3\x44" => "\xEC\xA5\xB5",
		"\xA3\x45" => "\xEC\xA5\xB6",
		"\xA3\x46" => "\xEC\xA5\xB7",
		"\xA3\x47" => "\xEC\xA5\xB8",
		"\xA3\x48" => "\xEC\xA5\xB9",
		"\xA3\x49" => "\xEC\xA5\xBA",
		"\xA3\x4A" => "\xEC\xA5\xBB",
		"\xA3\x4B" => "\xEC\xA5\xBD",
		"\xA3\x4C" => "\xEC\xA5\xBE",
		"\xA3\x4D" => "\xEC\xA5\xBF",
		"\xA3\x4E" => "\xEC\xA6\x80",
		"\xA3\x4F" => "\xEC\xA6\x81",
		"\xA3\x50" => "\xEC\xA6\x82",
		"\xA3\x51" => "\xEC\xA6\x83",
		"\xA3\x52" => "\xEC\xA6\x84",
		"\xA3\x53" => "\xEC\xA6\x85",
		"\xA3\x54" => "\xEC\xA6\x86",
		"\xA3\x55" => "\xEC\xA6\x87",
		"\xA3\x56" => "\xEC\xA6\x8A",
		"\xA3\x57" => "\xEC\xA6\x8B",
		"\xA3\x58" => "\xEC\xA6\x8D",
		"\xA3\x59" => "\xEC\xA6\x8E",
		"\xA3\x5A" => "\xEC\xA6\x8F",
		"\xA3\x61" => "\xEC\xA6\x91",
		"\xA3\x62" => "\xEC\xA6\x92",
		"\xA3\x63" => "\xEC\xA6\x93",
		"\xA3\x64" => "\xEC\xA6\x94",
		"\xA3\x65" => "\xEC\xA6\x95",
		"\xA3\x66" => "\xEC\xA6\x96",
		"\xA3\x67" => "\xEC\xA6\x97",
		"\xA3\x68" => "\xEC\xA6\x9A",
		"\xA3\x69" => "\xEC\xA6\x9C",
		"\xA3\x6A" => "\xEC\xA6\x9E",
		"\xA3\x6B" => "\xEC\xA6\x9F",
		"\xA3\x6C" => "\xEC\xA6\xA0",
		"\xA3\x6D" => "\xEC\xA6\xA1",
		"\xA3\x6E" => "\xEC\xA6\xA2",
		"\xA3\x6F" => "\xEC\xA6\xA3",
		"\xA3\x70" => "\xEC\xA6\xA4",
		"\xA3\x71" => "\xEC\xA6\xA5",
		"\xA3\x72" => "\xEC\xA6\xA6",
		"\xA3\x73" => "\xEC\xA6\xA7",
		"\xA3\x74" => "\xEC\xA6\xA8",
		"\xA3\x75" => "\xEC\xA6\xA9",
		"\xA3\x76" => "\xEC\xA6\xAA",
		"\xA3\x77" => "\xEC\xA6\xAB",
		"\xA3\x78" => "\xEC\xA6\xAC",
		"\xA3\x79" => "\xEC\xA6\xAD",
		"\xA3\x7A" => "\xEC\xA6\xAE",
		"\xA3\x81" => "\xEC\xA6\xAF",
		"\xA3\x82" => "\xEC\xA6\xB0",
		"\xA3\x83" => "\xEC\xA6\xB1",
		"\xA3\x84" => "\xEC\xA6\xB2",
		"\xA3\x85" => "\xEC\xA6\xB3",
		"\xA3\x86" => "\xEC\xA6\xB4",
		"\xA3\x87" => "\xEC\xA6\xB5",
		"\xA3\x88" => "\xEC\xA6\xB6",
		"\xA3\x89" => "\xEC\xA6\xB7",
		"\xA3\x8A" => "\xEC\xA6\xB8",
		"\xA3\x8B" => "\xEC\xA6\xB9",
		"\xA3\x8C" => "\xEC\xA6\xBA",
		"\xA3\x8D" => "\xEC\xA6\xBB",
		"\xA3\x8E" => "\xEC\xA6\xBC",
		"\xA3\x8F" => "\xEC\xA6\xBD",
		"\xA3\x90" => "\xEC\xA6\xBE",
		"\xA3\x91" => "\xEC\xA6\xBF",
		"\xA3\x92" => "\xEC\xA7\x82",
		"\xA3\x93" => "\xEC\xA7\x83",
		"\xA3\x94" => "\xEC\xA7\x85",
		"\xA3\x95" => "\xEC\xA7\x86",
		"\xA3\x96" => "\xEC\xA7\x89",
		"\xA3\x97" => "\xEC\xA7\x8B",
		"\xA3\x98" => "\xEC\xA7\x8C",
		"\xA3\x99" => "\xEC\xA7\x8D",
		"\xA3\x9A" => "\xEC\xA7\x8E",
		"\xA3\x9B" => "\xEC\xA7\x8F",
		"\xA3\x9C" => "\xEC\xA7\x92",
		"\xA3\x9D" => "\xEC\xA7\x94",
		"\xA3\x9E" => "\xEC\xA7\x97",
		"\xA3\x9F" => "\xEC\xA7\x98",
		"\xA3\xA0" => "\xEC\xA7\x9B",
		"\xA3\xA1" => "\xEF\xBC\x81",
		"\xA3\xA2" => "\xEF\xBC\x82",
		"\xA3\xA3" => "\xEF\xBC\x83",
		"\xA3\xA4" => "\xEF\xBC\x84",
		"\xA3\xA5" => "\xEF\xBC\x85",
		"\xA3\xA6" => "\xEF\xBC\x86",
		"\xA3\xA7" => "\xEF\xBC\x87",
		"\xA3\xA8" => "\xEF\xBC\x88",
		"\xA3\xA9" => "\xEF\xBC\x89",
		"\xA3\xAA" => "\xEF\xBC\x8A",
		"\xA3\xAB" => "\xEF\xBC\x8B",
		"\xA3\xAC" => "\xEF\xBC\x8C",
		"\xA3\xAD" => "\xEF\xBC\x8D",
		"\xA3\xAE" => "\xEF\xBC\x8E",
		"\xA3\xAF" => "\xEF\xBC\x8F",
		"\xA3\xB0" => "\xEF\xBC\x90",
		"\xA3\xB1" => "\xEF\xBC\x91",
		"\xA3\xB2" => "\xEF\xBC\x92",
		"\xA3\xB3" => "\xEF\xBC\x93",
		"\xA3\xB4" => "\xEF\xBC\x94",
		"\xA3\xB5" => "\xEF\xBC\x95",
		"\xA3\xB6" => "\xEF\xBC\x96",
		"\xA3\xB7" => "\xEF\xBC\x97",
		"\xA3\xB8" => "\xEF\xBC\x98",
		"\xA3\xB9" => "\xEF\xBC\x99",
		"\xA3\xBA" => "\xEF\xBC\x9A",
		"\xA3\xBB" => "\xEF\xBC\x9B",
		"\xA3\xBC" => "\xEF\xBC\x9C",
		"\xA3\xBD" => "\xEF\xBC\x9D",
		"\xA3\xBE" => "\xEF\xBC\x9E",
		"\xA3\xBF" => "\xEF\xBC\x9F",
		"\xA3\xC0" => "\xEF\xBC\xA0",
		"\xA3\xC1" => "\xEF\xBC\xA1",
		"\xA3\xC2" => "\xEF\xBC\xA2",
		"\xA3\xC3" => "\xEF\xBC\xA3",
		"\xA3\xC4" => "\xEF\xBC\xA4",
		"\xA3\xC5" => "\xEF\xBC\xA5",
		"\xA3\xC6" => "\xEF\xBC\xA6",
		"\xA3\xC7" => "\xEF\xBC\xA7",
		"\xA3\xC8" => "\xEF\xBC\xA8",
		"\xA3\xC9" => "\xEF\xBC\xA9",
		"\xA3\xCA" => "\xEF\xBC\xAA",
		"\xA3\xCB" => "\xEF\xBC\xAB",
		"\xA3\xCC" => "\xEF\xBC\xAC",
		"\xA3\xCD" => "\xEF\xBC\xAD",
		"\xA3\xCE" => "\xEF\xBC\xAE",
		"\xA3\xCF" => "\xEF\xBC\xAF",
		"\xA3\xD0" => "\xEF\xBC\xB0",
		"\xA3\xD1" => "\xEF\xBC\xB1",
		"\xA3\xD2" => "\xEF\xBC\xB2",
		"\xA3\xD3" => "\xEF\xBC\xB3",
		"\xA3\xD4" => "\xEF\xBC\xB4",
		"\xA3\xD5" => "\xEF\xBC\xB5",
		"\xA3\xD6" => "\xEF\xBC\xB6",
		"\xA3\xD7" => "\xEF\xBC\xB7",
		"\xA3\xD8" => "\xEF\xBC\xB8",
		"\xA3\xD9" => "\xEF\xBC\xB9",
		"\xA3\xDA" => "\xEF\xBC\xBA",
		"\xA3\xDB" => "\xEF\xBC\xBB",
		"\xA3\xDC" => "\xEF\xBF\xA6",
		"\xA3\xDD" => "\xEF\xBC\xBD",
		"\xA3\xDE" => "\xEF\xBC\xBE",
		"\xA3\xDF" => "\xEF\xBC\xBF",
		"\xA3\xE0" => "\xEF\xBD\x80",
		"\xA3\xE1" => "\xEF\xBD\x81",
		"\xA3\xE2" => "\xEF\xBD\x82",
		"\xA3\xE3" => "\xEF\xBD\x83",
		"\xA3\xE4" => "\xEF\xBD\x84",
		"\xA3\xE5" => "\xEF\xBD\x85",
		"\xA3\xE6" => "\xEF\xBD\x86",
		"\xA3\xE7" => "\xEF\xBD\x87",
		"\xA3\xE8" => "\xEF\xBD\x88",
		"\xA3\xE9" => "\xEF\xBD\x89",
		"\xA3\xEA" => "\xEF\xBD\x8A",
		"\xA3\xEB" => "\xEF\xBD\x8B",
		"\xA3\xEC" => "\xEF\xBD\x8C",
		"\xA3\xED" => "\xEF\xBD\x8D",
		"\xA3\xEE" => "\xEF\xBD\x8E",
		"\xA3\xEF" => "\xEF\xBD\x8F",
		"\xA3\xF0" => "\xEF\xBD\x90",
		"\xA3\xF1" => "\xEF\xBD\x91",
		"\xA3\xF2" => "\xEF\xBD\x92",
		"\xA3\xF3" => "\xEF\xBD\x93",
		"\xA3\xF4" => "\xEF\xBD\x94",
		"\xA3\xF5" => "\xEF\xBD\x95",
		"\xA3\xF6" => "\xEF\xBD\x96",
		"\xA3\xF7" => "\xEF\xBD\x97",
		"\xA3\xF8" => "\xEF\xBD\x98",
		"\xA3\xF9" => "\xEF\xBD\x99",
		"\xA3\xFA" => "\xEF\xBD\x9A",
		"\xA3\xFB" => "\xEF\xBD\x9B",
		"\xA3\xFC" => "\xEF\xBD\x9C",
		"\xA3\xFD" => "\xEF\xBD\x9D",
		"\xA3\xFE" => "\xEF\xBF\xA3",
		"\xA4\x41" => "\xEC\xA7\x9E",
		"\xA4\x42" => "\xEC\xA7\x9F",
		"\xA4\x43" => "\xEC\xA7\xA1",
		"\xA4\x44" => "\xEC\xA7\xA3",
		"\xA4\x45" => "\xEC\xA7\xA5",
		"\xA4\x46" => "\xEC\xA7\xA6",
		"\xA4\x47" => "\xEC\xA7\xA8",
		"\xA4\x48" => "\xEC\xA7\xA9",
		"\xA4\x49" => "\xEC\xA7\xAA",
		"\xA4\x4A" => "\xEC\xA7\xAB",
		"\xA4\x4B" => "\xEC\xA7\xAE",
		"\xA4\x4C" => "\xEC\xA7\xB2",
		"\xA4\x4D" => "\xEC\xA7\xB3",
		"\xA4\x4E" => "\xEC\xA7\xB4",
		"\xA4\x4F" => "\xEC\xA7\xB5",
		"\xA4\x50" => "\xEC\xA7\xB6",
		"\xA4\x51" => "\xEC\xA7\xB7",
		"\xA4\x52" => "\xEC\xA7\xBA",
		"\xA4\x53" => "\xEC\xA7\xBB",
		"\xA4\x54" => "\xEC\xA7\xBD",
		"\xA4\x55" => "\xEC\xA7\xBE",
		"\xA4\x56" => "\xEC\xA7\xBF",
		"\xA4\x57" => "\xEC\xA8\x81",
		"\xA4\x58" => "\xEC\xA8\x82",
		"\xA4\x59" => "\xEC\xA8\x83",
		"\xA4\x5A" => "\xEC\xA8\x84",
		"\xA4\x61" => "\xEC\xA8\x85",
		"\xA4\x62" => "\xEC\xA8\x86",
		"\xA4\x63" => "\xEC\xA8\x87",
		"\xA4\x64" => "\xEC\xA8\x8A",
		"\xA4\x65" => "\xEC\xA8\x8E",
		"\xA4\x66" => "\xEC\xA8\x8F",
		"\xA4\x67" => "\xEC\xA8\x90",
		"\xA4\x68" => "\xEC\xA8\x91",
		"\xA4\x69" => "\xEC\xA8\x92",
		"\xA4\x6A" => "\xEC\xA8\x93",
		"\xA4\x6B" => "\xEC\xA8\x95",
		"\xA4\x6C" => "\xEC\xA8\x96",
		"\xA4\x6D" => "\xEC\xA8\x97",
		"\xA4\x6E" => "\xEC\xA8\x99",
		"\xA4\x6F" => "\xEC\xA8\x9A",
		"\xA4\x70" => "\xEC\xA8\x9B",
		"\xA4\x71" => "\xEC\xA8\x9C",
		"\xA4\x72" => "\xEC\xA8\x9D",
		"\xA4\x73" => "\xEC\xA8\x9E",
		"\xA4\x74" => "\xEC\xA8\x9F",
		"\xA4\x75" => "\xEC\xA8\xA0",
		"\xA4\x76" => "\xEC\xA8\xA1",
		"\xA4\x77" => "\xEC\xA8\xA2",
		"\xA4\x78" => "\xEC\xA8\xA3",
		"\xA4\x79" => "\xEC\xA8\xA4",
		"\xA4\x7A" => "\xEC\xA8\xA5",
		"\xA4\x81" => "\xEC\xA8\xA6",
		"\xA4\x82" => "\xEC\xA8\xA7",
		"\xA4\x83" => "\xEC\xA8\xA8",
		"\xA4\x84" => "\xEC\xA8\xAA",
		"\xA4\x85" => "\xEC\xA8\xAB",
		"\xA4\x86" => "\xEC\xA8\xAC",
		"\xA4\x87" => "\xEC\xA8\xAD",
		"\xA4\x88" => "\xEC\xA8\xAE",
		"\xA4\x89" => "\xEC\xA8\xAF",
		"\xA4\x8A" => "\xEC\xA8\xB0",
		"\xA4\x8B" => "\xEC\xA8\xB1",
		"\xA4\x8C" => "\xEC\xA8\xB2",
		"\xA4\x8D" => "\xEC\xA8\xB3",
		"\xA4\x8E" => "\xEC\xA8\xB4",
		"\xA4\x8F" => "\xEC\xA8\xB5",
		"\xA4\x90" => "\xEC\xA8\xB6",
		"\xA4\x91" => "\xEC\xA8\xB7",
		"\xA4\x92" => "\xEC\xA8\xB8",
		"\xA4\x93" => "\xEC\xA8\xB9",
		"\xA4\x94" => "\xEC\xA8\xBA",
		"\xA4\x95" => "\xEC\xA8\xBB",
		"\xA4\x96" => "\xEC\xA8\xBC",
		"\xA4\x97" => "\xEC\xA8\xBD",
		"\xA4\x98" => "\xEC\xA8\xBE",
		"\xA4\x99" => "\xEC\xA8\xBF",
		"\xA4\x9A" => "\xEC\xA9\x80",
		"\xA4\x9B" => "\xEC\xA9\x81",
		"\xA4\x9C" => "\xEC\xA9\x82",
		"\xA4\x9D" => "\xEC\xA9\x83",
		"\xA4\x9E" => "\xEC\xA9\x84",
		"\xA4\x9F" => "\xEC\xA9\x85",
		"\xA4\xA0" => "\xEC\xA9\x86",
		"\xA4\xA1" => "\xE3\x84\xB1",
		"\xA4\xA2" => "\xE3\x84\xB2",
		"\xA4\xA3" => "\xE3\x84\xB3",
		"\xA4\xA4" => "\xE3\x84\xB4",
		"\xA4\xA5" => "\xE3\x84\xB5",
		"\xA4\xA6" => "\xE3\x84\xB6",
		"\xA4\xA7" => "\xE3\x84\xB7",
		"\xA4\xA8" => "\xE3\x84\xB8",
		"\xA4\xA9" => "\xE3\x84\xB9",
		"\xA4\xAA" => "\xE3\x84\xBA",
		"\xA4\xAB" => "\xE3\x84\xBB",
		"\xA4\xAC" => "\xE3\x84\xBC",
		"\xA4\xAD" => "\xE3\x84\xBD",
		"\xA4\xAE" => "\xE3\x84\xBE",
		"\xA4\xAF" => "\xE3\x84\xBF",
		"\xA4\xB0" => "\xE3\x85\x80",
		"\xA4\xB1" => "\xE3\x85\x81",
		"\xA4\xB2" => "\xE3\x85\x82",
		"\xA4\xB3" => "\xE3\x85\x83",
		"\xA4\xB4" => "\xE3\x85\x84",
		"\xA4\xB5" => "\xE3\x85\x85",
		"\xA4\xB6" => "\xE3\x85\x86",
		"\xA4\xB7" => "\xE3\x85\x87",
		"\xA4\xB8" => "\xE3\x85\x88",
		"\xA4\xB9" => "\xE3\x85\x89",
		"\xA4\xBA" => "\xE3\x85\x8A",
		"\xA4\xBB" => "\xE3\x85\x8B",
		"\xA4\xBC" => "\xE3\x85\x8C",
		"\xA4\xBD" => "\xE3\x85\x8D",
		"\xA4\xBE" => "\xE3\x85\x8E",
		"\xA4\xBF" => "\xE3\x85\x8F",
		"\xA4\xC0" => "\xE3\x85\x90",
		"\xA4\xC1" => "\xE3\x85\x91",
		"\xA4\xC2" => "\xE3\x85\x92",
		"\xA4\xC3" => "\xE3\x85\x93",
		"\xA4\xC4" => "\xE3\x85\x94",
		"\xA4\xC5" => "\xE3\x85\x95",
		"\xA4\xC6" => "\xE3\x85\x96",
		"\xA4\xC7" => "\xE3\x85\x97",
		"\xA4\xC8" => "\xE3\x85\x98",
		"\xA4\xC9" => "\xE3\x85\x99",
		"\xA4\xCA" => "\xE3\x85\x9A",
		"\xA4\xCB" => "\xE3\x85\x9B",
		"\xA4\xCC" => "\xE3\x85\x9C",
		"\xA4\xCD" => "\xE3\x85\x9D",
		"\xA4\xCE" => "\xE3\x85\x9E",
		"\xA4\xCF" => "\xE3\x85\x9F",
		"\xA4\xD0" => "\xE3\x85\xA0",
		"\xA4\xD1" => "\xE3\x85\xA1",
		"\xA4\xD2" => "\xE3\x85\xA2",
		"\xA4\xD3" => "\xE3\x85\xA3",
		"\xA4\xD4" => "\xE3\x85\xA4",
		"\xA4\xD5" => "\xE3\x85\xA5",
		"\xA4\xD6" => "\xE3\x85\xA6",
		"\xA4\xD7" => "\xE3\x85\xA7",
		"\xA4\xD8" => "\xE3\x85\xA8",
		"\xA4\xD9" => "\xE3\x85\xA9",
		"\xA4\xDA" => "\xE3\x85\xAA",
		"\xA4\xDB" => "\xE3\x85\xAB",
		"\xA4\xDC" => "\xE3\x85\xAC",
		"\xA4\xDD" => "\xE3\x85\xAD",
		"\xA4\xDE" => "\xE3\x85\xAE",
		"\xA4\xDF" => "\xE3\x85\xAF",
		"\xA4\xE0" => "\xE3\x85\xB0",
		"\xA4\xE1" => "\xE3\x85\xB1",
		"\xA4\xE2" => "\xE3\x85\xB2",
		"\xA4\xE3" => "\xE3\x85\xB3",
		"\xA4\xE4" => "\xE3\x85\xB4",
		"\xA4\xE5" => "\xE3\x85\xB5",
		"\xA4\xE6" => "\xE3\x85\xB6",
		"\xA4\xE7" => "\xE3\x85\xB7",
		"\xA4\xE8" => "\xE3\x85\xB8",
		"\xA4\xE9" => "\xE3\x85\xB9",
		"\xA4\xEA" => "\xE3\x85\xBA",
		"\xA4\xEB" => "\xE3\x85\xBB",
		"\xA4\xEC" => "\xE3\x85\xBC",
		"\xA4\xED" => "\xE3\x85\xBD",
		"\xA4\xEE" => "\xE3\x85\xBE",
		"\xA4\xEF" => "\xE3\x85\xBF",
		"\xA4\xF0" => "\xE3\x86\x80",
		"\xA4\xF1" => "\xE3\x86\x81",
		"\xA4\xF2" => "\xE3\x86\x82",
		"\xA4\xF3" => "\xE3\x86\x83",
		"\xA4\xF4" => "\xE3\x86\x84",
		"\xA4\xF5" => "\xE3\x86\x85",
		"\xA4\xF6" => "\xE3\x86\x86",
		"\xA4\xF7" => "\xE3\x86\x87",
		"\xA4\xF8" => "\xE3\x86\x88",
		"\xA4\xF9" => "\xE3\x86\x89",
		"\xA4\xFA" => "\xE3\x86\x8A",
		"\xA4\xFB" => "\xE3\x86\x8B",
		"\xA4\xFC" => "\xE3\x86\x8C",
		"\xA4\xFD" => "\xE3\x86\x8D",
		"\xA4\xFE" => "\xE3\x86\x8E",
		"\xA5\x41" => "\xEC\xA9\x87",
		"\xA5\x42" => "\xEC\xA9\x88",
		"\xA5\x43" => "\xEC\xA9\x89",
		"\xA5\x44" => "\xEC\xA9\x8A",
		"\xA5\x45" => "\xEC\xA9\x8B",
		"\xA5\x46" => "\xEC\xA9\x8E",
		"\xA5\x47" => "\xEC\xA9\x8F",
		"\xA5\x48" => "\xEC\xA9\x91",
		"\xA5\x49" => "\xEC\xA9\x92",
		"\xA5\x4A" => "\xEC\xA9\x93",
		"\xA5\x4B" => "\xEC\xA9\x95",
		"\xA5\x4C" => "\xEC\xA9\x96",
		"\xA5\x4D" => "\xEC\xA9\x97",
		"\xA5\x4E" => "\xEC\xA9\x98",
		"\xA5\x4F" => "\xEC\xA9\x99",
		"\xA5\x50" => "\xEC\xA9\x9A",
		"\xA5\x51" => "\xEC\xA9\x9B",
		"\xA5\x52" => "\xEC\xA9\x9E",
		"\xA5\x53" => "\xEC\xA9\xA2",
		"\xA5\x54" => "\xEC\xA9\xA3",
		"\xA5\x55" => "\xEC\xA9\xA4",
		"\xA5\x56" => "\xEC\xA9\xA5",
		"\xA5\x57" => "\xEC\xA9\xA6",
		"\xA5\x58" => "\xEC\xA9\xA7",
		"\xA5\x59" => "\xEC\xA9\xA9",
		"\xA5\x5A" => "\xEC\xA9\xAA",
		"\xA5\x61" => "\xEC\xA9\xAB",
		"\xA5\x62" => "\xEC\xA9\xAC",
		"\xA5\x63" => "\xEC\xA9\xAD",
		"\xA5\x64" => "\xEC\xA9\xAE",
		"\xA5\x65" => "\xEC\xA9\xAF",
		"\xA5\x66" => "\xEC\xA9\xB0",
		"\xA5\x67" => "\xEC\xA9\xB1",
		"\xA5\x68" => "\xEC\xA9\xB2",
		"\xA5\x69" => "\xEC\xA9\xB3",
		"\xA5\x6A" => "\xEC\xA9\xB4",
		"\xA5\x6B" => "\xEC\xA9\xB5",
		"\xA5\x6C" => "\xEC\xA9\xB6",
		"\xA5\x6D" => "\xEC\xA9\xB7",
		"\xA5\x6E" => "\xEC\xA9\xB8",
		"\xA5\x6F" => "\xEC\xA9\xB9",
		"\xA5\x70" => "\xEC\xA9\xBA",
		"\xA5\x71" => "\xEC\xA9\xBB",
		"\xA5\x72" => "\xEC\xA9\xBC",
		"\xA5\x73" => "\xEC\xA9\xBE",
		"\xA5\x74" => "\xEC\xA9\xBF",
		"\xA5\x75" => "\xEC\xAA\x80",
		"\xA5\x76" => "\xEC\xAA\x81",
		"\xA5\x77" => "\xEC\xAA\x82",
		"\xA5\x78" => "\xEC\xAA\x83",
		"\xA5\x79" => "\xEC\xAA\x85",
		"\xA5\x7A" => "\xEC\xAA\x86",
		"\xA5\x81" => "\xEC\xAA\x87",
		"\xA5\x82" => "\xEC\xAA\x88",
		"\xA5\x83" => "\xEC\xAA\x89",
		"\xA5\x84" => "\xEC\xAA\x8A",
		"\xA5\x85" => "\xEC\xAA\x8B",
		"\xA5\x86" => "\xEC\xAA\x8C",
		"\xA5\x87" => "\xEC\xAA\x8D",
		"\xA5\x88" => "\xEC\xAA\x8E",
		"\xA5\x89" => "\xEC\xAA\x8F",
		"\xA5\x8A" => "\xEC\xAA\x90",
		"\xA5\x8B" => "\xEC\xAA\x91",
		"\xA5\x8C" => "\xEC\xAA\x92",
		"\xA5\x8D" => "\xEC\xAA\x93",
		"\xA5\x8E" => "\xEC\xAA\x94",
		"\xA5\x8F" => "\xEC\xAA\x95",
		"\xA5\x90" => "\xEC\xAA\x96",
		"\xA5\x91" => "\xEC\xAA\x97",
		"\xA5\x92" => "\xEC\xAA\x99",
		"\xA5\x93" => "\xEC\xAA\x9A",
		"\xA5\x94" => "\xEC\xAA\x9B",
		"\xA5\x95" => "\xEC\xAA\x9C",
		"\xA5\x96" => "\xEC\xAA\x9D",
		"\xA5\x97" => "\xEC\xAA\x9E",
		"\xA5\x98" => "\xEC\xAA\x9F",
		"\xA5\x99" => "\xEC\xAA\xA0",
		"\xA5\x9A" => "\xEC\xAA\xA1",
		"\xA5\x9B" => "\xEC\xAA\xA2",
		"\xA5\x9C" => "\xEC\xAA\xA3",
		"\xA5\x9D" => "\xEC\xAA\xA4",
		"\xA5\x9E" => "\xEC\xAA\xA5",
		"\xA5\x9F" => "\xEC\xAA\xA6",
		"\xA5\xA0" => "\xEC\xAA\xA7",
		"\xA5\xA1" => "\xE2\x85\xB0",
		"\xA5\xA2" => "\xE2\x85\xB1",
		"\xA5\xA3" => "\xE2\x85\xB2",
		"\xA5\xA4" => "\xE2\x85\xB3",
		"\xA5\xA5" => "\xE2\x85\xB4",
		"\xA5\xA6" => "\xE2\x85\xB5",
		"\xA5\xA7" => "\xE2\x85\xB6",
		"\xA5\xA8" => "\xE2\x85\xB7",
		"\xA5\xA9" => "\xE2\x85\xB8",
		"\xA5\xAA" => "\xE2\x85\xB9",
		"\xA5\xB0" => "\xE2\x85\xA0",
		"\xA5\xB1" => "\xE2\x85\xA1",
		"\xA5\xB2" => "\xE2\x85\xA2",
		"\xA5\xB3" => "\xE2\x85\xA3",
		"\xA5\xB4" => "\xE2\x85\xA4",
		"\xA5\xB5" => "\xE2\x85\xA5",
		"\xA5\xB6" => "\xE2\x85\xA6",
		"\xA5\xB7" => "\xE2\x85\xA7",
		"\xA5\xB8" => "\xE2\x85\xA8",
		"\xA5\xB9" => "\xE2\x85\xA9",
		"\xA5\xC1" => "\xCE\x91",
		"\xA5\xC2" => "\xCE\x92",
		"\xA5\xC3" => "\xCE\x93",
		"\xA5\xC4" => "\xCE\x94",
		"\xA5\xC5" => "\xCE\x95",
		"\xA5\xC6" => "\xCE\x96",
		"\xA5\xC7" => "\xCE\x97",
		"\xA5\xC8" => "\xCE\x98",
		"\xA5\xC9" => "\xCE\x99",
		"\xA5\xCA" => "\xCE\x9A",
		"\xA5\xCB" => "\xCE\x9B",
		"\xA5\xCC" => "\xCE\x9C",
		"\xA5\xCD" => "\xCE\x9D",
		"\xA5\xCE" => "\xCE\x9E",
		"\xA5\xCF" => "\xCE\x9F",
		"\xA5\xD0" => "\xCE\xA0",
		"\xA5\xD1" => "\xCE\xA1",
		"\xA5\xD2" => "\xCE\xA3",
		"\xA5\xD3" => "\xCE\xA4",
		"\xA5\xD4" => "\xCE\xA5",
		"\xA5\xD5" => "\xCE\xA6",
		"\xA5\xD6" => "\xCE\xA7",
		"\xA5\xD7" => "\xCE\xA8",
		"\xA5\xD8" => "\xCE\xA9",
		"\xA5\xE1" => "\xCE\xB1",
		"\xA5\xE2" => "\xCE\xB2",
		"\xA5\xE3" => "\xCE\xB3",
		"\xA5\xE4" => "\xCE\xB4",
		"\xA5\xE5" => "\xCE\xB5",
		"\xA5\xE6" => "\xCE\xB6",
		"\xA5\xE7" => "\xCE\xB7",
		"\xA5\xE8" => "\xCE\xB8",
		"\xA5\xE9" => "\xCE\xB9",
		"\xA5\xEA" => "\xCE\xBA",
		"\xA5\xEB" => "\xCE\xBB",
		"\xA5\xEC" => "\xCE\xBC",
		"\xA5\xED" => "\xCE\xBD",
		"\xA5\xEE" => "\xCE\xBE",
		"\xA5\xEF" => "\xCE\xBF",
		"\xA5\xF0" => "\xCF\x80",
		"\xA5\xF1" => "\xCF\x81",
		"\xA5\xF2" => "\xCF\x83",
		"\xA5\xF3" => "\xCF\x84",
		"\xA5\xF4" => "\xCF\x85",
		"\xA5\xF5" => "\xCF\x86",
		"\xA5\xF6" => "\xCF\x87",
		"\xA5\xF7" => "\xCF\x88",
		"\xA5\xF8" => "\xCF\x89",
		"\xA6\x41" => "\xEC\xAA\xA8",
		"\xA6\x42" => "\xEC\xAA\xA9",
		"\xA6\x43" => "\xEC\xAA\xAA",
		"\xA6\x44" => "\xEC\xAA\xAB",
		"\xA6\x45" => "\xEC\xAA\xAC",
		"\xA6\x46" => "\xEC\xAA\xAD",
		"\xA6\x47" => "\xEC\xAA\xAE",
		"\xA6\x48" => "\xEC\xAA\xAF",
		"\xA6\x49" => "\xEC\xAA\xB0",
		"\xA6\x4A" => "\xEC\xAA\xB1",
		"\xA6\x4B" => "\xEC\xAA\xB2",
		"\xA6\x4C" => "\xEC\xAA\xB3",
		"\xA6\x4D" => "\xEC\xAA\xB4",
		"\xA6\x4E" => "\xEC\xAA\xB5",
		"\xA6\x4F" => "\xEC\xAA\xB6",
		"\xA6\x50" => "\xEC\xAA\xB7",
		"\xA6\x51" => "\xEC\xAA\xB8",
		"\xA6\x52" => "\xEC\xAA\xB9",
		"\xA6\x53" => "\xEC\xAA\xBA",
		"\xA6\x54" => "\xEC\xAA\xBB",
		"\xA6\x55" => "\xEC\xAA\xBE",
		"\xA6\x56" => "\xEC\xAA\xBF",
		"\xA6\x57" => "\xEC\xAB\x81",
		"\xA6\x58" => "\xEC\xAB\x82",
		"\xA6\x59" => "\xEC\xAB\x83",
		"\xA6\x5A" => "\xEC\xAB\x85",
		"\xA6\x61" => "\xEC\xAB\x86",
		"\xA6\x62" => "\xEC\xAB\x87",
		"\xA6\x63" => "\xEC\xAB\x88",
		"\xA6\x64" => "\xEC\xAB\x89",
		"\xA6\x65" => "\xEC\xAB\x8A",
		"\xA6\x66" => "\xEC\xAB\x8B",
		"\xA6\x67" => "\xEC\xAB\x8E",
		"\xA6\x68" => "\xEC\xAB\x90",
		"\xA6\x69" => "\xEC\xAB\x92",
		"\xA6\x6A" => "\xEC\xAB\x94",
		"\xA6\x6B" => "\xEC\xAB\x95",
		"\xA6\x6C" => "\xEC\xAB\x96",
		"\xA6\x6D" => "\xEC\xAB\x97",
		"\xA6\x6E" => "\xEC\xAB\x9A",
		"\xA6\x6F" => "\xEC\xAB\x9B",
		"\xA6\x70" => "\xEC\xAB\x9C",
		"\xA6\x71" => "\xEC\xAB\x9D",
		"\xA6\x72" => "\xEC\xAB\x9E",
		"\xA6\x73" => "\xEC\xAB\x9F",
		"\xA6\x74" => "\xEC\xAB\xA1",
		"\xA6\x75" => "\xEC\xAB\xA2",
		"\xA6\x76" => "\xEC\xAB\xA3",
		"\xA6\x77" => "\xEC\xAB\xA4",
		"\xA6\x78" => "\xEC\xAB\xA5",
		"\xA6\x79" => "\xEC\xAB\xA6",
		"\xA6\x7A" => "\xEC\xAB\xA7",
		"\xA6\x81" => "\xEC\xAB\xA8",
		"\xA6\x82" => "\xEC\xAB\xA9",
		"\xA6\x83" => "\xEC\xAB\xAA",
		"\xA6\x84" => "\xEC\xAB\xAB",
		"\xA6\x85" => "\xEC\xAB\xAD",
		"\xA6\x86" => "\xEC\xAB\xAE",
		"\xA6\x87" => "\xEC\xAB\xAF",
		"\xA6\x88" => "\xEC\xAB\xB0",
		"\xA6\x89" => "\xEC\xAB\xB1",
		"\xA6\x8A" => "\xEC\xAB\xB2",
		"\xA6\x8B" => "\xEC\xAB\xB3",
		"\xA6\x8C" => "\xEC\xAB\xB5",
		"\xA6\x8D" => "\xEC\xAB\xB6",
		"\xA6\x8E" => "\xEC\xAB\xB7",
		"\xA6\x8F" => "\xEC\xAB\xB8",
		"\xA6\x90" => "\xEC\xAB\xB9",
		"\xA6\x91" => "\xEC\xAB\xBA",
		"\xA6\x92" => "\xEC\xAB\xBB",
		"\xA6\x93" => "\xEC\xAB\xBC",
		"\xA6\x94" => "\xEC\xAB\xBD",
		"\xA6\x95" => "\xEC\xAB\xBE",
		"\xA6\x96" => "\xEC\xAB\xBF",
		"\xA6\x97" => "\xEC\xAC\x80",
		"\xA6\x98" => "\xEC\xAC\x81",
		"\xA6\x99" => "\xEC\xAC\x82",
		"\xA6\x9A" => "\xEC\xAC\x83",
		"\xA6\x9B" => "\xEC\xAC\x84",
		"\xA6\x9C" => "\xEC\xAC\x85",
		"\xA6\x9D" => "\xEC\xAC\x86",
		"\xA6\x9E" => "\xEC\xAC\x87",
		"\xA6\x9F" => "\xEC\xAC\x89",
		"\xA6\xA0" => "\xEC\xAC\x8A",
		"\xA6\xA1" => "\xE2\x94\x80",
		"\xA6\xA2" => "\xE2\x94\x82",
		"\xA6\xA3" => "\xE2\x94\x8C",
		"\xA6\xA4" => "\xE2\x94\x90",
		"\xA6\xA5" => "\xE2\x94\x98",
		"\xA6\xA6" => "\xE2\x94\x94",
		"\xA6\xA7" => "\xE2\x94\x9C",
		"\xA6\xA8" => "\xE2\x94\xAC",
		"\xA6\xA9" => "\xE2\x94\xA4",
		"\xA6\xAA" => "\xE2\x94\xB4",
		"\xA6\xAB" => "\xE2\x94\xBC",
		"\xA6\xAC" => "\xE2\x94\x81",
		"\xA6\xAD" => "\xE2\x94\x83",
		"\xA6\xAE" => "\xE2\x94\x8F",
		"\xA6\xAF" => "\xE2\x94\x93",
		"\xA6\xB0" => "\xE2\x94\x9B",
		"\xA6\xB1" => "\xE2\x94\x97",
		"\xA6\xB2" => "\xE2\x94\xA3",
		"\xA6\xB3" => "\xE2\x94\xB3",
		"\xA6\xB4" => "\xE2\x94\xAB",
		"\xA6\xB5" => "\xE2\x94\xBB",
		"\xA6\xB6" => "\xE2\x95\x8B",
		"\xA6\xB7" => "\xE2\x94\xA0",
		"\xA6\xB8" => "\xE2\x94\xAF",
		"\xA6\xB9" => "\xE2\x94\xA8",
		"\xA6\xBA" => "\xE2\x94\xB7",
		"\xA6\xBB" => "\xE2\x94\xBF",
		"\xA6\xBC" => "\xE2\x94\x9D",
		"\xA6\xBD" => "\xE2\x94\xB0",
		"\xA6\xBE" => "\xE2\x94\xA5",
		"\xA6\xBF" => "\xE2\x94\xB8",
		"\xA6\xC0" => "\xE2\x95\x82",
		"\xA6\xC1" => "\xE2\x94\x92",
		"\xA6\xC2" => "\xE2\x94\x91",
		"\xA6\xC3" => "\xE2\x94\x9A",
		"\xA6\xC4" => "\xE2\x94\x99",
		"\xA6\xC5" => "\xE2\x94\x96",
		"\xA6\xC6" => "\xE2\x94\x95",
		"\xA6\xC7" => "\xE2\x94\x8E",
		"\xA6\xC8" => "\xE2\x94\x8D",
		"\xA6\xC9" => "\xE2\x94\x9E",
		"\xA6\xCA" => "\xE2\x94\x9F",
		"\xA6\xCB" => "\xE2\x94\xA1",
		"\xA6\xCC" => "\xE2\x94\xA2",
		"\xA6\xCD" => "\xE2\x94\xA6",
		"\xA6\xCE" => "\xE2\x94\xA7",
		"\xA6\xCF" => "\xE2\x94\xA9",
		"\xA6\xD0" => "\xE2\x94\xAA",
		"\xA6\xD1" => "\xE2\x94\xAD",
		"\xA6\xD2" => "\xE2\x94\xAE",
		"\xA6\xD3" => "\xE2\x94\xB1",
		"\xA6\xD4" => "\xE2\x94\xB2",
		"\xA6\xD5" => "\xE2\x94\xB5",
		"\xA6\xD6" => "\xE2\x94\xB6",
		"\xA6\xD7" => "\xE2\x94\xB9",
		"\xA6\xD8" => "\xE2\x94\xBA",
		"\xA6\xD9" => "\xE2\x94\xBD",
		"\xA6\xDA" => "\xE2\x94\xBE",
		"\xA6\xDB" => "\xE2\x95\x80",
		"\xA6\xDC" => "\xE2\x95\x81",
		"\xA6\xDD" => "\xE2\x95\x83",
		"\xA6\xDE" => "\xE2\x95\x84",
		"\xA6\xDF" => "\xE2\x95\x85",
		"\xA6\xE0" => "\xE2\x95\x86",
		"\xA6\xE1" => "\xE2\x95\x87",
		"\xA6\xE2" => "\xE2\x95\x88",
		"\xA6\xE3" => "\xE2\x95\x89",
		"\xA6\xE4" => "\xE2\x95\x8A",
		"\xA7\x41" => "\xEC\xAC\x8B",
		"\xA7\x42" => "\xEC\xAC\x8C",
		"\xA7\x43" => "\xEC\xAC\x8D",
		"\xA7\x44" => "\xEC\xAC\x8E",
		"\xA7\x45" => "\xEC\xAC\x8F",
		"\xA7\x46" => "\xEC\xAC\x91",
		"\xA7\x47" => "\xEC\xAC\x92",
		"\xA7\x48" => "\xEC\xAC\x93",
		"\xA7\x49" => "\xEC\xAC\x95",
		"\xA7\x4A" => "\xEC\xAC\x96",
		"\xA7\x4B" => "\xEC\xAC\x97",
		"\xA7\x4C" => "\xEC\xAC\x99",
		"\xA7\x4D" => "\xEC\xAC\x9A",
		"\xA7\x4E" => "\xEC\xAC\x9B",
		"\xA7\x4F" => "\xEC\xAC\x9C",
		"\xA7\x50" => "\xEC\xAC\x9D",
		"\xA7\x51" => "\xEC\xAC\x9E",
		"\xA7\x52" => "\xEC\xAC\x9F",
		"\xA7\x53" => "\xEC\xAC\xA2",
		"\xA7\x54" => "\xEC\xAC\xA3",
		"\xA7\x55" => "\xEC\xAC\xA4",
		"\xA7\x56" => "\xEC\xAC\xA5",
		"\xA7\x57" => "\xEC\xAC\xA6",
		"\xA7\x58" => "\xEC\xAC\xA7",
		"\xA7\x59" => "\xEC\xAC\xA8",
		"\xA7\x5A" => "\xEC\xAC\xA9",
		"\xA7\x61" => "\xEC\xAC\xAA",
		"\xA7\x62" => "\xEC\xAC\xAB",
		"\xA7\x63" => "\xEC\xAC\xAC",
		"\xA7\x64" => "\xEC\xAC\xAD",
		"\xA7\x65" => "\xEC\xAC\xAE",
		"\xA7\x66" => "\xEC\xAC\xAF",
		"\xA7\x67" => "\xEC\xAC\xB0",
		"\xA7\x68" => "\xEC\xAC\xB1",
		"\xA7\x69" => "\xEC\xAC\xB2",
		"\xA7\x6A" => "\xEC\xAC\xB3",
		"\xA7\x6B" => "\xEC\xAC\xB4",
		"\xA7\x6C" => "\xEC\xAC\xB5",
		"\xA7\x6D" => "\xEC\xAC\xB6",
		"\xA7\x6E" => "\xEC\xAC\xB7",
		"\xA7\x6F" => "\xEC\xAC\xB8",
		"\xA7\x70" => "\xEC\xAC\xB9",
		"\xA7\x71" => "\xEC\xAC\xBA",
		"\xA7\x72" => "\xEC\xAC\xBB",
		"\xA7\x73" => "\xEC\xAC\xBC",
		"\xA7\x74" => "\xEC\xAC\xBD",
		"\xA7\x75" => "\xEC\xAC\xBE",
		"\xA7\x76" => "\xEC\xAC\xBF",
		"\xA7\x77" => "\xEC\xAD\x80",
		"\xA7\x78" => "\xEC\xAD\x82",
		"\xA7\x79" => "\xEC\xAD\x83",
		"\xA7\x7A" => "\xEC\xAD\x84",
		"\xA7\x81" => "\xEC\xAD\x85",
		"\xA7\x82" => "\xEC\xAD\x86",
		"\xA7\x83" => "\xEC\xAD\x87",
		"\xA7\x84" => "\xEC\xAD\x8A",
		"\xA7\x85" => "\xEC\xAD\x8B",
		"\xA7\x86" => "\xEC\xAD\x8D",
		"\xA7\x87" => "\xEC\xAD\x8E",
		"\xA7\x88" => "\xEC\xAD\x8F",
		"\xA7\x89" => "\xEC\xAD\x91",
		"\xA7\x8A" => "\xEC\xAD\x92",
		"\xA7\x8B" => "\xEC\xAD\x93",
		"\xA7\x8C" => "\xEC\xAD\x94",
		"\xA7\x8D" => "\xEC\xAD\x95",
		"\xA7\x8E" => "\xEC\xAD\x96",
		"\xA7\x8F" => "\xEC\xAD\x97",
		"\xA7\x90" => "\xEC\xAD\x9A",
		"\xA7\x91" => "\xEC\xAD\x9B",
		"\xA7\x92" => "\xEC\xAD\x9C",
		"\xA7\x93" => "\xEC\xAD\x9E",
		"\xA7\x94" => "\xEC\xAD\x9F",
		"\xA7\x95" => "\xEC\xAD\xA0",
		"\xA7\x96" => "\xEC\xAD\xA1",
		"\xA7\x97" => "\xEC\xAD\xA2",
		"\xA7\x98" => "\xEC\xAD\xA3",
		"\xA7\x99" => "\xEC\xAD\xA5",
		"\xA7\x9A" => "\xEC\xAD\xA6",
		"\xA7\x9B" => "\xEC\xAD\xA7",
		"\xA7\x9C" => "\xEC\xAD\xA8",
		"\xA7\x9D" => "\xEC\xAD\xA9",
		"\xA7\x9E" => "\xEC\xAD\xAA",
		"\xA7\x9F" => "\xEC\xAD\xAB",
		"\xA7\xA0" => "\xEC\xAD\xAC",
		"\xA7\xA1" => "\xE3\x8E\x95",
		"\xA7\xA2" => "\xE3\x8E\x96",
		"\xA7\xA3" => "\xE3\x8E\x97",
		"\xA7\xA4" => "\xE2\x84\x93",
		"\xA7\xA5" => "\xE3\x8E\x98",
		"\xA7\xA6" => "\xE3\x8F\x84",
		"\xA7\xA7" => "\xE3\x8E\xA3",
		"\xA7\xA8" => "\xE3\x8E\xA4",
		"\xA7\xA9" => "\xE3\x8E\xA5",
		"\xA7\xAA" => "\xE3\x8E\xA6",
		"\xA7\xAB" => "\xE3\x8E\x99",
		"\xA7\xAC" => "\xE3\x8E\x9A",
		"\xA7\xAD" => "\xE3\x8E\x9B",
		"\xA7\xAE" => "\xE3\x8E\x9C",
		"\xA7\xAF" => "\xE3\x8E\x9D",
		"\xA7\xB0" => "\xE3\x8E\x9E",
		"\xA7\xB1" => "\xE3\x8E\x9F",
		"\xA7\xB2" => "\xE3\x8E\xA0",
		"\xA7\xB3" => "\xE3\x8E\xA1",
		"\xA7\xB4" => "\xE3\x8E\xA2",
		"\xA7\xB5" => "\xE3\x8F\x8A",
		"\xA7\xB6" => "\xE3\x8E\x8D",
		"\xA7\xB7" => "\xE3\x8E\x8E",
		"\xA7\xB8" => "\xE3\x8E\x8F",
		"\xA7\xB9" => "\xE3\x8F\x8F",
		"\xA7\xBA" => "\xE3\x8E\x88",
		"\xA7\xBB" => "\xE3\x8E\x89",
		"\xA7\xBC" => "\xE3\x8F\x88",
		"\xA7\xBD" => "\xE3\x8E\xA7",
		"\xA7\xBE" => "\xE3\x8E\xA8",
		"\xA7\xBF" => "\xE3\x8E\xB0",
		"\xA7\xC0" => "\xE3\x8E\xB1",
		"\xA7\xC1" => "\xE3\x8E\xB2",
		"\xA7\xC2" => "\xE3\x8E\xB3",
		"\xA7\xC3" => "\xE3\x8E\xB4",
		"\xA7\xC4" => "\xE3\x8E\xB5",
		"\xA7\xC5" => "\xE3\x8E\xB6",
		"\xA7\xC6" => "\xE3\x8E\xB7",
		"\xA7\xC7" => "\xE3\x8E\xB8",
		"\xA7\xC8" => "\xE3\x8E\xB9",
		"\xA7\xC9" => "\xE3\x8E\x80",
		"\xA7\xCA" => "\xE3\x8E\x81",
		"\xA7\xCB" => "\xE3\x8E\x82",
		"\xA7\xCC" => "\xE3\x8E\x83",
		"\xA7\xCD" => "\xE3\x8E\x84",
		"\xA7\xCE" => "\xE3\x8E\xBA",
		"\xA7\xCF" => "\xE3\x8E\xBB",
		"\xA7\xD0" => "\xE3\x8E\xBC",
		"\xA7\xD1" => "\xE3\x8E\xBD",
		"\xA7\xD2" => "\xE3\x8E\xBE",
		"\xA7\xD3" => "\xE3\x8E\xBF",
		"\xA7\xD4" => "\xE3\x8E\x90",
		"\xA7\xD5" => "\xE3\x8E\x91",
		"\xA7\xD6" => "\xE3\x8E\x92",
		"\xA7\xD7" => "\xE3\x8E\x93",
		"\xA7\xD8" => "\xE3\x8E\x94",
		"\xA7\xD9" => "\xE2\x84\xA6",
		"\xA7\xDA" => "\xE3\x8F\x80",
		"\xA7\xDB" => "\xE3\x8F\x81",
		"\xA7\xDC" => "\xE3\x8E\x8A",
		"\xA7\xDD" => "\xE3\x8E\x8B",
		"\xA7\xDE" => "\xE3\x8E\x8C",
		"\xA7\xDF" => "\xE3\x8F\x96",
		"\xA7\xE0" => "\xE3\x8F\x85",
		"\xA7\xE1" => "\xE3\x8E\xAD",
		"\xA7\xE2" => "\xE3\x8E\xAE",
		"\xA7\xE3" => "\xE3\x8E\xAF",
		"\xA7\xE4" => "\xE3\x8F\x9B",
		"\xA7\xE5" => "\xE3\x8E\xA9",
		"\xA7\xE6" => "\xE3\x8E\xAA",
		"\xA7\xE7" => "\xE3\x8E\xAB",
		"\xA7\xE8" => "\xE3\x8E\xAC",
		"\xA7\xE9" => "\xE3\x8F\x9D",
		"\xA7\xEA" => "\xE3\x8F\x90",
		"\xA7\xEB" => "\xE3\x8F\x93",
		"\xA7\xEC" => "\xE3\x8F\x83",
		"\xA7\xED" => "\xE3\x8F\x89",
		"\xA7\xEE" => "\xE3\x8F\x9C",
		"\xA7\xEF" => "\xE3\x8F\x86",
		"\xA8\x41" => "\xEC\xAD\xAD",
		"\xA8\x42" => "\xEC\xAD\xAE",
		"\xA8\x43" => "\xEC\xAD\xAF",
		"\xA8\x44" => "\xEC\xAD\xB0",
		"\xA8\x45" => "\xEC\xAD\xB1",
		"\xA8\x46" => "\xEC\xAD\xB2",
		"\xA8\x47" => "\xEC\xAD\xB3",
		"\xA8\x48" => "\xEC\xAD\xB4",
		"\xA8\x49" => "\xEC\xAD\xB5",
		"\xA8\x4A" => "\xEC\xAD\xB6",
		"\xA8\x4B" => "\xEC\xAD\xB7",
		"\xA8\x4C" => "\xEC\xAD\xBA",
		"\xA8\x4D" => "\xEC\xAD\xBB",
		"\xA8\x4E" => "\xEC\xAD\xBC",
		"\xA8\x4F" => "\xEC\xAD\xBD",
		"\xA8\x50" => "\xEC\xAD\xBE",
		"\xA8\x51" => "\xEC\xAD\xBF",
		"\xA8\x52" => "\xEC\xAE\x80",
		"\xA8\x53" => "\xEC\xAE\x81",
		"\xA8\x54" => "\xEC\xAE\x82",
		"\xA8\x55" => "\xEC\xAE\x83",
		"\xA8\x56" => "\xEC\xAE\x84",
		"\xA8\x57" => "\xEC\xAE\x85",
		"\xA8\x58" => "\xEC\xAE\x86",
		"\xA8\x59" => "\xEC\xAE\x87",
		"\xA8\x5A" => "\xEC\xAE\x88",
		"\xA8\x61" => "\xEC\xAE\x89",
		"\xA8\x62" => "\xEC\xAE\x8A",
		"\xA8\x63" => "\xEC\xAE\x8B",
		"\xA8\x64" => "\xEC\xAE\x8C",
		"\xA8\x65" => "\xEC\xAE\x8D",
		"\xA8\x66" => "\xEC\xAE\x8E",
		"\xA8\x67" => "\xEC\xAE\x8F",
		"\xA8\x68" => "\xEC\xAE\x90",
		"\xA8\x69" => "\xEC\xAE\x91",
		"\xA8\x6A" => "\xEC\xAE\x92",
		"\xA8\x6B" => "\xEC\xAE\x93",
		"\xA8\x6C" => "\xEC\xAE\x94",
		"\xA8\x6D" => "\xEC\xAE\x95",
		"\xA8\x6E" => "\xEC\xAE\x96",
		"\xA8\x6F" => "\xEC\xAE\x97",
		"\xA8\x70" => "\xEC\xAE\x98",
		"\xA8\x71" => "\xEC\xAE\x99",
		"\xA8\x72" => "\xEC\xAE\x9A",
		"\xA8\x73" => "\xEC\xAE\x9B",
		"\xA8\x74" => "\xEC\xAE\x9D",
		"\xA8\x75" => "\xEC\xAE\x9E",
		"\xA8\x76" => "\xEC\xAE\x9F",
		"\xA8\x77" => "\xEC\xAE\xA0",
		"\xA8\x78" => "\xEC\xAE\xA1",
		"\xA8\x79" => "\xEC\xAE\xA2",
		"\xA8\x7A" => "\xEC\xAE\xA3",
		"\xA8\x81" => "\xEC\xAE\xA4",
		"\xA8\x82" => "\xEC\xAE\xA5",
		"\xA8\x83" => "\xEC\xAE\xA6",
		"\xA8\x84" => "\xEC\xAE\xA7",
		"\xA8\x85" => "\xEC\xAE\xA8",
		"\xA8\x86" => "\xEC\xAE\xA9",
		"\xA8\x87" => "\xEC\xAE\xAA",
		"\xA8\x88" => "\xEC\xAE\xAB",
		"\xA8\x89" => "\xEC\xAE\xAC",
		"\xA8\x8A" => "\xEC\xAE\xAD",
		"\xA8\x8B" => "\xEC\xAE\xAE",
		"\xA8\x8C" => "\xEC\xAE\xAF",
		"\xA8\x8D" => "\xEC\xAE\xB0",
		"\xA8\x8E" => "\xEC\xAE\xB1",
		"\xA8\x8F" => "\xEC\xAE\xB2",
		"\xA8\x90" => "\xEC\xAE\xB3",
		"\xA8\x91" => "\xEC\xAE\xB4",
		"\xA8\x92" => "\xEC\xAE\xB5",
		"\xA8\x93" => "\xEC\xAE\xB6",
		"\xA8\x94" => "\xEC\xAE\xB7",
		"\xA8\x95" => "\xEC\xAE\xB9",
		"\xA8\x96" => "\xEC\xAE\xBA",
		"\xA8\x97" => "\xEC\xAE\xBB",
		"\xA8\x98" => "\xEC\xAE\xBC",
		"\xA8\x99" => "\xEC\xAE\xBD",
		"\xA8\x9A" => "\xEC\xAE\xBE",
		"\xA8\x9B" => "\xEC\xAE\xBF",
		"\xA8\x9C" => "\xEC\xAF\x80",
		"\xA8\x9D" => "\xEC\xAF\x81",
		"\xA8\x9E" => "\xEC\xAF\x82",
		"\xA8\x9F" => "\xEC\xAF\x83",
		"\xA8\xA0" => "\xEC\xAF\x84",
		"\xA8\xA1" => "\xC3\x86",
		"\xA8\xA2" => "\xC3\x90",
		"\xA8\xA3" => "\xC2\xAA",
		"\xA8\xA4" => "\xC4\xA6",
		"\xA8\xA6" => "\xC4\xB2",
		"\xA8\xA8" => "\xC4\xBF",
		"\xA8\xA9" => "\xC5\x81",
		"\xA8\xAA" => "\xC3\x98",
		"\xA8\xAB" => "\xC5\x92",
		"\xA8\xAC" => "\xC2\xBA",
		"\xA8\xAD" => "\xC3\x9E",
		"\xA8\xAE" => "\xC5\xA6",
		"\xA8\xAF" => "\xC5\x8A",
		"\xA8\xB1" => "\xE3\x89\xA0",
		"\xA8\xB2" => "\xE3\x89\xA1",
		"\xA8\xB3" => "\xE3\x89\xA2",
		"\xA8\xB4" => "\xE3\x89\xA3",
		"\xA8\xB5" => "\xE3\x89\xA4",
		"\xA8\xB6" => "\xE3\x89\xA5",
		"\xA8\xB7" => "\xE3\x89\xA6",
		"\xA8\xB8" => "\xE3\x89\xA7",
		"\xA8\xB9" => "\xE3\x89\xA8",
		"\xA8\xBA" => "\xE3\x89\xA9",
		"\xA8\xBB" => "\xE3\x89\xAA",
		"\xA8\xBC" => "\xE3\x89\xAB",
		"\xA8\xBD" => "\xE3\x89\xAC",
		"\xA8\xBE" => "\xE3\x89\xAD",
		"\xA8\xBF" => "\xE3\x89\xAE",
		"\xA8\xC0" => "\xE3\x89\xAF",
		"\xA8\xC1" => "\xE3\x89\xB0",
		"\xA8\xC2" => "\xE3\x89\xB1",
		"\xA8\xC3" => "\xE3\x89\xB2",
		"\xA8\xC4" => "\xE3\x89\xB3",
		"\xA8\xC5" => "\xE3\x89\xB4",
		"\xA8\xC6" => "\xE3\x89\xB5",
		"\xA8\xC7" => "\xE3\x89\xB6",
		"\xA8\xC8" => "\xE3\x89\xB7",
		"\xA8\xC9" => "\xE3\x89\xB8",
		"\xA8\xCA" => "\xE3\x89\xB9",
		"\xA8\xCB" => "\xE3\x89\xBA",
		"\xA8\xCC" => "\xE3\x89\xBB",
		"\xA8\xCD" => "\xE2\x93\x90",
		"\xA8\xCE" => "\xE2\x93\x91",
		"\xA8\xCF" => "\xE2\x93\x92",
		"\xA8\xD0" => "\xE2\x93\x93",
		"\xA8\xD1" => "\xE2\x93\x94",
		"\xA8\xD2" => "\xE2\x93\x95",
		"\xA8\xD3" => "\xE2\x93\x96",
		"\xA8\xD4" => "\xE2\x93\x97",
		"\xA8\xD5" => "\xE2\x93\x98",
		"\xA8\xD6" => "\xE2\x93\x99",
		"\xA8\xD7" => "\xE2\x93\x9A",
		"\xA8\xD8" => "\xE2\x93\x9B",
		"\xA8\xD9" => "\xE2\x93\x9C",
		"\xA8\xDA" => "\xE2\x93\x9D",
		"\xA8\xDB" => "\xE2\x93\x9E",
		"\xA8\xDC" => "\xE2\x93\x9F",
		"\xA8\xDD" => "\xE2\x93\xA0",
		"\xA8\xDE" => "\xE2\x93\xA1",
		"\xA8\xDF" => "\xE2\x93\xA2",
		"\xA8\xE0" => "\xE2\x93\xA3",
		"\xA8\xE1" => "\xE2\x93\xA4",
		"\xA8\xE2" => "\xE2\x93\xA5",
		"\xA8\xE3" => "\xE2\x93\xA6",
		"\xA8\xE4" => "\xE2\x93\xA7",
		"\xA8\xE5" => "\xE2\x93\xA8",
		"\xA8\xE6" => "\xE2\x93\xA9",
		"\xA8\xE7" => "\xE2\x91\xA0",
		"\xA8\xE8" => "\xE2\x91\xA1",
		"\xA8\xE9" => "\xE2\x91\xA2",
		"\xA8\xEA" => "\xE2\x91\xA3",
		"\xA8\xEB" => "\xE2\x91\xA4",
		"\xA8\xEC" => "\xE2\x91\xA5",
		"\xA8\xED" => "\xE2\x91\xA6",
		"\xA8\xEE" => "\xE2\x91\xA7",
		"\xA8\xEF" => "\xE2\x91\xA8",
		"\xA8\xF0" => "\xE2\x91\xA9",
		"\xA8\xF1" => "\xE2\x91\xAA",
		"\xA8\xF2" => "\xE2\x91\xAB",
		"\xA8\xF3" => "\xE2\x91\xAC",
		"\xA8\xF4" => "\xE2\x91\xAD",
		"\xA8\xF5" => "\xE2\x91\xAE",
		"\xA8\xF6" => "\xC2\xBD",
		"\xA8\xF7" => "\xE2\x85\x93",
		"\xA8\xF8" => "\xE2\x85\x94",
		"\xA8\xF9" => "\xC2\xBC",
		"\xA8\xFA" => "\xC2\xBE",
		"\xA8\xFB" => "\xE2\x85\x9B",
		"\xA8\xFC" => "\xE2\x85\x9C",
		"\xA8\xFD" => "\xE2\x85\x9D",
		"\xA8\xFE" => "\xE2\x85\x9E",
		"\xA9\x41" => "\xEC\xAF\x85",
		"\xA9\x42" => "\xEC\xAF\x86",
		"\xA9\x43" => "\xEC\xAF\x87",
		"\xA9\x44" => "\xEC\xAF\x88",
		"\xA9\x45" => "\xEC\xAF\x89",
		"\xA9\x46" => "\xEC\xAF\x8A",
		"\xA9\x47" => "\xEC\xAF\x8B",
		"\xA9\x48" => "\xEC\xAF\x8C",
		"\xA9\x49" => "\xEC\xAF\x8D",
		"\xA9\x4A" => "\xEC\xAF\x8E",
		"\xA9\x4B" => "\xEC\xAF\x8F",
		"\xA9\x4C" => "\xEC\xAF\x90",
		"\xA9\x4D" => "\xEC\xAF\x91",
		"\xA9\x4E" => "\xEC\xAF\x92",
		"\xA9\x4F" => "\xEC\xAF\x93",
		"\xA9\x50" => "\xEC\xAF\x95",
		"\xA9\x51" => "\xEC\xAF\x96",
		"\xA9\x52" => "\xEC\xAF\x97",
		"\xA9\x53" => "\xEC\xAF\x98",
		"\xA9\x54" => "\xEC\xAF\x99",
		"\xA9\x55" => "\xEC\xAF\x9A",
		"\xA9\x56" => "\xEC\xAF\x9B",
		"\xA9\x57" => "\xEC\xAF\x9C",
		"\xA9\x58" => "\xEC\xAF\x9D",
		"\xA9\x59" => "\xEC\xAF\x9E",
		"\xA9\x5A" => "\xEC\xAF\x9F",
		"\xA9\x61" => "\xEC\xAF\xA0",
		"\xA9\x62" => "\xEC\xAF\xA1",
		"\xA9\x63" => "\xEC\xAF\xA2",
		"\xA9\x64" => "\xEC\xAF\xA3",
		"\xA9\x65" => "\xEC\xAF\xA5",
		"\xA9\x66" => "\xEC\xAF\xA6",
		"\xA9\x67" => "\xEC\xAF\xA8",
		"\xA9\x68" => "\xEC\xAF\xAA",
		"\xA9\x69" => "\xEC\xAF\xAB",
		"\xA9\x6A" => "\xEC\xAF\xAC",
		"\xA9\x6B" => "\xEC\xAF\xAD",
		"\xA9\x6C" => "\xEC\xAF\xAE",
		"\xA9\x6D" => "\xEC\xAF\xAF",
		"\xA9\x6E" => "\xEC\xAF\xB0",
		"\xA9\x6F" => "\xEC\xAF\xB1",
		"\xA9\x70" => "\xEC\xAF\xB2",
		"\xA9\x71" => "\xEC\xAF\xB3",
		"\xA9\x72" => "\xEC\xAF\xB4",
		"\xA9\x73" => "\xEC\xAF\xB5",
		"\xA9\x74" => "\xEC\xAF\xB6",
		"\xA9\x75" => "\xEC\xAF\xB7",
		"\xA9\x76" => "\xEC\xAF\xB8",
		"\xA9\x77" => "\xEC\xAF\xB9",
		"\xA9\x78" => "\xEC\xAF\xBA",
		"\xA9\x79" => "\xEC\xAF\xBB",
		"\xA9\x7A" => "\xEC\xAF\xBC",
		"\xA9\x81" => "\xEC\xAF\xBD",
		"\xA9\x82" => "\xEC\xAF\xBE",
		"\xA9\x83" => "\xEC\xAF\xBF",
		"\xA9\x84" => "\xEC\xB0\x80",
		"\xA9\x85" => "\xEC\xB0\x81",
		"\xA9\x86" => "\xEC\xB0\x82",
		"\xA9\x87" => "\xEC\xB0\x83",
		"\xA9\x88" => "\xEC\xB0\x84",
		"\xA9\x89" => "\xEC\xB0\x85",
		"\xA9\x8A" => "\xEC\xB0\x86",
		"\xA9\x8B" => "\xEC\xB0\x87",
		"\xA9\x8C" => "\xEC\xB0\x88",
		"\xA9\x8D" => "\xEC\xB0\x89",
		"\xA9\x8E" => "\xEC\xB0\x8A",
		"\xA9\x8F" => "\xEC\xB0\x8B",
		"\xA9\x90" => "\xEC\xB0\x8E",
		"\xA9\x91" => "\xEC\xB0\x8F",
		"\xA9\x92" => "\xEC\xB0\x91",
		"\xA9\x93" => "\xEC\xB0\x92",
		"\xA9\x94" => "\xEC\xB0\x93",
		"\xA9\x95" => "\xEC\xB0\x95",
		"\xA9\x96" => "\xEC\xB0\x96",
		"\xA9\x97" => "\xEC\xB0\x97",
		"\xA9\x98" => "\xEC\xB0\x98",
		"\xA9\x99" => "\xEC\xB0\x99",
		"\xA9\x9A" => "\xEC\xB0\x9A",
		"\xA9\x9B" => "\xEC\xB0\x9B",
		"\xA9\x9C" => "\xEC\xB0\x9E",
		"\xA9\x9D" => "\xEC\xB0\x9F",
		"\xA9\x9E" => "\xEC\xB0\xA0",
		"\xA9\x9F" => "\xEC\xB0\xA3",
		"\xA9\xA0" => "\xEC\xB0\xA4",
		"\xA9\xA1" => "\xC3\xA6",
		"\xA9\xA2" => "\xC4\x91",
		"\xA9\xA3" => "\xC3\xB0",
		"\xA9\xA4" => "\xC4\xA7",
		"\xA9\xA5" => "\xC4\xB1",
		"\xA9\xA6" => "\xC4\xB3",
		"\xA9\xA7" => "\xC4\xB8",
		"\xA9\xA8" => "\xC5\x80",
		"\xA9\xA9" => "\xC5\x82",
		"\xA9\xAA" => "\xC3\xB8",
		"\xA9\xAB" => "\xC5\x93",
		"\xA9\xAC" => "\xC3\x9F",
		"\xA9\xAD" => "\xC3\xBE",
		"\xA9\xAE" => "\xC5\xA7",
		"\xA9\xAF" => "\xC5\x8B",
		"\xA9\xB0" => "\xC5\x89",
		"\xA9\xB1" => "\xE3\x88\x80",
		"\xA9\xB2" => "\xE3\x88\x81",
		"\xA9\xB3" => "\xE3\x88\x82",
		"\xA9\xB4" => "\xE3\x88\x83",
		"\xA9\xB5" => "\xE3\x88\x84",
		"\xA9\xB6" => "\xE3\x88\x85",
		"\xA9\xB7" => "\xE3\x88\x86",
		"\xA9\xB8" => "\xE3\x88\x87",
		"\xA9\xB9" => "\xE3\x88\x88",
		"\xA9\xBA" => "\xE3\x88\x89",
		"\xA9\xBB" => "\xE3\x88\x8A",
		"\xA9\xBC" => "\xE3\x88\x8B",
		"\xA9\xBD" => "\xE3\x88\x8C",
		"\xA9\xBE" => "\xE3\x88\x8D",
		"\xA9\xBF" => "\xE3\x88\x8E",
		"\xA9\xC0" => "\xE3\x88\x8F",
		"\xA9\xC1" => "\xE3\x88\x90",
		"\xA9\xC2" => "\xE3\x88\x91",
		"\xA9\xC3" => "\xE3\x88\x92",
		"\xA9\xC4" => "\xE3\x88\x93",
		"\xA9\xC5" => "\xE3\x88\x94",
		"\xA9\xC6" => "\xE3\x88\x95",
		"\xA9\xC7" => "\xE3\x88\x96",
		"\xA9\xC8" => "\xE3\x88\x97",
		"\xA9\xC9" => "\xE3\x88\x98",
		"\xA9\xCA" => "\xE3\x88\x99",
		"\xA9\xCB" => "\xE3\x88\x9A",
		"\xA9\xCC" => "\xE3\x88\x9B",
		"\xA9\xCD" => "\xE2\x92\x9C",
		"\xA9\xCE" => "\xE2\x92\x9D",
		"\xA9\xCF" => "\xE2\x92\x9E",
		"\xA9\xD0" => "\xE2\x92\x9F",
		"\xA9\xD1" => "\xE2\x92\xA0",
		"\xA9\xD2" => "\xE2\x92\xA1",
		"\xA9\xD3" => "\xE2\x92\xA2",
		"\xA9\xD4" => "\xE2\x92\xA3",
		"\xA9\xD5" => "\xE2\x92\xA4",
		"\xA9\xD6" => "\xE2\x92\xA5",
		"\xA9\xD7" => "\xE2\x92\xA6",
		"\xA9\xD8" => "\xE2\x92\xA7",
		"\xA9\xD9" => "\xE2\x92\xA8",
		"\xA9\xDA" => "\xE2\x92\xA9",
		"\xA9\xDB" => "\xE2\x92\xAA",
		"\xA9\xDC" => "\xE2\x92\xAB",
		"\xA9\xDD" => "\xE2\x92\xAC",
		"\xA9\xDE" => "\xE2\x92\xAD",
		"\xA9\xDF" => "\xE2\x92\xAE",
		"\xA9\xE0" => "\xE2\x92\xAF",
		"\xA9\xE1" => "\xE2\x92\xB0",
		"\xA9\xE2" => "\xE2\x92\xB1",
		"\xA9\xE3" => "\xE2\x92\xB2",
		"\xA9\xE4" => "\xE2\x92\xB3",
		"\xA9\xE5" => "\xE2\x92\xB4",
		"\xA9\xE6" => "\xE2\x92\xB5",
		"\xA9\xE7" => "\xE2\x91\xB4",
		"\xA9\xE8" => "\xE2\x91\xB5",
		"\xA9\xE9" => "\xE2\x91\xB6",
		"\xA9\xEA" => "\xE2\x91\xB7",
		"\xA9\xEB" => "\xE2\x91\xB8",
		"\xA9\xEC" => "\xE2\x91\xB9",
		"\xA9\xED" => "\xE2\x91\xBA",
		"\xA9\xEE" => "\xE2\x91\xBB",
		"\xA9\xEF" => "\xE2\x91\xBC",
		"\xA9\xF0" => "\xE2\x91\xBD",
		"\xA9\xF1" => "\xE2\x91\xBE",
		"\xA9\xF2" => "\xE2\x91\xBF",
		"\xA9\xF3" => "\xE2\x92\x80",
		"\xA9\xF4" => "\xE2\x92\x81",
		"\xA9\xF5" => "\xE2\x92\x82",
		"\xA9\xF6" => "\xC2\xB9",
		"\xA9\xF7" => "\xC2\xB2",
		"\xA9\xF8" => "\xC2\xB3",
		"\xA9\xF9" => "\xE2\x81\xB4",
		"\xA9\xFA" => "\xE2\x81\xBF",
		"\xA9\xFB" => "\xE2\x82\x81",
		"\xA9\xFC" => "\xE2\x82\x82",
		"\xA9\xFD" => "\xE2\x82\x83",
		"\xA9\xFE" => "\xE2\x82\x84",
		"\xAA\x41" => "\xEC\xB0\xA5",
		"\xAA\x42" => "\xEC\xB0\xA6",
		"\xAA\x43" => "\xEC\xB0\xAA",
		"\xAA\x44" => "\xEC\xB0\xAB",
		"\xAA\x45" => "\xEC\xB0\xAD",
		"\xAA\x46" => "\xEC\xB0\xAF",
		"\xAA\x47" => "\xEC\xB0\xB1",
		"\xAA\x48" => "\xEC\xB0\xB2",
		"\xAA\x49" => "\xEC\xB0\xB3",
		"\xAA\x4A" => "\xEC\xB0\xB4",
		"\xAA\x4B" => "\xEC\xB0\xB5",
		"\xAA\x4C" => "\xEC\xB0\xB6",
		"\xAA\x4D" => "\xEC\xB0\xB7",
		"\xAA\x4E" => "\xEC\xB0\xBA",
		"\xAA\x4F" => "\xEC\xB0\xBF",
		"\xAA\x50" => "\xEC\xB1\x80",
		"\xAA\x51" => "\xEC\xB1\x81",
		"\xAA\x52" => "\xEC\xB1\x82",
		"\xAA\x53" => "\xEC\xB1\x83",
		"\xAA\x54" => "\xEC\xB1\x86",
		"\xAA\x55" => "\xEC\xB1\x87",
		"\xAA\x56" => "\xEC\xB1\x89",
		"\xAA\x57" => "\xEC\xB1\x8A",
		"\xAA\x58" => "\xEC\xB1\x8B",
		"\xAA\x59" => "\xEC\xB1\x8D",
		"\xAA\x5A" => "\xEC\xB1\x8E",
		"\xAA\x61" => "\xEC\xB1\x8F",
		"\xAA\x62" => "\xEC\xB1\x90",
		"\xAA\x63" => "\xEC\xB1\x91",
		"\xAA\x64" => "\xEC\xB1\x92",
		"\xAA\x65" => "\xEC\xB1\x93",
		"\xAA\x66" => "\xEC\xB1\x96",
		"\xAA\x67" => "\xEC\xB1\x9A",
		"\xAA\x68" => "\xEC\xB1\x9B",
		"\xAA\x69" => "\xEC\xB1\x9C",
		"\xAA\x6A" => "\xEC\xB1\x9D",
		"\xAA\x6B" => "\xEC\xB1\x9E",
		"\xAA\x6C" => "\xEC\xB1\x9F",
		"\xAA\x6D" => "\xEC\xB1\xA1",
		"\xAA\x6E" => "\xEC\xB1\xA2",
		"\xAA\x6F" => "\xEC\xB1\xA3",
		"\xAA\x70" => "\xEC\xB1\xA5",
		"\xAA\x71" => "\xEC\xB1\xA7",
		"\xAA\x72" => "\xEC\xB1\xA9",
		"\xAA\x73" => "\xEC\xB1\xAA",
		"\xAA\x74" => "\xEC\xB1\xAB",
		"\xAA\x75" => "\xEC\xB1\xAC",
		"\xAA\x76" => "\xEC\xB1\xAD",
		"\xAA\x77" => "\xEC\xB1\xAE",
		"\xAA\x78" => "\xEC\xB1\xAF",
		"\xAA\x79" => "\xEC\xB1\xB1",
		"\xAA\x7A" => "\xEC\xB1\xB2",
		"\xAA\x81" => "\xEC\xB1\xB3",
		"\xAA\x82" => "\xEC\xB1\xB4",
		"\xAA\x83" => "\xEC\xB1\xB6",
		"\xAA\x84" => "\xEC\xB1\xB7",
		"\xAA\x85" => "\xEC\xB1\xB8",
		"\xAA\x86" => "\xEC\xB1\xB9",
		"\xAA\x87" => "\xEC\xB1\xBA",
		"\xAA\x88" => "\xEC\xB1\xBB",
		"\xAA\x89" => "\xEC\xB1\xBC",
		"\xAA\x8A" => "\xEC\xB1\xBD",
		"\xAA\x8B" => "\xEC\xB1\xBE",
		"\xAA\x8C" => "\xEC\xB1\xBF",
		"\xAA\x8D" => "\xEC\xB2\x80",
		"\xAA\x8E" => "\xEC\xB2\x81",
		"\xAA\x8F" => "\xEC\xB2\x82",
		"\xAA\x90" => "\xEC\xB2\x83",
		"\xAA\x91" => "\xEC\xB2\x84",
		"\xAA\x92" => "\xEC\xB2\x85",
		"\xAA\x93" => "\xEC\xB2\x86",
		"\xAA\x94" => "\xEC\xB2\x87",
		"\xAA\x95" => "\xEC\xB2\x88",
		"\xAA\x96" => "\xEC\xB2\x89",
		"\xAA\x97" => "\xEC\xB2\x8A",
		"\xAA\x98" => "\xEC\xB2\x8B",
		"\xAA\x99" => "\xEC\xB2\x8C",
		"\xAA\x9A" => "\xEC\xB2\x8D",
		"\xAA\x9B" => "\xEC\xB2\x8E",
		"\xAA\x9C" => "\xEC\xB2\x8F",
		"\xAA\x9D" => "\xEC\xB2\x90",
		"\xAA\x9E" => "\xEC\xB2\x91",
		"\xAA\x9F" => "\xEC\xB2\x92",
		"\xAA\xA0" => "\xEC\xB2\x93",
		"\xAA\xA1" => "\xE3\x81\x81",
		"\xAA\xA2" => "\xE3\x81\x82",
		"\xAA\xA3" => "\xE3\x81\x83",
		"\xAA\xA4" => "\xE3\x81\x84",
		"\xAA\xA5" => "\xE3\x81\x85",
		"\xAA\xA6" => "\xE3\x81\x86",
		"\xAA\xA7" => "\xE3\x81\x87",
		"\xAA\xA8" => "\xE3\x81\x88",
		"\xAA\xA9" => "\xE3\x81\x89",
		"\xAA\xAA" => "\xE3\x81\x8A",
		"\xAA\xAB" => "\xE3\x81\x8B",
		"\xAA\xAC" => "\xE3\x81\x8C",
		"\xAA\xAD" => "\xE3\x81\x8D",
		"\xAA\xAE" => "\xE3\x81\x8E",
		"\xAA\xAF" => "\xE3\x81\x8F",
		"\xAA\xB0" => "\xE3\x81\x90",
		"\xAA\xB1" => "\xE3\x81\x91",
		"\xAA\xB2" => "\xE3\x81\x92",
		"\xAA\xB3" => "\xE3\x81\x93",
		"\xAA\xB4" => "\xE3\x81\x94",
		"\xAA\xB5" => "\xE3\x81\x95",
		"\xAA\xB6" => "\xE3\x81\x96",
		"\xAA\xB7" => "\xE3\x81\x97",
		"\xAA\xB8" => "\xE3\x81\x98",
		"\xAA\xB9" => "\xE3\x81\x99",
		"\xAA\xBA" => "\xE3\x81\x9A",
		"\xAA\xBB" => "\xE3\x81\x9B",
		"\xAA\xBC" => "\xE3\x81\x9C",
		"\xAA\xBD" => "\xE3\x81\x9D",
		"\xAA\xBE" => "\xE3\x81\x9E",
		"\xAA\xBF" => "\xE3\x81\x9F",
		"\xAA\xC0" => "\xE3\x81\xA0",
		"\xAA\xC1" => "\xE3\x81\xA1",
		"\xAA\xC2" => "\xE3\x81\xA2",
		"\xAA\xC3" => "\xE3\x81\xA3",
		"\xAA\xC4" => "\xE3\x81\xA4",
		"\xAA\xC5" => "\xE3\x81\xA5",
		"\xAA\xC6" => "\xE3\x81\xA6",
		"\xAA\xC7" => "\xE3\x81\xA7",
		"\xAA\xC8" => "\xE3\x81\xA8",
		"\xAA\xC9" => "\xE3\x81\xA9",
		"\xAA\xCA" => "\xE3\x81\xAA",
		"\xAA\xCB" => "\xE3\x81\xAB",
		"\xAA\xCC" => "\xE3\x81\xAC",
		"\xAA\xCD" => "\xE3\x81\xAD",
		"\xAA\xCE" => "\xE3\x81\xAE",
		"\xAA\xCF" => "\xE3\x81\xAF",
		"\xAA\xD0" => "\xE3\x81\xB0",
		"\xAA\xD1" => "\xE3\x81\xB1",
		"\xAA\xD2" => "\xE3\x81\xB2",
		"\xAA\xD3" => "\xE3\x81\xB3",
		"\xAA\xD4" => "\xE3\x81\xB4",
		"\xAA\xD5" => "\xE3\x81\xB5",
		"\xAA\xD6" => "\xE3\x81\xB6",
		"\xAA\xD7" => "\xE3\x81\xB7",
		"\xAA\xD8" => "\xE3\x81\xB8",
		"\xAA\xD9" => "\xE3\x81\xB9",
		"\xAA\xDA" => "\xE3\x81\xBA",
		"\xAA\xDB" => "\xE3\x81\xBB",
		"\xAA\xDC" => "\xE3\x81\xBC",
		"\xAA\xDD" => "\xE3\x81\xBD",
		"\xAA\xDE" => "\xE3\x81\xBE",
		"\xAA\xDF" => "\xE3\x81\xBF",
		"\xAA\xE0" => "\xE3\x82\x80",
		"\xAA\xE1" => "\xE3\x82\x81",
		"\xAA\xE2" => "\xE3\x82\x82",
		"\xAA\xE3" => "\xE3\x82\x83",
		"\xAA\xE4" => "\xE3\x82\x84",
		"\xAA\xE5" => "\xE3\x82\x85",
		"\xAA\xE6" => "\xE3\x82\x86",
		"\xAA\xE7" => "\xE3\x82\x87",
		"\xAA\xE8" => "\xE3\x82\x88",
		"\xAA\xE9" => "\xE3\x82\x89",
		"\xAA\xEA" => "\xE3\x82\x8A",
		"\xAA\xEB" => "\xE3\x82\x8B",
		"\xAA\xEC" => "\xE3\x82\x8C",
		"\xAA\xED" => "\xE3\x82\x8D",
		"\xAA\xEE" => "\xE3\x82\x8E",
		"\xAA\xEF" => "\xE3\x82\x8F",
		"\xAA\xF0" => "\xE3\x82\x90",
		"\xAA\xF1" => "\xE3\x82\x91",
		"\xAA\xF2" => "\xE3\x82\x92",
		"\xAA\xF3" => "\xE3\x82\x93",
		"\xAB\x41" => "\xEC\xB2\x94",
		"\xAB\x42" => "\xEC\xB2\x95",
		"\xAB\x43" => "\xEC\xB2\x96",
		"\xAB\x44" => "\xEC\xB2\x97",
		"\xAB\x45" => "\xEC\xB2\x9A",
		"\xAB\x46" => "\xEC\xB2\x9B",
		"\xAB\x47" => "\xEC\xB2\x9D",
		"\xAB\x48" => "\xEC\xB2\x9E",
		"\xAB\x49" => "\xEC\xB2\x9F",
		"\xAB\x4A" => "\xEC\xB2\xA1",
		"\xAB\x4B" => "\xEC\xB2\xA2",
		"\xAB\x4C" => "\xEC\xB2\xA3",
		"\xAB\x4D" => "\xEC\xB2\xA4",
		"\xAB\x4E" => "\xEC\xB2\xA5",
		"\xAB\x4F" => "\xEC\xB2\xA6",
		"\xAB\x50" => "\xEC\xB2\xA7",
		"\xAB\x51" => "\xEC\xB2\xAA",
		"\xAB\x52" => "\xEC\xB2\xAE",
		"\xAB\x53" => "\xEC\xB2\xAF",
		"\xAB\x54" => "\xEC\xB2\xB0",
		"\xAB\x55" => "\xEC\xB2\xB1",
		"\xAB\x56" => "\xEC\xB2\xB2",
		"\xAB\x57" => "\xEC\xB2\xB3",
		"\xAB\x58" => "\xEC\xB2\xB6",
		"\xAB\x59" => "\xEC\xB2\xB7",
		"\xAB\x5A" => "\xEC\xB2\xB9",
		"\xAB\x61" => "\xEC\xB2\xBA",
		"\xAB\x62" => "\xEC\xB2\xBB",
		"\xAB\x63" => "\xEC\xB2\xBD",
		"\xAB\x64" => "\xEC\xB2\xBE",
		"\xAB\x65" => "\xEC\xB2\xBF",
		"\xAB\x66" => "\xEC\xB3\x80",
		"\xAB\x67" => "\xEC\xB3\x81",
		"\xAB\x68" => "\xEC\xB3\x82",
		"\xAB\x69" => "\xEC\xB3\x83",
		"\xAB\x6A" => "\xEC\xB3\x86",
		"\xAB\x6B" => "\xEC\xB3\x88",
		"\xAB\x6C" => "\xEC\xB3\x8A",
		"\xAB\x6D" => "\xEC\xB3\x8B",
		"\xAB\x6E" => "\xEC\xB3\x8C",
		"\xAB\x6F" => "\xEC\xB3\x8D",
		"\xAB\x70" => "\xEC\xB3\x8E",
		"\xAB\x71" => "\xEC\xB3\x8F",
		"\xAB\x72" => "\xEC\xB3\x91",
		"\xAB\x73" => "\xEC\xB3\x92",
		"\xAB\x74" => "\xEC\xB3\x93",
		"\xAB\x75" => "\xEC\xB3\x95",
		"\xAB\x76" => "\xEC\xB3\x96",
		"\xAB\x77" => "\xEC\xB3\x97",
		"\xAB\x78" => "\xEC\xB3\x98",
		"\xAB\x79" => "\xEC\xB3\x99",
		"\xAB\x7A" => "\xEC\xB3\x9A",
		"\xAB\x81" => "\xEC\xB3\x9B",
		"\xAB\x82" => "\xEC\xB3\x9C",
		"\xAB\x83" => "\xEC\xB3\x9D",
		"\xAB\x84" => "\xEC\xB3\x9E",
		"\xAB\x85" => "\xEC\xB3\x9F",
		"\xAB\x86" => "\xEC\xB3\xA0",
		"\xAB\x87" => "\xEC\xB3\xA1",
		"\xAB\x88" => "\xEC\xB3\xA2",
		"\xAB\x89" => "\xEC\xB3\xA3",
		"\xAB\x8A" => "\xEC\xB3\xA5",
		"\xAB\x8B" => "\xEC\xB3\xA6",
		"\xAB\x8C" => "\xEC\xB3\xA7",
		"\xAB\x8D" => "\xEC\xB3\xA8",
		"\xAB\x8E" => "\xEC\xB3\xA9",
		"\xAB\x8F" => "\xEC\xB3\xAA",
		"\xAB\x90" => "\xEC\xB3\xAB",
		"\xAB\x91" => "\xEC\xB3\xAD",
		"\xAB\x92" => "\xEC\xB3\xAE",
		"\xAB\x93" => "\xEC\xB3\xAF",
		"\xAB\x94" => "\xEC\xB3\xB1",
		"\xAB\x95" => "\xEC\xB3\xB2",
		"\xAB\x96" => "\xEC\xB3\xB3",
		"\xAB\x97" => "\xEC\xB3\xB4",
		"\xAB\x98" => "\xEC\xB3\xB5",
		"\xAB\x99" => "\xEC\xB3\xB6",
		"\xAB\x9A" => "\xEC\xB3\xB7",
		"\xAB\x9B" => "\xEC\xB3\xB8",
		"\xAB\x9C" => "\xEC\xB3\xB9",
		"\xAB\x9D" => "\xEC\xB3\xBA",
		"\xAB\x9E" => "\xEC\xB3\xBB",
		"\xAB\x9F" => "\xEC\xB3\xBC",
		"\xAB\xA0" => "\xEC\xB3\xBD",
		"\xAB\xA1" => "\xE3\x82\xA1",
		"\xAB\xA2" => "\xE3\x82\xA2",
		"\xAB\xA3" => "\xE3\x82\xA3",
		"\xAB\xA4" => "\xE3\x82\xA4",
		"\xAB\xA5" => "\xE3\x82\xA5",
		"\xAB\xA6" => "\xE3\x82\xA6",
		"\xAB\xA7" => "\xE3\x82\xA7",
		"\xAB\xA8" => "\xE3\x82\xA8",
		"\xAB\xA9" => "\xE3\x82\xA9",
		"\xAB\xAA" => "\xE3\x82\xAA",
		"\xAB\xAB" => "\xE3\x82\xAB",
		"\xAB\xAC" => "\xE3\x82\xAC",
		"\xAB\xAD" => "\xE3\x82\xAD",
		"\xAB\xAE" => "\xE3\x82\xAE",
		"\xAB\xAF" => "\xE3\x82\xAF",
		"\xAB\xB0" => "\xE3\x82\xB0",
		"\xAB\xB1" => "\xE3\x82\xB1",
		"\xAB\xB2" => "\xE3\x82\xB2",
		"\xAB\xB3" => "\xE3\x82\xB3",
		"\xAB\xB4" => "\xE3\x82\xB4",
		"\xAB\xB5" => "\xE3\x82\xB5",
		"\xAB\xB6" => "\xE3\x82\xB6",
		"\xAB\xB7" => "\xE3\x82\xB7",
		"\xAB\xB8" => "\xE3\x82\xB8",
		"\xAB\xB9" => "\xE3\x82\xB9",
		"\xAB\xBA" => "\xE3\x82\xBA",
		"\xAB\xBB" => "\xE3\x82\xBB",
		"\xAB\xBC" => "\xE3\x82\xBC",
		"\xAB\xBD" => "\xE3\x82\xBD",
		"\xAB\xBE" => "\xE3\x82\xBE",
		"\xAB\xBF" => "\xE3\x82\xBF",
		"\xAB\xC0" => "\xE3\x83\x80",
		"\xAB\xC1" => "\xE3\x83\x81",
		"\xAB\xC2" => "\xE3\x83\x82",
		"\xAB\xC3" => "\xE3\x83\x83",
		"\xAB\xC4" => "\xE3\x83\x84",
		"\xAB\xC5" => "\xE3\x83\x85",
		"\xAB\xC6" => "\xE3\x83\x86",
		"\xAB\xC7" => "\xE3\x83\x87",
		"\xAB\xC8" => "\xE3\x83\x88",
		"\xAB\xC9" => "\xE3\x83\x89",
		"\xAB\xCA" => "\xE3\x83\x8A",
		"\xAB\xCB" => "\xE3\x83\x8B",
		"\xAB\xCC" => "\xE3\x83\x8C",
		"\xAB\xCD" => "\xE3\x83\x8D",
		"\xAB\xCE" => "\xE3\x83\x8E",
		"\xAB\xCF" => "\xE3\x83\x8F",
		"\xAB\xD0" => "\xE3\x83\x90",
		"\xAB\xD1" => "\xE3\x83\x91",
		"\xAB\xD2" => "\xE3\x83\x92",
		"\xAB\xD3" => "\xE3\x83\x93",
		"\xAB\xD4" => "\xE3\x83\x94",
		"\xAB\xD5" => "\xE3\x83\x95",
		"\xAB\xD6" => "\xE3\x83\x96",
		"\xAB\xD7" => "\xE3\x83\x97",
		"\xAB\xD8" => "\xE3\x83\x98",
		"\xAB\xD9" => "\xE3\x83\x99",
		"\xAB\xDA" => "\xE3\x83\x9A",
		"\xAB\xDB" => "\xE3\x83\x9B",
		"\xAB\xDC" => "\xE3\x83\x9C",
		"\xAB\xDD" => "\xE3\x83\x9D",
		"\xAB\xDE" => "\xE3\x83\x9E",
		"\xAB\xDF" => "\xE3\x83\x9F",
		"\xAB\xE0" => "\xE3\x83\xA0",
		"\xAB\xE1" => "\xE3\x83\xA1",
		"\xAB\xE2" => "\xE3\x83\xA2",
		"\xAB\xE3" => "\xE3\x83\xA3",
		"\xAB\xE4" => "\xE3\x83\xA4",
		"\xAB\xE5" => "\xE3\x83\xA5",
		"\xAB\xE6" => "\xE3\x83\xA6",
		"\xAB\xE7" => "\xE3\x83\xA7",
		"\xAB\xE8" => "\xE3\x83\xA8",
		"\xAB\xE9" => "\xE3\x83\xA9",
		"\xAB\xEA" => "\xE3\x83\xAA",
		"\xAB\xEB" => "\xE3\x83\xAB",
		"\xAB\xEC" => "\xE3\x83\xAC",
		"\xAB\xED" => "\xE3\x83\xAD",
		"\xAB\xEE" => "\xE3\x83\xAE",
		"\xAB\xEF" => "\xE3\x83\xAF",
		"\xAB\xF0" => "\xE3\x83\xB0",
		"\xAB\xF1" => "\xE3\x83\xB1",
		"\xAB\xF2" => "\xE3\x83\xB2",
		"\xAB\xF3" => "\xE3\x83\xB3",
		"\xAB\xF4" => "\xE3\x83\xB4",
		"\xAB\xF5" => "\xE3\x83\xB5",
		"\xAB\xF6" => "\xE3\x83\xB6",
		"\xAC\x41" => "\xEC\xB3\xBE",
		"\xAC\x42" => "\xEC\xB3\xBF",
		"\xAC\x43" => "\xEC\xB4\x80",
		"\xAC\x44" => "\xEC\xB4\x82",
		"\xAC\x45" => "\xEC\xB4\x83",
		"\xAC\x46" => "\xEC\xB4\x84",
		"\xAC\x47" => "\xEC\xB4\x85",
		"\xAC\x48" => "\xEC\xB4\x86",
		"\xAC\x49" => "\xEC\xB4\x87",
		"\xAC\x4A" => "\xEC\xB4\x8A",
		"\xAC\x4B" => "\xEC\xB4\x8B",
		"\xAC\x4C" => "\xEC\xB4\x8D",
		"\xAC\x4D" => "\xEC\xB4\x8E",
		"\xAC\x4E" => "\xEC\xB4\x8F",
		"\xAC\x4F" => "\xEC\xB4\x91",
		"\xAC\x50" => "\xEC\xB4\x92",
		"\xAC\x51" => "\xEC\xB4\x93",
		"\xAC\x52" => "\xEC\xB4\x94",
		"\xAC\x53" => "\xEC\xB4\x95",
		"\xAC\x54" => "\xEC\xB4\x96",
		"\xAC\x55" => "\xEC\xB4\x97",
		"\xAC\x56" => "\xEC\xB4\x9A",
		"\xAC\x57" => "\xEC\xB4\x9C",
		"\xAC\x58" => "\xEC\xB4\x9E",
		"\xAC\x59" => "\xEC\xB4\x9F",
		"\xAC\x5A" => "\xEC\xB4\xA0",
		"\xAC\x61" => "\xEC\xB4\xA1",
		"\xAC\x62" => "\xEC\xB4\xA2",
		"\xAC\x63" => "\xEC\xB4\xA3",
		"\xAC\x64" => "\xEC\xB4\xA5",
		"\xAC\x65" => "\xEC\xB4\xA6",
		"\xAC\x66" => "\xEC\xB4\xA7",
		"\xAC\x67" => "\xEC\xB4\xA9",
		"\xAC\x68" => "\xEC\xB4\xAA",
		"\xAC\x69" => "\xEC\xB4\xAB",
		"\xAC\x6A" => "\xEC\xB4\xAD",
		"\xAC\x6B" => "\xEC\xB4\xAE",
		"\xAC\x6C" => "\xEC\xB4\xAF",
		"\xAC\x6D" => "\xEC\xB4\xB0",
		"\xAC\x6E" => "\xEC\xB4\xB1",
		"\xAC\x6F" => "\xEC\xB4\xB2",
		"\xAC\x70" => "\xEC\xB4\xB3",
		"\xAC\x71" => "\xEC\xB4\xB4",
		"\xAC\x72" => "\xEC\xB4\xB5",
		"\xAC\x73" => "\xEC\xB4\xB6",
		"\xAC\x74" => "\xEC\xB4\xB7",
		"\xAC\x75" => "\xEC\xB4\xB8",
		"\xAC\x76" => "\xEC\xB4\xBA",
		"\xAC\x77" => "\xEC\xB4\xBB",
		"\xAC\x78" => "\xEC\xB4\xBC",
		"\xAC\x79" => "\xEC\xB4\xBD",
		"\xAC\x7A" => "\xEC\xB4\xBE",
		"\xAC\x81" => "\xEC\xB4\xBF",
		"\xAC\x82" => "\xEC\xB5\x80",
		"\xAC\x83" => "\xEC\xB5\x81",
		"\xAC\x84" => "\xEC\xB5\x82",
		"\xAC\x85" => "\xEC\xB5\x83",
		"\xAC\x86" => "\xEC\xB5\x84",
		"\xAC\x87" => "\xEC\xB5\x85",
		"\xAC\x88" => "\xEC\xB5\x86",
		"\xAC\x89" => "\xEC\xB5\x87",
		"\xAC\x8A" => "\xEC\xB5\x88",
		"\xAC\x8B" => "\xEC\xB5\x89",
		"\xAC\x8C" => "\xEC\xB5\x8A",
		"\xAC\x8D" => "\xEC\xB5\x8B",
		"\xAC\x8E" => "\xEC\xB5\x8C",
		"\xAC\x8F" => "\xEC\xB5\x8D",
		"\xAC\x90" => "\xEC\xB5\x8E",
		"\xAC\x91" => "\xEC\xB5\x8F",
		"\xAC\x92" => "\xEC\xB5\x90",
		"\xAC\x93" => "\xEC\xB5\x91",
		"\xAC\x94" => "\xEC\xB5\x92",
		"\xAC\x95" => "\xEC\xB5\x93",
		"\xAC\x96" => "\xEC\xB5\x94",
		"\xAC\x97" => "\xEC\xB5\x95",
		"\xAC\x98" => "\xEC\xB5\x96",
		"\xAC\x99" => "\xEC\xB5\x97",
		"\xAC\x9A" => "\xEC\xB5\x98",
		"\xAC\x9B" => "\xEC\xB5\x99",
		"\xAC\x9C" => "\xEC\xB5\x9A",
		"\xAC\x9D" => "\xEC\xB5\x9B",
		"\xAC\x9E" => "\xEC\xB5\x9D",
		"\xAC\x9F" => "\xEC\xB5\x9E",
		"\xAC\xA0" => "\xEC\xB5\x9F",
		"\xAC\xA1" => "\xD0\x90",
		"\xAC\xA2" => "\xD0\x91",
		"\xAC\xA3" => "\xD0\x92",
		"\xAC\xA4" => "\xD0\x93",
		"\xAC\xA5" => "\xD0\x94",
		"\xAC\xA6" => "\xD0\x95",
		"\xAC\xA7" => "\xD0\x81",
		"\xAC\xA8" => "\xD0\x96",
		"\xAC\xA9" => "\xD0\x97",
		"\xAC\xAA" => "\xD0\x98",
		"\xAC\xAB" => "\xD0\x99",
		"\xAC\xAC" => "\xD0\x9A",
		"\xAC\xAD" => "\xD0\x9B",
		"\xAC\xAE" => "\xD0\x9C",
		"\xAC\xAF" => "\xD0\x9D",
		"\xAC\xB0" => "\xD0\x9E",
		"\xAC\xB1" => "\xD0\x9F",
		"\xAC\xB2" => "\xD0\xA0",
		"\xAC\xB3" => "\xD0\xA1",
		"\xAC\xB4" => "\xD0\xA2",
		"\xAC\xB5" => "\xD0\xA3",
		"\xAC\xB6" => "\xD0\xA4",
		"\xAC\xB7" => "\xD0\xA5",
		"\xAC\xB8" => "\xD0\xA6",
		"\xAC\xB9" => "\xD0\xA7",
		"\xAC\xBA" => "\xD0\xA8",
		"\xAC\xBB" => "\xD0\xA9",
		"\xAC\xBC" => "\xD0\xAA",
		"\xAC\xBD" => "\xD0\xAB",
		"\xAC\xBE" => "\xD0\xAC",
		"\xAC\xBF" => "\xD0\xAD",
		"\xAC\xC0" => "\xD0\xAE",
		"\xAC\xC1" => "\xD0\xAF",
		"\xAC\xD1" => "\xD0\xB0",
		"\xAC\xD2" => "\xD0\xB1",
		"\xAC\xD3" => "\xD0\xB2",
		"\xAC\xD4" => "\xD0\xB3",
		"\xAC\xD5" => "\xD0\xB4",
		"\xAC\xD6" => "\xD0\xB5",
		"\xAC\xD7" => "\xD1\x91",
		"\xAC\xD8" => "\xD0\xB6",
		"\xAC\xD9" => "\xD0\xB7",
		"\xAC\xDA" => "\xD0\xB8",
		"\xAC\xDB" => "\xD0\xB9",
		"\xAC\xDC" => "\xD0\xBA",
		"\xAC\xDD" => "\xD0\xBB",
		"\xAC\xDE" => "\xD0\xBC",
		"\xAC\xDF" => "\xD0\xBD",
		"\xAC\xE0" => "\xD0\xBE",
		"\xAC\xE1" => "\xD0\xBF",
		"\xAC\xE2" => "\xD1\x80",
		"\xAC\xE3" => "\xD1\x81",
		"\xAC\xE4" => "\xD1\x82",
		"\xAC\xE5" => "\xD1\x83",
		"\xAC\xE6" => "\xD1\x84",
		"\xAC\xE7" => "\xD1\x85",
		"\xAC\xE8" => "\xD1\x86",
		"\xAC\xE9" => "\xD1\x87",
		"\xAC\xEA" => "\xD1\x88",
		"\xAC\xEB" => "\xD1\x89",
		"\xAC\xEC" => "\xD1\x8A",
		"\xAC\xED" => "\xD1\x8B",
		"\xAC\xEE" => "\xD1\x8C",
		"\xAC\xEF" => "\xD1\x8D",
		"\xAC\xF0" => "\xD1\x8E",
		"\xAC\xF1" => "\xD1\x8F",
		"\xAD\x41" => "\xEC\xB5\xA1",
		"\xAD\x42" => "\xEC\xB5\xA2",
		"\xAD\x43" => "\xEC\xB5\xA3",
		"\xAD\x44" => "\xEC\xB5\xA5",
		"\xAD\x45" => "\xEC\xB5\xA6",
		"\xAD\x46" => "\xEC\xB5\xA7",
		"\xAD\x47" => "\xEC\xB5\xA8",
		"\xAD\x48" => "\xEC\xB5\xA9",
		"\xAD\x49" => "\xEC\xB5\xAA",
		"\xAD\x4A" => "\xEC\xB5\xAB",
		"\xAD\x4B" => "\xEC\xB5\xAE",
		"\xAD\x4C" => "\xEC\xB5\xB0",
		"\xAD\x4D" => "\xEC\xB5\xB2",
		"\xAD\x4E" => "\xEC\xB5\xB3",
		"\xAD\x4F" => "\xEC\xB5\xB4",
		"\xAD\x50" => "\xEC\xB5\xB5",
		"\xAD\x51" => "\xEC\xB5\xB6",
		"\xAD\x52" => "\xEC\xB5\xB7",
		"\xAD\x53" => "\xEC\xB5\xB9",
		"\xAD\x54" => "\xEC\xB5\xBA",
		"\xAD\x55" => "\xEC\xB5\xBB",
		"\xAD\x56" => "\xEC\xB5\xBC",
		"\xAD\x57" => "\xEC\xB5\xBD",
		"\xAD\x58" => "\xEC\xB5\xBE",
		"\xAD\x59" => "\xEC\xB5\xBF",
		"\xAD\x5A" => "\xEC\xB6\x80",
		"\xAD\x61" => "\xEC\xB6\x81",
		"\xAD\x62" => "\xEC\xB6\x82",
		"\xAD\x63" => "\xEC\xB6\x83",
		"\xAD\x64" => "\xEC\xB6\x84",
		"\xAD\x65" => "\xEC\xB6\x85",
		"\xAD\x66" => "\xEC\xB6\x86",
		"\xAD\x67" => "\xEC\xB6\x87",
		"\xAD\x68" => "\xEC\xB6\x89",
		"\xAD\x69" => "\xEC\xB6\x8A",
		"\xAD\x6A" => "\xEC\xB6\x8B",
		"\xAD\x6B" => "\xEC\xB6\x8C",
		"\xAD\x6C" => "\xEC\xB6\x8D",
		"\xAD\x6D" => "\xEC\xB6\x8E",
		"\xAD\x6E" => "\xEC\xB6\x8F",
		"\xAD\x6F" => "\xEC\xB6\x90",
		"\xAD\x70" => "\xEC\xB6\x91",
		"\xAD\x71" => "\xEC\xB6\x92",
		"\xAD\x72" => "\xEC\xB6\x93",
		"\xAD\x73" => "\xEC\xB6\x96",
		"\xAD\x74" => "\xEC\xB6\x97",
		"\xAD\x75" => "\xEC\xB6\x99",
		"\xAD\x76" => "\xEC\xB6\x9A",
		"\xAD\x77" => "\xEC\xB6\x9B",
		"\xAD\x78" => "\xEC\xB6\x9D",
		"\xAD\x79" => "\xEC\xB6\x9E",
		"\xAD\x7A" => "\xEC\xB6\x9F",
		"\xAD\x81" => "\xEC\xB6\xA0",
		"\xAD\x82" => "\xEC\xB6\xA1",
		"\xAD\x83" => "\xEC\xB6\xA2",
		"\xAD\x84" => "\xEC\xB6\xA3",
		"\xAD\x85" => "\xEC\xB6\xA6",
		"\xAD\x86" => "\xEC\xB6\xA8",
		"\xAD\x87" => "\xEC\xB6\xAA",
		"\xAD\x88" => "\xEC\xB6\xAB",
		"\xAD\x89" => "\xEC\xB6\xAC",
		"\xAD\x8A" => "\xEC\xB6\xAD",
		"\xAD\x8B" => "\xEC\xB6\xAE",
		"\xAD\x8C" => "\xEC\xB6\xAF",
		"\xAD\x8D" => "\xEC\xB6\xB1",
		"\xAD\x8E" => "\xEC\xB6\xB2",
		"\xAD\x8F" => "\xEC\xB6\xB3",
		"\xAD\x90" => "\xEC\xB6\xB4",
		"\xAD\x91" => "\xEC\xB6\xB5",
		"\xAD\x92" => "\xEC\xB6\xB6",
		"\xAD\x93" => "\xEC\xB6\xB7",
		"\xAD\x94" => "\xEC\xB6\xB8",
		"\xAD\x95" => "\xEC\xB6\xB9",
		"\xAD\x96" => "\xEC\xB6\xBA",
		"\xAD\x97" => "\xEC\xB6\xBB",
		"\xAD\x98" => "\xEC\xB6\xBC",
		"\xAD\x99" => "\xEC\xB6\xBD",
		"\xAD\x9A" => "\xEC\xB6\xBE",
		"\xAD\x9B" => "\xEC\xB6\xBF",
		"\xAD\x9C" => "\xEC\xB7\x80",
		"\xAD\x9D" => "\xEC\xB7\x81",
		"\xAD\x9E" => "\xEC\xB7\x82",
		"\xAD\x9F" => "\xEC\xB7\x83",
		"\xAD\xA0" => "\xEC\xB7\x85",
		"\xAE\x41" => "\xEC\xB7\x86",
		"\xAE\x42" => "\xEC\xB7\x87",
		"\xAE\x43" => "\xEC\xB7\x88",
		"\xAE\x44" => "\xEC\xB7\x89",
		"\xAE\x45" => "\xEC\xB7\x8A",
		"\xAE\x46" => "\xEC\xB7\x8B",
		"\xAE\x47" => "\xEC\xB7\x8D",
		"\xAE\x48" => "\xEC\xB7\x8E",
		"\xAE\x49" => "\xEC\xB7\x8F",
		"\xAE\x4A" => "\xEC\xB7\x91",
		"\xAE\x4B" => "\xEC\xB7\x92",
		"\xAE\x4C" => "\xEC\xB7\x93",
		"\xAE\x4D" => "\xEC\xB7\x94",
		"\xAE\x4E" => "\xEC\xB7\x95",
		"\xAE\x4F" => "\xEC\xB7\x96",
		"\xAE\x50" => "\xEC\xB7\x97",
		"\xAE\x51" => "\xEC\xB7\x98",
		"\xAE\x52" => "\xEC\xB7\x99",
		"\xAE\x53" => "\xEC\xB7\x9A",
		"\xAE\x54" => "\xEC\xB7\x9B",
		"\xAE\x55" => "\xEC\xB7\x9C",
		"\xAE\x56" => "\xEC\xB7\x9D",
		"\xAE\x57" => "\xEC\xB7\x9E",
		"\xAE\x58" => "\xEC\xB7\x9F",
		"\xAE\x59" => "\xEC\xB7\xA0",
		"\xAE\x5A" => "\xEC\xB7\xA1",
		"\xAE\x61" => "\xEC\xB7\xA2",
		"\xAE\x62" => "\xEC\xB7\xA3",
		"\xAE\x63" => "\xEC\xB7\xA4",
		"\xAE\x64" => "\xEC\xB7\xA5",
		"\xAE\x65" => "\xEC\xB7\xA6",
		"\xAE\x66" => "\xEC\xB7\xA7",
		"\xAE\x67" => "\xEC\xB7\xA9",
		"\xAE\x68" => "\xEC\xB7\xAA",
		"\xAE\x69" => "\xEC\xB7\xAB",
		"\xAE\x6A" => "\xEC\xB7\xAD",
		"\xAE\x6B" => "\xEC\xB7\xAE",
		"\xAE\x6C" => "\xEC\xB7\xAF",
		"\xAE\x6D" => "\xEC\xB7\xB1",
		"\xAE\x6E" => "\xEC\xB7\xB2",
		"\xAE\x6F" => "\xEC\xB7\xB3",
		"\xAE\x70" => "\xEC\xB7\xB4",
		"\xAE\x71" => "\xEC\xB7\xB5",
		"\xAE\x72" => "\xEC\xB7\xB6",
		"\xAE\x73" => "\xEC\xB7\xB7",
		"\xAE\x74" => "\xEC\xB7\xBA",
		"\xAE\x75" => "\xEC\xB7\xBC",
		"\xAE\x76" => "\xEC\xB7\xBE",
		"\xAE\x77" => "\xEC\xB7\xBF",
		"\xAE\x78" => "\xEC\xB8\x80",
		"\xAE\x79" => "\xEC\xB8\x81",
		"\xAE\x7A" => "\xEC\xB8\x82",
		"\xAE\x81" => "\xEC\xB8\x83",
		"\xAE\x82" => "\xEC\xB8\x85",
		"\xAE\x83" => "\xEC\xB8\x86",
		"\xAE\x84" => "\xEC\xB8\x87",
		"\xAE\x85" => "\xEC\xB8\x89",
		"\xAE\x86" => "\xEC\xB8\x8A",
		"\xAE\x87" => "\xEC\xB8\x8B",
		"\xAE\x88" => "\xEC\xB8\x8D",
		"\xAE\x89" => "\xEC\xB8\x8E",
		"\xAE\x8A" => "\xEC\xB8\x8F",
		"\xAE\x8B" => "\xEC\xB8\x90",
		"\xAE\x8C" => "\xEC\xB8\x91",
		"\xAE\x8D" => "\xEC\xB8\x92",
		"\xAE\x8E" => "\xEC\xB8\x93",
		"\xAE\x8F" => "\xEC\xB8\x95",
		"\xAE\x90" => "\xEC\xB8\x96",
		"\xAE\x91" => "\xEC\xB8\x97",
		"\xAE\x92" => "\xEC\xB8\x98",
		"\xAE\x93" => "\xEC\xB8\x9A",
		"\xAE\x94" => "\xEC\xB8\x9B",
		"\xAE\x95" => "\xEC\xB8\x9C",
		"\xAE\x96" => "\xEC\xB8\x9D",
		"\xAE\x97" => "\xEC\xB8\x9E",
		"\xAE\x98" => "\xEC\xB8\x9F",
		"\xAE\x99" => "\xEC\xB8\xA2",
		"\xAE\x9A" => "\xEC\xB8\xA3",
		"\xAE\x9B" => "\xEC\xB8\xA5",
		"\xAE\x9C" => "\xEC\xB8\xA6",
		"\xAE\x9D" => "\xEC\xB8\xA7",
		"\xAE\x9E" => "\xEC\xB8\xA9",
		"\xAE\x9F" => "\xEC\xB8\xAA",
		"\xAE\xA0" => "\xEC\xB8\xAB",
		"\xAF\x41" => "\xEC\xB8\xAC",
		"\xAF\x42" => "\xEC\xB8\xAD",
		"\xAF\x43" => "\xEC\xB8\xAE",
		"\xAF\x44" => "\xEC\xB8\xAF",
		"\xAF\x45" => "\xEC\xB8\xB2",
		"\xAF\x46" => "\xEC\xB8\xB4",
		"\xAF\x47" => "\xEC\xB8\xB6",
		"\xAF\x48" => "\xEC\xB8\xB7",
		"\xAF\x49" => "\xEC\xB8\xB8",
		"\xAF\x4A" => "\xEC\xB8\xB9",
		"\xAF\x4B" => "\xEC\xB8\xBA",
		"\xAF\x4C" => "\xEC\xB8\xBB",
		"\xAF\x4D" => "\xEC\xB8\xBC",
		"\xAF\x4E" => "\xEC\xB8\xBD",
		"\xAF\x4F" => "\xEC\xB8\xBE",
		"\xAF\x50" => "\xEC\xB8\xBF",
		"\xAF\x51" => "\xEC\xB9\x80",
		"\xAF\x52" => "\xEC\xB9\x81",
		"\xAF\x53" => "\xEC\xB9\x82",
		"\xAF\x54" => "\xEC\xB9\x83",
		"\xAF\x55" => "\xEC\xB9\x84",
		"\xAF\x56" => "\xEC\xB9\x85",
		"\xAF\x57" => "\xEC\xB9\x86",
		"\xAF\x58" => "\xEC\xB9\x87",
		"\xAF\x59" => "\xEC\xB9\x88",
		"\xAF\x5A" => "\xEC\xB9\x89",
		"\xAF\x61" => "\xEC\xB9\x8A",
		"\xAF\x62" => "\xEC\xB9\x8B",
		"\xAF\x63" => "\xEC\xB9\x8C",
		"\xAF\x64" => "\xEC\xB9\x8D",
		"\xAF\x65" => "\xEC\xB9\x8E",
		"\xAF\x66" => "\xEC\xB9\x8F",
		"\xAF\x67" => "\xEC\xB9\x90",
		"\xAF\x68" => "\xEC\xB9\x91",
		"\xAF\x69" => "\xEC\xB9\x92",
		"\xAF\x6A" => "\xEC\xB9\x93",
		"\xAF\x6B" => "\xEC\xB9\x94",
		"\xAF\x6C" => "\xEC\xB9\x95",
		"\xAF\x6D" => "\xEC\xB9\x96",
		"\xAF\x6E" => "\xEC\xB9\x97",
		"\xAF\x6F" => "\xEC\xB9\x9A",
		"\xAF\x70" => "\xEC\xB9\x9B",
		"\xAF\x71" => "\xEC\xB9\x9D",
		"\xAF\x72" => "\xEC\xB9\x9E",
		"\xAF\x73" => "\xEC\xB9\xA2",
		"\xAF\x74" => "\xEC\xB9\xA3",
		"\xAF\x75" => "\xEC\xB9\xA4",
		"\xAF\x76" => "\xEC\xB9\xA5",
		"\xAF\x77" => "\xEC\xB9\xA6",
		"\xAF\x78" => "\xEC\xB9\xA7",
		"\xAF\x79" => "\xEC\xB9\xAA",
		"\xAF\x7A" => "\xEC\xB9\xAC",
		"\xAF\x81" => "\xEC\xB9\xAE",
		"\xAF\x82" => "\xEC\xB9\xAF",
		"\xAF\x83" => "\xEC\xB9\xB0",
		"\xAF\x84" => "\xEC\xB9\xB1",
		"\xAF\x85" => "\xEC\xB9\xB2",
		"\xAF\x86" => "\xEC\xB9\xB3",
		"\xAF\x87" => "\xEC\xB9\xB6",
		"\xAF\x88" => "\xEC\xB9\xB7",
		"\xAF\x89" => "\xEC\xB9\xB9",
		"\xAF\x8A" => "\xEC\xB9\xBA",
		"\xAF\x8B" => "\xEC\xB9\xBB",
		"\xAF\x8C" => "\xEC\xB9\xBD",
		"\xAF\x8D" => "\xEC\xB9\xBE",
		"\xAF\x8E" => "\xEC\xB9\xBF",
		"\xAF\x8F" => "\xEC\xBA\x80",
		"\xAF\x90" => "\xEC\xBA\x81",
		"\xAF\x91" => "\xEC\xBA\x82",
		"\xAF\x92" => "\xEC\xBA\x83",
		"\xAF\x93" => "\xEC\xBA\x86",
		"\xAF\x94" => "\xEC\xBA\x88",
		"\xAF\x95" => "\xEC\xBA\x8A",
		"\xAF\x96" => "\xEC\xBA\x8B",
		"\xAF\x97" => "\xEC\xBA\x8C",
		"\xAF\x98" => "\xEC\xBA\x8D",
		"\xAF\x99" => "\xEC\xBA\x8E",
		"\xAF\x9A" => "\xEC\xBA\x8F",
		"\xAF\x9B" => "\xEC\xBA\x92",
		"\xAF\x9C" => "\xEC\xBA\x93",
		"\xAF\x9D" => "\xEC\xBA\x95",
		"\xAF\x9E" => "\xEC\xBA\x96",
		"\xAF\x9F" => "\xEC\xBA\x97",
		"\xAF\xA0" => "\xEC\xBA\x99",
		"\xB0\x41" => "\xEC\xBA\x9A",
		"\xB0\x42" => "\xEC\xBA\x9B",
		"\xB0\x43" => "\xEC\xBA\x9C",
		"\xB0\x44" => "\xEC\xBA\x9D",
		"\xB0\x45" => "\xEC\xBA\x9E",
		"\xB0\x46" => "\xEC\xBA\x9F",
		"\xB0\x47" => "\xEC\xBA\xA2",
		"\xB0\x48" => "\xEC\xBA\xA6",
		"\xB0\x49" => "\xEC\xBA\xA7",
		"\xB0\x4A" => "\xEC\xBA\xA8",
		"\xB0\x4B" => "\xEC\xBA\xA9",
		"\xB0\x4C" => "\xEC\xBA\xAA",
		"\xB0\x4D" => "\xEC\xBA\xAB",
		"\xB0\x4E" => "\xEC\xBA\xAE",
		"\xB0\x4F" => "\xEC\xBA\xAF",
		"\xB0\x50" => "\xEC\xBA\xB0",
		"\xB0\x51" => "\xEC\xBA\xB1",
		"\xB0\x52" => "\xEC\xBA\xB2",
		"\xB0\x53" => "\xEC\xBA\xB3",
		"\xB0\x54" => "\xEC\xBA\xB4",
		"\xB0\x55" => "\xEC\xBA\xB5",
		"\xB0\x56" => "\xEC\xBA\xB6",
		"\xB0\x57" => "\xEC\xBA\xB7",
		"\xB0\x58" => "\xEC\xBA\xB8",
		"\xB0\x59" => "\xEC\xBA\xB9",
		"\xB0\x5A" => "\xEC\xBA\xBA",
		"\xB0\x61" => "\xEC\xBA\xBB",
		"\xB0\x62" => "\xEC\xBA\xBC",
		"\xB0\x63" => "\xEC\xBA\xBD",
		"\xB0\x64" => "\xEC\xBA\xBE",
		"\xB0\x65" => "\xEC\xBA\xBF",
		"\xB0\x66" => "\xEC\xBB\x80",
		"\xB0\x67" => "\xEC\xBB\x82",
		"\xB0\x68" => "\xEC\xBB\x83",
		"\xB0\x69" => "\xEC\xBB\x84",
		"\xB0\x6A" => "\xEC\xBB\x85",
		"\xB0\x6B" => "\xEC\xBB\x86",
		"\xB0\x6C" => "\xEC\xBB\x87",
		"\xB0\x6D" => "\xEC\xBB\x88",
		"\xB0\x6E" => "\xEC\xBB\x89",
		"\xB0\x6F" => "\xEC\xBB\x8A",
		"\xB0\x70" => "\xEC\xBB\x8B",
		"\xB0\x71" => "\xEC\xBB\x8C",
		"\xB0\x72" => "\xEC\xBB\x8D",
		"\xB0\x73" => "\xEC\xBB\x8E",
		"\xB0\x74" => "\xEC\xBB\x8F",
		"\xB0\x75" => "\xEC\xBB\x90",
		"\xB0\x76" => "\xEC\xBB\x91",
		"\xB0\x77" => "\xEC\xBB\x92",
		"\xB0\x78" => "\xEC\xBB\x93",
		"\xB0\x79" => "\xEC\xBB\x94",
		"\xB0\x7A" => "\xEC\xBB\x95",
		"\xB0\x81" => "\xEC\xBB\x96",
		"\xB0\x82" => "\xEC\xBB\x97",
		"\xB0\x83" => "\xEC\xBB\x98",
		"\xB0\x84" => "\xEC\xBB\x99",
		"\xB0\x85" => "\xEC\xBB\x9A",
		"\xB0\x86" => "\xEC\xBB\x9B",
		"\xB0\x87" => "\xEC\xBB\x9C",
		"\xB0\x88" => "\xEC\xBB\x9D",
		"\xB0\x89" => "\xEC\xBB\x9E",
		"\xB0\x8A" => "\xEC\xBB\x9F",
		"\xB0\x8B" => "\xEC\xBB\xA0",
		"\xB0\x8C" => "\xEC\xBB\xA1",
		"\xB0\x8D" => "\xEC\xBB\xA2",
		"\xB0\x8E" => "\xEC\xBB\xA3",
		"\xB0\x8F" => "\xEC\xBB\xA6",
		"\xB0\x90" => "\xEC\xBB\xA7",
		"\xB0\x91" => "\xEC\xBB\xA9",
		"\xB0\x92" => "\xEC\xBB\xAA",
		"\xB0\x93" => "\xEC\xBB\xAD",
		"\xB0\x94" => "\xEC\xBB\xAE",
		"\xB0\x95" => "\xEC\xBB\xAF",
		"\xB0\x96" => "\xEC\xBB\xB0",
		"\xB0\x97" => "\xEC\xBB\xB1",
		"\xB0\x98" => "\xEC\xBB\xB2",
		"\xB0\x99" => "\xEC\xBB\xB3",
		"\xB0\x9A" => "\xEC\xBB\xB6",
		"\xB0\x9B" => "\xEC\xBB\xBA",
		"\xB0\x9C" => "\xEC\xBB\xBB",
		"\xB0\x9D" => "\xEC\xBB\xBC",
		"\xB0\x9E" => "\xEC\xBB\xBD",
		"\xB0\x9F" => "\xEC\xBB\xBE",
		"\xB0\xA0" => "\xEC\xBB\xBF",
		"\xB0\xA1" => "\xEA\xB0\x80",
		"\xB0\xA2" => "\xEA\xB0\x81",
		"\xB0\xA3" => "\xEA\xB0\x84",
		"\xB0\xA4" => "\xEA\xB0\x87",
		"\xB0\xA5" => "\xEA\xB0\x88",
		"\xB0\xA6" => "\xEA\xB0\x89",
		"\xB0\xA7" => "\xEA\xB0\x8A",
		"\xB0\xA8" => "\xEA\xB0\x90",
		"\xB0\xA9" => "\xEA\xB0\x91",
		"\xB0\xAA" => "\xEA\xB0\x92",
		"\xB0\xAB" => "\xEA\xB0\x93",
		"\xB0\xAC" => "\xEA\xB0\x94",
		"\xB0\xAD" => "\xEA\xB0\x95",
		"\xB0\xAE" => "\xEA\xB0\x96",
		"\xB0\xAF" => "\xEA\xB0\x97",
		"\xB0\xB0" => "\xEA\xB0\x99",
		"\xB0\xB1" => "\xEA\xB0\x9A",
		"\xB0\xB2" => "\xEA\xB0\x9B",
		"\xB0\xB3" => "\xEA\xB0\x9C",
		"\xB0\xB4" => "\xEA\xB0\x9D",
		"\xB0\xB5" => "\xEA\xB0\xA0",
		"\xB0\xB6" => "\xEA\xB0\xA4",
		"\xB0\xB7" => "\xEA\xB0\xAC",
		"\xB0\xB8" => "\xEA\xB0\xAD",
		"\xB0\xB9" => "\xEA\xB0\xAF",
		"\xB0\xBA" => "\xEA\xB0\xB0",
		"\xB0\xBB" => "\xEA\xB0\xB1",
		"\xB0\xBC" => "\xEA\xB0\xB8",
		"\xB0\xBD" => "\xEA\xB0\xB9",
		"\xB0\xBE" => "\xEA\xB0\xBC",
		"\xB0\xBF" => "\xEA\xB1\x80",
		"\xB0\xC0" => "\xEA\xB1\x8B",
		"\xB0\xC1" => "\xEA\xB1\x8D",
		"\xB0\xC2" => "\xEA\xB1\x94",
		"\xB0\xC3" => "\xEA\xB1\x98",
		"\xB0\xC4" => "\xEA\xB1\x9C",
		"\xB0\xC5" => "\xEA\xB1\xB0",
		"\xB0\xC6" => "\xEA\xB1\xB1",
		"\xB0\xC7" => "\xEA\xB1\xB4",
		"\xB0\xC8" => "\xEA\xB1\xB7",
		"\xB0\xC9" => "\xEA\xB1\xB8",
		"\xB0\xCA" => "\xEA\xB1\xBA",
		"\xB0\xCB" => "\xEA\xB2\x80",
		"\xB0\xCC" => "\xEA\xB2\x81",
		"\xB0\xCD" => "\xEA\xB2\x83",
		"\xB0\xCE" => "\xEA\xB2\x84",
		"\xB0\xCF" => "\xEA\xB2\x85",
		"\xB0\xD0" => "\xEA\xB2\x86",
		"\xB0\xD1" => "\xEA\xB2\x89",
		"\xB0\xD2" => "\xEA\xB2\x8A",
		"\xB0\xD3" => "\xEA\xB2\x8B",
		"\xB0\xD4" => "\xEA\xB2\x8C",
		"\xB0\xD5" => "\xEA\xB2\x90",
		"\xB0\xD6" => "\xEA\xB2\x94",
		"\xB0\xD7" => "\xEA\xB2\x9C",
		"\xB0\xD8" => "\xEA\xB2\x9D",
		"\xB0\xD9" => "\xEA\xB2\x9F",
		"\xB0\xDA" => "\xEA\xB2\xA0",
		"\xB0\xDB" => "\xEA\xB2\xA1",
		"\xB0\xDC" => "\xEA\xB2\xA8",
		"\xB0\xDD" => "\xEA\xB2\xA9",
		"\xB0\xDE" => "\xEA\xB2\xAA",
		"\xB0\xDF" => "\xEA\xB2\xAC",
		"\xB0\xE0" => "\xEA\xB2\xAF",
		"\xB0\xE1" => "\xEA\xB2\xB0",
		"\xB0\xE2" => "\xEA\xB2\xB8",
		"\xB0\xE3" => "\xEA\xB2\xB9",
		"\xB0\xE4" => "\xEA\xB2\xBB",
		"\xB0\xE5" => "\xEA\xB2\xBC",
		"\xB0\xE6" => "\xEA\xB2\xBD",
		"\xB0\xE7" => "\xEA\xB3\x81",
		"\xB0\xE8" => "\xEA\xB3\x84",
		"\xB0\xE9" => "\xEA\xB3\x88",
		"\xB0\xEA" => "\xEA\xB3\x8C",
		"\xB0\xEB" => "\xEA\xB3\x95",
		"\xB0\xEC" => "\xEA\xB3\x97",
		"\xB0\xED" => "\xEA\xB3\xA0",
		"\xB0\xEE" => "\xEA\xB3\xA1",
		"\xB0\xEF" => "\xEA\xB3\xA4",
		"\xB0\xF0" => "\xEA\xB3\xA7",
		"\xB0\xF1" => "\xEA\xB3\xA8",
		"\xB0\xF2" => "\xEA\xB3\xAA",
		"\xB0\xF3" => "\xEA\xB3\xAC",
		"\xB0\xF4" => "\xEA\xB3\xAF",
		"\xB0\xF5" => "\xEA\xB3\xB0",
		"\xB0\xF6" => "\xEA\xB3\xB1",
		"\xB0\xF7" => "\xEA\xB3\xB3",
		"\xB0\xF8" => "\xEA\xB3\xB5",
		"\xB0\xF9" => "\xEA\xB3\xB6",
		"\xB0\xFA" => "\xEA\xB3\xBC",
		"\xB0\xFB" => "\xEA\xB3\xBD",
		"\xB0\xFC" => "\xEA\xB4\x80",
		"\xB0\xFD" => "\xEA\xB4\x84",
		"\xB0\xFE" => "\xEA\xB4\x86",
		"\xB1\x41" => "\xEC\xBC\x82",
		"\xB1\x42" => "\xEC\xBC\x83",
		"\xB1\x43" => "\xEC\xBC\x85",
		"\xB1\x44" => "\xEC\xBC\x86",
		"\xB1\x45" => "\xEC\xBC\x87",
		"\xB1\x46" => "\xEC\xBC\x89",
		"\xB1\x47" => "\xEC\xBC\x8A",
		"\xB1\x48" => "\xEC\xBC\x8B",
		"\xB1\x49" => "\xEC\xBC\x8C",
		"\xB1\x4A" => "\xEC\xBC\x8D",
		"\xB1\x4B" => "\xEC\xBC\x8E",
		"\xB1\x4C" => "\xEC\xBC\x8F",
		"\xB1\x4D" => "\xEC\xBC\x92",
		"\xB1\x4E" => "\xEC\xBC\x94",
		"\xB1\x4F" => "\xEC\xBC\x96",
		"\xB1\x50" => "\xEC\xBC\x97",
		"\xB1\x51" => "\xEC\xBC\x98",
		"\xB1\x52" => "\xEC\xBC\x99",
		"\xB1\x53" => "\xEC\xBC\x9A",
		"\xB1\x54" => "\xEC\xBC\x9B",
		"\xB1\x55" => "\xEC\xBC\x9D",
		"\xB1\x56" => "\xEC\xBC\x9E",
		"\xB1\x57" => "\xEC\xBC\x9F",
		"\xB1\x58" => "\xEC\xBC\xA1",
		"\xB1\x59" => "\xEC\xBC\xA2",
		"\xB1\x5A" => "\xEC\xBC\xA3",
		"\xB1\x61" => "\xEC\xBC\xA5",
		"\xB1\x62" => "\xEC\xBC\xA6",
		"\xB1\x63" => "\xEC\xBC\xA7",
		"\xB1\x64" => "\xEC\xBC\xA8",
		"\xB1\x65" => "\xEC\xBC\xA9",
		"\xB1\x66" => "\xEC\xBC\xAA",
		"\xB1\x67" => "\xEC\xBC\xAB",
		"\xB1\x68" => "\xEC\xBC\xAE",
		"\xB1\x69" => "\xEC\xBC\xB2",
		"\xB1\x6A" => "\xEC\xBC\xB3",
		"\xB1\x6B" => "\xEC\xBC\xB4",
		"\xB1\x6C" => "\xEC\xBC\xB5",
		"\xB1\x6D" => "\xEC\xBC\xB6",
		"\xB1\x6E" => "\xEC\xBC\xB7",
		"\xB1\x6F" => "\xEC\xBC\xB9",
		"\xB1\x70" => "\xEC\xBC\xBA",
		"\xB1\x71" => "\xEC\xBC\xBB",
		"\xB1\x72" => "\xEC\xBC\xBC",
		"\xB1\x73" => "\xEC\xBC\xBD",
		"\xB1\x74" => "\xEC\xBC\xBE",
		"\xB1\x75" => "\xEC\xBC\xBF",
		"\xB1\x76" => "\xEC\xBD\x80",
		"\xB1\x77" => "\xEC\xBD\x81",
		"\xB1\x78" => "\xEC\xBD\x82",
		"\xB1\x79" => "\xEC\xBD\x83",
		"\xB1\x7A" => "\xEC\xBD\x84",
		"\xB1\x81" => "\xEC\xBD\x85",
		"\xB1\x82" => "\xEC\xBD\x86",
		"\xB1\x83" => "\xEC\xBD\x87",
		"\xB1\x84" => "\xEC\xBD\x88",
		"\xB1\x85" => "\xEC\xBD\x89",
		"\xB1\x86" => "\xEC\xBD\x8A",
		"\xB1\x87" => "\xEC\xBD\x8B",
		"\xB1\x88" => "\xEC\xBD\x8C",
		"\xB1\x89" => "\xEC\xBD\x8D",
		"\xB1\x8A" => "\xEC\xBD\x8E",
		"\xB1\x8B" => "\xEC\xBD\x8F",
		"\xB1\x8C" => "\xEC\xBD\x90",
		"\xB1\x8D" => "\xEC\xBD\x91",
		"\xB1\x8E" => "\xEC\xBD\x92",
		"\xB1\x8F" => "\xEC\xBD\x93",
		"\xB1\x90" => "\xEC\xBD\x96",
		"\xB1\x91" => "\xEC\xBD\x97",
		"\xB1\x92" => "\xEC\xBD\x99",
		"\xB1\x93" => "\xEC\xBD\x9A",
		"\xB1\x94" => "\xEC\xBD\x9B",
		"\xB1\x95" => "\xEC\xBD\x9D",
		"\xB1\x96" => "\xEC\xBD\x9E",
		"\xB1\x97" => "\xEC\xBD\x9F",
		"\xB1\x98" => "\xEC\xBD\xA0",
		"\xB1\x99" => "\xEC\xBD\xA1",
		"\xB1\x9A" => "\xEC\xBD\xA2",
		"\xB1\x9B" => "\xEC\xBD\xA3",
		"\xB1\x9C" => "\xEC\xBD\xA6",
		"\xB1\x9D" => "\xEC\xBD\xA8",
		"\xB1\x9E" => "\xEC\xBD\xAA",
		"\xB1\x9F" => "\xEC\xBD\xAB",
		"\xB1\xA0" => "\xEC\xBD\xAC",
		"\xB1\xA1" => "\xEA\xB4\x8C",
		"\xB1\xA2" => "\xEA\xB4\x8D",
		"\xB1\xA3" => "\xEA\xB4\x8F",
		"\xB1\xA4" => "\xEA\xB4\x91",
		"\xB1\xA5" => "\xEA\xB4\x98",
		"\xB1\xA6" => "\xEA\xB4\x9C",
		"\xB1\xA7" => "\xEA\xB4\xA0",
		"\xB1\xA8" => "\xEA\xB4\xA9",
		"\xB1\xA9" => "\xEA\xB4\xAC",
		"\xB1\xAA" => "\xEA\xB4\xAD",
		"\xB1\xAB" => "\xEA\xB4\xB4",
		"\xB1\xAC" => "\xEA\xB4\xB5",
		"\xB1\xAD" => "\xEA\xB4\xB8",
		"\xB1\xAE" => "\xEA\xB4\xBC",
		"\xB1\xAF" => "\xEA\xB5\x84",
		"\xB1\xB0" => "\xEA\xB5\x85",
		"\xB1\xB1" => "\xEA\xB5\x87",
		"\xB1\xB2" => "\xEA\xB5\x89",
		"\xB1\xB3" => "\xEA\xB5\x90",
		"\xB1\xB4" => "\xEA\xB5\x94",
		"\xB1\xB5" => "\xEA\xB5\x98",
		"\xB1\xB6" => "\xEA\xB5\xA1",
		"\xB1\xB7" => "\xEA\xB5\xA3",
		"\xB1\xB8" => "\xEA\xB5\xAC",
		"\xB1\xB9" => "\xEA\xB5\xAD",
		"\xB1\xBA" => "\xEA\xB5\xB0",
		"\xB1\xBB" => "\xEA\xB5\xB3",
		"\xB1\xBC" => "\xEA\xB5\xB4",
		"\xB1\xBD" => "\xEA\xB5\xB5",
		"\xB1\xBE" => "\xEA\xB5\xB6",
		"\xB1\xBF" => "\xEA\xB5\xBB",
		"\xB1\xC0" => "\xEA\xB5\xBC",
		"\xB1\xC1" => "\xEA\xB5\xBD",
		"\xB1\xC2" => "\xEA\xB5\xBF",
		"\xB1\xC3" => "\xEA\xB6\x81",
		"\xB1\xC4" => "\xEA\xB6\x82",
		"\xB1\xC5" => "\xEA\xB6\x88",
		"\xB1\xC6" => "\xEA\xB6\x89",
		"\xB1\xC7" => "\xEA\xB6\x8C",
		"\xB1\xC8" => "\xEA\xB6\x90",
		"\xB1\xC9" => "\xEA\xB6\x9C",
		"\xB1\xCA" => "\xEA\xB6\x9D",
		"\xB1\xCB" => "\xEA\xB6\xA4",
		"\xB1\xCC" => "\xEA\xB6\xB7",
		"\xB1\xCD" => "\xEA\xB7\x80",
		"\xB1\xCE" => "\xEA\xB7\x81",
		"\xB1\xCF" => "\xEA\xB7\x84",
		"\xB1\xD0" => "\xEA\xB7\x88",
		"\xB1\xD1" => "\xEA\xB7\x90",
		"\xB1\xD2" => "\xEA\xB7\x91",
		"\xB1\xD3" => "\xEA\xB7\x93",
		"\xB1\xD4" => "\xEA\xB7\x9C",
		"\xB1\xD5" => "\xEA\xB7\xA0",
		"\xB1\xD6" => "\xEA\xB7\xA4",
		"\xB1\xD7" => "\xEA\xB7\xB8",
		"\xB1\xD8" => "\xEA\xB7\xB9",
		"\xB1\xD9" => "\xEA\xB7\xBC",
		"\xB1\xDA" => "\xEA\xB7\xBF",
		"\xB1\xDB" => "\xEA\xB8\x80",
		"\xB1\xDC" => "\xEA\xB8\x81",
		"\xB1\xDD" => "\xEA\xB8\x88",
		"\xB1\xDE" => "\xEA\xB8\x89",
		"\xB1\xDF" => "\xEA\xB8\x8B",
		"\xB1\xE0" => "\xEA\xB8\x8D",
		"\xB1\xE1" => "\xEA\xB8\x94",
		"\xB1\xE2" => "\xEA\xB8\xB0",
		"\xB1\xE3" => "\xEA\xB8\xB1",
		"\xB1\xE4" => "\xEA\xB8\xB4",
		"\xB1\xE5" => "\xEA\xB8\xB7",
		"\xB1\xE6" => "\xEA\xB8\xB8",
		"\xB1\xE7" => "\xEA\xB8\xBA",
		"\xB1\xE8" => "\xEA\xB9\x80",
		"\xB1\xE9" => "\xEA\xB9\x81",
		"\xB1\xEA" => "\xEA\xB9\x83",
		"\xB1\xEB" => "\xEA\xB9\x85",
		"\xB1\xEC" => "\xEA\xB9\x86",
		"\xB1\xED" => "\xEA\xB9\x8A",
		"\xB1\xEE" => "\xEA\xB9\x8C",
		"\xB1\xEF" => "\xEA\xB9\x8D",
		"\xB1\xF0" => "\xEA\xB9\x8E",
		"\xB1\xF1" => "\xEA\xB9\x90",
		"\xB1\xF2" => "\xEA\xB9\x94",
		"\xB1\xF3" => "\xEA\xB9\x96",
		"\xB1\xF4" => "\xEA\xB9\x9C",
		"\xB1\xF5" => "\xEA\xB9\x9D",
		"\xB1\xF6" => "\xEA\xB9\x9F",
		"\xB1\xF7" => "\xEA\xB9\xA0",
		"\xB1\xF8" => "\xEA\xB9\xA1",
		"\xB1\xF9" => "\xEA\xB9\xA5",
		"\xB1\xFA" => "\xEA\xB9\xA8",
		"\xB1\xFB" => "\xEA\xB9\xA9",
		"\xB1\xFC" => "\xEA\xB9\xAC",
		"\xB1\xFD" => "\xEA\xB9\xB0",
		"\xB1\xFE" => "\xEA\xB9\xB8",
		"\xB2\x41" => "\xEC\xBD\xAD",
		"\xB2\x42" => "\xEC\xBD\xAE",
		"\xB2\x43" => "\xEC\xBD\xAF",
		"\xB2\x44" => "\xEC\xBD\xB2",
		"\xB2\x45" => "\xEC\xBD\xB3",
		"\xB2\x46" => "\xEC\xBD\xB5",
		"\xB2\x47" => "\xEC\xBD\xB6",
		"\xB2\x48" => "\xEC\xBD\xB7",
		"\xB2\x49" => "\xEC\xBD\xB9",
		"\xB2\x4A" => "\xEC\xBD\xBA",
		"\xB2\x4B" => "\xEC\xBD\xBB",
		"\xB2\x4C" => "\xEC\xBD\xBC",
		"\xB2\x4D" => "\xEC\xBD\xBD",
		"\xB2\x4E" => "\xEC\xBD\xBE",
		"\xB2\x4F" => "\xEC\xBD\xBF",
		"\xB2\x50" => "\xEC\xBE\x81",
		"\xB2\x51" => "\xEC\xBE\x82",
		"\xB2\x52" => "\xEC\xBE\x83",
		"\xB2\x53" => "\xEC\xBE\x84",
		"\xB2\x54" => "\xEC\xBE\x86",
		"\xB2\x55" => "\xEC\xBE\x87",
		"\xB2\x56" => "\xEC\xBE\x88",
		"\xB2\x57" => "\xEC\xBE\x89",
		"\xB2\x58" => "\xEC\xBE\x8A",
		"\xB2\x59" => "\xEC\xBE\x8B",
		"\xB2\x5A" => "\xEC\xBE\x8D",
		"\xB2\x61" => "\xEC\xBE\x8E",
		"\xB2\x62" => "\xEC\xBE\x8F",
		"\xB2\x63" => "\xEC\xBE\x90",
		"\xB2\x64" => "\xEC\xBE\x91",
		"\xB2\x65" => "\xEC\xBE\x92",
		"\xB2\x66" => "\xEC\xBE\x93",
		"\xB2\x67" => "\xEC\xBE\x94",
		"\xB2\x68" => "\xEC\xBE\x95",
		"\xB2\x69" => "\xEC\xBE\x96",
		"\xB2\x6A" => "\xEC\xBE\x97",
		"\xB2\x6B" => "\xEC\xBE\x98",
		"\xB2\x6C" => "\xEC\xBE\x99",
		"\xB2\x6D" => "\xEC\xBE\x9A",
		"\xB2\x6E" => "\xEC\xBE\x9B",
		"\xB2\x6F" => "\xEC\xBE\x9C",
		"\xB2\x70" => "\xEC\xBE\x9D",
		"\xB2\x71" => "\xEC\xBE\x9E",
		"\xB2\x72" => "\xEC\xBE\x9F",
		"\xB2\x73" => "\xEC\xBE\xA0",
		"\xB2\x74" => "\xEC\xBE\xA2",
		"\xB2\x75" => "\xEC\xBE\xA3",
		"\xB2\x76" => "\xEC\xBE\xA4",
		"\xB2\x77" => "\xEC\xBE\xA5",
		"\xB2\x78" => "\xEC\xBE\xA6",
		"\xB2\x79" => "\xEC\xBE\xA7",
		"\xB2\x7A" => "\xEC\xBE\xA9",
		"\xB2\x81" => "\xEC\xBE\xAA",
		"\xB2\x82" => "\xEC\xBE\xAB",
		"\xB2\x83" => "\xEC\xBE\xAC",
		"\xB2\x84" => "\xEC\xBE\xAD",
		"\xB2\x85" => "\xEC\xBE\xAE",
		"\xB2\x86" => "\xEC\xBE\xAF",
		"\xB2\x87" => "\xEC\xBE\xB1",
		"\xB2\x88" => "\xEC\xBE\xB2",
		"\xB2\x89" => "\xEC\xBE\xB3",
		"\xB2\x8A" => "\xEC\xBE\xB4",
		"\xB2\x8B" => "\xEC\xBE\xB5",
		"\xB2\x8C" => "\xEC\xBE\xB6",
		"\xB2\x8D" => "\xEC\xBE\xB7",
		"\xB2\x8E" => "\xEC\xBE\xB8",
		"\xB2\x8F" => "\xEC\xBE\xB9",
		"\xB2\x90" => "\xEC\xBE\xBA",
		"\xB2\x91" => "\xEC\xBE\xBB",
		"\xB2\x92" => "\xEC\xBE\xBC",
		"\xB2\x93" => "\xEC\xBE\xBD",
		"\xB2\x94" => "\xEC\xBE\xBE",
		"\xB2\x95" => "\xEC\xBE\xBF",
		"\xB2\x96" => "\xEC\xBF\x80",
		"\xB2\x97" => "\xEC\xBF\x81",
		"\xB2\x98" => "\xEC\xBF\x82",
		"\xB2\x99" => "\xEC\xBF\x83",
		"\xB2\x9A" => "\xEC\xBF\x85",
		"\xB2\x9B" => "\xEC\xBF\x86",
		"\xB2\x9C" => "\xEC\xBF\x87",
		"\xB2\x9D" => "\xEC\xBF\x88",
		"\xB2\x9E" => "\xEC\xBF\x89",
		"\xB2\x9F" => "\xEC\xBF\x8A",
		"\xB2\xA0" => "\xEC\xBF\x8B",
		"\xB2\xA1" => "\xEA\xB9\xB9",
		"\xB2\xA2" => "\xEA\xB9\xBB",
		"\xB2\xA3" => "\xEA\xB9\xBC",
		"\xB2\xA4" => "\xEA\xB9\xBD",
		"\xB2\xA5" => "\xEA\xBA\x84",
		"\xB2\xA6" => "\xEA\xBA\x85",
		"\xB2\xA7" => "\xEA\xBA\x8C",
		"\xB2\xA8" => "\xEA\xBA\xBC",
		"\xB2\xA9" => "\xEA\xBA\xBD",
		"\xB2\xAA" => "\xEA\xBA\xBE",
		"\xB2\xAB" => "\xEA\xBB\x80",
		"\xB2\xAC" => "\xEA\xBB\x84",
		"\xB2\xAD" => "\xEA\xBB\x8C",
		"\xB2\xAE" => "\xEA\xBB\x8D",
		"\xB2\xAF" => "\xEA\xBB\x8F",
		"\xB2\xB0" => "\xEA\xBB\x90",
		"\xB2\xB1" => "\xEA\xBB\x91",
		"\xB2\xB2" => "\xEA\xBB\x98",
		"\xB2\xB3" => "\xEA\xBB\x99",
		"\xB2\xB4" => "\xEA\xBB\x9C",
		"\xB2\xB5" => "\xEA\xBB\xA8",
		"\xB2\xB6" => "\xEA\xBB\xAB",
		"\xB2\xB7" => "\xEA\xBB\xAD",
		"\xB2\xB8" => "\xEA\xBB\xB4",
		"\xB2\xB9" => "\xEA\xBB\xB8",
		"\xB2\xBA" => "\xEA\xBB\xBC",
		"\xB2\xBB" => "\xEA\xBC\x87",
		"\xB2\xBC" => "\xEA\xBC\x88",
		"\xB2\xBD" => "\xEA\xBC\x8D",
		"\xB2\xBE" => "\xEA\xBC\x90",
		"\xB2\xBF" => "\xEA\xBC\xAC",
		"\xB2\xC0" => "\xEA\xBC\xAD",
		"\xB2\xC1" => "\xEA\xBC\xB0",
		"\xB2\xC2" => "\xEA\xBC\xB2",
		"\xB2\xC3" => "\xEA\xBC\xB4",
		"\xB2\xC4" => "\xEA\xBC\xBC",
		"\xB2\xC5" => "\xEA\xBC\xBD",
		"\xB2\xC6" => "\xEA\xBC\xBF",
		"\xB2\xC7" => "\xEA\xBD\x81",
		"\xB2\xC8" => "\xEA\xBD\x82",
		"\xB2\xC9" => "\xEA\xBD\x83",
		"\xB2\xCA" => "\xEA\xBD\x88",
		"\xB2\xCB" => "\xEA\xBD\x89",
		"\xB2\xCC" => "\xEA\xBD\x90",
		"\xB2\xCD" => "\xEA\xBD\x9C",
		"\xB2\xCE" => "\xEA\xBD\x9D",
		"\xB2\xCF" => "\xEA\xBD\xA4",
		"\xB2\xD0" => "\xEA\xBD\xA5",
		"\xB2\xD1" => "\xEA\xBD\xB9",
		"\xB2\xD2" => "\xEA\xBE\x80",
		"\xB2\xD3" => "\xEA\xBE\x84",
		"\xB2\xD4" => "\xEA\xBE\x88",
		"\xB2\xD5" => "\xEA\xBE\x90",
		"\xB2\xD6" => "\xEA\xBE\x91",
		"\xB2\xD7" => "\xEA\xBE\x95",
		"\xB2\xD8" => "\xEA\xBE\x9C",
		"\xB2\xD9" => "\xEA\xBE\xB8",
		"\xB2\xDA" => "\xEA\xBE\xB9",
		"\xB2\xDB" => "\xEA\xBE\xBC",
		"\xB2\xDC" => "\xEA\xBF\x80",
		"\xB2\xDD" => "\xEA\xBF\x87",
		"\xB2\xDE" => "\xEA\xBF\x88",
		"\xB2\xDF" => "\xEA\xBF\x89",
		"\xB2\xE0" => "\xEA\xBF\x8B",
		"\xB2\xE1" => "\xEA\xBF\x8D",
		"\xB2\xE2" => "\xEA\xBF\x8E",
		"\xB2\xE3" => "\xEA\xBF\x94",
		"\xB2\xE4" => "\xEA\xBF\x9C",
		"\xB2\xE5" => "\xEA\xBF\xA8",
		"\xB2\xE6" => "\xEA\xBF\xA9",
		"\xB2\xE7" => "\xEA\xBF\xB0",
		"\xB2\xE8" => "\xEA\xBF\xB1",
		"\xB2\xE9" => "\xEA\xBF\xB4",
		"\xB2\xEA" => "\xEA\xBF\xB8",
		"\xB2\xEB" => "\xEB\x80\x80",
		"\xB2\xEC" => "\xEB\x80\x81",
		"\xB2\xED" => "\xEB\x80\x84",
		"\xB2\xEE" => "\xEB\x80\x8C",
		"\xB2\xEF" => "\xEB\x80\x90",
		"\xB2\xF0" => "\xEB\x80\x94",
		"\xB2\xF1" => "\xEB\x80\x9C",
		"\xB2\xF2" => "\xEB\x80\x9D",
		"\xB2\xF3" => "\xEB\x80\xA8",
		"\xB2\xF4" => "\xEB\x81\x84",
		"\xB2\xF5" => "\xEB\x81\x85",
		"\xB2\xF6" => "\xEB\x81\x88",
		"\xB2\xF7" => "\xEB\x81\x8A",
		"\xB2\xF8" => "\xEB\x81\x8C",
		"\xB2\xF9" => "\xEB\x81\x8E",
		"\xB2\xFA" => "\xEB\x81\x93",
		"\xB2\xFB" => "\xEB\x81\x94",
		"\xB2\xFC" => "\xEB\x81\x95",
		"\xB2\xFD" => "\xEB\x81\x97",
		"\xB2\xFE" => "\xEB\x81\x99",
		"\xB3\x41" => "\xEC\xBF\x8C",
		"\xB3\x42" => "\xEC\xBF\x8D",
		"\xB3\x43" => "\xEC\xBF\x8E",
		"\xB3\x44" => "\xEC\xBF\x8F",
		"\xB3\x45" => "\xEC\xBF\x90",
		"\xB3\x46" => "\xEC\xBF\x91",
		"\xB3\x47" => "\xEC\xBF\x92",
		"\xB3\x48" => "\xEC\xBF\x93",
		"\xB3\x49" => "\xEC\xBF\x94",
		"\xB3\x4A" => "\xEC\xBF\x95",
		"\xB3\x4B" => "\xEC\xBF\x96",
		"\xB3\x4C" => "\xEC\xBF\x97",
		"\xB3\x4D" => "\xEC\xBF\x98",
		"\xB3\x4E" => "\xEC\xBF\x99",
		"\xB3\x4F" => "\xEC\xBF\x9A",
		"\xB3\x50" => "\xEC\xBF\x9B",
		"\xB3\x51" => "\xEC\xBF\x9C",
		"\xB3\x52" => "\xEC\xBF\x9D",
		"\xB3\x53" => "\xEC\xBF\x9E",
		"\xB3\x54" => "\xEC\xBF\x9F",
		"\xB3\x55" => "\xEC\xBF\xA2",
		"\xB3\x56" => "\xEC\xBF\xA3",
		"\xB3\x57" => "\xEC\xBF\xA5",
		"\xB3\x58" => "\xEC\xBF\xA6",
		"\xB3\x59" => "\xEC\xBF\xA7",
		"\xB3\x5A" => "\xEC\xBF\xA9",
		"\xB3\x61" => "\xEC\xBF\xAA",
		"\xB3\x62" => "\xEC\xBF\xAB",
		"\xB3\x63" => "\xEC\xBF\xAC",
		"\xB3\x64" => "\xEC\xBF\xAD",
		"\xB3\x65" => "\xEC\xBF\xAE",
		"\xB3\x66" => "\xEC\xBF\xAF",
		"\xB3\x67" => "\xEC\xBF\xB2",
		"\xB3\x68" => "\xEC\xBF\xB4",
		"\xB3\x69" => "\xEC\xBF\xB6",
		"\xB3\x6A" => "\xEC\xBF\xB7",
		"\xB3\x6B" => "\xEC\xBF\xB8",
		"\xB3\x6C" => "\xEC\xBF\xB9",
		"\xB3\x6D" => "\xEC\xBF\xBA",
		"\xB3\x6E" => "\xEC\xBF\xBB",
		"\xB3\x6F" => "\xEC\xBF\xBD",
		"\xB3\x70" => "\xEC\xBF\xBE",
		"\xB3\x71" => "\xEC\xBF\xBF",
		"\xB3\x72" => "\xED\x80\x81",
		"\xB3\x73" => "\xED\x80\x82",
		"\xB3\x74" => "\xED\x80\x83",
		"\xB3\x75" => "\xED\x80\x85",
		"\xB3\x76" => "\xED\x80\x86",
		"\xB3\x77" => "\xED\x80\x87",
		"\xB3\x78" => "\xED\x80\x88",
		"\xB3\x79" => "\xED\x80\x89",
		"\xB3\x7A" => "\xED\x80\x8A",
		"\xB3\x81" => "\xED\x80\x8B",
		"\xB3\x82" => "\xED\x80\x8C",
		"\xB3\x83" => "\xED\x80\x8D",
		"\xB3\x84" => "\xED\x80\x8E",
		"\xB3\x85" => "\xED\x80\x8F",
		"\xB3\x86" => "\xED\x80\x90",
		"\xB3\x87" => "\xED\x80\x92",
		"\xB3\x88" => "\xED\x80\x93",
		"\xB3\x89" => "\xED\x80\x94",
		"\xB3\x8A" => "\xED\x80\x95",
		"\xB3\x8B" => "\xED\x80\x96",
		"\xB3\x8C" => "\xED\x80\x97",
		"\xB3\x8D" => "\xED\x80\x99",
		"\xB3\x8E" => "\xED\x80\x9A",
		"\xB3\x8F" => "\xED\x80\x9B",
		"\xB3\x90" => "\xED\x80\x9C",
		"\xB3\x91" => "\xED\x80\x9D",
		"\xB3\x92" => "\xED\x80\x9E",
		"\xB3\x93" => "\xED\x80\x9F",
		"\xB3\x94" => "\xED\x80\xA0",
		"\xB3\x95" => "\xED\x80\xA1",
		"\xB3\x96" => "\xED\x80\xA2",
		"\xB3\x97" => "\xED\x80\xA3",
		"\xB3\x98" => "\xED\x80\xA4",
		"\xB3\x99" => "\xED\x80\xA5",
		"\xB3\x9A" => "\xED\x80\xA6",
		"\xB3\x9B" => "\xED\x80\xA7",
		"\xB3\x9C" => "\xED\x80\xA8",
		"\xB3\x9D" => "\xED\x80\xA9",
		"\xB3\x9E" => "\xED\x80\xAA",
		"\xB3\x9F" => "\xED\x80\xAB",
		"\xB3\xA0" => "\xED\x80\xAC",
		"\xB3\xA1" => "\xEB\x81\x9D",
		"\xB3\xA2" => "\xEB\x81\xBC",
		"\xB3\xA3" => "\xEB\x81\xBD",
		"\xB3\xA4" => "\xEB\x82\x80",
		"\xB3\xA5" => "\xEB\x82\x84",
		"\xB3\xA6" => "\xEB\x82\x8C",
		"\xB3\xA7" => "\xEB\x82\x8D",
		"\xB3\xA8" => "\xEB\x82\x8F",
		"\xB3\xA9" => "\xEB\x82\x91",
		"\xB3\xAA" => "\xEB\x82\x98",
		"\xB3\xAB" => "\xEB\x82\x99",
		"\xB3\xAC" => "\xEB\x82\x9A",
		"\xB3\xAD" => "\xEB\x82\x9C",
		"\xB3\xAE" => "\xEB\x82\x9F",
		"\xB3\xAF" => "\xEB\x82\xA0",
		"\xB3\xB0" => "\xEB\x82\xA1",
		"\xB3\xB1" => "\xEB\x82\xA2",
		"\xB3\xB2" => "\xEB\x82\xA8",
		"\xB3\xB3" => "\xEB\x82\xA9",
		"\xB3\xB4" => "\xEB\x82\xAB",
		"\xB3\xB5" => "\xEB\x82\xAC",
		"\xB3\xB6" => "\xEB\x82\xAD",
		"\xB3\xB7" => "\xEB\x82\xAE",
		"\xB3\xB8" => "\xEB\x82\xAF",
		"\xB3\xB9" => "\xEB\x82\xB1",
		"\xB3\xBA" => "\xEB\x82\xB3",
		"\xB3\xBB" => "\xEB\x82\xB4",
		"\xB3\xBC" => "\xEB\x82\xB5",
		"\xB3\xBD" => "\xEB\x82\xB8",
		"\xB3\xBE" => "\xEB\x82\xBC",
		"\xB3\xBF" => "\xEB\x83\x84",
		"\xB3\xC0" => "\xEB\x83\x85",
		"\xB3\xC1" => "\xEB\x83\x87",
		"\xB3\xC2" => "\xEB\x83\x88",
		"\xB3\xC3" => "\xEB\x83\x89",
		"\xB3\xC4" => "\xEB\x83\x90",
		"\xB3\xC5" => "\xEB\x83\x91",
		"\xB3\xC6" => "\xEB\x83\x94",
		"\xB3\xC7" => "\xEB\x83\x98",
		"\xB3\xC8" => "\xEB\x83\xA0",
		"\xB3\xC9" => "\xEB\x83\xA5",
		"\xB3\xCA" => "\xEB\x84\x88",
		"\xB3\xCB" => "\xEB\x84\x89",
		"\xB3\xCC" => "\xEB\x84\x8B",
		"\xB3\xCD" => "\xEB\x84\x8C",
		"\xB3\xCE" => "\xEB\x84\x90",
		"\xB3\xCF" => "\xEB\x84\x92",
		"\xB3\xD0" => "\xEB\x84\x93",
		"\xB3\xD1" => "\xEB\x84\x98",
		"\xB3\xD2" => "\xEB\x84\x99",
		"\xB3\xD3" => "\xEB\x84\x9B",
		"\xB3\xD4" => "\xEB\x84\x9C",
		"\xB3\xD5" => "\xEB\x84\x9D",
		"\xB3\xD6" => "\xEB\x84\xA3",
		"\xB3\xD7" => "\xEB\x84\xA4",
		"\xB3\xD8" => "\xEB\x84\xA5",
		"\xB3\xD9" => "\xEB\x84\xA8",
		"\xB3\xDA" => "\xEB\x84\xAC",
		"\xB3\xDB" => "\xEB\x84\xB4",
		"\xB3\xDC" => "\xEB\x84\xB5",
		"\xB3\xDD" => "\xEB\x84\xB7",
		"\xB3\xDE" => "\xEB\x84\xB8",
		"\xB3\xDF" => "\xEB\x84\xB9",
		"\xB3\xE0" => "\xEB\x85\x80",
		"\xB3\xE1" => "\xEB\x85\x81",
		"\xB3\xE2" => "\xEB\x85\x84",
		"\xB3\xE3" => "\xEB\x85\x88",
		"\xB3\xE4" => "\xEB\x85\x90",
		"\xB3\xE5" => "\xEB\x85\x91",
		"\xB3\xE6" => "\xEB\x85\x94",
		"\xB3\xE7" => "\xEB\x85\x95",
		"\xB3\xE8" => "\xEB\x85\x98",
		"\xB3\xE9" => "\xEB\x85\x9C",
		"\xB3\xEA" => "\xEB\x85\xA0",
		"\xB3\xEB" => "\xEB\x85\xB8",
		"\xB3\xEC" => "\xEB\x85\xB9",
		"\xB3\xED" => "\xEB\x85\xBC",
		"\xB3\xEE" => "\xEB\x86\x80",
		"\xB3\xEF" => "\xEB\x86\x82",
		"\xB3\xF0" => "\xEB\x86\x88",
		"\xB3\xF1" => "\xEB\x86\x89",
		"\xB3\xF2" => "\xEB\x86\x8B",
		"\xB3\xF3" => "\xEB\x86\x8D",
		"\xB3\xF4" => "\xEB\x86\x92",
		"\xB3\xF5" => "\xEB\x86\x93",
		"\xB3\xF6" => "\xEB\x86\x94",
		"\xB3\xF7" => "\xEB\x86\x98",
		"\xB3\xF8" => "\xEB\x86\x9C",
		"\xB3\xF9" => "\xEB\x86\xA8",
		"\xB3\xFA" => "\xEB\x87\x8C",
		"\xB3\xFB" => "\xEB\x87\x90",
		"\xB3\xFC" => "\xEB\x87\x94",
		"\xB3\xFD" => "\xEB\x87\x9C",
		"\xB3\xFE" => "\xEB\x87\x9D",
		"\xB4\x41" => "\xED\x80\xAE",
		"\xB4\x42" => "\xED\x80\xAF",
		"\xB4\x43" => "\xED\x80\xB0",
		"\xB4\x44" => "\xED\x80\xB1",
		"\xB4\x45" => "\xED\x80\xB2",
		"\xB4\x46" => "\xED\x80\xB3",
		"\xB4\x47" => "\xED\x80\xB6",
		"\xB4\x48" => "\xED\x80\xB7",
		"\xB4\x49" => "\xED\x80\xB9",
		"\xB4\x4A" => "\xED\x80\xBA",
		"\xB4\x4B" => "\xED\x80\xBB",
		"\xB4\x4C" => "\xED\x80\xBD",
		"\xB4\x4D" => "\xED\x80\xBE",
		"\xB4\x4E" => "\xED\x80\xBF",
		"\xB4\x4F" => "\xED\x81\x80",
		"\xB4\x50" => "\xED\x81\x81",
		"\xB4\x51" => "\xED\x81\x82",
		"\xB4\x52" => "\xED\x81\x83",
		"\xB4\x53" => "\xED\x81\x86",
		"\xB4\x54" => "\xED\x81\x88",
		"\xB4\x55" => "\xED\x81\x8A",
		"\xB4\x56" => "\xED\x81\x8B",
		"\xB4\x57" => "\xED\x81\x8C",
		"\xB4\x58" => "\xED\x81\x8D",
		"\xB4\x59" => "\xED\x81\x8E",
		"\xB4\x5A" => "\xED\x81\x8F",
		"\xB4\x61" => "\xED\x81\x91",
		"\xB4\x62" => "\xED\x81\x92",
		"\xB4\x63" => "\xED\x81\x93",
		"\xB4\x64" => "\xED\x81\x95",
		"\xB4\x65" => "\xED\x81\x96",
		"\xB4\x66" => "\xED\x81\x97",
		"\xB4\x67" => "\xED\x81\x99",
		"\xB4\x68" => "\xED\x81\x9A",
		"\xB4\x69" => "\xED\x81\x9B",
		"\xB4\x6A" => "\xED\x81\x9C",
		"\xB4\x6B" => "\xED\x81\x9D",
		"\xB4\x6C" => "\xED\x81\x9E",
		"\xB4\x6D" => "\xED\x81\x9F",
		"\xB4\x6E" => "\xED\x81\xA1",
		"\xB4\x6F" => "\xED\x81\xA2",
		"\xB4\x70" => "\xED\x81\xA3",
		"\xB4\x71" => "\xED\x81\xA4",
		"\xB4\x72" => "\xED\x81\xA5",
		"\xB4\x73" => "\xED\x81\xA6",
		"\xB4\x74" => "\xED\x81\xA7",
		"\xB4\x75" => "\xED\x81\xA8",
		"\xB4\x76" => "\xED\x81\xA9",
		"\xB4\x77" => "\xED\x81\xAA",
		"\xB4\x78" => "\xED\x81\xAB",
		"\xB4\x79" => "\xED\x81\xAE",
		"\xB4\x7A" => "\xED\x81\xAF",
		"\xB4\x81" => "\xED\x81\xB1",
		"\xB4\x82" => "\xED\x81\xB2",
		"\xB4\x83" => "\xED\x81\xB3",
		"\xB4\x84" => "\xED\x81\xB5",
		"\xB4\x85" => "\xED\x81\xB6",
		"\xB4\x86" => "\xED\x81\xB7",
		"\xB4\x87" => "\xED\x81\xB8",
		"\xB4\x88" => "\xED\x81\xB9",
		"\xB4\x89" => "\xED\x81\xBA",
		"\xB4\x8A" => "\xED\x81\xBB",
		"\xB4\x8B" => "\xED\x81\xBE",
		"\xB4\x8C" => "\xED\x81\xBF",
		"\xB4\x8D" => "\xED\x82\x80",
		"\xB4\x8E" => "\xED\x82\x82",
		"\xB4\x8F" => "\xED\x82\x83",
		"\xB4\x90" => "\xED\x82\x84",
		"\xB4\x91" => "\xED\x82\x85",
		"\xB4\x92" => "\xED\x82\x86",
		"\xB4\x93" => "\xED\x82\x87",
		"\xB4\x94" => "\xED\x82\x88",
		"\xB4\x95" => "\xED\x82\x89",
		"\xB4\x96" => "\xED\x82\x8A",
		"\xB4\x97" => "\xED\x82\x8B",
		"\xB4\x98" => "\xED\x82\x8C",
		"\xB4\x99" => "\xED\x82\x8D",
		"\xB4\x9A" => "\xED\x82\x8E",
		"\xB4\x9B" => "\xED\x82\x8F",
		"\xB4\x9C" => "\xED\x82\x90",
		"\xB4\x9D" => "\xED\x82\x91",
		"\xB4\x9E" => "\xED\x82\x92",
		"\xB4\x9F" => "\xED\x82\x93",
		"\xB4\xA0" => "\xED\x82\x94",
		"\xB4\xA1" => "\xEB\x87\x9F",
		"\xB4\xA2" => "\xEB\x87\xA8",
		"\xB4\xA3" => "\xEB\x87\xA9",
		"\xB4\xA4" => "\xEB\x87\xAC",
		"\xB4\xA5" => "\xEB\x87\xB0",
		"\xB4\xA6" => "\xEB\x87\xB9",
		"\xB4\xA7" => "\xEB\x87\xBB",
		"\xB4\xA8" => "\xEB\x87\xBD",
		"\xB4\xA9" => "\xEB\x88\x84",
		"\xB4\xAA" => "\xEB\x88\x85",
		"\xB4\xAB" => "\xEB\x88\x88",
		"\xB4\xAC" => "\xEB\x88\x8B",
		"\xB4\xAD" => "\xEB\x88\x8C",
		"\xB4\xAE" => "\xEB\x88\x94",
		"\xB4\xAF" => "\xEB\x88\x95",
		"\xB4\xB0" => "\xEB\x88\x97",
		"\xB4\xB1" => "\xEB\x88\x99",
		"\xB4\xB2" => "\xEB\x88\xA0",
		"\xB4\xB3" => "\xEB\x88\xB4",
		"\xB4\xB4" => "\xEB\x88\xBC",
		"\xB4\xB5" => "\xEB\x89\x98",
		"\xB4\xB6" => "\xEB\x89\x9C",
		"\xB4\xB7" => "\xEB\x89\xA0",
		"\xB4\xB8" => "\xEB\x89\xA8",
		"\xB4\xB9" => "\xEB\x89\xA9",
		"\xB4\xBA" => "\xEB\x89\xB4",
		"\xB4\xBB" => "\xEB\x89\xB5",
		"\xB4\xBC" => "\xEB\x89\xBC",
		"\xB4\xBD" => "\xEB\x8A\x84",
		"\xB4\xBE" => "\xEB\x8A\x85",
		"\xB4\xBF" => "\xEB\x8A\x89",
		"\xB4\xC0" => "\xEB\x8A\x90",
		"\xB4\xC1" => "\xEB\x8A\x91",
		"\xB4\xC2" => "\xEB\x8A\x94",
		"\xB4\xC3" => "\xEB\x8A\x98",
		"\xB4\xC4" => "\xEB\x8A\x99",
		"\xB4\xC5" => "\xEB\x8A\x9A",
		"\xB4\xC6" => "\xEB\x8A\xA0",
		"\xB4\xC7" => "\xEB\x8A\xA1",
		"\xB4\xC8" => "\xEB\x8A\xA3",
		"\xB4\xC9" => "\xEB\x8A\xA5",
		"\xB4\xCA" => "\xEB\x8A\xA6",
		"\xB4\xCB" => "\xEB\x8A\xAA",
		"\xB4\xCC" => "\xEB\x8A\xAC",
		"\xB4\xCD" => "\xEB\x8A\xB0",
		"\xB4\xCE" => "\xEB\x8A\xB4",
		"\xB4\xCF" => "\xEB\x8B\x88",
		"\xB4\xD0" => "\xEB\x8B\x89",
		"\xB4\xD1" => "\xEB\x8B\x8C",
		"\xB4\xD2" => "\xEB\x8B\x90",
		"\xB4\xD3" => "\xEB\x8B\x92",
		"\xB4\xD4" => "\xEB\x8B\x98",
		"\xB4\xD5" => "\xEB\x8B\x99",
		"\xB4\xD6" => "\xEB\x8B\x9B",
		"\xB4\xD7" => "\xEB\x8B\x9D",
		"\xB4\xD8" => "\xEB\x8B\xA2",
		"\xB4\xD9" => "\xEB\x8B\xA4",
		"\xB4\xDA" => "\xEB\x8B\xA5",
		"\xB4\xDB" => "\xEB\x8B\xA6",
		"\xB4\xDC" => "\xEB\x8B\xA8",
		"\xB4\xDD" => "\xEB\x8B\xAB",
		"\xB4\xDE" => "\xEB\x8B\xAC",
		"\xB4\xDF" => "\xEB\x8B\xAD",
		"\xB4\xE0" => "\xEB\x8B\xAE",
		"\xB4\xE1" => "\xEB\x8B\xAF",
		"\xB4\xE2" => "\xEB\x8B\xB3",
		"\xB4\xE3" => "\xEB\x8B\xB4",
		"\xB4\xE4" => "\xEB\x8B\xB5",
		"\xB4\xE5" => "\xEB\x8B\xB7",
		"\xB4\xE6" => "\xEB\x8B\xB8",
		"\xB4\xE7" => "\xEB\x8B\xB9",
		"\xB4\xE8" => "\xEB\x8B\xBA",
		"\xB4\xE9" => "\xEB\x8B\xBB",
		"\xB4\xEA" => "\xEB\x8B\xBF",
		"\xB4\xEB" => "\xEB\x8C\x80",
		"\xB4\xEC" => "\xEB\x8C\x81",
		"\xB4\xED" => "\xEB\x8C\x84",
		"\xB4\xEE" => "\xEB\x8C\x88",
		"\xB4\xEF" => "\xEB\x8C\x90",
		"\xB4\xF0" => "\xEB\x8C\x91",
		"\xB4\xF1" => "\xEB\x8C\x93",
		"\xB4\xF2" => "\xEB\x8C\x94",
		"\xB4\xF3" => "\xEB\x8C\x95",
		"\xB4\xF4" => "\xEB\x8C\x9C",
		"\xB4\xF5" => "\xEB\x8D\x94",
		"\xB4\xF6" => "\xEB\x8D\x95",
		"\xB4\xF7" => "\xEB\x8D\x96",
		"\xB4\xF8" => "\xEB\x8D\x98",
		"\xB4\xF9" => "\xEB\x8D\x9B",
		"\xB4\xFA" => "\xEB\x8D\x9C",
		"\xB4\xFB" => "\xEB\x8D\x9E",
		"\xB4\xFC" => "\xEB\x8D\x9F",
		"\xB4\xFD" => "\xEB\x8D\xA4",
		"\xB4\xFE" => "\xEB\x8D\xA5",
		"\xB5\x41" => "\xED\x82\x95",
		"\xB5\x42" => "\xED\x82\x96",
		"\xB5\x43" => "\xED\x82\x97",
		"\xB5\x44" => "\xED\x82\x98",
		"\xB5\x45" => "\xED\x82\x99",
		"\xB5\x46" => "\xED\x82\x9A",
		"\xB5\x47" => "\xED\x82\x9B",
		"\xB5\x48" => "\xED\x82\x9C",
		"\xB5\x49" => "\xED\x82\x9D",
		"\xB5\x4A" => "\xED\x82\x9E",
		"\xB5\x4B" => "\xED\x82\x9F",
		"\xB5\x4C" => "\xED\x82\xA0",
		"\xB5\x4D" => "\xED\x82\xA1",
		"\xB5\x4E" => "\xED\x82\xA2",
		"\xB5\x4F" => "\xED\x82\xA3",
		"\xB5\x50" => "\xED\x82\xA6",
		"\xB5\x51" => "\xED\x82\xA7",
		"\xB5\x52" => "\xED\x82\xA9",
		"\xB5\x53" => "\xED\x82\xAA",
		"\xB5\x54" => "\xED\x82\xAB",
		"\xB5\x55" => "\xED\x82\xAD",
		"\xB5\x56" => "\xED\x82\xAE",
		"\xB5\x57" => "\xED\x82\xAF",
		"\xB5\x58" => "\xED\x82\xB0",
		"\xB5\x59" => "\xED\x82\xB1",
		"\xB5\x5A" => "\xED\x82\xB2",
		"\xB5\x61" => "\xED\x82\xB3",
		"\xB5\x62" => "\xED\x82\xB6",
		"\xB5\x63" => "\xED\x82\xB8",
		"\xB5\x64" => "\xED\x82\xBA",
		"\xB5\x65" => "\xED\x82\xBB",
		"\xB5\x66" => "\xED\x82\xBC",
		"\xB5\x67" => "\xED\x82\xBD",
		"\xB5\x68" => "\xED\x82\xBE",
		"\xB5\x69" => "\xED\x82\xBF",
		"\xB5\x6A" => "\xED\x83\x82",
		"\xB5\x6B" => "\xED\x83\x83",
		"\xB5\x6C" => "\xED\x83\x85",
		"\xB5\x6D" => "\xED\x83\x86",
		"\xB5\x6E" => "\xED\x83\x87",
		"\xB5\x6F" => "\xED\x83\x8A",
		"\xB5\x70" => "\xED\x83\x8B",
		"\xB5\x71" => "\xED\x83\x8C",
		"\xB5\x72" => "\xED\x83\x8D",
		"\xB5\x73" => "\xED\x83\x8E",
		"\xB5\x74" => "\xED\x83\x8F",
		"\xB5\x75" => "\xED\x83\x92",
		"\xB5\x76" => "\xED\x83\x96",
		"\xB5\x77" => "\xED\x83\x97",
		"\xB5\x78" => "\xED\x83\x98",
		"\xB5\x79" => "\xED\x83\x99",
		"\xB5\x7A" => "\xED\x83\x9A",
		"\xB5\x81" => "\xED\x83\x9B",
		"\xB5\x82" => "\xED\x83\x9E",
		"\xB5\x83" => "\xED\x83\x9F",
		"\xB5\x84" => "\xED\x83\xA1",
		"\xB5\x85" => "\xED\x83\xA2",
		"\xB5\x86" => "\xED\x83\xA3",
		"\xB5\x87" => "\xED\x83\xA5",
		"\xB5\x88" => "\xED\x83\xA6",
		"\xB5\x89" => "\xED\x83\xA7",
		"\xB5\x8A" => "\xED\x83\xA8",
		"\xB5\x8B" => "\xED\x83\xA9",
		"\xB5\x8C" => "\xED\x83\xAA",
		"\xB5\x8D" => "\xED\x83\xAB",
		"\xB5\x8E" => "\xED\x83\xAE",
		"\xB5\x8F" => "\xED\x83\xB2",
		"\xB5\x90" => "\xED\x83\xB3",
		"\xB5\x91" => "\xED\x83\xB4",
		"\xB5\x92" => "\xED\x83\xB5",
		"\xB5\x93" => "\xED\x83\xB6",
		"\xB5\x94" => "\xED\x83\xB7",
		"\xB5\x95" => "\xED\x83\xB9",
		"\xB5\x96" => "\xED\x83\xBA",
		"\xB5\x97" => "\xED\x83\xBB",
		"\xB5\x98" => "\xED\x83\xBC",
		"\xB5\x99" => "\xED\x83\xBD",
		"\xB5\x9A" => "\xED\x83\xBE",
		"\xB5\x9B" => "\xED\x83\xBF",
		"\xB5\x9C" => "\xED\x84\x80",
		"\xB5\x9D" => "\xED\x84\x81",
		"\xB5\x9E" => "\xED\x84\x82",
		"\xB5\x9F" => "\xED\x84\x83",
		"\xB5\xA0" => "\xED\x84\x84",
		"\xB5\xA1" => "\xEB\x8D\xA7",
		"\xB5\xA2" => "\xEB\x8D\xA9",
		"\xB5\xA3" => "\xEB\x8D\xAB",
		"\xB5\xA4" => "\xEB\x8D\xAE",
		"\xB5\xA5" => "\xEB\x8D\xB0",
		"\xB5\xA6" => "\xEB\x8D\xB1",
		"\xB5\xA7" => "\xEB\x8D\xB4",
		"\xB5\xA8" => "\xEB\x8D\xB8",
		"\xB5\xA9" => "\xEB\x8E\x80",
		"\xB5\xAA" => "\xEB\x8E\x81",
		"\xB5\xAB" => "\xEB\x8E\x83",
		"\xB5\xAC" => "\xEB\x8E\x84",
		"\xB5\xAD" => "\xEB\x8E\x85",
		"\xB5\xAE" => "\xEB\x8E\x8C",
		"\xB5\xAF" => "\xEB\x8E\x90",
		"\xB5\xB0" => "\xEB\x8E\x94",
		"\xB5\xB1" => "\xEB\x8E\xA0",
		"\xB5\xB2" => "\xEB\x8E\xA1",
		"\xB5\xB3" => "\xEB\x8E\xA8",
		"\xB5\xB4" => "\xEB\x8E\xAC",
		"\xB5\xB5" => "\xEB\x8F\x84",
		"\xB5\xB6" => "\xEB\x8F\x85",
		"\xB5\xB7" => "\xEB\x8F\x88",
		"\xB5\xB8" => "\xEB\x8F\x8B",
		"\xB5\xB9" => "\xEB\x8F\x8C",
		"\xB5\xBA" => "\xEB\x8F\x8E",
		"\xB5\xBB" => "\xEB\x8F\x90",
		"\xB5\xBC" => "\xEB\x8F\x94",
		"\xB5\xBD" => "\xEB\x8F\x95",
		"\xB5\xBE" => "\xEB\x8F\x97",
		"\xB5\xBF" => "\xEB\x8F\x99",
		"\xB5\xC0" => "\xEB\x8F\x9B",
		"\xB5\xC1" => "\xEB\x8F\x9D",
		"\xB5\xC2" => "\xEB\x8F\xA0",
		"\xB5\xC3" => "\xEB\x8F\xA4",
		"\xB5\xC4" => "\xEB\x8F\xA8",
		"\xB5\xC5" => "\xEB\x8F\xBC",
		"\xB5\xC6" => "\xEB\x90\x90",
		"\xB5\xC7" => "\xEB\x90\x98",
		"\xB5\xC8" => "\xEB\x90\x9C",
		"\xB5\xC9" => "\xEB\x90\xA0",
		"\xB5\xCA" => "\xEB\x90\xA8",
		"\xB5\xCB" => "\xEB\x90\xA9",
		"\xB5\xCC" => "\xEB\x90\xAB",
		"\xB5\xCD" => "\xEB\x90\xB4",
		"\xB5\xCE" => "\xEB\x91\x90",
		"\xB5\xCF" => "\xEB\x91\x91",
		"\xB5\xD0" => "\xEB\x91\x94",
		"\xB5\xD1" => "\xEB\x91\x98",
		"\xB5\xD2" => "\xEB\x91\xA0",
		"\xB5\xD3" => "\xEB\x91\xA1",
		"\xB5\xD4" => "\xEB\x91\xA3",
		"\xB5\xD5" => "\xEB\x91\xA5",
		"\xB5\xD6" => "\xEB\x91\xAC",
		"\xB5\xD7" => "\xEB\x92\x80",
		"\xB5\xD8" => "\xEB\x92\x88",
		"\xB5\xD9" => "\xEB\x92\x9D",
		"\xB5\xDA" => "\xEB\x92\xA4",
		"\xB5\xDB" => "\xEB\x92\xA8",
		"\xB5\xDC" => "\xEB\x92\xAC",
		"\xB5\xDD" => "\xEB\x92\xB5",
		"\xB5\xDE" => "\xEB\x92\xB7",
		"\xB5\xDF" => "\xEB\x92\xB9",
		"\xB5\xE0" => "\xEB\x93\x80",
		"\xB5\xE1" => "\xEB\x93\x84",
		"\xB5\xE2" => "\xEB\x93\x88",
		"\xB5\xE3" => "\xEB\x93\x90",
		"\xB5\xE4" => "\xEB\x93\x95",
		"\xB5\xE5" => "\xEB\x93\x9C",
		"\xB5\xE6" => "\xEB\x93\x9D",
		"\xB5\xE7" => "\xEB\x93\xA0",
		"\xB5\xE8" => "\xEB\x93\xA3",
		"\xB5\xE9" => "\xEB\x93\xA4",
		"\xB5\xEA" => "\xEB\x93\xA6",
		"\xB5\xEB" => "\xEB\x93\xAC",
		"\xB5\xEC" => "\xEB\x93\xAD",
		"\xB5\xED" => "\xEB\x93\xAF",
		"\xB5\xEE" => "\xEB\x93\xB1",
		"\xB5\xEF" => "\xEB\x93\xB8",
		"\xB5\xF0" => "\xEB\x94\x94",
		"\xB5\xF1" => "\xEB\x94\x95",
		"\xB5\xF2" => "\xEB\x94\x98",
		"\xB5\xF3" => "\xEB\x94\x9B",
		"\xB5\xF4" => "\xEB\x94\x9C",
		"\xB5\xF5" => "\xEB\x94\xA4",
		"\xB5\xF6" => "\xEB\x94\xA5",
		"\xB5\xF7" => "\xEB\x94\xA7",
		"\xB5\xF8" => "\xEB\x94\xA8",
		"\xB5\xF9" => "\xEB\x94\xA9",
		"\xB5\xFA" => "\xEB\x94\xAA",
		"\xB5\xFB" => "\xEB\x94\xB0",
		"\xB5\xFC" => "\xEB\x94\xB1",
		"\xB5\xFD" => "\xEB\x94\xB4",
		"\xB5\xFE" => "\xEB\x94\xB8",
		"\xB6\x41" => "\xED\x84\x85",
		"\xB6\x42" => "\xED\x84\x86",
		"\xB6\x43" => "\xED\x84\x87",
		"\xB6\x44" => "\xED\x84\x88",
		"\xB6\x45" => "\xED\x84\x89",
		"\xB6\x46" => "\xED\x84\x8A",
		"\xB6\x47" => "\xED\x84\x8B",
		"\xB6\x48" => "\xED\x84\x8C",
		"\xB6\x49" => "\xED\x84\x8E",
		"\xB6\x4A" => "\xED\x84\x8F",
		"\xB6\x4B" => "\xED\x84\x90",
		"\xB6\x4C" => "\xED\x84\x91",
		"\xB6\x4D" => "\xED\x84\x92",
		"\xB6\x4E" => "\xED\x84\x93",
		"\xB6\x4F" => "\xED\x84\x94",
		"\xB6\x50" => "\xED\x84\x95",
		"\xB6\x51" => "\xED\x84\x96",
		"\xB6\x52" => "\xED\x84\x97",
		"\xB6\x53" => "\xED\x84\x98",
		"\xB6\x54" => "\xED\x84\x99",
		"\xB6\x55" => "\xED\x84\x9A",
		"\xB6\x56" => "\xED\x84\x9B",
		"\xB6\x57" => "\xED\x84\x9C",
		"\xB6\x58" => "\xED\x84\x9D",
		"\xB6\x59" => "\xED\x84\x9E",
		"\xB6\x5A" => "\xED\x84\x9F",
		"\xB6\x61" => "\xED\x84\xA0",
		"\xB6\x62" => "\xED\x84\xA1",
		"\xB6\x63" => "\xED\x84\xA2",
		"\xB6\x64" => "\xED\x84\xA3",
		"\xB6\x65" => "\xED\x84\xA4",
		"\xB6\x66" => "\xED\x84\xA5",
		"\xB6\x67" => "\xED\x84\xA6",
		"\xB6\x68" => "\xED\x84\xA7",
		"\xB6\x69" => "\xED\x84\xA8",
		"\xB6\x6A" => "\xED\x84\xA9",
		"\xB6\x6B" => "\xED\x84\xAA",
		"\xB6\x6C" => "\xED\x84\xAB",
		"\xB6\x6D" => "\xED\x84\xAC",
		"\xB6\x6E" => "\xED\x84\xAD",
		"\xB6\x6F" => "\xED\x84\xAE",
		"\xB6\x70" => "\xED\x84\xAF",
		"\xB6\x71" => "\xED\x84\xB2",
		"\xB6\x72" => "\xED\x84\xB3",
		"\xB6\x73" => "\xED\x84\xB5",
		"\xB6\x74" => "\xED\x84\xB6",
		"\xB6\x75" => "\xED\x84\xB7",
		"\xB6\x76" => "\xED\x84\xB9",
		"\xB6\x77" => "\xED\x84\xBB",
		"\xB6\x78" => "\xED\x84\xBC",
		"\xB6\x79" => "\xED\x84\xBD",
		"\xB6\x7A" => "\xED\x84\xBE",
		"\xB6\x81" => "\xED\x84\xBF",
		"\xB6\x82" => "\xED\x85\x82",
		"\xB6\x83" => "\xED\x85\x86",
		"\xB6\x84" => "\xED\x85\x87",
		"\xB6\x85" => "\xED\x85\x88",
		"\xB6\x86" => "\xED\x85\x89",
		"\xB6\x87" => "\xED\x85\x8A",
		"\xB6\x88" => "\xED\x85\x8B",
		"\xB6\x89" => "\xED\x85\x8E",
		"\xB6\x8A" => "\xED\x85\x8F",
		"\xB6\x8B" => "\xED\x85\x91",
		"\xB6\x8C" => "\xED\x85\x92",
		"\xB6\x8D" => "\xED\x85\x93",
		"\xB6\x8E" => "\xED\x85\x95",
		"\xB6\x8F" => "\xED\x85\x96",
		"\xB6\x90" => "\xED\x85\x97",
		"\xB6\x91" => "\xED\x85\x98",
		"\xB6\x92" => "\xED\x85\x99",
		"\xB6\x93" => "\xED\x85\x9A",
		"\xB6\x94" => "\xED\x85\x9B",
		"\xB6\x95" => "\xED\x85\x9E",
		"\xB6\x96" => "\xED\x85\xA0",
		"\xB6\x97" => "\xED\x85\xA2",
		"\xB6\x98" => "\xED\x85\xA3",
		"\xB6\x99" => "\xED\x85\xA4",
		"\xB6\x9A" => "\xED\x85\xA5",
		"\xB6\x9B" => "\xED\x85\xA6",
		"\xB6\x9C" => "\xED\x85\xA7",
		"\xB6\x9D" => "\xED\x85\xA9",
		"\xB6\x9E" => "\xED\x85\xAA",
		"\xB6\x9F" => "\xED\x85\xAB",
		"\xB6\xA0" => "\xED\x85\xAD",
		"\xB6\xA1" => "\xEB\x95\x80",
		"\xB6\xA2" => "\xEB\x95\x81",
		"\xB6\xA3" => "\xEB\x95\x83",
		"\xB6\xA4" => "\xEB\x95\x84",
		"\xB6\xA5" => "\xEB\x95\x85",
		"\xB6\xA6" => "\xEB\x95\x8B",
		"\xB6\xA7" => "\xEB\x95\x8C",
		"\xB6\xA8" => "\xEB\x95\x8D",
		"\xB6\xA9" => "\xEB\x95\x90",
		"\xB6\xAA" => "\xEB\x95\x94",
		"\xB6\xAB" => "\xEB\x95\x9C",
		"\xB6\xAC" => "\xEB\x95\x9D",
		"\xB6\xAD" => "\xEB\x95\x9F",
		"\xB6\xAE" => "\xEB\x95\xA0",
		"\xB6\xAF" => "\xEB\x95\xA1",
		"\xB6\xB0" => "\xEB\x96\xA0",
		"\xB6\xB1" => "\xEB\x96\xA1",
		"\xB6\xB2" => "\xEB\x96\xA4",
		"\xB6\xB3" => "\xEB\x96\xA8",
		"\xB6\xB4" => "\xEB\x96\xAA",
		"\xB6\xB5" => "\xEB\x96\xAB",
		"\xB6\xB6" => "\xEB\x96\xB0",
		"\xB6\xB7" => "\xEB\x96\xB1",
		"\xB6\xB8" => "\xEB\x96\xB3",
		"\xB6\xB9" => "\xEB\x96\xB4",
		"\xB6\xBA" => "\xEB\x96\xB5",
		"\xB6\xBB" => "\xEB\x96\xBB",
		"\xB6\xBC" => "\xEB\x96\xBC",
		"\xB6\xBD" => "\xEB\x96\xBD",
		"\xB6\xBE" => "\xEB\x97\x80",
		"\xB6\xBF" => "\xEB\x97\x84",
		"\xB6\xC0" => "\xEB\x97\x8C",
		"\xB6\xC1" => "\xEB\x97\x8D",
		"\xB6\xC2" => "\xEB\x97\x8F",
		"\xB6\xC3" => "\xEB\x97\x90",
		"\xB6\xC4" => "\xEB\x97\x91",
		"\xB6\xC5" => "\xEB\x97\x98",
		"\xB6\xC6" => "\xEB\x97\xAC",
		"\xB6\xC7" => "\xEB\x98\x90",
		"\xB6\xC8" => "\xEB\x98\x91",
		"\xB6\xC9" => "\xEB\x98\x94",
		"\xB6\xCA" => "\xEB\x98\x98",
		"\xB6\xCB" => "\xEB\x98\xA5",
		"\xB6\xCC" => "\xEB\x98\xAC",
		"\xB6\xCD" => "\xEB\x98\xB4",
		"\xB6\xCE" => "\xEB\x99\x88",
		"\xB6\xCF" => "\xEB\x99\xA4",
		"\xB6\xD0" => "\xEB\x99\xA8",
		"\xB6\xD1" => "\xEB\x9A\x9C",
		"\xB6\xD2" => "\xEB\x9A\x9D",
		"\xB6\xD3" => "\xEB\x9A\xA0",
		"\xB6\xD4" => "\xEB\x9A\xA4",
		"\xB6\xD5" => "\xEB\x9A\xAB",
		"\xB6\xD6" => "\xEB\x9A\xAC",
		"\xB6\xD7" => "\xEB\x9A\xB1",
		"\xB6\xD8" => "\xEB\x9B\x94",
		"\xB6\xD9" => "\xEB\x9B\xB0",
		"\xB6\xDA" => "\xEB\x9B\xB4",
		"\xB6\xDB" => "\xEB\x9B\xB8",
		"\xB6\xDC" => "\xEB\x9C\x80",
		"\xB6\xDD" => "\xEB\x9C\x81",
		"\xB6\xDE" => "\xEB\x9C\x85",
		"\xB6\xDF" => "\xEB\x9C\xA8",
		"\xB6\xE0" => "\xEB\x9C\xA9",
		"\xB6\xE1" => "\xEB\x9C\xAC",
		"\xB6\xE2" => "\xEB\x9C\xAF",
		"\xB6\xE3" => "\xEB\x9C\xB0",
		"\xB6\xE4" => "\xEB\x9C\xB8",
		"\xB6\xE5" => "\xEB\x9C\xB9",
		"\xB6\xE6" => "\xEB\x9C\xBB",
		"\xB6\xE7" => "\xEB\x9D\x84",
		"\xB6\xE8" => "\xEB\x9D\x88",
		"\xB6\xE9" => "\xEB\x9D\x8C",
		"\xB6\xEA" => "\xEB\x9D\x94",
		"\xB6\xEB" => "\xEB\x9D\x95",
		"\xB6\xEC" => "\xEB\x9D\xA0",
		"\xB6\xED" => "\xEB\x9D\xA4",
		"\xB6\xEE" => "\xEB\x9D\xA8",
		"\xB6\xEF" => "\xEB\x9D\xB0",
		"\xB6\xF0" => "\xEB\x9D\xB1",
		"\xB6\xF1" => "\xEB\x9D\xB3",
		"\xB6\xF2" => "\xEB\x9D\xB5",
		"\xB6\xF3" => "\xEB\x9D\xBC",
		"\xB6\xF4" => "\xEB\x9D\xBD",
		"\xB6\xF5" => "\xEB\x9E\x80",
		"\xB6\xF6" => "\xEB\x9E\x84",
		"\xB6\xF7" => "\xEB\x9E\x8C",
		"\xB6\xF8" => "\xEB\x9E\x8D",
		"\xB6\xF9" => "\xEB\x9E\x8F",
		"\xB6\xFA" => "\xEB\x9E\x90",
		"\xB6\xFB" => "\xEB\x9E\x91",
		"\xB6\xFC" => "\xEB\x9E\x92",
		"\xB6\xFD" => "\xEB\x9E\x96",
		"\xB6\xFE" => "\xEB\x9E\x97",
		"\xB7\x41" => "\xED\x85\xAE",
		"\xB7\x42" => "\xED\x85\xAF",
		"\xB7\x43" => "\xED\x85\xB0",
		"\xB7\x44" => "\xED\x85\xB1",
		"\xB7\x45" => "\xED\x85\xB2",
		"\xB7\x46" => "\xED\x85\xB3",
		"\xB7\x47" => "\xED\x85\xB4",
		"\xB7\x48" => "\xED\x85\xB5",
		"\xB7\x49" => "\xED\x85\xB6",
		"\xB7\x4A" => "\xED\x85\xB7",
		"\xB7\x4B" => "\xED\x85\xB8",
		"\xB7\x4C" => "\xED\x85\xB9",
		"\xB7\x4D" => "\xED\x85\xBA",
		"\xB7\x4E" => "\xED\x85\xBB",
		"\xB7\x4F" => "\xED\x85\xBD",
		"\xB7\x50" => "\xED\x85\xBE",
		"\xB7\x51" => "\xED\x85\xBF",
		"\xB7\x52" => "\xED\x86\x80",
		"\xB7\x53" => "\xED\x86\x81",
		"\xB7\x54" => "\xED\x86\x82",
		"\xB7\x55" => "\xED\x86\x83",
		"\xB7\x56" => "\xED\x86\x85",
		"\xB7\x57" => "\xED\x86\x86",
		"\xB7\x58" => "\xED\x86\x87",
		"\xB7\x59" => "\xED\x86\x89",
		"\xB7\x5A" => "\xED\x86\x8A",
		"\xB7\x61" => "\xED\x86\x8B",
		"\xB7\x62" => "\xED\x86\x8C",
		"\xB7\x63" => "\xED\x86\x8D",
		"\xB7\x64" => "\xED\x86\x8E",
		"\xB7\x65" => "\xED\x86\x8F",
		"\xB7\x66" => "\xED\x86\x90",
		"\xB7\x67" => "\xED\x86\x91",
		"\xB7\x68" => "\xED\x86\x92",
		"\xB7\x69" => "\xED\x86\x93",
		"\xB7\x6A" => "\xED\x86\x94",
		"\xB7\x6B" => "\xED\x86\x95",
		"\xB7\x6C" => "\xED\x86\x96",
		"\xB7\x6D" => "\xED\x86\x97",
		"\xB7\x6E" => "\xED\x86\x98",
		"\xB7\x6F" => "\xED\x86\x99",
		"\xB7\x70" => "\xED\x86\x9A",
		"\xB7\x71" => "\xED\x86\x9B",
		"\xB7\x72" => "\xED\x86\x9C",
		"\xB7\x73" => "\xED\x86\x9D",
		"\xB7\x74" => "\xED\x86\x9E",
		"\xB7\x75" => "\xED\x86\x9F",
		"\xB7\x76" => "\xED\x86\xA2",
		"\xB7\x77" => "\xED\x86\xA3",
		"\xB7\x78" => "\xED\x86\xA5",
		"\xB7\x79" => "\xED\x86\xA6",
		"\xB7\x7A" => "\xED\x86\xA7",
		"\xB7\x81" => "\xED\x86\xA9",
		"\xB7\x82" => "\xED\x86\xAA",
		"\xB7\x83" => "\xED\x86\xAB",
		"\xB7\x84" => "\xED\x86\xAC",
		"\xB7\x85" => "\xED\x86\xAD",
		"\xB7\x86" => "\xED\x86\xAE",
		"\xB7\x87" => "\xED\x86\xAF",
		"\xB7\x88" => "\xED\x86\xB2",
		"\xB7\x89" => "\xED\x86\xB4",
		"\xB7\x8A" => "\xED\x86\xB6",
		"\xB7\x8B" => "\xED\x86\xB7",
		"\xB7\x8C" => "\xED\x86\xB8",
		"\xB7\x8D" => "\xED\x86\xB9",
		"\xB7\x8E" => "\xED\x86\xBB",
		"\xB7\x8F" => "\xED\x86\xBD",
		"\xB7\x90" => "\xED\x86\xBE",
		"\xB7\x91" => "\xED\x86\xBF",
		"\xB7\x92" => "\xED\x87\x81",
		"\xB7\x93" => "\xED\x87\x82",
		"\xB7\x94" => "\xED\x87\x83",
		"\xB7\x95" => "\xED\x87\x84",
		"\xB7\x96" => "\xED\x87\x85",
		"\xB7\x97" => "\xED\x87\x86",
		"\xB7\x98" => "\xED\x87\x87",
		"\xB7\x99" => "\xED\x87\x88",
		"\xB7\x9A" => "\xED\x87\x89",
		"\xB7\x9B" => "\xED\x87\x8A",
		"\xB7\x9C" => "\xED\x87\x8B",
		"\xB7\x9D" => "\xED\x87\x8C",
		"\xB7\x9E" => "\xED\x87\x8D",
		"\xB7\x9F" => "\xED\x87\x8E",
		"\xB7\xA0" => "\xED\x87\x8F",
		"\xB7\xA1" => "\xEB\x9E\x98",
		"\xB7\xA2" => "\xEB\x9E\x99",
		"\xB7\xA3" => "\xEB\x9E\x9C",
		"\xB7\xA4" => "\xEB\x9E\xA0",
		"\xB7\xA5" => "\xEB\x9E\xA8",
		"\xB7\xA6" => "\xEB\x9E\xA9",
		"\xB7\xA7" => "\xEB\x9E\xAB",
		"\xB7\xA8" => "\xEB\x9E\xAC",
		"\xB7\xA9" => "\xEB\x9E\xAD",
		"\xB7\xAA" => "\xEB\x9E\xB4",
		"\xB7\xAB" => "\xEB\x9E\xB5",
		"\xB7\xAC" => "\xEB\x9E\xB8",
		"\xB7\xAD" => "\xEB\x9F\x87",
		"\xB7\xAE" => "\xEB\x9F\x89",
		"\xB7\xAF" => "\xEB\x9F\xAC",
		"\xB7\xB0" => "\xEB\x9F\xAD",
		"\xB7\xB1" => "\xEB\x9F\xB0",
		"\xB7\xB2" => "\xEB\x9F\xB4",
		"\xB7\xB3" => "\xEB\x9F\xBC",
		"\xB7\xB4" => "\xEB\x9F\xBD",
		"\xB7\xB5" => "\xEB\x9F\xBF",
		"\xB7\xB6" => "\xEB\xA0\x80",
		"\xB7\xB7" => "\xEB\xA0\x81",
		"\xB7\xB8" => "\xEB\xA0\x87",
		"\xB7\xB9" => "\xEB\xA0\x88",
		"\xB7\xBA" => "\xEB\xA0\x89",
		"\xB7\xBB" => "\xEB\xA0\x8C",
		"\xB7\xBC" => "\xEB\xA0\x90",
		"\xB7\xBD" => "\xEB\xA0\x98",
		"\xB7\xBE" => "\xEB\xA0\x99",
		"\xB7\xBF" => "\xEB\xA0\x9B",
		"\xB7\xC0" => "\xEB\xA0\x9D",
		"\xB7\xC1" => "\xEB\xA0\xA4",
		"\xB7\xC2" => "\xEB\xA0\xA5",
		"\xB7\xC3" => "\xEB\xA0\xA8",
		"\xB7\xC4" => "\xEB\xA0\xAC",
		"\xB7\xC5" => "\xEB\xA0\xB4",
		"\xB7\xC6" => "\xEB\xA0\xB5",
		"\xB7\xC7" => "\xEB\xA0\xB7",
		"\xB7\xC8" => "\xEB\xA0\xB8",
		"\xB7\xC9" => "\xEB\xA0\xB9",
		"\xB7\xCA" => "\xEB\xA1\x80",
		"\xB7\xCB" => "\xEB\xA1\x84",
		"\xB7\xCC" => "\xEB\xA1\x91",
		"\xB7\xCD" => "\xEB\xA1\x93",
		"\xB7\xCE" => "\xEB\xA1\x9C",
		"\xB7\xCF" => "\xEB\xA1\x9D",
		"\xB7\xD0" => "\xEB\xA1\xA0",
		"\xB7\xD1" => "\xEB\xA1\xA4",
		"\xB7\xD2" => "\xEB\xA1\xAC",
		"\xB7\xD3" => "\xEB\xA1\xAD",
		"\xB7\xD4" => "\xEB\xA1\xAF",
		"\xB7\xD5" => "\xEB\xA1\xB1",
		"\xB7\xD6" => "\xEB\xA1\xB8",
		"\xB7\xD7" => "\xEB\xA1\xBC",
		"\xB7\xD8" => "\xEB\xA2\x8D",
		"\xB7\xD9" => "\xEB\xA2\xA8",
		"\xB7\xDA" => "\xEB\xA2\xB0",
		"\xB7\xDB" => "\xEB\xA2\xB4",
		"\xB7\xDC" => "\xEB\xA2\xB8",
		"\xB7\xDD" => "\xEB\xA3\x80",
		"\xB7\xDE" => "\xEB\xA3\x81",
		"\xB7\xDF" => "\xEB\xA3\x83",
		"\xB7\xE0" => "\xEB\xA3\x85",
		"\xB7\xE1" => "\xEB\xA3\x8C",
		"\xB7\xE2" => "\xEB\xA3\x90",
		"\xB7\xE3" => "\xEB\xA3\x94",
		"\xB7\xE4" => "\xEB\xA3\x9D",
		"\xB7\xE5" => "\xEB\xA3\x9F",
		"\xB7\xE6" => "\xEB\xA3\xA1",
		"\xB7\xE7" => "\xEB\xA3\xA8",
		"\xB7\xE8" => "\xEB\xA3\xA9",
		"\xB7\xE9" => "\xEB\xA3\xAC",
		"\xB7\xEA" => "\xEB\xA3\xB0",
		"\xB7\xEB" => "\xEB\xA3\xB8",
		"\xB7\xEC" => "\xEB\xA3\xB9",
		"\xB7\xED" => "\xEB\xA3\xBB",
		"\xB7\xEE" => "\xEB\xA3\xBD",
		"\xB7\xEF" => "\xEB\xA4\x84",
		"\xB7\xF0" => "\xEB\xA4\x98",
		"\xB7\xF1" => "\xEB\xA4\xA0",
		"\xB7\xF2" => "\xEB\xA4\xBC",
		"\xB7\xF3" => "\xEB\xA4\xBD",
		"\xB7\xF4" => "\xEB\xA5\x80",
		"\xB7\xF5" => "\xEB\xA5\x84",
		"\xB7\xF6" => "\xEB\xA5\x8C",
		"\xB7\xF7" => "\xEB\xA5\x8F",
		"\xB7\xF8" => "\xEB\xA5\x91",
		"\xB7\xF9" => "\xEB\xA5\x98",
		"\xB7\xFA" => "\xEB\xA5\x99",
		"\xB7\xFB" => "\xEB\xA5\x9C",
		"\xB7\xFC" => "\xEB\xA5\xA0",
		"\xB7\xFD" => "\xEB\xA5\xA8",
		"\xB7\xFE" => "\xEB\xA5\xA9",
		"\xB8\x41" => "\xED\x87\x90",
		"\xB8\x42" => "\xED\x87\x91",
		"\xB8\x43" => "\xED\x87\x92",
		"\xB8\x44" => "\xED\x87\x93",
		"\xB8\x45" => "\xED\x87\x94",
		"\xB8\x46" => "\xED\x87\x95",
		"\xB8\x47" => "\xED\x87\x96",
		"\xB8\x48" => "\xED\x87\x97",
		"\xB8\x49" => "\xED\x87\x99",
		"\xB8\x4A" => "\xED\x87\x9A",
		"\xB8\x4B" => "\xED\x87\x9B",
		"\xB8\x4C" => "\xED\x87\x9C",
		"\xB8\x4D" => "\xED\x87\x9D",
		"\xB8\x4E" => "\xED\x87\x9E",
		"\xB8\x4F" => "\xED\x87\x9F",
		"\xB8\x50" => "\xED\x87\xA0",
		"\xB8\x51" => "\xED\x87\xA1",
		"\xB8\x52" => "\xED\x87\xA2",
		"\xB8\x53" => "\xED\x87\xA3",
		"\xB8\x54" => "\xED\x87\xA4",
		"\xB8\x55" => "\xED\x87\xA5",
		"\xB8\x56" => "\xED\x87\xA6",
		"\xB8\x57" => "\xED\x87\xA7",
		"\xB8\x58" => "\xED\x87\xA8",
		"\xB8\x59" => "\xED\x87\xA9",
		"\xB8\x5A" => "\xED\x87\xAA",
		"\xB8\x61" => "\xED\x87\xAB",
		"\xB8\x62" => "\xED\x87\xAC",
		"\xB8\x63" => "\xED\x87\xAD",
		"\xB8\x64" => "\xED\x87\xAE",
		"\xB8\x65" => "\xED\x87\xAF",
		"\xB8\x66" => "\xED\x87\xB0",
		"\xB8\x67" => "\xED\x87\xB1",
		"\xB8\x68" => "\xED\x87\xB2",
		"\xB8\x69" => "\xED\x87\xB3",
		"\xB8\x6A" => "\xED\x87\xB5",
		"\xB8\x6B" => "\xED\x87\xB6",
		"\xB8\x6C" => "\xED\x87\xB7",
		"\xB8\x6D" => "\xED\x87\xB9",
		"\xB8\x6E" => "\xED\x87\xBA",
		"\xB8\x6F" => "\xED\x87\xBB",
		"\xB8\x70" => "\xED\x87\xBC",
		"\xB8\x71" => "\xED\x87\xBD",
		"\xB8\x72" => "\xED\x87\xBE",
		"\xB8\x73" => "\xED\x87\xBF",
		"\xB8\x74" => "\xED\x88\x80",
		"\xB8\x75" => "\xED\x88\x81",
		"\xB8\x76" => "\xED\x88\x82",
		"\xB8\x77" => "\xED\x88\x83",
		"\xB8\x78" => "\xED\x88\x84",
		"\xB8\x79" => "\xED\x88\x85",
		"\xB8\x7A" => "\xED\x88\x86",
		"\xB8\x81" => "\xED\x88\x88",
		"\xB8\x82" => "\xED\x88\x8A",
		"\xB8\x83" => "\xED\x88\x8B",
		"\xB8\x84" => "\xED\x88\x8C",
		"\xB8\x85" => "\xED\x88\x8D",
		"\xB8\x86" => "\xED\x88\x8E",
		"\xB8\x87" => "\xED\x88\x8F",
		"\xB8\x88" => "\xED\x88\x91",
		"\xB8\x89" => "\xED\x88\x92",
		"\xB8\x8A" => "\xED\x88\x93",
		"\xB8\x8B" => "\xED\x88\x94",
		"\xB8\x8C" => "\xED\x88\x95",
		"\xB8\x8D" => "\xED\x88\x96",
		"\xB8\x8E" => "\xED\x88\x97",
		"\xB8\x8F" => "\xED\x88\x98",
		"\xB8\x90" => "\xED\x88\x99",
		"\xB8\x91" => "\xED\x88\x9A",
		"\xB8\x92" => "\xED\x88\x9B",
		"\xB8\x93" => "\xED\x88\x9C",
		"\xB8\x94" => "\xED\x88\x9D",
		"\xB8\x95" => "\xED\x88\x9E",
		"\xB8\x96" => "\xED\x88\x9F",
		"\xB8\x97" => "\xED\x88\xA0",
		"\xB8\x98" => "\xED\x88\xA1",
		"\xB8\x99" => "\xED\x88\xA2",
		"\xB8\x9A" => "\xED\x88\xA3",
		"\xB8\x9B" => "\xED\x88\xA4",
		"\xB8\x9C" => "\xED\x88\xA5",
		"\xB8\x9D" => "\xED\x88\xA6",
		"\xB8\x9E" => "\xED\x88\xA7",
		"\xB8\x9F" => "\xED\x88\xA8",
		"\xB8\xA0" => "\xED\x88\xA9",
		"\xB8\xA1" => "\xEB\xA5\xAB",
		"\xB8\xA2" => "\xEB\xA5\xAD",
		"\xB8\xA3" => "\xEB\xA5\xB4",
		"\xB8\xA4" => "\xEB\xA5\xB5",
		"\xB8\xA5" => "\xEB\xA5\xB8",
		"\xB8\xA6" => "\xEB\xA5\xBC",
		"\xB8\xA7" => "\xEB\xA6\x84",
		"\xB8\xA8" => "\xEB\xA6\x85",
		"\xB8\xA9" => "\xEB\xA6\x87",
		"\xB8\xAA" => "\xEB\xA6\x89",
		"\xB8\xAB" => "\xEB\xA6\x8A",
		"\xB8\xAC" => "\xEB\xA6\x8D",
		"\xB8\xAD" => "\xEB\xA6\x8E",
		"\xB8\xAE" => "\xEB\xA6\xAC",
		"\xB8\xAF" => "\xEB\xA6\xAD",
		"\xB8\xB0" => "\xEB\xA6\xB0",
		"\xB8\xB1" => "\xEB\xA6\xB4",
		"\xB8\xB2" => "\xEB\xA6\xBC",
		"\xB8\xB3" => "\xEB\xA6\xBD",
		"\xB8\xB4" => "\xEB\xA6\xBF",
		"\xB8\xB5" => "\xEB\xA7\x81",
		"\xB8\xB6" => "\xEB\xA7\x88",
		"\xB8\xB7" => "\xEB\xA7\x89",
		"\xB8\xB8" => "\xEB\xA7\x8C",
		"\xB8\xB9" => "\xEB\xA7\x8E",
		"\xB8\xBA" => "\xEB\xA7\x8F",
		"\xB8\xBB" => "\xEB\xA7\x90",
		"\xB8\xBC" => "\xEB\xA7\x91",
		"\xB8\xBD" => "\xEB\xA7\x92",
		"\xB8\xBE" => "\xEB\xA7\x98",
		"\xB8\xBF" => "\xEB\xA7\x99",
		"\xB8\xC0" => "\xEB\xA7\x9B",
		"\xB8\xC1" => "\xEB\xA7\x9D",
		"\xB8\xC2" => "\xEB\xA7\x9E",
		"\xB8\xC3" => "\xEB\xA7\xA1",
		"\xB8\xC4" => "\xEB\xA7\xA3",
		"\xB8\xC5" => "\xEB\xA7\xA4",
		"\xB8\xC6" => "\xEB\xA7\xA5",
		"\xB8\xC7" => "\xEB\xA7\xA8",
		"\xB8\xC8" => "\xEB\xA7\xAC",
		"\xB8\xC9" => "\xEB\xA7\xB4",
		"\xB8\xCA" => "\xEB\xA7\xB5",
		"\xB8\xCB" => "\xEB\xA7\xB7",
		"\xB8\xCC" => "\xEB\xA7\xB8",
		"\xB8\xCD" => "\xEB\xA7\xB9",
		"\xB8\xCE" => "\xEB\xA7\xBA",
		"\xB8\xCF" => "\xEB\xA8\x80",
		"\xB8\xD0" => "\xEB\xA8\x81",
		"\xB8\xD1" => "\xEB\xA8\x88",
		"\xB8\xD2" => "\xEB\xA8\x95",
		"\xB8\xD3" => "\xEB\xA8\xB8",
		"\xB8\xD4" => "\xEB\xA8\xB9",
		"\xB8\xD5" => "\xEB\xA8\xBC",
		"\xB8\xD6" => "\xEB\xA9\x80",
		"\xB8\xD7" => "\xEB\xA9\x82",
		"\xB8\xD8" => "\xEB\xA9\x88",
		"\xB8\xD9" => "\xEB\xA9\x89",
		"\xB8\xDA" => "\xEB\xA9\x8B",
		"\xB8\xDB" => "\xEB\xA9\x8D",
		"\xB8\xDC" => "\xEB\xA9\x8E",
		"\xB8\xDD" => "\xEB\xA9\x93",
		"\xB8\xDE" => "\xEB\xA9\x94",
		"\xB8\xDF" => "\xEB\xA9\x95",
		"\xB8\xE0" => "\xEB\xA9\x98",
		"\xB8\xE1" => "\xEB\xA9\x9C",
		"\xB8\xE2" => "\xEB\xA9\xA4",
		"\xB8\xE3" => "\xEB\xA9\xA5",
		"\xB8\xE4" => "\xEB\xA9\xA7",
		"\xB8\xE5" => "\xEB\xA9\xA8",
		"\xB8\xE6" => "\xEB\xA9\xA9",
		"\xB8\xE7" => "\xEB\xA9\xB0",
		"\xB8\xE8" => "\xEB\xA9\xB1",
		"\xB8\xE9" => "\xEB\xA9\xB4",
		"\xB8\xEA" => "\xEB\xA9\xB8",
		"\xB8\xEB" => "\xEB\xAA\x83",
		"\xB8\xEC" => "\xEB\xAA\x84",
		"\xB8\xED" => "\xEB\xAA\x85",
		"\xB8\xEE" => "\xEB\xAA\x87",
		"\xB8\xEF" => "\xEB\xAA\x8C",
		"\xB8\xF0" => "\xEB\xAA\xA8",
		"\xB8\xF1" => "\xEB\xAA\xA9",
		"\xB8\xF2" => "\xEB\xAA\xAB",
		"\xB8\xF3" => "\xEB\xAA\xAC",
		"\xB8\xF4" => "\xEB\xAA\xB0",
		"\xB8\xF5" => "\xEB\xAA\xB2",
		"\xB8\xF6" => "\xEB\xAA\xB8",
		"\xB8\xF7" => "\xEB\xAA\xB9",
		"\xB8\xF8" => "\xEB\xAA\xBB",
		"\xB8\xF9" => "\xEB\xAA\xBD",
		"\xB8\xFA" => "\xEB\xAB\x84",
		"\xB8\xFB" => "\xEB\xAB\x88",
		"\xB8\xFC" => "\xEB\xAB\x98",
		"\xB8\xFD" => "\xEB\xAB\x99",
		"\xB8\xFE" => "\xEB\xAB\xBC",
		"\xB9\x41" => "\xED\x88\xAA",
		"\xB9\x42" => "\xED\x88\xAB",
		"\xB9\x43" => "\xED\x88\xAE",
		"\xB9\x44" => "\xED\x88\xAF",
		"\xB9\x45" => "\xED\x88\xB1",
		"\xB9\x46" => "\xED\x88\xB2",
		"\xB9\x47" => "\xED\x88\xB3",
		"\xB9\x48" => "\xED\x88\xB5",
		"\xB9\x49" => "\xED\x88\xB6",
		"\xB9\x4A" => "\xED\x88\xB7",
		"\xB9\x4B" => "\xED\x88\xB8",
		"\xB9\x4C" => "\xED\x88\xB9",
		"\xB9\x4D" => "\xED\x88\xBA",
		"\xB9\x4E" => "\xED\x88\xBB",
		"\xB9\x4F" => "\xED\x88\xBE",
		"\xB9\x50" => "\xED\x89\x80",
		"\xB9\x51" => "\xED\x89\x82",
		"\xB9\x52" => "\xED\x89\x83",
		"\xB9\x53" => "\xED\x89\x84",
		"\xB9\x54" => "\xED\x89\x85",
		"\xB9\x55" => "\xED\x89\x86",
		"\xB9\x56" => "\xED\x89\x87",
		"\xB9\x57" => "\xED\x89\x89",
		"\xB9\x58" => "\xED\x89\x8A",
		"\xB9\x59" => "\xED\x89\x8B",
		"\xB9\x5A" => "\xED\x89\x8C",
		"\xB9\x61" => "\xED\x89\x8D",
		"\xB9\x62" => "\xED\x89\x8E",
		"\xB9\x63" => "\xED\x89\x8F",
		"\xB9\x64" => "\xED\x89\x90",
		"\xB9\x65" => "\xED\x89\x91",
		"\xB9\x66" => "\xED\x89\x92",
		"\xB9\x67" => "\xED\x89\x93",
		"\xB9\x68" => "\xED\x89\x94",
		"\xB9\x69" => "\xED\x89\x95",
		"\xB9\x6A" => "\xED\x89\x96",
		"\xB9\x6B" => "\xED\x89\x97",
		"\xB9\x6C" => "\xED\x89\x98",
		"\xB9\x6D" => "\xED\x89\x99",
		"\xB9\x6E" => "\xED\x89\x9A",
		"\xB9\x6F" => "\xED\x89\x9B",
		"\xB9\x70" => "\xED\x89\x9D",
		"\xB9\x71" => "\xED\x89\x9E",
		"\xB9\x72" => "\xED\x89\x9F",
		"\xB9\x73" => "\xED\x89\xA0",
		"\xB9\x74" => "\xED\x89\xA1",
		"\xB9\x75" => "\xED\x89\xA2",
		"\xB9\x76" => "\xED\x89\xA3",
		"\xB9\x77" => "\xED\x89\xA5",
		"\xB9\x78" => "\xED\x89\xA6",
		"\xB9\x79" => "\xED\x89\xA7",
		"\xB9\x7A" => "\xED\x89\xA8",
		"\xB9\x81" => "\xED\x89\xA9",
		"\xB9\x82" => "\xED\x89\xAA",
		"\xB9\x83" => "\xED\x89\xAB",
		"\xB9\x84" => "\xED\x89\xAC",
		"\xB9\x85" => "\xED\x89\xAD",
		"\xB9\x86" => "\xED\x89\xAE",
		"\xB9\x87" => "\xED\x89\xAF",
		"\xB9\x88" => "\xED\x89\xB0",
		"\xB9\x89" => "\xED\x89\xB1",
		"\xB9\x8A" => "\xED\x89\xB2",
		"\xB9\x8B" => "\xED\x89\xB3",
		"\xB9\x8C" => "\xED\x89\xB4",
		"\xB9\x8D" => "\xED\x89\xB5",
		"\xB9\x8E" => "\xED\x89\xB6",
		"\xB9\x8F" => "\xED\x89\xB7",
		"\xB9\x90" => "\xED\x89\xB8",
		"\xB9\x91" => "\xED\x89\xB9",
		"\xB9\x92" => "\xED\x89\xBA",
		"\xB9\x93" => "\xED\x89\xBB",
		"\xB9\x94" => "\xED\x89\xBC",
		"\xB9\x95" => "\xED\x89\xBD",
		"\xB9\x96" => "\xED\x89\xBE",
		"\xB9\x97" => "\xED\x89\xBF",
		"\xB9\x98" => "\xED\x8A\x82",
		"\xB9\x99" => "\xED\x8A\x83",
		"\xB9\x9A" => "\xED\x8A\x85",
		"\xB9\x9B" => "\xED\x8A\x86",
		"\xB9\x9C" => "\xED\x8A\x87",
		"\xB9\x9D" => "\xED\x8A\x89",
		"\xB9\x9E" => "\xED\x8A\x8A",
		"\xB9\x9F" => "\xED\x8A\x8B",
		"\xB9\xA0" => "\xED\x8A\x8C",
		"\xB9\xA1" => "\xEB\xAC\x80",
		"\xB9\xA2" => "\xEB\xAC\x84",
		"\xB9\xA3" => "\xEB\xAC\x8D",
		"\xB9\xA4" => "\xEB\xAC\x8F",
		"\xB9\xA5" => "\xEB\xAC\x91",
		"\xB9\xA6" => "\xEB\xAC\x98",
		"\xB9\xA7" => "\xEB\xAC\x9C",
		"\xB9\xA8" => "\xEB\xAC\xA0",
		"\xB9\xA9" => "\xEB\xAC\xA9",
		"\xB9\xAA" => "\xEB\xAC\xAB",
		"\xB9\xAB" => "\xEB\xAC\xB4",
		"\xB9\xAC" => "\xEB\xAC\xB5",
		"\xB9\xAD" => "\xEB\xAC\xB6",
		"\xB9\xAE" => "\xEB\xAC\xB8",
		"\xB9\xAF" => "\xEB\xAC\xBB",
		"\xB9\xB0" => "\xEB\xAC\xBC",
		"\xB9\xB1" => "\xEB\xAC\xBD",
		"\xB9\xB2" => "\xEB\xAC\xBE",
		"\xB9\xB3" => "\xEB\xAD\x84",
		"\xB9\xB4" => "\xEB\xAD\x85",
		"\xB9\xB5" => "\xEB\xAD\x87",
		"\xB9\xB6" => "\xEB\xAD\x89",
		"\xB9\xB7" => "\xEB\xAD\x8D",
		"\xB9\xB8" => "\xEB\xAD\x8F",
		"\xB9\xB9" => "\xEB\xAD\x90",
		"\xB9\xBA" => "\xEB\xAD\x94",
		"\xB9\xBB" => "\xEB\xAD\x98",
		"\xB9\xBC" => "\xEB\xAD\xA1",
		"\xB9\xBD" => "\xEB\xAD\xA3",
		"\xB9\xBE" => "\xEB\xAD\xAC",
		"\xB9\xBF" => "\xEB\xAE\x88",
		"\xB9\xC0" => "\xEB\xAE\x8C",
		"\xB9\xC1" => "\xEB\xAE\x90",
		"\xB9\xC2" => "\xEB\xAE\xA4",
		"\xB9\xC3" => "\xEB\xAE\xA8",
		"\xB9\xC4" => "\xEB\xAE\xAC",
		"\xB9\xC5" => "\xEB\xAE\xB4",
		"\xB9\xC6" => "\xEB\xAE\xB7",
		"\xB9\xC7" => "\xEB\xAF\x80",
		"\xB9\xC8" => "\xEB\xAF\x84",
		"\xB9\xC9" => "\xEB\xAF\x88",
		"\xB9\xCA" => "\xEB\xAF\x90",
		"\xB9\xCB" => "\xEB\xAF\x93",
		"\xB9\xCC" => "\xEB\xAF\xB8",
		"\xB9\xCD" => "\xEB\xAF\xB9",
		"\xB9\xCE" => "\xEB\xAF\xBC",
		"\xB9\xCF" => "\xEB\xAF\xBF",
		"\xB9\xD0" => "\xEB\xB0\x80",
		"\xB9\xD1" => "\xEB\xB0\x82",
		"\xB9\xD2" => "\xEB\xB0\x88",
		"\xB9\xD3" => "\xEB\xB0\x89",
		"\xB9\xD4" => "\xEB\xB0\x8B",
		"\xB9\xD5" => "\xEB\xB0\x8C",
		"\xB9\xD6" => "\xEB\xB0\x8D",
		"\xB9\xD7" => "\xEB\xB0\x8F",
		"\xB9\xD8" => "\xEB\xB0\x91",
		"\xB9\xD9" => "\xEB\xB0\x94",
		"\xB9\xDA" => "\xEB\xB0\x95",
		"\xB9\xDB" => "\xEB\xB0\x96",
		"\xB9\xDC" => "\xEB\xB0\x97",
		"\xB9\xDD" => "\xEB\xB0\x98",
		"\xB9\xDE" => "\xEB\xB0\x9B",
		"\xB9\xDF" => "\xEB\xB0\x9C",
		"\xB9\xE0" => "\xEB\xB0\x9D",
		"\xB9\xE1" => "\xEB\xB0\x9E",
		"\xB9\xE2" => "\xEB\xB0\x9F",
		"\xB9\xE3" => "\xEB\xB0\xA4",
		"\xB9\xE4" => "\xEB\xB0\xA5",
		"\xB9\xE5" => "\xEB\xB0\xA7",
		"\xB9\xE6" => "\xEB\xB0\xA9",
		"\xB9\xE7" => "\xEB\xB0\xAD",
		"\xB9\xE8" => "\xEB\xB0\xB0",
		"\xB9\xE9" => "\xEB\xB0\xB1",
		"\xB9\xEA" => "\xEB\xB0\xB4",
		"\xB9\xEB" => "\xEB\xB0\xB8",
		"\xB9\xEC" => "\xEB\xB1\x80",
		"\xB9\xED" => "\xEB\xB1\x81",
		"\xB9\xEE" => "\xEB\xB1\x83",
		"\xB9\xEF" => "\xEB\xB1\x84",
		"\xB9\xF0" => "\xEB\xB1\x85",
		"\xB9\xF1" => "\xEB\xB1\x89",
		"\xB9\xF2" => "\xEB\xB1\x8C",
		"\xB9\xF3" => "\xEB\xB1\x8D",
		"\xB9\xF4" => "\xEB\xB1\x90",
		"\xB9\xF5" => "\xEB\xB1\x9D",
		"\xB9\xF6" => "\xEB\xB2\x84",
		"\xB9\xF7" => "\xEB\xB2\x85",
		"\xB9\xF8" => "\xEB\xB2\x88",
		"\xB9\xF9" => "\xEB\xB2\x8B",
		"\xB9\xFA" => "\xEB\xB2\x8C",
		"\xB9\xFB" => "\xEB\xB2\x8E",
		"\xB9\xFC" => "\xEB\xB2\x94",
		"\xB9\xFD" => "\xEB\xB2\x95",
		"\xB9\xFE" => "\xEB\xB2\x97",
		"\xBA\x41" => "\xED\x8A\x8D",
		"\xBA\x42" => "\xED\x8A\x8E",
		"\xBA\x43" => "\xED\x8A\x8F",
		"\xBA\x44" => "\xED\x8A\x92",
		"\xBA\x45" => "\xED\x8A\x93",
		"\xBA\x46" => "\xED\x8A\x94",
		"\xBA\x47" => "\xED\x8A\x96",
		"\xBA\x48" => "\xED\x8A\x97",
		"\xBA\x49" => "\xED\x8A\x98",
		"\xBA\x4A" => "\xED\x8A\x99",
		"\xBA\x4B" => "\xED\x8A\x9A",
		"\xBA\x4C" => "\xED\x8A\x9B",
		"\xBA\x4D" => "\xED\x8A\x9D",
		"\xBA\x4E" => "\xED\x8A\x9E",
		"\xBA\x4F" => "\xED\x8A\x9F",
		"\xBA\x50" => "\xED\x8A\xA1",
		"\xBA\x51" => "\xED\x8A\xA2",
		"\xBA\x52" => "\xED\x8A\xA3",
		"\xBA\x53" => "\xED\x8A\xA5",
		"\xBA\x54" => "\xED\x8A\xA6",
		"\xBA\x55" => "\xED\x8A\xA7",
		"\xBA\x56" => "\xED\x8A\xA8",
		"\xBA\x57" => "\xED\x8A\xA9",
		"\xBA\x58" => "\xED\x8A\xAA",
		"\xBA\x59" => "\xED\x8A\xAB",
		"\xBA\x5A" => "\xED\x8A\xAD",
		"\xBA\x61" => "\xED\x8A\xAE",
		"\xBA\x62" => "\xED\x8A\xAF",
		"\xBA\x63" => "\xED\x8A\xB0",
		"\xBA\x64" => "\xED\x8A\xB2",
		"\xBA\x65" => "\xED\x8A\xB3",
		"\xBA\x66" => "\xED\x8A\xB4",
		"\xBA\x67" => "\xED\x8A\xB5",
		"\xBA\x68" => "\xED\x8A\xB6",
		"\xBA\x69" => "\xED\x8A\xB7",
		"\xBA\x6A" => "\xED\x8A\xBA",
		"\xBA\x6B" => "\xED\x8A\xBB",
		"\xBA\x6C" => "\xED\x8A\xBD",
		"\xBA\x6D" => "\xED\x8A\xBE",
		"\xBA\x6E" => "\xED\x8B\x81",
		"\xBA\x6F" => "\xED\x8B\x83",
		"\xBA\x70" => "\xED\x8B\x84",
		"\xBA\x71" => "\xED\x8B\x85",
		"\xBA\x72" => "\xED\x8B\x86",
		"\xBA\x73" => "\xED\x8B\x87",
		"\xBA\x74" => "\xED\x8B\x8A",
		"\xBA\x75" => "\xED\x8B\x8C",
		"\xBA\x76" => "\xED\x8B\x8D",
		"\xBA\x77" => "\xED\x8B\x8E",
		"\xBA\x78" => "\xED\x8B\x8F",
		"\xBA\x79" => "\xED\x8B\x90",
		"\xBA\x7A" => "\xED\x8B\x91",
		"\xBA\x81" => "\xED\x8B\x92",
		"\xBA\x82" => "\xED\x8B\x93",
		"\xBA\x83" => "\xED\x8B\x95",
		"\xBA\x84" => "\xED\x8B\x96",
		"\xBA\x85" => "\xED\x8B\x97",
		"\xBA\x86" => "\xED\x8B\x99",
		"\xBA\x87" => "\xED\x8B\x9A",
		"\xBA\x88" => "\xED\x8B\x9B",
		"\xBA\x89" => "\xED\x8B\x9D",
		"\xBA\x8A" => "\xED\x8B\x9E",
		"\xBA\x8B" => "\xED\x8B\x9F",
		"\xBA\x8C" => "\xED\x8B\xA0",
		"\xBA\x8D" => "\xED\x8B\xA1",
		"\xBA\x8E" => "\xED\x8B\xA2",
		"\xBA\x8F" => "\xED\x8B\xA3",
		"\xBA\x90" => "\xED\x8B\xA6",
		"\xBA\x91" => "\xED\x8B\xA7",
		"\xBA\x92" => "\xED\x8B\xA8",
		"\xBA\x93" => "\xED\x8B\xA9",
		"\xBA\x94" => "\xED\x8B\xAA",
		"\xBA\x95" => "\xED\x8B\xAB",
		"\xBA\x96" => "\xED\x8B\xAC",
		"\xBA\x97" => "\xED\x8B\xAD",
		"\xBA\x98" => "\xED\x8B\xAE",
		"\xBA\x99" => "\xED\x8B\xAF",
		"\xBA\x9A" => "\xED\x8B\xB2",
		"\xBA\x9B" => "\xED\x8B\xB3",
		"\xBA\x9C" => "\xED\x8B\xB5",
		"\xBA\x9D" => "\xED\x8B\xB6",
		"\xBA\x9E" => "\xED\x8B\xB7",
		"\xBA\x9F" => "\xED\x8B\xB9",
		"\xBA\xA0" => "\xED\x8B\xBA",
		"\xBA\xA1" => "\xEB\xB2\x99",
		"\xBA\xA2" => "\xEB\xB2\x9A",
		"\xBA\xA3" => "\xEB\xB2\xA0",
		"\xBA\xA4" => "\xEB\xB2\xA1",
		"\xBA\xA5" => "\xEB\xB2\xA4",
		"\xBA\xA6" => "\xEB\xB2\xA7",
		"\xBA\xA7" => "\xEB\xB2\xA8",
		"\xBA\xA8" => "\xEB\xB2\xB0",
		"\xBA\xA9" => "\xEB\xB2\xB1",
		"\xBA\xAA" => "\xEB\xB2\xB3",
		"\xBA\xAB" => "\xEB\xB2\xB4",
		"\xBA\xAC" => "\xEB\xB2\xB5",
		"\xBA\xAD" => "\xEB\xB2\xBC",
		"\xBA\xAE" => "\xEB\xB2\xBD",
		"\xBA\xAF" => "\xEB\xB3\x80",
		"\xBA\xB0" => "\xEB\xB3\x84",
		"\xBA\xB1" => "\xEB\xB3\x8D",
		"\xBA\xB2" => "\xEB\xB3\x8F",
		"\xBA\xB3" => "\xEB\xB3\x90",
		"\xBA\xB4" => "\xEB\xB3\x91",
		"\xBA\xB5" => "\xEB\xB3\x95",
		"\xBA\xB6" => "\xEB\xB3\x98",
		"\xBA\xB7" => "\xEB\xB3\x9C",
		"\xBA\xB8" => "\xEB\xB3\xB4",
		"\xBA\xB9" => "\xEB\xB3\xB5",
		"\xBA\xBA" => "\xEB\xB3\xB6",
		"\xBA\xBB" => "\xEB\xB3\xB8",
		"\xBA\xBC" => "\xEB\xB3\xBC",
		"\xBA\xBD" => "\xEB\xB4\x84",
		"\xBA\xBE" => "\xEB\xB4\x85",
		"\xBA\xBF" => "\xEB\xB4\x87",
		"\xBA\xC0" => "\xEB\xB4\x89",
		"\xBA\xC1" => "\xEB\xB4\x90",
		"\xBA\xC2" => "\xEB\xB4\x94",
		"\xBA\xC3" => "\xEB\xB4\xA4",
		"\xBA\xC4" => "\xEB\xB4\xAC",
		"\xBA\xC5" => "\xEB\xB5\x80",
		"\xBA\xC6" => "\xEB\xB5\x88",
		"\xBA\xC7" => "\xEB\xB5\x89",
		"\xBA\xC8" => "\xEB\xB5\x8C",
		"\xBA\xC9" => "\xEB\xB5\x90",
		"\xBA\xCA" => "\xEB\xB5\x98",
		"\xBA\xCB" => "\xEB\xB5\x99",
		"\xBA\xCC" => "\xEB\xB5\xA4",
		"\xBA\xCD" => "\xEB\xB5\xA8",
		"\xBA\xCE" => "\xEB\xB6\x80",
		"\xBA\xCF" => "\xEB\xB6\x81",
		"\xBA\xD0" => "\xEB\xB6\x84",
		"\xBA\xD1" => "\xEB\xB6\x87",
		"\xBA\xD2" => "\xEB\xB6\x88",
		"\xBA\xD3" => "\xEB\xB6\x89",
		"\xBA\xD4" => "\xEB\xB6\x8A",
		"\xBA\xD5" => "\xEB\xB6\x90",
		"\xBA\xD6" => "\xEB\xB6\x91",
		"\xBA\xD7" => "\xEB\xB6\x93",
		"\xBA\xD8" => "\xEB\xB6\x95",
		"\xBA\xD9" => "\xEB\xB6\x99",
		"\xBA\xDA" => "\xEB\xB6\x9A",
		"\xBA\xDB" => "\xEB\xB6\x9C",
		"\xBA\xDC" => "\xEB\xB6\xA4",
		"\xBA\xDD" => "\xEB\xB6\xB0",
		"\xBA\xDE" => "\xEB\xB6\xB8",
		"\xBA\xDF" => "\xEB\xB7\x94",
		"\xBA\xE0" => "\xEB\xB7\x95",
		"\xBA\xE1" => "\xEB\xB7\x98",
		"\xBA\xE2" => "\xEB\xB7\x9C",
		"\xBA\xE3" => "\xEB\xB7\xA9",
		"\xBA\xE4" => "\xEB\xB7\xB0",
		"\xBA\xE5" => "\xEB\xB7\xB4",
		"\xBA\xE6" => "\xEB\xB7\xB8",
		"\xBA\xE7" => "\xEB\xB8\x80",
		"\xBA\xE8" => "\xEB\xB8\x83",
		"\xBA\xE9" => "\xEB\xB8\x85",
		"\xBA\xEA" => "\xEB\xB8\x8C",
		"\xBA\xEB" => "\xEB\xB8\x8D",
		"\xBA\xEC" => "\xEB\xB8\x90",
		"\xBA\xED" => "\xEB\xB8\x94",
		"\xBA\xEE" => "\xEB\xB8\x9C",
		"\xBA\xEF" => "\xEB\xB8\x9D",
		"\xBA\xF0" => "\xEB\xB8\x9F",
		"\xBA\xF1" => "\xEB\xB9\x84",
		"\xBA\xF2" => "\xEB\xB9\x85",
		"\xBA\xF3" => "\xEB\xB9\x88",
		"\xBA\xF4" => "\xEB\xB9\x8C",
		"\xBA\xF5" => "\xEB\xB9\x8E",
		"\xBA\xF6" => "\xEB\xB9\x94",
		"\xBA\xF7" => "\xEB\xB9\x95",
		"\xBA\xF8" => "\xEB\xB9\x97",
		"\xBA\xF9" => "\xEB\xB9\x99",
		"\xBA\xFA" => "\xEB\xB9\x9A",
		"\xBA\xFB" => "\xEB\xB9\x9B",
		"\xBA\xFC" => "\xEB\xB9\xA0",
		"\xBA\xFD" => "\xEB\xB9\xA1",
		"\xBA\xFE" => "\xEB\xB9\xA4",
		"\xBB\x41" => "\xED\x8B\xBB",
		"\xBB\x42" => "\xED\x8B\xBC",
		"\xBB\x43" => "\xED\x8B\xBD",
		"\xBB\x44" => "\xED\x8B\xBE",
		"\xBB\x45" => "\xED\x8B\xBF",
		"\xBB\x46" => "\xED\x8C\x82",
		"\xBB\x47" => "\xED\x8C\x84",
		"\xBB\x48" => "\xED\x8C\x86",
		"\xBB\x49" => "\xED\x8C\x87",
		"\xBB\x4A" => "\xED\x8C\x88",
		"\xBB\x4B" => "\xED\x8C\x89",
		"\xBB\x4C" => "\xED\x8C\x8A",
		"\xBB\x4D" => "\xED\x8C\x8B",
		"\xBB\x4E" => "\xED\x8C\x8F",
		"\xBB\x4F" => "\xED\x8C\x91",
		"\xBB\x50" => "\xED\x8C\x92",
		"\xBB\x51" => "\xED\x8C\x93",
		"\xBB\x52" => "\xED\x8C\x95",
		"\xBB\x53" => "\xED\x8C\x97",
		"\xBB\x54" => "\xED\x8C\x98",
		"\xBB\x55" => "\xED\x8C\x99",
		"\xBB\x56" => "\xED\x8C\x9A",
		"\xBB\x57" => "\xED\x8C\x9B",
		"\xBB\x58" => "\xED\x8C\x9E",
		"\xBB\x59" => "\xED\x8C\xA2",
		"\xBB\x5A" => "\xED\x8C\xA3",
		"\xBB\x61" => "\xED\x8C\xA4",
		"\xBB\x62" => "\xED\x8C\xA6",
		"\xBB\x63" => "\xED\x8C\xA7",
		"\xBB\x64" => "\xED\x8C\xAA",
		"\xBB\x65" => "\xED\x8C\xAB",
		"\xBB\x66" => "\xED\x8C\xAD",
		"\xBB\x67" => "\xED\x8C\xAE",
		"\xBB\x68" => "\xED\x8C\xAF",
		"\xBB\x69" => "\xED\x8C\xB1",
		"\xBB\x6A" => "\xED\x8C\xB2",
		"\xBB\x6B" => "\xED\x8C\xB3",
		"\xBB\x6C" => "\xED\x8C\xB4",
		"\xBB\x6D" => "\xED\x8C\xB5",
		"\xBB\x6E" => "\xED\x8C\xB6",
		"\xBB\x6F" => "\xED\x8C\xB7",
		"\xBB\x70" => "\xED\x8C\xBA",
		"\xBB\x71" => "\xED\x8C\xBE",
		"\xBB\x72" => "\xED\x8C\xBF",
		"\xBB\x73" => "\xED\x8D\x80",
		"\xBB\x74" => "\xED\x8D\x81",
		"\xBB\x75" => "\xED\x8D\x82",
		"\xBB\x76" => "\xED\x8D\x83",
		"\xBB\x77" => "\xED\x8D\x86",
		"\xBB\x78" => "\xED\x8D\x87",
		"\xBB\x79" => "\xED\x8D\x88",
		"\xBB\x7A" => "\xED\x8D\x89",
		"\xBB\x81" => "\xED\x8D\x8A",
		"\xBB\x82" => "\xED\x8D\x8B",
		"\xBB\x83" => "\xED\x8D\x8C",
		"\xBB\x84" => "\xED\x8D\x8D",
		"\xBB\x85" => "\xED\x8D\x8E",
		"\xBB\x86" => "\xED\x8D\x8F",
		"\xBB\x87" => "\xED\x8D\x90",
		"\xBB\x88" => "\xED\x8D\x91",
		"\xBB\x89" => "\xED\x8D\x92",
		"\xBB\x8A" => "\xED\x8D\x93",
		"\xBB\x8B" => "\xED\x8D\x94",
		"\xBB\x8C" => "\xED\x8D\x95",
		"\xBB\x8D" => "\xED\x8D\x96",
		"\xBB\x8E" => "\xED\x8D\x97",
		"\xBB\x8F" => "\xED\x8D\x98",
		"\xBB\x90" => "\xED\x8D\x99",
		"\xBB\x91" => "\xED\x8D\x9A",
		"\xBB\x92" => "\xED\x8D\x9B",
		"\xBB\x93" => "\xED\x8D\x9C",
		"\xBB\x94" => "\xED\x8D\x9D",
		"\xBB\x95" => "\xED\x8D\x9E",
		"\xBB\x96" => "\xED\x8D\x9F",
		"\xBB\x97" => "\xED\x8D\xA0",
		"\xBB\x98" => "\xED\x8D\xA1",
		"\xBB\x99" => "\xED\x8D\xA2",
		"\xBB\x9A" => "\xED\x8D\xA3",
		"\xBB\x9B" => "\xED\x8D\xA4",
		"\xBB\x9C" => "\xED\x8D\xA5",
		"\xBB\x9D" => "\xED\x8D\xA6",
		"\xBB\x9E" => "\xED\x8D\xA7",
		"\xBB\x9F" => "\xED\x8D\xA8",
		"\xBB\xA0" => "\xED\x8D\xA9",
		"\xBB\xA1" => "\xEB\xB9\xA8",
		"\xBB\xA2" => "\xEB\xB9\xAA",
		"\xBB\xA3" => "\xEB\xB9\xB0",
		"\xBB\xA4" => "\xEB\xB9\xB1",
		"\xBB\xA5" => "\xEB\xB9\xB3",
		"\xBB\xA6" => "\xEB\xB9\xB4",
		"\xBB\xA7" => "\xEB\xB9\xB5",
		"\xBB\xA8" => "\xEB\xB9\xBB",
		"\xBB\xA9" => "\xEB\xB9\xBC",
		"\xBB\xAA" => "\xEB\xB9\xBD",
		"\xBB\xAB" => "\xEB\xBA\x80",
		"\xBB\xAC" => "\xEB\xBA\x84",
		"\xBB\xAD" => "\xEB\xBA\x8C",
		"\xBB\xAE" => "\xEB\xBA\x8D",
		"\xBB\xAF" => "\xEB\xBA\x8F",
		"\xBB\xB0" => "\xEB\xBA\x90",
		"\xBB\xB1" => "\xEB\xBA\x91",
		"\xBB\xB2" => "\xEB\xBA\x98",
		"\xBB\xB3" => "\xEB\xBA\x99",
		"\xBB\xB4" => "\xEB\xBA\xA8",
		"\xBB\xB5" => "\xEB\xBB\x90",
		"\xBB\xB6" => "\xEB\xBB\x91",
		"\xBB\xB7" => "\xEB\xBB\x94",
		"\xBB\xB8" => "\xEB\xBB\x97",
		"\xBB\xB9" => "\xEB\xBB\x98",
		"\xBB\xBA" => "\xEB\xBB\xA0",
		"\xBB\xBB" => "\xEB\xBB\xA3",
		"\xBB\xBC" => "\xEB\xBB\xA4",
		"\xBB\xBD" => "\xEB\xBB\xA5",
		"\xBB\xBE" => "\xEB\xBB\xAC",
		"\xBB\xBF" => "\xEB\xBC\x81",
		"\xBB\xC0" => "\xEB\xBC\x88",
		"\xBB\xC1" => "\xEB\xBC\x89",
		"\xBB\xC2" => "\xEB\xBC\x98",
		"\xBB\xC3" => "\xEB\xBC\x99",
		"\xBB\xC4" => "\xEB\xBC\x9B",
		"\xBB\xC5" => "\xEB\xBC\x9C",
		"\xBB\xC6" => "\xEB\xBC\x9D",
		"\xBB\xC7" => "\xEB\xBD\x80",
		"\xBB\xC8" => "\xEB\xBD\x81",
		"\xBB\xC9" => "\xEB\xBD\x84",
		"\xBB\xCA" => "\xEB\xBD\x88",
		"\xBB\xCB" => "\xEB\xBD\x90",
		"\xBB\xCC" => "\xEB\xBD\x91",
		"\xBB\xCD" => "\xEB\xBD\x95",
		"\xBB\xCE" => "\xEB\xBE\x94",
		"\xBB\xCF" => "\xEB\xBE\xB0",
		"\xBB\xD0" => "\xEB\xBF\x85",
		"\xBB\xD1" => "\xEB\xBF\x8C",
		"\xBB\xD2" => "\xEB\xBF\x8D",
		"\xBB\xD3" => "\xEB\xBF\x90",
		"\xBB\xD4" => "\xEB\xBF\x94",
		"\xBB\xD5" => "\xEB\xBF\x9C",
		"\xBB\xD6" => "\xEB\xBF\x9F",
		"\xBB\xD7" => "\xEB\xBF\xA1",
		"\xBB\xD8" => "\xEC\x80\xBC",
		"\xBB\xD9" => "\xEC\x81\x91",
		"\xBB\xDA" => "\xEC\x81\x98",
		"\xBB\xDB" => "\xEC\x81\x9C",
		"\xBB\xDC" => "\xEC\x81\xA0",
		"\xBB\xDD" => "\xEC\x81\xA8",
		"\xBB\xDE" => "\xEC\x81\xA9",
		"\xBB\xDF" => "\xEC\x82\x90",
		"\xBB\xE0" => "\xEC\x82\x91",
		"\xBB\xE1" => "\xEC\x82\x94",
		"\xBB\xE2" => "\xEC\x82\x98",
		"\xBB\xE3" => "\xEC\x82\xA0",
		"\xBB\xE4" => "\xEC\x82\xA1",
		"\xBB\xE5" => "\xEC\x82\xA3",
		"\xBB\xE6" => "\xEC\x82\xA5",
		"\xBB\xE7" => "\xEC\x82\xAC",
		"\xBB\xE8" => "\xEC\x82\xAD",
		"\xBB\xE9" => "\xEC\x82\xAF",
		"\xBB\xEA" => "\xEC\x82\xB0",
		"\xBB\xEB" => "\xEC\x82\xB3",
		"\xBB\xEC" => "\xEC\x82\xB4",
		"\xBB\xED" => "\xEC\x82\xB5",
		"\xBB\xEE" => "\xEC\x82\xB6",
		"\xBB\xEF" => "\xEC\x82\xBC",
		"\xBB\xF0" => "\xEC\x82\xBD",
		"\xBB\xF1" => "\xEC\x82\xBF",
		"\xBB\xF2" => "\xEC\x83\x80",
		"\xBB\xF3" => "\xEC\x83\x81",
		"\xBB\xF4" => "\xEC\x83\x85",
		"\xBB\xF5" => "\xEC\x83\x88",
		"\xBB\xF6" => "\xEC\x83\x89",
		"\xBB\xF7" => "\xEC\x83\x8C",
		"\xBB\xF8" => "\xEC\x83\x90",
		"\xBB\xF9" => "\xEC\x83\x98",
		"\xBB\xFA" => "\xEC\x83\x99",
		"\xBB\xFB" => "\xEC\x83\x9B",
		"\xBB\xFC" => "\xEC\x83\x9C",
		"\xBB\xFD" => "\xEC\x83\x9D",
		"\xBB\xFE" => "\xEC\x83\xA4",
		"\xBC\x41" => "\xED\x8D\xAA",
		"\xBC\x42" => "\xED\x8D\xAB",
		"\xBC\x43" => "\xED\x8D\xAC",
		"\xBC\x44" => "\xED\x8D\xAD",
		"\xBC\x45" => "\xED\x8D\xAE",
		"\xBC\x46" => "\xED\x8D\xAF",
		"\xBC\x47" => "\xED\x8D\xB0",
		"\xBC\x48" => "\xED\x8D\xB1",
		"\xBC\x49" => "\xED\x8D\xB2",
		"\xBC\x4A" => "\xED\x8D\xB3",
		"\xBC\x4B" => "\xED\x8D\xB4",
		"\xBC\x4C" => "\xED\x8D\xB5",
		"\xBC\x4D" => "\xED\x8D\xB6",
		"\xBC\x4E" => "\xED\x8D\xB7",
		"\xBC\x4F" => "\xED\x8D\xB8",
		"\xBC\x50" => "\xED\x8D\xB9",
		"\xBC\x51" => "\xED\x8D\xBA",
		"\xBC\x52" => "\xED\x8D\xBB",
		"\xBC\x53" => "\xED\x8D\xBE",
		"\xBC\x54" => "\xED\x8D\xBF",
		"\xBC\x55" => "\xED\x8E\x81",
		"\xBC\x56" => "\xED\x8E\x82",
		"\xBC\x57" => "\xED\x8E\x83",
		"\xBC\x58" => "\xED\x8E\x85",
		"\xBC\x59" => "\xED\x8E\x86",
		"\xBC\x5A" => "\xED\x8E\x87",
		"\xBC\x61" => "\xED\x8E\x88",
		"\xBC\x62" => "\xED\x8E\x89",
		"\xBC\x63" => "\xED\x8E\x8A",
		"\xBC\x64" => "\xED\x8E\x8B",
		"\xBC\x65" => "\xED\x8E\x8E",
		"\xBC\x66" => "\xED\x8E\x92",
		"\xBC\x67" => "\xED\x8E\x93",
		"\xBC\x68" => "\xED\x8E\x94",
		"\xBC\x69" => "\xED\x8E\x95",
		"\xBC\x6A" => "\xED\x8E\x96",
		"\xBC\x6B" => "\xED\x8E\x97",
		"\xBC\x6C" => "\xED\x8E\x9A",
		"\xBC\x6D" => "\xED\x8E\x9B",
		"\xBC\x6E" => "\xED\x8E\x9D",
		"\xBC\x6F" => "\xED\x8E\x9E",
		"\xBC\x70" => "\xED\x8E\x9F",
		"\xBC\x71" => "\xED\x8E\xA1",
		"\xBC\x72" => "\xED\x8E\xA2",
		"\xBC\x73" => "\xED\x8E\xA3",
		"\xBC\x74" => "\xED\x8E\xA4",
		"\xBC\x75" => "\xED\x8E\xA5",
		"\xBC\x76" => "\xED\x8E\xA6",
		"\xBC\x77" => "\xED\x8E\xA7",
		"\xBC\x78" => "\xED\x8E\xAA",
		"\xBC\x79" => "\xED\x8E\xAC",
		"\xBC\x7A" => "\xED\x8E\xAE",
		"\xBC\x81" => "\xED\x8E\xAF",
		"\xBC\x82" => "\xED\x8E\xB0",
		"\xBC\x83" => "\xED\x8E\xB1",
		"\xBC\x84" => "\xED\x8E\xB2",
		"\xBC\x85" => "\xED\x8E\xB3",
		"\xBC\x86" => "\xED\x8E\xB5",
		"\xBC\x87" => "\xED\x8E\xB6",
		"\xBC\x88" => "\xED\x8E\xB7",
		"\xBC\x89" => "\xED\x8E\xB9",
		"\xBC\x8A" => "\xED\x8E\xBA",
		"\xBC\x8B" => "\xED\x8E\xBB",
		"\xBC\x8C" => "\xED\x8E\xBD",
		"\xBC\x8D" => "\xED\x8E\xBE",
		"\xBC\x8E" => "\xED\x8E\xBF",
		"\xBC\x8F" => "\xED\x8F\x80",
		"\xBC\x90" => "\xED\x8F\x81",
		"\xBC\x91" => "\xED\x8F\x82",
		"\xBC\x92" => "\xED\x8F\x83",
		"\xBC\x93" => "\xED\x8F\x86",
		"\xBC\x94" => "\xED\x8F\x87",
		"\xBC\x95" => "\xED\x8F\x8A",
		"\xBC\x96" => "\xED\x8F\x8B",
		"\xBC\x97" => "\xED\x8F\x8C",
		"\xBC\x98" => "\xED\x8F\x8D",
		"\xBC\x99" => "\xED\x8F\x8E",
		"\xBC\x9A" => "\xED\x8F\x8F",
		"\xBC\x9B" => "\xED\x8F\x91",
		"\xBC\x9C" => "\xED\x8F\x92",
		"\xBC\x9D" => "\xED\x8F\x93",
		"\xBC\x9E" => "\xED\x8F\x94",
		"\xBC\x9F" => "\xED\x8F\x95",
		"\xBC\xA0" => "\xED\x8F\x96",
		"\xBC\xA1" => "\xEC\x83\xA5",
		"\xBC\xA2" => "\xEC\x83\xA8",
		"\xBC\xA3" => "\xEC\x83\xAC",
		"\xBC\xA4" => "\xEC\x83\xB4",
		"\xBC\xA5" => "\xEC\x83\xB5",
		"\xBC\xA6" => "\xEC\x83\xB7",
		"\xBC\xA7" => "\xEC\x83\xB9",
		"\xBC\xA8" => "\xEC\x84\x80",
		"\xBC\xA9" => "\xEC\x84\x84",
		"\xBC\xAA" => "\xEC\x84\x88",
		"\xBC\xAB" => "\xEC\x84\x90",
		"\xBC\xAC" => "\xEC\x84\x95",
		"\xBC\xAD" => "\xEC\x84\x9C",
		"\xBC\xAE" => "\xEC\x84\x9D",
		"\xBC\xAF" => "\xEC\x84\x9E",
		"\xBC\xB0" => "\xEC\x84\x9F",
		"\xBC\xB1" => "\xEC\x84\xA0",
		"\xBC\xB2" => "\xEC\x84\xA3",
		"\xBC\xB3" => "\xEC\x84\xA4",
		"\xBC\xB4" => "\xEC\x84\xA6",
		"\xBC\xB5" => "\xEC\x84\xA7",
		"\xBC\xB6" => "\xEC\x84\xAC",
		"\xBC\xB7" => "\xEC\x84\xAD",
		"\xBC\xB8" => "\xEC\x84\xAF",
		"\xBC\xB9" => "\xEC\x84\xB0",
		"\xBC\xBA" => "\xEC\x84\xB1",
		"\xBC\xBB" => "\xEC\x84\xB6",
		"\xBC\xBC" => "\xEC\x84\xB8",
		"\xBC\xBD" => "\xEC\x84\xB9",
		"\xBC\xBE" => "\xEC\x84\xBC",
		"\xBC\xBF" => "\xEC\x85\x80",
		"\xBC\xC0" => "\xEC\x85\x88",
		"\xBC\xC1" => "\xEC\x85\x89",
		"\xBC\xC2" => "\xEC\x85\x8B",
		"\xBC\xC3" => "\xEC\x85\x8C",
		"\xBC\xC4" => "\xEC\x85\x8D",
		"\xBC\xC5" => "\xEC\x85\x94",
		"\xBC\xC6" => "\xEC\x85\x95",
		"\xBC\xC7" => "\xEC\x85\x98",
		"\xBC\xC8" => "\xEC\x85\x9C",
		"\xBC\xC9" => "\xEC\x85\xA4",
		"\xBC\xCA" => "\xEC\x85\xA5",
		"\xBC\xCB" => "\xEC\x85\xA7",
		"\xBC\xCC" => "\xEC\x85\xA8",
		"\xBC\xCD" => "\xEC\x85\xA9",
		"\xBC\xCE" => "\xEC\x85\xB0",
		"\xBC\xCF" => "\xEC\x85\xB4",
		"\xBC\xD0" => "\xEC\x85\xB8",
		"\xBC\xD1" => "\xEC\x86\x85",
		"\xBC\xD2" => "\xEC\x86\x8C",
		"\xBC\xD3" => "\xEC\x86\x8D",
		"\xBC\xD4" => "\xEC\x86\x8E",
		"\xBC\xD5" => "\xEC\x86\x90",
		"\xBC\xD6" => "\xEC\x86\x94",
		"\xBC\xD7" => "\xEC\x86\x96",
		"\xBC\xD8" => "\xEC\x86\x9C",
		"\xBC\xD9" => "\xEC\x86\x9D",
		"\xBC\xDA" => "\xEC\x86\x9F",
		"\xBC\xDB" => "\xEC\x86\xA1",
		"\xBC\xDC" => "\xEC\x86\xA5",
		"\xBC\xDD" => "\xEC\x86\xA8",
		"\xBC\xDE" => "\xEC\x86\xA9",
		"\xBC\xDF" => "\xEC\x86\xAC",
		"\xBC\xE0" => "\xEC\x86\xB0",
		"\xBC\xE1" => "\xEC\x86\xBD",
		"\xBC\xE2" => "\xEC\x87\x84",
		"\xBC\xE3" => "\xEC\x87\x88",
		"\xBC\xE4" => "\xEC\x87\x8C",
		"\xBC\xE5" => "\xEC\x87\x94",
		"\xBC\xE6" => "\xEC\x87\x97",
		"\xBC\xE7" => "\xEC\x87\x98",
		"\xBC\xE8" => "\xEC\x87\xA0",
		"\xBC\xE9" => "\xEC\x87\xA4",
		"\xBC\xEA" => "\xEC\x87\xA8",
		"\xBC\xEB" => "\xEC\x87\xB0",
		"\xBC\xEC" => "\xEC\x87\xB1",
		"\xBC\xED" => "\xEC\x87\xB3",
		"\xBC\xEE" => "\xEC\x87\xBC",
		"\xBC\xEF" => "\xEC\x87\xBD",
		"\xBC\xF0" => "\xEC\x88\x80",
		"\xBC\xF1" => "\xEC\x88\x84",
		"\xBC\xF2" => "\xEC\x88\x8C",
		"\xBC\xF3" => "\xEC\x88\x8D",
		"\xBC\xF4" => "\xEC\x88\x8F",
		"\xBC\xF5" => "\xEC\x88\x91",
		"\xBC\xF6" => "\xEC\x88\x98",
		"\xBC\xF7" => "\xEC\x88\x99",
		"\xBC\xF8" => "\xEC\x88\x9C",
		"\xBC\xF9" => "\xEC\x88\x9F",
		"\xBC\xFA" => "\xEC\x88\xA0",
		"\xBC\xFB" => "\xEC\x88\xA8",
		"\xBC\xFC" => "\xEC\x88\xA9",
		"\xBC\xFD" => "\xEC\x88\xAB",
		"\xBC\xFE" => "\xEC\x88\xAD",
		"\xBD\x41" => "\xED\x8F\x97",
		"\xBD\x42" => "\xED\x8F\x99",
		"\xBD\x43" => "\xED\x8F\x9A",
		"\xBD\x44" => "\xED\x8F\x9B",
		"\xBD\x45" => "\xED\x8F\x9C",
		"\xBD\x46" => "\xED\x8F\x9D",
		"\xBD\x47" => "\xED\x8F\x9E",
		"\xBD\x48" => "\xED\x8F\x9F",
		"\xBD\x49" => "\xED\x8F\xA0",
		"\xBD\x4A" => "\xED\x8F\xA2",
		"\xBD\x4B" => "\xED\x8F\xA4",
		"\xBD\x4C" => "\xED\x8F\xA5",
		"\xBD\x4D" => "\xED\x8F\xA6",
		"\xBD\x4E" => "\xED\x8F\xA7",
		"\xBD\x4F" => "\xED\x8F\xA8",
		"\xBD\x50" => "\xED\x8F\xA9",
		"\xBD\x51" => "\xED\x8F\xAA",
		"\xBD\x52" => "\xED\x8F\xAB",
		"\xBD\x53" => "\xED\x8F\xAE",
		"\xBD\x54" => "\xED\x8F\xAF",
		"\xBD\x55" => "\xED\x8F\xB1",
		"\xBD\x56" => "\xED\x8F\xB2",
		"\xBD\x57" => "\xED\x8F\xB3",
		"\xBD\x58" => "\xED\x8F\xB5",
		"\xBD\x59" => "\xED\x8F\xB6",
		"\xBD\x5A" => "\xED\x8F\xB7",
		"\xBD\x61" => "\xED\x8F\xB8",
		"\xBD\x62" => "\xED\x8F\xB9",
		"\xBD\x63" => "\xED\x8F\xBA",
		"\xBD\x64" => "\xED\x8F\xBB",
		"\xBD\x65" => "\xED\x8F\xBE",
		"\xBD\x66" => "\xED\x90\x80",
		"\xBD\x67" => "\xED\x90\x82",
		"\xBD\x68" => "\xED\x90\x83",
		"\xBD\x69" => "\xED\x90\x84",
		"\xBD\x6A" => "\xED\x90\x85",
		"\xBD\x6B" => "\xED\x90\x86",
		"\xBD\x6C" => "\xED\x90\x87",
		"\xBD\x6D" => "\xED\x90\x89",
		"\xBD\x6E" => "\xED\x90\x8A",
		"\xBD\x6F" => "\xED\x90\x8B",
		"\xBD\x70" => "\xED\x90\x8C",
		"\xBD\x71" => "\xED\x90\x8D",
		"\xBD\x72" => "\xED\x90\x8E",
		"\xBD\x73" => "\xED\x90\x8F",
		"\xBD\x74" => "\xED\x90\x90",
		"\xBD\x75" => "\xED\x90\x91",
		"\xBD\x76" => "\xED\x90\x92",
		"\xBD\x77" => "\xED\x90\x93",
		"\xBD\x78" => "\xED\x90\x94",
		"\xBD\x79" => "\xED\x90\x95",
		"\xBD\x7A" => "\xED\x90\x96",
		"\xBD\x81" => "\xED\x90\x97",
		"\xBD\x82" => "\xED\x90\x98",
		"\xBD\x83" => "\xED\x90\x99",
		"\xBD\x84" => "\xED\x90\x9A",
		"\xBD\x85" => "\xED\x90\x9B",
		"\xBD\x86" => "\xED\x90\x9C",
		"\xBD\x87" => "\xED\x90\x9E",
		"\xBD\x88" => "\xED\x90\x9F",
		"\xBD\x89" => "\xED\x90\xA0",
		"\xBD\x8A" => "\xED\x90\xA1",
		"\xBD\x8B" => "\xED\x90\xA2",
		"\xBD\x8C" => "\xED\x90\xA3",
		"\xBD\x8D" => "\xED\x90\xA4",
		"\xBD\x8E" => "\xED\x90\xA5",
		"\xBD\x8F" => "\xED\x90\xA6",
		"\xBD\x90" => "\xED\x90\xA7",
		"\xBD\x91" => "\xED\x90\xA8",
		"\xBD\x92" => "\xED\x90\xA9",
		"\xBD\x93" => "\xED\x90\xAA",
		"\xBD\x94" => "\xED\x90\xAB",
		"\xBD\x95" => "\xED\x90\xAC",
		"\xBD\x96" => "\xED\x90\xAD",
		"\xBD\x97" => "\xED\x90\xAE",
		"\xBD\x98" => "\xED\x90\xAF",
		"\xBD\x99" => "\xED\x90\xB0",
		"\xBD\x9A" => "\xED\x90\xB1",
		"\xBD\x9B" => "\xED\x90\xB2",
		"\xBD\x9C" => "\xED\x90\xB3",
		"\xBD\x9D" => "\xED\x90\xB4",
		"\xBD\x9E" => "\xED\x90\xB5",
		"\xBD\x9F" => "\xED\x90\xB6",
		"\xBD\xA0" => "\xED\x90\xB7",
		"\xBD\xA1" => "\xEC\x88\xAF",
		"\xBD\xA2" => "\xEC\x88\xB1",
		"\xBD\xA3" => "\xEC\x88\xB2",
		"\xBD\xA4" => "\xEC\x88\xB4",
		"\xBD\xA5" => "\xEC\x89\x88",
		"\xBD\xA6" => "\xEC\x89\x90",
		"\xBD\xA7" => "\xEC\x89\x91",
		"\xBD\xA8" => "\xEC\x89\x94",
		"\xBD\xA9" => "\xEC\x89\x98",
		"\xBD\xAA" => "\xEC\x89\xA0",
		"\xBD\xAB" => "\xEC\x89\xA5",
		"\xBD\xAC" => "\xEC\x89\xAC",
		"\xBD\xAD" => "\xEC\x89\xAD",
		"\xBD\xAE" => "\xEC\x89\xB0",
		"\xBD\xAF" => "\xEC\x89\xB4",
		"\xBD\xB0" => "\xEC\x89\xBC",
		"\xBD\xB1" => "\xEC\x89\xBD",
		"\xBD\xB2" => "\xEC\x89\xBF",
		"\xBD\xB3" => "\xEC\x8A\x81",
		"\xBD\xB4" => "\xEC\x8A\x88",
		"\xBD\xB5" => "\xEC\x8A\x89",
		"\xBD\xB6" => "\xEC\x8A\x90",
		"\xBD\xB7" => "\xEC\x8A\x98",
		"\xBD\xB8" => "\xEC\x8A\x9B",
		"\xBD\xB9" => "\xEC\x8A\x9D",
		"\xBD\xBA" => "\xEC\x8A\xA4",
		"\xBD\xBB" => "\xEC\x8A\xA5",
		"\xBD\xBC" => "\xEC\x8A\xA8",
		"\xBD\xBD" => "\xEC\x8A\xAC",
		"\xBD\xBE" => "\xEC\x8A\xAD",
		"\xBD\xBF" => "\xEC\x8A\xB4",
		"\xBD\xC0" => "\xEC\x8A\xB5",
		"\xBD\xC1" => "\xEC\x8A\xB7",
		"\xBD\xC2" => "\xEC\x8A\xB9",
		"\xBD\xC3" => "\xEC\x8B\x9C",
		"\xBD\xC4" => "\xEC\x8B\x9D",
		"\xBD\xC5" => "\xEC\x8B\xA0",
		"\xBD\xC6" => "\xEC\x8B\xA3",
		"\xBD\xC7" => "\xEC\x8B\xA4",
		"\xBD\xC8" => "\xEC\x8B\xAB",
		"\xBD\xC9" => "\xEC\x8B\xAC",
		"\xBD\xCA" => "\xEC\x8B\xAD",
		"\xBD\xCB" => "\xEC\x8B\xAF",
		"\xBD\xCC" => "\xEC\x8B\xB1",
		"\xBD\xCD" => "\xEC\x8B\xB6",
		"\xBD\xCE" => "\xEC\x8B\xB8",
		"\xBD\xCF" => "\xEC\x8B\xB9",
		"\xBD\xD0" => "\xEC\x8B\xBB",
		"\xBD\xD1" => "\xEC\x8B\xBC",
		"\xBD\xD2" => "\xEC\x8C\x80",
		"\xBD\xD3" => "\xEC\x8C\x88",
		"\xBD\xD4" => "\xEC\x8C\x89",
		"\xBD\xD5" => "\xEC\x8C\x8C",
		"\xBD\xD6" => "\xEC\x8C\x8D",
		"\xBD\xD7" => "\xEC\x8C\x93",
		"\xBD\xD8" => "\xEC\x8C\x94",
		"\xBD\xD9" => "\xEC\x8C\x95",
		"\xBD\xDA" => "\xEC\x8C\x98",
		"\xBD\xDB" => "\xEC\x8C\x9C",
		"\xBD\xDC" => "\xEC\x8C\xA4",
		"\xBD\xDD" => "\xEC\x8C\xA5",
		"\xBD\xDE" => "\xEC\x8C\xA8",
		"\xBD\xDF" => "\xEC\x8C\xA9",
		"\xBD\xE0" => "\xEC\x8D\x85",
		"\xBD\xE1" => "\xEC\x8D\xA8",
		"\xBD\xE2" => "\xEC\x8D\xA9",
		"\xBD\xE3" => "\xEC\x8D\xAC",
		"\xBD\xE4" => "\xEC\x8D\xB0",
		"\xBD\xE5" => "\xEC\x8D\xB2",
		"\xBD\xE6" => "\xEC\x8D\xB8",
		"\xBD\xE7" => "\xEC\x8D\xB9",
		"\xBD\xE8" => "\xEC\x8D\xBC",
		"\xBD\xE9" => "\xEC\x8D\xBD",
		"\xBD\xEA" => "\xEC\x8E\x84",
		"\xBD\xEB" => "\xEC\x8E\x88",
		"\xBD\xEC" => "\xEC\x8E\x8C",
		"\xBD\xED" => "\xEC\x8F\x80",
		"\xBD\xEE" => "\xEC\x8F\x98",
		"\xBD\xEF" => "\xEC\x8F\x99",
		"\xBD\xF0" => "\xEC\x8F\x9C",
		"\xBD\xF1" => "\xEC\x8F\x9F",
		"\xBD\xF2" => "\xEC\x8F\xA0",
		"\xBD\xF3" => "\xEC\x8F\xA2",
		"\xBD\xF4" => "\xEC\x8F\xA8",
		"\xBD\xF5" => "\xEC\x8F\xA9",
		"\xBD\xF6" => "\xEC\x8F\xAD",
		"\xBD\xF7" => "\xEC\x8F\xB4",
		"\xBD\xF8" => "\xEC\x8F\xB5",
		"\xBD\xF9" => "\xEC\x8F\xB8",
		"\xBD\xFA" => "\xEC\x90\x88",
		"\xBD\xFB" => "\xEC\x90\x90",
		"\xBD\xFC" => "\xEC\x90\xA4",
		"\xBD\xFD" => "\xEC\x90\xAC",
		"\xBD\xFE" => "\xEC\x90\xB0",
		"\xBE\x41" => "\xED\x90\xB8",
		"\xBE\x42" => "\xED\x90\xB9",
		"\xBE\x43" => "\xED\x90\xBA",
		"\xBE\x44" => "\xED\x90\xBB",
		"\xBE\x45" => "\xED\x90\xBC",
		"\xBE\x46" => "\xED\x90\xBD",
		"\xBE\x47" => "\xED\x90\xBE",
		"\xBE\x48" => "\xED\x90\xBF",
		"\xBE\x49" => "\xED\x91\x81",
		"\xBE\x4A" => "\xED\x91\x82",
		"\xBE\x4B" => "\xED\x91\x83",
		"\xBE\x4C" => "\xED\x91\x85",
		"\xBE\x4D" => "\xED\x91\x86",
		"\xBE\x4E" => "\xED\x91\x87",
		"\xBE\x4F" => "\xED\x91\x88",
		"\xBE\x50" => "\xED\x91\x89",
		"\xBE\x51" => "\xED\x91\x8A",
		"\xBE\x52" => "\xED\x91\x8B",
		"\xBE\x53" => "\xED\x91\x8C",
		"\xBE\x54" => "\xED\x91\x8D",
		"\xBE\x55" => "\xED\x91\x8E",
		"\xBE\x56" => "\xED\x91\x8F",
		"\xBE\x57" => "\xED\x91\x90",
		"\xBE\x58" => "\xED\x91\x91",
		"\xBE\x59" => "\xED\x91\x92",
		"\xBE\x5A" => "\xED\x91\x93",
		"\xBE\x61" => "\xED\x91\x94",
		"\xBE\x62" => "\xED\x91\x95",
		"\xBE\x63" => "\xED\x91\x96",
		"\xBE\x64" => "\xED\x91\x97",
		"\xBE\x65" => "\xED\x91\x98",
		"\xBE\x66" => "\xED\x91\x99",
		"\xBE\x67" => "\xED\x91\x9A",
		"\xBE\x68" => "\xED\x91\x9B",
		"\xBE\x69" => "\xED\x91\x9D",
		"\xBE\x6A" => "\xED\x91\x9E",
		"\xBE\x6B" => "\xED\x91\x9F",
		"\xBE\x6C" => "\xED\x91\xA1",
		"\xBE\x6D" => "\xED\x91\xA2",
		"\xBE\x6E" => "\xED\x91\xA3",
		"\xBE\x6F" => "\xED\x91\xA5",
		"\xBE\x70" => "\xED\x91\xA6",
		"\xBE\x71" => "\xED\x91\xA7",
		"\xBE\x72" => "\xED\x91\xA8",
		"\xBE\x73" => "\xED\x91\xA9",
		"\xBE\x74" => "\xED\x91\xAA",
		"\xBE\x75" => "\xED\x91\xAB",
		"\xBE\x76" => "\xED\x91\xAC",
		"\xBE\x77" => "\xED\x91\xAE",
		"\xBE\x78" => "\xED\x91\xB0",
		"\xBE\x79" => "\xED\x91\xB1",
		"\xBE\x7A" => "\xED\x91\xB2",
		"\xBE\x81" => "\xED\x91\xB3",
		"\xBE\x82" => "\xED\x91\xB4",
		"\xBE\x83" => "\xED\x91\xB5",
		"\xBE\x84" => "\xED\x91\xB6",
		"\xBE\x85" => "\xED\x91\xB7",
		"\xBE\x86" => "\xED\x91\xBA",
		"\xBE\x87" => "\xED\x91\xBB",
		"\xBE\x88" => "\xED\x91\xBD",
		"\xBE\x89" => "\xED\x91\xBE",
		"\xBE\x8A" => "\xED\x92\x81",
		"\xBE\x8B" => "\xED\x92\x83",
		"\xBE\x8C" => "\xED\x92\x84",
		"\xBE\x8D" => "\xED\x92\x85",
		"\xBE\x8E" => "\xED\x92\x86",
		"\xBE\x8F" => "\xED\x92\x87",
		"\xBE\x90" => "\xED\x92\x8A",
		"\xBE\x91" => "\xED\x92\x8C",
		"\xBE\x92" => "\xED\x92\x8E",
		"\xBE\x93" => "\xED\x92\x8F",
		"\xBE\x94" => "\xED\x92\x90",
		"\xBE\x95" => "\xED\x92\x91",
		"\xBE\x96" => "\xED\x92\x92",
		"\xBE\x97" => "\xED\x92\x93",
		"\xBE\x98" => "\xED\x92\x95",
		"\xBE\x99" => "\xED\x92\x96",
		"\xBE\x9A" => "\xED\x92\x97",
		"\xBE\x9B" => "\xED\x92\x98",
		"\xBE\x9C" => "\xED\x92\x99",
		"\xBE\x9D" => "\xED\x92\x9A",
		"\xBE\x9E" => "\xED\x92\x9B",
		"\xBE\x9F" => "\xED\x92\x9C",
		"\xBE\xA0" => "\xED\x92\x9D",
		"\xBE\xA1" => "\xEC\x90\xB4",
		"\xBE\xA2" => "\xEC\x90\xBC",
		"\xBE\xA3" => "\xEC\x90\xBD",
		"\xBE\xA4" => "\xEC\x91\x88",
		"\xBE\xA5" => "\xEC\x91\xA4",
		"\xBE\xA6" => "\xEC\x91\xA5",
		"\xBE\xA7" => "\xEC\x91\xA8",
		"\xBE\xA8" => "\xEC\x91\xAC",
		"\xBE\xA9" => "\xEC\x91\xB4",
		"\xBE\xAA" => "\xEC\x91\xB5",
		"\xBE\xAB" => "\xEC\x91\xB9",
		"\xBE\xAC" => "\xEC\x92\x80",
		"\xBE\xAD" => "\xEC\x92\x94",
		"\xBE\xAE" => "\xEC\x92\x9C",
		"\xBE\xAF" => "\xEC\x92\xB8",
		"\xBE\xB0" => "\xEC\x92\xBC",
		"\xBE\xB1" => "\xEC\x93\xA9",
		"\xBE\xB2" => "\xEC\x93\xB0",
		"\xBE\xB3" => "\xEC\x93\xB1",
		"\xBE\xB4" => "\xEC\x93\xB4",
		"\xBE\xB5" => "\xEC\x93\xB8",
		"\xBE\xB6" => "\xEC\x93\xBA",
		"\xBE\xB7" => "\xEC\x93\xBF",
		"\xBE\xB8" => "\xEC\x94\x80",
		"\xBE\xB9" => "\xEC\x94\x81",
		"\xBE\xBA" => "\xEC\x94\x8C",
		"\xBE\xBB" => "\xEC\x94\x90",
		"\xBE\xBC" => "\xEC\x94\x94",
		"\xBE\xBD" => "\xEC\x94\x9C",
		"\xBE\xBE" => "\xEC\x94\xA8",
		"\xBE\xBF" => "\xEC\x94\xA9",
		"\xBE\xC0" => "\xEC\x94\xAC",
		"\xBE\xC1" => "\xEC\x94\xB0",
		"\xBE\xC2" => "\xEC\x94\xB8",
		"\xBE\xC3" => "\xEC\x94\xB9",
		"\xBE\xC4" => "\xEC\x94\xBB",
		"\xBE\xC5" => "\xEC\x94\xBD",
		"\xBE\xC6" => "\xEC\x95\x84",
		"\xBE\xC7" => "\xEC\x95\x85",
		"\xBE\xC8" => "\xEC\x95\x88",
		"\xBE\xC9" => "\xEC\x95\x89",
		"\xBE\xCA" => "\xEC\x95\x8A",
		"\xBE\xCB" => "\xEC\x95\x8C",
		"\xBE\xCC" => "\xEC\x95\x8D",
		"\xBE\xCD" => "\xEC\x95\x8E",
		"\xBE\xCE" => "\xEC\x95\x93",
		"\xBE\xCF" => "\xEC\x95\x94",
		"\xBE\xD0" => "\xEC\x95\x95",
		"\xBE\xD1" => "\xEC\x95\x97",
		"\xBE\xD2" => "\xEC\x95\x98",
		"\xBE\xD3" => "\xEC\x95\x99",
		"\xBE\xD4" => "\xEC\x95\x9D",
		"\xBE\xD5" => "\xEC\x95\x9E",
		"\xBE\xD6" => "\xEC\x95\xA0",
		"\xBE\xD7" => "\xEC\x95\xA1",
		"\xBE\xD8" => "\xEC\x95\xA4",
		"\xBE\xD9" => "\xEC\x95\xA8",
		"\xBE\xDA" => "\xEC\x95\xB0",
		"\xBE\xDB" => "\xEC\x95\xB1",
		"\xBE\xDC" => "\xEC\x95\xB3",
		"\xBE\xDD" => "\xEC\x95\xB4",
		"\xBE\xDE" => "\xEC\x95\xB5",
		"\xBE\xDF" => "\xEC\x95\xBC",
		"\xBE\xE0" => "\xEC\x95\xBD",
		"\xBE\xE1" => "\xEC\x96\x80",
		"\xBE\xE2" => "\xEC\x96\x84",
		"\xBE\xE3" => "\xEC\x96\x87",
		"\xBE\xE4" => "\xEC\x96\x8C",
		"\xBE\xE5" => "\xEC\x96\x8D",
		"\xBE\xE6" => "\xEC\x96\x8F",
		"\xBE\xE7" => "\xEC\x96\x91",
		"\xBE\xE8" => "\xEC\x96\x95",
		"\xBE\xE9" => "\xEC\x96\x97",
		"\xBE\xEA" => "\xEC\x96\x98",
		"\xBE\xEB" => "\xEC\x96\x9C",
		"\xBE\xEC" => "\xEC\x96\xA0",
		"\xBE\xED" => "\xEC\x96\xA9",
		"\xBE\xEE" => "\xEC\x96\xB4",
		"\xBE\xEF" => "\xEC\x96\xB5",
		"\xBE\xF0" => "\xEC\x96\xB8",
		"\xBE\xF1" => "\xEC\x96\xB9",
		"\xBE\xF2" => "\xEC\x96\xBB",
		"\xBE\xF3" => "\xEC\x96\xBC",
		"\xBE\xF4" => "\xEC\x96\xBD",
		"\xBE\xF5" => "\xEC\x96\xBE",
		"\xBE\xF6" => "\xEC\x97\x84",
		"\xBE\xF7" => "\xEC\x97\x85",
		"\xBE\xF8" => "\xEC\x97\x86",
		"\xBE\xF9" => "\xEC\x97\x87",
		"\xBE\xFA" => "\xEC\x97\x88",
		"\xBE\xFB" => "\xEC\x97\x89",
		"\xBE\xFC" => "\xEC\x97\x8A",
		"\xBE\xFD" => "\xEC\x97\x8C",
		"\xBE\xFE" => "\xEC\x97\x8E",
		"\xBF\x41" => "\xED\x92\x9E",
		"\xBF\x42" => "\xED\x92\x9F",
		"\xBF\x43" => "\xED\x92\xA0",
		"\xBF\x44" => "\xED\x92\xA1",
		"\xBF\x45" => "\xED\x92\xA2",
		"\xBF\x46" => "\xED\x92\xA3",
		"\xBF\x47" => "\xED\x92\xA4",
		"\xBF\x48" => "\xED\x92\xA5",
		"\xBF\x49" => "\xED\x92\xA6",
		"\xBF\x4A" => "\xED\x92\xA7",
		"\xBF\x4B" => "\xED\x92\xA8",
		"\xBF\x4C" => "\xED\x92\xAA",
		"\xBF\x4D" => "\xED\x92\xAB",
		"\xBF\x4E" => "\xED\x92\xAC",
		"\xBF\x4F" => "\xED\x92\xAD",
		"\xBF\x50" => "\xED\x92\xAE",
		"\xBF\x51" => "\xED\x92\xAF",
		"\xBF\x52" => "\xED\x92\xB0",
		"\xBF\x53" => "\xED\x92\xB1",
		"\xBF\x54" => "\xED\x92\xB2",
		"\xBF\x55" => "\xED\x92\xB3",
		"\xBF\x56" => "\xED\x92\xB4",
		"\xBF\x57" => "\xED\x92\xB5",
		"\xBF\x58" => "\xED\x92\xB6",
		"\xBF\x59" => "\xED\x92\xB7",
		"\xBF\x5A" => "\xED\x92\xB8",
		"\xBF\x61" => "\xED\x92\xB9",
		"\xBF\x62" => "\xED\x92\xBA",
		"\xBF\x63" => "\xED\x92\xBB",
		"\xBF\x64" => "\xED\x92\xBC",
		"\xBF\x65" => "\xED\x92\xBD",
		"\xBF\x66" => "\xED\x92\xBE",
		"\xBF\x67" => "\xED\x92\xBF",
		"\xBF\x68" => "\xED\x93\x80",
		"\xBF\x69" => "\xED\x93\x81",
		"\xBF\x6A" => "\xED\x93\x82",
		"\xBF\x6B" => "\xED\x93\x83",
		"\xBF\x6C" => "\xED\x93\x84",
		"\xBF\x6D" => "\xED\x93\x85",
		"\xBF\x6E" => "\xED\x93\x86",
		"\xBF\x6F" => "\xED\x93\x87",
		"\xBF\x70" => "\xED\x93\x88",
		"\xBF\x71" => "\xED\x93\x89",
		"\xBF\x72" => "\xED\x93\x8A",
		"\xBF\x73" => "\xED\x93\x8B",
		"\xBF\x74" => "\xED\x93\x8D",
		"\xBF\x75" => "\xED\x93\x8E",
		"\xBF\x76" => "\xED\x93\x8F",
		"\xBF\x77" => "\xED\x93\x91",
		"\xBF\x78" => "\xED\x93\x92",
		"\xBF\x79" => "\xED\x93\x93",
		"\xBF\x7A" => "\xED\x93\x95",
		"\xBF\x81" => "\xED\x93\x96",
		"\xBF\x82" => "\xED\x93\x97",
		"\xBF\x83" => "\xED\x93\x98",
		"\xBF\x84" => "\xED\x93\x99",
		"\xBF\x85" => "\xED\x93\x9A",
		"\xBF\x86" => "\xED\x93\x9B",
		"\xBF\x87" => "\xED\x93\x9D",
		"\xBF\x88" => "\xED\x93\x9E",
		"\xBF\x89" => "\xED\x93\xA0",
		"\xBF\x8A" => "\xED\x93\xA1",
		"\xBF\x8B" => "\xED\x93\xA2",
		"\xBF\x8C" => "\xED\x93\xA3",
		"\xBF\x8D" => "\xED\x93\xA4",
		"\xBF\x8E" => "\xED\x93\xA5",
		"\xBF\x8F" => "\xED\x93\xA6",
		"\xBF\x90" => "\xED\x93\xA7",
		"\xBF\x91" => "\xED\x93\xA9",
		"\xBF\x92" => "\xED\x93\xAA",
		"\xBF\x93" => "\xED\x93\xAB",
		"\xBF\x94" => "\xED\x93\xAD",
		"\xBF\x95" => "\xED\x93\xAE",
		"\xBF\x96" => "\xED\x93\xAF",
		"\xBF\x97" => "\xED\x93\xB1",
		"\xBF\x98" => "\xED\x93\xB2",
		"\xBF\x99" => "\xED\x93\xB3",
		"\xBF\x9A" => "\xED\x93\xB4",
		"\xBF\x9B" => "\xED\x93\xB5",
		"\xBF\x9C" => "\xED\x93\xB6",
		"\xBF\x9D" => "\xED\x93\xB7",
		"\xBF\x9E" => "\xED\x93\xB9",
		"\xBF\x9F" => "\xED\x93\xBA",
		"\xBF\xA0" => "\xED\x93\xBC",
		"\xBF\xA1" => "\xEC\x97\x90",
		"\xBF\xA2" => "\xEC\x97\x91",
		"\xBF\xA3" => "\xEC\x97\x94",
		"\xBF\xA4" => "\xEC\x97\x98",
		"\xBF\xA5" => "\xEC\x97\xA0",
		"\xBF\xA6" => "\xEC\x97\xA1",
		"\xBF\xA7" => "\xEC\x97\xA3",
		"\xBF\xA8" => "\xEC\x97\xA5",
		"\xBF\xA9" => "\xEC\x97\xAC",
		"\xBF\xAA" => "\xEC\x97\xAD",
		"\xBF\xAB" => "\xEC\x97\xAE",
		"\xBF\xAC" => "\xEC\x97\xB0",
		"\xBF\xAD" => "\xEC\x97\xB4",
		"\xBF\xAE" => "\xEC\x97\xB6",
		"\xBF\xAF" => "\xEC\x97\xB7",
		"\xBF\xB0" => "\xEC\x97\xBC",
		"\xBF\xB1" => "\xEC\x97\xBD",
		"\xBF\xB2" => "\xEC\x97\xBE",
		"\xBF\xB3" => "\xEC\x97\xBF",
		"\xBF\xB4" => "\xEC\x98\x80",
		"\xBF\xB5" => "\xEC\x98\x81",
		"\xBF\xB6" => "\xEC\x98\x85",
		"\xBF\xB7" => "\xEC\x98\x86",
		"\xBF\xB8" => "\xEC\x98\x87",
		"\xBF\xB9" => "\xEC\x98\x88",
		"\xBF\xBA" => "\xEC\x98\x8C",
		"\xBF\xBB" => "\xEC\x98\x90",
		"\xBF\xBC" => "\xEC\x98\x98",
		"\xBF\xBD" => "\xEC\x98\x99",
		"\xBF\xBE" => "\xEC\x98\x9B",
		"\xBF\xBF" => "\xEC\x98\x9C",
		"\xBF\xC0" => "\xEC\x98\xA4",
		"\xBF\xC1" => "\xEC\x98\xA5",
		"\xBF\xC2" => "\xEC\x98\xA8",
		"\xBF\xC3" => "\xEC\x98\xAC",
		"\xBF\xC4" => "\xEC\x98\xAD",
		"\xBF\xC5" => "\xEC\x98\xAE",
		"\xBF\xC6" => "\xEC\x98\xB0",
		"\xBF\xC7" => "\xEC\x98\xB3",
		"\xBF\xC8" => "\xEC\x98\xB4",
		"\xBF\xC9" => "\xEC\x98\xB5",
		"\xBF\xCA" => "\xEC\x98\xB7",
		"\xBF\xCB" => "\xEC\x98\xB9",
		"\xBF\xCC" => "\xEC\x98\xBB",
		"\xBF\xCD" => "\xEC\x99\x80",
		"\xBF\xCE" => "\xEC\x99\x81",
		"\xBF\xCF" => "\xEC\x99\x84",
		"\xBF\xD0" => "\xEC\x99\x88",
		"\xBF\xD1" => "\xEC\x99\x90",
		"\xBF\xD2" => "\xEC\x99\x91",
		"\xBF\xD3" => "\xEC\x99\x93",
		"\xBF\xD4" => "\xEC\x99\x94",
		"\xBF\xD5" => "\xEC\x99\x95",
		"\xBF\xD6" => "\xEC\x99\x9C",
		"\xBF\xD7" => "\xEC\x99\x9D",
		"\xBF\xD8" => "\xEC\x99\xA0",
		"\xBF\xD9" => "\xEC\x99\xAC",
		"\xBF\xDA" => "\xEC\x99\xAF",
		"\xBF\xDB" => "\xEC\x99\xB1",
		"\xBF\xDC" => "\xEC\x99\xB8",
		"\xBF\xDD" => "\xEC\x99\xB9",
		"\xBF\xDE" => "\xEC\x99\xBC",
		"\xBF\xDF" => "\xEC\x9A\x80",
		"\xBF\xE0" => "\xEC\x9A\x88",
		"\xBF\xE1" => "\xEC\x9A\x89",
		"\xBF\xE2" => "\xEC\x9A\x8B",
		"\xBF\xE3" => "\xEC\x9A\x8D",
		"\xBF\xE4" => "\xEC\x9A\x94",
		"\xBF\xE5" => "\xEC\x9A\x95",
		"\xBF\xE6" => "\xEC\x9A\x98",
		"\xBF\xE7" => "\xEC\x9A\x9C",
		"\xBF\xE8" => "\xEC\x9A\xA4",
		"\xBF\xE9" => "\xEC\x9A\xA5",
		"\xBF\xEA" => "\xEC\x9A\xA7",
		"\xBF\xEB" => "\xEC\x9A\xA9",
		"\xBF\xEC" => "\xEC\x9A\xB0",
		"\xBF\xED" => "\xEC\x9A\xB1",
		"\xBF\xEE" => "\xEC\x9A\xB4",
		"\xBF\xEF" => "\xEC\x9A\xB8",
		"\xBF\xF0" => "\xEC\x9A\xB9",
		"\xBF\xF1" => "\xEC\x9A\xBA",
		"\xBF\xF2" => "\xEC\x9B\x80",
		"\xBF\xF3" => "\xEC\x9B\x81",
		"\xBF\xF4" => "\xEC\x9B\x83",
		"\xBF\xF5" => "\xEC\x9B\x85",
		"\xBF\xF6" => "\xEC\x9B\x8C",
		"\xBF\xF7" => "\xEC\x9B\x8D",
		"\xBF\xF8" => "\xEC\x9B\x90",
		"\xBF\xF9" => "\xEC\x9B\x94",
		"\xBF\xFA" => "\xEC\x9B\x9C",
		"\xBF\xFB" => "\xEC\x9B\x9D",
		"\xBF\xFC" => "\xEC\x9B\xA0",
		"\xBF\xFD" => "\xEC\x9B\xA1",
		"\xBF\xFE" => "\xEC\x9B\xA8",
		"\xC0\x41" => "\xED\x93\xBE",
		"\xC0\x42" => "\xED\x93\xBF",
		"\xC0\x43" => "\xED\x94\x80",
		"\xC0\x44" => "\xED\x94\x81",
		"\xC0\x45" => "\xED\x94\x82",
		"\xC0\x46" => "\xED\x94\x83",
		"\xC0\x47" => "\xED\x94\x85",
		"\xC0\x48" => "\xED\x94\x86",
		"\xC0\x49" => "\xED\x94\x87",
		"\xC0\x4A" => "\xED\x94\x89",
		"\xC0\x4B" => "\xED\x94\x8A",
		"\xC0\x4C" => "\xED\x94\x8B",
		"\xC0\x4D" => "\xED\x94\x8D",
		"\xC0\x4E" => "\xED\x94\x8E",
		"\xC0\x4F" => "\xED\x94\x8F",
		"\xC0\x50" => "\xED\x94\x90",
		"\xC0\x51" => "\xED\x94\x91",
		"\xC0\x52" => "\xED\x94\x92",
		"\xC0\x53" => "\xED\x94\x93",
		"\xC0\x54" => "\xED\x94\x96",
		"\xC0\x55" => "\xED\x94\x98",
		"\xC0\x56" => "\xED\x94\x99",
		"\xC0\x57" => "\xED\x94\x9A",
		"\xC0\x58" => "\xED\x94\x9B",
		"\xC0\x59" => "\xED\x94\x9C",
		"\xC0\x5A" => "\xED\x94\x9D",
		"\xC0\x61" => "\xED\x94\x9E",
		"\xC0\x62" => "\xED\x94\x9F",
		"\xC0\x63" => "\xED\x94\xA0",
		"\xC0\x64" => "\xED\x94\xA1",
		"\xC0\x65" => "\xED\x94\xA2",
		"\xC0\x66" => "\xED\x94\xA3",
		"\xC0\x67" => "\xED\x94\xA4",
		"\xC0\x68" => "\xED\x94\xA5",
		"\xC0\x69" => "\xED\x94\xA6",
		"\xC0\x6A" => "\xED\x94\xA7",
		"\xC0\x6B" => "\xED\x94\xA8",
		"\xC0\x6C" => "\xED\x94\xA9",
		"\xC0\x6D" => "\xED\x94\xAA",
		"\xC0\x6E" => "\xED\x94\xAB",
		"\xC0\x6F" => "\xED\x94\xAC",
		"\xC0\x70" => "\xED\x94\xAD",
		"\xC0\x71" => "\xED\x94\xAE",
		"\xC0\x72" => "\xED\x94\xAF",
		"\xC0\x73" => "\xED\x94\xB0",
		"\xC0\x74" => "\xED\x94\xB1",
		"\xC0\x75" => "\xED\x94\xB2",
		"\xC0\x76" => "\xED\x94\xB3",
		"\xC0\x77" => "\xED\x94\xB4",
		"\xC0\x78" => "\xED\x94\xB5",
		"\xC0\x79" => "\xED\x94\xB6",
		"\xC0\x7A" => "\xED\x94\xB7",
		"\xC0\x81" => "\xED\x94\xB8",
		"\xC0\x82" => "\xED\x94\xB9",
		"\xC0\x83" => "\xED\x94\xBA",
		"\xC0\x84" => "\xED\x94\xBB",
		"\xC0\x85" => "\xED\x94\xBE",
		"\xC0\x86" => "\xED\x94\xBF",
		"\xC0\x87" => "\xED\x95\x81",
		"\xC0\x88" => "\xED\x95\x82",
		"\xC0\x89" => "\xED\x95\x83",
		"\xC0\x8A" => "\xED\x95\x85",
		"\xC0\x8B" => "\xED\x95\x86",
		"\xC0\x8C" => "\xED\x95\x87",
		"\xC0\x8D" => "\xED\x95\x88",
		"\xC0\x8E" => "\xED\x95\x89",
		"\xC0\x8F" => "\xED\x95\x8A",
		"\xC0\x90" => "\xED\x95\x8B",
		"\xC0\x91" => "\xED\x95\x8E",
		"\xC0\x92" => "\xED\x95\x90",
		"\xC0\x93" => "\xED\x95\x92",
		"\xC0\x94" => "\xED\x95\x93",
		"\xC0\x95" => "\xED\x95\x94",
		"\xC0\x96" => "\xED\x95\x95",
		"\xC0\x97" => "\xED\x95\x96",
		"\xC0\x98" => "\xED\x95\x97",
		"\xC0\x99" => "\xED\x95\x9A",
		"\xC0\x9A" => "\xED\x95\x9B",
		"\xC0\x9B" => "\xED\x95\x9D",
		"\xC0\x9C" => "\xED\x95\x9E",
		"\xC0\x9D" => "\xED\x95\x9F",
		"\xC0\x9E" => "\xED\x95\xA1",
		"\xC0\x9F" => "\xED\x95\xA2",
		"\xC0\xA0" => "\xED\x95\xA3",
		"\xC0\xA1" => "\xEC\x9B\xA9",
		"\xC0\xA2" => "\xEC\x9B\xAC",
		"\xC0\xA3" => "\xEC\x9B\xB0",
		"\xC0\xA4" => "\xEC\x9B\xB8",
		"\xC0\xA5" => "\xEC\x9B\xB9",
		"\xC0\xA6" => "\xEC\x9B\xBD",
		"\xC0\xA7" => "\xEC\x9C\x84",
		"\xC0\xA8" => "\xEC\x9C\x85",
		"\xC0\xA9" => "\xEC\x9C\x88",
		"\xC0\xAA" => "\xEC\x9C\x8C",
		"\xC0\xAB" => "\xEC\x9C\x94",
		"\xC0\xAC" => "\xEC\x9C\x95",
		"\xC0\xAD" => "\xEC\x9C\x97",
		"\xC0\xAE" => "\xEC\x9C\x99",
		"\xC0\xAF" => "\xEC\x9C\xA0",
		"\xC0\xB0" => "\xEC\x9C\xA1",
		"\xC0\xB1" => "\xEC\x9C\xA4",
		"\xC0\xB2" => "\xEC\x9C\xA8",
		"\xC0\xB3" => "\xEC\x9C\xB0",
		"\xC0\xB4" => "\xEC\x9C\xB1",
		"\xC0\xB5" => "\xEC\x9C\xB3",
		"\xC0\xB6" => "\xEC\x9C\xB5",
		"\xC0\xB7" => "\xEC\x9C\xB7",
		"\xC0\xB8" => "\xEC\x9C\xBC",
		"\xC0\xB9" => "\xEC\x9C\xBD",
		"\xC0\xBA" => "\xEC\x9D\x80",
		"\xC0\xBB" => "\xEC\x9D\x84",
		"\xC0\xBC" => "\xEC\x9D\x8A",
		"\xC0\xBD" => "\xEC\x9D\x8C",
		"\xC0\xBE" => "\xEC\x9D\x8D",
		"\xC0\xBF" => "\xEC\x9D\x8F",
		"\xC0\xC0" => "\xEC\x9D\x91",
		"\xC0\xC1" => "\xEC\x9D\x92",
		"\xC0\xC2" => "\xEC\x9D\x93",
		"\xC0\xC3" => "\xEC\x9D\x94",
		"\xC0\xC4" => "\xEC\x9D\x95",
		"\xC0\xC5" => "\xEC\x9D\x96",
		"\xC0\xC6" => "\xEC\x9D\x97",
		"\xC0\xC7" => "\xEC\x9D\x98",
		"\xC0\xC8" => "\xEC\x9D\x9C",
		"\xC0\xC9" => "\xEC\x9D\xA0",
		"\xC0\xCA" => "\xEC\x9D\xA8",
		"\xC0\xCB" => "\xEC\x9D\xAB",
		"\xC0\xCC" => "\xEC\x9D\xB4",
		"\xC0\xCD" => "\xEC\x9D\xB5",
		"\xC0\xCE" => "\xEC\x9D\xB8",
		"\xC0\xCF" => "\xEC\x9D\xBC",
		"\xC0\xD0" => "\xEC\x9D\xBD",
		"\xC0\xD1" => "\xEC\x9D\xBE",
		"\xC0\xD2" => "\xEC\x9E\x83",
		"\xC0\xD3" => "\xEC\x9E\x84",
		"\xC0\xD4" => "\xEC\x9E\x85",
		"\xC0\xD5" => "\xEC\x9E\x87",
		"\xC0\xD6" => "\xEC\x9E\x88",
		"\xC0\xD7" => "\xEC\x9E\x89",
		"\xC0\xD8" => "\xEC\x9E\x8A",
		"\xC0\xD9" => "\xEC\x9E\x8E",
		"\xC0\xDA" => "\xEC\x9E\x90",
		"\xC0\xDB" => "\xEC\x9E\x91",
		"\xC0\xDC" => "\xEC\x9E\x94",
		"\xC0\xDD" => "\xEC\x9E\x96",
		"\xC0\xDE" => "\xEC\x9E\x97",
		"\xC0\xDF" => "\xEC\x9E\x98",
		"\xC0\xE0" => "\xEC\x9E\x9A",
		"\xC0\xE1" => "\xEC\x9E\xA0",
		"\xC0\xE2" => "\xEC\x9E\xA1",
		"\xC0\xE3" => "\xEC\x9E\xA3",
		"\xC0\xE4" => "\xEC\x9E\xA4",
		"\xC0\xE5" => "\xEC\x9E\xA5",
		"\xC0\xE6" => "\xEC\x9E\xA6",
		"\xC0\xE7" => "\xEC\x9E\xAC",
		"\xC0\xE8" => "\xEC\x9E\xAD",
		"\xC0\xE9" => "\xEC\x9E\xB0",
		"\xC0\xEA" => "\xEC\x9E\xB4",
		"\xC0\xEB" => "\xEC\x9E\xBC",
		"\xC0\xEC" => "\xEC\x9E\xBD",
		"\xC0\xED" => "\xEC\x9E\xBF",
		"\xC0\xEE" => "\xEC\x9F\x80",
		"\xC0\xEF" => "\xEC\x9F\x81",
		"\xC0\xF0" => "\xEC\x9F\x88",
		"\xC0\xF1" => "\xEC\x9F\x89",
		"\xC0\xF2" => "\xEC\x9F\x8C",
		"\xC0\xF3" => "\xEC\x9F\x8E",
		"\xC0\xF4" => "\xEC\x9F\x90",
		"\xC0\xF5" => "\xEC\x9F\x98",
		"\xC0\xF6" => "\xEC\x9F\x9D",
		"\xC0\xF7" => "\xEC\x9F\xA4",
		"\xC0\xF8" => "\xEC\x9F\xA8",
		"\xC0\xF9" => "\xEC\x9F\xAC",
		"\xC0\xFA" => "\xEC\xA0\x80",
		"\xC0\xFB" => "\xEC\xA0\x81",
		"\xC0\xFC" => "\xEC\xA0\x84",
		"\xC0\xFD" => "\xEC\xA0\x88",
		"\xC0\xFE" => "\xEC\xA0\x8A",
		"\xC1\x41" => "\xED\x95\xA4",
		"\xC1\x42" => "\xED\x95\xA6",
		"\xC1\x43" => "\xED\x95\xA7",
		"\xC1\x44" => "\xED\x95\xAA",
		"\xC1\x45" => "\xED\x95\xAC",
		"\xC1\x46" => "\xED\x95\xAE",
		"\xC1\x47" => "\xED\x95\xAF",
		"\xC1\x48" => "\xED\x95\xB0",
		"\xC1\x49" => "\xED\x95\xB1",
		"\xC1\x4A" => "\xED\x95\xB2",
		"\xC1\x4B" => "\xED\x95\xB3",
		"\xC1\x4C" => "\xED\x95\xB6",
		"\xC1\x4D" => "\xED\x95\xB7",
		"\xC1\x4E" => "\xED\x95\xB9",
		"\xC1\x4F" => "\xED\x95\xBA",
		"\xC1\x50" => "\xED\x95\xBB",
		"\xC1\x51" => "\xED\x95\xBD",
		"\xC1\x52" => "\xED\x95\xBE",
		"\xC1\x53" => "\xED\x95\xBF",
		"\xC1\x54" => "\xED\x96\x80",
		"\xC1\x55" => "\xED\x96\x81",
		"\xC1\x56" => "\xED\x96\x82",
		"\xC1\x57" => "\xED\x96\x83",
		"\xC1\x58" => "\xED\x96\x86",
		"\xC1\x59" => "\xED\x96\x8A",
		"\xC1\x5A" => "\xED\x96\x8B",
		"\xC1\x61" => "\xED\x96\x8C",
		"\xC1\x62" => "\xED\x96\x8D",
		"\xC1\x63" => "\xED\x96\x8E",
		"\xC1\x64" => "\xED\x96\x8F",
		"\xC1\x65" => "\xED\x96\x91",
		"\xC1\x66" => "\xED\x96\x92",
		"\xC1\x67" => "\xED\x96\x93",
		"\xC1\x68" => "\xED\x96\x94",
		"\xC1\x69" => "\xED\x96\x95",
		"\xC1\x6A" => "\xED\x96\x96",
		"\xC1\x6B" => "\xED\x96\x97",
		"\xC1\x6C" => "\xED\x96\x98",
		"\xC1\x6D" => "\xED\x96\x99",
		"\xC1\x6E" => "\xED\x96\x9A",
		"\xC1\x6F" => "\xED\x96\x9B",
		"\xC1\x70" => "\xED\x96\x9C",
		"\xC1\x71" => "\xED\x96\x9D",
		"\xC1\x72" => "\xED\x96\x9E",
		"\xC1\x73" => "\xED\x96\x9F",
		"\xC1\x74" => "\xED\x96\xA0",
		"\xC1\x75" => "\xED\x96\xA1",
		"\xC1\x76" => "\xED\x96\xA2",
		"\xC1\x77" => "\xED\x96\xA3",
		"\xC1\x78" => "\xED\x96\xA4",
		"\xC1\x79" => "\xED\x96\xA6",
		"\xC1\x7A" => "\xED\x96\xA7",
		"\xC1\x81" => "\xED\x96\xA8",
		"\xC1\x82" => "\xED\x96\xA9",
		"\xC1\x83" => "\xED\x96\xAA",
		"\xC1\x84" => "\xED\x96\xAB",
		"\xC1\x85" => "\xED\x96\xAC",
		"\xC1\x86" => "\xED\x96\xAD",
		"\xC1\x87" => "\xED\x96\xAE",
		"\xC1\x88" => "\xED\x96\xAF",
		"\xC1\x89" => "\xED\x96\xB0",
		"\xC1\x8A" => "\xED\x96\xB1",
		"\xC1\x8B" => "\xED\x96\xB2",
		"\xC1\x8C" => "\xED\x96\xB3",
		"\xC1\x8D" => "\xED\x96\xB4",
		"\xC1\x8E" => "\xED\x96\xB5",
		"\xC1\x8F" => "\xED\x96\xB6",
		"\xC1\x90" => "\xED\x96\xB7",
		"\xC1\x91" => "\xED\x96\xB8",
		"\xC1\x92" => "\xED\x96\xB9",
		"\xC1\x93" => "\xED\x96\xBA",
		"\xC1\x94" => "\xED\x96\xBB",
		"\xC1\x95" => "\xED\x96\xBC",
		"\xC1\x96" => "\xED\x96\xBD",
		"\xC1\x97" => "\xED\x96\xBE",
		"\xC1\x98" => "\xED\x96\xBF",
		"\xC1\x99" => "\xED\x97\x80",
		"\xC1\x9A" => "\xED\x97\x81",
		"\xC1\x9B" => "\xED\x97\x82",
		"\xC1\x9C" => "\xED\x97\x83",
		"\xC1\x9D" => "\xED\x97\x84",
		"\xC1\x9E" => "\xED\x97\x85",
		"\xC1\x9F" => "\xED\x97\x86",
		"\xC1\xA0" => "\xED\x97\x87",
		"\xC1\xA1" => "\xEC\xA0\x90",
		"\xC1\xA2" => "\xEC\xA0\x91",
		"\xC1\xA3" => "\xEC\xA0\x93",
		"\xC1\xA4" => "\xEC\xA0\x95",
		"\xC1\xA5" => "\xEC\xA0\x96",
		"\xC1\xA6" => "\xEC\xA0\x9C",
		"\xC1\xA7" => "\xEC\xA0\x9D",
		"\xC1\xA8" => "\xEC\xA0\xA0",
		"\xC1\xA9" => "\xEC\xA0\xA4",
		"\xC1\xAA" => "\xEC\xA0\xAC",
		"\xC1\xAB" => "\xEC\xA0\xAD",
		"\xC1\xAC" => "\xEC\xA0\xAF",
		"\xC1\xAD" => "\xEC\xA0\xB1",
		"\xC1\xAE" => "\xEC\xA0\xB8",
		"\xC1\xAF" => "\xEC\xA0\xBC",
		"\xC1\xB0" => "\xEC\xA1\x80",
		"\xC1\xB1" => "\xEC\xA1\x88",
		"\xC1\xB2" => "\xEC\xA1\x89",
		"\xC1\xB3" => "\xEC\xA1\x8C",
		"\xC1\xB4" => "\xEC\xA1\x8D",
		"\xC1\xB5" => "\xEC\xA1\x94",
		"\xC1\xB6" => "\xEC\xA1\xB0",
		"\xC1\xB7" => "\xEC\xA1\xB1",
		"\xC1\xB8" => "\xEC\xA1\xB4",
		"\xC1\xB9" => "\xEC\xA1\xB8",
		"\xC1\xBA" => "\xEC\xA1\xBA",
		"\xC1\xBB" => "\xEC\xA2\x80",
		"\xC1\xBC" => "\xEC\xA2\x81",
		"\xC1\xBD" => "\xEC\xA2\x83",
		"\xC1\xBE" => "\xEC\xA2\x85",
		"\xC1\xBF" => "\xEC\xA2\x86",
		"\xC1\xC0" => "\xEC\xA2\x87",
		"\xC1\xC1" => "\xEC\xA2\x8B",
		"\xC1\xC2" => "\xEC\xA2\x8C",
		"\xC1\xC3" => "\xEC\xA2\x8D",
		"\xC1\xC4" => "\xEC\xA2\x94",
		"\xC1\xC5" => "\xEC\xA2\x9D",
		"\xC1\xC6" => "\xEC\xA2\x9F",
		"\xC1\xC7" => "\xEC\xA2\xA1",
		"\xC1\xC8" => "\xEC\xA2\xA8",
		"\xC1\xC9" => "\xEC\xA2\xBC",
		"\xC1\xCA" => "\xEC\xA2\xBD",
		"\xC1\xCB" => "\xEC\xA3\x84",
		"\xC1\xCC" => "\xEC\xA3\x88",
		"\xC1\xCD" => "\xEC\xA3\x8C",
		"\xC1\xCE" => "\xEC\xA3\x94",
		"\xC1\xCF" => "\xEC\xA3\x95",
		"\xC1\xD0" => "\xEC\xA3\x97",
		"\xC1\xD1" => "\xEC\xA3\x99",
		"\xC1\xD2" => "\xEC\xA3\xA0",
		"\xC1\xD3" => "\xEC\xA3\xA1",
		"\xC1\xD4" => "\xEC\xA3\xA4",
		"\xC1\xD5" => "\xEC\xA3\xB5",
		"\xC1\xD6" => "\xEC\xA3\xBC",
		"\xC1\xD7" => "\xEC\xA3\xBD",
		"\xC1\xD8" => "\xEC\xA4\x80",
		"\xC1\xD9" => "\xEC\xA4\x84",
		"\xC1\xDA" => "\xEC\xA4\x85",
		"\xC1\xDB" => "\xEC\xA4\x86",
		"\xC1\xDC" => "\xEC\xA4\x8C",
		"\xC1\xDD" => "\xEC\xA4\x8D",
		"\xC1\xDE" => "\xEC\xA4\x8F",
		"\xC1\xDF" => "\xEC\xA4\x91",
		"\xC1\xE0" => "\xEC\xA4\x98",
		"\xC1\xE1" => "\xEC\xA4\xAC",
		"\xC1\xE2" => "\xEC\xA4\xB4",
		"\xC1\xE3" => "\xEC\xA5\x90",
		"\xC1\xE4" => "\xEC\xA5\x91",
		"\xC1\xE5" => "\xEC\xA5\x94",
		"\xC1\xE6" => "\xEC\xA5\x98",
		"\xC1\xE7" => "\xEC\xA5\xA0",
		"\xC1\xE8" => "\xEC\xA5\xA1",
		"\xC1\xE9" => "\xEC\xA5\xA3",
		"\xC1\xEA" => "\xEC\xA5\xAC",
		"\xC1\xEB" => "\xEC\xA5\xB0",
		"\xC1\xEC" => "\xEC\xA5\xB4",
		"\xC1\xED" => "\xEC\xA5\xBC",
		"\xC1\xEE" => "\xEC\xA6\x88",
		"\xC1\xEF" => "\xEC\xA6\x89",
		"\xC1\xF0" => "\xEC\xA6\x8C",
		"\xC1\xF1" => "\xEC\xA6\x90",
		"\xC1\xF2" => "\xEC\xA6\x98",
		"\xC1\xF3" => "\xEC\xA6\x99",
		"\xC1\xF4" => "\xEC\xA6\x9B",
		"\xC1\xF5" => "\xEC\xA6\x9D",
		"\xC1\xF6" => "\xEC\xA7\x80",
		"\xC1\xF7" => "\xEC\xA7\x81",
		"\xC1\xF8" => "\xEC\xA7\x84",
		"\xC1\xF9" => "\xEC\xA7\x87",
		"\xC1\xFA" => "\xEC\xA7\x88",
		"\xC1\xFB" => "\xEC\xA7\x8A",
		"\xC1\xFC" => "\xEC\xA7\x90",
		"\xC1\xFD" => "\xEC\xA7\x91",
		"\xC1\xFE" => "\xEC\xA7\x93",
		"\xC2\x41" => "\xED\x97\x8A",
		"\xC2\x42" => "\xED\x97\x8B",
		"\xC2\x43" => "\xED\x97\x8D",
		"\xC2\x44" => "\xED\x97\x8E",
		"\xC2\x45" => "\xED\x97\x8F",
		"\xC2\x46" => "\xED\x97\x91",
		"\xC2\x47" => "\xED\x97\x93",
		"\xC2\x48" => "\xED\x97\x94",
		"\xC2\x49" => "\xED\x97\x95",
		"\xC2\x4A" => "\xED\x97\x96",
		"\xC2\x4B" => "\xED\x97\x97",
		"\xC2\x4C" => "\xED\x97\x9A",
		"\xC2\x4D" => "\xED\x97\x9C",
		"\xC2\x4E" => "\xED\x97\x9E",
		"\xC2\x4F" => "\xED\x97\x9F",
		"\xC2\x50" => "\xED\x97\xA0",
		"\xC2\x51" => "\xED\x97\xA1",
		"\xC2\x52" => "\xED\x97\xA2",
		"\xC2\x53" => "\xED\x97\xA3",
		"\xC2\x54" => "\xED\x97\xA6",
		"\xC2\x55" => "\xED\x97\xA7",
		"\xC2\x56" => "\xED\x97\xA9",
		"\xC2\x57" => "\xED\x97\xAA",
		"\xC2\x58" => "\xED\x97\xAB",
		"\xC2\x59" => "\xED\x97\xAD",
		"\xC2\x5A" => "\xED\x97\xAE",
		"\xC2\x61" => "\xED\x97\xAF",
		"\xC2\x62" => "\xED\x97\xB0",
		"\xC2\x63" => "\xED\x97\xB1",
		"\xC2\x64" => "\xED\x97\xB2",
		"\xC2\x65" => "\xED\x97\xB3",
		"\xC2\x66" => "\xED\x97\xB6",
		"\xC2\x67" => "\xED\x97\xB8",
		"\xC2\x68" => "\xED\x97\xBA",
		"\xC2\x69" => "\xED\x97\xBB",
		"\xC2\x6A" => "\xED\x97\xBC",
		"\xC2\x6B" => "\xED\x97\xBD",
		"\xC2\x6C" => "\xED\x97\xBE",
		"\xC2\x6D" => "\xED\x97\xBF",
		"\xC2\x6E" => "\xED\x98\x82",
		"\xC2\x6F" => "\xED\x98\x83",
		"\xC2\x70" => "\xED\x98\x85",
		"\xC2\x71" => "\xED\x98\x86",
		"\xC2\x72" => "\xED\x98\x87",
		"\xC2\x73" => "\xED\x98\x89",
		"\xC2\x74" => "\xED\x98\x8A",
		"\xC2\x75" => "\xED\x98\x8B",
		"\xC2\x76" => "\xED\x98\x8C",
		"\xC2\x77" => "\xED\x98\x8D",
		"\xC2\x78" => "\xED\x98\x8E",
		"\xC2\x79" => "\xED\x98\x8F",
		"\xC2\x7A" => "\xED\x98\x92",
		"\xC2\x81" => "\xED\x98\x96",
		"\xC2\x82" => "\xED\x98\x97",
		"\xC2\x83" => "\xED\x98\x98",
		"\xC2\x84" => "\xED\x98\x99",
		"\xC2\x85" => "\xED\x98\x9A",
		"\xC2\x86" => "\xED\x98\x9B",
		"\xC2\x87" => "\xED\x98\x9D",
		"\xC2\x88" => "\xED\x98\x9E",
		"\xC2\x89" => "\xED\x98\x9F",
		"\xC2\x8A" => "\xED\x98\xA1",
		"\xC2\x8B" => "\xED\x98\xA2",
		"\xC2\x8C" => "\xED\x98\xA3",
		"\xC2\x8D" => "\xED\x98\xA5",
		"\xC2\x8E" => "\xED\x98\xA6",
		"\xC2\x8F" => "\xED\x98\xA7",
		"\xC2\x90" => "\xED\x98\xA8",
		"\xC2\x91" => "\xED\x98\xA9",
		"\xC2\x92" => "\xED\x98\xAA",
		"\xC2\x93" => "\xED\x98\xAB",
		"\xC2\x94" => "\xED\x98\xAC",
		"\xC2\x95" => "\xED\x98\xAE",
		"\xC2\x96" => "\xED\x98\xAF",
		"\xC2\x97" => "\xED\x98\xB0",
		"\xC2\x98" => "\xED\x98\xB1",
		"\xC2\x99" => "\xED\x98\xB2",
		"\xC2\x9A" => "\xED\x98\xB3",
		"\xC2\x9B" => "\xED\x98\xB4",
		"\xC2\x9C" => "\xED\x98\xB5",
		"\xC2\x9D" => "\xED\x98\xB6",
		"\xC2\x9E" => "\xED\x98\xB7",
		"\xC2\x9F" => "\xED\x98\xBA",
		"\xC2\xA0" => "\xED\x98\xBB",
		"\xC2\xA1" => "\xEC\xA7\x95",
		"\xC2\xA2" => "\xEC\xA7\x96",
		"\xC2\xA3" => "\xEC\xA7\x99",
		"\xC2\xA4" => "\xEC\xA7\x9A",
		"\xC2\xA5" => "\xEC\xA7\x9C",
		"\xC2\xA6" => "\xEC\xA7\x9D",
		"\xC2\xA7" => "\xEC\xA7\xA0",
		"\xC2\xA8" => "\xEC\xA7\xA2",
		"\xC2\xA9" => "\xEC\xA7\xA4",
		"\xC2\xAA" => "\xEC\xA7\xA7",
		"\xC2\xAB" => "\xEC\xA7\xAC",
		"\xC2\xAC" => "\xEC\xA7\xAD",
		"\xC2\xAD" => "\xEC\xA7\xAF",
		"\xC2\xAE" => "\xEC\xA7\xB0",
		"\xC2\xAF" => "\xEC\xA7\xB1",
		"\xC2\xB0" => "\xEC\xA7\xB8",
		"\xC2\xB1" => "\xEC\xA7\xB9",
		"\xC2\xB2" => "\xEC\xA7\xBC",
		"\xC2\xB3" => "\xEC\xA8\x80",
		"\xC2\xB4" => "\xEC\xA8\x88",
		"\xC2\xB5" => "\xEC\xA8\x89",
		"\xC2\xB6" => "\xEC\xA8\x8B",
		"\xC2\xB7" => "\xEC\xA8\x8C",
		"\xC2\xB8" => "\xEC\xA8\x8D",
		"\xC2\xB9" => "\xEC\xA8\x94",
		"\xC2\xBA" => "\xEC\xA8\x98",
		"\xC2\xBB" => "\xEC\xA8\xA9",
		"\xC2\xBC" => "\xEC\xA9\x8C",
		"\xC2\xBD" => "\xEC\xA9\x8D",
		"\xC2\xBE" => "\xEC\xA9\x90",
		"\xC2\xBF" => "\xEC\xA9\x94",
		"\xC2\xC0" => "\xEC\xA9\x9C",
		"\xC2\xC1" => "\xEC\xA9\x9D",
		"\xC2\xC2" => "\xEC\xA9\x9F",
		"\xC2\xC3" => "\xEC\xA9\xA0",
		"\xC2\xC4" => "\xEC\xA9\xA1",
		"\xC2\xC5" => "\xEC\xA9\xA8",
		"\xC2\xC6" => "\xEC\xA9\xBD",
		"\xC2\xC7" => "\xEC\xAA\x84",
		"\xC2\xC8" => "\xEC\xAA\x98",
		"\xC2\xC9" => "\xEC\xAA\xBC",
		"\xC2\xCA" => "\xEC\xAA\xBD",
		"\xC2\xCB" => "\xEC\xAB\x80",
		"\xC2\xCC" => "\xEC\xAB\x84",
		"\xC2\xCD" => "\xEC\xAB\x8C",
		"\xC2\xCE" => "\xEC\xAB\x8D",
		"\xC2\xCF" => "\xEC\xAB\x8F",
		"\xC2\xD0" => "\xEC\xAB\x91",
		"\xC2\xD1" => "\xEC\xAB\x93",
		"\xC2\xD2" => "\xEC\xAB\x98",
		"\xC2\xD3" => "\xEC\xAB\x99",
		"\xC2\xD4" => "\xEC\xAB\xA0",
		"\xC2\xD5" => "\xEC\xAB\xAC",
		"\xC2\xD6" => "\xEC\xAB\xB4",
		"\xC2\xD7" => "\xEC\xAC\x88",
		"\xC2\xD8" => "\xEC\xAC\x90",
		"\xC2\xD9" => "\xEC\xAC\x94",
		"\xC2\xDA" => "\xEC\xAC\x98",
		"\xC2\xDB" => "\xEC\xAC\xA0",
		"\xC2\xDC" => "\xEC\xAC\xA1",
		"\xC2\xDD" => "\xEC\xAD\x81",
		"\xC2\xDE" => "\xEC\xAD\x88",
		"\xC2\xDF" => "\xEC\xAD\x89",
		"\xC2\xE0" => "\xEC\xAD\x8C",
		"\xC2\xE1" => "\xEC\xAD\x90",
		"\xC2\xE2" => "\xEC\xAD\x98",
		"\xC2\xE3" => "\xEC\xAD\x99",
		"\xC2\xE4" => "\xEC\xAD\x9D",
		"\xC2\xE5" => "\xEC\xAD\xA4",
		"\xC2\xE6" => "\xEC\xAD\xB8",
		"\xC2\xE7" => "\xEC\xAD\xB9",
		"\xC2\xE8" => "\xEC\xAE\x9C",
		"\xC2\xE9" => "\xEC\xAE\xB8",
		"\xC2\xEA" => "\xEC\xAF\x94",
		"\xC2\xEB" => "\xEC\xAF\xA4",
		"\xC2\xEC" => "\xEC\xAF\xA7",
		"\xC2\xED" => "\xEC\xAF\xA9",
		"\xC2\xEE" => "\xEC\xB0\x8C",
		"\xC2\xEF" => "\xEC\xB0\x8D",
		"\xC2\xF0" => "\xEC\xB0\x90",
		"\xC2\xF1" => "\xEC\xB0\x94",
		"\xC2\xF2" => "\xEC\xB0\x9C",
		"\xC2\xF3" => "\xEC\xB0\x9D",
		"\xC2\xF4" => "\xEC\xB0\xA1",
		"\xC2\xF5" => "\xEC\xB0\xA2",
		"\xC2\xF6" => "\xEC\xB0\xA7",
		"\xC2\xF7" => "\xEC\xB0\xA8",
		"\xC2\xF8" => "\xEC\xB0\xA9",
		"\xC2\xF9" => "\xEC\xB0\xAC",
		"\xC2\xFA" => "\xEC\xB0\xAE",
		"\xC2\xFB" => "\xEC\xB0\xB0",
		"\xC2\xFC" => "\xEC\xB0\xB8",
		"\xC2\xFD" => "\xEC\xB0\xB9",
		"\xC2\xFE" => "\xEC\xB0\xBB",
		"\xC3\x41" => "\xED\x98\xBD",
		"\xC3\x42" => "\xED\x98\xBE",
		"\xC3\x43" => "\xED\x98\xBF",
		"\xC3\x44" => "\xED\x99\x81",
		"\xC3\x45" => "\xED\x99\x82",
		"\xC3\x46" => "\xED\x99\x83",
		"\xC3\x47" => "\xED\x99\x84",
		"\xC3\x48" => "\xED\x99\x86",
		"\xC3\x49" => "\xED\x99\x87",
		"\xC3\x4A" => "\xED\x99\x8A",
		"\xC3\x4B" => "\xED\x99\x8C",
		"\xC3\x4C" => "\xED\x99\x8E",
		"\xC3\x4D" => "\xED\x99\x8F",
		"\xC3\x4E" => "\xED\x99\x90",
		"\xC3\x4F" => "\xED\x99\x92",
		"\xC3\x50" => "\xED\x99\x93",
		"\xC3\x51" => "\xED\x99\x96",
		"\xC3\x52" => "\xED\x99\x97",
		"\xC3\x53" => "\xED\x99\x99",
		"\xC3\x54" => "\xED\x99\x9A",
		"\xC3\x55" => "\xED\x99\x9B",
		"\xC3\x56" => "\xED\x99\x9D",
		"\xC3\x57" => "\xED\x99\x9E",
		"\xC3\x58" => "\xED\x99\x9F",
		"\xC3\x59" => "\xED\x99\xA0",
		"\xC3\x5A" => "\xED\x99\xA1",
		"\xC3\x61" => "\xED\x99\xA2",
		"\xC3\x62" => "\xED\x99\xA3",
		"\xC3\x63" => "\xED\x99\xA4",
		"\xC3\x64" => "\xED\x99\xA5",
		"\xC3\x65" => "\xED\x99\xA6",
		"\xC3\x66" => "\xED\x99\xA8",
		"\xC3\x67" => "\xED\x99\xAA",
		"\xC3\x68" => "\xED\x99\xAB",
		"\xC3\x69" => "\xED\x99\xAC",
		"\xC3\x6A" => "\xED\x99\xAD",
		"\xC3\x6B" => "\xED\x99\xAE",
		"\xC3\x6C" => "\xED\x99\xAF",
		"\xC3\x6D" => "\xED\x99\xB2",
		"\xC3\x6E" => "\xED\x99\xB3",
		"\xC3\x6F" => "\xED\x99\xB5",
		"\xC3\x70" => "\xED\x99\xB6",
		"\xC3\x71" => "\xED\x99\xB7",
		"\xC3\x72" => "\xED\x99\xB8",
		"\xC3\x73" => "\xED\x99\xB9",
		"\xC3\x74" => "\xED\x99\xBA",
		"\xC3\x75" => "\xED\x99\xBB",
		"\xC3\x76" => "\xED\x99\xBC",
		"\xC3\x77" => "\xED\x99\xBD",
		"\xC3\x78" => "\xED\x99\xBE",
		"\xC3\x79" => "\xED\x99\xBF",
		"\xC3\x7A" => "\xED\x9A\x80",
		"\xC3\x81" => "\xED\x9A\x81",
		"\xC3\x82" => "\xED\x9A\x82",
		"\xC3\x83" => "\xED\x9A\x84",
		"\xC3\x84" => "\xED\x9A\x86",
		"\xC3\x85" => "\xED\x9A\x87",
		"\xC3\x86" => "\xED\x9A\x88",
		"\xC3\x87" => "\xED\x9A\x89",
		"\xC3\x88" => "\xED\x9A\x8A",
		"\xC3\x89" => "\xED\x9A\x8B",
		"\xC3\x8A" => "\xED\x9A\x8E",
		"\xC3\x8B" => "\xED\x9A\x8F",
		"\xC3\x8C" => "\xED\x9A\x91",
		"\xC3\x8D" => "\xED\x9A\x92",
		"\xC3\x8E" => "\xED\x9A\x93",
		"\xC3\x8F" => "\xED\x9A\x95",
		"\xC3\x90" => "\xED\x9A\x96",
		"\xC3\x91" => "\xED\x9A\x97",
		"\xC3\x92" => "\xED\x9A\x98",
		"\xC3\x93" => "\xED\x9A\x99",
		"\xC3\x94" => "\xED\x9A\x9A",
		"\xC3\x95" => "\xED\x9A\x9B",
		"\xC3\x96" => "\xED\x9A\x9C",
		"\xC3\x97" => "\xED\x9A\x9E",
		"\xC3\x98" => "\xED\x9A\xA0",
		"\xC3\x99" => "\xED\x9A\xA2",
		"\xC3\x9A" => "\xED\x9A\xA3",
		"\xC3\x9B" => "\xED\x9A\xA4",
		"\xC3\x9C" => "\xED\x9A\xA5",
		"\xC3\x9D" => "\xED\x9A\xA6",
		"\xC3\x9E" => "\xED\x9A\xA7",
		"\xC3\x9F" => "\xED\x9A\xA9",
		"\xC3\xA0" => "\xED\x9A\xAA",
		"\xC3\xA1" => "\xEC\xB0\xBC",
		"\xC3\xA2" => "\xEC\xB0\xBD",
		"\xC3\xA3" => "\xEC\xB0\xBE",
		"\xC3\xA4" => "\xEC\xB1\x84",
		"\xC3\xA5" => "\xEC\xB1\x85",
		"\xC3\xA6" => "\xEC\xB1\x88",
		"\xC3\xA7" => "\xEC\xB1\x8C",
		"\xC3\xA8" => "\xEC\xB1\x94",
		"\xC3\xA9" => "\xEC\xB1\x95",
		"\xC3\xAA" => "\xEC\xB1\x97",
		"\xC3\xAB" => "\xEC\xB1\x98",
		"\xC3\xAC" => "\xEC\xB1\x99",
		"\xC3\xAD" => "\xEC\xB1\xA0",
		"\xC3\xAE" => "\xEC\xB1\xA4",
		"\xC3\xAF" => "\xEC\xB1\xA6",
		"\xC3\xB0" => "\xEC\xB1\xA8",
		"\xC3\xB1" => "\xEC\xB1\xB0",
		"\xC3\xB2" => "\xEC\xB1\xB5",
		"\xC3\xB3" => "\xEC\xB2\x98",
		"\xC3\xB4" => "\xEC\xB2\x99",
		"\xC3\xB5" => "\xEC\xB2\x9C",
		"\xC3\xB6" => "\xEC\xB2\xA0",
		"\xC3\xB7" => "\xEC\xB2\xA8",
		"\xC3\xB8" => "\xEC\xB2\xA9",
		"\xC3\xB9" => "\xEC\xB2\xAB",
		"\xC3\xBA" => "\xEC\xB2\xAC",
		"\xC3\xBB" => "\xEC\xB2\xAD",
		"\xC3\xBC" => "\xEC\xB2\xB4",
		"\xC3\xBD" => "\xEC\xB2\xB5",
		"\xC3\xBE" => "\xEC\xB2\xB8",
		"\xC3\xBF" => "\xEC\xB2\xBC",
		"\xC3\xC0" => "\xEC\xB3\x84",
		"\xC3\xC1" => "\xEC\xB3\x85",
		"\xC3\xC2" => "\xEC\xB3\x87",
		"\xC3\xC3" => "\xEC\xB3\x89",
		"\xC3\xC4" => "\xEC\xB3\x90",
		"\xC3\xC5" => "\xEC\xB3\x94",
		"\xC3\xC6" => "\xEC\xB3\xA4",
		"\xC3\xC7" => "\xEC\xB3\xAC",
		"\xC3\xC8" => "\xEC\xB3\xB0",
		"\xC3\xC9" => "\xEC\xB4\x81",
		"\xC3\xCA" => "\xEC\xB4\x88",
		"\xC3\xCB" => "\xEC\xB4\x89",
		"\xC3\xCC" => "\xEC\xB4\x8C",
		"\xC3\xCD" => "\xEC\xB4\x90",
		"\xC3\xCE" => "\xEC\xB4\x98",
		"\xC3\xCF" => "\xEC\xB4\x99",
		"\xC3\xD0" => "\xEC\xB4\x9B",
		"\xC3\xD1" => "\xEC\xB4\x9D",
		"\xC3\xD2" => "\xEC\xB4\xA4",
		"\xC3\xD3" => "\xEC\xB4\xA8",
		"\xC3\xD4" => "\xEC\xB4\xAC",
		"\xC3\xD5" => "\xEC\xB4\xB9",
		"\xC3\xD6" => "\xEC\xB5\x9C",
		"\xC3\xD7" => "\xEC\xB5\xA0",
		"\xC3\xD8" => "\xEC\xB5\xA4",
		"\xC3\xD9" => "\xEC\xB5\xAC",
		"\xC3\xDA" => "\xEC\xB5\xAD",
		"\xC3\xDB" => "\xEC\xB5\xAF",
		"\xC3\xDC" => "\xEC\xB5\xB1",
		"\xC3\xDD" => "\xEC\xB5\xB8",
		"\xC3\xDE" => "\xEC\xB6\x88",
		"\xC3\xDF" => "\xEC\xB6\x94",
		"\xC3\xE0" => "\xEC\xB6\x95",
		"\xC3\xE1" => "\xEC\xB6\x98",
		"\xC3\xE2" => "\xEC\xB6\x9C",
		"\xC3\xE3" => "\xEC\xB6\xA4",
		"\xC3\xE4" => "\xEC\xB6\xA5",
		"\xC3\xE5" => "\xEC\xB6\xA7",
		"\xC3\xE6" => "\xEC\xB6\xA9",
		"\xC3\xE7" => "\xEC\xB6\xB0",
		"\xC3\xE8" => "\xEC\xB7\x84",
		"\xC3\xE9" => "\xEC\xB7\x8C",
		"\xC3\xEA" => "\xEC\xB7\x90",
		"\xC3\xEB" => "\xEC\xB7\xA8",
		"\xC3\xEC" => "\xEC\xB7\xAC",
		"\xC3\xED" => "\xEC\xB7\xB0",
		"\xC3\xEE" => "\xEC\xB7\xB8",
		"\xC3\xEF" => "\xEC\xB7\xB9",
		"\xC3\xF0" => "\xEC\xB7\xBB",
		"\xC3\xF1" => "\xEC\xB7\xBD",
		"\xC3\xF2" => "\xEC\xB8\x84",
		"\xC3\xF3" => "\xEC\xB8\x88",
		"\xC3\xF4" => "\xEC\xB8\x8C",
		"\xC3\xF5" => "\xEC\xB8\x94",
		"\xC3\xF6" => "\xEC\xB8\x99",
		"\xC3\xF7" => "\xEC\xB8\xA0",
		"\xC3\xF8" => "\xEC\xB8\xA1",
		"\xC3\xF9" => "\xEC\xB8\xA4",
		"\xC3\xFA" => "\xEC\xB8\xA8",
		"\xC3\xFB" => "\xEC\xB8\xB0",
		"\xC3\xFC" => "\xEC\xB8\xB1",
		"\xC3\xFD" => "\xEC\xB8\xB3",
		"\xC3\xFE" => "\xEC\xB8\xB5",
		"\xC4\x41" => "\xED\x9A\xAB",
		"\xC4\x42" => "\xED\x9A\xAD",
		"\xC4\x43" => "\xED\x9A\xAE",
		"\xC4\x44" => "\xED\x9A\xAF",
		"\xC4\x45" => "\xED\x9A\xB1",
		"\xC4\x46" => "\xED\x9A\xB2",
		"\xC4\x47" => "\xED\x9A\xB3",
		"\xC4\x48" => "\xED\x9A\xB4",
		"\xC4\x49" => "\xED\x9A\xB5",
		"\xC4\x4A" => "\xED\x9A\xB6",
		"\xC4\x4B" => "\xED\x9A\xB7",
		"\xC4\x4C" => "\xED\x9A\xB8",
		"\xC4\x4D" => "\xED\x9A\xBA",
		"\xC4\x4E" => "\xED\x9A\xBC",
		"\xC4\x4F" => "\xED\x9A\xBD",
		"\xC4\x50" => "\xED\x9A\xBE",
		"\xC4\x51" => "\xED\x9A\xBF",
		"\xC4\x52" => "\xED\x9B\x80",
		"\xC4\x53" => "\xED\x9B\x81",
		"\xC4\x54" => "\xED\x9B\x82",
		"\xC4\x55" => "\xED\x9B\x83",
		"\xC4\x56" => "\xED\x9B\x86",
		"\xC4\x57" => "\xED\x9B\x87",
		"\xC4\x58" => "\xED\x9B\x89",
		"\xC4\x59" => "\xED\x9B\x8A",
		"\xC4\x5A" => "\xED\x9B\x8B",
		"\xC4\x61" => "\xED\x9B\x8D",
		"\xC4\x62" => "\xED\x9B\x8E",
		"\xC4\x63" => "\xED\x9B\x8F",
		"\xC4\x64" => "\xED\x9B\x90",
		"\xC4\x65" => "\xED\x9B\x92",
		"\xC4\x66" => "\xED\x9B\x93",
		"\xC4\x67" => "\xED\x9B\x95",
		"\xC4\x68" => "\xED\x9B\x96",
		"\xC4\x69" => "\xED\x9B\x98",
		"\xC4\x6A" => "\xED\x9B\x9A",
		"\xC4\x6B" => "\xED\x9B\x9B",
		"\xC4\x6C" => "\xED\x9B\x9C",
		"\xC4\x6D" => "\xED\x9B\x9D",
		"\xC4\x6E" => "\xED\x9B\x9E",
		"\xC4\x6F" => "\xED\x9B\x9F",
		"\xC4\x70" => "\xED\x9B\xA1",
		"\xC4\x71" => "\xED\x9B\xA2",
		"\xC4\x72" => "\xED\x9B\xA3",
		"\xC4\x73" => "\xED\x9B\xA5",
		"\xC4\x74" => "\xED\x9B\xA6",
		"\xC4\x75" => "\xED\x9B\xA7",
		"\xC4\x76" => "\xED\x9B\xA9",
		"\xC4\x77" => "\xED\x9B\xAA",
		"\xC4\x78" => "\xED\x9B\xAB",
		"\xC4\x79" => "\xED\x9B\xAC",
		"\xC4\x7A" => "\xED\x9B\xAD",
		"\xC4\x81" => "\xED\x9B\xAE",
		"\xC4\x82" => "\xED\x9B\xAF",
		"\xC4\x83" => "\xED\x9B\xB1",
		"\xC4\x84" => "\xED\x9B\xB2",
		"\xC4\x85" => "\xED\x9B\xB3",
		"\xC4\x86" => "\xED\x9B\xB4",
		"\xC4\x87" => "\xED\x9B\xB6",
		"\xC4\x88" => "\xED\x9B\xB7",
		"\xC4\x89" => "\xED\x9B\xB8",
		"\xC4\x8A" => "\xED\x9B\xB9",
		"\xC4\x8B" => "\xED\x9B\xBA",
		"\xC4\x8C" => "\xED\x9B\xBB",
		"\xC4\x8D" => "\xED\x9B\xBE",
		"\xC4\x8E" => "\xED\x9B\xBF",
		"\xC4\x8F" => "\xED\x9C\x81",
		"\xC4\x90" => "\xED\x9C\x82",
		"\xC4\x91" => "\xED\x9C\x83",
		"\xC4\x92" => "\xED\x9C\x85",
		"\xC4\x93" => "\xED\x9C\x86",
		"\xC4\x94" => "\xED\x9C\x87",
		"\xC4\x95" => "\xED\x9C\x88",
		"\xC4\x96" => "\xED\x9C\x89",
		"\xC4\x97" => "\xED\x9C\x8A",
		"\xC4\x98" => "\xED\x9C\x8B",
		"\xC4\x99" => "\xED\x9C\x8C",
		"\xC4\x9A" => "\xED\x9C\x8D",
		"\xC4\x9B" => "\xED\x9C\x8E",
		"\xC4\x9C" => "\xED\x9C\x8F",
		"\xC4\x9D" => "\xED\x9C\x90",
		"\xC4\x9E" => "\xED\x9C\x92",
		"\xC4\x9F" => "\xED\x9C\x93",
		"\xC4\xA0" => "\xED\x9C\x94",
		"\xC4\xA1" => "\xEC\xB9\x98",
		"\xC4\xA2" => "\xEC\xB9\x99",
		"\xC4\xA3" => "\xEC\xB9\x9C",
		"\xC4\xA4" => "\xEC\xB9\x9F",
		"\xC4\xA5" => "\xEC\xB9\xA0",
		"\xC4\xA6" => "\xEC\xB9\xA1",
		"\xC4\xA7" => "\xEC\xB9\xA8",
		"\xC4\xA8" => "\xEC\xB9\xA9",
		"\xC4\xA9" => "\xEC\xB9\xAB",
		"\xC4\xAA" => "\xEC\xB9\xAD",
		"\xC4\xAB" => "\xEC\xB9\xB4",
		"\xC4\xAC" => "\xEC\xB9\xB5",
		"\xC4\xAD" => "\xEC\xB9\xB8",
		"\xC4\xAE" => "\xEC\xB9\xBC",
		"\xC4\xAF" => "\xEC\xBA\x84",
		"\xC4\xB0" => "\xEC\xBA\x85",
		"\xC4\xB1" => "\xEC\xBA\x87",
		"\xC4\xB2" => "\xEC\xBA\x89",
		"\xC4\xB3" => "\xEC\xBA\x90",
		"\xC4\xB4" => "\xEC\xBA\x91",
		"\xC4\xB5" => "\xEC\xBA\x94",
		"\xC4\xB6" => "\xEC\xBA\x98",
		"\xC4\xB7" => "\xEC\xBA\xA0",
		"\xC4\xB8" => "\xEC\xBA\xA1",
		"\xC4\xB9" => "\xEC\xBA\xA3",
		"\xC4\xBA" => "\xEC\xBA\xA4",
		"\xC4\xBB" => "\xEC\xBA\xA5",
		"\xC4\xBC" => "\xEC\xBA\xAC",
		"\xC4\xBD" => "\xEC\xBA\xAD",
		"\xC4\xBE" => "\xEC\xBB\x81",
		"\xC4\xBF" => "\xEC\xBB\xA4",
		"\xC4\xC0" => "\xEC\xBB\xA5",
		"\xC4\xC1" => "\xEC\xBB\xA8",
		"\xC4\xC2" => "\xEC\xBB\xAB",
		"\xC4\xC3" => "\xEC\xBB\xAC",
		"\xC4\xC4" => "\xEC\xBB\xB4",
		"\xC4\xC5" => "\xEC\xBB\xB5",
		"\xC4\xC6" => "\xEC\xBB\xB7",
		"\xC4\xC7" => "\xEC\xBB\xB8",
		"\xC4\xC8" => "\xEC\xBB\xB9",
		"\xC4\xC9" => "\xEC\xBC\x80",
		"\xC4\xCA" => "\xEC\xBC\x81",
		"\xC4\xCB" => "\xEC\xBC\x84",
		"\xC4\xCC" => "\xEC\xBC\x88",
		"\xC4\xCD" => "\xEC\xBC\x90",
		"\xC4\xCE" => "\xEC\xBC\x91",
		"\xC4\xCF" => "\xEC\xBC\x93",
		"\xC4\xD0" => "\xEC\xBC\x95",
		"\xC4\xD1" => "\xEC\xBC\x9C",
		"\xC4\xD2" => "\xEC\xBC\xA0",
		"\xC4\xD3" => "\xEC\xBC\xA4",
		"\xC4\xD4" => "\xEC\xBC\xAC",
		"\xC4\xD5" => "\xEC\xBC\xAD",
		"\xC4\xD6" => "\xEC\xBC\xAF",
		"\xC4\xD7" => "\xEC\xBC\xB0",
		"\xC4\xD8" => "\xEC\xBC\xB1",
		"\xC4\xD9" => "\xEC\xBC\xB8",
		"\xC4\xDA" => "\xEC\xBD\x94",
		"\xC4\xDB" => "\xEC\xBD\x95",
		"\xC4\xDC" => "\xEC\xBD\x98",
		"\xC4\xDD" => "\xEC\xBD\x9C",
		"\xC4\xDE" => "\xEC\xBD\xA4",
		"\xC4\xDF" => "\xEC\xBD\xA5",
		"\xC4\xE0" => "\xEC\xBD\xA7",
		"\xC4\xE1" => "\xEC\xBD\xA9",
		"\xC4\xE2" => "\xEC\xBD\xB0",
		"\xC4\xE3" => "\xEC\xBD\xB1",
		"\xC4\xE4" => "\xEC\xBD\xB4",
		"\xC4\xE5" => "\xEC\xBD\xB8",
		"\xC4\xE6" => "\xEC\xBE\x80",
		"\xC4\xE7" => "\xEC\xBE\x85",
		"\xC4\xE8" => "\xEC\xBE\x8C",
		"\xC4\xE9" => "\xEC\xBE\xA1",
		"\xC4\xEA" => "\xEC\xBE\xA8",
		"\xC4\xEB" => "\xEC\xBE\xB0",
		"\xC4\xEC" => "\xEC\xBF\x84",
		"\xC4\xED" => "\xEC\xBF\xA0",
		"\xC4\xEE" => "\xEC\xBF\xA1",
		"\xC4\xEF" => "\xEC\xBF\xA4",
		"\xC4\xF0" => "\xEC\xBF\xA8",
		"\xC4\xF1" => "\xEC\xBF\xB0",
		"\xC4\xF2" => "\xEC\xBF\xB1",
		"\xC4\xF3" => "\xEC\xBF\xB3",
		"\xC4\xF4" => "\xEC\xBF\xB5",
		"\xC4\xF5" => "\xEC\xBF\xBC",
		"\xC4\xF6" => "\xED\x80\x80",
		"\xC4\xF7" => "\xED\x80\x84",
		"\xC4\xF8" => "\xED\x80\x91",
		"\xC4\xF9" => "\xED\x80\x98",
		"\xC4\xFA" => "\xED\x80\xAD",
		"\xC4\xFB" => "\xED\x80\xB4",
		"\xC4\xFC" => "\xED\x80\xB5",
		"\xC4\xFD" => "\xED\x80\xB8",
		"\xC4\xFE" => "\xED\x80\xBC",
		"\xC5\x41" => "\xED\x9C\x95",
		"\xC5\x42" => "\xED\x9C\x96",
		"\xC5\x43" => "\xED\x9C\x97",
		"\xC5\x44" => "\xED\x9C\x9A",
		"\xC5\x45" => "\xED\x9C\x9B",
		"\xC5\x46" => "\xED\x9C\x9D",
		"\xC5\x47" => "\xED\x9C\x9E",
		"\xC5\x48" => "\xED\x9C\x9F",
		"\xC5\x49" => "\xED\x9C\xA1",
		"\xC5\x4A" => "\xED\x9C\xA2",
		"\xC5\x4B" => "\xED\x9C\xA3",
		"\xC5\x4C" => "\xED\x9C\xA4",
		"\xC5\x4D" => "\xED\x9C\xA5",
		"\xC5\x4E" => "\xED\x9C\xA6",
		"\xC5\x4F" => "\xED\x9C\xA7",
		"\xC5\x50" => "\xED\x9C\xAA",
		"\xC5\x51" => "\xED\x9C\xAC",
		"\xC5\x52" => "\xED\x9C\xAE",
		"\xC5\x53" => "\xED\x9C\xAF",
		"\xC5\x54" => "\xED\x9C\xB0",
		"\xC5\x55" => "\xED\x9C\xB1",
		"\xC5\x56" => "\xED\x9C\xB2",
		"\xC5\x57" => "\xED\x9C\xB3",
		"\xC5\x58" => "\xED\x9C\xB6",
		"\xC5\x59" => "\xED\x9C\xB7",
		"\xC5\x5A" => "\xED\x9C\xB9",
		"\xC5\x61" => "\xED\x9C\xBA",
		"\xC5\x62" => "\xED\x9C\xBB",
		"\xC5\x63" => "\xED\x9C\xBD",
		"\xC5\x64" => "\xED\x9C\xBE",
		"\xC5\x65" => "\xED\x9C\xBF",
		"\xC5\x66" => "\xED\x9D\x80",
		"\xC5\x67" => "\xED\x9D\x81",
		"\xC5\x68" => "\xED\x9D\x82",
		"\xC5\x69" => "\xED\x9D\x83",
		"\xC5\x6A" => "\xED\x9D\x85",
		"\xC5\x6B" => "\xED\x9D\x86",
		"\xC5\x6C" => "\xED\x9D\x88",
		"\xC5\x6D" => "\xED\x9D\x8A",
		"\xC5\x6E" => "\xED\x9D\x8B",
		"\xC5\x6F" => "\xED\x9D\x8C",
		"\xC5\x70" => "\xED\x9D\x8D",
		"\xC5\x71" => "\xED\x9D\x8E",
		"\xC5\x72" => "\xED\x9D\x8F",
		"\xC5\x73" => "\xED\x9D\x92",
		"\xC5\x74" => "\xED\x9D\x93",
		"\xC5\x75" => "\xED\x9D\x95",
		"\xC5\x76" => "\xED\x9D\x9A",
		"\xC5\x77" => "\xED\x9D\x9B",
		"\xC5\x78" => "\xED\x9D\x9C",
		"\xC5\x79" => "\xED\x9D\x9D",
		"\xC5\x7A" => "\xED\x9D\x9E",
		"\xC5\x81" => "\xED\x9D\x9F",
		"\xC5\x82" => "\xED\x9D\xA2",
		"\xC5\x83" => "\xED\x9D\xA4",
		"\xC5\x84" => "\xED\x9D\xA6",
		"\xC5\x85" => "\xED\x9D\xA7",
		"\xC5\x86" => "\xED\x9D\xA8",
		"\xC5\x87" => "\xED\x9D\xAA",
		"\xC5\x88" => "\xED\x9D\xAB",
		"\xC5\x89" => "\xED\x9D\xAD",
		"\xC5\x8A" => "\xED\x9D\xAE",
		"\xC5\x8B" => "\xED\x9D\xAF",
		"\xC5\x8C" => "\xED\x9D\xB1",
		"\xC5\x8D" => "\xED\x9D\xB2",
		"\xC5\x8E" => "\xED\x9D\xB3",
		"\xC5\x8F" => "\xED\x9D\xB5",
		"\xC5\x90" => "\xED\x9D\xB6",
		"\xC5\x91" => "\xED\x9D\xB7",
		"\xC5\x92" => "\xED\x9D\xB8",
		"\xC5\x93" => "\xED\x9D\xB9",
		"\xC5\x94" => "\xED\x9D\xBA",
		"\xC5\x95" => "\xED\x9D\xBB",
		"\xC5\x96" => "\xED\x9D\xBE",
		"\xC5\x97" => "\xED\x9D\xBF",
		"\xC5\x98" => "\xED\x9E\x80",
		"\xC5\x99" => "\xED\x9E\x82",
		"\xC5\x9A" => "\xED\x9E\x83",
		"\xC5\x9B" => "\xED\x9E\x84",
		"\xC5\x9C" => "\xED\x9E\x85",
		"\xC5\x9D" => "\xED\x9E\x86",
		"\xC5\x9E" => "\xED\x9E\x87",
		"\xC5\x9F" => "\xED\x9E\x8A",
		"\xC5\xA0" => "\xED\x9E\x8B",
		"\xC5\xA1" => "\xED\x81\x84",
		"\xC5\xA2" => "\xED\x81\x85",
		"\xC5\xA3" => "\xED\x81\x87",
		"\xC5\xA4" => "\xED\x81\x89",
		"\xC5\xA5" => "\xED\x81\x90",
		"\xC5\xA6" => "\xED\x81\x94",
		"\xC5\xA7" => "\xED\x81\x98",
		"\xC5\xA8" => "\xED\x81\xA0",
		"\xC5\xA9" => "\xED\x81\xAC",
		"\xC5\xAA" => "\xED\x81\xAD",
		"\xC5\xAB" => "\xED\x81\xB0",
		"\xC5\xAC" => "\xED\x81\xB4",
		"\xC5\xAD" => "\xED\x81\xBC",
		"\xC5\xAE" => "\xED\x81\xBD",
		"\xC5\xAF" => "\xED\x82\x81",
		"\xC5\xB0" => "\xED\x82\xA4",
		"\xC5\xB1" => "\xED\x82\xA5",
		"\xC5\xB2" => "\xED\x82\xA8",
		"\xC5\xB3" => "\xED\x82\xAC",
		"\xC5\xB4" => "\xED\x82\xB4",
		"\xC5\xB5" => "\xED\x82\xB5",
		"\xC5\xB6" => "\xED\x82\xB7",
		"\xC5\xB7" => "\xED\x82\xB9",
		"\xC5\xB8" => "\xED\x83\x80",
		"\xC5\xB9" => "\xED\x83\x81",
		"\xC5\xBA" => "\xED\x83\x84",
		"\xC5\xBB" => "\xED\x83\x88",
		"\xC5\xBC" => "\xED\x83\x89",
		"\xC5\xBD" => "\xED\x83\x90",
		"\xC5\xBE" => "\xED\x83\x91",
		"\xC5\xBF" => "\xED\x83\x93",
		"\xC5\xC0" => "\xED\x83\x94",
		"\xC5\xC1" => "\xED\x83\x95",
		"\xC5\xC2" => "\xED\x83\x9C",
		"\xC5\xC3" => "\xED\x83\x9D",
		"\xC5\xC4" => "\xED\x83\xA0",
		"\xC5\xC5" => "\xED\x83\xA4",
		"\xC5\xC6" => "\xED\x83\xAC",
		"\xC5\xC7" => "\xED\x83\xAD",
		"\xC5\xC8" => "\xED\x83\xAF",
		"\xC5\xC9" => "\xED\x83\xB0",
		"\xC5\xCA" => "\xED\x83\xB1",
		"\xC5\xCB" => "\xED\x83\xB8",
		"\xC5\xCC" => "\xED\x84\x8D",
		"\xC5\xCD" => "\xED\x84\xB0",
		"\xC5\xCE" => "\xED\x84\xB1",
		"\xC5\xCF" => "\xED\x84\xB4",
		"\xC5\xD0" => "\xED\x84\xB8",
		"\xC5\xD1" => "\xED\x84\xBA",
		"\xC5\xD2" => "\xED\x85\x80",
		"\xC5\xD3" => "\xED\x85\x81",
		"\xC5\xD4" => "\xED\x85\x83",
		"\xC5\xD5" => "\xED\x85\x84",
		"\xC5\xD6" => "\xED\x85\x85",
		"\xC5\xD7" => "\xED\x85\x8C",
		"\xC5\xD8" => "\xED\x85\x8D",
		"\xC5\xD9" => "\xED\x85\x90",
		"\xC5\xDA" => "\xED\x85\x94",
		"\xC5\xDB" => "\xED\x85\x9C",
		"\xC5\xDC" => "\xED\x85\x9D",
		"\xC5\xDD" => "\xED\x85\x9F",
		"\xC5\xDE" => "\xED\x85\xA1",
		"\xC5\xDF" => "\xED\x85\xA8",
		"\xC5\xE0" => "\xED\x85\xAC",
		"\xC5\xE1" => "\xED\x85\xBC",
		"\xC5\xE2" => "\xED\x86\x84",
		"\xC5\xE3" => "\xED\x86\x88",
		"\xC5\xE4" => "\xED\x86\xA0",
		"\xC5\xE5" => "\xED\x86\xA1",
		"\xC5\xE6" => "\xED\x86\xA4",
		"\xC5\xE7" => "\xED\x86\xA8",
		"\xC5\xE8" => "\xED\x86\xB0",
		"\xC5\xE9" => "\xED\x86\xB1",
		"\xC5\xEA" => "\xED\x86\xB3",
		"\xC5\xEB" => "\xED\x86\xB5",
		"\xC5\xEC" => "\xED\x86\xBA",
		"\xC5\xED" => "\xED\x86\xBC",
		"\xC5\xEE" => "\xED\x87\x80",
		"\xC5\xEF" => "\xED\x87\x98",
		"\xC5\xF0" => "\xED\x87\xB4",
		"\xC5\xF1" => "\xED\x87\xB8",
		"\xC5\xF2" => "\xED\x88\x87",
		"\xC5\xF3" => "\xED\x88\x89",
		"\xC5\xF4" => "\xED\x88\x90",
		"\xC5\xF5" => "\xED\x88\xAC",
		"\xC5\xF6" => "\xED\x88\xAD",
		"\xC5\xF7" => "\xED\x88\xB0",
		"\xC5\xF8" => "\xED\x88\xB4",
		"\xC5\xF9" => "\xED\x88\xBC",
		"\xC5\xFA" => "\xED\x88\xBD",
		"\xC5\xFB" => "\xED\x88\xBF",
		"\xC5\xFC" => "\xED\x89\x81",
		"\xC5\xFD" => "\xED\x89\x88",
		"\xC5\xFE" => "\xED\x89\x9C",
		"\xC6\x41" => "\xED\x9E\x8D",
		"\xC6\x42" => "\xED\x9E\x8E",
		"\xC6\x43" => "\xED\x9E\x8F",
		"\xC6\x44" => "\xED\x9E\x91",
		"\xC6\x45" => "\xED\x9E\x92",
		"\xC6\x46" => "\xED\x9E\x93",
		"\xC6\x47" => "\xED\x9E\x94",
		"\xC6\x48" => "\xED\x9E\x95",
		"\xC6\x49" => "\xED\x9E\x96",
		"\xC6\x4A" => "\xED\x9E\x97",
		"\xC6\x4B" => "\xED\x9E\x9A",
		"\xC6\x4C" => "\xED\x9E\x9C",
		"\xC6\x4D" => "\xED\x9E\x9E",
		"\xC6\x4E" => "\xED\x9E\x9F",
		"\xC6\x4F" => "\xED\x9E\xA0",
		"\xC6\x50" => "\xED\x9E\xA1",
		"\xC6\x51" => "\xED\x9E\xA2",
		"\xC6\x52" => "\xED\x9E\xA3",
		"\xC6\xA1" => "\xED\x89\xA4",
		"\xC6\xA2" => "\xED\x8A\x80",
		"\xC6\xA3" => "\xED\x8A\x81",
		"\xC6\xA4" => "\xED\x8A\x84",
		"\xC6\xA5" => "\xED\x8A\x88",
		"\xC6\xA6" => "\xED\x8A\x90",
		"\xC6\xA7" => "\xED\x8A\x91",
		"\xC6\xA8" => "\xED\x8A\x95",
		"\xC6\xA9" => "\xED\x8A\x9C",
		"\xC6\xAA" => "\xED\x8A\xA0",
		"\xC6\xAB" => "\xED\x8A\xA4",
		"\xC6\xAC" => "\xED\x8A\xAC",
		"\xC6\xAD" => "\xED\x8A\xB1",
		"\xC6\xAE" => "\xED\x8A\xB8",
		"\xC6\xAF" => "\xED\x8A\xB9",
		"\xC6\xB0" => "\xED\x8A\xBC",
		"\xC6\xB1" => "\xED\x8A\xBF",
		"\xC6\xB2" => "\xED\x8B\x80",
		"\xC6\xB3" => "\xED\x8B\x82",
		"\xC6\xB4" => "\xED\x8B\x88",
		"\xC6\xB5" => "\xED\x8B\x89",
		"\xC6\xB6" => "\xED\x8B\x8B",
		"\xC6\xB7" => "\xED\x8B\x94",
		"\xC6\xB8" => "\xED\x8B\x98",
		"\xC6\xB9" => "\xED\x8B\x9C",
		"\xC6\xBA" => "\xED\x8B\xA4",
		"\xC6\xBB" => "\xED\x8B\xA5",
		"\xC6\xBC" => "\xED\x8B\xB0",
		"\xC6\xBD" => "\xED\x8B\xB1",
		"\xC6\xBE" => "\xED\x8B\xB4",
		"\xC6\xBF" => "\xED\x8B\xB8",
		"\xC6\xC0" => "\xED\x8C\x80",
		"\xC6\xC1" => "\xED\x8C\x81",
		"\xC6\xC2" => "\xED\x8C\x83",
		"\xC6\xC3" => "\xED\x8C\x85",
		"\xC6\xC4" => "\xED\x8C\x8C",
		"\xC6\xC5" => "\xED\x8C\x8D",
		"\xC6\xC6" => "\xED\x8C\x8E",
		"\xC6\xC7" => "\xED\x8C\x90",
		"\xC6\xC8" => "\xED\x8C\x94",
		"\xC6\xC9" => "\xED\x8C\x96",
		"\xC6\xCA" => "\xED\x8C\x9C",
		"\xC6\xCB" => "\xED\x8C\x9D",
		"\xC6\xCC" => "\xED\x8C\x9F",
		"\xC6\xCD" => "\xED\x8C\xA0",
		"\xC6\xCE" => "\xED\x8C\xA1",
		"\xC6\xCF" => "\xED\x8C\xA5",
		"\xC6\xD0" => "\xED\x8C\xA8",
		"\xC6\xD1" => "\xED\x8C\xA9",
		"\xC6\xD2" => "\xED\x8C\xAC",
		"\xC6\xD3" => "\xED\x8C\xB0",
		"\xC6\xD4" => "\xED\x8C\xB8",
		"\xC6\xD5" => "\xED\x8C\xB9",
		"\xC6\xD6" => "\xED\x8C\xBB",
		"\xC6\xD7" => "\xED\x8C\xBC",
		"\xC6\xD8" => "\xED\x8C\xBD",
		"\xC6\xD9" => "\xED\x8D\x84",
		"\xC6\xDA" => "\xED\x8D\x85",
		"\xC6\xDB" => "\xED\x8D\xBC",
		"\xC6\xDC" => "\xED\x8D\xBD",
		"\xC6\xDD" => "\xED\x8E\x80",
		"\xC6\xDE" => "\xED\x8E\x84",
		"\xC6\xDF" => "\xED\x8E\x8C",
		"\xC6\xE0" => "\xED\x8E\x8D",
		"\xC6\xE1" => "\xED\x8E\x8F",
		"\xC6\xE2" => "\xED\x8E\x90",
		"\xC6\xE3" => "\xED\x8E\x91",
		"\xC6\xE4" => "\xED\x8E\x98",
		"\xC6\xE5" => "\xED\x8E\x99",
		"\xC6\xE6" => "\xED\x8E\x9C",
		"\xC6\xE7" => "\xED\x8E\xA0",
		"\xC6\xE8" => "\xED\x8E\xA8",
		"\xC6\xE9" => "\xED\x8E\xA9",
		"\xC6\xEA" => "\xED\x8E\xAB",
		"\xC6\xEB" => "\xED\x8E\xAD",
		"\xC6\xEC" => "\xED\x8E\xB4",
		"\xC6\xED" => "\xED\x8E\xB8",
		"\xC6\xEE" => "\xED\x8E\xBC",
		"\xC6\xEF" => "\xED\x8F\x84",
		"\xC6\xF0" => "\xED\x8F\x85",
		"\xC6\xF1" => "\xED\x8F\x88",
		"\xC6\xF2" => "\xED\x8F\x89",
		"\xC6\xF3" => "\xED\x8F\x90",
		"\xC6\xF4" => "\xED\x8F\x98",
		"\xC6\xF5" => "\xED\x8F\xA1",
		"\xC6\xF6" => "\xED\x8F\xA3",
		"\xC6\xF7" => "\xED\x8F\xAC",
		"\xC6\xF8" => "\xED\x8F\xAD",
		"\xC6\xF9" => "\xED\x8F\xB0",
		"\xC6\xFA" => "\xED\x8F\xB4",
		"\xC6\xFB" => "\xED\x8F\xBC",
		"\xC6\xFC" => "\xED\x8F\xBD",
		"\xC6\xFD" => "\xED\x8F\xBF",
		"\xC6\xFE" => "\xED\x90\x81",
		"\xC7\xA1" => "\xED\x90\x88",
		"\xC7\xA2" => "\xED\x90\x9D",
		"\xC7\xA3" => "\xED\x91\x80",
		"\xC7\xA4" => "\xED\x91\x84",
		"\xC7\xA5" => "\xED\x91\x9C",
		"\xC7\xA6" => "\xED\x91\xA0",
		"\xC7\xA7" => "\xED\x91\xA4",
		"\xC7\xA8" => "\xED\x91\xAD",
		"\xC7\xA9" => "\xED\x91\xAF",
		"\xC7\xAA" => "\xED\x91\xB8",
		"\xC7\xAB" => "\xED\x91\xB9",
		"\xC7\xAC" => "\xED\x91\xBC",
		"\xC7\xAD" => "\xED\x91\xBF",
		"\xC7\xAE" => "\xED\x92\x80",
		"\xC7\xAF" => "\xED\x92\x82",
		"\xC7\xB0" => "\xED\x92\x88",
		"\xC7\xB1" => "\xED\x92\x89",
		"\xC7\xB2" => "\xED\x92\x8B",
		"\xC7\xB3" => "\xED\x92\x8D",
		"\xC7\xB4" => "\xED\x92\x94",
		"\xC7\xB5" => "\xED\x92\xA9",
		"\xC7\xB6" => "\xED\x93\x8C",
		"\xC7\xB7" => "\xED\x93\x90",
		"\xC7\xB8" => "\xED\x93\x94",
		"\xC7\xB9" => "\xED\x93\x9C",
		"\xC7\xBA" => "\xED\x93\x9F",
		"\xC7\xBB" => "\xED\x93\xA8",
		"\xC7\xBC" => "\xED\x93\xAC",
		"\xC7\xBD" => "\xED\x93\xB0",
		"\xC7\xBE" => "\xED\x93\xB8",
		"\xC7\xBF" => "\xED\x93\xBB",
		"\xC7\xC0" => "\xED\x93\xBD",
		"\xC7\xC1" => "\xED\x94\x84",
		"\xC7\xC2" => "\xED\x94\x88",
		"\xC7\xC3" => "\xED\x94\x8C",
		"\xC7\xC4" => "\xED\x94\x94",
		"\xC7\xC5" => "\xED\x94\x95",
		"\xC7\xC6" => "\xED\x94\x97",
		"\xC7\xC7" => "\xED\x94\xBC",
		"\xC7\xC8" => "\xED\x94\xBD",
		"\xC7\xC9" => "\xED\x95\x80",
		"\xC7\xCA" => "\xED\x95\x84",
		"\xC7\xCB" => "\xED\x95\x8C",
		"\xC7\xCC" => "\xED\x95\x8D",
		"\xC7\xCD" => "\xED\x95\x8F",
		"\xC7\xCE" => "\xED\x95\x91",
		"\xC7\xCF" => "\xED\x95\x98",
		"\xC7\xD0" => "\xED\x95\x99",
		"\xC7\xD1" => "\xED\x95\x9C",
		"\xC7\xD2" => "\xED\x95\xA0",
		"\xC7\xD3" => "\xED\x95\xA5",
		"\xC7\xD4" => "\xED\x95\xA8",
		"\xC7\xD5" => "\xED\x95\xA9",
		"\xC7\xD6" => "\xED\x95\xAB",
		"\xC7\xD7" => "\xED\x95\xAD",
		"\xC7\xD8" => "\xED\x95\xB4",
		"\xC7\xD9" => "\xED\x95\xB5",
		"\xC7\xDA" => "\xED\x95\xB8",
		"\xC7\xDB" => "\xED\x95\xBC",
		"\xC7\xDC" => "\xED\x96\x84",
		"\xC7\xDD" => "\xED\x96\x85",
		"\xC7\xDE" => "\xED\x96\x87",
		"\xC7\xDF" => "\xED\x96\x88",
		"\xC7\xE0" => "\xED\x96\x89",
		"\xC7\xE1" => "\xED\x96\x90",
		"\xC7\xE2" => "\xED\x96\xA5",
		"\xC7\xE3" => "\xED\x97\x88",
		"\xC7\xE4" => "\xED\x97\x89",
		"\xC7\xE5" => "\xED\x97\x8C",
		"\xC7\xE6" => "\xED\x97\x90",
		"\xC7\xE7" => "\xED\x97\x92",
		"\xC7\xE8" => "\xED\x97\x98",
		"\xC7\xE9" => "\xED\x97\x99",
		"\xC7\xEA" => "\xED\x97\x9B",
		"\xC7\xEB" => "\xED\x97\x9D",
		"\xC7\xEC" => "\xED\x97\xA4",
		"\xC7\xED" => "\xED\x97\xA5",
		"\xC7\xEE" => "\xED\x97\xA8",
		"\xC7\xEF" => "\xED\x97\xAC",
		"\xC7\xF0" => "\xED\x97\xB4",
		"\xC7\xF1" => "\xED\x97\xB5",
		"\xC7\xF2" => "\xED\x97\xB7",
		"\xC7\xF3" => "\xED\x97\xB9",
		"\xC7\xF4" => "\xED\x98\x80",
		"\xC7\xF5" => "\xED\x98\x81",
		"\xC7\xF6" => "\xED\x98\x84",
		"\xC7\xF7" => "\xED\x98\x88",
		"\xC7\xF8" => "\xED\x98\x90",
		"\xC7\xF9" => "\xED\x98\x91",
		"\xC7\xFA" => "\xED\x98\x93",
		"\xC7\xFB" => "\xED\x98\x94",
		"\xC7\xFC" => "\xED\x98\x95",
		"\xC7\xFD" => "\xED\x98\x9C",
		"\xC7\xFE" => "\xED\x98\xA0",
		"\xC8\xA1" => "\xED\x98\xA4",
		"\xC8\xA2" => "\xED\x98\xAD",
		"\xC8\xA3" => "\xED\x98\xB8",
		"\xC8\xA4" => "\xED\x98\xB9",
		"\xC8\xA5" => "\xED\x98\xBC",
		"\xC8\xA6" => "\xED\x99\x80",
		"\xC8\xA7" => "\xED\x99\x85",
		"\xC8\xA8" => "\xED\x99\x88",
		"\xC8\xA9" => "\xED\x99\x89",
		"\xC8\xAA" => "\xED\x99\x8B",
		"\xC8\xAB" => "\xED\x99\x8D",
		"\xC8\xAC" => "\xED\x99\x91",
		"\xC8\xAD" => "\xED\x99\x94",
		"\xC8\xAE" => "\xED\x99\x95",
		"\xC8\xAF" => "\xED\x99\x98",
		"\xC8\xB0" => "\xED\x99\x9C",
		"\xC8\xB1" => "\xED\x99\xA7",
		"\xC8\xB2" => "\xED\x99\xA9",
		"\xC8\xB3" => "\xED\x99\xB0",
		"\xC8\xB4" => "\xED\x99\xB1",
		"\xC8\xB5" => "\xED\x99\xB4",
		"\xC8\xB6" => "\xED\x9A\x83",
		"\xC8\xB7" => "\xED\x9A\x85",
		"\xC8\xB8" => "\xED\x9A\x8C",
		"\xC8\xB9" => "\xED\x9A\x8D",
		"\xC8\xBA" => "\xED\x9A\x90",
		"\xC8\xBB" => "\xED\x9A\x94",
		"\xC8\xBC" => "\xED\x9A\x9D",
		"\xC8\xBD" => "\xED\x9A\x9F",
		"\xC8\xBE" => "\xED\x9A\xA1",
		"\xC8\xBF" => "\xED\x9A\xA8",
		"\xC8\xC0" => "\xED\x9A\xAC",
		"\xC8\xC1" => "\xED\x9A\xB0",
		"\xC8\xC2" => "\xED\x9A\xB9",
		"\xC8\xC3" => "\xED\x9A\xBB",
		"\xC8\xC4" => "\xED\x9B\x84",
		"\xC8\xC5" => "\xED\x9B\x85",
		"\xC8\xC6" => "\xED\x9B\x88",
		"\xC8\xC7" => "\xED\x9B\x8C",
		"\xC8\xC8" => "\xED\x9B\x91",
		"\xC8\xC9" => "\xED\x9B\x94",
		"\xC8\xCA" => "\xED\x9B\x97",
		"\xC8\xCB" => "\xED\x9B\x99",
		"\xC8\xCC" => "\xED\x9B\xA0",
		"\xC8\xCD" => "\xED\x9B\xA4",
		"\xC8\xCE" => "\xED\x9B\xA8",
		"\xC8\xCF" => "\xED\x9B\xB0",
		"\xC8\xD0" => "\xED\x9B\xB5",
		"\xC8\xD1" => "\xED\x9B\xBC",
		"\xC8\xD2" => "\xED\x9B\xBD",
		"\xC8\xD3" => "\xED\x9C\x80",
		"\xC8\xD4" => "\xED\x9C\x84",
		"\xC8\xD5" => "\xED\x9C\x91",
		"\xC8\xD6" => "\xED\x9C\x98",
		"\xC8\xD7" => "\xED\x9C\x99",
		"\xC8\xD8" => "\xED\x9C\x9C",
		"\xC8\xD9" => "\xED\x9C\xA0",
		"\xC8\xDA" => "\xED\x9C\xA8",
		"\xC8\xDB" => "\xED\x9C\xA9",
		"\xC8\xDC" => "\xED\x9C\xAB",
		"\xC8\xDD" => "\xED\x9C\xAD",
		"\xC8\xDE" => "\xED\x9C\xB4",
		"\xC8\xDF" => "\xED\x9C\xB5",
		"\xC8\xE0" => "\xED\x9C\xB8",
		"\xC8\xE1" => "\xED\x9C\xBC",
		"\xC8\xE2" => "\xED\x9D\x84",
		"\xC8\xE3" => "\xED\x9D\x87",
		"\xC8\xE4" => "\xED\x9D\x89",
		"\xC8\xE5" => "\xED\x9D\x90",
		"\xC8\xE6" => "\xED\x9D\x91",
		"\xC8\xE7" => "\xED\x9D\x94",
		"\xC8\xE8" => "\xED\x9D\x96",
		"\xC8\xE9" => "\xED\x9D\x97",
		"\xC8\xEA" => "\xED\x9D\x98",
		"\xC8\xEB" => "\xED\x9D\x99",
		"\xC8\xEC" => "\xED\x9D\xA0",
		"\xC8\xED" => "\xED\x9D\xA1",
		"\xC8\xEE" => "\xED\x9D\xA3",
		"\xC8\xEF" => "\xED\x9D\xA5",
		"\xC8\xF0" => "\xED\x9D\xA9",
		"\xC8\xF1" => "\xED\x9D\xAC",
		"\xC8\xF2" => "\xED\x9D\xB0",
		"\xC8\xF3" => "\xED\x9D\xB4",
		"\xC8\xF4" => "\xED\x9D\xBC",
		"\xC8\xF5" => "\xED\x9D\xBD",
		"\xC8\xF6" => "\xED\x9E\x81",
		"\xC8\xF7" => "\xED\x9E\x88",
		"\xC8\xF8" => "\xED\x9E\x89",
		"\xC8\xF9" => "\xED\x9E\x8C",
		"\xC8\xFA" => "\xED\x9E\x90",
		"\xC8\xFB" => "\xED\x9E\x98",
		"\xC8\xFC" => "\xED\x9E\x99",
		"\xC8\xFD" => "\xED\x9E\x9B",
		"\xC8\xFE" => "\xED\x9E\x9D",
		"\xCA\xA1" => "\xE4\xBC\xBD",
		"\xCA\xA2" => "\xE4\xBD\xB3",
		"\xCA\xA3" => "\xE5\x81\x87",
		"\xCA\xA4" => "\xE5\x83\xB9",
		"\xCA\xA5" => "\xE5\x8A\xA0",
		"\xCA\xA6" => "\xE5\x8F\xAF",
		"\xCA\xA7" => "\xE5\x91\xB5",
		"\xCA\xA8" => "\xE5\x93\xA5",
		"\xCA\xA9" => "\xE5\x98\x89",
		"\xCA\xAA" => "\xE5\xAB\x81",
		"\xCA\xAB" => "\xE5\xAE\xB6",
		"\xCA\xAC" => "\xE6\x9A\x87",
		"\xCA\xAD" => "\xE6\x9E\xB6",
		"\xCA\xAE" => "\xE6\x9E\xB7",
		"\xCA\xAF" => "\xE6\x9F\xAF",
		"\xCA\xB0" => "\xE6\xAD\x8C",
		"\xCA\xB1" => "\xE7\x8F\x82",
		"\xCA\xB2" => "\xE7\x97\x82",
		"\xCA\xB3" => "\xE7\xA8\xBC",
		"\xCA\xB4" => "\xE8\x8B\x9B",
		"\xCA\xB5" => "\xE8\x8C\x84",
		"\xCA\xB6" => "\xE8\xA1\x97",
		"\xCA\xB7" => "\xE8\xA2\x88",
		"\xCA\xB8" => "\xE8\xA8\xB6",
		"\xCA\xB9" => "\xE8\xB3\x88",
		"\xCA\xBA" => "\xE8\xB7\x8F",
		"\xCA\xBB" => "\xE8\xBB\xBB",
		"\xCA\xBC" => "\xE8\xBF\xA6",
		"\xCA\xBD" => "\xE9\xA7\x95",
		"\xCA\xBE" => "\xE5\x88\xBB",
		"\xCA\xBF" => "\xE5\x8D\xB4",
		"\xCA\xC0" => "\xE5\x90\x84",
		"\xCA\xC1" => "\xE6\x81\xAA",
		"\xCA\xC2" => "\xE6\x85\xA4",
		"\xCA\xC3" => "\xE6\xAE\xBC",
		"\xCA\xC4" => "\xE7\x8F\x8F",
		"\xCA\xC5" => "\xE8\x84\x9A",
		"\xCA\xC6" => "\xE8\xA6\xBA",
		"\xCA\xC7" => "\xE8\xA7\x92",
		"\xCA\xC8" => "\xE9\x96\xA3",
		"\xCA\xC9" => "\xE4\xBE\x83",
		"\xCA\xCA" => "\xE5\x88\x8A",
		"\xCA\xCB" => "\xE5\xA2\xBE",
		"\xCA\xCC" => "\xE5\xA5\xB8",
		"\xCA\xCD" => "\xE5\xA7\xA6",
		"\xCA\xCE" => "\xE5\xB9\xB2",
		"\xCA\xCF" => "\xE5\xB9\xB9",
		"\xCA\xD0" => "\xE6\x87\x87",
		"\xCA\xD1" => "\xE6\x8F\x80",
		"\xCA\xD2" => "\xE6\x9D\x86",
		"\xCA\xD3" => "\xE6\x9F\xAC",
		"\xCA\xD4" => "\xE6\xA1\xBF",
		"\xCA\xD5" => "\xE6\xBE\x97",
		"\xCA\xD6" => "\xE7\x99\x8E",
		"\xCA\xD7" => "\xE7\x9C\x8B",
		"\xCA\xD8" => "\xE7\xA3\xB5",
		"\xCA\xD9" => "\xE7\xA8\x88",
		"\xCA\xDA" => "\xE7\xAB\xBF",
		"\xCA\xDB" => "\xE7\xB0\xA1",
		"\xCA\xDC" => "\xE8\x82\x9D",
		"\xCA\xDD" => "\xE8\x89\xAE",
		"\xCA\xDE" => "\xE8\x89\xB1",
		"\xCA\xDF" => "\xE8\xAB\xAB",
		"\xCA\xE0" => "\xE9\x96\x93",
		"\xCA\xE1" => "\xE4\xB9\xAB",
		"\xCA\xE2" => "\xE5\x96\x9D",
		"\xCA\xE3" => "\xE6\x9B\xB7",
		"\xCA\xE4" => "\xE6\xB8\xB4",
		"\xCA\xE5" => "\xE7\xA2\xA3",
		"\xCA\xE6" => "\xE7\xAB\xAD",
		"\xCA\xE7" => "\xE8\x91\x9B",
		"\xCA\xE8" => "\xE8\xA4\x90",
		"\xCA\xE9" => "\xE8\x9D\x8E",
		"\xCA\xEA" => "\xE9\x9E\xA8",
		"\xCA\xEB" => "\xE5\x8B\x98",
		"\xCA\xEC" => "\xE5\x9D\x8E",
		"\xCA\xED" => "\xE5\xA0\xAA",
		"\xCA\xEE" => "\xE5\xB5\x8C",
		"\xCA\xEF" => "\xE6\x84\x9F",
		"\xCA\xF0" => "\xE6\x86\xBE",
		"\xCA\xF1" => "\xE6\x88\xA1",
		"\xCA\xF2" => "\xE6\x95\xA2",
		"\xCA\xF3" => "\xE6\x9F\x91",
		"\xCA\xF4" => "\xE6\xA9\x84",
		"\xCA\xF5" => "\xE6\xB8\x9B",
		"\xCA\xF6" => "\xE7\x94\x98",
		"\xCA\xF7" => "\xE7\x96\xB3",
		"\xCA\xF8" => "\xE7\x9B\xA3",
		"\xCA\xF9" => "\xE7\x9E\xB0",
		"\xCA\xFA" => "\xE7\xB4\xBA",
		"\xCA\xFB" => "\xE9\x82\xAF",
		"\xCA\xFC" => "\xE9\x91\x91",
		"\xCA\xFD" => "\xE9\x91\x92",
		"\xCA\xFE" => "\xE9\xBE\x95",
		"\xCB\xA1" => "\xE5\x8C\xA3",
		"\xCB\xA2" => "\xE5\xB2\xAC",
		"\xCB\xA3" => "\xE7\x94\xB2",
		"\xCB\xA4" => "\xE8\x83\x9B",
		"\xCB\xA5" => "\xE9\x89\x80",
		"\xCB\xA6" => "\xE9\x96\x98",
		"\xCB\xA7" => "\xE5\x89\x9B",
		"\xCB\xA8" => "\xE5\xA0\x88",
		"\xCB\xA9" => "\xE5\xA7\x9C",
		"\xCB\xAA" => "\xE5\xB2\xA1",
		"\xCB\xAB" => "\xE5\xB4\x97",
		"\xCB\xAC" => "\xE5\xBA\xB7",
		"\xCB\xAD" => "\xE5\xBC\xBA",
		"\xCB\xAE" => "\xE5\xBD\x8A",
		"\xCB\xAF" => "\xE6\x85\xB7",
		"\xCB\xB0" => "\xE6\xB1\x9F",
		"\xCB\xB1" => "\xE7\x95\xBA",
		"\xCB\xB2" => "\xE7\x96\x86",
		"\xCB\xB3" => "\xE7\xB3\xA0",
		"\xCB\xB4" => "\xE7\xB5\xB3",
		"\xCB\xB5" => "\xE7\xB6\xB1",
		"\xCB\xB6" => "\xE7\xBE\x8C",
		"\xCB\xB7" => "\xE8\x85\x94",
		"\xCB\xB8" => "\xE8\x88\xA1",
		"\xCB\xB9" => "\xE8\x96\x91",
		"\xCB\xBA" => "\xE8\xA5\x81",
		"\xCB\xBB" => "\xE8\xAC\x9B",
		"\xCB\xBC" => "\xE9\x8B\xBC",
		"\xCB\xBD" => "\xE9\x99\x8D",
		"\xCB\xBE" => "\xE9\xB1\x87",
		"\xCB\xBF" => "\xE4\xBB\x8B",
		"\xCB\xC0" => "\xE4\xBB\xB7",
		"\xCB\xC1" => "\xE5\x80\x8B",
		"\xCB\xC2" => "\xE5\x87\xB1",
		"\xCB\xC3" => "\xE5\xA1\x8F",
		"\xCB\xC4" => "\xE6\x84\xB7",
		"\xCB\xC5" => "\xE6\x84\xBE",
		"\xCB\xC6" => "\xE6\x85\xA8",
		"\xCB\xC7" => "\xE6\x94\xB9",
		"\xCB\xC8" => "\xE6\xA7\xAA",
		"\xCB\xC9" => "\xE6\xBC\x91",
		"\xCB\xCA" => "\xE7\x96\xA5",
		"\xCB\xCB" => "\xE7\x9A\x86",
		"\xCB\xCC" => "\xE7\x9B\x96",
		"\xCB\xCD" => "\xE7\xAE\x87",
		"\xCB\xCE" => "\xE8\x8A\xA5",
		"\xCB\xCF" => "\xE8\x93\x8B",
		"\xCB\xD0" => "\xEF\xA4\x80",
		"\xCB\xD1" => "\xE9\x8E\xA7",
		"\xCB\xD2" => "\xE9\x96\x8B",
		"\xCB\xD3" => "\xE5\x96\x80",
		"\xCB\xD4" => "\xE5\xAE\xA2",
		"\xCB\xD5" => "\xE5\x9D\x91",
		"\xCB\xD6" => "\xEF\xA4\x81",
		"\xCB\xD7" => "\xE7\xB2\xB3",
		"\xCB\xD8" => "\xE7\xBE\xB9",
		"\xCB\xD9" => "\xE9\x86\xB5",
		"\xCB\xDA" => "\xE5\x80\xA8",
		"\xCB\xDB" => "\xE5\x8E\xBB",
		"\xCB\xDC" => "\xE5\xB1\x85",
		"\xCB\xDD" => "\xE5\xB7\xA8",
		"\xCB\xDE" => "\xE6\x8B\x92",
		"\xCB\xDF" => "\xE6\x8D\xAE",
		"\xCB\xE0" => "\xE6\x93\x9A",
		"\xCB\xE1" => "\xE6\x93\xA7",
		"\xCB\xE2" => "\xE6\xB8\xA0",
		"\xCB\xE3" => "\xE7\x82\xAC",
		"\xCB\xE4" => "\xE7\xA5\x9B",
		"\xCB\xE5" => "\xE8\xB7\x9D",
		"\xCB\xE6" => "\xE8\xB8\x9E",
		"\xCB\xE7" => "\xEF\xA4\x82",
		"\xCB\xE8" => "\xE9\x81\xBD",
		"\xCB\xE9" => "\xE9\x89\x85",
		"\xCB\xEA" => "\xE9\x8B\xB8",
		"\xCB\xEB" => "\xE4\xB9\xBE",
		"\xCB\xEC" => "\xE4\xBB\xB6",
		"\xCB\xED" => "\xE5\x81\xA5",
		"\xCB\xEE" => "\xE5\xB7\xBE",
		"\xCB\xEF" => "\xE5\xBB\xBA",
		"\xCB\xF0" => "\xE6\x84\x86",
		"\xCB\xF1" => "\xE6\xA5\x97",
		"\xCB\xF2" => "\xE8\x85\xB1",
		"\xCB\xF3" => "\xE8\x99\x94",
		"\xCB\xF4" => "\xE8\xB9\x87",
		"\xCB\xF5" => "\xE9\x8D\xB5",
		"\xCB\xF6" => "\xE9\xA8\xAB",
		"\xCB\xF7" => "\xE4\xB9\x9E",
		"\xCB\xF8" => "\xE5\x82\x91",
		"\xCB\xF9" => "\xE6\x9D\xB0",
		"\xCB\xFA" => "\xE6\xA1\x80",
		"\xCB\xFB" => "\xE5\x84\x89",
		"\xCB\xFC" => "\xE5\x8A\x8D",
		"\xCB\xFD" => "\xE5\x8A\x92",
		"\xCB\xFE" => "\xE6\xAA\xA2",
		"\xCC\xA1" => "\xE7\x9E\xBC",
		"\xCC\xA2" => "\xE9\x88\x90",
		"\xCC\xA3" => "\xE9\xBB\x94",
		"\xCC\xA4" => "\xE5\x8A\xAB",
		"\xCC\xA5" => "\xE6\x80\xAF",
		"\xCC\xA6" => "\xE8\xBF\xB2",
		"\xCC\xA7" => "\xE5\x81\x88",
		"\xCC\xA8" => "\xE6\x86\xA9",
		"\xCC\xA9" => "\xE6\x8F\xAD",
		"\xCC\xAA" => "\xE6\x93\x8A",
		"\xCC\xAB" => "\xE6\xA0\xBC",
		"\xCC\xAC" => "\xE6\xAA\x84",
		"\xCC\xAD" => "\xE6\xBF\x80",
		"\xCC\xAE" => "\xE8\x86\x88",
		"\xCC\xAF" => "\xE8\xA6\xA1",
		"\xCC\xB0" => "\xE9\x9A\x94",
		"\xCC\xB1" => "\xE5\xA0\x85",
		"\xCC\xB2" => "\xE7\x89\xBD",
		"\xCC\xB3" => "\xE7\x8A\xAC",
		"\xCC\xB4" => "\xE7\x94\x84",
		"\xCC\xB5" => "\xE7\xB5\xB9",
		"\xCC\xB6" => "\xE7\xB9\xAD",
		"\xCC\xB7" => "\xE8\x82\xA9",
		"\xCC\xB8" => "\xE8\xA6\x8B",
		"\xCC\xB9" => "\xE8\xAD\xB4",
		"\xCC\xBA" => "\xE9\x81\xA3",
		"\xCC\xBB" => "\xE9\xB5\x91",
		"\xCC\xBC" => "\xE6\x8A\x89",
		"\xCC\xBD" => "\xE6\xB1\xBA",
		"\xCC\xBE" => "\xE6\xBD\x94",
		"\xCC\xBF" => "\xE7\xB5\x90",
		"\xCC\xC0" => "\xE7\xBC\xBA",
		"\xCC\xC1" => "\xE8\xA8\xA3",
		"\xCC\xC2" => "\xE5\x85\xBC",
		"\xCC\xC3" => "\xE6\x85\x8A",
		"\xCC\xC4" => "\xE7\xAE\x9D",
		"\xCC\xC5" => "\xE8\xAC\x99",
		"\xCC\xC6" => "\xE9\x89\x97",
		"\xCC\xC7" => "\xE9\x8E\x8C",
		"\xCC\xC8" => "\xE4\xBA\xAC",
		"\xCC\xC9" => "\xE4\xBF\x93",
		"\xCC\xCA" => "\xE5\x80\x9E",
		"\xCC\xCB" => "\xE5\x82\xBE",
		"\xCC\xCC" => "\xE5\x84\x86",
		"\xCC\xCD" => "\xE5\x8B\x81",
		"\xCC\xCE" => "\xE5\x8B\x8D",
		"\xCC\xCF" => "\xE5\x8D\xBF",
		"\xCC\xD0" => "\xE5\x9D\xB0",
		"\xCC\xD1" => "\xE5\xA2\x83",
		"\xCC\xD2" => "\xE5\xBA\x9A",
		"\xCC\xD3" => "\xE5\xBE\x91",
		"\xCC\xD4" => "\xE6\x85\xB6",
		"\xCC\xD5" => "\xE6\x86\xAC",
		"\xCC\xD6" => "\xE6\x93\x8E",
		"\xCC\xD7" => "\xE6\x95\xAC",
		"\xCC\xD8" => "\xE6\x99\xAF",
		"\xCC\xD9" => "\xE6\x9A\xBB",
		"\xCC\xDA" => "\xE6\x9B\xB4",
		"\xCC\xDB" => "\xE6\xA2\x97",
		"\xCC\xDC" => "\xE6\xB6\x87",
		"\xCC\xDD" => "\xE7\x82\x85",
		"\xCC\xDE" => "\xE7\x83\xB1",
		"\xCC\xDF" => "\xE7\x92\x9F",
		"\xCC\xE0" => "\xE7\x92\xA5",
		"\xCC\xE1" => "\xE7\x93\x8A",
		"\xCC\xE2" => "\xE7\x97\x99",
		"\xCC\xE3" => "\xE7\xA1\xAC",
		"\xCC\xE4" => "\xE7\xA3\xAC",
		"\xCC\xE5" => "\xE7\xAB\x9F",
		"\xCC\xE6" => "\xE7\xAB\xB6",
		"\xCC\xE7" => "\xE7\xB5\x85",
		"\xCC\xE8" => "\xE7\xB6\x93",
		"\xCC\xE9" => "\xE8\x80\x95",
		"\xCC\xEA" => "\xE8\x80\xBF",
		"\xCC\xEB" => "\xE8\x84\x9B",
		"\xCC\xEC" => "\xE8\x8E\x96",
		"\xCC\xED" => "\xE8\xAD\xA6",
		"\xCC\xEE" => "\xE8\xBC\x95",
		"\xCC\xEF" => "\xE9\x80\x95",
		"\xCC\xF0" => "\xE9\x8F\xA1",
		"\xCC\xF1" => "\xE9\xA0\x83",
		"\xCC\xF2" => "\xE9\xA0\xB8",
		"\xCC\xF3" => "\xE9\xA9\x9A",
		"\xCC\xF4" => "\xE9\xAF\xA8",
		"\xCC\xF5" => "\xE4\xBF\x82",
		"\xCC\xF6" => "\xE5\x95\x93",
		"\xCC\xF7" => "\xE5\xA0\xBA",
		"\xCC\xF8" => "\xE5\xA5\x91",
		"\xCC\xF9" => "\xE5\xAD\xA3",
		"\xCC\xFA" => "\xE5\xB1\x86",
		"\xCC\xFB" => "\xE6\x82\xB8",
		"\xCC\xFC" => "\xE6\x88\x92",
		"\xCC\xFD" => "\xE6\xA1\x82",
		"\xCC\xFE" => "\xE6\xA2\xB0",
		"\xCD\xA1" => "\xE6\xA3\xA8",
		"\xCD\xA2" => "\xE6\xBA\xAA",
		"\xCD\xA3" => "\xE7\x95\x8C",
		"\xCD\xA4" => "\xE7\x99\xB8",
		"\xCD\xA5" => "\xE7\xA3\x8E",
		"\xCD\xA6" => "\xE7\xA8\xBD",
		"\xCD\xA7" => "\xE7\xB3\xBB",
		"\xCD\xA8" => "\xE7\xB9\xAB",
		"\xCD\xA9" => "\xE7\xB9\xBC",
		"\xCD\xAA" => "\xE8\xA8\x88",
		"\xCD\xAB" => "\xE8\xAA\xA1",
		"\xCD\xAC" => "\xE8\xB0\xBF",
		"\xCD\xAD" => "\xE9\x9A\x8E",
		"\xCD\xAE" => "\xE9\xB7\x84",
		"\xCD\xAF" => "\xE5\x8F\xA4",
		"\xCD\xB0" => "\xE5\x8F\xA9",
		"\xCD\xB1" => "\xE5\x91\x8A",
		"\xCD\xB2" => "\xE5\x91\xB1",
		"\xCD\xB3" => "\xE5\x9B\xBA",
		"\xCD\xB4" => "\xE5\xA7\x91",
		"\xCD\xB5" => "\xE5\xAD\xA4",
		"\xCD\xB6" => "\xE5\xB0\xBB",
		"\xCD\xB7" => "\xE5\xBA\xAB",
		"\xCD\xB8" => "\xE6\x8B\xB7",
		"\xCD\xB9" => "\xE6\x94\xB7",
		"\xCD\xBA" => "\xE6\x95\x85",
		"\xCD\xBB" => "\xE6\x95\xB2",
		"\xCD\xBC" => "\xE6\x9A\xA0",
		"\xCD\xBD" => "\xE6\x9E\xAF",
		"\xCD\xBE" => "\xE6\xA7\x81",
		"\xCD\xBF" => "\xE6\xB2\xBD",
		"\xCD\xC0" => "\xE7\x97\xBC",
		"\xCD\xC1" => "\xE7\x9A\x90",
		"\xCD\xC2" => "\xE7\x9D\xBE",
		"\xCD\xC3" => "\xE7\xA8\xBF",
		"\xCD\xC4" => "\xE7\xBE\x94",
		"\xCD\xC5" => "\xE8\x80\x83",
		"\xCD\xC6" => "\xE8\x82\xA1",
		"\xCD\xC7" => "\xE8\x86\x8F",
		"\xCD\xC8" => "\xE8\x8B\xA6",
		"\xCD\xC9" => "\xE8\x8B\xBD",
		"\xCD\xCA" => "\xE8\x8F\xB0",
		"\xCD\xCB" => "\xE8\x97\x81",
		"\xCD\xCC" => "\xE8\xA0\xB1",
		"\xCD\xCD" => "\xE8\xA2\xB4",
		"\xCD\xCE" => "\xE8\xAA\xA5",
		"\xCD\xCF" => "\xEF\xA4\x83",
		"\xCD\xD0" => "\xE8\xBE\x9C",
		"\xCD\xD1" => "\xE9\x8C\xAE",
		"\xCD\xD2" => "\xE9\x9B\x87",
		"\xCD\xD3" => "\xE9\xA1\xA7",
		"\xCD\xD4" => "\xE9\xAB\x98",
		"\xCD\xD5" => "\xE9\xBC\x93",
		"\xCD\xD6" => "\xE5\x93\xAD",
		"\xCD\xD7" => "\xE6\x96\x9B",
		"\xCD\xD8" => "\xE6\x9B\xB2",
		"\xCD\xD9" => "\xE6\xA2\x8F",
		"\xCD\xDA" => "\xE7\xA9\x80",
		"\xCD\xDB" => "\xE8\xB0\xB7",
		"\xCD\xDC" => "\xE9\xB5\xA0",
		"\xCD\xDD" => "\xE5\x9B\xB0",
		"\xCD\xDE" => "\xE5\x9D\xA4",
		"\xCD\xDF" => "\xE5\xB4\x91",
		"\xCD\xE0" => "\xE6\x98\x86",
		"\xCD\xE1" => "\xE6\xA2\xB1",
		"\xCD\xE2" => "\xE6\xA3\x8D",
		"\xCD\xE3" => "\xE6\xBB\xBE",
		"\xCD\xE4" => "\xE7\x90\xA8",
		"\xCD\xE5" => "\xE8\xA2\x9E",
		"\xCD\xE6" => "\xE9\xAF\xA4",
		"\xCD\xE7" => "\xE6\xB1\xA8",
		"\xCD\xE8" => "\xEF\xA4\x84",
		"\xCD\xE9" => "\xE9\xAA\xA8",
		"\xCD\xEA" => "\xE4\xBE\x9B",
		"\xCD\xEB" => "\xE5\x85\xAC",
		"\xCD\xEC" => "\xE5\x85\xB1",
		"\xCD\xED" => "\xE5\x8A\x9F",
		"\xCD\xEE" => "\xE5\xAD\x94",
		"\xCD\xEF" => "\xE5\xB7\xA5",
		"\xCD\xF0" => "\xE6\x81\x90",
		"\xCD\xF1" => "\xE6\x81\xAD",
		"\xCD\xF2" => "\xE6\x8B\xB1",
		"\xCD\xF3" => "\xE6\x8E\xA7",
		"\xCD\xF4" => "\xE6\x94\xBB",
		"\xCD\xF5" => "\xE7\x8F\x99",
		"\xCD\xF6" => "\xE7\xA9\xBA",
		"\xCD\xF7" => "\xE8\x9A\xA3",
		"\xCD\xF8" => "\xE8\xB2\xA2",
		"\xCD\xF9" => "\xE9\x9E\x8F",
		"\xCD\xFA" => "\xE4\xB8\xB2",
		"\xCD\xFB" => "\xE5\xAF\xA1",
		"\xCD\xFC" => "\xE6\x88\x88",
		"\xCD\xFD" => "\xE6\x9E\x9C",
		"\xCD\xFE" => "\xE7\x93\x9C",
		"\xCE\xA1" => "\xE7\xA7\x91",
		"\xCE\xA2" => "\xE8\x8F\x93",
		"\xCE\xA3" => "\xE8\xAA\x87",
		"\xCE\xA4" => "\xE8\xAA\xB2",
		"\xCE\xA5" => "\xE8\xB7\xA8",
		"\xCE\xA6" => "\xE9\x81\x8E",
		"\xCE\xA7" => "\xE9\x8D\x8B",
		"\xCE\xA8" => "\xE9\xA1\x86",
		"\xCE\xA9" => "\xE5\xBB\x93",
		"\xCE\xAA" => "\xE6\xA7\xA8",
		"\xCE\xAB" => "\xE8\x97\xBF",
		"\xCE\xAC" => "\xE9\x83\xAD",
		"\xCE\xAD" => "\xEF\xA4\x85",
		"\xCE\xAE" => "\xE5\x86\xA0",
		"\xCE\xAF" => "\xE5\xAE\x98",
		"\xCE\xB0" => "\xE5\xAF\xAC",
		"\xCE\xB1" => "\xE6\x85\xA3",
		"\xCE\xB2" => "\xE6\xA3\xBA",
		"\xCE\xB3" => "\xE6\xAC\xBE",
		"\xCE\xB4" => "\xE7\x81\x8C",
		"\xCE\xB5" => "\xE7\x90\xAF",
		"\xCE\xB6" => "\xE7\x93\x98",
		"\xCE\xB7" => "\xE7\xAE\xA1",
		"\xCE\xB8" => "\xE7\xBD\x90",
		"\xCE\xB9" => "\xE8\x8F\x85",
		"\xCE\xBA" => "\xE8\xA7\x80",
		"\xCE\xBB" => "\xE8\xB2\xAB",
		"\xCE\xBC" => "\xE9\x97\x9C",
		"\xCE\xBD" => "\xE9\xA4\xA8",
		"\xCE\xBE" => "\xE5\x88\xAE",
		"\xCE\xBF" => "\xE6\x81\x9D",
		"\xCE\xC0" => "\xE6\x8B\xAC",
		"\xCE\xC1" => "\xE9\x80\x82",
		"\xCE\xC2" => "\xE4\xBE\x8A",
		"\xCE\xC3" => "\xE5\x85\x89",
		"\xCE\xC4" => "\xE5\x8C\xA1",
		"\xCE\xC5" => "\xE5\xA3\x99",
		"\xCE\xC6" => "\xE5\xBB\xA3",
		"\xCE\xC7" => "\xE6\x9B\xA0",
		"\xCE\xC8" => "\xE6\xB4\xB8",
		"\xCE\xC9" => "\xE7\x82\x9A",
		"\xCE\xCA" => "\xE7\x8B\x82",
		"\xCE\xCB" => "\xE7\x8F\x96",
		"\xCE\xCC" => "\xE7\xAD\x90",
		"\xCE\xCD" => "\xE8\x83\xB1",
		"\xCE\xCE" => "\xE9\x91\x9B",
		"\xCE\xCF" => "\xE5\x8D\xA6",
		"\xCE\xD0" => "\xE6\x8E\x9B",
		"\xCE\xD1" => "\xE7\xBD\xAB",
		"\xCE\xD2" => "\xE4\xB9\x96",
		"\xCE\xD3" => "\xE5\x82\x80",
		"\xCE\xD4" => "\xE5\xA1\x8A",
		"\xCE\xD5" => "\xE5\xA3\x9E",
		"\xCE\xD6" => "\xE6\x80\xAA",
		"\xCE\xD7" => "\xE6\x84\xA7",
		"\xCE\xD8" => "\xE6\x8B\x90",
		"\xCE\xD9" => "\xE6\xA7\x90",
		"\xCE\xDA" => "\xE9\xAD\x81",
		"\xCE\xDB" => "\xE5\xAE\x8F",
		"\xCE\xDC" => "\xE7\xB4\x98",
		"\xCE\xDD" => "\xE8\x82\xB1",
		"\xCE\xDE" => "\xE8\xBD\x9F",
		"\xCE\xDF" => "\xE4\xBA\xA4",
		"\xCE\xE0" => "\xE5\x83\x91",
		"\xCE\xE1" => "\xE5\x92\xAC",
		"\xCE\xE2" => "\xE5\x96\xAC",
		"\xCE\xE3" => "\xE5\xAC\x8C",
		"\xCE\xE4" => "\xE5\xB6\xA0",
		"\xCE\xE5" => "\xE5\xB7\xA7",
		"\xCE\xE6" => "\xE6\x94\xAA",
		"\xCE\xE7" => "\xE6\x95\x8E",
		"\xCE\xE8" => "\xE6\xA0\xA1",
		"\xCE\xE9" => "\xE6\xA9\x8B",
		"\xCE\xEA" => "\xE7\x8B\xA1",
		"\xCE\xEB" => "\xE7\x9A\x8E",
		"\xCE\xEC" => "\xE7\x9F\xAF",
		"\xCE\xED" => "\xE7\xB5\x9E",
		"\xCE\xEE" => "\xE7\xBF\xB9",
		"\xCE\xEF" => "\xE8\x86\xA0",
		"\xCE\xF0" => "\xE8\x95\x8E",
		"\xCE\xF1" => "\xE8\x9B\x9F",
		"\xCE\xF2" => "\xE8\xBC\x83",
		"\xCE\xF3" => "\xE8\xBD\x8E",
		"\xCE\xF4" => "\xE9\x83\x8A",
		"\xCE\xF5" => "\xE9\xA4\x83",
		"\xCE\xF6" => "\xE9\xA9\x95",
		"\xCE\xF7" => "\xE9\xAE\xAB",
		"\xCE\xF8" => "\xE4\xB8\x98",
		"\xCE\xF9" => "\xE4\xB9\x85",
		"\xCE\xFA" => "\xE4\xB9\x9D",
		"\xCE\xFB" => "\xE4\xBB\x87",
		"\xCE\xFC" => "\xE4\xBF\xB1",
		"\xCE\xFD" => "\xE5\x85\xB7",
		"\xCE\xFE" => "\xE5\x8B\xBE",
		"\xCF\xA1" => "\xE5\x8D\x80",
		"\xCF\xA2" => "\xE5\x8F\xA3",
		"\xCF\xA3" => "\xE5\x8F\xA5",
		"\xCF\xA4" => "\xE5\x92\x8E",
		"\xCF\xA5" => "\xE5\x98\x94",
		"\xCF\xA6" => "\xE5\x9D\xB5",
		"\xCF\xA7" => "\xE5\x9E\xA2",
		"\xCF\xA8" => "\xE5\xAF\x87",
		"\xCF\xA9" => "\xE5\xB6\x87",
		"\xCF\xAA" => "\xE5\xBB\x90",
		"\xCF\xAB" => "\xE6\x87\xBC",
		"\xCF\xAC" => "\xE6\x8B\x98",
		"\xCF\xAD" => "\xE6\x95\x91",
		"\xCF\xAE" => "\xE6\x9E\xB8",
		"\xCF\xAF" => "\xE6\x9F\xA9",
		"\xCF\xB0" => "\xE6\xA7\x8B",
		"\xCF\xB1" => "\xE6\xAD\x90",
		"\xCF\xB2" => "\xE6\xAF\x86",
		"\xCF\xB3" => "\xE6\xAF\xAC",
		"\xCF\xB4" => "\xE6\xB1\x82",
		"\xCF\xB5" => "\xE6\xBA\x9D",
		"\xCF\xB6" => "\xE7\x81\xB8",
		"\xCF\xB7" => "\xE7\x8B\x97",
		"\xCF\xB8" => "\xE7\x8E\x96",
		"\xCF\xB9" => "\xE7\x90\x83",
		"\xCF\xBA" => "\xE7\x9E\xBF",
		"\xCF\xBB" => "\xE7\x9F\xA9",
		"\xCF\xBC" => "\xE7\xA9\xB6",
		"\xCF\xBD" => "\xE7\xB5\xBF",
		"\xCF\xBE" => "\xE8\x80\x89",
		"\xCF\xBF" => "\xE8\x87\xBC",
		"\xCF\xC0" => "\xE8\x88\x85",
		"\xCF\xC1" => "\xE8\x88\x8A",
		"\xCF\xC2" => "\xE8\x8B\x9F",
		"\xCF\xC3" => "\xE8\xA1\xA2",
		"\xCF\xC4" => "\xE8\xAC\xB3",
		"\xCF\xC5" => "\xE8\xB3\xBC",
		"\xCF\xC6" => "\xE8\xBB\x80",
		"\xCF\xC7" => "\xE9\x80\x91",
		"\xCF\xC8" => "\xE9\x82\xB1",
		"\xCF\xC9" => "\xE9\x89\xA4",
		"\xCF\xCA" => "\xE9\x8A\xB6",
		"\xCF\xCB" => "\xE9\xA7\x92",
		"\xCF\xCC" => "\xE9\xA9\x85",
		"\xCF\xCD" => "\xE9\xB3\xA9",
		"\xCF\xCE" => "\xE9\xB7\x97",
		"\xCF\xCF" => "\xE9\xBE\x9C",
		"\xCF\xD0" => "\xE5\x9C\x8B",
		"\xCF\xD1" => "\xE5\xB1\x80",
		"\xCF\xD2" => "\xE8\x8F\x8A",
		"\xCF\xD3" => "\xE9\x9E\xA0",
		"\xCF\xD4" => "\xE9\x9E\xAB",
		"\xCF\xD5" => "\xE9\xBA\xB4",
		"\xCF\xD6" => "\xE5\x90\x9B",
		"\xCF\xD7" => "\xE7\xAA\x98",
		"\xCF\xD8" => "\xE7\xBE\xA4",
		"\xCF\xD9" => "\xE8\xA3\x99",
		"\xCF\xDA" => "\xE8\xBB\x8D",
		"\xCF\xDB" => "\xE9\x83\xA1",
		"\xCF\xDC" => "\xE5\xA0\x80",
		"\xCF\xDD" => "\xE5\xB1\x88",
		"\xCF\xDE" => "\xE6\x8E\x98",
		"\xCF\xDF" => "\xE7\xAA\x9F",
		"\xCF\xE0" => "\xE5\xAE\xAE",
		"\xCF\xE1" => "\xE5\xBC\x93",
		"\xCF\xE2" => "\xE7\xA9\xB9",
		"\xCF\xE3" => "\xE7\xAA\xAE",
		"\xCF\xE4" => "\xE8\x8A\x8E",
		"\xCF\xE5" => "\xE8\xBA\xAC",
		"\xCF\xE6" => "\xE5\x80\xA6",
		"\xCF\xE7" => "\xE5\x88\xB8",
		"\xCF\xE8" => "\xE5\x8B\xB8",
		"\xCF\xE9" => "\xE5\x8D\xB7",
		"\xCF\xEA" => "\xE5\x9C\x88",
		"\xCF\xEB" => "\xE6\x8B\xB3",
		"\xCF\xEC" => "\xE6\x8D\xB2",
		"\xCF\xED" => "\xE6\xAC\x8A",
		"\xCF\xEE" => "\xE6\xB7\x83",
		"\xCF\xEF" => "\xE7\x9C\xB7",
		"\xCF\xF0" => "\xE5\x8E\xA5",
		"\xCF\xF1" => "\xE7\x8D\x97",
		"\xCF\xF2" => "\xE8\x95\xA8",
		"\xCF\xF3" => "\xE8\xB9\xB6",
		"\xCF\xF4" => "\xE9\x97\x95",
		"\xCF\xF5" => "\xE6\x9C\xBA",
		"\xCF\xF6" => "\xE6\xAB\x83",
		"\xCF\xF7" => "\xE6\xBD\xB0",
		"\xCF\xF8" => "\xE8\xA9\xAD",
		"\xCF\xF9" => "\xE8\xBB\x8C",
		"\xCF\xFA" => "\xE9\xA5\x8B",
		"\xCF\xFB" => "\xEF\xA4\x86",
		"\xCF\xFC" => "\xE6\x99\xB7",
		"\xCF\xFD" => "\xE6\xAD\xB8",
		"\xCF\xFE" => "\xE8\xB2\xB4",
		"\xD0\xA1" => "\xE9\xAC\xBC",
		"\xD0\xA2" => "\xEF\xA4\x87",
		"\xD0\xA3" => "\xE5\x8F\xAB",
		"\xD0\xA4" => "\xE5\x9C\xAD",
		"\xD0\xA5" => "\xE5\xA5\x8E",
		"\xD0\xA6" => "\xE6\x8F\x86",
		"\xD0\xA7" => "\xE6\xA7\xBB",
		"\xD0\xA8" => "\xE7\x8F\xAA",
		"\xD0\xA9" => "\xE7\xA1\x85",
		"\xD0\xAA" => "\xE7\xAA\xBA",
		"\xD0\xAB" => "\xE7\xAB\x85",
		"\xD0\xAC" => "\xE7\xB3\xBE",
		"\xD0\xAD" => "\xE8\x91\xB5",
		"\xD0\xAE" => "\xE8\xA6\x8F",
		"\xD0\xAF" => "\xE8\xB5\xB3",
		"\xD0\xB0" => "\xE9\x80\xB5",
		"\xD0\xB1" => "\xE9\x96\xA8",
		"\xD0\xB2" => "\xE5\x8B\xBB",
		"\xD0\xB3" => "\xE5\x9D\x87",
		"\xD0\xB4" => "\xE7\x95\x87",
		"\xD0\xB5" => "\xE7\xAD\xA0",
		"\xD0\xB6" => "\xE8\x8F\x8C",
		"\xD0\xB7" => "\xE9\x88\x9E",
		"\xD0\xB8" => "\xEF\xA4\x88",
		"\xD0\xB9" => "\xE6\xA9\x98",
		"\xD0\xBA" => "\xE5\x85\x8B",
		"\xD0\xBB" => "\xE5\x89\x8B",
		"\xD0\xBC" => "\xE5\x8A\x87",
		"\xD0\xBD" => "\xE6\x88\x9F",
		"\xD0\xBE" => "\xE6\xA3\x98",
		"\xD0\xBF" => "\xE6\xA5\xB5",
		"\xD0\xC0" => "\xE9\x9A\x99",
		"\xD0\xC1" => "\xE5\x83\x85",
		"\xD0\xC2" => "\xE5\x8A\xA4",
		"\xD0\xC3" => "\xE5\x8B\xA4",
		"\xD0\xC4" => "\xE6\x87\x83",
		"\xD0\xC5" => "\xE6\x96\xA4",
		"\xD0\xC6" => "\xE6\xA0\xB9",
		"\xD0\xC7" => "\xE6\xA7\xBF",
		"\xD0\xC8" => "\xE7\x91\xBE",
		"\xD0\xC9" => "\xE7\xAD\x8B",
		"\xD0\xCA" => "\xE8\x8A\xB9",
		"\xD0\xCB" => "\xE8\x8F\xAB",
		"\xD0\xCC" => "\xE8\xA6\xB2",
		"\xD0\xCD" => "\xE8\xAC\xB9",
		"\xD0\xCE" => "\xE8\xBF\x91",
		"\xD0\xCF" => "\xE9\xA5\x89",
		"\xD0\xD0" => "\xEF\xA4\x89",
		"\xD0\xD1" => "\xE4\xBB\x8A",
		"\xD0\xD2" => "\xE5\xA6\x97",
		"\xD0\xD3" => "\xE6\x93\x92",
		"\xD0\xD4" => "\xE6\x98\x91",
		"\xD0\xD5" => "\xE6\xAA\x8E",
		"\xD0\xD6" => "\xE7\x90\xB4",
		"\xD0\xD7" => "\xE7\xA6\x81",
		"\xD0\xD8" => "\xE7\xA6\xBD",
		"\xD0\xD9" => "\xE8\x8A\xA9",
		"\xD0\xDA" => "\xE8\xA1\xBE",
		"\xD0\xDB" => "\xE8\xA1\xBF",
		"\xD0\xDC" => "\xE8\xA5\x9F",
		"\xD0\xDD" => "\xEF\xA4\x8A",
		"\xD0\xDE" => "\xE9\x8C\xA6",
		"\xD0\xDF" => "\xE4\xBC\x8B",
		"\xD0\xE0" => "\xE5\x8F\x8A",
		"\xD0\xE1" => "\xE6\x80\xA5",
		"\xD0\xE2" => "\xE6\x89\xB1",
		"\xD0\xE3" => "\xE6\xB1\xB2",
		"\xD0\xE4" => "\xE7\xB4\x9A",
		"\xD0\xE5" => "\xE7\xB5\xA6",
		"\xD0\xE6" => "\xE4\xBA\x98",
		"\xD0\xE7" => "\xE5\x85\xA2",
		"\xD0\xE8" => "\xE7\x9F\x9C",
		"\xD0\xE9" => "\xE8\x82\xAF",
		"\xD0\xEA" => "\xE4\xBC\x81",
		"\xD0\xEB" => "\xE4\xBC\x8E",
		"\xD0\xEC" => "\xE5\x85\xB6",
		"\xD0\xED" => "\xE5\x86\x80",
		"\xD0\xEE" => "\xE5\x97\x9C",
		"\xD0\xEF" => "\xE5\x99\xA8",
		"\xD0\xF0" => "\xE5\x9C\xBB",
		"\xD0\xF1" => "\xE5\x9F\xBA",
		"\xD0\xF2" => "\xE5\x9F\xBC",
		"\xD0\xF3" => "\xE5\xA4\x94",
		"\xD0\xF4" => "\xE5\xA5\x87",
		"\xD0\xF5" => "\xE5\xA6\x93",
		"\xD0\xF6" => "\xE5\xAF\x84",
		"\xD0\xF7" => "\xE5\xB2\x90",
		"\xD0\xF8" => "\xE5\xB4\x8E",
		"\xD0\xF9" => "\xE5\xB7\xB1",
		"\xD0\xFA" => "\xE5\xB9\xBE",
		"\xD0\xFB" => "\xE5\xBF\x8C",
		"\xD0\xFC" => "\xE6\x8A\x80",
		"\xD0\xFD" => "\xE6\x97\x97",
		"\xD0\xFE" => "\xE6\x97\xA3",
		"\xD1\xA1" => "\xE6\x9C\x9E",
		"\xD1\xA2" => "\xE6\x9C\x9F",
		"\xD1\xA3" => "\xE6\x9D\x9E",
		"\xD1\xA4" => "\xE6\xA3\x8B",
		"\xD1\xA5" => "\xE6\xA3\x84",
		"\xD1\xA6" => "\xE6\xA9\x9F",
		"\xD1\xA7" => "\xE6\xAC\xBA",
		"\xD1\xA8" => "\xE6\xB0\xA3",
		"\xD1\xA9" => "\xE6\xB1\xBD",
		"\xD1\xAA" => "\xE6\xB2\x82",
		"\xD1\xAB" => "\xE6\xB7\x87",
		"\xD1\xAC" => "\xE7\x8E\x98",
		"\xD1\xAD" => "\xE7\x90\xA6",
		"\xD1\xAE" => "\xE7\x90\xAA",
		"\xD1\xAF" => "\xE7\x92\x82",
		"\xD1\xB0" => "\xE7\x92\xA3",
		"\xD1\xB1" => "\xE7\x95\xB8",
		"\xD1\xB2" => "\xE7\x95\xBF",
		"\xD1\xB3" => "\xE7\xA2\x81",
		"\xD1\xB4" => "\xE7\xA3\xAF",
		"\xD1\xB5" => "\xE7\xA5\x81",
		"\xD1\xB6" => "\xE7\xA5\x87",
		"\xD1\xB7" => "\xE7\xA5\x88",
		"\xD1\xB8" => "\xE7\xA5\xBA",
		"\xD1\xB9" => "\xE7\xAE\x95",
		"\xD1\xBA" => "\xE7\xB4\x80",
		"\xD1\xBB" => "\xE7\xB6\xBA",
		"\xD1\xBC" => "\xE7\xBE\x88",
		"\xD1\xBD" => "\xE8\x80\x86",
		"\xD1\xBE" => "\xE8\x80\xAD",
		"\xD1\xBF" => "\xE8\x82\x8C",
		"\xD1\xC0" => "\xE8\xA8\x98",
		"\xD1\xC1" => "\xE8\xAD\x8F",
		"\xD1\xC2" => "\xE8\xB1\x88",
		"\xD1\xC3" => "\xE8\xB5\xB7",
		"\xD1\xC4" => "\xE9\x8C\xA1",
		"\xD1\xC5" => "\xE9\x8C\xA4",
		"\xD1\xC6" => "\xE9\xA3\xA2",
		"\xD1\xC7" => "\xE9\xA5\x91",
		"\xD1\xC8" => "\xE9\xA8\x8E",
		"\xD1\xC9" => "\xE9\xA8\x8F",
		"\xD1\xCA" => "\xE9\xA9\xA5",
		"\xD1\xCB" => "\xE9\xBA\x92",
		"\xD1\xCC" => "\xE7\xB7\x8A",
		"\xD1\xCD" => "\xE4\xBD\xB6",
		"\xD1\xCE" => "\xE5\x90\x89",
		"\xD1\xCF" => "\xE6\x8B\xAE",
		"\xD1\xD0" => "\xE6\xA1\x94",
		"\xD1\xD1" => "\xE9\x87\x91",
		"\xD1\xD2" => "\xE5\x96\xAB",
		"\xD1\xD3" => "\xE5\x84\xBA",
		"\xD1\xD4" => "\xEF\xA4\x8B",
		"\xD1\xD5" => "\xEF\xA4\x8C",
		"\xD1\xD6" => "\xE5\xA8\x9C",
		"\xD1\xD7" => "\xE6\x87\xA6",
		"\xD1\xD8" => "\xEF\xA4\x8D",
		"\xD1\xD9" => "\xE6\x8B\x8F",
		"\xD1\xDA" => "\xE6\x8B\xBF",
		"\xD1\xDB" => "\xEF\xA4\x8E",
		"\xD1\xDC" => "\xEF\xA4\x8F",
		"\xD1\xDD" => "\xEF\xA4\x90",
		"\xD1\xDE" => "\xEF\xA4\x91",
		"\xD1\xDF" => "\xEF\xA4\x92",
		"\xD1\xE0" => "\xEF\xA4\x93",
		"\xD1\xE1" => "\xE9\x82\xA3",
		"\xD1\xE2" => "\xEF\xA4\x94",
		"\xD1\xE3" => "\xEF\xA4\x95",
		"\xD1\xE4" => "\xEF\xA4\x96",
		"\xD1\xE5" => "\xEF\xA4\x97",
		"\xD1\xE6" => "\xEF\xA4\x98",
		"\xD1\xE7" => "\xE8\xAB\xBE",
		"\xD1\xE8" => "\xEF\xA4\x99",
		"\xD1\xE9" => "\xEF\xA4\x9A",
		"\xD1\xEA" => "\xEF\xA4\x9B",
		"\xD1\xEB" => "\xEF\xA4\x9C",
		"\xD1\xEC" => "\xE6\x9A\x96",
		"\xD1\xED" => "\xEF\xA4\x9D",
		"\xD1\xEE" => "\xE7\x85\x96",
		"\xD1\xEF" => "\xEF\xA4\x9E",
		"\xD1\xF0" => "\xEF\xA4\x9F",
		"\xD1\xF1" => "\xE9\x9B\xA3",
		"\xD1\xF2" => "\xEF\xA4\xA0",
		"\xD1\xF3" => "\xE6\x8D\x8F",
		"\xD1\xF4" => "\xE6\x8D\xBA",
		"\xD1\xF5" => "\xE5\x8D\x97",
		"\xD1\xF6" => "\xEF\xA4\xA1",
		"\xD1\xF7" => "\xE6\x9E\x8F",
		"\xD1\xF8" => "\xE6\xA5\xA0",
		"\xD1\xF9" => "\xE6\xB9\xB3",
		"\xD1\xFA" => "\xEF\xA4\xA2",
		"\xD1\xFB" => "\xE7\x94\xB7",
		"\xD1\xFC" => "\xEF\xA4\xA3",
		"\xD1\xFD" => "\xEF\xA4\xA4",
		"\xD1\xFE" => "\xEF\xA4\xA5",
		"\xD2\xA1" => "\xE7\xB4\x8D",
		"\xD2\xA2" => "\xEF\xA4\xA6",
		"\xD2\xA3" => "\xEF\xA4\xA7",
		"\xD2\xA4" => "\xE8\xA1\xB2",
		"\xD2\xA5" => "\xE5\x9B\x8A",
		"\xD2\xA6" => "\xE5\xA8\x98",
		"\xD2\xA7" => "\xEF\xA4\xA8",
		"\xD2\xA8" => "\xEF\xA4\xA9",
		"\xD2\xA9" => "\xEF\xA4\xAA",
		"\xD2\xAA" => "\xEF\xA4\xAB",
		"\xD2\xAB" => "\xEF\xA4\xAC",
		"\xD2\xAC" => "\xE4\xB9\x83",
		"\xD2\xAD" => "\xEF\xA4\xAD",
		"\xD2\xAE" => "\xE5\x85\xA7",
		"\xD2\xAF" => "\xE5\xA5\x88",
		"\xD2\xB0" => "\xE6\x9F\xB0",
		"\xD2\xB1" => "\xE8\x80\x90",
		"\xD2\xB2" => "\xEF\xA4\xAE",
		"\xD2\xB3" => "\xE5\xA5\xB3",
		"\xD2\xB4" => "\xE5\xB9\xB4",
		"\xD2\xB5" => "\xE6\x92\x9A",
		"\xD2\xB6" => "\xE7\xA7\x8A",
		"\xD2\xB7" => "\xE5\xBF\xB5",
		"\xD2\xB8" => "\xE6\x81\xAC",
		"\xD2\xB9" => "\xE6\x8B\x88",
		"\xD2\xBA" => "\xE6\x8D\xBB",
		"\xD2\xBB" => "\xE5\xAF\xA7",
		"\xD2\xBC" => "\xE5\xAF\x97",
		"\xD2\xBD" => "\xE5\x8A\xAA",
		"\xD2\xBE" => "\xEF\xA4\xAF",
		"\xD2\xBF" => "\xE5\xA5\xB4",
		"\xD2\xC0" => "\xE5\xBC\xA9",
		"\xD2\xC1" => "\xE6\x80\x92",
		"\xD2\xC2" => "\xEF\xA4\xB0",
		"\xD2\xC3" => "\xEF\xA4\xB1",
		"\xD2\xC4" => "\xEF\xA4\xB2",
		"\xD2\xC5" => "\xE7\x91\x99",
		"\xD2\xC6" => "\xEF\xA4\xB3",
		"\xD2\xC7" => "\xEF\xA4\xB4",
		"\xD2\xC8" => "\xEF\xA4\xB5",
		"\xD2\xC9" => "\xEF\xA4\xB6",
		"\xD2\xCA" => "\xEF\xA4\xB7",
		"\xD2\xCB" => "\xEF\xA4\xB8",
		"\xD2\xCC" => "\xE9\xA7\x91",
		"\xD2\xCD" => "\xEF\xA4\xB9",
		"\xD2\xCE" => "\xEF\xA4\xBA",
		"\xD2\xCF" => "\xEF\xA4\xBB",
		"\xD2\xD0" => "\xEF\xA4\xBC",
		"\xD2\xD1" => "\xEF\xA4\xBD",
		"\xD2\xD2" => "\xEF\xA4\xBE",
		"\xD2\xD3" => "\xEF\xA4\xBF",
		"\xD2\xD4" => "\xEF\xA5\x80",
		"\xD2\xD5" => "\xEF\xA5\x81",
		"\xD2\xD6" => "\xEF\xA5\x82",
		"\xD2\xD7" => "\xEF\xA5\x83",
		"\xD2\xD8" => "\xE6\xBF\x83",
		"\xD2\xD9" => "\xEF\xA5\x84",
		"\xD2\xDA" => "\xEF\xA5\x85",
		"\xD2\xDB" => "\xE8\x86\xBF",
		"\xD2\xDC" => "\xE8\xBE\xB2",
		"\xD2\xDD" => "\xE6\x83\xB1",
		"\xD2\xDE" => "\xEF\xA5\x86",
		"\xD2\xDF" => "\xEF\xA5\x87",
		"\xD2\xE0" => "\xE8\x85\xA6",
		"\xD2\xE1" => "\xEF\xA5\x88",
		"\xD2\xE2" => "\xEF\xA5\x89",
		"\xD2\xE3" => "\xE5\xB0\xBF",
		"\xD2\xE4" => "\xEF\xA5\x8A",
		"\xD2\xE5" => "\xEF\xA5\x8B",
		"\xD2\xE6" => "\xEF\xA5\x8C",
		"\xD2\xE7" => "\xEF\xA5\x8D",
		"\xD2\xE8" => "\xEF\xA5\x8E",
		"\xD2\xE9" => "\xEF\xA5\x8F",
		"\xD2\xEA" => "\xEF\xA5\x90",
		"\xD2\xEB" => "\xEF\xA5\x91",
		"\xD2\xEC" => "\xE5\xAB\xA9",
		"\xD2\xED" => "\xE8\xA8\xA5",
		"\xD2\xEE" => "\xE6\x9D\xBB",
		"\xD2\xEF" => "\xE7\xB4\x90",
		"\xD2\xF0" => "\xEF\xA5\x92",
		"\xD2\xF1" => "\xEF\xA5\x93",
		"\xD2\xF2" => "\xEF\xA5\x94",
		"\xD2\xF3" => "\xEF\xA5\x95",
		"\xD2\xF4" => "\xEF\xA5\x96",
		"\xD2\xF5" => "\xEF\xA5\x97",
		"\xD2\xF6" => "\xE8\x83\xBD",
		"\xD2\xF7" => "\xEF\xA5\x98",
		"\xD2\xF8" => "\xEF\xA5\x99",
		"\xD2\xF9" => "\xE5\xB0\xBC",
		"\xD2\xFA" => "\xE6\xB3\xA5",
		"\xD2\xFB" => "\xE5\x8C\xBF",
		"\xD2\xFC" => "\xE6\xBA\xBA",
		"\xD2\xFD" => "\xE5\xA4\x9A",
		"\xD2\xFE" => "\xE8\x8C\xB6",
		"\xD3\xA1" => "\xE4\xB8\xB9",
		"\xD3\xA2" => "\xE4\xBA\xB6",
		"\xD3\xA3" => "\xE4\xBD\x86",
		"\xD3\xA4" => "\xE5\x96\xAE",
		"\xD3\xA5" => "\xE5\x9C\x98",
		"\xD3\xA6" => "\xE5\xA3\x87",
		"\xD3\xA7" => "\xE5\xBD\x96",
		"\xD3\xA8" => "\xE6\x96\xB7",
		"\xD3\xA9" => "\xE6\x97\xA6",
		"\xD3\xAA" => "\xE6\xAA\x80",
		"\xD3\xAB" => "\xE6\xAE\xB5",
		"\xD3\xAC" => "\xE6\xB9\x8D",
		"\xD3\xAD" => "\xE7\x9F\xAD",
		"\xD3\xAE" => "\xE7\xAB\xAF",
		"\xD3\xAF" => "\xE7\xB0\x9E",
		"\xD3\xB0" => "\xE7\xB7\x9E",
		"\xD3\xB1" => "\xE8\x9B\x8B",
		"\xD3\xB2" => "\xE8\xA2\x92",
		"\xD3\xB3" => "\xE9\x84\xB2",
		"\xD3\xB4" => "\xE9\x8D\x9B",
		"\xD3\xB5" => "\xE6\x92\xBB",
		"\xD3\xB6" => "\xE6\xBE\xBE",
		"\xD3\xB7" => "\xE7\x8D\xBA",
		"\xD3\xB8" => "\xE7\x96\xB8",
		"\xD3\xB9" => "\xE9\x81\x94",
		"\xD3\xBA" => "\xE5\x95\x96",
		"\xD3\xBB" => "\xE5\x9D\x8D",
		"\xD3\xBC" => "\xE6\x86\xBA",
		"\xD3\xBD" => "\xE6\x93\x94",
		"\xD3\xBE" => "\xE6\x9B\x87",
		"\xD3\xBF" => "\xE6\xB7\xA1",
		"\xD3\xC0" => "\xE6\xB9\x9B",
		"\xD3\xC1" => "\xE6\xBD\xAD",
		"\xD3\xC2" => "\xE6\xBE\xB9",
		"\xD3\xC3" => "\xE7\x97\xB0",
		"\xD3\xC4" => "\xE8\x81\x83",
		"\xD3\xC5" => "\xE8\x86\xBD",
		"\xD3\xC6" => "\xE8\x95\x81",
		"\xD3\xC7" => "\xE8\xA6\x83",
		"\xD3\xC8" => "\xE8\xAB\x87",
		"\xD3\xC9" => "\xE8\xAD\x9A",
		"\xD3\xCA" => "\xE9\x8C\x9F",
		"\xD3\xCB" => "\xE6\xB2\x93",
		"\xD3\xCC" => "\xE7\x95\x93",
		"\xD3\xCD" => "\xE7\xAD\x94",
		"\xD3\xCE" => "\xE8\xB8\x8F",
		"\xD3\xCF" => "\xE9\x81\x9D",
		"\xD3\xD0" => "\xE5\x94\x90",
		"\xD3\xD1" => "\xE5\xA0\x82",
		"\xD3\xD2" => "\xE5\xA1\x98",
		"\xD3\xD3" => "\xE5\xB9\xA2",
		"\xD3\xD4" => "\xE6\x88\x87",
		"\xD3\xD5" => "\xE6\x92\x9E",
		"\xD3\xD6" => "\xE6\xA3\xA0",
		"\xD3\xD7" => "\xE7\x95\xB6",
		"\xD3\xD8" => "\xE7\xB3\x96",
		"\xD3\xD9" => "\xE8\x9E\xB3",
		"\xD3\xDA" => "\xE9\xBB\xA8",
		"\xD3\xDB" => "\xE4\xBB\xA3",
		"\xD3\xDC" => "\xE5\x9E\x88",
		"\xD3\xDD" => "\xE5\x9D\xAE",
		"\xD3\xDE" => "\xE5\xA4\xA7",
		"\xD3\xDF" => "\xE5\xB0\x8D",
		"\xD3\xE0" => "\xE5\xB2\xB1",
		"\xD3\xE1" => "\xE5\xB8\xB6",
		"\xD3\xE2" => "\xE5\xBE\x85",
		"\xD3\xE3" => "\xE6\x88\xB4",
		"\xD3\xE4" => "\xE6\x93\xA1",
		"\xD3\xE5" => "\xE7\x8E\xB3",
		"\xD3\xE6" => "\xE8\x87\xBA",
		"\xD3\xE7" => "\xE8\xA2\x8B",
		"\xD3\xE8" => "\xE8\xB2\xB8",
		"\xD3\xE9" => "\xE9\x9A\x8A",
		"\xD3\xEA" => "\xE9\xBB\x9B",
		"\xD3\xEB" => "\xE5\xAE\x85",
		"\xD3\xEC" => "\xE5\xBE\xB7",
		"\xD3\xED" => "\xE6\x82\xB3",
		"\xD3\xEE" => "\xE5\x80\x92",
		"\xD3\xEF" => "\xE5\x88\x80",
		"\xD3\xF0" => "\xE5\x88\xB0",
		"\xD3\xF1" => "\xE5\x9C\x96",
		"\xD3\xF2" => "\xE5\xA0\xB5",
		"\xD3\xF3" => "\xE5\xA1\x97",
		"\xD3\xF4" => "\xE5\xB0\x8E",
		"\xD3\xF5" => "\xE5\xB1\xA0",
		"\xD3\xF6" => "\xE5\xB3\xB6",
		"\xD3\xF7" => "\xE5\xB6\x8B",
		"\xD3\xF8" => "\xE5\xBA\xA6",
		"\xD3\xF9" => "\xE5\xBE\x92",
		"\xD3\xFA" => "\xE6\x82\xBC",
		"\xD3\xFB" => "\xE6\x8C\x91",
		"\xD3\xFC" => "\xE6\x8E\x89",
		"\xD3\xFD" => "\xE6\x90\x97",
		"\xD3\xFE" => "\xE6\xA1\x83",
		"\xD4\xA1" => "\xE6\xA3\xB9",
		"\xD4\xA2" => "\xE6\xAB\x82",
		"\xD4\xA3" => "\xE6\xB7\x98",
		"\xD4\xA4" => "\xE6\xB8\xA1",
		"\xD4\xA5" => "\xE6\xBB\x94",
		"\xD4\xA6" => "\xE6\xBF\xA4",
		"\xD4\xA7" => "\xE7\x87\xBE",
		"\xD4\xA8" => "\xE7\x9B\x9C",
		"\xD4\xA9" => "\xE7\x9D\xB9",
		"\xD4\xAA" => "\xE7\xA6\xB1",
		"\xD4\xAB" => "\xE7\xA8\xBB",
		"\xD4\xAC" => "\xE8\x90\x84",
		"\xD4\xAD" => "\xE8\xA6\xA9",
		"\xD4\xAE" => "\xE8\xB3\xAD",
		"\xD4\xAF" => "\xE8\xB7\xB3",
		"\xD4\xB0" => "\xE8\xB9\x88",
		"\xD4\xB1" => "\xE9\x80\x83",
		"\xD4\xB2" => "\xE9\x80\x94",
		"\xD4\xB3" => "\xE9\x81\x93",
		"\xD4\xB4" => "\xE9\x83\xBD",
		"\xD4\xB5" => "\xE9\x8D\x8D",
		"\xD4\xB6" => "\xE9\x99\xB6",
		"\xD4\xB7" => "\xE9\x9F\x9C",
		"\xD4\xB8" => "\xE6\xAF\x92",
		"\xD4\xB9" => "\xE7\x80\x86",
		"\xD4\xBA" => "\xE7\x89\x98",
		"\xD4\xBB" => "\xE7\x8A\xA2",
		"\xD4\xBC" => "\xE7\x8D\xA8",
		"\xD4\xBD" => "\xE7\x9D\xA3",
		"\xD4\xBE" => "\xE7\xA6\xBF",
		"\xD4\xBF" => "\xE7\xAF\xA4",
		"\xD4\xC0" => "\xE7\xBA\x9B",
		"\xD4\xC1" => "\xE8\xAE\x80",
		"\xD4\xC2" => "\xE5\xA2\xA9",
		"\xD4\xC3" => "\xE6\x83\x87",
		"\xD4\xC4" => "\xE6\x95\xA6",
		"\xD4\xC5" => "\xE6\x97\xBD",
		"\xD4\xC6" => "\xE6\x9A\xBE",
		"\xD4\xC7" => "\xE6\xB2\x8C",
		"\xD4\xC8" => "\xE7\x84\x9E",
		"\xD4\xC9" => "\xE7\x87\x89",
		"\xD4\xCA" => "\xE8\xB1\x9A",
		"\xD4\xCB" => "\xE9\xA0\x93",
		"\xD4\xCC" => "\xE4\xB9\xAD",
		"\xD4\xCD" => "\xE7\xAA\x81",
		"\xD4\xCE" => "\xE4\xBB\x9D",
		"\xD4\xCF" => "\xE5\x86\xAC",
		"\xD4\xD0" => "\xE5\x87\x8D",
		"\xD4\xD1" => "\xE5\x8B\x95",
		"\xD4\xD2" => "\xE5\x90\x8C",
		"\xD4\xD3" => "\xE6\x86\xA7",
		"\xD4\xD4" => "\xE6\x9D\xB1",
		"\xD4\xD5" => "\xE6\xA1\x90",
		"\xD4\xD6" => "\xE6\xA3\x9F",
		"\xD4\xD7" => "\xE6\xB4\x9E",
		"\xD4\xD8" => "\xE6\xBD\xBC",
		"\xD4\xD9" => "\xE7\x96\xBC",
		"\xD4\xDA" => "\xE7\x9E\xB3",
		"\xD4\xDB" => "\xE7\xAB\xA5",
		"\xD4\xDC" => "\xE8\x83\xB4",
		"\xD4\xDD" => "\xE8\x91\xA3",
		"\xD4\xDE" => "\xE9\x8A\x85",
		"\xD4\xDF" => "\xE5\x85\x9C",
		"\xD4\xE0" => "\xE6\x96\x97",
		"\xD4\xE1" => "\xE6\x9D\x9C",
		"\xD4\xE2" => "\xE6\x9E\x93",
		"\xD4\xE3" => "\xE7\x97\x98",
		"\xD4\xE4" => "\xE7\xAB\x87",
		"\xD4\xE5" => "\xE8\x8D\xB3",
		"\xD4\xE6" => "\xEF\xA5\x9A",
		"\xD4\xE7" => "\xE8\xB1\x86",
		"\xD4\xE8" => "\xE9\x80\x97",
		"\xD4\xE9" => "\xE9\xA0\xAD",
		"\xD4\xEA" => "\xE5\xB1\xAF",
		"\xD4\xEB" => "\xE8\x87\x80",
		"\xD4\xEC" => "\xE8\x8A\x9A",
		"\xD4\xED" => "\xE9\x81\x81",
		"\xD4\xEE" => "\xE9\x81\xAF",
		"\xD4\xEF" => "\xE9\x88\x8D",
		"\xD4\xF0" => "\xE5\xBE\x97",
		"\xD4\xF1" => "\xE5\xB6\x9D",
		"\xD4\xF2" => "\xE6\xA9\x99",
		"\xD4\xF3" => "\xE7\x87\x88",
		"\xD4\xF4" => "\xE7\x99\xBB",
		"\xD4\xF5" => "\xE7\xAD\x89",
		"\xD4\xF6" => "\xE8\x97\xA4",
		"\xD4\xF7" => "\xE8\xAC\x84",
		"\xD4\xF8" => "\xE9\x84\xA7",
		"\xD4\xF9" => "\xE9\xA8\xB0",
		"\xD4\xFA" => "\xE5\x96\x87",
		"\xD4\xFB" => "\xE6\x87\xB6",
		"\xD4\xFC" => "\xEF\xA5\x9B",
		"\xD4\xFD" => "\xE7\x99\xA9",
		"\xD4\xFE" => "\xE7\xBE\x85",
		"\xD5\xA1" => "\xE8\x98\xBF",
		"\xD5\xA2" => "\xE8\x9E\xBA",
		"\xD5\xA3" => "\xE8\xA3\xB8",
		"\xD5\xA4" => "\xE9\x82\x8F",
		"\xD5\xA5" => "\xEF\xA5\x9C",
		"\xD5\xA6" => "\xE6\xB4\x9B",
		"\xD5\xA7" => "\xE7\x83\x99",
		"\xD5\xA8" => "\xE7\x8F\x9E",
		"\xD5\xA9" => "\xE7\xB5\xA1",
		"\xD5\xAA" => "\xE8\x90\xBD",
		"\xD5\xAB" => "\xEF\xA5\x9D",
		"\xD5\xAC" => "\xE9\x85\xAA",
		"\xD5\xAD" => "\xE9\xA7\xB1",
		"\xD5\xAE" => "\xEF\xA5\x9E",
		"\xD5\xAF" => "\xE4\xBA\x82",
		"\xD5\xB0" => "\xE5\x8D\xB5",
		"\xD5\xB1" => "\xE6\xAC\x84",
		"\xD5\xB2" => "\xE6\xAC\x92",
		"\xD5\xB3" => "\xE7\x80\xBE",
		"\xD5\xB4" => "\xE7\x88\x9B",
		"\xD5\xB5" => "\xE8\x98\xAD",
		"\xD5\xB6" => "\xE9\xB8\x9E",
		"\xD5\xB7" => "\xE5\x89\x8C",
		"\xD5\xB8" => "\xE8\xBE\xA3",
		"\xD5\xB9" => "\xE5\xB5\x90",
		"\xD5\xBA" => "\xE6\x93\xA5",
		"\xD5\xBB" => "\xE6\x94\xAC",
		"\xD5\xBC" => "\xE6\xAC\x96",
		"\xD5\xBD" => "\xE6\xBF\xAB",
		"\xD5\xBE" => "\xE7\xB1\x83",
		"\xD5\xBF" => "\xE7\xBA\x9C",
		"\xD5\xC0" => "\xE8\x97\x8D",
		"\xD5\xC1" => "\xE8\xA5\xA4",
		"\xD5\xC2" => "\xE8\xA6\xBD",
		"\xD5\xC3" => "\xE6\x8B\x89",
		"\xD5\xC4" => "\xE8\x87\x98",
		"\xD5\xC5" => "\xE8\xA0\x9F",
		"\xD5\xC6" => "\xE5\xBB\x8A",
		"\xD5\xC7" => "\xE6\x9C\x97",
		"\xD5\xC8" => "\xE6\xB5\xAA",
		"\xD5\xC9" => "\xE7\x8B\xBC",
		"\xD5\xCA" => "\xE7\x90\x85",
		"\xD5\xCB" => "\xE7\x91\xAF",
		"\xD5\xCC" => "\xE8\x9E\x82",
		"\xD5\xCD" => "\xE9\x83\x9E",
		"\xD5\xCE" => "\xE4\xBE\x86",
		"\xD5\xCF" => "\xE5\xB4\x8D",
		"\xD5\xD0" => "\xE5\xBE\xA0",
		"\xD5\xD1" => "\xE8\x90\x8A",
		"\xD5\xD2" => "\xE5\x86\xB7",
		"\xD5\xD3" => "\xE6\x8E\xA0",
		"\xD5\xD4" => "\xE7\x95\xA5",
		"\xD5\xD5" => "\xE4\xBA\xAE",
		"\xD5\xD6" => "\xE5\x80\x86",
		"\xD5\xD7" => "\xE5\x85\xA9",
		"\xD5\xD8" => "\xE5\x87\x89",
		"\xD5\xD9" => "\xE6\xA2\x81",
		"\xD5\xDA" => "\xE6\xA8\x91",
		"\xD5\xDB" => "\xE7\xB2\xAE",
		"\xD5\xDC" => "\xE7\xB2\xB1",
		"\xD5\xDD" => "\xE7\xB3\xA7",
		"\xD5\xDE" => "\xE8\x89\xAF",
		"\xD5\xDF" => "\xE8\xAB\x92",
		"\xD5\xE0" => "\xE8\xBC\x9B",
		"\xD5\xE1" => "\xE9\x87\x8F",
		"\xD5\xE2" => "\xE4\xBE\xB6",
		"\xD5\xE3" => "\xE5\x84\xB7",
		"\xD5\xE4" => "\xE5\x8B\xB5",
		"\xD5\xE5" => "\xE5\x91\x82",
		"\xD5\xE6" => "\xE5\xBB\xAC",
		"\xD5\xE7" => "\xE6\x85\xAE",
		"\xD5\xE8" => "\xE6\x88\xBE",
		"\xD5\xE9" => "\xE6\x97\x85",
		"\xD5\xEA" => "\xE6\xAB\x9A",
		"\xD5\xEB" => "\xE6\xBF\xBE",
		"\xD5\xEC" => "\xE7\xA4\xAA",
		"\xD5\xED" => "\xE8\x97\x9C",
		"\xD5\xEE" => "\xE8\xA0\xA3",
		"\xD5\xEF" => "\xE9\x96\xAD",
		"\xD5\xF0" => "\xE9\xA9\xA2",
		"\xD5\xF1" => "\xE9\xA9\xAA",
		"\xD5\xF2" => "\xE9\xBA\x97",
		"\xD5\xF3" => "\xE9\xBB\x8E",
		"\xD5\xF4" => "\xE5\x8A\x9B",
		"\xD5\xF5" => "\xE6\x9B\x86",
		"\xD5\xF6" => "\xE6\xAD\xB7",
		"\xD5\xF7" => "\xE7\x80\x9D",
		"\xD5\xF8" => "\xE7\xA4\xAB",
		"\xD5\xF9" => "\xE8\xBD\xA2",
		"\xD5\xFA" => "\xE9\x9D\x82",
		"\xD5\xFB" => "\xE6\x86\x90",
		"\xD5\xFC" => "\xE6\x88\x80",
		"\xD5\xFD" => "\xE6\x94\xA3",
		"\xD5\xFE" => "\xE6\xBC\xA3",
		"\xD6\xA1" => "\xE7\x85\x89",
		"\xD6\xA2" => "\xE7\x92\x89",
		"\xD6\xA3" => "\xE7\xB7\xB4",
		"\xD6\xA4" => "\xE8\x81\xAF",
		"\xD6\xA5" => "\xE8\x93\xAE",
		"\xD6\xA6" => "\xE8\xBC\xA6",
		"\xD6\xA7" => "\xE9\x80\xA3",
		"\xD6\xA8" => "\xE9\x8D\x8A",
		"\xD6\xA9" => "\xE5\x86\xBD",
		"\xD6\xAA" => "\xE5\x88\x97",
		"\xD6\xAB" => "\xE5\x8A\xA3",
		"\xD6\xAC" => "\xE6\xB4\x8C",
		"\xD6\xAD" => "\xE7\x83\x88",
		"\xD6\xAE" => "\xE8\xA3\x82",
		"\xD6\xAF" => "\xE5\xBB\x89",
		"\xD6\xB0" => "\xE6\x96\x82",
		"\xD6\xB1" => "\xE6\xAE\xAE",
		"\xD6\xB2" => "\xE6\xBF\x82",
		"\xD6\xB3" => "\xE7\xB0\xBE",
		"\xD6\xB4" => "\xE7\x8D\xB5",
		"\xD6\xB5" => "\xE4\xBB\xA4",
		"\xD6\xB6" => "\xE4\xBC\xB6",
		"\xD6\xB7" => "\xE5\x9B\xB9",
		"\xD6\xB8" => "\xEF\xA5\x9F",
		"\xD6\xB9" => "\xE5\xB2\xBA",
		"\xD6\xBA" => "\xE5\xB6\xBA",
		"\xD6\xBB" => "\xE6\x80\x9C",
		"\xD6\xBC" => "\xE7\x8E\xB2",
		"\xD6\xBD" => "\xE7\xAC\xAD",
		"\xD6\xBE" => "\xE7\xBE\x9A",
		"\xD6\xBF" => "\xE7\xBF\x8E",
		"\xD6\xC0" => "\xE8\x81\x86",
		"\xD6\xC1" => "\xE9\x80\x9E",
		"\xD6\xC2" => "\xE9\x88\xB4",
		"\xD6\xC3" => "\xE9\x9B\xB6",
		"\xD6\xC4" => "\xE9\x9D\x88",
		"\xD6\xC5" => "\xE9\xA0\x98",
		"\xD6\xC6" => "\xE9\xBD\xA1",
		"\xD6\xC7" => "\xE4\xBE\x8B",
		"\xD6\xC8" => "\xE6\xBE\xA7",
		"\xD6\xC9" => "\xE7\xA6\xAE",
		"\xD6\xCA" => "\xE9\x86\xB4",
		"\xD6\xCB" => "\xE9\x9A\xB7",
		"\xD6\xCC" => "\xE5\x8B\x9E",
		"\xD6\xCD" => "\xEF\xA5\xA0",
		"\xD6\xCE" => "\xE6\x92\x88",
		"\xD6\xCF" => "\xE6\x93\x84",
		"\xD6\xD0" => "\xE6\xAB\x93",
		"\xD6\xD1" => "\xE6\xBD\x9E",
		"\xD6\xD2" => "\xE7\x80\x98",
		"\xD6\xD3" => "\xE7\x88\x90",
		"\xD6\xD4" => "\xE7\x9B\xA7",
		"\xD6\xD5" => "\xE8\x80\x81",
		"\xD6\xD6" => "\xE8\x98\x86",
		"\xD6\xD7" => "\xE8\x99\x9C",
		"\xD6\xD8" => "\xE8\xB7\xAF",
		"\xD6\xD9" => "\xE8\xBC\x85",
		"\xD6\xDA" => "\xE9\x9C\xB2",
		"\xD6\xDB" => "\xE9\xAD\xAF",
		"\xD6\xDC" => "\xE9\xB7\xBA",
		"\xD6\xDD" => "\xE9\xB9\xB5",
		"\xD6\xDE" => "\xE7\xA2\x8C",
		"\xD6\xDF" => "\xE7\xA5\xBF",
		"\xD6\xE0" => "\xE7\xB6\xA0",
		"\xD6\xE1" => "\xE8\x8F\x89",
		"\xD6\xE2" => "\xE9\x8C\x84",
		"\xD6\xE3" => "\xE9\xB9\xBF",
		"\xD6\xE4" => "\xE9\xBA\x93",
		"\xD6\xE5" => "\xE8\xAB\x96",
		"\xD6\xE6" => "\xE5\xA3\x9F",
		"\xD6\xE7" => "\xE5\xBC\x84",
		"\xD6\xE8" => "\xE6\x9C\xA7",
		"\xD6\xE9" => "\xE7\x80\xA7",
		"\xD6\xEA" => "\xE7\x93\x8F",
		"\xD6\xEB" => "\xE7\xB1\xA0",
		"\xD6\xEC" => "\xE8\x81\xBE",
		"\xD6\xED" => "\xE5\x84\xA1",
		"\xD6\xEE" => "\xE7\x80\xA8",
		"\xD6\xEF" => "\xE7\x89\xA2",
		"\xD6\xF0" => "\xE7\xA3\x8A",
		"\xD6\xF1" => "\xE8\xB3\x82",
		"\xD6\xF2" => "\xE8\xB3\x9A",
		"\xD6\xF3" => "\xE8\xB3\xB4",
		"\xD6\xF4" => "\xE9\x9B\xB7",
		"\xD6\xF5" => "\xE4\xBA\x86",
		"\xD6\xF6" => "\xE5\x83\x9A",
		"\xD6\xF7" => "\xE5\xAF\xAE",
		"\xD6\xF8" => "\xE5\xBB\x96",
		"\xD6\xF9" => "\xE6\x96\x99",
		"\xD6\xFA" => "\xE7\x87\x8E",
		"\xD6\xFB" => "\xE7\x99\x82",
		"\xD6\xFC" => "\xE7\x9E\xAD",
		"\xD6\xFD" => "\xE8\x81\x8A",
		"\xD6\xFE" => "\xE8\x93\xBC",
		"\xD7\xA1" => "\xE9\x81\xBC",
		"\xD7\xA2" => "\xE9\xAC\xA7",
		"\xD7\xA3" => "\xE9\xBE\x8D",
		"\xD7\xA4" => "\xE5\xA3\x98",
		"\xD7\xA5" => "\xE5\xA9\x81",
		"\xD7\xA6" => "\xE5\xB1\xA2",
		"\xD7\xA7" => "\xE6\xA8\x93",
		"\xD7\xA8" => "\xE6\xB7\x9A",
		"\xD7\xA9" => "\xE6\xBC\x8F",
		"\xD7\xAA" => "\xE7\x98\xBB",
		"\xD7\xAB" => "\xE7\xB4\xAF",
		"\xD7\xAC" => "\xE7\xB8\xB7",
		"\xD7\xAD" => "\xE8\x94\x9E",
		"\xD7\xAE" => "\xE8\xA4\xB8",
		"\xD7\xAF" => "\xE9\x8F\xA4",
		"\xD7\xB0" => "\xE9\x99\x8B",
		"\xD7\xB1" => "\xE5\x8A\x89",
		"\xD7\xB2" => "\xE6\x97\x92",
		"\xD7\xB3" => "\xE6\x9F\xB3",
		"\xD7\xB4" => "\xE6\xA6\xB4",
		"\xD7\xB5" => "\xE6\xB5\x81",
		"\xD7\xB6" => "\xE6\xBA\x9C",
		"\xD7\xB7" => "\xE7\x80\x8F",
		"\xD7\xB8" => "\xE7\x90\x89",
		"\xD7\xB9" => "\xE7\x91\xA0",
		"\xD7\xBA" => "\xE7\x95\x99",
		"\xD7\xBB" => "\xE7\x98\xA4",
		"\xD7\xBC" => "\xE7\xA1\xAB",
		"\xD7\xBD" => "\xE8\xAC\xAC",
		"\xD7\xBE" => "\xE9\xA1\x9E",
		"\xD7\xBF" => "\xE5\x85\xAD",
		"\xD7\xC0" => "\xE6\x88\xAE",
		"\xD7\xC1" => "\xE9\x99\xB8",
		"\xD7\xC2" => "\xE4\xBE\x96",
		"\xD7\xC3" => "\xE5\x80\xAB",
		"\xD7\xC4" => "\xE5\xB4\x99",
		"\xD7\xC5" => "\xE6\xB7\xAA",
		"\xD7\xC6" => "\xE7\xB6\xB8",
		"\xD7\xC7" => "\xE8\xBC\xAA",
		"\xD7\xC8" => "\xE5\xBE\x8B",
		"\xD7\xC9" => "\xE6\x85\x84",
		"\xD7\xCA" => "\xE6\xA0\x97",
		"\xD7\xCB" => "\xEF\xA5\xA1",
		"\xD7\xCC" => "\xE9\x9A\x86",
		"\xD7\xCD" => "\xE5\x8B\x92",
		"\xD7\xCE" => "\xE8\x82\x8B",
		"\xD7\xCF" => "\xE5\x87\x9C",
		"\xD7\xD0" => "\xE5\x87\x8C",
		"\xD7\xD1" => "\xE6\xA5\x9E",
		"\xD7\xD2" => "\xE7\xA8\x9C",
		"\xD7\xD3" => "\xE7\xB6\xBE",
		"\xD7\xD4" => "\xE8\x8F\xB1",
		"\xD7\xD5" => "\xE9\x99\xB5",
		"\xD7\xD6" => "\xE4\xBF\x9A",
		"\xD7\xD7" => "\xE5\x88\xA9",
		"\xD7\xD8" => "\xE5\x8E\x98",
		"\xD7\xD9" => "\xE5\x90\x8F",
		"\xD7\xDA" => "\xE5\x94\x8E",
		"\xD7\xDB" => "\xE5\xB1\xA5",
		"\xD7\xDC" => "\xE6\x82\xA7",
		"\xD7\xDD" => "\xE6\x9D\x8E",
		"\xD7\xDE" => "\xE6\xA2\xA8",
		"\xD7\xDF" => "\xE6\xB5\xAC",
		"\xD7\xE0" => "\xE7\x8A\x81",
		"\xD7\xE1" => "\xE7\x8B\xB8",
		"\xD7\xE2" => "\xE7\x90\x86",
		"\xD7\xE3" => "\xE7\x92\x83",
		"\xD7\xE4" => "\xEF\xA5\xA2",
		"\xD7\xE5" => "\xE7\x97\xA2",
		"\xD7\xE6" => "\xE7\xB1\xAC",
		"\xD7\xE7" => "\xE7\xBD\xB9",
		"\xD7\xE8" => "\xE7\xBE\xB8",
		"\xD7\xE9" => "\xE8\x8E\x89",
		"\xD7\xEA" => "\xE8\xA3\x8F",
		"\xD7\xEB" => "\xE8\xA3\xA1",
		"\xD7\xEC" => "\xE9\x87\x8C",
		"\xD7\xED" => "\xE9\x87\x90",
		"\xD7\xEE" => "\xE9\x9B\xA2",
		"\xD7\xEF" => "\xE9\xAF\x89",
		"\xD7\xF0" => "\xE5\x90\x9D",
		"\xD7\xF1" => "\xE6\xBD\xBE",
		"\xD7\xF2" => "\xE7\x87\x90",
		"\xD7\xF3" => "\xE7\x92\x98",
		"\xD7\xF4" => "\xE8\x97\xBA",
		"\xD7\xF5" => "\xE8\xBA\xAA",
		"\xD7\xF6" => "\xE9\x9A\xA3",
		"\xD7\xF7" => "\xE9\xB1\x97",
		"\xD7\xF8" => "\xE9\xBA\x9F",
		"\xD7\xF9" => "\xE6\x9E\x97",
		"\xD7\xFA" => "\xE6\xB7\x8B",
		"\xD7\xFB" => "\xE7\x90\xB3",
		"\xD7\xFC" => "\xE8\x87\xA8",
		"\xD7\xFD" => "\xE9\x9C\x96",
		"\xD7\xFE" => "\xE7\xA0\xAC",
		"\xD8\xA1" => "\xE7\xAB\x8B",
		"\xD8\xA2" => "\xE7\xAC\xA0",
		"\xD8\xA3" => "\xE7\xB2\x92",
		"\xD8\xA4" => "\xE6\x91\xA9",
		"\xD8\xA5" => "\xE7\x91\xAA",
		"\xD8\xA6" => "\xE7\x97\xB2",
		"\xD8\xA7" => "\xE7\xA2\xBC",
		"\xD8\xA8" => "\xE7\xA3\xA8",
		"\xD8\xA9" => "\xE9\xA6\xAC",
		"\xD8\xAA" => "\xE9\xAD\x94",
		"\xD8\xAB" => "\xE9\xBA\xBB",
		"\xD8\xAC" => "\xE5\xAF\x9E",
		"\xD8\xAD" => "\xE5\xB9\x95",
		"\xD8\xAE" => "\xE6\xBC\xA0",
		"\xD8\xAF" => "\xE8\x86\x9C",
		"\xD8\xB0" => "\xE8\x8E\xAB",
		"\xD8\xB1" => "\xE9\x82\x88",
		"\xD8\xB2" => "\xE4\xB8\x87",
		"\xD8\xB3" => "\xE5\x8D\x8D",
		"\xD8\xB4" => "\xE5\xA8\xA9",
		"\xD8\xB5" => "\xE5\xB7\x92",
		"\xD8\xB6" => "\xE5\xBD\x8E",
		"\xD8\xB7" => "\xE6\x85\xA2",
		"\xD8\xB8" => "\xE6\x8C\xBD",
		"\xD8\xB9" => "\xE6\x99\xA9",
		"\xD8\xBA" => "\xE6\x9B\xBC",
		"\xD8\xBB" => "\xE6\xBB\xBF",
		"\xD8\xBC" => "\xE6\xBC\xAB",
		"\xD8\xBD" => "\xE7\x81\xA3",
		"\xD8\xBE" => "\xE7\x9E\x9E",
		"\xD8\xBF" => "\xE8\x90\xAC",
		"\xD8\xC0" => "\xE8\x94\x93",
		"\xD8\xC1" => "\xE8\xA0\xBB",
		"\xD8\xC2" => "\xE8\xBC\x93",
		"\xD8\xC3" => "\xE9\xA5\x85",
		"\xD8\xC4" => "\xE9\xB0\xBB",
		"\xD8\xC5" => "\xE5\x94\x9C",
		"\xD8\xC6" => "\xE6\x8A\xB9",
		"\xD8\xC7" => "\xE6\x9C\xAB",
		"\xD8\xC8" => "\xE6\xB2\xAB",
		"\xD8\xC9" => "\xE8\x8C\x89",
		"\xD8\xCA" => "\xE8\xA5\xAA",
		"\xD8\xCB" => "\xE9\x9D\xBA",
		"\xD8\xCC" => "\xE4\xBA\xA1",
		"\xD8\xCD" => "\xE5\xA6\x84",
		"\xD8\xCE" => "\xE5\xBF\x98",
		"\xD8\xCF" => "\xE5\xBF\x99",
		"\xD8\xD0" => "\xE6\x9C\x9B",
		"\xD8\xD1" => "\xE7\xB6\xB2",
		"\xD8\xD2" => "\xE7\xBD\x94",
		"\xD8\xD3" => "\xE8\x8A\x92",
		"\xD8\xD4" => "\xE8\x8C\xAB",
		"\xD8\xD5" => "\xE8\x8E\xBD",
		"\xD8\xD6" => "\xE8\xBC\x9E",
		"\xD8\xD7" => "\xE9\x82\x99",
		"\xD8\xD8" => "\xE5\x9F\x8B",
		"\xD8\xD9" => "\xE5\xA6\xB9",
		"\xD8\xDA" => "\xE5\xAA\x92",
		"\xD8\xDB" => "\xE5\xAF\x90",
		"\xD8\xDC" => "\xE6\x98\xA7",
		"\xD8\xDD" => "\xE6\x9E\x9A",
		"\xD8\xDE" => "\xE6\xA2\x85",
		"\xD8\xDF" => "\xE6\xAF\x8F",
		"\xD8\xE0" => "\xE7\x85\xA4",
		"\xD8\xE1" => "\xE7\xBD\xB5",
		"\xD8\xE2" => "\xE8\xB2\xB7",
		"\xD8\xE3" => "\xE8\xB3\xA3",
		"\xD8\xE4" => "\xE9\x82\x81",
		"\xD8\xE5" => "\xE9\xAD\x85",
		"\xD8\xE6" => "\xE8\x84\x88",
		"\xD8\xE7" => "\xE8\xB2\x8A",
		"\xD8\xE8" => "\xE9\x99\x8C",
		"\xD8\xE9" => "\xE9\xA9\x80",
		"\xD8\xEA" => "\xE9\xBA\xA5",
		"\xD8\xEB" => "\xE5\xAD\x9F",
		"\xD8\xEC" => "\xE6\xB0\x93",
		"\xD8\xED" => "\xE7\x8C\x9B",
		"\xD8\xEE" => "\xE7\x9B\xB2",
		"\xD8\xEF" => "\xE7\x9B\x9F",
		"\xD8\xF0" => "\xE8\x90\x8C",
		"\xD8\xF1" => "\xE5\x86\xAA",
		"\xD8\xF2" => "\xE8\xA6\x93",
		"\xD8\xF3" => "\xE5\x85\x8D",
		"\xD8\xF4" => "\xE5\x86\x95",
		"\xD8\xF5" => "\xE5\x8B\x89",
		"\xD8\xF6" => "\xE6\xA3\x89",
		"\xD8\xF7" => "\xE6\xB2\x94",
		"\xD8\xF8" => "\xE7\x9C\x84",
		"\xD8\xF9" => "\xE7\x9C\xA0",
		"\xD8\xFA" => "\xE7\xB6\xBF",
		"\xD8\xFB" => "\xE7\xB7\xAC",
		"\xD8\xFC" => "\xE9\x9D\xA2",
		"\xD8\xFD" => "\xE9\xBA\xB5",
		"\xD8\xFE" => "\xE6\xBB\x85",
		"\xD9\xA1" => "\xE8\x94\x91",
		"\xD9\xA2" => "\xE5\x86\xA5",
		"\xD9\xA3" => "\xE5\x90\x8D",
		"\xD9\xA4" => "\xE5\x91\xBD",
		"\xD9\xA5" => "\xE6\x98\x8E",
		"\xD9\xA6" => "\xE6\x9A\x9D",
		"\xD9\xA7" => "\xE6\xA4\xA7",
		"\xD9\xA8" => "\xE6\xBA\x9F",
		"\xD9\xA9" => "\xE7\x9A\xBF",
		"\xD9\xAA" => "\xE7\x9E\x91",
		"\xD9\xAB" => "\xE8\x8C\x97",
		"\xD9\xAC" => "\xE8\x93\x82",
		"\xD9\xAD" => "\xE8\x9E\x9F",
		"\xD9\xAE" => "\xE9\x85\xA9",
		"\xD9\xAF" => "\xE9\x8A\x98",
		"\xD9\xB0" => "\xE9\xB3\xB4",
		"\xD9\xB1" => "\xE8\xA2\x82",
		"\xD9\xB2" => "\xE4\xBE\xAE",
		"\xD9\xB3" => "\xE5\x86\x92",
		"\xD9\xB4" => "\xE5\x8B\x9F",
		"\xD9\xB5" => "\xE5\xA7\x86",
		"\xD9\xB6" => "\xE5\xB8\xBD",
		"\xD9\xB7" => "\xE6\x85\x95",
		"\xD9\xB8" => "\xE6\x91\xB8",
		"\xD9\xB9" => "\xE6\x91\xB9",
		"\xD9\xBA" => "\xE6\x9A\xAE",
		"\xD9\xBB" => "\xE6\x9F\x90",
		"\xD9\xBC" => "\xE6\xA8\xA1",
		"\xD9\xBD" => "\xE6\xAF\x8D",
		"\xD9\xBE" => "\xE6\xAF\x9B",
		"\xD9\xBF" => "\xE7\x89\x9F",
		"\xD9\xC0" => "\xE7\x89\xA1",
		"\xD9\xC1" => "\xE7\x91\x81",
		"\xD9\xC2" => "\xE7\x9C\xB8",
		"\xD9\xC3" => "\xE7\x9F\x9B",
		"\xD9\xC4" => "\xE8\x80\x97",
		"\xD9\xC5" => "\xE8\x8A\xBC",
		"\xD9\xC6" => "\xE8\x8C\x85",
		"\xD9\xC7" => "\xE8\xAC\x80",
		"\xD9\xC8" => "\xE8\xAC\xA8",
		"\xD9\xC9" => "\xE8\xB2\x8C",
		"\xD9\xCA" => "\xE6\x9C\xA8",
		"\xD9\xCB" => "\xE6\xB2\x90",
		"\xD9\xCC" => "\xE7\x89\xA7",
		"\xD9\xCD" => "\xE7\x9B\xAE",
		"\xD9\xCE" => "\xE7\x9D\xA6",
		"\xD9\xCF" => "\xE7\xA9\x86",
		"\xD9\xD0" => "\xE9\xB6\xA9",
		"\xD9\xD1" => "\xE6\xAD\xBF",
		"\xD9\xD2" => "\xE6\xB2\x92",
		"\xD9\xD3" => "\xE5\xA4\xA2",
		"\xD9\xD4" => "\xE6\x9C\xA6",
		"\xD9\xD5" => "\xE8\x92\x99",
		"\xD9\xD6" => "\xE5\x8D\xAF",
		"\xD9\xD7" => "\xE5\xA2\x93",
		"\xD9\xD8" => "\xE5\xA6\x99",
		"\xD9\xD9" => "\xE5\xBB\x9F",
		"\xD9\xDA" => "\xE6\x8F\x8F",
		"\xD9\xDB" => "\xE6\x98\xB4",
		"\xD9\xDC" => "\xE6\x9D\xB3",
		"\xD9\xDD" => "\xE6\xB8\xBA",
		"\xD9\xDE" => "\xE7\x8C\xAB",
		"\xD9\xDF" => "\xE7\xAB\x97",
		"\xD9\xE0" => "\xE8\x8B\x97",
		"\xD9\xE1" => "\xE9\x8C\xA8",
		"\xD9\xE2" => "\xE5\x8B\x99",
		"\xD9\xE3" => "\xE5\xB7\xAB",
		"\xD9\xE4" => "\xE6\x86\xAE",
		"\xD9\xE5" => "\xE6\x87\x8B",
		"\xD9\xE6" => "\xE6\x88\x8A",
		"\xD9\xE7" => "\xE6\x8B\x87",
		"\xD9\xE8" => "\xE6\x92\xAB",
		"\xD9\xE9" => "\xE6\x97\xA0",
		"\xD9\xEA" => "\xE6\xA5\x99",
		"\xD9\xEB" => "\xE6\xAD\xA6",
		"\xD9\xEC" => "\xE6\xAF\x8B",
		"\xD9\xED" => "\xE7\x84\xA1",
		"\xD9\xEE" => "\xE7\x8F\xB7",
		"\xD9\xEF" => "\xE7\x95\x9D",
		"\xD9\xF0" => "\xE7\xB9\x86",
		"\xD9\xF1" => "\xE8\x88\x9E",
		"\xD9\xF2" => "\xE8\x8C\x82",
		"\xD9\xF3" => "\xE8\x95\xAA",
		"\xD9\xF4" => "\xE8\xAA\xA3",
		"\xD9\xF5" => "\xE8\xB2\xBF",
		"\xD9\xF6" => "\xE9\x9C\xA7",
		"\xD9\xF7" => "\xE9\xB5\xA1",
		"\xD9\xF8" => "\xE5\xA2\xA8",
		"\xD9\xF9" => "\xE9\xBB\x98",
		"\xD9\xFA" => "\xE5\x80\x91",
		"\xD9\xFB" => "\xE5\x88\x8E",
		"\xD9\xFC" => "\xE5\x90\xBB",
		"\xD9\xFD" => "\xE5\x95\x8F",
		"\xD9\xFE" => "\xE6\x96\x87",
		"\xDA\xA1" => "\xE6\xB1\xB6",
		"\xDA\xA2" => "\xE7\xB4\x8A",
		"\xDA\xA3" => "\xE7\xB4\x8B",
		"\xDA\xA4" => "\xE8\x81\x9E",
		"\xDA\xA5" => "\xE8\x9A\x8A",
		"\xDA\xA6" => "\xE9\x96\x80",
		"\xDA\xA7" => "\xE9\x9B\xAF",
		"\xDA\xA8" => "\xE5\x8B\xBF",
		"\xDA\xA9" => "\xE6\xB2\x95",
		"\xDA\xAA" => "\xE7\x89\xA9",
		"\xDA\xAB" => "\xE5\x91\xB3",
		"\xDA\xAC" => "\xE5\xAA\x9A",
		"\xDA\xAD" => "\xE5\xB0\xBE",
		"\xDA\xAE" => "\xE5\xB5\x8B",
		"\xDA\xAF" => "\xE5\xBD\x8C",
		"\xDA\xB0" => "\xE5\xBE\xAE",
		"\xDA\xB1" => "\xE6\x9C\xAA",
		"\xDA\xB2" => "\xE6\xA2\xB6",
		"\xDA\xB3" => "\xE6\xA5\xA3",
		"\xDA\xB4" => "\xE6\xB8\xBC",
		"\xDA\xB5" => "\xE6\xB9\x84",
		"\xDA\xB6" => "\xE7\x9C\x89",
		"\xDA\xB7" => "\xE7\xB1\xB3",
		"\xDA\xB8" => "\xE7\xBE\x8E",
		"\xDA\xB9" => "\xE8\x96\x87",
		"\xDA\xBA" => "\xE8\xAC\x8E",
		"\xDA\xBB" => "\xE8\xBF\xB7",
		"\xDA\xBC" => "\xE9\x9D\xA1",
		"\xDA\xBD" => "\xE9\xBB\xB4",
		"\xDA\xBE" => "\xE5\xB2\xB7",
		"\xDA\xBF" => "\xE6\x82\xB6",
		"\xDA\xC0" => "\xE6\x84\x8D",
		"\xDA\xC1" => "\xE6\x86\xAB",
		"\xDA\xC2" => "\xE6\x95\x8F",
		"\xDA\xC3" => "\xE6\x97\xBB",
		"\xDA\xC4" => "\xE6\x97\xBC",
		"\xDA\xC5" => "\xE6\xB0\x91",
		"\xDA\xC6" => "\xE6\xB3\xAF",
		"\xDA\xC7" => "\xE7\x8E\x9F",
		"\xDA\xC8" => "\xE7\x8F\x89",
		"\xDA\xC9" => "\xE7\xB7\xA1",
		"\xDA\xCA" => "\xE9\x96\x94",
		"\xDA\xCB" => "\xE5\xAF\x86",
		"\xDA\xCC" => "\xE8\x9C\x9C",
		"\xDA\xCD" => "\xE8\xAC\x90",
		"\xDA\xCE" => "\xE5\x89\x9D",
		"\xDA\xCF" => "\xE5\x8D\x9A",
		"\xDA\xD0" => "\xE6\x8B\x8D",
		"\xDA\xD1" => "\xE6\x90\x8F",
		"\xDA\xD2" => "\xE6\x92\xB2",
		"\xDA\xD3" => "\xE6\x9C\xB4",
		"\xDA\xD4" => "\xE6\xA8\xB8",
		"\xDA\xD5" => "\xE6\xB3\x8A",
		"\xDA\xD6" => "\xE7\x8F\x80",
		"\xDA\xD7" => "\xE7\x92\x9E",
		"\xDA\xD8" => "\xE7\xAE\x94",
		"\xDA\xD9" => "\xE7\xB2\x95",
		"\xDA\xDA" => "\xE7\xB8\x9B",
		"\xDA\xDB" => "\xE8\x86\x8A",
		"\xDA\xDC" => "\xE8\x88\xB6",
		"\xDA\xDD" => "\xE8\x96\x84",
		"\xDA\xDE" => "\xE8\xBF\xAB",
		"\xDA\xDF" => "\xE9\x9B\xB9",
		"\xDA\xE0" => "\xE9\xA7\x81",
		"\xDA\xE1" => "\xE4\xBC\xB4",
		"\xDA\xE2" => "\xE5\x8D\x8A",
		"\xDA\xE3" => "\xE5\x8F\x8D",
		"\xDA\xE4" => "\xE5\x8F\x9B",
		"\xDA\xE5" => "\xE6\x8B\x8C",
		"\xDA\xE6" => "\xE6\x90\xAC",
		"\xDA\xE7" => "\xE6\x94\x80",
		"\xDA\xE8" => "\xE6\x96\x91",
		"\xDA\xE9" => "\xE6\xA7\x83",
		"\xDA\xEA" => "\xE6\xB3\xAE",
		"\xDA\xEB" => "\xE6\xBD\x98",
		"\xDA\xEC" => "\xE7\x8F\xAD",
		"\xDA\xED" => "\xE7\x95\x94",
		"\xDA\xEE" => "\xE7\x98\xA2",
		"\xDA\xEF" => "\xE7\x9B\xA4",
		"\xDA\xF0" => "\xE7\x9B\xBC",
		"\xDA\xF1" => "\xE7\xA3\x90",
		"\xDA\xF2" => "\xE7\xA3\xBB",
		"\xDA\xF3" => "\xE7\xA4\xAC",
		"\xDA\xF4" => "\xE7\xB5\x86",
		"\xDA\xF5" => "\xE8\x88\xAC",
		"\xDA\xF6" => "\xE8\x9F\xA0",
		"\xDA\xF7" => "\xE8\xBF\x94",
		"\xDA\xF8" => "\xE9\xA0\x92",
		"\xDA\xF9" => "\xE9\xA3\xAF",
		"\xDA\xFA" => "\xE5\x8B\x83",
		"\xDA\xFB" => "\xE6\x8B\x94",
		"\xDA\xFC" => "\xE6\x92\xA5",
		"\xDA\xFD" => "\xE6\xB8\xA4",
		"\xDA\xFE" => "\xE6\xBD\x91",
		"\xDB\xA1" => "\xE7\x99\xBC",
		"\xDB\xA2" => "\xE8\xB7\x8B",
		"\xDB\xA3" => "\xE9\x86\xB1",
		"\xDB\xA4" => "\xE9\x89\xA2",
		"\xDB\xA5" => "\xE9\xAB\xAE",
		"\xDB\xA6" => "\xE9\xAD\x83",
		"\xDB\xA7" => "\xE5\x80\xA3",
		"\xDB\xA8" => "\xE5\x82\x8D",
		"\xDB\xA9" => "\xE5\x9D\x8A",
		"\xDB\xAA" => "\xE5\xA6\xA8",
		"\xDB\xAB" => "\xE5\xB0\xA8",
		"\xDB\xAC" => "\xE5\xB9\x87",
		"\xDB\xAD" => "\xE5\xBD\xB7",
		"\xDB\xAE" => "\xE6\x88\xBF",
		"\xDB\xAF" => "\xE6\x94\xBE",
		"\xDB\xB0" => "\xE6\x96\xB9",
		"\xDB\xB1" => "\xE6\x97\x81",
		"\xDB\xB2" => "\xE6\x98\x89",
		"\xDB\xB3" => "\xE6\x9E\x8B",
		"\xDB\xB4" => "\xE6\xA6\x9C",
		"\xDB\xB5" => "\xE6\xBB\x82",
		"\xDB\xB6" => "\xE7\xA3\x85",
		"\xDB\xB7" => "\xE7\xB4\xA1",
		"\xDB\xB8" => "\xE8\x82\xAA",
		"\xDB\xB9" => "\xE8\x86\x80",
		"\xDB\xBA" => "\xE8\x88\xAB",
		"\xDB\xBB" => "\xE8\x8A\xB3",
		"\xDB\xBC" => "\xE8\x92\xA1",
		"\xDB\xBD" => "\xE8\x9A\x8C",
		"\xDB\xBE" => "\xE8\xA8\xAA",
		"\xDB\xBF" => "\xE8\xAC\x97",
		"\xDB\xC0" => "\xE9\x82\xA6",
		"\xDB\xC1" => "\xE9\x98\xB2",
		"\xDB\xC2" => "\xE9\xBE\x90",
		"\xDB\xC3" => "\xE5\x80\x8D",
		"\xDB\xC4" => "\xE4\xBF\xB3",
		"\xDB\xC5" => "\xEF\xA5\xA3",
		"\xDB\xC6" => "\xE5\x9F\xB9",
		"\xDB\xC7" => "\xE5\xBE\x98",
		"\xDB\xC8" => "\xE6\x8B\x9C",
		"\xDB\xC9" => "\xE6\x8E\x92",
		"\xDB\xCA" => "\xE6\x9D\xAF",
		"\xDB\xCB" => "\xE6\xB9\x83",
		"\xDB\xCC" => "\xE7\x84\x99",
		"\xDB\xCD" => "\xE7\x9B\x83",
		"\xDB\xCE" => "\xE8\x83\x8C",
		"\xDB\xCF" => "\xE8\x83\x9A",
		"\xDB\xD0" => "\xE8\xA3\xB4",
		"\xDB\xD1" => "\xE8\xA3\xB5",
		"\xDB\xD2" => "\xE8\xA4\x99",
		"\xDB\xD3" => "\xE8\xB3\xA0",
		"\xDB\xD4" => "\xE8\xBC\xA9",
		"\xDB\xD5" => "\xE9\x85\x8D",
		"\xDB\xD6" => "\xE9\x99\xAA",
		"\xDB\xD7" => "\xE4\xBC\xAF",
		"\xDB\xD8" => "\xE4\xBD\xB0",
		"\xDB\xD9" => "\xE5\xB8\x9B",
		"\xDB\xDA" => "\xE6\x9F\x8F",
		"\xDB\xDB" => "\xE6\xA0\xA2",
		"\xDB\xDC" => "\xE7\x99\xBD",
		"\xDB\xDD" => "\xE7\x99\xBE",
		"\xDB\xDE" => "\xE9\xAD\x84",
		"\xDB\xDF" => "\xE5\xB9\xA1",
		"\xDB\xE0" => "\xE6\xA8\x8A",
		"\xDB\xE1" => "\xE7\x85\xA9",
		"\xDB\xE2" => "\xE7\x87\x94",
		"\xDB\xE3" => "\xE7\x95\xAA",
		"\xDB\xE4" => "\xEF\xA5\xA4",
		"\xDB\xE5" => "\xE7\xB9\x81",
		"\xDB\xE6" => "\xE8\x95\x83",
		"\xDB\xE7" => "\xE8\x97\xA9",
		"\xDB\xE8" => "\xE9\xA3\x9C",
		"\xDB\xE9" => "\xE4\xBC\x90",
		"\xDB\xEA" => "\xE7\xAD\x8F",
		"\xDB\xEB" => "\xE7\xBD\xB0",
		"\xDB\xEC" => "\xE9\x96\xA5",
		"\xDB\xED" => "\xE5\x87\xA1",
		"\xDB\xEE" => "\xE5\xB8\x86",
		"\xDB\xEF" => "\xE6\xA2\xB5",
		"\xDB\xF0" => "\xE6\xB0\xBE",
		"\xDB\xF1" => "\xE6\xB1\x8E",
		"\xDB\xF2" => "\xE6\xB3\x9B",
		"\xDB\xF3" => "\xE7\x8A\xAF",
		"\xDB\xF4" => "\xE7\xAF\x84",
		"\xDB\xF5" => "\xE8\x8C\x83",
		"\xDB\xF6" => "\xE6\xB3\x95",
		"\xDB\xF7" => "\xE7\x90\xBA",
		"\xDB\xF8" => "\xE5\x83\xBB",
		"\xDB\xF9" => "\xE5\x8A\x88",
		"\xDB\xFA" => "\xE5\xA3\x81",
		"\xDB\xFB" => "\xE6\x93\x98",
		"\xDB\xFC" => "\xE6\xAA\x97",
		"\xDB\xFD" => "\xE7\x92\xA7",
		"\xDB\xFE" => "\xE7\x99\x96",
		"\xDC\xA1" => "\xE7\xA2\xA7",
		"\xDC\xA2" => "\xE8\x98\x97",
		"\xDC\xA3" => "\xE9\x97\xA2",
		"\xDC\xA4" => "\xE9\x9C\xB9",
		"\xDC\xA5" => "\xEF\xA5\xA5",
		"\xDC\xA6" => "\xE5\x8D\x9E",
		"\xDC\xA7" => "\xE5\xBC\x81",
		"\xDC\xA8" => "\xE8\xAE\x8A",
		"\xDC\xA9" => "\xE8\xBE\xA8",
		"\xDC\xAA" => "\xE8\xBE\xAF",
		"\xDC\xAB" => "\xE9\x82\x8A",
		"\xDC\xAC" => "\xE5\x88\xA5",
		"\xDC\xAD" => "\xE7\x9E\xA5",
		"\xDC\xAE" => "\xE9\xB1\x89",
		"\xDC\xAF" => "\xE9\xBC\x88",
		"\xDC\xB0" => "\xE4\xB8\x99",
		"\xDC\xB1" => "\xE5\x80\x82",
		"\xDC\xB2" => "\xE5\x85\xB5",
		"\xDC\xB3" => "\xE5\xB1\x9B",
		"\xDC\xB4" => "\xE5\xB9\xB7",
		"\xDC\xB5" => "\xE6\x98\x9E",
		"\xDC\xB6" => "\xE6\x98\xBA",
		"\xDC\xB7" => "\xE6\x9F\x84",
		"\xDC\xB8" => "\xE6\xA3\x85",
		"\xDC\xB9" => "\xE7\x82\xB3",
		"\xDC\xBA" => "\xE7\x94\x81",
		"\xDC\xBB" => "\xE7\x97\x85",
		"\xDC\xBC" => "\xE7\xA7\x89",
		"\xDC\xBD" => "\xE7\xAB\x9D",
		"\xDC\xBE" => "\xE8\xBC\xA7",
		"\xDC\xBF" => "\xE9\xA4\xA0",
		"\xDC\xC0" => "\xE9\xA8\x88",
		"\xDC\xC1" => "\xE4\xBF\x9D",
		"\xDC\xC2" => "\xE5\xA0\xA1",
		"\xDC\xC3" => "\xE5\xA0\xB1",
		"\xDC\xC4" => "\xE5\xAF\xB6",
		"\xDC\xC5" => "\xE6\x99\xAE",
		"\xDC\xC6" => "\xE6\xAD\xA5",
		"\xDC\xC7" => "\xE6\xB4\x91",
		"\xDC\xC8" => "\xE6\xB9\xBA",
		"\xDC\xC9" => "\xE6\xBD\xBD",
		"\xDC\xCA" => "\xE7\x8F\xA4",
		"\xDC\xCB" => "\xE7\x94\xAB",
		"\xDC\xCC" => "\xE8\x8F\xA9",
		"\xDC\xCD" => "\xE8\xA3\x9C",
		"\xDC\xCE" => "\xE8\xA4\x93",
		"\xDC\xCF" => "\xE8\xAD\x9C",
		"\xDC\xD0" => "\xE8\xBC\x94",
		"\xDC\xD1" => "\xE4\xBC\x8F",
		"\xDC\xD2" => "\xE5\x83\x95",
		"\xDC\xD3" => "\xE5\x8C\x90",
		"\xDC\xD4" => "\xE5\x8D\x9C",
		"\xDC\xD5" => "\xE5\xAE\x93",
		"\xDC\xD6" => "\xE5\xBE\xA9",
		"\xDC\xD7" => "\xE6\x9C\x8D",
		"\xDC\xD8" => "\xE7\xA6\x8F",
		"\xDC\xD9" => "\xE8\x85\xB9",
		"\xDC\xDA" => "\xE8\x8C\xAF",
		"\xDC\xDB" => "\xE8\x94\x94",
		"\xDC\xDC" => "\xE8\xA4\x87",
		"\xDC\xDD" => "\xE8\xA6\x86",
		"\xDC\xDE" => "\xE8\xBC\xB9",
		"\xDC\xDF" => "\xE8\xBC\xBB",
		"\xDC\xE0" => "\xE9\xA6\xA5",
		"\xDC\xE1" => "\xE9\xB0\x92",
		"\xDC\xE2" => "\xE6\x9C\xAC",
		"\xDC\xE3" => "\xE4\xB9\xB6",
		"\xDC\xE4" => "\xE4\xBF\xB8",
		"\xDC\xE5" => "\xE5\xA5\x89",
		"\xDC\xE6" => "\xE5\xB0\x81",
		"\xDC\xE7" => "\xE5\xB3\xAF",
		"\xDC\xE8" => "\xE5\xB3\xB0",
		"\xDC\xE9" => "\xE6\x8D\xA7",
		"\xDC\xEA" => "\xE6\xA3\x92",
		"\xDC\xEB" => "\xE7\x83\xBD",
		"\xDC\xEC" => "\xE7\x86\xA2",
		"\xDC\xED" => "\xE7\x90\xAB",
		"\xDC\xEE" => "\xE7\xB8\xAB",
		"\xDC\xEF" => "\xE8\x93\xAC",
		"\xDC\xF0" => "\xE8\x9C\x82",
		"\xDC\xF1" => "\xE9\x80\xA2",
		"\xDC\xF2" => "\xE9\x8B\x92",
		"\xDC\xF3" => "\xE9\xB3\xB3",
		"\xDC\xF4" => "\xE4\xB8\x8D",
		"\xDC\xF5" => "\xE4\xBB\x98",
		"\xDC\xF6" => "\xE4\xBF\xAF",
		"\xDC\xF7" => "\xE5\x82\x85",
		"\xDC\xF8" => "\xE5\x89\x96",
		"\xDC\xF9" => "\xE5\x89\xAF",
		"\xDC\xFA" => "\xE5\x90\xA6",
		"\xDC\xFB" => "\xE5\x92\x90",
		"\xDC\xFC" => "\xE5\x9F\xA0",
		"\xDC\xFD" => "\xE5\xA4\xAB",
		"\xDC\xFE" => "\xE5\xA9\xA6",
		"\xDD\xA1" => "\xE5\xAD\x9A",
		"\xDD\xA2" => "\xE5\xAD\xB5",
		"\xDD\xA3" => "\xE5\xAF\x8C",
		"\xDD\xA4" => "\xE5\xBA\x9C",
		"\xDD\xA5" => "\xEF\xA5\xA6",
		"\xDD\xA6" => "\xE6\x89\xB6",
		"\xDD\xA7" => "\xE6\x95\xB7",
		"\xDD\xA8" => "\xE6\x96\xA7",
		"\xDD\xA9" => "\xE6\xB5\xAE",
		"\xDD\xAA" => "\xE6\xBA\xA5",
		"\xDD\xAB" => "\xE7\x88\xB6",
		"\xDD\xAC" => "\xE7\xAC\xA6",
		"\xDD\xAD" => "\xE7\xB0\xBF",
		"\xDD\xAE" => "\xE7\xBC\xB6",
		"\xDD\xAF" => "\xE8\x85\x90",
		"\xDD\xB0" => "\xE8\x85\x91",
		"\xDD\xB1" => "\xE8\x86\x9A",
		"\xDD\xB2" => "\xE8\x89\x80",
		"\xDD\xB3" => "\xE8\x8A\x99",
		"\xDD\xB4" => "\xE8\x8E\xA9",
		"\xDD\xB5" => "\xE8\xA8\x83",
		"\xDD\xB6" => "\xE8\xB2\xA0",
		"\xDD\xB7" => "\xE8\xB3\xA6",
		"\xDD\xB8" => "\xE8\xB3\xBB",
		"\xDD\xB9" => "\xE8\xB5\xB4",
		"\xDD\xBA" => "\xE8\xB6\xBA",
		"\xDD\xBB" => "\xE9\x83\xA8",
		"\xDD\xBC" => "\xE9\x87\x9C",
		"\xDD\xBD" => "\xE9\x98\x9C",
		"\xDD\xBE" => "\xE9\x99\x84",
		"\xDD\xBF" => "\xE9\xA7\x99",
		"\xDD\xC0" => "\xE9\xB3\xA7",
		"\xDD\xC1" => "\xE5\x8C\x97",
		"\xDD\xC2" => "\xE5\x88\x86",
		"\xDD\xC3" => "\xE5\x90\xA9",
		"\xDD\xC4" => "\xE5\x99\xB4",
		"\xDD\xC5" => "\xE5\xA2\xB3",
		"\xDD\xC6" => "\xE5\xA5\x94",
		"\xDD\xC7" => "\xE5\xA5\xAE",
		"\xDD\xC8" => "\xE5\xBF\xBF",
		"\xDD\xC9" => "\xE6\x86\xA4",
		"\xDD\xCA" => "\xE6\x89\xAE",
		"\xDD\xCB" => "\xE6\x98\x90",
		"\xDD\xCC" => "\xE6\xB1\xBE",
		"\xDD\xCD" => "\xE7\x84\x9A",
		"\xDD\xCE" => "\xE7\x9B\x86",
		"\xDD\xCF" => "\xE7\xB2\x89",
		"\xDD\xD0" => "\xE7\xB3\x9E",
		"\xDD\xD1" => "\xE7\xB4\x9B",
		"\xDD\xD2" => "\xE8\x8A\xAC",
		"\xDD\xD3" => "\xE8\xB3\x81",
		"\xDD\xD4" => "\xE9\x9B\xB0",
		"\xDD\xD5" => "\xEF\xA5\xA7",
		"\xDD\xD6" => "\xE4\xBD\x9B",
		"\xDD\xD7" => "\xE5\xBC\x97",
		"\xDD\xD8" => "\xE5\xBD\xBF",
		"\xDD\xD9" => "\xE6\x8B\x82",
		"\xDD\xDA" => "\xE5\xB4\xA9",
		"\xDD\xDB" => "\xE6\x9C\x8B",
		"\xDD\xDC" => "\xE6\xA3\x9A",
		"\xDD\xDD" => "\xE7\xA1\xBC",
		"\xDD\xDE" => "\xE7\xB9\x83",
		"\xDD\xDF" => "\xE9\xB5\xAC",
		"\xDD\xE0" => "\xE4\xB8\x95",
		"\xDD\xE1" => "\xE5\x82\x99",
		"\xDD\xE2" => "\xE5\x8C\x95",
		"\xDD\xE3" => "\xE5\x8C\xAA",
		"\xDD\xE4" => "\xE5\x8D\x91",
		"\xDD\xE5" => "\xE5\xA6\x83",
		"\xDD\xE6" => "\xE5\xA9\xA2",
		"\xDD\xE7" => "\xE5\xBA\x87",
		"\xDD\xE8" => "\xE6\x82\xB2",
		"\xDD\xE9" => "\xE6\x86\x8A",
		"\xDD\xEA" => "\xE6\x89\x89",
		"\xDD\xEB" => "\xE6\x89\xB9",
		"\xDD\xEC" => "\xE6\x96\x90",
		"\xDD\xED" => "\xE6\x9E\x87",
		"\xDD\xEE" => "\xE6\xA6\xA7",
		"\xDD\xEF" => "\xE6\xAF\x94",
		"\xDD\xF0" => "\xE6\xAF\x96",
		"\xDD\xF1" => "\xE6\xAF\x97",
		"\xDD\xF2" => "\xE6\xAF\x98",
		"\xDD\xF3" => "\xE6\xB2\xB8",
		"\xDD\xF4" => "\xEF\xA5\xA8",
		"\xDD\xF5" => "\xE7\x90\xB5",
		"\xDD\xF6" => "\xE7\x97\xBA",
		"\xDD\xF7" => "\xE7\xA0\x92",
		"\xDD\xF8" => "\xE7\xA2\x91",
		"\xDD\xF9" => "\xE7\xA7\x95",
		"\xDD\xFA" => "\xE7\xA7\x98",
		"\xDD\xFB" => "\xE7\xB2\x83",
		"\xDD\xFC" => "\xE7\xB7\x8B",
		"\xDD\xFD" => "\xE7\xBF\xA1",
		"\xDD\xFE" => "\xE8\x82\xA5",
		"\xDE\xA1" => "\xE8\x84\xBE",
		"\xDE\xA2" => "\xE8\x87\x82",
		"\xDE\xA3" => "\xE8\x8F\xB2",
		"\xDE\xA4" => "\xE8\x9C\x9A",
		"\xDE\xA5" => "\xE8\xA3\xA8",
		"\xDE\xA6" => "\xE8\xAA\xB9",
		"\xDE\xA7" => "\xE8\xAD\xAC",
		"\xDE\xA8" => "\xE8\xB2\xBB",
		"\xDE\xA9" => "\xE9\x84\x99",
		"\xDE\xAA" => "\xE9\x9D\x9E",
		"\xDE\xAB" => "\xE9\xA3\x9B",
		"\xDE\xAC" => "\xE9\xBC\xBB",
		"\xDE\xAD" => "\xE5\x9A\xAC",
		"\xDE\xAE" => "\xE5\xAC\xAA",
		"\xDE\xAF" => "\xE5\xBD\xAC",
		"\xDE\xB0" => "\xE6\x96\x8C",
		"\xDE\xB1" => "\xE6\xAA\xB3",
		"\xDE\xB2" => "\xE6\xAE\xAF",
		"\xDE\xB3" => "\xE6\xB5\x9C",
		"\xDE\xB4" => "\xE6\xBF\xB1",
		"\xDE\xB5" => "\xE7\x80\x95",
		"\xDE\xB6" => "\xE7\x89\x9D",
		"\xDE\xB7" => "\xE7\x8E\xAD",
		"\xDE\xB8" => "\xE8\xB2\xA7",
		"\xDE\xB9" => "\xE8\xB3\x93",
		"\xDE\xBA" => "\xE9\xA0\xBB",
		"\xDE\xBB" => "\xE6\x86\x91",
		"\xDE\xBC" => "\xE6\xB0\xB7",
		"\xDE\xBD" => "\xE8\x81\x98",
		"\xDE\xBE" => "\xE9\xA8\x81",
		"\xDE\xBF" => "\xE4\xB9\x8D",
		"\xDE\xC0" => "\xE4\xBA\x8B",
		"\xDE\xC1" => "\xE4\xBA\x9B",
		"\xDE\xC2" => "\xE4\xBB\x95",
		"\xDE\xC3" => "\xE4\xBC\xBA",
		"\xDE\xC4" => "\xE4\xBC\xBC",
		"\xDE\xC5" => "\xE4\xBD\xBF",
		"\xDE\xC6" => "\xE4\xBF\x9F",
		"\xDE\xC7" => "\xE5\x83\xBF",
		"\xDE\xC8" => "\xE5\x8F\xB2",
		"\xDE\xC9" => "\xE5\x8F\xB8",
		"\xDE\xCA" => "\xE5\x94\x86",
		"\xDE\xCB" => "\xE5\x97\xA3",
		"\xDE\xCC" => "\xE5\x9B\x9B",
		"\xDE\xCD" => "\xE5\xA3\xAB",
		"\xDE\xCE" => "\xE5\xA5\xA2",
		"\xDE\xCF" => "\xE5\xA8\x91",
		"\xDE\xD0" => "\xE5\xAF\xAB",
		"\xDE\xD1" => "\xE5\xAF\xBA",
		"\xDE\xD2" => "\xE5\xB0\x84",
		"\xDE\xD3" => "\xE5\xB7\xB3",
		"\xDE\xD4" => "\xE5\xB8\xAB",
		"\xDE\xD5" => "\xE5\xBE\x99",
		"\xDE\xD6" => "\xE6\x80\x9D",
		"\xDE\xD7" => "\xE6\x8D\xA8",
		"\xDE\xD8" => "\xE6\x96\x9C",
		"\xDE\xD9" => "\xE6\x96\xAF",
		"\xDE\xDA" => "\xE6\x9F\xB6",
		"\xDE\xDB" => "\xE6\x9F\xBB",
		"\xDE\xDC" => "\xE6\xA2\xAD",
		"\xDE\xDD" => "\xE6\xAD\xBB",
		"\xDE\xDE" => "\xE6\xB2\x99",
		"\xDE\xDF" => "\xE6\xB3\x97",
		"\xDE\xE0" => "\xE6\xB8\xA3",
		"\xDE\xE1" => "\xE7\x80\x89",
		"\xDE\xE2" => "\xE7\x8D\x85",
		"\xDE\xE3" => "\xE7\xA0\x82",
		"\xDE\xE4" => "\xE7\xA4\xBE",
		"\xDE\xE5" => "\xE7\xA5\x80",
		"\xDE\xE6" => "\xE7\xA5\xA0",
		"\xDE\xE7" => "\xE7\xA7\x81",
		"\xDE\xE8" => "\xE7\xAF\xA9",
		"\xDE\xE9" => "\xE7\xB4\x97",
		"\xDE\xEA" => "\xE7\xB5\xB2",
		"\xDE\xEB" => "\xE8\x82\x86",
		"\xDE\xEC" => "\xE8\x88\x8D",
		"\xDE\xED" => "\xE8\x8E\x8E",
		"\xDE\xEE" => "\xE8\x93\x91",
		"\xDE\xEF" => "\xE8\x9B\x87",
		"\xDE\xF0" => "\xE8\xA3\x9F",
		"\xDE\xF1" => "\xE8\xA9\x90",
		"\xDE\xF2" => "\xE8\xA9\x9E",
		"\xDE\xF3" => "\xE8\xAC\x9D",
		"\xDE\xF4" => "\xE8\xB3\x9C",
		"\xDE\xF5" => "\xE8\xB5\xA6",
		"\xDE\xF6" => "\xE8\xBE\xAD",
		"\xDE\xF7" => "\xE9\x82\xAA",
		"\xDE\xF8" => "\xE9\xA3\xBC",
		"\xDE\xF9" => "\xE9\xA7\x9F",
		"\xDE\xFA" => "\xE9\xBA\x9D",
		"\xDE\xFB" => "\xE5\x89\x8A",
		"\xDE\xFC" => "\xEF\xA5\xA9",
		"\xDE\xFD" => "\xE6\x9C\x94",
		"\xDE\xFE" => "\xEF\xA5\xAA",
		"\xDF\xA1" => "\xE5\x82\x98",
		"\xDF\xA2" => "\xE5\x88\xAA",
		"\xDF\xA3" => "\xE5\xB1\xB1",
		"\xDF\xA4" => "\xE6\x95\xA3",
		"\xDF\xA5" => "\xE6\xB1\x95",
		"\xDF\xA6" => "\xE7\x8F\x8A",
		"\xDF\xA7" => "\xE7\x94\xA3",
		"\xDF\xA8" => "\xE7\x96\x9D",
		"\xDF\xA9" => "\xE7\xAE\x97",
		"\xDF\xAA" => "\xE8\x92\x9C",
		"\xDF\xAB" => "\xE9\x85\xB8",
		"\xDF\xAC" => "\xE9\x9C\xB0",
		"\xDF\xAD" => "\xE4\xB9\xB7",
		"\xDF\xAE" => "\xE6\x92\x92",
		"\xDF\xAF" => "\xE6\xAE\xBA",
		"\xDF\xB0" => "\xE7\x85\x9E",
		"\xDF\xB1" => "\xE8\x96\xA9",
		"\xDF\xB2" => "\xE4\xB8\x89",
		"\xDF\xB3" => "\xEF\xA5\xAB",
		"\xDF\xB4" => "\xE6\x9D\x89",
		"\xDF\xB5" => "\xE6\xA3\xAE",
		"\xDF\xB6" => "\xE6\xB8\x97",
		"\xDF\xB7" => "\xE8\x8A\x9F",
		"\xDF\xB8" => "\xE8\x94\x98",
		"\xDF\xB9" => "\xE8\xA1\xAB",
		"\xDF\xBA" => "\xE6\x8F\xB7",
		"\xDF\xBB" => "\xE6\xBE\x81",
		"\xDF\xBC" => "\xE9\x88\x92",
		"\xDF\xBD" => "\xE9\xA2\xAF",
		"\xDF\xBE" => "\xE4\xB8\x8A",
		"\xDF\xBF" => "\xE5\x82\xB7",
		"\xDF\xC0" => "\xE5\x83\x8F",
		"\xDF\xC1" => "\xE5\x84\x9F",
		"\xDF\xC2" => "\xE5\x95\x86",
		"\xDF\xC3" => "\xE5\x96\xAA",
		"\xDF\xC4" => "\xE5\x98\x97",
		"\xDF\xC5" => "\xE5\xAD\x80",
		"\xDF\xC6" => "\xE5\xB0\x99",
		"\xDF\xC7" => "\xE5\xB3\xA0",
		"\xDF\xC8" => "\xE5\xB8\xB8",
		"\xDF\xC9" => "\xE5\xBA\x8A",
		"\xDF\xCA" => "\xE5\xBA\xA0",
		"\xDF\xCB" => "\xE5\xBB\x82",
		"\xDF\xCC" => "\xE6\x83\xB3",
		"\xDF\xCD" => "\xE6\xA1\x91",
		"\xDF\xCE" => "\xE6\xA9\xA1",
		"\xDF\xCF" => "\xE6\xB9\x98",
		"\xDF\xD0" => "\xE7\x88\xBD",
		"\xDF\xD1" => "\xE7\x89\x80",
		"\xDF\xD2" => "\xE7\x8B\x80",
		"\xDF\xD3" => "\xE7\x9B\xB8",
		"\xDF\xD4" => "\xE7\xA5\xA5",
		"\xDF\xD5" => "\xE7\xAE\xB1",
		"\xDF\xD6" => "\xE7\xBF\x94",
		"\xDF\xD7" => "\xE8\xA3\xB3",
		"\xDF\xD8" => "\xE8\xA7\xB4",
		"\xDF\xD9" => "\xE8\xA9\xB3",
		"\xDF\xDA" => "\xE8\xB1\xA1",
		"\xDF\xDB" => "\xE8\xB3\x9E",
		"\xDF\xDC" => "\xE9\x9C\x9C",
		"\xDF\xDD" => "\xE5\xA1\x9E",
		"\xDF\xDE" => "\xE7\x92\xBD",
		"\xDF\xDF" => "\xE8\xB3\xBD",
		"\xDF\xE0" => "\xE5\x97\x87",
		"\xDF\xE1" => "\xEF\xA5\xAC",
		"\xDF\xE2" => "\xE7\xA9\xA1",
		"\xDF\xE3" => "\xE7\xB4\xA2",
		"\xDF\xE4" => "\xE8\x89\xB2",
		"\xDF\xE5" => "\xE7\x89\xB2",
		"\xDF\xE6" => "\xE7\x94\x9F",
		"\xDF\xE7" => "\xE7\x94\xA5",
		"\xDF\xE8" => "\xEF\xA5\xAD",
		"\xDF\xE9" => "\xE7\xAC\x99",
		"\xDF\xEA" => "\xE5\xA2\x85",
		"\xDF\xEB" => "\xE5\xA3\xBB",
		"\xDF\xEC" => "\xE5\xB6\xBC",
		"\xDF\xED" => "\xE5\xBA\x8F",
		"\xDF\xEE" => "\xE5\xBA\xB6",
		"\xDF\xEF" => "\xE5\xBE\x90",
		"\xDF\xF0" => "\xE6\x81\x95",
		"\xDF\xF1" => "\xE6\x8A\x92",
		"\xDF\xF2" => "\xE6\x8D\xBF",
		"\xDF\xF3" => "\xE6\x95\x8D",
		"\xDF\xF4" => "\xE6\x9A\x91",
		"\xDF\xF5" => "\xE6\x9B\x99",
		"\xDF\xF6" => "\xE6\x9B\xB8",
		"\xDF\xF7" => "\xE6\xA0\x96",
		"\xDF\xF8" => "\xE6\xA3\xB2",
		"\xDF\xF9" => "\xE7\x8A\x80",
		"\xDF\xFA" => "\xE7\x91\x9E",
		"\xDF\xFB" => "\xE7\xAD\xAE",
		"\xDF\xFC" => "\xE7\xB5\xAE",
		"\xDF\xFD" => "\xE7\xB7\x96",
		"\xDF\xFE" => "\xE7\xBD\xB2",
		"\xE0\xA1" => "\xE8\x83\xA5",
		"\xE0\xA2" => "\xE8\x88\x92",
		"\xE0\xA3" => "\xE8\x96\xAF",
		"\xE0\xA4" => "\xE8\xA5\xBF",
		"\xE0\xA5" => "\xE8\xAA\x93",
		"\xE0\xA6" => "\xE9\x80\x9D",
		"\xE0\xA7" => "\xE9\x8B\xA4",
		"\xE0\xA8" => "\xE9\xBB\x8D",
		"\xE0\xA9" => "\xE9\xBC\xA0",
		"\xE0\xAA" => "\xE5\xA4\x95",
		"\xE0\xAB" => "\xE5\xA5\xAD",
		"\xE0\xAC" => "\xE5\xB8\xAD",
		"\xE0\xAD" => "\xE6\x83\x9C",
		"\xE0\xAE" => "\xE6\x98\x94",
		"\xE0\xAF" => "\xE6\x99\xB3",
		"\xE0\xB0" => "\xE6\x9E\x90",
		"\xE0\xB1" => "\xE6\xB1\x90",
		"\xE0\xB2" => "\xE6\xB7\x85",
		"\xE0\xB3" => "\xE6\xBD\x9F",
		"\xE0\xB4" => "\xE7\x9F\xB3",
		"\xE0\xB5" => "\xE7\xA2\xA9",
		"\xE0\xB6" => "\xE8\x93\x86",
		"\xE0\xB7" => "\xE9\x87\x8B",
		"\xE0\xB8" => "\xE9\x8C\xAB",
		"\xE0\xB9" => "\xE4\xBB\x99",
		"\xE0\xBA" => "\xE5\x83\x8A",
		"\xE0\xBB" => "\xE5\x85\x88",
		"\xE0\xBC" => "\xE5\x96\x84",
		"\xE0\xBD" => "\xE5\xAC\x8B",
		"\xE0\xBE" => "\xE5\xAE\xA3",
		"\xE0\xBF" => "\xE6\x89\x87",
		"\xE0\xC0" => "\xE6\x95\xBE",
		"\xE0\xC1" => "\xE6\x97\x8B",
		"\xE0\xC2" => "\xE6\xB8\xB2",
		"\xE0\xC3" => "\xE7\x85\xBD",
		"\xE0\xC4" => "\xE7\x90\x81",
		"\xE0\xC5" => "\xE7\x91\x84",
		"\xE0\xC6" => "\xE7\x92\x87",
		"\xE0\xC7" => "\xE7\x92\xBF",
		"\xE0\xC8" => "\xE7\x99\xAC",
		"\xE0\xC9" => "\xE7\xA6\xAA",
		"\xE0\xCA" => "\xE7\xB7\x9A",
		"\xE0\xCB" => "\xE7\xB9\x95",
		"\xE0\xCC" => "\xE7\xBE\xA8",
		"\xE0\xCD" => "\xE8\x85\xBA",
		"\xE0\xCE" => "\xE8\x86\xB3",
		"\xE0\xCF" => "\xE8\x88\xB9",
		"\xE0\xD0" => "\xE8\x98\x9A",
		"\xE0\xD1" => "\xE8\x9F\xAC",
		"\xE0\xD2" => "\xE8\xA9\xB5",
		"\xE0\xD3" => "\xE8\xB7\xA3",
		"\xE0\xD4" => "\xE9\x81\xB8",
		"\xE0\xD5" => "\xE9\x8A\x91",
		"\xE0\xD6" => "\xE9\x90\xA5",
		"\xE0\xD7" => "\xE9\xA5\x8D",
		"\xE0\xD8" => "\xE9\xAE\xAE",
		"\xE0\xD9" => "\xE5\x8D\xA8",
		"\xE0\xDA" => "\xE5\xB1\x91",
		"\xE0\xDB" => "\xE6\xA5\x94",
		"\xE0\xDC" => "\xE6\xB3\x84",
		"\xE0\xDD" => "\xE6\xB4\xA9",
		"\xE0\xDE" => "\xE6\xB8\xAB",
		"\xE0\xDF" => "\xE8\x88\x8C",
		"\xE0\xE0" => "\xE8\x96\x9B",
		"\xE0\xE1" => "\xE8\xA4\xBB",
		"\xE0\xE2" => "\xE8\xA8\xAD",
		"\xE0\xE3" => "\xE8\xAA\xAA",
		"\xE0\xE4" => "\xE9\x9B\xAA",
		"\xE0\xE5" => "\xE9\xBD\xA7",
		"\xE0\xE6" => "\xE5\x89\xA1",
		"\xE0\xE7" => "\xE6\x9A\xB9",
		"\xE0\xE8" => "\xE6\xAE\xB2",
		"\xE0\xE9" => "\xE7\xBA\x96",
		"\xE0\xEA" => "\xE8\x9F\xBE",
		"\xE0\xEB" => "\xE8\xB4\x8D",
		"\xE0\xEC" => "\xE9\x96\x83",
		"\xE0\xED" => "\xE9\x99\x9D",
		"\xE0\xEE" => "\xE6\x94\x9D",
		"\xE0\xEF" => "\xE6\xB6\x89",
		"\xE0\xF0" => "\xE7\x87\xAE",
		"\xE0\xF1" => "\xEF\xA5\xAE",
		"\xE0\xF2" => "\xE5\x9F\x8E",
		"\xE0\xF3" => "\xE5\xA7\x93",
		"\xE0\xF4" => "\xE5\xAE\xAC",
		"\xE0\xF5" => "\xE6\x80\xA7",
		"\xE0\xF6" => "\xE6\x83\xBA",
		"\xE0\xF7" => "\xE6\x88\x90",
		"\xE0\xF8" => "\xE6\x98\x9F",
		"\xE0\xF9" => "\xE6\x99\x9F",
		"\xE0\xFA" => "\xE7\x8C\xA9",
		"\xE0\xFB" => "\xE7\x8F\xB9",
		"\xE0\xFC" => "\xE7\x9B\x9B",
		"\xE0\xFD" => "\xE7\x9C\x81",
		"\xE0\xFE" => "\xE7\xAD\xAC",
		"\xE1\xA1" => "\xE8\x81\x96",
		"\xE1\xA2" => "\xE8\x81\xB2",
		"\xE1\xA3" => "\xE8\x85\xA5",
		"\xE1\xA4" => "\xE8\xAA\xA0",
		"\xE1\xA5" => "\xE9\x86\x92",
		"\xE1\xA6" => "\xE4\xB8\x96",
		"\xE1\xA7" => "\xE5\x8B\xA2",
		"\xE1\xA8" => "\xE6\xAD\xB2",
		"\xE1\xA9" => "\xE6\xB4\x97",
		"\xE1\xAA" => "\xE7\xA8\x85",
		"\xE1\xAB" => "\xE7\xAC\xB9",
		"\xE1\xAC" => "\xE7\xB4\xB0",
		"\xE1\xAD" => "\xEF\xA5\xAF",
		"\xE1\xAE" => "\xE8\xB2\xB0",
		"\xE1\xAF" => "\xE5\x8F\xAC",
		"\xE1\xB0" => "\xE5\x98\xAF",
		"\xE1\xB1" => "\xE5\xA1\x91",
		"\xE1\xB2" => "\xE5\xAE\xB5",
		"\xE1\xB3" => "\xE5\xB0\x8F",
		"\xE1\xB4" => "\xE5\xB0\x91",
		"\xE1\xB5" => "\xE5\xB7\xA2",
		"\xE1\xB6" => "\xE6\x89\x80",
		"\xE1\xB7" => "\xE6\x8E\x83",
		"\xE1\xB8" => "\xE6\x90\x94",
		"\xE1\xB9" => "\xE6\x98\xAD",
		"\xE1\xBA" => "\xE6\xA2\xB3",
		"\xE1\xBB" => "\xE6\xB2\xBC",
		"\xE1\xBC" => "\xE6\xB6\x88",
		"\xE1\xBD" => "\xE6\xBA\xAF",
		"\xE1\xBE" => "\xE7\x80\x9F",
		"\xE1\xBF" => "\xE7\x82\xA4",
		"\xE1\xC0" => "\xE7\x87\x92",
		"\xE1\xC1" => "\xE7\x94\xA6",
		"\xE1\xC2" => "\xE7\x96\x8F",
		"\xE1\xC3" => "\xE7\x96\x8E",
		"\xE1\xC4" => "\xE7\x98\x99",
		"\xE1\xC5" => "\xE7\xAC\x91",
		"\xE1\xC6" => "\xE7\xAF\xA0",
		"\xE1\xC7" => "\xE7\xB0\xAB",
		"\xE1\xC8" => "\xE7\xB4\xA0",
		"\xE1\xC9" => "\xE7\xB4\xB9",
		"\xE1\xCA" => "\xE8\x94\xAC",
		"\xE1\xCB" => "\xE8\x95\xAD",
		"\xE1\xCC" => "\xE8\x98\x87",
		"\xE1\xCD" => "\xE8\xA8\xB4",
		"\xE1\xCE" => "\xE9\x80\x8D",
		"\xE1\xCF" => "\xE9\x81\xA1",
		"\xE1\xD0" => "\xE9\x82\xB5",
		"\xE1\xD1" => "\xE9\x8A\xB7",
		"\xE1\xD2" => "\xE9\x9F\xB6",
		"\xE1\xD3" => "\xE9\xA8\xB7",
		"\xE1\xD4" => "\xE4\xBF\x97",
		"\xE1\xD5" => "\xE5\xB1\xAC",
		"\xE1\xD6" => "\xE6\x9D\x9F",
		"\xE1\xD7" => "\xE6\xB6\x91",
		"\xE1\xD8" => "\xE7\xB2\x9F",
		"\xE1\xD9" => "\xE7\xBA\x8C",
		"\xE1\xDA" => "\xE8\xAC\x96",
		"\xE1\xDB" => "\xE8\xB4\x96",
		"\xE1\xDC" => "\xE9\x80\x9F",
		"\xE1\xDD" => "\xE5\xAD\xAB",
		"\xE1\xDE" => "\xE5\xB7\xBD",
		"\xE1\xDF" => "\xE6\x90\x8D",
		"\xE1\xE0" => "\xE8\x93\x80",
		"\xE1\xE1" => "\xE9\x81\x9C",
		"\xE1\xE2" => "\xE9\xA3\xA1",
		"\xE1\xE3" => "\xE7\x8E\x87",
		"\xE1\xE4" => "\xE5\xAE\x8B",
		"\xE1\xE5" => "\xE6\x82\x9A",
		"\xE1\xE6" => "\xE6\x9D\xBE",
		"\xE1\xE7" => "\xE6\xB7\x9E",
		"\xE1\xE8" => "\xE8\xA8\x9F",
		"\xE1\xE9" => "\xE8\xAA\xA6",
		"\xE1\xEA" => "\xE9\x80\x81",
		"\xE1\xEB" => "\xE9\xA0\x8C",
		"\xE1\xEC" => "\xE5\x88\xB7",
		"\xE1\xED" => "\xEF\xA5\xB0",
		"\xE1\xEE" => "\xE7\x81\x91",
		"\xE1\xEF" => "\xE7\xA2\x8E",
		"\xE1\xF0" => "\xE9\x8E\x96",
		"\xE1\xF1" => "\xE8\xA1\xB0",
		"\xE1\xF2" => "\xE9\x87\x97",
		"\xE1\xF3" => "\xE4\xBF\xAE",
		"\xE1\xF4" => "\xE5\x8F\x97",
		"\xE1\xF5" => "\xE5\x97\xBD",
		"\xE1\xF6" => "\xE5\x9B\x9A",
		"\xE1\xF7" => "\xE5\x9E\x82",
		"\xE1\xF8" => "\xE5\xA3\xBD",
		"\xE1\xF9" => "\xE5\xAB\x82",
		"\xE1\xFA" => "\xE5\xAE\x88",
		"\xE1\xFB" => "\xE5\xB2\xAB",
		"\xE1\xFC" => "\xE5\xB3\x80",
		"\xE1\xFD" => "\xE5\xB8\xA5",
		"\xE1\xFE" => "\xE6\x84\x81",
		"\xE2\xA1" => "\xE6\x88\x8D",
		"\xE2\xA2" => "\xE6\x89\x8B",
		"\xE2\xA3" => "\xE6\x8E\x88",
		"\xE2\xA4" => "\xE6\x90\x9C",
		"\xE2\xA5" => "\xE6\x94\xB6",
		"\xE2\xA6" => "\xE6\x95\xB8",
		"\xE2\xA7" => "\xE6\xA8\xB9",
		"\xE2\xA8" => "\xE6\xAE\x8A",
		"\xE2\xA9" => "\xE6\xB0\xB4",
		"\xE2\xAA" => "\xE6\xB4\x99",
		"\xE2\xAB" => "\xE6\xBC\xB1",
		"\xE2\xAC" => "\xE7\x87\xA7",
		"\xE2\xAD" => "\xE7\x8B\xA9",
		"\xE2\xAE" => "\xE7\x8D\xB8",
		"\xE2\xAF" => "\xE7\x90\x87",
		"\xE2\xB0" => "\xE7\x92\xB2",
		"\xE2\xB1" => "\xE7\x98\xA6",
		"\xE2\xB2" => "\xE7\x9D\xA1",
		"\xE2\xB3" => "\xE7\xA7\x80",
		"\xE2\xB4" => "\xE7\xA9\x97",
		"\xE2\xB5" => "\xE7\xAB\xAA",
		"\xE2\xB6" => "\xE7\xB2\xB9",
		"\xE2\xB7" => "\xE7\xB6\x8F",
		"\xE2\xB8" => "\xE7\xB6\xAC",
		"\xE2\xB9" => "\xE7\xB9\xA1",
		"\xE2\xBA" => "\xE7\xBE\x9E",
		"\xE2\xBB" => "\xE8\x84\xA9",
		"\xE2\xBC" => "\xE8\x8C\xB1",
		"\xE2\xBD" => "\xE8\x92\x90",
		"\xE2\xBE" => "\xE8\x93\x9A",
		"\xE2\xBF" => "\xE8\x97\xAA",
		"\xE2\xC0" => "\xE8\xA2\x96",
		"\xE2\xC1" => "\xE8\xAA\xB0",
		"\xE2\xC2" => "\xE8\xAE\x90",
		"\xE2\xC3" => "\xE8\xBC\xB8",
		"\xE2\xC4" => "\xE9\x81\x82",
		"\xE2\xC5" => "\xE9\x82\x83",
		"\xE2\xC6" => "\xE9\x85\xAC",
		"\xE2\xC7" => "\xE9\x8A\x96",
		"\xE2\xC8" => "\xE9\x8A\xB9",
		"\xE2\xC9" => "\xE9\x9A\x8B",
		"\xE2\xCA" => "\xE9\x9A\xA7",
		"\xE2\xCB" => "\xE9\x9A\xA8",
		"\xE2\xCC" => "\xE9\x9B\x96",
		"\xE2\xCD" => "\xE9\x9C\x80",
		"\xE2\xCE" => "\xE9\xA0\x88",
		"\xE2\xCF" => "\xE9\xA6\x96",
		"\xE2\xD0" => "\xE9\xAB\x93",
		"\xE2\xD1" => "\xE9\xAC\x9A",
		"\xE2\xD2" => "\xE5\x8F\x94",
		"\xE2\xD3" => "\xE5\xA1\xBE",
		"\xE2\xD4" => "\xE5\xA4\x99",
		"\xE2\xD5" => "\xE5\xAD\xB0",
		"\xE2\xD6" => "\xE5\xAE\xBF",
		"\xE2\xD7" => "\xE6\xB7\x91",
		"\xE2\xD8" => "\xE6\xBD\x9A",
		"\xE2\xD9" => "\xE7\x86\x9F",
		"\xE2\xDA" => "\xE7\x90\xA1",
		"\xE2\xDB" => "\xE7\x92\xB9",
		"\xE2\xDC" => "\xE8\x82\x85",
		"\xE2\xDD" => "\xE8\x8F\xBD",
		"\xE2\xDE" => "\xE5\xB7\xA1",
		"\xE2\xDF" => "\xE5\xBE\x87",
		"\xE2\xE0" => "\xE5\xBE\xAA",
		"\xE2\xE1" => "\xE6\x81\x82",
		"\xE2\xE2" => "\xE6\x97\xAC",
		"\xE2\xE3" => "\xE6\xA0\x92",
		"\xE2\xE4" => "\xE6\xA5\xAF",
		"\xE2\xE5" => "\xE6\xA9\x93",
		"\xE2\xE6" => "\xE6\xAE\x89",
		"\xE2\xE7" => "\xE6\xB4\xB5",
		"\xE2\xE8" => "\xE6\xB7\xB3",
		"\xE2\xE9" => "\xE7\x8F\xA3",
		"\xE2\xEA" => "\xE7\x9B\xBE",
		"\xE2\xEB" => "\xE7\x9E\xAC",
		"\xE2\xEC" => "\xE7\xAD\x8D",
		"\xE2\xED" => "\xE7\xB4\x94",
		"\xE2\xEE" => "\xE8\x84\xA3",
		"\xE2\xEF" => "\xE8\x88\x9C",
		"\xE2\xF0" => "\xE8\x8D\x80",
		"\xE2\xF1" => "\xE8\x93\xB4",
		"\xE2\xF2" => "\xE8\x95\xA3",
		"\xE2\xF3" => "\xE8\xA9\xA2",
		"\xE2\xF4" => "\xE8\xAB\x84",
		"\xE2\xF5" => "\xE9\x86\x87",
		"\xE2\xF6" => "\xE9\x8C\x9E",
		"\xE2\xF7" => "\xE9\xA0\x86",
		"\xE2\xF8" => "\xE9\xA6\xB4",
		"\xE2\xF9" => "\xE6\x88\x8C",
		"\xE2\xFA" => "\xE8\xA1\x93",
		"\xE2\xFB" => "\xE8\xBF\xB0",
		"\xE2\xFC" => "\xE9\x89\xA5",
		"\xE2\xFD" => "\xE5\xB4\x87",
		"\xE2\xFE" => "\xE5\xB4\xA7",
		"\xE3\xA1" => "\xE5\xB5\xA9",
		"\xE3\xA2" => "\xE7\x91\x9F",
		"\xE3\xA3" => "\xE8\x86\x9D",
		"\xE3\xA4" => "\xE8\x9D\xA8",
		"\xE3\xA5" => "\xE6\xBF\x95",
		"\xE3\xA6" => "\xE6\x8B\xBE",
		"\xE3\xA7" => "\xE7\xBF\x92",
		"\xE3\xA8" => "\xE8\xA4\xB6",
		"\xE3\xA9" => "\xE8\xA5\xB2",
		"\xE3\xAA" => "\xE4\xB8\x9E",
		"\xE3\xAB" => "\xE4\xB9\x98",
		"\xE3\xAC" => "\xE5\x83\xA7",
		"\xE3\xAD" => "\xE5\x8B\x9D",
		"\xE3\xAE" => "\xE5\x8D\x87",
		"\xE3\xAF" => "\xE6\x89\xBF",
		"\xE3\xB0" => "\xE6\x98\x87",
		"\xE3\xB1" => "\xE7\xB9\xA9",
		"\xE3\xB2" => "\xE8\xA0\x85",
		"\xE3\xB3" => "\xE9\x99\x9E",
		"\xE3\xB4" => "\xE4\xBE\x8D",
		"\xE3\xB5" => "\xE5\x8C\x99",
		"\xE3\xB6" => "\xE5\x98\xB6",
		"\xE3\xB7" => "\xE5\xA7\x8B",
		"\xE3\xB8" => "\xE5\xAA\xA4",
		"\xE3\xB9" => "\xE5\xB0\xB8",
		"\xE3\xBA" => "\xE5\xB1\x8E",
		"\xE3\xBB" => "\xE5\xB1\x8D",
		"\xE3\xBC" => "\xE5\xB8\x82",
		"\xE3\xBD" => "\xE5\xBC\x91",
		"\xE3\xBE" => "\xE6\x81\x83",
		"\xE3\xBF" => "\xE6\x96\xBD",
		"\xE3\xC0" => "\xE6\x98\xAF",
		"\xE3\xC1" => "\xE6\x99\x82",
		"\xE3\xC2" => "\xE6\x9E\xBE",
		"\xE3\xC3" => "\xE6\x9F\xB4",
		"\xE3\xC4" => "\xE7\x8C\x9C",
		"\xE3\xC5" => "\xE7\x9F\xA2",
		"\xE3\xC6" => "\xE7\xA4\xBA",
		"\xE3\xC7" => "\xE7\xBF\x85",
		"\xE3\xC8" => "\xE8\x92\x94",
		"\xE3\xC9" => "\xE8\x93\x8D",
		"\xE3\xCA" => "\xE8\xA6\x96",
		"\xE3\xCB" => "\xE8\xA9\xA6",
		"\xE3\xCC" => "\xE8\xA9\xA9",
		"\xE3\xCD" => "\xE8\xAB\xA1",
		"\xE3\xCE" => "\xE8\xB1\x95",
		"\xE3\xCF" => "\xE8\xB1\xBA",
		"\xE3\xD0" => "\xE5\x9F\xB4",
		"\xE3\xD1" => "\xE5\xAF\x94",
		"\xE3\xD2" => "\xE5\xBC\x8F",
		"\xE3\xD3" => "\xE6\x81\xAF",
		"\xE3\xD4" => "\xE6\x8B\xAD",
		"\xE3\xD5" => "\xE6\xA4\x8D",
		"\xE3\xD6" => "\xE6\xAE\x96",
		"\xE3\xD7" => "\xE6\xB9\x9C",
		"\xE3\xD8" => "\xE7\x86\x84",
		"\xE3\xD9" => "\xE7\xAF\x92",
		"\xE3\xDA" => "\xE8\x9D\x95",
		"\xE3\xDB" => "\xE8\xAD\x98",
		"\xE3\xDC" => "\xE8\xBB\xBE",
		"\xE3\xDD" => "\xE9\xA3\x9F",
		"\xE3\xDE" => "\xE9\xA3\xBE",
		"\xE3\xDF" => "\xE4\xBC\xB8",
		"\xE3\xE0" => "\xE4\xBE\x81",
		"\xE3\xE1" => "\xE4\xBF\xA1",
		"\xE3\xE2" => "\xE5\x91\xBB",
		"\xE3\xE3" => "\xE5\xA8\xA0",
		"\xE3\xE4" => "\xE5\xAE\xB8",
		"\xE3\xE5" => "\xE6\x84\xBC",
		"\xE3\xE6" => "\xE6\x96\xB0",
		"\xE3\xE7" => "\xE6\x99\xA8",
		"\xE3\xE8" => "\xE7\x87\xBC",
		"\xE3\xE9" => "\xE7\x94\xB3",
		"\xE3\xEA" => "\xE7\xA5\x9E",
		"\xE3\xEB" => "\xE7\xB4\xB3",
		"\xE3\xEC" => "\xE8\x85\x8E",
		"\xE3\xED" => "\xE8\x87\xA3",
		"\xE3\xEE" => "\xE8\x8E\x98",
		"\xE3\xEF" => "\xE8\x96\xAA",
		"\xE3\xF0" => "\xE8\x97\x8E",
		"\xE3\xF1" => "\xE8\x9C\x83",
		"\xE3\xF2" => "\xE8\xA8\x8A",
		"\xE3\xF3" => "\xE8\xBA\xAB",
		"\xE3\xF4" => "\xE8\xBE\x9B",
		"\xE3\xF5" => "\xEF\xA5\xB1",
		"\xE3\xF6" => "\xE8\xBF\x85",
		"\xE3\xF7" => "\xE5\xA4\xB1",
		"\xE3\xF8" => "\xE5\xAE\xA4",
		"\xE3\xF9" => "\xE5\xAF\xA6",
		"\xE3\xFA" => "\xE6\x82\x89",
		"\xE3\xFB" => "\xE5\xAF\xA9",
		"\xE3\xFC" => "\xE5\xB0\x8B",
		"\xE3\xFD" => "\xE5\xBF\x83",
		"\xE3\xFE" => "\xE6\xB2\x81",
		"\xE4\xA1" => "\xEF\xA5\xB2",
		"\xE4\xA2" => "\xE6\xB7\xB1",
		"\xE4\xA3" => "\xE7\x80\x8B",
		"\xE4\xA4" => "\xE7\x94\x9A",
		"\xE4\xA5" => "\xE8\x8A\xAF",
		"\xE4\xA6" => "\xE8\xAB\xB6",
		"\xE4\xA7" => "\xE4\xBB\x80",
		"\xE4\xA8" => "\xE5\x8D\x81",
		"\xE4\xA9" => "\xEF\xA5\xB3",
		"\xE4\xAA" => "\xE9\x9B\x99",
		"\xE4\xAB" => "\xE6\xB0\x8F",
		"\xE4\xAC" => "\xE4\xBA\x9E",
		"\xE4\xAD" => "\xE4\xBF\x84",
		"\xE4\xAE" => "\xE5\x85\x92",
		"\xE4\xAF" => "\xE5\x95\x9E",
		"\xE4\xB0" => "\xE5\xA8\xA5",
		"\xE4\xB1" => "\xE5\xB3\xA8",
		"\xE4\xB2" => "\xE6\x88\x91",
		"\xE4\xB3" => "\xE7\x89\x99",
		"\xE4\xB4" => "\xE8\x8A\xBD",
		"\xE4\xB5" => "\xE8\x8E\xAA",
		"\xE4\xB6" => "\xE8\x9B\xBE",
		"\xE4\xB7" => "\xE8\xA1\x99",
		"\xE4\xB8" => "\xE8\xA8\x9D",
		"\xE4\xB9" => "\xE9\x98\xBF",
		"\xE4\xBA" => "\xE9\x9B\x85",
		"\xE4\xBB" => "\xE9\xA4\x93",
		"\xE4\xBC" => "\xE9\xB4\x89",
		"\xE4\xBD" => "\xE9\xB5\x9D",
		"\xE4\xBE" => "\xE5\xA0\x8A",
		"\xE4\xBF" => "\xE5\xB2\xB3",
		"\xE4\xC0" => "\xE5\xB6\xBD",
		"\xE4\xC1" => "\xE5\xB9\x84",
		"\xE4\xC2" => "\xE6\x83\xA1",
		"\xE4\xC3" => "\xE6\x84\x95",
		"\xE4\xC4" => "\xE6\x8F\xA1",
		"\xE4\xC5" => "\xE6\xA8\x82",
		"\xE4\xC6" => "\xE6\xB8\xA5",
		"\xE4\xC7" => "\xE9\x84\x82",
		"\xE4\xC8" => "\xE9\x8D\x94",
		"\xE4\xC9" => "\xE9\xA1\x8E",
		"\xE4\xCA" => "\xE9\xB0\x90",
		"\xE4\xCB" => "\xE9\xBD\xB7",
		"\xE4\xCC" => "\xE5\xAE\x89",
		"\xE4\xCD" => "\xE5\xB2\xB8",
		"\xE4\xCE" => "\xE6\x8C\x89",
		"\xE4\xCF" => "\xE6\x99\x8F",
		"\xE4\xD0" => "\xE6\xA1\x88",
		"\xE4\xD1" => "\xE7\x9C\xBC",
		"\xE4\xD2" => "\xE9\x9B\x81",
		"\xE4\xD3" => "\xE9\x9E\x8D",
		"\xE4\xD4" => "\xE9\xA1\x94",
		"\xE4\xD5" => "\xE9\xAE\x9F",
		"\xE4\xD6" => "\xE6\x96\xA1",
		"\xE4\xD7" => "\xE8\xAC\x81",
		"\xE4\xD8" => "\xE8\xBB\x8B",
		"\xE4\xD9" => "\xE9\x96\xBC",
		"\xE4\xDA" => "\xE5\x94\xB5",
		"\xE4\xDB" => "\xE5\xB2\xA9",
		"\xE4\xDC" => "\xE5\xB7\x96",
		"\xE4\xDD" => "\xE5\xBA\xB5",
		"\xE4\xDE" => "\xE6\x9A\x97",
		"\xE4\xDF" => "\xE7\x99\x8C",
		"\xE4\xE0" => "\xE8\x8F\xB4",
		"\xE4\xE1" => "\xE9\x97\x87",
		"\xE4\xE2" => "\xE5\xA3\x93",
		"\xE4\xE3" => "\xE6\x8A\xBC",
		"\xE4\xE4" => "\xE7\x8B\x8E",
		"\xE4\xE5" => "\xE9\xB4\xA8",
		"\xE4\xE6" => "\xE4\xBB\xB0",
		"\xE4\xE7" => "\xE5\xA4\xAE",
		"\xE4\xE8" => "\xE6\x80\x8F",
		"\xE4\xE9" => "\xE6\x98\xBB",
		"\xE4\xEA" => "\xE6\xAE\x83",
		"\xE4\xEB" => "\xE7\xA7\xA7",
		"\xE4\xEC" => "\xE9\xB4\xA6",
		"\xE4\xED" => "\xE5\x8E\x93",
		"\xE4\xEE" => "\xE5\x93\x80",
		"\xE4\xEF" => "\xE5\x9F\x83",
		"\xE4\xF0" => "\xE5\xB4\x96",
		"\xE4\xF1" => "\xE6\x84\x9B",
		"\xE4\xF2" => "\xE6\x9B\x96",
		"\xE4\xF3" => "\xE6\xB6\xAF",
		"\xE4\xF4" => "\xE7\xA2\x8D",
		"\xE4\xF5" => "\xE8\x89\xBE",
		"\xE4\xF6" => "\xE9\x9A\x98",
		"\xE4\xF7" => "\xE9\x9D\x84",
		"\xE4\xF8" => "\xE5\x8E\x84",
		"\xE4\xF9" => "\xE6\x89\xBC",
		"\xE4\xFA" => "\xE6\x8E\x96",
		"\xE4\xFB" => "\xE6\xB6\xB2",
		"\xE4\xFC" => "\xE7\xB8\x8A",
		"\xE4\xFD" => "\xE8\x85\x8B",
		"\xE4\xFE" => "\xE9\xA1\x8D",
		"\xE5\xA1" => "\xE6\xAB\xBB",
		"\xE5\xA2" => "\xE7\xBD\x8C",
		"\xE5\xA3" => "\xE9\xB6\xAF",
		"\xE5\xA4" => "\xE9\xB8\x9A",
		"\xE5\xA5" => "\xE4\xB9\x9F",
		"\xE5\xA6" => "\xE5\x80\xBB",
		"\xE5\xA7" => "\xE5\x86\xB6",
		"\xE5\xA8" => "\xE5\xA4\x9C",
		"\xE5\xA9" => "\xE6\x83\xB9",
		"\xE5\xAA" => "\xE6\x8F\xB6",
		"\xE5\xAB" => "\xE6\xA4\xB0",
		"\xE5\xAC" => "\xE7\x88\xBA",
		"\xE5\xAD" => "\xE8\x80\xB6",
		"\xE5\xAE" => "\xEF\xA5\xB4",
		"\xE5\xAF" => "\xE9\x87\x8E",
		"\xE5\xB0" => "\xE5\xBC\xB1",
		"\xE5\xB1" => "\xEF\xA5\xB5",
		"\xE5\xB2" => "\xEF\xA5\xB6",
		"\xE5\xB3" => "\xE7\xB4\x84",
		"\xE5\xB4" => "\xE8\x8B\xA5",
		"\xE5\xB5" => "\xE8\x91\xAF",
		"\xE5\xB6" => "\xE8\x92\xBB",
		"\xE5\xB7" => "\xE8\x97\xA5",
		"\xE5\xB8" => "\xE8\xBA\x8D",
		"\xE5\xB9" => "\xEF\xA5\xB7",
		"\xE5\xBA" => "\xE4\xBD\xAF",
		"\xE5\xBB" => "\xEF\xA5\xB8",
		"\xE5\xBC" => "\xEF\xA5\xB9",
		"\xE5\xBD" => "\xE5\xA3\xA4",
		"\xE5\xBE" => "\xE5\xAD\x83",
		"\xE5\xBF" => "\xE6\x81\x99",
		"\xE5\xC0" => "\xE6\x8F\x9A",
		"\xE5\xC1" => "\xE6\x94\x98",
		"\xE5\xC2" => "\xE6\x95\xAD",
		"\xE5\xC3" => "\xE6\x9A\x98",
		"\xE5\xC4" => "\xEF\xA5\xBA",
		"\xE5\xC5" => "\xE6\xA5\x8A",
		"\xE5\xC6" => "\xE6\xA8\xA3",
		"\xE5\xC7" => "\xE6\xB4\x8B",
		"\xE5\xC8" => "\xE7\x80\x81",
		"\xE5\xC9" => "\xE7\x85\xAC",
		"\xE5\xCA" => "\xE7\x97\x92",
		"\xE5\xCB" => "\xE7\x98\x8D",
		"\xE5\xCC" => "\xE7\xA6\xB3",
		"\xE5\xCD" => "\xE7\xA9\xB0",
		"\xE5\xCE" => "\xEF\xA5\xBB",
		"\xE5\xCF" => "\xE7\xBE\x8A",
		"\xE5\xD0" => "\xEF\xA5\xBC",
		"\xE5\xD1" => "\xE8\xA5\x84",
		"\xE5\xD2" => "\xEF\xA5\xBD",
		"\xE5\xD3" => "\xE8\xAE\x93",
		"\xE5\xD4" => "\xE9\x87\x80",
		"\xE5\xD5" => "\xE9\x99\xBD",
		"\xE5\xD6" => "\xEF\xA5\xBE",
		"\xE5\xD7" => "\xE9\xA4\x8A",
		"\xE5\xD8" => "\xE5\x9C\x84",
		"\xE5\xD9" => "\xE5\xBE\xA1",
		"\xE5\xDA" => "\xE6\x96\xBC",
		"\xE5\xDB" => "\xE6\xBC\x81",
		"\xE5\xDC" => "\xE7\x98\x80",
		"\xE5\xDD" => "\xE7\xA6\xA6",
		"\xE5\xDE" => "\xE8\xAA\x9E",
		"\xE5\xDF" => "\xE9\xA6\xAD",
		"\xE5\xE0" => "\xE9\xAD\x9A",
		"\xE5\xE1" => "\xE9\xBD\xAC",
		"\xE5\xE2" => "\xE5\x84\x84",
		"\xE5\xE3" => "\xE6\x86\xB6",
		"\xE5\xE4" => "\xE6\x8A\x91",
		"\xE5\xE5" => "\xE6\xAA\x8D",
		"\xE5\xE6" => "\xE8\x87\x86",
		"\xE5\xE7" => "\xE5\x81\x83",
		"\xE5\xE8" => "\xE5\xA0\xB0",
		"\xE5\xE9" => "\xE5\xBD\xA6",
		"\xE5\xEA" => "\xE7\x84\x89",
		"\xE5\xEB" => "\xE8\xA8\x80",
		"\xE5\xEC" => "\xE8\xAB\xBA",
		"\xE5\xED" => "\xE5\xAD\xBC",
		"\xE5\xEE" => "\xE8\x98\x96",
		"\xE5\xEF" => "\xE4\xBF\xBA",
		"\xE5\xF0" => "\xE5\x84\xBC",
		"\xE5\xF1" => "\xE5\x9A\xB4",
		"\xE5\xF2" => "\xE5\xA5\x84",
		"\xE5\xF3" => "\xE6\x8E\xA9",
		"\xE5\xF4" => "\xE6\xB7\xB9",
		"\xE5\xF5" => "\xE5\xB6\xAA",
		"\xE5\xF6" => "\xE6\xA5\xAD",
		"\xE5\xF7" => "\xE5\x86\x86",
		"\xE5\xF8" => "\xE4\xBA\x88",
		"\xE5\xF9" => "\xE4\xBD\x99",
		"\xE5\xFA" => "\xEF\xA5\xBF",
		"\xE5\xFB" => "\xEF\xA6\x80",
		"\xE5\xFC" => "\xEF\xA6\x81",
		"\xE5\xFD" => "\xE5\xA6\x82",
		"\xE5\xFE" => "\xEF\xA6\x82",
		"\xE6\xA1" => "\xEF\xA6\x83",
		"\xE6\xA2" => "\xE6\xAD\x9F",
		"\xE6\xA3" => "\xE6\xB1\x9D",
		"\xE6\xA4" => "\xEF\xA6\x84",
		"\xE6\xA5" => "\xE7\x92\xB5",
		"\xE6\xA6" => "\xE7\xA4\x96",
		"\xE6\xA7" => "\xEF\xA6\x85",
		"\xE6\xA8" => "\xE8\x88\x87",
		"\xE6\xA9" => "\xE8\x89\x85",
		"\xE6\xAA" => "\xE8\x8C\xB9",
		"\xE6\xAB" => "\xE8\xBC\xBF",
		"\xE6\xAC" => "\xE8\xBD\x9D",
		"\xE6\xAD" => "\xEF\xA6\x86",
		"\xE6\xAE" => "\xE9\xA4\x98",
		"\xE6\xAF" => "\xEF\xA6\x87",
		"\xE6\xB0" => "\xEF\xA6\x88",
		"\xE6\xB1" => "\xEF\xA6\x89",
		"\xE6\xB2" => "\xE4\xBA\xA6",
		"\xE6\xB3" => "\xEF\xA6\x8A",
		"\xE6\xB4" => "\xE5\x9F\x9F",
		"\xE6\xB5" => "\xE5\xBD\xB9",
		"\xE6\xB6" => "\xE6\x98\x93",
		"\xE6\xB7" => "\xEF\xA6\x8B",
		"\xE6\xB8" => "\xEF\xA6\x8C",
		"\xE6\xB9" => "\xE7\x96\xAB",
		"\xE6\xBA" => "\xE7\xB9\xB9",
		"\xE6\xBB" => "\xE8\xAD\xAF",
		"\xE6\xBC" => "\xEF\xA6\x8D",
		"\xE6\xBD" => "\xE9\x80\x86",
		"\xE6\xBE" => "\xE9\xA9\x9B",
		"\xE6\xBF" => "\xE5\x9A\xA5",
		"\xE6\xC0" => "\xE5\xA0\xA7",
		"\xE6\xC1" => "\xE5\xA7\xB8",
		"\xE6\xC2" => "\xE5\xA8\x9F",
		"\xE6\xC3" => "\xE5\xAE\xB4",
		"\xE6\xC4" => "\xEF\xA6\x8E",
		"\xE6\xC5" => "\xE5\xBB\xB6",
		"\xE6\xC6" => "\xEF\xA6\x8F",
		"\xE6\xC7" => "\xEF\xA6\x90",
		"\xE6\xC8" => "\xE6\x8D\x90",
		"\xE6\xC9" => "\xE6\x8C\xBB",
		"\xE6\xCA" => "\xEF\xA6\x91",
		"\xE6\xCB" => "\xE6\xA4\xBD",
		"\xE6\xCC" => "\xE6\xB2\x87",
		"\xE6\xCD" => "\xE6\xB2\xBF",
		"\xE6\xCE" => "\xE6\xB6\x8E",
		"\xE6\xCF" => "\xE6\xB6\x93",
		"\xE6\xD0" => "\xE6\xB7\xB5",
		"\xE6\xD1" => "\xE6\xBC\x94",
		"\xE6\xD2" => "\xEF\xA6\x92",
		"\xE6\xD3" => "\xE7\x83\x9F",
		"\xE6\xD4" => "\xE7\x84\xB6",
		"\xE6\xD5" => "\xE7\x85\x99",
		"\xE6\xD6" => "\xEF\xA6\x93",
		"\xE6\xD7" => "\xE7\x87\x83",
		"\xE6\xD8" => "\xE7\x87\x95",
		"\xE6\xD9" => "\xEF\xA6\x94",
		"\xE6\xDA" => "\xE7\xA1\x8F",
		"\xE6\xDB" => "\xE7\xA1\xAF",
		"\xE6\xDC" => "\xEF\xA6\x95",
		"\xE6\xDD" => "\xE7\xAD\xB5",
		"\xE6\xDE" => "\xE7\xB7\xA3",
		"\xE6\xDF" => "\xEF\xA6\x96",
		"\xE6\xE0" => "\xE7\xB8\xAF",
		"\xE6\xE1" => "\xEF\xA6\x97",
		"\xE6\xE2" => "\xE8\xA1\x8D",
		"\xE6\xE3" => "\xE8\xBB\x9F",
		"\xE6\xE4" => "\xEF\xA6\x98",
		"\xE6\xE5" => "\xEF\xA6\x99",
		"\xE6\xE6" => "\xEF\xA6\x9A",
		"\xE6\xE7" => "\xE9\x89\x9B",
		"\xE6\xE8" => "\xEF\xA6\x9B",
		"\xE6\xE9" => "\xE9\xB3\xB6",
		"\xE6\xEA" => "\xEF\xA6\x9C",
		"\xE6\xEB" => "\xEF\xA6\x9D",
		"\xE6\xEC" => "\xEF\xA6\x9E",
		"\xE6\xED" => "\xE6\x82\x85",
		"\xE6\xEE" => "\xE6\xB6\x85",
		"\xE6\xEF" => "\xEF\xA6\x9F",
		"\xE6\xF0" => "\xE7\x86\xB1",
		"\xE6\xF1" => "\xEF\xA6\xA0",
		"\xE6\xF2" => "\xEF\xA6\xA1",
		"\xE6\xF3" => "\xE9\x96\xB1",
		"\xE6\xF4" => "\xE5\x8E\xAD",
		"\xE6\xF5" => "\xEF\xA6\xA2",
		"\xE6\xF6" => "\xEF\xA6\xA3",
		"\xE6\xF7" => "\xEF\xA6\xA4",
		"\xE6\xF8" => "\xE6\x9F\x93",
		"\xE6\xF9" => "\xEF\xA6\xA5",
		"\xE6\xFA" => "\xE7\x82\x8E",
		"\xE6\xFB" => "\xE7\x84\xB0",
		"\xE6\xFC" => "\xE7\x90\xB0",
		"\xE6\xFD" => "\xE8\x89\xB6",
		"\xE6\xFE" => "\xE8\x8B\x92",
		"\xE7\xA1" => "\xEF\xA6\xA6",
		"\xE7\xA2" => "\xE9\x96\xBB",
		"\xE7\xA3" => "\xE9\xAB\xA5",
		"\xE7\xA4" => "\xE9\xB9\xBD",
		"\xE7\xA5" => "\xE6\x9B\x84",
		"\xE7\xA6" => "\xEF\xA6\xA7",
		"\xE7\xA7" => "\xE7\x87\x81",
		"\xE7\xA8" => "\xE8\x91\x89",
		"\xE7\xA9" => "\xEF\xA6\xA8",
		"\xE7\xAA" => "\xEF\xA6\xA9",
		"\xE7\xAB" => "\xE5\xA1\x8B",
		"\xE7\xAC" => "\xEF\xA6\xAA",
		"\xE7\xAD" => "\xEF\xA6\xAB",
		"\xE7\xAE" => "\xE5\xB6\xB8",
		"\xE7\xAF" => "\xE5\xBD\xB1",
		"\xE7\xB0" => "\xEF\xA6\xAC",
		"\xE7\xB1" => "\xE6\x98\xA0",
		"\xE7\xB2" => "\xE6\x9A\x8E",
		"\xE7\xB3" => "\xE6\xA5\xB9",
		"\xE7\xB4" => "\xE6\xA6\xAE",
		"\xE7\xB5" => "\xE6\xB0\xB8",
		"\xE7\xB6" => "\xE6\xB3\xB3",
		"\xE7\xB7" => "\xE6\xB8\xB6",
		"\xE7\xB8" => "\xE6\xBD\x81",
		"\xE7\xB9" => "\xE6\xBF\x9A",
		"\xE7\xBA" => "\xE7\x80\x9B",
		"\xE7\xBB" => "\xE7\x80\xAF",
		"\xE7\xBC" => "\xE7\x85\x90",
		"\xE7\xBD" => "\xE7\x87\x9F",
		"\xE7\xBE" => "\xE7\x8D\xB0",
		"\xE7\xBF" => "\xEF\xA6\xAD",
		"\xE7\xC0" => "\xE7\x91\x9B",
		"\xE7\xC1" => "\xEF\xA6\xAE",
		"\xE7\xC2" => "\xE7\x93\x94",
		"\xE7\xC3" => "\xE7\x9B\x88",
		"\xE7\xC4" => "\xE7\xA9\x8E",
		"\xE7\xC5" => "\xE7\xBA\x93",
		"\xE7\xC6" => "\xEF\xA6\xAF",
		"\xE7\xC7" => "\xEF\xA6\xB0",
		"\xE7\xC8" => "\xE8\x8B\xB1",
		"\xE7\xC9" => "\xE8\xA9\xA0",
		"\xE7\xCA" => "\xE8\xBF\x8E",
		"\xE7\xCB" => "\xEF\xA6\xB1",
		"\xE7\xCC" => "\xE9\x8D\x88",
		"\xE7\xCD" => "\xEF\xA6\xB2",
		"\xE7\xCE" => "\xE9\x9C\x99",
		"\xE7\xCF" => "\xEF\xA6\xB3",
		"\xE7\xD0" => "\xEF\xA6\xB4",
		"\xE7\xD1" => "\xE4\xB9\x82",
		"\xE7\xD2" => "\xE5\x80\xAA",
		"\xE7\xD3" => "\xEF\xA6\xB5",
		"\xE7\xD4" => "\xE5\x88\x88",
		"\xE7\xD5" => "\xE5\x8F\xA1",
		"\xE7\xD6" => "\xE6\x9B\xB3",
		"\xE7\xD7" => "\xE6\xB1\xAD",
		"\xE7\xD8" => "\xE6\xBF\x8A",
		"\xE7\xD9" => "\xE7\x8C\x8A",
		"\xE7\xDA" => "\xE7\x9D\xBF",
		"\xE7\xDB" => "\xE7\xA9\xA2",
		"\xE7\xDC" => "\xE8\x8A\xAE",
		"\xE7\xDD" => "\xE8\x97\x9D",
		"\xE7\xDE" => "\xE8\x98\x82",
		"\xE7\xDF" => "\xEF\xA6\xB6",
		"\xE7\xE0" => "\xE8\xA3\x94",
		"\xE7\xE1" => "\xE8\xA9\xA3",
		"\xE7\xE2" => "\xE8\xAD\xBD",
		"\xE7\xE3" => "\xE8\xB1\xAB",
		"\xE7\xE4" => "\xEF\xA6\xB7",
		"\xE7\xE5" => "\xE9\x8A\xB3",
		"\xE7\xE6" => "\xEF\xA6\xB8",
		"\xE7\xE7" => "\xE9\x9C\x93",
		"\xE7\xE8" => "\xE9\xA0\x90",
		"\xE7\xE9" => "\xE4\xBA\x94",
		"\xE7\xEA" => "\xE4\xBC\x8D",
		"\xE7\xEB" => "\xE4\xBF\x89",
		"\xE7\xEC" => "\xE5\x82\xB2",
		"\xE7\xED" => "\xE5\x8D\x88",
		"\xE7\xEE" => "\xE5\x90\xBE",
		"\xE7\xEF" => "\xE5\x90\xB3",
		"\xE7\xF0" => "\xE5\x97\x9A",
		"\xE7\xF1" => "\xE5\xA1\xA2",
		"\xE7\xF2" => "\xE5\xA2\xBA",
		"\xE7\xF3" => "\xE5\xA5\xA7",
		"\xE7\xF4" => "\xE5\xA8\x9B",
		"\xE7\xF5" => "\xE5\xAF\xA4",
		"\xE7\xF6" => "\xE6\x82\x9F",
		"\xE7\xF7" => "\xEF\xA6\xB9",
		"\xE7\xF8" => "\xE6\x87\x8A",
		"\xE7\xF9" => "\xE6\x95\x96",
		"\xE7\xFA" => "\xE6\x97\xBF",
		"\xE7\xFB" => "\xE6\x99\xA4",
		"\xE7\xFC" => "\xE6\xA2\xA7",
		"\xE7\xFD" => "\xE6\xB1\x9A",
		"\xE7\xFE" => "\xE6\xBE\xB3",
		"\xE8\xA1" => "\xE7\x83\x8F",
		"\xE8\xA2" => "\xE7\x86\xAC",
		"\xE8\xA3" => "\xE7\x8D\x92",
		"\xE8\xA4" => "\xE7\xAD\xBD",
		"\xE8\xA5" => "\xE8\x9C\x88",
		"\xE8\xA6" => "\xE8\xAA\xA4",
		"\xE8\xA7" => "\xE9\xB0\xB2",
		"\xE8\xA8" => "\xE9\xBC\x87",
		"\xE8\xA9" => "\xE5\xB1\x8B",
		"\xE8\xAA" => "\xE6\xB2\x83",
		"\xE8\xAB" => "\xE7\x8D\x84",
		"\xE8\xAC" => "\xE7\x8E\x89",
		"\xE8\xAD" => "\xE9\x88\xBA",
		"\xE8\xAE" => "\xE6\xBA\xAB",
		"\xE8\xAF" => "\xE7\x91\xA5",
		"\xE8\xB0" => "\xE7\x98\x9F",
		"\xE8\xB1" => "\xE7\xA9\xA9",
		"\xE8\xB2" => "\xE7\xB8\x95",
		"\xE8\xB3" => "\xE8\x98\x8A",
		"\xE8\xB4" => "\xE5\x85\x80",
		"\xE8\xB5" => "\xE5\xA3\x85",
		"\xE8\xB6" => "\xE6\x93\x81",
		"\xE8\xB7" => "\xE7\x93\xAE",
		"\xE8\xB8" => "\xE7\x94\x95",
		"\xE8\xB9" => "\xE7\x99\xB0",
		"\xE8\xBA" => "\xE7\xBF\x81",
		"\xE8\xBB" => "\xE9\x82\x95",
		"\xE8\xBC" => "\xE9\x9B\x8D",
		"\xE8\xBD" => "\xE9\xA5\x94",
		"\xE8\xBE" => "\xE6\xB8\xA6",
		"\xE8\xBF" => "\xE7\x93\xA6",
		"\xE8\xC0" => "\xE7\xAA\xA9",
		"\xE8\xC1" => "\xE7\xAA\xAA",
		"\xE8\xC2" => "\xE8\x87\xA5",
		"\xE8\xC3" => "\xE8\x9B\x99",
		"\xE8\xC4" => "\xE8\x9D\xB8",
		"\xE8\xC5" => "\xE8\xA8\x9B",
		"\xE8\xC6" => "\xE5\xA9\x89",
		"\xE8\xC7" => "\xE5\xAE\x8C",
		"\xE8\xC8" => "\xE5\xAE\x9B",
		"\xE8\xC9" => "\xE6\xA2\xA1",
		"\xE8\xCA" => "\xE6\xA4\x80",
		"\xE8\xCB" => "\xE6\xB5\xA3",
		"\xE8\xCC" => "\xE7\x8E\xA9",
		"\xE8\xCD" => "\xE7\x90\x93",
		"\xE8\xCE" => "\xE7\x90\xAC",
		"\xE8\xCF" => "\xE7\xA2\x97",
		"\xE8\xD0" => "\xE7\xB7\xA9",
		"\xE8\xD1" => "\xE7\xBF\xAB",
		"\xE8\xD2" => "\xE8\x84\x98",
		"\xE8\xD3" => "\xE8\x85\x95",
		"\xE8\xD4" => "\xE8\x8E\x9E",
		"\xE8\xD5" => "\xE8\xB1\x8C",
		"\xE8\xD6" => "\xE9\x98\xAE",
		"\xE8\xD7" => "\xE9\xA0\x91",
		"\xE8\xD8" => "\xE6\x9B\xB0",
		"\xE8\xD9" => "\xE5\xBE\x80",
		"\xE8\xDA" => "\xE6\x97\xBA",
		"\xE8\xDB" => "\xE6\x9E\x89",
		"\xE8\xDC" => "\xE6\xB1\xAA",
		"\xE8\xDD" => "\xE7\x8E\x8B",
		"\xE8\xDE" => "\xE5\x80\xAD",
		"\xE8\xDF" => "\xE5\xA8\x83",
		"\xE8\xE0" => "\xE6\xAD\xAA",
		"\xE8\xE1" => "\xE7\x9F\xAE",
		"\xE8\xE2" => "\xE5\xA4\x96",
		"\xE8\xE3" => "\xE5\xB5\xAC",
		"\xE8\xE4" => "\xE5\xB7\x8D",
		"\xE8\xE5" => "\xE7\x8C\xA5",
		"\xE8\xE6" => "\xE7\x95\x8F",
		"\xE8\xE7" => "\xEF\xA6\xBA",
		"\xE8\xE8" => "\xEF\xA6\xBB",
		"\xE8\xE9" => "\xE5\x83\xA5",
		"\xE8\xEA" => "\xE5\x87\xB9",
		"\xE8\xEB" => "\xE5\xA0\xAF",
		"\xE8\xEC" => "\xE5\xA4\xAD",
		"\xE8\xED" => "\xE5\xA6\x96",
		"\xE8\xEE" => "\xE5\xA7\x9A",
		"\xE8\xEF" => "\xE5\xAF\xA5",
		"\xE8\xF0" => "\xEF\xA6\xBC",
		"\xE8\xF1" => "\xEF\xA6\xBD",
		"\xE8\xF2" => "\xE5\xB6\xA2",
		"\xE8\xF3" => "\xE6\x8B\x97",
		"\xE8\xF4" => "\xE6\x90\x96",
		"\xE8\xF5" => "\xE6\x92\x93",
		"\xE8\xF6" => "\xE6\x93\xBE",
		"\xE8\xF7" => "\xEF\xA6\xBE",
		"\xE8\xF8" => "\xE6\x9B\x9C",
		"\xE8\xF9" => "\xEF\xA6\xBF",
		"\xE8\xFA" => "\xE6\xA9\x88",
		"\xE8\xFB" => "\xEF\xA7\x80",
		"\xE8\xFC" => "\xE7\x87\xBF",
		"\xE8\xFD" => "\xE7\x91\xA4",
		"\xE8\xFE" => "\xEF\xA7\x81",
		"\xE9\xA1" => "\xE7\xAA\x88",
		"\xE9\xA2" => "\xE7\xAA\xAF",
		"\xE9\xA3" => "\xE7\xB9\x87",
		"\xE9\xA4" => "\xE7\xB9\x9E",
		"\xE9\xA5" => "\xE8\x80\x80",
		"\xE9\xA6" => "\xE8\x85\xB0",
		"\xE9\xA7" => "\xEF\xA7\x82",
		"\xE9\xA8" => "\xE8\x9F\xAF",
		"\xE9\xA9" => "\xE8\xA6\x81",
		"\xE9\xAA" => "\xE8\xAC\xA0",
		"\xE9\xAB" => "\xE9\x81\x99",
		"\xE9\xAC" => "\xEF\xA7\x83",
		"\xE9\xAD" => "\xE9\x82\x80",
		"\xE9\xAE" => "\xE9\xA5\x92",
		"\xE9\xAF" => "\xE6\x85\xBE",
		"\xE9\xB0" => "\xE6\xAC\xB2",
		"\xE9\xB1" => "\xE6\xB5\xB4",
		"\xE9\xB2" => "\xE7\xB8\x9F",
		"\xE9\xB3" => "\xE8\xA4\xA5",
		"\xE9\xB4" => "\xE8\xBE\xB1",
		"\xE9\xB5" => "\xE4\xBF\x91",
		"\xE9\xB6" => "\xE5\x82\xAD",
		"\xE9\xB7" => "\xE5\x86\x97",
		"\xE9\xB8" => "\xE5\x8B\x87",
		"\xE9\xB9" => "\xE5\x9F\x87",
		"\xE9\xBA" => "\xE5\xA2\x89",
		"\xE9\xBB" => "\xE5\xAE\xB9",
		"\xE9\xBC" => "\xE5\xBA\xB8",
		"\xE9\xBD" => "\xE6\x85\x82",
		"\xE9\xBE" => "\xE6\xA6\x95",
		"\xE9\xBF" => "\xE6\xB6\x8C",
		"\xE9\xC0" => "\xE6\xB9\xA7",
		"\xE9\xC1" => "\xE6\xBA\xB6",
		"\xE9\xC2" => "\xE7\x86\x94",
		"\xE9\xC3" => "\xE7\x91\xA2",
		"\xE9\xC4" => "\xE7\x94\xA8",
		"\xE9\xC5" => "\xE7\x94\xAC",
		"\xE9\xC6" => "\xE8\x81\xB3",
		"\xE9\xC7" => "\xE8\x8C\xB8",
		"\xE9\xC8" => "\xE8\x93\x89",
		"\xE9\xC9" => "\xE8\xB8\x8A",
		"\xE9\xCA" => "\xE9\x8E\x94",
		"\xE9\xCB" => "\xE9\x8F\x9E",
		"\xE9\xCC" => "\xEF\xA7\x84",
		"\xE9\xCD" => "\xE4\xBA\x8E",
		"\xE9\xCE" => "\xE4\xBD\x91",
		"\xE9\xCF" => "\xE5\x81\xB6",
		"\xE9\xD0" => "\xE5\x84\xAA",
		"\xE9\xD1" => "\xE5\x8F\x88",
		"\xE9\xD2" => "\xE5\x8F\x8B",
		"\xE9\xD3" => "\xE5\x8F\xB3",
		"\xE9\xD4" => "\xE5\xAE\x87",
		"\xE9\xD5" => "\xE5\xAF\x93",
		"\xE9\xD6" => "\xE5\xB0\xA4",
		"\xE9\xD7" => "\xE6\x84\x9A",
		"\xE9\xD8" => "\xE6\x86\x82",
		"\xE9\xD9" => "\xE6\x97\xB4",
		"\xE9\xDA" => "\xE7\x89\x9B",
		"\xE9\xDB" => "\xE7\x8E\x97",
		"\xE9\xDC" => "\xE7\x91\x80",
		"\xE9\xDD" => "\xE7\x9B\x82",
		"\xE9\xDE" => "\xE7\xA5\x90",
		"\xE9\xDF" => "\xE7\xA6\x91",
		"\xE9\xE0" => "\xE7\xA6\xB9",
		"\xE9\xE1" => "\xE7\xB4\x86",
		"\xE9\xE2" => "\xE7\xBE\xBD",
		"\xE9\xE3" => "\xE8\x8A\x8B",
		"\xE9\xE4" => "\xE8\x97\x95",
		"\xE9\xE5" => "\xE8\x99\x9E",
		"\xE9\xE6" => "\xE8\xBF\x82",
		"\xE9\xE7" => "\xE9\x81\x87",
		"\xE9\xE8" => "\xE9\x83\xB5",
		"\xE9\xE9" => "\xE9\x87\xAA",
		"\xE9\xEA" => "\xE9\x9A\x85",
		"\xE9\xEB" => "\xE9\x9B\xA8",
		"\xE9\xEC" => "\xE9\x9B\xA9",
		"\xE9\xED" => "\xE5\x8B\x96",
		"\xE9\xEE" => "\xE5\xBD\xA7",
		"\xE9\xEF" => "\xE6\x97\xAD",
		"\xE9\xF0" => "\xE6\x98\xB1",
		"\xE9\xF1" => "\xE6\xA0\xAF",
		"\xE9\xF2" => "\xE7\x85\x9C",
		"\xE9\xF3" => "\xE7\xA8\xB6",
		"\xE9\xF4" => "\xE9\x83\x81",
		"\xE9\xF5" => "\xE9\xA0\x8A",
		"\xE9\xF6" => "\xE4\xBA\x91",
		"\xE9\xF7" => "\xEF\xA7\x85",
		"\xE9\xF8" => "\xE6\xA9\x92",
		"\xE9\xF9" => "\xE6\xAE\x9E",
		"\xE9\xFA" => "\xE6\xBE\x90",
		"\xE9\xFB" => "\xE7\x86\x89",
		"\xE9\xFC" => "\xE8\x80\x98",
		"\xE9\xFD" => "\xE8\x8A\xB8",
		"\xE9\xFE" => "\xE8\x95\x93",
		"\xEA\xA1" => "\xE9\x81\x8B",
		"\xEA\xA2" => "\xE9\x9A\x95",
		"\xEA\xA3" => "\xE9\x9B\xB2",
		"\xEA\xA4" => "\xE9\x9F\xBB",
		"\xEA\xA5" => "\xE8\x94\x9A",
		"\xEA\xA6" => "\xE9\xAC\xB1",
		"\xEA\xA7" => "\xE4\xBA\x90",
		"\xEA\xA8" => "\xE7\x86\x8A",
		"\xEA\xA9" => "\xE9\x9B\x84",
		"\xEA\xAA" => "\xE5\x85\x83",
		"\xEA\xAB" => "\xE5\x8E\x9F",
		"\xEA\xAC" => "\xE5\x93\xA1",
		"\xEA\xAD" => "\xE5\x9C\x93",
		"\xEA\xAE" => "\xE5\x9C\x92",
		"\xEA\xAF" => "\xE5\x9E\xA3",
		"\xEA\xB0" => "\xE5\xAA\x9B",
		"\xEA\xB1" => "\xE5\xAB\x84",
		"\xEA\xB2" => "\xE5\xAF\x83",
		"\xEA\xB3" => "\xE6\x80\xA8",
		"\xEA\xB4" => "\xE6\x84\xBF",
		"\xEA\xB5" => "\xE6\x8F\xB4",
		"\xEA\xB6" => "\xE6\xB2\x85",
		"\xEA\xB7" => "\xE6\xB4\xB9",
		"\xEA\xB8" => "\xE6\xB9\xB2",
		"\xEA\xB9" => "\xE6\xBA\x90",
		"\xEA\xBA" => "\xE7\x88\xB0",
		"\xEA\xBB" => "\xE7\x8C\xBF",
		"\xEA\xBC" => "\xE7\x91\x97",
		"\xEA\xBD" => "\xE8\x8B\x91",
		"\xEA\xBE" => "\xE8\xA2\x81",
		"\xEA\xBF" => "\xE8\xBD\x85",
		"\xEA\xC0" => "\xE9\x81\xA0",
		"\xEA\xC1" => "\xEF\xA7\x86",
		"\xEA\xC2" => "\xE9\x99\xA2",
		"\xEA\xC3" => "\xE9\xA1\x98",
		"\xEA\xC4" => "\xE9\xB4\x9B",
		"\xEA\xC5" => "\xE6\x9C\x88",
		"\xEA\xC6" => "\xE8\xB6\x8A",
		"\xEA\xC7" => "\xE9\x89\x9E",
		"\xEA\xC8" => "\xE4\xBD\x8D",
		"\xEA\xC9" => "\xE5\x81\x89",
		"\xEA\xCA" => "\xE5\x83\x9E",
		"\xEA\xCB" => "\xE5\x8D\xB1",
		"\xEA\xCC" => "\xE5\x9C\x8D",
		"\xEA\xCD" => "\xE5\xA7\x94",
		"\xEA\xCE" => "\xE5\xA8\x81",
		"\xEA\xCF" => "\xE5\xB0\x89",
		"\xEA\xD0" => "\xE6\x85\xB0",
		"\xEA\xD1" => "\xE6\x9A\x90",
		"\xEA\xD2" => "\xE6\xB8\xAD",
		"\xEA\xD3" => "\xE7\x88\xB2",
		"\xEA\xD4" => "\xE7\x91\x8B",
		"\xEA\xD5" => "\xE7\xB7\xAF",
		"\xEA\xD6" => "\xE8\x83\x83",
		"\xEA\xD7" => "\xE8\x90\x8E",
		"\xEA\xD8" => "\xE8\x91\xA6",
		"\xEA\xD9" => "\xE8\x94\xBF",
		"\xEA\xDA" => "\xE8\x9D\x9F",
		"\xEA\xDB" => "\xE8\xA1\x9B",
		"\xEA\xDC" => "\xE8\xA4\x98",
		"\xEA\xDD" => "\xE8\xAC\x82",
		"\xEA\xDE" => "\xE9\x81\x95",
		"\xEA\xDF" => "\xE9\x9F\x8B",
		"\xEA\xE0" => "\xE9\xAD\x8F",
		"\xEA\xE1" => "\xE4\xB9\xB3",
		"\xEA\xE2" => "\xE4\xBE\x91",
		"\xEA\xE3" => "\xE5\x84\x92",
		"\xEA\xE4" => "\xE5\x85\xAA",
		"\xEA\xE5" => "\xEF\xA7\x87",
		"\xEA\xE6" => "\xE5\x94\xAF",
		"\xEA\xE7" => "\xE5\x96\xA9",
		"\xEA\xE8" => "\xE5\xAD\xBA",
		"\xEA\xE9" => "\xE5\xAE\xA5",
		"\xEA\xEA" => "\xE5\xB9\xBC",
		"\xEA\xEB" => "\xE5\xB9\xBD",
		"\xEA\xEC" => "\xE5\xBA\xBE",
		"\xEA\xED" => "\xE6\x82\xA0",
		"\xEA\xEE" => "\xE6\x83\x9F",
		"\xEA\xEF" => "\xE6\x84\x88",
		"\xEA\xF0" => "\xE6\x84\x89",
		"\xEA\xF1" => "\xE6\x8F\x84",
		"\xEA\xF2" => "\xE6\x94\xB8",
		"\xEA\xF3" => "\xE6\x9C\x89",
		"\xEA\xF4" => "\xEF\xA7\x88",
		"\xEA\xF5" => "\xE6\x9F\x94",
		"\xEA\xF6" => "\xE6\x9F\x9A",
		"\xEA\xF7" => "\xEF\xA7\x89",
		"\xEA\xF8" => "\xE6\xA5\xA1",
		"\xEA\xF9" => "\xE6\xA5\xA2",
		"\xEA\xFA" => "\xE6\xB2\xB9",
		"\xEA\xFB" => "\xE6\xB4\xA7",
		"\xEA\xFC" => "\xEF\xA7\x8A",
		"\xEA\xFD" => "\xE6\xB8\xB8",
		"\xEA\xFE" => "\xEF\xA7\x8B",
		"\xEB\xA1" => "\xE6\xBF\xA1",
		"\xEB\xA2" => "\xE7\x8C\xB6",
		"\xEB\xA3" => "\xE7\x8C\xB7",
		"\xEB\xA4" => "\xEF\xA7\x8C",
		"\xEB\xA5" => "\xE7\x91\x9C",
		"\xEB\xA6" => "\xE7\x94\xB1",
		"\xEB\xA7" => "\xEF\xA7\x8D",
		"\xEB\xA8" => "\xE7\x99\x92",
		"\xEB\xA9" => "\xEF\xA7\x8E",
		"\xEB\xAA" => "\xEF\xA7\x8F",
		"\xEB\xAB" => "\xE7\xB6\xAD",
		"\xEB\xAC" => "\xE8\x87\xBE",
		"\xEB\xAD" => "\xE8\x90\xB8",
		"\xEB\xAE" => "\xE8\xA3\x95",
		"\xEB\xAF" => "\xE8\xAA\x98",
		"\xEB\xB0" => "\xE8\xAB\x9B",
		"\xEB\xB1" => "\xE8\xAB\xAD",
		"\xEB\xB2" => "\xE8\xB8\xB0",
		"\xEB\xB3" => "\xE8\xB9\x82",
		"\xEB\xB4" => "\xE9\x81\x8A",
		"\xEB\xB5" => "\xE9\x80\xBE",
		"\xEB\xB6" => "\xE9\x81\xBA",
		"\xEB\xB7" => "\xE9\x85\x89",
		"\xEB\xB8" => "\xE9\x87\x89",
		"\xEB\xB9" => "\xE9\x8D\xAE",
		"\xEB\xBA" => "\xEF\xA7\x90",
		"\xEB\xBB" => "\xEF\xA7\x91",
		"\xEB\xBC" => "\xE5\xA0\x89",
		"\xEB\xBD" => "\xEF\xA7\x92",
		"\xEB\xBE" => "\xE6\xAF\x93",
		"\xEB\xBF" => "\xE8\x82\x89",
		"\xEB\xC0" => "\xE8\x82\xB2",
		"\xEB\xC1" => "\xEF\xA7\x93",
		"\xEB\xC2" => "\xEF\xA7\x94",
		"\xEB\xC3" => "\xE5\x85\x81",
		"\xEB\xC4" => "\xE5\xA5\xAB",
		"\xEB\xC5" => "\xE5\xB0\xB9",
		"\xEB\xC6" => "\xEF\xA7\x95",
		"\xEB\xC7" => "\xEF\xA7\x96",
		"\xEB\xC8" => "\xE6\xBD\xA4",
		"\xEB\xC9" => "\xE7\x8E\xA7",
		"\xEB\xCA" => "\xE8\x83\xA4",
		"\xEB\xCB" => "\xE8\xB4\x87",
		"\xEB\xCC" => "\xEF\xA7\x97",
		"\xEB\xCD" => "\xE9\x88\x97",
		"\xEB\xCE" => "\xE9\x96\x8F",
		"\xEB\xCF" => "\xEF\xA7\x98",
		"\xEB\xD0" => "\xEF\xA7\x99",
		"\xEB\xD1" => "\xEF\xA7\x9A",
		"\xEB\xD2" => "\xEF\xA7\x9B",
		"\xEB\xD3" => "\xE8\x81\xBF",
		"\xEB\xD4" => "\xE6\x88\x8E",
		"\xEB\xD5" => "\xE7\x80\x9C",
		"\xEB\xD6" => "\xE7\xB5\xA8",
		"\xEB\xD7" => "\xE8\x9E\x8D",
		"\xEB\xD8" => "\xEF\xA7\x9C",
		"\xEB\xD9" => "\xE5\x9E\xA0",
		"\xEB\xDA" => "\xE6\x81\xA9",
		"\xEB\xDB" => "\xE6\x85\x87",
		"\xEB\xDC" => "\xE6\xAE\xB7",
		"\xEB\xDD" => "\xE8\xAA\xBE",
		"\xEB\xDE" => "\xE9\x8A\x80",
		"\xEB\xDF" => "\xE9\x9A\xB1",
		"\xEB\xE0" => "\xE4\xB9\x99",
		"\xEB\xE1" => "\xE5\x90\x9F",
		"\xEB\xE2" => "\xE6\xB7\xAB",
		"\xEB\xE3" => "\xE8\x94\xAD",
		"\xEB\xE4" => "\xE9\x99\xB0",
		"\xEB\xE5" => "\xE9\x9F\xB3",
		"\xEB\xE6" => "\xE9\xA3\xAE",
		"\xEB\xE7" => "\xE6\x8F\x96",
		"\xEB\xE8" => "\xE6\xB3\xA3",
		"\xEB\xE9" => "\xE9\x82\x91",
		"\xEB\xEA" => "\xE5\x87\x9D",
		"\xEB\xEB" => "\xE6\x87\x89",
		"\xEB\xEC" => "\xE8\x86\xBA",
		"\xEB\xED" => "\xE9\xB7\xB9",
		"\xEB\xEE" => "\xE4\xBE\x9D",
		"\xEB\xEF" => "\xE5\x80\x9A",
		"\xEB\xF0" => "\xE5\x84\x80",
		"\xEB\xF1" => "\xE5\xAE\x9C",
		"\xEB\xF2" => "\xE6\x84\x8F",
		"\xEB\xF3" => "\xE6\x87\xBF",
		"\xEB\xF4" => "\xE6\x93\xAC",
		"\xEB\xF5" => "\xE6\xA4\x85",
		"\xEB\xF6" => "\xE6\xAF\x85",
		"\xEB\xF7" => "\xE7\x96\x91",
		"\xEB\xF8" => "\xE7\x9F\xA3",
		"\xEB\xF9" => "\xE7\xBE\xA9",
		"\xEB\xFA" => "\xE8\x89\xA4",
		"\xEB\xFB" => "\xE8\x96\x8F",
		"\xEB\xFC" => "\xE8\x9F\xBB",
		"\xEB\xFD" => "\xE8\xA1\xA3",
		"\xEB\xFE" => "\xE8\xAA\xBC",
		"\xEC\xA1" => "\xE8\xAD\xB0",
		"\xEC\xA2" => "\xE9\x86\xAB",
		"\xEC\xA3" => "\xE4\xBA\x8C",
		"\xEC\xA4" => "\xE4\xBB\xA5",
		"\xEC\xA5" => "\xE4\xBC\x8A",
		"\xEC\xA6" => "\xEF\xA7\x9D",
		"\xEC\xA7" => "\xEF\xA7\x9E",
		"\xEC\xA8" => "\xE5\xA4\xB7",
		"\xEC\xA9" => "\xE5\xA7\xA8",
		"\xEC\xAA" => "\xEF\xA7\x9F",
		"\xEC\xAB" => "\xE5\xB7\xB2",
		"\xEC\xAC" => "\xE5\xBC\x9B",
		"\xEC\xAD" => "\xE5\xBD\x9B",
		"\xEC\xAE" => "\xE6\x80\xA1",
		"\xEC\xAF" => "\xEF\xA7\xA0",
		"\xEC\xB0" => "\xEF\xA7\xA1",
		"\xEC\xB1" => "\xEF\xA7\xA2",
		"\xEC\xB2" => "\xEF\xA7\xA3",
		"\xEC\xB3" => "\xE7\x88\xBE",
		"\xEC\xB4" => "\xE7\x8F\xA5",
		"\xEC\xB5" => "\xEF\xA7\xA4",
		"\xEC\xB6" => "\xE7\x95\xB0",
		"\xEC\xB7" => "\xE7\x97\x8D",
		"\xEC\xB8" => "\xEF\xA7\xA5",
		"\xEC\xB9" => "\xE7\xA7\xBB",
		"\xEC\xBA" => "\xEF\xA7\xA6",
		"\xEC\xBB" => "\xE8\x80\x8C",
		"\xEC\xBC" => "\xE8\x80\xB3",
		"\xEC\xBD" => "\xE8\x82\x84",
		"\xEC\xBE" => "\xE8\x8B\xA1",
		"\xEC\xBF" => "\xE8\x8D\x91",
		"\xEC\xC0" => "\xEF\xA7\xA7",
		"\xEC\xC1" => "\xEF\xA7\xA8",
		"\xEC\xC2" => "\xE8\xB2\xBD",
		"\xEC\xC3" => "\xE8\xB2\xB3",
		"\xEC\xC4" => "\xE9\x82\x87",
		"\xEC\xC5" => "\xEF\xA7\xA9",
		"\xEC\xC6" => "\xEF\xA7\xAA",
		"\xEC\xC7" => "\xE9\xA3\xB4",
		"\xEC\xC8" => "\xE9\xA4\x8C",
		"\xEC\xC9" => "\xEF\xA7\xAB",
		"\xEC\xCA" => "\xEF\xA7\xAC",
		"\xEC\xCB" => "\xE7\x80\xB7",
		"\xEC\xCC" => "\xE7\x9B\x8A",
		"\xEC\xCD" => "\xE7\xBF\x8A",
		"\xEC\xCE" => "\xE7\xBF\x8C",
		"\xEC\xCF" => "\xE7\xBF\xBC",
		"\xEC\xD0" => "\xE8\xAC\x9A",
		"\xEC\xD1" => "\xE4\xBA\xBA",
		"\xEC\xD2" => "\xE4\xBB\x81",
		"\xEC\xD3" => "\xE5\x88\x83",
		"\xEC\xD4" => "\xE5\x8D\xB0",
		"\xEC\xD5" => "\xEF\xA7\xAD",
		"\xEC\xD6" => "\xE5\x92\xBD",
		"\xEC\xD7" => "\xE5\x9B\xA0",
		"\xEC\xD8" => "\xE5\xA7\xBB",
		"\xEC\xD9" => "\xE5\xAF\x85",
		"\xEC\xDA" => "\xE5\xBC\x95",
		"\xEC\xDB" => "\xE5\xBF\x8D",
		"\xEC\xDC" => "\xE6\xB9\xAE",
		"\xEC\xDD" => "\xEF\xA7\xAE",
		"\xEC\xDE" => "\xEF\xA7\xAF",
		"\xEC\xDF" => "\xE7\xB5\xAA",
		"\xEC\xE0" => "\xE8\x8C\xB5",
		"\xEC\xE1" => "\xEF\xA7\xB0",
		"\xEC\xE2" => "\xE8\x9A\x93",
		"\xEC\xE3" => "\xE8\xAA\x8D",
		"\xEC\xE4" => "\xEF\xA7\xB1",
		"\xEC\xE5" => "\xE9\x9D\xAD",
		"\xEC\xE6" => "\xE9\x9D\xB7",
		"\xEC\xE7" => "\xEF\xA7\xB2",
		"\xEC\xE8" => "\xEF\xA7\xB3",
		"\xEC\xE9" => "\xE4\xB8\x80",
		"\xEC\xEA" => "\xE4\xBD\x9A",
		"\xEC\xEB" => "\xE4\xBD\xBE",
		"\xEC\xEC" => "\xE5\xA3\xB9",
		"\xEC\xED" => "\xE6\x97\xA5",
		"\xEC\xEE" => "\xE6\xBA\xA2",
		"\xEC\xEF" => "\xE9\x80\xB8",
		"\xEC\xF0" => "\xE9\x8E\xB0",
		"\xEC\xF1" => "\xE9\xA6\xB9",
		"\xEC\xF2" => "\xE4\xBB\xBB",
		"\xEC\xF3" => "\xE5\xA3\xAC",
		"\xEC\xF4" => "\xE5\xA6\x8A",
		"\xEC\xF5" => "\xE5\xA7\x99",
		"\xEC\xF6" => "\xE6\x81\x81",
		"\xEC\xF7" => "\xEF\xA7\xB4",
		"\xEC\xF8" => "\xEF\xA7\xB5",
		"\xEC\xF9" => "\xE7\xA8\x94",
		"\xEC\xFA" => "\xEF\xA7\xB6",
		"\xEC\xFB" => "\xE8\x8D\x8F",
		"\xEC\xFC" => "\xE8\xB3\x83",
		"\xEC\xFD" => "\xE5\x85\xA5",
		"\xEC\xFE" => "\xE5\x8D\x84",
		"\xED\xA1" => "\xEF\xA7\xB7",
		"\xED\xA2" => "\xEF\xA7\xB8",
		"\xED\xA3" => "\xEF\xA7\xB9",
		"\xED\xA4" => "\xE4\xBB\x8D",
		"\xED\xA5" => "\xE5\x89\xA9",
		"\xED\xA6" => "\xE5\xAD\x95",
		"\xED\xA7" => "\xE8\x8A\xBF",
		"\xED\xA8" => "\xE4\xBB\x94",
		"\xED\xA9" => "\xE5\x88\xBA",
		"\xED\xAA" => "\xE5\x92\xA8",
		"\xED\xAB" => "\xE5\xA7\x89",
		"\xED\xAC" => "\xE5\xA7\xBF",
		"\xED\xAD" => "\xE5\xAD\x90",
		"\xED\xAE" => "\xE5\xAD\x97",
		"\xED\xAF" => "\xE5\xAD\x9C",
		"\xED\xB0" => "\xE6\x81\xA3",
		"\xED\xB1" => "\xE6\x85\x88",
		"\xED\xB2" => "\xE6\xBB\x8B",
		"\xED\xB3" => "\xE7\x82\x99",
		"\xED\xB4" => "\xE7\x85\xAE",
		"\xED\xB5" => "\xE7\x8E\x86",
		"\xED\xB6" => "\xE7\x93\xB7",
		"\xED\xB7" => "\xE7\x96\xB5",
		"\xED\xB8" => "\xE7\xA3\x81",
		"\xED\xB9" => "\xE7\xB4\xAB",
		"\xED\xBA" => "\xE8\x80\x85",
		"\xED\xBB" => "\xE8\x87\xAA",
		"\xED\xBC" => "\xE8\x8C\xA8",
		"\xED\xBD" => "\xE8\x94\x97",
		"\xED\xBE" => "\xE8\x97\x89",
		"\xED\xBF" => "\xE8\xAB\xAE",
		"\xED\xC0" => "\xE8\xB3\x87",
		"\xED\xC1" => "\xE9\x9B\x8C",
		"\xED\xC2" => "\xE4\xBD\x9C",
		"\xED\xC3" => "\xE5\x8B\xBA",
		"\xED\xC4" => "\xE5\x9A\xBC",
		"\xED\xC5" => "\xE6\x96\xAB",
		"\xED\xC6" => "\xE6\x98\xA8",
		"\xED\xC7" => "\xE7\x81\xBC",
		"\xED\xC8" => "\xE7\x82\xB8",
		"\xED\xC9" => "\xE7\x88\xB5",
		"\xED\xCA" => "\xE7\xB6\xBD",
		"\xED\xCB" => "\xE8\x8A\x8D",
		"\xED\xCC" => "\xE9\x85\x8C",
		"\xED\xCD" => "\xE9\x9B\x80",
		"\xED\xCE" => "\xE9\xB5\xB2",
		"\xED\xCF" => "\xE5\xAD\xB1",
		"\xED\xD0" => "\xE6\xA3\xA7",
		"\xED\xD1" => "\xE6\xAE\x98",
		"\xED\xD2" => "\xE6\xBD\xBA",
		"\xED\xD3" => "\xE7\x9B\x9E",
		"\xED\xD4" => "\xE5\xB2\x91",
		"\xED\xD5" => "\xE6\x9A\xAB",
		"\xED\xD6" => "\xE6\xBD\x9B",
		"\xED\xD7" => "\xE7\xAE\xB4",
		"\xED\xD8" => "\xE7\xB0\xAA",
		"\xED\xD9" => "\xE8\xA0\xB6",
		"\xED\xDA" => "\xE9\x9B\x9C",
		"\xED\xDB" => "\xE4\xB8\x88",
		"\xED\xDC" => "\xE4\xBB\x97",
		"\xED\xDD" => "\xE5\x8C\xA0",
		"\xED\xDE" => "\xE5\xA0\xB4",
		"\xED\xDF" => "\xE5\xA2\xBB",
		"\xED\xE0" => "\xE5\xA3\xAF",
		"\xED\xE1" => "\xE5\xA5\xAC",
		"\xED\xE2" => "\xE5\xB0\x87",
		"\xED\xE3" => "\xE5\xB8\xB3",
		"\xED\xE4" => "\xE5\xBA\x84",
		"\xED\xE5" => "\xE5\xBC\xB5",
		"\xED\xE6" => "\xE6\x8E\x8C",
		"\xED\xE7" => "\xE6\x9A\xB2",
		"\xED\xE8" => "\xE6\x9D\x96",
		"\xED\xE9" => "\xE6\xA8\x9F",
		"\xED\xEA" => "\xE6\xAA\xA3",
		"\xED\xEB" => "\xE6\xAC\x8C",
		"\xED\xEC" => "\xE6\xBC\xBF",
		"\xED\xED" => "\xE7\x89\x86",
		"\xED\xEE" => "\xEF\xA7\xBA",
		"\xED\xEF" => "\xE7\x8D\x90",
		"\xED\xF0" => "\xE7\x92\x8B",
		"\xED\xF1" => "\xE7\xAB\xA0",
		"\xED\xF2" => "\xE7\xB2\xA7",
		"\xED\xF3" => "\xE8\x85\xB8",
		"\xED\xF4" => "\xE8\x87\x9F",
		"\xED\xF5" => "\xE8\x87\xA7",
		"\xED\xF6" => "\xE8\x8E\x8A",
		"\xED\xF7" => "\xE8\x91\xAC",
		"\xED\xF8" => "\xE8\x94\xA3",
		"\xED\xF9" => "\xE8\x96\x94",
		"\xED\xFA" => "\xE8\x97\x8F",
		"\xED\xFB" => "\xE8\xA3\x9D",
		"\xED\xFC" => "\xE8\xB4\x93",
		"\xED\xFD" => "\xE9\x86\xAC",
		"\xED\xFE" => "\xE9\x95\xB7",
		"\xEE\xA1" => "\xE9\x9A\x9C",
		"\xEE\xA2" => "\xE5\x86\x8D",
		"\xEE\xA3" => "\xE5\x93\x89",
		"\xEE\xA4" => "\xE5\x9C\xA8",
		"\xEE\xA5" => "\xE5\xAE\xB0",
		"\xEE\xA6" => "\xE6\x89\x8D",
		"\xEE\xA7" => "\xE6\x9D\x90",
		"\xEE\xA8" => "\xE6\xA0\xBD",
		"\xEE\xA9" => "\xE6\xA2\x93",
		"\xEE\xAA" => "\xE6\xB8\xBD",
		"\xEE\xAB" => "\xE6\xBB\x93",
		"\xEE\xAC" => "\xE7\x81\xBD",
		"\xEE\xAD" => "\xE7\xB8\xA1",
		"\xEE\xAE" => "\xE8\xA3\x81",
		"\xEE\xAF" => "\xE8\xB2\xA1",
		"\xEE\xB0" => "\xE8\xBC\x89",
		"\xEE\xB1" => "\xE9\xBD\x8B",
		"\xEE\xB2" => "\xE9\xBD\x8E",
		"\xEE\xB3" => "\xE7\x88\xAD",
		"\xEE\xB4" => "\xE7\xAE\x8F",
		"\xEE\xB5" => "\xE8\xAB\x8D",
		"\xEE\xB6" => "\xE9\x8C\x9A",
		"\xEE\xB7" => "\xE4\xBD\x87",
		"\xEE\xB8" => "\xE4\xBD\x8E",
		"\xEE\xB9" => "\xE5\x84\xB2",
		"\xEE\xBA" => "\xE5\x92\x80",
		"\xEE\xBB" => "\xE5\xA7\x90",
		"\xEE\xBC" => "\xE5\xBA\x95",
		"\xEE\xBD" => "\xE6\x8A\xB5",
		"\xEE\xBE" => "\xE6\x9D\xB5",
		"\xEE\xBF" => "\xE6\xA5\xAE",
		"\xEE\xC0" => "\xE6\xA8\x97",
		"\xEE\xC1" => "\xE6\xB2\xAE",
		"\xEE\xC2" => "\xE6\xB8\x9A",
		"\xEE\xC3" => "\xE7\x8B\x99",
		"\xEE\xC4" => "\xE7\x8C\xAA",
		"\xEE\xC5" => "\xE7\x96\xBD",
		"\xEE\xC6" => "\xE7\xAE\xB8",
		"\xEE\xC7" => "\xE7\xB4\xB5",
		"\xEE\xC8" => "\xE8\x8B\xA7",
		"\xEE\xC9" => "\xE8\x8F\xB9",
		"\xEE\xCA" => "\xE8\x91\x97",
		"\xEE\xCB" => "\xE8\x97\xB7",
		"\xEE\xCC" => "\xE8\xA9\x9B",
		"\xEE\xCD" => "\xE8\xB2\xAF",
		"\xEE\xCE" => "\xE8\xBA\x87",
		"\xEE\xCF" => "\xE9\x80\x99",
		"\xEE\xD0" => "\xE9\x82\xB8",
		"\xEE\xD1" => "\xE9\x9B\x8E",
		"\xEE\xD2" => "\xE9\xBD\x9F",
		"\xEE\xD3" => "\xE5\x8B\xA3",
		"\xEE\xD4" => "\xE5\x90\x8A",
		"\xEE\xD5" => "\xE5\xAB\xA1",
		"\xEE\xD6" => "\xE5\xAF\x82",
		"\xEE\xD7" => "\xE6\x91\x98",
		"\xEE\xD8" => "\xE6\x95\xB5",
		"\xEE\xD9" => "\xE6\xBB\xB4",
		"\xEE\xDA" => "\xE7\x8B\x84",
		"\xEE\xDB" => "\xEF\xA7\xBB",
		"\xEE\xDC" => "\xE7\x9A\x84",
		"\xEE\xDD" => "\xE7\xA9\x8D",
		"\xEE\xDE" => "\xE7\xAC\x9B",
		"\xEE\xDF" => "\xE7\xB1\x8D",
		"\xEE\xE0" => "\xE7\xB8\xBE",
		"\xEE\xE1" => "\xE7\xBF\x9F",
		"\xEE\xE2" => "\xE8\x8D\xBB",
		"\xEE\xE3" => "\xE8\xAC\xAB",
		"\xEE\xE4" => "\xE8\xB3\x8A",
		"\xEE\xE5" => "\xE8\xB5\xA4",
		"\xEE\xE6" => "\xE8\xB7\xA1",
		"\xEE\xE7" => "\xE8\xB9\x9F",
		"\xEE\xE8" => "\xE8\xBF\xAA",
		"\xEE\xE9" => "\xE8\xBF\xB9",
		"\xEE\xEA" => "\xE9\x81\xA9",
		"\xEE\xEB" => "\xE9\x8F\x91",
		"\xEE\xEC" => "\xE4\xBD\x83",
		"\xEE\xED" => "\xE4\xBD\xBA",
		"\xEE\xEE" => "\xE5\x82\xB3",
		"\xEE\xEF" => "\xE5\x85\xA8",
		"\xEE\xF0" => "\xE5\x85\xB8",
		"\xEE\xF1" => "\xE5\x89\x8D",
		"\xEE\xF2" => "\xE5\x89\xAA",
		"\xEE\xF3" => "\xE5\xA1\xA1",
		"\xEE\xF4" => "\xE5\xA1\xBC",
		"\xEE\xF5" => "\xE5\xA5\xA0",
		"\xEE\xF6" => "\xE5\xB0\x88",
		"\xEE\xF7" => "\xE5\xB1\x95",
		"\xEE\xF8" => "\xE5\xBB\x9B",
		"\xEE\xF9" => "\xE6\x82\x9B",
		"\xEE\xFA" => "\xE6\x88\xB0",
		"\xEE\xFB" => "\xE6\xA0\x93",
		"\xEE\xFC" => "\xE6\xAE\xBF",
		"\xEE\xFD" => "\xE6\xB0\x88",
		"\xEE\xFE" => "\xE6\xBE\xB1",
		"\xEF\xA1" => "\xE7\x85\x8E",
		"\xEF\xA2" => "\xE7\x90\xA0",
		"\xEF\xA3" => "\xE7\x94\xB0",
		"\xEF\xA4" => "\xE7\x94\xB8",
		"\xEF\xA5" => "\xE7\x95\x91",
		"\xEF\xA6" => "\xE7\x99\xB2",
		"\xEF\xA7" => "\xE7\xAD\x8C",
		"\xEF\xA8" => "\xE7\xAE\x8B",
		"\xEF\xA9" => "\xE7\xAE\xAD",
		"\xEF\xAA" => "\xE7\xAF\x86",
		"\xEF\xAB" => "\xE7\xBA\x8F",
		"\xEF\xAC" => "\xE8\xA9\xAE",
		"\xEF\xAD" => "\xE8\xBC\xBE",
		"\xEF\xAE" => "\xE8\xBD\x89",
		"\xEF\xAF" => "\xE9\x88\xBF",
		"\xEF\xB0" => "\xE9\x8A\x93",
		"\xEF\xB1" => "\xE9\x8C\xA2",
		"\xEF\xB2" => "\xE9\x90\xAB",
		"\xEF\xB3" => "\xE9\x9B\xBB",
		"\xEF\xB4" => "\xE9\xA1\x9A",
		"\xEF\xB5" => "\xE9\xA1\xAB",
		"\xEF\xB6" => "\xE9\xA4\x9E",
		"\xEF\xB7" => "\xE5\x88\x87",
		"\xEF\xB8" => "\xE6\x88\xAA",
		"\xEF\xB9" => "\xE6\x8A\x98",
		"\xEF\xBA" => "\xE6\xB5\x99",
		"\xEF\xBB" => "\xE7\x99\xA4",
		"\xEF\xBC" => "\xE7\xAB\x8A",
		"\xEF\xBD" => "\xE7\xAF\x80",
		"\xEF\xBE" => "\xE7\xB5\xB6",
		"\xEF\xBF" => "\xE5\x8D\xA0",
		"\xEF\xC0" => "\xE5\xB2\xBE",
		"\xEF\xC1" => "\xE5\xBA\x97",
		"\xEF\xC2" => "\xE6\xBC\xB8",
		"\xEF\xC3" => "\xE7\x82\xB9",
		"\xEF\xC4" => "\xE7\xB2\x98",
		"\xEF\xC5" => "\xE9\x9C\x91",
		"\xEF\xC6" => "\xE9\xAE\x8E",
		"\xEF\xC7" => "\xE9\xBB\x9E",
		"\xEF\xC8" => "\xE6\x8E\xA5",
		"\xEF\xC9" => "\xE6\x91\xBA",
		"\xEF\xCA" => "\xE8\x9D\xB6",
		"\xEF\xCB" => "\xE4\xB8\x81",
		"\xEF\xCC" => "\xE4\xBA\x95",
		"\xEF\xCD" => "\xE4\xBA\xAD",
		"\xEF\xCE" => "\xE5\x81\x9C",
		"\xEF\xCF" => "\xE5\x81\xB5",
		"\xEF\xD0" => "\xE5\x91\x88",
		"\xEF\xD1" => "\xE5\xA7\x83",
		"\xEF\xD2" => "\xE5\xAE\x9A",
		"\xEF\xD3" => "\xE5\xB9\x80",
		"\xEF\xD4" => "\xE5\xBA\xAD",
		"\xEF\xD5" => "\xE5\xBB\xB7",
		"\xEF\xD6" => "\xE5\xBE\x81",
		"\xEF\xD7" => "\xE6\x83\x85",
		"\xEF\xD8" => "\xE6\x8C\xBA",
		"\xEF\xD9" => "\xE6\x94\xBF",
		"\xEF\xDA" => "\xE6\x95\xB4",
		"\xEF\xDB" => "\xE6\x97\x8C",
		"\xEF\xDC" => "\xE6\x99\xB6",
		"\xEF\xDD" => "\xE6\x99\xB8",
		"\xEF\xDE" => "\xE6\x9F\xBE",
		"\xEF\xDF" => "\xE6\xA5\xA8",
		"\xEF\xE0" => "\xE6\xAA\x89",
		"\xEF\xE1" => "\xE6\xAD\xA3",
		"\xEF\xE2" => "\xE6\xB1\x80",
		"\xEF\xE3" => "\xE6\xB7\x80",
		"\xEF\xE4" => "\xE6\xB7\xA8",
		"\xEF\xE5" => "\xE6\xB8\x9F",
		"\xEF\xE6" => "\xE6\xB9\x9E",
		"\xEF\xE7" => "\xE7\x80\x9E",
		"\xEF\xE8" => "\xE7\x82\xA1",
		"\xEF\xE9" => "\xE7\x8E\x8E",
		"\xEF\xEA" => "\xE7\x8F\xBD",
		"\xEF\xEB" => "\xE7\x94\xBA",
		"\xEF\xEC" => "\xE7\x9D\x9B",
		"\xEF\xED" => "\xE7\xA2\x87",
		"\xEF\xEE" => "\xE7\xA6\x8E",
		"\xEF\xEF" => "\xE7\xA8\x8B",
		"\xEF\xF0" => "\xE7\xA9\xBD",
		"\xEF\xF1" => "\xE7\xB2\xBE",
		"\xEF\xF2" => "\xE7\xB6\x8E",
		"\xEF\xF3" => "\xE8\x89\x87",
		"\xEF\xF4" => "\xE8\xA8\x82",
		"\xEF\xF5" => "\xE8\xAB\xAA",
		"\xEF\xF6" => "\xE8\xB2\x9E",
		"\xEF\xF7" => "\xE9\x84\xAD",
		"\xEF\xF8" => "\xE9\x85\x8A",
		"\xEF\xF9" => "\xE9\x87\x98",
		"\xEF\xFA" => "\xE9\x89\xA6",
		"\xEF\xFB" => "\xE9\x8B\x8C",
		"\xEF\xFC" => "\xE9\x8C\xA0",
		"\xEF\xFD" => "\xE9\x9C\x86",
		"\xEF\xFE" => "\xE9\x9D\x96",
		"\xF0\xA1" => "\xE9\x9D\x9C",
		"\xF0\xA2" => "\xE9\xA0\x82",
		"\xF0\xA3" => "\xE9\xBC\x8E",
		"\xF0\xA4" => "\xE5\x88\xB6",
		"\xF0\xA5" => "\xE5\x8A\x91",
		"\xF0\xA6" => "\xE5\x95\xBC",
		"\xF0\xA7" => "\xE5\xA0\xA4",
		"\xF0\xA8" => "\xE5\xB8\x9D",
		"\xF0\xA9" => "\xE5\xBC\x9F",
		"\xF0\xAA" => "\xE6\x82\x8C",
		"\xF0\xAB" => "\xE6\x8F\x90",
		"\xF0\xAC" => "\xE6\xA2\xAF",
		"\xF0\xAD" => "\xE6\xBF\x9F",
		"\xF0\xAE" => "\xE7\xA5\xAD",
		"\xF0\xAF" => "\xE7\xAC\xAC",
		"\xF0\xB0" => "\xE8\x87\x8D",
		"\xF0\xB1" => "\xE8\x96\xBA",
		"\xF0\xB2" => "\xE8\xA3\xBD",
		"\xF0\xB3" => "\xE8\xAB\xB8",
		"\xF0\xB4" => "\xE8\xB9\x84",
		"\xF0\xB5" => "\xE9\x86\x8D",
		"\xF0\xB6" => "\xE9\x99\xA4",
		"\xF0\xB7" => "\xE9\x9A\x9B",
		"\xF0\xB8" => "\xE9\x9C\xBD",
		"\xF0\xB9" => "\xE9\xA1\x8C",
		"\xF0\xBA" => "\xE9\xBD\x8A",
		"\xF0\xBB" => "\xE4\xBF\x8E",
		"\xF0\xBC" => "\xE5\x85\x86",
		"\xF0\xBD" => "\xE5\x87\x8B",
		"\xF0\xBE" => "\xE5\x8A\xA9",
		"\xF0\xBF" => "\xE5\x98\xB2",
		"\xF0\xC0" => "\xE5\xBC\x94",
		"\xF0\xC1" => "\xE5\xBD\xAB",
		"\xF0\xC2" => "\xE6\x8E\xAA",
		"\xF0\xC3" => "\xE6\x93\x8D",
		"\xF0\xC4" => "\xE6\x97\xA9",
		"\xF0\xC5" => "\xE6\x99\x81",
		"\xF0\xC6" => "\xE6\x9B\xBA",
		"\xF0\xC7" => "\xE6\x9B\xB9",
		"\xF0\xC8" => "\xE6\x9C\x9D",
		"\xF0\xC9" => "\xE6\xA2\x9D",
		"\xF0\xCA" => "\xE6\xA3\x97",
		"\xF0\xCB" => "\xE6\xA7\xBD",
		"\xF0\xCC" => "\xE6\xBC\x95",
		"\xF0\xCD" => "\xE6\xBD\xAE",
		"\xF0\xCE" => "\xE7\x85\xA7",
		"\xF0\xCF" => "\xE7\x87\xA5",
		"\xF0\xD0" => "\xE7\x88\xAA",
		"\xF0\xD1" => "\xE7\x92\xAA",
		"\xF0\xD2" => "\xE7\x9C\xBA",
		"\xF0\xD3" => "\xE7\xA5\x96",
		"\xF0\xD4" => "\xE7\xA5\x9A",
		"\xF0\xD5" => "\xE7\xA7\x9F",
		"\xF0\xD6" => "\xE7\xA8\xA0",
		"\xF0\xD7" => "\xE7\xAA\x95",
		"\xF0\xD8" => "\xE7\xB2\x97",
		"\xF0\xD9" => "\xE7\xB3\x9F",
		"\xF0\xDA" => "\xE7\xB5\x84",
		"\xF0\xDB" => "\xE7\xB9\xB0",
		"\xF0\xDC" => "\xE8\x82\x87",
		"\xF0\xDD" => "\xE8\x97\xBB",
		"\xF0\xDE" => "\xE8\x9A\xA4",
		"\xF0\xDF" => "\xE8\xA9\x94",
		"\xF0\xE0" => "\xE8\xAA\xBF",
		"\xF0\xE1" => "\xE8\xB6\x99",
		"\xF0\xE2" => "\xE8\xBA\x81",
		"\xF0\xE3" => "\xE9\x80\xA0",
		"\xF0\xE4" => "\xE9\x81\xAD",
		"\xF0\xE5" => "\xE9\x87\xA3",
		"\xF0\xE6" => "\xE9\x98\xBB",
		"\xF0\xE7" => "\xE9\x9B\x95",
		"\xF0\xE8" => "\xE9\xB3\xA5",
		"\xF0\xE9" => "\xE6\x97\x8F",
		"\xF0\xEA" => "\xE7\xB0\x87",
		"\xF0\xEB" => "\xE8\xB6\xB3",
		"\xF0\xEC" => "\xE9\x8F\x83",
		"\xF0\xED" => "\xE5\xAD\x98",
		"\xF0\xEE" => "\xE5\xB0\x8A",
		"\xF0\xEF" => "\xE5\x8D\x92",
		"\xF0\xF0" => "\xE6\x8B\x99",
		"\xF0\xF1" => "\xE7\x8C\x9D",
		"\xF0\xF2" => "\xE5\x80\xA7",
		"\xF0\xF3" => "\xE5\xAE\x97",
		"\xF0\xF4" => "\xE5\xBE\x9E",
		"\xF0\xF5" => "\xE6\x82\xB0",
		"\xF0\xF6" => "\xE6\x85\xAB",
		"\xF0\xF7" => "\xE6\xA3\x95",
		"\xF0\xF8" => "\xE6\xB7\x99",
		"\xF0\xF9" => "\xE7\x90\xAE",
		"\xF0\xFA" => "\xE7\xA8\xAE",
		"\xF0\xFB" => "\xE7\xB5\x82",
		"\xF0\xFC" => "\xE7\xB6\x9C",
		"\xF0\xFD" => "\xE7\xB8\xB1",
		"\xF0\xFE" => "\xE8\x85\xAB",
		"\xF1\xA1" => "\xE8\xB8\xAA",
		"\xF1\xA2" => "\xE8\xB8\xB5",
		"\xF1\xA3" => "\xE9\x8D\xBE",
		"\xF1\xA4" => "\xE9\x90\x98",
		"\xF1\xA5" => "\xE4\xBD\x90",
		"\xF1\xA6" => "\xE5\x9D\x90",
		"\xF1\xA7" => "\xE5\xB7\xA6",
		"\xF1\xA8" => "\xE5\xBA\xA7",
		"\xF1\xA9" => "\xE6\x8C\xAB",
		"\xF1\xAA" => "\xE7\xBD\xAA",
		"\xF1\xAB" => "\xE4\xB8\xBB",
		"\xF1\xAC" => "\xE4\xBD\x8F",
		"\xF1\xAD" => "\xE4\xBE\x8F",
		"\xF1\xAE" => "\xE5\x81\x9A",
		"\xF1\xAF" => "\xE5\xA7\x9D",
		"\xF1\xB0" => "\xE8\x83\x84",
		"\xF1\xB1" => "\xE5\x91\xAA",
		"\xF1\xB2" => "\xE5\x91\xA8",
		"\xF1\xB3" => "\xE5\x97\xBE",
		"\xF1\xB4" => "\xE5\xA5\x8F",
		"\xF1\xB5" => "\xE5\xAE\x99",
		"\xF1\xB6" => "\xE5\xB7\x9E",
		"\xF1\xB7" => "\xE5\xBB\x9A",
		"\xF1\xB8" => "\xE6\x99\x9D",
		"\xF1\xB9" => "\xE6\x9C\xB1",
		"\xF1\xBA" => "\xE6\x9F\xB1",
		"\xF1\xBB" => "\xE6\xA0\xAA",
		"\xF1\xBC" => "\xE6\xB3\xA8",
		"\xF1\xBD" => "\xE6\xB4\xB2",
		"\xF1\xBE" => "\xE6\xB9\x8A",
		"\xF1\xBF" => "\xE6\xBE\x8D",
		"\xF1\xC0" => "\xE7\x82\xB7",
		"\xF1\xC1" => "\xE7\x8F\xA0",
		"\xF1\xC2" => "\xE7\x96\x87",
		"\xF1\xC3" => "\xE7\xB1\x8C",
		"\xF1\xC4" => "\xE7\xB4\x82",
		"\xF1\xC5" => "\xE7\xB4\xAC",
		"\xF1\xC6" => "\xE7\xB6\xA2",
		"\xF1\xC7" => "\xE8\x88\x9F",
		"\xF1\xC8" => "\xE8\x9B\x9B",
		"\xF1\xC9" => "\xE8\xA8\xBB",
		"\xF1\xCA" => "\xE8\xAA\x85",
		"\xF1\xCB" => "\xE8\xB5\xB0",
		"\xF1\xCC" => "\xE8\xBA\x8A",
		"\xF1\xCD" => "\xE8\xBC\xB3",
		"\xF1\xCE" => "\xE9\x80\xB1",
		"\xF1\xCF" => "\xE9\x85\x8E",
		"\xF1\xD0" => "\xE9\x85\x92",
		"\xF1\xD1" => "\xE9\x91\x84",
		"\xF1\xD2" => "\xE9\xA7\x90",
		"\xF1\xD3" => "\xE7\xAB\xB9",
		"\xF1\xD4" => "\xE7\xB2\xA5",
		"\xF1\xD5" => "\xE4\xBF\x8A",
		"\xF1\xD6" => "\xE5\x84\x81",
		"\xF1\xD7" => "\xE5\x87\x86",
		"\xF1\xD8" => "\xE5\x9F\x88",
		"\xF1\xD9" => "\xE5\xAF\xAF",
		"\xF1\xDA" => "\xE5\xB3\xBB",
		"\xF1\xDB" => "\xE6\x99\x99",
		"\xF1\xDC" => "\xE6\xA8\xBD",
		"\xF1\xDD" => "\xE6\xB5\x9A",
		"\xF1\xDE" => "\xE6\xBA\x96",
		"\xF1\xDF" => "\xE6\xBF\xAC",
		"\xF1\xE0" => "\xE7\x84\x8C",
		"\xF1\xE1" => "\xE7\x95\xAF",
		"\xF1\xE2" => "\xE7\xAB\xA3",
		"\xF1\xE3" => "\xE8\xA0\xA2",
		"\xF1\xE4" => "\xE9\x80\xA1",
		"\xF1\xE5" => "\xE9\x81\xB5",
		"\xF1\xE6" => "\xE9\x9B\x8B",
		"\xF1\xE7" => "\xE9\xA7\xBF",
		"\xF1\xE8" => "\xE8\x8C\x81",
		"\xF1\xE9" => "\xE4\xB8\xAD",
		"\xF1\xEA" => "\xE4\xBB\xB2",
		"\xF1\xEB" => "\xE8\xA1\x86",
		"\xF1\xEC" => "\xE9\x87\x8D",
		"\xF1\xED" => "\xE5\x8D\xBD",
		"\xF1\xEE" => "\xE6\xAB\x9B",
		"\xF1\xEF" => "\xE6\xA5\xAB",
		"\xF1\xF0" => "\xE6\xB1\x81",
		"\xF1\xF1" => "\xE8\x91\xBA",
		"\xF1\xF2" => "\xE5\xA2\x9E",
		"\xF1\xF3" => "\xE6\x86\x8E",
		"\xF1\xF4" => "\xE6\x9B\xBE",
		"\xF1\xF5" => "\xE6\x8B\xAF",
		"\xF1\xF6" => "\xE7\x83\x9D",
		"\xF1\xF7" => "\xE7\x94\x91",
		"\xF1\xF8" => "\xE7\x97\x87",
		"\xF1\xF9" => "\xE7\xB9\x92",
		"\xF1\xFA" => "\xE8\x92\xB8",
		"\xF1\xFB" => "\xE8\xAD\x89",
		"\xF1\xFC" => "\xE8\xB4\x88",
		"\xF1\xFD" => "\xE4\xB9\x8B",
		"\xF1\xFE" => "\xE5\x8F\xAA",
		"\xF2\xA1" => "\xE5\x92\xAB",
		"\xF2\xA2" => "\xE5\x9C\xB0",
		"\xF2\xA3" => "\xE5\x9D\x80",
		"\xF2\xA4" => "\xE5\xBF\x97",
		"\xF2\xA5" => "\xE6\x8C\x81",
		"\xF2\xA6" => "\xE6\x8C\x87",
		"\xF2\xA7" => "\xE6\x91\xAF",
		"\xF2\xA8" => "\xE6\x94\xAF",
		"\xF2\xA9" => "\xE6\x97\xA8",
		"\xF2\xAA" => "\xE6\x99\xBA",
		"\xF2\xAB" => "\xE6\x9E\x9D",
		"\xF2\xAC" => "\xE6\x9E\xB3",
		"\xF2\xAD" => "\xE6\xAD\xA2",
		"\xF2\xAE" => "\xE6\xB1\xA0",
		"\xF2\xAF" => "\xE6\xB2\x9A",
		"\xF2\xB0" => "\xE6\xBC\xAC",
		"\xF2\xB1" => "\xE7\x9F\xA5",
		"\xF2\xB2" => "\xE7\xA0\xA5",
		"\xF2\xB3" => "\xE7\xA5\x89",
		"\xF2\xB4" => "\xE7\xA5\x97",
		"\xF2\xB5" => "\xE7\xB4\x99",
		"\xF2\xB6" => "\xE8\x82\xA2",
		"\xF2\xB7" => "\xE8\x84\x82",
		"\xF2\xB8" => "\xE8\x87\xB3",
		"\xF2\xB9" => "\xE8\x8A\x9D",
		"\xF2\xBA" => "\xE8\x8A\xB7",
		"\xF2\xBB" => "\xE8\x9C\x98",
		"\xF2\xBC" => "\xE8\xAA\x8C",
		"\xF2\xBD" => "\xEF\xA7\xBC",
		"\xF2\xBE" => "\xE8\xB4\x84",
		"\xF2\xBF" => "\xE8\xB6\xBE",
		"\xF2\xC0" => "\xE9\x81\xB2",
		"\xF2\xC1" => "\xE7\x9B\xB4",
		"\xF2\xC2" => "\xE7\xA8\x99",
		"\xF2\xC3" => "\xE7\xA8\xB7",
		"\xF2\xC4" => "\xE7\xB9\x94",
		"\xF2\xC5" => "\xE8\x81\xB7",
		"\xF2\xC6" => "\xE5\x94\x87",
		"\xF2\xC7" => "\xE5\x97\x94",
		"\xF2\xC8" => "\xE5\xA1\xB5",
		"\xF2\xC9" => "\xE6\x8C\xAF",
		"\xF2\xCA" => "\xE6\x90\xA2",
		"\xF2\xCB" => "\xE6\x99\x89",
		"\xF2\xCC" => "\xE6\x99\x8B",
		"\xF2\xCD" => "\xE6\xA1\xAD",
		"\xF2\xCE" => "\xE6\xA6\x9B",
		"\xF2\xCF" => "\xE6\xAE\x84",
		"\xF2\xD0" => "\xE6\xB4\xA5",
		"\xF2\xD1" => "\xE6\xBA\xB1",
		"\xF2\xD2" => "\xE7\x8F\x8D",
		"\xF2\xD3" => "\xE7\x91\xA8",
		"\xF2\xD4" => "\xE7\x92\xA1",
		"\xF2\xD5" => "\xE7\x95\x9B",
		"\xF2\xD6" => "\xE7\x96\xB9",
		"\xF2\xD7" => "\xE7\x9B\xA1",
		"\xF2\xD8" => "\xE7\x9C\x9E",
		"\xF2\xD9" => "\xE7\x9E\x8B",
		"\xF2\xDA" => "\xE7\xA7\xA6",
		"\xF2\xDB" => "\xE7\xB8\x89",
		"\xF2\xDC" => "\xE7\xB8\x9D",
		"\xF2\xDD" => "\xE8\x87\xBB",
		"\xF2\xDE" => "\xE8\x94\xAF",
		"\xF2\xDF" => "\xE8\xA2\x97",
		"\xF2\xE0" => "\xE8\xA8\xBA",
		"\xF2\xE1" => "\xE8\xB3\x91",
		"\xF2\xE2" => "\xE8\xBB\xAB",
		"\xF2\xE3" => "\xE8\xBE\xB0",
		"\xF2\xE4" => "\xE9\x80\xB2",
		"\xF2\xE5" => "\xE9\x8E\xAD",
		"\xF2\xE6" => "\xE9\x99\xA3",
		"\xF2\xE7" => "\xE9\x99\xB3",
		"\xF2\xE8" => "\xE9\x9C\x87",
		"\xF2\xE9" => "\xE4\xBE\x84",
		"\xF2\xEA" => "\xE5\x8F\xB1",
		"\xF2\xEB" => "\xE5\xA7\xAA",
		"\xF2\xEC" => "\xE5\xAB\x89",
		"\xF2\xED" => "\xE5\xB8\x99",
		"\xF2\xEE" => "\xE6\xA1\x8E",
		"\xF2\xEF" => "\xE7\x93\x86",
		"\xF2\xF0" => "\xE7\x96\xBE",
		"\xF2\xF1" => "\xE7\xA7\xA9",
		"\xF2\xF2" => "\xE7\xAA\x92",
		"\xF2\xF3" => "\xE8\x86\xA3",
		"\xF2\xF4" => "\xE8\x9B\xAD",
		"\xF2\xF5" => "\xE8\xB3\xAA",
		"\xF2\xF6" => "\xE8\xB7\x8C",
		"\xF2\xF7" => "\xE8\xBF\xAD",
		"\xF2\xF8" => "\xE6\x96\x9F",
		"\xF2\xF9" => "\xE6\x9C\x95",
		"\xF2\xFA" => "\xEF\xA7\xBD",
		"\xF2\xFB" => "\xE5\x9F\xB7",
		"\xF2\xFC" => "\xE6\xBD\x97",
		"\xF2\xFD" => "\xE7\xB7\x9D",
		"\xF2\xFE" => "\xE8\xBC\xAF",
		"\xF3\xA1" => "\xE9\x8F\xB6",
		"\xF3\xA2" => "\xE9\x9B\x86",
		"\xF3\xA3" => "\xE5\xBE\xB5",
		"\xF3\xA4" => "\xE6\x87\xB2",
		"\xF3\xA5" => "\xE6\xBE\x84",
		"\xF3\xA6" => "\xE4\xB8\x94",
		"\xF3\xA7" => "\xE4\xBE\x98",
		"\xF3\xA8" => "\xE5\x80\x9F",
		"\xF3\xA9" => "\xE5\x8F\x89",
		"\xF3\xAA" => "\xE5\x97\x9F",
		"\xF3\xAB" => "\xE5\xB5\xAF",
		"\xF3\xAC" => "\xE5\xB7\xAE",
		"\xF3\xAD" => "\xE6\xAC\xA1",
		"\xF3\xAE" => "\xE6\xAD\xA4",
		"\xF3\xAF" => "\xE7\xA3\x8B",
		"\xF3\xB0" => "\xE7\xAE\x9A",
		"\xF3\xB1" => "\xEF\xA7\xBE",
		"\xF3\xB2" => "\xE8\xB9\x89",
		"\xF3\xB3" => "\xE8\xBB\x8A",
		"\xF3\xB4" => "\xE9\x81\xAE",
		"\xF3\xB5" => "\xE6\x8D\x89",
		"\xF3\xB6" => "\xE6\x90\xBE",
		"\xF3\xB7" => "\xE7\x9D\x80",
		"\xF3\xB8" => "\xE7\xAA\x84",
		"\xF3\xB9" => "\xE9\x8C\xAF",
		"\xF3\xBA" => "\xE9\x91\xBF",
		"\xF3\xBB" => "\xE9\xBD\xAA",
		"\xF3\xBC" => "\xE6\x92\xB0",
		"\xF3\xBD" => "\xE6\xBE\xAF",
		"\xF3\xBE" => "\xE7\x87\xA6",
		"\xF3\xBF" => "\xE7\x92\xA8",
		"\xF3\xC0" => "\xE7\x93\x9A",
		"\xF3\xC1" => "\xE7\xAB\x84",
		"\xF3\xC2" => "\xE7\xB0\x92",
		"\xF3\xC3" => "\xE7\xBA\x82",
		"\xF3\xC4" => "\xE7\xB2\xB2",
		"\xF3\xC5" => "\xE7\xBA\x98",
		"\xF3\xC6" => "\xE8\xAE\x9A",
		"\xF3\xC7" => "\xE8\xB4\x8A",
		"\xF3\xC8" => "\xE9\x91\xBD",
		"\xF3\xC9" => "\xE9\xA4\x90",
		"\xF3\xCA" => "\xE9\xA5\x8C",
		"\xF3\xCB" => "\xE5\x88\xB9",
		"\xF3\xCC" => "\xE5\xAF\x9F",
		"\xF3\xCD" => "\xE6\x93\xA6",
		"\xF3\xCE" => "\xE6\x9C\xAD",
		"\xF3\xCF" => "\xE7\xB4\xAE",
		"\xF3\xD0" => "\xE5\x83\xAD",
		"\xF3\xD1" => "\xE5\x8F\x83",
		"\xF3\xD2" => "\xE5\xA1\xB9",
		"\xF3\xD3" => "\xE6\x85\x98",
		"\xF3\xD4" => "\xE6\x85\x99",
		"\xF3\xD5" => "\xE6\x87\xBA",
		"\xF3\xD6" => "\xE6\x96\xAC",
		"\xF3\xD7" => "\xE7\xAB\x99",
		"\xF3\xD8" => "\xE8\xAE\x92",
		"\xF3\xD9" => "\xE8\xAE\x96",
		"\xF3\xDA" => "\xE5\x80\x89",
		"\xF3\xDB" => "\xE5\x80\xA1",
		"\xF3\xDC" => "\xE5\x89\xB5",
		"\xF3\xDD" => "\xE5\x94\xB1",
		"\xF3\xDE" => "\xE5\xA8\xBC",
		"\xF3\xDF" => "\xE5\xBB\xA0",
		"\xF3\xE0" => "\xE5\xBD\xB0",
		"\xF3\xE1" => "\xE6\x84\xB4",
		"\xF3\xE2" => "\xE6\x95\x9E",
		"\xF3\xE3" => "\xE6\x98\x8C",
		"\xF3\xE4" => "\xE6\x98\xB6",
		"\xF3\xE5" => "\xE6\x9A\xA2",
		"\xF3\xE6" => "\xE6\xA7\x8D",
		"\xF3\xE7" => "\xE6\xBB\x84",
		"\xF3\xE8" => "\xE6\xBC\xB2",
		"\xF3\xE9" => "\xE7\x8C\x96",
		"\xF3\xEA" => "\xE7\x98\xA1",
		"\xF3\xEB" => "\xE7\xAA\x93",
		"\xF3\xEC" => "\xE8\x84\xB9",
		"\xF3\xED" => "\xE8\x89\x99",
		"\xF3\xEE" => "\xE8\x8F\x96",
		"\xF3\xEF" => "\xE8\x92\xBC",
		"\xF3\xF0" => "\xE5\x82\xB5",
		"\xF3\xF1" => "\xE5\x9F\xB0",
		"\xF3\xF2" => "\xE5\xAF\x80",
		"\xF3\xF3" => "\xE5\xAF\xA8",
		"\xF3\xF4" => "\xE5\xBD\xA9",
		"\xF3\xF5" => "\xE6\x8E\xA1",
		"\xF3\xF6" => "\xE7\xA0\xA6",
		"\xF3\xF7" => "\xE7\xB6\xB5",
		"\xF3\xF8" => "\xE8\x8F\x9C",
		"\xF3\xF9" => "\xE8\x94\xA1",
		"\xF3\xFA" => "\xE9\x87\x87",
		"\xF3\xFB" => "\xE9\x87\xB5",
		"\xF3\xFC" => "\xE5\x86\x8A",
		"\xF3\xFD" => "\xE6\x9F\xB5",
		"\xF3\xFE" => "\xE7\xAD\x96",
		"\xF4\xA1" => "\xE8\xB2\xAC",
		"\xF4\xA2" => "\xE5\x87\x84",
		"\xF4\xA3" => "\xE5\xA6\xBB",
		"\xF4\xA4" => "\xE6\x82\xBD",
		"\xF4\xA5" => "\xE8\x99\x95",
		"\xF4\xA6" => "\xE5\x80\x9C",
		"\xF4\xA7" => "\xEF\xA7\xBF",
		"\xF4\xA8" => "\xE5\x89\x94",
		"\xF4\xA9" => "\xE5\xB0\xBA",
		"\xF4\xAA" => "\xE6\x85\xBD",
		"\xF4\xAB" => "\xE6\x88\x9A",
		"\xF4\xAC" => "\xE6\x8B\x93",
		"\xF4\xAD" => "\xE6\x93\xB2",
		"\xF4\xAE" => "\xE6\x96\xA5",
		"\xF4\xAF" => "\xE6\xBB\x8C",
		"\xF4\xB0" => "\xE7\x98\xA0",
		"\xF4\xB1" => "\xE8\x84\x8A",
		"\xF4\xB2" => "\xE8\xB9\xA0",
		"\xF4\xB3" => "\xE9\x99\x9F",
		"\xF4\xB4" => "\xE9\x9A\xBB",
		"\xF4\xB5" => "\xE4\xBB\x9F",
		"\xF4\xB6" => "\xE5\x8D\x83",
		"\xF4\xB7" => "\xE5\x96\x98",
		"\xF4\xB8" => "\xE5\xA4\xA9",
		"\xF4\xB9" => "\xE5\xB7\x9D",
		"\xF4\xBA" => "\xE6\x93\x85",
		"\xF4\xBB" => "\xE6\xB3\x89",
		"\xF4\xBC" => "\xE6\xB7\xBA",
		"\xF4\xBD" => "\xE7\x8E\x94",
		"\xF4\xBE" => "\xE7\xA9\xBF",
		"\xF4\xBF" => "\xE8\x88\x9B",
		"\xF4\xC0" => "\xE8\x96\xA6",
		"\xF4\xC1" => "\xE8\xB3\xA4",
		"\xF4\xC2" => "\xE8\xB8\x90",
		"\xF4\xC3" => "\xE9\x81\xB7",
		"\xF4\xC4" => "\xE9\x87\xA7",
		"\xF4\xC5" => "\xE9\x97\xA1",
		"\xF4\xC6" => "\xE9\x98\xA1",
		"\xF4\xC7" => "\xE9\x9F\x86",
		"\xF4\xC8" => "\xE5\x87\xB8",
		"\xF4\xC9" => "\xE5\x93\xB2",
		"\xF4\xCA" => "\xE5\x96\x86",
		"\xF4\xCB" => "\xE5\xBE\xB9",
		"\xF4\xCC" => "\xE6\x92\xA4",
		"\xF4\xCD" => "\xE6\xBE\x88",
		"\xF4\xCE" => "\xE7\xB6\xB4",
		"\xF4\xCF" => "\xE8\xBC\x9F",
		"\xF4\xD0" => "\xE8\xBD\x8D",
		"\xF4\xD1" => "\xE9\x90\xB5",
		"\xF4\xD2" => "\xE5\x83\x89",
		"\xF4\xD3" => "\xE5\xB0\x96",
		"\xF4\xD4" => "\xE6\xB2\xBE",
		"\xF4\xD5" => "\xE6\xB7\xBB",
		"\xF4\xD6" => "\xE7\x94\x9B",
		"\xF4\xD7" => "\xE7\x9E\xBB",
		"\xF4\xD8" => "\xE7\xB0\xBD",
		"\xF4\xD9" => "\xE7\xB1\xA4",
		"\xF4\xDA" => "\xE8\xA9\xB9",
		"\xF4\xDB" => "\xE8\xAB\x82",
		"\xF4\xDC" => "\xE5\xA0\x9E",
		"\xF4\xDD" => "\xE5\xA6\xBE",
		"\xF4\xDE" => "\xE5\xB8\x96",
		"\xF4\xDF" => "\xE6\x8D\xB7",
		"\xF4\xE0" => "\xE7\x89\x92",
		"\xF4\xE1" => "\xE7\x96\x8A",
		"\xF4\xE2" => "\xE7\x9D\xAB",
		"\xF4\xE3" => "\xE8\xAB\x9C",
		"\xF4\xE4" => "\xE8\xB2\xBC",
		"\xF4\xE5" => "\xE8\xBC\x92",
		"\xF4\xE6" => "\xE5\xBB\xB3",
		"\xF4\xE7" => "\xE6\x99\xB4",
		"\xF4\xE8" => "\xE6\xB7\xB8",
		"\xF4\xE9" => "\xE8\x81\xBD",
		"\xF4\xEA" => "\xE8\x8F\x81",
		"\xF4\xEB" => "\xE8\xAB\x8B",
		"\xF4\xEC" => "\xE9\x9D\x91",
		"\xF4\xED" => "\xE9\xAF\x96",
		"\xF4\xEE" => "\xEF\xA8\x80",
		"\xF4\xEF" => "\xE5\x89\x83",
		"\xF4\xF0" => "\xE6\x9B\xBF",
		"\xF4\xF1" => "\xE6\xB6\x95",
		"\xF4\xF2" => "\xE6\xBB\xAF",
		"\xF4\xF3" => "\xE7\xB7\xA0",
		"\xF4\xF4" => "\xE8\xAB\xA6",
		"\xF4\xF5" => "\xE9\x80\xAE",
		"\xF4\xF6" => "\xE9\x81\x9E",
		"\xF4\xF7" => "\xE9\xAB\x94",
		"\xF4\xF8" => "\xE5\x88\x9D",
		"\xF4\xF9" => "\xE5\x89\xBF",
		"\xF4\xFA" => "\xE5\x93\xA8",
		"\xF4\xFB" => "\xE6\x86\x94",
		"\xF4\xFC" => "\xE6\x8A\x84",
		"\xF4\xFD" => "\xE6\x8B\x9B",
		"\xF4\xFE" => "\xE6\xA2\xA2",
		"\xF5\xA1" => "\xE6\xA4\x92",
		"\xF5\xA2" => "\xE6\xA5\x9A",
		"\xF5\xA3" => "\xE6\xA8\xB5",
		"\xF5\xA4" => "\xE7\x82\x92",
		"\xF5\xA5" => "\xE7\x84\xA6",
		"\xF5\xA6" => "\xE7\xA1\x9D",
		"\xF5\xA7" => "\xE7\xA4\x81",
		"\xF5\xA8" => "\xE7\xA4\x8E",
		"\xF5\xA9" => "\xE7\xA7\x92",
		"\xF5\xAA" => "\xE7\xA8\x8D",
		"\xF5\xAB" => "\xE8\x82\x96",
		"\xF5\xAC" => "\xE8\x89\xB8",
		"\xF5\xAD" => "\xE8\x8B\x95",
		"\xF5\xAE" => "\xE8\x8D\x89",
		"\xF5\xAF" => "\xE8\x95\x89",
		"\xF5\xB0" => "\xE8\xB2\x82",
		"\xF5\xB1" => "\xE8\xB6\x85",
		"\xF5\xB2" => "\xE9\x85\xA2",
		"\xF5\xB3" => "\xE9\x86\x8B",
		"\xF5\xB4" => "\xE9\x86\xAE",
		"\xF5\xB5" => "\xE4\xBF\x83",
		"\xF5\xB6" => "\xE5\x9B\x91",
		"\xF5\xB7" => "\xE7\x87\xAD",
		"\xF5\xB8" => "\xE7\x9F\x97",
		"\xF5\xB9" => "\xE8\x9C\x80",
		"\xF5\xBA" => "\xE8\xA7\xB8",
		"\xF5\xBB" => "\xE5\xAF\xB8",
		"\xF5\xBC" => "\xE5\xBF\x96",
		"\xF5\xBD" => "\xE6\x9D\x91",
		"\xF5\xBE" => "\xE9\x82\xA8",
		"\xF5\xBF" => "\xE5\x8F\xA2",
		"\xF5\xC0" => "\xE5\xA1\x9A",
		"\xF5\xC1" => "\xE5\xAF\xB5",
		"\xF5\xC2" => "\xE6\x82\xA4",
		"\xF5\xC3" => "\xE6\x86\x81",
		"\xF5\xC4" => "\xE6\x91\xA0",
		"\xF5\xC5" => "\xE7\xB8\xBD",
		"\xF5\xC6" => "\xE8\x81\xB0",
		"\xF5\xC7" => "\xE8\x94\xA5",
		"\xF5\xC8" => "\xE9\x8A\x83",
		"\xF5\xC9" => "\xE6\x92\xAE",
		"\xF5\xCA" => "\xE5\x82\xAC",
		"\xF5\xCB" => "\xE5\xB4\x94",
		"\xF5\xCC" => "\xE6\x9C\x80",
		"\xF5\xCD" => "\xE5\xA2\x9C",
		"\xF5\xCE" => "\xE6\x8A\xBD",
		"\xF5\xCF" => "\xE6\x8E\xA8",
		"\xF5\xD0" => "\xE6\xA4\x8E",
		"\xF5\xD1" => "\xE6\xA5\xB8",
		"\xF5\xD2" => "\xE6\xA8\x9E",
		"\xF5\xD3" => "\xE6\xB9\xAB",
		"\xF5\xD4" => "\xE7\x9A\xBA",
		"\xF5\xD5" => "\xE7\xA7\x8B",
		"\xF5\xD6" => "\xE8\x8A\xBB",
		"\xF5\xD7" => "\xE8\x90\xA9",
		"\xF5\xD8" => "\xE8\xAB\x8F",
		"\xF5\xD9" => "\xE8\xB6\xA8",
		"\xF5\xDA" => "\xE8\xBF\xBD",
		"\xF5\xDB" => "\xE9\x84\x92",
		"\xF5\xDC" => "\xE9\x85\x8B",
		"\xF5\xDD" => "\xE9\x86\x9C",
		"\xF5\xDE" => "\xE9\x8C\x90",
		"\xF5\xDF" => "\xE9\x8C\x98",
		"\xF5\xE0" => "\xE9\x8E\x9A",
		"\xF5\xE1" => "\xE9\x9B\x9B",
		"\xF5\xE2" => "\xE9\xA8\xB6",
		"\xF5\xE3" => "\xE9\xB0\x8D",
		"\xF5\xE4" => "\xE4\xB8\x91",
		"\xF5\xE5" => "\xE7\x95\x9C",
		"\xF5\xE6" => "\xE7\xA5\x9D",
		"\xF5\xE7" => "\xE7\xAB\xBA",
		"\xF5\xE8" => "\xE7\xAD\x91",
		"\xF5\xE9" => "\xE7\xAF\x89",
		"\xF5\xEA" => "\xE7\xB8\xAE",
		"\xF5\xEB" => "\xE8\x93\x84",
		"\xF5\xEC" => "\xE8\xB9\x99",
		"\xF5\xED" => "\xE8\xB9\xB4",
		"\xF5\xEE" => "\xE8\xBB\xB8",
		"\xF5\xEF" => "\xE9\x80\x90",
		"\xF5\xF0" => "\xE6\x98\xA5",
		"\xF5\xF1" => "\xE6\xA4\xBF",
		"\xF5\xF2" => "\xE7\x91\x83",
		"\xF5\xF3" => "\xE5\x87\xBA",
		"\xF5\xF4" => "\xE6\x9C\xAE",
		"\xF5\xF5" => "\xE9\xBB\x9C",
		"\xF5\xF6" => "\xE5\x85\x85",
		"\xF5\xF7" => "\xE5\xBF\xA0",
		"\xF5\xF8" => "\xE6\xB2\x96",
		"\xF5\xF9" => "\xE8\x9F\xB2",
		"\xF5\xFA" => "\xE8\xA1\x9D",
		"\xF5\xFB" => "\xE8\xA1\xB7",
		"\xF5\xFC" => "\xE6\x82\xB4",
		"\xF5\xFD" => "\xE8\x86\xB5",
		"\xF5\xFE" => "\xE8\x90\x83",
		"\xF6\xA1" => "\xE8\xB4\x85",
		"\xF6\xA2" => "\xE5\x8F\x96",
		"\xF6\xA3" => "\xE5\x90\xB9",
		"\xF6\xA4" => "\xE5\x98\xB4",
		"\xF6\xA5" => "\xE5\xA8\xB6",
		"\xF6\xA6" => "\xE5\xB0\xB1",
		"\xF6\xA7" => "\xE7\x82\x8A",
		"\xF6\xA8" => "\xE7\xBF\xA0",
		"\xF6\xA9" => "\xE8\x81\x9A",
		"\xF6\xAA" => "\xE8\x84\x86",
		"\xF6\xAB" => "\xE8\x87\xAD",
		"\xF6\xAC" => "\xE8\xB6\xA3",
		"\xF6\xAD" => "\xE9\x86\x89",
		"\xF6\xAE" => "\xE9\xA9\x9F",
		"\xF6\xAF" => "\xE9\xB7\xB2",
		"\xF6\xB0" => "\xE5\x81\xB4",
		"\xF6\xB1" => "\xE4\xBB\x84",
		"\xF6\xB2" => "\xE5\x8E\xA0",
		"\xF6\xB3" => "\xE6\x83\xBB",
		"\xF6\xB4" => "\xE6\xB8\xAC",
		"\xF6\xB5" => "\xE5\xB1\xA4",
		"\xF6\xB6" => "\xE4\xBE\x88",
		"\xF6\xB7" => "\xE5\x80\xA4",
		"\xF6\xB8" => "\xE5\x97\xA4",
		"\xF6\xB9" => "\xE5\xB3\x99",
		"\xF6\xBA" => "\xE5\xB9\x9F",
		"\xF6\xBB" => "\xE6\x81\xA5",
		"\xF6\xBC" => "\xE6\xA2\x94",
		"\xF6\xBD" => "\xE6\xB2\xBB",
		"\xF6\xBE" => "\xE6\xB7\x84",
		"\xF6\xBF" => "\xE7\x86\xBE",
		"\xF6\xC0" => "\xE7\x97\x94",
		"\xF6\xC1" => "\xE7\x97\xB4",
		"\xF6\xC2" => "\xE7\x99\xA1",
		"\xF6\xC3" => "\xE7\xA8\x9A",
		"\xF6\xC4" => "\xE7\xA9\x89",
		"\xF6\xC5" => "\xE7\xB7\x87",
		"\xF6\xC6" => "\xE7\xB7\xBB",
		"\xF6\xC7" => "\xE7\xBD\xAE",
		"\xF6\xC8" => "\xE8\x87\xB4",
		"\xF6\xC9" => "\xE8\x9A\xA9",
		"\xF6\xCA" => "\xE8\xBC\x9C",
		"\xF6\xCB" => "\xE9\x9B\x89",
		"\xF6\xCC" => "\xE9\xA6\xB3",
		"\xF6\xCD" => "\xE9\xBD\x92",
		"\xF6\xCE" => "\xE5\x89\x87",
		"\xF6\xCF" => "\xE5\x8B\x85",
		"\xF6\xD0" => "\xE9\xA3\xAD",
		"\xF6\xD1" => "\xE8\xA6\xAA",
		"\xF6\xD2" => "\xE4\xB8\x83",
		"\xF6\xD3" => "\xE6\x9F\x92",
		"\xF6\xD4" => "\xE6\xBC\x86",
		"\xF6\xD5" => "\xE4\xBE\xB5",
		"\xF6\xD6" => "\xE5\xAF\xA2",
		"\xF6\xD7" => "\xE6\x9E\x95",
		"\xF6\xD8" => "\xE6\xB2\x88",
		"\xF6\xD9" => "\xE6\xB5\xB8",
		"\xF6\xDA" => "\xE7\x90\x9B",
		"\xF6\xDB" => "\xE7\xA0\xA7",
		"\xF6\xDC" => "\xE9\x87\x9D",
		"\xF6\xDD" => "\xE9\x8D\xBC",
		"\xF6\xDE" => "\xE8\x9F\x84",
		"\xF6\xDF" => "\xE7\xA7\xA4",
		"\xF6\xE0" => "\xE7\xA8\xB1",
		"\xF6\xE1" => "\xE5\xBF\xAB",
		"\xF6\xE2" => "\xE4\xBB\x96",
		"\xF6\xE3" => "\xE5\x92\xA4",
		"\xF6\xE4" => "\xE5\x94\xBE",
		"\xF6\xE5" => "\xE5\xA2\xAE",
		"\xF6\xE6" => "\xE5\xA6\xA5",
		"\xF6\xE7" => "\xE6\x83\xB0",
		"\xF6\xE8" => "\xE6\x89\x93",
		"\xF6\xE9" => "\xE6\x8B\x96",
		"\xF6\xEA" => "\xE6\x9C\xB6",
		"\xF6\xEB" => "\xE6\xA5\x95",
		"\xF6\xEC" => "\xE8\x88\xB5",
		"\xF6\xED" => "\xE9\x99\x80",
		"\xF6\xEE" => "\xE9\xA6\xB1",
		"\xF6\xEF" => "\xE9\xA7\x9D",
		"\xF6\xF0" => "\xE5\x80\xAC",
		"\xF6\xF1" => "\xE5\x8D\x93",
		"\xF6\xF2" => "\xE5\x95\x84",
		"\xF6\xF3" => "\xE5\x9D\xBC",
		"\xF6\xF4" => "\xEF\xA8\x81",
		"\xF6\xF5" => "\xE6\x89\x98",
		"\xF6\xF6" => "\xEF\xA8\x82",
		"\xF6\xF7" => "\xE6\x93\xA2",
		"\xF6\xF8" => "\xE6\x99\xAB",
		"\xF6\xF9" => "\xE6\x9F\x9D",
		"\xF6\xFA" => "\xE6\xBF\x81",
		"\xF6\xFB" => "\xE6\xBF\xAF",
		"\xF6\xFC" => "\xE7\x90\xA2",
		"\xF6\xFD" => "\xE7\x90\xB8",
		"\xF6\xFE" => "\xE8\xA8\x97",
		"\xF7\xA1" => "\xE9\x90\xB8",
		"\xF7\xA2" => "\xE5\x91\x91",
		"\xF7\xA3" => "\xE5\x98\x86",
		"\xF7\xA4" => "\xE5\x9D\xA6",
		"\xF7\xA5" => "\xE5\xBD\x88",
		"\xF7\xA6" => "\xE6\x86\x9A",
		"\xF7\xA7" => "\xE6\xAD\x8E",
		"\xF7\xA8" => "\xE7\x81\x98",
		"\xF7\xA9" => "\xE7\x82\xAD",
		"\xF7\xAA" => "\xE7\xB6\xBB",
		"\xF7\xAB" => "\xE8\xAA\x95",
		"\xF7\xAC" => "\xE5\xA5\xAA",
		"\xF7\xAD" => "\xE8\x84\xAB",
		"\xF7\xAE" => "\xE6\x8E\xA2",
		"\xF7\xAF" => "\xE7\x9C\x88",
		"\xF7\xB0" => "\xE8\x80\xBD",
		"\xF7\xB1" => "\xE8\xB2\xAA",
		"\xF7\xB2" => "\xE5\xA1\x94",
		"\xF7\xB3" => "\xE6\x90\xAD",
		"\xF7\xB4" => "\xE6\xA6\xBB",
		"\xF7\xB5" => "\xE5\xAE\x95",
		"\xF7\xB6" => "\xE5\xB8\x91",
		"\xF7\xB7" => "\xE6\xB9\xAF",
		"\xF7\xB8" => "\xEF\xA8\x83",
		"\xF7\xB9" => "\xE8\x95\xA9",
		"\xF7\xBA" => "\xE5\x85\x8C",
		"\xF7\xBB" => "\xE5\x8F\xB0",
		"\xF7\xBC" => "\xE5\xA4\xAA",
		"\xF7\xBD" => "\xE6\x80\xA0",
		"\xF7\xBE" => "\xE6\x85\x8B",
		"\xF7\xBF" => "\xE6\xAE\x86",
		"\xF7\xC0" => "\xE6\xB1\xB0",
		"\xF7\xC1" => "\xE6\xB3\xB0",
		"\xF7\xC2" => "\xE7\xAC\x9E",
		"\xF7\xC3" => "\xE8\x83\x8E",
		"\xF7\xC4" => "\xE8\x8B\x94",
		"\xF7\xC5" => "\xE8\xB7\x86",
		"\xF7\xC6" => "\xE9\x82\xB0",
		"\xF7\xC7" => "\xE9\xA2\xB1",
		"\xF7\xC8" => "\xEF\xA8\x84",
		"\xF7\xC9" => "\xE6\x93\x87",
		"\xF7\xCA" => "\xE6\xBE\xA4",
		"\xF7\xCB" => "\xE6\x92\x91",
		"\xF7\xCC" => "\xE6\x94\x84",
		"\xF7\xCD" => "\xE5\x85\x8E",
		"\xF7\xCE" => "\xE5\x90\x90",
		"\xF7\xCF" => "\xE5\x9C\x9F",
		"\xF7\xD0" => "\xE8\xA8\x8E",
		"\xF7\xD1" => "\xE6\x85\x9F",
		"\xF7\xD2" => "\xE6\xA1\xB6",
		"\xF7\xD3" => "\xEF\xA8\x85",
		"\xF7\xD4" => "\xE7\x97\x9B",
		"\xF7\xD5" => "\xE7\xAD\x92",
		"\xF7\xD6" => "\xE7\xB5\xB1",
		"\xF7\xD7" => "\xE9\x80\x9A",
		"\xF7\xD8" => "\xE5\xA0\x86",
		"\xF7\xD9" => "\xE6\xA7\x8C",
		"\xF7\xDA" => "\xE8\x85\xBF",
		"\xF7\xDB" => "\xE8\xA4\xAA",
		"\xF7\xDC" => "\xE9\x80\x80",
		"\xF7\xDD" => "\xE9\xA0\xB9",
		"\xF7\xDE" => "\xE5\x81\xB8",
		"\xF7\xDF" => "\xE5\xA5\x97",
		"\xF7\xE0" => "\xE5\xA6\xAC",
		"\xF7\xE1" => "\xE6\x8A\x95",
		"\xF7\xE2" => "\xE9\x80\x8F",
		"\xF7\xE3" => "\xE9\xAC\xAA",
		"\xF7\xE4" => "\xE6\x85\x9D",
		"\xF7\xE5" => "\xE7\x89\xB9",
		"\xF7\xE6" => "\xE9\x97\x96",
		"\xF7\xE7" => "\xE5\x9D\xA1",
		"\xF7\xE8" => "\xE5\xA9\x86",
		"\xF7\xE9" => "\xE5\xB7\xB4",
		"\xF7\xEA" => "\xE6\x8A\x8A",
		"\xF7\xEB" => "\xE6\x92\xAD",
		"\xF7\xEC" => "\xE6\x93\xBA",
		"\xF7\xED" => "\xE6\x9D\xB7",
		"\xF7\xEE" => "\xE6\xB3\xA2",
		"\xF7\xEF" => "\xE6\xB4\xBE",
		"\xF7\xF0" => "\xE7\x88\xAC",
		"\xF7\xF1" => "\xE7\x90\xB6",
		"\xF7\xF2" => "\xE7\xA0\xB4",
		"\xF7\xF3" => "\xE7\xBD\xB7",
		"\xF7\xF4" => "\xE8\x8A\xAD",
		"\xF7\xF5" => "\xE8\xB7\x9B",
		"\xF7\xF6" => "\xE9\xA0\x97",
		"\xF7\xF7" => "\xE5\x88\xA4",
		"\xF7\xF8" => "\xE5\x9D\x82",
		"\xF7\xF9" => "\xE6\x9D\xBF",
		"\xF7\xFA" => "\xE7\x89\x88",
		"\xF7\xFB" => "\xE7\x93\xA3",
		"\xF7\xFC" => "\xE8\xB2\xA9",
		"\xF7\xFD" => "\xE8\xBE\xA6",
		"\xF7\xFE" => "\xE9\x88\x91",
		"\xF8\xA1" => "\xE9\x98\xAA",
		"\xF8\xA2" => "\xE5\x85\xAB",
		"\xF8\xA3" => "\xE5\x8F\xAD",
		"\xF8\xA4" => "\xE6\x8D\x8C",
		"\xF8\xA5" => "\xE4\xBD\xA9",
		"\xF8\xA6" => "\xE5\x94\x84",
		"\xF8\xA7" => "\xE6\x82\x96",
		"\xF8\xA8" => "\xE6\x95\x97",
		"\xF8\xA9" => "\xE6\xB2\x9B",
		"\xF8\xAA" => "\xE6\xB5\xBF",
		"\xF8\xAB" => "\xE7\x89\x8C",
		"\xF8\xAC" => "\xE7\x8B\xBD",
		"\xF8\xAD" => "\xE7\xA8\x97",
		"\xF8\xAE" => "\xE8\xA6\x87",
		"\xF8\xAF" => "\xE8\xB2\x9D",
		"\xF8\xB0" => "\xE5\xBD\xAD",
		"\xF8\xB1" => "\xE6\xBE\x8E",
		"\xF8\xB2" => "\xE7\x83\xB9",
		"\xF8\xB3" => "\xE8\x86\xA8",
		"\xF8\xB4" => "\xE6\x84\x8E",
		"\xF8\xB5" => "\xE4\xBE\xBF",
		"\xF8\xB6" => "\xE5\x81\x8F",
		"\xF8\xB7" => "\xE6\x89\x81",
		"\xF8\xB8" => "\xE7\x89\x87",
		"\xF8\xB9" => "\xE7\xAF\x87",
		"\xF8\xBA" => "\xE7\xB7\xA8",
		"\xF8\xBB" => "\xE7\xBF\xA9",
		"\xF8\xBC" => "\xE9\x81\x8D",
		"\xF8\xBD" => "\xE9\x9E\xAD",
		"\xF8\xBE" => "\xE9\xA8\x99",
		"\xF8\xBF" => "\xE8\xB2\xB6",
		"\xF8\xC0" => "\xE5\x9D\xAA",
		"\xF8\xC1" => "\xE5\xB9\xB3",
		"\xF8\xC2" => "\xE6\x9E\xB0",
		"\xF8\xC3" => "\xE8\x90\x8D",
		"\xF8\xC4" => "\xE8\xA9\x95",
		"\xF8\xC5" => "\xE5\x90\xA0",
		"\xF8\xC6" => "\xE5\xAC\x96",
		"\xF8\xC7" => "\xE5\xB9\xA3",
		"\xF8\xC8" => "\xE5\xBB\xA2",
		"\xF8\xC9" => "\xE5\xBC\x8A",
		"\xF8\xCA" => "\xE6\x96\x83",
		"\xF8\xCB" => "\xE8\x82\xBA",
		"\xF8\xCC" => "\xE8\x94\xBD",
		"\xF8\xCD" => "\xE9\x96\x89",
		"\xF8\xCE" => "\xE9\x99\x9B",
		"\xF8\xCF" => "\xE4\xBD\x88",
		"\xF8\xD0" => "\xE5\x8C\x85",
		"\xF8\xD1" => "\xE5\x8C\x8D",
		"\xF8\xD2" => "\xE5\x8C\x8F",
		"\xF8\xD3" => "\xE5\x92\x86",
		"\xF8\xD4" => "\xE5\x93\xBA",
		"\xF8\xD5" => "\xE5\x9C\x83",
		"\xF8\xD6" => "\xE5\xB8\x83",
		"\xF8\xD7" => "\xE6\x80\x96",
		"\xF8\xD8" => "\xE6\x8A\x9B",
		"\xF8\xD9" => "\xE6\x8A\xB1",
		"\xF8\xDA" => "\xE6\x8D\x95",
		"\xF8\xDB" => "\xEF\xA8\x86",
		"\xF8\xDC" => "\xE6\xB3\xA1",
		"\xF8\xDD" => "\xE6\xB5\xA6",
		"\xF8\xDE" => "\xE7\x96\xB1",
		"\xF8\xDF" => "\xE7\xA0\xB2",
		"\xF8\xE0" => "\xE8\x83\x9E",
		"\xF8\xE1" => "\xE8\x84\xAF",
		"\xF8\xE2" => "\xE8\x8B\x9E",
		"\xF8\xE3" => "\xE8\x91\xA1",
		"\xF8\xE4" => "\xE8\x92\xB2",
		"\xF8\xE5" => "\xE8\xA2\x8D",
		"\xF8\xE6" => "\xE8\xA4\x92",
		"\xF8\xE7" => "\xE9\x80\x8B",
		"\xF8\xE8" => "\xE9\x8B\xAA",
		"\xF8\xE9" => "\xE9\xA3\xBD",
		"\xF8\xEA" => "\xE9\xAE\x91",
		"\xF8\xEB" => "\xE5\xB9\x85",
		"\xF8\xEC" => "\xE6\x9A\xB4",
		"\xF8\xED" => "\xE6\x9B\x9D",
		"\xF8\xEE" => "\xE7\x80\x91",
		"\xF8\xEF" => "\xE7\x88\x86",
		"\xF8\xF0" => "\xEF\xA8\x87",
		"\xF8\xF1" => "\xE4\xBF\xB5",
		"\xF8\xF2" => "\xE5\x89\xBD",
		"\xF8\xF3" => "\xE5\xBD\xAA",
		"\xF8\xF4" => "\xE6\x85\x93",
		"\xF8\xF5" => "\xE6\x9D\x93",
		"\xF8\xF6" => "\xE6\xA8\x99",
		"\xF8\xF7" => "\xE6\xBC\x82",
		"\xF8\xF8" => "\xE7\x93\xA2",
		"\xF8\xF9" => "\xE7\xA5\xA8",
		"\xF8\xFA" => "\xE8\xA1\xA8",
		"\xF8\xFB" => "\xE8\xB1\xB9",
		"\xF8\xFC" => "\xE9\xA3\x87",
		"\xF8\xFD" => "\xE9\xA3\x84",
		"\xF8\xFE" => "\xE9\xA9\x83",
		"\xF9\xA1" => "\xE5\x93\x81",
		"\xF9\xA2" => "\xE7\xA8\x9F",
		"\xF9\xA3" => "\xE6\xA5\x93",
		"\xF9\xA4" => "\xE8\xAB\xB7",
		"\xF9\xA5" => "\xE8\xB1\x8A",
		"\xF9\xA6" => "\xE9\xA2\xA8",
		"\xF9\xA7" => "\xE9\xA6\xAE",
		"\xF9\xA8" => "\xE5\xBD\xBC",
		"\xF9\xA9" => "\xE6\x8A\xAB",
		"\xF9\xAA" => "\xE7\x96\xB2",
		"\xF9\xAB" => "\xE7\x9A\xAE",
		"\xF9\xAC" => "\xE8\xA2\xAB",
		"\xF9\xAD" => "\xE9\x81\xBF",
		"\xF9\xAE" => "\xE9\x99\x82",
		"\xF9\xAF" => "\xE5\x8C\xB9",
		"\xF9\xB0" => "\xE5\xBC\xBC",
		"\xF9\xB1" => "\xE5\xBF\x85",
		"\xF9\xB2" => "\xE6\xB3\x8C",
		"\xF9\xB3" => "\xE7\x8F\x8C",
		"\xF9\xB4" => "\xE7\x95\xA2",
		"\xF9\xB5" => "\xE7\x96\x8B",
		"\xF9\xB6" => "\xE7\xAD\x86",
		"\xF9\xB7" => "\xE8\x8B\xBE",
		"\xF9\xB8" => "\xE9\xA6\x9D",
		"\xF9\xB9" => "\xE4\xB9\x8F",
		"\xF9\xBA" => "\xE9\x80\xBC",
		"\xF9\xBB" => "\xE4\xB8\x8B",
		"\xF9\xBC" => "\xE4\xBD\x95",
		"\xF9\xBD" => "\xE5\x8E\xA6",
		"\xF9\xBE" => "\xE5\xA4\x8F",
		"\xF9\xBF" => "\xE5\xBB\x88",
		"\xF9\xC0" => "\xE6\x98\xB0",
		"\xF9\xC1" => "\xE6\xB2\xB3",
		"\xF9\xC2" => "\xE7\x91\x95",
		"\xF9\xC3" => "\xE8\x8D\xB7",
		"\xF9\xC4" => "\xE8\x9D\xA6",
		"\xF9\xC5" => "\xE8\xB3\x80",
		"\xF9\xC6" => "\xE9\x81\x90",
		"\xF9\xC7" => "\xE9\x9C\x9E",
		"\xF9\xC8" => "\xE9\xB0\x95",
		"\xF9\xC9" => "\xE5\xA3\x91",
		"\xF9\xCA" => "\xE5\xAD\xB8",
		"\xF9\xCB" => "\xE8\x99\x90",
		"\xF9\xCC" => "\xE8\xAC\x94",
		"\xF9\xCD" => "\xE9\xB6\xB4",
		"\xF9\xCE" => "\xE5\xAF\x92",
		"\xF9\xCF" => "\xE6\x81\xA8",
		"\xF9\xD0" => "\xE6\x82\x8D",
		"\xF9\xD1" => "\xE6\x97\xB1",
		"\xF9\xD2" => "\xE6\xB1\x97",
		"\xF9\xD3" => "\xE6\xBC\xA2",
		"\xF9\xD4" => "\xE6\xBE\xA3",
		"\xF9\xD5" => "\xE7\x80\x9A",
		"\xF9\xD6" => "\xE7\xBD\x95",
		"\xF9\xD7" => "\xE7\xBF\xB0",
		"\xF9\xD8" => "\xE9\x96\x91",
		"\xF9\xD9" => "\xE9\x96\x92",
		"\xF9\xDA" => "\xE9\x99\x90",
		"\xF9\xDB" => "\xE9\x9F\x93",
		"\xF9\xDC" => "\xE5\x89\xB2",
		"\xF9\xDD" => "\xE8\xBD\x84",
		"\xF9\xDE" => "\xE5\x87\xBD",
		"\xF9\xDF" => "\xE5\x90\xAB",
		"\xF9\xE0" => "\xE5\x92\xB8",
		"\xF9\xE1" => "\xE5\x95\xA3",
		"\xF9\xE2" => "\xE5\x96\x8A",
		"\xF9\xE3" => "\xE6\xAA\xBB",
		"\xF9\xE4" => "\xE6\xB6\xB5",
		"\xF9\xE5" => "\xE7\xB7\x98",
		"\xF9\xE6" => "\xE8\x89\xA6",
		"\xF9\xE7" => "\xE9\x8A\x9C",
		"\xF9\xE8" => "\xE9\x99\xB7",
		"\xF9\xE9" => "\xE9\xB9\xB9",
		"\xF9\xEA" => "\xE5\x90\x88",
		"\xF9\xEB" => "\xE5\x93\x88",
		"\xF9\xEC" => "\xE7\x9B\x92",
		"\xF9\xED" => "\xE8\x9B\xA4",
		"\xF9\xEE" => "\xE9\x96\xA4",
		"\xF9\xEF" => "\xE9\x97\x94",
		"\xF9\xF0" => "\xE9\x99\x9C",
		"\xF9\xF1" => "\xE4\xBA\xA2",
		"\xF9\xF2" => "\xE4\xBC\x89",
		"\xF9\xF3" => "\xE5\xA7\xAE",
		"\xF9\xF4" => "\xE5\xAB\xA6",
		"\xF9\xF5" => "\xE5\xB7\xB7",
		"\xF9\xF6" => "\xE6\x81\x92",
		"\xF9\xF7" => "\xE6\x8A\x97",
		"\xF9\xF8" => "\xE6\x9D\xAD",
		"\xF9\xF9" => "\xE6\xA1\x81",
		"\xF9\xFA" => "\xE6\xB2\x86",
		"\xF9\xFB" => "\xE6\xB8\xAF",
		"\xF9\xFC" => "\xE7\xBC\xB8",
		"\xF9\xFD" => "\xE8\x82\x9B",
		"\xF9\xFE" => "\xE8\x88\xAA",
		"\xFA\xA1" => "\xEF\xA8\x88",
		"\xFA\xA2" => "\xEF\xA8\x89",
		"\xFA\xA3" => "\xE9\xA0\x85",
		"\xFA\xA4" => "\xE4\xBA\xA5",
		"\xFA\xA5" => "\xE5\x81\x95",
		"\xFA\xA6" => "\xE5\x92\xB3",
		"\xFA\xA7" => "\xE5\x9E\x93",
		"\xFA\xA8" => "\xE5\xA5\x9A",
		"\xFA\xA9" => "\xE5\xAD\xA9",
		"\xFA\xAA" => "\xE5\xAE\xB3",
		"\xFA\xAB" => "\xE6\x87\x88",
		"\xFA\xAC" => "\xE6\xA5\xB7",
		"\xFA\xAD" => "\xE6\xB5\xB7",
		"\xFA\xAE" => "\xE7\x80\xA3",
		"\xFA\xAF" => "\xE8\x9F\xB9",
		"\xFA\xB0" => "\xE8\xA7\xA3",
		"\xFA\xB1" => "\xE8\xA9\xB2",
		"\xFA\xB2" => "\xE8\xAB\xA7",
		"\xFA\xB3" => "\xE9\x82\x82",
		"\xFA\xB4" => "\xE9\xA7\xAD",
		"\xFA\xB5" => "\xE9\xAA\xB8",
		"\xFA\xB6" => "\xE5\x8A\xBE",
		"\xFA\xB7" => "\xE6\xA0\xB8",
		"\xFA\xB8" => "\xE5\x80\x96",
		"\xFA\xB9" => "\xE5\xB9\xB8",
		"\xFA\xBA" => "\xE6\x9D\x8F",
		"\xFA\xBB" => "\xE8\x8D\x87",
		"\xFA\xBC" => "\xE8\xA1\x8C",
		"\xFA\xBD" => "\xE4\xBA\xAB",
		"\xFA\xBE" => "\xE5\x90\x91",
		"\xFA\xBF" => "\xE5\x9A\xAE",
		"\xFA\xC0" => "\xE7\x8F\xA6",
		"\xFA\xC1" => "\xE9\x84\x95",
		"\xFA\xC2" => "\xE9\x9F\xBF",
		"\xFA\xC3" => "\xE9\xA4\x89",
		"\xFA\xC4" => "\xE9\xA5\x97",
		"\xFA\xC5" => "\xE9\xA6\x99",
		"\xFA\xC6" => "\xE5\x99\x93",
		"\xFA\xC7" => "\xE5\xA2\x9F",
		"\xFA\xC8" => "\xE8\x99\x9B",
		"\xFA\xC9" => "\xE8\xA8\xB1",
		"\xFA\xCA" => "\xE6\x86\xB2",
		"\xFA\xCB" => "\xE6\xAB\xB6",
		"\xFA\xCC" => "\xE7\x8D\xBB",
		"\xFA\xCD" => "\xE8\xBB\x92",
		"\xFA\xCE" => "\xE6\xAD\x87",
		"\xFA\xCF" => "\xE9\x9A\xAA",
		"\xFA\xD0" => "\xE9\xA9\x97",
		"\xFA\xD1" => "\xE5\xA5\x95",
		"\xFA\xD2" => "\xE7\x88\x80",
		"\xFA\xD3" => "\xE8\xB5\xAB",
		"\xFA\xD4" => "\xE9\x9D\xA9",
		"\xFA\xD5" => "\xE4\xBF\x94",
		"\xFA\xD6" => "\xE5\xB3\xB4",
		"\xFA\xD7" => "\xE5\xBC\xA6",
		"\xFA\xD8" => "\xE6\x87\xB8",
		"\xFA\xD9" => "\xE6\x99\x9B",
		"\xFA\xDA" => "\xE6\xB3\xAB",
		"\xFA\xDB" => "\xE7\x82\xAB",
		"\xFA\xDC" => "\xE7\x8E\x84",
		"\xFA\xDD" => "\xE7\x8E\xB9",
		"\xFA\xDE" => "\xE7\x8F\xBE",
		"\xFA\xDF" => "\xE7\x9C\xA9",
		"\xFA\xE0" => "\xE7\x9D\x8D",
		"\xFA\xE1" => "\xE7\xB5\x83",
		"\xFA\xE2" => "\xE7\xB5\xA2",
		"\xFA\xE3" => "\xE7\xB8\xA3",
		"\xFA\xE4" => "\xE8\x88\xB7",
		"\xFA\xE5" => "\xE8\xA1\x92",
		"\xFA\xE6" => "\xEF\xA8\x8A",
		"\xFA\xE7" => "\xE8\xB3\xA2",
		"\xFA\xE8" => "\xE9\x89\x89",
		"\xFA\xE9" => "\xE9\xA1\xAF",
		"\xFA\xEA" => "\xE5\xAD\x91",
		"\xFA\xEB" => "\xE7\xA9\xB4",
		"\xFA\xEC" => "\xE8\xA1\x80",
		"\xFA\xED" => "\xE9\xA0\x81",
		"\xFA\xEE" => "\xE5\xAB\x8C",
		"\xFA\xEF" => "\xE4\xBF\xA0",
		"\xFA\xF0" => "\xE5\x8D\x94",
		"\xFA\xF1" => "\xE5\xA4\xBE",
		"\xFA\xF2" => "\xE5\xB3\xBD",
		"\xFA\xF3" => "\xE6\x8C\xBE",
		"\xFA\xF4" => "\xE6\xB5\xB9",
		"\xFA\xF5" => "\xE7\x8B\xB9",
		"\xFA\xF6" => "\xE8\x84\x85",
		"\xFA\xF7" => "\xE8\x84\x87",
		"\xFA\xF8" => "\xE8\x8E\xA2",
		"\xFA\xF9" => "\xE9\x8B\x8F",
		"\xFA\xFA" => "\xE9\xA0\xB0",
		"\xFA\xFB" => "\xE4\xBA\xA8",
		"\xFA\xFC" => "\xE5\x85\x84",
		"\xFA\xFD" => "\xE5\x88\x91",
		"\xFA\xFE" => "\xE5\x9E\x8B",
		"\xFB\xA1" => "\xE5\xBD\xA2",
		"\xFB\xA2" => "\xE6\xB3\x82",
		"\xFB\xA3" => "\xE6\xBB\x8E",
		"\xFB\xA4" => "\xE7\x80\x85",
		"\xFB\xA5" => "\xE7\x81\x90",
		"\xFB\xA6" => "\xE7\x82\xAF",
		"\xFB\xA7" => "\xE7\x86\x92",
		"\xFB\xA8" => "\xE7\x8F\xA9",
		"\xFB\xA9" => "\xE7\x91\xA9",
		"\xFB\xAA" => "\xE8\x8D\x8A",
		"\xFB\xAB" => "\xE8\x9E\xA2",
		"\xFB\xAC" => "\xE8\xA1\xA1",
		"\xFB\xAD" => "\xE9\x80\x88",
		"\xFB\xAE" => "\xE9\x82\xA2",
		"\xFB\xAF" => "\xE9\x8E\xA3",
		"\xFB\xB0" => "\xE9\xA6\xA8",
		"\xFB\xB1" => "\xE5\x85\xAE",
		"\xFB\xB2" => "\xE5\xBD\x97",
		"\xFB\xB3" => "\xE6\x83\xA0",
		"\xFB\xB4" => "\xE6\x85\xA7",
		"\xFB\xB5" => "\xE6\x9A\xB3",
		"\xFB\xB6" => "\xE8\x95\x99",
		"\xFB\xB7" => "\xE8\xB9\x8A",
		"\xFB\xB8" => "\xE9\x86\xAF",
		"\xFB\xB9" => "\xE9\x9E\x8B",
		"\xFB\xBA" => "\xE4\xB9\x8E",
		"\xFB\xBB" => "\xE4\xBA\x92",
		"\xFB\xBC" => "\xE5\x91\xBC",
		"\xFB\xBD" => "\xE5\xA3\x95",
		"\xFB\xBE" => "\xE5\xA3\xBA",
		"\xFB\xBF" => "\xE5\xA5\xBD",
		"\xFB\xC0" => "\xE5\xB2\xB5",
		"\xFB\xC1" => "\xE5\xBC\xA7",
		"\xFB\xC2" => "\xE6\x88\xB6",
		"\xFB\xC3" => "\xE6\x89\x88",
		"\xFB\xC4" => "\xE6\x98\x8A",
		"\xFB\xC5" => "\xE6\x99\xA7",
		"\xFB\xC6" => "\xE6\xAF\xAB",
		"\xFB\xC7" => "\xE6\xB5\xA9",
		"\xFB\xC8" => "\xE6\xB7\x8F",
		"\xFB\xC9" => "\xE6\xB9\x96",
		"\xFB\xCA" => "\xE6\xBB\xB8",
		"\xFB\xCB" => "\xE6\xBE\x94",
		"\xFB\xCC" => "\xE6\xBF\xA0",
		"\xFB\xCD" => "\xE6\xBF\xA9",
		"\xFB\xCE" => "\xE7\x81\x9D",
		"\xFB\xCF" => "\xE7\x8B\x90",
		"\xFB\xD0" => "\xE7\x90\xA5",
		"\xFB\xD1" => "\xE7\x91\x9A",
		"\xFB\xD2" => "\xE7\x93\xA0",
		"\xFB\xD3" => "\xE7\x9A\x93",
		"\xFB\xD4" => "\xE7\xA5\x9C",
		"\xFB\xD5" => "\xE7\xB3\x8A",
		"\xFB\xD6" => "\xE7\xB8\x9E",
		"\xFB\xD7" => "\xE8\x83\xA1",
		"\xFB\xD8" => "\xE8\x8A\xA6",
		"\xFB\xD9" => "\xE8\x91\xAB",
		"\xFB\xDA" => "\xE8\x92\xBF",
		"\xFB\xDB" => "\xE8\x99\x8E",
		"\xFB\xDC" => "\xE8\x99\x9F",
		"\xFB\xDD" => "\xE8\x9D\xB4",
		"\xFB\xDE" => "\xE8\xAD\xB7",
		"\xFB\xDF" => "\xE8\xB1\xAA",
		"\xFB\xE0" => "\xE9\x8E\xAC",
		"\xFB\xE1" => "\xE9\xA0\x80",
		"\xFB\xE2" => "\xE9\xA1\xA5",
		"\xFB\xE3" => "\xE6\x83\x91",
		"\xFB\xE4" => "\xE6\x88\x96",
		"\xFB\xE5" => "\xE9\x85\xB7",
		"\xFB\xE6" => "\xE5\xA9\x9A",
		"\xFB\xE7" => "\xE6\x98\x8F",
		"\xFB\xE8" => "\xE6\xB7\xB7",
		"\xFB\xE9" => "\xE6\xB8\xBE",
		"\xFB\xEA" => "\xE7\x90\xBF",
		"\xFB\xEB" => "\xE9\xAD\x82",
		"\xFB\xEC" => "\xE5\xBF\xBD",
		"\xFB\xED" => "\xE6\x83\x9A",
		"\xFB\xEE" => "\xE7\xAC\x8F",
		"\xFB\xEF" => "\xE5\x93\x84",
		"\xFB\xF0" => "\xE5\xBC\x98",
		"\xFB\xF1" => "\xE6\xB1\x9E",
		"\xFB\xF2" => "\xE6\xB3\x93",
		"\xFB\xF3" => "\xE6\xB4\xAA",
		"\xFB\xF4" => "\xE7\x83\x98",
		"\xFB\xF5" => "\xE7\xB4\x85",
		"\xFB\xF6" => "\xE8\x99\xB9",
		"\xFB\xF7" => "\xE8\xA8\x8C",
		"\xFB\xF8" => "\xE9\xB4\xBB",
		"\xFB\xF9" => "\xE5\x8C\x96",
		"\xFB\xFA" => "\xE5\x92\x8C",
		"\xFB\xFB" => "\xE5\xAC\x85",
		"\xFB\xFC" => "\xE6\xA8\xBA",
		"\xFB\xFD" => "\xE7\x81\xAB",
		"\xFB\xFE" => "\xE7\x95\xB5",
		"\xFC\xA1" => "\xE7\xA6\x8D",
		"\xFC\xA2" => "\xE7\xA6\xBE",
		"\xFC\xA3" => "\xE8\x8A\xB1",
		"\xFC\xA4" => "\xE8\x8F\xAF",
		"\xFC\xA5" => "\xE8\xA9\xB1",
		"\xFC\xA6" => "\xE8\xAD\x81",
		"\xFC\xA7" => "\xE8\xB2\xA8",
		"\xFC\xA8" => "\xE9\x9D\xB4",
		"\xFC\xA9" => "\xEF\xA8\x8B",
		"\xFC\xAA" => "\xE6\x93\xB4",
		"\xFC\xAB" => "\xE6\x94\xAB",
		"\xFC\xAC" => "\xE7\xA2\xBA",
		"\xFC\xAD" => "\xE7\xA2\xBB",
		"\xFC\xAE" => "\xE7\xA9\xAB",
		"\xFC\xAF" => "\xE4\xB8\xB8",
		"\xFC\xB0" => "\xE5\x96\x9A",
		"\xFC\xB1" => "\xE5\xA5\x90",
		"\xFC\xB2" => "\xE5\xAE\xA6",
		"\xFC\xB3" => "\xE5\xB9\xBB",
		"\xFC\xB4" => "\xE6\x82\xA3",
		"\xFC\xB5" => "\xE6\x8F\x9B",
		"\xFC\xB6" => "\xE6\xAD\xA1",
		"\xFC\xB7" => "\xE6\x99\xA5",
		"\xFC\xB8" => "\xE6\xA1\x93",
		"\xFC\xB9" => "\xE6\xB8\x99",
		"\xFC\xBA" => "\xE7\x85\xA5",
		"\xFC\xBB" => "\xE7\x92\xB0",
		"\xFC\xBC" => "\xE7\xB4\x88",
		"\xFC\xBD" => "\xE9\x82\x84",
		"\xFC\xBE" => "\xE9\xA9\xA9",
		"\xFC\xBF" => "\xE9\xB0\xA5",
		"\xFC\xC0" => "\xE6\xB4\xBB",
		"\xFC\xC1" => "\xE6\xBB\x91",
		"\xFC\xC2" => "\xE7\x8C\xBE",
		"\xFC\xC3" => "\xE8\xB1\x81",
		"\xFC\xC4" => "\xE9\x97\x8A",
		"\xFC\xC5" => "\xE5\x87\xB0",
		"\xFC\xC6" => "\xE5\xB9\x8C",
		"\xFC\xC7" => "\xE5\xBE\xA8",
		"\xFC\xC8" => "\xE6\x81\x8D",
		"\xFC\xC9" => "\xE6\x83\xB6",
		"\xFC\xCA" => "\xE6\x84\xB0",
		"\xFC\xCB" => "\xE6\x85\x8C",
		"\xFC\xCC" => "\xE6\x99\x83",
		"\xFC\xCD" => "\xE6\x99\x84",
		"\xFC\xCE" => "\xE6\xA6\xA5",
		"\xFC\xCF" => "\xE6\xB3\x81",
		"\xFC\xD0" => "\xE6\xB9\x9F",
		"\xFC\xD1" => "\xE6\xBB\x89",
		"\xFC\xD2" => "\xE6\xBD\xA2",
		"\xFC\xD3" => "\xE7\x85\x8C",
		"\xFC\xD4" => "\xE7\x92\x9C",
		"\xFC\xD5" => "\xE7\x9A\x87",
		"\xFC\xD6" => "\xE7\xAF\x81",
		"\xFC\xD7" => "\xE7\xB0\xA7",
		"\xFC\xD8" => "\xE8\x8D\x92",
		"\xFC\xD9" => "\xE8\x9D\x97",
		"\xFC\xDA" => "\xE9\x81\x91",
		"\xFC\xDB" => "\xE9\x9A\x8D",
		"\xFC\xDC" => "\xE9\xBB\x83",
		"\xFC\xDD" => "\xE5\x8C\xAF",
		"\xFC\xDE" => "\xE5\x9B\x9E",
		"\xFC\xDF" => "\xE5\xBB\xBB",
		"\xFC\xE0" => "\xE5\xBE\x8A",
		"\xFC\xE1" => "\xE6\x81\xA2",
		"\xFC\xE2" => "\xE6\x82\x94",
		"\xFC\xE3" => "\xE6\x87\xB7",
		"\xFC\xE4" => "\xE6\x99\xA6",
		"\xFC\xE5" => "\xE6\x9C\x83",
		"\xFC\xE6" => "\xE6\xAA\x9C",
		"\xFC\xE7" => "\xE6\xB7\xAE",
		"\xFC\xE8" => "\xE6\xBE\xAE",
		"\xFC\xE9" => "\xE7\x81\xB0",
		"\xFC\xEA" => "\xE7\x8D\xAA",
		"\xFC\xEB" => "\xE7\xB9\xAA",
		"\xFC\xEC" => "\xE8\x86\xBE",
		"\xFC\xED" => "\xE8\x8C\xB4",
		"\xFC\xEE" => "\xE8\x9B\x94",
		"\xFC\xEF" => "\xE8\xAA\xA8",
		"\xFC\xF0" => "\xE8\xB3\x84",
		"\xFC\xF1" => "\xE5\x8A\x83",
		"\xFC\xF2" => "\xE7\x8D\xB2",
		"\xFC\xF3" => "\xE5\xAE\x96",
		"\xFC\xF4" => "\xE6\xA9\xAB",
		"\xFC\xF5" => "\xE9\x90\x84",
		"\xFC\xF6" => "\xE5\x93\xAE",
		"\xFC\xF7" => "\xE5\x9A\x86",
		"\xFC\xF8" => "\xE5\xAD\x9D",
		"\xFC\xF9" => "\xE6\x95\x88",
		"\xFC\xFA" => "\xE6\x96\x85",
		"\xFC\xFB" => "\xE6\x9B\x89",
		"\xFC\xFC" => "\xE6\xA2\x9F",
		"\xFC\xFD" => "\xE6\xB6\x8D",
		"\xFC\xFE" => "\xE6\xB7\x86",
		"\xFD\xA1" => "\xE7\x88\xBB",
		"\xFD\xA2" => "\xE8\x82\xB4",
		"\xFD\xA3" => "\xE9\x85\xB5",
		"\xFD\xA4" => "\xE9\xA9\x8D",
		"\xFD\xA5" => "\xE4\xBE\xAF",
		"\xFD\xA6" => "\xE5\x80\x99",
		"\xFD\xA7" => "\xE5\x8E\x9A",
		"\xFD\xA8" => "\xE5\x90\x8E",
		"\xFD\xA9" => "\xE5\x90\xBC",
		"\xFD\xAA" => "\xE5\x96\x89",
		"\xFD\xAB" => "\xE5\x97\x85",
		"\xFD\xAC" => "\xE5\xB8\xBF",
		"\xFD\xAD" => "\xE5\xBE\x8C",
		"\xFD\xAE" => "\xE6\x9C\xBD",
		"\xFD\xAF" => "\xE7\x85\xA6",
		"\xFD\xB0" => "\xE7\x8F\x9D",
		"\xFD\xB1" => "\xE9\x80\x85",
		"\xFD\xB2" => "\xE5\x8B\x9B",
		"\xFD\xB3" => "\xE5\x8B\xB3",
		"\xFD\xB4" => "\xE5\xA1\xA4",
		"\xFD\xB5" => "\xE5\xA3\x8E",
		"\xFD\xB6" => "\xE7\x84\x84",
		"\xFD\xB7" => "\xE7\x86\x8F",
		"\xFD\xB8" => "\xE7\x87\xBB",
		"\xFD\xB9" => "\xE8\x96\xB0",
		"\xFD\xBA" => "\xE8\xA8\x93",
		"\xFD\xBB" => "\xE6\x9A\x88",
		"\xFD\xBC" => "\xE8\x96\xA8",
		"\xFD\xBD" => "\xE5\x96\xA7",
		"\xFD\xBE" => "\xE6\x9A\x84",
		"\xFD\xBF" => "\xE7\x85\x8A",
		"\xFD\xC0" => "\xE8\x90\xB1",
		"\xFD\xC1" => "\xE5\x8D\x89",
		"\xFD\xC2" => "\xE5\x96\x99",
		"\xFD\xC3" => "\xE6\xAF\x81",
		"\xFD\xC4" => "\xE5\xBD\x99",
		"\xFD\xC5" => "\xE5\xBE\xBD",
		"\xFD\xC6" => "\xE6\x8F\xAE",
		"\xFD\xC7" => "\xE6\x9A\x89",
		"\xFD\xC8" => "\xE7\x85\x87",
		"\xFD\xC9" => "\xE8\xAB\xB1",
		"\xFD\xCA" => "\xE8\xBC\x9D",
		"\xFD\xCB" => "\xE9\xBA\xBE",
		"\xFD\xCC" => "\xE4\xBC\x91",
		"\xFD\xCD" => "\xE6\x90\xBA",
		"\xFD\xCE" => "\xE7\x83\x8B",
		"\xFD\xCF" => "\xE7\x95\xA6",
		"\xFD\xD0" => "\xE8\x99\xA7",
		"\xFD\xD1" => "\xE6\x81\xA4",
		"\xFD\xD2" => "\xE8\xAD\x8E",
		"\xFD\xD3" => "\xE9\xB7\xB8",
		"\xFD\xD4" => "\xE5\x85\x87",
		"\xFD\xD5" => "\xE5\x87\xB6",
		"\xFD\xD6" => "\xE5\x8C\x88",
		"\xFD\xD7" => "\xE6\xB4\xB6",
		"\xFD\xD8" => "\xE8\x83\xB8",
		"\xFD\xD9" => "\xE9\xBB\x91",
		"\xFD\xDA" => "\xE6\x98\x95",
		"\xFD\xDB" => "\xE6\xAC\xA3",
		"\xFD\xDC" => "\xE7\x82\x98",
		"\xFD\xDD" => "\xE7\x97\x95",
		"\xFD\xDE" => "\xE5\x90\x83",
		"\xFD\xDF" => "\xE5\xB1\xB9",
		"\xFD\xE0" => "\xE7\xB4\x87",
		"\xFD\xE1" => "\xE8\xA8\x96",
		"\xFD\xE2" => "\xE6\xAC\xA0",
		"\xFD\xE3" => "\xE6\xAC\xBD",
		"\xFD\xE4" => "\xE6\xAD\x86",
		"\xFD\xE5" => "\xE5\x90\xB8",
		"\xFD\xE6" => "\xE6\x81\xB0",
		"\xFD\xE7" => "\xE6\xB4\xBD",
		"\xFD\xE8" => "\xE7\xBF\x95",
		"\xFD\xE9" => "\xE8\x88\x88",
		"\xFD\xEA" => "\xE5\x83\x96",
		"\xFD\xEB" => "\xE5\x87\x9E",
		"\xFD\xEC" => "\xE5\x96\x9C",
		"\xFD\xED" => "\xE5\x99\xAB",
		"\xFD\xEE" => "\xE5\x9B\x8D",
		"\xFD\xEF" => "\xE5\xA7\xAC",
		"\xFD\xF0" => "\xE5\xAC\x89",
		"\xFD\xF1" => "\xE5\xB8\x8C",
		"\xFD\xF2" => "\xE6\x86\x99",
		"\xFD\xF3" => "\xE6\x86\x98",
		"\xFD\xF4" => "\xE6\x88\xB1",
		"\xFD\xF5" => "\xE6\x99\x9E",
		"\xFD\xF6" => "\xE6\x9B\xA6",
		"\xFD\xF7" => "\xE7\x86\x99",
		"\xFD\xF8" => "\xE7\x86\xB9",
		"\xFD\xF9" => "\xE7\x86\xBA",
		"\xFD\xFA" => "\xE7\x8A\xA7",
		"\xFD\xFB" => "\xE7\xA6\xA7",
		"\xFD\xFC" => "\xE7\xA8\x80",
		"\xFD\xFD" => "\xE7\xBE\xB2",
		"\xFD\xFE" => "\xE8\xA9\xB0",
	);
	return strtr($string, $transform);
}

function big5($string)
{
	static $transform = array(
		"\xA1\x40" => "\xE3\x80\x80",
		"\xA1\x41" => "\xEF\xBC\x8C",
		"\xA1\x42" => "\xE3\x80\x81",
		"\xA1\x43" => "\xE3\x80\x82",
		"\xA1\x44" => "\xEF\xBC\x8E",
		"\xA1\x45" => "\xE2\x80\xA2",
		"\xA1\x46" => "\xEF\xBC\x9B",
		"\xA1\x47" => "\xEF\xBC\x9A",
		"\xA1\x48" => "\xEF\xBC\x9F",
		"\xA1\x49" => "\xEF\xBC\x81",
		"\xA1\x4A" => "\xEF\xB8\xB0",
		"\xA1\x4B" => "\xE2\x80\xA6",
		"\xA1\x4C" => "\xE2\x80\xA5",
		"\xA1\x4D" => "\xEF\xB9\x90",
		"\xA1\x4E" => "\xEF\xBD\xA4",
		"\xA1\x4F" => "\xEF\xB9\x92",
		"\xA1\x50" => "\xC2\xB7",
		"\xA1\x51" => "\xEF\xB9\x94",
		"\xA1\x52" => "\xEF\xB9\x95",
		"\xA1\x53" => "\xEF\xB9\x96",
		"\xA1\x54" => "\xEF\xB9\x97",
		"\xA1\x55" => "\xEF\xBD\x9C",
		"\xA1\x56" => "\xE2\x80\x93",
		"\xA1\x57" => "\xEF\xB8\xB1",
		"\xA1\x58" => "\xE2\x80\x94",
		"\xA1\x59" => "\xEF\xB8\xB3",
		"\xA1\x5A" => "\xEF\xBF\xBD",
		"\xA1\x5B" => "\xEF\xB8\xB4",
		"\xA1\x5C" => "\xEF\xB9\x8F",
		"\xA1\x5D" => "\xEF\xBC\x88",
		"\xA1\x5E" => "\xEF\xBC\x89",
		"\xA1\x5F" => "\xEF\xB8\xB5",
		"\xA1\x60" => "\xEF\xB8\xB6",
		"\xA1\x61" => "\xEF\xBD\x9B",
		"\xA1\x62" => "\xEF\xBD\x9D",
		"\xA1\x63" => "\xEF\xB8\xB7",
		"\xA1\x64" => "\xEF\xB8\xB8",
		"\xA1\x65" => "\xE3\x80\x94",
		"\xA1\x66" => "\xE3\x80\x95",
		"\xA1\x67" => "\xEF\xB8\xB9",
		"\xA1\x68" => "\xEF\xB8\xBA",
		"\xA1\x69" => "\xE3\x80\x90",
		"\xA1\x6A" => "\xE3\x80\x91",
		"\xA1\x6B" => "\xEF\xB8\xBB",
		"\xA1\x6C" => "\xEF\xB8\xBC",
		"\xA1\x6D" => "\xE3\x80\x8A",
		"\xA1\x6E" => "\xE3\x80\x8B",
		"\xA1\x6F" => "\xEF\xB8\xBD",
		"\xA1\x70" => "\xEF\xB8\xBE",
		"\xA1\x71" => "\xE3\x80\x88",
		"\xA1\x72" => "\xE3\x80\x89",
		"\xA1\x73" => "\xEF\xB8\xBF",
		"\xA1\x74" => "\xEF\xB9\x80",
		"\xA1\x75" => "\xE3\x80\x8C",
		"\xA1\x76" => "\xE3\x80\x8D",
		"\xA1\x77" => "\xEF\xB9\x81",
		"\xA1\x78" => "\xEF\xB9\x82",
		"\xA1\x79" => "\xE3\x80\x8E",
		"\xA1\x7A" => "\xE3\x80\x8F",
		"\xA1\x7B" => "\xEF\xB9\x83",
		"\xA1\x7C" => "\xEF\xB9\x84",
		"\xA1\x7D" => "\xEF\xB9\x99",
		"\xA1\x7E" => "\xEF\xB9\x9A",
		"\xA1\xA1" => "\xEF\xB9\x9B",
		"\xA1\xA2" => "\xEF\xB9\x9C",
		"\xA1\xA3" => "\xEF\xB9\x9D",
		"\xA1\xA4" => "\xEF\xB9\x9E",
		"\xA1\xA5" => "\xE2\x80\x98",
		"\xA1\xA6" => "\xE2\x80\x99",
		"\xA1\xA7" => "\xE2\x80\x9C",
		"\xA1\xA8" => "\xE2\x80\x9D",
		"\xA1\xA9" => "\xE3\x80\x9D",
		"\xA1\xAA" => "\xE3\x80\x9E",
		"\xA1\xAB" => "\xE2\x80\xB5",
		"\xA1\xAC" => "\xE2\x80\xB2",
		"\xA1\xAD" => "\xEF\xBC\x83",
		"\xA1\xAE" => "\xEF\xBC\x86",
		"\xA1\xAF" => "\xEF\xBC\x8A",
		"\xA1\xB0" => "\xE2\x80\xBB",
		"\xA1\xB1" => "\xC2\xA7",
		"\xA1\xB2" => "\xE3\x80\x83",
		"\xA1\xB3" => "\xE2\x97\x8B",
		"\xA1\xB4" => "\xE2\x97\x8F",
		"\xA1\xB5" => "\xE2\x96\xB3",
		"\xA1\xB6" => "\xE2\x96\xB2",
		"\xA1\xB7" => "\xE2\x97\x8E",
		"\xA1\xB8" => "\xE2\x98\x86",
		"\xA1\xB9" => "\xE2\x98\x85",
		"\xA1\xBA" => "\xE2\x97\x87",
		"\xA1\xBB" => "\xE2\x97\x86",
		"\xA1\xBC" => "\xE2\x96\xA1",
		"\xA1\xBD" => "\xE2\x96\xA0",
		"\xA1\xBE" => "\xE2\x96\xBD",
		"\xA1\xBF" => "\xE2\x96\xBC",
		"\xA1\xC0" => "\xE3\x8A\xA3",
		"\xA1\xC1" => "\xE2\x84\x85",
		"\xA1\xC2" => "\xE2\x80\xBE",
		"\xA1\xC3" => "\xEF\xBF\xBD",
		"\xA1\xC4" => "\xEF\xBC\xBF",
		"\xA1\xC5" => "\xEF\xBF\xBD",
		"\xA1\xC6" => "\xEF\xB9\x89",
		"\xA1\xC7" => "\xEF\xB9\x8A",
		"\xA1\xC8" => "\xEF\xB9\x8D",
		"\xA1\xC9" => "\xEF\xB9\x8E",
		"\xA1\xCA" => "\xEF\xB9\x8B",
		"\xA1\xCB" => "\xEF\xB9\x8C",
		"\xA1\xCC" => "\xEF\xB9\x9F",
		"\xA1\xCD" => "\xEF\xB9\xA0",
		"\xA1\xCE" => "\xEF\xB9\xA1",
		"\xA1\xCF" => "\xEF\xBC\x8B",
		"\xA1\xD0" => "\xEF\xBC\x8D",
		"\xA1\xD1" => "\xC3\x97",
		"\xA1\xD2" => "\xC3\xB7",
		"\xA1\xD3" => "\xC2\xB1",
		"\xA1\xD4" => "\xE2\x88\x9A",
		"\xA1\xD5" => "\xEF\xBC\x9C",
		"\xA1\xD6" => "\xEF\xBC\x9E",
		"\xA1\xD7" => "\xEF\xBC\x9D",
		"\xA1\xD8" => "\xE2\x89\xA6",
		"\xA1\xD9" => "\xE2\x89\xA7",
		"\xA1\xDA" => "\xE2\x89\xA0",
		"\xA1\xDB" => "\xE2\x88\x9E",
		"\xA1\xDC" => "\xE2\x89\x92",
		"\xA1\xDD" => "\xE2\x89\xA1",
		"\xA1\xDE" => "\xEF\xB9\xA2",
		"\xA1\xDF" => "\xEF\xB9\xA3",
		"\xA1\xE0" => "\xEF\xB9\xA4",
		"\xA1\xE1" => "\xEF\xB9\xA5",
		"\xA1\xE2" => "\xEF\xB9\xA6",
		"\xA1\xE3" => "\xE2\x88\xBC",
		"\xA1\xE4" => "\xE2\x88\xA9",
		"\xA1\xE5" => "\xE2\x88\xAA",
		"\xA1\xE6" => "\xE2\x8A\xA5",
		"\xA1\xE7" => "\xE2\x88\xA0",
		"\xA1\xE8" => "\xE2\x88\x9F",
		"\xA1\xE9" => "\xE2\x8A\xBF",
		"\xA1\xEA" => "\xE3\x8F\x92",
		"\xA1\xEB" => "\xE3\x8F\x91",
		"\xA1\xEC" => "\xE2\x88\xAB",
		"\xA1\xED" => "\xE2\x88\xAE",
		"\xA1\xEE" => "\xE2\x88\xB5",
		"\xA1\xEF" => "\xE2\x88\xB4",
		"\xA1\xF0" => "\xE2\x99\x80",
		"\xA1\xF1" => "\xE2\x99\x82",
		"\xA1\xF2" => "\xE2\x99\x81",
		"\xA1\xF3" => "\xE2\x98\x89",
		"\xA1\xF4" => "\xE2\x86\x91",
		"\xA1\xF5" => "\xE2\x86\x93",
		"\xA1\xF6" => "\xE2\x86\x90",
		"\xA1\xF7" => "\xE2\x86\x92",
		"\xA1\xF8" => "\xE2\x86\x96",
		"\xA1\xF9" => "\xE2\x86\x97",
		"\xA1\xFA" => "\xE2\x86\x99",
		"\xA1\xFB" => "\xE2\x86\x98",
		"\xA1\xFC" => "\xE2\x88\xA5",
		"\xA1\xFD" => "\xE2\x88\xA3",
		"\xA1\xFE" => "\xEF\xBF\xBD",
		"\xA2\x40" => "\xEF\xBF\xBD",
		"\xA2\x41" => "\xEF\xBC\x8F",
		"\xA2\x42" => "\xEF\xBC\xBC",
		"\xA2\x43" => "\xEF\xBC\x84",
		"\xA2\x44" => "\xC2\xA5",
		"\xA2\x45" => "\xE3\x80\x92",
		"\xA2\x46" => "\xC2\xA2",
		"\xA2\x47" => "\xC2\xA3",
		"\xA2\x48" => "\xEF\xBC\x85",
		"\xA2\x49" => "\xEF\xBC\xA0",
		"\xA2\x4A" => "\xE2\x84\x83",
		"\xA2\x4B" => "\xE2\x84\x89",
		"\xA2\x4C" => "\xEF\xB9\xA9",
		"\xA2\x4D" => "\xEF\xB9\xAA",
		"\xA2\x4E" => "\xEF\xB9\xAB",
		"\xA2\x4F" => "\xE3\x8F\x95",
		"\xA2\x50" => "\xE3\x8E\x9C",
		"\xA2\x51" => "\xE3\x8E\x9D",
		"\xA2\x52" => "\xE3\x8E\x9E",
		"\xA2\x53" => "\xE3\x8F\x8E",
		"\xA2\x54" => "\xE3\x8E\xA1",
		"\xA2\x55" => "\xE3\x8E\x8E",
		"\xA2\x56" => "\xE3\x8E\x8F",
		"\xA2\x57" => "\xE3\x8F\x84",
		"\xA2\x58" => "\xC2\xB0",
		"\xA2\x59" => "\xE5\x85\x99",
		"\xA2\x5A" => "\xE5\x85\x9B",
		"\xA2\x5B" => "\xE5\x85\x9E",
		"\xA2\x5C" => "\xE5\x85\x9D",
		"\xA2\x5D" => "\xE5\x85\xA1",
		"\xA2\x5E" => "\xE5\x85\xA3",
		"\xA2\x5F" => "\xE5\x97\xA7",
		"\xA2\x60" => "\xE7\x93\xA9",
		"\xA2\x61" => "\xE7\xB3\x8E",
		"\xA2\x62" => "\xE2\x96\x81",
		"\xA2\x63" => "\xE2\x96\x82",
		"\xA2\x64" => "\xE2\x96\x83",
		"\xA2\x65" => "\xE2\x96\x84",
		"\xA2\x66" => "\xE2\x96\x85",
		"\xA2\x67" => "\xE2\x96\x86",
		"\xA2\x68" => "\xE2\x96\x87",
		"\xA2\x69" => "\xE2\x96\x88",
		"\xA2\x6A" => "\xE2\x96\x8F",
		"\xA2\x6B" => "\xE2\x96\x8E",
		"\xA2\x6C" => "\xE2\x96\x8D",
		"\xA2\x6D" => "\xE2\x96\x8C",
		"\xA2\x6E" => "\xE2\x96\x8B",
		"\xA2\x6F" => "\xE2\x96\x8A",
		"\xA2\x70" => "\xE2\x96\x89",
		"\xA2\x71" => "\xE2\x94\xBC",
		"\xA2\x72" => "\xE2\x94\xB4",
		"\xA2\x73" => "\xE2\x94\xAC",
		"\xA2\x74" => "\xE2\x94\xA4",
		"\xA2\x75" => "\xE2\x94\x9C",
		"\xA2\x76" => "\xE2\x96\x94",
		"\xA2\x77" => "\xE2\x94\x80",
		"\xA2\x78" => "\xE2\x94\x82",
		"\xA2\x79" => "\xE2\x96\x95",
		"\xA2\x7A" => "\xE2\x94\x8C",
		"\xA2\x7B" => "\xE2\x94\x90",
		"\xA2\x7C" => "\xE2\x94\x94",
		"\xA2\x7D" => "\xE2\x94\x98",
		"\xA2\x7E" => "\xE2\x95\xAD",
		"\xA2\xA1" => "\xE2\x95\xAE",
		"\xA2\xA2" => "\xE2\x95\xB0",
		"\xA2\xA3" => "\xE2\x95\xAF",
		"\xA2\xA4" => "\xE2\x95\x90",
		"\xA2\xA5" => "\xE2\x95\x9E",
		"\xA2\xA6" => "\xE2\x95\xAA",
		"\xA2\xA7" => "\xE2\x95\xA1",
		"\xA2\xA8" => "\xE2\x97\xA2",
		"\xA2\xA9" => "\xE2\x97\xA3",
		"\xA2\xAA" => "\xE2\x97\xA5",
		"\xA2\xAB" => "\xE2\x97\xA4",
		"\xA2\xAC" => "\xE2\x95\xB1",
		"\xA2\xAD" => "\xE2\x95\xB2",
		"\xA2\xAE" => "\xE2\x95\xB3",
		"\xA2\xAF" => "\xEF\xBC\x90",
		"\xA2\xB0" => "\xEF\xBC\x91",
		"\xA2\xB1" => "\xEF\xBC\x92",
		"\xA2\xB2" => "\xEF\xBC\x93",
		"\xA2\xB3" => "\xEF\xBC\x94",
		"\xA2\xB4" => "\xEF\xBC\x95",
		"\xA2\xB5" => "\xEF\xBC\x96",
		"\xA2\xB6" => "\xEF\xBC\x97",
		"\xA2\xB7" => "\xEF\xBC\x98",
		"\xA2\xB8" => "\xEF\xBC\x99",
		"\xA2\xB9" => "\xE2\x85\xA0",
		"\xA2\xBA" => "\xE2\x85\xA1",
		"\xA2\xBB" => "\xE2\x85\xA2",
		"\xA2\xBC" => "\xE2\x85\xA3",
		"\xA2\xBD" => "\xE2\x85\xA4",
		"\xA2\xBE" => "\xE2\x85\xA5",
		"\xA2\xBF" => "\xE2\x85\xA6",
		"\xA2\xC0" => "\xE2\x85\xA7",
		"\xA2\xC1" => "\xE2\x85\xA8",
		"\xA2\xC2" => "\xE2\x85\xA9",
		"\xA2\xC3" => "\xE3\x80\xA1",
		"\xA2\xC4" => "\xE3\x80\xA2",
		"\xA2\xC5" => "\xE3\x80\xA3",
		"\xA2\xC6" => "\xE3\x80\xA4",
		"\xA2\xC7" => "\xE3\x80\xA5",
		"\xA2\xC8" => "\xE3\x80\xA6",
		"\xA2\xC9" => "\xE3\x80\xA7",
		"\xA2\xCA" => "\xE3\x80\xA8",
		"\xA2\xCB" => "\xE3\x80\xA9",
		"\xA2\xCC" => "\xEF\xBF\xBD",
		"\xA2\xCD" => "\xE5\x8D\x84",
		"\xA2\xCE" => "\xEF\xBF\xBD",
		"\xA2\xCF" => "\xEF\xBC\xA1",
		"\xA2\xD0" => "\xEF\xBC\xA2",
		"\xA2\xD1" => "\xEF\xBC\xA3",
		"\xA2\xD2" => "\xEF\xBC\xA4",
		"\xA2\xD3" => "\xEF\xBC\xA5",
		"\xA2\xD4" => "\xEF\xBC\xA6",
		"\xA2\xD5" => "\xEF\xBC\xA7",
		"\xA2\xD6" => "\xEF\xBC\xA8",
		"\xA2\xD7" => "\xEF\xBC\xA9",
		"\xA2\xD8" => "\xEF\xBC\xAA",
		"\xA2\xD9" => "\xEF\xBC\xAB",
		"\xA2\xDA" => "\xEF\xBC\xAC",
		"\xA2\xDB" => "\xEF\xBC\xAD",
		"\xA2\xDC" => "\xEF\xBC\xAE",
		"\xA2\xDD" => "\xEF\xBC\xAF",
		"\xA2\xDE" => "\xEF\xBC\xB0",
		"\xA2\xDF" => "\xEF\xBC\xB1",
		"\xA2\xE0" => "\xEF\xBC\xB2",
		"\xA2\xE1" => "\xEF\xBC\xB3",
		"\xA2\xE2" => "\xEF\xBC\xB4",
		"\xA2\xE3" => "\xEF\xBC\xB5",
		"\xA2\xE4" => "\xEF\xBC\xB6",
		"\xA2\xE5" => "\xEF\xBC\xB7",
		"\xA2\xE6" => "\xEF\xBC\xB8",
		"\xA2\xE7" => "\xEF\xBC\xB9",
		"\xA2\xE8" => "\xEF\xBC\xBA",
		"\xA2\xE9" => "\xEF\xBD\x81",
		"\xA2\xEA" => "\xEF\xBD\x82",
		"\xA2\xEB" => "\xEF\xBD\x83",
		"\xA2\xEC" => "\xEF\xBD\x84",
		"\xA2\xED" => "\xEF\xBD\x85",
		"\xA2\xEE" => "\xEF\xBD\x86",
		"\xA2\xEF" => "\xEF\xBD\x87",
		"\xA2\xF0" => "\xEF\xBD\x88",
		"\xA2\xF1" => "\xEF\xBD\x89",
		"\xA2\xF2" => "\xEF\xBD\x8A",
		"\xA2\xF3" => "\xEF\xBD\x8B",
		"\xA2\xF4" => "\xEF\xBD\x8C",
		"\xA2\xF5" => "\xEF\xBD\x8D",
		"\xA2\xF6" => "\xEF\xBD\x8E",
		"\xA2\xF7" => "\xEF\xBD\x8F",
		"\xA2\xF8" => "\xEF\xBD\x90",
		"\xA2\xF9" => "\xEF\xBD\x91",
		"\xA2\xFA" => "\xEF\xBD\x92",
		"\xA2\xFB" => "\xEF\xBD\x93",
		"\xA2\xFC" => "\xEF\xBD\x94",
		"\xA2\xFD" => "\xEF\xBD\x95",
		"\xA2\xFE" => "\xEF\xBD\x96",
		"\xA3\x40" => "\xEF\xBD\x97",
		"\xA3\x41" => "\xEF\xBD\x98",
		"\xA3\x42" => "\xEF\xBD\x99",
		"\xA3\x43" => "\xEF\xBD\x9A",
		"\xA3\x44" => "\xCE\x91",
		"\xA3\x45" => "\xCE\x92",
		"\xA3\x46" => "\xCE\x93",
		"\xA3\x47" => "\xCE\x94",
		"\xA3\x48" => "\xCE\x95",
		"\xA3\x49" => "\xCE\x96",
		"\xA3\x4A" => "\xCE\x97",
		"\xA3\x4B" => "\xCE\x98",
		"\xA3\x4C" => "\xCE\x99",
		"\xA3\x4D" => "\xCE\x9A",
		"\xA3\x4E" => "\xCE\x9B",
		"\xA3\x4F" => "\xCE\x9C",
		"\xA3\x50" => "\xCE\x9D",
		"\xA3\x51" => "\xCE\x9E",
		"\xA3\x52" => "\xCE\x9F",
		"\xA3\x53" => "\xCE\xA0",
		"\xA3\x54" => "\xCE\xA1",
		"\xA3\x55" => "\xCE\xA3",
		"\xA3\x56" => "\xCE\xA4",
		"\xA3\x57" => "\xCE\xA5",
		"\xA3\x58" => "\xCE\xA6",
		"\xA3\x59" => "\xCE\xA7",
		"\xA3\x5A" => "\xCE\xA8",
		"\xA3\x5B" => "\xCE\xA9",
		"\xA3\x5C" => "\xCE\xB1",
		"\xA3\x5D" => "\xCE\xB2",
		"\xA3\x5E" => "\xCE\xB3",
		"\xA3\x5F" => "\xCE\xB4",
		"\xA3\x60" => "\xCE\xB5",
		"\xA3\x61" => "\xCE\xB6",
		"\xA3\x62" => "\xCE\xB7",
		"\xA3\x63" => "\xCE\xB8",
		"\xA3\x64" => "\xCE\xB9",
		"\xA3\x65" => "\xCE\xBA",
		"\xA3\x66" => "\xCE\xBB",
		"\xA3\x67" => "\xCE\xBC",
		"\xA3\x68" => "\xCE\xBD",
		"\xA3\x69" => "\xCE\xBE",
		"\xA3\x6A" => "\xCE\xBF",
		"\xA3\x6B" => "\xCF\x80",
		"\xA3\x6C" => "\xCF\x81",
		"\xA3\x6D" => "\xCF\x83",
		"\xA3\x6E" => "\xCF\x84",
		"\xA3\x6F" => "\xCF\x85",
		"\xA3\x70" => "\xCF\x86",
		"\xA3\x71" => "\xCF\x87",
		"\xA3\x72" => "\xCF\x88",
		"\xA3\x73" => "\xCF\x89",
		"\xA3\x74" => "\xE3\x84\x85",
		"\xA3\x75" => "\xE3\x84\x86",
		"\xA3\x76" => "\xE3\x84\x87",
		"\xA3\x77" => "\xE3\x84\x88",
		"\xA3\x78" => "\xE3\x84\x89",
		"\xA3\x79" => "\xE3\x84\x8A",
		"\xA3\x7A" => "\xE3\x84\x8B",
		"\xA3\x7B" => "\xE3\x84\x8C",
		"\xA3\x7C" => "\xE3\x84\x8D",
		"\xA3\x7D" => "\xE3\x84\x8E",
		"\xA3\x7E" => "\xE3\x84\x8F",
		"\xA3\xA1" => "\xE3\x84\x90",
		"\xA3\xA2" => "\xE3\x84\x91",
		"\xA3\xA3" => "\xE3\x84\x92",
		"\xA3\xA4" => "\xE3\x84\x93",
		"\xA3\xA5" => "\xE3\x84\x94",
		"\xA3\xA6" => "\xE3\x84\x95",
		"\xA3\xA7" => "\xE3\x84\x96",
		"\xA3\xA8" => "\xE3\x84\x97",
		"\xA3\xA9" => "\xE3\x84\x98",
		"\xA3\xAA" => "\xE3\x84\x99",
		"\xA3\xAB" => "\xE3\x84\x9A",
		"\xA3\xAC" => "\xE3\x84\x9B",
		"\xA3\xAD" => "\xE3\x84\x9C",
		"\xA3\xAE" => "\xE3\x84\x9D",
		"\xA3\xAF" => "\xE3\x84\x9E",
		"\xA3\xB0" => "\xE3\x84\x9F",
		"\xA3\xB1" => "\xE3\x84\xA0",
		"\xA3\xB2" => "\xE3\x84\xA1",
		"\xA3\xB3" => "\xE3\x84\xA2",
		"\xA3\xB4" => "\xE3\x84\xA3",
		"\xA3\xB5" => "\xE3\x84\xA4",
		"\xA3\xB6" => "\xE3\x84\xA5",
		"\xA3\xB7" => "\xE3\x84\xA6",
		"\xA3\xB8" => "\xE3\x84\xA7",
		"\xA3\xB9" => "\xE3\x84\xA8",
		"\xA3\xBA" => "\xE3\x84\xA9",
		"\xA3\xBB" => "\xCB\x99",
		"\xA3\xBC" => "\xCB\x89",
		"\xA3\xBD" => "\xCB\x8A",
		"\xA3\xBE" => "\xCB\x87",
		"\xA3\xBF" => "\xCB\x8B",
		"\xA4\x40" => "\xE4\xB8\x80",
		"\xA4\x41" => "\xE4\xB9\x99",
		"\xA4\x42" => "\xE4\xB8\x81",
		"\xA4\x43" => "\xE4\xB8\x83",
		"\xA4\x44" => "\xE4\xB9\x83",
		"\xA4\x45" => "\xE4\xB9\x9D",
		"\xA4\x46" => "\xE4\xBA\x86",
		"\xA4\x47" => "\xE4\xBA\x8C",
		"\xA4\x48" => "\xE4\xBA\xBA",
		"\xA4\x49" => "\xE5\x84\xBF",
		"\xA4\x4A" => "\xE5\x85\xA5",
		"\xA4\x4B" => "\xE5\x85\xAB",
		"\xA4\x4C" => "\xE5\x87\xA0",
		"\xA4\x4D" => "\xE5\x88\x80",
		"\xA4\x4E" => "\xE5\x88\x81",
		"\xA4\x4F" => "\xE5\x8A\x9B",
		"\xA4\x50" => "\xE5\x8C\x95",
		"\xA4\x51" => "\xE5\x8D\x81",
		"\xA4\x52" => "\xE5\x8D\x9C",
		"\xA4\x53" => "\xE5\x8F\x88",
		"\xA4\x54" => "\xE4\xB8\x89",
		"\xA4\x55" => "\xE4\xB8\x8B",
		"\xA4\x56" => "\xE4\xB8\x88",
		"\xA4\x57" => "\xE4\xB8\x8A",
		"\xA4\x58" => "\xE4\xB8\xAB",
		"\xA4\x59" => "\xE4\xB8\xB8",
		"\xA4\x5A" => "\xE5\x87\xA1",
		"\xA4\x5B" => "\xE4\xB9\x85",
		"\xA4\x5C" => "\xE4\xB9\x88",
		"\xA4\x5D" => "\xE4\xB9\x9F",
		"\xA4\x5E" => "\xE4\xB9\x9E",
		"\xA4\x5F" => "\xE4\xBA\x8E",
		"\xA4\x60" => "\xE4\xBA\xA1",
		"\xA4\x61" => "\xE5\x85\x80",
		"\xA4\x62" => "\xE5\x88\x83",
		"\xA4\x63" => "\xE5\x8B\xBA",
		"\xA4\x64" => "\xE5\x8D\x83",
		"\xA4\x65" => "\xE5\x8F\x89",
		"\xA4\x66" => "\xE5\x8F\xA3",
		"\xA4\x67" => "\xE5\x9C\x9F",
		"\xA4\x68" => "\xE5\xA3\xAB",
		"\xA4\x69" => "\xE5\xA4\x95",
		"\xA4\x6A" => "\xE5\xA4\xA7",
		"\xA4\x6B" => "\xE5\xA5\xB3",
		"\xA4\x6C" => "\xE5\xAD\x90",
		"\xA4\x6D" => "\xE5\xAD\x91",
		"\xA4\x6E" => "\xE5\xAD\x93",
		"\xA4\x6F" => "\xE5\xAF\xB8",
		"\xA4\x70" => "\xE5\xB0\x8F",
		"\xA4\x71" => "\xE5\xB0\xA2",
		"\xA4\x72" => "\xE5\xB0\xB8",
		"\xA4\x73" => "\xE5\xB1\xB1",
		"\xA4\x74" => "\xE5\xB7\x9D",
		"\xA4\x75" => "\xE5\xB7\xA5",
		"\xA4\x76" => "\xE5\xB7\xB1",
		"\xA4\x77" => "\xE5\xB7\xB2",
		"\xA4\x78" => "\xE5\xB7\xB3",
		"\xA4\x79" => "\xE5\xB7\xBE",
		"\xA4\x7A" => "\xE5\xB9\xB2",
		"\xA4\x7B" => "\xE5\xBB\xBE",
		"\xA4\x7C" => "\xE5\xBC\x8B",
		"\xA4\x7D" => "\xE5\xBC\x93",
		"\xA4\x7E" => "\xE6\x89\x8D",
		"\xA4\xA1" => "\xE4\xB8\x91",
		"\xA4\xA2" => "\xE4\xB8\x90",
		"\xA4\xA3" => "\xE4\xB8\x8D",
		"\xA4\xA4" => "\xE4\xB8\xAD",
		"\xA4\xA5" => "\xE4\xB8\xB0",
		"\xA4\xA6" => "\xE4\xB8\xB9",
		"\xA4\xA7" => "\xE4\xB9\x8B",
		"\xA4\xA8" => "\xE5\xB0\xB9",
		"\xA4\xA9" => "\xE4\xBA\x88",
		"\xA4\xAA" => "\xE4\xBA\x91",
		"\xA4\xAB" => "\xE4\xBA\x95",
		"\xA4\xAC" => "\xE4\xBA\x92",
		"\xA4\xAD" => "\xE4\xBA\x94",
		"\xA4\xAE" => "\xE4\xBA\xA2",
		"\xA4\xAF" => "\xE4\xBB\x81",
		"\xA4\xB0" => "\xE4\xBB\x80",
		"\xA4\xB1" => "\xE4\xBB\x83",
		"\xA4\xB2" => "\xE4\xBB\x86",
		"\xA4\xB3" => "\xE4\xBB\x87",
		"\xA4\xB4" => "\xE4\xBB\x8D",
		"\xA4\xB5" => "\xE4\xBB\x8A",
		"\xA4\xB6" => "\xE4\xBB\x8B",
		"\xA4\xB7" => "\xE4\xBB\x84",
		"\xA4\xB8" => "\xE5\x85\x83",
		"\xA4\xB9" => "\xE5\x85\x81",
		"\xA4\xBA" => "\xE5\x85\xA7",
		"\xA4\xBB" => "\xE5\x85\xAD",
		"\xA4\xBC" => "\xE5\x85\xAE",
		"\xA4\xBD" => "\xE5\x85\xAC",
		"\xA4\xBE" => "\xE5\x86\x97",
		"\xA4\xBF" => "\xE5\x87\xB6",
		"\xA4\xC0" => "\xE5\x88\x86",
		"\xA4\xC1" => "\xE5\x88\x87",
		"\xA4\xC2" => "\xE5\x88\x88",
		"\xA4\xC3" => "\xE5\x8B\xBB",
		"\xA4\xC4" => "\xE5\x8B\xBE",
		"\xA4\xC5" => "\xE5\x8B\xBF",
		"\xA4\xC6" => "\xE5\x8C\x96",
		"\xA4\xC7" => "\xE5\x8C\xB9",
		"\xA4\xC8" => "\xE5\x8D\x88",
		"\xA4\xC9" => "\xE5\x8D\x87",
		"\xA4\xCA" => "\xE5\x8D\x85",
		"\xA4\xCB" => "\xE5\x8D\x9E",
		"\xA4\xCC" => "\xE5\x8E\x84",
		"\xA4\xCD" => "\xE5\x8F\x8B",
		"\xA4\xCE" => "\xE5\x8F\x8A",
		"\xA4\xCF" => "\xE5\x8F\x8D",
		"\xA4\xD0" => "\xE5\xA3\xAC",
		"\xA4\xD1" => "\xE5\xA4\xA9",
		"\xA4\xD2" => "\xE5\xA4\xAB",
		"\xA4\xD3" => "\xE5\xA4\xAA",
		"\xA4\xD4" => "\xE5\xA4\xAD",
		"\xA4\xD5" => "\xE5\xAD\x94",
		"\xA4\xD6" => "\xE5\xB0\x91",
		"\xA4\xD7" => "\xE5\xB0\xA4",
		"\xA4\xD8" => "\xE5\xB0\xBA",
		"\xA4\xD9" => "\xE5\xB1\xAF",
		"\xA4\xDA" => "\xE5\xB7\xB4",
		"\xA4\xDB" => "\xE5\xB9\xBB",
		"\xA4\xDC" => "\xE5\xBB\xBF",
		"\xA4\xDD" => "\xE5\xBC\x94",
		"\xA4\xDE" => "\xE5\xBC\x95",
		"\xA4\xDF" => "\xE5\xBF\x83",
		"\xA4\xE0" => "\xE6\x88\x88",
		"\xA4\xE1" => "\xE6\x88\xB6",
		"\xA4\xE2" => "\xE6\x89\x8B",
		"\xA4\xE3" => "\xE6\x89\x8E",
		"\xA4\xE4" => "\xE6\x94\xAF",
		"\xA4\xE5" => "\xE6\x96\x87",
		"\xA4\xE6" => "\xE6\x96\x97",
		"\xA4\xE7" => "\xE6\x96\xA4",
		"\xA4\xE8" => "\xE6\x96\xB9",
		"\xA4\xE9" => "\xE6\x97\xA5",
		"\xA4\xEA" => "\xE6\x9B\xB0",
		"\xA4\xEB" => "\xE6\x9C\x88",
		"\xA4\xEC" => "\xE6\x9C\xA8",
		"\xA4\xED" => "\xE6\xAC\xA0",
		"\xA4\xEE" => "\xE6\xAD\xA2",
		"\xA4\xEF" => "\xE6\xAD\xB9",
		"\xA4\xF0" => "\xE6\xAF\x8B",
		"\xA4\xF1" => "\xE6\xAF\x94",
		"\xA4\xF2" => "\xE6\xAF\x9B",
		"\xA4\xF3" => "\xE6\xB0\x8F",
		"\xA4\xF4" => "\xE6\xB0\xB4",
		"\xA4\xF5" => "\xE7\x81\xAB",
		"\xA4\xF6" => "\xE7\x88\xAA",
		"\xA4\xF7" => "\xE7\x88\xB6",
		"\xA4\xF8" => "\xE7\x88\xBB",
		"\xA4\xF9" => "\xE7\x89\x87",
		"\xA4\xFA" => "\xE7\x89\x99",
		"\xA4\xFB" => "\xE7\x89\x9B",
		"\xA4\xFC" => "\xE7\x8A\xAC",
		"\xA4\xFD" => "\xE7\x8E\x8B",
		"\xA4\xFE" => "\xE4\xB8\x99",
		"\xA5\x40" => "\xE4\xB8\x96",
		"\xA5\x41" => "\xE4\xB8\x95",
		"\xA5\x42" => "\xE4\xB8\x94",
		"\xA5\x43" => "\xE4\xB8\x98",
		"\xA5\x44" => "\xE4\xB8\xBB",
		"\xA5\x45" => "\xE4\xB9\x8D",
		"\xA5\x46" => "\xE4\xB9\x8F",
		"\xA5\x47" => "\xE4\xB9\x8E",
		"\xA5\x48" => "\xE4\xBB\xA5",
		"\xA5\x49" => "\xE4\xBB\x98",
		"\xA5\x4A" => "\xE4\xBB\x94",
		"\xA5\x4B" => "\xE4\xBB\x95",
		"\xA5\x4C" => "\xE4\xBB\x96",
		"\xA5\x4D" => "\xE4\xBB\x97",
		"\xA5\x4E" => "\xE4\xBB\xA3",
		"\xA5\x4F" => "\xE4\xBB\xA4",
		"\xA5\x50" => "\xE4\xBB\x99",
		"\xA5\x51" => "\xE4\xBB\x9E",
		"\xA5\x52" => "\xE5\x85\x85",
		"\xA5\x53" => "\xE5\x85\x84",
		"\xA5\x54" => "\xE5\x86\x89",
		"\xA5\x55" => "\xE5\x86\x8A",
		"\xA5\x56" => "\xE5\x86\xAC",
		"\xA5\x57" => "\xE5\x87\xB9",
		"\xA5\x58" => "\xE5\x87\xBA",
		"\xA5\x59" => "\xE5\x87\xB8",
		"\xA5\x5A" => "\xE5\x88\x8A",
		"\xA5\x5B" => "\xE5\x8A\xA0",
		"\xA5\x5C" => "\xE5\x8A\x9F",
		"\xA5\x5D" => "\xE5\x8C\x85",
		"\xA5\x5E" => "\xE5\x8C\x86",
		"\xA5\x5F" => "\xE5\x8C\x97",
		"\xA5\x60" => "\xE5\x8C\x9D",
		"\xA5\x61" => "\xE4\xBB\x9F",
		"\xA5\x62" => "\xE5\x8D\x8A",
		"\xA5\x63" => "\xE5\x8D\x89",
		"\xA5\x64" => "\xE5\x8D\xA1",
		"\xA5\x65" => "\xE5\x8D\xA0",
		"\xA5\x66" => "\xE5\x8D\xAF",
		"\xA5\x67" => "\xE5\x8D\xAE",
		"\xA5\x68" => "\xE5\x8E\xBB",
		"\xA5\x69" => "\xE5\x8F\xAF",
		"\xA5\x6A" => "\xE5\x8F\xA4",
		"\xA5\x6B" => "\xE5\x8F\xB3",
		"\xA5\x6C" => "\xE5\x8F\xAC",
		"\xA5\x6D" => "\xE5\x8F\xAE",
		"\xA5\x6E" => "\xE5\x8F\xA9",
		"\xA5\x6F" => "\xE5\x8F\xA8",
		"\xA5\x70" => "\xE5\x8F\xBC",
		"\xA5\x71" => "\xE5\x8F\xB8",
		"\xA5\x72" => "\xE5\x8F\xB5",
		"\xA5\x73" => "\xE5\x8F\xAB",
		"\xA5\x74" => "\xE5\x8F\xA6",
		"\xA5\x75" => "\xE5\x8F\xAA",
		"\xA5\x76" => "\xE5\x8F\xB2",
		"\xA5\x77" => "\xE5\x8F\xB1",
		"\xA5\x78" => "\xE5\x8F\xB0",
		"\xA5\x79" => "\xE5\x8F\xA5",
		"\xA5\x7A" => "\xE5\x8F\xAD",
		"\xA5\x7B" => "\xE5\x8F\xBB",
		"\xA5\x7C" => "\xE5\x9B\x9B",
		"\xA5\x7D" => "\xE5\x9B\x9A",
		"\xA5\x7E" => "\xE5\xA4\x96",
		"\xA5\xA1" => "\xE5\xA4\xAE",
		"\xA5\xA2" => "\xE5\xA4\xB1",
		"\xA5\xA3" => "\xE5\xA5\xB4",
		"\xA5\xA4" => "\xE5\xA5\xB6",
		"\xA5\xA5" => "\xE5\xAD\x95",
		"\xA5\xA6" => "\xE5\xAE\x83",
		"\xA5\xA7" => "\xE5\xB0\xBC",
		"\xA5\xA8" => "\xE5\xB7\xA8",
		"\xA5\xA9" => "\xE5\xB7\xA7",
		"\xA5\xAA" => "\xE5\xB7\xA6",
		"\xA5\xAB" => "\xE5\xB8\x82",
		"\xA5\xAC" => "\xE5\xB8\x83",
		"\xA5\xAD" => "\xE5\xB9\xB3",
		"\xA5\xAE" => "\xE5\xB9\xBC",
		"\xA5\xAF" => "\xE5\xBC\x81",
		"\xA5\xB0" => "\xE5\xBC\x98",
		"\xA5\xB1" => "\xE5\xBC\x97",
		"\xA5\xB2" => "\xE5\xBF\x85",
		"\xA5\xB3" => "\xE6\x88\x8A",
		"\xA5\xB4" => "\xE6\x89\x93",
		"\xA5\xB5" => "\xE6\x89\x94",
		"\xA5\xB6" => "\xE6\x89\x92",
		"\xA5\xB7" => "\xE6\x89\x91",
		"\xA5\xB8" => "\xE6\x96\xA5",
		"\xA5\xB9" => "\xE6\x97\xA6",
		"\xA5\xBA" => "\xE6\x9C\xAE",
		"\xA5\xBB" => "\xE6\x9C\xAC",
		"\xA5\xBC" => "\xE6\x9C\xAA",
		"\xA5\xBD" => "\xE6\x9C\xAB",
		"\xA5\xBE" => "\xE6\x9C\xAD",
		"\xA5\xBF" => "\xE6\xAD\xA3",
		"\xA5\xC0" => "\xE6\xAF\x8D",
		"\xA5\xC1" => "\xE6\xB0\x91",
		"\xA5\xC2" => "\xE6\xB0\x90",
		"\xA5\xC3" => "\xE6\xB0\xB8",
		"\xA5\xC4" => "\xE6\xB1\x81",
		"\xA5\xC5" => "\xE6\xB1\x80",
		"\xA5\xC6" => "\xE6\xB0\xBE",
		"\xA5\xC7" => "\xE7\x8A\xAF",
		"\xA5\xC8" => "\xE7\x8E\x84",
		"\xA5\xC9" => "\xE7\x8E\x89",
		"\xA5\xCA" => "\xE7\x93\x9C",
		"\xA5\xCB" => "\xE7\x93\xA6",
		"\xA5\xCC" => "\xE7\x94\x98",
		"\xA5\xCD" => "\xE7\x94\x9F",
		"\xA5\xCE" => "\xE7\x94\xA8",
		"\xA5\xCF" => "\xE7\x94\xA9",
		"\xA5\xD0" => "\xE7\x94\xB0",
		"\xA5\xD1" => "\xE7\x94\xB1",
		"\xA5\xD2" => "\xE7\x94\xB2",
		"\xA5\xD3" => "\xE7\x94\xB3",
		"\xA5\xD4" => "\xE7\x96\x8B",
		"\xA5\xD5" => "\xE7\x99\xBD",
		"\xA5\xD6" => "\xE7\x9A\xAE",
		"\xA5\xD7" => "\xE7\x9A\xBF",
		"\xA5\xD8" => "\xE7\x9B\xAE",
		"\xA5\xD9" => "\xE7\x9F\x9B",
		"\xA5\xDA" => "\xE7\x9F\xA2",
		"\xA5\xDB" => "\xE7\x9F\xB3",
		"\xA5\xDC" => "\xE7\xA4\xBA",
		"\xA5\xDD" => "\xE7\xA6\xBE",
		"\xA5\xDE" => "\xE7\xA9\xB4",
		"\xA5\xDF" => "\xE7\xAB\x8B",
		"\xA5\xE0" => "\xE4\xB8\x9E",
		"\xA5\xE1" => "\xE4\xB8\x9F",
		"\xA5\xE2" => "\xE4\xB9\x92",
		"\xA5\xE3" => "\xE4\xB9\x93",
		"\xA5\xE4" => "\xE4\xB9\xA9",
		"\xA5\xE5" => "\xE4\xBA\x99",
		"\xA5\xE6" => "\xE4\xBA\xA4",
		"\xA5\xE7" => "\xE4\xBA\xA6",
		"\xA5\xE8" => "\xE4\xBA\xA5",
		"\xA5\xE9" => "\xE4\xBB\xBF",
		"\xA5\xEA" => "\xE4\xBC\x89",
		"\xA5\xEB" => "\xE4\xBC\x99",
		"\xA5\xEC" => "\xE4\xBC\x8A",
		"\xA5\xED" => "\xE4\xBC\x95",
		"\xA5\xEE" => "\xE4\xBC\x8D",
		"\xA5\xEF" => "\xE4\xBC\x90",
		"\xA5\xF0" => "\xE4\xBC\x91",
		"\xA5\xF1" => "\xE4\xBC\x8F",
		"\xA5\xF2" => "\xE4\xBB\xB2",
		"\xA5\xF3" => "\xE4\xBB\xB6",
		"\xA5\xF4" => "\xE4\xBB\xBB",
		"\xA5\xF5" => "\xE4\xBB\xB0",
		"\xA5\xF6" => "\xE4\xBB\xB3",
		"\xA5\xF7" => "\xE4\xBB\xBD",
		"\xA5\xF8" => "\xE4\xBC\x81",
		"\xA5\xF9" => "\xE4\xBC\x8B",
		"\xA5\xFA" => "\xE5\x85\x89",
		"\xA5\xFB" => "\xE5\x85\x87",
		"\xA5\xFC" => "\xE5\x85\x86",
		"\xA5\xFD" => "\xE5\x85\x88",
		"\xA5\xFE" => "\xE5\x85\xA8",
		"\xA6\x40" => "\xE5\x85\xB1",
		"\xA6\x41" => "\xE5\x86\x8D",
		"\xA6\x42" => "\xE5\x86\xB0",
		"\xA6\x43" => "\xE5\x88\x97",
		"\xA6\x44" => "\xE5\x88\x91",
		"\xA6\x45" => "\xE5\x88\x92",
		"\xA6\x46" => "\xE5\x88\x8E",
		"\xA6\x47" => "\xE5\x88\x96",
		"\xA6\x48" => "\xE5\x8A\xA3",
		"\xA6\x49" => "\xE5\x8C\x88",
		"\xA6\x4A" => "\xE5\x8C\xA1",
		"\xA6\x4B" => "\xE5\x8C\xA0",
		"\xA6\x4C" => "\xE5\x8D\xB0",
		"\xA6\x4D" => "\xE5\x8D\xB1",
		"\xA6\x4E" => "\xE5\x90\x89",
		"\xA6\x4F" => "\xE5\x90\x8F",
		"\xA6\x50" => "\xE5\x90\x8C",
		"\xA6\x51" => "\xE5\x90\x8A",
		"\xA6\x52" => "\xE5\x90\x90",
		"\xA6\x53" => "\xE5\x90\x81",
		"\xA6\x54" => "\xE5\x90\x8B",
		"\xA6\x55" => "\xE5\x90\x84",
		"\xA6\x56" => "\xE5\x90\x91",
		"\xA6\x57" => "\xE5\x90\x8D",
		"\xA6\x58" => "\xE5\x90\x88",
		"\xA6\x59" => "\xE5\x90\x83",
		"\xA6\x5A" => "\xE5\x90\x8E",
		"\xA6\x5B" => "\xE5\x90\x86",
		"\xA6\x5C" => "\xE5\x90\x92",
		"\xA6\x5D" => "\xE5\x9B\xA0",
		"\xA6\x5E" => "\xE5\x9B\x9E",
		"\xA6\x5F" => "\xE5\x9B\x9D",
		"\xA6\x60" => "\xE5\x9C\xB3",
		"\xA6\x61" => "\xE5\x9C\xB0",
		"\xA6\x62" => "\xE5\x9C\xA8",
		"\xA6\x63" => "\xE5\x9C\xAD",
		"\xA6\x64" => "\xE5\x9C\xAC",
		"\xA6\x65" => "\xE5\x9C\xAF",
		"\xA6\x66" => "\xE5\x9C\xA9",
		"\xA6\x67" => "\xE5\xA4\x99",
		"\xA6\x68" => "\xE5\xA4\x9A",
		"\xA6\x69" => "\xE5\xA4\xB7",
		"\xA6\x6A" => "\xE5\xA4\xB8",
		"\xA6\x6B" => "\xE5\xA6\x84",
		"\xA6\x6C" => "\xE5\xA5\xB8",
		"\xA6\x6D" => "\xE5\xA6\x83",
		"\xA6\x6E" => "\xE5\xA5\xBD",
		"\xA6\x6F" => "\xE5\xA5\xB9",
		"\xA6\x70" => "\xE5\xA6\x82",
		"\xA6\x71" => "\xE5\xA6\x81",
		"\xA6\x72" => "\xE5\xAD\x97",
		"\xA6\x73" => "\xE5\xAD\x98",
		"\xA6\x74" => "\xE5\xAE\x87",
		"\xA6\x75" => "\xE5\xAE\x88",
		"\xA6\x76" => "\xE5\xAE\x85",
		"\xA6\x77" => "\xE5\xAE\x89",
		"\xA6\x78" => "\xE5\xAF\xBA",
		"\xA6\x79" => "\xE5\xB0\x96",
		"\xA6\x7A" => "\xE5\xB1\xB9",
		"\xA6\x7B" => "\xE5\xB7\x9E",
		"\xA6\x7C" => "\xE5\xB8\x86",
		"\xA6\x7D" => "\xE5\xB9\xB6",
		"\xA6\x7E" => "\xE5\xB9\xB4",
		"\xA6\xA1" => "\xE5\xBC\x8F",
		"\xA6\xA2" => "\xE5\xBC\x9B",
		"\xA6\xA3" => "\xE5\xBF\x99",
		"\xA6\xA4" => "\xE5\xBF\x96",
		"\xA6\xA5" => "\xE6\x88\x8E",
		"\xA6\xA6" => "\xE6\x88\x8C",
		"\xA6\xA7" => "\xE6\x88\x8D",
		"\xA6\xA8" => "\xE6\x88\x90",
		"\xA6\xA9" => "\xE6\x89\xA3",
		"\xA6\xAA" => "\xE6\x89\x9B",
		"\xA6\xAB" => "\xE6\x89\x98",
		"\xA6\xAC" => "\xE6\x94\xB6",
		"\xA6\xAD" => "\xE6\x97\xA9",
		"\xA6\xAE" => "\xE6\x97\xA8",
		"\xA6\xAF" => "\xE6\x97\xAC",
		"\xA6\xB0" => "\xE6\x97\xAD",
		"\xA6\xB1" => "\xE6\x9B\xB2",
		"\xA6\xB2" => "\xE6\x9B\xB3",
		"\xA6\xB3" => "\xE6\x9C\x89",
		"\xA6\xB4" => "\xE6\x9C\xBD",
		"\xA6\xB5" => "\xE6\x9C\xB4",
		"\xA6\xB6" => "\xE6\x9C\xB1",
		"\xA6\xB7" => "\xE6\x9C\xB5",
		"\xA6\xB8" => "\xE6\xAC\xA1",
		"\xA6\xB9" => "\xE6\xAD\xA4",
		"\xA6\xBA" => "\xE6\xAD\xBB",
		"\xA6\xBB" => "\xE6\xB0\x96",
		"\xA6\xBC" => "\xE6\xB1\x9D",
		"\xA6\xBD" => "\xE6\xB1\x97",
		"\xA6\xBE" => "\xE6\xB1\x99",
		"\xA6\xBF" => "\xE6\xB1\x9F",
		"\xA6\xC0" => "\xE6\xB1\xA0",
		"\xA6\xC1" => "\xE6\xB1\x90",
		"\xA6\xC2" => "\xE6\xB1\x95",
		"\xA6\xC3" => "\xE6\xB1\xA1",
		"\xA6\xC4" => "\xE6\xB1\x9B",
		"\xA6\xC5" => "\xE6\xB1\x8D",
		"\xA6\xC6" => "\xE6\xB1\x8E",
		"\xA6\xC7" => "\xE7\x81\xB0",
		"\xA6\xC8" => "\xE7\x89\x9F",
		"\xA6\xC9" => "\xE7\x89\x9D",
		"\xA6\xCA" => "\xE7\x99\xBE",
		"\xA6\xCB" => "\xE7\xAB\xB9",
		"\xA6\xCC" => "\xE7\xB1\xB3",
		"\xA6\xCD" => "\xE7\xB3\xB8",
		"\xA6\xCE" => "\xE7\xBC\xB6",
		"\xA6\xCF" => "\xE7\xBE\x8A",
		"\xA6\xD0" => "\xE7\xBE\xBD",
		"\xA6\xD1" => "\xE8\x80\x81",
		"\xA6\xD2" => "\xE8\x80\x83",
		"\xA6\xD3" => "\xE8\x80\x8C",
		"\xA6\xD4" => "\xE8\x80\x92",
		"\xA6\xD5" => "\xE8\x80\xB3",
		"\xA6\xD6" => "\xE8\x81\xBF",
		"\xA6\xD7" => "\xE8\x82\x89",
		"\xA6\xD8" => "\xE8\x82\x8B",
		"\xA6\xD9" => "\xE8\x82\x8C",
		"\xA6\xDA" => "\xE8\x87\xA3",
		"\xA6\xDB" => "\xE8\x87\xAA",
		"\xA6\xDC" => "\xE8\x87\xB3",
		"\xA6\xDD" => "\xE8\x87\xBC",
		"\xA6\xDE" => "\xE8\x88\x8C",
		"\xA6\xDF" => "\xE8\x88\x9B",
		"\xA6\xE0" => "\xE8\x88\x9F",
		"\xA6\xE1" => "\xE8\x89\xAE",
		"\xA6\xE2" => "\xE8\x89\xB2",
		"\xA6\xE3" => "\xE8\x89\xBE",
		"\xA6\xE4" => "\xE8\x99\xAB",
		"\xA6\xE5" => "\xE8\xA1\x80",
		"\xA6\xE6" => "\xE8\xA1\x8C",
		"\xA6\xE7" => "\xE8\xA1\xA3",
		"\xA6\xE8" => "\xE8\xA5\xBF",
		"\xA6\xE9" => "\xE9\x98\xA1",
		"\xA6\xEA" => "\xE4\xB8\xB2",
		"\xA6\xEB" => "\xE4\xBA\xA8",
		"\xA6\xEC" => "\xE4\xBD\x8D",
		"\xA6\xED" => "\xE4\xBD\x8F",
		"\xA6\xEE" => "\xE4\xBD\x87",
		"\xA6\xEF" => "\xE4\xBD\x97",
		"\xA6\xF0" => "\xE4\xBD\x9E",
		"\xA6\xF1" => "\xE4\xBC\xB4",
		"\xA6\xF2" => "\xE4\xBD\x9B",
		"\xA6\xF3" => "\xE4\xBD\x95",
		"\xA6\xF4" => "\xE4\xBC\xB0",
		"\xA6\xF5" => "\xE4\xBD\x90",
		"\xA6\xF6" => "\xE4\xBD\x91",
		"\xA6\xF7" => "\xE4\xBC\xBD",
		"\xA6\xF8" => "\xE4\xBC\xBA",
		"\xA6\xF9" => "\xE4\xBC\xB8",
		"\xA6\xFA" => "\xE4\xBD\x83",
		"\xA6\xFB" => "\xE4\xBD\x94",
		"\xA6\xFC" => "\xE4\xBC\xBC",
		"\xA6\xFD" => "\xE4\xBD\x86",
		"\xA6\xFE" => "\xE4\xBD\xA3",
		"\xA7\x40" => "\xE4\xBD\x9C",
		"\xA7\x41" => "\xE4\xBD\xA0",
		"\xA7\x42" => "\xE4\xBC\xAF",
		"\xA7\x43" => "\xE4\xBD\x8E",
		"\xA7\x44" => "\xE4\xBC\xB6",
		"\xA7\x45" => "\xE4\xBD\x99",
		"\xA7\x46" => "\xE4\xBD\x9D",
		"\xA7\x47" => "\xE4\xBD\x88",
		"\xA7\x48" => "\xE4\xBD\x9A",
		"\xA7\x49" => "\xE5\x85\x8C",
		"\xA7\x4A" => "\xE5\x85\x8B",
		"\xA7\x4B" => "\xE5\x85\x8D",
		"\xA7\x4C" => "\xE5\x85\xB5",
		"\xA7\x4D" => "\xE5\x86\xB6",
		"\xA7\x4E" => "\xE5\x86\xB7",
		"\xA7\x4F" => "\xE5\x88\xA5",
		"\xA7\x50" => "\xE5\x88\xA4",
		"\xA7\x51" => "\xE5\x88\xA9",
		"\xA7\x52" => "\xE5\x88\xAA",
		"\xA7\x53" => "\xE5\x88\xA8",
		"\xA7\x54" => "\xE5\x8A\xAB",
		"\xA7\x55" => "\xE5\x8A\xA9",
		"\xA7\x56" => "\xE5\x8A\xAA",
		"\xA7\x57" => "\xE5\x8A\xAC",
		"\xA7\x58" => "\xE5\x8C\xA3",
		"\xA7\x59" => "\xE5\x8D\xB3",
		"\xA7\x5A" => "\xE5\x8D\xB5",
		"\xA7\x5B" => "\xE5\x90\x9D",
		"\xA7\x5C" => "\xE5\x90\xAD",
		"\xA7\x5D" => "\xE5\x90\x9E",
		"\xA7\x5E" => "\xE5\x90\xBE",
		"\xA7\x5F" => "\xE5\x90\xA6",
		"\xA7\x60" => "\xE5\x91\x8E",
		"\xA7\x61" => "\xE5\x90\xA7",
		"\xA7\x62" => "\xE5\x91\x86",
		"\xA7\x63" => "\xE5\x91\x83",
		"\xA7\x64" => "\xE5\x90\xB3",
		"\xA7\x65" => "\xE5\x91\x88",
		"\xA7\x66" => "\xE5\x91\x82",
		"\xA7\x67" => "\xE5\x90\x9B",
		"\xA7\x68" => "\xE5\x90\xA9",
		"\xA7\x69" => "\xE5\x91\x8A",
		"\xA7\x6A" => "\xE5\x90\xB9",
		"\xA7\x6B" => "\xE5\x90\xBB",
		"\xA7\x6C" => "\xE5\x90\xB8",
		"\xA7\x6D" => "\xE5\x90\xAE",
		"\xA7\x6E" => "\xE5\x90\xB5",
		"\xA7\x6F" => "\xE5\x90\xB6",
		"\xA7\x70" => "\xE5\x90\xA0",
		"\xA7\x71" => "\xE5\x90\xBC",
		"\xA7\x72" => "\xE5\x91\x80",
		"\xA7\x73" => "\xE5\x90\xB1",
		"\xA7\x74" => "\xE5\x90\xAB",
		"\xA7\x75" => "\xE5\x90\x9F",
		"\xA7\x76" => "\xE5\x90\xAC",
		"\xA7\x77" => "\xE5\x9B\xAA",
		"\xA7\x78" => "\xE5\x9B\xB0",
		"\xA7\x79" => "\xE5\x9B\xA4",
		"\xA7\x7A" => "\xE5\x9B\xAB",
		"\xA7\x7B" => "\xE5\x9D\x8A",
		"\xA7\x7C" => "\xE5\x9D\x91",
		"\xA7\x7D" => "\xE5\x9D\x80",
		"\xA7\x7E" => "\xE5\x9D\x8D",
		"\xA7\xA1" => "\xE5\x9D\x87",
		"\xA7\xA2" => "\xE5\x9D\x8E",
		"\xA7\xA3" => "\xE5\x9C\xBE",
		"\xA7\xA4" => "\xE5\x9D\x90",
		"\xA7\xA5" => "\xE5\x9D\x8F",
		"\xA7\xA6" => "\xE5\x9C\xBB",
		"\xA7\xA7" => "\xE5\xA3\xAF",
		"\xA7\xA8" => "\xE5\xA4\xBE",
		"\xA7\xA9" => "\xE5\xA6\x9D",
		"\xA7\xAA" => "\xE5\xA6\x92",
		"\xA7\xAB" => "\xE5\xA6\xA8",
		"\xA7\xAC" => "\xE5\xA6\x9E",
		"\xA7\xAD" => "\xE5\xA6\xA3",
		"\xA7\xAE" => "\xE5\xA6\x99",
		"\xA7\xAF" => "\xE5\xA6\x96",
		"\xA7\xB0" => "\xE5\xA6\x8D",
		"\xA7\xB1" => "\xE5\xA6\xA4",
		"\xA7\xB2" => "\xE5\xA6\x93",
		"\xA7\xB3" => "\xE5\xA6\x8A",
		"\xA7\xB4" => "\xE5\xA6\xA5",
		"\xA7\xB5" => "\xE5\xAD\x9D",
		"\xA7\xB6" => "\xE5\xAD\x9C",
		"\xA7\xB7" => "\xE5\xAD\x9A",
		"\xA7\xB8" => "\xE5\xAD\x9B",
		"\xA7\xB9" => "\xE5\xAE\x8C",
		"\xA7\xBA" => "\xE5\xAE\x8B",
		"\xA7\xBB" => "\xE5\xAE\x8F",
		"\xA7\xBC" => "\xE5\xB0\xAC",
		"\xA7\xBD" => "\xE5\xB1\x80",
		"\xA7\xBE" => "\xE5\xB1\x81",
		"\xA7\xBF" => "\xE5\xB0\xBF",
		"\xA7\xC0" => "\xE5\xB0\xBE",
		"\xA7\xC1" => "\xE5\xB2\x90",
		"\xA7\xC2" => "\xE5\xB2\x91",
		"\xA7\xC3" => "\xE5\xB2\x94",
		"\xA7\xC4" => "\xE5\xB2\x8C",
		"\xA7\xC5" => "\xE5\xB7\xAB",
		"\xA7\xC6" => "\xE5\xB8\x8C",
		"\xA7\xC7" => "\xE5\xBA\x8F",
		"\xA7\xC8" => "\xE5\xBA\x87",
		"\xA7\xC9" => "\xE5\xBA\x8A",
		"\xA7\xCA" => "\xE5\xBB\xB7",
		"\xA7\xCB" => "\xE5\xBC\x84",
		"\xA7\xCC" => "\xE5\xBC\x9F",
		"\xA7\xCD" => "\xE5\xBD\xA4",
		"\xA7\xCE" => "\xE5\xBD\xA2",
		"\xA7\xCF" => "\xE5\xBD\xB7",
		"\xA7\xD0" => "\xE5\xBD\xB9",
		"\xA7\xD1" => "\xE5\xBF\x98",
		"\xA7\xD2" => "\xE5\xBF\x8C",
		"\xA7\xD3" => "\xE5\xBF\x97",
		"\xA7\xD4" => "\xE5\xBF\x8D",
		"\xA7\xD5" => "\xE5\xBF\xB1",
		"\xA7\xD6" => "\xE5\xBF\xAB",
		"\xA7\xD7" => "\xE5\xBF\xB8",
		"\xA7\xD8" => "\xE5\xBF\xAA",
		"\xA7\xD9" => "\xE6\x88\x92",
		"\xA7\xDA" => "\xE6\x88\x91",
		"\xA7\xDB" => "\xE6\x8A\x84",
		"\xA7\xDC" => "\xE6\x8A\x97",
		"\xA7\xDD" => "\xE6\x8A\x96",
		"\xA7\xDE" => "\xE6\x8A\x80",
		"\xA7\xDF" => "\xE6\x89\xB6",
		"\xA7\xE0" => "\xE6\x8A\x89",
		"\xA7\xE1" => "\xE6\x89\xAD",
		"\xA7\xE2" => "\xE6\x8A\x8A",
		"\xA7\xE3" => "\xE6\x89\xBC",
		"\xA7\xE4" => "\xE6\x89\xBE",
		"\xA7\xE5" => "\xE6\x89\xB9",
		"\xA7\xE6" => "\xE6\x89\xB3",
		"\xA7\xE7" => "\xE6\x8A\x92",
		"\xA7\xE8" => "\xE6\x89\xAF",
		"\xA7\xE9" => "\xE6\x8A\x98",
		"\xA7\xEA" => "\xE6\x89\xAE",
		"\xA7\xEB" => "\xE6\x8A\x95",
		"\xA7\xEC" => "\xE6\x8A\x93",
		"\xA7\xED" => "\xE6\x8A\x91",
		"\xA7\xEE" => "\xE6\x8A\x86",
		"\xA7\xEF" => "\xE6\x94\xB9",
		"\xA7\xF0" => "\xE6\x94\xBB",
		"\xA7\xF1" => "\xE6\x94\xB8",
		"\xA7\xF2" => "\xE6\x97\xB1",
		"\xA7\xF3" => "\xE6\x9B\xB4",
		"\xA7\xF4" => "\xE6\x9D\x9F",
		"\xA7\xF5" => "\xE6\x9D\x8E",
		"\xA7\xF6" => "\xE6\x9D\x8F",
		"\xA7\xF7" => "\xE6\x9D\x90",
		"\xA7\xF8" => "\xE6\x9D\x91",
		"\xA7\xF9" => "\xE6\x9D\x9C",
		"\xA7\xFA" => "\xE6\x9D\x96",
		"\xA7\xFB" => "\xE6\x9D\x9E",
		"\xA7\xFC" => "\xE6\x9D\x89",
		"\xA7\xFD" => "\xE6\x9D\x86",
		"\xA7\xFE" => "\xE6\x9D\xA0",
		"\xA8\x40" => "\xE6\x9D\x93",
		"\xA8\x41" => "\xE6\x9D\x97",
		"\xA8\x42" => "\xE6\xAD\xA5",
		"\xA8\x43" => "\xE6\xAF\x8F",
		"\xA8\x44" => "\xE6\xB1\x82",
		"\xA8\x45" => "\xE6\xB1\x9E",
		"\xA8\x46" => "\xE6\xB2\x99",
		"\xA8\x47" => "\xE6\xB2\x81",
		"\xA8\x48" => "\xE6\xB2\x88",
		"\xA8\x49" => "\xE6\xB2\x89",
		"\xA8\x4A" => "\xE6\xB2\x85",
		"\xA8\x4B" => "\xE6\xB2\x9B",
		"\xA8\x4C" => "\xE6\xB1\xAA",
		"\xA8\x4D" => "\xE6\xB1\xBA",
		"\xA8\x4E" => "\xE6\xB2\x90",
		"\xA8\x4F" => "\xE6\xB1\xB0",
		"\xA8\x50" => "\xE6\xB2\x8C",
		"\xA8\x51" => "\xE6\xB1\xA8",
		"\xA8\x52" => "\xE6\xB2\x96",
		"\xA8\x53" => "\xE6\xB2\x92",
		"\xA8\x54" => "\xE6\xB1\xBD",
		"\xA8\x55" => "\xE6\xB2\x83",
		"\xA8\x56" => "\xE6\xB1\xB2",
		"\xA8\x57" => "\xE6\xB1\xBE",
		"\xA8\x58" => "\xE6\xB1\xB4",
		"\xA8\x59" => "\xE6\xB2\x86",
		"\xA8\x5A" => "\xE6\xB1\xB6",
		"\xA8\x5B" => "\xE6\xB2\x8D",
		"\xA8\x5C" => "\xE6\xB2\x94",
		"\xA8\x5D" => "\xE6\xB2\x98",
		"\xA8\x5E" => "\xE6\xB2\x82",
		"\xA8\x5F" => "\xE7\x81\xB6",
		"\xA8\x60" => "\xE7\x81\xBC",
		"\xA8\x61" => "\xE7\x81\xBD",
		"\xA8\x62" => "\xE7\x81\xB8",
		"\xA8\x63" => "\xE7\x89\xA2",
		"\xA8\x64" => "\xE7\x89\xA1",
		"\xA8\x65" => "\xE7\x89\xA0",
		"\xA8\x66" => "\xE7\x8B\x84",
		"\xA8\x67" => "\xE7\x8B\x82",
		"\xA8\x68" => "\xE7\x8E\x96",
		"\xA8\x69" => "\xE7\x94\xAC",
		"\xA8\x6A" => "\xE7\x94\xAB",
		"\xA8\x6B" => "\xE7\x94\xB7",
		"\xA8\x6C" => "\xE7\x94\xB8",
		"\xA8\x6D" => "\xE7\x9A\x82",
		"\xA8\x6E" => "\xE7\x9B\xAF",
		"\xA8\x6F" => "\xE7\x9F\xA3",
		"\xA8\x70" => "\xE7\xA7\x81",
		"\xA8\x71" => "\xE7\xA7\x80",
		"\xA8\x72" => "\xE7\xA6\xBF",
		"\xA8\x73" => "\xE7\xA9\xB6",
		"\xA8\x74" => "\xE7\xB3\xBB",
		"\xA8\x75" => "\xE7\xBD\x95",
		"\xA8\x76" => "\xE8\x82\x96",
		"\xA8\x77" => "\xE8\x82\x93",
		"\xA8\x78" => "\xE8\x82\x9D",
		"\xA8\x79" => "\xE8\x82\x98",
		"\xA8\x7A" => "\xE8\x82\x9B",
		"\xA8\x7B" => "\xE8\x82\x9A",
		"\xA8\x7C" => "\xE8\x82\xB2",
		"\xA8\x7D" => "\xE8\x89\xAF",
		"\xA8\x7E" => "\xE8\x8A\x92",
		"\xA8\xA1" => "\xE8\x8A\x8B",
		"\xA8\xA2" => "\xE8\x8A\x8D",
		"\xA8\xA3" => "\xE8\xA6\x8B",
		"\xA8\xA4" => "\xE8\xA7\x92",
		"\xA8\xA5" => "\xE8\xA8\x80",
		"\xA8\xA6" => "\xE8\xB0\xB7",
		"\xA8\xA7" => "\xE8\xB1\x86",
		"\xA8\xA8" => "\xE8\xB1\x95",
		"\xA8\xA9" => "\xE8\xB2\x9D",
		"\xA8\xAA" => "\xE8\xB5\xA4",
		"\xA8\xAB" => "\xE8\xB5\xB0",
		"\xA8\xAC" => "\xE8\xB6\xB3",
		"\xA8\xAD" => "\xE8\xBA\xAB",
		"\xA8\xAE" => "\xE8\xBB\x8A",
		"\xA8\xAF" => "\xE8\xBE\x9B",
		"\xA8\xB0" => "\xE8\xBE\xB0",
		"\xA8\xB1" => "\xE8\xBF\x82",
		"\xA8\xB2" => "\xE8\xBF\x86",
		"\xA8\xB3" => "\xE8\xBF\x85",
		"\xA8\xB4" => "\xE8\xBF\x84",
		"\xA8\xB5" => "\xE5\xB7\xA1",
		"\xA8\xB6" => "\xE9\x82\x91",
		"\xA8\xB7" => "\xE9\x82\xA2",
		"\xA8\xB8" => "\xE9\x82\xAA",
		"\xA8\xB9" => "\xE9\x82\xA6",
		"\xA8\xBA" => "\xE9\x82\xA3",
		"\xA8\xBB" => "\xE9\x85\x89",
		"\xA8\xBC" => "\xE9\x87\x86",
		"\xA8\xBD" => "\xE9\x87\x8C",
		"\xA8\xBE" => "\xE9\x98\xB2",
		"\xA8\xBF" => "\xE9\x98\xAE",
		"\xA8\xC0" => "\xE9\x98\xB1",
		"\xA8\xC1" => "\xE9\x98\xAA",
		"\xA8\xC2" => "\xE9\x98\xAC",
		"\xA8\xC3" => "\xE4\xB8\xA6",
		"\xA8\xC4" => "\xE4\xB9\x96",
		"\xA8\xC5" => "\xE4\xB9\xB3",
		"\xA8\xC6" => "\xE4\xBA\x8B",
		"\xA8\xC7" => "\xE4\xBA\x9B",
		"\xA8\xC8" => "\xE4\xBA\x9E",
		"\xA8\xC9" => "\xE4\xBA\xAB",
		"\xA8\xCA" => "\xE4\xBA\xAC",
		"\xA8\xCB" => "\xE4\xBD\xAF",
		"\xA8\xCC" => "\xE4\xBE\x9D",
		"\xA8\xCD" => "\xE4\xBE\x8D",
		"\xA8\xCE" => "\xE4\xBD\xB3",
		"\xA8\xCF" => "\xE4\xBD\xBF",
		"\xA8\xD0" => "\xE4\xBD\xAC",
		"\xA8\xD1" => "\xE4\xBE\x9B",
		"\xA8\xD2" => "\xE4\xBE\x8B",
		"\xA8\xD3" => "\xE4\xBE\x86",
		"\xA8\xD4" => "\xE4\xBE\x83",
		"\xA8\xD5" => "\xE4\xBD\xB0",
		"\xA8\xD6" => "\xE4\xBD\xB5",
		"\xA8\xD7" => "\xE4\xBE\x88",
		"\xA8\xD8" => "\xE4\xBD\xA9",
		"\xA8\xD9" => "\xE4\xBD\xBB",
		"\xA8\xDA" => "\xE4\xBE\x96",
		"\xA8\xDB" => "\xE4\xBD\xBE",
		"\xA8\xDC" => "\xE4\xBE\x8F",
		"\xA8\xDD" => "\xE4\xBE\x91",
		"\xA8\xDE" => "\xE4\xBD\xBA",
		"\xA8\xDF" => "\xE5\x85\x94",
		"\xA8\xE0" => "\xE5\x85\x92",
		"\xA8\xE1" => "\xE5\x85\x95",
		"\xA8\xE2" => "\xE5\x85\xA9",
		"\xA8\xE3" => "\xE5\x85\xB7",
		"\xA8\xE4" => "\xE5\x85\xB6",
		"\xA8\xE5" => "\xE5\x85\xB8",
		"\xA8\xE6" => "\xE5\x86\xBD",
		"\xA8\xE7" => "\xE5\x87\xBD",
		"\xA8\xE8" => "\xE5\x88\xBB",
		"\xA8\xE9" => "\xE5\x88\xB8",
		"\xA8\xEA" => "\xE5\x88\xB7",
		"\xA8\xEB" => "\xE5\x88\xBA",
		"\xA8\xEC" => "\xE5\x88\xB0",
		"\xA8\xED" => "\xE5\x88\xAE",
		"\xA8\xEE" => "\xE5\x88\xB6",
		"\xA8\xEF" => "\xE5\x89\x81",
		"\xA8\xF0" => "\xE5\x8A\xBE",
		"\xA8\xF1" => "\xE5\x8A\xBB",
		"\xA8\xF2" => "\xE5\x8D\x92",
		"\xA8\xF3" => "\xE5\x8D\x94",
		"\xA8\xF4" => "\xE5\x8D\x93",
		"\xA8\xF5" => "\xE5\x8D\x91",
		"\xA8\xF6" => "\xE5\x8D\xA6",
		"\xA8\xF7" => "\xE5\x8D\xB7",
		"\xA8\xF8" => "\xE5\x8D\xB8",
		"\xA8\xF9" => "\xE5\x8D\xB9",
		"\xA8\xFA" => "\xE5\x8F\x96",
		"\xA8\xFB" => "\xE5\x8F\x94",
		"\xA8\xFC" => "\xE5\x8F\x97",
		"\xA8\xFD" => "\xE5\x91\xB3",
		"\xA8\xFE" => "\xE5\x91\xB5",
		"\xA9\x40" => "\xE5\x92\x96",
		"\xA9\x41" => "\xE5\x91\xB8",
		"\xA9\x42" => "\xE5\x92\x95",
		"\xA9\x43" => "\xE5\x92\x80",
		"\xA9\x44" => "\xE5\x91\xBB",
		"\xA9\x45" => "\xE5\x91\xB7",
		"\xA9\x46" => "\xE5\x92\x84",
		"\xA9\x47" => "\xE5\x92\x92",
		"\xA9\x48" => "\xE5\x92\x86",
		"\xA9\x49" => "\xE5\x91\xBC",
		"\xA9\x4A" => "\xE5\x92\x90",
		"\xA9\x4B" => "\xE5\x91\xB1",
		"\xA9\x4C" => "\xE5\x91\xB6",
		"\xA9\x4D" => "\xE5\x92\x8C",
		"\xA9\x4E" => "\xE5\x92\x9A",
		"\xA9\x4F" => "\xE5\x91\xA2",
		"\xA9\x50" => "\xE5\x91\xA8",
		"\xA9\x51" => "\xE5\x92\x8B",
		"\xA9\x52" => "\xE5\x91\xBD",
		"\xA9\x53" => "\xE5\x92\x8E",
		"\xA9\x54" => "\xE5\x9B\xBA",
		"\xA9\x55" => "\xE5\x9E\x83",
		"\xA9\x56" => "\xE5\x9D\xB7",
		"\xA9\x57" => "\xE5\x9D\xAA",
		"\xA9\x58" => "\xE5\x9D\xA9",
		"\xA9\x59" => "\xE5\x9D\xA1",
		"\xA9\x5A" => "\xE5\x9D\xA6",
		"\xA9\x5B" => "\xE5\x9D\xA4",
		"\xA9\x5C" => "\xE5\x9D\xBC",
		"\xA9\x5D" => "\xE5\xA4\x9C",
		"\xA9\x5E" => "\xE5\xA5\x89",
		"\xA9\x5F" => "\xE5\xA5\x87",
		"\xA9\x60" => "\xE5\xA5\x88",
		"\xA9\x61" => "\xE5\xA5\x84",
		"\xA9\x62" => "\xE5\xA5\x94",
		"\xA9\x63" => "\xE5\xA6\xBE",
		"\xA9\x64" => "\xE5\xA6\xBB",
		"\xA9\x65" => "\xE5\xA7\x94",
		"\xA9\x66" => "\xE5\xA6\xB9",
		"\xA9\x67" => "\xE5\xA6\xAE",
		"\xA9\x68" => "\xE5\xA7\x91",
		"\xA9\x69" => "\xE5\xA7\x86",
		"\xA9\x6A" => "\xE5\xA7\x90",
		"\xA9\x6B" => "\xE5\xA7\x8D",
		"\xA9\x6C" => "\xE5\xA7\x8B",
		"\xA9\x6D" => "\xE5\xA7\x93",
		"\xA9\x6E" => "\xE5\xA7\x8A",
		"\xA9\x6F" => "\xE5\xA6\xAF",
		"\xA9\x70" => "\xE5\xA6\xB3",
		"\xA9\x71" => "\xE5\xA7\x92",
		"\xA9\x72" => "\xE5\xA7\x85",
		"\xA9\x73" => "\xE5\xAD\x9F",
		"\xA9\x74" => "\xE5\xAD\xA4",
		"\xA9\x75" => "\xE5\xAD\xA3",
		"\xA9\x76" => "\xE5\xAE\x97",
		"\xA9\x77" => "\xE5\xAE\x9A",
		"\xA9\x78" => "\xE5\xAE\x98",
		"\xA9\x79" => "\xE5\xAE\x9C",
		"\xA9\x7A" => "\xE5\xAE\x99",
		"\xA9\x7B" => "\xE5\xAE\x9B",
		"\xA9\x7C" => "\xE5\xB0\x9A",
		"\xA9\x7D" => "\xE5\xB1\x88",
		"\xA9\x7E" => "\xE5\xB1\x85",
		"\xA9\xA1" => "\xE5\xB1\x86",
		"\xA9\xA2" => "\xE5\xB2\xB7",
		"\xA9\xA3" => "\xE5\xB2\xA1",
		"\xA9\xA4" => "\xE5\xB2\xB8",
		"\xA9\xA5" => "\xE5\xB2\xA9",
		"\xA9\xA6" => "\xE5\xB2\xAB",
		"\xA9\xA7" => "\xE5\xB2\xB1",
		"\xA9\xA8" => "\xE5\xB2\xB3",
		"\xA9\xA9" => "\xE5\xB8\x98",
		"\xA9\xAA" => "\xE5\xB8\x9A",
		"\xA9\xAB" => "\xE5\xB8\x96",
		"\xA9\xAC" => "\xE5\xB8\x95",
		"\xA9\xAD" => "\xE5\xB8\x9B",
		"\xA9\xAE" => "\xE5\xB8\x91",
		"\xA9\xAF" => "\xE5\xB9\xB8",
		"\xA9\xB0" => "\xE5\xBA\x9A",
		"\xA9\xB1" => "\xE5\xBA\x97",
		"\xA9\xB2" => "\xE5\xBA\x9C",
		"\xA9\xB3" => "\xE5\xBA\x95",
		"\xA9\xB4" => "\xE5\xBA\x96",
		"\xA9\xB5" => "\xE5\xBB\xB6",
		"\xA9\xB6" => "\xE5\xBC\xA6",
		"\xA9\xB7" => "\xE5\xBC\xA7",
		"\xA9\xB8" => "\xE5\xBC\xA9",
		"\xA9\xB9" => "\xE5\xBE\x80",
		"\xA9\xBA" => "\xE5\xBE\x81",
		"\xA9\xBB" => "\xE5\xBD\xBF",
		"\xA9\xBC" => "\xE5\xBD\xBC",
		"\xA9\xBD" => "\xE5\xBF\x9D",
		"\xA9\xBE" => "\xE5\xBF\xA0",
		"\xA9\xBF" => "\xE5\xBF\xBD",
		"\xA9\xC0" => "\xE5\xBF\xB5",
		"\xA9\xC1" => "\xE5\xBF\xBF",
		"\xA9\xC2" => "\xE6\x80\x8F",
		"\xA9\xC3" => "\xE6\x80\x94",
		"\xA9\xC4" => "\xE6\x80\xAF",
		"\xA9\xC5" => "\xE6\x80\xB5",
		"\xA9\xC6" => "\xE6\x80\x96",
		"\xA9\xC7" => "\xE6\x80\xAA",
		"\xA9\xC8" => "\xE6\x80\x95",
		"\xA9\xC9" => "\xE6\x80\xA1",
		"\xA9\xCA" => "\xE6\x80\xA7",
		"\xA9\xCB" => "\xE6\x80\xA9",
		"\xA9\xCC" => "\xE6\x80\xAB",
		"\xA9\xCD" => "\xE6\x80\x9B",
		"\xA9\xCE" => "\xE6\x88\x96",
		"\xA9\xCF" => "\xE6\x88\x95",
		"\xA9\xD0" => "\xE6\x88\xBF",
		"\xA9\xD1" => "\xE6\x88\xBE",
		"\xA9\xD2" => "\xE6\x89\x80",
		"\xA9\xD3" => "\xE6\x89\xBF",
		"\xA9\xD4" => "\xE6\x8B\x89",
		"\xA9\xD5" => "\xE6\x8B\x8C",
		"\xA9\xD6" => "\xE6\x8B\x84",
		"\xA9\xD7" => "\xE6\x8A\xBF",
		"\xA9\xD8" => "\xE6\x8B\x82",
		"\xA9\xD9" => "\xE6\x8A\xB9",
		"\xA9\xDA" => "\xE6\x8B\x92",
		"\xA9\xDB" => "\xE6\x8B\x9B",
		"\xA9\xDC" => "\xE6\x8A\xAB",
		"\xA9\xDD" => "\xE6\x8B\x93",
		"\xA9\xDE" => "\xE6\x8B\x94",
		"\xA9\xDF" => "\xE6\x8B\x8B",
		"\xA9\xE0" => "\xE6\x8B\x88",
		"\xA9\xE1" => "\xE6\x8A\xA8",
		"\xA9\xE2" => "\xE6\x8A\xBD",
		"\xA9\xE3" => "\xE6\x8A\xBC",
		"\xA9\xE4" => "\xE6\x8B\x90",
		"\xA9\xE5" => "\xE6\x8B\x99",
		"\xA9\xE6" => "\xE6\x8B\x87",
		"\xA9\xE7" => "\xE6\x8B\x8D",
		"\xA9\xE8" => "\xE6\x8A\xB5",
		"\xA9\xE9" => "\xE6\x8B\x9A",
		"\xA9\xEA" => "\xE6\x8A\xB1",
		"\xA9\xEB" => "\xE6\x8B\x98",
		"\xA9\xEC" => "\xE6\x8B\x96",
		"\xA9\xED" => "\xE6\x8B\x97",
		"\xA9\xEE" => "\xE6\x8B\x86",
		"\xA9\xEF" => "\xE6\x8A\xAC",
		"\xA9\xF0" => "\xE6\x8B\x8E",
		"\xA9\xF1" => "\xE6\x94\xBE",
		"\xA9\xF2" => "\xE6\x96\xA7",
		"\xA9\xF3" => "\xE6\x96\xBC",
		"\xA9\xF4" => "\xE6\x97\xBA",
		"\xA9\xF5" => "\xE6\x98\x94",
		"\xA9\xF6" => "\xE6\x98\x93",
		"\xA9\xF7" => "\xE6\x98\x8C",
		"\xA9\xF8" => "\xE6\x98\x86",
		"\xA9\xF9" => "\xE6\x98\x82",
		"\xA9\xFA" => "\xE6\x98\x8E",
		"\xA9\xFB" => "\xE6\x98\x80",
		"\xA9\xFC" => "\xE6\x98\x8F",
		"\xA9\xFD" => "\xE6\x98\x95",
		"\xA9\xFE" => "\xE6\x98\x8A",
		"\xAA\x40" => "\xE6\x98\x87",
		"\xAA\x41" => "\xE6\x9C\x8D",
		"\xAA\x42" => "\xE6\x9C\x8B",
		"\xAA\x43" => "\xE6\x9D\xAD",
		"\xAA\x44" => "\xE6\x9E\x8B",
		"\xAA\x45" => "\xE6\x9E\x95",
		"\xAA\x46" => "\xE6\x9D\xB1",
		"\xAA\x47" => "\xE6\x9E\x9C",
		"\xAA\x48" => "\xE6\x9D\xB3",
		"\xAA\x49" => "\xE6\x9D\xB7",
		"\xAA\x4A" => "\xE6\x9E\x87",
		"\xAA\x4B" => "\xE6\x9E\x9D",
		"\xAA\x4C" => "\xE6\x9E\x97",
		"\xAA\x4D" => "\xE6\x9D\xAF",
		"\xAA\x4E" => "\xE6\x9D\xB0",
		"\xAA\x4F" => "\xE6\x9D\xBF",
		"\xAA\x50" => "\xE6\x9E\x89",
		"\xAA\x51" => "\xE6\x9D\xBE",
		"\xAA\x52" => "\xE6\x9E\x90",
		"\xAA\x53" => "\xE6\x9D\xB5",
		"\xAA\x54" => "\xE6\x9E\x9A",
		"\xAA\x55" => "\xE6\x9E\x93",
		"\xAA\x56" => "\xE6\x9D\xBC",
		"\xAA\x57" => "\xE6\x9D\xAA",
		"\xAA\x58" => "\xE6\x9D\xB2",
		"\xAA\x59" => "\xE6\xAC\xA3",
		"\xAA\x5A" => "\xE6\xAD\xA6",
		"\xAA\x5B" => "\xE6\xAD\xA7",
		"\xAA\x5C" => "\xE6\xAD\xBF",
		"\xAA\x5D" => "\xE6\xB0\x93",
		"\xAA\x5E" => "\xE6\xB0\x9B",
		"\xAA\x5F" => "\xE6\xB3\xA3",
		"\xAA\x60" => "\xE6\xB3\xA8",
		"\xAA\x61" => "\xE6\xB3\xB3",
		"\xAA\x62" => "\xE6\xB2\xB1",
		"\xAA\x63" => "\xE6\xB3\x8C",
		"\xAA\x64" => "\xE6\xB3\xA5",
		"\xAA\x65" => "\xE6\xB2\xB3",
		"\xAA\x66" => "\xE6\xB2\xBD",
		"\xAA\x67" => "\xE6\xB2\xBE",
		"\xAA\x68" => "\xE6\xB2\xBC",
		"\xAA\x69" => "\xE6\xB3\xA2",
		"\xAA\x6A" => "\xE6\xB2\xAB",
		"\xAA\x6B" => "\xE6\xB3\x95",
		"\xAA\x6C" => "\xE6\xB3\x93",
		"\xAA\x6D" => "\xE6\xB2\xB8",
		"\xAA\x6E" => "\xE6\xB3\x84",
		"\xAA\x6F" => "\xE6\xB2\xB9",
		"\xAA\x70" => "\xE6\xB3\x81",
		"\xAA\x71" => "\xE6\xB2\xAE",
		"\xAA\x72" => "\xE6\xB3\x97",
		"\xAA\x73" => "\xE6\xB3\x85",
		"\xAA\x74" => "\xE6\xB3\xB1",
		"\xAA\x75" => "\xE6\xB2\xBF",
		"\xAA\x76" => "\xE6\xB2\xBB",
		"\xAA\x77" => "\xE6\xB3\xA1",
		"\xAA\x78" => "\xE6\xB3\x9B",
		"\xAA\x79" => "\xE6\xB3\x8A",
		"\xAA\x7A" => "\xE6\xB2\xAC",
		"\xAA\x7B" => "\xE6\xB3\xAF",
		"\xAA\x7C" => "\xE6\xB3\x9C",
		"\xAA\x7D" => "\xE6\xB3\x96",
		"\xAA\x7E" => "\xE6\xB3\xA0",
		"\xAA\xA1" => "\xE7\x82\x95",
		"\xAA\xA2" => "\xE7\x82\x8E",
		"\xAA\xA3" => "\xE7\x82\x92",
		"\xAA\xA4" => "\xE7\x82\x8A",
		"\xAA\xA5" => "\xE7\x82\x99",
		"\xAA\xA6" => "\xE7\x88\xAC",
		"\xAA\xA7" => "\xE7\x88\xAD",
		"\xAA\xA8" => "\xE7\x88\xB8",
		"\xAA\xA9" => "\xE7\x89\x88",
		"\xAA\xAA" => "\xE7\x89\xA7",
		"\xAA\xAB" => "\xE7\x89\xA9",
		"\xAA\xAC" => "\xE7\x8B\x80",
		"\xAA\xAD" => "\xE7\x8B\x8E",
		"\xAA\xAE" => "\xE7\x8B\x99",
		"\xAA\xAF" => "\xE7\x8B\x97",
		"\xAA\xB0" => "\xE7\x8B\x90",
		"\xAA\xB1" => "\xE7\x8E\xA9",
		"\xAA\xB2" => "\xE7\x8E\xA8",
		"\xAA\xB3" => "\xE7\x8E\x9F",
		"\xAA\xB4" => "\xE7\x8E\xAB",
		"\xAA\xB5" => "\xE7\x8E\xA5",
		"\xAA\xB6" => "\xE7\x94\xBD",
		"\xAA\xB7" => "\xE7\x96\x9D",
		"\xAA\xB8" => "\xE7\x96\x99",
		"\xAA\xB9" => "\xE7\x96\x9A",
		"\xAA\xBA" => "\xE7\x9A\x84",
		"\xAA\xBB" => "\xE7\x9B\x82",
		"\xAA\xBC" => "\xE7\x9B\xB2",
		"\xAA\xBD" => "\xE7\x9B\xB4",
		"\xAA\xBE" => "\xE7\x9F\xA5",
		"\xAA\xBF" => "\xE7\x9F\xBD",
		"\xAA\xC0" => "\xE7\xA4\xBE",
		"\xAA\xC1" => "\xE7\xA5\x80",
		"\xAA\xC2" => "\xE7\xA5\x81",
		"\xAA\xC3" => "\xE7\xA7\x89",
		"\xAA\xC4" => "\xE7\xA7\x88",
		"\xAA\xC5" => "\xE7\xA9\xBA",
		"\xAA\xC6" => "\xE7\xA9\xB9",
		"\xAA\xC7" => "\xE7\xAB\xBA",
		"\xAA\xC8" => "\xE7\xB3\xBE",
		"\xAA\xC9" => "\xE7\xBD\x94",
		"\xAA\xCA" => "\xE7\xBE\x8C",
		"\xAA\xCB" => "\xE7\xBE\x8B",
		"\xAA\xCC" => "\xE8\x80\x85",
		"\xAA\xCD" => "\xE8\x82\xBA",
		"\xAA\xCE" => "\xE8\x82\xA5",
		"\xAA\xCF" => "\xE8\x82\xA2",
		"\xAA\xD0" => "\xE8\x82\xB1",
		"\xAA\xD1" => "\xE8\x82\xA1",
		"\xAA\xD2" => "\xE8\x82\xAB",
		"\xAA\xD3" => "\xE8\x82\xA9",
		"\xAA\xD4" => "\xE8\x82\xB4",
		"\xAA\xD5" => "\xE8\x82\xAA",
		"\xAA\xD6" => "\xE8\x82\xAF",
		"\xAA\xD7" => "\xE8\x87\xA5",
		"\xAA\xD8" => "\xE8\x87\xBE",
		"\xAA\xD9" => "\xE8\x88\x8D",
		"\xAA\xDA" => "\xE8\x8A\xB3",
		"\xAA\xDB" => "\xE8\x8A\x9D",
		"\xAA\xDC" => "\xE8\x8A\x99",
		"\xAA\xDD" => "\xE8\x8A\xAD",
		"\xAA\xDE" => "\xE8\x8A\xBD",
		"\xAA\xDF" => "\xE8\x8A\x9F",
		"\xAA\xE0" => "\xE8\x8A\xB9",
		"\xAA\xE1" => "\xE8\x8A\xB1",
		"\xAA\xE2" => "\xE8\x8A\xAC",
		"\xAA\xE3" => "\xE8\x8A\xA5",
		"\xAA\xE4" => "\xE8\x8A\xAF",
		"\xAA\xE5" => "\xE8\x8A\xB8",
		"\xAA\xE6" => "\xE8\x8A\xA3",
		"\xAA\xE7" => "\xE8\x8A\xB0",
		"\xAA\xE8" => "\xE8\x8A\xBE",
		"\xAA\xE9" => "\xE8\x8A\xB7",
		"\xAA\xEA" => "\xE8\x99\x8E",
		"\xAA\xEB" => "\xE8\x99\xB1",
		"\xAA\xEC" => "\xE5\x88\x9D",
		"\xAA\xED" => "\xE8\xA1\xA8",
		"\xAA\xEE" => "\xE8\xBB\x8B",
		"\xAA\xEF" => "\xE8\xBF\x8E",
		"\xAA\xF0" => "\xE8\xBF\x94",
		"\xAA\xF1" => "\xE8\xBF\x91",
		"\xAA\xF2" => "\xE9\x82\xB5",
		"\xAA\xF3" => "\xE9\x82\xB8",
		"\xAA\xF4" => "\xE9\x82\xB1",
		"\xAA\xF5" => "\xE9\x82\xB6",
		"\xAA\xF6" => "\xE9\x87\x87",
		"\xAA\xF7" => "\xE9\x87\x91",
		"\xAA\xF8" => "\xE9\x95\xB7",
		"\xAA\xF9" => "\xE9\x96\x80",
		"\xAA\xFA" => "\xE9\x98\x9C",
		"\xAA\xFB" => "\xE9\x99\x80",
		"\xAA\xFC" => "\xE9\x98\xBF",
		"\xAA\xFD" => "\xE9\x98\xBB",
		"\xAA\xFE" => "\xE9\x99\x84",
		"\xAB\x40" => "\xE9\x99\x82",
		"\xAB\x41" => "\xE9\x9A\xB9",
		"\xAB\x42" => "\xE9\x9B\xA8",
		"\xAB\x43" => "\xE9\x9D\x92",
		"\xAB\x44" => "\xE9\x9D\x9E",
		"\xAB\x45" => "\xE4\xBA\x9F",
		"\xAB\x46" => "\xE4\xBA\xAD",
		"\xAB\x47" => "\xE4\xBA\xAE",
		"\xAB\x48" => "\xE4\xBF\xA1",
		"\xAB\x49" => "\xE4\xBE\xB5",
		"\xAB\x4A" => "\xE4\xBE\xAF",
		"\xAB\x4B" => "\xE4\xBE\xBF",
		"\xAB\x4C" => "\xE4\xBF\xA0",
		"\xAB\x4D" => "\xE4\xBF\x91",
		"\xAB\x4E" => "\xE4\xBF\x8F",
		"\xAB\x4F" => "\xE4\xBF\x9D",
		"\xAB\x50" => "\xE4\xBF\x83",
		"\xAB\x51" => "\xE4\xBE\xB6",
		"\xAB\x52" => "\xE4\xBF\x98",
		"\xAB\x53" => "\xE4\xBF\x9F",
		"\xAB\x54" => "\xE4\xBF\x8A",
		"\xAB\x55" => "\xE4\xBF\x97",
		"\xAB\x56" => "\xE4\xBE\xAE",
		"\xAB\x57" => "\xE4\xBF\x90",
		"\xAB\x58" => "\xE4\xBF\x84",
		"\xAB\x59" => "\xE4\xBF\x82",
		"\xAB\x5A" => "\xE4\xBF\x9A",
		"\xAB\x5B" => "\xE4\xBF\x8E",
		"\xAB\x5C" => "\xE4\xBF\x9E",
		"\xAB\x5D" => "\xE4\xBE\xB7",
		"\xAB\x5E" => "\xE5\x85\x97",
		"\xAB\x5F" => "\xE5\x86\x92",
		"\xAB\x60" => "\xE5\x86\x91",
		"\xAB\x61" => "\xE5\x86\xA0",
		"\xAB\x62" => "\xE5\x89\x8E",
		"\xAB\x63" => "\xE5\x89\x83",
		"\xAB\x64" => "\xE5\x89\x8A",
		"\xAB\x65" => "\xE5\x89\x8D",
		"\xAB\x66" => "\xE5\x89\x8C",
		"\xAB\x67" => "\xE5\x89\x8B",
		"\xAB\x68" => "\xE5\x89\x87",
		"\xAB\x69" => "\xE5\x8B\x87",
		"\xAB\x6A" => "\xE5\x8B\x89",
		"\xAB\x6B" => "\xE5\x8B\x83",
		"\xAB\x6C" => "\xE5\x8B\x81",
		"\xAB\x6D" => "\xE5\x8C\x8D",
		"\xAB\x6E" => "\xE5\x8D\x97",
		"\xAB\x6F" => "\xE5\x8D\xBB",
		"\xAB\x70" => "\xE5\x8E\x9A",
		"\xAB\x71" => "\xE5\x8F\x9B",
		"\xAB\x72" => "\xE5\x92\xAC",
		"\xAB\x73" => "\xE5\x93\x80",
		"\xAB\x74" => "\xE5\x92\xA8",
		"\xAB\x75" => "\xE5\x93\x8E",
		"\xAB\x76" => "\xE5\x93\x89",
		"\xAB\x77" => "\xE5\x92\xB8",
		"\xAB\x78" => "\xE5\x92\xA6",
		"\xAB\x79" => "\xE5\x92\xB3",
		"\xAB\x7A" => "\xE5\x93\x87",
		"\xAB\x7B" => "\xE5\x93\x82",
		"\xAB\x7C" => "\xE5\x92\xBD",
		"\xAB\x7D" => "\xE5\x92\xAA",
		"\xAB\x7E" => "\xE5\x93\x81",
		"\xAB\xA1" => "\xE5\x93\x84",
		"\xAB\xA2" => "\xE5\x93\x88",
		"\xAB\xA3" => "\xE5\x92\xAF",
		"\xAB\xA4" => "\xE5\x92\xAB",
		"\xAB\xA5" => "\xE5\x92\xB1",
		"\xAB\xA6" => "\xE5\x92\xBB",
		"\xAB\xA7" => "\xE5\x92\xA9",
		"\xAB\xA8" => "\xE5\x92\xA7",
		"\xAB\xA9" => "\xE5\x92\xBF",
		"\xAB\xAA" => "\xE5\x9B\xBF",
		"\xAB\xAB" => "\xE5\x9E\x82",
		"\xAB\xAC" => "\xE5\x9E\x8B",
		"\xAB\xAD" => "\xE5\x9E\xA0",
		"\xAB\xAE" => "\xE5\x9E\xA3",
		"\xAB\xAF" => "\xE5\x9E\xA2",
		"\xAB\xB0" => "\xE5\x9F\x8E",
		"\xAB\xB1" => "\xE5\x9E\xAE",
		"\xAB\xB2" => "\xE5\x9E\x93",
		"\xAB\xB3" => "\xE5\xA5\x95",
		"\xAB\xB4" => "\xE5\xA5\x91",
		"\xAB\xB5" => "\xE5\xA5\x8F",
		"\xAB\xB6" => "\xE5\xA5\x8E",
		"\xAB\xB7" => "\xE5\xA5\x90",
		"\xAB\xB8" => "\xE5\xA7\x9C",
		"\xAB\xB9" => "\xE5\xA7\x98",
		"\xAB\xBA" => "\xE5\xA7\xBF",
		"\xAB\xBB" => "\xE5\xA7\xA3",
		"\xAB\xBC" => "\xE5\xA7\xA8",
		"\xAB\xBD" => "\xE5\xA8\x83",
		"\xAB\xBE" => "\xE5\xA7\xA5",
		"\xAB\xBF" => "\xE5\xA7\xAA",
		"\xAB\xC0" => "\xE5\xA7\x9A",
		"\xAB\xC1" => "\xE5\xA7\xA6",
		"\xAB\xC2" => "\xE5\xA8\x81",
		"\xAB\xC3" => "\xE5\xA7\xBB",
		"\xAB\xC4" => "\xE5\xAD\xA9",
		"\xAB\xC5" => "\xE5\xAE\xA3",
		"\xAB\xC6" => "\xE5\xAE\xA6",
		"\xAB\xC7" => "\xE5\xAE\xA4",
		"\xAB\xC8" => "\xE5\xAE\xA2",
		"\xAB\xC9" => "\xE5\xAE\xA5",
		"\xAB\xCA" => "\xE5\xB0\x81",
		"\xAB\xCB" => "\xE5\xB1\x8E",
		"\xAB\xCC" => "\xE5\xB1\x8F",
		"\xAB\xCD" => "\xE5\xB1\x8D",
		"\xAB\xCE" => "\xE5\xB1\x8B",
		"\xAB\xCF" => "\xE5\xB3\x99",
		"\xAB\xD0" => "\xE5\xB3\x92",
		"\xAB\xD1" => "\xE5\xB7\xB7",
		"\xAB\xD2" => "\xE5\xB8\x9D",
		"\xAB\xD3" => "\xE5\xB8\xA5",
		"\xAB\xD4" => "\xE5\xB8\x9F",
		"\xAB\xD5" => "\xE5\xB9\xBD",
		"\xAB\xD6" => "\xE5\xBA\xA0",
		"\xAB\xD7" => "\xE5\xBA\xA6",
		"\xAB\xD8" => "\xE5\xBB\xBA",
		"\xAB\xD9" => "\xE5\xBC\x88",
		"\xAB\xDA" => "\xE5\xBC\xAD",
		"\xAB\xDB" => "\xE5\xBD\xA5",
		"\xAB\xDC" => "\xE5\xBE\x88",
		"\xAB\xDD" => "\xE5\xBE\x85",
		"\xAB\xDE" => "\xE5\xBE\x8A",
		"\xAB\xDF" => "\xE5\xBE\x8B",
		"\xAB\xE0" => "\xE5\xBE\x87",
		"\xAB\xE1" => "\xE5\xBE\x8C",
		"\xAB\xE2" => "\xE5\xBE\x89",
		"\xAB\xE3" => "\xE6\x80\x92",
		"\xAB\xE4" => "\xE6\x80\x9D",
		"\xAB\xE5" => "\xE6\x80\xA0",
		"\xAB\xE6" => "\xE6\x80\xA5",
		"\xAB\xE7" => "\xE6\x80\x8E",
		"\xAB\xE8" => "\xE6\x80\xA8",
		"\xAB\xE9" => "\xE6\x81\x8D",
		"\xAB\xEA" => "\xE6\x81\xB0",
		"\xAB\xEB" => "\xE6\x81\xA8",
		"\xAB\xEC" => "\xE6\x81\xA2",
		"\xAB\xED" => "\xE6\x81\x86",
		"\xAB\xEE" => "\xE6\x81\x83",
		"\xAB\xEF" => "\xE6\x81\xAC",
		"\xAB\xF0" => "\xE6\x81\xAB",
		"\xAB\xF1" => "\xE6\x81\xAA",
		"\xAB\xF2" => "\xE6\x81\xA4",
		"\xAB\xF3" => "\xE6\x89\x81",
		"\xAB\xF4" => "\xE6\x8B\x9C",
		"\xAB\xF5" => "\xE6\x8C\x96",
		"\xAB\xF6" => "\xE6\x8C\x89",
		"\xAB\xF7" => "\xE6\x8B\xBC",
		"\xAB\xF8" => "\xE6\x8B\xAD",
		"\xAB\xF9" => "\xE6\x8C\x81",
		"\xAB\xFA" => "\xE6\x8B\xAE",
		"\xAB\xFB" => "\xE6\x8B\xBD",
		"\xAB\xFC" => "\xE6\x8C\x87",
		"\xAB\xFD" => "\xE6\x8B\xB1",
		"\xAB\xFE" => "\xE6\x8B\xB7",
		"\xAC\x40" => "\xE6\x8B\xAF",
		"\xAC\x41" => "\xE6\x8B\xAC",
		"\xAC\x42" => "\xE6\x8B\xBE",
		"\xAC\x43" => "\xE6\x8B\xB4",
		"\xAC\x44" => "\xE6\x8C\x91",
		"\xAC\x45" => "\xE6\x8C\x82",
		"\xAC\x46" => "\xE6\x94\xBF",
		"\xAC\x47" => "\xE6\x95\x85",
		"\xAC\x48" => "\xE6\x96\xAB",
		"\xAC\x49" => "\xE6\x96\xBD",
		"\xAC\x4A" => "\xE6\x97\xA2",
		"\xAC\x4B" => "\xE6\x98\xA5",
		"\xAC\x4C" => "\xE6\x98\xAD",
		"\xAC\x4D" => "\xE6\x98\xA0",
		"\xAC\x4E" => "\xE6\x98\xA7",
		"\xAC\x4F" => "\xE6\x98\xAF",
		"\xAC\x50" => "\xE6\x98\x9F",
		"\xAC\x51" => "\xE6\x98\xA8",
		"\xAC\x52" => "\xE6\x98\xB1",
		"\xAC\x53" => "\xE6\x98\xA4",
		"\xAC\x54" => "\xE6\x9B\xB7",
		"\xAC\x55" => "\xE6\x9F\xBF",
		"\xAC\x56" => "\xE6\x9F\x93",
		"\xAC\x57" => "\xE6\x9F\xB1",
		"\xAC\x58" => "\xE6\x9F\x94",
		"\xAC\x59" => "\xE6\x9F\x90",
		"\xAC\x5A" => "\xE6\x9F\xAC",
		"\xAC\x5B" => "\xE6\x9E\xB6",
		"\xAC\x5C" => "\xE6\x9E\xAF",
		"\xAC\x5D" => "\xE6\x9F\xB5",
		"\xAC\x5E" => "\xE6\x9F\xA9",
		"\xAC\x5F" => "\xE6\x9F\xAF",
		"\xAC\x60" => "\xE6\x9F\x84",
		"\xAC\x61" => "\xE6\x9F\x91",
		"\xAC\x62" => "\xE6\x9E\xB4",
		"\xAC\x63" => "\xE6\x9F\x9A",
		"\xAC\x64" => "\xE6\x9F\xA5",
		"\xAC\x65" => "\xE6\x9E\xB8",
		"\xAC\x66" => "\xE6\x9F\x8F",
		"\xAC\x67" => "\xE6\x9F\x9E",
		"\xAC\x68" => "\xE6\x9F\xB3",
		"\xAC\x69" => "\xE6\x9E\xB0",
		"\xAC\x6A" => "\xE6\x9F\x99",
		"\xAC\x6B" => "\xE6\x9F\xA2",
		"\xAC\x6C" => "\xE6\x9F\x9D",
		"\xAC\x6D" => "\xE6\x9F\x92",
		"\xAC\x6E" => "\xE6\xAD\xAA",
		"\xAC\x6F" => "\xE6\xAE\x83",
		"\xAC\x70" => "\xE6\xAE\x86",
		"\xAC\x71" => "\xE6\xAE\xB5",
		"\xAC\x72" => "\xE6\xAF\x92",
		"\xAC\x73" => "\xE6\xAF\x97",
		"\xAC\x74" => "\xE6\xB0\x9F",
		"\xAC\x75" => "\xE6\xB3\x89",
		"\xAC\x76" => "\xE6\xB4\x8B",
		"\xAC\x77" => "\xE6\xB4\xB2",
		"\xAC\x78" => "\xE6\xB4\xAA",
		"\xAC\x79" => "\xE6\xB5\x81",
		"\xAC\x7A" => "\xE6\xB4\xA5",
		"\xAC\x7B" => "\xE6\xB4\x8C",
		"\xAC\x7C" => "\xE6\xB4\xB1",
		"\xAC\x7D" => "\xE6\xB4\x9E",
		"\xAC\x7E" => "\xE6\xB4\x97",
		"\xAC\xA1" => "\xE6\xB4\xBB",
		"\xAC\xA2" => "\xE6\xB4\xBD",
		"\xAC\xA3" => "\xE6\xB4\xBE",
		"\xAC\xA4" => "\xE6\xB4\xB6",
		"\xAC\xA5" => "\xE6\xB4\x9B",
		"\xAC\xA6" => "\xE6\xB3\xB5",
		"\xAC\xA7" => "\xE6\xB4\xB9",
		"\xAC\xA8" => "\xE6\xB4\xA7",
		"\xAC\xA9" => "\xE6\xB4\xB8",
		"\xAC\xAA" => "\xE6\xB4\xA9",
		"\xAC\xAB" => "\xE6\xB4\xAE",
		"\xAC\xAC" => "\xE6\xB4\xB5",
		"\xAC\xAD" => "\xE6\xB4\x8E",
		"\xAC\xAE" => "\xE6\xB4\xAB",
		"\xAC\xAF" => "\xE7\x82\xAB",
		"\xAC\xB0" => "\xE7\x82\xBA",
		"\xAC\xB1" => "\xE7\x82\xB3",
		"\xAC\xB2" => "\xE7\x82\xAC",
		"\xAC\xB3" => "\xE7\x82\xAF",
		"\xAC\xB4" => "\xE7\x82\xAD",
		"\xAC\xB5" => "\xE7\x82\xB8",
		"\xAC\xB6" => "\xE7\x82\xAE",
		"\xAC\xB7" => "\xE7\x82\xA4",
		"\xAC\xB8" => "\xE7\x88\xB0",
		"\xAC\xB9" => "\xE7\x89\xB2",
		"\xAC\xBA" => "\xE7\x89\xAF",
		"\xAC\xBB" => "\xE7\x89\xB4",
		"\xAC\xBC" => "\xE7\x8B\xA9",
		"\xAC\xBD" => "\xE7\x8B\xA0",
		"\xAC\xBE" => "\xE7\x8B\xA1",
		"\xAC\xBF" => "\xE7\x8E\xB7",
		"\xAC\xC0" => "\xE7\x8F\x8A",
		"\xAC\xC1" => "\xE7\x8E\xBB",
		"\xAC\xC2" => "\xE7\x8E\xB2",
		"\xAC\xC3" => "\xE7\x8F\x8D",
		"\xAC\xC4" => "\xE7\x8F\x80",
		"\xAC\xC5" => "\xE7\x8E\xB3",
		"\xAC\xC6" => "\xE7\x94\x9A",
		"\xAC\xC7" => "\xE7\x94\xAD",
		"\xAC\xC8" => "\xE7\x95\x8F",
		"\xAC\xC9" => "\xE7\x95\x8C",
		"\xAC\xCA" => "\xE7\x95\x8E",
		"\xAC\xCB" => "\xE7\x95\x8B",
		"\xAC\xCC" => "\xE7\x96\xAB",
		"\xAC\xCD" => "\xE7\x96\xA4",
		"\xAC\xCE" => "\xE7\x96\xA5",
		"\xAC\xCF" => "\xE7\x96\xA2",
		"\xAC\xD0" => "\xE7\x96\xA3",
		"\xAC\xD1" => "\xE7\x99\xB8",
		"\xAC\xD2" => "\xE7\x9A\x86",
		"\xAC\xD3" => "\xE7\x9A\x87",
		"\xAC\xD4" => "\xE7\x9A\x88",
		"\xAC\xD5" => "\xE7\x9B\x88",
		"\xAC\xD6" => "\xE7\x9B\x86",
		"\xAC\xD7" => "\xE7\x9B\x83",
		"\xAC\xD8" => "\xE7\x9B\x85",
		"\xAC\xD9" => "\xE7\x9C\x81",
		"\xAC\xDA" => "\xE7\x9B\xB9",
		"\xAC\xDB" => "\xE7\x9B\xB8",
		"\xAC\xDC" => "\xE7\x9C\x89",
		"\xAC\xDD" => "\xE7\x9C\x8B",
		"\xAC\xDE" => "\xE7\x9B\xBE",
		"\xAC\xDF" => "\xE7\x9B\xBC",
		"\xAC\xE0" => "\xE7\x9C\x87",
		"\xAC\xE1" => "\xE7\x9F\x9C",
		"\xAC\xE2" => "\xE7\xA0\x82",
		"\xAC\xE3" => "\xE7\xA0\x94",
		"\xAC\xE4" => "\xE7\xA0\x8C",
		"\xAC\xE5" => "\xE7\xA0\x8D",
		"\xAC\xE6" => "\xE7\xA5\x86",
		"\xAC\xE7" => "\xE7\xA5\x89",
		"\xAC\xE8" => "\xE7\xA5\x88",
		"\xAC\xE9" => "\xE7\xA5\x87",
		"\xAC\xEA" => "\xE7\xA6\xB9",
		"\xAC\xEB" => "\xE7\xA6\xBA",
		"\xAC\xEC" => "\xE7\xA7\x91",
		"\xAC\xED" => "\xE7\xA7\x92",
		"\xAC\xEE" => "\xE7\xA7\x8B",
		"\xAC\xEF" => "\xE7\xA9\xBF",
		"\xAC\xF0" => "\xE7\xAA\x81",
		"\xAC\xF1" => "\xE7\xAB\xBF",
		"\xAC\xF2" => "\xE7\xAB\xBD",
		"\xAC\xF3" => "\xE7\xB1\xBD",
		"\xAC\xF4" => "\xE7\xB4\x82",
		"\xAC\xF5" => "\xE7\xB4\x85",
		"\xAC\xF6" => "\xE7\xB4\x80",
		"\xAC\xF7" => "\xE7\xB4\x89",
		"\xAC\xF8" => "\xE7\xB4\x87",
		"\xAC\xF9" => "\xE7\xB4\x84",
		"\xAC\xFA" => "\xE7\xB4\x86",
		"\xAC\xFB" => "\xE7\xBC\xB8",
		"\xAC\xFC" => "\xE7\xBE\x8E",
		"\xAC\xFD" => "\xE7\xBE\xBF",
		"\xAC\xFE" => "\xE8\x80\x84",
		"\xAD\x40" => "\xE8\x80\x90",
		"\xAD\x41" => "\xE8\x80\x8D",
		"\xAD\x42" => "\xE8\x80\x91",
		"\xAD\x43" => "\xE8\x80\xB6",
		"\xAD\x44" => "\xE8\x83\x96",
		"\xAD\x45" => "\xE8\x83\xA5",
		"\xAD\x46" => "\xE8\x83\x9A",
		"\xAD\x47" => "\xE8\x83\x83",
		"\xAD\x48" => "\xE8\x83\x84",
		"\xAD\x49" => "\xE8\x83\x8C",
		"\xAD\x4A" => "\xE8\x83\xA1",
		"\xAD\x4B" => "\xE8\x83\x9B",
		"\xAD\x4C" => "\xE8\x83\x8E",
		"\xAD\x4D" => "\xE8\x83\x9E",
		"\xAD\x4E" => "\xE8\x83\xA4",
		"\xAD\x4F" => "\xE8\x83\x9D",
		"\xAD\x50" => "\xE8\x87\xB4",
		"\xAD\x51" => "\xE8\x88\xA2",
		"\xAD\x52" => "\xE8\x8B\xA7",
		"\xAD\x53" => "\xE8\x8C\x83",
		"\xAD\x54" => "\xE8\x8C\x85",
		"\xAD\x55" => "\xE8\x8B\xA3",
		"\xAD\x56" => "\xE8\x8B\x9B",
		"\xAD\x57" => "\xE8\x8B\xA6",
		"\xAD\x58" => "\xE8\x8C\x84",
		"\xAD\x59" => "\xE8\x8B\xA5",
		"\xAD\x5A" => "\xE8\x8C\x82",
		"\xAD\x5B" => "\xE8\x8C\x89",
		"\xAD\x5C" => "\xE8\x8B\x92",
		"\xAD\x5D" => "\xE8\x8B\x97",
		"\xAD\x5E" => "\xE8\x8B\xB1",
		"\xAD\x5F" => "\xE8\x8C\x81",
		"\xAD\x60" => "\xE8\x8B\x9C",
		"\xAD\x61" => "\xE8\x8B\x94",
		"\xAD\x62" => "\xE8\x8B\x91",
		"\xAD\x63" => "\xE8\x8B\x9E",
		"\xAD\x64" => "\xE8\x8B\x93",
		"\xAD\x65" => "\xE8\x8B\x9F",
		"\xAD\x66" => "\xE8\x8B\xAF",
		"\xAD\x67" => "\xE8\x8C\x86",
		"\xAD\x68" => "\xE8\x99\x90",
		"\xAD\x69" => "\xE8\x99\xB9",
		"\xAD\x6A" => "\xE8\x99\xBB",
		"\xAD\x6B" => "\xE8\x99\xBA",
		"\xAD\x6C" => "\xE8\xA1\x8D",
		"\xAD\x6D" => "\xE8\xA1\xAB",
		"\xAD\x6E" => "\xE8\xA6\x81",
		"\xAD\x6F" => "\xE8\xA7\x94",
		"\xAD\x70" => "\xE8\xA8\x88",
		"\xAD\x71" => "\xE8\xA8\x82",
		"\xAD\x72" => "\xE8\xA8\x83",
		"\xAD\x73" => "\xE8\xB2\x9E",
		"\xAD\x74" => "\xE8\xB2\xA0",
		"\xAD\x75" => "\xE8\xB5\xB4",
		"\xAD\x76" => "\xE8\xB5\xB3",
		"\xAD\x77" => "\xE8\xB6\xB4",
		"\xAD\x78" => "\xE8\xBB\x8D",
		"\xAD\x79" => "\xE8\xBB\x8C",
		"\xAD\x7A" => "\xE8\xBF\xB0",
		"\xAD\x7B" => "\xE8\xBF\xA6",
		"\xAD\x7C" => "\xE8\xBF\xA2",
		"\xAD\x7D" => "\xE8\xBF\xAA",
		"\xAD\x7E" => "\xE8\xBF\xA5",
		"\xAD\xA1" => "\xE8\xBF\xAD",
		"\xAD\xA2" => "\xE8\xBF\xAB",
		"\xAD\xA3" => "\xE8\xBF\xA4",
		"\xAD\xA4" => "\xE8\xBF\xA8",
		"\xAD\xA5" => "\xE9\x83\x8A",
		"\xAD\xA6" => "\xE9\x83\x8E",
		"\xAD\xA7" => "\xE9\x83\x81",
		"\xAD\xA8" => "\xE9\x83\x83",
		"\xAD\xA9" => "\xE9\x85\x8B",
		"\xAD\xAA" => "\xE9\x85\x8A",
		"\xAD\xAB" => "\xE9\x87\x8D",
		"\xAD\xAC" => "\xE9\x96\x82",
		"\xAD\xAD" => "\xE9\x99\x90",
		"\xAD\xAE" => "\xE9\x99\x8B",
		"\xAD\xAF" => "\xE9\x99\x8C",
		"\xAD\xB0" => "\xE9\x99\x8D",
		"\xAD\xB1" => "\xE9\x9D\xA2",
		"\xAD\xB2" => "\xE9\x9D\xA9",
		"\xAD\xB3" => "\xE9\x9F\x8B",
		"\xAD\xB4" => "\xE9\x9F\xAD",
		"\xAD\xB5" => "\xE9\x9F\xB3",
		"\xAD\xB6" => "\xE9\xA0\x81",
		"\xAD\xB7" => "\xE9\xA2\xA8",
		"\xAD\xB8" => "\xE9\xA3\x9B",
		"\xAD\xB9" => "\xE9\xA3\x9F",
		"\xAD\xBA" => "\xE9\xA6\x96",
		"\xAD\xBB" => "\xE9\xA6\x99",
		"\xAD\xBC" => "\xE4\xB9\x98",
		"\xAD\xBD" => "\xE4\xBA\xB3",
		"\xAD\xBE" => "\xE5\x80\x8C",
		"\xAD\xBF" => "\xE5\x80\x8D",
		"\xAD\xC0" => "\xE5\x80\xA3",
		"\xAD\xC1" => "\xE4\xBF\xAF",
		"\xAD\xC2" => "\xE5\x80\xA6",
		"\xAD\xC3" => "\xE5\x80\xA5",
		"\xAD\xC4" => "\xE4\xBF\xB8",
		"\xAD\xC5" => "\xE5\x80\xA9",
		"\xAD\xC6" => "\xE5\x80\x96",
		"\xAD\xC7" => "\xE5\x80\x86",
		"\xAD\xC8" => "\xE5\x80\xBC",
		"\xAD\xC9" => "\xE5\x80\x9F",
		"\xAD\xCA" => "\xE5\x80\x9A",
		"\xAD\xCB" => "\xE5\x80\x92",
		"\xAD\xCC" => "\xE5\x80\x91",
		"\xAD\xCD" => "\xE4\xBF\xBA",
		"\xAD\xCE" => "\xE5\x80\x80",
		"\xAD\xCF" => "\xE5\x80\x94",
		"\xAD\xD0" => "\xE5\x80\xA8",
		"\xAD\xD1" => "\xE4\xBF\xB1",
		"\xAD\xD2" => "\xE5\x80\xA1",
		"\xAD\xD3" => "\xE5\x80\x8B",
		"\xAD\xD4" => "\xE5\x80\x99",
		"\xAD\xD5" => "\xE5\x80\x98",
		"\xAD\xD6" => "\xE4\xBF\xB3",
		"\xAD\xD7" => "\xE4\xBF\xAE",
		"\xAD\xD8" => "\xE5\x80\xAD",
		"\xAD\xD9" => "\xE5\x80\xAA",
		"\xAD\xDA" => "\xE4\xBF\xBE",
		"\xAD\xDB" => "\xE5\x80\xAB",
		"\xAD\xDC" => "\xE5\x80\x89",
		"\xAD\xDD" => "\xE5\x85\xBC",
		"\xAD\xDE" => "\xE5\x86\xA4",
		"\xAD\xDF" => "\xE5\x86\xA5",
		"\xAD\xE0" => "\xE5\x86\xA2",
		"\xAD\xE1" => "\xE5\x87\x8D",
		"\xAD\xE2" => "\xE5\x87\x8C",
		"\xAD\xE3" => "\xE5\x87\x86",
		"\xAD\xE4" => "\xE5\x87\x8B",
		"\xAD\xE5" => "\xE5\x89\x96",
		"\xAD\xE6" => "\xE5\x89\x9C",
		"\xAD\xE7" => "\xE5\x89\x94",
		"\xAD\xE8" => "\xE5\x89\x9B",
		"\xAD\xE9" => "\xE5\x89\x9D",
		"\xAD\xEA" => "\xE5\x8C\xAA",
		"\xAD\xEB" => "\xE5\x8D\xBF",
		"\xAD\xEC" => "\xE5\x8E\x9F",
		"\xAD\xED" => "\xE5\x8E\x9D",
		"\xAD\xEE" => "\xE5\x8F\x9F",
		"\xAD\xEF" => "\xE5\x93\xA8",
		"\xAD\xF0" => "\xE5\x94\x90",
		"\xAD\xF1" => "\xE5\x94\x81",
		"\xAD\xF2" => "\xE5\x94\xB7",
		"\xAD\xF3" => "\xE5\x93\xBC",
		"\xAD\xF4" => "\xE5\x93\xA5",
		"\xAD\xF5" => "\xE5\x93\xB2",
		"\xAD\xF6" => "\xE5\x94\x86",
		"\xAD\xF7" => "\xE5\x93\xBA",
		"\xAD\xF8" => "\xE5\x94\x94",
		"\xAD\xF9" => "\xE5\x93\xA9",
		"\xAD\xFA" => "\xE5\x93\xAD",
		"\xAD\xFB" => "\xE5\x93\xA1",
		"\xAD\xFC" => "\xE5\x94\x89",
		"\xAD\xFD" => "\xE5\x93\xAE",
		"\xAD\xFE" => "\xE5\x93\xAA",
		"\xAE\x40" => "\xE5\x93\xA6",
		"\xAE\x41" => "\xE5\x94\xA7",
		"\xAE\x42" => "\xE5\x94\x87",
		"\xAE\x43" => "\xE5\x93\xBD",
		"\xAE\x44" => "\xE5\x94\x8F",
		"\xAE\x45" => "\xE5\x9C\x83",
		"\xAE\x46" => "\xE5\x9C\x84",
		"\xAE\x47" => "\xE5\x9F\x82",
		"\xAE\x48" => "\xE5\x9F\x94",
		"\xAE\x49" => "\xE5\x9F\x8B",
		"\xAE\x4A" => "\xE5\x9F\x83",
		"\xAE\x4B" => "\xE5\xA0\x89",
		"\xAE\x4C" => "\xE5\xA4\x8F",
		"\xAE\x4D" => "\xE5\xA5\x97",
		"\xAE\x4E" => "\xE5\xA5\x98",
		"\xAE\x4F" => "\xE5\xA5\x9A",
		"\xAE\x50" => "\xE5\xA8\x91",
		"\xAE\x51" => "\xE5\xA8\x98",
		"\xAE\x52" => "\xE5\xA8\x9C",
		"\xAE\x53" => "\xE5\xA8\x9F",
		"\xAE\x54" => "\xE5\xA8\x9B",
		"\xAE\x55" => "\xE5\xA8\x93",
		"\xAE\x56" => "\xE5\xA7\xAC",
		"\xAE\x57" => "\xE5\xA8\xA0",
		"\xAE\x58" => "\xE5\xA8\xA3",
		"\xAE\x59" => "\xE5\xA8\xA9",
		"\xAE\x5A" => "\xE5\xA8\xA5",
		"\xAE\x5B" => "\xE5\xA8\x8C",
		"\xAE\x5C" => "\xE5\xA8\x89",
		"\xAE\x5D" => "\xE5\xAD\xAB",
		"\xAE\x5E" => "\xE5\xB1\x98",
		"\xAE\x5F" => "\xE5\xAE\xB0",
		"\xAE\x60" => "\xE5\xAE\xB3",
		"\xAE\x61" => "\xE5\xAE\xB6",
		"\xAE\x62" => "\xE5\xAE\xB4",
		"\xAE\x63" => "\xE5\xAE\xAE",
		"\xAE\x64" => "\xE5\xAE\xB5",
		"\xAE\x65" => "\xE5\xAE\xB9",
		"\xAE\x66" => "\xE5\xAE\xB8",
		"\xAE\x67" => "\xE5\xB0\x84",
		"\xAE\x68" => "\xE5\xB1\x91",
		"\xAE\x69" => "\xE5\xB1\x95",
		"\xAE\x6A" => "\xE5\xB1\x90",
		"\xAE\x6B" => "\xE5\xB3\xAD",
		"\xAE\x6C" => "\xE5\xB3\xBD",
		"\xAE\x6D" => "\xE5\xB3\xBB",
		"\xAE\x6E" => "\xE5\xB3\xAA",
		"\xAE\x6F" => "\xE5\xB3\xA8",
		"\xAE\x70" => "\xE5\xB3\xB0",
		"\xAE\x71" => "\xE5\xB3\xB6",
		"\xAE\x72" => "\xE5\xB4\x81",
		"\xAE\x73" => "\xE5\xB3\xB4",
		"\xAE\x74" => "\xE5\xB7\xAE",
		"\xAE\x75" => "\xE5\xB8\xAD",
		"\xAE\x76" => "\xE5\xB8\xAB",
		"\xAE\x77" => "\xE5\xBA\xAB",
		"\xAE\x78" => "\xE5\xBA\xAD",
		"\xAE\x79" => "\xE5\xBA\xA7",
		"\xAE\x7A" => "\xE5\xBC\xB1",
		"\xAE\x7B" => "\xE5\xBE\x92",
		"\xAE\x7C" => "\xE5\xBE\x91",
		"\xAE\x7D" => "\xE5\xBE\x90",
		"\xAE\x7E" => "\xE6\x81\x99",
		"\xAE\xA1" => "\xE6\x81\xA3",
		"\xAE\xA2" => "\xE6\x81\xA5",
		"\xAE\xA3" => "\xE6\x81\x90",
		"\xAE\xA4" => "\xE6\x81\x95",
		"\xAE\xA5" => "\xE6\x81\xAD",
		"\xAE\xA6" => "\xE6\x81\xA9",
		"\xAE\xA7" => "\xE6\x81\xAF",
		"\xAE\xA8" => "\xE6\x82\x84",
		"\xAE\xA9" => "\xE6\x82\x9F",
		"\xAE\xAA" => "\xE6\x82\x9A",
		"\xAE\xAB" => "\xE6\x82\x8D",
		"\xAE\xAC" => "\xE6\x82\x94",
		"\xAE\xAD" => "\xE6\x82\x8C",
		"\xAE\xAE" => "\xE6\x82\x85",
		"\xAE\xAF" => "\xE6\x82\x96",
		"\xAE\xB0" => "\xE6\x89\x87",
		"\xAE\xB1" => "\xE6\x8B\xB3",
		"\xAE\xB2" => "\xE6\x8C\x88",
		"\xAE\xB3" => "\xE6\x8B\xBF",
		"\xAE\xB4" => "\xE6\x8D\x8E",
		"\xAE\xB5" => "\xE6\x8C\xBE",
		"\xAE\xB6" => "\xE6\x8C\xAF",
		"\xAE\xB7" => "\xE6\x8D\x95",
		"\xAE\xB8" => "\xE6\x8D\x82",
		"\xAE\xB9" => "\xE6\x8D\x86",
		"\xAE\xBA" => "\xE6\x8D\x8F",
		"\xAE\xBB" => "\xE6\x8D\x89",
		"\xAE\xBC" => "\xE6\x8C\xBA",
		"\xAE\xBD" => "\xE6\x8D\x90",
		"\xAE\xBE" => "\xE6\x8C\xBD",
		"\xAE\xBF" => "\xE6\x8C\xAA",
		"\xAE\xC0" => "\xE6\x8C\xAB",
		"\xAE\xC1" => "\xE6\x8C\xA8",
		"\xAE\xC2" => "\xE6\x8D\x8D",
		"\xAE\xC3" => "\xE6\x8D\x8C",
		"\xAE\xC4" => "\xE6\x95\x88",
		"\xAE\xC5" => "\xE6\x95\x89",
		"\xAE\xC6" => "\xE6\x96\x99",
		"\xAE\xC7" => "\xE6\x97\x81",
		"\xAE\xC8" => "\xE6\x97\x85",
		"\xAE\xC9" => "\xE6\x99\x82",
		"\xAE\xCA" => "\xE6\x99\x89",
		"\xAE\xCB" => "\xE6\x99\x8F",
		"\xAE\xCC" => "\xE6\x99\x83",
		"\xAE\xCD" => "\xE6\x99\x92",
		"\xAE\xCE" => "\xE6\x99\x8C",
		"\xAE\xCF" => "\xE6\x99\x85",
		"\xAE\xD0" => "\xE6\x99\x81",
		"\xAE\xD1" => "\xE6\x9B\xB8",
		"\xAE\xD2" => "\xE6\x9C\x94",
		"\xAE\xD3" => "\xE6\x9C\x95",
		"\xAE\xD4" => "\xE6\x9C\x97",
		"\xAE\xD5" => "\xE6\xA0\xA1",
		"\xAE\xD6" => "\xE6\xA0\xB8",
		"\xAE\xD7" => "\xE6\xA1\x88",
		"\xAE\xD8" => "\xE6\xA1\x86",
		"\xAE\xD9" => "\xE6\xA1\x93",
		"\xAE\xDA" => "\xE6\xA0\xB9",
		"\xAE\xDB" => "\xE6\xA1\x82",
		"\xAE\xDC" => "\xE6\xA1\x94",
		"\xAE\xDD" => "\xE6\xA0\xA9",
		"\xAE\xDE" => "\xE6\xA2\xB3",
		"\xAE\xDF" => "\xE6\xA0\x97",
		"\xAE\xE0" => "\xE6\xA1\x8C",
		"\xAE\xE1" => "\xE6\xA1\x91",
		"\xAE\xE2" => "\xE6\xA0\xBD",
		"\xAE\xE3" => "\xE6\x9F\xB4",
		"\xAE\xE4" => "\xE6\xA1\x90",
		"\xAE\xE5" => "\xE6\xA1\x80",
		"\xAE\xE6" => "\xE6\xA0\xBC",
		"\xAE\xE7" => "\xE6\xA1\x83",
		"\xAE\xE8" => "\xE6\xA0\xAA",
		"\xAE\xE9" => "\xE6\xA1\x85",
		"\xAE\xEA" => "\xE6\xA0\x93",
		"\xAE\xEB" => "\xE6\xA0\x98",
		"\xAE\xEC" => "\xE6\xA1\x81",
		"\xAE\xED" => "\xE6\xAE\x8A",
		"\xAE\xEE" => "\xE6\xAE\x89",
		"\xAE\xEF" => "\xE6\xAE\xB7",
		"\xAE\xF0" => "\xE6\xB0\xA3",
		"\xAE\xF1" => "\xE6\xB0\xA7",
		"\xAE\xF2" => "\xE6\xB0\xA8",
		"\xAE\xF3" => "\xE6\xB0\xA6",
		"\xAE\xF4" => "\xE6\xB0\xA4",
		"\xAE\xF5" => "\xE6\xB3\xB0",
		"\xAE\xF6" => "\xE6\xB5\xAA",
		"\xAE\xF7" => "\xE6\xB6\x95",
		"\xAE\xF8" => "\xE6\xB6\x88",
		"\xAE\xF9" => "\xE6\xB6\x87",
		"\xAE\xFA" => "\xE6\xB5\xA6",
		"\xAE\xFB" => "\xE6\xB5\xB8",
		"\xAE\xFC" => "\xE6\xB5\xB7",
		"\xAE\xFD" => "\xE6\xB5\x99",
		"\xAE\xFE" => "\xE6\xB6\x93",
		"\xAF\x40" => "\xE6\xB5\xAC",
		"\xAF\x41" => "\xE6\xB6\x89",
		"\xAF\x42" => "\xE6\xB5\xAE",
		"\xAF\x43" => "\xE6\xB5\x9A",
		"\xAF\x44" => "\xE6\xB5\xB4",
		"\xAF\x45" => "\xE6\xB5\xA9",
		"\xAF\x46" => "\xE6\xB6\x8C",
		"\xAF\x47" => "\xE6\xB6\x8A",
		"\xAF\x48" => "\xE6\xB5\xB9",
		"\xAF\x49" => "\xE6\xB6\x85",
		"\xAF\x4A" => "\xE6\xB5\xA5",
		"\xAF\x4B" => "\xE6\xB6\x94",
		"\xAF\x4C" => "\xE7\x83\x8A",
		"\xAF\x4D" => "\xE7\x83\x98",
		"\xAF\x4E" => "\xE7\x83\xA4",
		"\xAF\x4F" => "\xE7\x83\x99",
		"\xAF\x50" => "\xE7\x83\x88",
		"\xAF\x51" => "\xE7\x83\x8F",
		"\xAF\x52" => "\xE7\x88\xB9",
		"\xAF\x53" => "\xE7\x89\xB9",
		"\xAF\x54" => "\xE7\x8B\xBC",
		"\xAF\x55" => "\xE7\x8B\xB9",
		"\xAF\x56" => "\xE7\x8B\xBD",
		"\xAF\x57" => "\xE7\x8B\xB8",
		"\xAF\x58" => "\xE7\x8B\xB7",
		"\xAF\x59" => "\xE7\x8E\x86",
		"\xAF\x5A" => "\xE7\x8F\xAD",
		"\xAF\x5B" => "\xE7\x90\x89",
		"\xAF\x5C" => "\xE7\x8F\xAE",
		"\xAF\x5D" => "\xE7\x8F\xA0",
		"\xAF\x5E" => "\xE7\x8F\xAA",
		"\xAF\x5F" => "\xE7\x8F\x9E",
		"\xAF\x60" => "\xE7\x95\x94",
		"\xAF\x61" => "\xE7\x95\x9D",
		"\xAF\x62" => "\xE7\x95\x9C",
		"\xAF\x63" => "\xE7\x95\x9A",
		"\xAF\x64" => "\xE7\x95\x99",
		"\xAF\x65" => "\xE7\x96\xBE",
		"\xAF\x66" => "\xE7\x97\x85",
		"\xAF\x67" => "\xE7\x97\x87",
		"\xAF\x68" => "\xE7\x96\xB2",
		"\xAF\x69" => "\xE7\x96\xB3",
		"\xAF\x6A" => "\xE7\x96\xBD",
		"\xAF\x6B" => "\xE7\x96\xBC",
		"\xAF\x6C" => "\xE7\x96\xB9",
		"\xAF\x6D" => "\xE7\x97\x82",
		"\xAF\x6E" => "\xE7\x96\xB8",
		"\xAF\x6F" => "\xE7\x9A\x8B",
		"\xAF\x70" => "\xE7\x9A\xB0",
		"\xAF\x71" => "\xE7\x9B\x8A",
		"\xAF\x72" => "\xE7\x9B\x8D",
		"\xAF\x73" => "\xE7\x9B\x8E",
		"\xAF\x74" => "\xE7\x9C\xA9",
		"\xAF\x75" => "\xE7\x9C\x9F",
		"\xAF\x76" => "\xE7\x9C\xA0",
		"\xAF\x77" => "\xE7\x9C\xA8",
		"\xAF\x78" => "\xE7\x9F\xA9",
		"\xAF\x79" => "\xE7\xA0\xB0",
		"\xAF\x7A" => "\xE7\xA0\xA7",
		"\xAF\x7B" => "\xE7\xA0\xB8",
		"\xAF\x7C" => "\xE7\xA0\x9D",
		"\xAF\x7D" => "\xE7\xA0\xB4",
		"\xAF\x7E" => "\xE7\xA0\xB7",
		"\xAF\xA1" => "\xE7\xA0\xA5",
		"\xAF\xA2" => "\xE7\xA0\xAD",
		"\xAF\xA3" => "\xE7\xA0\xA0",
		"\xAF\xA4" => "\xE7\xA0\x9F",
		"\xAF\xA5" => "\xE7\xA0\xB2",
		"\xAF\xA6" => "\xE7\xA5\x95",
		"\xAF\xA7" => "\xE7\xA5\x90",
		"\xAF\xA8" => "\xE7\xA5\xA0",
		"\xAF\xA9" => "\xE7\xA5\x9F",
		"\xAF\xAA" => "\xE7\xA5\x96",
		"\xAF\xAB" => "\xE7\xA5\x9E",
		"\xAF\xAC" => "\xE7\xA5\x9D",
		"\xAF\xAD" => "\xE7\xA5\x97",
		"\xAF\xAE" => "\xE7\xA5\x9A",
		"\xAF\xAF" => "\xE7\xA7\xA4",
		"\xAF\xB0" => "\xE7\xA7\xA3",
		"\xAF\xB1" => "\xE7\xA7\xA7",
		"\xAF\xB2" => "\xE7\xA7\x9F",
		"\xAF\xB3" => "\xE7\xA7\xA6",
		"\xAF\xB4" => "\xE7\xA7\xA9",
		"\xAF\xB5" => "\xE7\xA7\x98",
		"\xAF\xB6" => "\xE7\xAA\x84",
		"\xAF\xB7" => "\xE7\xAA\x88",
		"\xAF\xB8" => "\xE7\xAB\x99",
		"\xAF\xB9" => "\xE7\xAC\x86",
		"\xAF\xBA" => "\xE7\xAC\x91",
		"\xAF\xBB" => "\xE7\xB2\x89",
		"\xAF\xBC" => "\xE7\xB4\xA1",
		"\xAF\xBD" => "\xE7\xB4\x97",
		"\xAF\xBE" => "\xE7\xB4\x8B",
		"\xAF\xBF" => "\xE7\xB4\x8A",
		"\xAF\xC0" => "\xE7\xB4\xA0",
		"\xAF\xC1" => "\xE7\xB4\xA2",
		"\xAF\xC2" => "\xE7\xB4\x94",
		"\xAF\xC3" => "\xE7\xB4\x90",
		"\xAF\xC4" => "\xE7\xB4\x95",
		"\xAF\xC5" => "\xE7\xB4\x9A",
		"\xAF\xC6" => "\xE7\xB4\x9C",
		"\xAF\xC7" => "\xE7\xB4\x8D",
		"\xAF\xC8" => "\xE7\xB4\x99",
		"\xAF\xC9" => "\xE7\xB4\x9B",
		"\xAF\xCA" => "\xE7\xBC\xBA",
		"\xAF\xCB" => "\xE7\xBD\x9F",
		"\xAF\xCC" => "\xE7\xBE\x94",
		"\xAF\xCD" => "\xE7\xBF\x85",
		"\xAF\xCE" => "\xE7\xBF\x81",
		"\xAF\xCF" => "\xE8\x80\x86",
		"\xAF\xD0" => "\xE8\x80\x98",
		"\xAF\xD1" => "\xE8\x80\x95",
		"\xAF\xD2" => "\xE8\x80\x99",
		"\xAF\xD3" => "\xE8\x80\x97",
		"\xAF\xD4" => "\xE8\x80\xBD",
		"\xAF\xD5" => "\xE8\x80\xBF",
		"\xAF\xD6" => "\xE8\x83\xB1",
		"\xAF\xD7" => "\xE8\x84\x82",
		"\xAF\xD8" => "\xE8\x83\xB0",
		"\xAF\xD9" => "\xE8\x84\x85",
		"\xAF\xDA" => "\xE8\x83\xAD",
		"\xAF\xDB" => "\xE8\x83\xB4",
		"\xAF\xDC" => "\xE8\x84\x86",
		"\xAF\xDD" => "\xE8\x83\xB8",
		"\xAF\xDE" => "\xE8\x83\xB3",
		"\xAF\xDF" => "\xE8\x84\x88",
		"\xAF\xE0" => "\xE8\x83\xBD",
		"\xAF\xE1" => "\xE8\x84\x8A",
		"\xAF\xE2" => "\xE8\x83\xBC",
		"\xAF\xE3" => "\xE8\x83\xAF",
		"\xAF\xE4" => "\xE8\x87\xAD",
		"\xAF\xE5" => "\xE8\x87\xAC",
		"\xAF\xE6" => "\xE8\x88\x80",
		"\xAF\xE7" => "\xE8\x88\x90",
		"\xAF\xE8" => "\xE8\x88\xAA",
		"\xAF\xE9" => "\xE8\x88\xAB",
		"\xAF\xEA" => "\xE8\x88\xA8",
		"\xAF\xEB" => "\xE8\x88\xAC",
		"\xAF\xEC" => "\xE8\x8A\xBB",
		"\xAF\xED" => "\xE8\x8C\xAB",
		"\xAF\xEE" => "\xE8\x8D\x92",
		"\xAF\xEF" => "\xE8\x8D\x94",
		"\xAF\xF0" => "\xE8\x8D\x8A",
		"\xAF\xF1" => "\xE8\x8C\xB8",
		"\xAF\xF2" => "\xE8\x8D\x90",
		"\xAF\xF3" => "\xE8\x8D\x89",
		"\xAF\xF4" => "\xE8\x8C\xB5",
		"\xAF\xF5" => "\xE8\x8C\xB4",
		"\xAF\xF6" => "\xE8\x8D\x8F",
		"\xAF\xF7" => "\xE8\x8C\xB2",
		"\xAF\xF8" => "\xE8\x8C\xB9",
		"\xAF\xF9" => "\xE8\x8C\xB6",
		"\xAF\xFA" => "\xE8\x8C\x97",
		"\xAF\xFB" => "\xE8\x8D\x80",
		"\xAF\xFC" => "\xE8\x8C\xB1",
		"\xAF\xFD" => "\xE8\x8C\xA8",
		"\xAF\xFE" => "\xE8\x8D\x83",
		"\xB0\x40" => "\xE8\x99\x94",
		"\xB0\x41" => "\xE8\x9A\x8A",
		"\xB0\x42" => "\xE8\x9A\xAA",
		"\xB0\x43" => "\xE8\x9A\x93",
		"\xB0\x44" => "\xE8\x9A\xA4",
		"\xB0\x45" => "\xE8\x9A\xA9",
		"\xB0\x46" => "\xE8\x9A\x8C",
		"\xB0\x47" => "\xE8\x9A\xA3",
		"\xB0\x48" => "\xE8\x9A\x9C",
		"\xB0\x49" => "\xE8\xA1\xB0",
		"\xB0\x4A" => "\xE8\xA1\xB7",
		"\xB0\x4B" => "\xE8\xA2\x81",
		"\xB0\x4C" => "\xE8\xA2\x82",
		"\xB0\x4D" => "\xE8\xA1\xBD",
		"\xB0\x4E" => "\xE8\xA1\xB9",
		"\xB0\x4F" => "\xE8\xA8\x98",
		"\xB0\x50" => "\xE8\xA8\x90",
		"\xB0\x51" => "\xE8\xA8\x8E",
		"\xB0\x52" => "\xE8\xA8\x8C",
		"\xB0\x53" => "\xE8\xA8\x95",
		"\xB0\x54" => "\xE8\xA8\x8A",
		"\xB0\x55" => "\xE8\xA8\x97",
		"\xB0\x56" => "\xE8\xA8\x93",
		"\xB0\x57" => "\xE8\xA8\x96",
		"\xB0\x58" => "\xE8\xA8\x8F",
		"\xB0\x59" => "\xE8\xA8\x91",
		"\xB0\x5A" => "\xE8\xB1\x88",
		"\xB0\x5B" => "\xE8\xB1\xBA",
		"\xB0\x5C" => "\xE8\xB1\xB9",
		"\xB0\x5D" => "\xE8\xB2\xA1",
		"\xB0\x5E" => "\xE8\xB2\xA2",
		"\xB0\x5F" => "\xE8\xB5\xB7",
		"\xB0\x60" => "\xE8\xBA\xAC",
		"\xB0\x61" => "\xE8\xBB\x92",
		"\xB0\x62" => "\xE8\xBB\x94",
		"\xB0\x63" => "\xE8\xBB\x8F",
		"\xB0\x64" => "\xE8\xBE\xB1",
		"\xB0\x65" => "\xE9\x80\x81",
		"\xB0\x66" => "\xE9\x80\x86",
		"\xB0\x67" => "\xE8\xBF\xB7",
		"\xB0\x68" => "\xE9\x80\x80",
		"\xB0\x69" => "\xE8\xBF\xBA",
		"\xB0\x6A" => "\xE8\xBF\xB4",
		"\xB0\x6B" => "\xE9\x80\x83",
		"\xB0\x6C" => "\xE8\xBF\xBD",
		"\xB0\x6D" => "\xE9\x80\x85",
		"\xB0\x6E" => "\xE8\xBF\xB8",
		"\xB0\x6F" => "\xE9\x82\x95",
		"\xB0\x70" => "\xE9\x83\xA1",
		"\xB0\x71" => "\xE9\x83\x9D",
		"\xB0\x72" => "\xE9\x83\xA2",
		"\xB0\x73" => "\xE9\x85\x92",
		"\xB0\x74" => "\xE9\x85\x8D",
		"\xB0\x75" => "\xE9\x85\x8C",
		"\xB0\x76" => "\xE9\x87\x98",
		"\xB0\x77" => "\xE9\x87\x9D",
		"\xB0\x78" => "\xE9\x87\x97",
		"\xB0\x79" => "\xE9\x87\x9C",
		"\xB0\x7A" => "\xE9\x87\x99",
		"\xB0\x7B" => "\xE9\x96\x83",
		"\xB0\x7C" => "\xE9\x99\xA2",
		"\xB0\x7D" => "\xE9\x99\xA3",
		"\xB0\x7E" => "\xE9\x99\xA1",
		"\xB0\xA1" => "\xE9\x99\x9B",
		"\xB0\xA2" => "\xE9\x99\x9D",
		"\xB0\xA3" => "\xE9\x99\xA4",
		"\xB0\xA4" => "\xE9\x99\x98",
		"\xB0\xA5" => "\xE9\x99\x9E",
		"\xB0\xA6" => "\xE9\x9A\xBB",
		"\xB0\xA7" => "\xE9\xA3\xA2",
		"\xB0\xA8" => "\xE9\xA6\xAC",
		"\xB0\xA9" => "\xE9\xAA\xA8",
		"\xB0\xAA" => "\xE9\xAB\x98",
		"\xB0\xAB" => "\xE9\xAC\xA5",
		"\xB0\xAC" => "\xE9\xAC\xB2",
		"\xB0\xAD" => "\xE9\xAC\xBC",
		"\xB0\xAE" => "\xE4\xB9\xBE",
		"\xB0\xAF" => "\xE5\x81\xBA",
		"\xB0\xB0" => "\xE5\x81\xBD",
		"\xB0\xB1" => "\xE5\x81\x9C",
		"\xB0\xB2" => "\xE5\x81\x87",
		"\xB0\xB3" => "\xE5\x81\x83",
		"\xB0\xB4" => "\xE5\x81\x8C",
		"\xB0\xB5" => "\xE5\x81\x9A",
		"\xB0\xB6" => "\xE5\x81\x89",
		"\xB0\xB7" => "\xE5\x81\xA5",
		"\xB0\xB8" => "\xE5\x81\xB6",
		"\xB0\xB9" => "\xE5\x81\x8E",
		"\xB0\xBA" => "\xE5\x81\x95",
		"\xB0\xBB" => "\xE5\x81\xB5",
		"\xB0\xBC" => "\xE5\x81\xB4",
		"\xB0\xBD" => "\xE5\x81\xB7",
		"\xB0\xBE" => "\xE5\x81\x8F",
		"\xB0\xBF" => "\xE5\x80\x8F",
		"\xB0\xC0" => "\xE5\x81\xAF",
		"\xB0\xC1" => "\xE5\x81\xAD",
		"\xB0\xC2" => "\xE5\x85\x9C",
		"\xB0\xC3" => "\xE5\x86\x95",
		"\xB0\xC4" => "\xE5\x87\xB0",
		"\xB0\xC5" => "\xE5\x89\xAA",
		"\xB0\xC6" => "\xE5\x89\xAF",
		"\xB0\xC7" => "\xE5\x8B\x92",
		"\xB0\xC8" => "\xE5\x8B\x99",
		"\xB0\xC9" => "\xE5\x8B\x98",
		"\xB0\xCA" => "\xE5\x8B\x95",
		"\xB0\xCB" => "\xE5\x8C\x90",
		"\xB0\xCC" => "\xE5\x8C\x8F",
		"\xB0\xCD" => "\xE5\x8C\x99",
		"\xB0\xCE" => "\xE5\x8C\xBF",
		"\xB0\xCF" => "\xE5\x8D\x80",
		"\xB0\xD0" => "\xE5\x8C\xBE",
		"\xB0\xD1" => "\xE5\x8F\x83",
		"\xB0\xD2" => "\xE6\x9B\xBC",
		"\xB0\xD3" => "\xE5\x95\x86",
		"\xB0\xD4" => "\xE5\x95\xAA",
		"\xB0\xD5" => "\xE5\x95\xA6",
		"\xB0\xD6" => "\xE5\x95\x84",
		"\xB0\xD7" => "\xE5\x95\x9E",
		"\xB0\xD8" => "\xE5\x95\xA1",
		"\xB0\xD9" => "\xE5\x95\x83",
		"\xB0\xDA" => "\xE5\x95\x8A",
		"\xB0\xDB" => "\xE5\x94\xB1",
		"\xB0\xDC" => "\xE5\x95\x96",
		"\xB0\xDD" => "\xE5\x95\x8F",
		"\xB0\xDE" => "\xE5\x95\x95",
		"\xB0\xDF" => "\xE5\x94\xAF",
		"\xB0\xE0" => "\xE5\x95\xA4",
		"\xB0\xE1" => "\xE5\x94\xB8",
		"\xB0\xE2" => "\xE5\x94\xAE",
		"\xB0\xE3" => "\xE5\x95\x9C",
		"\xB0\xE4" => "\xE5\x94\xAC",
		"\xB0\xE5" => "\xE5\x95\xA3",
		"\xB0\xE6" => "\xE5\x94\xB3",
		"\xB0\xE7" => "\xE5\x95\x81",
		"\xB0\xE8" => "\xE5\x95\x97",
		"\xB0\xE9" => "\xE5\x9C\x88",
		"\xB0\xEA" => "\xE5\x9C\x8B",
		"\xB0\xEB" => "\xE5\x9C\x89",
		"\xB0\xEC" => "\xE5\x9F\x9F",
		"\xB0\xED" => "\xE5\xA0\x85",
		"\xB0\xEE" => "\xE5\xA0\x8A",
		"\xB0\xEF" => "\xE5\xA0\x86",
		"\xB0\xF0" => "\xE5\x9F\xA0",
		"\xB0\xF1" => "\xE5\x9F\xA4",
		"\xB0\xF2" => "\xE5\x9F\xBA",
		"\xB0\xF3" => "\xE5\xA0\x82",
		"\xB0\xF4" => "\xE5\xA0\xB5",
		"\xB0\xF5" => "\xE5\x9F\xB7",
		"\xB0\xF6" => "\xE5\x9F\xB9",
		"\xB0\xF7" => "\xE5\xA4\xA0",
		"\xB0\xF8" => "\xE5\xA5\xA2",
		"\xB0\xF9" => "\xE5\xA8\xB6",
		"\xB0\xFA" => "\xE5\xA9\x81",
		"\xB0\xFB" => "\xE5\xA9\x89",
		"\xB0\xFC" => "\xE5\xA9\xA6",
		"\xB0\xFD" => "\xE5\xA9\xAA",
		"\xB0\xFE" => "\xE5\xA9\x80",
		"\xB1\x40" => "\xE5\xA8\xBC",
		"\xB1\x41" => "\xE5\xA9\xA2",
		"\xB1\x42" => "\xE5\xA9\x9A",
		"\xB1\x43" => "\xE5\xA9\x86",
		"\xB1\x44" => "\xE5\xA9\x8A",
		"\xB1\x45" => "\xE5\xAD\xB0",
		"\xB1\x46" => "\xE5\xAF\x87",
		"\xB1\x47" => "\xE5\xAF\x85",
		"\xB1\x48" => "\xE5\xAF\x84",
		"\xB1\x49" => "\xE5\xAF\x82",
		"\xB1\x4A" => "\xE5\xAE\xBF",
		"\xB1\x4B" => "\xE5\xAF\x86",
		"\xB1\x4C" => "\xE5\xB0\x89",
		"\xB1\x4D" => "\xE5\xB0\x88",
		"\xB1\x4E" => "\xE5\xB0\x87",
		"\xB1\x4F" => "\xE5\xB1\xA0",
		"\xB1\x50" => "\xE5\xB1\x9C",
		"\xB1\x51" => "\xE5\xB1\x9D",
		"\xB1\x52" => "\xE5\xB4\x87",
		"\xB1\x53" => "\xE5\xB4\x86",
		"\xB1\x54" => "\xE5\xB4\x8E",
		"\xB1\x55" => "\xE5\xB4\x9B",
		"\xB1\x56" => "\xE5\xB4\x96",
		"\xB1\x57" => "\xE5\xB4\xA2",
		"\xB1\x58" => "\xE5\xB4\x91",
		"\xB1\x59" => "\xE5\xB4\xA9",
		"\xB1\x5A" => "\xE5\xB4\x94",
		"\xB1\x5B" => "\xE5\xB4\x99",
		"\xB1\x5C" => "\xE5\xB4\xA4",
		"\xB1\x5D" => "\xE5\xB4\xA7",
		"\xB1\x5E" => "\xE5\xB4\x97",
		"\xB1\x5F" => "\xE5\xB7\xA2",
		"\xB1\x60" => "\xE5\xB8\xB8",
		"\xB1\x61" => "\xE5\xB8\xB6",
		"\xB1\x62" => "\xE5\xB8\xB3",
		"\xB1\x63" => "\xE5\xB8\xB7",
		"\xB1\x64" => "\xE5\xBA\xB7",
		"\xB1\x65" => "\xE5\xBA\xB8",
		"\xB1\x66" => "\xE5\xBA\xB6",
		"\xB1\x67" => "\xE5\xBA\xB5",
		"\xB1\x68" => "\xE5\xBA\xBE",
		"\xB1\x69" => "\xE5\xBC\xB5",
		"\xB1\x6A" => "\xE5\xBC\xB7",
		"\xB1\x6B" => "\xE5\xBD\x97",
		"\xB1\x6C" => "\xE5\xBD\xAC",
		"\xB1\x6D" => "\xE5\xBD\xA9",
		"\xB1\x6E" => "\xE5\xBD\xAB",
		"\xB1\x6F" => "\xE5\xBE\x97",
		"\xB1\x70" => "\xE5\xBE\x99",
		"\xB1\x71" => "\xE5\xBE\x9E",
		"\xB1\x72" => "\xE5\xBE\x98",
		"\xB1\x73" => "\xE5\xBE\xA1",
		"\xB1\x74" => "\xE5\xBE\xA0",
		"\xB1\x75" => "\xE5\xBE\x9C",
		"\xB1\x76" => "\xE6\x81\xBF",
		"\xB1\x77" => "\xE6\x82\xA3",
		"\xB1\x78" => "\xE6\x82\x89",
		"\xB1\x79" => "\xE6\x82\xA0",
		"\xB1\x7A" => "\xE6\x82\xA8",
		"\xB1\x7B" => "\xE6\x83\x8B",
		"\xB1\x7C" => "\xE6\x82\xB4",
		"\xB1\x7D" => "\xE6\x83\xA6",
		"\xB1\x7E" => "\xE6\x82\xBD",
		"\xB1\xA1" => "\xE6\x83\x85",
		"\xB1\xA2" => "\xE6\x82\xBB",
		"\xB1\xA3" => "\xE6\x82\xB5",
		"\xB1\xA4" => "\xE6\x83\x9C",
		"\xB1\xA5" => "\xE6\x82\xBC",
		"\xB1\xA6" => "\xE6\x83\x98",
		"\xB1\xA7" => "\xE6\x83\x95",
		"\xB1\xA8" => "\xE6\x83\x86",
		"\xB1\xA9" => "\xE6\x83\x9F",
		"\xB1\xAA" => "\xE6\x82\xB8",
		"\xB1\xAB" => "\xE6\x83\x9A",
		"\xB1\xAC" => "\xE6\x83\x87",
		"\xB1\xAD" => "\xE6\x88\x9A",
		"\xB1\xAE" => "\xE6\x88\x9B",
		"\xB1\xAF" => "\xE6\x89\x88",
		"\xB1\xB0" => "\xE6\x8E\xA0",
		"\xB1\xB1" => "\xE6\x8E\xA7",
		"\xB1\xB2" => "\xE6\x8D\xB2",
		"\xB1\xB3" => "\xE6\x8E\x96",
		"\xB1\xB4" => "\xE6\x8E\xA2",
		"\xB1\xB5" => "\xE6\x8E\xA5",
		"\xB1\xB6" => "\xE6\x8D\xB7",
		"\xB1\xB7" => "\xE6\x8D\xA7",
		"\xB1\xB8" => "\xE6\x8E\x98",
		"\xB1\xB9" => "\xE6\x8E\xAA",
		"\xB1\xBA" => "\xE6\x8D\xB1",
		"\xB1\xBB" => "\xE6\x8E\xA9",
		"\xB1\xBC" => "\xE6\x8E\x89",
		"\xB1\xBD" => "\xE6\x8E\x83",
		"\xB1\xBE" => "\xE6\x8E\x9B",
		"\xB1\xBF" => "\xE6\x8D\xAB",
		"\xB1\xC0" => "\xE6\x8E\xA8",
		"\xB1\xC1" => "\xE6\x8E\x84",
		"\xB1\xC2" => "\xE6\x8E\x88",
		"\xB1\xC3" => "\xE6\x8E\x99",
		"\xB1\xC4" => "\xE6\x8E\xA1",
		"\xB1\xC5" => "\xE6\x8E\xAC",
		"\xB1\xC6" => "\xE6\x8E\x92",
		"\xB1\xC7" => "\xE6\x8E\x8F",
		"\xB1\xC8" => "\xE6\x8E\x80",
		"\xB1\xC9" => "\xE6\x8D\xBB",
		"\xB1\xCA" => "\xE6\x8D\xA9",
		"\xB1\xCB" => "\xE6\x8D\xA8",
		"\xB1\xCC" => "\xE6\x8D\xBA",
		"\xB1\xCD" => "\xE6\x95\x9D",
		"\xB1\xCE" => "\xE6\x95\x96",
		"\xB1\xCF" => "\xE6\x95\x91",
		"\xB1\xD0" => "\xE6\x95\x99",
		"\xB1\xD1" => "\xE6\x95\x97",
		"\xB1\xD2" => "\xE5\x95\x9F",
		"\xB1\xD3" => "\xE6\x95\x8F",
		"\xB1\xD4" => "\xE6\x95\x98",
		"\xB1\xD5" => "\xE6\x95\x95",
		"\xB1\xD6" => "\xE6\x95\x94",
		"\xB1\xD7" => "\xE6\x96\x9C",
		"\xB1\xD8" => "\xE6\x96\x9B",
		"\xB1\xD9" => "\xE6\x96\xAC",
		"\xB1\xDA" => "\xE6\x97\x8F",
		"\xB1\xDB" => "\xE6\x97\x8B",
		"\xB1\xDC" => "\xE6\x97\x8C",
		"\xB1\xDD" => "\xE6\x97\x8E",
		"\xB1\xDE" => "\xE6\x99\x9D",
		"\xB1\xDF" => "\xE6\x99\x9A",
		"\xB1\xE0" => "\xE6\x99\xA4",
		"\xB1\xE1" => "\xE6\x99\xA8",
		"\xB1\xE2" => "\xE6\x99\xA6",
		"\xB1\xE3" => "\xE6\x99\x9E",
		"\xB1\xE4" => "\xE6\x9B\xB9",
		"\xB1\xE5" => "\xE5\x8B\x97",
		"\xB1\xE6" => "\xE6\x9C\x9B",
		"\xB1\xE7" => "\xE6\xA2\x81",
		"\xB1\xE8" => "\xE6\xA2\xAF",
		"\xB1\xE9" => "\xE6\xA2\xA2",
		"\xB1\xEA" => "\xE6\xA2\x93",
		"\xB1\xEB" => "\xE6\xA2\xB5",
		"\xB1\xEC" => "\xE6\xA1\xBF",
		"\xB1\xED" => "\xE6\xA1\xB6",
		"\xB1\xEE" => "\xE6\xA2\xB1",
		"\xB1\xEF" => "\xE6\xA2\xA7",
		"\xB1\xF0" => "\xE6\xA2\x97",
		"\xB1\xF1" => "\xE6\xA2\xB0",
		"\xB1\xF2" => "\xE6\xA2\x83",
		"\xB1\xF3" => "\xE6\xA3\x84",
		"\xB1\xF4" => "\xE6\xA2\xAD",
		"\xB1\xF5" => "\xE6\xA2\x86",
		"\xB1\xF6" => "\xE6\xA2\x85",
		"\xB1\xF7" => "\xE6\xA2\x94",
		"\xB1\xF8" => "\xE6\xA2\x9D",
		"\xB1\xF9" => "\xE6\xA2\xA8",
		"\xB1\xFA" => "\xE6\xA2\x9F",
		"\xB1\xFB" => "\xE6\xA2\xA1",
		"\xB1\xFC" => "\xE6\xA2\x82",
		"\xB1\xFD" => "\xE6\xAC\xB2",
		"\xB1\xFE" => "\xE6\xAE\xBA",
		"\xB2\x40" => "\xE6\xAF\xAB",
		"\xB2\x41" => "\xE6\xAF\xAC",
		"\xB2\x42" => "\xE6\xB0\xAB",
		"\xB2\x43" => "\xE6\xB6\x8E",
		"\xB2\x44" => "\xE6\xB6\xBC",
		"\xB2\x45" => "\xE6\xB7\xB3",
		"\xB2\x46" => "\xE6\xB7\x99",
		"\xB2\x47" => "\xE6\xB6\xB2",
		"\xB2\x48" => "\xE6\xB7\xA1",
		"\xB2\x49" => "\xE6\xB7\x8C",
		"\xB2\x4A" => "\xE6\xB7\xA4",
		"\xB2\x4B" => "\xE6\xB7\xBB",
		"\xB2\x4C" => "\xE6\xB7\xBA",
		"\xB2\x4D" => "\xE6\xB8\x85",
		"\xB2\x4E" => "\xE6\xB7\x87",
		"\xB2\x4F" => "\xE6\xB7\x8B",
		"\xB2\x50" => "\xE6\xB6\xAF",
		"\xB2\x51" => "\xE6\xB7\x91",
		"\xB2\x52" => "\xE6\xB6\xAE",
		"\xB2\x53" => "\xE6\xB7\x9E",
		"\xB2\x54" => "\xE6\xB7\xB9",
		"\xB2\x55" => "\xE6\xB6\xB8",
		"\xB2\x56" => "\xE6\xB7\xB7",
		"\xB2\x57" => "\xE6\xB7\xB5",
		"\xB2\x58" => "\xE6\xB7\x85",
		"\xB2\x59" => "\xE6\xB7\x92",
		"\xB2\x5A" => "\xE6\xB8\x9A",
		"\xB2\x5B" => "\xE6\xB6\xB5",
		"\xB2\x5C" => "\xE6\xB7\x9A",
		"\xB2\x5D" => "\xE6\xB7\xAB",
		"\xB2\x5E" => "\xE6\xB7\x98",
		"\xB2\x5F" => "\xE6\xB7\xAA",
		"\xB2\x60" => "\xE6\xB7\xB1",
		"\xB2\x61" => "\xE6\xB7\xAE",
		"\xB2\x62" => "\xE6\xB7\xA8",
		"\xB2\x63" => "\xE6\xB7\x86",
		"\xB2\x64" => "\xE6\xB7\x84",
		"\xB2\x65" => "\xE6\xB6\xAA",
		"\xB2\x66" => "\xE6\xB7\xAC",
		"\xB2\x67" => "\xE6\xB6\xBF",
		"\xB2\x68" => "\xE6\xB7\xA6",
		"\xB2\x69" => "\xE7\x83\xB9",
		"\xB2\x6A" => "\xE7\x84\x89",
		"\xB2\x6B" => "\xE7\x84\x8A",
		"\xB2\x6C" => "\xE7\x83\xBD",
		"\xB2\x6D" => "\xE7\x83\xAF",
		"\xB2\x6E" => "\xE7\x88\xBD",
		"\xB2\x6F" => "\xE7\x89\xBD",
		"\xB2\x70" => "\xE7\x8A\x81",
		"\xB2\x71" => "\xE7\x8C\x9C",
		"\xB2\x72" => "\xE7\x8C\x9B",
		"\xB2\x73" => "\xE7\x8C\x96",
		"\xB2\x74" => "\xE7\x8C\x93",
		"\xB2\x75" => "\xE7\x8C\x99",
		"\xB2\x76" => "\xE7\x8E\x87",
		"\xB2\x77" => "\xE7\x90\x85",
		"\xB2\x78" => "\xE7\x90\x8A",
		"\xB2\x79" => "\xE7\x90\x83",
		"\xB2\x7A" => "\xE7\x90\x86",
		"\xB2\x7B" => "\xE7\x8F\xBE",
		"\xB2\x7C" => "\xE7\x90\x8D",
		"\xB2\x7D" => "\xE7\x93\xA0",
		"\xB2\x7E" => "\xE7\x93\xB6",
		"\xB2\xA1" => "\xE7\x93\xB7",
		"\xB2\xA2" => "\xE7\x94\x9C",
		"\xB2\xA3" => "\xE7\x94\xA2",
		"\xB2\xA4" => "\xE7\x95\xA5",
		"\xB2\xA5" => "\xE7\x95\xA6",
		"\xB2\xA6" => "\xE7\x95\xA2",
		"\xB2\xA7" => "\xE7\x95\xB0",
		"\xB2\xA8" => "\xE7\x96\x8F",
		"\xB2\xA9" => "\xE7\x97\x94",
		"\xB2\xAA" => "\xE7\x97\x95",
		"\xB2\xAB" => "\xE7\x96\xB5",
		"\xB2\xAC" => "\xE7\x97\x8A",
		"\xB2\xAD" => "\xE7\x97\x8D",
		"\xB2\xAE" => "\xE7\x9A\x8E",
		"\xB2\xAF" => "\xE7\x9B\x94",
		"\xB2\xB0" => "\xE7\x9B\x92",
		"\xB2\xB1" => "\xE7\x9B\x9B",
		"\xB2\xB2" => "\xE7\x9C\xB7",
		"\xB2\xB3" => "\xE7\x9C\xBE",
		"\xB2\xB4" => "\xE7\x9C\xBC",
		"\xB2\xB5" => "\xE7\x9C\xB6",
		"\xB2\xB6" => "\xE7\x9C\xB8",
		"\xB2\xB7" => "\xE7\x9C\xBA",
		"\xB2\xB8" => "\xE7\xA1\xAB",
		"\xB2\xB9" => "\xE7\xA1\x83",
		"\xB2\xBA" => "\xE7\xA1\x8E",
		"\xB2\xBB" => "\xE7\xA5\xA5",
		"\xB2\xBC" => "\xE7\xA5\xA8",
		"\xB2\xBD" => "\xE7\xA5\xAD",
		"\xB2\xBE" => "\xE7\xA7\xBB",
		"\xB2\xBF" => "\xE7\xAA\x92",
		"\xB2\xC0" => "\xE7\xAA\x95",
		"\xB2\xC1" => "\xE7\xAC\xA0",
		"\xB2\xC2" => "\xE7\xAC\xA8",
		"\xB2\xC3" => "\xE7\xAC\x9B",
		"\xB2\xC4" => "\xE7\xAC\xAC",
		"\xB2\xC5" => "\xE7\xAC\xA6",
		"\xB2\xC6" => "\xE7\xAC\x99",
		"\xB2\xC7" => "\xE7\xAC\x9E",
		"\xB2\xC8" => "\xE7\xAC\xAE",
		"\xB2\xC9" => "\xE7\xB2\x92",
		"\xB2\xCA" => "\xE7\xB2\x97",
		"\xB2\xCB" => "\xE7\xB2\x95",
		"\xB2\xCC" => "\xE7\xB5\x86",
		"\xB2\xCD" => "\xE7\xB5\x83",
		"\xB2\xCE" => "\xE7\xB5\xB1",
		"\xB2\xCF" => "\xE7\xB4\xAE",
		"\xB2\xD0" => "\xE7\xB4\xB9",
		"\xB2\xD1" => "\xE7\xB4\xBC",
		"\xB2\xD2" => "\xE7\xB5\x80",
		"\xB2\xD3" => "\xE7\xB4\xB0",
		"\xB2\xD4" => "\xE7\xB4\xB3",
		"\xB2\xD5" => "\xE7\xB5\x84",
		"\xB2\xD6" => "\xE7\xB4\xAF",
		"\xB2\xD7" => "\xE7\xB5\x82",
		"\xB2\xD8" => "\xE7\xB4\xB2",
		"\xB2\xD9" => "\xE7\xB4\xB1",
		"\xB2\xDA" => "\xE7\xBC\xBD",
		"\xB2\xDB" => "\xE7\xBE\x9E",
		"\xB2\xDC" => "\xE7\xBE\x9A",
		"\xB2\xDD" => "\xE7\xBF\x8C",
		"\xB2\xDE" => "\xE7\xBF\x8E",
		"\xB2\xDF" => "\xE7\xBF\x92",
		"\xB2\xE0" => "\xE8\x80\x9C",
		"\xB2\xE1" => "\xE8\x81\x8A",
		"\xB2\xE2" => "\xE8\x81\x86",
		"\xB2\xE3" => "\xE8\x84\xAF",
		"\xB2\xE4" => "\xE8\x84\x96",
		"\xB2\xE5" => "\xE8\x84\xA3",
		"\xB2\xE6" => "\xE8\x84\xAB",
		"\xB2\xE7" => "\xE8\x84\xA9",
		"\xB2\xE8" => "\xE8\x84\xB0",
		"\xB2\xE9" => "\xE8\x84\xA4",
		"\xB2\xEA" => "\xE8\x88\x82",
		"\xB2\xEB" => "\xE8\x88\xB5",
		"\xB2\xEC" => "\xE8\x88\xB7",
		"\xB2\xED" => "\xE8\x88\xB6",
		"\xB2\xEE" => "\xE8\x88\xB9",
		"\xB2\xEF" => "\xE8\x8E\x8E",
		"\xB2\xF0" => "\xE8\x8E\x9E",
		"\xB2\xF1" => "\xE8\x8E\x98",
		"\xB2\xF2" => "\xE8\x8D\xB8",
		"\xB2\xF3" => "\xE8\x8E\xA2",
		"\xB2\xF4" => "\xE8\x8E\x96",
		"\xB2\xF5" => "\xE8\x8E\xBD",
		"\xB2\xF6" => "\xE8\x8E\xAB",
		"\xB2\xF7" => "\xE8\x8E\x92",
		"\xB2\xF8" => "\xE8\x8E\x8A",
		"\xB2\xF9" => "\xE8\x8E\x93",
		"\xB2\xFA" => "\xE8\x8E\x89",
		"\xB2\xFB" => "\xE8\x8E\xA0",
		"\xB2\xFC" => "\xE8\x8D\xB7",
		"\xB2\xFD" => "\xE8\x8D\xBB",
		"\xB2\xFE" => "\xE8\x8D\xBC",
		"\xB3\x40" => "\xE8\x8E\x86",
		"\xB3\x41" => "\xE8\x8E\xA7",
		"\xB3\x42" => "\xE8\x99\x95",
		"\xB3\x43" => "\xE5\xBD\xAA",
		"\xB3\x44" => "\xE8\x9B\x87",
		"\xB3\x45" => "\xE8\x9B\x80",
		"\xB3\x46" => "\xE8\x9A\xB6",
		"\xB3\x47" => "\xE8\x9B\x84",
		"\xB3\x48" => "\xE8\x9A\xB5",
		"\xB3\x49" => "\xE8\x9B\x86",
		"\xB3\x4A" => "\xE8\x9B\x8B",
		"\xB3\x4B" => "\xE8\x9A\xB1",
		"\xB3\x4C" => "\xE8\x9A\xAF",
		"\xB3\x4D" => "\xE8\x9B\x89",
		"\xB3\x4E" => "\xE8\xA1\x93",
		"\xB3\x4F" => "\xE8\xA2\x9E",
		"\xB3\x50" => "\xE8\xA2\x88",
		"\xB3\x51" => "\xE8\xA2\xAB",
		"\xB3\x52" => "\xE8\xA2\x92",
		"\xB3\x53" => "\xE8\xA2\x96",
		"\xB3\x54" => "\xE8\xA2\x8D",
		"\xB3\x55" => "\xE8\xA2\x8B",
		"\xB3\x56" => "\xE8\xA6\x93",
		"\xB3\x57" => "\xE8\xA6\x8F",
		"\xB3\x58" => "\xE8\xA8\xAA",
		"\xB3\x59" => "\xE8\xA8\x9D",
		"\xB3\x5A" => "\xE8\xA8\xA3",
		"\xB3\x5B" => "\xE8\xA8\xA5",
		"\xB3\x5C" => "\xE8\xA8\xB1",
		"\xB3\x5D" => "\xE8\xA8\xAD",
		"\xB3\x5E" => "\xE8\xA8\x9F",
		"\xB3\x5F" => "\xE8\xA8\x9B",
		"\xB3\x60" => "\xE8\xA8\xA2",
		"\xB3\x61" => "\xE8\xB1\x89",
		"\xB3\x62" => "\xE8\xB1\x9A",
		"\xB3\x63" => "\xE8\xB2\xA9",
		"\xB3\x64" => "\xE8\xB2\xAC",
		"\xB3\x65" => "\xE8\xB2\xAB",
		"\xB3\x66" => "\xE8\xB2\xA8",
		"\xB3\x67" => "\xE8\xB2\xAA",
		"\xB3\x68" => "\xE8\xB2\xA7",
		"\xB3\x69" => "\xE8\xB5\xA7",
		"\xB3\x6A" => "\xE8\xB5\xA6",
		"\xB3\x6B" => "\xE8\xB6\xBE",
		"\xB3\x6C" => "\xE8\xB6\xBA",
		"\xB3\x6D" => "\xE8\xBB\x9B",
		"\xB3\x6E" => "\xE8\xBB\x9F",
		"\xB3\x6F" => "\xE9\x80\x99",
		"\xB3\x70" => "\xE9\x80\x8D",
		"\xB3\x71" => "\xE9\x80\x9A",
		"\xB3\x72" => "\xE9\x80\x97",
		"\xB3\x73" => "\xE9\x80\xA3",
		"\xB3\x74" => "\xE9\x80\x9F",
		"\xB3\x75" => "\xE9\x80\x9D",
		"\xB3\x76" => "\xE9\x80\x90",
		"\xB3\x77" => "\xE9\x80\x95",
		"\xB3\x78" => "\xE9\x80\x9E",
		"\xB3\x79" => "\xE9\x80\xA0",
		"\xB3\x7A" => "\xE9\x80\x8F",
		"\xB3\x7B" => "\xE9\x80\xA2",
		"\xB3\x7C" => "\xE9\x80\x96",
		"\xB3\x7D" => "\xE9\x80\x9B",
		"\xB3\x7E" => "\xE9\x80\x94",
		"\xB3\xA1" => "\xE9\x83\xA8",
		"\xB3\xA2" => "\xE9\x83\xAD",
		"\xB3\xA3" => "\xE9\x83\xBD",
		"\xB3\xA4" => "\xE9\x85\x97",
		"\xB3\xA5" => "\xE9\x87\x8E",
		"\xB3\xA6" => "\xE9\x87\xB5",
		"\xB3\xA7" => "\xE9\x87\xA6",
		"\xB3\xA8" => "\xE9\x87\xA3",
		"\xB3\xA9" => "\xE9\x87\xA7",
		"\xB3\xAA" => "\xE9\x87\xAD",
		"\xB3\xAB" => "\xE9\x87\xA9",
		"\xB3\xAC" => "\xE9\x96\x89",
		"\xB3\xAD" => "\xE9\x99\xAA",
		"\xB3\xAE" => "\xE9\x99\xB5",
		"\xB3\xAF" => "\xE9\x99\xB3",
		"\xB3\xB0" => "\xE9\x99\xB8",
		"\xB3\xB1" => "\xE9\x99\xB0",
		"\xB3\xB2" => "\xE9\x99\xB4",
		"\xB3\xB3" => "\xE9\x99\xB6",
		"\xB3\xB4" => "\xE9\x99\xB7",
		"\xB3\xB5" => "\xE9\x99\xAC",
		"\xB3\xB6" => "\xE9\x9B\x80",
		"\xB3\xB7" => "\xE9\x9B\xAA",
		"\xB3\xB8" => "\xE9\x9B\xA9",
		"\xB3\xB9" => "\xE7\xAB\xA0",
		"\xB3\xBA" => "\xE7\xAB\x9F",
		"\xB3\xBB" => "\xE9\xA0\x82",
		"\xB3\xBC" => "\xE9\xA0\x83",
		"\xB3\xBD" => "\xE9\xAD\x9A",
		"\xB3\xBE" => "\xE9\xB3\xA5",
		"\xB3\xBF" => "\xE9\xB9\xB5",
		"\xB3\xC0" => "\xE9\xB9\xBF",
		"\xB3\xC1" => "\xE9\xBA\xA5",
		"\xB3\xC2" => "\xE9\xBA\xBB",
		"\xB3\xC3" => "\xE5\x82\xA2",
		"\xB3\xC4" => "\xE5\x82\x8D",
		"\xB3\xC5" => "\xE5\x82\x85",
		"\xB3\xC6" => "\xE5\x82\x99",
		"\xB3\xC7" => "\xE5\x82\x91",
		"\xB3\xC8" => "\xE5\x82\x80",
		"\xB3\xC9" => "\xE5\x82\x96",
		"\xB3\xCA" => "\xE5\x82\x98",
		"\xB3\xCB" => "\xE5\x82\x9A",
		"\xB3\xCC" => "\xE6\x9C\x80",
		"\xB3\xCD" => "\xE5\x87\xB1",
		"\xB3\xCE" => "\xE5\x89\xB2",
		"\xB3\xCF" => "\xE5\x89\xB4",
		"\xB3\xD0" => "\xE5\x89\xB5",
		"\xB3\xD1" => "\xE5\x89\xA9",
		"\xB3\xD2" => "\xE5\x8B\x9E",
		"\xB3\xD3" => "\xE5\x8B\x9D",
		"\xB3\xD4" => "\xE5\x8B\x9B",
		"\xB3\xD5" => "\xE5\x8D\x9A",
		"\xB3\xD6" => "\xE5\x8E\xA5",
		"\xB3\xD7" => "\xE5\x95\xBB",
		"\xB3\xD8" => "\xE5\x96\x80",
		"\xB3\xD9" => "\xE5\x96\xA7",
		"\xB3\xDA" => "\xE5\x95\xBC",
		"\xB3\xDB" => "\xE5\x96\x8A",
		"\xB3\xDC" => "\xE5\x96\x9D",
		"\xB3\xDD" => "\xE5\x96\x98",
		"\xB3\xDE" => "\xE5\x96\x82",
		"\xB3\xDF" => "\xE5\x96\x9C",
		"\xB3\xE0" => "\xE5\x96\xAA",
		"\xB3\xE1" => "\xE5\x96\x94",
		"\xB3\xE2" => "\xE5\x96\x87",
		"\xB3\xE3" => "\xE5\x96\x8B",
		"\xB3\xE4" => "\xE5\x96\x83",
		"\xB3\xE5" => "\xE5\x96\xB3",
		"\xB3\xE6" => "\xE5\x96\xAE",
		"\xB3\xE7" => "\xE5\x96\x9F",
		"\xB3\xE8" => "\xE5\x94\xBE",
		"\xB3\xE9" => "\xE5\x96\xB2",
		"\xB3\xEA" => "\xE5\x96\x9A",
		"\xB3\xEB" => "\xE5\x96\xBB",
		"\xB3\xEC" => "\xE5\x96\xAC",
		"\xB3\xED" => "\xE5\x96\xB1",
		"\xB3\xEE" => "\xE5\x95\xBE",
		"\xB3\xEF" => "\xE5\x96\x89",
		"\xB3\xF0" => "\xE5\x96\xAB",
		"\xB3\xF1" => "\xE5\x96\x99",
		"\xB3\xF2" => "\xE5\x9C\x8D",
		"\xB3\xF3" => "\xE5\xA0\xAF",
		"\xB3\xF4" => "\xE5\xA0\xAA",
		"\xB3\xF5" => "\xE5\xA0\xB4",
		"\xB3\xF6" => "\xE5\xA0\xA4",
		"\xB3\xF7" => "\xE5\xA0\xB0",
		"\xB3\xF8" => "\xE5\xA0\xB1",
		"\xB3\xF9" => "\xE5\xA0\xA1",
		"\xB3\xFA" => "\xE5\xA0\x9D",
		"\xB3\xFB" => "\xE5\xA0\xA0",
		"\xB3\xFC" => "\xE5\xA3\xB9",
		"\xB3\xFD" => "\xE5\xA3\xBA",
		"\xB3\xFE" => "\xE5\xA5\xA0",
		"\xB4\x40" => "\xE5\xA9\xB7",
		"\xB4\x41" => "\xE5\xAA\x9A",
		"\xB4\x42" => "\xE5\xA9\xBF",
		"\xB4\x43" => "\xE5\xAA\x92",
		"\xB4\x44" => "\xE5\xAA\x9B",
		"\xB4\x45" => "\xE5\xAA\xA7",
		"\xB4\x46" => "\xE5\xAD\xB3",
		"\xB4\x47" => "\xE5\xAD\xB1",
		"\xB4\x48" => "\xE5\xAF\x92",
		"\xB4\x49" => "\xE5\xAF\x8C",
		"\xB4\x4A" => "\xE5\xAF\x93",
		"\xB4\x4B" => "\xE5\xAF\x90",
		"\xB4\x4C" => "\xE5\xB0\x8A",
		"\xB4\x4D" => "\xE5\xB0\x8B",
		"\xB4\x4E" => "\xE5\xB0\xB1",
		"\xB4\x4F" => "\xE5\xB5\x8C",
		"\xB4\x50" => "\xE5\xB5\x90",
		"\xB4\x51" => "\xE5\xB4\xB4",
		"\xB4\x52" => "\xE5\xB5\x87",
		"\xB4\x53" => "\xE5\xB7\xBD",
		"\xB4\x54" => "\xE5\xB9\x85",
		"\xB4\x55" => "\xE5\xB8\xBD",
		"\xB4\x56" => "\xE5\xB9\x80",
		"\xB4\x57" => "\xE5\xB9\x83",
		"\xB4\x58" => "\xE5\xB9\xBE",
		"\xB4\x59" => "\xE5\xBB\x8A",
		"\xB4\x5A" => "\xE5\xBB\x81",
		"\xB4\x5B" => "\xE5\xBB\x82",
		"\xB4\x5C" => "\xE5\xBB\x84",
		"\xB4\x5D" => "\xE5\xBC\xBC",
		"\xB4\x5E" => "\xE5\xBD\xAD",
		"\xB4\x5F" => "\xE5\xBE\xA9",
		"\xB4\x60" => "\xE5\xBE\xAA",
		"\xB4\x61" => "\xE5\xBE\xA8",
		"\xB4\x62" => "\xE6\x83\x91",
		"\xB4\x63" => "\xE6\x83\xA1",
		"\xB4\x64" => "\xE6\x82\xB2",
		"\xB4\x65" => "\xE6\x82\xB6",
		"\xB4\x66" => "\xE6\x83\xA0",
		"\xB4\x67" => "\xE6\x84\x9C",
		"\xB4\x68" => "\xE6\x84\xA3",
		"\xB4\x69" => "\xE6\x83\xBA",
		"\xB4\x6A" => "\xE6\x84\x95",
		"\xB4\x6B" => "\xE6\x83\xB0",
		"\xB4\x6C" => "\xE6\x83\xBB",
		"\xB4\x6D" => "\xE6\x83\xB4",
		"\xB4\x6E" => "\xE6\x85\xA8",
		"\xB4\x6F" => "\xE6\x83\xB1",
		"\xB4\x70" => "\xE6\x84\x8E",
		"\xB4\x71" => "\xE6\x83\xB6",
		"\xB4\x72" => "\xE6\x84\x89",
		"\xB4\x73" => "\xE6\x84\x80",
		"\xB4\x74" => "\xE6\x84\x92",
		"\xB4\x75" => "\xE6\x88\x9F",
		"\xB4\x76" => "\xE6\x89\x89",
		"\xB4\x77" => "\xE6\x8E\xA3",
		"\xB4\x78" => "\xE6\x8E\x8C",
		"\xB4\x79" => "\xE6\x8F\x8F",
		"\xB4\x7A" => "\xE6\x8F\x80",
		"\xB4\x7B" => "\xE6\x8F\xA9",
		"\xB4\x7C" => "\xE6\x8F\x89",
		"\xB4\x7D" => "\xE6\x8F\x86",
		"\xB4\x7E" => "\xE6\x8F\x8D",
		"\xB4\xA1" => "\xE6\x8F\x92",
		"\xB4\xA2" => "\xE6\x8F\xA3",
		"\xB4\xA3" => "\xE6\x8F\x90",
		"\xB4\xA4" => "\xE6\x8F\xA1",
		"\xB4\xA5" => "\xE6\x8F\x96",
		"\xB4\xA6" => "\xE6\x8F\xAD",
		"\xB4\xA7" => "\xE6\x8F\xAE",
		"\xB4\xA8" => "\xE6\x8D\xB6",
		"\xB4\xA9" => "\xE6\x8F\xB4",
		"\xB4\xAA" => "\xE6\x8F\xAA",
		"\xB4\xAB" => "\xE6\x8F\x9B",
		"\xB4\xAC" => "\xE6\x91\x92",
		"\xB4\xAD" => "\xE6\x8F\x9A",
		"\xB4\xAE" => "\xE6\x8F\xB9",
		"\xB4\xAF" => "\xE6\x95\x9E",
		"\xB4\xB0" => "\xE6\x95\xA6",
		"\xB4\xB1" => "\xE6\x95\xA2",
		"\xB4\xB2" => "\xE6\x95\xA3",
		"\xB4\xB3" => "\xE6\x96\x91",
		"\xB4\xB4" => "\xE6\x96\x90",
		"\xB4\xB5" => "\xE6\x96\xAF",
		"\xB4\xB6" => "\xE6\x99\xAE",
		"\xB4\xB7" => "\xE6\x99\xB0",
		"\xB4\xB8" => "\xE6\x99\xB4",
		"\xB4\xB9" => "\xE6\x99\xB6",
		"\xB4\xBA" => "\xE6\x99\xAF",
		"\xB4\xBB" => "\xE6\x9A\x91",
		"\xB4\xBC" => "\xE6\x99\xBA",
		"\xB4\xBD" => "\xE6\x99\xBE",
		"\xB4\xBE" => "\xE6\x99\xB7",
		"\xB4\xBF" => "\xE6\x9B\xBE",
		"\xB4\xC0" => "\xE6\x9B\xBF",
		"\xB4\xC1" => "\xE6\x9C\x9F",
		"\xB4\xC2" => "\xE6\x9C\x9D",
		"\xB4\xC3" => "\xE6\xA3\xBA",
		"\xB4\xC4" => "\xE6\xA3\x95",
		"\xB4\xC5" => "\xE6\xA3\xA0",
		"\xB4\xC6" => "\xE6\xA3\x98",
		"\xB4\xC7" => "\xE6\xA3\x97",
		"\xB4\xC8" => "\xE6\xA4\x85",
		"\xB4\xC9" => "\xE6\xA3\x9F",
		"\xB4\xCA" => "\xE6\xA3\xB5",
		"\xB4\xCB" => "\xE6\xA3\xAE",
		"\xB4\xCC" => "\xE6\xA3\xA7",
		"\xB4\xCD" => "\xE6\xA3\xB9",
		"\xB4\xCE" => "\xE6\xA3\x92",
		"\xB4\xCF" => "\xE6\xA3\xB2",
		"\xB4\xD0" => "\xE6\xA3\xA3",
		"\xB4\xD1" => "\xE6\xA3\x8B",
		"\xB4\xD2" => "\xE6\xA3\x8D",
		"\xB4\xD3" => "\xE6\xA4\x8D",
		"\xB4\xD4" => "\xE6\xA4\x92",
		"\xB4\xD5" => "\xE6\xA4\x8E",
		"\xB4\xD6" => "\xE6\xA3\x89",
		"\xB4\xD7" => "\xE6\xA3\x9A",
		"\xB4\xD8" => "\xE6\xA5\xAE",
		"\xB4\xD9" => "\xE6\xA3\xBB",
		"\xB4\xDA" => "\xE6\xAC\xBE",
		"\xB4\xDB" => "\xE6\xAC\xBA",
		"\xB4\xDC" => "\xE6\xAC\xBD",
		"\xB4\xDD" => "\xE6\xAE\x98",
		"\xB4\xDE" => "\xE6\xAE\x96",
		"\xB4\xDF" => "\xE6\xAE\xBC",
		"\xB4\xE0" => "\xE6\xAF\xAF",
		"\xB4\xE1" => "\xE6\xB0\xAE",
		"\xB4\xE2" => "\xE6\xB0\xAF",
		"\xB4\xE3" => "\xE6\xB0\xAC",
		"\xB4\xE4" => "\xE6\xB8\xAF",
		"\xB4\xE5" => "\xE6\xB8\xB8",
		"\xB4\xE6" => "\xE6\xB9\x94",
		"\xB4\xE7" => "\xE6\xB8\xA1",
		"\xB4\xE8" => "\xE6\xB8\xB2",
		"\xB4\xE9" => "\xE6\xB9\xA7",
		"\xB4\xEA" => "\xE6\xB9\x8A",
		"\xB4\xEB" => "\xE6\xB8\xA0",
		"\xB4\xEC" => "\xE6\xB8\xA5",
		"\xB4\xED" => "\xE6\xB8\xA3",
		"\xB4\xEE" => "\xE6\xB8\x9B",
		"\xB4\xEF" => "\xE6\xB9\x9B",
		"\xB4\xF0" => "\xE6\xB9\x98",
		"\xB4\xF1" => "\xE6\xB8\xA4",
		"\xB4\xF2" => "\xE6\xB9\x96",
		"\xB4\xF3" => "\xE6\xB9\xAE",
		"\xB4\xF4" => "\xE6\xB8\xAD",
		"\xB4\xF5" => "\xE6\xB8\xA6",
		"\xB4\xF6" => "\xE6\xB9\xAF",
		"\xB4\xF7" => "\xE6\xB8\xB4",
		"\xB4\xF8" => "\xE6\xB9\x8D",
		"\xB4\xF9" => "\xE6\xB8\xBA",
		"\xB4\xFA" => "\xE6\xB8\xAC",
		"\xB4\xFB" => "\xE6\xB9\x83",
		"\xB4\xFC" => "\xE6\xB8\x9D",
		"\xB4\xFD" => "\xE6\xB8\xBE",
		"\xB4\xFE" => "\xE6\xBB\x8B",
		"\xB5\x40" => "\xE6\xBA\x89",
		"\xB5\x41" => "\xE6\xB8\x99",
		"\xB5\x42" => "\xE6\xB9\x8E",
		"\xB5\x43" => "\xE6\xB9\xA3",
		"\xB5\x44" => "\xE6\xB9\x84",
		"\xB5\x45" => "\xE6\xB9\xB2",
		"\xB5\x46" => "\xE6\xB9\xA9",
		"\xB5\x47" => "\xE6\xB9\x9F",
		"\xB5\x48" => "\xE7\x84\x99",
		"\xB5\x49" => "\xE7\x84\x9A",
		"\xB5\x4A" => "\xE7\x84\xA6",
		"\xB5\x4B" => "\xE7\x84\xB0",
		"\xB5\x4C" => "\xE7\x84\xA1",
		"\xB5\x4D" => "\xE7\x84\xB6",
		"\xB5\x4E" => "\xE7\x85\xAE",
		"\xB5\x4F" => "\xE7\x84\x9C",
		"\xB5\x50" => "\xE7\x89\x8C",
		"\xB5\x51" => "\xE7\x8A\x84",
		"\xB5\x52" => "\xE7\x8A\x80",
		"\xB5\x53" => "\xE7\x8C\xB6",
		"\xB5\x54" => "\xE7\x8C\xA5",
		"\xB5\x55" => "\xE7\x8C\xB4",
		"\xB5\x56" => "\xE7\x8C\xA9",
		"\xB5\x57" => "\xE7\x90\xBA",
		"\xB5\x58" => "\xE7\x90\xAA",
		"\xB5\x59" => "\xE7\x90\xB3",
		"\xB5\x5A" => "\xE7\x90\xA2",
		"\xB5\x5B" => "\xE7\x90\xA5",
		"\xB5\x5C" => "\xE7\x90\xB5",
		"\xB5\x5D" => "\xE7\x90\xB6",
		"\xB5\x5E" => "\xE7\x90\xB4",
		"\xB5\x5F" => "\xE7\x90\xAF",
		"\xB5\x60" => "\xE7\x90\x9B",
		"\xB5\x61" => "\xE7\x90\xA6",
		"\xB5\x62" => "\xE7\x90\xA8",
		"\xB5\x63" => "\xE7\x94\xA5",
		"\xB5\x64" => "\xE7\x94\xA6",
		"\xB5\x65" => "\xE7\x95\xAB",
		"\xB5\x66" => "\xE7\x95\xAA",
		"\xB5\x67" => "\xE7\x97\xA2",
		"\xB5\x68" => "\xE7\x97\x9B",
		"\xB5\x69" => "\xE7\x97\xA3",
		"\xB5\x6A" => "\xE7\x97\x99",
		"\xB5\x6B" => "\xE7\x97\x98",
		"\xB5\x6C" => "\xE7\x97\x9E",
		"\xB5\x6D" => "\xE7\x97\xA0",
		"\xB5\x6E" => "\xE7\x99\xBB",
		"\xB5\x6F" => "\xE7\x99\xBC",
		"\xB5\x70" => "\xE7\x9A\x96",
		"\xB5\x71" => "\xE7\x9A\x93",
		"\xB5\x72" => "\xE7\x9A\xB4",
		"\xB5\x73" => "\xE7\x9B\x9C",
		"\xB5\x74" => "\xE7\x9D\x8F",
		"\xB5\x75" => "\xE7\x9F\xAD",
		"\xB5\x76" => "\xE7\xA1\x9D",
		"\xB5\x77" => "\xE7\xA1\xAC",
		"\xB5\x78" => "\xE7\xA1\xAF",
		"\xB5\x79" => "\xE7\xA8\x8D",
		"\xB5\x7A" => "\xE7\xA8\x88",
		"\xB5\x7B" => "\xE7\xA8\x8B",
		"\xB5\x7C" => "\xE7\xA8\x85",
		"\xB5\x7D" => "\xE7\xA8\x80",
		"\xB5\x7E" => "\xE7\xAA\x98",
		"\xB5\xA1" => "\xE7\xAA\x97",
		"\xB5\xA2" => "\xE7\xAA\x96",
		"\xB5\xA3" => "\xE7\xAB\xA5",
		"\xB5\xA4" => "\xE7\xAB\xA3",
		"\xB5\xA5" => "\xE7\xAD\x89",
		"\xB5\xA6" => "\xE7\xAD\x96",
		"\xB5\xA7" => "\xE7\xAD\x86",
		"\xB5\xA8" => "\xE7\xAD\x90",
		"\xB5\xA9" => "\xE7\xAD\x92",
		"\xB5\xAA" => "\xE7\xAD\x94",
		"\xB5\xAB" => "\xE7\xAD\x8D",
		"\xB5\xAC" => "\xE7\xAD\x8B",
		"\xB5\xAD" => "\xE7\xAD\x8F",
		"\xB5\xAE" => "\xE7\xAD\x91",
		"\xB5\xAF" => "\xE7\xB2\x9F",
		"\xB5\xB0" => "\xE7\xB2\xA5",
		"\xB5\xB1" => "\xE7\xB5\x9E",
		"\xB5\xB2" => "\xE7\xB5\x90",
		"\xB5\xB3" => "\xE7\xB5\xA8",
		"\xB5\xB4" => "\xE7\xB5\x95",
		"\xB5\xB5" => "\xE7\xB4\xAB",
		"\xB5\xB6" => "\xE7\xB5\xAE",
		"\xB5\xB7" => "\xE7\xB5\xB2",
		"\xB5\xB8" => "\xE7\xB5\xA1",
		"\xB5\xB9" => "\xE7\xB5\xA6",
		"\xB5\xBA" => "\xE7\xB5\xA2",
		"\xB5\xBB" => "\xE7\xB5\xB0",
		"\xB5\xBC" => "\xE7\xB5\xB3",
		"\xB5\xBD" => "\xE5\x96\x84",
		"\xB5\xBE" => "\xE7\xBF\x94",
		"\xB5\xBF" => "\xE7\xBF\x95",
		"\xB5\xC0" => "\xE8\x80\x8B",
		"\xB5\xC1" => "\xE8\x81\x92",
		"\xB5\xC2" => "\xE8\x82\x85",
		"\xB5\xC3" => "\xE8\x85\x95",
		"\xB5\xC4" => "\xE8\x85\x94",
		"\xB5\xC5" => "\xE8\x85\x8B",
		"\xB5\xC6" => "\xE8\x85\x91",
		"\xB5\xC7" => "\xE8\x85\x8E",
		"\xB5\xC8" => "\xE8\x84\xB9",
		"\xB5\xC9" => "\xE8\x85\x86",
		"\xB5\xCA" => "\xE8\x84\xBE",
		"\xB5\xCB" => "\xE8\x85\x8C",
		"\xB5\xCC" => "\xE8\x85\x93",
		"\xB5\xCD" => "\xE8\x85\xB4",
		"\xB5\xCE" => "\xE8\x88\x92",
		"\xB5\xCF" => "\xE8\x88\x9C",
		"\xB5\xD0" => "\xE8\x8F\xA9",
		"\xB5\xD1" => "\xE8\x90\x83",
		"\xB5\xD2" => "\xE8\x8F\xB8",
		"\xB5\xD3" => "\xE8\x90\x8D",
		"\xB5\xD4" => "\xE8\x8F\xA0",
		"\xB5\xD5" => "\xE8\x8F\x85",
		"\xB5\xD6" => "\xE8\x90\x8B",
		"\xB5\xD7" => "\xE8\x8F\x81",
		"\xB5\xD8" => "\xE8\x8F\xAF",
		"\xB5\xD9" => "\xE8\x8F\xB1",
		"\xB5\xDA" => "\xE8\x8F\xB4",
		"\xB5\xDB" => "\xE8\x91\x97",
		"\xB5\xDC" => "\xE8\x90\x8A",
		"\xB5\xDD" => "\xE8\x8F\xB0",
		"\xB5\xDE" => "\xE8\x90\x8C",
		"\xB5\xDF" => "\xE8\x8F\x8C",
		"\xB5\xE0" => "\xE8\x8F\xBD",
		"\xB5\xE1" => "\xE8\x8F\xB2",
		"\xB5\xE2" => "\xE8\x8F\x8A",
		"\xB5\xE3" => "\xE8\x90\xB8",
		"\xB5\xE4" => "\xE8\x90\x8E",
		"\xB5\xE5" => "\xE8\x90\x84",
		"\xB5\xE6" => "\xE8\x8F\x9C",
		"\xB5\xE7" => "\xE8\x90\x87",
		"\xB5\xE8" => "\xE8\x8F\x94",
		"\xB5\xE9" => "\xE8\x8F\x9F",
		"\xB5\xEA" => "\xE8\x99\x9B",
		"\xB5\xEB" => "\xE8\x9B\x9F",
		"\xB5\xEC" => "\xE8\x9B\x99",
		"\xB5\xED" => "\xE8\x9B\xAD",
		"\xB5\xEE" => "\xE8\x9B\x94",
		"\xB5\xEF" => "\xE8\x9B\x9B",
		"\xB5\xF0" => "\xE8\x9B\xA4",
		"\xB5\xF1" => "\xE8\x9B\x90",
		"\xB5\xF2" => "\xE8\x9B\x9E",
		"\xB5\xF3" => "\xE8\xA1\x97",
		"\xB5\xF4" => "\xE8\xA3\x81",
		"\xB5\xF5" => "\xE8\xA3\x82",
		"\xB5\xF6" => "\xE8\xA2\xB1",
		"\xB5\xF7" => "\xE8\xA6\x83",
		"\xB5\xF8" => "\xE8\xA6\x96",
		"\xB5\xF9" => "\xE8\xA8\xBB",
		"\xB5\xFA" => "\xE8\xA9\xA0",
		"\xB5\xFB" => "\xE8\xA9\x95",
		"\xB5\xFC" => "\xE8\xA9\x9E",
		"\xB5\xFD" => "\xE8\xA8\xBC",
		"\xB5\xFE" => "\xE8\xA9\x81",
		"\xB6\x40" => "\xE8\xA9\x94",
		"\xB6\x41" => "\xE8\xA9\x9B",
		"\xB6\x42" => "\xE8\xA9\x90",
		"\xB6\x43" => "\xE8\xA9\x86",
		"\xB6\x44" => "\xE8\xA8\xB4",
		"\xB6\x45" => "\xE8\xA8\xBA",
		"\xB6\x46" => "\xE8\xA8\xB6",
		"\xB6\x47" => "\xE8\xA9\x96",
		"\xB6\x48" => "\xE8\xB1\xA1",
		"\xB6\x49" => "\xE8\xB2\x82",
		"\xB6\x4A" => "\xE8\xB2\xAF",
		"\xB6\x4B" => "\xE8\xB2\xBC",
		"\xB6\x4C" => "\xE8\xB2\xB3",
		"\xB6\x4D" => "\xE8\xB2\xBD",
		"\xB6\x4E" => "\xE8\xB3\x81",
		"\xB6\x4F" => "\xE8\xB2\xBB",
		"\xB6\x50" => "\xE8\xB3\x80",
		"\xB6\x51" => "\xE8\xB2\xB4",
		"\xB6\x52" => "\xE8\xB2\xB7",
		"\xB6\x53" => "\xE8\xB2\xB6",
		"\xB6\x54" => "\xE8\xB2\xBF",
		"\xB6\x55" => "\xE8\xB2\xB8",
		"\xB6\x56" => "\xE8\xB6\x8A",
		"\xB6\x57" => "\xE8\xB6\x85",
		"\xB6\x58" => "\xE8\xB6\x81",
		"\xB6\x59" => "\xE8\xB7\x8E",
		"\xB6\x5A" => "\xE8\xB7\x9D",
		"\xB6\x5B" => "\xE8\xB7\x8B",
		"\xB6\x5C" => "\xE8\xB7\x9A",
		"\xB6\x5D" => "\xE8\xB7\x91",
		"\xB6\x5E" => "\xE8\xB7\x8C",
		"\xB6\x5F" => "\xE8\xB7\x9B",
		"\xB6\x60" => "\xE8\xB7\x86",
		"\xB6\x61" => "\xE8\xBB\xBB",
		"\xB6\x62" => "\xE8\xBB\xB8",
		"\xB6\x63" => "\xE8\xBB\xBC",
		"\xB6\x64" => "\xE8\xBE\x9C",
		"\xB6\x65" => "\xE9\x80\xAE",
		"\xB6\x66" => "\xE9\x80\xB5",
		"\xB6\x67" => "\xE9\x80\xB1",
		"\xB6\x68" => "\xE9\x80\xB8",
		"\xB6\x69" => "\xE9\x80\xB2",
		"\xB6\x6A" => "\xE9\x80\xB6",
		"\xB6\x6B" => "\xE9\x84\x82",
		"\xB6\x6C" => "\xE9\x83\xB5",
		"\xB6\x6D" => "\xE9\x84\x89",
		"\xB6\x6E" => "\xE9\x83\xBE",
		"\xB6\x6F" => "\xE9\x85\xA3",
		"\xB6\x70" => "\xE9\x85\xA5",
		"\xB6\x71" => "\xE9\x87\x8F",
		"\xB6\x72" => "\xE9\x88\x94",
		"\xB6\x73" => "\xE9\x88\x95",
		"\xB6\x74" => "\xE9\x88\xA3",
		"\xB6\x75" => "\xE9\x88\x89",
		"\xB6\x76" => "\xE9\x88\x9E",
		"\xB6\x77" => "\xE9\x88\x8D",
		"\xB6\x78" => "\xE9\x88\x90",
		"\xB6\x79" => "\xE9\x88\x87",
		"\xB6\x7A" => "\xE9\x88\x91",
		"\xB6\x7B" => "\xE9\x96\x94",
		"\xB6\x7C" => "\xE9\x96\x8F",
		"\xB6\x7D" => "\xE9\x96\x8B",
		"\xB6\x7E" => "\xE9\x96\x91",
		"\xB6\xA1" => "\xE9\x96\x93",
		"\xB6\xA2" => "\xE9\x96\x92",
		"\xB6\xA3" => "\xE9\x96\x8E",
		"\xB6\xA4" => "\xE9\x9A\x8A",
		"\xB6\xA5" => "\xE9\x9A\x8E",
		"\xB6\xA6" => "\xE9\x9A\x8B",
		"\xB6\xA7" => "\xE9\x99\xBD",
		"\xB6\xA8" => "\xE9\x9A\x85",
		"\xB6\xA9" => "\xE9\x9A\x86",
		"\xB6\xAA" => "\xE9\x9A\x8D",
		"\xB6\xAB" => "\xE9\x99\xB2",
		"\xB6\xAC" => "\xE9\x9A\x84",
		"\xB6\xAD" => "\xE9\x9B\x81",
		"\xB6\xAE" => "\xE9\x9B\x85",
		"\xB6\xAF" => "\xE9\x9B\x84",
		"\xB6\xB0" => "\xE9\x9B\x86",
		"\xB6\xB1" => "\xE9\x9B\x87",
		"\xB6\xB2" => "\xE9\x9B\xAF",
		"\xB6\xB3" => "\xE9\x9B\xB2",
		"\xB6\xB4" => "\xE9\x9F\x8C",
		"\xB6\xB5" => "\xE9\xA0\x85",
		"\xB6\xB6" => "\xE9\xA0\x86",
		"\xB6\xB7" => "\xE9\xA0\x88",
		"\xB6\xB8" => "\xE9\xA3\xA7",
		"\xB6\xB9" => "\xE9\xA3\xAA",
		"\xB6\xBA" => "\xE9\xA3\xAF",
		"\xB6\xBB" => "\xE9\xA3\xA9",
		"\xB6\xBC" => "\xE9\xA3\xB2",
		"\xB6\xBD" => "\xE9\xA3\xAD",
		"\xB6\xBE" => "\xE9\xA6\xAE",
		"\xB6\xBF" => "\xE9\xA6\xAD",
		"\xB6\xC0" => "\xE9\xBB\x83",
		"\xB6\xC1" => "\xE9\xBB\x8D",
		"\xB6\xC2" => "\xE9\xBB\x91",
		"\xB6\xC3" => "\xE4\xBA\x82",
		"\xB6\xC4" => "\xE5\x82\xAD",
		"\xB6\xC5" => "\xE5\x82\xB5",
		"\xB6\xC6" => "\xE5\x82\xB2",
		"\xB6\xC7" => "\xE5\x82\xB3",
		"\xB6\xC8" => "\xE5\x83\x85",
		"\xB6\xC9" => "\xE5\x82\xBE",
		"\xB6\xCA" => "\xE5\x82\xAC",
		"\xB6\xCB" => "\xE5\x82\xB7",
		"\xB6\xCC" => "\xE5\x82\xBB",
		"\xB6\xCD" => "\xE5\x82\xAF",
		"\xB6\xCE" => "\xE5\x83\x87",
		"\xB6\xCF" => "\xE5\x89\xBF",
		"\xB6\xD0" => "\xE5\x89\xB7",
		"\xB6\xD1" => "\xE5\x89\xBD",
		"\xB6\xD2" => "\xE5\x8B\x9F",
		"\xB6\xD3" => "\xE5\x8B\xA6",
		"\xB6\xD4" => "\xE5\x8B\xA4",
		"\xB6\xD5" => "\xE5\x8B\xA2",
		"\xB6\xD6" => "\xE5\x8B\xA3",
		"\xB6\xD7" => "\xE5\x8C\xAF",
		"\xB6\xD8" => "\xE5\x97\x9F",
		"\xB6\xD9" => "\xE5\x97\xA8",
		"\xB6\xDA" => "\xE5\x97\x93",
		"\xB6\xDB" => "\xE5\x97\xA6",
		"\xB6\xDC" => "\xE5\x97\x8E",
		"\xB6\xDD" => "\xE5\x97\x9C",
		"\xB6\xDE" => "\xE5\x97\x87",
		"\xB6\xDF" => "\xE5\x97\x91",
		"\xB6\xE0" => "\xE5\x97\xA3",
		"\xB6\xE1" => "\xE5\x97\xA4",
		"\xB6\xE2" => "\xE5\x97\xAF",
		"\xB6\xE3" => "\xE5\x97\x9A",
		"\xB6\xE4" => "\xE5\x97\xA1",
		"\xB6\xE5" => "\xE5\x97\x85",
		"\xB6\xE6" => "\xE5\x97\x86",
		"\xB6\xE7" => "\xE5\x97\xA5",
		"\xB6\xE8" => "\xE5\x97\x89",
		"\xB6\xE9" => "\xE5\x9C\x92",
		"\xB6\xEA" => "\xE5\x9C\x93",
		"\xB6\xEB" => "\xE5\xA1\x9E",
		"\xB6\xEC" => "\xE5\xA1\x91",
		"\xB6\xED" => "\xE5\xA1\x98",
		"\xB6\xEE" => "\xE5\xA1\x97",
		"\xB6\xEF" => "\xE5\xA1\x9A",
		"\xB6\xF0" => "\xE5\xA1\x94",
		"\xB6\xF1" => "\xE5\xA1\xAB",
		"\xB6\xF2" => "\xE5\xA1\x8C",
		"\xB6\xF3" => "\xE5\xA1\xAD",
		"\xB6\xF4" => "\xE5\xA1\x8A",
		"\xB6\xF5" => "\xE5\xA1\xA2",
		"\xB6\xF6" => "\xE5\xA1\x92",
		"\xB6\xF7" => "\xE5\xA1\x8B",
		"\xB6\xF8" => "\xE5\xA5\xA7",
		"\xB6\xF9" => "\xE5\xAB\x81",
		"\xB6\xFA" => "\xE5\xAB\x89",
		"\xB6\xFB" => "\xE5\xAB\x8C",
		"\xB6\xFC" => "\xE5\xAA\xBE",
		"\xB6\xFD" => "\xE5\xAA\xBD",
		"\xB6\xFE" => "\xE5\xAA\xBC",
		"\xB7\x40" => "\xE5\xAA\xB3",
		"\xB7\x41" => "\xE5\xAB\x82",
		"\xB7\x42" => "\xE5\xAA\xB2",
		"\xB7\x43" => "\xE5\xB5\xA9",
		"\xB7\x44" => "\xE5\xB5\xAF",
		"\xB7\x45" => "\xE5\xB9\x8C",
		"\xB7\x46" => "\xE5\xB9\xB9",
		"\xB7\x47" => "\xE5\xBB\x89",
		"\xB7\x48" => "\xE5\xBB\x88",
		"\xB7\x49" => "\xE5\xBC\x92",
		"\xB7\x4A" => "\xE5\xBD\x99",
		"\xB7\x4B" => "\xE5\xBE\xAC",
		"\xB7\x4C" => "\xE5\xBE\xAE",
		"\xB7\x4D" => "\xE6\x84\x9A",
		"\xB7\x4E" => "\xE6\x84\x8F",
		"\xB7\x4F" => "\xE6\x85\x88",
		"\xB7\x50" => "\xE6\x84\x9F",
		"\xB7\x51" => "\xE6\x83\xB3",
		"\xB7\x52" => "\xE6\x84\x9B",
		"\xB7\x53" => "\xE6\x83\xB9",
		"\xB7\x54" => "\xE6\x84\x81",
		"\xB7\x55" => "\xE6\x84\x88",
		"\xB7\x56" => "\xE6\x85\x8E",
		"\xB7\x57" => "\xE6\x85\x8C",
		"\xB7\x58" => "\xE6\x85\x84",
		"\xB7\x59" => "\xE6\x85\x8D",
		"\xB7\x5A" => "\xE6\x84\xBE",
		"\xB7\x5B" => "\xE6\x84\xB4",
		"\xB7\x5C" => "\xE6\x84\xA7",
		"\xB7\x5D" => "\xE6\x84\x8D",
		"\xB7\x5E" => "\xE6\x84\x86",
		"\xB7\x5F" => "\xE6\x84\xB7",
		"\xB7\x60" => "\xE6\x88\xA1",
		"\xB7\x61" => "\xE6\x88\xA2",
		"\xB7\x62" => "\xE6\x90\x93",
		"\xB7\x63" => "\xE6\x90\xBE",
		"\xB7\x64" => "\xE6\x90\x9E",
		"\xB7\x65" => "\xE6\x90\xAA",
		"\xB7\x66" => "\xE6\x90\xAD",
		"\xB7\x67" => "\xE6\x90\xBD",
		"\xB7\x68" => "\xE6\x90\xAC",
		"\xB7\x69" => "\xE6\x90\x8F",
		"\xB7\x6A" => "\xE6\x90\x9C",
		"\xB7\x6B" => "\xE6\x90\x94",
		"\xB7\x6C" => "\xE6\x90\x8D",
		"\xB7\x6D" => "\xE6\x90\xB6",
		"\xB7\x6E" => "\xE6\x90\x96",
		"\xB7\x6F" => "\xE6\x90\x97",
		"\xB7\x70" => "\xE6\x90\x86",
		"\xB7\x71" => "\xE6\x95\xAC",
		"\xB7\x72" => "\xE6\x96\x9F",
		"\xB7\x73" => "\xE6\x96\xB0",
		"\xB7\x74" => "\xE6\x9A\x97",
		"\xB7\x75" => "\xE6\x9A\x89",
		"\xB7\x76" => "\xE6\x9A\x87",
		"\xB7\x77" => "\xE6\x9A\x88",
		"\xB7\x78" => "\xE6\x9A\x96",
		"\xB7\x79" => "\xE6\x9A\x84",
		"\xB7\x7A" => "\xE6\x9A\x98",
		"\xB7\x7B" => "\xE6\x9A\x8D",
		"\xB7\x7C" => "\xE6\x9C\x83",
		"\xB7\x7D" => "\xE6\xA6\x94",
		"\xB7\x7E" => "\xE6\xA5\xAD",
		"\xB7\xA1" => "\xE6\xA5\x9A",
		"\xB7\xA2" => "\xE6\xA5\xB7",
		"\xB7\xA3" => "\xE6\xA5\xA0",
		"\xB7\xA4" => "\xE6\xA5\x94",
		"\xB7\xA5" => "\xE6\xA5\xB5",
		"\xB7\xA6" => "\xE6\xA4\xB0",
		"\xB7\xA7" => "\xE6\xA6\x82",
		"\xB7\xA8" => "\xE6\xA5\x8A",
		"\xB7\xA9" => "\xE6\xA5\xA8",
		"\xB7\xAA" => "\xE6\xA5\xAB",
		"\xB7\xAB" => "\xE6\xA5\x9E",
		"\xB7\xAC" => "\xE6\xA5\x93",
		"\xB7\xAD" => "\xE6\xA5\xB9",
		"\xB7\xAE" => "\xE6\xA6\x86",
		"\xB7\xAF" => "\xE6\xA5\x9D",
		"\xB7\xB0" => "\xE6\xA5\xA3",
		"\xB7\xB1" => "\xE6\xA5\x9B",
		"\xB7\xB2" => "\xE6\xAD\x87",
		"\xB7\xB3" => "\xE6\xAD\xB2",
		"\xB7\xB4" => "\xE6\xAF\x80",
		"\xB7\xB5" => "\xE6\xAE\xBF",
		"\xB7\xB6" => "\xE6\xAF\x93",
		"\xB7\xB7" => "\xE6\xAF\xBD",
		"\xB7\xB8" => "\xE6\xBA\xA2",
		"\xB7\xB9" => "\xE6\xBA\xAF",
		"\xB7\xBA" => "\xE6\xBB\x93",
		"\xB7\xBB" => "\xE6\xBA\xB6",
		"\xB7\xBC" => "\xE6\xBB\x82",
		"\xB7\xBD" => "\xE6\xBA\x90",
		"\xB7\xBE" => "\xE6\xBA\x9D",
		"\xB7\xBF" => "\xE6\xBB\x87",
		"\xB7\xC0" => "\xE6\xBB\x85",
		"\xB7\xC1" => "\xE6\xBA\xA5",
		"\xB7\xC2" => "\xE6\xBA\x98",
		"\xB7\xC3" => "\xE6\xBA\xBC",
		"\xB7\xC4" => "\xE6\xBA\xBA",
		"\xB7\xC5" => "\xE6\xBA\xAB",
		"\xB7\xC6" => "\xE6\xBB\x91",
		"\xB7\xC7" => "\xE6\xBA\x96",
		"\xB7\xC8" => "\xE6\xBA\x9C",
		"\xB7\xC9" => "\xE6\xBB\x84",
		"\xB7\xCA" => "\xE6\xBB\x94",
		"\xB7\xCB" => "\xE6\xBA\xAA",
		"\xB7\xCC" => "\xE6\xBA\xA7",
		"\xB7\xCD" => "\xE6\xBA\xB4",
		"\xB7\xCE" => "\xE7\x85\x8E",
		"\xB7\xCF" => "\xE7\x85\x99",
		"\xB7\xD0" => "\xE7\x85\xA9",
		"\xB7\xD1" => "\xE7\x85\xA4",
		"\xB7\xD2" => "\xE7\x85\x89",
		"\xB7\xD3" => "\xE7\x85\xA7",
		"\xB7\xD4" => "\xE7\x85\x9C",
		"\xB7\xD5" => "\xE7\x85\xAC",
		"\xB7\xD6" => "\xE7\x85\xA6",
		"\xB7\xD7" => "\xE7\x85\x8C",
		"\xB7\xD8" => "\xE7\x85\xA5",
		"\xB7\xD9" => "\xE7\x85\x9E",
		"\xB7\xDA" => "\xE7\x85\x86",
		"\xB7\xDB" => "\xE7\x85\xA8",
		"\xB7\xDC" => "\xE7\x85\x96",
		"\xB7\xDD" => "\xE7\x88\xBA",
		"\xB7\xDE" => "\xE7\x89\x92",
		"\xB7\xDF" => "\xE7\x8C\xB7",
		"\xB7\xE0" => "\xE7\x8D\x85",
		"\xB7\xE1" => "\xE7\x8C\xBF",
		"\xB7\xE2" => "\xE7\x8C\xBE",
		"\xB7\xE3" => "\xE7\x91\xAF",
		"\xB7\xE4" => "\xE7\x91\x9A",
		"\xB7\xE5" => "\xE7\x91\x95",
		"\xB7\xE6" => "\xE7\x91\x9F",
		"\xB7\xE7" => "\xE7\x91\x9E",
		"\xB7\xE8" => "\xE7\x91\x81",
		"\xB7\xE9" => "\xE7\x90\xBF",
		"\xB7\xEA" => "\xE7\x91\x99",
		"\xB7\xEB" => "\xE7\x91\x9B",
		"\xB7\xEC" => "\xE7\x91\x9C",
		"\xB7\xED" => "\xE7\x95\xB6",
		"\xB7\xEE" => "\xE7\x95\xB8",
		"\xB7\xEF" => "\xE7\x98\x80",
		"\xB7\xF0" => "\xE7\x97\xB0",
		"\xB7\xF1" => "\xE7\x98\x81",
		"\xB7\xF2" => "\xE7\x97\xB2",
		"\xB7\xF3" => "\xE7\x97\xB1",
		"\xB7\xF4" => "\xE7\x97\xBA",
		"\xB7\xF5" => "\xE7\x97\xBF",
		"\xB7\xF6" => "\xE7\x97\xB4",
		"\xB7\xF7" => "\xE7\x97\xB3",
		"\xB7\xF8" => "\xE7\x9B\x9E",
		"\xB7\xF9" => "\xE7\x9B\x9F",
		"\xB7\xFA" => "\xE7\x9D\x9B",
		"\xB7\xFB" => "\xE7\x9D\xAB",
		"\xB7\xFC" => "\xE7\x9D\xA6",
		"\xB7\xFD" => "\xE7\x9D\x9E",
		"\xB7\xFE" => "\xE7\x9D\xA3",
		"\xB8\x40" => "\xE7\x9D\xB9",
		"\xB8\x41" => "\xE7\x9D\xAA",
		"\xB8\x42" => "\xE7\x9D\xAC",
		"\xB8\x43" => "\xE7\x9D\x9C",
		"\xB8\x44" => "\xE7\x9D\xA5",
		"\xB8\x45" => "\xE7\x9D\xA8",
		"\xB8\x46" => "\xE7\x9D\xA2",
		"\xB8\x47" => "\xE7\x9F\xAE",
		"\xB8\x48" => "\xE7\xA2\x8E",
		"\xB8\x49" => "\xE7\xA2\xB0",
		"\xB8\x4A" => "\xE7\xA2\x97",
		"\xB8\x4B" => "\xE7\xA2\x98",
		"\xB8\x4C" => "\xE7\xA2\x8C",
		"\xB8\x4D" => "\xE7\xA2\x89",
		"\xB8\x4E" => "\xE7\xA1\xBC",
		"\xB8\x4F" => "\xE7\xA2\x91",
		"\xB8\x50" => "\xE7\xA2\x93",
		"\xB8\x51" => "\xE7\xA1\xBF",
		"\xB8\x52" => "\xE7\xA5\xBA",
		"\xB8\x53" => "\xE7\xA5\xBF",
		"\xB8\x54" => "\xE7\xA6\x81",
		"\xB8\x55" => "\xE8\x90\xAC",
		"\xB8\x56" => "\xE7\xA6\xBD",
		"\xB8\x57" => "\xE7\xA8\x9C",
		"\xB8\x58" => "\xE7\xA8\x9A",
		"\xB8\x59" => "\xE7\xA8\xA0",
		"\xB8\x5A" => "\xE7\xA8\x94",
		"\xB8\x5B" => "\xE7\xA8\x9F",
		"\xB8\x5C" => "\xE7\xA8\x9E",
		"\xB8\x5D" => "\xE7\xAA\x9F",
		"\xB8\x5E" => "\xE7\xAA\xA0",
		"\xB8\x5F" => "\xE7\xAD\xB7",
		"\xB8\x60" => "\xE7\xAF\x80",
		"\xB8\x61" => "\xE7\xAD\xA0",
		"\xB8\x62" => "\xE7\xAD\xAE",
		"\xB8\x63" => "\xE7\xAD\xA7",
		"\xB8\x64" => "\xE7\xB2\xB1",
		"\xB8\x65" => "\xE7\xB2\xB3",
		"\xB8\x66" => "\xE7\xB2\xB5",
		"\xB8\x67" => "\xE7\xB6\x93",
		"\xB8\x68" => "\xE7\xB5\xB9",
		"\xB8\x69" => "\xE7\xB6\x91",
		"\xB8\x6A" => "\xE7\xB6\x81",
		"\xB8\x6B" => "\xE7\xB6\x8F",
		"\xB8\x6C" => "\xE7\xB5\x9B",
		"\xB8\x6D" => "\xE7\xBD\xAE",
		"\xB8\x6E" => "\xE7\xBD\xA9",
		"\xB8\x6F" => "\xE7\xBD\xAA",
		"\xB8\x70" => "\xE7\xBD\xB2",
		"\xB8\x71" => "\xE7\xBE\xA9",
		"\xB8\x72" => "\xE7\xBE\xA8",
		"\xB8\x73" => "\xE7\xBE\xA4",
		"\xB8\x74" => "\xE8\x81\x96",
		"\xB8\x75" => "\xE8\x81\x98",
		"\xB8\x76" => "\xE8\x82\x86",
		"\xB8\x77" => "\xE8\x82\x84",
		"\xB8\x78" => "\xE8\x85\xB1",
		"\xB8\x79" => "\xE8\x85\xB0",
		"\xB8\x7A" => "\xE8\x85\xB8",
		"\xB8\x7B" => "\xE8\x85\xA5",
		"\xB8\x7C" => "\xE8\x85\xAE",
		"\xB8\x7D" => "\xE8\x85\xB3",
		"\xB8\x7E" => "\xE8\x85\xAB",
		"\xB8\xA1" => "\xE8\x85\xB9",
		"\xB8\xA2" => "\xE8\x85\xBA",
		"\xB8\xA3" => "\xE8\x85\xA6",
		"\xB8\xA4" => "\xE8\x88\x85",
		"\xB8\xA5" => "\xE8\x89\x87",
		"\xB8\xA6" => "\xE8\x92\x82",
		"\xB8\xA7" => "\xE8\x91\xB7",
		"\xB8\xA8" => "\xE8\x90\xBD",
		"\xB8\xA9" => "\xE8\x90\xB1",
		"\xB8\xAA" => "\xE8\x91\xB5",
		"\xB8\xAB" => "\xE8\x91\xA6",
		"\xB8\xAC" => "\xE8\x91\xAB",
		"\xB8\xAD" => "\xE8\x91\x89",
		"\xB8\xAE" => "\xE8\x91\xAC",
		"\xB8\xAF" => "\xE8\x91\x9B",
		"\xB8\xB0" => "\xE8\x90\xBC",
		"\xB8\xB1" => "\xE8\x90\xB5",
		"\xB8\xB2" => "\xE8\x91\xA1",
		"\xB8\xB3" => "\xE8\x91\xA3",
		"\xB8\xB4" => "\xE8\x91\xA9",
		"\xB8\xB5" => "\xE8\x91\xAD",
		"\xB8\xB6" => "\xE8\x91\x86",
		"\xB8\xB7" => "\xE8\x99\x9E",
		"\xB8\xB8" => "\xE8\x99\x9C",
		"\xB8\xB9" => "\xE8\x99\x9F",
		"\xB8\xBA" => "\xE8\x9B\xB9",
		"\xB8\xBB" => "\xE8\x9C\x93",
		"\xB8\xBC" => "\xE8\x9C\x88",
		"\xB8\xBD" => "\xE8\x9C\x87",
		"\xB8\xBE" => "\xE8\x9C\x80",
		"\xB8\xBF" => "\xE8\x9B\xBE",
		"\xB8\xC0" => "\xE8\x9B\xBB",
		"\xB8\xC1" => "\xE8\x9C\x82",
		"\xB8\xC2" => "\xE8\x9C\x83",
		"\xB8\xC3" => "\xE8\x9C\x86",
		"\xB8\xC4" => "\xE8\x9C\x8A",
		"\xB8\xC5" => "\xE8\xA1\x99",
		"\xB8\xC6" => "\xE8\xA3\x9F",
		"\xB8\xC7" => "\xE8\xA3\x94",
		"\xB8\xC8" => "\xE8\xA3\x99",
		"\xB8\xC9" => "\xE8\xA3\x9C",
		"\xB8\xCA" => "\xE8\xA3\x98",
		"\xB8\xCB" => "\xE8\xA3\x9D",
		"\xB8\xCC" => "\xE8\xA3\xA1",
		"\xB8\xCD" => "\xE8\xA3\x8A",
		"\xB8\xCE" => "\xE8\xA3\x95",
		"\xB8\xCF" => "\xE8\xA3\x92",
		"\xB8\xD0" => "\xE8\xA6\x9C",
		"\xB8\xD1" => "\xE8\xA7\xA3",
		"\xB8\xD2" => "\xE8\xA9\xAB",
		"\xB8\xD3" => "\xE8\xA9\xB2",
		"\xB8\xD4" => "\xE8\xA9\xB3",
		"\xB8\xD5" => "\xE8\xA9\xA6",
		"\xB8\xD6" => "\xE8\xA9\xA9",
		"\xB8\xD7" => "\xE8\xA9\xB0",
		"\xB8\xD8" => "\xE8\xAA\x87",
		"\xB8\xD9" => "\xE8\xA9\xBC",
		"\xB8\xDA" => "\xE8\xA9\xA3",
		"\xB8\xDB" => "\xE8\xAA\xA0",
		"\xB8\xDC" => "\xE8\xA9\xB1",
		"\xB8\xDD" => "\xE8\xAA\x85",
		"\xB8\xDE" => "\xE8\xA9\xAD",
		"\xB8\xDF" => "\xE8\xA9\xA2",
		"\xB8\xE0" => "\xE8\xA9\xAE",
		"\xB8\xE1" => "\xE8\xA9\xAC",
		"\xB8\xE2" => "\xE8\xA9\xB9",
		"\xB8\xE3" => "\xE8\xA9\xBB",
		"\xB8\xE4" => "\xE8\xA8\xBE",
		"\xB8\xE5" => "\xE8\xA9\xA8",
		"\xB8\xE6" => "\xE8\xB1\xA2",
		"\xB8\xE7" => "\xE8\xB2\x8A",
		"\xB8\xE8" => "\xE8\xB2\x89",
		"\xB8\xE9" => "\xE8\xB3\x8A",
		"\xB8\xEA" => "\xE8\xB3\x87",
		"\xB8\xEB" => "\xE8\xB3\x88",
		"\xB8\xEC" => "\xE8\xB3\x84",
		"\xB8\xED" => "\xE8\xB2\xB2",
		"\xB8\xEE" => "\xE8\xB3\x83",
		"\xB8\xEF" => "\xE8\xB3\x82",
		"\xB8\xF0" => "\xE8\xB3\x85",
		"\xB8\xF1" => "\xE8\xB7\xA1",
		"\xB8\xF2" => "\xE8\xB7\x9F",
		"\xB8\xF3" => "\xE8\xB7\xA8",
		"\xB8\xF4" => "\xE8\xB7\xAF",
		"\xB8\xF5" => "\xE8\xB7\xB3",
		"\xB8\xF6" => "\xE8\xB7\xBA",
		"\xB8\xF7" => "\xE8\xB7\xAA",
		"\xB8\xF8" => "\xE8\xB7\xA4",
		"\xB8\xF9" => "\xE8\xB7\xA6",
		"\xB8\xFA" => "\xE8\xBA\xB2",
		"\xB8\xFB" => "\xE8\xBC\x83",
		"\xB8\xFC" => "\xE8\xBC\x89",
		"\xB8\xFD" => "\xE8\xBB\xBE",
		"\xB8\xFE" => "\xE8\xBC\x8A",
		"\xB9\x40" => "\xE8\xBE\x9F",
		"\xB9\x41" => "\xE8\xBE\xB2",
		"\xB9\x42" => "\xE9\x81\x8B",
		"\xB9\x43" => "\xE9\x81\x8A",
		"\xB9\x44" => "\xE9\x81\x93",
		"\xB9\x45" => "\xE9\x81\x82",
		"\xB9\x46" => "\xE9\x81\x94",
		"\xB9\x47" => "\xE9\x80\xBC",
		"\xB9\x48" => "\xE9\x81\x95",
		"\xB9\x49" => "\xE9\x81\x90",
		"\xB9\x4A" => "\xE9\x81\x87",
		"\xB9\x4B" => "\xE9\x81\x8F",
		"\xB9\x4C" => "\xE9\x81\x8E",
		"\xB9\x4D" => "\xE9\x81\x8D",
		"\xB9\x4E" => "\xE9\x81\x91",
		"\xB9\x4F" => "\xE9\x80\xBE",
		"\xB9\x50" => "\xE9\x81\x81",
		"\xB9\x51" => "\xE9\x84\x92",
		"\xB9\x52" => "\xE9\x84\x97",
		"\xB9\x53" => "\xE9\x85\xAC",
		"\xB9\x54" => "\xE9\x85\xAA",
		"\xB9\x55" => "\xE9\x85\xA9",
		"\xB9\x56" => "\xE9\x87\x89",
		"\xB9\x57" => "\xE9\x88\xB7",
		"\xB9\x58" => "\xE9\x89\x97",
		"\xB9\x59" => "\xE9\x88\xB8",
		"\xB9\x5A" => "\xE9\x88\xBD",
		"\xB9\x5B" => "\xE9\x89\x80",
		"\xB9\x5C" => "\xE9\x88\xBE",
		"\xB9\x5D" => "\xE9\x89\x9B",
		"\xB9\x5E" => "\xE9\x89\x8B",
		"\xB9\x5F" => "\xE9\x89\xA4",
		"\xB9\x60" => "\xE9\x89\x91",
		"\xB9\x61" => "\xE9\x88\xB4",
		"\xB9\x62" => "\xE9\x89\x89",
		"\xB9\x63" => "\xE9\x89\x8D",
		"\xB9\x64" => "\xE9\x89\x85",
		"\xB9\x65" => "\xE9\x88\xB9",
		"\xB9\x66" => "\xE9\x88\xBF",
		"\xB9\x67" => "\xE9\x89\x9A",
		"\xB9\x68" => "\xE9\x96\x98",
		"\xB9\x69" => "\xE9\x9A\x98",
		"\xB9\x6A" => "\xE9\x9A\x94",
		"\xB9\x6B" => "\xE9\x9A\x95",
		"\xB9\x6C" => "\xE9\x9B\x8D",
		"\xB9\x6D" => "\xE9\x9B\x8B",
		"\xB9\x6E" => "\xE9\x9B\x89",
		"\xB9\x6F" => "\xE9\x9B\x8A",
		"\xB9\x70" => "\xE9\x9B\xB7",
		"\xB9\x71" => "\xE9\x9B\xBB",
		"\xB9\x72" => "\xE9\x9B\xB9",
		"\xB9\x73" => "\xE9\x9B\xB6",
		"\xB9\x74" => "\xE9\x9D\x96",
		"\xB9\x75" => "\xE9\x9D\xB4",
		"\xB9\x76" => "\xE9\x9D\xB6",
		"\xB9\x77" => "\xE9\xA0\x90",
		"\xB9\x78" => "\xE9\xA0\x91",
		"\xB9\x79" => "\xE9\xA0\x93",
		"\xB9\x7A" => "\xE9\xA0\x8A",
		"\xB9\x7B" => "\xE9\xA0\x92",
		"\xB9\x7C" => "\xE9\xA0\x8C",
		"\xB9\x7D" => "\xE9\xA3\xBC",
		"\xB9\x7E" => "\xE9\xA3\xB4",
		"\xB9\xA1" => "\xE9\xA3\xBD",
		"\xB9\xA2" => "\xE9\xA3\xBE",
		"\xB9\xA3" => "\xE9\xA6\xB3",
		"\xB9\xA4" => "\xE9\xA6\xB1",
		"\xB9\xA5" => "\xE9\xA6\xB4",
		"\xB9\xA6" => "\xE9\xAB\xA1",
		"\xB9\xA7" => "\xE9\xB3\xA9",
		"\xB9\xA8" => "\xE9\xBA\x82",
		"\xB9\xA9" => "\xE9\xBC\x8E",
		"\xB9\xAA" => "\xE9\xBC\x93",
		"\xB9\xAB" => "\xE9\xBC\xA0",
		"\xB9\xAC" => "\xE5\x83\xA7",
		"\xB9\xAD" => "\xE5\x83\xAE",
		"\xB9\xAE" => "\xE5\x83\xA5",
		"\xB9\xAF" => "\xE5\x83\x96",
		"\xB9\xB0" => "\xE5\x83\xAD",
		"\xB9\xB1" => "\xE5\x83\x9A",
		"\xB9\xB2" => "\xE5\x83\x95",
		"\xB9\xB3" => "\xE5\x83\x8F",
		"\xB9\xB4" => "\xE5\x83\x91",
		"\xB9\xB5" => "\xE5\x83\xB1",
		"\xB9\xB6" => "\xE5\x83\x8E",
		"\xB9\xB7" => "\xE5\x83\xA9",
		"\xB9\xB8" => "\xE5\x85\xA2",
		"\xB9\xB9" => "\xE5\x87\xB3",
		"\xB9\xBA" => "\xE5\x8A\x83",
		"\xB9\xBB" => "\xE5\x8A\x82",
		"\xB9\xBC" => "\xE5\x8C\xB1",
		"\xB9\xBD" => "\xE5\x8E\xAD",
		"\xB9\xBE" => "\xE5\x97\xBE",
		"\xB9\xBF" => "\xE5\x98\x80",
		"\xB9\xC0" => "\xE5\x98\x9B",
		"\xB9\xC1" => "\xE5\x98\x97",
		"\xB9\xC2" => "\xE5\x97\xBD",
		"\xB9\xC3" => "\xE5\x98\x94",
		"\xB9\xC4" => "\xE5\x98\x86",
		"\xB9\xC5" => "\xE5\x98\x89",
		"\xB9\xC6" => "\xE5\x98\x8D",
		"\xB9\xC7" => "\xE5\x98\x8E",
		"\xB9\xC8" => "\xE5\x97\xB7",
		"\xB9\xC9" => "\xE5\x98\x96",
		"\xB9\xCA" => "\xE5\x98\x9F",
		"\xB9\xCB" => "\xE5\x98\x88",
		"\xB9\xCC" => "\xE5\x98\x90",
		"\xB9\xCD" => "\xE5\x97\xB6",
		"\xB9\xCE" => "\xE5\x9C\x98",
		"\xB9\xCF" => "\xE5\x9C\x96",
		"\xB9\xD0" => "\xE5\xA1\xB5",
		"\xB9\xD1" => "\xE5\xA1\xBE",
		"\xB9\xD2" => "\xE5\xA2\x83",
		"\xB9\xD3" => "\xE5\xA2\x93",
		"\xB9\xD4" => "\xE5\xA2\x8A",
		"\xB9\xD5" => "\xE5\xA1\xB9",
		"\xB9\xD6" => "\xE5\xA2\x85",
		"\xB9\xD7" => "\xE5\xA1\xBD",
		"\xB9\xD8" => "\xE5\xA3\xBD",
		"\xB9\xD9" => "\xE5\xA4\xA5",
		"\xB9\xDA" => "\xE5\xA4\xA2",
		"\xB9\xDB" => "\xE5\xA4\xA4",
		"\xB9\xDC" => "\xE5\xA5\xAA",
		"\xB9\xDD" => "\xE5\xA5\xA9",
		"\xB9\xDE" => "\xE5\xAB\xA1",
		"\xB9\xDF" => "\xE5\xAB\xA6",
		"\xB9\xE0" => "\xE5\xAB\xA9",
		"\xB9\xE1" => "\xE5\xAB\x97",
		"\xB9\xE2" => "\xE5\xAB\x96",
		"\xB9\xE3" => "\xE5\xAB\x98",
		"\xB9\xE4" => "\xE5\xAB\xA3",
		"\xB9\xE5" => "\xE5\xAD\xB5",
		"\xB9\xE6" => "\xE5\xAF\x9E",
		"\xB9\xE7" => "\xE5\xAF\xA7",
		"\xB9\xE8" => "\xE5\xAF\xA1",
		"\xB9\xE9" => "\xE5\xAF\xA5",
		"\xB9\xEA" => "\xE5\xAF\xA6",
		"\xB9\xEB" => "\xE5\xAF\xA8",
		"\xB9\xEC" => "\xE5\xAF\xA2",
		"\xB9\xED" => "\xE5\xAF\xA4",
		"\xB9\xEE" => "\xE5\xAF\x9F",
		"\xB9\xEF" => "\xE5\xB0\x8D",
		"\xB9\xF0" => "\xE5\xB1\xA2",
		"\xB9\xF1" => "\xE5\xB6\x84",
		"\xB9\xF2" => "\xE5\xB6\x87",
		"\xB9\xF3" => "\xE5\xB9\x9B",
		"\xB9\xF4" => "\xE5\xB9\xA3",
		"\xB9\xF5" => "\xE5\xB9\x95",
		"\xB9\xF6" => "\xE5\xB9\x97",
		"\xB9\xF7" => "\xE5\xB9\x94",
		"\xB9\xF8" => "\xE5\xBB\x93",
		"\xB9\xF9" => "\xE5\xBB\x96",
		"\xB9\xFA" => "\xE5\xBC\x8A",
		"\xB9\xFB" => "\xE5\xBD\x86",
		"\xB9\xFC" => "\xE5\xBD\xB0",
		"\xB9\xFD" => "\xE5\xBE\xB9",
		"\xB9\xFE" => "\xE6\x85\x87",
		"\xBA\x40" => "\xE6\x84\xBF",
		"\xBA\x41" => "\xE6\x85\x8B",
		"\xBA\x42" => "\xE6\x85\xB7",
		"\xBA\x43" => "\xE6\x85\xA2",
		"\xBA\x44" => "\xE6\x85\xA3",
		"\xBA\x45" => "\xE6\x85\x9F",
		"\xBA\x46" => "\xE6\x85\x9A",
		"\xBA\x47" => "\xE6\x85\x98",
		"\xBA\x48" => "\xE6\x85\xB5",
		"\xBA\x49" => "\xE6\x88\xAA",
		"\xBA\x4A" => "\xE6\x92\x87",
		"\xBA\x4B" => "\xE6\x91\x98",
		"\xBA\x4C" => "\xE6\x91\x94",
		"\xBA\x4D" => "\xE6\x92\xA4",
		"\xBA\x4E" => "\xE6\x91\xB8",
		"\xBA\x4F" => "\xE6\x91\x9F",
		"\xBA\x50" => "\xE6\x91\xBA",
		"\xBA\x51" => "\xE6\x91\x91",
		"\xBA\x52" => "\xE6\x91\xA7",
		"\xBA\x53" => "\xE6\x90\xB4",
		"\xBA\x54" => "\xE6\x91\xAD",
		"\xBA\x55" => "\xE6\x91\xBB",
		"\xBA\x56" => "\xE6\x95\xB2",
		"\xBA\x57" => "\xE6\x96\xA1",
		"\xBA\x58" => "\xE6\x97\x97",
		"\xBA\x59" => "\xE6\x97\x96",
		"\xBA\x5A" => "\xE6\x9A\xA2",
		"\xBA\x5B" => "\xE6\x9A\xA8",
		"\xBA\x5C" => "\xE6\x9A\x9D",
		"\xBA\x5D" => "\xE6\xA6\x9C",
		"\xBA\x5E" => "\xE6\xA6\xA8",
		"\xBA\x5F" => "\xE6\xA6\x95",
		"\xBA\x60" => "\xE6\xA7\x81",
		"\xBA\x61" => "\xE6\xA6\xAE",
		"\xBA\x62" => "\xE6\xA7\x93",
		"\xBA\x63" => "\xE6\xA7\x8B",
		"\xBA\x64" => "\xE6\xA6\x9B",
		"\xBA\x65" => "\xE6\xA6\xB7",
		"\xBA\x66" => "\xE6\xA6\xBB",
		"\xBA\x67" => "\xE6\xA6\xAB",
		"\xBA\x68" => "\xE6\xA6\xB4",
		"\xBA\x69" => "\xE6\xA7\x90",
		"\xBA\x6A" => "\xE6\xA7\x8D",
		"\xBA\x6B" => "\xE6\xA6\xAD",
		"\xBA\x6C" => "\xE6\xA7\x8C",
		"\xBA\x6D" => "\xE6\xA6\xA6",
		"\xBA\x6E" => "\xE6\xA7\x83",
		"\xBA\x6F" => "\xE6\xA6\xA3",
		"\xBA\x70" => "\xE6\xAD\x89",
		"\xBA\x71" => "\xE6\xAD\x8C",
		"\xBA\x72" => "\xE6\xB0\xB3",
		"\xBA\x73" => "\xE6\xBC\xB3",
		"\xBA\x74" => "\xE6\xBC\x94",
		"\xBA\x75" => "\xE6\xBB\xBE",
		"\xBA\x76" => "\xE6\xBC\x93",
		"\xBA\x77" => "\xE6\xBB\xB4",
		"\xBA\x78" => "\xE6\xBC\xA9",
		"\xBA\x79" => "\xE6\xBC\xBE",
		"\xBA\x7A" => "\xE6\xBC\xA0",
		"\xBA\x7B" => "\xE6\xBC\xAC",
		"\xBA\x7C" => "\xE6\xBC\x8F",
		"\xBA\x7D" => "\xE6\xBC\x82",
		"\xBA\x7E" => "\xE6\xBC\xA2",
		"\xBA\xA1" => "\xE6\xBB\xBF",
		"\xBA\xA2" => "\xE6\xBB\xAF",
		"\xBA\xA3" => "\xE6\xBC\x86",
		"\xBA\xA4" => "\xE6\xBC\xB1",
		"\xBA\xA5" => "\xE6\xBC\xB8",
		"\xBA\xA6" => "\xE6\xBC\xB2",
		"\xBA\xA7" => "\xE6\xBC\xA3",
		"\xBA\xA8" => "\xE6\xBC\x95",
		"\xBA\xA9" => "\xE6\xBC\xAB",
		"\xBA\xAA" => "\xE6\xBC\xAF",
		"\xBA\xAB" => "\xE6\xBE\x88",
		"\xBA\xAC" => "\xE6\xBC\xAA",
		"\xBA\xAD" => "\xE6\xBB\xAC",
		"\xBA\xAE" => "\xE6\xBC\x81",
		"\xBA\xAF" => "\xE6\xBB\xB2",
		"\xBA\xB0" => "\xE6\xBB\x8C",
		"\xBA\xB1" => "\xE6\xBB\xB7",
		"\xBA\xB2" => "\xE7\x86\x94",
		"\xBA\xB3" => "\xE7\x86\x99",
		"\xBA\xB4" => "\xE7\x85\xBD",
		"\xBA\xB5" => "\xE7\x86\x8A",
		"\xBA\xB6" => "\xE7\x86\x84",
		"\xBA\xB7" => "\xE7\x86\x92",
		"\xBA\xB8" => "\xE7\x88\xBE",
		"\xBA\xB9" => "\xE7\x8A\x92",
		"\xBA\xBA" => "\xE7\x8A\x96",
		"\xBA\xBB" => "\xE7\x8D\x84",
		"\xBA\xBC" => "\xE7\x8D\x90",
		"\xBA\xBD" => "\xE7\x91\xA4",
		"\xBA\xBE" => "\xE7\x91\xA3",
		"\xBA\xBF" => "\xE7\x91\xAA",
		"\xBA\xC0" => "\xE7\x91\xB0",
		"\xBA\xC1" => "\xE7\x91\xAD",
		"\xBA\xC2" => "\xE7\x94\x84",
		"\xBA\xC3" => "\xE7\x96\x91",
		"\xBA\xC4" => "\xE7\x98\xA7",
		"\xBA\xC5" => "\xE7\x98\x8D",
		"\xBA\xC6" => "\xE7\x98\x8B",
		"\xBA\xC7" => "\xE7\x98\x89",
		"\xBA\xC8" => "\xE7\x98\x93",
		"\xBA\xC9" => "\xE7\x9B\xA1",
		"\xBA\xCA" => "\xE7\x9B\xA3",
		"\xBA\xCB" => "\xE7\x9E\x84",
		"\xBA\xCC" => "\xE7\x9D\xBD",
		"\xBA\xCD" => "\xE7\x9D\xBF",
		"\xBA\xCE" => "\xE7\x9D\xA1",
		"\xBA\xCF" => "\xE7\xA3\x81",
		"\xBA\xD0" => "\xE7\xA2\x9F",
		"\xBA\xD1" => "\xE7\xA2\xA7",
		"\xBA\xD2" => "\xE7\xA2\xB3",
		"\xBA\xD3" => "\xE7\xA2\xA9",
		"\xBA\xD4" => "\xE7\xA2\xA3",
		"\xBA\xD5" => "\xE7\xA6\x8E",
		"\xBA\xD6" => "\xE7\xA6\x8F",
		"\xBA\xD7" => "\xE7\xA6\x8D",
		"\xBA\xD8" => "\xE7\xA8\xAE",
		"\xBA\xD9" => "\xE7\xA8\xB1",
		"\xBA\xDA" => "\xE7\xAA\xAA",
		"\xBA\xDB" => "\xE7\xAA\xA9",
		"\xBA\xDC" => "\xE7\xAB\xAD",
		"\xBA\xDD" => "\xE7\xAB\xAF",
		"\xBA\xDE" => "\xE7\xAE\xA1",
		"\xBA\xDF" => "\xE7\xAE\x95",
		"\xBA\xE0" => "\xE7\xAE\x8B",
		"\xBA\xE1" => "\xE7\xAD\xB5",
		"\xBA\xE2" => "\xE7\xAE\x97",
		"\xBA\xE3" => "\xE7\xAE\x9D",
		"\xBA\xE4" => "\xE7\xAE\x94",
		"\xBA\xE5" => "\xE7\xAE\x8F",
		"\xBA\xE6" => "\xE7\xAE\xB8",
		"\xBA\xE7" => "\xE7\xAE\x87",
		"\xBA\xE8" => "\xE7\xAE\x84",
		"\xBA\xE9" => "\xE7\xB2\xB9",
		"\xBA\xEA" => "\xE7\xB2\xBD",
		"\xBA\xEB" => "\xE7\xB2\xBE",
		"\xBA\xEC" => "\xE7\xB6\xBB",
		"\xBA\xED" => "\xE7\xB6\xB0",
		"\xBA\xEE" => "\xE7\xB6\x9C",
		"\xBA\xEF" => "\xE7\xB6\xBD",
		"\xBA\xF0" => "\xE7\xB6\xBE",
		"\xBA\xF1" => "\xE7\xB6\xA0",
		"\xBA\xF2" => "\xE7\xB7\x8A",
		"\xBA\xF3" => "\xE7\xB6\xB4",
		"\xBA\xF4" => "\xE7\xB6\xB2",
		"\xBA\xF5" => "\xE7\xB6\xB1",
		"\xBA\xF6" => "\xE7\xB6\xBA",
		"\xBA\xF7" => "\xE7\xB6\xA2",
		"\xBA\xF8" => "\xE7\xB6\xBF",
		"\xBA\xF9" => "\xE7\xB6\xB5",
		"\xBA\xFA" => "\xE7\xB6\xB8",
		"\xBA\xFB" => "\xE7\xB6\xAD",
		"\xBA\xFC" => "\xE7\xB7\x92",
		"\xBA\xFD" => "\xE7\xB7\x87",
		"\xBA\xFE" => "\xE7\xB6\xAC",
		"\xBB\x40" => "\xE7\xBD\xB0",
		"\xBB\x41" => "\xE7\xBF\xA0",
		"\xBB\x42" => "\xE7\xBF\xA1",
		"\xBB\x43" => "\xE7\xBF\x9F",
		"\xBB\x44" => "\xE8\x81\x9E",
		"\xBB\x45" => "\xE8\x81\x9A",
		"\xBB\x46" => "\xE8\x82\x87",
		"\xBB\x47" => "\xE8\x85\x90",
		"\xBB\x48" => "\xE8\x86\x80",
		"\xBB\x49" => "\xE8\x86\x8F",
		"\xBB\x4A" => "\xE8\x86\x88",
		"\xBB\x4B" => "\xE8\x86\x8A",
		"\xBB\x4C" => "\xE8\x85\xBF",
		"\xBB\x4D" => "\xE8\x86\x82",
		"\xBB\x4E" => "\xE8\x87\xA7",
		"\xBB\x4F" => "\xE8\x87\xBA",
		"\xBB\x50" => "\xE8\x88\x87",
		"\xBB\x51" => "\xE8\x88\x94",
		"\xBB\x52" => "\xE8\x88\x9E",
		"\xBB\x53" => "\xE8\x89\x8B",
		"\xBB\x54" => "\xE8\x93\x89",
		"\xBB\x55" => "\xE8\x92\xBF",
		"\xBB\x56" => "\xE8\x93\x86",
		"\xBB\x57" => "\xE8\x93\x84",
		"\xBB\x58" => "\xE8\x92\x99",
		"\xBB\x59" => "\xE8\x92\x9E",
		"\xBB\x5A" => "\xE8\x92\xB2",
		"\xBB\x5B" => "\xE8\x92\x9C",
		"\xBB\x5C" => "\xE8\x93\x8B",
		"\xBB\x5D" => "\xE8\x92\xB8",
		"\xBB\x5E" => "\xE8\x93\x80",
		"\xBB\x5F" => "\xE8\x93\x93",
		"\xBB\x60" => "\xE8\x92\x90",
		"\xBB\x61" => "\xE8\x92\xBC",
		"\xBB\x62" => "\xE8\x93\x91",
		"\xBB\x63" => "\xE8\x93\x8A",
		"\xBB\x64" => "\xE8\x9C\xBF",
		"\xBB\x65" => "\xE8\x9C\x9C",
		"\xBB\x66" => "\xE8\x9C\xBB",
		"\xBB\x67" => "\xE8\x9C\xA2",
		"\xBB\x68" => "\xE8\x9C\xA5",
		"\xBB\x69" => "\xE8\x9C\xB4",
		"\xBB\x6A" => "\xE8\x9C\x98",
		"\xBB\x6B" => "\xE8\x9D\x95",
		"\xBB\x6C" => "\xE8\x9C\xB7",
		"\xBB\x6D" => "\xE8\x9C\xA9",
		"\xBB\x6E" => "\xE8\xA3\xB3",
		"\xBB\x6F" => "\xE8\xA4\x82",
		"\xBB\x70" => "\xE8\xA3\xB4",
		"\xBB\x71" => "\xE8\xA3\xB9",
		"\xBB\x72" => "\xE8\xA3\xB8",
		"\xBB\x73" => "\xE8\xA3\xBD",
		"\xBB\x74" => "\xE8\xA3\xA8",
		"\xBB\x75" => "\xE8\xA4\x9A",
		"\xBB\x76" => "\xE8\xA3\xAF",
		"\xBB\x77" => "\xE8\xAA\xA6",
		"\xBB\x78" => "\xE8\xAA\x8C",
		"\xBB\x79" => "\xE8\xAA\x9E",
		"\xBB\x7A" => "\xE8\xAA\xA3",
		"\xBB\x7B" => "\xE8\xAA\x8D",
		"\xBB\x7C" => "\xE8\xAA\xA1",
		"\xBB\x7D" => "\xE8\xAA\x93",
		"\xBB\x7E" => "\xE8\xAA\xA4",
		"\xBB\xA1" => "\xE8\xAA\xAA",
		"\xBB\xA2" => "\xE8\xAA\xA5",
		"\xBB\xA3" => "\xE8\xAA\xA8",
		"\xBB\xA4" => "\xE8\xAA\x98",
		"\xBB\xA5" => "\xE8\xAA\x91",
		"\xBB\xA6" => "\xE8\xAA\x9A",
		"\xBB\xA7" => "\xE8\xAA\xA7",
		"\xBB\xA8" => "\xE8\xB1\xAA",
		"\xBB\xA9" => "\xE8\xB2\x8D",
		"\xBB\xAA" => "\xE8\xB2\x8C",
		"\xBB\xAB" => "\xE8\xB3\x93",
		"\xBB\xAC" => "\xE8\xB3\x91",
		"\xBB\xAD" => "\xE8\xB3\x92",
		"\xBB\xAE" => "\xE8\xB5\xAB",
		"\xBB\xAF" => "\xE8\xB6\x99",
		"\xBB\xB0" => "\xE8\xB6\x95",
		"\xBB\xB1" => "\xE8\xB7\xBC",
		"\xBB\xB2" => "\xE8\xBC\x94",
		"\xBB\xB3" => "\xE8\xBC\x92",
		"\xBB\xB4" => "\xE8\xBC\x95",
		"\xBB\xB5" => "\xE8\xBC\x93",
		"\xBB\xB6" => "\xE8\xBE\xA3",
		"\xBB\xB7" => "\xE9\x81\xA0",
		"\xBB\xB8" => "\xE9\x81\x98",
		"\xBB\xB9" => "\xE9\x81\x9C",
		"\xBB\xBA" => "\xE9\x81\xA3",
		"\xBB\xBB" => "\xE9\x81\x99",
		"\xBB\xBC" => "\xE9\x81\x9E",
		"\xBB\xBD" => "\xE9\x81\xA2",
		"\xBB\xBE" => "\xE9\x81\x9D",
		"\xBB\xBF" => "\xE9\x81\x9B",
		"\xBB\xC0" => "\xE9\x84\x99",
		"\xBB\xC1" => "\xE9\x84\x98",
		"\xBB\xC2" => "\xE9\x84\x9E",
		"\xBB\xC3" => "\xE9\x85\xB5",
		"\xBB\xC4" => "\xE9\x85\xB8",
		"\xBB\xC5" => "\xE9\x85\xB7",
		"\xBB\xC6" => "\xE9\x85\xB4",
		"\xBB\xC7" => "\xE9\x89\xB8",
		"\xBB\xC8" => "\xE9\x8A\x80",
		"\xBB\xC9" => "\xE9\x8A\x85",
		"\xBB\xCA" => "\xE9\x8A\x98",
		"\xBB\xCB" => "\xE9\x8A\x96",
		"\xBB\xCC" => "\xE9\x89\xBB",
		"\xBB\xCD" => "\xE9\x8A\x93",
		"\xBB\xCE" => "\xE9\x8A\x9C",
		"\xBB\xCF" => "\xE9\x8A\xA8",
		"\xBB\xD0" => "\xE9\x89\xBC",
		"\xBB\xD1" => "\xE9\x8A\x91",
		"\xBB\xD2" => "\xE9\x96\xA1",
		"\xBB\xD3" => "\xE9\x96\xA8",
		"\xBB\xD4" => "\xE9\x96\xA9",
		"\xBB\xD5" => "\xE9\x96\xA3",
		"\xBB\xD6" => "\xE9\x96\xA5",
		"\xBB\xD7" => "\xE9\x96\xA4",
		"\xBB\xD8" => "\xE9\x9A\x99",
		"\xBB\xD9" => "\xE9\x9A\x9C",
		"\xBB\xDA" => "\xE9\x9A\x9B",
		"\xBB\xDB" => "\xE9\x9B\x8C",
		"\xBB\xDC" => "\xE9\x9B\x92",
		"\xBB\xDD" => "\xE9\x9C\x80",
		"\xBB\xDE" => "\xE9\x9D\xBC",
		"\xBB\xDF" => "\xE9\x9E\x85",
		"\xBB\xE0" => "\xE9\x9F\xB6",
		"\xBB\xE1" => "\xE9\xA0\x97",
		"\xBB\xE2" => "\xE9\xA0\x98",
		"\xBB\xE3" => "\xE9\xA2\xAF",
		"\xBB\xE4" => "\xE9\xA2\xB1",
		"\xBB\xE5" => "\xE9\xA4\x83",
		"\xBB\xE6" => "\xE9\xA4\x85",
		"\xBB\xE7" => "\xE9\xA4\x8C",
		"\xBB\xE8" => "\xE9\xA4\x89",
		"\xBB\xE9" => "\xE9\xA7\x81",
		"\xBB\xEA" => "\xE9\xAA\xAF",
		"\xBB\xEB" => "\xE9\xAA\xB0",
		"\xBB\xEC" => "\xE9\xAB\xA6",
		"\xBB\xED" => "\xE9\xAD\x81",
		"\xBB\xEE" => "\xE9\xAD\x82",
		"\xBB\xEF" => "\xE9\xB3\xB4",
		"\xBB\xF0" => "\xE9\xB3\xB6",
		"\xBB\xF1" => "\xE9\xB3\xB3",
		"\xBB\xF2" => "\xE9\xBA\xBC",
		"\xBB\xF3" => "\xE9\xBC\xBB",
		"\xBB\xF4" => "\xE9\xBD\x8A",
		"\xBB\xF5" => "\xE5\x84\x84",
		"\xBB\xF6" => "\xE5\x84\x80",
		"\xBB\xF7" => "\xE5\x83\xBB",
		"\xBB\xF8" => "\xE5\x83\xB5",
		"\xBB\xF9" => "\xE5\x83\xB9",
		"\xBB\xFA" => "\xE5\x84\x82",
		"\xBB\xFB" => "\xE5\x84\x88",
		"\xBB\xFC" => "\xE5\x84\x89",
		"\xBB\xFD" => "\xE5\x84\x85",
		"\xBB\xFE" => "\xE5\x87\x9C",
		"\xBC\x40" => "\xE5\x8A\x87",
		"\xBC\x41" => "\xE5\x8A\x88",
		"\xBC\x42" => "\xE5\x8A\x89",
		"\xBC\x43" => "\xE5\x8A\x8D",
		"\xBC\x44" => "\xE5\x8A\x8A",
		"\xBC\x45" => "\xE5\x8B\xB0",
		"\xBC\x46" => "\xE5\x8E\xB2",
		"\xBC\x47" => "\xE5\x98\xAE",
		"\xBC\x48" => "\xE5\x98\xBB",
		"\xBC\x49" => "\xE5\x98\xB9",
		"\xBC\x4A" => "\xE5\x98\xB2",
		"\xBC\x4B" => "\xE5\x98\xBF",
		"\xBC\x4C" => "\xE5\x98\xB4",
		"\xBC\x4D" => "\xE5\x98\xA9",
		"\xBC\x4E" => "\xE5\x99\x93",
		"\xBC\x4F" => "\xE5\x99\x8E",
		"\xBC\x50" => "\xE5\x99\x97",
		"\xBC\x51" => "\xE5\x99\xB4",
		"\xBC\x52" => "\xE5\x98\xB6",
		"\xBC\x53" => "\xE5\x98\xAF",
		"\xBC\x54" => "\xE5\x98\xB0",
		"\xBC\x55" => "\xE5\xA2\x80",
		"\xBC\x56" => "\xE5\xA2\x9F",
		"\xBC\x57" => "\xE5\xA2\x9E",
		"\xBC\x58" => "\xE5\xA2\xB3",
		"\xBC\x59" => "\xE5\xA2\x9C",
		"\xBC\x5A" => "\xE5\xA2\xAE",
		"\xBC\x5B" => "\xE5\xA2\xA9",
		"\xBC\x5C" => "\xE5\xA2\xA6",
		"\xBC\x5D" => "\xE5\xA5\xAD",
		"\xBC\x5E" => "\xE5\xAC\x89",
		"\xBC\x5F" => "\xE5\xAB\xBB",
		"\xBC\x60" => "\xE5\xAC\x8B",
		"\xBC\x61" => "\xE5\xAB\xB5",
		"\xBC\x62" => "\xE5\xAC\x8C",
		"\xBC\x63" => "\xE5\xAC\x88",
		"\xBC\x64" => "\xE5\xAF\xAE",
		"\xBC\x65" => "\xE5\xAF\xAC",
		"\xBC\x66" => "\xE5\xAF\xA9",
		"\xBC\x67" => "\xE5\xAF\xAB",
		"\xBC\x68" => "\xE5\xB1\xA4",
		"\xBC\x69" => "\xE5\xB1\xA5",
		"\xBC\x6A" => "\xE5\xB6\x9D",
		"\xBC\x6B" => "\xE5\xB6\x94",
		"\xBC\x6C" => "\xE5\xB9\xA2",
		"\xBC\x6D" => "\xE5\xB9\x9F",
		"\xBC\x6E" => "\xE5\xB9\xA1",
		"\xBC\x6F" => "\xE5\xBB\xA2",
		"\xBC\x70" => "\xE5\xBB\x9A",
		"\xBC\x71" => "\xE5\xBB\x9F",
		"\xBC\x72" => "\xE5\xBB\x9D",
		"\xBC\x73" => "\xE5\xBB\xA3",
		"\xBC\x74" => "\xE5\xBB\xA0",
		"\xBC\x75" => "\xE5\xBD\x88",
		"\xBC\x76" => "\xE5\xBD\xB1",
		"\xBC\x77" => "\xE5\xBE\xB7",
		"\xBC\x78" => "\xE5\xBE\xB5",
		"\xBC\x79" => "\xE6\x85\xB6",
		"\xBC\x7A" => "\xE6\x85\xA7",
		"\xBC\x7B" => "\xE6\x85\xAE",
		"\xBC\x7C" => "\xE6\x85\x9D",
		"\xBC\x7D" => "\xE6\x85\x95",
		"\xBC\x7E" => "\xE6\x86\x82",
		"\xBC\xA1" => "\xE6\x85\xBC",
		"\xBC\xA2" => "\xE6\x85\xB0",
		"\xBC\xA3" => "\xE6\x85\xAB",
		"\xBC\xA4" => "\xE6\x85\xBE",
		"\xBC\xA5" => "\xE6\x86\xA7",
		"\xBC\xA6" => "\xE6\x86\x90",
		"\xBC\xA7" => "\xE6\x86\xAB",
		"\xBC\xA8" => "\xE6\x86\x8E",
		"\xBC\xA9" => "\xE6\x86\xAC",
		"\xBC\xAA" => "\xE6\x86\x9A",
		"\xBC\xAB" => "\xE6\x86\xA4",
		"\xBC\xAC" => "\xE6\x86\x94",
		"\xBC\xAD" => "\xE6\x86\xAE",
		"\xBC\xAE" => "\xE6\x88\xAE",
		"\xBC\xAF" => "\xE6\x91\xA9",
		"\xBC\xB0" => "\xE6\x91\xAF",
		"\xBC\xB1" => "\xE6\x91\xB9",
		"\xBC\xB2" => "\xE6\x92\x9E",
		"\xBC\xB3" => "\xE6\x92\xB2",
		"\xBC\xB4" => "\xE6\x92\x88",
		"\xBC\xB5" => "\xE6\x92\x90",
		"\xBC\xB6" => "\xE6\x92\xB0",
		"\xBC\xB7" => "\xE6\x92\xA5",
		"\xBC\xB8" => "\xE6\x92\x93",
		"\xBC\xB9" => "\xE6\x92\x95",
		"\xBC\xBA" => "\xE6\x92\xA9",
		"\xBC\xBB" => "\xE6\x92\x92",
		"\xBC\xBC" => "\xE6\x92\xAE",
		"\xBC\xBD" => "\xE6\x92\xAD",
		"\xBC\xBE" => "\xE6\x92\xAB",
		"\xBC\xBF" => "\xE6\x92\x9A",
		"\xBC\xC0" => "\xE6\x92\xAC",
		"\xBC\xC1" => "\xE6\x92\x99",
		"\xBC\xC2" => "\xE6\x92\xA2",
		"\xBC\xC3" => "\xE6\x92\xB3",
		"\xBC\xC4" => "\xE6\x95\xB5",
		"\xBC\xC5" => "\xE6\x95\xB7",
		"\xBC\xC6" => "\xE6\x95\xB8",
		"\xBC\xC7" => "\xE6\x9A\xAE",
		"\xBC\xC8" => "\xE6\x9A\xAB",
		"\xBC\xC9" => "\xE6\x9A\xB4",
		"\xBC\xCA" => "\xE6\x9A\xB1",
		"\xBC\xCB" => "\xE6\xA8\xA3",
		"\xBC\xCC" => "\xE6\xA8\x9F",
		"\xBC\xCD" => "\xE6\xA7\xA8",
		"\xBC\xCE" => "\xE6\xA8\x81",
		"\xBC\xCF" => "\xE6\xA8\x9E",
		"\xBC\xD0" => "\xE6\xA8\x99",
		"\xBC\xD1" => "\xE6\xA7\xBD",
		"\xBC\xD2" => "\xE6\xA8\xA1",
		"\xBC\xD3" => "\xE6\xA8\x93",
		"\xBC\xD4" => "\xE6\xA8\x8A",
		"\xBC\xD5" => "\xE6\xA7\xB3",
		"\xBC\xD6" => "\xE6\xA8\x82",
		"\xBC\xD7" => "\xE6\xA8\x85",
		"\xBC\xD8" => "\xE6\xA7\xAD",
		"\xBC\xD9" => "\xE6\xA8\x91",
		"\xBC\xDA" => "\xE6\xAD\x90",
		"\xBC\xDB" => "\xE6\xAD\x8E",
		"\xBC\xDC" => "\xE6\xAE\xA4",
		"\xBC\xDD" => "\xE6\xAF\x85",
		"\xBC\xDE" => "\xE6\xAF\x86",
		"\xBC\xDF" => "\xE6\xBC\xBF",
		"\xBC\xE0" => "\xE6\xBD\xBC",
		"\xBC\xE1" => "\xE6\xBE\x84",
		"\xBC\xE2" => "\xE6\xBD\x91",
		"\xBC\xE3" => "\xE6\xBD\xA6",
		"\xBC\xE4" => "\xE6\xBD\x94",
		"\xBC\xE5" => "\xE6\xBE\x86",
		"\xBC\xE6" => "\xE6\xBD\xAD",
		"\xBC\xE7" => "\xE6\xBD\x9B",
		"\xBC\xE8" => "\xE6\xBD\xB8",
		"\xBC\xE9" => "\xE6\xBD\xAE",
		"\xBC\xEA" => "\xE6\xBE\x8E",
		"\xBC\xEB" => "\xE6\xBD\xBA",
		"\xBC\xEC" => "\xE6\xBD\xB0",
		"\xBC\xED" => "\xE6\xBD\xA4",
		"\xBC\xEE" => "\xE6\xBE\x97",
		"\xBC\xEF" => "\xE6\xBD\x98",
		"\xBC\xF0" => "\xE6\xBB\x95",
		"\xBC\xF1" => "\xE6\xBD\xAF",
		"\xBC\xF2" => "\xE6\xBD\xA0",
		"\xBC\xF3" => "\xE6\xBD\x9F",
		"\xBC\xF4" => "\xE7\x86\x9F",
		"\xBC\xF5" => "\xE7\x86\xAC",
		"\xBC\xF6" => "\xE7\x86\xB1",
		"\xBC\xF7" => "\xE7\x86\xA8",
		"\xBC\xF8" => "\xE7\x89\x96",
		"\xBC\xF9" => "\xE7\x8A\x9B",
		"\xBC\xFA" => "\xE7\x8D\x8E",
		"\xBC\xFB" => "\xE7\x8D\x97",
		"\xBC\xFC" => "\xE7\x91\xA9",
		"\xBC\xFD" => "\xE7\x92\x8B",
		"\xBC\xFE" => "\xE7\x92\x83",
		"\xBD\x40" => "\xE7\x91\xBE",
		"\xBD\x41" => "\xE7\x92\x80",
		"\xBD\x42" => "\xE7\x95\xBF",
		"\xBD\x43" => "\xE7\x98\xA0",
		"\xBD\x44" => "\xE7\x98\xA9",
		"\xBD\x45" => "\xE7\x98\x9F",
		"\xBD\x46" => "\xE7\x98\xA4",
		"\xBD\x47" => "\xE7\x98\xA6",
		"\xBD\x48" => "\xE7\x98\xA1",
		"\xBD\x49" => "\xE7\x98\xA2",
		"\xBD\x4A" => "\xE7\x9A\x9A",
		"\xBD\x4B" => "\xE7\x9A\xBA",
		"\xBD\x4C" => "\xE7\x9B\xA4",
		"\xBD\x4D" => "\xE7\x9E\x8E",
		"\xBD\x4E" => "\xE7\x9E\x87",
		"\xBD\x4F" => "\xE7\x9E\x8C",
		"\xBD\x50" => "\xE7\x9E\x91",
		"\xBD\x51" => "\xE7\x9E\x8B",
		"\xBD\x52" => "\xE7\xA3\x8B",
		"\xBD\x53" => "\xE7\xA3\x85",
		"\xBD\x54" => "\xE7\xA2\xBA",
		"\xBD\x55" => "\xE7\xA3\x8A",
		"\xBD\x56" => "\xE7\xA2\xBE",
		"\xBD\x57" => "\xE7\xA3\x95",
		"\xBD\x58" => "\xE7\xA2\xBC",
		"\xBD\x59" => "\xE7\xA3\x90",
		"\xBD\x5A" => "\xE7\xA8\xBF",
		"\xBD\x5B" => "\xE7\xA8\xBC",
		"\xBD\x5C" => "\xE7\xA9\x80",
		"\xBD\x5D" => "\xE7\xA8\xBD",
		"\xBD\x5E" => "\xE7\xA8\xB7",
		"\xBD\x5F" => "\xE7\xA8\xBB",
		"\xBD\x60" => "\xE7\xAA\xAF",
		"\xBD\x61" => "\xE7\xAA\xAE",
		"\xBD\x62" => "\xE7\xAE\xAD",
		"\xBD\x63" => "\xE7\xAE\xB1",
		"\xBD\x64" => "\xE7\xAF\x84",
		"\xBD\x65" => "\xE7\xAE\xB4",
		"\xBD\x66" => "\xE7\xAF\x86",
		"\xBD\x67" => "\xE7\xAF\x87",
		"\xBD\x68" => "\xE7\xAF\x81",
		"\xBD\x69" => "\xE7\xAE\xA0",
		"\xBD\x6A" => "\xE7\xAF\x8C",
		"\xBD\x6B" => "\xE7\xB3\x8A",
		"\xBD\x6C" => "\xE7\xB7\xA0",
		"\xBD\x6D" => "\xE7\xB7\xB4",
		"\xBD\x6E" => "\xE7\xB7\xAF",
		"\xBD\x6F" => "\xE7\xB7\xBB",
		"\xBD\x70" => "\xE7\xB7\x98",
		"\xBD\x71" => "\xE7\xB7\xAC",
		"\xBD\x72" => "\xE7\xB7\x9D",
		"\xBD\x73" => "\xE7\xB7\xA8",
		"\xBD\x74" => "\xE7\xB7\xA3",
		"\xBD\x75" => "\xE7\xB7\x9A",
		"\xBD\x76" => "\xE7\xB7\x9E",
		"\xBD\x77" => "\xE7\xB7\xA9",
		"\xBD\x78" => "\xE7\xB6\x9E",
		"\xBD\x79" => "\xE7\xB7\x99",
		"\xBD\x7A" => "\xE7\xB7\xB2",
		"\xBD\x7B" => "\xE7\xB7\xB9",
		"\xBD\x7C" => "\xE7\xBD\xB5",
		"\xBD\x7D" => "\xE7\xBD\xB7",
		"\xBD\x7E" => "\xE7\xBE\xAF",
		"\xBD\xA1" => "\xE7\xBF\xA9",
		"\xBD\xA2" => "\xE8\x80\xA6",
		"\xBD\xA3" => "\xE8\x86\x9B",
		"\xBD\xA4" => "\xE8\x86\x9C",
		"\xBD\xA5" => "\xE8\x86\x9D",
		"\xBD\xA6" => "\xE8\x86\xA0",
		"\xBD\xA7" => "\xE8\x86\x9A",
		"\xBD\xA8" => "\xE8\x86\x98",
		"\xBD\xA9" => "\xE8\x94\x97",
		"\xBD\xAA" => "\xE8\x94\xBD",
		"\xBD\xAB" => "\xE8\x94\x9A",
		"\xBD\xAC" => "\xE8\x93\xAE",
		"\xBD\xAD" => "\xE8\x94\xAC",
		"\xBD\xAE" => "\xE8\x94\xAD",
		"\xBD\xAF" => "\xE8\x94\x93",
		"\xBD\xB0" => "\xE8\x94\x91",
		"\xBD\xB1" => "\xE8\x94\xA3",
		"\xBD\xB2" => "\xE8\x94\xA1",
		"\xBD\xB3" => "\xE8\x94\x94",
		"\xBD\xB4" => "\xE8\x93\xAC",
		"\xBD\xB5" => "\xE8\x94\xA5",
		"\xBD\xB6" => "\xE8\x93\xBF",
		"\xBD\xB7" => "\xE8\x94\x86",
		"\xBD\xB8" => "\xE8\x9E\x82",
		"\xBD\xB9" => "\xE8\x9D\xB4",
		"\xBD\xBA" => "\xE8\x9D\xB6",
		"\xBD\xBB" => "\xE8\x9D\xA0",
		"\xBD\xBC" => "\xE8\x9D\xA6",
		"\xBD\xBD" => "\xE8\x9D\xB8",
		"\xBD\xBE" => "\xE8\x9D\xA8",
		"\xBD\xBF" => "\xE8\x9D\x99",
		"\xBD\xC0" => "\xE8\x9D\x97",
		"\xBD\xC1" => "\xE8\x9D\x8C",
		"\xBD\xC2" => "\xE8\x9D\x93",
		"\xBD\xC3" => "\xE8\xA1\x9B",
		"\xBD\xC4" => "\xE8\xA1\x9D",
		"\xBD\xC5" => "\xE8\xA4\x90",
		"\xBD\xC6" => "\xE8\xA4\x87",
		"\xBD\xC7" => "\xE8\xA4\x92",
		"\xBD\xC8" => "\xE8\xA4\x93",
		"\xBD\xC9" => "\xE8\xA4\x95",
		"\xBD\xCA" => "\xE8\xA4\x8A",
		"\xBD\xCB" => "\xE8\xAA\xBC",
		"\xBD\xCC" => "\xE8\xAB\x92",
		"\xBD\xCD" => "\xE8\xAB\x87",
		"\xBD\xCE" => "\xE8\xAB\x84",
		"\xBD\xCF" => "\xE8\xAA\x95",
		"\xBD\xD0" => "\xE8\xAB\x8B",
		"\xBD\xD1" => "\xE8\xAB\xB8",
		"\xBD\xD2" => "\xE8\xAA\xB2",
		"\xBD\xD3" => "\xE8\xAB\x89",
		"\xBD\xD4" => "\xE8\xAB\x82",
		"\xBD\xD5" => "\xE8\xAA\xBF",
		"\xBD\xD6" => "\xE8\xAA\xB0",
		"\xBD\xD7" => "\xE8\xAB\x96",
		"\xBD\xD8" => "\xE8\xAB\x8D",
		"\xBD\xD9" => "\xE8\xAA\xB6",
		"\xBD\xDA" => "\xE8\xAA\xB9",
		"\xBD\xDB" => "\xE8\xAB\x9B",
		"\xBD\xDC" => "\xE8\xB1\x8C",
		"\xBD\xDD" => "\xE8\xB1\x8E",
		"\xBD\xDE" => "\xE8\xB1\xAC",
		"\xBD\xDF" => "\xE8\xB3\xA0",
		"\xBD\xE0" => "\xE8\xB3\x9E",
		"\xBD\xE1" => "\xE8\xB3\xA6",
		"\xBD\xE2" => "\xE8\xB3\xA4",
		"\xBD\xE3" => "\xE8\xB3\xAC",
		"\xBD\xE4" => "\xE8\xB3\xAD",
		"\xBD\xE5" => "\xE8\xB3\xA2",
		"\xBD\xE6" => "\xE8\xB3\xA3",
		"\xBD\xE7" => "\xE8\xB3\x9C",
		"\xBD\xE8" => "\xE8\xB3\xAA",
		"\xBD\xE9" => "\xE8\xB3\xA1",
		"\xBD\xEA" => "\xE8\xB5\xAD",
		"\xBD\xEB" => "\xE8\xB6\x9F",
		"\xBD\xEC" => "\xE8\xB6\xA3",
		"\xBD\xED" => "\xE8\xB8\xAB",
		"\xBD\xEE" => "\xE8\xB8\x90",
		"\xBD\xEF" => "\xE8\xB8\x9D",
		"\xBD\xF0" => "\xE8\xB8\xA2",
		"\xBD\xF1" => "\xE8\xB8\x8F",
		"\xBD\xF2" => "\xE8\xB8\xA9",
		"\xBD\xF3" => "\xE8\xB8\x9F",
		"\xBD\xF4" => "\xE8\xB8\xA1",
		"\xBD\xF5" => "\xE8\xB8\x9E",
		"\xBD\xF6" => "\xE8\xBA\xBA",
		"\xBD\xF7" => "\xE8\xBC\x9D",
		"\xBD\xF8" => "\xE8\xBC\x9B",
		"\xBD\xF9" => "\xE8\xBC\x9F",
		"\xBD\xFA" => "\xE8\xBC\xA9",
		"\xBD\xFB" => "\xE8\xBC\xA6",
		"\xBD\xFC" => "\xE8\xBC\xAA",
		"\xBD\xFD" => "\xE8\xBC\x9C",
		"\xBD\xFE" => "\xE8\xBC\x9E",
		"\xBE\x40" => "\xE8\xBC\xA5",
		"\xBE\x41" => "\xE9\x81\xA9",
		"\xBE\x42" => "\xE9\x81\xAE",
		"\xBE\x43" => "\xE9\x81\xA8",
		"\xBE\x44" => "\xE9\x81\xAD",
		"\xBE\x45" => "\xE9\x81\xB7",
		"\xBE\x46" => "\xE9\x84\xB0",
		"\xBE\x47" => "\xE9\x84\xAD",
		"\xBE\x48" => "\xE9\x84\xA7",
		"\xBE\x49" => "\xE9\x84\xB1",
		"\xBE\x4A" => "\xE9\x86\x87",
		"\xBE\x4B" => "\xE9\x86\x89",
		"\xBE\x4C" => "\xE9\x86\x8B",
		"\xBE\x4D" => "\xE9\x86\x83",
		"\xBE\x4E" => "\xE9\x8B\x85",
		"\xBE\x4F" => "\xE9\x8A\xBB",
		"\xBE\x50" => "\xE9\x8A\xB7",
		"\xBE\x51" => "\xE9\x8B\xAA",
		"\xBE\x52" => "\xE9\x8A\xAC",
		"\xBE\x53" => "\xE9\x8B\xA4",
		"\xBE\x54" => "\xE9\x8B\x81",
		"\xBE\x55" => "\xE9\x8A\xB3",
		"\xBE\x56" => "\xE9\x8A\xBC",
		"\xBE\x57" => "\xE9\x8B\x92",
		"\xBE\x58" => "\xE9\x8B\x87",
		"\xBE\x59" => "\xE9\x8B\xB0",
		"\xBE\x5A" => "\xE9\x8A\xB2",
		"\xBE\x5B" => "\xE9\x96\xAD",
		"\xBE\x5C" => "\xE9\x96\xB1",
		"\xBE\x5D" => "\xE9\x9C\x84",
		"\xBE\x5E" => "\xE9\x9C\x86",
		"\xBE\x5F" => "\xE9\x9C\x87",
		"\xBE\x60" => "\xE9\x9C\x89",
		"\xBE\x61" => "\xE9\x9D\xA0",
		"\xBE\x62" => "\xE9\x9E\x8D",
		"\xBE\x63" => "\xE9\x9E\x8B",
		"\xBE\x64" => "\xE9\x9E\x8F",
		"\xBE\x65" => "\xE9\xA0\xA1",
		"\xBE\x66" => "\xE9\xA0\xAB",
		"\xBE\x67" => "\xE9\xA0\x9C",
		"\xBE\x68" => "\xE9\xA2\xB3",
		"\xBE\x69" => "\xE9\xA4\x8A",
		"\xBE\x6A" => "\xE9\xA4\x93",
		"\xBE\x6B" => "\xE9\xA4\x92",
		"\xBE\x6C" => "\xE9\xA4\x98",
		"\xBE\x6D" => "\xE9\xA7\x9D",
		"\xBE\x6E" => "\xE9\xA7\x90",
		"\xBE\x6F" => "\xE9\xA7\x9F",
		"\xBE\x70" => "\xE9\xA7\x9B",
		"\xBE\x71" => "\xE9\xA7\x91",
		"\xBE\x72" => "\xE9\xA7\x95",
		"\xBE\x73" => "\xE9\xA7\x92",
		"\xBE\x74" => "\xE9\xA7\x99",
		"\xBE\x75" => "\xE9\xAA\xB7",
		"\xBE\x76" => "\xE9\xAB\xAE",
		"\xBE\x77" => "\xE9\xAB\xAF",
		"\xBE\x78" => "\xE9\xAC\xA7",
		"\xBE\x79" => "\xE9\xAD\x85",
		"\xBE\x7A" => "\xE9\xAD\x84",
		"\xBE\x7B" => "\xE9\xAD\xB7",
		"\xBE\x7C" => "\xE9\xAD\xAF",
		"\xBE\x7D" => "\xE9\xB4\x86",
		"\xBE\x7E" => "\xE9\xB4\x89",
		"\xBE\xA1" => "\xE9\xB4\x83",
		"\xBE\xA2" => "\xE9\xBA\xA9",
		"\xBE\xA3" => "\xE9\xBA\xBE",
		"\xBE\xA4" => "\xE9\xBB\x8E",
		"\xBE\xA5" => "\xE5\xA2\xA8",
		"\xBE\xA6" => "\xE9\xBD\x92",
		"\xBE\xA7" => "\xE5\x84\x92",
		"\xBE\xA8" => "\xE5\x84\x98",
		"\xBE\xA9" => "\xE5\x84\x94",
		"\xBE\xAA" => "\xE5\x84\x90",
		"\xBE\xAB" => "\xE5\x84\x95",
		"\xBE\xAC" => "\xE5\x86\x80",
		"\xBE\xAD" => "\xE5\x86\xAA",
		"\xBE\xAE" => "\xE5\x87\x9D",
		"\xBE\xAF" => "\xE5\x8A\x91",
		"\xBE\xB0" => "\xE5\x8A\x93",
		"\xBE\xB1" => "\xE5\x8B\xB3",
		"\xBE\xB2" => "\xE5\x99\x99",
		"\xBE\xB3" => "\xE5\x99\xAB",
		"\xBE\xB4" => "\xE5\x99\xB9",
		"\xBE\xB5" => "\xE5\x99\xA9",
		"\xBE\xB6" => "\xE5\x99\xA4",
		"\xBE\xB7" => "\xE5\x99\xB8",
		"\xBE\xB8" => "\xE5\x99\xAA",
		"\xBE\xB9" => "\xE5\x99\xA8",
		"\xBE\xBA" => "\xE5\x99\xA5",
		"\xBE\xBB" => "\xE5\x99\xB1",
		"\xBE\xBC" => "\xE5\x99\xAF",
		"\xBE\xBD" => "\xE5\x99\xAC",
		"\xBE\xBE" => "\xE5\x99\xA2",
		"\xBE\xBF" => "\xE5\x99\xB6",
		"\xBE\xC0" => "\xE5\xA3\x81",
		"\xBE\xC1" => "\xE5\xA2\xBE",
		"\xBE\xC2" => "\xE5\xA3\x87",
		"\xBE\xC3" => "\xE5\xA3\x85",
		"\xBE\xC4" => "\xE5\xA5\xAE",
		"\xBE\xC5" => "\xE5\xAC\x9D",
		"\xBE\xC6" => "\xE5\xAC\xB4",
		"\xBE\xC7" => "\xE5\xAD\xB8",
		"\xBE\xC8" => "\xE5\xAF\xB0",
		"\xBE\xC9" => "\xE5\xB0\x8E",
		"\xBE\xCA" => "\xE5\xBD\x8A",
		"\xBE\xCB" => "\xE6\x86\xB2",
		"\xBE\xCC" => "\xE6\x86\x91",
		"\xBE\xCD" => "\xE6\x86\xA9",
		"\xBE\xCE" => "\xE6\x86\x8A",
		"\xBE\xCF" => "\xE6\x87\x8D",
		"\xBE\xD0" => "\xE6\x86\xB6",
		"\xBE\xD1" => "\xE6\x86\xBE",
		"\xBE\xD2" => "\xE6\x87\x8A",
		"\xBE\xD3" => "\xE6\x87\x88",
		"\xBE\xD4" => "\xE6\x88\xB0",
		"\xBE\xD5" => "\xE6\x93\x85",
		"\xBE\xD6" => "\xE6\x93\x81",
		"\xBE\xD7" => "\xE6\x93\x8B",
		"\xBE\xD8" => "\xE6\x92\xBB",
		"\xBE\xD9" => "\xE6\x92\xBC",
		"\xBE\xDA" => "\xE6\x93\x9A",
		"\xBE\xDB" => "\xE6\x93\x84",
		"\xBE\xDC" => "\xE6\x93\x87",
		"\xBE\xDD" => "\xE6\x93\x82",
		"\xBE\xDE" => "\xE6\x93\x8D",
		"\xBE\xDF" => "\xE6\x92\xBF",
		"\xBE\xE0" => "\xE6\x93\x92",
		"\xBE\xE1" => "\xE6\x93\x94",
		"\xBE\xE2" => "\xE6\x92\xBE",
		"\xBE\xE3" => "\xE6\x95\xB4",
		"\xBE\xE4" => "\xE6\x9B\x86",
		"\xBE\xE5" => "\xE6\x9B\x89",
		"\xBE\xE6" => "\xE6\x9A\xB9",
		"\xBE\xE7" => "\xE6\x9B\x84",
		"\xBE\xE8" => "\xE6\x9B\x87",
		"\xBE\xE9" => "\xE6\x9A\xB8",
		"\xBE\xEA" => "\xE6\xA8\xBD",
		"\xBE\xEB" => "\xE6\xA8\xB8",
		"\xBE\xEC" => "\xE6\xA8\xBA",
		"\xBE\xED" => "\xE6\xA9\x99",
		"\xBE\xEE" => "\xE6\xA9\xAB",
		"\xBE\xEF" => "\xE6\xA9\x98",
		"\xBE\xF0" => "\xE6\xA8\xB9",
		"\xBE\xF1" => "\xE6\xA9\x84",
		"\xBE\xF2" => "\xE6\xA9\xA2",
		"\xBE\xF3" => "\xE6\xA9\xA1",
		"\xBE\xF4" => "\xE6\xA9\x8B",
		"\xBE\xF5" => "\xE6\xA9\x87",
		"\xBE\xF6" => "\xE6\xA8\xB5",
		"\xBE\xF7" => "\xE6\xA9\x9F",
		"\xBE\xF8" => "\xE6\xA9\x88",
		"\xBE\xF9" => "\xE6\xAD\x99",
		"\xBE\xFA" => "\xE6\xAD\xB7",
		"\xBE\xFB" => "\xE6\xB0\x85",
		"\xBE\xFC" => "\xE6\xBF\x82",
		"\xBE\xFD" => "\xE6\xBE\xB1",
		"\xBE\xFE" => "\xE6\xBE\xA1",
		"\xBF\x40" => "\xE6\xBF\x83",
		"\xBF\x41" => "\xE6\xBE\xA4",
		"\xBF\x42" => "\xE6\xBF\x81",
		"\xBF\x43" => "\xE6\xBE\xA7",
		"\xBF\x44" => "\xE6\xBE\xB3",
		"\xBF\x45" => "\xE6\xBF\x80",
		"\xBF\x46" => "\xE6\xBE\xB9",
		"\xBF\x47" => "\xE6\xBE\xB6",
		"\xBF\x48" => "\xE6\xBE\xA6",
		"\xBF\x49" => "\xE6\xBE\xA0",
		"\xBF\x4A" => "\xE6\xBE\xB4",
		"\xBF\x4B" => "\xE7\x86\xBE",
		"\xBF\x4C" => "\xE7\x87\x89",
		"\xBF\x4D" => "\xE7\x87\x90",
		"\xBF\x4E" => "\xE7\x87\x92",
		"\xBF\x4F" => "\xE7\x87\x88",
		"\xBF\x50" => "\xE7\x87\x95",
		"\xBF\x51" => "\xE7\x86\xB9",
		"\xBF\x52" => "\xE7\x87\x8E",
		"\xBF\x53" => "\xE7\x87\x99",
		"\xBF\x54" => "\xE7\x87\x9C",
		"\xBF\x55" => "\xE7\x87\x83",
		"\xBF\x56" => "\xE7\x87\x84",
		"\xBF\x57" => "\xE7\x8D\xA8",
		"\xBF\x58" => "\xE7\x92\x9C",
		"\xBF\x59" => "\xE7\x92\xA3",
		"\xBF\x5A" => "\xE7\x92\x98",
		"\xBF\x5B" => "\xE7\x92\x9F",
		"\xBF\x5C" => "\xE7\x92\x9E",
		"\xBF\x5D" => "\xE7\x93\xA2",
		"\xBF\x5E" => "\xE7\x94\x8C",
		"\xBF\x5F" => "\xE7\x94\x8D",
		"\xBF\x60" => "\xE7\x98\xB4",
		"\xBF\x61" => "\xE7\x98\xB8",
		"\xBF\x62" => "\xE7\x98\xBA",
		"\xBF\x63" => "\xE7\x9B\xA7",
		"\xBF\x64" => "\xE7\x9B\xA5",
		"\xBF\x65" => "\xE7\x9E\xA0",
		"\xBF\x66" => "\xE7\x9E\x9E",
		"\xBF\x67" => "\xE7\x9E\x9F",
		"\xBF\x68" => "\xE7\x9E\xA5",
		"\xBF\x69" => "\xE7\xA3\xA8",
		"\xBF\x6A" => "\xE7\xA3\x9A",
		"\xBF\x6B" => "\xE7\xA3\xAC",
		"\xBF\x6C" => "\xE7\xA3\xA7",
		"\xBF\x6D" => "\xE7\xA6\xA6",
		"\xBF\x6E" => "\xE7\xA9\x8D",
		"\xBF\x6F" => "\xE7\xA9\x8E",
		"\xBF\x70" => "\xE7\xA9\x86",
		"\xBF\x71" => "\xE7\xA9\x8C",
		"\xBF\x72" => "\xE7\xA9\x8B",
		"\xBF\x73" => "\xE7\xAA\xBA",
		"\xBF\x74" => "\xE7\xAF\x99",
		"\xBF\x75" => "\xE7\xB0\x91",
		"\xBF\x76" => "\xE7\xAF\x89",
		"\xBF\x77" => "\xE7\xAF\xA4",
		"\xBF\x78" => "\xE7\xAF\x9B",
		"\xBF\x79" => "\xE7\xAF\xA1",
		"\xBF\x7A" => "\xE7\xAF\xA9",
		"\xBF\x7B" => "\xE7\xAF\xA6",
		"\xBF\x7C" => "\xE7\xB3\x95",
		"\xBF\x7D" => "\xE7\xB3\x96",
		"\xBF\x7E" => "\xE7\xB8\x8A",
		"\xBF\xA1" => "\xE7\xB8\x91",
		"\xBF\xA2" => "\xE7\xB8\x88",
		"\xBF\xA3" => "\xE7\xB8\x9B",
		"\xBF\xA4" => "\xE7\xB8\xA3",
		"\xBF\xA5" => "\xE7\xB8\x9E",
		"\xBF\xA6" => "\xE7\xB8\x9D",
		"\xBF\xA7" => "\xE7\xB8\x89",
		"\xBF\xA8" => "\xE7\xB8\x90",
		"\xBF\xA9" => "\xE7\xBD\xB9",
		"\xBF\xAA" => "\xE7\xBE\xB2",
		"\xBF\xAB" => "\xE7\xBF\xB0",
		"\xBF\xAC" => "\xE7\xBF\xB1",
		"\xBF\xAD" => "\xE7\xBF\xAE",
		"\xBF\xAE" => "\xE8\x80\xA8",
		"\xBF\xAF" => "\xE8\x86\xB3",
		"\xBF\xB0" => "\xE8\x86\xA9",
		"\xBF\xB1" => "\xE8\x86\xA8",
		"\xBF\xB2" => "\xE8\x87\xBB",
		"\xBF\xB3" => "\xE8\x88\x88",
		"\xBF\xB4" => "\xE8\x89\x98",
		"\xBF\xB5" => "\xE8\x89\x99",
		"\xBF\xB6" => "\xE8\x95\x8A",
		"\xBF\xB7" => "\xE8\x95\x99",
		"\xBF\xB8" => "\xE8\x95\x88",
		"\xBF\xB9" => "\xE8\x95\xA8",
		"\xBF\xBA" => "\xE8\x95\xA9",
		"\xBF\xBB" => "\xE8\x95\x83",
		"\xBF\xBC" => "\xE8\x95\x89",
		"\xBF\xBD" => "\xE8\x95\xAD",
		"\xBF\xBE" => "\xE8\x95\xAA",
		"\xBF\xBF" => "\xE8\x95\x9E",
		"\xBF\xC0" => "\xE8\x9E\x83",
		"\xBF\xC1" => "\xE8\x9E\x9F",
		"\xBF\xC2" => "\xE8\x9E\x9E",
		"\xBF\xC3" => "\xE8\x9E\xA2",
		"\xBF\xC4" => "\xE8\x9E\x8D",
		"\xBF\xC5" => "\xE8\xA1\xA1",
		"\xBF\xC6" => "\xE8\xA4\xAA",
		"\xBF\xC7" => "\xE8\xA4\xB2",
		"\xBF\xC8" => "\xE8\xA4\xA5",
		"\xBF\xC9" => "\xE8\xA4\xAB",
		"\xBF\xCA" => "\xE8\xA4\xA1",
		"\xBF\xCB" => "\xE8\xA6\xAA",
		"\xBF\xCC" => "\xE8\xA6\xA6",
		"\xBF\xCD" => "\xE8\xAB\xA6",
		"\xBF\xCE" => "\xE8\xAB\xBA",
		"\xBF\xCF" => "\xE8\xAB\xAB",
		"\xBF\xD0" => "\xE8\xAB\xB1",
		"\xBF\xD1" => "\xE8\xAC\x80",
		"\xBF\xD2" => "\xE8\xAB\x9C",
		"\xBF\xD3" => "\xE8\xAB\xA7",
		"\xBF\xD4" => "\xE8\xAB\xAE",
		"\xBF\xD5" => "\xE8\xAB\xBE",
		"\xBF\xD6" => "\xE8\xAC\x81",
		"\xBF\xD7" => "\xE8\xAC\x82",
		"\xBF\xD8" => "\xE8\xAB\xB7",
		"\xBF\xD9" => "\xE8\xAB\xAD",
		"\xBF\xDA" => "\xE8\xAB\xB3",
		"\xBF\xDB" => "\xE8\xAB\xB6",
		"\xBF\xDC" => "\xE8\xAB\xBC",
		"\xBF\xDD" => "\xE8\xB1\xAB",
		"\xBF\xDE" => "\xE8\xB1\xAD",
		"\xBF\xDF" => "\xE8\xB2\x93",
		"\xBF\xE0" => "\xE8\xB3\xB4",
		"\xBF\xE1" => "\xE8\xB9\x84",
		"\xBF\xE2" => "\xE8\xB8\xB1",
		"\xBF\xE3" => "\xE8\xB8\xB4",
		"\xBF\xE4" => "\xE8\xB9\x82",
		"\xBF\xE5" => "\xE8\xB8\xB9",
		"\xBF\xE6" => "\xE8\xB8\xB5",
		"\xBF\xE7" => "\xE8\xBC\xBB",
		"\xBF\xE8" => "\xE8\xBC\xAF",
		"\xBF\xE9" => "\xE8\xBC\xB8",
		"\xBF\xEA" => "\xE8\xBC\xB3",
		"\xBF\xEB" => "\xE8\xBE\xA8",
		"\xBF\xEC" => "\xE8\xBE\xA6",
		"\xBF\xED" => "\xE9\x81\xB5",
		"\xBF\xEE" => "\xE9\x81\xB4",
		"\xBF\xEF" => "\xE9\x81\xB8",
		"\xBF\xF0" => "\xE9\x81\xB2",
		"\xBF\xF1" => "\xE9\x81\xBC",
		"\xBF\xF2" => "\xE9\x81\xBA",
		"\xBF\xF3" => "\xE9\x84\xB4",
		"\xBF\xF4" => "\xE9\x86\x92",
		"\xBF\xF5" => "\xE9\x8C\xA0",
		"\xBF\xF6" => "\xE9\x8C\xB6",
		"\xBF\xF7" => "\xE9\x8B\xB8",
		"\xBF\xF8" => "\xE9\x8C\xB3",
		"\xBF\xF9" => "\xE9\x8C\xAF",
		"\xBF\xFA" => "\xE9\x8C\xA2",
		"\xBF\xFB" => "\xE9\x8B\xBC",
		"\xBF\xFC" => "\xE9\x8C\xAB",
		"\xBF\xFD" => "\xE9\x8C\x84",
		"\xBF\xFE" => "\xE9\x8C\x9A",
		"\xC0\x40" => "\xE9\x8C\x90",
		"\xC0\x41" => "\xE9\x8C\xA6",
		"\xC0\x42" => "\xE9\x8C\xA1",
		"\xC0\x43" => "\xE9\x8C\x95",
		"\xC0\x44" => "\xE9\x8C\xAE",
		"\xC0\x45" => "\xE9\x8C\x99",
		"\xC0\x46" => "\xE9\x96\xBB",
		"\xC0\x47" => "\xE9\x9A\xA7",
		"\xC0\x48" => "\xE9\x9A\xA8",
		"\xC0\x49" => "\xE9\x9A\xAA",
		"\xC0\x4A" => "\xE9\x9B\x95",
		"\xC0\x4B" => "\xE9\x9C\x8E",
		"\xC0\x4C" => "\xE9\x9C\x91",
		"\xC0\x4D" => "\xE9\x9C\x96",
		"\xC0\x4E" => "\xE9\x9C\x8D",
		"\xC0\x4F" => "\xE9\x9C\x93",
		"\xC0\x50" => "\xE9\x9C\x8F",
		"\xC0\x51" => "\xE9\x9D\x9B",
		"\xC0\x52" => "\xE9\x9D\x9C",
		"\xC0\x53" => "\xE9\x9D\xA6",
		"\xC0\x54" => "\xE9\x9E\x98",
		"\xC0\x55" => "\xE9\xA0\xB0",
		"\xC0\x56" => "\xE9\xA0\xB8",
		"\xC0\x57" => "\xE9\xA0\xBB",
		"\xC0\x58" => "\xE9\xA0\xB7",
		"\xC0\x59" => "\xE9\xA0\xAD",
		"\xC0\x5A" => "\xE9\xA0\xB9",
		"\xC0\x5B" => "\xE9\xA0\xA4",
		"\xC0\x5C" => "\xE9\xA4\x90",
		"\xC0\x5D" => "\xE9\xA4\xA8",
		"\xC0\x5E" => "\xE9\xA4\x9E",
		"\xC0\x5F" => "\xE9\xA4\x9B",
		"\xC0\x60" => "\xE9\xA4\xA1",
		"\xC0\x61" => "\xE9\xA4\x9A",
		"\xC0\x62" => "\xE9\xA7\xAD",
		"\xC0\x63" => "\xE9\xA7\xA2",
		"\xC0\x64" => "\xE9\xA7\xB1",
		"\xC0\x65" => "\xE9\xAA\xB8",
		"\xC0\x66" => "\xE9\xAA\xBC",
		"\xC0\x67" => "\xE9\xAB\xBB",
		"\xC0\x68" => "\xE9\xAB\xAD",
		"\xC0\x69" => "\xE9\xAC\xA8",
		"\xC0\x6A" => "\xE9\xAE\x91",
		"\xC0\x6B" => "\xE9\xB4\x95",
		"\xC0\x6C" => "\xE9\xB4\xA3",
		"\xC0\x6D" => "\xE9\xB4\xA6",
		"\xC0\x6E" => "\xE9\xB4\xA8",
		"\xC0\x6F" => "\xE9\xB4\x92",
		"\xC0\x70" => "\xE9\xB4\x9B",
		"\xC0\x71" => "\xE9\xBB\x98",
		"\xC0\x72" => "\xE9\xBB\x94",
		"\xC0\x73" => "\xE9\xBE\x8D",
		"\xC0\x74" => "\xE9\xBE\x9C",
		"\xC0\x75" => "\xE5\x84\xAA",
		"\xC0\x76" => "\xE5\x84\x9F",
		"\xC0\x77" => "\xE5\x84\xA1",
		"\xC0\x78" => "\xE5\x84\xB2",
		"\xC0\x79" => "\xE5\x8B\xB5",
		"\xC0\x7A" => "\xE5\x9A\x8E",
		"\xC0\x7B" => "\xE5\x9A\x80",
		"\xC0\x7C" => "\xE5\x9A\x90",
		"\xC0\x7D" => "\xE5\x9A\x85",
		"\xC0\x7E" => "\xE5\x9A\x87",
		"\xC0\xA1" => "\xE5\x9A\x8F",
		"\xC0\xA2" => "\xE5\xA3\x95",
		"\xC0\xA3" => "\xE5\xA3\x93",
		"\xC0\xA4" => "\xE5\xA3\x91",
		"\xC0\xA5" => "\xE5\xA3\x8E",
		"\xC0\xA6" => "\xE5\xAC\xB0",
		"\xC0\xA7" => "\xE5\xAC\xAA",
		"\xC0\xA8" => "\xE5\xAC\xA4",
		"\xC0\xA9" => "\xE5\xAD\xBA",
		"\xC0\xAA" => "\xE5\xB0\xB7",
		"\xC0\xAB" => "\xE5\xB1\xA8",
		"\xC0\xAC" => "\xE5\xB6\xBC",
		"\xC0\xAD" => "\xE5\xB6\xBA",
		"\xC0\xAE" => "\xE5\xB6\xBD",
		"\xC0\xAF" => "\xE5\xB6\xB8",
		"\xC0\xB0" => "\xE5\xB9\xAB",
		"\xC0\xB1" => "\xE5\xBD\x8C",
		"\xC0\xB2" => "\xE5\xBE\xBD",
		"\xC0\xB3" => "\xE6\x87\x89",
		"\xC0\xB4" => "\xE6\x87\x82",
		"\xC0\xB5" => "\xE6\x87\x87",
		"\xC0\xB6" => "\xE6\x87\xA6",
		"\xC0\xB7" => "\xE6\x87\x8B",
		"\xC0\xB8" => "\xE6\x88\xB2",
		"\xC0\xB9" => "\xE6\x88\xB4",
		"\xC0\xBA" => "\xE6\x93\x8E",
		"\xC0\xBB" => "\xE6\x93\x8A",
		"\xC0\xBC" => "\xE6\x93\x98",
		"\xC0\xBD" => "\xE6\x93\xA0",
		"\xC0\xBE" => "\xE6\x93\xB0",
		"\xC0\xBF" => "\xE6\x93\xA6",
		"\xC0\xC0" => "\xE6\x93\xAC",
		"\xC0\xC1" => "\xE6\x93\xB1",
		"\xC0\xC2" => "\xE6\x93\xA2",
		"\xC0\xC3" => "\xE6\x93\xAD",
		"\xC0\xC4" => "\xE6\x96\x82",
		"\xC0\xC5" => "\xE6\x96\x83",
		"\xC0\xC6" => "\xE6\x9B\x99",
		"\xC0\xC7" => "\xE6\x9B\x96",
		"\xC0\xC8" => "\xE6\xAA\x80",
		"\xC0\xC9" => "\xE6\xAA\x94",
		"\xC0\xCA" => "\xE6\xAA\x84",
		"\xC0\xCB" => "\xE6\xAA\xA2",
		"\xC0\xCC" => "\xE6\xAA\x9C",
		"\xC0\xCD" => "\xE6\xAB\x9B",
		"\xC0\xCE" => "\xE6\xAA\xA3",
		"\xC0\xCF" => "\xE6\xA9\xBE",
		"\xC0\xD0" => "\xE6\xAA\x97",
		"\xC0\xD1" => "\xE6\xAA\x90",
		"\xC0\xD2" => "\xE6\xAA\xA0",
		"\xC0\xD3" => "\xE6\xAD\x9C",
		"\xC0\xD4" => "\xE6\xAE\xAE",
		"\xC0\xD5" => "\xE6\xAF\x9A",
		"\xC0\xD6" => "\xE6\xB0\x88",
		"\xC0\xD7" => "\xE6\xBF\x98",
		"\xC0\xD8" => "\xE6\xBF\xB1",
		"\xC0\xD9" => "\xE6\xBF\x9F",
		"\xC0\xDA" => "\xE6\xBF\xA0",
		"\xC0\xDB" => "\xE6\xBF\x9B",
		"\xC0\xDC" => "\xE6\xBF\xA4",
		"\xC0\xDD" => "\xE6\xBF\xAB",
		"\xC0\xDE" => "\xE6\xBF\xAF",
		"\xC0\xDF" => "\xE6\xBE\x80",
		"\xC0\xE0" => "\xE6\xBF\xAC",
		"\xC0\xE1" => "\xE6\xBF\xA1",
		"\xC0\xE2" => "\xE6\xBF\xA9",
		"\xC0\xE3" => "\xE6\xBF\x95",
		"\xC0\xE4" => "\xE6\xBF\xAE",
		"\xC0\xE5" => "\xE6\xBF\xB0",
		"\xC0\xE6" => "\xE7\x87\xA7",
		"\xC0\xE7" => "\xE7\x87\x9F",
		"\xC0\xE8" => "\xE7\x87\xAE",
		"\xC0\xE9" => "\xE7\x87\xA6",
		"\xC0\xEA" => "\xE7\x87\xA5",
		"\xC0\xEB" => "\xE7\x87\xAD",
		"\xC0\xEC" => "\xE7\x87\xAC",
		"\xC0\xED" => "\xE7\x87\xB4",
		"\xC0\xEE" => "\xE7\x87\xA0",
		"\xC0\xEF" => "\xE7\x88\xB5",
		"\xC0\xF0" => "\xE7\x89\x86",
		"\xC0\xF1" => "\xE7\x8D\xB0",
		"\xC0\xF2" => "\xE7\x8D\xB2",
		"\xC0\xF3" => "\xE7\x92\xA9",
		"\xC0\xF4" => "\xE7\x92\xB0",
		"\xC0\xF5" => "\xE7\x92\xA6",
		"\xC0\xF6" => "\xE7\x92\xA8",
		"\xC0\xF7" => "\xE7\x99\x86",
		"\xC0\xF8" => "\xE7\x99\x82",
		"\xC0\xF9" => "\xE7\x99\x8C",
		"\xC0\xFA" => "\xE7\x9B\xAA",
		"\xC0\xFB" => "\xE7\x9E\xB3",
		"\xC0\xFC" => "\xE7\x9E\xAA",
		"\xC0\xFD" => "\xE7\x9E\xB0",
		"\xC0\xFE" => "\xE7\x9E\xAC",
		"\xC1\x40" => "\xE7\x9E\xA7",
		"\xC1\x41" => "\xE7\x9E\xAD",
		"\xC1\x42" => "\xE7\x9F\xAF",
		"\xC1\x43" => "\xE7\xA3\xB7",
		"\xC1\x44" => "\xE7\xA3\xBA",
		"\xC1\x45" => "\xE7\xA3\xB4",
		"\xC1\x46" => "\xE7\xA3\xAF",
		"\xC1\x47" => "\xE7\xA4\x81",
		"\xC1\x48" => "\xE7\xA6\xA7",
		"\xC1\x49" => "\xE7\xA6\xAA",
		"\xC1\x4A" => "\xE7\xA9\x97",
		"\xC1\x4B" => "\xE7\xAA\xBF",
		"\xC1\x4C" => "\xE7\xB0\x87",
		"\xC1\x4D" => "\xE7\xB0\x8D",
		"\xC1\x4E" => "\xE7\xAF\xBE",
		"\xC1\x4F" => "\xE7\xAF\xB7",
		"\xC1\x50" => "\xE7\xB0\x8C",
		"\xC1\x51" => "\xE7\xAF\xA0",
		"\xC1\x52" => "\xE7\xB3\xA0",
		"\xC1\x53" => "\xE7\xB3\x9C",
		"\xC1\x54" => "\xE7\xB3\x9E",
		"\xC1\x55" => "\xE7\xB3\xA2",
		"\xC1\x56" => "\xE7\xB3\x9F",
		"\xC1\x57" => "\xE7\xB3\x99",
		"\xC1\x58" => "\xE7\xB3\x9D",
		"\xC1\x59" => "\xE7\xB8\xAE",
		"\xC1\x5A" => "\xE7\xB8\xBE",
		"\xC1\x5B" => "\xE7\xB9\x86",
		"\xC1\x5C" => "\xE7\xB8\xB7",
		"\xC1\x5D" => "\xE7\xB8\xB2",
		"\xC1\x5E" => "\xE7\xB9\x83",
		"\xC1\x5F" => "\xE7\xB8\xAB",
		"\xC1\x60" => "\xE7\xB8\xBD",
		"\xC1\x61" => "\xE7\xB8\xB1",
		"\xC1\x62" => "\xE7\xB9\x85",
		"\xC1\x63" => "\xE7\xB9\x81",
		"\xC1\x64" => "\xE7\xB8\xB4",
		"\xC1\x65" => "\xE7\xB8\xB9",
		"\xC1\x66" => "\xE7\xB9\x88",
		"\xC1\x67" => "\xE7\xB8\xB5",
		"\xC1\x68" => "\xE7\xB8\xBF",
		"\xC1\x69" => "\xE7\xB8\xAF",
		"\xC1\x6A" => "\xE7\xBD\x84",
		"\xC1\x6B" => "\xE7\xBF\xB3",
		"\xC1\x6C" => "\xE7\xBF\xBC",
		"\xC1\x6D" => "\xE8\x81\xB1",
		"\xC1\x6E" => "\xE8\x81\xB2",
		"\xC1\x6F" => "\xE8\x81\xB0",
		"\xC1\x70" => "\xE8\x81\xAF",
		"\xC1\x71" => "\xE8\x81\xB3",
		"\xC1\x72" => "\xE8\x87\x86",
		"\xC1\x73" => "\xE8\x87\x83",
		"\xC1\x74" => "\xE8\x86\xBA",
		"\xC1\x75" => "\xE8\x87\x82",
		"\xC1\x76" => "\xE8\x87\x80",
		"\xC1\x77" => "\xE8\x86\xBF",
		"\xC1\x78" => "\xE8\x86\xBD",
		"\xC1\x79" => "\xE8\x87\x89",
		"\xC1\x7A" => "\xE8\x86\xBE",
		"\xC1\x7B" => "\xE8\x87\xA8",
		"\xC1\x7C" => "\xE8\x88\x89",
		"\xC1\x7D" => "\xE8\x89\xB1",
		"\xC1\x7E" => "\xE8\x96\xAA",
		"\xC1\xA1" => "\xE8\x96\x84",
		"\xC1\xA2" => "\xE8\x95\xBE",
		"\xC1\xA3" => "\xE8\x96\x9C",
		"\xC1\xA4" => "\xE8\x96\x91",
		"\xC1\xA5" => "\xE8\x96\x94",
		"\xC1\xA6" => "\xE8\x96\xAF",
		"\xC1\xA7" => "\xE8\x96\x9B",
		"\xC1\xA8" => "\xE8\x96\x87",
		"\xC1\xA9" => "\xE8\x96\xA8",
		"\xC1\xAA" => "\xE8\x96\x8A",
		"\xC1\xAB" => "\xE8\x99\xA7",
		"\xC1\xAC" => "\xE8\x9F\x80",
		"\xC1\xAD" => "\xE8\x9F\x91",
		"\xC1\xAE" => "\xE8\x9E\xB3",
		"\xC1\xAF" => "\xE8\x9F\x92",
		"\xC1\xB0" => "\xE8\x9F\x86",
		"\xC1\xB1" => "\xE8\x9E\xAB",
		"\xC1\xB2" => "\xE8\x9E\xBB",
		"\xC1\xB3" => "\xE8\x9E\xBA",
		"\xC1\xB4" => "\xE8\x9F\x88",
		"\xC1\xB5" => "\xE8\x9F\x8B",
		"\xC1\xB6" => "\xE8\xA4\xBB",
		"\xC1\xB7" => "\xE8\xA4\xB6",
		"\xC1\xB8" => "\xE8\xA5\x84",
		"\xC1\xB9" => "\xE8\xA4\xB8",
		"\xC1\xBA" => "\xE8\xA4\xBD",
		"\xC1\xBB" => "\xE8\xA6\xAC",
		"\xC1\xBC" => "\xE8\xAC\x8E",
		"\xC1\xBD" => "\xE8\xAC\x97",
		"\xC1\xBE" => "\xE8\xAC\x99",
		"\xC1\xBF" => "\xE8\xAC\x9B",
		"\xC1\xC0" => "\xE8\xAC\x8A",
		"\xC1\xC1" => "\xE8\xAC\xA0",
		"\xC1\xC2" => "\xE8\xAC\x9D",
		"\xC1\xC3" => "\xE8\xAC\x84",
		"\xC1\xC4" => "\xE8\xAC\x90",
		"\xC1\xC5" => "\xE8\xB1\x81",
		"\xC1\xC6" => "\xE8\xB0\xBF",
		"\xC1\xC7" => "\xE8\xB1\xB3",
		"\xC1\xC8" => "\xE8\xB3\xBA",
		"\xC1\xC9" => "\xE8\xB3\xBD",
		"\xC1\xCA" => "\xE8\xB3\xBC",
		"\xC1\xCB" => "\xE8\xB3\xB8",
		"\xC1\xCC" => "\xE8\xB3\xBB",
		"\xC1\xCD" => "\xE8\xB6\xA8",
		"\xC1\xCE" => "\xE8\xB9\x89",
		"\xC1\xCF" => "\xE8\xB9\x8B",
		"\xC1\xD0" => "\xE8\xB9\x88",
		"\xC1\xD1" => "\xE8\xB9\x8A",
		"\xC1\xD2" => "\xE8\xBD\x84",
		"\xC1\xD3" => "\xE8\xBC\xBE",
		"\xC1\xD4" => "\xE8\xBD\x82",
		"\xC1\xD5" => "\xE8\xBD\x85",
		"\xC1\xD6" => "\xE8\xBC\xBF",
		"\xC1\xD7" => "\xE9\x81\xBF",
		"\xC1\xD8" => "\xE9\x81\xBD",
		"\xC1\xD9" => "\xE9\x82\x84",
		"\xC1\xDA" => "\xE9\x82\x81",
		"\xC1\xDB" => "\xE9\x82\x82",
		"\xC1\xDC" => "\xE9\x82\x80",
		"\xC1\xDD" => "\xE9\x84\xB9",
		"\xC1\xDE" => "\xE9\x86\xA3",
		"\xC1\xDF" => "\xE9\x86\x9E",
		"\xC1\xE0" => "\xE9\x86\x9C",
		"\xC1\xE1" => "\xE9\x8D\x8D",
		"\xC1\xE2" => "\xE9\x8E\x82",
		"\xC1\xE3" => "\xE9\x8C\xA8",
		"\xC1\xE4" => "\xE9\x8D\xB5",
		"\xC1\xE5" => "\xE9\x8D\x8A",
		"\xC1\xE6" => "\xE9\x8D\xA5",
		"\xC1\xE7" => "\xE9\x8D\x8B",
		"\xC1\xE8" => "\xE9\x8C\x98",
		"\xC1\xE9" => "\xE9\x8D\xBE",
		"\xC1\xEA" => "\xE9\x8D\xAC",
		"\xC1\xEB" => "\xE9\x8D\x9B",
		"\xC1\xEC" => "\xE9\x8D\xB0",
		"\xC1\xED" => "\xE9\x8D\x9A",
		"\xC1\xEE" => "\xE9\x8D\x94",
		"\xC1\xEF" => "\xE9\x97\x8A",
		"\xC1\xF0" => "\xE9\x97\x8B",
		"\xC1\xF1" => "\xE9\x97\x8C",
		"\xC1\xF2" => "\xE9\x97\x88",
		"\xC1\xF3" => "\xE9\x97\x86",
		"\xC1\xF4" => "\xE9\x9A\xB1",
		"\xC1\xF5" => "\xE9\x9A\xB8",
		"\xC1\xF6" => "\xE9\x9B\x96",
		"\xC1\xF7" => "\xE9\x9C\x9C",
		"\xC1\xF8" => "\xE9\x9C\x9E",
		"\xC1\xF9" => "\xE9\x9E\xA0",
		"\xC1\xFA" => "\xE9\x9F\x93",
		"\xC1\xFB" => "\xE9\xA1\x86",
		"\xC1\xFC" => "\xE9\xA2\xB6",
		"\xC1\xFD" => "\xE9\xA4\xB5",
		"\xC1\xFE" => "\xE9\xA8\x81",
		"\xC2\x40" => "\xE9\xA7\xBF",
		"\xC2\x41" => "\xE9\xAE\xAE",
		"\xC2\x42" => "\xE9\xAE\xAB",
		"\xC2\x43" => "\xE9\xAE\xAA",
		"\xC2\x44" => "\xE9\xAE\xAD",
		"\xC2\x45" => "\xE9\xB4\xBB",
		"\xC2\x46" => "\xE9\xB4\xBF",
		"\xC2\x47" => "\xE9\xBA\x8B",
		"\xC2\x48" => "\xE9\xBB\x8F",
		"\xC2\x49" => "\xE9\xBB\x9E",
		"\xC2\x4A" => "\xE9\xBB\x9C",
		"\xC2\x4B" => "\xE9\xBB\x9D",
		"\xC2\x4C" => "\xE9\xBB\x9B",
		"\xC2\x4D" => "\xE9\xBC\xBE",
		"\xC2\x4E" => "\xE9\xBD\x8B",
		"\xC2\x4F" => "\xE5\x8F\xA2",
		"\xC2\x50" => "\xE5\x9A\x95",
		"\xC2\x51" => "\xE5\x9A\xAE",
		"\xC2\x52" => "\xE5\xA3\x99",
		"\xC2\x53" => "\xE5\xA3\x98",
		"\xC2\x54" => "\xE5\xAC\xB8",
		"\xC2\x55" => "\xE5\xBD\x9D",
		"\xC2\x56" => "\xE6\x87\xA3",
		"\xC2\x57" => "\xE6\x88\xB3",
		"\xC2\x58" => "\xE6\x93\xB4",
		"\xC2\x59" => "\xE6\x93\xB2",
		"\xC2\x5A" => "\xE6\x93\xBE",
		"\xC2\x5B" => "\xE6\x94\x86",
		"\xC2\x5C" => "\xE6\x93\xBA",
		"\xC2\x5D" => "\xE6\x93\xBB",
		"\xC2\x5E" => "\xE6\x93\xB7",
		"\xC2\x5F" => "\xE6\x96\xB7",
		"\xC2\x60" => "\xE6\x9B\x9C",
		"\xC2\x61" => "\xE6\x9C\xA6",
		"\xC2\x62" => "\xE6\xAA\xB3",
		"\xC2\x63" => "\xE6\xAA\xAC",
		"\xC2\x64" => "\xE6\xAB\x83",
		"\xC2\x65" => "\xE6\xAA\xBB",
		"\xC2\x66" => "\xE6\xAA\xB8",
		"\xC2\x67" => "\xE6\xAB\x82",
		"\xC2\x68" => "\xE6\xAA\xAE",
		"\xC2\x69" => "\xE6\xAA\xAF",
		"\xC2\x6A" => "\xE6\xAD\x9F",
		"\xC2\x6B" => "\xE6\xAD\xB8",
		"\xC2\x6C" => "\xE6\xAE\xAF",
		"\xC2\x6D" => "\xE7\x80\x89",
		"\xC2\x6E" => "\xE7\x80\x8B",
		"\xC2\x6F" => "\xE6\xBF\xBE",
		"\xC2\x70" => "\xE7\x80\x86",
		"\xC2\x71" => "\xE6\xBF\xBA",
		"\xC2\x72" => "\xE7\x80\x91",
		"\xC2\x73" => "\xE7\x80\x8F",
		"\xC2\x74" => "\xE7\x87\xBB",
		"\xC2\x75" => "\xE7\x87\xBC",
		"\xC2\x76" => "\xE7\x87\xBE",
		"\xC2\x77" => "\xE7\x87\xB8",
		"\xC2\x78" => "\xE7\x8D\xB7",
		"\xC2\x79" => "\xE7\x8D\xB5",
		"\xC2\x7A" => "\xE7\x92\xA7",
		"\xC2\x7B" => "\xE7\x92\xBF",
		"\xC2\x7C" => "\xE7\x94\x95",
		"\xC2\x7D" => "\xE7\x99\x96",
		"\xC2\x7E" => "\xE7\x99\x98",
		"\xC2\xA1" => "\xE7\x99\x92",
		"\xC2\xA2" => "\xE7\x9E\xBD",
		"\xC2\xA3" => "\xE7\x9E\xBF",
		"\xC2\xA4" => "\xE7\x9E\xBB",
		"\xC2\xA5" => "\xE7\x9E\xBC",
		"\xC2\xA6" => "\xE7\xA4\x8E",
		"\xC2\xA7" => "\xE7\xA6\xAE",
		"\xC2\xA8" => "\xE7\xA9\xA1",
		"\xC2\xA9" => "\xE7\xA9\xA2",
		"\xC2\xAA" => "\xE7\xA9\xA0",
		"\xC2\xAB" => "\xE7\xAB\x84",
		"\xC2\xAC" => "\xE7\xAB\x85",
		"\xC2\xAD" => "\xE7\xB0\xAB",
		"\xC2\xAE" => "\xE7\xB0\xA7",
		"\xC2\xAF" => "\xE7\xB0\xAA",
		"\xC2\xB0" => "\xE7\xB0\x9E",
		"\xC2\xB1" => "\xE7\xB0\xA3",
		"\xC2\xB2" => "\xE7\xB0\xA1",
		"\xC2\xB3" => "\xE7\xB3\xA7",
		"\xC2\xB4" => "\xE7\xB9\x94",
		"\xC2\xB5" => "\xE7\xB9\x95",
		"\xC2\xB6" => "\xE7\xB9\x9E",
		"\xC2\xB7" => "\xE7\xB9\x9A",
		"\xC2\xB8" => "\xE7\xB9\xA1",
		"\xC2\xB9" => "\xE7\xB9\x92",
		"\xC2\xBA" => "\xE7\xB9\x99",
		"\xC2\xBB" => "\xE7\xBD\x88",
		"\xC2\xBC" => "\xE7\xBF\xB9",
		"\xC2\xBD" => "\xE7\xBF\xBB",
		"\xC2\xBE" => "\xE8\x81\xB7",
		"\xC2\xBF" => "\xE8\x81\xB6",
		"\xC2\xC0" => "\xE8\x87\x8D",
		"\xC2\xC1" => "\xE8\x87\x8F",
		"\xC2\xC2" => "\xE8\x88\x8A",
		"\xC2\xC3" => "\xE8\x97\x8F",
		"\xC2\xC4" => "\xE8\x96\xA9",
		"\xC2\xC5" => "\xE8\x97\x8D",
		"\xC2\xC6" => "\xE8\x97\x90",
		"\xC2\xC7" => "\xE8\x97\x89",
		"\xC2\xC8" => "\xE8\x96\xB0",
		"\xC2\xC9" => "\xE8\x96\xBA",
		"\xC2\xCA" => "\xE8\x96\xB9",
		"\xC2\xCB" => "\xE8\x96\xA6",
		"\xC2\xCC" => "\xE8\x9F\xAF",
		"\xC2\xCD" => "\xE8\x9F\xAC",
		"\xC2\xCE" => "\xE8\x9F\xB2",
		"\xC2\xCF" => "\xE8\x9F\xA0",
		"\xC2\xD0" => "\xE8\xA6\x86",
		"\xC2\xD1" => "\xE8\xA6\xB2",
		"\xC2\xD2" => "\xE8\xA7\xB4",
		"\xC2\xD3" => "\xE8\xAC\xA8",
		"\xC2\xD4" => "\xE8\xAC\xB9",
		"\xC2\xD5" => "\xE8\xAC\xAC",
		"\xC2\xD6" => "\xE8\xAC\xAB",
		"\xC2\xD7" => "\xE8\xB1\x90",
		"\xC2\xD8" => "\xE8\xB4\x85",
		"\xC2\xD9" => "\xE8\xB9\x99",
		"\xC2\xDA" => "\xE8\xB9\xA3",
		"\xC2\xDB" => "\xE8\xB9\xA6",
		"\xC2\xDC" => "\xE8\xB9\xA4",
		"\xC2\xDD" => "\xE8\xB9\x9F",
		"\xC2\xDE" => "\xE8\xB9\x95",
		"\xC2\xDF" => "\xE8\xBB\x80",
		"\xC2\xE0" => "\xE8\xBD\x89",
		"\xC2\xE1" => "\xE8\xBD\x8D",
		"\xC2\xE2" => "\xE9\x82\x87",
		"\xC2\xE3" => "\xE9\x82\x83",
		"\xC2\xE4" => "\xE9\x82\x88",
		"\xC2\xE5" => "\xE9\x86\xAB",
		"\xC2\xE6" => "\xE9\x86\xAC",
		"\xC2\xE7" => "\xE9\x87\x90",
		"\xC2\xE8" => "\xE9\x8E\x94",
		"\xC2\xE9" => "\xE9\x8E\x8A",
		"\xC2\xEA" => "\xE9\x8E\x96",
		"\xC2\xEB" => "\xE9\x8E\xA2",
		"\xC2\xEC" => "\xE9\x8E\xB3",
		"\xC2\xED" => "\xE9\x8E\xAE",
		"\xC2\xEE" => "\xE9\x8E\xAC",
		"\xC2\xEF" => "\xE9\x8E\xB0",
		"\xC2\xF0" => "\xE9\x8E\x98",
		"\xC2\xF1" => "\xE9\x8E\x9A",
		"\xC2\xF2" => "\xE9\x8E\x97",
		"\xC2\xF3" => "\xE9\x97\x94",
		"\xC2\xF4" => "\xE9\x97\x96",
		"\xC2\xF5" => "\xE9\x97\x90",
		"\xC2\xF6" => "\xE9\x97\x95",
		"\xC2\xF7" => "\xE9\x9B\xA2",
		"\xC2\xF8" => "\xE9\x9B\x9C",
		"\xC2\xF9" => "\xE9\x9B\x99",
		"\xC2\xFA" => "\xE9\x9B\x9B",
		"\xC2\xFB" => "\xE9\x9B\x9E",
		"\xC2\xFC" => "\xE9\x9C\xA4",
		"\xC2\xFD" => "\xE9\x9E\xA3",
		"\xC2\xFE" => "\xE9\x9E\xA6",
		"\xC3\x40" => "\xE9\x9E\xAD",
		"\xC3\x41" => "\xE9\x9F\xB9",
		"\xC3\x42" => "\xE9\xA1\x8D",
		"\xC3\x43" => "\xE9\xA1\x8F",
		"\xC3\x44" => "\xE9\xA1\x8C",
		"\xC3\x45" => "\xE9\xA1\x8E",
		"\xC3\x46" => "\xE9\xA1\x93",
		"\xC3\x47" => "\xE9\xA2\xBA",
		"\xC3\x48" => "\xE9\xA4\xBE",
		"\xC3\x49" => "\xE9\xA4\xBF",
		"\xC3\x4A" => "\xE9\xA4\xBD",
		"\xC3\x4B" => "\xE9\xA4\xAE",
		"\xC3\x4C" => "\xE9\xA6\xA5",
		"\xC3\x4D" => "\xE9\xA8\x8E",
		"\xC3\x4E" => "\xE9\xAB\x81",
		"\xC3\x4F" => "\xE9\xAC\x83",
		"\xC3\x50" => "\xE9\xAC\x86",
		"\xC3\x51" => "\xE9\xAD\x8F",
		"\xC3\x52" => "\xE9\xAD\x8E",
		"\xC3\x53" => "\xE9\xAD\x8D",
		"\xC3\x54" => "\xE9\xAF\x8A",
		"\xC3\x55" => "\xE9\xAF\x89",
		"\xC3\x56" => "\xE9\xAF\xBD",
		"\xC3\x57" => "\xE9\xAF\x88",
		"\xC3\x58" => "\xE9\xAF\x80",
		"\xC3\x59" => "\xE9\xB5\x91",
		"\xC3\x5A" => "\xE9\xB5\x9D",
		"\xC3\x5B" => "\xE9\xB5\xA0",
		"\xC3\x5C" => "\xE9\xBB\xA0",
		"\xC3\x5D" => "\xE9\xBC\x95",
		"\xC3\x5E" => "\xE9\xBC\xAC",
		"\xC3\x5F" => "\xE5\x84\xB3",
		"\xC3\x60" => "\xE5\x9A\xA5",
		"\xC3\x61" => "\xE5\xA3\x9E",
		"\xC3\x62" => "\xE5\xA3\x9F",
		"\xC3\x63" => "\xE5\xA3\xA2",
		"\xC3\x64" => "\xE5\xAF\xB5",
		"\xC3\x65" => "\xE9\xBE\x90",
		"\xC3\x66" => "\xE5\xBB\xAC",
		"\xC3\x67" => "\xE6\x87\xB2",
		"\xC3\x68" => "\xE6\x87\xB7",
		"\xC3\x69" => "\xE6\x87\xB6",
		"\xC3\x6A" => "\xE6\x87\xB5",
		"\xC3\x6B" => "\xE6\x94\x80",
		"\xC3\x6C" => "\xE6\x94\x8F",
		"\xC3\x6D" => "\xE6\x9B\xA0",
		"\xC3\x6E" => "\xE6\x9B\x9D",
		"\xC3\x6F" => "\xE6\xAB\xA5",
		"\xC3\x70" => "\xE6\xAB\x9D",
		"\xC3\x71" => "\xE6\xAB\x9A",
		"\xC3\x72" => "\xE6\xAB\x93",
		"\xC3\x73" => "\xE7\x80\x9B",
		"\xC3\x74" => "\xE7\x80\x9F",
		"\xC3\x75" => "\xE7\x80\xA8",
		"\xC3\x76" => "\xE7\x80\x9A",
		"\xC3\x77" => "\xE7\x80\x9D",
		"\xC3\x78" => "\xE7\x80\x95",
		"\xC3\x79" => "\xE7\x80\x98",
		"\xC3\x7A" => "\xE7\x88\x86",
		"\xC3\x7B" => "\xE7\x88\x8D",
		"\xC3\x7C" => "\xE7\x89\x98",
		"\xC3\x7D" => "\xE7\x8A\xA2",
		"\xC3\x7E" => "\xE7\x8D\xB8",
		"\xC3\xA1" => "\xE7\x8D\xBA",
		"\xC3\xA2" => "\xE7\x92\xBD",
		"\xC3\xA3" => "\xE7\x93\x8A",
		"\xC3\xA4" => "\xE7\x93\xA3",
		"\xC3\xA5" => "\xE7\x96\x87",
		"\xC3\xA6" => "\xE7\x96\x86",
		"\xC3\xA7" => "\xE7\x99\x9F",
		"\xC3\xA8" => "\xE7\x99\xA1",
		"\xC3\xA9" => "\xE7\x9F\x87",
		"\xC3\xAA" => "\xE7\xA4\x99",
		"\xC3\xAB" => "\xE7\xA6\xB1",
		"\xC3\xAC" => "\xE7\xA9\xAB",
		"\xC3\xAD" => "\xE7\xA9\xA9",
		"\xC3\xAE" => "\xE7\xB0\xBE",
		"\xC3\xAF" => "\xE7\xB0\xBF",
		"\xC3\xB0" => "\xE7\xB0\xB8",
		"\xC3\xB1" => "\xE7\xB0\xBD",
		"\xC3\xB2" => "\xE7\xB0\xB7",
		"\xC3\xB3" => "\xE7\xB1\x80",
		"\xC3\xB4" => "\xE7\xB9\xAB",
		"\xC3\xB5" => "\xE7\xB9\xAD",
		"\xC3\xB6" => "\xE7\xB9\xB9",
		"\xC3\xB7" => "\xE7\xB9\xA9",
		"\xC3\xB8" => "\xE7\xB9\xAA",
		"\xC3\xB9" => "\xE7\xBE\x85",
		"\xC3\xBA" => "\xE7\xB9\xB3",
		"\xC3\xBB" => "\xE7\xBE\xB6",
		"\xC3\xBC" => "\xE7\xBE\xB9",
		"\xC3\xBD" => "\xE7\xBE\xB8",
		"\xC3\xBE" => "\xE8\x87\x98",
		"\xC3\xBF" => "\xE8\x97\xA9",
		"\xC3\xC0" => "\xE8\x97\x9D",
		"\xC3\xC1" => "\xE8\x97\xAA",
		"\xC3\xC2" => "\xE8\x97\x95",
		"\xC3\xC3" => "\xE8\x97\xA4",
		"\xC3\xC4" => "\xE8\x97\xA5",
		"\xC3\xC5" => "\xE8\x97\xB7",
		"\xC3\xC6" => "\xE8\x9F\xBB",
		"\xC3\xC7" => "\xE8\xA0\x85",
		"\xC3\xC8" => "\xE8\xA0\x8D",
		"\xC3\xC9" => "\xE8\x9F\xB9",
		"\xC3\xCA" => "\xE8\x9F\xBE",
		"\xC3\xCB" => "\xE8\xA5\xA0",
		"\xC3\xCC" => "\xE8\xA5\x9F",
		"\xC3\xCD" => "\xE8\xA5\x96",
		"\xC3\xCE" => "\xE8\xA5\x9E",
		"\xC3\xCF" => "\xE8\xAD\x81",
		"\xC3\xD0" => "\xE8\xAD\x9C",
		"\xC3\xD1" => "\xE8\xAD\x98",
		"\xC3\xD2" => "\xE8\xAD\x89",
		"\xC3\xD3" => "\xE8\xAD\x9A",
		"\xC3\xD4" => "\xE8\xAD\x8E",
		"\xC3\xD5" => "\xE8\xAD\x8F",
		"\xC3\xD6" => "\xE8\xAD\x86",
		"\xC3\xD7" => "\xE8\xAD\x99",
		"\xC3\xD8" => "\xE8\xB4\x88",
		"\xC3\xD9" => "\xE8\xB4\x8A",
		"\xC3\xDA" => "\xE8\xB9\xBC",
		"\xC3\xDB" => "\xE8\xB9\xB2",
		"\xC3\xDC" => "\xE8\xBA\x87",
		"\xC3\xDD" => "\xE8\xB9\xB6",
		"\xC3\xDE" => "\xE8\xB9\xAC",
		"\xC3\xDF" => "\xE8\xB9\xBA",
		"\xC3\xE0" => "\xE8\xB9\xB4",
		"\xC3\xE1" => "\xE8\xBD\x94",
		"\xC3\xE2" => "\xE8\xBD\x8E",
		"\xC3\xE3" => "\xE8\xBE\xAD",
		"\xC3\xE4" => "\xE9\x82\x8A",
		"\xC3\xE5" => "\xE9\x82\x8B",
		"\xC3\xE6" => "\xE9\x86\xB1",
		"\xC3\xE7" => "\xE9\x86\xAE",
		"\xC3\xE8" => "\xE9\x8F\xA1",
		"\xC3\xE9" => "\xE9\x8F\x91",
		"\xC3\xEA" => "\xE9\x8F\x9F",
		"\xC3\xEB" => "\xE9\x8F\x83",
		"\xC3\xEC" => "\xE9\x8F\x88",
		"\xC3\xED" => "\xE9\x8F\x9C",
		"\xC3\xEE" => "\xE9\x8F\x9D",
		"\xC3\xEF" => "\xE9\x8F\x96",
		"\xC3\xF0" => "\xE9\x8F\xA2",
		"\xC3\xF1" => "\xE9\x8F\x8D",
		"\xC3\xF2" => "\xE9\x8F\x98",
		"\xC3\xF3" => "\xE9\x8F\xA4",
		"\xC3\xF4" => "\xE9\x8F\x97",
		"\xC3\xF5" => "\xE9\x8F\xA8",
		"\xC3\xF6" => "\xE9\x97\x9C",
		"\xC3\xF7" => "\xE9\x9A\xB4",
		"\xC3\xF8" => "\xE9\x9B\xA3",
		"\xC3\xF9" => "\xE9\x9C\xAA",
		"\xC3\xFA" => "\xE9\x9C\xA7",
		"\xC3\xFB" => "\xE9\x9D\xA1",
		"\xC3\xFC" => "\xE9\x9F\x9C",
		"\xC3\xFD" => "\xE9\x9F\xBB",
		"\xC3\xFE" => "\xE9\xA1\x9E",
		"\xC4\x40" => "\xE9\xA1\x98",
		"\xC4\x41" => "\xE9\xA1\x9B",
		"\xC4\x42" => "\xE9\xA2\xBC",
		"\xC4\x43" => "\xE9\xA5\x85",
		"\xC4\x44" => "\xE9\xA5\x89",
		"\xC4\x45" => "\xE9\xA8\x96",
		"\xC4\x46" => "\xE9\xA8\x99",
		"\xC4\x47" => "\xE9\xAC\x8D",
		"\xC4\x48" => "\xE9\xAF\xA8",
		"\xC4\x49" => "\xE9\xAF\xA7",
		"\xC4\x4A" => "\xE9\xAF\x96",
		"\xC4\x4B" => "\xE9\xAF\x9B",
		"\xC4\x4C" => "\xE9\xB6\x89",
		"\xC4\x4D" => "\xE9\xB5\xA1",
		"\xC4\x4E" => "\xE9\xB5\xB2",
		"\xC4\x4F" => "\xE9\xB5\xAA",
		"\xC4\x50" => "\xE9\xB5\xAC",
		"\xC4\x51" => "\xE9\xBA\x92",
		"\xC4\x52" => "\xE9\xBA\x97",
		"\xC4\x53" => "\xE9\xBA\x93",
		"\xC4\x54" => "\xE9\xBA\xB4",
		"\xC4\x55" => "\xE5\x8B\xB8",
		"\xC4\x56" => "\xE5\x9A\xA8",
		"\xC4\x57" => "\xE5\x9A\xB7",
		"\xC4\x58" => "\xE5\x9A\xB6",
		"\xC4\x59" => "\xE5\x9A\xB4",
		"\xC4\x5A" => "\xE5\x9A\xBC",
		"\xC4\x5B" => "\xE5\xA3\xA4",
		"\xC4\x5C" => "\xE5\xAD\x80",
		"\xC4\x5D" => "\xE5\xAD\x83",
		"\xC4\x5E" => "\xE5\xAD\xBD",
		"\xC4\x5F" => "\xE5\xAF\xB6",
		"\xC4\x60" => "\xE5\xB7\x89",
		"\xC4\x61" => "\xE6\x87\xB8",
		"\xC4\x62" => "\xE6\x87\xBA",
		"\xC4\x63" => "\xE6\x94\x98",
		"\xC4\x64" => "\xE6\x94\x94",
		"\xC4\x65" => "\xE6\x94\x99",
		"\xC4\x66" => "\xE6\x9B\xA6",
		"\xC4\x67" => "\xE6\x9C\xA7",
		"\xC4\x68" => "\xE6\xAB\xAC",
		"\xC4\x69" => "\xE7\x80\xBE",
		"\xC4\x6A" => "\xE7\x80\xB0",
		"\xC4\x6B" => "\xE7\x80\xB2",
		"\xC4\x6C" => "\xE7\x88\x90",
		"\xC4\x6D" => "\xE7\x8D\xBB",
		"\xC4\x6E" => "\xE7\x93\x8F",
		"\xC4\x6F" => "\xE7\x99\xA2",
		"\xC4\x70" => "\xE7\x99\xA5",
		"\xC4\x71" => "\xE7\xA4\xA6",
		"\xC4\x72" => "\xE7\xA4\xAA",
		"\xC4\x73" => "\xE7\xA4\xAC",
		"\xC4\x74" => "\xE7\xA4\xAB",
		"\xC4\x75" => "\xE7\xAB\x87",
		"\xC4\x76" => "\xE7\xAB\xB6",
		"\xC4\x77" => "\xE7\xB1\x8C",
		"\xC4\x78" => "\xE7\xB1\x83",
		"\xC4\x79" => "\xE7\xB1\x8D",
		"\xC4\x7A" => "\xE7\xB3\xAF",
		"\xC4\x7B" => "\xE7\xB3\xB0",
		"\xC4\x7C" => "\xE8\xBE\xAE",
		"\xC4\x7D" => "\xE7\xB9\xBD",
		"\xC4\x7E" => "\xE7\xB9\xBC",
		"\xC4\xA1" => "\xE7\xBA\x82",
		"\xC4\xA2" => "\xE7\xBD\x8C",
		"\xC4\xA3" => "\xE8\x80\x80",
		"\xC4\xA4" => "\xE8\x87\x9A",
		"\xC4\xA5" => "\xE8\x89\xA6",
		"\xC4\xA6" => "\xE8\x97\xBB",
		"\xC4\xA7" => "\xE8\x97\xB9",
		"\xC4\xA8" => "\xE8\x98\x91",
		"\xC4\xA9" => "\xE8\x97\xBA",
		"\xC4\xAA" => "\xE8\x98\x86",
		"\xC4\xAB" => "\xE8\x98\x8B",
		"\xC4\xAC" => "\xE8\x98\x87",
		"\xC4\xAD" => "\xE8\x98\x8A",
		"\xC4\xAE" => "\xE8\xA0\x94",
		"\xC4\xAF" => "\xE8\xA0\x95",
		"\xC4\xB0" => "\xE8\xA5\xA4",
		"\xC4\xB1" => "\xE8\xA6\xBA",
		"\xC4\xB2" => "\xE8\xA7\xB8",
		"\xC4\xB3" => "\xE8\xAD\xB0",
		"\xC4\xB4" => "\xE8\xAD\xAC",
		"\xC4\xB5" => "\xE8\xAD\xA6",
		"\xC4\xB6" => "\xE8\xAD\xAF",
		"\xC4\xB7" => "\xE8\xAD\x9F",
		"\xC4\xB8" => "\xE8\xAD\xAB",
		"\xC4\xB9" => "\xE8\xB4\x8F",
		"\xC4\xBA" => "\xE8\xB4\x8D",
		"\xC4\xBB" => "\xE8\xBA\x89",
		"\xC4\xBC" => "\xE8\xBA\x81",
		"\xC4\xBD" => "\xE8\xBA\x85",
		"\xC4\xBE" => "\xE8\xBA\x82",
		"\xC4\xBF" => "\xE9\x86\xB4",
		"\xC4\xC0" => "\xE9\x87\x8B",
		"\xC4\xC1" => "\xE9\x90\x98",
		"\xC4\xC2" => "\xE9\x90\x83",
		"\xC4\xC3" => "\xE9\x8F\xBD",
		"\xC4\xC4" => "\xE9\x97\xA1",
		"\xC4\xC5" => "\xE9\x9C\xB0",
		"\xC4\xC6" => "\xE9\xA3\x84",
		"\xC4\xC7" => "\xE9\xA5\x92",
		"\xC4\xC8" => "\xE9\xA5\x91",
		"\xC4\xC9" => "\xE9\xA6\xA8",
		"\xC4\xCA" => "\xE9\xA8\xAB",
		"\xC4\xCB" => "\xE9\xA8\xB0",
		"\xC4\xCC" => "\xE9\xA8\xB7",
		"\xC4\xCD" => "\xE9\xA8\xB5",
		"\xC4\xCE" => "\xE9\xB0\x93",
		"\xC4\xCF" => "\xE9\xB0\x8D",
		"\xC4\xD0" => "\xE9\xB9\xB9",
		"\xC4\xD1" => "\xE9\xBA\xB5",
		"\xC4\xD2" => "\xE9\xBB\xA8",
		"\xC4\xD3" => "\xE9\xBC\xAF",
		"\xC4\xD4" => "\xE9\xBD\x9F",
		"\xC4\xD5" => "\xE9\xBD\xA3",
		"\xC4\xD6" => "\xE9\xBD\xA1",
		"\xC4\xD7" => "\xE5\x84\xB7",
		"\xC4\xD8" => "\xE5\x84\xB8",
		"\xC4\xD9" => "\xE5\x9B\x81",
		"\xC4\xDA" => "\xE5\x9B\x80",
		"\xC4\xDB" => "\xE5\x9B\x82",
		"\xC4\xDC" => "\xE5\xA4\x94",
		"\xC4\xDD" => "\xE5\xB1\xAC",
		"\xC4\xDE" => "\xE5\xB7\x8D",
		"\xC4\xDF" => "\xE6\x87\xBC",
		"\xC4\xE0" => "\xE6\x87\xBE",
		"\xC4\xE1" => "\xE6\x94\x9D",
		"\xC4\xE2" => "\xE6\x94\x9C",
		"\xC4\xE3" => "\xE6\x96\x95",
		"\xC4\xE4" => "\xE6\x9B\xA9",
		"\xC4\xE5" => "\xE6\xAB\xBB",
		"\xC4\xE6" => "\xE6\xAC\x84",
		"\xC4\xE7" => "\xE6\xAB\xBA",
		"\xC4\xE8" => "\xE6\xAE\xB2",
		"\xC4\xE9" => "\xE7\x81\x8C",
		"\xC4\xEA" => "\xE7\x88\x9B",
		"\xC4\xEB" => "\xE7\x8A\xA7",
		"\xC4\xEC" => "\xE7\x93\x96",
		"\xC4\xED" => "\xE7\x93\x94",
		"\xC4\xEE" => "\xE7\x99\xA9",
		"\xC4\xEF" => "\xE7\x9F\x93",
		"\xC4\xF0" => "\xE7\xB1\x90",
		"\xC4\xF1" => "\xE7\xBA\x8F",
		"\xC4\xF2" => "\xE7\xBA\x8C",
		"\xC4\xF3" => "\xE7\xBE\xBC",
		"\xC4\xF4" => "\xE8\x98\x97",
		"\xC4\xF5" => "\xE8\x98\xAD",
		"\xC4\xF6" => "\xE8\x98\x9A",
		"\xC4\xF7" => "\xE8\xA0\xA3",
		"\xC4\xF8" => "\xE8\xA0\xA2",
		"\xC4\xF9" => "\xE8\xA0\xA1",
		"\xC4\xFA" => "\xE8\xA0\x9F",
		"\xC4\xFB" => "\xE8\xA5\xAA",
		"\xC4\xFC" => "\xE8\xA5\xAC",
		"\xC4\xFD" => "\xE8\xA6\xBD",
		"\xC4\xFE" => "\xE8\xAD\xB4",
		"\xC5\x40" => "\xE8\xAD\xB7",
		"\xC5\x41" => "\xE8\xAD\xBD",
		"\xC5\x42" => "\xE8\xB4\x93",
		"\xC5\x43" => "\xE8\xBA\x8A",
		"\xC5\x44" => "\xE8\xBA\x8D",
		"\xC5\x45" => "\xE8\xBA\x8B",
		"\xC5\x46" => "\xE8\xBD\x9F",
		"\xC5\x47" => "\xE8\xBE\xAF",
		"\xC5\x48" => "\xE9\x86\xBA",
		"\xC5\x49" => "\xE9\x90\xAE",
		"\xC5\x4A" => "\xE9\x90\xB3",
		"\xC5\x4B" => "\xE9\x90\xB5",
		"\xC5\x4C" => "\xE9\x90\xBA",
		"\xC5\x4D" => "\xE9\x90\xB8",
		"\xC5\x4E" => "\xE9\x90\xB2",
		"\xC5\x4F" => "\xE9\x90\xAB",
		"\xC5\x50" => "\xE9\x97\xA2",
		"\xC5\x51" => "\xE9\x9C\xB8",
		"\xC5\x52" => "\xE9\x9C\xB9",
		"\xC5\x53" => "\xE9\x9C\xB2",
		"\xC5\x54" => "\xE9\x9F\xBF",
		"\xC5\x55" => "\xE9\xA1\xA7",
		"\xC5\x56" => "\xE9\xA1\xA5",
		"\xC5\x57" => "\xE9\xA5\x97",
		"\xC5\x58" => "\xE9\xA9\x85",
		"\xC5\x59" => "\xE9\xA9\x83",
		"\xC5\x5A" => "\xE9\xA9\x80",
		"\xC5\x5B" => "\xE9\xA8\xBE",
		"\xC5\x5C" => "\xE9\xAB\x8F",
		"\xC5\x5D" => "\xE9\xAD\x94",
		"\xC5\x5E" => "\xE9\xAD\x91",
		"\xC5\x5F" => "\xE9\xB0\xAD",
		"\xC5\x60" => "\xE9\xB0\xA5",
		"\xC5\x61" => "\xE9\xB6\xAF",
		"\xC5\x62" => "\xE9\xB6\xB4",
		"\xC5\x63" => "\xE9\xB7\x82",
		"\xC5\x64" => "\xE9\xB6\xB8",
		"\xC5\x65" => "\xE9\xBA\x9D",
		"\xC5\x66" => "\xE9\xBB\xAF",
		"\xC5\x67" => "\xE9\xBC\x99",
		"\xC5\x68" => "\xE9\xBD\x9C",
		"\xC5\x69" => "\xE9\xBD\xA6",
		"\xC5\x6A" => "\xE9\xBD\xA7",
		"\xC5\x6B" => "\xE5\x84\xBC",
		"\xC5\x6C" => "\xE5\x84\xBB",
		"\xC5\x6D" => "\xE5\x9B\x88",
		"\xC5\x6E" => "\xE5\x9B\x8A",
		"\xC5\x6F" => "\xE5\x9B\x89",
		"\xC5\x70" => "\xE5\xAD\xBF",
		"\xC5\x71" => "\xE5\xB7\x94",
		"\xC5\x72" => "\xE5\xB7\x92",
		"\xC5\x73" => "\xE5\xBD\x8E",
		"\xC5\x74" => "\xE6\x87\xBF",
		"\xC5\x75" => "\xE6\x94\xA4",
		"\xC5\x76" => "\xE6\xAC\x8A",
		"\xC5\x77" => "\xE6\xAD\xA1",
		"\xC5\x78" => "\xE7\x81\x91",
		"\xC5\x79" => "\xE7\x81\x98",
		"\xC5\x7A" => "\xE7\x8E\x80",
		"\xC5\x7B" => "\xE7\x93\xA4",
		"\xC5\x7C" => "\xE7\x96\x8A",
		"\xC5\x7D" => "\xE7\x99\xAE",
		"\xC5\x7E" => "\xE7\x99\xAC",
		"\xC5\xA1" => "\xE7\xA6\xB3",
		"\xC5\xA2" => "\xE7\xB1\xA0",
		"\xC5\xA3" => "\xE7\xB1\x9F",
		"\xC5\xA4" => "\xE8\x81\xBE",
		"\xC5\xA5" => "\xE8\x81\xBD",
		"\xC5\xA6" => "\xE8\x87\x9F",
		"\xC5\xA7" => "\xE8\xA5\xB2",
		"\xC5\xA8" => "\xE8\xA5\xAF",
		"\xC5\xA9" => "\xE8\xA7\xBC",
		"\xC5\xAA" => "\xE8\xAE\x80",
		"\xC5\xAB" => "\xE8\xB4\x96",
		"\xC5\xAC" => "\xE8\xB4\x97",
		"\xC5\xAD" => "\xE8\xBA\x91",
		"\xC5\xAE" => "\xE8\xBA\x93",
		"\xC5\xAF" => "\xE8\xBD\xA1",
		"\xC5\xB0" => "\xE9\x85\x88",
		"\xC5\xB1" => "\xE9\x91\x84",
		"\xC5\xB2" => "\xE9\x91\x91",
		"\xC5\xB3" => "\xE9\x91\x92",
		"\xC5\xB4" => "\xE9\x9C\xBD",
		"\xC5\xB5" => "\xE9\x9C\xBE",
		"\xC5\xB6" => "\xE9\x9F\x83",
		"\xC5\xB7" => "\xE9\x9F\x81",
		"\xC5\xB8" => "\xE9\xA1\xAB",
		"\xC5\xB9" => "\xE9\xA5\x95",
		"\xC5\xBA" => "\xE9\xA9\x95",
		"\xC5\xBB" => "\xE9\xA9\x8D",
		"\xC5\xBC" => "\xE9\xAB\x92",
		"\xC5\xBD" => "\xE9\xAC\x9A",
		"\xC5\xBE" => "\xE9\xB1\x89",
		"\xC5\xBF" => "\xE9\xB0\xB1",
		"\xC5\xC0" => "\xE9\xB0\xBE",
		"\xC5\xC1" => "\xE9\xB0\xBB",
		"\xC5\xC2" => "\xE9\xB7\x93",
		"\xC5\xC3" => "\xE9\xB7\x97",
		"\xC5\xC4" => "\xE9\xBC\xB4",
		"\xC5\xC5" => "\xE9\xBD\xAC",
		"\xC5\xC6" => "\xE9\xBD\xAA",
		"\xC5\xC7" => "\xE9\xBE\x94",
		"\xC5\xC8" => "\xE5\x9B\x8C",
		"\xC5\xC9" => "\xE5\xB7\x96",
		"\xC5\xCA" => "\xE6\x88\x80",
		"\xC5\xCB" => "\xE6\x94\xA3",
		"\xC5\xCC" => "\xE6\x94\xAB",
		"\xC5\xCD" => "\xE6\x94\xAA",
		"\xC5\xCE" => "\xE6\x9B\xAC",
		"\xC5\xCF" => "\xE6\xAC\x90",
		"\xC5\xD0" => "\xE7\x93\x9A",
		"\xC5\xD1" => "\xE7\xAB\x8A",
		"\xC5\xD2" => "\xE7\xB1\xA4",
		"\xC5\xD3" => "\xE7\xB1\xA3",
		"\xC5\xD4" => "\xE7\xB1\xA5",
		"\xC5\xD5" => "\xE7\xBA\x93",
		"\xC5\xD6" => "\xE7\xBA\x96",
		"\xC5\xD7" => "\xE7\xBA\x94",
		"\xC5\xD8" => "\xE8\x87\xA2",
		"\xC5\xD9" => "\xE8\x98\xB8",
		"\xC5\xDA" => "\xE8\x98\xBF",
		"\xC5\xDB" => "\xE8\xA0\xB1",
		"\xC5\xDC" => "\xE8\xAE\x8A",
		"\xC5\xDD" => "\xE9\x82\x90",
		"\xC5\xDE" => "\xE9\x82\x8F",
		"\xC5\xDF" => "\xE9\x91\xA3",
		"\xC5\xE0" => "\xE9\x91\xA0",
		"\xC5\xE1" => "\xE9\x91\xA4",
		"\xC5\xE2" => "\xE9\x9D\xA8",
		"\xC5\xE3" => "\xE9\xA1\xAF",
		"\xC5\xE4" => "\xE9\xA5\x9C",
		"\xC5\xE5" => "\xE9\xA9\x9A",
		"\xC5\xE6" => "\xE9\xA9\x9B",
		"\xC5\xE7" => "\xE9\xA9\x97",
		"\xC5\xE8" => "\xE9\xAB\x93",
		"\xC5\xE9" => "\xE9\xAB\x94",
		"\xC5\xEA" => "\xE9\xAB\x91",
		"\xC5\xEB" => "\xE9\xB1\x94",
		"\xC5\xEC" => "\xE9\xB1\x97",
		"\xC5\xED" => "\xE9\xB1\x96",
		"\xC5\xEE" => "\xE9\xB7\xA5",
		"\xC5\xEF" => "\xE9\xBA\x9F",
		"\xC5\xF0" => "\xE9\xBB\xB4",
		"\xC5\xF1" => "\xE5\x9B\x91",
		"\xC5\xF2" => "\xE5\xA3\xA9",
		"\xC5\xF3" => "\xE6\x94\xAC",
		"\xC5\xF4" => "\xE7\x81\x9E",
		"\xC5\xF5" => "\xE7\x99\xB1",
		"\xC5\xF6" => "\xE7\x99\xB2",
		"\xC5\xF7" => "\xE7\x9F\x97",
		"\xC5\xF8" => "\xE7\xBD\x90",
		"\xC5\xF9" => "\xE7\xBE\x88",
		"\xC5\xFA" => "\xE8\xA0\xB6",
		"\xC5\xFB" => "\xE8\xA0\xB9",
		"\xC5\xFC" => "\xE8\xA1\xA2",
		"\xC5\xFD" => "\xE8\xAE\x93",
		"\xC5\xFE" => "\xE8\xAE\x92",
		"\xC6\x40" => "\xE8\xAE\x96",
		"\xC6\x41" => "\xE8\x89\xB7",
		"\xC6\x42" => "\xE8\xB4\x9B",
		"\xC6\x43" => "\xE9\x87\x80",
		"\xC6\x44" => "\xE9\x91\xAA",
		"\xC6\x45" => "\xE9\x9D\x82",
		"\xC6\x46" => "\xE9\x9D\x88",
		"\xC6\x47" => "\xE9\x9D\x84",
		"\xC6\x48" => "\xE9\x9F\x86",
		"\xC6\x49" => "\xE9\xA1\xB0",
		"\xC6\x4A" => "\xE9\xA9\x9F",
		"\xC6\x4B" => "\xE9\xAC\xA2",
		"\xC6\x4C" => "\xE9\xAD\x98",
		"\xC6\x4D" => "\xE9\xB1\x9F",
		"\xC6\x4E" => "\xE9\xB7\xB9",
		"\xC6\x4F" => "\xE9\xB7\xBA",
		"\xC6\x50" => "\xE9\xB9\xBC",
		"\xC6\x51" => "\xE9\xB9\xBD",
		"\xC6\x52" => "\xE9\xBC\x87",
		"\xC6\x53" => "\xE9\xBD\xB7",
		"\xC6\x54" => "\xE9\xBD\xB2",
		"\xC6\x55" => "\xE5\xBB\xB3",
		"\xC6\x56" => "\xE6\xAC\x96",
		"\xC6\x57" => "\xE7\x81\xA3",
		"\xC6\x58" => "\xE7\xB1\xAC",
		"\xC6\x59" => "\xE7\xB1\xAE",
		"\xC6\x5A" => "\xE8\xA0\xBB",
		"\xC6\x5B" => "\xE8\xA7\x80",
		"\xC6\x5C" => "\xE8\xBA\xA1",
		"\xC6\x5D" => "\xE9\x87\x81",
		"\xC6\x5E" => "\xE9\x91\xB2",
		"\xC6\x5F" => "\xE9\x91\xB0",
		"\xC6\x60" => "\xE9\xA1\xB1",
		"\xC6\x61" => "\xE9\xA5\x9E",
		"\xC6\x62" => "\xE9\xAB\x96",
		"\xC6\x63" => "\xE9\xAC\xA3",
		"\xC6\x64" => "\xE9\xBB\x8C",
		"\xC6\x65" => "\xE7\x81\xA4",
		"\xC6\x66" => "\xE7\x9F\x9A",
		"\xC6\x67" => "\xE8\xAE\x9A",
		"\xC6\x68" => "\xE9\x91\xB7",
		"\xC6\x69" => "\xE9\x9F\x89",
		"\xC6\x6A" => "\xE9\xA9\xA2",
		"\xC6\x6B" => "\xE9\xA9\xA5",
		"\xC6\x6C" => "\xE7\xBA\x9C",
		"\xC6\x6D" => "\xE8\xAE\x9C",
		"\xC6\x6E" => "\xE8\xBA\xAA",
		"\xC6\x6F" => "\xE9\x87\x85",
		"\xC6\x70" => "\xE9\x91\xBD",
		"\xC6\x71" => "\xE9\x91\xBE",
		"\xC6\x72" => "\xE9\x91\xBC",
		"\xC6\x73" => "\xE9\xB1\xB7",
		"\xC6\x74" => "\xE9\xB1\xB8",
		"\xC6\x75" => "\xE9\xBB\xB7",
		"\xC6\x76" => "\xE8\xB1\x94",
		"\xC6\x77" => "\xE9\x91\xBF",
		"\xC6\x78" => "\xE9\xB8\x9A",
		"\xC6\x79" => "\xE7\x88\xA8",
		"\xC6\x7A" => "\xE9\xA9\xAA",
		"\xC6\x7B" => "\xE9\xAC\xB1",
		"\xC6\x7C" => "\xE9\xB8\x9B",
		"\xC6\x7D" => "\xE9\xB8\x9E",
		"\xC6\x7E" => "\xE7\xB1\xB2",
		"\xC6\xA1" => "\xE3\x83\xBE",
		"\xC6\xA2" => "\xE3\x82\x9D",
		"\xC6\xA3" => "\xE3\x82\x9E",
		"\xC6\xA4" => "\xE3\x80\x85",
		"\xC6\xA5" => "\xE3\x81\x81",
		"\xC6\xA6" => "\xE3\x81\x82",
		"\xC6\xA7" => "\xE3\x81\x83",
		"\xC6\xA8" => "\xE3\x81\x84",
		"\xC6\xA9" => "\xE3\x81\x85",
		"\xC6\xAA" => "\xE3\x81\x86",
		"\xC6\xAB" => "\xE3\x81\x87",
		"\xC6\xAC" => "\xE3\x81\x88",
		"\xC6\xAD" => "\xE3\x81\x89",
		"\xC6\xAE" => "\xE3\x81\x8A",
		"\xC6\xAF" => "\xE3\x81\x8B",
		"\xC6\xB0" => "\xE3\x81\x8C",
		"\xC6\xB1" => "\xE3\x81\x8D",
		"\xC6\xB2" => "\xE3\x81\x8E",
		"\xC6\xB3" => "\xE3\x81\x8F",
		"\xC6\xB4" => "\xE3\x81\x90",
		"\xC6\xB5" => "\xE3\x81\x91",
		"\xC6\xB6" => "\xE3\x81\x92",
		"\xC6\xB7" => "\xE3\x81\x93",
		"\xC6\xB8" => "\xE3\x81\x94",
		"\xC6\xB9" => "\xE3\x81\x95",
		"\xC6\xBA" => "\xE3\x81\x96",
		"\xC6\xBB" => "\xE3\x81\x97",
		"\xC6\xBC" => "\xE3\x81\x98",
		"\xC6\xBD" => "\xE3\x81\x99",
		"\xC6\xBE" => "\xE3\x81\x9A",
		"\xC6\xBF" => "\xE3\x81\x9B",
		"\xC6\xC0" => "\xE3\x81\x9C",
		"\xC6\xC1" => "\xE3\x81\x9D",
		"\xC6\xC2" => "\xE3\x81\x9E",
		"\xC6\xC3" => "\xE3\x81\x9F",
		"\xC6\xC4" => "\xE3\x81\xA0",
		"\xC6\xC5" => "\xE3\x81\xA1",
		"\xC6\xC6" => "\xE3\x81\xA2",
		"\xC6\xC7" => "\xE3\x81\xA3",
		"\xC6\xC8" => "\xE3\x81\xA4",
		"\xC6\xC9" => "\xE3\x81\xA5",
		"\xC6\xCA" => "\xE3\x81\xA6",
		"\xC6\xCB" => "\xE3\x81\xA7",
		"\xC6\xCC" => "\xE3\x81\xA8",
		"\xC6\xCD" => "\xE3\x81\xA9",
		"\xC6\xCE" => "\xE3\x81\xAA",
		"\xC6\xCF" => "\xE3\x81\xAB",
		"\xC6\xD0" => "\xE3\x81\xAC",
		"\xC6\xD1" => "\xE3\x81\xAD",
		"\xC6\xD2" => "\xE3\x81\xAE",
		"\xC6\xD3" => "\xE3\x81\xAF",
		"\xC6\xD4" => "\xE3\x81\xB0",
		"\xC6\xD5" => "\xE3\x81\xB1",
		"\xC6\xD6" => "\xE3\x81\xB2",
		"\xC6\xD7" => "\xE3\x81\xB3",
		"\xC6\xD8" => "\xE3\x81\xB4",
		"\xC6\xD9" => "\xE3\x81\xB5",
		"\xC6\xDA" => "\xE3\x81\xB6",
		"\xC6\xDB" => "\xE3\x81\xB7",
		"\xC6\xDC" => "\xE3\x81\xB8",
		"\xC6\xDD" => "\xE3\x81\xB9",
		"\xC6\xDE" => "\xE3\x81\xBA",
		"\xC6\xDF" => "\xE3\x81\xBB",
		"\xC6\xE0" => "\xE3\x81\xBC",
		"\xC6\xE1" => "\xE3\x81\xBD",
		"\xC6\xE2" => "\xE3\x81\xBE",
		"\xC6\xE3" => "\xE3\x81\xBF",
		"\xC6\xE4" => "\xE3\x82\x80",
		"\xC6\xE5" => "\xE3\x82\x81",
		"\xC6\xE6" => "\xE3\x82\x82",
		"\xC6\xE7" => "\xE3\x82\x83",
		"\xC6\xE8" => "\xE3\x82\x84",
		"\xC6\xE9" => "\xE3\x82\x85",
		"\xC6\xEA" => "\xE3\x82\x86",
		"\xC6\xEB" => "\xE3\x82\x87",
		"\xC6\xEC" => "\xE3\x82\x88",
		"\xC6\xED" => "\xE3\x82\x89",
		"\xC6\xEE" => "\xE3\x82\x8A",
		"\xC6\xEF" => "\xE3\x82\x8B",
		"\xC6\xF0" => "\xE3\x82\x8C",
		"\xC6\xF1" => "\xE3\x82\x8D",
		"\xC6\xF2" => "\xE3\x82\x8E",
		"\xC6\xF3" => "\xE3\x82\x8F",
		"\xC6\xF4" => "\xE3\x82\x90",
		"\xC6\xF5" => "\xE3\x82\x91",
		"\xC6\xF6" => "\xE3\x82\x92",
		"\xC6\xF7" => "\xE3\x82\x93",
		"\xC6\xF8" => "\xE3\x82\xA1",
		"\xC6\xF9" => "\xE3\x82\xA2",
		"\xC6\xFA" => "\xE3\x82\xA3",
		"\xC6\xFB" => "\xE3\x82\xA4",
		"\xC6\xFC" => "\xE3\x82\xA5",
		"\xC6\xFD" => "\xE3\x82\xA6",
		"\xC6\xFE" => "\xE3\x82\xA7",
		"\xC7\x40" => "\xE3\x82\xA8",
		"\xC7\x41" => "\xE3\x82\xA9",
		"\xC7\x42" => "\xE3\x82\xAA",
		"\xC7\x43" => "\xE3\x82\xAB",
		"\xC7\x44" => "\xE3\x82\xAC",
		"\xC7\x45" => "\xE3\x82\xAD",
		"\xC7\x46" => "\xE3\x82\xAE",
		"\xC7\x47" => "\xE3\x82\xAF",
		"\xC7\x48" => "\xE3\x82\xB0",
		"\xC7\x49" => "\xE3\x82\xB1",
		"\xC7\x4A" => "\xE3\x82\xB2",
		"\xC7\x4B" => "\xE3\x82\xB3",
		"\xC7\x4C" => "\xE3\x82\xB4",
		"\xC7\x4D" => "\xE3\x82\xB5",
		"\xC7\x4E" => "\xE3\x82\xB6",
		"\xC7\x4F" => "\xE3\x82\xB7",
		"\xC7\x50" => "\xE3\x82\xB8",
		"\xC7\x51" => "\xE3\x82\xB9",
		"\xC7\x52" => "\xE3\x82\xBA",
		"\xC7\x53" => "\xE3\x82\xBB",
		"\xC7\x54" => "\xE3\x82\xBC",
		"\xC7\x55" => "\xE3\x82\xBD",
		"\xC7\x56" => "\xE3\x82\xBE",
		"\xC7\x57" => "\xE3\x82\xBF",
		"\xC7\x58" => "\xE3\x83\x80",
		"\xC7\x59" => "\xE3\x83\x81",
		"\xC7\x5A" => "\xE3\x83\x82",
		"\xC7\x5B" => "\xE3\x83\x83",
		"\xC7\x5C" => "\xE3\x83\x84",
		"\xC7\x5D" => "\xE3\x83\x85",
		"\xC7\x5E" => "\xE3\x83\x86",
		"\xC7\x5F" => "\xE3\x83\x87",
		"\xC7\x60" => "\xE3\x83\x88",
		"\xC7\x61" => "\xE3\x83\x89",
		"\xC7\x62" => "\xE3\x83\x8A",
		"\xC7\x63" => "\xE3\x83\x8B",
		"\xC7\x64" => "\xE3\x83\x8C",
		"\xC7\x65" => "\xE3\x83\x8D",
		"\xC7\x66" => "\xE3\x83\x8E",
		"\xC7\x67" => "\xE3\x83\x8F",
		"\xC7\x68" => "\xE3\x83\x90",
		"\xC7\x69" => "\xE3\x83\x91",
		"\xC7\x6A" => "\xE3\x83\x92",
		"\xC7\x6B" => "\xE3\x83\x93",
		"\xC7\x6C" => "\xE3\x83\x94",
		"\xC7\x6D" => "\xE3\x83\x95",
		"\xC7\x6E" => "\xE3\x83\x96",
		"\xC7\x6F" => "\xE3\x83\x97",
		"\xC7\x70" => "\xE3\x83\x98",
		"\xC7\x71" => "\xE3\x83\x99",
		"\xC7\x72" => "\xE3\x83\x9A",
		"\xC7\x73" => "\xE3\x83\x9B",
		"\xC7\x74" => "\xE3\x83\x9C",
		"\xC7\x75" => "\xE3\x83\x9D",
		"\xC7\x76" => "\xE3\x83\x9E",
		"\xC7\x77" => "\xE3\x83\x9F",
		"\xC7\x78" => "\xE3\x83\xA0",
		"\xC7\x79" => "\xE3\x83\xA1",
		"\xC7\x7A" => "\xE3\x83\xA2",
		"\xC7\x7B" => "\xE3\x83\xA3",
		"\xC7\x7C" => "\xE3\x83\xA4",
		"\xC7\x7D" => "\xE3\x83\xA5",
		"\xC7\x7E" => "\xE3\x83\xA6",
		"\xC7\xA1" => "\xE3\x83\xA7",
		"\xC7\xA2" => "\xE3\x83\xA8",
		"\xC7\xA3" => "\xE3\x83\xA9",
		"\xC7\xA4" => "\xE3\x83\xAA",
		"\xC7\xA5" => "\xE3\x83\xAB",
		"\xC7\xA6" => "\xE3\x83\xAC",
		"\xC7\xA7" => "\xE3\x83\xAD",
		"\xC7\xA8" => "\xE3\x83\xAE",
		"\xC7\xA9" => "\xE3\x83\xAF",
		"\xC7\xAA" => "\xE3\x83\xB0",
		"\xC7\xAB" => "\xE3\x83\xB1",
		"\xC7\xAC" => "\xE3\x83\xB2",
		"\xC7\xAD" => "\xE3\x83\xB3",
		"\xC7\xAE" => "\xE3\x83\xB4",
		"\xC7\xAF" => "\xE3\x83\xB5",
		"\xC7\xB0" => "\xE3\x83\xB6",
		"\xC7\xB1" => "\xD0\x94",
		"\xC7\xB2" => "\xD0\x95",
		"\xC7\xB3" => "\xD0\x81",
		"\xC7\xB4" => "\xD0\x96",
		"\xC7\xB5" => "\xD0\x97",
		"\xC7\xB6" => "\xD0\x98",
		"\xC7\xB7" => "\xD0\x99",
		"\xC7\xB8" => "\xD0\x9A",
		"\xC7\xB9" => "\xD0\x9B",
		"\xC7\xBA" => "\xD0\x9C",
		"\xC7\xBB" => "\xD0\xA3",
		"\xC7\xBC" => "\xD0\xA4",
		"\xC7\xBD" => "\xD0\xA5",
		"\xC7\xBE" => "\xD0\xA6",
		"\xC7\xBF" => "\xD0\xA7",
		"\xC7\xC0" => "\xD0\xA8",
		"\xC7\xC1" => "\xD0\xA9",
		"\xC7\xC2" => "\xD0\xAA",
		"\xC7\xC3" => "\xD0\xAB",
		"\xC7\xC4" => "\xD0\xAC",
		"\xC7\xC5" => "\xD0\xAD",
		"\xC7\xC6" => "\xD0\xAE",
		"\xC7\xC7" => "\xD0\xAF",
		"\xC7\xC8" => "\xD0\xB0",
		"\xC7\xC9" => "\xD0\xB1",
		"\xC7\xCA" => "\xD0\xB2",
		"\xC7\xCB" => "\xD0\xB3",
		"\xC7\xCC" => "\xD0\xB4",
		"\xC7\xCD" => "\xD0\xB5",
		"\xC7\xCE" => "\xD1\x91",
		"\xC7\xCF" => "\xD0\xB6",
		"\xC7\xD0" => "\xD0\xB7",
		"\xC7\xD1" => "\xD0\xB8",
		"\xC7\xD2" => "\xD0\xB9",
		"\xC7\xD3" => "\xD0\xBA",
		"\xC7\xD4" => "\xD0\xBB",
		"\xC7\xD5" => "\xD0\xBC",
		"\xC7\xD6" => "\xD0\xBD",
		"\xC7\xD7" => "\xD0\xBE",
		"\xC7\xD8" => "\xD0\xBF",
		"\xC7\xD9" => "\xD1\x80",
		"\xC7\xDA" => "\xD1\x81",
		"\xC7\xDB" => "\xD1\x82",
		"\xC7\xDC" => "\xD1\x83",
		"\xC7\xDD" => "\xD1\x84",
		"\xC7\xDE" => "\xD1\x85",
		"\xC7\xDF" => "\xD1\x86",
		"\xC7\xE0" => "\xD1\x87",
		"\xC7\xE1" => "\xD1\x88",
		"\xC7\xE2" => "\xD1\x89",
		"\xC7\xE3" => "\xD1\x8A",
		"\xC7\xE4" => "\xD1\x8B",
		"\xC7\xE5" => "\xD1\x8C",
		"\xC7\xE6" => "\xD1\x8D",
		"\xC7\xE7" => "\xD1\x8E",
		"\xC7\xE8" => "\xD1\x8F",
		"\xC7\xE9" => "\xE2\x91\xA0",
		"\xC7\xEA" => "\xE2\x91\xA1",
		"\xC7\xEB" => "\xE2\x91\xA2",
		"\xC7\xEC" => "\xE2\x91\xA3",
		"\xC7\xED" => "\xE2\x91\xA4",
		"\xC7\xEE" => "\xE2\x91\xA5",
		"\xC7\xEF" => "\xE2\x91\xA6",
		"\xC7\xF0" => "\xE2\x91\xA7",
		"\xC7\xF1" => "\xE2\x91\xA8",
		"\xC7\xF2" => "\xE2\x91\xA9",
		"\xC7\xF3" => "\xE2\x91\xB4",
		"\xC7\xF4" => "\xE2\x91\xB5",
		"\xC7\xF5" => "\xE2\x91\xB6",
		"\xC7\xF6" => "\xE2\x91\xB7",
		"\xC7\xF7" => "\xE2\x91\xB8",
		"\xC7\xF8" => "\xE2\x91\xB9",
		"\xC7\xF9" => "\xE2\x91\xBA",
		"\xC7\xFA" => "\xE2\x91\xBB",
		"\xC7\xFB" => "\xE2\x91\xBC",
		"\xC7\xFC" => "\xE2\x91\xBD",
		"\xC9\x40" => "\xE4\xB9\x82",
		"\xC9\x41" => "\xE4\xB9\x9C",
		"\xC9\x42" => "\xE5\x87\xB5",
		"\xC9\x43" => "\xE5\x8C\x9A",
		"\xC9\x44" => "\xE5\x8E\x82",
		"\xC9\x45" => "\xE4\xB8\x87",
		"\xC9\x46" => "\xE4\xB8\x8C",
		"\xC9\x47" => "\xE4\xB9\x87",
		"\xC9\x48" => "\xE4\xBA\x8D",
		"\xC9\x49" => "\xE5\x9B\x97",
		"\xC9\x4A" => "\xEF\xA8\x8C",
		"\xC9\x4B" => "\xE5\xB1\xAE",
		"\xC9\x4C" => "\xE5\xBD\xB3",
		"\xC9\x4D" => "\xE4\xB8\x8F",
		"\xC9\x4E" => "\xE5\x86\x87",
		"\xC9\x4F" => "\xE4\xB8\x8E",
		"\xC9\x50" => "\xE4\xB8\xAE",
		"\xC9\x51" => "\xE4\xBA\x93",
		"\xC9\x52" => "\xE4\xBB\x82",
		"\xC9\x53" => "\xE4\xBB\x89",
		"\xC9\x54" => "\xE4\xBB\x88",
		"\xC9\x55" => "\xE5\x86\x98",
		"\xC9\x56" => "\xE5\x8B\xBC",
		"\xC9\x57" => "\xE5\x8D\xAC",
		"\xC9\x58" => "\xE5\x8E\xB9",
		"\xC9\x59" => "\xE5\x9C\xA0",
		"\xC9\x5A" => "\xE5\xA4\x83",
		"\xC9\x5B" => "\xE5\xA4\xAC",
		"\xC9\x5C" => "\xE5\xB0\x90",
		"\xC9\x5D" => "\xE5\xB7\xBF",
		"\xC9\x5E" => "\xE6\x97\xA1",
		"\xC9\x5F" => "\xE6\xAE\xB3",
		"\xC9\x60" => "\xE6\xAF\x8C",
		"\xC9\x61" => "\xE6\xB0\x94",
		"\xC9\x62" => "\xE7\x88\xBF",
		"\xC9\x63" => "\xE4\xB8\xB1",
		"\xC9\x64" => "\xE4\xB8\xBC",
		"\xC9\x65" => "\xE4\xBB\xA8",
		"\xC9\x66" => "\xE4\xBB\x9C",
		"\xC9\x67" => "\xE4\xBB\xA9",
		"\xC9\x68" => "\xE4\xBB\xA1",
		"\xC9\x69" => "\xE4\xBB\x9D",
		"\xC9\x6A" => "\xE4\xBB\x9A",
		"\xC9\x6B" => "\xE5\x88\x8C",
		"\xC9\x6C" => "\xE5\x8C\x9C",
		"\xC9\x6D" => "\xE5\x8D\x8C",
		"\xC9\x6E" => "\xE5\x9C\xA2",
		"\xC9\x6F" => "\xE5\x9C\xA3",
		"\xC9\x70" => "\xE5\xA4\x97",
		"\xC9\x71" => "\xE5\xA4\xAF",
		"\xC9\x72" => "\xE5\xAE\x81",
		"\xC9\x73" => "\xE5\xAE\x84",
		"\xC9\x74" => "\xE5\xB0\x92",
		"\xC9\x75" => "\xE5\xB0\xBB",
		"\xC9\x76" => "\xE5\xB1\xB4",
		"\xC9\x77" => "\xE5\xB1\xB3",
		"\xC9\x78" => "\xE5\xB8\x84",
		"\xC9\x79" => "\xE5\xBA\x80",
		"\xC9\x7A" => "\xE5\xBA\x82",
		"\xC9\x7B" => "\xE5\xBF\x89",
		"\xC9\x7C" => "\xE6\x88\x89",
		"\xC9\x7D" => "\xE6\x89\x90",
		"\xC9\x7E" => "\xE6\xB0\x95",
		"\xC9\xA1" => "\xE6\xB0\xB6",
		"\xC9\xA2" => "\xE6\xB1\x83",
		"\xC9\xA3" => "\xE6\xB0\xBF",
		"\xC9\xA4" => "\xE6\xB0\xBB",
		"\xC9\xA5" => "\xE7\x8A\xAE",
		"\xC9\xA6" => "\xE7\x8A\xB0",
		"\xC9\xA7" => "\xE7\x8E\x8A",
		"\xC9\xA8" => "\xE7\xA6\xB8",
		"\xC9\xA9" => "\xE8\x82\x8A",
		"\xC9\xAA" => "\xE9\x98\x9E",
		"\xC9\xAB" => "\xE4\xBC\x8E",
		"\xC9\xAC" => "\xE4\xBC\x98",
		"\xC9\xAD" => "\xE4\xBC\xAC",
		"\xC9\xAE" => "\xE4\xBB\xB5",
		"\xC9\xAF" => "\xE4\xBC\x94",
		"\xC9\xB0" => "\xE4\xBB\xB1",
		"\xC9\xB1" => "\xE4\xBC\x80",
		"\xC9\xB2" => "\xE4\xBB\xB7",
		"\xC9\xB3" => "\xE4\xBC\x88",
		"\xC9\xB4" => "\xE4\xBC\x9D",
		"\xC9\xB5" => "\xE4\xBC\x82",
		"\xC9\xB6" => "\xE4\xBC\x85",
		"\xC9\xB7" => "\xE4\xBC\xA2",
		"\xC9\xB8" => "\xE4\xBC\x93",
		"\xC9\xB9" => "\xE4\xBC\x84",
		"\xC9\xBA" => "\xE4\xBB\xB4",
		"\xC9\xBB" => "\xE4\xBC\x92",
		"\xC9\xBC" => "\xE5\x86\xB1",
		"\xC9\xBD" => "\xE5\x88\x93",
		"\xC9\xBE" => "\xE5\x88\x89",
		"\xC9\xBF" => "\xE5\x88\x90",
		"\xC9\xC0" => "\xE5\x8A\xA6",
		"\xC9\xC1" => "\xE5\x8C\xA2",
		"\xC9\xC2" => "\xE5\x8C\x9F",
		"\xC9\xC3" => "\xE5\x8D\x8D",
		"\xC9\xC4" => "\xE5\x8E\x8A",
		"\xC9\xC5" => "\xE5\x90\x87",
		"\xC9\xC6" => "\xE5\x9B\xA1",
		"\xC9\xC7" => "\xE5\x9B\x9F",
		"\xC9\xC8" => "\xE5\x9C\xAE",
		"\xC9\xC9" => "\xE5\x9C\xAA",
		"\xC9\xCA" => "\xE5\x9C\xB4",
		"\xC9\xCB" => "\xE5\xA4\xBC",
		"\xC9\xCC" => "\xE5\xA6\x80",
		"\xC9\xCD" => "\xE5\xA5\xBC",
		"\xC9\xCE" => "\xE5\xA6\x85",
		"\xC9\xCF" => "\xE5\xA5\xBB",
		"\xC9\xD0" => "\xE5\xA5\xBE",
		"\xC9\xD1" => "\xE5\xA5\xB7",
		"\xC9\xD2" => "\xE5\xA5\xBF",
		"\xC9\xD3" => "\xE5\xAD\x96",
		"\xC9\xD4" => "\xE5\xB0\x95",
		"\xC9\xD5" => "\xE5\xB0\xA5",
		"\xC9\xD6" => "\xE5\xB1\xBC",
		"\xC9\xD7" => "\xE5\xB1\xBA",
		"\xC9\xD8" => "\xE5\xB1\xBB",
		"\xC9\xD9" => "\xE5\xB1\xBE",
		"\xC9\xDA" => "\xE5\xB7\x9F",
		"\xC9\xDB" => "\xE5\xB9\xB5",
		"\xC9\xDC" => "\xE5\xBA\x84",
		"\xC9\xDD" => "\xE5\xBC\x82",
		"\xC9\xDE" => "\xE5\xBC\x9A",
		"\xC9\xDF" => "\xE5\xBD\xB4",
		"\xC9\xE0" => "\xE5\xBF\x95",
		"\xC9\xE1" => "\xE5\xBF\x94",
		"\xC9\xE2" => "\xE5\xBF\x8F",
		"\xC9\xE3" => "\xE6\x89\x9C",
		"\xC9\xE4" => "\xE6\x89\x9E",
		"\xC9\xE5" => "\xE6\x89\xA4",
		"\xC9\xE6" => "\xE6\x89\xA1",
		"\xC9\xE7" => "\xE6\x89\xA6",
		"\xC9\xE8" => "\xE6\x89\xA2",
		"\xC9\xE9" => "\xE6\x89\x99",
		"\xC9\xEA" => "\xE6\x89\xA0",
		"\xC9\xEB" => "\xE6\x89\x9A",
		"\xC9\xEC" => "\xE6\x89\xA5",
		"\xC9\xED" => "\xE6\x97\xAF",
		"\xC9\xEE" => "\xE6\x97\xAE",
		"\xC9\xEF" => "\xE6\x9C\xBE",
		"\xC9\xF0" => "\xE6\x9C\xB9",
		"\xC9\xF1" => "\xE6\x9C\xB8",
		"\xC9\xF2" => "\xE6\x9C\xBB",
		"\xC9\xF3" => "\xE6\x9C\xBA",
		"\xC9\xF4" => "\xE6\x9C\xBF",
		"\xC9\xF5" => "\xE6\x9C\xBC",
		"\xC9\xF6" => "\xE6\x9C\xB3",
		"\xC9\xF7" => "\xE6\xB0\x98",
		"\xC9\xF8" => "\xE6\xB1\x86",
		"\xC9\xF9" => "\xE6\xB1\x92",
		"\xC9\xFA" => "\xE6\xB1\x9C",
		"\xC9\xFB" => "\xE6\xB1\x8F",
		"\xC9\xFC" => "\xE6\xB1\x8A",
		"\xC9\xFD" => "\xE6\xB1\x94",
		"\xC9\xFE" => "\xE6\xB1\x8B",
		"\xCA\x40" => "\xE6\xB1\x8C",
		"\xCA\x41" => "\xE7\x81\xB1",
		"\xCA\x42" => "\xE7\x89\x9E",
		"\xCA\x43" => "\xE7\x8A\xB4",
		"\xCA\x44" => "\xE7\x8A\xB5",
		"\xCA\x45" => "\xE7\x8E\x8E",
		"\xCA\x46" => "\xE7\x94\xAA",
		"\xCA\x47" => "\xE7\x99\xBF",
		"\xCA\x48" => "\xE7\xA9\xB5",
		"\xCA\x49" => "\xE7\xBD\x91",
		"\xCA\x4A" => "\xE8\x89\xB8",
		"\xCA\x4B" => "\xE8\x89\xBC",
		"\xCA\x4C" => "\xE8\x8A\x80",
		"\xCA\x4D" => "\xE8\x89\xBD",
		"\xCA\x4E" => "\xE8\x89\xBF",
		"\xCA\x4F" => "\xE8\x99\x8D",
		"\xCA\x50" => "\xE8\xA5\xBE",
		"\xCA\x51" => "\xE9\x82\x99",
		"\xCA\x52" => "\xE9\x82\x97",
		"\xCA\x53" => "\xE9\x82\x98",
		"\xCA\x54" => "\xE9\x82\x9B",
		"\xCA\x55" => "\xE9\x82\x94",
		"\xCA\x56" => "\xE9\x98\xA2",
		"\xCA\x57" => "\xE9\x98\xA4",
		"\xCA\x58" => "\xE9\x98\xA0",
		"\xCA\x59" => "\xE9\x98\xA3",
		"\xCA\x5A" => "\xE4\xBD\x96",
		"\xCA\x5B" => "\xE4\xBC\xBB",
		"\xCA\x5C" => "\xE4\xBD\xA2",
		"\xCA\x5D" => "\xE4\xBD\x89",
		"\xCA\x5E" => "\xE4\xBD\x93",
		"\xCA\x5F" => "\xE4\xBD\xA4",
		"\xCA\x60" => "\xE4\xBC\xBE",
		"\xCA\x61" => "\xE4\xBD\xA7",
		"\xCA\x62" => "\xE4\xBD\x92",
		"\xCA\x63" => "\xE4\xBD\x9F",
		"\xCA\x64" => "\xE4\xBD\x81",
		"\xCA\x65" => "\xE4\xBD\x98",
		"\xCA\x66" => "\xE4\xBC\xAD",
		"\xCA\x67" => "\xE4\xBC\xB3",
		"\xCA\x68" => "\xE4\xBC\xBF",
		"\xCA\x69" => "\xE4\xBD\xA1",
		"\xCA\x6A" => "\xE5\x86\x8F",
		"\xCA\x6B" => "\xE5\x86\xB9",
		"\xCA\x6C" => "\xE5\x88\x9C",
		"\xCA\x6D" => "\xE5\x88\x9E",
		"\xCA\x6E" => "\xE5\x88\xA1",
		"\xCA\x6F" => "\xE5\x8A\xAD",
		"\xCA\x70" => "\xE5\x8A\xAE",
		"\xCA\x71" => "\xE5\x8C\x89",
		"\xCA\x72" => "\xE5\x8D\xA3",
		"\xCA\x73" => "\xE5\x8D\xB2",
		"\xCA\x74" => "\xE5\x8E\x8E",
		"\xCA\x75" => "\xE5\x8E\x8F",
		"\xCA\x76" => "\xE5\x90\xB0",
		"\xCA\x77" => "\xE5\x90\xB7",
		"\xCA\x78" => "\xE5\x90\xAA",
		"\xCA\x79" => "\xE5\x91\x94",
		"\xCA\x7A" => "\xE5\x91\x85",
		"\xCA\x7B" => "\xE5\x90\x99",
		"\xCA\x7C" => "\xE5\x90\x9C",
		"\xCA\x7D" => "\xE5\x90\xA5",
		"\xCA\x7E" => "\xE5\x90\x98",
		"\xCA\xA1" => "\xE5\x90\xBD",
		"\xCA\xA2" => "\xE5\x91\x8F",
		"\xCA\xA3" => "\xE5\x91\x81",
		"\xCA\xA4" => "\xE5\x90\xA8",
		"\xCA\xA5" => "\xE5\x90\xA4",
		"\xCA\xA6" => "\xE5\x91\x87",
		"\xCA\xA7" => "\xE5\x9B\xAE",
		"\xCA\xA8" => "\xE5\x9B\xA7",
		"\xCA\xA9" => "\xE5\x9B\xA5",
		"\xCA\xAA" => "\xE5\x9D\x81",
		"\xCA\xAB" => "\xE5\x9D\x85",
		"\xCA\xAC" => "\xE5\x9D\x8C",
		"\xCA\xAD" => "\xE5\x9D\x89",
		"\xCA\xAE" => "\xE5\x9D\x8B",
		"\xCA\xAF" => "\xE5\x9D\x92",
		"\xCA\xB0" => "\xE5\xA4\x86",
		"\xCA\xB1" => "\xE5\xA5\x80",
		"\xCA\xB2" => "\xE5\xA6\xA6",
		"\xCA\xB3" => "\xE5\xA6\x98",
		"\xCA\xB4" => "\xE5\xA6\xA0",
		"\xCA\xB5" => "\xE5\xA6\x97",
		"\xCA\xB6" => "\xE5\xA6\x8E",
		"\xCA\xB7" => "\xE5\xA6\xA2",
		"\xCA\xB8" => "\xE5\xA6\x90",
		"\xCA\xB9" => "\xE5\xA6\x8F",
		"\xCA\xBA" => "\xE5\xA6\xA7",
		"\xCA\xBB" => "\xE5\xA6\xA1",
		"\xCA\xBC" => "\xE5\xAE\x8E",
		"\xCA\xBD" => "\xE5\xAE\x92",
		"\xCA\xBE" => "\xE5\xB0\xA8",
		"\xCA\xBF" => "\xE5\xB0\xAA",
		"\xCA\xC0" => "\xE5\xB2\x8D",
		"\xCA\xC1" => "\xE5\xB2\x8F",
		"\xCA\xC2" => "\xE5\xB2\x88",
		"\xCA\xC3" => "\xE5\xB2\x8B",
		"\xCA\xC4" => "\xE5\xB2\x89",
		"\xCA\xC5" => "\xE5\xB2\x92",
		"\xCA\xC6" => "\xE5\xB2\x8A",
		"\xCA\xC7" => "\xE5\xB2\x86",
		"\xCA\xC8" => "\xE5\xB2\x93",
		"\xCA\xC9" => "\xE5\xB2\x95",
		"\xCA\xCA" => "\xE5\xB7\xA0",
		"\xCA\xCB" => "\xE5\xB8\x8A",
		"\xCA\xCC" => "\xE5\xB8\x8E",
		"\xCA\xCD" => "\xE5\xBA\x8B",
		"\xCA\xCE" => "\xE5\xBA\x89",
		"\xCA\xCF" => "\xE5\xBA\x8C",
		"\xCA\xD0" => "\xE5\xBA\x88",
		"\xCA\xD1" => "\xE5\xBA\x8D",
		"\xCA\xD2" => "\xE5\xBC\x85",
		"\xCA\xD3" => "\xE5\xBC\x9D",
		"\xCA\xD4" => "\xE5\xBD\xB8",
		"\xCA\xD5" => "\xE5\xBD\xB6",
		"\xCA\xD6" => "\xE5\xBF\x92",
		"\xCA\xD7" => "\xE5\xBF\x91",
		"\xCA\xD8" => "\xE5\xBF\x90",
		"\xCA\xD9" => "\xE5\xBF\xAD",
		"\xCA\xDA" => "\xE5\xBF\xA8",
		"\xCA\xDB" => "\xE5\xBF\xAE",
		"\xCA\xDC" => "\xE5\xBF\xB3",
		"\xCA\xDD" => "\xE5\xBF\xA1",
		"\xCA\xDE" => "\xE5\xBF\xA4",
		"\xCA\xDF" => "\xE5\xBF\xA3",
		"\xCA\xE0" => "\xE5\xBF\xBA",
		"\xCA\xE1" => "\xE5\xBF\xAF",
		"\xCA\xE2" => "\xE5\xBF\xB7",
		"\xCA\xE3" => "\xE5\xBF\xBB",
		"\xCA\xE4" => "\xE6\x80\x80",
		"\xCA\xE5" => "\xE5\xBF\xB4",
		"\xCA\xE6" => "\xE6\x88\xBA",
		"\xCA\xE7" => "\xE6\x8A\x83",
		"\xCA\xE8" => "\xE6\x8A\x8C",
		"\xCA\xE9" => "\xE6\x8A\x8E",
		"\xCA\xEA" => "\xE6\x8A\x8F",
		"\xCA\xEB" => "\xE6\x8A\x94",
		"\xCA\xEC" => "\xE6\x8A\x87",
		"\xCA\xED" => "\xE6\x89\xB1",
		"\xCA\xEE" => "\xE6\x89\xBB",
		"\xCA\xEF" => "\xE6\x89\xBA",
		"\xCA\xF0" => "\xE6\x89\xB0",
		"\xCA\xF1" => "\xE6\x8A\x81",
		"\xCA\xF2" => "\xE6\x8A\x88",
		"\xCA\xF3" => "\xE6\x89\xB7",
		"\xCA\xF4" => "\xE6\x89\xBD",
		"\xCA\xF5" => "\xE6\x89\xB2",
		"\xCA\xF6" => "\xE6\x89\xB4",
		"\xCA\xF7" => "\xE6\x94\xB7",
		"\xCA\xF8" => "\xE6\x97\xB0",
		"\xCA\xF9" => "\xE6\x97\xB4",
		"\xCA\xFA" => "\xE6\x97\xB3",
		"\xCA\xFB" => "\xE6\x97\xB2",
		"\xCA\xFC" => "\xE6\x97\xB5",
		"\xCA\xFD" => "\xE6\x9D\x85",
		"\xCA\xFE" => "\xE6\x9D\x87",
		"\xCB\x40" => "\xE6\x9D\x99",
		"\xCB\x41" => "\xE6\x9D\x95",
		"\xCB\x42" => "\xE6\x9D\x8C",
		"\xCB\x43" => "\xE6\x9D\x88",
		"\xCB\x44" => "\xE6\x9D\x9D",
		"\xCB\x45" => "\xE6\x9D\x8D",
		"\xCB\x46" => "\xE6\x9D\x9A",
		"\xCB\x47" => "\xE6\x9D\x8B",
		"\xCB\x48" => "\xE6\xAF\x90",
		"\xCB\x49" => "\xE6\xB0\x99",
		"\xCB\x4A" => "\xE6\xB0\x9A",
		"\xCB\x4B" => "\xE6\xB1\xB8",
		"\xCB\x4C" => "\xE6\xB1\xA7",
		"\xCB\x4D" => "\xE6\xB1\xAB",
		"\xCB\x4E" => "\xE6\xB2\x84",
		"\xCB\x4F" => "\xE6\xB2\x8B",
		"\xCB\x50" => "\xE6\xB2\x8F",
		"\xCB\x51" => "\xE6\xB1\xB1",
		"\xCB\x52" => "\xE6\xB1\xAF",
		"\xCB\x53" => "\xE6\xB1\xA9",
		"\xCB\x54" => "\xE6\xB2\x9A",
		"\xCB\x55" => "\xE6\xB1\xAD",
		"\xCB\x56" => "\xE6\xB2\x87",
		"\xCB\x57" => "\xE6\xB2\x95",
		"\xCB\x58" => "\xE6\xB2\x9C",
		"\xCB\x59" => "\xE6\xB1\xA6",
		"\xCB\x5A" => "\xE6\xB1\xB3",
		"\xCB\x5B" => "\xE6\xB1\xA5",
		"\xCB\x5C" => "\xE6\xB1\xBB",
		"\xCB\x5D" => "\xE6\xB2\x8E",
		"\xCB\x5E" => "\xE7\x81\xB4",
		"\xCB\x5F" => "\xE7\x81\xBA",
		"\xCB\x60" => "\xE7\x89\xA3",
		"\xCB\x61" => "\xE7\x8A\xBF",
		"\xCB\x62" => "\xE7\x8A\xBD",
		"\xCB\x63" => "\xE7\x8B\x83",
		"\xCB\x64" => "\xE7\x8B\x86",
		"\xCB\x65" => "\xE7\x8B\x81",
		"\xCB\x66" => "\xE7\x8A\xBA",
		"\xCB\x67" => "\xE7\x8B\x85",
		"\xCB\x68" => "\xE7\x8E\x95",
		"\xCB\x69" => "\xE7\x8E\x97",
		"\xCB\x6A" => "\xE7\x8E\x93",
		"\xCB\x6B" => "\xE7\x8E\x94",
		"\xCB\x6C" => "\xE7\x8E\x92",
		"\xCB\x6D" => "\xE7\x94\xBA",
		"\xCB\x6E" => "\xE7\x94\xB9",
		"\xCB\x6F" => "\xE7\x96\x94",
		"\xCB\x70" => "\xE7\x96\x95",
		"\xCB\x71" => "\xE7\x9A\x81",
		"\xCB\x72" => "\xE7\xA4\xBD",
		"\xCB\x73" => "\xE8\x80\xB4",
		"\xCB\x74" => "\xE8\x82\x95",
		"\xCB\x75" => "\xE8\x82\x99",
		"\xCB\x76" => "\xE8\x82\x90",
		"\xCB\x77" => "\xE8\x82\x92",
		"\xCB\x78" => "\xE8\x82\x9C",
		"\xCB\x79" => "\xE8\x8A\x90",
		"\xCB\x7A" => "\xE8\x8A\x8F",
		"\xCB\x7B" => "\xE8\x8A\x85",
		"\xCB\x7C" => "\xE8\x8A\x8E",
		"\xCB\x7D" => "\xE8\x8A\x91",
		"\xCB\x7E" => "\xE8\x8A\x93",
		"\xCB\xA1" => "\xE8\x8A\x8A",
		"\xCB\xA2" => "\xE8\x8A\x83",
		"\xCB\xA3" => "\xE8\x8A\x84",
		"\xCB\xA4" => "\xE8\xB1\xB8",
		"\xCB\xA5" => "\xE8\xBF\x89",
		"\xCB\xA6" => "\xE8\xBE\xBF",
		"\xCB\xA7" => "\xE9\x82\x9F",
		"\xCB\xA8" => "\xE9\x82\xA1",
		"\xCB\xA9" => "\xE9\x82\xA5",
		"\xCB\xAA" => "\xE9\x82\x9E",
		"\xCB\xAB" => "\xE9\x82\xA7",
		"\xCB\xAC" => "\xE9\x82\xA0",
		"\xCB\xAD" => "\xE9\x98\xB0",
		"\xCB\xAE" => "\xE9\x98\xA8",
		"\xCB\xAF" => "\xE9\x98\xAF",
		"\xCB\xB0" => "\xE9\x98\xAD",
		"\xCB\xB1" => "\xE4\xB8\xB3",
		"\xCB\xB2" => "\xE4\xBE\x98",
		"\xCB\xB3" => "\xE4\xBD\xBC",
		"\xCB\xB4" => "\xE4\xBE\x85",
		"\xCB\xB5" => "\xE4\xBD\xBD",
		"\xCB\xB6" => "\xE4\xBE\x80",
		"\xCB\xB7" => "\xE4\xBE\x87",
		"\xCB\xB8" => "\xE4\xBD\xB6",
		"\xCB\xB9" => "\xE4\xBD\xB4",
		"\xCB\xBA" => "\xE4\xBE\x89",
		"\xCB\xBB" => "\xE4\xBE\x84",
		"\xCB\xBC" => "\xE4\xBD\xB7",
		"\xCB\xBD" => "\xE4\xBD\x8C",
		"\xCB\xBE" => "\xE4\xBE\x97",
		"\xCB\xBF" => "\xE4\xBD\xAA",
		"\xCB\xC0" => "\xE4\xBE\x9A",
		"\xCB\xC1" => "\xE4\xBD\xB9",
		"\xCB\xC2" => "\xE4\xBE\x81",
		"\xCB\xC3" => "\xE4\xBD\xB8",
		"\xCB\xC4" => "\xE4\xBE\x90",
		"\xCB\xC5" => "\xE4\xBE\x9C",
		"\xCB\xC6" => "\xE4\xBE\x94",
		"\xCB\xC7" => "\xE4\xBE\x9E",
		"\xCB\xC8" => "\xE4\xBE\x92",
		"\xCB\xC9" => "\xE4\xBE\x82",
		"\xCB\xCA" => "\xE4\xBE\x95",
		"\xCB\xCB" => "\xE4\xBD\xAB",
		"\xCB\xCC" => "\xE4\xBD\xAE",
		"\xCB\xCD" => "\xE5\x86\x9E",
		"\xCB\xCE" => "\xE5\x86\xBC",
		"\xCB\xCF" => "\xE5\x86\xBE",
		"\xCB\xD0" => "\xE5\x88\xB5",
		"\xCB\xD1" => "\xE5\x88\xB2",
		"\xCB\xD2" => "\xE5\x88\xB3",
		"\xCB\xD3" => "\xE5\x89\x86",
		"\xCB\xD4" => "\xE5\x88\xB1",
		"\xCB\xD5" => "\xE5\x8A\xBC",
		"\xCB\xD6" => "\xE5\x8C\x8A",
		"\xCB\xD7" => "\xE5\x8C\x8B",
		"\xCB\xD8" => "\xE5\x8C\xBC",
		"\xCB\xD9" => "\xE5\x8E\x92",
		"\xCB\xDA" => "\xE5\x8E\x94",
		"\xCB\xDB" => "\xE5\x92\x87",
		"\xCB\xDC" => "\xE5\x91\xBF",
		"\xCB\xDD" => "\xE5\x92\x81",
		"\xCB\xDE" => "\xE5\x92\x91",
		"\xCB\xDF" => "\xE5\x92\x82",
		"\xCB\xE0" => "\xE5\x92\x88",
		"\xCB\xE1" => "\xE5\x91\xAB",
		"\xCB\xE2" => "\xE5\x91\xBA",
		"\xCB\xE3" => "\xE5\x91\xBE",
		"\xCB\xE4" => "\xE5\x91\xA5",
		"\xCB\xE5" => "\xE5\x91\xAC",
		"\xCB\xE6" => "\xE5\x91\xB4",
		"\xCB\xE7" => "\xE5\x91\xA6",
		"\xCB\xE8" => "\xE5\x92\x8D",
		"\xCB\xE9" => "\xE5\x91\xAF",
		"\xCB\xEA" => "\xE5\x91\xA1",
		"\xCB\xEB" => "\xE5\x91\xA0",
		"\xCB\xEC" => "\xE5\x92\x98",
		"\xCB\xED" => "\xE5\x91\xA3",
		"\xCB\xEE" => "\xE5\x91\xA7",
		"\xCB\xEF" => "\xE5\x91\xA4",
		"\xCB\xF0" => "\xE5\x9B\xB7",
		"\xCB\xF1" => "\xE5\x9B\xB9",
		"\xCB\xF2" => "\xE5\x9D\xAF",
		"\xCB\xF3" => "\xE5\x9D\xB2",
		"\xCB\xF4" => "\xE5\x9D\xAD",
		"\xCB\xF5" => "\xE5\x9D\xAB",
		"\xCB\xF6" => "\xE5\x9D\xB1",
		"\xCB\xF7" => "\xE5\x9D\xB0",
		"\xCB\xF8" => "\xE5\x9D\xB6",
		"\xCB\xF9" => "\xE5\x9E\x80",
		"\xCB\xFA" => "\xE5\x9D\xB5",
		"\xCB\xFB" => "\xE5\x9D\xBB",
		"\xCB\xFC" => "\xE5\x9D\xB3",
		"\xCB\xFD" => "\xE5\x9D\xB4",
		"\xCB\xFE" => "\xE5\x9D\xA2",
		"\xCC\x40" => "\xE5\x9D\xA8",
		"\xCC\x41" => "\xE5\x9D\xBD",
		"\xCC\x42" => "\xE5\xA4\x8C",
		"\xCC\x43" => "\xE5\xA5\x85",
		"\xCC\x44" => "\xE5\xA6\xB5",
		"\xCC\x45" => "\xE5\xA6\xBA",
		"\xCC\x46" => "\xE5\xA7\x8F",
		"\xCC\x47" => "\xE5\xA7\x8E",
		"\xCC\x48" => "\xE5\xA6\xB2",
		"\xCC\x49" => "\xE5\xA7\x8C",
		"\xCC\x4A" => "\xE5\xA7\x81",
		"\xCC\x4B" => "\xE5\xA6\xB6",
		"\xCC\x4C" => "\xE5\xA6\xBC",
		"\xCC\x4D" => "\xE5\xA7\x83",
		"\xCC\x4E" => "\xE5\xA7\x96",
		"\xCC\x4F" => "\xE5\xA6\xB1",
		"\xCC\x50" => "\xE5\xA6\xBD",
		"\xCC\x51" => "\xE5\xA7\x80",
		"\xCC\x52" => "\xE5\xA7\x88",
		"\xCC\x53" => "\xE5\xA6\xB4",
		"\xCC\x54" => "\xE5\xA7\x87",
		"\xCC\x55" => "\xE5\xAD\xA2",
		"\xCC\x56" => "\xE5\xAD\xA5",
		"\xCC\x57" => "\xE5\xAE\x93",
		"\xCC\x58" => "\xE5\xAE\x95",
		"\xCC\x59" => "\xE5\xB1\x84",
		"\xCC\x5A" => "\xE5\xB1\x87",
		"\xCC\x5B" => "\xE5\xB2\xAE",
		"\xCC\x5C" => "\xE5\xB2\xA4",
		"\xCC\x5D" => "\xE5\xB2\xA0",
		"\xCC\x5E" => "\xE5\xB2\xB5",
		"\xCC\x5F" => "\xE5\xB2\xAF",
		"\xCC\x60" => "\xE5\xB2\xA8",
		"\xCC\x61" => "\xE5\xB2\xAC",
		"\xCC\x62" => "\xE5\xB2\x9F",
		"\xCC\x63" => "\xE5\xB2\xA3",
		"\xCC\x64" => "\xE5\xB2\xAD",
		"\xCC\x65" => "\xE5\xB2\xA2",
		"\xCC\x66" => "\xE5\xB2\xAA",
		"\xCC\x67" => "\xE5\xB2\xA7",
		"\xCC\x68" => "\xE5\xB2\x9D",
		"\xCC\x69" => "\xE5\xB2\xA5",
		"\xCC\x6A" => "\xE5\xB2\xB6",
		"\xCC\x6B" => "\xE5\xB2\xB0",
		"\xCC\x6C" => "\xE5\xB2\xA6",
		"\xCC\x6D" => "\xE5\xB8\x97",
		"\xCC\x6E" => "\xE5\xB8\x94",
		"\xCC\x6F" => "\xE5\xB8\x99",
		"\xCC\x70" => "\xE5\xBC\xA8",
		"\xCC\x71" => "\xE5\xBC\xA2",
		"\xCC\x72" => "\xE5\xBC\xA3",
		"\xCC\x73" => "\xE5\xBC\xA4",
		"\xCC\x74" => "\xE5\xBD\x94",
		"\xCC\x75" => "\xE5\xBE\x82",
		"\xCC\x76" => "\xE5\xBD\xBE",
		"\xCC\x77" => "\xE5\xBD\xBD",
		"\xCC\x78" => "\xE5\xBF\x9E",
		"\xCC\x79" => "\xE5\xBF\xA5",
		"\xCC\x7A" => "\xE6\x80\xAD",
		"\xCC\x7B" => "\xE6\x80\xA6",
		"\xCC\x7C" => "\xE6\x80\x99",
		"\xCC\x7D" => "\xE6\x80\xB2",
		"\xCC\x7E" => "\xE6\x80\x8B",
		"\xCC\xA1" => "\xE6\x80\xB4",
		"\xCC\xA2" => "\xE6\x80\x8A",
		"\xCC\xA3" => "\xE6\x80\x97",
		"\xCC\xA4" => "\xE6\x80\xB3",
		"\xCC\xA5" => "\xE6\x80\x9A",
		"\xCC\xA6" => "\xE6\x80\x9E",
		"\xCC\xA7" => "\xE6\x80\xAC",
		"\xCC\xA8" => "\xE6\x80\xA2",
		"\xCC\xA9" => "\xE6\x80\x8D",
		"\xCC\xAA" => "\xE6\x80\x90",
		"\xCC\xAB" => "\xE6\x80\xAE",
		"\xCC\xAC" => "\xE6\x80\x93",
		"\xCC\xAD" => "\xE6\x80\x91",
		"\xCC\xAE" => "\xE6\x80\x8C",
		"\xCC\xAF" => "\xE6\x80\x89",
		"\xCC\xB0" => "\xE6\x80\x9C",
		"\xCC\xB1" => "\xE6\x88\x94",
		"\xCC\xB2" => "\xE6\x88\xBD",
		"\xCC\xB3" => "\xE6\x8A\xAD",
		"\xCC\xB4" => "\xE6\x8A\xB4",
		"\xCC\xB5" => "\xE6\x8B\x91",
		"\xCC\xB6" => "\xE6\x8A\xBE",
		"\xCC\xB7" => "\xE6\x8A\xAA",
		"\xCC\xB8" => "\xE6\x8A\xB6",
		"\xCC\xB9" => "\xE6\x8B\x8A",
		"\xCC\xBA" => "\xE6\x8A\xAE",
		"\xCC\xBB" => "\xE6\x8A\xB3",
		"\xCC\xBC" => "\xE6\x8A\xAF",
		"\xCC\xBD" => "\xE6\x8A\xBB",
		"\xCC\xBE" => "\xE6\x8A\xA9",
		"\xCC\xBF" => "\xE6\x8A\xB0",
		"\xCC\xC0" => "\xE6\x8A\xB8",
		"\xCC\xC1" => "\xE6\x94\xBD",
		"\xCC\xC2" => "\xE6\x96\xA8",
		"\xCC\xC3" => "\xE6\x96\xBB",
		"\xCC\xC4" => "\xE6\x98\x89",
		"\xCC\xC5" => "\xE6\x97\xBC",
		"\xCC\xC6" => "\xE6\x98\x84",
		"\xCC\xC7" => "\xE6\x98\x92",
		"\xCC\xC8" => "\xE6\x98\x88",
		"\xCC\xC9" => "\xE6\x97\xBB",
		"\xCC\xCA" => "\xE6\x98\x83",
		"\xCC\xCB" => "\xE6\x98\x8B",
		"\xCC\xCC" => "\xE6\x98\x8D",
		"\xCC\xCD" => "\xE6\x98\x85",
		"\xCC\xCE" => "\xE6\x97\xBD",
		"\xCC\xCF" => "\xE6\x98\x91",
		"\xCC\xD0" => "\xE6\x98\x90",
		"\xCC\xD1" => "\xE6\x9B\xB6",
		"\xCC\xD2" => "\xE6\x9C\x8A",
		"\xCC\xD3" => "\xE6\x9E\x85",
		"\xCC\xD4" => "\xE6\x9D\xAC",
		"\xCC\xD5" => "\xE6\x9E\x8E",
		"\xCC\xD6" => "\xE6\x9E\x92",
		"\xCC\xD7" => "\xE6\x9D\xB6",
		"\xCC\xD8" => "\xE6\x9D\xBB",
		"\xCC\xD9" => "\xE6\x9E\x98",
		"\xCC\xDA" => "\xE6\x9E\x86",
		"\xCC\xDB" => "\xE6\x9E\x84",
		"\xCC\xDC" => "\xE6\x9D\xB4",
		"\xCC\xDD" => "\xE6\x9E\x8D",
		"\xCC\xDE" => "\xE6\x9E\x8C",
		"\xCC\xDF" => "\xE6\x9D\xBA",
		"\xCC\xE0" => "\xE6\x9E\x9F",
		"\xCC\xE1" => "\xE6\x9E\x91",
		"\xCC\xE2" => "\xE6\x9E\x99",
		"\xCC\xE3" => "\xE6\x9E\x83",
		"\xCC\xE4" => "\xE6\x9D\xBD",
		"\xCC\xE5" => "\xE6\x9E\x81",
		"\xCC\xE6" => "\xE6\x9D\xB8",
		"\xCC\xE7" => "\xE6\x9D\xB9",
		"\xCC\xE8" => "\xE6\x9E\x94",
		"\xCC\xE9" => "\xE6\xAC\xA5",
		"\xCC\xEA" => "\xE6\xAE\x80",
		"\xCC\xEB" => "\xE6\xAD\xBE",
		"\xCC\xEC" => "\xE6\xAF\x9E",
		"\xCC\xED" => "\xE6\xB0\x9D",
		"\xCC\xEE" => "\xE6\xB2\x93",
		"\xCC\xEF" => "\xE6\xB3\xAC",
		"\xCC\xF0" => "\xE6\xB3\xAB",
		"\xCC\xF1" => "\xE6\xB3\xAE",
		"\xCC\xF2" => "\xE6\xB3\x99",
		"\xCC\xF3" => "\xE6\xB2\xB6",
		"\xCC\xF4" => "\xE6\xB3\x94",
		"\xCC\xF5" => "\xE6\xB2\xAD",
		"\xCC\xF6" => "\xE6\xB3\xA7",
		"\xCC\xF7" => "\xE6\xB2\xB7",
		"\xCC\xF8" => "\xE6\xB3\x90",
		"\xCC\xF9" => "\xE6\xB3\x82",
		"\xCC\xFA" => "\xE6\xB2\xBA",
		"\xCC\xFB" => "\xE6\xB3\x83",
		"\xCC\xFC" => "\xE6\xB3\x86",
		"\xCC\xFD" => "\xE6\xB3\xAD",
		"\xCC\xFE" => "\xE6\xB3\xB2",
		"\xCD\x40" => "\xE6\xB3\x92",
		"\xCD\x41" => "\xE6\xB3\x9D",
		"\xCD\x42" => "\xE6\xB2\xB4",
		"\xCD\x43" => "\xE6\xB2\x8A",
		"\xCD\x44" => "\xE6\xB2\x9D",
		"\xCD\x45" => "\xE6\xB2\x80",
		"\xCD\x46" => "\xE6\xB3\x9E",
		"\xCD\x47" => "\xE6\xB3\x80",
		"\xCD\x48" => "\xE6\xB4\xB0",
		"\xCD\x49" => "\xE6\xB3\x8D",
		"\xCD\x4A" => "\xE6\xB3\x87",
		"\xCD\x4B" => "\xE6\xB2\xB0",
		"\xCD\x4C" => "\xE6\xB3\xB9",
		"\xCD\x4D" => "\xE6\xB3\x8F",
		"\xCD\x4E" => "\xE6\xB3\xA9",
		"\xCD\x4F" => "\xE6\xB3\x91",
		"\xCD\x50" => "\xE7\x82\x94",
		"\xCD\x51" => "\xE7\x82\x98",
		"\xCD\x52" => "\xE7\x82\x85",
		"\xCD\x53" => "\xE7\x82\x93",
		"\xCD\x54" => "\xE7\x82\x86",
		"\xCD\x55" => "\xE7\x82\x84",
		"\xCD\x56" => "\xE7\x82\x91",
		"\xCD\x57" => "\xE7\x82\x96",
		"\xCD\x58" => "\xE7\x82\x82",
		"\xCD\x59" => "\xE7\x82\x9A",
		"\xCD\x5A" => "\xE7\x82\x83",
		"\xCD\x5B" => "\xE7\x89\xAA",
		"\xCD\x5C" => "\xE7\x8B\x96",
		"\xCD\x5D" => "\xE7\x8B\x8B",
		"\xCD\x5E" => "\xE7\x8B\x98",
		"\xCD\x5F" => "\xE7\x8B\x89",
		"\xCD\x60" => "\xE7\x8B\x9C",
		"\xCD\x61" => "\xE7\x8B\x92",
		"\xCD\x62" => "\xE7\x8B\x94",
		"\xCD\x63" => "\xE7\x8B\x9A",
		"\xCD\x64" => "\xE7\x8B\x8C",
		"\xCD\x65" => "\xE7\x8B\x91",
		"\xCD\x66" => "\xE7\x8E\xA4",
		"\xCD\x67" => "\xE7\x8E\xA1",
		"\xCD\x68" => "\xE7\x8E\xAD",
		"\xCD\x69" => "\xE7\x8E\xA6",
		"\xCD\x6A" => "\xE7\x8E\xA2",
		"\xCD\x6B" => "\xE7\x8E\xA0",
		"\xCD\x6C" => "\xE7\x8E\xAC",
		"\xCD\x6D" => "\xE7\x8E\x9D",
		"\xCD\x6E" => "\xE7\x93\x9D",
		"\xCD\x6F" => "\xE7\x93\xA8",
		"\xCD\x70" => "\xE7\x94\xBF",
		"\xCD\x71" => "\xE7\x95\x80",
		"\xCD\x72" => "\xE7\x94\xBE",
		"\xCD\x73" => "\xE7\x96\x8C",
		"\xCD\x74" => "\xE7\x96\x98",
		"\xCD\x75" => "\xE7\x9A\xAF",
		"\xCD\x76" => "\xE7\x9B\xB3",
		"\xCD\x77" => "\xE7\x9B\xB1",
		"\xCD\x78" => "\xE7\x9B\xB0",
		"\xCD\x79" => "\xE7\x9B\xB5",
		"\xCD\x7A" => "\xE7\x9F\xB8",
		"\xCD\x7B" => "\xE7\x9F\xBC",
		"\xCD\x7C" => "\xE7\x9F\xB9",
		"\xCD\x7D" => "\xE7\x9F\xBB",
		"\xCD\x7E" => "\xE7\x9F\xBA",
		"\xCD\xA1" => "\xE7\x9F\xB7",
		"\xCD\xA2" => "\xE7\xA5\x82",
		"\xCD\xA3" => "\xE7\xA4\xBF",
		"\xCD\xA4" => "\xE7\xA7\x85",
		"\xCD\xA5" => "\xE7\xA9\xB8",
		"\xCD\xA6" => "\xE7\xA9\xBB",
		"\xCD\xA7" => "\xE7\xAB\xBB",
		"\xCD\xA8" => "\xE7\xB1\xB5",
		"\xCD\xA9" => "\xE7\xB3\xBD",
		"\xCD\xAA" => "\xE8\x80\xB5",
		"\xCD\xAB" => "\xE8\x82\x8F",
		"\xCD\xAC" => "\xE8\x82\xAE",
		"\xCD\xAD" => "\xE8\x82\xA3",
		"\xCD\xAE" => "\xE8\x82\xB8",
		"\xCD\xAF" => "\xE8\x82\xB5",
		"\xCD\xB0" => "\xE8\x82\xAD",
		"\xCD\xB1" => "\xE8\x88\xA0",
		"\xCD\xB2" => "\xE8\x8A\xA0",
		"\xCD\xB3" => "\xE8\x8B\x80",
		"\xCD\xB4" => "\xE8\x8A\xAB",
		"\xCD\xB5" => "\xE8\x8A\x9A",
		"\xCD\xB6" => "\xE8\x8A\x98",
		"\xCD\xB7" => "\xE8\x8A\x9B",
		"\xCD\xB8" => "\xE8\x8A\xB5",
		"\xCD\xB9" => "\xE8\x8A\xA7",
		"\xCD\xBA" => "\xE8\x8A\xAE",
		"\xCD\xBB" => "\xE8\x8A\xBC",
		"\xCD\xBC" => "\xE8\x8A\x9E",
		"\xCD\xBD" => "\xE8\x8A\xBA",
		"\xCD\xBE" => "\xE8\x8A\xB4",
		"\xCD\xBF" => "\xE8\x8A\xA8",
		"\xCD\xC0" => "\xE8\x8A\xA1",
		"\xCD\xC1" => "\xE8\x8A\xA9",
		"\xCD\xC2" => "\xE8\x8B\x82",
		"\xCD\xC3" => "\xE8\x8A\xA4",
		"\xCD\xC4" => "\xE8\x8B\x83",
		"\xCD\xC5" => "\xE8\x8A\xB6",
		"\xCD\xC6" => "\xE8\x8A\xA2",
		"\xCD\xC7" => "\xE8\x99\xB0",
		"\xCD\xC8" => "\xE8\x99\xAF",
		"\xCD\xC9" => "\xE8\x99\xAD",
		"\xCD\xCA" => "\xE8\x99\xAE",
		"\xCD\xCB" => "\xE8\xB1\x96",
		"\xCD\xCC" => "\xE8\xBF\x92",
		"\xCD\xCD" => "\xE8\xBF\x8B",
		"\xCD\xCE" => "\xE8\xBF\x93",
		"\xCD\xCF" => "\xE8\xBF\x8D",
		"\xCD\xD0" => "\xE8\xBF\x96",
		"\xCD\xD1" => "\xE8\xBF\x95",
		"\xCD\xD2" => "\xE8\xBF\x97",
		"\xCD\xD3" => "\xE9\x82\xB2",
		"\xCD\xD4" => "\xE9\x82\xB4",
		"\xCD\xD5" => "\xE9\x82\xAF",
		"\xCD\xD6" => "\xE9\x82\xB3",
		"\xCD\xD7" => "\xE9\x82\xB0",
		"\xCD\xD8" => "\xE9\x98\xB9",
		"\xCD\xD9" => "\xE9\x98\xBD",
		"\xCD\xDA" => "\xE9\x98\xBC",
		"\xCD\xDB" => "\xE9\x98\xBA",
		"\xCD\xDC" => "\xE9\x99\x83",
		"\xCD\xDD" => "\xE4\xBF\x8D",
		"\xCD\xDE" => "\xE4\xBF\x85",
		"\xCD\xDF" => "\xE4\xBF\x93",
		"\xCD\xE0" => "\xE4\xBE\xB2",
		"\xCD\xE1" => "\xE4\xBF\x89",
		"\xCD\xE2" => "\xE4\xBF\x8B",
		"\xCD\xE3" => "\xE4\xBF\x81",
		"\xCD\xE4" => "\xE4\xBF\x94",
		"\xCD\xE5" => "\xE4\xBF\x9C",
		"\xCD\xE6" => "\xE4\xBF\x99",
		"\xCD\xE7" => "\xE4\xBE\xBB",
		"\xCD\xE8" => "\xE4\xBE\xB3",
		"\xCD\xE9" => "\xE4\xBF\x9B",
		"\xCD\xEA" => "\xE4\xBF\x87",
		"\xCD\xEB" => "\xE4\xBF\x96",
		"\xCD\xEC" => "\xE4\xBE\xBA",
		"\xCD\xED" => "\xE4\xBF\x80",
		"\xCD\xEE" => "\xE4\xBE\xB9",
		"\xCD\xEF" => "\xE4\xBF\xAC",
		"\xCD\xF0" => "\xE5\x89\x84",
		"\xCD\xF1" => "\xE5\x89\x89",
		"\xCD\xF2" => "\xE5\x8B\x80",
		"\xCD\xF3" => "\xE5\x8B\x82",
		"\xCD\xF4" => "\xE5\x8C\xBD",
		"\xCD\xF5" => "\xE5\x8D\xBC",
		"\xCD\xF6" => "\xE5\x8E\x97",
		"\xCD\xF7" => "\xE5\x8E\x96",
		"\xCD\xF8" => "\xE5\x8E\x99",
		"\xCD\xF9" => "\xE5\x8E\x98",
		"\xCD\xFA" => "\xE5\x92\xBA",
		"\xCD\xFB" => "\xE5\x92\xA1",
		"\xCD\xFC" => "\xE5\x92\xAD",
		"\xCD\xFD" => "\xE5\x92\xA5",
		"\xCD\xFE" => "\xE5\x93\x8F",
		"\xCE\x40" => "\xE5\x93\x83",
		"\xCE\x41" => "\xE8\x8C\x8D",
		"\xCE\x42" => "\xE5\x92\xB7",
		"\xCE\x43" => "\xE5\x92\xAE",
		"\xCE\x44" => "\xE5\x93\x96",
		"\xCE\x45" => "\xE5\x92\xB6",
		"\xCE\x46" => "\xE5\x93\x85",
		"\xCE\x47" => "\xE5\x93\x86",
		"\xCE\x48" => "\xE5\x92\xA0",
		"\xCE\x49" => "\xE5\x91\xB0",
		"\xCE\x4A" => "\xE5\x92\xBC",
		"\xCE\x4B" => "\xE5\x92\xA2",
		"\xCE\x4C" => "\xE5\x92\xBE",
		"\xCE\x4D" => "\xE5\x91\xB2",
		"\xCE\x4E" => "\xE5\x93\x9E",
		"\xCE\x4F" => "\xE5\x92\xB0",
		"\xCE\x50" => "\xE5\x9E\xB5",
		"\xCE\x51" => "\xE5\x9E\x9E",
		"\xCE\x52" => "\xE5\x9E\x9F",
		"\xCE\x53" => "\xE5\x9E\xA4",
		"\xCE\x54" => "\xE5\x9E\x8C",
		"\xCE\x55" => "\xE5\x9E\x97",
		"\xCE\x56" => "\xE5\x9E\x9D",
		"\xCE\x57" => "\xE5\x9E\x9B",
		"\xCE\x58" => "\xE5\x9E\x94",
		"\xCE\x59" => "\xE5\x9E\x98",
		"\xCE\x5A" => "\xE5\x9E\x8F",
		"\xCE\x5B" => "\xE5\x9E\x99",
		"\xCE\x5C" => "\xE5\x9E\xA5",
		"\xCE\x5D" => "\xE5\x9E\x9A",
		"\xCE\x5E" => "\xE5\x9E\x95",
		"\xCE\x5F" => "\xE5\xA3\xB4",
		"\xCE\x60" => "\xE5\xA4\x8D",
		"\xCE\x61" => "\xE5\xA5\x93",
		"\xCE\x62" => "\xE5\xA7\xA1",
		"\xCE\x63" => "\xE5\xA7\x9E",
		"\xCE\x64" => "\xE5\xA7\xAE",
		"\xCE\x65" => "\xE5\xA8\x80",
		"\xCE\x66" => "\xE5\xA7\xB1",
		"\xCE\x67" => "\xE5\xA7\x9D",
		"\xCE\x68" => "\xE5\xA7\xBA",
		"\xCE\x69" => "\xE5\xA7\xBD",
		"\xCE\x6A" => "\xE5\xA7\xBC",
		"\xCE\x6B" => "\xE5\xA7\xB6",
		"\xCE\x6C" => "\xE5\xA7\xA4",
		"\xCE\x6D" => "\xE5\xA7\xB2",
		"\xCE\x6E" => "\xE5\xA7\xB7",
		"\xCE\x6F" => "\xE5\xA7\x9B",
		"\xCE\x70" => "\xE5\xA7\xA9",
		"\xCE\x71" => "\xE5\xA7\xB3",
		"\xCE\x72" => "\xE5\xA7\xB5",
		"\xCE\x73" => "\xE5\xA7\xA0",
		"\xCE\x74" => "\xE5\xA7\xBE",
		"\xCE\x75" => "\xE5\xA7\xB4",
		"\xCE\x76" => "\xE5\xA7\xAD",
		"\xCE\x77" => "\xE5\xAE\xA8",
		"\xCE\x78" => "\xE5\xB1\x8C",
		"\xCE\x79" => "\xE5\xB3\x90",
		"\xCE\x7A" => "\xE5\xB3\x98",
		"\xCE\x7B" => "\xE5\xB3\x8C",
		"\xCE\x7C" => "\xE5\xB3\x97",
		"\xCE\x7D" => "\xE5\xB3\x8B",
		"\xCE\x7E" => "\xE5\xB3\x9B",
		"\xCE\xA1" => "\xE5\xB3\x9E",
		"\xCE\xA2" => "\xE5\xB3\x9A",
		"\xCE\xA3" => "\xE5\xB3\x89",
		"\xCE\xA4" => "\xE5\xB3\x87",
		"\xCE\xA5" => "\xE5\xB3\x8A",
		"\xCE\xA6" => "\xE5\xB3\x96",
		"\xCE\xA7" => "\xE5\xB3\x93",
		"\xCE\xA8" => "\xE5\xB3\x94",
		"\xCE\xA9" => "\xE5\xB3\x8F",
		"\xCE\xAA" => "\xE5\xB3\x88",
		"\xCE\xAB" => "\xE5\xB3\x86",
		"\xCE\xAC" => "\xE5\xB3\x8E",
		"\xCE\xAD" => "\xE5\xB3\x9F",
		"\xCE\xAE" => "\xE5\xB3\xB8",
		"\xCE\xAF" => "\xE5\xB7\xB9",
		"\xCE\xB0" => "\xE5\xB8\xA1",
		"\xCE\xB1" => "\xE5\xB8\xA2",
		"\xCE\xB2" => "\xE5\xB8\xA3",
		"\xCE\xB3" => "\xE5\xB8\xA0",
		"\xCE\xB4" => "\xE5\xB8\xA4",
		"\xCE\xB5" => "\xE5\xBA\xB0",
		"\xCE\xB6" => "\xE5\xBA\xA4",
		"\xCE\xB7" => "\xE5\xBA\xA2",
		"\xCE\xB8" => "\xE5\xBA\x9B",
		"\xCE\xB9" => "\xE5\xBA\xA3",
		"\xCE\xBA" => "\xE5\xBA\xA5",
		"\xCE\xBB" => "\xE5\xBC\x87",
		"\xCE\xBC" => "\xE5\xBC\xAE",
		"\xCE\xBD" => "\xE5\xBD\x96",
		"\xCE\xBE" => "\xE5\xBE\x86",
		"\xCE\xBF" => "\xE6\x80\xB7",
		"\xCE\xC0" => "\xE6\x80\xB9",
		"\xCE\xC1" => "\xE6\x81\x94",
		"\xCE\xC2" => "\xE6\x81\xB2",
		"\xCE\xC3" => "\xE6\x81\x9E",
		"\xCE\xC4" => "\xE6\x81\x85",
		"\xCE\xC5" => "\xE6\x81\x93",
		"\xCE\xC6" => "\xE6\x81\x87",
		"\xCE\xC7" => "\xE6\x81\x89",
		"\xCE\xC8" => "\xE6\x81\x9B",
		"\xCE\xC9" => "\xE6\x81\x8C",
		"\xCE\xCA" => "\xE6\x81\x80",
		"\xCE\xCB" => "\xE6\x81\x82",
		"\xCE\xCC" => "\xE6\x81\x9F",
		"\xCE\xCD" => "\xE6\x80\xA4",
		"\xCE\xCE" => "\xE6\x81\x84",
		"\xCE\xCF" => "\xE6\x81\x98",
		"\xCE\xD0" => "\xE6\x81\xA6",
		"\xCE\xD1" => "\xE6\x81\xAE",
		"\xCE\xD2" => "\xE6\x89\x82",
		"\xCE\xD3" => "\xE6\x89\x83",
		"\xCE\xD4" => "\xE6\x8B\x8F",
		"\xCE\xD5" => "\xE6\x8C\x8D",
		"\xCE\xD6" => "\xE6\x8C\x8B",
		"\xCE\xD7" => "\xE6\x8B\xB5",
		"\xCE\xD8" => "\xE6\x8C\x8E",
		"\xCE\xD9" => "\xE6\x8C\x83",
		"\xCE\xDA" => "\xE6\x8B\xAB",
		"\xCE\xDB" => "\xE6\x8B\xB9",
		"\xCE\xDC" => "\xE6\x8C\x8F",
		"\xCE\xDD" => "\xE6\x8C\x8C",
		"\xCE\xDE" => "\xE6\x8B\xB8",
		"\xCE\xDF" => "\xE6\x8B\xB6",
		"\xCE\xE0" => "\xE6\x8C\x80",
		"\xCE\xE1" => "\xE6\x8C\x93",
		"\xCE\xE2" => "\xE6\x8C\x94",
		"\xCE\xE3" => "\xE6\x8B\xBA",
		"\xCE\xE4" => "\xE6\x8C\x95",
		"\xCE\xE5" => "\xE6\x8B\xBB",
		"\xCE\xE6" => "\xE6\x8B\xB0",
		"\xCE\xE7" => "\xE6\x95\x81",
		"\xCE\xE8" => "\xE6\x95\x83",
		"\xCE\xE9" => "\xE6\x96\xAA",
		"\xCE\xEA" => "\xE6\x96\xBF",
		"\xCE\xEB" => "\xE6\x98\xB6",
		"\xCE\xEC" => "\xE6\x98\xA1",
		"\xCE\xED" => "\xE6\x98\xB2",
		"\xCE\xEE" => "\xE6\x98\xB5",
		"\xCE\xEF" => "\xE6\x98\x9C",
		"\xCE\xF0" => "\xE6\x98\xA6",
		"\xCE\xF1" => "\xE6\x98\xA2",
		"\xCE\xF2" => "\xE6\x98\xB3",
		"\xCE\xF3" => "\xE6\x98\xAB",
		"\xCE\xF4" => "\xE6\x98\xBA",
		"\xCE\xF5" => "\xE6\x98\x9D",
		"\xCE\xF6" => "\xE6\x98\xB4",
		"\xCE\xF7" => "\xE6\x98\xB9",
		"\xCE\xF8" => "\xE6\x98\xAE",
		"\xCE\xF9" => "\xE6\x9C\x8F",
		"\xCE\xFA" => "\xE6\x9C\x90",
		"\xCE\xFB" => "\xE6\x9F\x81",
		"\xCE\xFC" => "\xE6\x9F\xB2",
		"\xCE\xFD" => "\xE6\x9F\x88",
		"\xCE\xFE" => "\xE6\x9E\xBA",
		"\xCF\x40" => "\xE6\x9F\x9C",
		"\xCF\x41" => "\xE6\x9E\xBB",
		"\xCF\x42" => "\xE6\x9F\xB8",
		"\xCF\x43" => "\xE6\x9F\x98",
		"\xCF\x44" => "\xE6\x9F\x80",
		"\xCF\x45" => "\xE6\x9E\xB7",
		"\xCF\x46" => "\xE6\x9F\x85",
		"\xCF\x47" => "\xE6\x9F\xAB",
		"\xCF\x48" => "\xE6\x9F\xA4",
		"\xCF\x49" => "\xE6\x9F\x9F",
		"\xCF\x4A" => "\xE6\x9E\xB5",
		"\xCF\x4B" => "\xE6\x9F\x8D",
		"\xCF\x4C" => "\xE6\x9E\xB3",
		"\xCF\x4D" => "\xE6\x9F\xB7",
		"\xCF\x4E" => "\xE6\x9F\xB6",
		"\xCF\x4F" => "\xE6\x9F\xAE",
		"\xCF\x50" => "\xE6\x9F\xA3",
		"\xCF\x51" => "\xE6\x9F\x82",
		"\xCF\x52" => "\xE6\x9E\xB9",
		"\xCF\x53" => "\xE6\x9F\x8E",
		"\xCF\x54" => "\xE6\x9F\xA7",
		"\xCF\x55" => "\xE6\x9F\xB0",
		"\xCF\x56" => "\xE6\x9E\xB2",
		"\xCF\x57" => "\xE6\x9F\xBC",
		"\xCF\x58" => "\xE6\x9F\x86",
		"\xCF\x59" => "\xE6\x9F\xAD",
		"\xCF\x5A" => "\xE6\x9F\x8C",
		"\xCF\x5B" => "\xE6\x9E\xAE",
		"\xCF\x5C" => "\xE6\x9F\xA6",
		"\xCF\x5D" => "\xE6\x9F\x9B",
		"\xCF\x5E" => "\xE6\x9F\xBA",
		"\xCF\x5F" => "\xE6\x9F\x89",
		"\xCF\x60" => "\xE6\x9F\x8A",
		"\xCF\x61" => "\xE6\x9F\x83",
		"\xCF\x62" => "\xE6\x9F\xAA",
		"\xCF\x63" => "\xE6\x9F\x8B",
		"\xCF\x64" => "\xE6\xAC\xA8",
		"\xCF\x65" => "\xE6\xAE\x82",
		"\xCF\x66" => "\xE6\xAE\x84",
		"\xCF\x67" => "\xE6\xAE\xB6",
		"\xCF\x68" => "\xE6\xAF\x96",
		"\xCF\x69" => "\xE6\xAF\x98",
		"\xCF\x6A" => "\xE6\xAF\xA0",
		"\xCF\x6B" => "\xE6\xB0\xA0",
		"\xCF\x6C" => "\xE6\xB0\xA1",
		"\xCF\x6D" => "\xE6\xB4\xA8",
		"\xCF\x6E" => "\xE6\xB4\xB4",
		"\xCF\x6F" => "\xE6\xB4\xAD",
		"\xCF\x70" => "\xE6\xB4\x9F",
		"\xCF\x71" => "\xE6\xB4\xBC",
		"\xCF\x72" => "\xE6\xB4\xBF",
		"\xCF\x73" => "\xE6\xB4\x92",
		"\xCF\x74" => "\xE6\xB4\x8A",
		"\xCF\x75" => "\xE6\xB3\x9A",
		"\xCF\x76" => "\xE6\xB4\xB3",
		"\xCF\x77" => "\xE6\xB4\x84",
		"\xCF\x78" => "\xE6\xB4\x99",
		"\xCF\x79" => "\xE6\xB4\xBA",
		"\xCF\x7A" => "\xE6\xB4\x9A",
		"\xCF\x7B" => "\xE6\xB4\x91",
		"\xCF\x7C" => "\xE6\xB4\x80",
		"\xCF\x7D" => "\xE6\xB4\x9D",
		"\xCF\x7E" => "\xE6\xB5\x82",
		"\xCF\xA1" => "\xE6\xB4\x81",
		"\xCF\xA2" => "\xE6\xB4\x98",
		"\xCF\xA3" => "\xE6\xB4\xB7",
		"\xCF\xA4" => "\xE6\xB4\x83",
		"\xCF\xA5" => "\xE6\xB4\x8F",
		"\xCF\xA6" => "\xE6\xB5\x80",
		"\xCF\xA7" => "\xE6\xB4\x87",
		"\xCF\xA8" => "\xE6\xB4\xA0",
		"\xCF\xA9" => "\xE6\xB4\xAC",
		"\xCF\xAA" => "\xE6\xB4\x88",
		"\xCF\xAB" => "\xE6\xB4\xA2",
		"\xCF\xAC" => "\xE6\xB4\x89",
		"\xCF\xAD" => "\xE6\xB4\x90",
		"\xCF\xAE" => "\xE7\x82\xB7",
		"\xCF\xAF" => "\xE7\x82\x9F",
		"\xCF\xB0" => "\xE7\x82\xBE",
		"\xCF\xB1" => "\xE7\x82\xB1",
		"\xCF\xB2" => "\xE7\x82\xB0",
		"\xCF\xB3" => "\xE7\x82\xA1",
		"\xCF\xB4" => "\xE7\x82\xB4",
		"\xCF\xB5" => "\xE7\x82\xB5",
		"\xCF\xB6" => "\xE7\x82\xA9",
		"\xCF\xB7" => "\xE7\x89\x81",
		"\xCF\xB8" => "\xE7\x89\x89",
		"\xCF\xB9" => "\xE7\x89\x8A",
		"\xCF\xBA" => "\xE7\x89\xAC",
		"\xCF\xBB" => "\xE7\x89\xB0",
		"\xCF\xBC" => "\xE7\x89\xB3",
		"\xCF\xBD" => "\xE7\x89\xAE",
		"\xCF\xBE" => "\xE7\x8B\x8A",
		"\xCF\xBF" => "\xE7\x8B\xA4",
		"\xCF\xC0" => "\xE7\x8B\xA8",
		"\xCF\xC1" => "\xE7\x8B\xAB",
		"\xCF\xC2" => "\xE7\x8B\x9F",
		"\xCF\xC3" => "\xE7\x8B\xAA",
		"\xCF\xC4" => "\xE7\x8B\xA6",
		"\xCF\xC5" => "\xE7\x8B\xA3",
		"\xCF\xC6" => "\xE7\x8E\x85",
		"\xCF\xC7" => "\xE7\x8F\x8C",
		"\xCF\xC8" => "\xE7\x8F\x82",
		"\xCF\xC9" => "\xE7\x8F\x88",
		"\xCF\xCA" => "\xE7\x8F\x85",
		"\xCF\xCB" => "\xE7\x8E\xB9",
		"\xCF\xCC" => "\xE7\x8E\xB6",
		"\xCF\xCD" => "\xE7\x8E\xB5",
		"\xCF\xCE" => "\xE7\x8E\xB4",
		"\xCF\xCF" => "\xE7\x8F\xAB",
		"\xCF\xD0" => "\xE7\x8E\xBF",
		"\xCF\xD1" => "\xE7\x8F\x87",
		"\xCF\xD2" => "\xE7\x8E\xBE",
		"\xCF\xD3" => "\xE7\x8F\x83",
		"\xCF\xD4" => "\xE7\x8F\x86",
		"\xCF\xD5" => "\xE7\x8E\xB8",
		"\xCF\xD6" => "\xE7\x8F\x8B",
		"\xCF\xD7" => "\xE7\x93\xAC",
		"\xCF\xD8" => "\xE7\x93\xAE",
		"\xCF\xD9" => "\xE7\x94\xAE",
		"\xCF\xDA" => "\xE7\x95\x87",
		"\xCF\xDB" => "\xE7\x95\x88",
		"\xCF\xDC" => "\xE7\x96\xA7",
		"\xCF\xDD" => "\xE7\x96\xAA",
		"\xCF\xDE" => "\xE7\x99\xB9",
		"\xCF\xDF" => "\xE7\x9B\x84",
		"\xCF\xE0" => "\xE7\x9C\x88",
		"\xCF\xE1" => "\xE7\x9C\x83",
		"\xCF\xE2" => "\xE7\x9C\x84",
		"\xCF\xE3" => "\xE7\x9C\x85",
		"\xCF\xE4" => "\xE7\x9C\x8A",
		"\xCF\xE5" => "\xE7\x9B\xB7",
		"\xCF\xE6" => "\xE7\x9B\xBB",
		"\xCF\xE7" => "\xE7\x9B\xBA",
		"\xCF\xE8" => "\xE7\x9F\xA7",
		"\xCF\xE9" => "\xE7\x9F\xA8",
		"\xCF\xEA" => "\xE7\xA0\x86",
		"\xCF\xEB" => "\xE7\xA0\x91",
		"\xCF\xEC" => "\xE7\xA0\x92",
		"\xCF\xED" => "\xE7\xA0\x85",
		"\xCF\xEE" => "\xE7\xA0\x90",
		"\xCF\xEF" => "\xE7\xA0\x8F",
		"\xCF\xF0" => "\xE7\xA0\x8E",
		"\xCF\xF1" => "\xE7\xA0\x89",
		"\xCF\xF2" => "\xE7\xA0\x83",
		"\xCF\xF3" => "\xE7\xA0\x93",
		"\xCF\xF4" => "\xE7\xA5\x8A",
		"\xCF\xF5" => "\xE7\xA5\x8C",
		"\xCF\xF6" => "\xE7\xA5\x8B",
		"\xCF\xF7" => "\xE7\xA5\x85",
		"\xCF\xF8" => "\xE7\xA5\x84",
		"\xCF\xF9" => "\xE7\xA7\x95",
		"\xCF\xFA" => "\xE7\xA7\x8D",
		"\xCF\xFB" => "\xE7\xA7\x8F",
		"\xCF\xFC" => "\xE7\xA7\x96",
		"\xCF\xFD" => "\xE7\xA7\x8E",
		"\xCF\xFE" => "\xE7\xAA\x80",
		"\xD0\x40" => "\xE7\xA9\xBE",
		"\xD0\x41" => "\xE7\xAB\x91",
		"\xD0\x42" => "\xE7\xAC\x80",
		"\xD0\x43" => "\xE7\xAC\x81",
		"\xD0\x44" => "\xE7\xB1\xBA",
		"\xD0\x45" => "\xE7\xB1\xB8",
		"\xD0\x46" => "\xE7\xB1\xB9",
		"\xD0\x47" => "\xE7\xB1\xBF",
		"\xD0\x48" => "\xE7\xB2\x80",
		"\xD0\x49" => "\xE7\xB2\x81",
		"\xD0\x4A" => "\xE7\xB4\x83",
		"\xD0\x4B" => "\xE7\xB4\x88",
		"\xD0\x4C" => "\xE7\xB4\x81",
		"\xD0\x4D" => "\xE7\xBD\x98",
		"\xD0\x4E" => "\xE7\xBE\x91",
		"\xD0\x4F" => "\xE7\xBE\x8D",
		"\xD0\x50" => "\xE7\xBE\xBE",
		"\xD0\x51" => "\xE8\x80\x87",
		"\xD0\x52" => "\xE8\x80\x8E",
		"\xD0\x53" => "\xE8\x80\x8F",
		"\xD0\x54" => "\xE8\x80\x94",
		"\xD0\x55" => "\xE8\x80\xB7",
		"\xD0\x56" => "\xE8\x83\x98",
		"\xD0\x57" => "\xE8\x83\x87",
		"\xD0\x58" => "\xE8\x83\xA0",
		"\xD0\x59" => "\xE8\x83\x91",
		"\xD0\x5A" => "\xE8\x83\x88",
		"\xD0\x5B" => "\xE8\x83\x82",
		"\xD0\x5C" => "\xE8\x83\x90",
		"\xD0\x5D" => "\xE8\x83\x85",
		"\xD0\x5E" => "\xE8\x83\xA3",
		"\xD0\x5F" => "\xE8\x83\x99",
		"\xD0\x60" => "\xE8\x83\x9C",
		"\xD0\x61" => "\xE8\x83\x8A",
		"\xD0\x62" => "\xE8\x83\x95",
		"\xD0\x63" => "\xE8\x83\x89",
		"\xD0\x64" => "\xE8\x83\x8F",
		"\xD0\x65" => "\xE8\x83\x97",
		"\xD0\x66" => "\xE8\x83\xA6",
		"\xD0\x67" => "\xE8\x83\x8D",
		"\xD0\x68" => "\xE8\x87\xBF",
		"\xD0\x69" => "\xE8\x88\xA1",
		"\xD0\x6A" => "\xE8\x8A\x94",
		"\xD0\x6B" => "\xE8\x8B\x99",
		"\xD0\x6C" => "\xE8\x8B\xBE",
		"\xD0\x6D" => "\xE8\x8B\xB9",
		"\xD0\x6E" => "\xE8\x8C\x87",
		"\xD0\x6F" => "\xE8\x8B\xA8",
		"\xD0\x70" => "\xE8\x8C\x80",
		"\xD0\x71" => "\xE8\x8B\x95",
		"\xD0\x72" => "\xE8\x8C\xBA",
		"\xD0\x73" => "\xE8\x8B\xAB",
		"\xD0\x74" => "\xE8\x8B\x96",
		"\xD0\x75" => "\xE8\x8B\xB4",
		"\xD0\x76" => "\xE8\x8B\xAC",
		"\xD0\x77" => "\xE8\x8B\xA1",
		"\xD0\x78" => "\xE8\x8B\xB2",
		"\xD0\x79" => "\xE8\x8B\xB5",
		"\xD0\x7A" => "\xE8\x8C\x8C",
		"\xD0\x7B" => "\xE8\x8B\xBB",
		"\xD0\x7C" => "\xE8\x8B\xB6",
		"\xD0\x7D" => "\xE8\x8B\xB0",
		"\xD0\x7E" => "\xE8\x8B\xAA",
		"\xD0\xA1" => "\xE8\x8B\xA4",
		"\xD0\xA2" => "\xE8\x8B\xA0",
		"\xD0\xA3" => "\xE8\x8B\xBA",
		"\xD0\xA4" => "\xE8\x8B\xB3",
		"\xD0\xA5" => "\xE8\x8B\xAD",
		"\xD0\xA6" => "\xE8\x99\xB7",
		"\xD0\xA7" => "\xE8\x99\xB4",
		"\xD0\xA8" => "\xE8\x99\xBC",
		"\xD0\xA9" => "\xE8\x99\xB3",
		"\xD0\xAA" => "\xE8\xA1\x81",
		"\xD0\xAB" => "\xE8\xA1\x8E",
		"\xD0\xAC" => "\xE8\xA1\xA7",
		"\xD0\xAD" => "\xE8\xA1\xAA",
		"\xD0\xAE" => "\xE8\xA1\xA9",
		"\xD0\xAF" => "\xE8\xA7\x93",
		"\xD0\xB0" => "\xE8\xA8\x84",
		"\xD0\xB1" => "\xE8\xA8\x87",
		"\xD0\xB2" => "\xE8\xB5\xB2",
		"\xD0\xB3" => "\xE8\xBF\xA3",
		"\xD0\xB4" => "\xE8\xBF\xA1",
		"\xD0\xB5" => "\xE8\xBF\xAE",
		"\xD0\xB6" => "\xE8\xBF\xA0",
		"\xD0\xB7" => "\xE9\x83\xB1",
		"\xD0\xB8" => "\xE9\x82\xBD",
		"\xD0\xB9" => "\xE9\x82\xBF",
		"\xD0\xBA" => "\xE9\x83\x95",
		"\xD0\xBB" => "\xE9\x83\x85",
		"\xD0\xBC" => "\xE9\x82\xBE",
		"\xD0\xBD" => "\xE9\x83\x87",
		"\xD0\xBE" => "\xE9\x83\x8B",
		"\xD0\xBF" => "\xE9\x83\x88",
		"\xD0\xC0" => "\xE9\x87\x94",
		"\xD0\xC1" => "\xE9\x87\x93",
		"\xD0\xC2" => "\xE9\x99\x94",
		"\xD0\xC3" => "\xE9\x99\x8F",
		"\xD0\xC4" => "\xE9\x99\x91",
		"\xD0\xC5" => "\xE9\x99\x93",
		"\xD0\xC6" => "\xE9\x99\x8A",
		"\xD0\xC7" => "\xE9\x99\x8E",
		"\xD0\xC8" => "\xE5\x80\x9E",
		"\xD0\xC9" => "\xE5\x80\x85",
		"\xD0\xCA" => "\xE5\x80\x87",
		"\xD0\xCB" => "\xE5\x80\x93",
		"\xD0\xCC" => "\xE5\x80\xA2",
		"\xD0\xCD" => "\xE5\x80\xB0",
		"\xD0\xCE" => "\xE5\x80\x9B",
		"\xD0\xCF" => "\xE4\xBF\xB5",
		"\xD0\xD0" => "\xE4\xBF\xB4",
		"\xD0\xD1" => "\xE5\x80\xB3",
		"\xD0\xD2" => "\xE5\x80\xB7",
		"\xD0\xD3" => "\xE5\x80\xAC",
		"\xD0\xD4" => "\xE4\xBF\xB6",
		"\xD0\xD5" => "\xE4\xBF\xB7",
		"\xD0\xD6" => "\xE5\x80\x97",
		"\xD0\xD7" => "\xE5\x80\x9C",
		"\xD0\xD8" => "\xE5\x80\xA0",
		"\xD0\xD9" => "\xE5\x80\xA7",
		"\xD0\xDA" => "\xE5\x80\xB5",
		"\xD0\xDB" => "\xE5\x80\xAF",
		"\xD0\xDC" => "\xE5\x80\xB1",
		"\xD0\xDD" => "\xE5\x80\x8E",
		"\xD0\xDE" => "\xE5\x85\x9A",
		"\xD0\xDF" => "\xE5\x86\x94",
		"\xD0\xE0" => "\xE5\x86\x93",
		"\xD0\xE1" => "\xE5\x87\x8A",
		"\xD0\xE2" => "\xE5\x87\x84",
		"\xD0\xE3" => "\xE5\x87\x85",
		"\xD0\xE4" => "\xE5\x87\x88",
		"\xD0\xE5" => "\xE5\x87\x8E",
		"\xD0\xE6" => "\xE5\x89\xA1",
		"\xD0\xE7" => "\xE5\x89\x9A",
		"\xD0\xE8" => "\xE5\x89\x92",
		"\xD0\xE9" => "\xE5\x89\x9E",
		"\xD0\xEA" => "\xE5\x89\x9F",
		"\xD0\xEB" => "\xE5\x89\x95",
		"\xD0\xEC" => "\xE5\x89\xA2",
		"\xD0\xED" => "\xE5\x8B\x8D",
		"\xD0\xEE" => "\xE5\x8C\x8E",
		"\xD0\xEF" => "\xE5\x8E\x9E",
		"\xD0\xF0" => "\xE5\x94\xA6",
		"\xD0\xF1" => "\xE5\x93\xA2",
		"\xD0\xF2" => "\xE5\x94\x97",
		"\xD0\xF3" => "\xE5\x94\x92",
		"\xD0\xF4" => "\xE5\x93\xA7",
		"\xD0\xF5" => "\xE5\x93\xB3",
		"\xD0\xF6" => "\xE5\x93\xA4",
		"\xD0\xF7" => "\xE5\x94\x9A",
		"\xD0\xF8" => "\xE5\x93\xBF",
		"\xD0\xF9" => "\xE5\x94\x84",
		"\xD0\xFA" => "\xE5\x94\x88",
		"\xD0\xFB" => "\xE5\x93\xAB",
		"\xD0\xFC" => "\xE5\x94\x91",
		"\xD0\xFD" => "\xE5\x94\x85",
		"\xD0\xFE" => "\xE5\x93\xB1",
		"\xD1\x40" => "\xE5\x94\x8A",
		"\xD1\x41" => "\xE5\x93\xBB",
		"\xD1\x42" => "\xE5\x93\xB7",
		"\xD1\x43" => "\xE5\x93\xB8",
		"\xD1\x44" => "\xE5\x93\xA0",
		"\xD1\x45" => "\xE5\x94\x8E",
		"\xD1\x46" => "\xE5\x94\x83",
		"\xD1\x47" => "\xE5\x94\x8B",
		"\xD1\x48" => "\xE5\x9C\x81",
		"\xD1\x49" => "\xE5\x9C\x82",
		"\xD1\x4A" => "\xE5\x9F\x8C",
		"\xD1\x4B" => "\xE5\xA0\xB2",
		"\xD1\x4C" => "\xE5\x9F\x95",
		"\xD1\x4D" => "\xE5\x9F\x92",
		"\xD1\x4E" => "\xE5\x9E\xBA",
		"\xD1\x4F" => "\xE5\x9F\x86",
		"\xD1\x50" => "\xE5\x9E\xBD",
		"\xD1\x51" => "\xE5\x9E\xBC",
		"\xD1\x52" => "\xE5\x9E\xB8",
		"\xD1\x53" => "\xE5\x9E\xB6",
		"\xD1\x54" => "\xE5\x9E\xBF",
		"\xD1\x55" => "\xE5\x9F\x87",
		"\xD1\x56" => "\xE5\x9F\x90",
		"\xD1\x57" => "\xE5\x9E\xB9",
		"\xD1\x58" => "\xE5\x9F\x81",
		"\xD1\x59" => "\xE5\xA4\x8E",
		"\xD1\x5A" => "\xE5\xA5\x8A",
		"\xD1\x5B" => "\xE5\xA8\x99",
		"\xD1\x5C" => "\xE5\xA8\x96",
		"\xD1\x5D" => "\xE5\xA8\xAD",
		"\xD1\x5E" => "\xE5\xA8\xAE",
		"\xD1\x5F" => "\xE5\xA8\x95",
		"\xD1\x60" => "\xE5\xA8\x8F",
		"\xD1\x61" => "\xE5\xA8\x97",
		"\xD1\x62" => "\xE5\xA8\x8A",
		"\xD1\x63" => "\xE5\xA8\x9E",
		"\xD1\x64" => "\xE5\xA8\xB3",
		"\xD1\x65" => "\xE5\xAD\xAC",
		"\xD1\x66" => "\xE5\xAE\xA7",
		"\xD1\x67" => "\xE5\xAE\xAD",
		"\xD1\x68" => "\xE5\xAE\xAC",
		"\xD1\x69" => "\xE5\xB0\x83",
		"\xD1\x6A" => "\xE5\xB1\x96",
		"\xD1\x6B" => "\xE5\xB1\x94",
		"\xD1\x6C" => "\xE5\xB3\xAC",
		"\xD1\x6D" => "\xE5\xB3\xBF",
		"\xD1\x6E" => "\xE5\xB3\xAE",
		"\xD1\x6F" => "\xE5\xB3\xB1",
		"\xD1\x70" => "\xE5\xB3\xB7",
		"\xD1\x71" => "\xE5\xB4\x80",
		"\xD1\x72" => "\xE5\xB3\xB9",
		"\xD1\x73" => "\xE5\xB8\xA9",
		"\xD1\x74" => "\xE5\xB8\xA8",
		"\xD1\x75" => "\xE5\xBA\xA8",
		"\xD1\x76" => "\xE5\xBA\xAE",
		"\xD1\x77" => "\xE5\xBA\xAA",
		"\xD1\x78" => "\xE5\xBA\xAC",
		"\xD1\x79" => "\xE5\xBC\xB3",
		"\xD1\x7A" => "\xE5\xBC\xB0",
		"\xD1\x7B" => "\xE5\xBD\xA7",
		"\xD1\x7C" => "\xE6\x81\x9D",
		"\xD1\x7D" => "\xE6\x81\x9A",
		"\xD1\x7E" => "\xE6\x81\xA7",
		"\xD1\xA1" => "\xE6\x81\x81",
		"\xD1\xA2" => "\xE6\x82\xA2",
		"\xD1\xA3" => "\xE6\x82\x88",
		"\xD1\xA4" => "\xE6\x82\x80",
		"\xD1\xA5" => "\xE6\x82\x92",
		"\xD1\xA6" => "\xE6\x82\x81",
		"\xD1\xA7" => "\xE6\x82\x9D",
		"\xD1\xA8" => "\xE6\x82\x83",
		"\xD1\xA9" => "\xE6\x82\x95",
		"\xD1\xAA" => "\xE6\x82\x9B",
		"\xD1\xAB" => "\xE6\x82\x97",
		"\xD1\xAC" => "\xE6\x82\x87",
		"\xD1\xAD" => "\xE6\x82\x9C",
		"\xD1\xAE" => "\xE6\x82\x8E",
		"\xD1\xAF" => "\xE6\x88\x99",
		"\xD1\xB0" => "\xE6\x89\x86",
		"\xD1\xB1" => "\xE6\x8B\xB2",
		"\xD1\xB2" => "\xE6\x8C\x90",
		"\xD1\xB3" => "\xE6\x8D\x96",
		"\xD1\xB4" => "\xE6\x8C\xAC",
		"\xD1\xB5" => "\xE6\x8D\x84",
		"\xD1\xB6" => "\xE6\x8D\x85",
		"\xD1\xB7" => "\xE6\x8C\xB6",
		"\xD1\xB8" => "\xE6\x8D\x83",
		"\xD1\xB9" => "\xE6\x8F\xA4",
		"\xD1\xBA" => "\xE6\x8C\xB9",
		"\xD1\xBB" => "\xE6\x8D\x8B",
		"\xD1\xBC" => "\xE6\x8D\x8A",
		"\xD1\xBD" => "\xE6\x8C\xBC",
		"\xD1\xBE" => "\xE6\x8C\xA9",
		"\xD1\xBF" => "\xE6\x8D\x81",
		"\xD1\xC0" => "\xE6\x8C\xB4",
		"\xD1\xC1" => "\xE6\x8D\x98",
		"\xD1\xC2" => "\xE6\x8D\x94",
		"\xD1\xC3" => "\xE6\x8D\x99",
		"\xD1\xC4" => "\xE6\x8C\xAD",
		"\xD1\xC5" => "\xE6\x8D\x87",
		"\xD1\xC6" => "\xE6\x8C\xB3",
		"\xD1\xC7" => "\xE6\x8D\x9A",
		"\xD1\xC8" => "\xE6\x8D\x91",
		"\xD1\xC9" => "\xE6\x8C\xB8",
		"\xD1\xCA" => "\xE6\x8D\x97",
		"\xD1\xCB" => "\xE6\x8D\x80",
		"\xD1\xCC" => "\xE6\x8D\x88",
		"\xD1\xCD" => "\xE6\x95\x8A",
		"\xD1\xCE" => "\xE6\x95\x86",
		"\xD1\xCF" => "\xE6\x97\x86",
		"\xD1\xD0" => "\xE6\x97\x83",
		"\xD1\xD1" => "\xE6\x97\x84",
		"\xD1\xD2" => "\xE6\x97\x82",
		"\xD1\xD3" => "\xE6\x99\x8A",
		"\xD1\xD4" => "\xE6\x99\x9F",
		"\xD1\xD5" => "\xE6\x99\x87",
		"\xD1\xD6" => "\xE6\x99\x91",
		"\xD1\xD7" => "\xE6\x9C\x92",
		"\xD1\xD8" => "\xE6\x9C\x93",
		"\xD1\xD9" => "\xE6\xA0\x9F",
		"\xD1\xDA" => "\xE6\xA0\x9A",
		"\xD1\xDB" => "\xE6\xA1\x89",
		"\xD1\xDC" => "\xE6\xA0\xB2",
		"\xD1\xDD" => "\xE6\xA0\xB3",
		"\xD1\xDE" => "\xE6\xA0\xBB",
		"\xD1\xDF" => "\xE6\xA1\x8B",
		"\xD1\xE0" => "\xE6\xA1\x8F",
		"\xD1\xE1" => "\xE6\xA0\x96",
		"\xD1\xE2" => "\xE6\xA0\xB1",
		"\xD1\xE3" => "\xE6\xA0\x9C",
		"\xD1\xE4" => "\xE6\xA0\xB5",
		"\xD1\xE5" => "\xE6\xA0\xAB",
		"\xD1\xE6" => "\xE6\xA0\xAD",
		"\xD1\xE7" => "\xE6\xA0\xAF",
		"\xD1\xE8" => "\xE6\xA1\x8E",
		"\xD1\xE9" => "\xE6\xA1\x84",
		"\xD1\xEA" => "\xE6\xA0\xB4",
		"\xD1\xEB" => "\xE6\xA0\x9D",
		"\xD1\xEC" => "\xE6\xA0\x92",
		"\xD1\xED" => "\xE6\xA0\x94",
		"\xD1\xEE" => "\xE6\xA0\xA6",
		"\xD1\xEF" => "\xE6\xA0\xA8",
		"\xD1\xF0" => "\xE6\xA0\xAE",
		"\xD1\xF1" => "\xE6\xA1\x8D",
		"\xD1\xF2" => "\xE6\xA0\xBA",
		"\xD1\xF3" => "\xE6\xA0\xA5",
		"\xD1\xF4" => "\xE6\xA0\xA0",
		"\xD1\xF5" => "\xE6\xAC\xAC",
		"\xD1\xF6" => "\xE6\xAC\xAF",
		"\xD1\xF7" => "\xE6\xAC\xAD",
		"\xD1\xF8" => "\xE6\xAC\xB1",
		"\xD1\xF9" => "\xE6\xAC\xB4",
		"\xD1\xFA" => "\xE6\xAD\xAD",
		"\xD1\xFB" => "\xE8\x82\x82",
		"\xD1\xFC" => "\xE6\xAE\x88",
		"\xD1\xFD" => "\xE6\xAF\xA6",
		"\xD1\xFE" => "\xE6\xAF\xA4",
		"\xD2\x40" => "\xE6\xAF\xA8",
		"\xD2\x41" => "\xE6\xAF\xA3",
		"\xD2\x42" => "\xE6\xAF\xA2",
		"\xD2\x43" => "\xE6\xAF\xA7",
		"\xD2\x44" => "\xE6\xB0\xA5",
		"\xD2\x45" => "\xE6\xB5\xBA",
		"\xD2\x46" => "\xE6\xB5\xA3",
		"\xD2\x47" => "\xE6\xB5\xA4",
		"\xD2\x48" => "\xE6\xB5\xB6",
		"\xD2\x49" => "\xE6\xB4\x8D",
		"\xD2\x4A" => "\xE6\xB5\xA1",
		"\xD2\x4B" => "\xE6\xB6\x92",
		"\xD2\x4C" => "\xE6\xB5\x98",
		"\xD2\x4D" => "\xE6\xB5\xA2",
		"\xD2\x4E" => "\xE6\xB5\xAD",
		"\xD2\x4F" => "\xE6\xB5\xAF",
		"\xD2\x50" => "\xE6\xB6\x91",
		"\xD2\x51" => "\xE6\xB6\x8D",
		"\xD2\x52" => "\xE6\xB7\xAF",
		"\xD2\x53" => "\xE6\xB5\xBF",
		"\xD2\x54" => "\xE6\xB6\x86",
		"\xD2\x55" => "\xE6\xB5\x9E",
		"\xD2\x56" => "\xE6\xB5\xA7",
		"\xD2\x57" => "\xE6\xB5\xA0",
		"\xD2\x58" => "\xE6\xB6\x97",
		"\xD2\x59" => "\xE6\xB5\xB0",
		"\xD2\x5A" => "\xE6\xB5\xBC",
		"\xD2\x5B" => "\xE6\xB5\x9F",
		"\xD2\x5C" => "\xE6\xB6\x82",
		"\xD2\x5D" => "\xE6\xB6\x98",
		"\xD2\x5E" => "\xE6\xB4\xAF",
		"\xD2\x5F" => "\xE6\xB5\xA8",
		"\xD2\x60" => "\xE6\xB6\x8B",
		"\xD2\x61" => "\xE6\xB5\xBE",
		"\xD2\x62" => "\xE6\xB6\x80",
		"\xD2\x63" => "\xE6\xB6\x84",
		"\xD2\x64" => "\xE6\xB4\x96",
		"\xD2\x65" => "\xE6\xB6\x83",
		"\xD2\x66" => "\xE6\xB5\xBB",
		"\xD2\x67" => "\xE6\xB5\xBD",
		"\xD2\x68" => "\xE6\xB5\xB5",
		"\xD2\x69" => "\xE6\xB6\x90",
		"\xD2\x6A" => "\xE7\x83\x9C",
		"\xD2\x6B" => "\xE7\x83\x93",
		"\xD2\x6C" => "\xE7\x83\x91",
		"\xD2\x6D" => "\xE7\x83\x9D",
		"\xD2\x6E" => "\xE7\x83\x8B",
		"\xD2\x6F" => "\xE7\xBC\xB9",
		"\xD2\x70" => "\xE7\x83\xA2",
		"\xD2\x71" => "\xE7\x83\x97",
		"\xD2\x72" => "\xE7\x83\x92",
		"\xD2\x73" => "\xE7\x83\x9E",
		"\xD2\x74" => "\xE7\x83\xA0",
		"\xD2\x75" => "\xE7\x83\x94",
		"\xD2\x76" => "\xE7\x83\x8D",
		"\xD2\x77" => "\xE7\x83\x85",
		"\xD2\x78" => "\xE7\x83\x86",
		"\xD2\x79" => "\xE7\x83\x87",
		"\xD2\x7A" => "\xE7\x83\x9A",
		"\xD2\x7B" => "\xE7\x83\x8E",
		"\xD2\x7C" => "\xE7\x83\xA1",
		"\xD2\x7D" => "\xE7\x89\x82",
		"\xD2\x7E" => "\xE7\x89\xB8",
		"\xD2\xA1" => "\xE7\x89\xB7",
		"\xD2\xA2" => "\xE7\x89\xB6",
		"\xD2\xA3" => "\xE7\x8C\x80",
		"\xD2\xA4" => "\xE7\x8B\xBA",
		"\xD2\xA5" => "\xE7\x8B\xB4",
		"\xD2\xA6" => "\xE7\x8B\xBE",
		"\xD2\xA7" => "\xE7\x8B\xB6",
		"\xD2\xA8" => "\xE7\x8B\xB3",
		"\xD2\xA9" => "\xE7\x8B\xBB",
		"\xD2\xAA" => "\xE7\x8C\x81",
		"\xD2\xAB" => "\xE7\x8F\x93",
		"\xD2\xAC" => "\xE7\x8F\x99",
		"\xD2\xAD" => "\xE7\x8F\xA5",
		"\xD2\xAE" => "\xE7\x8F\x96",
		"\xD2\xAF" => "\xE7\x8E\xBC",
		"\xD2\xB0" => "\xE7\x8F\xA7",
		"\xD2\xB1" => "\xE7\x8F\xA3",
		"\xD2\xB2" => "\xE7\x8F\xA9",
		"\xD2\xB3" => "\xE7\x8F\x9C",
		"\xD2\xB4" => "\xE7\x8F\x92",
		"\xD2\xB5" => "\xE7\x8F\x9B",
		"\xD2\xB6" => "\xE7\x8F\x94",
		"\xD2\xB7" => "\xE7\x8F\x9D",
		"\xD2\xB8" => "\xE7\x8F\x9A",
		"\xD2\xB9" => "\xE7\x8F\x97",
		"\xD2\xBA" => "\xE7\x8F\x98",
		"\xD2\xBB" => "\xE7\x8F\xA8",
		"\xD2\xBC" => "\xE7\x93\x9E",
		"\xD2\xBD" => "\xE7\x93\x9F",
		"\xD2\xBE" => "\xE7\x93\xB4",
		"\xD2\xBF" => "\xE7\x93\xB5",
		"\xD2\xC0" => "\xE7\x94\xA1",
		"\xD2\xC1" => "\xE7\x95\x9B",
		"\xD2\xC2" => "\xE7\x95\x9F",
		"\xD2\xC3" => "\xE7\x96\xB0",
		"\xD2\xC4" => "\xE7\x97\x81",
		"\xD2\xC5" => "\xE7\x96\xBB",
		"\xD2\xC6" => "\xE7\x97\x84",
		"\xD2\xC7" => "\xE7\x97\x80",
		"\xD2\xC8" => "\xE7\x96\xBF",
		"\xD2\xC9" => "\xE7\x96\xB6",
		"\xD2\xCA" => "\xE7\x96\xBA",
		"\xD2\xCB" => "\xE7\x9A\x8A",
		"\xD2\xCC" => "\xE7\x9B\x89",
		"\xD2\xCD" => "\xE7\x9C\x9D",
		"\xD2\xCE" => "\xE7\x9C\x9B",
		"\xD2\xCF" => "\xE7\x9C\x90",
		"\xD2\xD0" => "\xE7\x9C\x93",
		"\xD2\xD1" => "\xE7\x9C\x92",
		"\xD2\xD2" => "\xE7\x9C\xA3",
		"\xD2\xD3" => "\xE7\x9C\x91",
		"\xD2\xD4" => "\xE7\x9C\x95",
		"\xD2\xD5" => "\xE7\x9C\x99",
		"\xD2\xD6" => "\xE7\x9C\x9A",
		"\xD2\xD7" => "\xE7\x9C\xA2",
		"\xD2\xD8" => "\xE7\x9C\xA7",
		"\xD2\xD9" => "\xE7\xA0\xA3",
		"\xD2\xDA" => "\xE7\xA0\xAC",
		"\xD2\xDB" => "\xE7\xA0\xA2",
		"\xD2\xDC" => "\xE7\xA0\xB5",
		"\xD2\xDD" => "\xE7\xA0\xAF",
		"\xD2\xDE" => "\xE7\xA0\xA8",
		"\xD2\xDF" => "\xE7\xA0\xAE",
		"\xD2\xE0" => "\xE7\xA0\xAB",
		"\xD2\xE1" => "\xE7\xA0\xA1",
		"\xD2\xE2" => "\xE7\xA0\xA9",
		"\xD2\xE3" => "\xE7\xA0\xB3",
		"\xD2\xE4" => "\xE7\xA0\xAA",
		"\xD2\xE5" => "\xE7\xA0\xB1",
		"\xD2\xE6" => "\xE7\xA5\x94",
		"\xD2\xE7" => "\xE7\xA5\x9B",
		"\xD2\xE8" => "\xE7\xA5\x8F",
		"\xD2\xE9" => "\xE7\xA5\x9C",
		"\xD2\xEA" => "\xE7\xA5\x93",
		"\xD2\xEB" => "\xE7\xA5\x92",
		"\xD2\xEC" => "\xE7\xA5\x91",
		"\xD2\xED" => "\xE7\xA7\xAB",
		"\xD2\xEE" => "\xE7\xA7\xAC",
		"\xD2\xEF" => "\xE7\xA7\xA0",
		"\xD2\xF0" => "\xE7\xA7\xAE",
		"\xD2\xF1" => "\xE7\xA7\xAD",
		"\xD2\xF2" => "\xE7\xA7\xAA",
		"\xD2\xF3" => "\xE7\xA7\x9C",
		"\xD2\xF4" => "\xE7\xA7\x9E",
		"\xD2\xF5" => "\xE7\xA7\x9D",
		"\xD2\xF6" => "\xE7\xAA\x86",
		"\xD2\xF7" => "\xE7\xAA\x89",
		"\xD2\xF8" => "\xE7\xAA\x85",
		"\xD2\xF9" => "\xE7\xAA\x8B",
		"\xD2\xFA" => "\xE7\xAA\x8C",
		"\xD2\xFB" => "\xE7\xAA\x8A",
		"\xD2\xFC" => "\xE7\xAA\x87",
		"\xD2\xFD" => "\xE7\xAB\x98",
		"\xD2\xFE" => "\xE7\xAC\x90",
		"\xD3\x40" => "\xE7\xAC\x84",
		"\xD3\x41" => "\xE7\xAC\x93",
		"\xD3\x42" => "\xE7\xAC\x85",
		"\xD3\x43" => "\xE7\xAC\x8F",
		"\xD3\x44" => "\xE7\xAC\x88",
		"\xD3\x45" => "\xE7\xAC\x8A",
		"\xD3\x46" => "\xE7\xAC\x8E",
		"\xD3\x47" => "\xE7\xAC\x89",
		"\xD3\x48" => "\xE7\xAC\x92",
		"\xD3\x49" => "\xE7\xB2\x84",
		"\xD3\x4A" => "\xE7\xB2\x91",
		"\xD3\x4B" => "\xE7\xB2\x8A",
		"\xD3\x4C" => "\xE7\xB2\x8C",
		"\xD3\x4D" => "\xE7\xB2\x88",
		"\xD3\x4E" => "\xE7\xB2\x8D",
		"\xD3\x4F" => "\xE7\xB2\x85",
		"\xD3\x50" => "\xE7\xB4\x9E",
		"\xD3\x51" => "\xE7\xB4\x9D",
		"\xD3\x52" => "\xE7\xB4\x91",
		"\xD3\x53" => "\xE7\xB4\x8E",
		"\xD3\x54" => "\xE7\xB4\x98",
		"\xD3\x55" => "\xE7\xB4\x96",
		"\xD3\x56" => "\xE7\xB4\x93",
		"\xD3\x57" => "\xE7\xB4\x9F",
		"\xD3\x58" => "\xE7\xB4\x92",
		"\xD3\x59" => "\xE7\xB4\x8F",
		"\xD3\x5A" => "\xE7\xB4\x8C",
		"\xD3\x5B" => "\xE7\xBD\x9C",
		"\xD3\x5C" => "\xE7\xBD\xA1",
		"\xD3\x5D" => "\xE7\xBD\x9E",
		"\xD3\x5E" => "\xE7\xBD\xA0",
		"\xD3\x5F" => "\xE7\xBD\x9D",
		"\xD3\x60" => "\xE7\xBD\x9B",
		"\xD3\x61" => "\xE7\xBE\x96",
		"\xD3\x62" => "\xE7\xBE\x92",
		"\xD3\x63" => "\xE7\xBF\x83",
		"\xD3\x64" => "\xE7\xBF\x82",
		"\xD3\x65" => "\xE7\xBF\x80",
		"\xD3\x66" => "\xE8\x80\x96",
		"\xD3\x67" => "\xE8\x80\xBE",
		"\xD3\x68" => "\xE8\x80\xB9",
		"\xD3\x69" => "\xE8\x83\xBA",
		"\xD3\x6A" => "\xE8\x83\xB2",
		"\xD3\x6B" => "\xE8\x83\xB9",
		"\xD3\x6C" => "\xE8\x83\xB5",
		"\xD3\x6D" => "\xE8\x84\x81",
		"\xD3\x6E" => "\xE8\x83\xBB",
		"\xD3\x6F" => "\xE8\x84\x80",
		"\xD3\x70" => "\xE8\x88\x81",
		"\xD3\x71" => "\xE8\x88\xAF",
		"\xD3\x72" => "\xE8\x88\xA5",
		"\xD3\x73" => "\xE8\x8C\xB3",
		"\xD3\x74" => "\xE8\x8C\xAD",
		"\xD3\x75" => "\xE8\x8D\x84",
		"\xD3\x76" => "\xE8\x8C\x99",
		"\xD3\x77" => "\xE8\x8D\x91",
		"\xD3\x78" => "\xE8\x8C\xA5",
		"\xD3\x79" => "\xE8\x8D\x96",
		"\xD3\x7A" => "\xE8\x8C\xBF",
		"\xD3\x7B" => "\xE8\x8D\x81",
		"\xD3\x7C" => "\xE8\x8C\xA6",
		"\xD3\x7D" => "\xE8\x8C\x9C",
		"\xD3\x7E" => "\xE8\x8C\xA2",
		"\xD3\xA1" => "\xE8\x8D\x82",
		"\xD3\xA2" => "\xE8\x8D\x8E",
		"\xD3\xA3" => "\xE8\x8C\x9B",
		"\xD3\xA4" => "\xE8\x8C\xAA",
		"\xD3\xA5" => "\xE8\x8C\x88",
		"\xD3\xA6" => "\xE8\x8C\xBC",
		"\xD3\xA7" => "\xE8\x8D\x8D",
		"\xD3\xA8" => "\xE8\x8C\x96",
		"\xD3\xA9" => "\xE8\x8C\xA4",
		"\xD3\xAA" => "\xE8\x8C\xA0",
		"\xD3\xAB" => "\xE8\x8C\xB7",
		"\xD3\xAC" => "\xE8\x8C\xAF",
		"\xD3\xAD" => "\xE8\x8C\xA9",
		"\xD3\xAE" => "\xE8\x8D\x87",
		"\xD3\xAF" => "\xE8\x8D\x85",
		"\xD3\xB0" => "\xE8\x8D\x8C",
		"\xD3\xB1" => "\xE8\x8D\x93",
		"\xD3\xB2" => "\xE8\x8C\x9E",
		"\xD3\xB3" => "\xE8\x8C\xAC",
		"\xD3\xB4" => "\xE8\x8D\x8B",
		"\xD3\xB5" => "\xE8\x8C\xA7",
		"\xD3\xB6" => "\xE8\x8D\x88",
		"\xD3\xB7" => "\xE8\x99\x93",
		"\xD3\xB8" => "\xE8\x99\x92",
		"\xD3\xB9" => "\xE8\x9A\xA2",
		"\xD3\xBA" => "\xE8\x9A\xA8",
		"\xD3\xBB" => "\xE8\x9A\x96",
		"\xD3\xBC" => "\xE8\x9A\x8D",
		"\xD3\xBD" => "\xE8\x9A\x91",
		"\xD3\xBE" => "\xE8\x9A\x9E",
		"\xD3\xBF" => "\xE8\x9A\x87",
		"\xD3\xC0" => "\xE8\x9A\x97",
		"\xD3\xC1" => "\xE8\x9A\x86",
		"\xD3\xC2" => "\xE8\x9A\x8B",
		"\xD3\xC3" => "\xE8\x9A\x9A",
		"\xD3\xC4" => "\xE8\x9A\x85",
		"\xD3\xC5" => "\xE8\x9A\xA5",
		"\xD3\xC6" => "\xE8\x9A\x99",
		"\xD3\xC7" => "\xE8\x9A\xA1",
		"\xD3\xC8" => "\xE8\x9A\xA7",
		"\xD3\xC9" => "\xE8\x9A\x95",
		"\xD3\xCA" => "\xE8\x9A\x98",
		"\xD3\xCB" => "\xE8\x9A\x8E",
		"\xD3\xCC" => "\xE8\x9A\x9D",
		"\xD3\xCD" => "\xE8\x9A\x90",
		"\xD3\xCE" => "\xE8\x9A\x94",
		"\xD3\xCF" => "\xE8\xA1\x83",
		"\xD3\xD0" => "\xE8\xA1\x84",
		"\xD3\xD1" => "\xE8\xA1\xAD",
		"\xD3\xD2" => "\xE8\xA1\xB5",
		"\xD3\xD3" => "\xE8\xA1\xB6",
		"\xD3\xD4" => "\xE8\xA1\xB2",
		"\xD3\xD5" => "\xE8\xA2\x80",
		"\xD3\xD6" => "\xE8\xA1\xB1",
		"\xD3\xD7" => "\xE8\xA1\xBF",
		"\xD3\xD8" => "\xE8\xA1\xAF",
		"\xD3\xD9" => "\xE8\xA2\x83",
		"\xD3\xDA" => "\xE8\xA1\xBE",
		"\xD3\xDB" => "\xE8\xA1\xB4",
		"\xD3\xDC" => "\xE8\xA1\xBC",
		"\xD3\xDD" => "\xE8\xA8\x92",
		"\xD3\xDE" => "\xE8\xB1\x87",
		"\xD3\xDF" => "\xE8\xB1\x97",
		"\xD3\xE0" => "\xE8\xB1\xBB",
		"\xD3\xE1" => "\xE8\xB2\xA4",
		"\xD3\xE2" => "\xE8\xB2\xA3",
		"\xD3\xE3" => "\xE8\xB5\xB6",
		"\xD3\xE4" => "\xE8\xB5\xB8",
		"\xD3\xE5" => "\xE8\xB6\xB5",
		"\xD3\xE6" => "\xE8\xB6\xB7",
		"\xD3\xE7" => "\xE8\xB6\xB6",
		"\xD3\xE8" => "\xE8\xBB\x91",
		"\xD3\xE9" => "\xE8\xBB\x93",
		"\xD3\xEA" => "\xE8\xBF\xBE",
		"\xD3\xEB" => "\xE8\xBF\xB5",
		"\xD3\xEC" => "\xE9\x80\x82",
		"\xD3\xED" => "\xE8\xBF\xBF",
		"\xD3\xEE" => "\xE8\xBF\xBB",
		"\xD3\xEF" => "\xE9\x80\x84",
		"\xD3\xF0" => "\xE8\xBF\xBC",
		"\xD3\xF1" => "\xE8\xBF\xB6",
		"\xD3\xF2" => "\xE9\x83\x96",
		"\xD3\xF3" => "\xE9\x83\xA0",
		"\xD3\xF4" => "\xE9\x83\x99",
		"\xD3\xF5" => "\xE9\x83\x9A",
		"\xD3\xF6" => "\xE9\x83\xA3",
		"\xD3\xF7" => "\xE9\x83\x9F",
		"\xD3\xF8" => "\xE9\x83\xA5",
		"\xD3\xF9" => "\xE9\x83\x98",
		"\xD3\xFA" => "\xE9\x83\x9B",
		"\xD3\xFB" => "\xE9\x83\x97",
		"\xD3\xFC" => "\xE9\x83\x9C",
		"\xD3\xFD" => "\xE9\x83\xA4",
		"\xD3\xFE" => "\xE9\x85\x90",
		"\xD4\x40" => "\xE9\x85\x8E",
		"\xD4\x41" => "\xE9\x85\x8F",
		"\xD4\x42" => "\xE9\x87\x95",
		"\xD4\x43" => "\xE9\x87\xA2",
		"\xD4\x44" => "\xE9\x87\x9A",
		"\xD4\x45" => "\xE9\x99\x9C",
		"\xD4\x46" => "\xE9\x99\x9F",
		"\xD4\x47" => "\xE9\x9A\xBC",
		"\xD4\x48" => "\xE9\xA3\xA3",
		"\xD4\x49" => "\xE9\xAB\x9F",
		"\xD4\x4A" => "\xE9\xAC\xAF",
		"\xD4\x4B" => "\xE4\xB9\xBF",
		"\xD4\x4C" => "\xE5\x81\xB0",
		"\xD4\x4D" => "\xE5\x81\xAA",
		"\xD4\x4E" => "\xE5\x81\xA1",
		"\xD4\x4F" => "\xE5\x81\x9E",
		"\xD4\x50" => "\xE5\x81\xA0",
		"\xD4\x51" => "\xE5\x81\x93",
		"\xD4\x52" => "\xE5\x81\x8B",
		"\xD4\x53" => "\xE5\x81\x9D",
		"\xD4\x54" => "\xE5\x81\xB2",
		"\xD4\x55" => "\xE5\x81\x88",
		"\xD4\x56" => "\xE5\x81\x8D",
		"\xD4\x57" => "\xE5\x81\x81",
		"\xD4\x58" => "\xE5\x81\x9B",
		"\xD4\x59" => "\xE5\x81\x8A",
		"\xD4\x5A" => "\xE5\x81\xA2",
		"\xD4\x5B" => "\xE5\x80\x95",
		"\xD4\x5C" => "\xE5\x81\x85",
		"\xD4\x5D" => "\xE5\x81\x9F",
		"\xD4\x5E" => "\xE5\x81\xA9",
		"\xD4\x5F" => "\xE5\x81\xAB",
		"\xD4\x60" => "\xE5\x81\xA3",
		"\xD4\x61" => "\xE5\x81\xA4",
		"\xD4\x62" => "\xE5\x81\x86",
		"\xD4\x63" => "\xE5\x81\x80",
		"\xD4\x64" => "\xE5\x81\xAE",
		"\xD4\x65" => "\xE5\x81\xB3",
		"\xD4\x66" => "\xE5\x81\x97",
		"\xD4\x67" => "\xE5\x81\x91",
		"\xD4\x68" => "\xE5\x87\x90",
		"\xD4\x69" => "\xE5\x89\xAB",
		"\xD4\x6A" => "\xE5\x89\xAD",
		"\xD4\x6B" => "\xE5\x89\xAC",
		"\xD4\x6C" => "\xE5\x89\xAE",
		"\xD4\x6D" => "\xE5\x8B\x96",
		"\xD4\x6E" => "\xE5\x8B\x93",
		"\xD4\x6F" => "\xE5\x8C\xAD",
		"\xD4\x70" => "\xE5\x8E\x9C",
		"\xD4\x71" => "\xE5\x95\xB5",
		"\xD4\x72" => "\xE5\x95\xB6",
		"\xD4\x73" => "\xE5\x94\xBC",
		"\xD4\x74" => "\xE5\x95\x8D",
		"\xD4\x75" => "\xE5\x95\x90",
		"\xD4\x76" => "\xE5\x94\xB4",
		"\xD4\x77" => "\xE5\x94\xAA",
		"\xD4\x78" => "\xE5\x95\x91",
		"\xD4\x79" => "\xE5\x95\xA2",
		"\xD4\x7A" => "\xE5\x94\xB6",
		"\xD4\x7B" => "\xE5\x94\xB5",
		"\xD4\x7C" => "\xE5\x94\xB0",
		"\xD4\x7D" => "\xE5\x95\x92",
		"\xD4\x7E" => "\xE5\x95\x85",
		"\xD4\xA1" => "\xE5\x94\x8C",
		"\xD4\xA2" => "\xE5\x94\xB2",
		"\xD4\xA3" => "\xE5\x95\xA5",
		"\xD4\xA4" => "\xE5\x95\x8E",
		"\xD4\xA5" => "\xE5\x94\xB9",
		"\xD4\xA6" => "\xE5\x95\x88",
		"\xD4\xA7" => "\xE5\x94\xAD",
		"\xD4\xA8" => "\xE5\x94\xBB",
		"\xD4\xA9" => "\xE5\x95\x80",
		"\xD4\xAA" => "\xE5\x95\x8B",
		"\xD4\xAB" => "\xE5\x9C\x8A",
		"\xD4\xAC" => "\xE5\x9C\x87",
		"\xD4\xAD" => "\xE5\x9F\xBB",
		"\xD4\xAE" => "\xE5\xA0\x94",
		"\xD4\xAF" => "\xE5\x9F\xA2",
		"\xD4\xB0" => "\xE5\x9F\xB6",
		"\xD4\xB1" => "\xE5\x9F\x9C",
		"\xD4\xB2" => "\xE5\x9F\xB4",
		"\xD4\xB3" => "\xE5\xA0\x80",
		"\xD4\xB4" => "\xE5\x9F\xAD",
		"\xD4\xB5" => "\xE5\x9F\xBD",
		"\xD4\xB6" => "\xE5\xA0\x88",
		"\xD4\xB7" => "\xE5\x9F\xB8",
		"\xD4\xB8" => "\xE5\xA0\x8B",
		"\xD4\xB9" => "\xE5\x9F\xB3",
		"\xD4\xBA" => "\xE5\x9F\x8F",
		"\xD4\xBB" => "\xE5\xA0\x87",
		"\xD4\xBC" => "\xE5\x9F\xAE",
		"\xD4\xBD" => "\xE5\x9F\xA3",
		"\xD4\xBE" => "\xE5\x9F\xB2",
		"\xD4\xBF" => "\xE5\x9F\xA5",
		"\xD4\xC0" => "\xE5\x9F\xAC",
		"\xD4\xC1" => "\xE5\x9F\xA1",
		"\xD4\xC2" => "\xE5\xA0\x8E",
		"\xD4\xC3" => "\xE5\x9F\xBC",
		"\xD4\xC4" => "\xE5\xA0\x90",
		"\xD4\xC5" => "\xE5\x9F\xA7",
		"\xD4\xC6" => "\xE5\xA0\x81",
		"\xD4\xC7" => "\xE5\xA0\x8C",
		"\xD4\xC8" => "\xE5\x9F\xB1",
		"\xD4\xC9" => "\xE5\x9F\xA9",
		"\xD4\xCA" => "\xE5\x9F\xB0",
		"\xD4\xCB" => "\xE5\xA0\x8D",
		"\xD4\xCC" => "\xE5\xA0\x84",
		"\xD4\xCD" => "\xE5\xA5\x9C",
		"\xD4\xCE" => "\xE5\xA9\xA0",
		"\xD4\xCF" => "\xE5\xA9\x98",
		"\xD4\xD0" => "\xE5\xA9\x95",
		"\xD4\xD1" => "\xE5\xA9\xA7",
		"\xD4\xD2" => "\xE5\xA9\x9E",
		"\xD4\xD3" => "\xE5\xA8\xB8",
		"\xD4\xD4" => "\xE5\xA8\xB5",
		"\xD4\xD5" => "\xE5\xA9\xAD",
		"\xD4\xD6" => "\xE5\xA9\x90",
		"\xD4\xD7" => "\xE5\xA9\x9F",
		"\xD4\xD8" => "\xE5\xA9\xA5",
		"\xD4\xD9" => "\xE5\xA9\xAC",
		"\xD4\xDA" => "\xE5\xA9\x93",
		"\xD4\xDB" => "\xE5\xA9\xA4",
		"\xD4\xDC" => "\xE5\xA9\x97",
		"\xD4\xDD" => "\xE5\xA9\x83",
		"\xD4\xDE" => "\xE5\xA9\x9D",
		"\xD4\xDF" => "\xE5\xA9\x92",
		"\xD4\xE0" => "\xE5\xA9\x84",
		"\xD4\xE1" => "\xE5\xA9\x9B",
		"\xD4\xE2" => "\xE5\xA9\x88",
		"\xD4\xE3" => "\xE5\xAA\x8E",
		"\xD4\xE4" => "\xE5\xA8\xBE",
		"\xD4\xE5" => "\xE5\xA9\x8D",
		"\xD4\xE6" => "\xE5\xA8\xB9",
		"\xD4\xE7" => "\xE5\xA9\x8C",
		"\xD4\xE8" => "\xE5\xA9\xB0",
		"\xD4\xE9" => "\xE5\xA9\xA9",
		"\xD4\xEA" => "\xE5\xA9\x87",
		"\xD4\xEB" => "\xE5\xA9\x91",
		"\xD4\xEC" => "\xE5\xA9\x96",
		"\xD4\xED" => "\xE5\xA9\x82",
		"\xD4\xEE" => "\xE5\xA9\x9C",
		"\xD4\xEF" => "\xE5\xAD\xB2",
		"\xD4\xF0" => "\xE5\xAD\xAE",
		"\xD4\xF1" => "\xE5\xAF\x81",
		"\xD4\xF2" => "\xE5\xAF\x80",
		"\xD4\xF3" => "\xE5\xB1\x99",
		"\xD4\xF4" => "\xE5\xB4\x9E",
		"\xD4\xF5" => "\xE5\xB4\x8B",
		"\xD4\xF6" => "\xE5\xB4\x9D",
		"\xD4\xF7" => "\xE5\xB4\x9A",
		"\xD4\xF8" => "\xE5\xB4\xA0",
		"\xD4\xF9" => "\xE5\xB4\x8C",
		"\xD4\xFA" => "\xE5\xB4\xA8",
		"\xD4\xFB" => "\xE5\xB4\x8D",
		"\xD4\xFC" => "\xE5\xB4\xA6",
		"\xD4\xFD" => "\xE5\xB4\xA5",
		"\xD4\xFE" => "\xE5\xB4\x8F",
		"\xD5\x40" => "\xE5\xB4\xB0",
		"\xD5\x41" => "\xE5\xB4\x92",
		"\xD5\x42" => "\xE5\xB4\xA3",
		"\xD5\x43" => "\xE5\xB4\x9F",
		"\xD5\x44" => "\xE5\xB4\xAE",
		"\xD5\x45" => "\xE5\xB8\xBE",
		"\xD5\x46" => "\xE5\xB8\xB4",
		"\xD5\x47" => "\xE5\xBA\xB1",
		"\xD5\x48" => "\xE5\xBA\xB4",
		"\xD5\x49" => "\xE5\xBA\xB9",
		"\xD5\x4A" => "\xE5\xBA\xB2",
		"\xD5\x4B" => "\xE5\xBA\xB3",
		"\xD5\x4C" => "\xE5\xBC\xB6",
		"\xD5\x4D" => "\xE5\xBC\xB8",
		"\xD5\x4E" => "\xE5\xBE\x9B",
		"\xD5\x4F" => "\xE5\xBE\x96",
		"\xD5\x50" => "\xE5\xBE\x9F",
		"\xD5\x51" => "\xE6\x82\x8A",
		"\xD5\x52" => "\xE6\x82\x90",
		"\xD5\x53" => "\xE6\x82\x86",
		"\xD5\x54" => "\xE6\x82\xBE",
		"\xD5\x55" => "\xE6\x82\xB0",
		"\xD5\x56" => "\xE6\x82\xBA",
		"\xD5\x57" => "\xE6\x83\x93",
		"\xD5\x58" => "\xE6\x83\x94",
		"\xD5\x59" => "\xE6\x83\x8F",
		"\xD5\x5A" => "\xE6\x83\xA4",
		"\xD5\x5B" => "\xE6\x83\x99",
		"\xD5\x5C" => "\xE6\x83\x9D",
		"\xD5\x5D" => "\xE6\x83\x88",
		"\xD5\x5E" => "\xE6\x82\xB1",
		"\xD5\x5F" => "\xE6\x83\x9B",
		"\xD5\x60" => "\xE6\x82\xB7",
		"\xD5\x61" => "\xE6\x83\x8A",
		"\xD5\x62" => "\xE6\x82\xBF",
		"\xD5\x63" => "\xE6\x83\x83",
		"\xD5\x64" => "\xE6\x83\x8D",
		"\xD5\x65" => "\xE6\x83\x80",
		"\xD5\x66" => "\xE6\x8C\xB2",
		"\xD5\x67" => "\xE6\x8D\xA5",
		"\xD5\x68" => "\xE6\x8E\x8A",
		"\xD5\x69" => "\xE6\x8E\x82",
		"\xD5\x6A" => "\xE6\x8D\xBD",
		"\xD5\x6B" => "\xE6\x8E\xBD",
		"\xD5\x6C" => "\xE6\x8E\x9E",
		"\xD5\x6D" => "\xE6\x8E\xAD",
		"\xD5\x6E" => "\xE6\x8E\x9D",
		"\xD5\x6F" => "\xE6\x8E\x97",
		"\xD5\x70" => "\xE6\x8E\xAB",
		"\xD5\x71" => "\xE6\x8E\x8E",
		"\xD5\x72" => "\xE6\x8D\xAF",
		"\xD5\x73" => "\xE6\x8E\x87",
		"\xD5\x74" => "\xE6\x8E\x90",
		"\xD5\x75" => "\xE6\x8D\xAE",
		"\xD5\x76" => "\xE6\x8E\xAF",
		"\xD5\x77" => "\xE6\x8D\xB5",
		"\xD5\x78" => "\xE6\x8E\x9C",
		"\xD5\x79" => "\xE6\x8D\xAD",
		"\xD5\x7A" => "\xE6\x8E\xAE",
		"\xD5\x7B" => "\xE6\x8D\xBC",
		"\xD5\x7C" => "\xE6\x8E\xA4",
		"\xD5\x7D" => "\xE6\x8C\xBB",
		"\xD5\x7E" => "\xE6\x8E\x9F",
		"\xD5\xA1" => "\xE6\x8D\xB8",
		"\xD5\xA2" => "\xE6\x8E\x85",
		"\xD5\xA3" => "\xE6\x8E\x81",
		"\xD5\xA4" => "\xE6\x8E\x91",
		"\xD5\xA5" => "\xE6\x8E\x8D",
		"\xD5\xA6" => "\xE6\x8D\xB0",
		"\xD5\xA7" => "\xE6\x95\x93",
		"\xD5\xA8" => "\xE6\x97\x8D",
		"\xD5\xA9" => "\xE6\x99\xA5",
		"\xD5\xAA" => "\xE6\x99\xA1",
		"\xD5\xAB" => "\xE6\x99\x9B",
		"\xD5\xAC" => "\xE6\x99\x99",
		"\xD5\xAD" => "\xE6\x99\x9C",
		"\xD5\xAE" => "\xE6\x99\xA2",
		"\xD5\xAF" => "\xE6\x9C\x98",
		"\xD5\xB0" => "\xE6\xA1\xB9",
		"\xD5\xB1" => "\xE6\xA2\x87",
		"\xD5\xB2" => "\xE6\xA2\x90",
		"\xD5\xB3" => "\xE6\xA2\x9C",
		"\xD5\xB4" => "\xE6\xA1\xAD",
		"\xD5\xB5" => "\xE6\xA1\xAE",
		"\xD5\xB6" => "\xE6\xA2\xAE",
		"\xD5\xB7" => "\xE6\xA2\xAB",
		"\xD5\xB8" => "\xE6\xA5\x96",
		"\xD5\xB9" => "\xE6\xA1\xAF",
		"\xD5\xBA" => "\xE6\xA2\xA3",
		"\xD5\xBB" => "\xE6\xA2\xAC",
		"\xD5\xBC" => "\xE6\xA2\xA9",
		"\xD5\xBD" => "\xE6\xA1\xB5",
		"\xD5\xBE" => "\xE6\xA1\xB4",
		"\xD5\xBF" => "\xE6\xA2\xB2",
		"\xD5\xC0" => "\xE6\xA2\x8F",
		"\xD5\xC1" => "\xE6\xA1\xB7",
		"\xD5\xC2" => "\xE6\xA2\x92",
		"\xD5\xC3" => "\xE6\xA1\xBC",
		"\xD5\xC4" => "\xE6\xA1\xAB",
		"\xD5\xC5" => "\xE6\xA1\xB2",
		"\xD5\xC6" => "\xE6\xA2\xAA",
		"\xD5\xC7" => "\xE6\xA2\x80",
		"\xD5\xC8" => "\xE6\xA1\xB1",
		"\xD5\xC9" => "\xE6\xA1\xBE",
		"\xD5\xCA" => "\xE6\xA2\x9B",
		"\xD5\xCB" => "\xE6\xA2\x96",
		"\xD5\xCC" => "\xE6\xA2\x8B",
		"\xD5\xCD" => "\xE6\xA2\xA0",
		"\xD5\xCE" => "\xE6\xA2\x89",
		"\xD5\xCF" => "\xE6\xA2\xA4",
		"\xD5\xD0" => "\xE6\xA1\xB8",
		"\xD5\xD1" => "\xE6\xA1\xBB",
		"\xD5\xD2" => "\xE6\xA2\x91",
		"\xD5\xD3" => "\xE6\xA2\x8C",
		"\xD5\xD4" => "\xE6\xA2\x8A",
		"\xD5\xD5" => "\xE6\xA1\xBD",
		"\xD5\xD6" => "\xE6\xAC\xB6",
		"\xD5\xD7" => "\xE6\xAC\xB3",
		"\xD5\xD8" => "\xE6\xAC\xB7",
		"\xD5\xD9" => "\xE6\xAC\xB8",
		"\xD5\xDA" => "\xE6\xAE\x91",
		"\xD5\xDB" => "\xE6\xAE\x8F",
		"\xD5\xDC" => "\xE6\xAE\x8D",
		"\xD5\xDD" => "\xE6\xAE\x8E",
		"\xD5\xDE" => "\xE6\xAE\x8C",
		"\xD5\xDF" => "\xE6\xB0\xAA",
		"\xD5\xE0" => "\xE6\xB7\x80",
		"\xD5\xE1" => "\xE6\xB6\xAB",
		"\xD5\xE2" => "\xE6\xB6\xB4",
		"\xD5\xE3" => "\xE6\xB6\xB3",
		"\xD5\xE4" => "\xE6\xB9\xB4",
		"\xD5\xE5" => "\xE6\xB6\xAC",
		"\xD5\xE6" => "\xE6\xB7\xA9",
		"\xD5\xE7" => "\xE6\xB7\xA2",
		"\xD5\xE8" => "\xE6\xB6\xB7",
		"\xD5\xE9" => "\xE6\xB7\xB6",
		"\xD5\xEA" => "\xE6\xB7\x94",
		"\xD5\xEB" => "\xE6\xB8\x80",
		"\xD5\xEC" => "\xE6\xB7\x88",
		"\xD5\xED" => "\xE6\xB7\xA0",
		"\xD5\xEE" => "\xE6\xB7\x9F",
		"\xD5\xEF" => "\xE6\xB7\x96",
		"\xD5\xF0" => "\xE6\xB6\xBE",
		"\xD5\xF1" => "\xE6\xB7\xA5",
		"\xD5\xF2" => "\xE6\xB7\x9C",
		"\xD5\xF3" => "\xE6\xB7\x9D",
		"\xD5\xF4" => "\xE6\xB7\x9B",
		"\xD5\xF5" => "\xE6\xB7\xB4",
		"\xD5\xF6" => "\xE6\xB7\x8A",
		"\xD5\xF7" => "\xE6\xB6\xBD",
		"\xD5\xF8" => "\xE6\xB7\xAD",
		"\xD5\xF9" => "\xE6\xB7\xB0",
		"\xD5\xFA" => "\xE6\xB6\xBA",
		"\xD5\xFB" => "\xE6\xB7\x95",
		"\xD5\xFC" => "\xE6\xB7\x82",
		"\xD5\xFD" => "\xE6\xB7\x8F",
		"\xD5\xFE" => "\xE6\xB7\x89",
		"\xD6\x40" => "\xE6\xB7\x90",
		"\xD6\x41" => "\xE6\xB7\xB2",
		"\xD6\x42" => "\xE6\xB7\x93",
		"\xD6\x43" => "\xE6\xB7\xBD",
		"\xD6\x44" => "\xE6\xB7\x97",
		"\xD6\x45" => "\xE6\xB7\x8D",
		"\xD6\x46" => "\xE6\xB7\xA3",
		"\xD6\x47" => "\xE6\xB6\xBB",
		"\xD6\x48" => "\xE7\x83\xBA",
		"\xD6\x49" => "\xE7\x84\x8D",
		"\xD6\x4A" => "\xE7\x83\xB7",
		"\xD6\x4B" => "\xE7\x84\x97",
		"\xD6\x4C" => "\xE7\x83\xB4",
		"\xD6\x4D" => "\xE7\x84\x8C",
		"\xD6\x4E" => "\xE7\x83\xB0",
		"\xD6\x4F" => "\xE7\x84\x84",
		"\xD6\x50" => "\xE7\x83\xB3",
		"\xD6\x51" => "\xE7\x84\x90",
		"\xD6\x52" => "\xE7\x83\xBC",
		"\xD6\x53" => "\xE7\x83\xBF",
		"\xD6\x54" => "\xE7\x84\x86",
		"\xD6\x55" => "\xE7\x84\x93",
		"\xD6\x56" => "\xE7\x84\x80",
		"\xD6\x57" => "\xE7\x83\xB8",
		"\xD6\x58" => "\xE7\x83\xB6",
		"\xD6\x59" => "\xE7\x84\x8B",
		"\xD6\x5A" => "\xE7\x84\x82",
		"\xD6\x5B" => "\xE7\x84\x8E",
		"\xD6\x5C" => "\xE7\x89\xBE",
		"\xD6\x5D" => "\xE7\x89\xBB",
		"\xD6\x5E" => "\xE7\x89\xBC",
		"\xD6\x5F" => "\xE7\x89\xBF",
		"\xD6\x60" => "\xE7\x8C\x9D",
		"\xD6\x61" => "\xE7\x8C\x97",
		"\xD6\x62" => "\xE7\x8C\x87",
		"\xD6\x63" => "\xE7\x8C\x91",
		"\xD6\x64" => "\xE7\x8C\x98",
		"\xD6\x65" => "\xE7\x8C\x8A",
		"\xD6\x66" => "\xE7\x8C\x88",
		"\xD6\x67" => "\xE7\x8B\xBF",
		"\xD6\x68" => "\xE7\x8C\x8F",
		"\xD6\x69" => "\xE7\x8C\x9E",
		"\xD6\x6A" => "\xE7\x8E\x88",
		"\xD6\x6B" => "\xE7\x8F\xB6",
		"\xD6\x6C" => "\xE7\x8F\xB8",
		"\xD6\x6D" => "\xE7\x8F\xB5",
		"\xD6\x6E" => "\xE7\x90\x84",
		"\xD6\x6F" => "\xE7\x90\x81",
		"\xD6\x70" => "\xE7\x8F\xBD",
		"\xD6\x71" => "\xE7\x90\x87",
		"\xD6\x72" => "\xE7\x90\x80",
		"\xD6\x73" => "\xE7\x8F\xBA",
		"\xD6\x74" => "\xE7\x8F\xBC",
		"\xD6\x75" => "\xE7\x8F\xBF",
		"\xD6\x76" => "\xE7\x90\x8C",
		"\xD6\x77" => "\xE7\x90\x8B",
		"\xD6\x78" => "\xE7\x8F\xB4",
		"\xD6\x79" => "\xE7\x90\x88",
		"\xD6\x7A" => "\xE7\x95\xA4",
		"\xD6\x7B" => "\xE7\x95\xA3",
		"\xD6\x7C" => "\xE7\x97\x8E",
		"\xD6\x7D" => "\xE7\x97\x92",
		"\xD6\x7E" => "\xE7\x97\x8F",
		"\xD6\xA1" => "\xE7\x97\x8B",
		"\xD6\xA2" => "\xE7\x97\x8C",
		"\xD6\xA3" => "\xE7\x97\x91",
		"\xD6\xA4" => "\xE7\x97\x90",
		"\xD6\xA5" => "\xE7\x9A\x8F",
		"\xD6\xA6" => "\xE7\x9A\x89",
		"\xD6\xA7" => "\xE7\x9B\x93",
		"\xD6\xA8" => "\xE7\x9C\xB9",
		"\xD6\xA9" => "\xE7\x9C\xAF",
		"\xD6\xAA" => "\xE7\x9C\xAD",
		"\xD6\xAB" => "\xE7\x9C\xB1",
		"\xD6\xAC" => "\xE7\x9C\xB2",
		"\xD6\xAD" => "\xE7\x9C\xB4",
		"\xD6\xAE" => "\xE7\x9C\xB3",
		"\xD6\xAF" => "\xE7\x9C\xBD",
		"\xD6\xB0" => "\xE7\x9C\xA5",
		"\xD6\xB1" => "\xE7\x9C\xBB",
		"\xD6\xB2" => "\xE7\x9C\xB5",
		"\xD6\xB3" => "\xE7\xA1\x88",
		"\xD6\xB4" => "\xE7\xA1\x92",
		"\xD6\xB5" => "\xE7\xA1\x89",
		"\xD6\xB6" => "\xE7\xA1\x8D",
		"\xD6\xB7" => "\xE7\xA1\x8A",
		"\xD6\xB8" => "\xE7\xA1\x8C",
		"\xD6\xB9" => "\xE7\xA0\xA6",
		"\xD6\xBA" => "\xE7\xA1\x85",
		"\xD6\xBB" => "\xE7\xA1\x90",
		"\xD6\xBC" => "\xE7\xA5\xA4",
		"\xD6\xBD" => "\xE7\xA5\xA7",
		"\xD6\xBE" => "\xE7\xA5\xA9",
		"\xD6\xBF" => "\xE7\xA5\xAA",
		"\xD6\xC0" => "\xE7\xA5\xA3",
		"\xD6\xC1" => "\xE7\xA5\xAB",
		"\xD6\xC2" => "\xE7\xA5\xA1",
		"\xD6\xC3" => "\xE7\xA6\xBB",
		"\xD6\xC4" => "\xE7\xA7\xBA",
		"\xD6\xC5" => "\xE7\xA7\xB8",
		"\xD6\xC6" => "\xE7\xA7\xB6",
		"\xD6\xC7" => "\xE7\xA7\xB7",
		"\xD6\xC8" => "\xE7\xAA\x8F",
		"\xD6\xC9" => "\xE7\xAA\x94",
		"\xD6\xCA" => "\xE7\xAA\x90",
		"\xD6\xCB" => "\xE7\xAC\xB5",
		"\xD6\xCC" => "\xE7\xAD\x87",
		"\xD6\xCD" => "\xE7\xAC\xB4",
		"\xD6\xCE" => "\xE7\xAC\xA5",
		"\xD6\xCF" => "\xE7\xAC\xB0",
		"\xD6\xD0" => "\xE7\xAC\xA2",
		"\xD6\xD1" => "\xE7\xAC\xA4",
		"\xD6\xD2" => "\xE7\xAC\xB3",
		"\xD6\xD3" => "\xE7\xAC\x98",
		"\xD6\xD4" => "\xE7\xAC\xAA",
		"\xD6\xD5" => "\xE7\xAC\x9D",
		"\xD6\xD6" => "\xE7\xAC\xB1",
		"\xD6\xD7" => "\xE7\xAC\xAB",
		"\xD6\xD8" => "\xE7\xAC\xAD",
		"\xD6\xD9" => "\xE7\xAC\xAF",
		"\xD6\xDA" => "\xE7\xAC\xB2",
		"\xD6\xDB" => "\xE7\xAC\xB8",
		"\xD6\xDC" => "\xE7\xAC\x9A",
		"\xD6\xDD" => "\xE7\xAC\xA3",
		"\xD6\xDE" => "\xE7\xB2\x94",
		"\xD6\xDF" => "\xE7\xB2\x98",
		"\xD6\xE0" => "\xE7\xB2\x96",
		"\xD6\xE1" => "\xE7\xB2\xA3",
		"\xD6\xE2" => "\xE7\xB4\xB5",
		"\xD6\xE3" => "\xE7\xB4\xBD",
		"\xD6\xE4" => "\xE7\xB4\xB8",
		"\xD6\xE5" => "\xE7\xB4\xB6",
		"\xD6\xE6" => "\xE7\xB4\xBA",
		"\xD6\xE7" => "\xE7\xB5\x85",
		"\xD6\xE8" => "\xE7\xB4\xAC",
		"\xD6\xE9" => "\xE7\xB4\xA9",
		"\xD6\xEA" => "\xE7\xB5\x81",
		"\xD6\xEB" => "\xE7\xB5\x87",
		"\xD6\xEC" => "\xE7\xB4\xBE",
		"\xD6\xED" => "\xE7\xB4\xBF",
		"\xD6\xEE" => "\xE7\xB5\x8A",
		"\xD6\xEF" => "\xE7\xB4\xBB",
		"\xD6\xF0" => "\xE7\xB4\xA8",
		"\xD6\xF1" => "\xE7\xBD\xA3",
		"\xD6\xF2" => "\xE7\xBE\x95",
		"\xD6\xF3" => "\xE7\xBE\x9C",
		"\xD6\xF4" => "\xE7\xBE\x9D",
		"\xD6\xF5" => "\xE7\xBE\x9B",
		"\xD6\xF6" => "\xE7\xBF\x8A",
		"\xD6\xF7" => "\xE7\xBF\x8B",
		"\xD6\xF8" => "\xE7\xBF\x8D",
		"\xD6\xF9" => "\xE7\xBF\x90",
		"\xD6\xFA" => "\xE7\xBF\x91",
		"\xD6\xFB" => "\xE7\xBF\x87",
		"\xD6\xFC" => "\xE7\xBF\x8F",
		"\xD6\xFD" => "\xE7\xBF\x89",
		"\xD6\xFE" => "\xE8\x80\x9F",
		"\xD7\x40" => "\xE8\x80\x9E",
		"\xD7\x41" => "\xE8\x80\x9B",
		"\xD7\x42" => "\xE8\x81\x87",
		"\xD7\x43" => "\xE8\x81\x83",
		"\xD7\x44" => "\xE8\x81\x88",
		"\xD7\x45" => "\xE8\x84\x98",
		"\xD7\x46" => "\xE8\x84\xA5",
		"\xD7\x47" => "\xE8\x84\x99",
		"\xD7\x48" => "\xE8\x84\x9B",
		"\xD7\x49" => "\xE8\x84\xAD",
		"\xD7\x4A" => "\xE8\x84\x9F",
		"\xD7\x4B" => "\xE8\x84\xAC",
		"\xD7\x4C" => "\xE8\x84\x9E",
		"\xD7\x4D" => "\xE8\x84\xA1",
		"\xD7\x4E" => "\xE8\x84\x95",
		"\xD7\x4F" => "\xE8\x84\xA7",
		"\xD7\x50" => "\xE8\x84\x9D",
		"\xD7\x51" => "\xE8\x84\xA2",
		"\xD7\x52" => "\xE8\x88\x91",
		"\xD7\x53" => "\xE8\x88\xB8",
		"\xD7\x54" => "\xE8\x88\xB3",
		"\xD7\x55" => "\xE8\x88\xBA",
		"\xD7\x56" => "\xE8\x88\xB4",
		"\xD7\x57" => "\xE8\x88\xB2",
		"\xD7\x58" => "\xE8\x89\xB4",
		"\xD7\x59" => "\xE8\x8E\x90",
		"\xD7\x5A" => "\xE8\x8E\xA3",
		"\xD7\x5B" => "\xE8\x8E\xA8",
		"\xD7\x5C" => "\xE8\x8E\x8D",
		"\xD7\x5D" => "\xE8\x8D\xBA",
		"\xD7\x5E" => "\xE8\x8D\xB3",
		"\xD7\x5F" => "\xE8\x8E\xA4",
		"\xD7\x60" => "\xE8\x8D\xB4",
		"\xD7\x61" => "\xE8\x8E\x8F",
		"\xD7\x62" => "\xE8\x8E\x81",
		"\xD7\x63" => "\xE8\x8E\x95",
		"\xD7\x64" => "\xE8\x8E\x99",
		"\xD7\x65" => "\xE8\x8D\xB5",
		"\xD7\x66" => "\xE8\x8E\x94",
		"\xD7\x67" => "\xE8\x8E\xA9",
		"\xD7\x68" => "\xE8\x8D\xBD",
		"\xD7\x69" => "\xE8\x8E\x83",
		"\xD7\x6A" => "\xE8\x8E\x8C",
		"\xD7\x6B" => "\xE8\x8E\x9D",
		"\xD7\x6C" => "\xE8\x8E\x9B",
		"\xD7\x6D" => "\xE8\x8E\xAA",
		"\xD7\x6E" => "\xE8\x8E\x8B",
		"\xD7\x6F" => "\xE8\x8D\xBE",
		"\xD7\x70" => "\xE8\x8E\xA5",
		"\xD7\x71" => "\xE8\x8E\xAF",
		"\xD7\x72" => "\xE8\x8E\x88",
		"\xD7\x73" => "\xE8\x8E\x97",
		"\xD7\x74" => "\xE8\x8E\xB0",
		"\xD7\x75" => "\xE8\x8D\xBF",
		"\xD7\x76" => "\xE8\x8E\xA6",
		"\xD7\x77" => "\xE8\x8E\x87",
		"\xD7\x78" => "\xE8\x8E\xAE",
		"\xD7\x79" => "\xE8\x8D\xB6",
		"\xD7\x7A" => "\xE8\x8E\x9A",
		"\xD7\x7B" => "\xE8\x99\x99",
		"\xD7\x7C" => "\xE8\x99\x96",
		"\xD7\x7D" => "\xE8\x9A\xBF",
		"\xD7\x7E" => "\xE8\x9A\xB7",
		"\xD7\xA1" => "\xE8\x9B\x82",
		"\xD7\xA2" => "\xE8\x9B\x81",
		"\xD7\xA3" => "\xE8\x9B\x85",
		"\xD7\xA4" => "\xE8\x9A\xBA",
		"\xD7\xA5" => "\xE8\x9A\xB0",
		"\xD7\xA6" => "\xE8\x9B\x88",
		"\xD7\xA7" => "\xE8\x9A\xB9",
		"\xD7\xA8" => "\xE8\x9A\xB3",
		"\xD7\xA9" => "\xE8\x9A\xB8",
		"\xD7\xAA" => "\xE8\x9B\x8C",
		"\xD7\xAB" => "\xE8\x9A\xB4",
		"\xD7\xAC" => "\xE8\x9A\xBB",
		"\xD7\xAD" => "\xE8\x9A\xBC",
		"\xD7\xAE" => "\xE8\x9B\x83",
		"\xD7\xAF" => "\xE8\x9A\xBD",
		"\xD7\xB0" => "\xE8\x9A\xBE",
		"\xD7\xB1" => "\xE8\xA1\x92",
		"\xD7\xB2" => "\xE8\xA2\x89",
		"\xD7\xB3" => "\xE8\xA2\x95",
		"\xD7\xB4" => "\xE8\xA2\xA8",
		"\xD7\xB5" => "\xE8\xA2\xA2",
		"\xD7\xB6" => "\xE8\xA2\xAA",
		"\xD7\xB7" => "\xE8\xA2\x9A",
		"\xD7\xB8" => "\xE8\xA2\x91",
		"\xD7\xB9" => "\xE8\xA2\xA1",
		"\xD7\xBA" => "\xE8\xA2\x9F",
		"\xD7\xBB" => "\xE8\xA2\x98",
		"\xD7\xBC" => "\xE8\xA2\xA7",
		"\xD7\xBD" => "\xE8\xA2\x99",
		"\xD7\xBE" => "\xE8\xA2\x9B",
		"\xD7\xBF" => "\xE8\xA2\x97",
		"\xD7\xC0" => "\xE8\xA2\xA4",
		"\xD7\xC1" => "\xE8\xA2\xAC",
		"\xD7\xC2" => "\xE8\xA2\x8C",
		"\xD7\xC3" => "\xE8\xA2\x93",
		"\xD7\xC4" => "\xE8\xA2\x8E",
		"\xD7\xC5" => "\xE8\xA6\x82",
		"\xD7\xC6" => "\xE8\xA7\x96",
		"\xD7\xC7" => "\xE8\xA7\x99",
		"\xD7\xC8" => "\xE8\xA7\x95",
		"\xD7\xC9" => "\xE8\xA8\xB0",
		"\xD7\xCA" => "\xE8\xA8\xA7",
		"\xD7\xCB" => "\xE8\xA8\xAC",
		"\xD7\xCC" => "\xE8\xA8\x9E",
		"\xD7\xCD" => "\xE8\xB0\xB9",
		"\xD7\xCE" => "\xE8\xB0\xBB",
		"\xD7\xCF" => "\xE8\xB1\x9C",
		"\xD7\xD0" => "\xE8\xB1\x9D",
		"\xD7\xD1" => "\xE8\xB1\xBD",
		"\xD7\xD2" => "\xE8\xB2\xA5",
		"\xD7\xD3" => "\xE8\xB5\xBD",
		"\xD7\xD4" => "\xE8\xB5\xBB",
		"\xD7\xD5" => "\xE8\xB5\xB9",
		"\xD7\xD6" => "\xE8\xB6\xBC",
		"\xD7\xD7" => "\xE8\xB7\x82",
		"\xD7\xD8" => "\xE8\xB6\xB9",
		"\xD7\xD9" => "\xE8\xB6\xBF",
		"\xD7\xDA" => "\xE8\xB7\x81",
		"\xD7\xDB" => "\xE8\xBB\x98",
		"\xD7\xDC" => "\xE8\xBB\x9E",
		"\xD7\xDD" => "\xE8\xBB\x9D",
		"\xD7\xDE" => "\xE8\xBB\x9C",
		"\xD7\xDF" => "\xE8\xBB\x97",
		"\xD7\xE0" => "\xE8\xBB\xA0",
		"\xD7\xE1" => "\xE8\xBB\xA1",
		"\xD7\xE2" => "\xE9\x80\xA4",
		"\xD7\xE3" => "\xE9\x80\x8B",
		"\xD7\xE4" => "\xE9\x80\x91",
		"\xD7\xE5" => "\xE9\x80\x9C",
		"\xD7\xE6" => "\xE9\x80\x8C",
		"\xD7\xE7" => "\xE9\x80\xA1",
		"\xD7\xE8" => "\xE9\x83\xAF",
		"\xD7\xE9" => "\xE9\x83\xAA",
		"\xD7\xEA" => "\xE9\x83\xB0",
		"\xD7\xEB" => "\xE9\x83\xB4",
		"\xD7\xEC" => "\xE9\x83\xB2",
		"\xD7\xED" => "\xE9\x83\xB3",
		"\xD7\xEE" => "\xE9\x83\x94",
		"\xD7\xEF" => "\xE9\x83\xAB",
		"\xD7\xF0" => "\xE9\x83\xAC",
		"\xD7\xF1" => "\xE9\x83\xA9",
		"\xD7\xF2" => "\xE9\x85\x96",
		"\xD7\xF3" => "\xE9\x85\x98",
		"\xD7\xF4" => "\xE9\x85\x9A",
		"\xD7\xF5" => "\xE9\x85\x93",
		"\xD7\xF6" => "\xE9\x85\x95",
		"\xD7\xF7" => "\xE9\x87\xAC",
		"\xD7\xF8" => "\xE9\x87\xB4",
		"\xD7\xF9" => "\xE9\x87\xB1",
		"\xD7\xFA" => "\xE9\x87\xB3",
		"\xD7\xFB" => "\xE9\x87\xB8",
		"\xD7\xFC" => "\xE9\x87\xA4",
		"\xD7\xFD" => "\xE9\x87\xB9",
		"\xD7\xFE" => "\xE9\x87\xAA",
		"\xD8\x40" => "\xE9\x87\xAB",
		"\xD8\x41" => "\xE9\x87\xB7",
		"\xD8\x42" => "\xE9\x87\xA8",
		"\xD8\x43" => "\xE9\x87\xAE",
		"\xD8\x44" => "\xE9\x95\xBA",
		"\xD8\x45" => "\xE9\x96\x86",
		"\xD8\x46" => "\xE9\x96\x88",
		"\xD8\x47" => "\xE9\x99\xBC",
		"\xD8\x48" => "\xE9\x99\xAD",
		"\xD8\x49" => "\xE9\x99\xAB",
		"\xD8\x4A" => "\xE9\x99\xB1",
		"\xD8\x4B" => "\xE9\x99\xAF",
		"\xD8\x4C" => "\xE9\x9A\xBF",
		"\xD8\x4D" => "\xE9\x9D\xAA",
		"\xD8\x4E" => "\xE9\xA0\x84",
		"\xD8\x4F" => "\xE9\xA3\xA5",
		"\xD8\x50" => "\xE9\xA6\x97",
		"\xD8\x51" => "\xE5\x82\x9B",
		"\xD8\x52" => "\xE5\x82\x95",
		"\xD8\x53" => "\xE5\x82\x94",
		"\xD8\x54" => "\xE5\x82\x9E",
		"\xD8\x55" => "\xE5\x82\x8B",
		"\xD8\x56" => "\xE5\x82\xA3",
		"\xD8\x57" => "\xE5\x82\x83",
		"\xD8\x58" => "\xE5\x82\x8C",
		"\xD8\x59" => "\xE5\x82\x8E",
		"\xD8\x5A" => "\xE5\x82\x9D",
		"\xD8\x5B" => "\xE5\x81\xA8",
		"\xD8\x5C" => "\xE5\x82\x9C",
		"\xD8\x5D" => "\xE5\x82\x92",
		"\xD8\x5E" => "\xE5\x82\x82",
		"\xD8\x5F" => "\xE5\x82\x87",
		"\xD8\x60" => "\xE5\x85\x9F",
		"\xD8\x61" => "\xE5\x87\x94",
		"\xD8\x62" => "\xE5\x8C\x92",
		"\xD8\x63" => "\xE5\x8C\x91",
		"\xD8\x64" => "\xE5\x8E\xA4",
		"\xD8\x65" => "\xE5\x8E\xA7",
		"\xD8\x66" => "\xE5\x96\x91",
		"\xD8\x67" => "\xE5\x96\xA8",
		"\xD8\x68" => "\xE5\x96\xA5",
		"\xD8\x69" => "\xE5\x96\xAD",
		"\xD8\x6A" => "\xE5\x95\xB7",
		"\xD8\x6B" => "\xE5\x99\x85",
		"\xD8\x6C" => "\xE5\x96\xA2",
		"\xD8\x6D" => "\xE5\x96\x93",
		"\xD8\x6E" => "\xE5\x96\x88",
		"\xD8\x6F" => "\xE5\x96\x8F",
		"\xD8\x70" => "\xE5\x96\xB5",
		"\xD8\x71" => "\xE5\x96\x81",
		"\xD8\x72" => "\xE5\x96\xA3",
		"\xD8\x73" => "\xE5\x96\x92",
		"\xD8\x74" => "\xE5\x96\xA4",
		"\xD8\x75" => "\xE5\x95\xBD",
		"\xD8\x76" => "\xE5\x96\x8C",
		"\xD8\x77" => "\xE5\x96\xA6",
		"\xD8\x78" => "\xE5\x95\xBF",
		"\xD8\x79" => "\xE5\x96\x95",
		"\xD8\x7A" => "\xE5\x96\xA1",
		"\xD8\x7B" => "\xE5\x96\x8E",
		"\xD8\x7C" => "\xE5\x9C\x8C",
		"\xD8\x7D" => "\xE5\xA0\xA9",
		"\xD8\x7E" => "\xE5\xA0\xB7",
		"\xD8\xA1" => "\xE5\xA0\x99",
		"\xD8\xA2" => "\xE5\xA0\x9E",
		"\xD8\xA3" => "\xE5\xA0\xA7",
		"\xD8\xA4" => "\xE5\xA0\xA3",
		"\xD8\xA5" => "\xE5\xA0\xA8",
		"\xD8\xA6" => "\xE5\x9F\xB5",
		"\xD8\xA7" => "\xE5\xA1\x88",
		"\xD8\xA8" => "\xE5\xA0\xA5",
		"\xD8\xA9" => "\xE5\xA0\x9C",
		"\xD8\xAA" => "\xE5\xA0\x9B",
		"\xD8\xAB" => "\xE5\xA0\xB3",
		"\xD8\xAC" => "\xE5\xA0\xBF",
		"\xD8\xAD" => "\xE5\xA0\xB6",
		"\xD8\xAE" => "\xE5\xA0\xAE",
		"\xD8\xAF" => "\xE5\xA0\xB9",
		"\xD8\xB0" => "\xE5\xA0\xB8",
		"\xD8\xB1" => "\xE5\xA0\xAD",
		"\xD8\xB2" => "\xE5\xA0\xAC",
		"\xD8\xB3" => "\xE5\xA0\xBB",
		"\xD8\xB4" => "\xE5\xA5\xA1",
		"\xD8\xB5" => "\xE5\xAA\xAF",
		"\xD8\xB6" => "\xE5\xAA\x94",
		"\xD8\xB7" => "\xE5\xAA\x9F",
		"\xD8\xB8" => "\xE5\xA9\xBA",
		"\xD8\xB9" => "\xE5\xAA\xA2",
		"\xD8\xBA" => "\xE5\xAA\x9E",
		"\xD8\xBB" => "\xE5\xA9\xB8",
		"\xD8\xBC" => "\xE5\xAA\xA6",
		"\xD8\xBD" => "\xE5\xA9\xBC",
		"\xD8\xBE" => "\xE5\xAA\xA5",
		"\xD8\xBF" => "\xE5\xAA\xAC",
		"\xD8\xC0" => "\xE5\xAA\x95",
		"\xD8\xC1" => "\xE5\xAA\xAE",
		"\xD8\xC2" => "\xE5\xA8\xB7",
		"\xD8\xC3" => "\xE5\xAA\x84",
		"\xD8\xC4" => "\xE5\xAA\x8A",
		"\xD8\xC5" => "\xE5\xAA\x97",
		"\xD8\xC6" => "\xE5\xAA\x83",
		"\xD8\xC7" => "\xE5\xAA\x8B",
		"\xD8\xC8" => "\xE5\xAA\xA9",
		"\xD8\xC9" => "\xE5\xA9\xBB",
		"\xD8\xCA" => "\xE5\xA9\xBD",
		"\xD8\xCB" => "\xE5\xAA\x8C",
		"\xD8\xCC" => "\xE5\xAA\x9C",
		"\xD8\xCD" => "\xE5\xAA\x8F",
		"\xD8\xCE" => "\xE5\xAA\x93",
		"\xD8\xCF" => "\xE5\xAA\x9D",
		"\xD8\xD0" => "\xE5\xAF\xAA",
		"\xD8\xD1" => "\xE5\xAF\x8D",
		"\xD8\xD2" => "\xE5\xAF\x8B",
		"\xD8\xD3" => "\xE5\xAF\x94",
		"\xD8\xD4" => "\xE5\xAF\x91",
		"\xD8\xD5" => "\xE5\xAF\x8A",
		"\xD8\xD6" => "\xE5\xAF\x8E",
		"\xD8\xD7" => "\xE5\xB0\x8C",
		"\xD8\xD8" => "\xE5\xB0\xB0",
		"\xD8\xD9" => "\xE5\xB4\xB7",
		"\xD8\xDA" => "\xE5\xB5\x83",
		"\xD8\xDB" => "\xE5\xB5\xAB",
		"\xD8\xDC" => "\xE5\xB5\x81",
		"\xD8\xDD" => "\xE5\xB5\x8B",
		"\xD8\xDE" => "\xE5\xB4\xBF",
		"\xD8\xDF" => "\xE5\xB4\xB5",
		"\xD8\xE0" => "\xE5\xB5\x91",
		"\xD8\xE1" => "\xE5\xB5\x8E",
		"\xD8\xE2" => "\xE5\xB5\x95",
		"\xD8\xE3" => "\xE5\xB4\xB3",
		"\xD8\xE4" => "\xE5\xB4\xBA",
		"\xD8\xE5" => "\xE5\xB5\x92",
		"\xD8\xE6" => "\xE5\xB4\xBD",
		"\xD8\xE7" => "\xE5\xB4\xB1",
		"\xD8\xE8" => "\xE5\xB5\x99",
		"\xD8\xE9" => "\xE5\xB5\x82",
		"\xD8\xEA" => "\xE5\xB4\xB9",
		"\xD8\xEB" => "\xE5\xB5\x89",
		"\xD8\xEC" => "\xE5\xB4\xB8",
		"\xD8\xED" => "\xE5\xB4\xBC",
		"\xD8\xEE" => "\xE5\xB4\xB2",
		"\xD8\xEF" => "\xE5\xB4\xB6",
		"\xD8\xF0" => "\xE5\xB5\x80",
		"\xD8\xF1" => "\xE5\xB5\x85",
		"\xD8\xF2" => "\xE5\xB9\x84",
		"\xD8\xF3" => "\xE5\xB9\x81",
		"\xD8\xF4" => "\xE5\xBD\x98",
		"\xD8\xF5" => "\xE5\xBE\xA6",
		"\xD8\xF6" => "\xE5\xBE\xA5",
		"\xD8\xF7" => "\xE5\xBE\xAB",
		"\xD8\xF8" => "\xE6\x83\x89",
		"\xD8\xF9" => "\xE6\x82\xB9",
		"\xD8\xFA" => "\xE6\x83\x8C",
		"\xD8\xFB" => "\xE6\x83\xA2",
		"\xD8\xFC" => "\xE6\x83\x8E",
		"\xD8\xFD" => "\xE6\x83\x84",
		"\xD8\xFE" => "\xE6\x84\x94",
		"\xD9\x40" => "\xE6\x83\xB2",
		"\xD9\x41" => "\xE6\x84\x8A",
		"\xD9\x42" => "\xE6\x84\x96",
		"\xD9\x43" => "\xE6\x84\x85",
		"\xD9\x44" => "\xE6\x83\xB5",
		"\xD9\x45" => "\xE6\x84\x93",
		"\xD9\x46" => "\xE6\x83\xB8",
		"\xD9\x47" => "\xE6\x83\xBC",
		"\xD9\x48" => "\xE6\x83\xBE",
		"\xD9\x49" => "\xE6\x83\x81",
		"\xD9\x4A" => "\xE6\x84\x83",
		"\xD9\x4B" => "\xE6\x84\x98",
		"\xD9\x4C" => "\xE6\x84\x9D",
		"\xD9\x4D" => "\xE6\x84\x90",
		"\xD9\x4E" => "\xE6\x83\xBF",
		"\xD9\x4F" => "\xE6\x84\x84",
		"\xD9\x50" => "\xE6\x84\x8B",
		"\xD9\x51" => "\xE6\x89\x8A",
		"\xD9\x52" => "\xE6\x8E\x94",
		"\xD9\x53" => "\xE6\x8E\xB1",
		"\xD9\x54" => "\xE6\x8E\xB0",
		"\xD9\x55" => "\xE6\x8F\x8E",
		"\xD9\x56" => "\xE6\x8F\xA5",
		"\xD9\x57" => "\xE6\x8F\xA8",
		"\xD9\x58" => "\xE6\x8F\xAF",
		"\xD9\x59" => "\xE6\x8F\x83",
		"\xD9\x5A" => "\xE6\x92\x9D",
		"\xD9\x5B" => "\xE6\x8F\xB3",
		"\xD9\x5C" => "\xE6\x8F\x8A",
		"\xD9\x5D" => "\xE6\x8F\xA0",
		"\xD9\x5E" => "\xE6\x8F\xB6",
		"\xD9\x5F" => "\xE6\x8F\x95",
		"\xD9\x60" => "\xE6\x8F\xB2",
		"\xD9\x61" => "\xE6\x8F\xB5",
		"\xD9\x62" => "\xE6\x91\xA1",
		"\xD9\x63" => "\xE6\x8F\x9F",
		"\xD9\x64" => "\xE6\x8E\xBE",
		"\xD9\x65" => "\xE6\x8F\x9D",
		"\xD9\x66" => "\xE6\x8F\x9C",
		"\xD9\x67" => "\xE6\x8F\x84",
		"\xD9\x68" => "\xE6\x8F\x98",
		"\xD9\x69" => "\xE6\x8F\x93",
		"\xD9\x6A" => "\xE6\x8F\x82",
		"\xD9\x6B" => "\xE6\x8F\x87",
		"\xD9\x6C" => "\xE6\x8F\x8C",
		"\xD9\x6D" => "\xE6\x8F\x8B",
		"\xD9\x6E" => "\xE6\x8F\x88",
		"\xD9\x6F" => "\xE6\x8F\xB0",
		"\xD9\x70" => "\xE6\x8F\x97",
		"\xD9\x71" => "\xE6\x8F\x99",
		"\xD9\x72" => "\xE6\x94\xB2",
		"\xD9\x73" => "\xE6\x95\xA7",
		"\xD9\x74" => "\xE6\x95\xAA",
		"\xD9\x75" => "\xE6\x95\xA4",
		"\xD9\x76" => "\xE6\x95\x9C",
		"\xD9\x77" => "\xE6\x95\xA8",
		"\xD9\x78" => "\xE6\x95\xA5",
		"\xD9\x79" => "\xE6\x96\x8C",
		"\xD9\x7A" => "\xE6\x96\x9D",
		"\xD9\x7B" => "\xE6\x96\x9E",
		"\xD9\x7C" => "\xE6\x96\xAE",
		"\xD9\x7D" => "\xE6\x97\x90",
		"\xD9\x7E" => "\xE6\x97\x92",
		"\xD9\xA1" => "\xE6\x99\xBC",
		"\xD9\xA2" => "\xE6\x99\xAC",
		"\xD9\xA3" => "\xE6\x99\xBB",
		"\xD9\xA4" => "\xE6\x9A\x80",
		"\xD9\xA5" => "\xE6\x99\xB1",
		"\xD9\xA6" => "\xE6\x99\xB9",
		"\xD9\xA7" => "\xE6\x99\xAA",
		"\xD9\xA8" => "\xE6\x99\xB2",
		"\xD9\xA9" => "\xE6\x9C\x81",
		"\xD9\xAA" => "\xE6\xA4\x8C",
		"\xD9\xAB" => "\xE6\xA3\x93",
		"\xD9\xAC" => "\xE6\xA4\x84",
		"\xD9\xAD" => "\xE6\xA3\x9C",
		"\xD9\xAE" => "\xE6\xA4\xAA",
		"\xD9\xAF" => "\xE6\xA3\xAC",
		"\xD9\xB0" => "\xE6\xA3\xAA",
		"\xD9\xB1" => "\xE6\xA3\xB1",
		"\xD9\xB2" => "\xE6\xA4\x8F",
		"\xD9\xB3" => "\xE6\xA3\x96",
		"\xD9\xB4" => "\xE6\xA3\xB7",
		"\xD9\xB5" => "\xE6\xA3\xAB",
		"\xD9\xB6" => "\xE6\xA3\xA4",
		"\xD9\xB7" => "\xE6\xA3\xB6",
		"\xD9\xB8" => "\xE6\xA4\x93",
		"\xD9\xB9" => "\xE6\xA4\x90",
		"\xD9\xBA" => "\xE6\xA3\xB3",
		"\xD9\xBB" => "\xE6\xA3\xA1",
		"\xD9\xBC" => "\xE6\xA4\x87",
		"\xD9\xBD" => "\xE6\xA3\x8C",
		"\xD9\xBE" => "\xE6\xA4\x88",
		"\xD9\xBF" => "\xE6\xA5\xB0",
		"\xD9\xC0" => "\xE6\xA2\xB4",
		"\xD9\xC1" => "\xE6\xA4\x91",
		"\xD9\xC2" => "\xE6\xA3\xAF",
		"\xD9\xC3" => "\xE6\xA3\x86",
		"\xD9\xC4" => "\xE6\xA4\x94",
		"\xD9\xC5" => "\xE6\xA3\xB8",
		"\xD9\xC6" => "\xE6\xA3\x90",
		"\xD9\xC7" => "\xE6\xA3\xBD",
		"\xD9\xC8" => "\xE6\xA3\xBC",
		"\xD9\xC9" => "\xE6\xA3\xA8",
		"\xD9\xCA" => "\xE6\xA4\x8B",
		"\xD9\xCB" => "\xE6\xA4\x8A",
		"\xD9\xCC" => "\xE6\xA4\x97",
		"\xD9\xCD" => "\xE6\xA3\x8E",
		"\xD9\xCE" => "\xE6\xA3\x88",
		"\xD9\xCF" => "\xE6\xA3\x9D",
		"\xD9\xD0" => "\xE6\xA3\x9E",
		"\xD9\xD1" => "\xE6\xA3\xA6",
		"\xD9\xD2" => "\xE6\xA3\xB4",
		"\xD9\xD3" => "\xE6\xA3\x91",
		"\xD9\xD4" => "\xE6\xA4\x86",
		"\xD9\xD5" => "\xE6\xA3\x94",
		"\xD9\xD6" => "\xE6\xA3\xA9",
		"\xD9\xD7" => "\xE6\xA4\x95",
		"\xD9\xD8" => "\xE6\xA4\xA5",
		"\xD9\xD9" => "\xE6\xA3\x87",
		"\xD9\xDA" => "\xE6\xAC\xB9",
		"\xD9\xDB" => "\xE6\xAC\xBB",
		"\xD9\xDC" => "\xE6\xAC\xBF",
		"\xD9\xDD" => "\xE6\xAC\xBC",
		"\xD9\xDE" => "\xE6\xAE\x94",
		"\xD9\xDF" => "\xE6\xAE\x97",
		"\xD9\xE0" => "\xE6\xAE\x99",
		"\xD9\xE1" => "\xE6\xAE\x95",
		"\xD9\xE2" => "\xE6\xAE\xBD",
		"\xD9\xE3" => "\xE6\xAF\xB0",
		"\xD9\xE4" => "\xE6\xAF\xB2",
		"\xD9\xE5" => "\xE6\xAF\xB3",
		"\xD9\xE6" => "\xE6\xB0\xB0",
		"\xD9\xE7" => "\xE6\xB7\xBC",
		"\xD9\xE8" => "\xE6\xB9\x86",
		"\xD9\xE9" => "\xE6\xB9\x87",
		"\xD9\xEA" => "\xE6\xB8\x9F",
		"\xD9\xEB" => "\xE6\xB9\x89",
		"\xD9\xEC" => "\xE6\xBA\x88",
		"\xD9\xED" => "\xE6\xB8\xBC",
		"\xD9\xEE" => "\xE6\xB8\xBD",
		"\xD9\xEF" => "\xE6\xB9\x85",
		"\xD9\xF0" => "\xE6\xB9\xA2",
		"\xD9\xF1" => "\xE6\xB8\xAB",
		"\xD9\xF2" => "\xE6\xB8\xBF",
		"\xD9\xF3" => "\xE6\xB9\x81",
		"\xD9\xF4" => "\xE6\xB9\x9D",
		"\xD9\xF5" => "\xE6\xB9\xB3",
		"\xD9\xF6" => "\xE6\xB8\x9C",
		"\xD9\xF7" => "\xE6\xB8\xB3",
		"\xD9\xF8" => "\xE6\xB9\x8B",
		"\xD9\xF9" => "\xE6\xB9\x80",
		"\xD9\xFA" => "\xE6\xB9\x91",
		"\xD9\xFB" => "\xE6\xB8\xBB",
		"\xD9\xFC" => "\xE6\xB8\x83",
		"\xD9\xFD" => "\xE6\xB8\xAE",
		"\xD9\xFE" => "\xE6\xB9\x9E",
		"\xDA\x40" => "\xE6\xB9\xA8",
		"\xDA\x41" => "\xE6\xB9\x9C",
		"\xDA\x42" => "\xE6\xB9\xA1",
		"\xDA\x43" => "\xE6\xB8\xB1",
		"\xDA\x44" => "\xE6\xB8\xA8",
		"\xDA\x45" => "\xE6\xB9\xA0",
		"\xDA\x46" => "\xE6\xB9\xB1",
		"\xDA\x47" => "\xE6\xB9\xAB",
		"\xDA\x48" => "\xE6\xB8\xB9",
		"\xDA\x49" => "\xE6\xB8\xA2",
		"\xDA\x4A" => "\xE6\xB8\xB0",
		"\xDA\x4B" => "\xE6\xB9\x93",
		"\xDA\x4C" => "\xE6\xB9\xA5",
		"\xDA\x4D" => "\xE6\xB8\xA7",
		"\xDA\x4E" => "\xE6\xB9\xB8",
		"\xDA\x4F" => "\xE6\xB9\xA4",
		"\xDA\x50" => "\xE6\xB9\xB7",
		"\xDA\x51" => "\xE6\xB9\x95",
		"\xDA\x52" => "\xE6\xB9\xB9",
		"\xDA\x53" => "\xE6\xB9\x92",
		"\xDA\x54" => "\xE6\xB9\xA6",
		"\xDA\x55" => "\xE6\xB8\xB5",
		"\xDA\x56" => "\xE6\xB8\xB6",
		"\xDA\x57" => "\xE6\xB9\x9A",
		"\xDA\x58" => "\xE7\x84\xA0",
		"\xDA\x59" => "\xE7\x84\x9E",
		"\xDA\x5A" => "\xE7\x84\xAF",
		"\xDA\x5B" => "\xE7\x83\xBB",
		"\xDA\x5C" => "\xE7\x84\xAE",
		"\xDA\x5D" => "\xE7\x84\xB1",
		"\xDA\x5E" => "\xE7\x84\xA3",
		"\xDA\x5F" => "\xE7\x84\xA5",
		"\xDA\x60" => "\xE7\x84\xA2",
		"\xDA\x61" => "\xE7\x84\xB2",
		"\xDA\x62" => "\xE7\x84\x9F",
		"\xDA\x63" => "\xE7\x84\xA8",
		"\xDA\x64" => "\xE7\x84\xBA",
		"\xDA\x65" => "\xE7\x84\x9B",
		"\xDA\x66" => "\xE7\x89\x8B",
		"\xDA\x67" => "\xE7\x89\x9A",
		"\xDA\x68" => "\xE7\x8A\x88",
		"\xDA\x69" => "\xE7\x8A\x89",
		"\xDA\x6A" => "\xE7\x8A\x86",
		"\xDA\x6B" => "\xE7\x8A\x85",
		"\xDA\x6C" => "\xE7\x8A\x8B",
		"\xDA\x6D" => "\xE7\x8C\x92",
		"\xDA\x6E" => "\xE7\x8C\x8B",
		"\xDA\x6F" => "\xE7\x8C\xB0",
		"\xDA\x70" => "\xE7\x8C\xA2",
		"\xDA\x71" => "\xE7\x8C\xB1",
		"\xDA\x72" => "\xE7\x8C\xB3",
		"\xDA\x73" => "\xE7\x8C\xA7",
		"\xDA\x74" => "\xE7\x8C\xB2",
		"\xDA\x75" => "\xE7\x8C\xAD",
		"\xDA\x76" => "\xE7\x8C\xA6",
		"\xDA\x77" => "\xE7\x8C\xA3",
		"\xDA\x78" => "\xE7\x8C\xB5",
		"\xDA\x79" => "\xE7\x8C\x8C",
		"\xDA\x7A" => "\xE7\x90\xAE",
		"\xDA\x7B" => "\xE7\x90\xAC",
		"\xDA\x7C" => "\xE7\x90\xB0",
		"\xDA\x7D" => "\xE7\x90\xAB",
		"\xDA\x7E" => "\xE7\x90\x96",
		"\xDA\xA1" => "\xE7\x90\x9A",
		"\xDA\xA2" => "\xE7\x90\xA1",
		"\xDA\xA3" => "\xE7\x90\xAD",
		"\xDA\xA4" => "\xE7\x90\xB1",
		"\xDA\xA5" => "\xE7\x90\xA4",
		"\xDA\xA6" => "\xE7\x90\xA3",
		"\xDA\xA7" => "\xE7\x90\x9D",
		"\xDA\xA8" => "\xE7\x90\xA9",
		"\xDA\xA9" => "\xE7\x90\xA0",
		"\xDA\xAA" => "\xE7\x90\xB2",
		"\xDA\xAB" => "\xE7\x93\xBB",
		"\xDA\xAC" => "\xE7\x94\xAF",
		"\xDA\xAD" => "\xE7\x95\xAF",
		"\xDA\xAE" => "\xE7\x95\xAC",
		"\xDA\xAF" => "\xE7\x97\xA7",
		"\xDA\xB0" => "\xE7\x97\x9A",
		"\xDA\xB1" => "\xE7\x97\xA1",
		"\xDA\xB2" => "\xE7\x97\xA6",
		"\xDA\xB3" => "\xE7\x97\x9D",
		"\xDA\xB4" => "\xE7\x97\x9F",
		"\xDA\xB5" => "\xE7\x97\xA4",
		"\xDA\xB6" => "\xE7\x97\x97",
		"\xDA\xB7" => "\xE7\x9A\x95",
		"\xDA\xB8" => "\xE7\x9A\x92",
		"\xDA\xB9" => "\xE7\x9B\x9A",
		"\xDA\xBA" => "\xE7\x9D\x86",
		"\xDA\xBB" => "\xE7\x9D\x87",
		"\xDA\xBC" => "\xE7\x9D\x84",
		"\xDA\xBD" => "\xE7\x9D\x8D",
		"\xDA\xBE" => "\xE7\x9D\x85",
		"\xDA\xBF" => "\xE7\x9D\x8A",
		"\xDA\xC0" => "\xE7\x9D\x8E",
		"\xDA\xC1" => "\xE7\x9D\x8B",
		"\xDA\xC2" => "\xE7\x9D\x8C",
		"\xDA\xC3" => "\xE7\x9F\x9E",
		"\xDA\xC4" => "\xE7\x9F\xAC",
		"\xDA\xC5" => "\xE7\xA1\xA0",
		"\xDA\xC6" => "\xE7\xA1\xA4",
		"\xDA\xC7" => "\xE7\xA1\xA5",
		"\xDA\xC8" => "\xE7\xA1\x9C",
		"\xDA\xC9" => "\xE7\xA1\xAD",
		"\xDA\xCA" => "\xE7\xA1\xB1",
		"\xDA\xCB" => "\xE7\xA1\xAA",
		"\xDA\xCC" => "\xE7\xA1\xAE",
		"\xDA\xCD" => "\xE7\xA1\xB0",
		"\xDA\xCE" => "\xE7\xA1\xA9",
		"\xDA\xCF" => "\xE7\xA1\xA8",
		"\xDA\xD0" => "\xE7\xA1\x9E",
		"\xDA\xD1" => "\xE7\xA1\xA2",
		"\xDA\xD2" => "\xE7\xA5\xB4",
		"\xDA\xD3" => "\xE7\xA5\xB3",
		"\xDA\xD4" => "\xE7\xA5\xB2",
		"\xDA\xD5" => "\xE7\xA5\xB0",
		"\xDA\xD6" => "\xE7\xA8\x82",
		"\xDA\xD7" => "\xE7\xA8\x8A",
		"\xDA\xD8" => "\xE7\xA8\x83",
		"\xDA\xD9" => "\xE7\xA8\x8C",
		"\xDA\xDA" => "\xE7\xA8\x84",
		"\xDA\xDB" => "\xE7\xAA\x99",
		"\xDA\xDC" => "\xE7\xAB\xA6",
		"\xDA\xDD" => "\xE7\xAB\xA4",
		"\xDA\xDE" => "\xE7\xAD\x8A",
		"\xDA\xDF" => "\xE7\xAC\xBB",
		"\xDA\xE0" => "\xE7\xAD\x84",
		"\xDA\xE1" => "\xE7\xAD\x88",
		"\xDA\xE2" => "\xE7\xAD\x8C",
		"\xDA\xE3" => "\xE7\xAD\x8E",
		"\xDA\xE4" => "\xE7\xAD\x80",
		"\xDA\xE5" => "\xE7\xAD\x98",
		"\xDA\xE6" => "\xE7\xAD\x85",
		"\xDA\xE7" => "\xE7\xB2\xA2",
		"\xDA\xE8" => "\xE7\xB2\x9E",
		"\xDA\xE9" => "\xE7\xB2\xA8",
		"\xDA\xEA" => "\xE7\xB2\xA1",
		"\xDA\xEB" => "\xE7\xB5\x98",
		"\xDA\xEC" => "\xE7\xB5\xAF",
		"\xDA\xED" => "\xE7\xB5\xA3",
		"\xDA\xEE" => "\xE7\xB5\x93",
		"\xDA\xEF" => "\xE7\xB5\x96",
		"\xDA\xF0" => "\xE7\xB5\xA7",
		"\xDA\xF1" => "\xE7\xB5\xAA",
		"\xDA\xF2" => "\xE7\xB5\x8F",
		"\xDA\xF3" => "\xE7\xB5\xAD",
		"\xDA\xF4" => "\xE7\xB5\x9C",
		"\xDA\xF5" => "\xE7\xB5\xAB",
		"\xDA\xF6" => "\xE7\xB5\x92",
		"\xDA\xF7" => "\xE7\xB5\x94",
		"\xDA\xF8" => "\xE7\xB5\xA9",
		"\xDA\xF9" => "\xE7\xB5\x91",
		"\xDA\xFA" => "\xE7\xB5\x9F",
		"\xDA\xFB" => "\xE7\xB5\x8E",
		"\xDA\xFC" => "\xE7\xBC\xBE",
		"\xDA\xFD" => "\xE7\xBC\xBF",
		"\xDA\xFE" => "\xE7\xBD\xA5",
		"\xDB\x40" => "\xE7\xBD\xA6",
		"\xDB\x41" => "\xE7\xBE\xA2",
		"\xDB\x42" => "\xE7\xBE\xA0",
		"\xDB\x43" => "\xE7\xBE\xA1",
		"\xDB\x44" => "\xE7\xBF\x97",
		"\xDB\x45" => "\xE8\x81\x91",
		"\xDB\x46" => "\xE8\x81\x8F",
		"\xDB\x47" => "\xE8\x81\x90",
		"\xDB\x48" => "\xE8\x83\xBE",
		"\xDB\x49" => "\xE8\x83\x94",
		"\xDB\x4A" => "\xE8\x85\x83",
		"\xDB\x4B" => "\xE8\x85\x8A",
		"\xDB\x4C" => "\xE8\x85\x92",
		"\xDB\x4D" => "\xE8\x85\x8F",
		"\xDB\x4E" => "\xE8\x85\x87",
		"\xDB\x4F" => "\xE8\x84\xBD",
		"\xDB\x50" => "\xE8\x85\x8D",
		"\xDB\x51" => "\xE8\x84\xBA",
		"\xDB\x52" => "\xE8\x87\xA6",
		"\xDB\x53" => "\xE8\x87\xAE",
		"\xDB\x54" => "\xE8\x87\xB7",
		"\xDB\x55" => "\xE8\x87\xB8",
		"\xDB\x56" => "\xE8\x87\xB9",
		"\xDB\x57" => "\xE8\x88\x84",
		"\xDB\x58" => "\xE8\x88\xBC",
		"\xDB\x59" => "\xE8\x88\xBD",
		"\xDB\x5A" => "\xE8\x88\xBF",
		"\xDB\x5B" => "\xE8\x89\xB5",
		"\xDB\x5C" => "\xE8\x8C\xBB",
		"\xDB\x5D" => "\xE8\x8F\x8F",
		"\xDB\x5E" => "\xE8\x8F\xB9",
		"\xDB\x5F" => "\xE8\x90\xA3",
		"\xDB\x60" => "\xE8\x8F\x80",
		"\xDB\x61" => "\xE8\x8F\xA8",
		"\xDB\x62" => "\xE8\x90\x92",
		"\xDB\x63" => "\xE8\x8F\xA7",
		"\xDB\x64" => "\xE8\x8F\xA4",
		"\xDB\x65" => "\xE8\x8F\xBC",
		"\xDB\x66" => "\xE8\x8F\xB6",
		"\xDB\x67" => "\xE8\x90\x90",
		"\xDB\x68" => "\xE8\x8F\x86",
		"\xDB\x69" => "\xE8\x8F\x88",
		"\xDB\x6A" => "\xE8\x8F\xAB",
		"\xDB\x6B" => "\xE8\x8F\xA3",
		"\xDB\x6C" => "\xE8\x8E\xBF",
		"\xDB\x6D" => "\xE8\x90\x81",
		"\xDB\x6E" => "\xE8\x8F\x9D",
		"\xDB\x6F" => "\xE8\x8F\xA5",
		"\xDB\x70" => "\xE8\x8F\x98",
		"\xDB\x71" => "\xE8\x8F\xBF",
		"\xDB\x72" => "\xE8\x8F\xA1",
		"\xDB\x73" => "\xE8\x8F\x8B",
		"\xDB\x74" => "\xE8\x8F\x8E",
		"\xDB\x75" => "\xE8\x8F\x96",
		"\xDB\x76" => "\xE8\x8F\xB5",
		"\xDB\x77" => "\xE8\x8F\x89",
		"\xDB\x78" => "\xE8\x90\x89",
		"\xDB\x79" => "\xE8\x90\x8F",
		"\xDB\x7A" => "\xE8\x8F\x9E",
		"\xDB\x7B" => "\xE8\x90\x91",
		"\xDB\x7C" => "\xE8\x90\x86",
		"\xDB\x7D" => "\xE8\x8F\x82",
		"\xDB\x7E" => "\xE8\x8F\xB3",
		"\xDB\xA1" => "\xE8\x8F\x95",
		"\xDB\xA2" => "\xE8\x8F\xBA",
		"\xDB\xA3" => "\xE8\x8F\x87",
		"\xDB\xA4" => "\xE8\x8F\x91",
		"\xDB\xA5" => "\xE8\x8F\xAA",
		"\xDB\xA6" => "\xE8\x90\x93",
		"\xDB\xA7" => "\xE8\x8F\x83",
		"\xDB\xA8" => "\xE8\x8F\xAC",
		"\xDB\xA9" => "\xE8\x8F\xAE",
		"\xDB\xAA" => "\xE8\x8F\x84",
		"\xDB\xAB" => "\xE8\x8F\xBB",
		"\xDB\xAC" => "\xE8\x8F\x97",
		"\xDB\xAD" => "\xE8\x8F\xA2",
		"\xDB\xAE" => "\xE8\x90\x9B",
		"\xDB\xAF" => "\xE8\x8F\x9B",
		"\xDB\xB0" => "\xE8\x8F\xBE",
		"\xDB\xB1" => "\xE8\x9B\x98",
		"\xDB\xB2" => "\xE8\x9B\xA2",
		"\xDB\xB3" => "\xE8\x9B\xA6",
		"\xDB\xB4" => "\xE8\x9B\x93",
		"\xDB\xB5" => "\xE8\x9B\xA3",
		"\xDB\xB6" => "\xE8\x9B\x9A",
		"\xDB\xB7" => "\xE8\x9B\xAA",
		"\xDB\xB8" => "\xE8\x9B\x9D",
		"\xDB\xB9" => "\xE8\x9B\xAB",
		"\xDB\xBA" => "\xE8\x9B\x9C",
		"\xDB\xBB" => "\xE8\x9B\xAC",
		"\xDB\xBC" => "\xE8\x9B\xA9",
		"\xDB\xBD" => "\xE8\x9B\x97",
		"\xDB\xBE" => "\xE8\x9B\xA8",
		"\xDB\xBF" => "\xE8\x9B\x91",
		"\xDB\xC0" => "\xE8\xA1\x88",
		"\xDB\xC1" => "\xE8\xA1\x96",
		"\xDB\xC2" => "\xE8\xA1\x95",
		"\xDB\xC3" => "\xE8\xA2\xBA",
		"\xDB\xC4" => "\xE8\xA3\x97",
		"\xDB\xC5" => "\xE8\xA2\xB9",
		"\xDB\xC6" => "\xE8\xA2\xB8",
		"\xDB\xC7" => "\xE8\xA3\x80",
		"\xDB\xC8" => "\xE8\xA2\xBE",
		"\xDB\xC9" => "\xE8\xA2\xB6",
		"\xDB\xCA" => "\xE8\xA2\xBC",
		"\xDB\xCB" => "\xE8\xA2\xB7",
		"\xDB\xCC" => "\xE8\xA2\xBD",
		"\xDB\xCD" => "\xE8\xA2\xB2",
		"\xDB\xCE" => "\xE8\xA4\x81",
		"\xDB\xCF" => "\xE8\xA3\x89",
		"\xDB\xD0" => "\xE8\xA6\x95",
		"\xDB\xD1" => "\xE8\xA6\x98",
		"\xDB\xD2" => "\xE8\xA6\x97",
		"\xDB\xD3" => "\xE8\xA7\x9D",
		"\xDB\xD4" => "\xE8\xA7\x9A",
		"\xDB\xD5" => "\xE8\xA7\x9B",
		"\xDB\xD6" => "\xE8\xA9\x8E",
		"\xDB\xD7" => "\xE8\xA9\x8D",
		"\xDB\xD8" => "\xE8\xA8\xB9",
		"\xDB\xD9" => "\xE8\xA9\x99",
		"\xDB\xDA" => "\xE8\xA9\x80",
		"\xDB\xDB" => "\xE8\xA9\x97",
		"\xDB\xDC" => "\xE8\xA9\x98",
		"\xDB\xDD" => "\xE8\xA9\x84",
		"\xDB\xDE" => "\xE8\xA9\x85",
		"\xDB\xDF" => "\xE8\xA9\x92",
		"\xDB\xE0" => "\xE8\xA9\x88",
		"\xDB\xE1" => "\xE8\xA9\x91",
		"\xDB\xE2" => "\xE8\xA9\x8A",
		"\xDB\xE3" => "\xE8\xA9\x8C",
		"\xDB\xE4" => "\xE8\xA9\x8F",
		"\xDB\xE5" => "\xE8\xB1\x9F",
		"\xDB\xE6" => "\xE8\xB2\x81",
		"\xDB\xE7" => "\xE8\xB2\x80",
		"\xDB\xE8" => "\xE8\xB2\xBA",
		"\xDB\xE9" => "\xE8\xB2\xBE",
		"\xDB\xEA" => "\xE8\xB2\xB0",
		"\xDB\xEB" => "\xE8\xB2\xB9",
		"\xDB\xEC" => "\xE8\xB2\xB5",
		"\xDB\xED" => "\xE8\xB6\x84",
		"\xDB\xEE" => "\xE8\xB6\x80",
		"\xDB\xEF" => "\xE8\xB6\x89",
		"\xDB\xF0" => "\xE8\xB7\x98",
		"\xDB\xF1" => "\xE8\xB7\x93",
		"\xDB\xF2" => "\xE8\xB7\x8D",
		"\xDB\xF3" => "\xE8\xB7\x87",
		"\xDB\xF4" => "\xE8\xB7\x96",
		"\xDB\xF5" => "\xE8\xB7\x9C",
		"\xDB\xF6" => "\xE8\xB7\x8F",
		"\xDB\xF7" => "\xE8\xB7\x95",
		"\xDB\xF8" => "\xE8\xB7\x99",
		"\xDB\xF9" => "\xE8\xB7\x88",
		"\xDB\xFA" => "\xE8\xB7\x97",
		"\xDB\xFB" => "\xE8\xB7\x85",
		"\xDB\xFC" => "\xE8\xBB\xAF",
		"\xDB\xFD" => "\xE8\xBB\xB7",
		"\xDB\xFE" => "\xE8\xBB\xBA",
		"\xDC\x40" => "\xE8\xBB\xB9",
		"\xDC\x41" => "\xE8\xBB\xA6",
		"\xDC\x42" => "\xE8\xBB\xAE",
		"\xDC\x43" => "\xE8\xBB\xA5",
		"\xDC\x44" => "\xE8\xBB\xB5",
		"\xDC\x45" => "\xE8\xBB\xA7",
		"\xDC\x46" => "\xE8\xBB\xA8",
		"\xDC\x47" => "\xE8\xBB\xB6",
		"\xDC\x48" => "\xE8\xBB\xAB",
		"\xDC\x49" => "\xE8\xBB\xB1",
		"\xDC\x4A" => "\xE8\xBB\xAC",
		"\xDC\x4B" => "\xE8\xBB\xB4",
		"\xDC\x4C" => "\xE8\xBB\xA9",
		"\xDC\x4D" => "\xE9\x80\xAD",
		"\xDC\x4E" => "\xE9\x80\xB4",
		"\xDC\x4F" => "\xE9\x80\xAF",
		"\xDC\x50" => "\xE9\x84\x86",
		"\xDC\x51" => "\xE9\x84\xAC",
		"\xDC\x52" => "\xE9\x84\x84",
		"\xDC\x53" => "\xE9\x83\xBF",
		"\xDC\x54" => "\xE9\x83\xBC",
		"\xDC\x55" => "\xE9\x84\x88",
		"\xDC\x56" => "\xE9\x83\xB9",
		"\xDC\x57" => "\xE9\x83\xBB",
		"\xDC\x58" => "\xE9\x84\x81",
		"\xDC\x59" => "\xE9\x84\x80",
		"\xDC\x5A" => "\xE9\x84\x87",
		"\xDC\x5B" => "\xE9\x84\x85",
		"\xDC\x5C" => "\xE9\x84\x83",
		"\xDC\x5D" => "\xE9\x85\xA1",
		"\xDC\x5E" => "\xE9\x85\xA4",
		"\xDC\x5F" => "\xE9\x85\x9F",
		"\xDC\x60" => "\xE9\x85\xA2",
		"\xDC\x61" => "\xE9\x85\xA0",
		"\xDC\x62" => "\xE9\x88\x81",
		"\xDC\x63" => "\xE9\x88\x8A",
		"\xDC\x64" => "\xE9\x88\xA5",
		"\xDC\x65" => "\xE9\x88\x83",
		"\xDC\x66" => "\xE9\x88\x9A",
		"\xDC\x67" => "\xE9\x88\xA6",
		"\xDC\x68" => "\xE9\x88\x8F",
		"\xDC\x69" => "\xE9\x88\x8C",
		"\xDC\x6A" => "\xE9\x88\x80",
		"\xDC\x6B" => "\xE9\x88\x92",
		"\xDC\x6C" => "\xE9\x87\xBF",
		"\xDC\x6D" => "\xE9\x87\xBD",
		"\xDC\x6E" => "\xE9\x88\x86",
		"\xDC\x6F" => "\xE9\x88\x84",
		"\xDC\x70" => "\xE9\x88\xA7",
		"\xDC\x71" => "\xE9\x88\x82",
		"\xDC\x72" => "\xE9\x88\x9C",
		"\xDC\x73" => "\xE9\x88\xA4",
		"\xDC\x74" => "\xE9\x88\x99",
		"\xDC\x75" => "\xE9\x88\x97",
		"\xDC\x76" => "\xE9\x88\x85",
		"\xDC\x77" => "\xE9\x88\x96",
		"\xDC\x78" => "\xE9\x95\xBB",
		"\xDC\x79" => "\xE9\x96\x8D",
		"\xDC\x7A" => "\xE9\x96\x8C",
		"\xDC\x7B" => "\xE9\x96\x90",
		"\xDC\x7C" => "\xE9\x9A\x87",
		"\xDC\x7D" => "\xE9\x99\xBE",
		"\xDC\x7E" => "\xE9\x9A\x88",
		"\xDC\xA1" => "\xE9\x9A\x89",
		"\xDC\xA2" => "\xE9\x9A\x83",
		"\xDC\xA3" => "\xE9\x9A\x80",
		"\xDC\xA4" => "\xE9\x9B\x82",
		"\xDC\xA5" => "\xE9\x9B\x88",
		"\xDC\xA6" => "\xE9\x9B\x83",
		"\xDC\xA7" => "\xE9\x9B\xB1",
		"\xDC\xA8" => "\xE9\x9B\xB0",
		"\xDC\xA9" => "\xE9\x9D\xAC",
		"\xDC\xAA" => "\xE9\x9D\xB0",
		"\xDC\xAB" => "\xE9\x9D\xAE",
		"\xDC\xAC" => "\xE9\xA0\x87",
		"\xDC\xAD" => "\xE9\xA2\xA9",
		"\xDC\xAE" => "\xE9\xA3\xAB",
		"\xDC\xAF" => "\xE9\xB3\xA6",
		"\xDC\xB0" => "\xE9\xBB\xB9",
		"\xDC\xB1" => "\xE4\xBA\x83",
		"\xDC\xB2" => "\xE4\xBA\x84",
		"\xDC\xB3" => "\xE4\xBA\xB6",
		"\xDC\xB4" => "\xE5\x82\xBD",
		"\xDC\xB5" => "\xE5\x82\xBF",
		"\xDC\xB6" => "\xE5\x83\x86",
		"\xDC\xB7" => "\xE5\x82\xAE",
		"\xDC\xB8" => "\xE5\x83\x84",
		"\xDC\xB9" => "\xE5\x83\x8A",
		"\xDC\xBA" => "\xE5\x82\xB4",
		"\xDC\xBB" => "\xE5\x83\x88",
		"\xDC\xBC" => "\xE5\x83\x82",
		"\xDC\xBD" => "\xE5\x82\xB0",
		"\xDC\xBE" => "\xE5\x83\x81",
		"\xDC\xBF" => "\xE5\x82\xBA",
		"\xDC\xC0" => "\xE5\x82\xB1",
		"\xDC\xC1" => "\xE5\x83\x8B",
		"\xDC\xC2" => "\xE5\x83\x89",
		"\xDC\xC3" => "\xE5\x82\xB6",
		"\xDC\xC4" => "\xE5\x82\xB8",
		"\xDC\xC5" => "\xE5\x87\x97",
		"\xDC\xC6" => "\xE5\x89\xBA",
		"\xDC\xC7" => "\xE5\x89\xB8",
		"\xDC\xC8" => "\xE5\x89\xBB",
		"\xDC\xC9" => "\xE5\x89\xBC",
		"\xDC\xCA" => "\xE5\x97\x83",
		"\xDC\xCB" => "\xE5\x97\x9B",
		"\xDC\xCC" => "\xE5\x97\x8C",
		"\xDC\xCD" => "\xE5\x97\x90",
		"\xDC\xCE" => "\xE5\x97\x8B",
		"\xDC\xCF" => "\xE5\x97\x8A",
		"\xDC\xD0" => "\xE5\x97\x9D",
		"\xDC\xD1" => "\xE5\x97\x80",
		"\xDC\xD2" => "\xE5\x97\x94",
		"\xDC\xD3" => "\xE5\x97\x84",
		"\xDC\xD4" => "\xE5\x97\xA9",
		"\xDC\xD5" => "\xE5\x96\xBF",
		"\xDC\xD6" => "\xE5\x97\x92",
		"\xDC\xD7" => "\xE5\x96\x8D",
		"\xDC\xD8" => "\xE5\x97\x8F",
		"\xDC\xD9" => "\xE5\x97\x95",
		"\xDC\xDA" => "\xE5\x97\xA2",
		"\xDC\xDB" => "\xE5\x97\x96",
		"\xDC\xDC" => "\xE5\x97\x88",
		"\xDC\xDD" => "\xE5\x97\xB2",
		"\xDC\xDE" => "\xE5\x97\x8D",
		"\xDC\xDF" => "\xE5\x97\x99",
		"\xDC\xE0" => "\xE5\x97\x82",
		"\xDC\xE1" => "\xE5\x9C\x94",
		"\xDC\xE2" => "\xE5\xA1\x93",
		"\xDC\xE3" => "\xE5\xA1\xA8",
		"\xDC\xE4" => "\xE5\xA1\xA4",
		"\xDC\xE5" => "\xE5\xA1\x8F",
		"\xDC\xE6" => "\xE5\xA1\x8D",
		"\xDC\xE7" => "\xE5\xA1\x89",
		"\xDC\xE8" => "\xE5\xA1\xAF",
		"\xDC\xE9" => "\xE5\xA1\x95",
		"\xDC\xEA" => "\xE5\xA1\x8E",
		"\xDC\xEB" => "\xE5\xA1\x9D",
		"\xDC\xEC" => "\xE5\xA1\x99",
		"\xDC\xED" => "\xE5\xA1\xA5",
		"\xDC\xEE" => "\xE5\xA1\x9B",
		"\xDC\xEF" => "\xE5\xA0\xBD",
		"\xDC\xF0" => "\xE5\xA1\xA3",
		"\xDC\xF1" => "\xE5\xA1\xB1",
		"\xDC\xF2" => "\xE5\xA3\xBC",
		"\xDC\xF3" => "\xE5\xAB\x87",
		"\xDC\xF4" => "\xE5\xAB\x84",
		"\xDC\xF5" => "\xE5\xAB\x8B",
		"\xDC\xF6" => "\xE5\xAA\xBA",
		"\xDC\xF7" => "\xE5\xAA\xB8",
		"\xDC\xF8" => "\xE5\xAA\xB1",
		"\xDC\xF9" => "\xE5\xAA\xB5",
		"\xDC\xFA" => "\xE5\xAA\xB0",
		"\xDC\xFB" => "\xE5\xAA\xBF",
		"\xDC\xFC" => "\xE5\xAB\x88",
		"\xDC\xFD" => "\xE5\xAA\xBB",
		"\xDC\xFE" => "\xE5\xAB\x86",
		"\xDD\x40" => "\xE5\xAA\xB7",
		"\xDD\x41" => "\xE5\xAB\x80",
		"\xDD\x42" => "\xE5\xAB\x8A",
		"\xDD\x43" => "\xE5\xAA\xB4",
		"\xDD\x44" => "\xE5\xAA\xB6",
		"\xDD\x45" => "\xE5\xAB\x8D",
		"\xDD\x46" => "\xE5\xAA\xB9",
		"\xDD\x47" => "\xE5\xAA\x90",
		"\xDD\x48" => "\xE5\xAF\x96",
		"\xDD\x49" => "\xE5\xAF\x98",
		"\xDD\x4A" => "\xE5\xAF\x99",
		"\xDD\x4B" => "\xE5\xB0\x9F",
		"\xDD\x4C" => "\xE5\xB0\xB3",
		"\xDD\x4D" => "\xE5\xB5\xB1",
		"\xDD\x4E" => "\xE5\xB5\xA3",
		"\xDD\x4F" => "\xE5\xB5\x8A",
		"\xDD\x50" => "\xE5\xB5\xA5",
		"\xDD\x51" => "\xE5\xB5\xB2",
		"\xDD\x52" => "\xE5\xB5\xAC",
		"\xDD\x53" => "\xE5\xB5\x9E",
		"\xDD\x54" => "\xE5\xB5\xA8",
		"\xDD\x55" => "\xE5\xB5\xA7",
		"\xDD\x56" => "\xE5\xB5\xA2",
		"\xDD\x57" => "\xE5\xB7\xB0",
		"\xDD\x58" => "\xE5\xB9\x8F",
		"\xDD\x59" => "\xE5\xB9\x8E",
		"\xDD\x5A" => "\xE5\xB9\x8A",
		"\xDD\x5B" => "\xE5\xB9\x8D",
		"\xDD\x5C" => "\xE5\xB9\x8B",
		"\xDD\x5D" => "\xE5\xBB\x85",
		"\xDD\x5E" => "\xE5\xBB\x8C",
		"\xDD\x5F" => "\xE5\xBB\x86",
		"\xDD\x60" => "\xE5\xBB\x8B",
		"\xDD\x61" => "\xE5\xBB\x87",
		"\xDD\x62" => "\xE5\xBD\x80",
		"\xDD\x63" => "\xE5\xBE\xAF",
		"\xDD\x64" => "\xE5\xBE\xAD",
		"\xDD\x65" => "\xE6\x83\xB7",
		"\xDD\x66" => "\xE6\x85\x89",
		"\xDD\x67" => "\xE6\x85\x8A",
		"\xDD\x68" => "\xE6\x84\xAB",
		"\xDD\x69" => "\xE6\x85\x85",
		"\xDD\x6A" => "\xE6\x84\xB6",
		"\xDD\x6B" => "\xE6\x84\xB2",
		"\xDD\x6C" => "\xE6\x84\xAE",
		"\xDD\x6D" => "\xE6\x85\x86",
		"\xDD\x6E" => "\xE6\x84\xAF",
		"\xDD\x6F" => "\xE6\x85\x8F",
		"\xDD\x70" => "\xE6\x84\xA9",
		"\xDD\x71" => "\xE6\x85\x80",
		"\xDD\x72" => "\xE6\x88\xA0",
		"\xDD\x73" => "\xE9\x85\xA8",
		"\xDD\x74" => "\xE6\x88\xA3",
		"\xDD\x75" => "\xE6\x88\xA5",
		"\xDD\x76" => "\xE6\x88\xA4",
		"\xDD\x77" => "\xE6\x8F\x85",
		"\xDD\x78" => "\xE6\x8F\xB1",
		"\xDD\x79" => "\xE6\x8F\xAB",
		"\xDD\x7A" => "\xE6\x90\x90",
		"\xDD\x7B" => "\xE6\x90\x92",
		"\xDD\x7C" => "\xE6\x90\x89",
		"\xDD\x7D" => "\xE6\x90\xA0",
		"\xDD\x7E" => "\xE6\x90\xA4",
		"\xDD\xA1" => "\xE6\x90\xB3",
		"\xDD\xA2" => "\xE6\x91\x83",
		"\xDD\xA3" => "\xE6\x90\x9F",
		"\xDD\xA4" => "\xE6\x90\x95",
		"\xDD\xA5" => "\xE6\x90\x98",
		"\xDD\xA6" => "\xE6\x90\xB9",
		"\xDD\xA7" => "\xE6\x90\xB7",
		"\xDD\xA8" => "\xE6\x90\xA2",
		"\xDD\xA9" => "\xE6\x90\xA3",
		"\xDD\xAA" => "\xE6\x90\x8C",
		"\xDD\xAB" => "\xE6\x90\xA6",
		"\xDD\xAC" => "\xE6\x90\xB0",
		"\xDD\xAD" => "\xE6\x90\xA8",
		"\xDD\xAE" => "\xE6\x91\x81",
		"\xDD\xAF" => "\xE6\x90\xB5",
		"\xDD\xB0" => "\xE6\x90\xAF",
		"\xDD\xB1" => "\xE6\x90\x8A",
		"\xDD\xB2" => "\xE6\x90\x9A",
		"\xDD\xB3" => "\xE6\x91\x80",
		"\xDD\xB4" => "\xE6\x90\xA5",
		"\xDD\xB5" => "\xE6\x90\xA7",
		"\xDD\xB6" => "\xE6\x90\x8B",
		"\xDD\xB7" => "\xE6\x8F\xA7",
		"\xDD\xB8" => "\xE6\x90\x9B",
		"\xDD\xB9" => "\xE6\x90\xAE",
		"\xDD\xBA" => "\xE6\x90\xA1",
		"\xDD\xBB" => "\xE6\x90\x8E",
		"\xDD\xBC" => "\xE6\x95\xAF",
		"\xDD\xBD" => "\xE6\x96\x92",
		"\xDD\xBE" => "\xE6\x97\x93",
		"\xDD\xBF" => "\xE6\x9A\x86",
		"\xDD\xC0" => "\xE6\x9A\x8C",
		"\xDD\xC1" => "\xE6\x9A\x95",
		"\xDD\xC2" => "\xE6\x9A\x90",
		"\xDD\xC3" => "\xE6\x9A\x8B",
		"\xDD\xC4" => "\xE6\x9A\x8A",
		"\xDD\xC5" => "\xE6\x9A\x99",
		"\xDD\xC6" => "\xE6\x9A\x94",
		"\xDD\xC7" => "\xE6\x99\xB8",
		"\xDD\xC8" => "\xE6\x9C\xA0",
		"\xDD\xC9" => "\xE6\xA5\xA6",
		"\xDD\xCA" => "\xE6\xA5\x9F",
		"\xDD\xCB" => "\xE6\xA4\xB8",
		"\xDD\xCC" => "\xE6\xA5\x8E",
		"\xDD\xCD" => "\xE6\xA5\xA2",
		"\xDD\xCE" => "\xE6\xA5\xB1",
		"\xDD\xCF" => "\xE6\xA4\xBF",
		"\xDD\xD0" => "\xE6\xA5\x85",
		"\xDD\xD1" => "\xE6\xA5\xAA",
		"\xDD\xD2" => "\xE6\xA4\xB9",
		"\xDD\xD3" => "\xE6\xA5\x82",
		"\xDD\xD4" => "\xE6\xA5\x97",
		"\xDD\xD5" => "\xE6\xA5\x99",
		"\xDD\xD6" => "\xE6\xA5\xBA",
		"\xDD\xD7" => "\xE6\xA5\x88",
		"\xDD\xD8" => "\xE6\xA5\x89",
		"\xDD\xD9" => "\xE6\xA4\xB5",
		"\xDD\xDA" => "\xE6\xA5\xAC",
		"\xDD\xDB" => "\xE6\xA4\xB3",
		"\xDD\xDC" => "\xE6\xA4\xBD",
		"\xDD\xDD" => "\xE6\xA5\xA5",
		"\xDD\xDE" => "\xE6\xA3\xB0",
		"\xDD\xDF" => "\xE6\xA5\xB8",
		"\xDD\xE0" => "\xE6\xA4\xB4",
		"\xDD\xE1" => "\xE6\xA5\xA9",
		"\xDD\xE2" => "\xE6\xA5\x80",
		"\xDD\xE3" => "\xE6\xA5\xAF",
		"\xDD\xE4" => "\xE6\xA5\x84",
		"\xDD\xE5" => "\xE6\xA5\xB6",
		"\xDD\xE6" => "\xE6\xA5\x98",
		"\xDD\xE7" => "\xE6\xA5\x81",
		"\xDD\xE8" => "\xE6\xA5\xB4",
		"\xDD\xE9" => "\xE6\xA5\x8C",
		"\xDD\xEA" => "\xE6\xA4\xBB",
		"\xDD\xEB" => "\xE6\xA5\x8B",
		"\xDD\xEC" => "\xE6\xA4\xB7",
		"\xDD\xED" => "\xE6\xA5\x9C",
		"\xDD\xEE" => "\xE6\xA5\x8F",
		"\xDD\xEF" => "\xE6\xA5\x91",
		"\xDD\xF0" => "\xE6\xA4\xB2",
		"\xDD\xF1" => "\xE6\xA5\x92",
		"\xDD\xF2" => "\xE6\xA4\xAF",
		"\xDD\xF3" => "\xE6\xA5\xBB",
		"\xDD\xF4" => "\xE6\xA4\xBC",
		"\xDD\xF5" => "\xE6\xAD\x86",
		"\xDD\xF6" => "\xE6\xAD\x85",
		"\xDD\xF7" => "\xE6\xAD\x83",
		"\xDD\xF8" => "\xE6\xAD\x82",
		"\xDD\xF9" => "\xE6\xAD\x88",
		"\xDD\xFA" => "\xE6\xAD\x81",
		"\xDD\xFB" => "\xE6\xAE\x9B",
		"\xDD\xFC" => "\xEF\xA8\x8D",
		"\xDD\xFD" => "\xE6\xAF\xBB",
		"\xDD\xFE" => "\xE6\xAF\xBC",
		"\xDE\x40" => "\xE6\xAF\xB9",
		"\xDE\x41" => "\xE6\xAF\xB7",
		"\xDE\x42" => "\xE6\xAF\xB8",
		"\xDE\x43" => "\xE6\xBA\x9B",
		"\xDE\x44" => "\xE6\xBB\x96",
		"\xDE\x45" => "\xE6\xBB\x88",
		"\xDE\x46" => "\xE6\xBA\x8F",
		"\xDE\x47" => "\xE6\xBB\x80",
		"\xDE\x48" => "\xE6\xBA\x9F",
		"\xDE\x49" => "\xE6\xBA\x93",
		"\xDE\x4A" => "\xE6\xBA\x94",
		"\xDE\x4B" => "\xE6\xBA\xA0",
		"\xDE\x4C" => "\xE6\xBA\xB1",
		"\xDE\x4D" => "\xE6\xBA\xB9",
		"\xDE\x4E" => "\xE6\xBB\x86",
		"\xDE\x4F" => "\xE6\xBB\x92",
		"\xDE\x50" => "\xE6\xBA\xBD",
		"\xDE\x51" => "\xE6\xBB\x81",
		"\xDE\x52" => "\xE6\xBA\x9E",
		"\xDE\x53" => "\xE6\xBB\x89",
		"\xDE\x54" => "\xE6\xBA\xB7",
		"\xDE\x55" => "\xE6\xBA\xB0",
		"\xDE\x56" => "\xE6\xBB\x8D",
		"\xDE\x57" => "\xE6\xBA\xA6",
		"\xDE\x58" => "\xE6\xBB\x8F",
		"\xDE\x59" => "\xE6\xBA\xB2",
		"\xDE\x5A" => "\xE6\xBA\xBE",
		"\xDE\x5B" => "\xE6\xBB\x83",
		"\xDE\x5C" => "\xE6\xBB\x9C",
		"\xDE\x5D" => "\xE6\xBB\x98",
		"\xDE\x5E" => "\xE6\xBA\x99",
		"\xDE\x5F" => "\xE6\xBA\x92",
		"\xDE\x60" => "\xE6\xBA\x8E",
		"\xDE\x61" => "\xE6\xBA\x8D",
		"\xDE\x62" => "\xE6\xBA\xA4",
		"\xDE\x63" => "\xE6\xBA\xA1",
		"\xDE\x64" => "\xE6\xBA\xBF",
		"\xDE\x65" => "\xE6\xBA\xB3",
		"\xDE\x66" => "\xE6\xBB\x90",
		"\xDE\x67" => "\xE6\xBB\x8A",
		"\xDE\x68" => "\xE6\xBA\x97",
		"\xDE\x69" => "\xE6\xBA\xAE",
		"\xDE\x6A" => "\xE6\xBA\xA3",
		"\xDE\x6B" => "\xE7\x85\x87",
		"\xDE\x6C" => "\xE7\x85\x94",
		"\xDE\x6D" => "\xE7\x85\x92",
		"\xDE\x6E" => "\xE7\x85\xA3",
		"\xDE\x6F" => "\xE7\x85\xA0",
		"\xDE\x70" => "\xE7\x85\x81",
		"\xDE\x71" => "\xE7\x85\x9D",
		"\xDE\x72" => "\xE7\x85\xA2",
		"\xDE\x73" => "\xE7\x85\xB2",
		"\xDE\x74" => "\xE7\x85\xB8",
		"\xDE\x75" => "\xE7\x85\xAA",
		"\xDE\x76" => "\xE7\x85\xA1",
		"\xDE\x77" => "\xE7\x85\x82",
		"\xDE\x78" => "\xE7\x85\x98",
		"\xDE\x79" => "\xE7\x85\x83",
		"\xDE\x7A" => "\xE7\x85\x8B",
		"\xDE\x7B" => "\xE7\x85\xB0",
		"\xDE\x7C" => "\xE7\x85\x9F",
		"\xDE\x7D" => "\xE7\x85\x90",
		"\xDE\x7E" => "\xE7\x85\x93",
		"\xDE\xA1" => "\xE7\x85\x84",
		"\xDE\xA2" => "\xE7\x85\x8D",
		"\xDE\xA3" => "\xE7\x85\x9A",
		"\xDE\xA4" => "\xE7\x89\x8F",
		"\xDE\xA5" => "\xE7\x8A\x8D",
		"\xDE\xA6" => "\xE7\x8A\x8C",
		"\xDE\xA7" => "\xE7\x8A\x91",
		"\xDE\xA8" => "\xE7\x8A\x90",
		"\xDE\xA9" => "\xE7\x8A\x8E",
		"\xDE\xAA" => "\xE7\x8C\xBC",
		"\xDE\xAB" => "\xE7\x8D\x82",
		"\xDE\xAC" => "\xE7\x8C\xBB",
		"\xDE\xAD" => "\xE7\x8C\xBA",
		"\xDE\xAE" => "\xE7\x8D\x80",
		"\xDE\xAF" => "\xE7\x8D\x8A",
		"\xDE\xB0" => "\xE7\x8D\x89",
		"\xDE\xB1" => "\xE7\x91\x84",
		"\xDE\xB2" => "\xE7\x91\x8A",
		"\xDE\xB3" => "\xE7\x91\x8B",
		"\xDE\xB4" => "\xE7\x91\x92",
		"\xDE\xB5" => "\xE7\x91\x91",
		"\xDE\xB6" => "\xE7\x91\x97",
		"\xDE\xB7" => "\xE7\x91\x80",
		"\xDE\xB8" => "\xE7\x91\x8F",
		"\xDE\xB9" => "\xE7\x91\x90",
		"\xDE\xBA" => "\xE7\x91\x8E",
		"\xDE\xBB" => "\xE7\x91\x82",
		"\xDE\xBC" => "\xE7\x91\x86",
		"\xDE\xBD" => "\xE7\x91\x8D",
		"\xDE\xBE" => "\xE7\x91\x94",
		"\xDE\xBF" => "\xE7\x93\xA1",
		"\xDE\xC0" => "\xE7\x93\xBF",
		"\xDE\xC1" => "\xE7\x93\xBE",
		"\xDE\xC2" => "\xE7\x93\xBD",
		"\xDE\xC3" => "\xE7\x94\x9D",
		"\xDE\xC4" => "\xE7\x95\xB9",
		"\xDE\xC5" => "\xE7\x95\xB7",
		"\xDE\xC6" => "\xE6\xA6\x83",
		"\xDE\xC7" => "\xE7\x97\xAF",
		"\xDE\xC8" => "\xE7\x98\x8F",
		"\xDE\xC9" => "\xE7\x98\x83",
		"\xDE\xCA" => "\xE7\x97\xB7",
		"\xDE\xCB" => "\xE7\x97\xBE",
		"\xDE\xCC" => "\xE7\x97\xBC",
		"\xDE\xCD" => "\xE7\x97\xB9",
		"\xDE\xCE" => "\xE7\x97\xB8",
		"\xDE\xCF" => "\xE7\x98\x90",
		"\xDE\xD0" => "\xE7\x97\xBB",
		"\xDE\xD1" => "\xE7\x97\xB6",
		"\xDE\xD2" => "\xE7\x97\xAD",
		"\xDE\xD3" => "\xE7\x97\xB5",
		"\xDE\xD4" => "\xE7\x97\xBD",
		"\xDE\xD5" => "\xE7\x9A\x99",
		"\xDE\xD6" => "\xE7\x9A\xB5",
		"\xDE\xD7" => "\xE7\x9B\x9D",
		"\xDE\xD8" => "\xE7\x9D\x95",
		"\xDE\xD9" => "\xE7\x9D\x9F",
		"\xDE\xDA" => "\xE7\x9D\xA0",
		"\xDE\xDB" => "\xE7\x9D\x92",
		"\xDE\xDC" => "\xE7\x9D\x96",
		"\xDE\xDD" => "\xE7\x9D\x9A",
		"\xDE\xDE" => "\xE7\x9D\xA9",
		"\xDE\xDF" => "\xE7\x9D\xA7",
		"\xDE\xE0" => "\xE7\x9D\x94",
		"\xDE\xE1" => "\xE7\x9D\x99",
		"\xDE\xE2" => "\xE7\x9D\xAD",
		"\xDE\xE3" => "\xE7\x9F\xA0",
		"\xDE\xE4" => "\xE7\xA2\x87",
		"\xDE\xE5" => "\xE7\xA2\x9A",
		"\xDE\xE6" => "\xE7\xA2\x94",
		"\xDE\xE7" => "\xE7\xA2\x8F",
		"\xDE\xE8" => "\xE7\xA2\x84",
		"\xDE\xE9" => "\xE7\xA2\x95",
		"\xDE\xEA" => "\xE7\xA2\x85",
		"\xDE\xEB" => "\xE7\xA2\x86",
		"\xDE\xEC" => "\xE7\xA2\xA1",
		"\xDE\xED" => "\xE7\xA2\x83",
		"\xDE\xEE" => "\xE7\xA1\xB9",
		"\xDE\xEF" => "\xE7\xA2\x99",
		"\xDE\xF0" => "\xE7\xA2\x80",
		"\xDE\xF1" => "\xE7\xA2\x96",
		"\xDE\xF2" => "\xE7\xA1\xBB",
		"\xDE\xF3" => "\xE7\xA5\xBC",
		"\xDE\xF4" => "\xE7\xA6\x82",
		"\xDE\xF5" => "\xE7\xA5\xBD",
		"\xDE\xF6" => "\xE7\xA5\xB9",
		"\xDE\xF7" => "\xE7\xA8\x91",
		"\xDE\xF8" => "\xE7\xA8\x98",
		"\xDE\xF9" => "\xE7\xA8\x99",
		"\xDE\xFA" => "\xE7\xA8\x92",
		"\xDE\xFB" => "\xE7\xA8\x97",
		"\xDE\xFC" => "\xE7\xA8\x95",
		"\xDE\xFD" => "\xE7\xA8\xA2",
		"\xDE\xFE" => "\xE7\xA8\x93",
		"\xDF\x40" => "\xE7\xA8\x9B",
		"\xDF\x41" => "\xE7\xA8\x90",
		"\xDF\x42" => "\xE7\xAA\xA3",
		"\xDF\x43" => "\xE7\xAA\xA2",
		"\xDF\x44" => "\xE7\xAA\x9E",
		"\xDF\x45" => "\xE7\xAB\xAB",
		"\xDF\x46" => "\xE7\xAD\xA6",
		"\xDF\x47" => "\xE7\xAD\xA4",
		"\xDF\x48" => "\xE7\xAD\xAD",
		"\xDF\x49" => "\xE7\xAD\xB4",
		"\xDF\x4A" => "\xE7\xAD\xA9",
		"\xDF\x4B" => "\xE7\xAD\xB2",
		"\xDF\x4C" => "\xE7\xAD\xA5",
		"\xDF\x4D" => "\xE7\xAD\xB3",
		"\xDF\x4E" => "\xE7\xAD\xB1",
		"\xDF\x4F" => "\xE7\xAD\xB0",
		"\xDF\x50" => "\xE7\xAD\xA1",
		"\xDF\x51" => "\xE7\xAD\xB8",
		"\xDF\x52" => "\xE7\xAD\xB6",
		"\xDF\x53" => "\xE7\xAD\xA3",
		"\xDF\x54" => "\xE7\xB2\xB2",
		"\xDF\x55" => "\xE7\xB2\xB4",
		"\xDF\x56" => "\xE7\xB2\xAF",
		"\xDF\x57" => "\xE7\xB6\x88",
		"\xDF\x58" => "\xE7\xB6\x86",
		"\xDF\x59" => "\xE7\xB6\x80",
		"\xDF\x5A" => "\xE7\xB6\x8D",
		"\xDF\x5B" => "\xE7\xB5\xBF",
		"\xDF\x5C" => "\xE7\xB6\x85",
		"\xDF\x5D" => "\xE7\xB5\xBA",
		"\xDF\x5E" => "\xE7\xB6\x8E",
		"\xDF\x5F" => "\xE7\xB5\xBB",
		"\xDF\x60" => "\xE7\xB6\x83",
		"\xDF\x61" => "\xE7\xB5\xBC",
		"\xDF\x62" => "\xE7\xB6\x8C",
		"\xDF\x63" => "\xE7\xB6\x94",
		"\xDF\x64" => "\xE7\xB6\x84",
		"\xDF\x65" => "\xE7\xB5\xBD",
		"\xDF\x66" => "\xE7\xB6\x92",
		"\xDF\x67" => "\xE7\xBD\xAD",
		"\xDF\x68" => "\xE7\xBD\xAB",
		"\xDF\x69" => "\xE7\xBD\xA7",
		"\xDF\x6A" => "\xE7\xBD\xA8",
		"\xDF\x6B" => "\xE7\xBD\xAC",
		"\xDF\x6C" => "\xE7\xBE\xA6",
		"\xDF\x6D" => "\xE7\xBE\xA5",
		"\xDF\x6E" => "\xE7\xBE\xA7",
		"\xDF\x6F" => "\xE7\xBF\x9B",
		"\xDF\x70" => "\xE7\xBF\x9C",
		"\xDF\x71" => "\xE8\x80\xA1",
		"\xDF\x72" => "\xE8\x85\xA4",
		"\xDF\x73" => "\xE8\x85\xA0",
		"\xDF\x74" => "\xE8\x85\xB7",
		"\xDF\x75" => "\xE8\x85\x9C",
		"\xDF\x76" => "\xE8\x85\xA9",
		"\xDF\x77" => "\xE8\x85\x9B",
		"\xDF\x78" => "\xE8\x85\xA2",
		"\xDF\x79" => "\xE8\x85\xB2",
		"\xDF\x7A" => "\xE6\x9C\xA1",
		"\xDF\x7B" => "\xE8\x85\x9E",
		"\xDF\x7C" => "\xE8\x85\xB6",
		"\xDF\x7D" => "\xE8\x85\xA7",
		"\xDF\x7E" => "\xE8\x85\xAF",
		"\xDF\xA1" => "\xE8\x85\x84",
		"\xDF\xA2" => "\xE8\x85\xA1",
		"\xDF\xA3" => "\xE8\x88\x9D",
		"\xDF\xA4" => "\xE8\x89\x89",
		"\xDF\xA5" => "\xE8\x89\x84",
		"\xDF\xA6" => "\xE8\x89\x80",
		"\xDF\xA7" => "\xE8\x89\x82",
		"\xDF\xA8" => "\xE8\x89\x85",
		"\xDF\xA9" => "\xE8\x93\xB1",
		"\xDF\xAA" => "\xE8\x90\xBF",
		"\xDF\xAB" => "\xE8\x91\x96",
		"\xDF\xAC" => "\xE8\x91\xB6",
		"\xDF\xAD" => "\xE8\x91\xB9",
		"\xDF\xAE" => "\xE8\x92\x8F",
		"\xDF\xAF" => "\xE8\x92\x8D",
		"\xDF\xB0" => "\xE8\x91\xA5",
		"\xDF\xB1" => "\xE8\x91\x91",
		"\xDF\xB2" => "\xE8\x91\x80",
		"\xDF\xB3" => "\xE8\x92\x86",
		"\xDF\xB4" => "\xE8\x91\xA7",
		"\xDF\xB5" => "\xE8\x90\xB0",
		"\xDF\xB6" => "\xE8\x91\x8D",
		"\xDF\xB7" => "\xE8\x91\xBD",
		"\xDF\xB8" => "\xE8\x91\x9A",
		"\xDF\xB9" => "\xE8\x91\x99",
		"\xDF\xBA" => "\xE8\x91\xB4",
		"\xDF\xBB" => "\xE8\x91\xB3",
		"\xDF\xBC" => "\xE8\x91\x9D",
		"\xDF\xBD" => "\xE8\x94\x87",
		"\xDF\xBE" => "\xE8\x91\x9E",
		"\xDF\xBF" => "\xE8\x90\xB7",
		"\xDF\xC0" => "\xE8\x90\xBA",
		"\xDF\xC1" => "\xE8\x90\xB4",
		"\xDF\xC2" => "\xE8\x91\xBA",
		"\xDF\xC3" => "\xE8\x91\x83",
		"\xDF\xC4" => "\xE8\x91\xB8",
		"\xDF\xC5" => "\xE8\x90\xB2",
		"\xDF\xC6" => "\xE8\x91\x85",
		"\xDF\xC7" => "\xE8\x90\xA9",
		"\xDF\xC8" => "\xE8\x8F\x99",
		"\xDF\xC9" => "\xE8\x91\x8B",
		"\xDF\xCA" => "\xE8\x90\xAF",
		"\xDF\xCB" => "\xE8\x91\x82",
		"\xDF\xCC" => "\xE8\x90\xAD",
		"\xDF\xCD" => "\xE8\x91\x9F",
		"\xDF\xCE" => "\xE8\x91\xB0",
		"\xDF\xCF" => "\xE8\x90\xB9",
		"\xDF\xD0" => "\xE8\x91\x8E",
		"\xDF\xD1" => "\xE8\x91\x8C",
		"\xDF\xD2" => "\xE8\x91\x92",
		"\xDF\xD3" => "\xE8\x91\xAF",
		"\xDF\xD4" => "\xE8\x93\x85",
		"\xDF\xD5" => "\xE8\x92\x8E",
		"\xDF\xD6" => "\xE8\x90\xBB",
		"\xDF\xD7" => "\xE8\x91\x87",
		"\xDF\xD8" => "\xE8\x90\xB6",
		"\xDF\xD9" => "\xE8\x90\xB3",
		"\xDF\xDA" => "\xE8\x91\xA8",
		"\xDF\xDB" => "\xE8\x91\xBE",
		"\xDF\xDC" => "\xE8\x91\x84",
		"\xDF\xDD" => "\xE8\x90\xAB",
		"\xDF\xDE" => "\xE8\x91\xA0",
		"\xDF\xDF" => "\xE8\x91\x94",
		"\xDF\xE0" => "\xE8\x91\xAE",
		"\xDF\xE1" => "\xE8\x91\x90",
		"\xDF\xE2" => "\xE8\x9C\x8B",
		"\xDF\xE3" => "\xE8\x9C\x84",
		"\xDF\xE4" => "\xE8\x9B\xB7",
		"\xDF\xE5" => "\xE8\x9C\x8C",
		"\xDF\xE6" => "\xE8\x9B\xBA",
		"\xDF\xE7" => "\xE8\x9B\x96",
		"\xDF\xE8" => "\xE8\x9B\xB5",
		"\xDF\xE9" => "\xE8\x9D\x8D",
		"\xDF\xEA" => "\xE8\x9B\xB8",
		"\xDF\xEB" => "\xE8\x9C\x8E",
		"\xDF\xEC" => "\xE8\x9C\x89",
		"\xDF\xED" => "\xE8\x9C\x81",
		"\xDF\xEE" => "\xE8\x9B\xB6",
		"\xDF\xEF" => "\xE8\x9C\x8D",
		"\xDF\xF0" => "\xE8\x9C\x85",
		"\xDF\xF1" => "\xE8\xA3\x96",
		"\xDF\xF2" => "\xE8\xA3\x8B",
		"\xDF\xF3" => "\xE8\xA3\x8D",
		"\xDF\xF4" => "\xE8\xA3\x8E",
		"\xDF\xF5" => "\xE8\xA3\x9E",
		"\xDF\xF6" => "\xE8\xA3\x9B",
		"\xDF\xF7" => "\xE8\xA3\x9A",
		"\xDF\xF8" => "\xE8\xA3\x8C",
		"\xDF\xF9" => "\xE8\xA3\x90",
		"\xDF\xFA" => "\xE8\xA6\x85",
		"\xDF\xFB" => "\xE8\xA6\x9B",
		"\xDF\xFC" => "\xE8\xA7\x9F",
		"\xDF\xFD" => "\xE8\xA7\xA5",
		"\xDF\xFE" => "\xE8\xA7\xA4",
		"\xE0\x40" => "\xE8\xA7\xA1",
		"\xE0\x41" => "\xE8\xA7\xA0",
		"\xE0\x42" => "\xE8\xA7\xA2",
		"\xE0\x43" => "\xE8\xA7\x9C",
		"\xE0\x44" => "\xE8\xA7\xA6",
		"\xE0\x45" => "\xE8\xA9\xB6",
		"\xE0\x46" => "\xE8\xAA\x86",
		"\xE0\x47" => "\xE8\xA9\xBF",
		"\xE0\x48" => "\xE8\xA9\xA1",
		"\xE0\x49" => "\xE8\xA8\xBF",
		"\xE0\x4A" => "\xE8\xA9\xB7",
		"\xE0\x4B" => "\xE8\xAA\x82",
		"\xE0\x4C" => "\xE8\xAA\x84",
		"\xE0\x4D" => "\xE8\xA9\xB5",
		"\xE0\x4E" => "\xE8\xAA\x83",
		"\xE0\x4F" => "\xE8\xAA\x81",
		"\xE0\x50" => "\xE8\xA9\xB4",
		"\xE0\x51" => "\xE8\xA9\xBA",
		"\xE0\x52" => "\xE8\xB0\xBC",
		"\xE0\x53" => "\xE8\xB1\x8B",
		"\xE0\x54" => "\xE8\xB1\x8A",
		"\xE0\x55" => "\xE8\xB1\xA5",
		"\xE0\x56" => "\xE8\xB1\xA4",
		"\xE0\x57" => "\xE8\xB1\xA6",
		"\xE0\x58" => "\xE8\xB2\x86",
		"\xE0\x59" => "\xE8\xB2\x84",
		"\xE0\x5A" => "\xE8\xB2\x85",
		"\xE0\x5B" => "\xE8\xB3\x8C",
		"\xE0\x5C" => "\xE8\xB5\xA8",
		"\xE0\x5D" => "\xE8\xB5\xA9",
		"\xE0\x5E" => "\xE8\xB6\x91",
		"\xE0\x5F" => "\xE8\xB6\x8C",
		"\xE0\x60" => "\xE8\xB6\x8E",
		"\xE0\x61" => "\xE8\xB6\x8F",
		"\xE0\x62" => "\xE8\xB6\x8D",
		"\xE0\x63" => "\xE8\xB6\x93",
		"\xE0\x64" => "\xE8\xB6\x94",
		"\xE0\x65" => "\xE8\xB6\x90",
		"\xE0\x66" => "\xE8\xB6\x92",
		"\xE0\x67" => "\xE8\xB7\xB0",
		"\xE0\x68" => "\xE8\xB7\xA0",
		"\xE0\x69" => "\xE8\xB7\xAC",
		"\xE0\x6A" => "\xE8\xB7\xB1",
		"\xE0\x6B" => "\xE8\xB7\xAE",
		"\xE0\x6C" => "\xE8\xB7\x90",
		"\xE0\x6D" => "\xE8\xB7\xA9",
		"\xE0\x6E" => "\xE8\xB7\xA3",
		"\xE0\x6F" => "\xE8\xB7\xA2",
		"\xE0\x70" => "\xE8\xB7\xA7",
		"\xE0\x71" => "\xE8\xB7\xB2",
		"\xE0\x72" => "\xE8\xB7\xAB",
		"\xE0\x73" => "\xE8\xB7\xB4",
		"\xE0\x74" => "\xE8\xBC\x86",
		"\xE0\x75" => "\xE8\xBB\xBF",
		"\xE0\x76" => "\xE8\xBC\x81",
		"\xE0\x77" => "\xE8\xBC\x80",
		"\xE0\x78" => "\xE8\xBC\x85",
		"\xE0\x79" => "\xE8\xBC\x87",
		"\xE0\x7A" => "\xE8\xBC\x88",
		"\xE0\x7B" => "\xE8\xBC\x82",
		"\xE0\x7C" => "\xE8\xBC\x8B",
		"\xE0\x7D" => "\xE9\x81\x92",
		"\xE0\x7E" => "\xE9\x80\xBF",
		"\xE0\xA1" => "\xE9\x81\x84",
		"\xE0\xA2" => "\xE9\x81\x89",
		"\xE0\xA3" => "\xE9\x80\xBD",
		"\xE0\xA4" => "\xE9\x84\x90",
		"\xE0\xA5" => "\xE9\x84\x8D",
		"\xE0\xA6" => "\xE9\x84\x8F",
		"\xE0\xA7" => "\xE9\x84\x91",
		"\xE0\xA8" => "\xE9\x84\x96",
		"\xE0\xA9" => "\xE9\x84\x94",
		"\xE0\xAA" => "\xE9\x84\x8B",
		"\xE0\xAB" => "\xE9\x84\x8E",
		"\xE0\xAC" => "\xE9\x85\xAE",
		"\xE0\xAD" => "\xE9\x85\xAF",
		"\xE0\xAE" => "\xE9\x89\x88",
		"\xE0\xAF" => "\xE9\x89\x92",
		"\xE0\xB0" => "\xE9\x88\xB0",
		"\xE0\xB1" => "\xE9\x88\xBA",
		"\xE0\xB2" => "\xE9\x89\xA6",
		"\xE0\xB3" => "\xE9\x88\xB3",
		"\xE0\xB4" => "\xE9\x89\xA5",
		"\xE0\xB5" => "\xE9\x89\x9E",
		"\xE0\xB6" => "\xE9\x8A\x83",
		"\xE0\xB7" => "\xE9\x88\xAE",
		"\xE0\xB8" => "\xE9\x89\x8A",
		"\xE0\xB9" => "\xE9\x89\x86",
		"\xE0\xBA" => "\xE9\x89\xAD",
		"\xE0\xBB" => "\xE9\x89\xAC",
		"\xE0\xBC" => "\xE9\x89\x8F",
		"\xE0\xBD" => "\xE9\x89\xA0",
		"\xE0\xBE" => "\xE9\x89\xA7",
		"\xE0\xBF" => "\xE9\x89\xAF",
		"\xE0\xC0" => "\xE9\x88\xB6",
		"\xE0\xC1" => "\xE9\x89\xA1",
		"\xE0\xC2" => "\xE9\x89\xB0",
		"\xE0\xC3" => "\xE9\x88\xB1",
		"\xE0\xC4" => "\xE9\x89\x94",
		"\xE0\xC5" => "\xE9\x89\xA3",
		"\xE0\xC6" => "\xE9\x89\x90",
		"\xE0\xC7" => "\xE9\x89\xB2",
		"\xE0\xC8" => "\xE9\x89\x8E",
		"\xE0\xC9" => "\xE9\x89\x93",
		"\xE0\xCA" => "\xE9\x89\x8C",
		"\xE0\xCB" => "\xE9\x89\x96",
		"\xE0\xCC" => "\xE9\x88\xB2",
		"\xE0\xCD" => "\xE9\x96\x9F",
		"\xE0\xCE" => "\xE9\x96\x9C",
		"\xE0\xCF" => "\xE9\x96\x9E",
		"\xE0\xD0" => "\xE9\x96\x9B",
		"\xE0\xD1" => "\xE9\x9A\x92",
		"\xE0\xD2" => "\xE9\x9A\x93",
		"\xE0\xD3" => "\xE9\x9A\x91",
		"\xE0\xD4" => "\xE9\x9A\x97",
		"\xE0\xD5" => "\xE9\x9B\x8E",
		"\xE0\xD6" => "\xE9\x9B\xBA",
		"\xE0\xD7" => "\xE9\x9B\xBD",
		"\xE0\xD8" => "\xE9\x9B\xB8",
		"\xE0\xD9" => "\xE9\x9B\xB5",
		"\xE0\xDA" => "\xE9\x9D\xB3",
		"\xE0\xDB" => "\xE9\x9D\xB7",
		"\xE0\xDC" => "\xE9\x9D\xB8",
		"\xE0\xDD" => "\xE9\x9D\xB2",
		"\xE0\xDE" => "\xE9\xA0\x8F",
		"\xE0\xDF" => "\xE9\xA0\x8D",
		"\xE0\xE0" => "\xE9\xA0\x8E",
		"\xE0\xE1" => "\xE9\xA2\xAC",
		"\xE0\xE2" => "\xE9\xA3\xB6",
		"\xE0\xE3" => "\xE9\xA3\xB9",
		"\xE0\xE4" => "\xE9\xA6\xAF",
		"\xE0\xE5" => "\xE9\xA6\xB2",
		"\xE0\xE6" => "\xE9\xA6\xB0",
		"\xE0\xE7" => "\xE9\xA6\xB5",
		"\xE0\xE8" => "\xE9\xAA\xAD",
		"\xE0\xE9" => "\xE9\xAA\xAB",
		"\xE0\xEA" => "\xE9\xAD\x9B",
		"\xE0\xEB" => "\xE9\xB3\xAA",
		"\xE0\xEC" => "\xE9\xB3\xAD",
		"\xE0\xED" => "\xE9\xB3\xA7",
		"\xE0\xEE" => "\xE9\xBA\x80",
		"\xE0\xEF" => "\xE9\xBB\xBD",
		"\xE0\xF0" => "\xE5\x83\xA6",
		"\xE0\xF1" => "\xE5\x83\x94",
		"\xE0\xF2" => "\xE5\x83\x97",
		"\xE0\xF3" => "\xE5\x83\xA8",
		"\xE0\xF4" => "\xE5\x83\xB3",
		"\xE0\xF5" => "\xE5\x83\x9B",
		"\xE0\xF6" => "\xE5\x83\xAA",
		"\xE0\xF7" => "\xE5\x83\x9D",
		"\xE0\xF8" => "\xE5\x83\xA4",
		"\xE0\xF9" => "\xE5\x83\x93",
		"\xE0\xFA" => "\xE5\x83\xAC",
		"\xE0\xFB" => "\xE5\x83\xB0",
		"\xE0\xFC" => "\xE5\x83\xAF",
		"\xE0\xFD" => "\xE5\x83\xA3",
		"\xE0\xFE" => "\xE5\x83\xA0",
		"\xE1\x40" => "\xE5\x87\x98",
		"\xE1\x41" => "\xE5\x8A\x80",
		"\xE1\x42" => "\xE5\x8A\x81",
		"\xE1\x43" => "\xE5\x8B\xA9",
		"\xE1\x44" => "\xE5\x8B\xAB",
		"\xE1\x45" => "\xE5\x8C\xB0",
		"\xE1\x46" => "\xE5\x8E\xAC",
		"\xE1\x47" => "\xE5\x98\xA7",
		"\xE1\x48" => "\xE5\x98\x95",
		"\xE1\x49" => "\xE5\x98\x8C",
		"\xE1\x4A" => "\xE5\x98\x92",
		"\xE1\x4B" => "\xE5\x97\xBC",
		"\xE1\x4C" => "\xE5\x98\x8F",
		"\xE1\x4D" => "\xE5\x98\x9C",
		"\xE1\x4E" => "\xE5\x98\x81",
		"\xE1\x4F" => "\xE5\x98\x93",
		"\xE1\x50" => "\xE5\x98\x82",
		"\xE1\x51" => "\xE5\x97\xBA",
		"\xE1\x52" => "\xE5\x98\x9D",
		"\xE1\x53" => "\xE5\x98\x84",
		"\xE1\x54" => "\xE5\x97\xBF",
		"\xE1\x55" => "\xE5\x97\xB9",
		"\xE1\x56" => "\xE5\xA2\x89",
		"\xE1\x57" => "\xE5\xA1\xBC",
		"\xE1\x58" => "\xE5\xA2\x90",
		"\xE1\x59" => "\xE5\xA2\x98",
		"\xE1\x5A" => "\xE5\xA2\x86",
		"\xE1\x5B" => "\xE5\xA2\x81",
		"\xE1\x5C" => "\xE5\xA1\xBF",
		"\xE1\x5D" => "\xE5\xA1\xB4",
		"\xE1\x5E" => "\xE5\xA2\x8B",
		"\xE1\x5F" => "\xE5\xA1\xBA",
		"\xE1\x60" => "\xE5\xA2\x87",
		"\xE1\x61" => "\xE5\xA2\x91",
		"\xE1\x62" => "\xE5\xA2\x8E",
		"\xE1\x63" => "\xE5\xA1\xB6",
		"\xE1\x64" => "\xE5\xA2\x82",
		"\xE1\x65" => "\xE5\xA2\x88",
		"\xE1\x66" => "\xE5\xA1\xBB",
		"\xE1\x67" => "\xE5\xA2\x94",
		"\xE1\x68" => "\xE5\xA2\x8F",
		"\xE1\x69" => "\xE5\xA3\xBE",
		"\xE1\x6A" => "\xE5\xA5\xAB",
		"\xE1\x6B" => "\xE5\xAB\x9C",
		"\xE1\x6C" => "\xE5\xAB\xAE",
		"\xE1\x6D" => "\xE5\xAB\xA5",
		"\xE1\x6E" => "\xE5\xAB\x95",
		"\xE1\x6F" => "\xE5\xAB\xAA",
		"\xE1\x70" => "\xE5\xAB\x9A",
		"\xE1\x71" => "\xE5\xAB\xAD",
		"\xE1\x72" => "\xE5\xAB\xAB",
		"\xE1\x73" => "\xE5\xAB\xB3",
		"\xE1\x74" => "\xE5\xAB\xA2",
		"\xE1\x75" => "\xE5\xAB\xA0",
		"\xE1\x76" => "\xE5\xAB\x9B",
		"\xE1\x77" => "\xE5\xAB\xAC",
		"\xE1\x78" => "\xE5\xAB\x9E",
		"\xE1\x79" => "\xE5\xAB\x9D",
		"\xE1\x7A" => "\xE5\xAB\x99",
		"\xE1\x7B" => "\xE5\xAB\xA8",
		"\xE1\x7C" => "\xE5\xAB\x9F",
		"\xE1\x7D" => "\xE5\xAD\xB7",
		"\xE1\x7E" => "\xE5\xAF\xA0",
		"\xE1\xA1" => "\xE5\xAF\xA3",
		"\xE1\xA2" => "\xE5\xB1\xA3",
		"\xE1\xA3" => "\xE5\xB6\x82",
		"\xE1\xA4" => "\xE5\xB6\x80",
		"\xE1\xA5" => "\xE5\xB5\xBD",
		"\xE1\xA6" => "\xE5\xB6\x86",
		"\xE1\xA7" => "\xE5\xB5\xBA",
		"\xE1\xA8" => "\xE5\xB6\x81",
		"\xE1\xA9" => "\xE5\xB5\xB7",
		"\xE1\xAA" => "\xE5\xB6\x8A",
		"\xE1\xAB" => "\xE5\xB6\x89",
		"\xE1\xAC" => "\xE5\xB6\x88",
		"\xE1\xAD" => "\xE5\xB5\xBE",
		"\xE1\xAE" => "\xE5\xB5\xBC",
		"\xE1\xAF" => "\xE5\xB6\x8D",
		"\xE1\xB0" => "\xE5\xB5\xB9",
		"\xE1\xB1" => "\xE5\xB5\xBF",
		"\xE1\xB2" => "\xE5\xB9\x98",
		"\xE1\xB3" => "\xE5\xB9\x99",
		"\xE1\xB4" => "\xE5\xB9\x93",
		"\xE1\xB5" => "\xE5\xBB\x98",
		"\xE1\xB6" => "\xE5\xBB\x91",
		"\xE1\xB7" => "\xE5\xBB\x97",
		"\xE1\xB8" => "\xE5\xBB\x8E",
		"\xE1\xB9" => "\xE5\xBB\x9C",
		"\xE1\xBA" => "\xE5\xBB\x95",
		"\xE1\xBB" => "\xE5\xBB\x99",
		"\xE1\xBC" => "\xE5\xBB\x92",
		"\xE1\xBD" => "\xE5\xBB\x94",
		"\xE1\xBE" => "\xE5\xBD\x84",
		"\xE1\xBF" => "\xE5\xBD\x83",
		"\xE1\xC0" => "\xE5\xBD\xAF",
		"\xE1\xC1" => "\xE5\xBE\xB6",
		"\xE1\xC2" => "\xE6\x84\xAC",
		"\xE1\xC3" => "\xE6\x84\xA8",
		"\xE1\xC4" => "\xE6\x85\x81",
		"\xE1\xC5" => "\xE6\x85\x9E",
		"\xE1\xC6" => "\xE6\x85\xB1",
		"\xE1\xC7" => "\xE6\x85\xB3",
		"\xE1\xC8" => "\xE6\x85\x92",
		"\xE1\xC9" => "\xE6\x85\x93",
		"\xE1\xCA" => "\xE6\x85\xB2",
		"\xE1\xCB" => "\xE6\x85\xAC",
		"\xE1\xCC" => "\xE6\x86\x80",
		"\xE1\xCD" => "\xE6\x85\xB4",
		"\xE1\xCE" => "\xE6\x85\x94",
		"\xE1\xCF" => "\xE6\x85\xBA",
		"\xE1\xD0" => "\xE6\x85\x9B",
		"\xE1\xD1" => "\xE6\x85\xA5",
		"\xE1\xD2" => "\xE6\x84\xBB",
		"\xE1\xD3" => "\xE6\x85\xAA",
		"\xE1\xD4" => "\xE6\x85\xA1",
		"\xE1\xD5" => "\xE6\x85\x96",
		"\xE1\xD6" => "\xE6\x88\xA9",
		"\xE1\xD7" => "\xE6\x88\xA7",
		"\xE1\xD8" => "\xE6\x88\xAB",
		"\xE1\xD9" => "\xE6\x90\xAB",
		"\xE1\xDA" => "\xE6\x91\x8D",
		"\xE1\xDB" => "\xE6\x91\x9B",
		"\xE1\xDC" => "\xE6\x91\x9D",
		"\xE1\xDD" => "\xE6\x91\xB4",
		"\xE1\xDE" => "\xE6\x91\xB6",
		"\xE1\xDF" => "\xE6\x91\xB2",
		"\xE1\xE0" => "\xE6\x91\xB3",
		"\xE1\xE1" => "\xE6\x91\xBD",
		"\xE1\xE2" => "\xE6\x91\xB5",
		"\xE1\xE3" => "\xE6\x91\xA6",
		"\xE1\xE4" => "\xE6\x92\xA6",
		"\xE1\xE5" => "\xE6\x91\x8E",
		"\xE1\xE6" => "\xE6\x92\x82",
		"\xE1\xE7" => "\xE6\x91\x9E",
		"\xE1\xE8" => "\xE6\x91\x9C",
		"\xE1\xE9" => "\xE6\x91\x8B",
		"\xE1\xEA" => "\xE6\x91\x93",
		"\xE1\xEB" => "\xE6\x91\xA0",
		"\xE1\xEC" => "\xE6\x91\x90",
		"\xE1\xED" => "\xE6\x91\xBF",
		"\xE1\xEE" => "\xE6\x90\xBF",
		"\xE1\xEF" => "\xE6\x91\xAC",
		"\xE1\xF0" => "\xE6\x91\xAB",
		"\xE1\xF1" => "\xE6\x91\x99",
		"\xE1\xF2" => "\xE6\x91\xA5",
		"\xE1\xF3" => "\xE6\x91\xB7",
		"\xE1\xF4" => "\xE6\x95\xB3",
		"\xE1\xF5" => "\xE6\x96\xA0",
		"\xE1\xF6" => "\xE6\x9A\xA1",
		"\xE1\xF7" => "\xE6\x9A\xA0",
		"\xE1\xF8" => "\xE6\x9A\x9F",
		"\xE1\xF9" => "\xE6\x9C\x85",
		"\xE1\xFA" => "\xE6\x9C\x84",
		"\xE1\xFB" => "\xE6\x9C\xA2",
		"\xE1\xFC" => "\xE6\xA6\xB1",
		"\xE1\xFD" => "\xE6\xA6\xB6",
		"\xE1\xFE" => "\xE6\xA7\x89",
		"\xE2\x40" => "\xE6\xA6\xA0",
		"\xE2\x41" => "\xE6\xA7\x8E",
		"\xE2\x42" => "\xE6\xA6\x96",
		"\xE2\x43" => "\xE6\xA6\xB0",
		"\xE2\x44" => "\xE6\xA6\xAC",
		"\xE2\x45" => "\xE6\xA6\xBC",
		"\xE2\x46" => "\xE6\xA6\x91",
		"\xE2\x47" => "\xE6\xA6\x99",
		"\xE2\x48" => "\xE6\xA6\x8E",
		"\xE2\x49" => "\xE6\xA6\xA7",
		"\xE2\x4A" => "\xE6\xA6\x8D",
		"\xE2\x4B" => "\xE6\xA6\xA9",
		"\xE2\x4C" => "\xE6\xA6\xBE",
		"\xE2\x4D" => "\xE6\xA6\xAF",
		"\xE2\x4E" => "\xE6\xA6\xBF",
		"\xE2\x4F" => "\xE6\xA7\x84",
		"\xE2\x50" => "\xE6\xA6\xBD",
		"\xE2\x51" => "\xE6\xA6\xA4",
		"\xE2\x52" => "\xE6\xA7\x94",
		"\xE2\x53" => "\xE6\xA6\xB9",
		"\xE2\x54" => "\xE6\xA7\x8A",
		"\xE2\x55" => "\xE6\xA6\x9A",
		"\xE2\x56" => "\xE6\xA7\x8F",
		"\xE2\x57" => "\xE6\xA6\xB3",
		"\xE2\x58" => "\xE6\xA6\x93",
		"\xE2\x59" => "\xE6\xA6\xAA",
		"\xE2\x5A" => "\xE6\xA6\xA1",
		"\xE2\x5B" => "\xE6\xA6\x9E",
		"\xE2\x5C" => "\xE6\xA7\x99",
		"\xE2\x5D" => "\xE6\xA6\x97",
		"\xE2\x5E" => "\xE6\xA6\x90",
		"\xE2\x5F" => "\xE6\xA7\x82",
		"\xE2\x60" => "\xE6\xA6\xB5",
		"\xE2\x61" => "\xE6\xA6\xA5",
		"\xE2\x62" => "\xE6\xA7\x86",
		"\xE2\x63" => "\xE6\xAD\x8A",
		"\xE2\x64" => "\xE6\xAD\x8D",
		"\xE2\x65" => "\xE6\xAD\x8B",
		"\xE2\x66" => "\xE6\xAE\x9E",
		"\xE2\x67" => "\xE6\xAE\x9F",
		"\xE2\x68" => "\xE6\xAE\xA0",
		"\xE2\x69" => "\xE6\xAF\x83",
		"\xE2\x6A" => "\xE6\xAF\x84",
		"\xE2\x6B" => "\xE6\xAF\xBE",
		"\xE2\x6C" => "\xE6\xBB\x8E",
		"\xE2\x6D" => "\xE6\xBB\xB5",
		"\xE2\x6E" => "\xE6\xBB\xB1",
		"\xE2\x6F" => "\xE6\xBC\x83",
		"\xE2\x70" => "\xE6\xBC\xA5",
		"\xE2\x71" => "\xE6\xBB\xB8",
		"\xE2\x72" => "\xE6\xBC\xB7",
		"\xE2\x73" => "\xE6\xBB\xBB",
		"\xE2\x74" => "\xE6\xBC\xAE",
		"\xE2\x75" => "\xE6\xBC\x89",
		"\xE2\x76" => "\xE6\xBD\x8E",
		"\xE2\x77" => "\xE6\xBC\x99",
		"\xE2\x78" => "\xE6\xBC\x9A",
		"\xE2\x79" => "\xE6\xBC\xA7",
		"\xE2\x7A" => "\xE6\xBC\x98",
		"\xE2\x7B" => "\xE6\xBC\xBB",
		"\xE2\x7C" => "\xE6\xBC\x92",
		"\xE2\x7D" => "\xE6\xBB\xAD",
		"\xE2\x7E" => "\xE6\xBC\x8A",
		"\xE2\xA1" => "\xE6\xBC\xB6",
		"\xE2\xA2" => "\xE6\xBD\xB3",
		"\xE2\xA3" => "\xE6\xBB\xB9",
		"\xE2\xA4" => "\xE6\xBB\xAE",
		"\xE2\xA5" => "\xE6\xBC\xAD",
		"\xE2\xA6" => "\xE6\xBD\x80",
		"\xE2\xA7" => "\xE6\xBC\xB0",
		"\xE2\xA8" => "\xE6\xBC\xBC",
		"\xE2\xA9" => "\xE6\xBC\xB5",
		"\xE2\xAA" => "\xE6\xBB\xAB",
		"\xE2\xAB" => "\xE6\xBC\x87",
		"\xE2\xAC" => "\xE6\xBC\x8E",
		"\xE2\xAD" => "\xE6\xBD\x83",
		"\xE2\xAE" => "\xE6\xBC\x85",
		"\xE2\xAF" => "\xE6\xBB\xBD",
		"\xE2\xB0" => "\xE6\xBB\xB6",
		"\xE2\xB1" => "\xE6\xBC\xB9",
		"\xE2\xB2" => "\xE6\xBC\x9C",
		"\xE2\xB3" => "\xE6\xBB\xBC",
		"\xE2\xB4" => "\xE6\xBC\xBA",
		"\xE2\xB5" => "\xE6\xBC\x9F",
		"\xE2\xB6" => "\xE6\xBC\x8D",
		"\xE2\xB7" => "\xE6\xBC\x9E",
		"\xE2\xB8" => "\xE6\xBC\x88",
		"\xE2\xB9" => "\xE6\xBC\xA1",
		"\xE2\xBA" => "\xE7\x86\x87",
		"\xE2\xBB" => "\xE7\x86\x90",
		"\xE2\xBC" => "\xE7\x86\x89",
		"\xE2\xBD" => "\xE7\x86\x80",
		"\xE2\xBE" => "\xE7\x86\x85",
		"\xE2\xBF" => "\xE7\x86\x82",
		"\xE2\xC0" => "\xE7\x86\x8F",
		"\xE2\xC1" => "\xE7\x85\xBB",
		"\xE2\xC2" => "\xE7\x86\x86",
		"\xE2\xC3" => "\xE7\x86\x81",
		"\xE2\xC4" => "\xE7\x86\x97",
		"\xE2\xC5" => "\xE7\x89\x84",
		"\xE2\xC6" => "\xE7\x89\x93",
		"\xE2\xC7" => "\xE7\x8A\x97",
		"\xE2\xC8" => "\xE7\x8A\x95",
		"\xE2\xC9" => "\xE7\x8A\x93",
		"\xE2\xCA" => "\xE7\x8D\x83",
		"\xE2\xCB" => "\xE7\x8D\x8D",
		"\xE2\xCC" => "\xE7\x8D\x91",
		"\xE2\xCD" => "\xE7\x8D\x8C",
		"\xE2\xCE" => "\xE7\x91\xA2",
		"\xE2\xCF" => "\xE7\x91\xB3",
		"\xE2\xD0" => "\xE7\x91\xB1",
		"\xE2\xD1" => "\xE7\x91\xB5",
		"\xE2\xD2" => "\xE7\x91\xB2",
		"\xE2\xD3" => "\xE7\x91\xA7",
		"\xE2\xD4" => "\xE7\x91\xAE",
		"\xE2\xD5" => "\xE7\x94\x80",
		"\xE2\xD6" => "\xE7\x94\x82",
		"\xE2\xD7" => "\xE7\x94\x83",
		"\xE2\xD8" => "\xE7\x95\xBD",
		"\xE2\xD9" => "\xE7\x96\x90",
		"\xE2\xDA" => "\xE7\x98\x96",
		"\xE2\xDB" => "\xE7\x98\x88",
		"\xE2\xDC" => "\xE7\x98\x8C",
		"\xE2\xDD" => "\xE7\x98\x95",
		"\xE2\xDE" => "\xE7\x98\x91",
		"\xE2\xDF" => "\xE7\x98\x8A",
		"\xE2\xE0" => "\xE7\x98\x94",
		"\xE2\xE1" => "\xE7\x9A\xB8",
		"\xE2\xE2" => "\xE7\x9E\x81",
		"\xE2\xE3" => "\xE7\x9D\xBC",
		"\xE2\xE4" => "\xE7\x9E\x85",
		"\xE2\xE5" => "\xE7\x9E\x82",
		"\xE2\xE6" => "\xE7\x9D\xAE",
		"\xE2\xE7" => "\xE7\x9E\x80",
		"\xE2\xE8" => "\xE7\x9D\xAF",
		"\xE2\xE9" => "\xE7\x9D\xBE",
		"\xE2\xEA" => "\xE7\x9E\x83",
		"\xE2\xEB" => "\xE7\xA2\xB2",
		"\xE2\xEC" => "\xE7\xA2\xAA",
		"\xE2\xED" => "\xE7\xA2\xB4",
		"\xE2\xEE" => "\xE7\xA2\xAD",
		"\xE2\xEF" => "\xE7\xA2\xA8",
		"\xE2\xF0" => "\xE7\xA1\xBE",
		"\xE2\xF1" => "\xE7\xA2\xAB",
		"\xE2\xF2" => "\xE7\xA2\x9E",
		"\xE2\xF3" => "\xE7\xA2\xA5",
		"\xE2\xF4" => "\xE7\xA2\xA0",
		"\xE2\xF5" => "\xE7\xA2\xAC",
		"\xE2\xF6" => "\xE7\xA2\xA2",
		"\xE2\xF7" => "\xE7\xA2\xA4",
		"\xE2\xF8" => "\xE7\xA6\x98",
		"\xE2\xF9" => "\xE7\xA6\x8A",
		"\xE2\xFA" => "\xE7\xA6\x8B",
		"\xE2\xFB" => "\xE7\xA6\x96",
		"\xE2\xFC" => "\xE7\xA6\x95",
		"\xE2\xFD" => "\xE7\xA6\x94",
		"\xE2\xFE" => "\xE7\xA6\x93",
		"\xE3\x40" => "\xE7\xA6\x97",
		"\xE3\x41" => "\xE7\xA6\x88",
		"\xE3\x42" => "\xE7\xA6\x92",
		"\xE3\x43" => "\xE7\xA6\x90",
		"\xE3\x44" => "\xE7\xA8\xAB",
		"\xE3\x45" => "\xE7\xA9\x8A",
		"\xE3\x46" => "\xE7\xA8\xB0",
		"\xE3\x47" => "\xE7\xA8\xAF",
		"\xE3\x48" => "\xE7\xA8\xA8",
		"\xE3\x49" => "\xE7\xA8\xA6",
		"\xE3\x4A" => "\xE7\xAA\xA8",
		"\xE3\x4B" => "\xE7\xAA\xAB",
		"\xE3\x4C" => "\xE7\xAA\xAC",
		"\xE3\x4D" => "\xE7\xAB\xAE",
		"\xE3\x4E" => "\xE7\xAE\x88",
		"\xE3\x4F" => "\xE7\xAE\x9C",
		"\xE3\x50" => "\xE7\xAE\x8A",
		"\xE3\x51" => "\xE7\xAE\x91",
		"\xE3\x52" => "\xE7\xAE\x90",
		"\xE3\x53" => "\xE7\xAE\x96",
		"\xE3\x54" => "\xE7\xAE\x8D",
		"\xE3\x55" => "\xE7\xAE\x8C",
		"\xE3\x56" => "\xE7\xAE\x9B",
		"\xE3\x57" => "\xE7\xAE\x8E",
		"\xE3\x58" => "\xE7\xAE\x85",
		"\xE3\x59" => "\xE7\xAE\x98",
		"\xE3\x5A" => "\xE5\x8A\x84",
		"\xE3\x5B" => "\xE7\xAE\x99",
		"\xE3\x5C" => "\xE7\xAE\xA4",
		"\xE3\x5D" => "\xE7\xAE\x82",
		"\xE3\x5E" => "\xE7\xB2\xBB",
		"\xE3\x5F" => "\xE7\xB2\xBF",
		"\xE3\x60" => "\xE7\xB2\xBC",
		"\xE3\x61" => "\xE7\xB2\xBA",
		"\xE3\x62" => "\xE7\xB6\xA7",
		"\xE3\x63" => "\xE7\xB6\xB7",
		"\xE3\x64" => "\xE7\xB7\x82",
		"\xE3\x65" => "\xE7\xB6\xA3",
		"\xE3\x66" => "\xE7\xB6\xAA",
		"\xE3\x67" => "\xE7\xB7\x81",
		"\xE3\x68" => "\xE7\xB7\x80",
		"\xE3\x69" => "\xE7\xB7\x85",
		"\xE3\x6A" => "\xE7\xB6\x9D",
		"\xE3\x6B" => "\xE7\xB7\x8E",
		"\xE3\x6C" => "\xE7\xB7\x84",
		"\xE3\x6D" => "\xE7\xB7\x86",
		"\xE3\x6E" => "\xE7\xB7\x8B",
		"\xE3\x6F" => "\xE7\xB7\x8C",
		"\xE3\x70" => "\xE7\xB6\xAF",
		"\xE3\x71" => "\xE7\xB6\xB9",
		"\xE3\x72" => "\xE7\xB6\x96",
		"\xE3\x73" => "\xE7\xB6\xBC",
		"\xE3\x74" => "\xE7\xB6\x9F",
		"\xE3\x75" => "\xE7\xB6\xA6",
		"\xE3\x76" => "\xE7\xB6\xAE",
		"\xE3\x77" => "\xE7\xB6\xA9",
		"\xE3\x78" => "\xE7\xB6\xA1",
		"\xE3\x79" => "\xE7\xB7\x89",
		"\xE3\x7A" => "\xE7\xBD\xB3",
		"\xE3\x7B" => "\xE7\xBF\xA2",
		"\xE3\x7C" => "\xE7\xBF\xA3",
		"\xE3\x7D" => "\xE7\xBF\xA5",
		"\xE3\x7E" => "\xE7\xBF\x9E",
		"\xE3\xA1" => "\xE8\x80\xA4",
		"\xE3\xA2" => "\xE8\x81\x9D",
		"\xE3\xA3" => "\xE8\x81\x9C",
		"\xE3\xA4" => "\xE8\x86\x89",
		"\xE3\xA5" => "\xE8\x86\x86",
		"\xE3\xA6" => "\xE8\x86\x83",
		"\xE3\xA7" => "\xE8\x86\x87",
		"\xE3\xA8" => "\xE8\x86\x8D",
		"\xE3\xA9" => "\xE8\x86\x8C",
		"\xE3\xAA" => "\xE8\x86\x8B",
		"\xE3\xAB" => "\xE8\x88\x95",
		"\xE3\xAC" => "\xE8\x92\x97",
		"\xE3\xAD" => "\xE8\x92\xA4",
		"\xE3\xAE" => "\xE8\x92\xA1",
		"\xE3\xAF" => "\xE8\x92\x9F",
		"\xE3\xB0" => "\xE8\x92\xBA",
		"\xE3\xB1" => "\xE8\x93\x8E",
		"\xE3\xB2" => "\xE8\x93\x82",
		"\xE3\xB3" => "\xE8\x92\xAC",
		"\xE3\xB4" => "\xE8\x92\xAE",
		"\xE3\xB5" => "\xE8\x92\xAB",
		"\xE3\xB6" => "\xE8\x92\xB9",
		"\xE3\xB7" => "\xE8\x92\xB4",
		"\xE3\xB8" => "\xE8\x93\x81",
		"\xE3\xB9" => "\xE8\x93\x8D",
		"\xE3\xBA" => "\xE8\x92\xAA",
		"\xE3\xBB" => "\xE8\x92\x9A",
		"\xE3\xBC" => "\xE8\x92\xB1",
		"\xE3\xBD" => "\xE8\x93\x90",
		"\xE3\xBE" => "\xE8\x92\x9D",
		"\xE3\xBF" => "\xE8\x92\xA7",
		"\xE3\xC0" => "\xE8\x92\xBB",
		"\xE3\xC1" => "\xE8\x92\xA2",
		"\xE3\xC2" => "\xE8\x92\x94",
		"\xE3\xC3" => "\xE8\x93\x87",
		"\xE3\xC4" => "\xE8\x93\x8C",
		"\xE3\xC5" => "\xE8\x92\x9B",
		"\xE3\xC6" => "\xE8\x92\xA9",
		"\xE3\xC7" => "\xE8\x92\xAF",
		"\xE3\xC8" => "\xE8\x92\xA8",
		"\xE3\xC9" => "\xE8\x93\x96",
		"\xE3\xCA" => "\xE8\x92\x98",
		"\xE3\xCB" => "\xE8\x92\xB6",
		"\xE3\xCC" => "\xE8\x93\x8F",
		"\xE3\xCD" => "\xE8\x92\xA0",
		"\xE3\xCE" => "\xE8\x93\x97",
		"\xE3\xCF" => "\xE8\x93\x94",
		"\xE3\xD0" => "\xE8\x93\x92",
		"\xE3\xD1" => "\xE8\x93\x9B",
		"\xE3\xD2" => "\xE8\x92\xB0",
		"\xE3\xD3" => "\xE8\x92\x91",
		"\xE3\xD4" => "\xE8\x99\xA1",
		"\xE3\xD5" => "\xE8\x9C\xB3",
		"\xE3\xD6" => "\xE8\x9C\xA3",
		"\xE3\xD7" => "\xE8\x9C\xA8",
		"\xE3\xD8" => "\xE8\x9D\xAB",
		"\xE3\xD9" => "\xE8\x9D\x80",
		"\xE3\xDA" => "\xE8\x9C\xAE",
		"\xE3\xDB" => "\xE8\x9C\x9E",
		"\xE3\xDC" => "\xE8\x9C\xA1",
		"\xE3\xDD" => "\xE8\x9C\x99",
		"\xE3\xDE" => "\xE8\x9C\x9B",
		"\xE3\xDF" => "\xE8\x9D\x83",
		"\xE3\xE0" => "\xE8\x9C\xAC",
		"\xE3\xE1" => "\xE8\x9D\x81",
		"\xE3\xE2" => "\xE8\x9C\xBE",
		"\xE3\xE3" => "\xE8\x9D\x86",
		"\xE3\xE4" => "\xE8\x9C\xA0",
		"\xE3\xE5" => "\xE8\x9C\xB2",
		"\xE3\xE6" => "\xE8\x9C\xAA",
		"\xE3\xE7" => "\xE8\x9C\xAD",
		"\xE3\xE8" => "\xE8\x9C\xBC",
		"\xE3\xE9" => "\xE8\x9C\x92",
		"\xE3\xEA" => "\xE8\x9C\xBA",
		"\xE3\xEB" => "\xE8\x9C\xB1",
		"\xE3\xEC" => "\xE8\x9C\xB5",
		"\xE3\xED" => "\xE8\x9D\x82",
		"\xE3\xEE" => "\xE8\x9C\xA6",
		"\xE3\xEF" => "\xE8\x9C\xA7",
		"\xE3\xF0" => "\xE8\x9C\xB8",
		"\xE3\xF1" => "\xE8\x9C\xA4",
		"\xE3\xF2" => "\xE8\x9C\x9A",
		"\xE3\xF3" => "\xE8\x9C\xB0",
		"\xE3\xF4" => "\xE8\x9C\x91",
		"\xE3\xF5" => "\xE8\xA3\xB7",
		"\xE3\xF6" => "\xE8\xA3\xA7",
		"\xE3\xF7" => "\xE8\xA3\xB1",
		"\xE3\xF8" => "\xE8\xA3\xB2",
		"\xE3\xF9" => "\xE8\xA3\xBA",
		"\xE3\xFA" => "\xE8\xA3\xBE",
		"\xE3\xFB" => "\xE8\xA3\xAE",
		"\xE3\xFC" => "\xE8\xA3\xBC",
		"\xE3\xFD" => "\xE8\xA3\xB6",
		"\xE3\xFE" => "\xE8\xA3\xBB",
		"\xE4\x40" => "\xE8\xA3\xB0",
		"\xE4\x41" => "\xE8\xA3\xAC",
		"\xE4\x42" => "\xE8\xA3\xAB",
		"\xE4\x43" => "\xE8\xA6\x9D",
		"\xE4\x44" => "\xE8\xA6\xA1",
		"\xE4\x45" => "\xE8\xA6\x9F",
		"\xE4\x46" => "\xE8\xA6\x9E",
		"\xE4\x47" => "\xE8\xA7\xA9",
		"\xE4\x48" => "\xE8\xA7\xAB",
		"\xE4\x49" => "\xE8\xA7\xA8",
		"\xE4\x4A" => "\xE8\xAA\xAB",
		"\xE4\x4B" => "\xE8\xAA\x99",
		"\xE4\x4C" => "\xE8\xAA\x8B",
		"\xE4\x4D" => "\xE8\xAA\x92",
		"\xE4\x4E" => "\xE8\xAA\x8F",
		"\xE4\x4F" => "\xE8\xAA\x96",
		"\xE4\x50" => "\xE8\xB0\xBD",
		"\xE4\x51" => "\xE8\xB1\xA8",
		"\xE4\x52" => "\xE8\xB1\xA9",
		"\xE4\x53" => "\xE8\xB3\x95",
		"\xE4\x54" => "\xE8\xB3\x8F",
		"\xE4\x55" => "\xE8\xB3\x97",
		"\xE4\x56" => "\xE8\xB6\x96",
		"\xE4\x57" => "\xE8\xB8\x89",
		"\xE4\x58" => "\xE8\xB8\x82",
		"\xE4\x59" => "\xE8\xB7\xBF",
		"\xE4\x5A" => "\xE8\xB8\x8D",
		"\xE4\x5B" => "\xE8\xB7\xBD",
		"\xE4\x5C" => "\xE8\xB8\x8A",
		"\xE4\x5D" => "\xE8\xB8\x83",
		"\xE4\x5E" => "\xE8\xB8\x87",
		"\xE4\x5F" => "\xE8\xB8\x86",
		"\xE4\x60" => "\xE8\xB8\x85",
		"\xE4\x61" => "\xE8\xB7\xBE",
		"\xE4\x62" => "\xE8\xB8\x80",
		"\xE4\x63" => "\xE8\xB8\x84",
		"\xE4\x64" => "\xE8\xBC\x90",
		"\xE4\x65" => "\xE8\xBC\x91",
		"\xE4\x66" => "\xE8\xBC\x8E",
		"\xE4\x67" => "\xE8\xBC\x8D",
		"\xE4\x68" => "\xE9\x84\xA3",
		"\xE4\x69" => "\xE9\x84\x9C",
		"\xE4\x6A" => "\xE9\x84\xA0",
		"\xE4\x6B" => "\xE9\x84\xA2",
		"\xE4\x6C" => "\xE9\x84\x9F",
		"\xE4\x6D" => "\xE9\x84\x9D",
		"\xE4\x6E" => "\xE9\x84\x9A",
		"\xE4\x6F" => "\xE9\x84\xA4",
		"\xE4\x70" => "\xE9\x84\xA1",
		"\xE4\x71" => "\xE9\x84\x9B",
		"\xE4\x72" => "\xE9\x85\xBA",
		"\xE4\x73" => "\xE9\x85\xB2",
		"\xE4\x74" => "\xE9\x85\xB9",
		"\xE4\x75" => "\xE9\x85\xB3",
		"\xE4\x76" => "\xE9\x8A\xA5",
		"\xE4\x77" => "\xE9\x8A\xA4",
		"\xE4\x78" => "\xE9\x89\xB6",
		"\xE4\x79" => "\xE9\x8A\x9B",
		"\xE4\x7A" => "\xE9\x89\xBA",
		"\xE4\x7B" => "\xE9\x8A\xA0",
		"\xE4\x7C" => "\xE9\x8A\x94",
		"\xE4\x7D" => "\xE9\x8A\xAA",
		"\xE4\x7E" => "\xE9\x8A\x8D",
		"\xE4\xA1" => "\xE9\x8A\xA6",
		"\xE4\xA2" => "\xE9\x8A\x9A",
		"\xE4\xA3" => "\xE9\x8A\xAB",
		"\xE4\xA4" => "\xE9\x89\xB9",
		"\xE4\xA5" => "\xE9\x8A\x97",
		"\xE4\xA6" => "\xE9\x89\xBF",
		"\xE4\xA7" => "\xE9\x8A\xA3",
		"\xE4\xA8" => "\xE9\x8B\xAE",
		"\xE4\xA9" => "\xE9\x8A\x8E",
		"\xE4\xAA" => "\xE9\x8A\x82",
		"\xE4\xAB" => "\xE9\x8A\x95",
		"\xE4\xAC" => "\xE9\x8A\xA2",
		"\xE4\xAD" => "\xE9\x89\xBD",
		"\xE4\xAE" => "\xE9\x8A\x88",
		"\xE4\xAF" => "\xE9\x8A\xA1",
		"\xE4\xB0" => "\xE9\x8A\x8A",
		"\xE4\xB1" => "\xE9\x8A\x86",
		"\xE4\xB2" => "\xE9\x8A\x8C",
		"\xE4\xB3" => "\xE9\x8A\x99",
		"\xE4\xB4" => "\xE9\x8A\xA7",
		"\xE4\xB5" => "\xE9\x89\xBE",
		"\xE4\xB6" => "\xE9\x8A\x87",
		"\xE4\xB7" => "\xE9\x8A\xA9",
		"\xE4\xB8" => "\xE9\x8A\x9D",
		"\xE4\xB9" => "\xE9\x8A\x8B",
		"\xE4\xBA" => "\xE9\x88\xAD",
		"\xE4\xBB" => "\xE9\x9A\x9E",
		"\xE4\xBC" => "\xE9\x9A\xA1",
		"\xE4\xBD" => "\xE9\x9B\xBF",
		"\xE4\xBE" => "\xE9\x9D\x98",
		"\xE4\xBF" => "\xE9\x9D\xBD",
		"\xE4\xC0" => "\xE9\x9D\xBA",
		"\xE4\xC1" => "\xE9\x9D\xBE",
		"\xE4\xC2" => "\xE9\x9E\x83",
		"\xE4\xC3" => "\xE9\x9E\x80",
		"\xE4\xC4" => "\xE9\x9E\x82",
		"\xE4\xC5" => "\xE9\x9D\xBB",
		"\xE4\xC6" => "\xE9\x9E\x84",
		"\xE4\xC7" => "\xE9\x9E\x81",
		"\xE4\xC8" => "\xE9\x9D\xBF",
		"\xE4\xC9" => "\xE9\x9F\x8E",
		"\xE4\xCA" => "\xE9\x9F\x8D",
		"\xE4\xCB" => "\xE9\xA0\x96",
		"\xE4\xCC" => "\xE9\xA2\xAD",
		"\xE4\xCD" => "\xE9\xA2\xAE",
		"\xE4\xCE" => "\xE9\xA4\x82",
		"\xE4\xCF" => "\xE9\xA4\x80",
		"\xE4\xD0" => "\xE9\xA4\x87",
		"\xE4\xD1" => "\xE9\xA6\x9D",
		"\xE4\xD2" => "\xE9\xA6\x9C",
		"\xE4\xD3" => "\xE9\xA7\x83",
		"\xE4\xD4" => "\xE9\xA6\xB9",
		"\xE4\xD5" => "\xE9\xA6\xBB",
		"\xE4\xD6" => "\xE9\xA6\xBA",
		"\xE4\xD7" => "\xE9\xA7\x82",
		"\xE4\xD8" => "\xE9\xA6\xBD",
		"\xE4\xD9" => "\xE9\xA7\x87",
		"\xE4\xDA" => "\xE9\xAA\xB1",
		"\xE4\xDB" => "\xE9\xAB\xA3",
		"\xE4\xDC" => "\xE9\xAB\xA7",
		"\xE4\xDD" => "\xE9\xAC\xBE",
		"\xE4\xDE" => "\xE9\xAC\xBF",
		"\xE4\xDF" => "\xE9\xAD\xA0",
		"\xE4\xE0" => "\xE9\xAD\xA1",
		"\xE4\xE1" => "\xE9\xAD\x9F",
		"\xE4\xE2" => "\xE9\xB3\xB1",
		"\xE4\xE3" => "\xE9\xB3\xB2",
		"\xE4\xE4" => "\xE9\xB3\xB5",
		"\xE4\xE5" => "\xE9\xBA\xA7",
		"\xE4\xE6" => "\xE5\x83\xBF",
		"\xE4\xE7" => "\xE5\x84\x83",
		"\xE4\xE8" => "\xE5\x84\xB0",
		"\xE4\xE9" => "\xE5\x83\xB8",
		"\xE4\xEA" => "\xE5\x84\x86",
		"\xE4\xEB" => "\xE5\x84\x87",
		"\xE4\xEC" => "\xE5\x83\xB6",
		"\xE4\xED" => "\xE5\x83\xBE",
		"\xE4\xEE" => "\xE5\x84\x8B",
		"\xE4\xEF" => "\xE5\x84\x8C",
		"\xE4\xF0" => "\xE5\x83\xBD",
		"\xE4\xF1" => "\xE5\x84\x8A",
		"\xE4\xF2" => "\xE5\x8A\x8B",
		"\xE4\xF3" => "\xE5\x8A\x8C",
		"\xE4\xF4" => "\xE5\x8B\xB1",
		"\xE4\xF5" => "\xE5\x8B\xAF",
		"\xE4\xF6" => "\xE5\x99\x88",
		"\xE4\xF7" => "\xE5\x99\x82",
		"\xE4\xF8" => "\xE5\x99\x8C",
		"\xE4\xF9" => "\xE5\x98\xB5",
		"\xE4\xFA" => "\xE5\x99\x81",
		"\xE4\xFB" => "\xE5\x99\x8A",
		"\xE4\xFC" => "\xE5\x99\x89",
		"\xE4\xFD" => "\xE5\x99\x86",
		"\xE4\xFE" => "\xE5\x99\x98",
		"\xE5\x40" => "\xE5\x99\x9A",
		"\xE5\x41" => "\xE5\x99\x80",
		"\xE5\x42" => "\xE5\x98\xB3",
		"\xE5\x43" => "\xE5\x98\xBD",
		"\xE5\x44" => "\xE5\x98\xAC",
		"\xE5\x45" => "\xE5\x98\xBE",
		"\xE5\x46" => "\xE5\x98\xB8",
		"\xE5\x47" => "\xE5\x98\xAA",
		"\xE5\x48" => "\xE5\x98\xBA",
		"\xE5\x49" => "\xE5\x9C\x9A",
		"\xE5\x4A" => "\xE5\xA2\xAB",
		"\xE5\x4B" => "\xE5\xA2\x9D",
		"\xE5\x4C" => "\xE5\xA2\xB1",
		"\xE5\x4D" => "\xE5\xA2\xA0",
		"\xE5\x4E" => "\xE5\xA2\xA3",
		"\xE5\x4F" => "\xE5\xA2\xAF",
		"\xE5\x50" => "\xE5\xA2\xAC",
		"\xE5\x51" => "\xE5\xA2\xA5",
		"\xE5\x52" => "\xE5\xA2\xA1",
		"\xE5\x53" => "\xE5\xA3\xBF",
		"\xE5\x54" => "\xE5\xAB\xBF",
		"\xE5\x55" => "\xE5\xAB\xB4",
		"\xE5\x56" => "\xE5\xAB\xBD",
		"\xE5\x57" => "\xE5\xAB\xB7",
		"\xE5\x58" => "\xE5\xAB\xB6",
		"\xE5\x59" => "\xE5\xAC\x83",
		"\xE5\x5A" => "\xE5\xAB\xB8",
		"\xE5\x5B" => "\xE5\xAC\x82",
		"\xE5\x5C" => "\xE5\xAB\xB9",
		"\xE5\x5D" => "\xE5\xAC\x81",
		"\xE5\x5E" => "\xE5\xAC\x87",
		"\xE5\x5F" => "\xE5\xAC\x85",
		"\xE5\x60" => "\xE5\xAC\x8F",
		"\xE5\x61" => "\xE5\xB1\xA7",
		"\xE5\x62" => "\xE5\xB6\x99",
		"\xE5\x63" => "\xE5\xB6\x97",
		"\xE5\x64" => "\xE5\xB6\x9F",
		"\xE5\x65" => "\xE5\xB6\x92",
		"\xE5\x66" => "\xE5\xB6\xA2",
		"\xE5\x67" => "\xE5\xB6\x93",
		"\xE5\x68" => "\xE5\xB6\x95",
		"\xE5\x69" => "\xE5\xB6\xA0",
		"\xE5\x6A" => "\xE5\xB6\x9C",
		"\xE5\x6B" => "\xE5\xB6\xA1",
		"\xE5\x6C" => "\xE5\xB6\x9A",
		"\xE5\x6D" => "\xE5\xB6\x9E",
		"\xE5\x6E" => "\xE5\xB9\xA9",
		"\xE5\x6F" => "\xE5\xB9\x9D",
		"\xE5\x70" => "\xE5\xB9\xA0",
		"\xE5\x71" => "\xE5\xB9\x9C",
		"\xE5\x72" => "\xE7\xB7\xB3",
		"\xE5\x73" => "\xE5\xBB\x9B",
		"\xE5\x74" => "\xE5\xBB\x9E",
		"\xE5\x75" => "\xE5\xBB\xA1",
		"\xE5\x76" => "\xE5\xBD\x89",
		"\xE5\x77" => "\xE5\xBE\xB2",
		"\xE5\x78" => "\xE6\x86\x8B",
		"\xE5\x79" => "\xE6\x86\x83",
		"\xE5\x7A" => "\xE6\x85\xB9",
		"\xE5\x7B" => "\xE6\x86\xB1",
		"\xE5\x7C" => "\xE6\x86\xB0",
		"\xE5\x7D" => "\xE6\x86\xA2",
		"\xE5\x7E" => "\xE6\x86\x89",
		"\xE5\xA1" => "\xE6\x86\x9B",
		"\xE5\xA2" => "\xE6\x86\x93",
		"\xE5\xA3" => "\xE6\x86\xAF",
		"\xE5\xA4" => "\xE6\x86\xAD",
		"\xE5\xA5" => "\xE6\x86\x9F",
		"\xE5\xA6" => "\xE6\x86\x92",
		"\xE5\xA7" => "\xE6\x86\xAA",
		"\xE5\xA8" => "\xE6\x86\xA1",
		"\xE5\xA9" => "\xE6\x86\x8D",
		"\xE5\xAA" => "\xE6\x85\xA6",
		"\xE5\xAB" => "\xE6\x86\xB3",
		"\xE5\xAC" => "\xE6\x88\xAD",
		"\xE5\xAD" => "\xE6\x91\xAE",
		"\xE5\xAE" => "\xE6\x91\xB0",
		"\xE5\xAF" => "\xE6\x92\x96",
		"\xE5\xB0" => "\xE6\x92\xA0",
		"\xE5\xB1" => "\xE6\x92\x85",
		"\xE5\xB2" => "\xE6\x92\x97",
		"\xE5\xB3" => "\xE6\x92\x9C",
		"\xE5\xB4" => "\xE6\x92\x8F",
		"\xE5\xB5" => "\xE6\x92\x8B",
		"\xE5\xB6" => "\xE6\x92\x8A",
		"\xE5\xB7" => "\xE6\x92\x8C",
		"\xE5\xB8" => "\xE6\x92\xA3",
		"\xE5\xB9" => "\xE6\x92\x9F",
		"\xE5\xBA" => "\xE6\x91\xA8",
		"\xE5\xBB" => "\xE6\x92\xB1",
		"\xE5\xBC" => "\xE6\x92\x98",
		"\xE5\xBD" => "\xE6\x95\xB6",
		"\xE5\xBE" => "\xE6\x95\xBA",
		"\xE5\xBF" => "\xE6\x95\xB9",
		"\xE5\xC0" => "\xE6\x95\xBB",
		"\xE5\xC1" => "\xE6\x96\xB2",
		"\xE5\xC2" => "\xE6\x96\xB3",
		"\xE5\xC3" => "\xE6\x9A\xB5",
		"\xE5\xC4" => "\xE6\x9A\xB0",
		"\xE5\xC5" => "\xE6\x9A\xA9",
		"\xE5\xC6" => "\xE6\x9A\xB2",
		"\xE5\xC7" => "\xE6\x9A\xB7",
		"\xE5\xC8" => "\xE6\x9A\xAA",
		"\xE5\xC9" => "\xE6\x9A\xAF",
		"\xE5\xCA" => "\xE6\xA8\x80",
		"\xE5\xCB" => "\xE6\xA8\x86",
		"\xE5\xCC" => "\xE6\xA8\x97",
		"\xE5\xCD" => "\xE6\xA7\xA5",
		"\xE5\xCE" => "\xE6\xA7\xB8",
		"\xE5\xCF" => "\xE6\xA8\x95",
		"\xE5\xD0" => "\xE6\xA7\xB1",
		"\xE5\xD1" => "\xE6\xA7\xA4",
		"\xE5\xD2" => "\xE6\xA8\xA0",
		"\xE5\xD3" => "\xE6\xA7\xBF",
		"\xE5\xD4" => "\xE6\xA7\xAC",
		"\xE5\xD5" => "\xE6\xA7\xA2",
		"\xE5\xD6" => "\xE6\xA8\x9B",
		"\xE5\xD7" => "\xE6\xA8\x9D",
		"\xE5\xD8" => "\xE6\xA7\xBE",
		"\xE5\xD9" => "\xE6\xA8\xA7",
		"\xE5\xDA" => "\xE6\xA7\xB2",
		"\xE5\xDB" => "\xE6\xA7\xAE",
		"\xE5\xDC" => "\xE6\xA8\x94",
		"\xE5\xDD" => "\xE6\xA7\xB7",
		"\xE5\xDE" => "\xE6\xA7\xA7",
		"\xE5\xDF" => "\xE6\xA9\x80",
		"\xE5\xE0" => "\xE6\xA8\x88",
		"\xE5\xE1" => "\xE6\xA7\xA6",
		"\xE5\xE2" => "\xE6\xA7\xBB",
		"\xE5\xE3" => "\xE6\xA8\x8D",
		"\xE5\xE4" => "\xE6\xA7\xBC",
		"\xE5\xE5" => "\xE6\xA7\xAB",
		"\xE5\xE6" => "\xE6\xA8\x89",
		"\xE5\xE7" => "\xE6\xA8\x84",
		"\xE5\xE8" => "\xE6\xA8\x98",
		"\xE5\xE9" => "\xE6\xA8\xA5",
		"\xE5\xEA" => "\xE6\xA8\x8F",
		"\xE5\xEB" => "\xE6\xA7\xB6",
		"\xE5\xEC" => "\xE6\xA8\xA6",
		"\xE5\xED" => "\xE6\xA8\x87",
		"\xE5\xEE" => "\xE6\xA7\xB4",
		"\xE5\xEF" => "\xE6\xA8\x96",
		"\xE5\xF0" => "\xE6\xAD\x91",
		"\xE5\xF1" => "\xE6\xAE\xA5",
		"\xE5\xF2" => "\xE6\xAE\xA3",
		"\xE5\xF3" => "\xE6\xAE\xA2",
		"\xE5\xF4" => "\xE6\xAE\xA6",
		"\xE5\xF5" => "\xE6\xB0\x81",
		"\xE5\xF6" => "\xE6\xB0\x80",
		"\xE5\xF7" => "\xE6\xAF\xBF",
		"\xE5\xF8" => "\xE6\xB0\x82",
		"\xE5\xF9" => "\xE6\xBD\x81",
		"\xE5\xFA" => "\xE6\xBC\xA6",
		"\xE5\xFB" => "\xE6\xBD\xBE",
		"\xE5\xFC" => "\xE6\xBE\x87",
		"\xE5\xFD" => "\xE6\xBF\x86",
		"\xE5\xFE" => "\xE6\xBE\x92",
		"\xE6\x40" => "\xE6\xBE\x8D",
		"\xE6\x41" => "\xE6\xBE\x89",
		"\xE6\x42" => "\xE6\xBE\x8C",
		"\xE6\x43" => "\xE6\xBD\xA2",
		"\xE6\x44" => "\xE6\xBD\x8F",
		"\xE6\x45" => "\xE6\xBE\x85",
		"\xE6\x46" => "\xE6\xBD\x9A",
		"\xE6\x47" => "\xE6\xBE\x96",
		"\xE6\x48" => "\xE6\xBD\xB6",
		"\xE6\x49" => "\xE6\xBD\xAC",
		"\xE6\x4A" => "\xE6\xBE\x82",
		"\xE6\x4B" => "\xE6\xBD\x95",
		"\xE6\x4C" => "\xE6\xBD\xB2",
		"\xE6\x4D" => "\xE6\xBD\x92",
		"\xE6\x4E" => "\xE6\xBD\x90",
		"\xE6\x4F" => "\xE6\xBD\x97",
		"\xE6\x50" => "\xE6\xBE\x94",
		"\xE6\x51" => "\xE6\xBE\x93",
		"\xE6\x52" => "\xE6\xBD\x9D",
		"\xE6\x53" => "\xE6\xBC\x80",
		"\xE6\x54" => "\xE6\xBD\xA1",
		"\xE6\x55" => "\xE6\xBD\xAB",
		"\xE6\x56" => "\xE6\xBD\xBD",
		"\xE6\x57" => "\xE6\xBD\xA7",
		"\xE6\x58" => "\xE6\xBE\x90",
		"\xE6\x59" => "\xE6\xBD\x93",
		"\xE6\x5A" => "\xE6\xBE\x8B",
		"\xE6\x5B" => "\xE6\xBD\xA9",
		"\xE6\x5C" => "\xE6\xBD\xBF",
		"\xE6\x5D" => "\xE6\xBE\x95",
		"\xE6\x5E" => "\xE6\xBD\xA3",
		"\xE6\x5F" => "\xE6\xBD\xB7",
		"\xE6\x60" => "\xE6\xBD\xAA",
		"\xE6\x61" => "\xE6\xBD\xBB",
		"\xE6\x62" => "\xE7\x86\xB2",
		"\xE6\x63" => "\xE7\x86\xAF",
		"\xE6\x64" => "\xE7\x86\x9B",
		"\xE6\x65" => "\xE7\x86\xB0",
		"\xE6\x66" => "\xE7\x86\xA0",
		"\xE6\x67" => "\xE7\x86\x9A",
		"\xE6\x68" => "\xE7\x86\xA9",
		"\xE6\x69" => "\xE7\x86\xB5",
		"\xE6\x6A" => "\xE7\x86\x9D",
		"\xE6\x6B" => "\xE7\x86\xA5",
		"\xE6\x6C" => "\xE7\x86\x9E",
		"\xE6\x6D" => "\xE7\x86\xA4",
		"\xE6\x6E" => "\xE7\x86\xA1",
		"\xE6\x6F" => "\xE7\x86\xAA",
		"\xE6\x70" => "\xE7\x86\x9C",
		"\xE6\x71" => "\xE7\x86\xA7",
		"\xE6\x72" => "\xE7\x86\xB3",
		"\xE6\x73" => "\xE7\x8A\x98",
		"\xE6\x74" => "\xE7\x8A\x9A",
		"\xE6\x75" => "\xE7\x8D\x98",
		"\xE6\x76" => "\xE7\x8D\x92",
		"\xE6\x77" => "\xE7\x8D\x9E",
		"\xE6\x78" => "\xE7\x8D\x9F",
		"\xE6\x79" => "\xE7\x8D\xA0",
		"\xE6\x7A" => "\xE7\x8D\x9D",
		"\xE6\x7B" => "\xE7\x8D\x9B",
		"\xE6\x7C" => "\xE7\x8D\xA1",
		"\xE6\x7D" => "\xE7\x8D\x9A",
		"\xE6\x7E" => "\xE7\x8D\x99",
		"\xE6\xA1" => "\xE7\x8D\xA2",
		"\xE6\xA2" => "\xE7\x92\x87",
		"\xE6\xA3" => "\xE7\x92\x89",
		"\xE6\xA4" => "\xE7\x92\x8A",
		"\xE6\xA5" => "\xE7\x92\x86",
		"\xE6\xA6" => "\xE7\x92\x81",
		"\xE6\xA7" => "\xE7\x91\xBD",
		"\xE6\xA8" => "\xE7\x92\x85",
		"\xE6\xA9" => "\xE7\x92\x88",
		"\xE6\xAA" => "\xE7\x91\xBC",
		"\xE6\xAB" => "\xE7\x91\xB9",
		"\xE6\xAC" => "\xE7\x94\x88",
		"\xE6\xAD" => "\xE7\x94\x87",
		"\xE6\xAE" => "\xE7\x95\xBE",
		"\xE6\xAF" => "\xE7\x98\xA5",
		"\xE6\xB0" => "\xE7\x98\x9E",
		"\xE6\xB1" => "\xE7\x98\x99",
		"\xE6\xB2" => "\xE7\x98\x9D",
		"\xE6\xB3" => "\xE7\x98\x9C",
		"\xE6\xB4" => "\xE7\x98\xA3",
		"\xE6\xB5" => "\xE7\x98\x9A",
		"\xE6\xB6" => "\xE7\x98\xA8",
		"\xE6\xB7" => "\xE7\x98\x9B",
		"\xE6\xB8" => "\xE7\x9A\x9C",
		"\xE6\xB9" => "\xE7\x9A\x9D",
		"\xE6\xBA" => "\xE7\x9A\x9E",
		"\xE6\xBB" => "\xE7\x9A\x9B",
		"\xE6\xBC" => "\xE7\x9E\x8D",
		"\xE6\xBD" => "\xE7\x9E\x8F",
		"\xE6\xBE" => "\xE7\x9E\x89",
		"\xE6\xBF" => "\xE7\x9E\x88",
		"\xE6\xC0" => "\xE7\xA3\x8D",
		"\xE6\xC1" => "\xE7\xA2\xBB",
		"\xE6\xC2" => "\xE7\xA3\x8F",
		"\xE6\xC3" => "\xE7\xA3\x8C",
		"\xE6\xC4" => "\xE7\xA3\x91",
		"\xE6\xC5" => "\xE7\xA3\x8E",
		"\xE6\xC6" => "\xE7\xA3\x94",
		"\xE6\xC7" => "\xE7\xA3\x88",
		"\xE6\xC8" => "\xE7\xA3\x83",
		"\xE6\xC9" => "\xE7\xA3\x84",
		"\xE6\xCA" => "\xE7\xA3\x89",
		"\xE6\xCB" => "\xE7\xA6\x9A",
		"\xE6\xCC" => "\xE7\xA6\xA1",
		"\xE6\xCD" => "\xE7\xA6\xA0",
		"\xE6\xCE" => "\xE7\xA6\x9C",
		"\xE6\xCF" => "\xE7\xA6\xA2",
		"\xE6\xD0" => "\xE7\xA6\x9B",
		"\xE6\xD1" => "\xE6\xAD\xB6",
		"\xE6\xD2" => "\xE7\xA8\xB9",
		"\xE6\xD3" => "\xE7\xAA\xB2",
		"\xE6\xD4" => "\xE7\xAA\xB4",
		"\xE6\xD5" => "\xE7\xAA\xB3",
		"\xE6\xD6" => "\xE7\xAE\xB7",
		"\xE6\xD7" => "\xE7\xAF\x8B",
		"\xE6\xD8" => "\xE7\xAE\xBE",
		"\xE6\xD9" => "\xE7\xAE\xAC",
		"\xE6\xDA" => "\xE7\xAF\x8E",
		"\xE6\xDB" => "\xE7\xAE\xAF",
		"\xE6\xDC" => "\xE7\xAE\xB9",
		"\xE6\xDD" => "\xE7\xAF\x8A",
		"\xE6\xDE" => "\xE7\xAE\xB5",
		"\xE6\xDF" => "\xE7\xB3\x85",
		"\xE6\xE0" => "\xE7\xB3\x88",
		"\xE6\xE1" => "\xE7\xB3\x8C",
		"\xE6\xE2" => "\xE7\xB3\x8B",
		"\xE6\xE3" => "\xE7\xB7\xB7",
		"\xE6\xE4" => "\xE7\xB7\x9B",
		"\xE6\xE5" => "\xE7\xB7\xAA",
		"\xE6\xE6" => "\xE7\xB7\xA7",
		"\xE6\xE7" => "\xE7\xB7\x97",
		"\xE6\xE8" => "\xE7\xB7\xA1",
		"\xE6\xE9" => "\xE7\xB8\x83",
		"\xE6\xEA" => "\xE7\xB7\xBA",
		"\xE6\xEB" => "\xE7\xB7\xA6",
		"\xE6\xEC" => "\xE7\xB7\xB6",
		"\xE6\xED" => "\xE7\xB7\xB1",
		"\xE6\xEE" => "\xE7\xB7\xB0",
		"\xE6\xEF" => "\xE7\xB7\xAE",
		"\xE6\xF0" => "\xE7\xB7\x9F",
		"\xE6\xF1" => "\xE7\xBD\xB6",
		"\xE6\xF2" => "\xE7\xBE\xAC",
		"\xE6\xF3" => "\xE7\xBE\xB0",
		"\xE6\xF4" => "\xE7\xBE\xAD",
		"\xE6\xF5" => "\xE7\xBF\xAD",
		"\xE6\xF6" => "\xE7\xBF\xAB",
		"\xE6\xF7" => "\xE7\xBF\xAA",
		"\xE6\xF8" => "\xE7\xBF\xAC",
		"\xE6\xF9" => "\xE7\xBF\xA6",
		"\xE6\xFA" => "\xE7\xBF\xA8",
		"\xE6\xFB" => "\xE8\x81\xA4",
		"\xE6\xFC" => "\xE8\x81\xA7",
		"\xE6\xFD" => "\xE8\x86\xA3",
		"\xE6\xFE" => "\xE8\x86\x9F",
		"\xE7\x40" => "\xE8\x86\x9E",
		"\xE7\x41" => "\xE8\x86\x95",
		"\xE7\x42" => "\xE8\x86\xA2",
		"\xE7\x43" => "\xE8\x86\x99",
		"\xE7\x44" => "\xE8\x86\x97",
		"\xE7\x45" => "\xE8\x88\x96",
		"\xE7\x46" => "\xE8\x89\x8F",
		"\xE7\x47" => "\xE8\x89\x93",
		"\xE7\x48" => "\xE8\x89\x92",
		"\xE7\x49" => "\xE8\x89\x90",
		"\xE7\x4A" => "\xE8\x89\x8E",
		"\xE7\x4B" => "\xE8\x89\x91",
		"\xE7\x4C" => "\xE8\x94\xA4",
		"\xE7\x4D" => "\xE8\x94\xBB",
		"\xE7\x4E" => "\xE8\x94\x8F",
		"\xE7\x4F" => "\xE8\x94\x80",
		"\xE7\x50" => "\xE8\x94\xA9",
		"\xE7\x51" => "\xE8\x94\x8E",
		"\xE7\x52" => "\xE8\x94\x89",
		"\xE7\x53" => "\xE8\x94\x8D",
		"\xE7\x54" => "\xE8\x94\x9F",
		"\xE7\x55" => "\xE8\x94\x8A",
		"\xE7\x56" => "\xE8\x94\xA7",
		"\xE7\x57" => "\xE8\x94\x9C",
		"\xE7\x58" => "\xE8\x93\xBB",
		"\xE7\x59" => "\xE8\x94\xAB",
		"\xE7\x5A" => "\xE8\x93\xBA",
		"\xE7\x5B" => "\xE8\x94\x88",
		"\xE7\x5C" => "\xE8\x94\x8C",
		"\xE7\x5D" => "\xE8\x93\xB4",
		"\xE7\x5E" => "\xE8\x94\xAA",
		"\xE7\x5F" => "\xE8\x93\xB2",
		"\xE7\x60" => "\xE8\x94\x95",
		"\xE7\x61" => "\xE8\x93\xB7",
		"\xE7\x62" => "\xE8\x93\xAB",
		"\xE7\x63" => "\xE8\x93\xB3",
		"\xE7\x64" => "\xE8\x93\xBC",
		"\xE7\x65" => "\xE8\x94\x92",
		"\xE7\x66" => "\xE8\x93\xAA",
		"\xE7\x67" => "\xE8\x93\xA9",
		"\xE7\x68" => "\xE8\x94\x96",
		"\xE7\x69" => "\xE8\x93\xBE",
		"\xE7\x6A" => "\xE8\x94\xA8",
		"\xE7\x6B" => "\xE8\x94\x9D",
		"\xE7\x6C" => "\xE8\x94\xAE",
		"\xE7\x6D" => "\xE8\x94\x82",
		"\xE7\x6E" => "\xE8\x93\xBD",
		"\xE7\x6F" => "\xE8\x94\x9E",
		"\xE7\x70" => "\xE8\x93\xB6",
		"\xE7\x71" => "\xE8\x94\xB1",
		"\xE7\x72" => "\xE8\x94\xA6",
		"\xE7\x73" => "\xE8\x93\xA7",
		"\xE7\x74" => "\xE8\x93\xA8",
		"\xE7\x75" => "\xE8\x93\xB0",
		"\xE7\x76" => "\xE8\x93\xAF",
		"\xE7\x77" => "\xE8\x93\xB9",
		"\xE7\x78" => "\xE8\x94\x98",
		"\xE7\x79" => "\xE8\x94\xA0",
		"\xE7\x7A" => "\xE8\x94\xB0",
		"\xE7\x7B" => "\xE8\x94\x8B",
		"\xE7\x7C" => "\xE8\x94\x99",
		"\xE7\x7D" => "\xE8\x94\xAF",
		"\xE7\x7E" => "\xE8\x99\xA2",
		"\xE7\xA1" => "\xE8\x9D\x96",
		"\xE7\xA2" => "\xE8\x9D\xA3",
		"\xE7\xA3" => "\xE8\x9D\xA4",
		"\xE7\xA4" => "\xE8\x9D\xB7",
		"\xE7\xA5" => "\xE8\x9F\xA1",
		"\xE7\xA6" => "\xE8\x9D\xB3",
		"\xE7\xA7" => "\xE8\x9D\x98",
		"\xE7\xA8" => "\xE8\x9D\x94",
		"\xE7\xA9" => "\xE8\x9D\x9B",
		"\xE7\xAA" => "\xE8\x9D\x92",
		"\xE7\xAB" => "\xE8\x9D\xA1",
		"\xE7\xAC" => "\xE8\x9D\x9A",
		"\xE7\xAD" => "\xE8\x9D\x91",
		"\xE7\xAE" => "\xE8\x9D\x9E",
		"\xE7\xAF" => "\xE8\x9D\xAD",
		"\xE7\xB0" => "\xE8\x9D\xAA",
		"\xE7\xB1" => "\xE8\x9D\x90",
		"\xE7\xB2" => "\xE8\x9D\x8E",
		"\xE7\xB3" => "\xE8\x9D\x9F",
		"\xE7\xB4" => "\xE8\x9D\x9D",
		"\xE7\xB5" => "\xE8\x9D\xAF",
		"\xE7\xB6" => "\xE8\x9D\xAC",
		"\xE7\xB7" => "\xE8\x9D\xBA",
		"\xE7\xB8" => "\xE8\x9D\xAE",
		"\xE7\xB9" => "\xE8\x9D\x9C",
		"\xE7\xBA" => "\xE8\x9D\xA5",
		"\xE7\xBB" => "\xE8\x9D\x8F",
		"\xE7\xBC" => "\xE8\x9D\xBB",
		"\xE7\xBD" => "\xE8\x9D\xB5",
		"\xE7\xBE" => "\xE8\x9D\xA2",
		"\xE7\xBF" => "\xE8\x9D\xA7",
		"\xE7\xC0" => "\xE8\x9D\xA9",
		"\xE7\xC1" => "\xE8\xA1\x9A",
		"\xE7\xC2" => "\xE8\xA4\x85",
		"\xE7\xC3" => "\xE8\xA4\x8C",
		"\xE7\xC4" => "\xE8\xA4\x94",
		"\xE7\xC5" => "\xE8\xA4\x8B",
		"\xE7\xC6" => "\xE8\xA4\x97",
		"\xE7\xC7" => "\xE8\xA4\x98",
		"\xE7\xC8" => "\xE8\xA4\x99",
		"\xE7\xC9" => "\xE8\xA4\x86",
		"\xE7\xCA" => "\xE8\xA4\x96",
		"\xE7\xCB" => "\xE8\xA4\x91",
		"\xE7\xCC" => "\xE8\xA4\x8E",
		"\xE7\xCD" => "\xE8\xA4\x89",
		"\xE7\xCE" => "\xE8\xA6\xA2",
		"\xE7\xCF" => "\xE8\xA6\xA4",
		"\xE7\xD0" => "\xE8\xA6\xA3",
		"\xE7\xD1" => "\xE8\xA7\xAD",
		"\xE7\xD2" => "\xE8\xA7\xB0",
		"\xE7\xD3" => "\xE8\xA7\xAC",
		"\xE7\xD4" => "\xE8\xAB\x8F",
		"\xE7\xD5" => "\xE8\xAB\x86",
		"\xE7\xD6" => "\xE8\xAA\xB8",
		"\xE7\xD7" => "\xE8\xAB\x93",
		"\xE7\xD8" => "\xE8\xAB\x91",
		"\xE7\xD9" => "\xE8\xAB\x94",
		"\xE7\xDA" => "\xE8\xAB\x95",
		"\xE7\xDB" => "\xE8\xAA\xBB",
		"\xE7\xDC" => "\xE8\xAB\x97",
		"\xE7\xDD" => "\xE8\xAA\xBE",
		"\xE7\xDE" => "\xE8\xAB\x80",
		"\xE7\xDF" => "\xE8\xAB\x85",
		"\xE7\xE0" => "\xE8\xAB\x98",
		"\xE7\xE1" => "\xE8\xAB\x83",
		"\xE7\xE2" => "\xE8\xAA\xBA",
		"\xE7\xE3" => "\xE8\xAA\xBD",
		"\xE7\xE4" => "\xE8\xAB\x99",
		"\xE7\xE5" => "\xE8\xB0\xBE",
		"\xE7\xE6" => "\xE8\xB1\x8D",
		"\xE7\xE7" => "\xE8\xB2\x8F",
		"\xE7\xE8" => "\xE8\xB3\xA5",
		"\xE7\xE9" => "\xE8\xB3\x9F",
		"\xE7\xEA" => "\xE8\xB3\x99",
		"\xE7\xEB" => "\xE8\xB3\xA8",
		"\xE7\xEC" => "\xE8\xB3\x9A",
		"\xE7\xED" => "\xE8\xB3\x9D",
		"\xE7\xEE" => "\xE8\xB3\xA7",
		"\xE7\xEF" => "\xE8\xB6\xA0",
		"\xE7\xF0" => "\xE8\xB6\x9C",
		"\xE7\xF1" => "\xE8\xB6\xA1",
		"\xE7\xF2" => "\xE8\xB6\x9B",
		"\xE7\xF3" => "\xE8\xB8\xA0",
		"\xE7\xF4" => "\xE8\xB8\xA3",
		"\xE7\xF5" => "\xE8\xB8\xA5",
		"\xE7\xF6" => "\xE8\xB8\xA4",
		"\xE7\xF7" => "\xE8\xB8\xAE",
		"\xE7\xF8" => "\xE8\xB8\x95",
		"\xE7\xF9" => "\xE8\xB8\x9B",
		"\xE7\xFA" => "\xE8\xB8\x96",
		"\xE7\xFB" => "\xE8\xB8\x91",
		"\xE7\xFC" => "\xE8\xB8\x99",
		"\xE7\xFD" => "\xE8\xB8\xA6",
		"\xE7\xFE" => "\xE8\xB8\xA7",
		"\xE8\x40" => "\xE8\xB8\x94",
		"\xE8\x41" => "\xE8\xB8\x92",
		"\xE8\x42" => "\xE8\xB8\x98",
		"\xE8\x43" => "\xE8\xB8\x93",
		"\xE8\x44" => "\xE8\xB8\x9C",
		"\xE8\x45" => "\xE8\xB8\x97",
		"\xE8\x46" => "\xE8\xB8\x9A",
		"\xE8\x47" => "\xE8\xBC\xAC",
		"\xE8\x48" => "\xE8\xBC\xA4",
		"\xE8\x49" => "\xE8\xBC\x98",
		"\xE8\x4A" => "\xE8\xBC\x9A",
		"\xE8\x4B" => "\xE8\xBC\xA0",
		"\xE8\x4C" => "\xE8\xBC\xA3",
		"\xE8\x4D" => "\xE8\xBC\x96",
		"\xE8\x4E" => "\xE8\xBC\x97",
		"\xE8\x4F" => "\xE9\x81\xB3",
		"\xE8\x50" => "\xE9\x81\xB0",
		"\xE8\x51" => "\xE9\x81\xAF",
		"\xE8\x52" => "\xE9\x81\xA7",
		"\xE8\x53" => "\xE9\x81\xAB",
		"\xE8\x54" => "\xE9\x84\xAF",
		"\xE8\x55" => "\xE9\x84\xAB",
		"\xE8\x56" => "\xE9\x84\xA9",
		"\xE8\x57" => "\xE9\x84\xAA",
		"\xE8\x58" => "\xE9\x84\xB2",
		"\xE8\x59" => "\xE9\x84\xA6",
		"\xE8\x5A" => "\xE9\x84\xAE",
		"\xE8\x5B" => "\xE9\x86\x85",
		"\xE8\x5C" => "\xE9\x86\x86",
		"\xE8\x5D" => "\xE9\x86\x8A",
		"\xE8\x5E" => "\xE9\x86\x81",
		"\xE8\x5F" => "\xE9\x86\x82",
		"\xE8\x60" => "\xE9\x86\x84",
		"\xE8\x61" => "\xE9\x86\x80",
		"\xE8\x62" => "\xE9\x8B\x90",
		"\xE8\x63" => "\xE9\x8B\x83",
		"\xE8\x64" => "\xE9\x8B\x84",
		"\xE8\x65" => "\xE9\x8B\x80",
		"\xE8\x66" => "\xE9\x8B\x99",
		"\xE8\x67" => "\xE9\x8A\xB6",
		"\xE8\x68" => "\xE9\x8B\x8F",
		"\xE8\x69" => "\xE9\x8B\xB1",
		"\xE8\x6A" => "\xE9\x8B\x9F",
		"\xE8\x6B" => "\xE9\x8B\x98",
		"\xE8\x6C" => "\xE9\x8B\xA9",
		"\xE8\x6D" => "\xE9\x8B\x97",
		"\xE8\x6E" => "\xE9\x8B\x9D",
		"\xE8\x6F" => "\xE9\x8B\x8C",
		"\xE8\x70" => "\xE9\x8B\xAF",
		"\xE8\x71" => "\xE9\x8B\x82",
		"\xE8\x72" => "\xE9\x8B\xA8",
		"\xE8\x73" => "\xE9\x8B\x8A",
		"\xE8\x74" => "\xE9\x8B\x88",
		"\xE8\x75" => "\xE9\x8B\x8E",
		"\xE8\x76" => "\xE9\x8B\xA6",
		"\xE8\x77" => "\xE9\x8B\x8D",
		"\xE8\x78" => "\xE9\x8B\x95",
		"\xE8\x79" => "\xE9\x8B\x89",
		"\xE8\x7A" => "\xE9\x8B\xA0",
		"\xE8\x7B" => "\xE9\x8B\x9E",
		"\xE8\x7C" => "\xE9\x8B\xA7",
		"\xE8\x7D" => "\xE9\x8B\x91",
		"\xE8\x7E" => "\xE9\x8B\x93",
		"\xE8\xA1" => "\xE9\x8A\xB5",
		"\xE8\xA2" => "\xE9\x8B\xA1",
		"\xE8\xA3" => "\xE9\x8B\x86",
		"\xE8\xA4" => "\xE9\x8A\xB4",
		"\xE8\xA5" => "\xE9\x95\xBC",
		"\xE8\xA6" => "\xE9\x96\xAC",
		"\xE8\xA7" => "\xE9\x96\xAB",
		"\xE8\xA8" => "\xE9\x96\xAE",
		"\xE8\xA9" => "\xE9\x96\xB0",
		"\xE8\xAA" => "\xE9\x9A\xA4",
		"\xE8\xAB" => "\xE9\x9A\xA2",
		"\xE8\xAC" => "\xE9\x9B\x93",
		"\xE8\xAD" => "\xE9\x9C\x85",
		"\xE8\xAE" => "\xE9\x9C\x88",
		"\xE8\xAF" => "\xE9\x9C\x82",
		"\xE8\xB0" => "\xE9\x9D\x9A",
		"\xE8\xB1" => "\xE9\x9E\x8A",
		"\xE8\xB2" => "\xE9\x9E\x8E",
		"\xE8\xB3" => "\xE9\x9E\x88",
		"\xE8\xB4" => "\xE9\x9F\x90",
		"\xE8\xB5" => "\xE9\x9F\x8F",
		"\xE8\xB6" => "\xE9\xA0\x9E",
		"\xE8\xB7" => "\xE9\xA0\x9D",
		"\xE8\xB8" => "\xE9\xA0\xA6",
		"\xE8\xB9" => "\xE9\xA0\xA9",
		"\xE8\xBA" => "\xE9\xA0\xA8",
		"\xE8\xBB" => "\xE9\xA0\xA0",
		"\xE8\xBC" => "\xE9\xA0\x9B",
		"\xE8\xBD" => "\xE9\xA0\xA7",
		"\xE8\xBE" => "\xE9\xA2\xB2",
		"\xE8\xBF" => "\xE9\xA4\x88",
		"\xE8\xC0" => "\xE9\xA3\xBA",
		"\xE8\xC1" => "\xE9\xA4\x91",
		"\xE8\xC2" => "\xE9\xA4\x94",
		"\xE8\xC3" => "\xE9\xA4\x96",
		"\xE8\xC4" => "\xE9\xA4\x97",
		"\xE8\xC5" => "\xE9\xA4\x95",
		"\xE8\xC6" => "\xE9\xA7\x9C",
		"\xE8\xC7" => "\xE9\xA7\x8D",
		"\xE8\xC8" => "\xE9\xA7\x8F",
		"\xE8\xC9" => "\xE9\xA7\x93",
		"\xE8\xCA" => "\xE9\xA7\x94",
		"\xE8\xCB" => "\xE9\xA7\x8E",
		"\xE8\xCC" => "\xE9\xA7\x89",
		"\xE8\xCD" => "\xE9\xA7\x96",
		"\xE8\xCE" => "\xE9\xA7\x98",
		"\xE8\xCF" => "\xE9\xA7\x8B",
		"\xE8\xD0" => "\xE9\xA7\x97",
		"\xE8\xD1" => "\xE9\xA7\x8C",
		"\xE8\xD2" => "\xE9\xAA\xB3",
		"\xE8\xD3" => "\xE9\xAB\xAC",
		"\xE8\xD4" => "\xE9\xAB\xAB",
		"\xE8\xD5" => "\xE9\xAB\xB3",
		"\xE8\xD6" => "\xE9\xAB\xB2",
		"\xE8\xD7" => "\xE9\xAB\xB1",
		"\xE8\xD8" => "\xE9\xAD\x86",
		"\xE8\xD9" => "\xE9\xAD\x83",
		"\xE8\xDA" => "\xE9\xAD\xA7",
		"\xE8\xDB" => "\xE9\xAD\xB4",
		"\xE8\xDC" => "\xE9\xAD\xB1",
		"\xE8\xDD" => "\xE9\xAD\xA6",
		"\xE8\xDE" => "\xE9\xAD\xB6",
		"\xE8\xDF" => "\xE9\xAD\xB5",
		"\xE8\xE0" => "\xE9\xAD\xB0",
		"\xE8\xE1" => "\xE9\xAD\xA8",
		"\xE8\xE2" => "\xE9\xAD\xA4",
		"\xE8\xE3" => "\xE9\xAD\xAC",
		"\xE8\xE4" => "\xE9\xB3\xBC",
		"\xE8\xE5" => "\xE9\xB3\xBA",
		"\xE8\xE6" => "\xE9\xB3\xBD",
		"\xE8\xE7" => "\xE9\xB3\xBF",
		"\xE8\xE8" => "\xE9\xB3\xB7",
		"\xE8\xE9" => "\xE9\xB4\x87",
		"\xE8\xEA" => "\xE9\xB4\x80",
		"\xE8\xEB" => "\xE9\xB3\xB9",
		"\xE8\xEC" => "\xE9\xB3\xBB",
		"\xE8\xED" => "\xE9\xB4\x88",
		"\xE8\xEE" => "\xE9\xB4\x85",
		"\xE8\xEF" => "\xE9\xB4\x84",
		"\xE8\xF0" => "\xE9\xBA\x83",
		"\xE8\xF1" => "\xE9\xBB\x93",
		"\xE8\xF2" => "\xE9\xBC\x8F",
		"\xE8\xF3" => "\xE9\xBC\x90",
		"\xE8\xF4" => "\xE5\x84\x9C",
		"\xE8\xF5" => "\xE5\x84\x93",
		"\xE8\xF6" => "\xE5\x84\x97",
		"\xE8\xF7" => "\xE5\x84\x9A",
		"\xE8\xF8" => "\xE5\x84\x91",
		"\xE8\xF9" => "\xE5\x87\x9E",
		"\xE8\xFA" => "\xE5\x8C\xB4",
		"\xE8\xFB" => "\xE5\x8F\xA1",
		"\xE8\xFC" => "\xE5\x99\xB0",
		"\xE8\xFD" => "\xE5\x99\xA0",
		"\xE8\xFE" => "\xE5\x99\xAE",
		"\xE9\x40" => "\xE5\x99\xB3",
		"\xE9\x41" => "\xE5\x99\xA6",
		"\xE9\x42" => "\xE5\x99\xA3",
		"\xE9\x43" => "\xE5\x99\xAD",
		"\xE9\x44" => "\xE5\x99\xB2",
		"\xE9\x45" => "\xE5\x99\x9E",
		"\xE9\x46" => "\xE5\x99\xB7",
		"\xE9\x47" => "\xE5\x9C\x9C",
		"\xE9\x48" => "\xE5\x9C\x9B",
		"\xE9\x49" => "\xE5\xA3\x88",
		"\xE9\x4A" => "\xE5\xA2\xBD",
		"\xE9\x4B" => "\xE5\xA3\x89",
		"\xE9\x4C" => "\xE5\xA2\xBF",
		"\xE9\x4D" => "\xE5\xA2\xBA",
		"\xE9\x4E" => "\xE5\xA3\x82",
		"\xE9\x4F" => "\xE5\xA2\xBC",
		"\xE9\x50" => "\xE5\xA3\x86",
		"\xE9\x51" => "\xE5\xAC\x97",
		"\xE9\x52" => "\xE5\xAC\x99",
		"\xE9\x53" => "\xE5\xAC\x9B",
		"\xE9\x54" => "\xE5\xAC\xA1",
		"\xE9\x55" => "\xE5\xAC\x94",
		"\xE9\x56" => "\xE5\xAC\x93",
		"\xE9\x57" => "\xE5\xAC\x90",
		"\xE9\x58" => "\xE5\xAC\x96",
		"\xE9\x59" => "\xE5\xAC\xA8",
		"\xE9\x5A" => "\xE5\xAC\x9A",
		"\xE9\x5B" => "\xE5\xAC\xA0",
		"\xE9\x5C" => "\xE5\xAC\x9E",
		"\xE9\x5D" => "\xE5\xAF\xAF",
		"\xE9\x5E" => "\xE5\xB6\xAC",
		"\xE9\x5F" => "\xE5\xB6\xB1",
		"\xE9\x60" => "\xE5\xB6\xA9",
		"\xE9\x61" => "\xE5\xB6\xA7",
		"\xE9\x62" => "\xE5\xB6\xB5",
		"\xE9\x63" => "\xE5\xB6\xB0",
		"\xE9\x64" => "\xE5\xB6\xAE",
		"\xE9\x65" => "\xE5\xB6\xAA",
		"\xE9\x66" => "\xE5\xB6\xA8",
		"\xE9\x67" => "\xE5\xB6\xB2",
		"\xE9\x68" => "\xE5\xB6\xAD",
		"\xE9\x69" => "\xE5\xB6\xAF",
		"\xE9\x6A" => "\xE5\xB6\xB4",
		"\xE9\x6B" => "\xE5\xB9\xA7",
		"\xE9\x6C" => "\xE5\xB9\xA8",
		"\xE9\x6D" => "\xE5\xB9\xA6",
		"\xE9\x6E" => "\xE5\xB9\xAF",
		"\xE9\x6F" => "\xE5\xBB\xA9",
		"\xE9\x70" => "\xE5\xBB\xA7",
		"\xE9\x71" => "\xE5\xBB\xA6",
		"\xE9\x72" => "\xE5\xBB\xA8",
		"\xE9\x73" => "\xE5\xBB\xA5",
		"\xE9\x74" => "\xE5\xBD\x8B",
		"\xE9\x75" => "\xE5\xBE\xBC",
		"\xE9\x76" => "\xE6\x86\x9D",
		"\xE9\x77" => "\xE6\x86\xA8",
		"\xE9\x78" => "\xE6\x86\x96",
		"\xE9\x79" => "\xE6\x87\x85",
		"\xE9\x7A" => "\xE6\x86\xB4",
		"\xE9\x7B" => "\xE6\x87\x86",
		"\xE9\x7C" => "\xE6\x87\x81",
		"\xE9\x7D" => "\xE6\x87\x8C",
		"\xE9\x7E" => "\xE6\x86\xBA",
		"\xE9\xA1" => "\xE6\x86\xBF",
		"\xE9\xA2" => "\xE6\x86\xB8",
		"\xE9\xA3" => "\xE6\x86\x8C",
		"\xE9\xA4" => "\xE6\x93\x97",
		"\xE9\xA5" => "\xE6\x93\x96",
		"\xE9\xA6" => "\xE6\x93\x90",
		"\xE9\xA7" => "\xE6\x93\x8F",
		"\xE9\xA8" => "\xE6\x93\x89",
		"\xE9\xA9" => "\xE6\x92\xBD",
		"\xE9\xAA" => "\xE6\x92\x89",
		"\xE9\xAB" => "\xE6\x93\x83",
		"\xE9\xAC" => "\xE6\x93\x9B",
		"\xE9\xAD" => "\xE6\x93\xB3",
		"\xE9\xAE" => "\xE6\x93\x99",
		"\xE9\xAF" => "\xE6\x94\xB3",
		"\xE9\xB0" => "\xE6\x95\xBF",
		"\xE9\xB1" => "\xE6\x95\xBC",
		"\xE9\xB2" => "\xE6\x96\xA2",
		"\xE9\xB3" => "\xE6\x9B\x88",
		"\xE9\xB4" => "\xE6\x9A\xBE",
		"\xE9\xB5" => "\xE6\x9B\x80",
		"\xE9\xB6" => "\xE6\x9B\x8A",
		"\xE9\xB7" => "\xE6\x9B\x8B",
		"\xE9\xB8" => "\xE6\x9B\x8F",
		"\xE9\xB9" => "\xE6\x9A\xBD",
		"\xE9\xBA" => "\xE6\x9A\xBB",
		"\xE9\xBB" => "\xE6\x9A\xBA",
		"\xE9\xBC" => "\xE6\x9B\x8C",
		"\xE9\xBD" => "\xE6\x9C\xA3",
		"\xE9\xBE" => "\xE6\xA8\xB4",
		"\xE9\xBF" => "\xE6\xA9\xA6",
		"\xE9\xC0" => "\xE6\xA9\x89",
		"\xE9\xC1" => "\xE6\xA9\xA7",
		"\xE9\xC2" => "\xE6\xA8\xB2",
		"\xE9\xC3" => "\xE6\xA9\xA8",
		"\xE9\xC4" => "\xE6\xA8\xBE",
		"\xE9\xC5" => "\xE6\xA9\x9D",
		"\xE9\xC6" => "\xE6\xA9\xAD",
		"\xE9\xC7" => "\xE6\xA9\xB6",
		"\xE9\xC8" => "\xE6\xA9\x9B",
		"\xE9\xC9" => "\xE6\xA9\x91",
		"\xE9\xCA" => "\xE6\xA8\xA8",
		"\xE9\xCB" => "\xE6\xA9\x9A",
		"\xE9\xCC" => "\xE6\xA8\xBB",
		"\xE9\xCD" => "\xE6\xA8\xBF",
		"\xE9\xCE" => "\xE6\xA9\x81",
		"\xE9\xCF" => "\xE6\xA9\xAA",
		"\xE9\xD0" => "\xE6\xA9\xA4",
		"\xE9\xD1" => "\xE6\xA9\x90",
		"\xE9\xD2" => "\xE6\xA9\x8F",
		"\xE9\xD3" => "\xE6\xA9\x94",
		"\xE9\xD4" => "\xE6\xA9\xAF",
		"\xE9\xD5" => "\xE6\xA9\xA9",
		"\xE9\xD6" => "\xE6\xA9\xA0",
		"\xE9\xD7" => "\xE6\xA8\xBC",
		"\xE9\xD8" => "\xE6\xA9\x9E",
		"\xE9\xD9" => "\xE6\xA9\x96",
		"\xE9\xDA" => "\xE6\xA9\x95",
		"\xE9\xDB" => "\xE6\xA9\x8D",
		"\xE9\xDC" => "\xE6\xA9\x8E",
		"\xE9\xDD" => "\xE6\xA9\x86",
		"\xE9\xDE" => "\xE6\xAD\x95",
		"\xE9\xDF" => "\xE6\xAD\x94",
		"\xE9\xE0" => "\xE6\xAD\x96",
		"\xE9\xE1" => "\xE6\xAE\xA7",
		"\xE9\xE2" => "\xE6\xAE\xAA",
		"\xE9\xE3" => "\xE6\xAE\xAB",
		"\xE9\xE4" => "\xE6\xAF\x88",
		"\xE9\xE5" => "\xE6\xAF\x87",
		"\xE9\xE6" => "\xE6\xB0\x84",
		"\xE9\xE7" => "\xE6\xB0\x83",
		"\xE9\xE8" => "\xE6\xB0\x86",
		"\xE9\xE9" => "\xE6\xBE\xAD",
		"\xE9\xEA" => "\xE6\xBF\x8B",
		"\xE9\xEB" => "\xE6\xBE\xA3",
		"\xE9\xEC" => "\xE6\xBF\x87",
		"\xE9\xED" => "\xE6\xBE\xBC",
		"\xE9\xEE" => "\xE6\xBF\x8E",
		"\xE9\xEF" => "\xE6\xBF\x88",
		"\xE9\xF0" => "\xE6\xBD\x9E",
		"\xE9\xF1" => "\xE6\xBF\x84",
		"\xE9\xF2" => "\xE6\xBE\xBD",
		"\xE9\xF3" => "\xE6\xBE\x9E",
		"\xE9\xF4" => "\xE6\xBF\x8A",
		"\xE9\xF5" => "\xE6\xBE\xA8",
		"\xE9\xF6" => "\xE7\x80\x84",
		"\xE9\xF7" => "\xE6\xBE\xA5",
		"\xE9\xF8" => "\xE6\xBE\xAE",
		"\xE9\xF9" => "\xE6\xBE\xBA",
		"\xE9\xFA" => "\xE6\xBE\xAC",
		"\xE9\xFB" => "\xE6\xBE\xAA",
		"\xE9\xFC" => "\xE6\xBF\x8F",
		"\xE9\xFD" => "\xE6\xBE\xBF",
		"\xE9\xFE" => "\xE6\xBE\xB8",
		"\xEA\x40" => "\xE6\xBE\xA2",
		"\xEA\x41" => "\xE6\xBF\x89",
		"\xEA\x42" => "\xE6\xBE\xAB",
		"\xEA\x43" => "\xE6\xBF\x8D",
		"\xEA\x44" => "\xE6\xBE\xAF",
		"\xEA\x45" => "\xE6\xBE\xB2",
		"\xEA\x46" => "\xE6\xBE\xB0",
		"\xEA\x47" => "\xE7\x87\x85",
		"\xEA\x48" => "\xE7\x87\x82",
		"\xEA\x49" => "\xE7\x86\xBF",
		"\xEA\x4A" => "\xE7\x86\xB8",
		"\xEA\x4B" => "\xE7\x87\x96",
		"\xEA\x4C" => "\xE7\x87\x80",
		"\xEA\x4D" => "\xE7\x87\x81",
		"\xEA\x4E" => "\xE7\x87\x8B",
		"\xEA\x4F" => "\xE7\x87\x94",
		"\xEA\x50" => "\xE7\x87\x8A",
		"\xEA\x51" => "\xE7\x87\x87",
		"\xEA\x52" => "\xE7\x87\x8F",
		"\xEA\x53" => "\xE7\x86\xBD",
		"\xEA\x54" => "\xE7\x87\x98",
		"\xEA\x55" => "\xE7\x86\xBC",
		"\xEA\x56" => "\xE7\x87\x86",
		"\xEA\x57" => "\xE7\x87\x9A",
		"\xEA\x58" => "\xE7\x87\x9B",
		"\xEA\x59" => "\xE7\x8A\x9D",
		"\xEA\x5A" => "\xE7\x8A\x9E",
		"\xEA\x5B" => "\xE7\x8D\xA9",
		"\xEA\x5C" => "\xE7\x8D\xA6",
		"\xEA\x5D" => "\xE7\x8D\xA7",
		"\xEA\x5E" => "\xE7\x8D\xAC",
		"\xEA\x5F" => "\xE7\x8D\xA5",
		"\xEA\x60" => "\xE7\x8D\xAB",
		"\xEA\x61" => "\xE7\x8D\xAA",
		"\xEA\x62" => "\xE7\x91\xBF",
		"\xEA\x63" => "\xE7\x92\x9A",
		"\xEA\x64" => "\xE7\x92\xA0",
		"\xEA\x65" => "\xE7\x92\x94",
		"\xEA\x66" => "\xE7\x92\x92",
		"\xEA\x67" => "\xE7\x92\x95",
		"\xEA\x68" => "\xE7\x92\xA1",
		"\xEA\x69" => "\xE7\x94\x8B",
		"\xEA\x6A" => "\xE7\x96\x80",
		"\xEA\x6B" => "\xE7\x98\xAF",
		"\xEA\x6C" => "\xE7\x98\xAD",
		"\xEA\x6D" => "\xE7\x98\xB1",
		"\xEA\x6E" => "\xE7\x98\xBD",
		"\xEA\x6F" => "\xE7\x98\xB3",
		"\xEA\x70" => "\xE7\x98\xBC",
		"\xEA\x71" => "\xE7\x98\xB5",
		"\xEA\x72" => "\xE7\x98\xB2",
		"\xEA\x73" => "\xE7\x98\xB0",
		"\xEA\x74" => "\xE7\x9A\xBB",
		"\xEA\x75" => "\xE7\x9B\xA6",
		"\xEA\x76" => "\xE7\x9E\x9A",
		"\xEA\x77" => "\xE7\x9E\x9D",
		"\xEA\x78" => "\xE7\x9E\xA1",
		"\xEA\x79" => "\xE7\x9E\x9C",
		"\xEA\x7A" => "\xE7\x9E\x9B",
		"\xEA\x7B" => "\xE7\x9E\xA2",
		"\xEA\x7C" => "\xE7\x9E\xA3",
		"\xEA\x7D" => "\xE7\x9E\x95",
		"\xEA\x7E" => "\xE7\x9E\x99",
		"\xEA\xA1" => "\xE7\x9E\x97",
		"\xEA\xA2" => "\xE7\xA3\x9D",
		"\xEA\xA3" => "\xE7\xA3\xA9",
		"\xEA\xA4" => "\xE7\xA3\xA5",
		"\xEA\xA5" => "\xE7\xA3\xAA",
		"\xEA\xA6" => "\xE7\xA3\x9E",
		"\xEA\xA7" => "\xE7\xA3\xA3",
		"\xEA\xA8" => "\xE7\xA3\x9B",
		"\xEA\xA9" => "\xE7\xA3\xA1",
		"\xEA\xAA" => "\xE7\xA3\xA2",
		"\xEA\xAB" => "\xE7\xA3\xAD",
		"\xEA\xAC" => "\xE7\xA3\x9F",
		"\xEA\xAD" => "\xE7\xA3\xA0",
		"\xEA\xAE" => "\xE7\xA6\xA4",
		"\xEA\xAF" => "\xE7\xA9\x84",
		"\xEA\xB0" => "\xE7\xA9\x88",
		"\xEA\xB1" => "\xE7\xA9\x87",
		"\xEA\xB2" => "\xE7\xAA\xB6",
		"\xEA\xB3" => "\xE7\xAA\xB8",
		"\xEA\xB4" => "\xE7\xAA\xB5",
		"\xEA\xB5" => "\xE7\xAA\xB1",
		"\xEA\xB6" => "\xE7\xAA\xB7",
		"\xEA\xB7" => "\xE7\xAF\x9E",
		"\xEA\xB8" => "\xE7\xAF\xA3",
		"\xEA\xB9" => "\xE7\xAF\xA7",
		"\xEA\xBA" => "\xE7\xAF\x9D",
		"\xEA\xBB" => "\xE7\xAF\x95",
		"\xEA\xBC" => "\xE7\xAF\xA5",
		"\xEA\xBD" => "\xE7\xAF\x9A",
		"\xEA\xBE" => "\xE7\xAF\xA8",
		"\xEA\xBF" => "\xE7\xAF\xB9",
		"\xEA\xC0" => "\xE7\xAF\x94",
		"\xEA\xC1" => "\xE7\xAF\xAA",
		"\xEA\xC2" => "\xE7\xAF\xA2",
		"\xEA\xC3" => "\xE7\xAF\x9C",
		"\xEA\xC4" => "\xE7\xAF\xAB",
		"\xEA\xC5" => "\xE7\xAF\x98",
		"\xEA\xC6" => "\xE7\xAF\x9F",
		"\xEA\xC7" => "\xE7\xB3\x92",
		"\xEA\xC8" => "\xE7\xB3\x94",
		"\xEA\xC9" => "\xE7\xB3\x97",
		"\xEA\xCA" => "\xE7\xB3\x90",
		"\xEA\xCB" => "\xE7\xB3\x91",
		"\xEA\xCC" => "\xE7\xB8\x92",
		"\xEA\xCD" => "\xE7\xB8\xA1",
		"\xEA\xCE" => "\xE7\xB8\x97",
		"\xEA\xCF" => "\xE7\xB8\x8C",
		"\xEA\xD0" => "\xE7\xB8\x9F",
		"\xEA\xD1" => "\xE7\xB8\xA0",
		"\xEA\xD2" => "\xE7\xB8\x93",
		"\xEA\xD3" => "\xE7\xB8\x8E",
		"\xEA\xD4" => "\xE7\xB8\x9C",
		"\xEA\xD5" => "\xE7\xB8\x95",
		"\xEA\xD6" => "\xE7\xB8\x9A",
		"\xEA\xD7" => "\xE7\xB8\xA2",
		"\xEA\xD8" => "\xE7\xB8\x8B",
		"\xEA\xD9" => "\xE7\xB8\x8F",
		"\xEA\xDA" => "\xE7\xB8\x96",
		"\xEA\xDB" => "\xE7\xB8\x8D",
		"\xEA\xDC" => "\xE7\xB8\x94",
		"\xEA\xDD" => "\xE7\xB8\xA5",
		"\xEA\xDE" => "\xE7\xB8\xA4",
		"\xEA\xDF" => "\xE7\xBD\x83",
		"\xEA\xE0" => "\xE7\xBD\xBB",
		"\xEA\xE1" => "\xE7\xBD\xBC",
		"\xEA\xE2" => "\xE7\xBD\xBA",
		"\xEA\xE3" => "\xE7\xBE\xB1",
		"\xEA\xE4" => "\xE7\xBF\xAF",
		"\xEA\xE5" => "\xE8\x80\xAA",
		"\xEA\xE6" => "\xE8\x80\xA9",
		"\xEA\xE7" => "\xE8\x81\xAC",
		"\xEA\xE8" => "\xE8\x86\xB1",
		"\xEA\xE9" => "\xE8\x86\xA6",
		"\xEA\xEA" => "\xE8\x86\xAE",
		"\xEA\xEB" => "\xE8\x86\xB9",
		"\xEA\xEC" => "\xE8\x86\xB5",
		"\xEA\xED" => "\xE8\x86\xAB",
		"\xEA\xEE" => "\xE8\x86\xB0",
		"\xEA\xEF" => "\xE8\x86\xAC",
		"\xEA\xF0" => "\xE8\x86\xB4",
		"\xEA\xF1" => "\xE8\x86\xB2",
		"\xEA\xF2" => "\xE8\x86\xB7",
		"\xEA\xF3" => "\xE8\x86\xA7",
		"\xEA\xF4" => "\xE8\x87\xB2",
		"\xEA\xF5" => "\xE8\x89\x95",
		"\xEA\xF6" => "\xE8\x89\x96",
		"\xEA\xF7" => "\xE8\x89\x97",
		"\xEA\xF8" => "\xE8\x95\x96",
		"\xEA\xF9" => "\xE8\x95\x85",
		"\xEA\xFA" => "\xE8\x95\xAB",
		"\xEA\xFB" => "\xE8\x95\x8D",
		"\xEA\xFC" => "\xE8\x95\x93",
		"\xEA\xFD" => "\xE8\x95\xA1",
		"\xEA\xFE" => "\xE8\x95\x98",
		"\xEB\x40" => "\xE8\x95\x80",
		"\xEB\x41" => "\xE8\x95\x86",
		"\xEB\x42" => "\xE8\x95\xA4",
		"\xEB\x43" => "\xE8\x95\x81",
		"\xEB\x44" => "\xE8\x95\xA2",
		"\xEB\x45" => "\xE8\x95\x84",
		"\xEB\x46" => "\xE8\x95\x91",
		"\xEB\x47" => "\xE8\x95\x87",
		"\xEB\x48" => "\xE8\x95\xA3",
		"\xEB\x49" => "\xE8\x94\xBE",
		"\xEB\x4A" => "\xE8\x95\x9B",
		"\xEB\x4B" => "\xE8\x95\xB1",
		"\xEB\x4C" => "\xE8\x95\x8E",
		"\xEB\x4D" => "\xE8\x95\xAE",
		"\xEB\x4E" => "\xE8\x95\xB5",
		"\xEB\x4F" => "\xE8\x95\x95",
		"\xEB\x50" => "\xE8\x95\xA7",
		"\xEB\x51" => "\xE8\x95\xA0",
		"\xEB\x52" => "\xE8\x96\x8C",
		"\xEB\x53" => "\xE8\x95\xA6",
		"\xEB\x54" => "\xE8\x95\x9D",
		"\xEB\x55" => "\xE8\x95\x94",
		"\xEB\x56" => "\xE8\x95\xA5",
		"\xEB\x57" => "\xE8\x95\xAC",
		"\xEB\x58" => "\xE8\x99\xA3",
		"\xEB\x59" => "\xE8\x99\xA5",
		"\xEB\x5A" => "\xE8\x99\xA4",
		"\xEB\x5B" => "\xE8\x9E\x9B",
		"\xEB\x5C" => "\xE8\x9E\x8F",
		"\xEB\x5D" => "\xE8\x9E\x97",
		"\xEB\x5E" => "\xE8\x9E\x93",
		"\xEB\x5F" => "\xE8\x9E\x92",
		"\xEB\x60" => "\xE8\x9E\x88",
		"\xEB\x61" => "\xE8\x9E\x81",
		"\xEB\x62" => "\xE8\x9E\x96",
		"\xEB\x63" => "\xE8\x9E\x98",
		"\xEB\x64" => "\xE8\x9D\xB9",
		"\xEB\x65" => "\xE8\x9E\x87",
		"\xEB\x66" => "\xE8\x9E\xA3",
		"\xEB\x67" => "\xE8\x9E\x85",
		"\xEB\x68" => "\xE8\x9E\x90",
		"\xEB\x69" => "\xE8\x9E\x91",
		"\xEB\x6A" => "\xE8\x9E\x9D",
		"\xEB\x6B" => "\xE8\x9E\x84",
		"\xEB\x6C" => "\xE8\x9E\x94",
		"\xEB\x6D" => "\xE8\x9E\x9C",
		"\xEB\x6E" => "\xE8\x9E\x9A",
		"\xEB\x6F" => "\xE8\x9E\x89",
		"\xEB\x70" => "\xE8\xA4\x9E",
		"\xEB\x71" => "\xE8\xA4\xA6",
		"\xEB\x72" => "\xE8\xA4\xB0",
		"\xEB\x73" => "\xE8\xA4\xAD",
		"\xEB\x74" => "\xE8\xA4\xAE",
		"\xEB\x75" => "\xE8\xA4\xA7",
		"\xEB\x76" => "\xE8\xA4\xB1",
		"\xEB\x77" => "\xE8\xA4\xA2",
		"\xEB\x78" => "\xE8\xA4\xA9",
		"\xEB\x79" => "\xE8\xA4\xA3",
		"\xEB\x7A" => "\xE8\xA4\xAF",
		"\xEB\x7B" => "\xE8\xA4\xAC",
		"\xEB\x7C" => "\xE8\xA4\x9F",
		"\xEB\x7D" => "\xE8\xA7\xB1",
		"\xEB\x7E" => "\xE8\xAB\xA0",
		"\xEB\xA1" => "\xE8\xAB\xA2",
		"\xEB\xA2" => "\xE8\xAB\xB2",
		"\xEB\xA3" => "\xE8\xAB\xB4",
		"\xEB\xA4" => "\xE8\xAB\xB5",
		"\xEB\xA5" => "\xE8\xAB\x9D",
		"\xEB\xA6" => "\xE8\xAC\x94",
		"\xEB\xA7" => "\xE8\xAB\xA4",
		"\xEB\xA8" => "\xE8\xAB\x9F",
		"\xEB\xA9" => "\xE8\xAB\xB0",
		"\xEB\xAA" => "\xE8\xAB\x88",
		"\xEB\xAB" => "\xE8\xAB\x9E",
		"\xEB\xAC" => "\xE8\xAB\xA1",
		"\xEB\xAD" => "\xE8\xAB\xA8",
		"\xEB\xAE" => "\xE8\xAB\xBF",
		"\xEB\xAF" => "\xE8\xAB\xAF",
		"\xEB\xB0" => "\xE8\xAB\xBB",
		"\xEB\xB1" => "\xE8\xB2\x91",
		"\xEB\xB2" => "\xE8\xB2\x92",
		"\xEB\xB3" => "\xE8\xB2\x90",
		"\xEB\xB4" => "\xE8\xB3\xB5",
		"\xEB\xB5" => "\xE8\xB3\xAE",
		"\xEB\xB6" => "\xE8\xB3\xB1",
		"\xEB\xB7" => "\xE8\xB3\xB0",
		"\xEB\xB8" => "\xE8\xB3\xB3",
		"\xEB\xB9" => "\xE8\xB5\xAC",
		"\xEB\xBA" => "\xE8\xB5\xAE",
		"\xEB\xBB" => "\xE8\xB6\xA5",
		"\xEB\xBC" => "\xE8\xB6\xA7",
		"\xEB\xBD" => "\xE8\xB8\xB3",
		"\xEB\xBE" => "\xE8\xB8\xBE",
		"\xEB\xBF" => "\xE8\xB8\xB8",
		"\xEB\xC0" => "\xE8\xB9\x80",
		"\xEB\xC1" => "\xE8\xB9\x85",
		"\xEB\xC2" => "\xE8\xB8\xB6",
		"\xEB\xC3" => "\xE8\xB8\xBC",
		"\xEB\xC4" => "\xE8\xB8\xBD",
		"\xEB\xC5" => "\xE8\xB9\x81",
		"\xEB\xC6" => "\xE8\xB8\xB0",
		"\xEB\xC7" => "\xE8\xB8\xBF",
		"\xEB\xC8" => "\xE8\xBA\xBD",
		"\xEB\xC9" => "\xE8\xBC\xB6",
		"\xEB\xCA" => "\xE8\xBC\xAE",
		"\xEB\xCB" => "\xE8\xBC\xB5",
		"\xEB\xCC" => "\xE8\xBC\xB2",
		"\xEB\xCD" => "\xE8\xBC\xB9",
		"\xEB\xCE" => "\xE8\xBC\xB7",
		"\xEB\xCF" => "\xE8\xBC\xB4",
		"\xEB\xD0" => "\xE9\x81\xB6",
		"\xEB\xD1" => "\xE9\x81\xB9",
		"\xEB\xD2" => "\xE9\x81\xBB",
		"\xEB\xD3" => "\xE9\x82\x86",
		"\xEB\xD4" => "\xE9\x83\xBA",
		"\xEB\xD5" => "\xE9\x84\xB3",
		"\xEB\xD6" => "\xE9\x84\xB5",
		"\xEB\xD7" => "\xE9\x84\xB6",
		"\xEB\xD8" => "\xE9\x86\x93",
		"\xEB\xD9" => "\xE9\x86\x90",
		"\xEB\xDA" => "\xE9\x86\x91",
		"\xEB\xDB" => "\xE9\x86\x8D",
		"\xEB\xDC" => "\xE9\x86\x8F",
		"\xEB\xDD" => "\xE9\x8C\xA7",
		"\xEB\xDE" => "\xE9\x8C\x9E",
		"\xEB\xDF" => "\xE9\x8C\x88",
		"\xEB\xE0" => "\xE9\x8C\x9F",
		"\xEB\xE1" => "\xE9\x8C\x86",
		"\xEB\xE2" => "\xE9\x8C\x8F",
		"\xEB\xE3" => "\xE9\x8D\xBA",
		"\xEB\xE4" => "\xE9\x8C\xB8",
		"\xEB\xE5" => "\xE9\x8C\xBC",
		"\xEB\xE6" => "\xE9\x8C\x9B",
		"\xEB\xE7" => "\xE9\x8C\xA3",
		"\xEB\xE8" => "\xE9\x8C\x92",
		"\xEB\xE9" => "\xE9\x8C\x81",
		"\xEB\xEA" => "\xE9\x8D\x86",
		"\xEB\xEB" => "\xE9\x8C\xAD",
		"\xEB\xEC" => "\xE9\x8C\x8E",
		"\xEB\xED" => "\xE9\x8C\x8D",
		"\xEB\xEE" => "\xE9\x8B\x8B",
		"\xEB\xEF" => "\xE9\x8C\x9D",
		"\xEB\xF0" => "\xE9\x8B\xBA",
		"\xEB\xF1" => "\xE9\x8C\xA5",
		"\xEB\xF2" => "\xE9\x8C\x93",
		"\xEB\xF3" => "\xE9\x8B\xB9",
		"\xEB\xF4" => "\xE9\x8B\xB7",
		"\xEB\xF5" => "\xE9\x8C\xB4",
		"\xEB\xF6" => "\xE9\x8C\x82",
		"\xEB\xF7" => "\xE9\x8C\xA4",
		"\xEB\xF8" => "\xE9\x8B\xBF",
		"\xEB\xF9" => "\xE9\x8C\xA9",
		"\xEB\xFA" => "\xE9\x8C\xB9",
		"\xEB\xFB" => "\xE9\x8C\xB5",
		"\xEB\xFC" => "\xE9\x8C\xAA",
		"\xEB\xFD" => "\xE9\x8C\x94",
		"\xEB\xFE" => "\xE9\x8C\x8C",
		"\xEC\x40" => "\xE9\x8C\x8B",
		"\xEC\x41" => "\xE9\x8B\xBE",
		"\xEC\x42" => "\xE9\x8C\x89",
		"\xEC\x43" => "\xE9\x8C\x80",
		"\xEC\x44" => "\xE9\x8B\xBB",
		"\xEC\x45" => "\xE9\x8C\x96",
		"\xEC\x46" => "\xE9\x96\xBC",
		"\xEC\x47" => "\xE9\x97\x8D",
		"\xEC\x48" => "\xE9\x96\xBE",
		"\xEC\x49" => "\xE9\x96\xB9",
		"\xEC\x4A" => "\xE9\x96\xBA",
		"\xEC\x4B" => "\xE9\x96\xB6",
		"\xEC\x4C" => "\xE9\x96\xBF",
		"\xEC\x4D" => "\xE9\x96\xB5",
		"\xEC\x4E" => "\xE9\x96\xBD",
		"\xEC\x4F" => "\xE9\x9A\xA9",
		"\xEC\x50" => "\xE9\x9B\x94",
		"\xEC\x51" => "\xE9\x9C\x8B",
		"\xEC\x52" => "\xE9\x9C\x92",
		"\xEC\x53" => "\xE9\x9C\x90",
		"\xEC\x54" => "\xE9\x9E\x99",
		"\xEC\x55" => "\xE9\x9E\x97",
		"\xEC\x56" => "\xE9\x9E\x94",
		"\xEC\x57" => "\xE9\x9F\xB0",
		"\xEC\x58" => "\xE9\x9F\xB8",
		"\xEC\x59" => "\xE9\xA0\xB5",
		"\xEC\x5A" => "\xE9\xA0\xAF",
		"\xEC\x5B" => "\xE9\xA0\xB2",
		"\xEC\x5C" => "\xE9\xA4\xA4",
		"\xEC\x5D" => "\xE9\xA4\x9F",
		"\xEC\x5E" => "\xE9\xA4\xA7",
		"\xEC\x5F" => "\xE9\xA4\xA9",
		"\xEC\x60" => "\xE9\xA6\x9E",
		"\xEC\x61" => "\xE9\xA7\xAE",
		"\xEC\x62" => "\xE9\xA7\xAC",
		"\xEC\x63" => "\xE9\xA7\xA5",
		"\xEC\x64" => "\xE9\xA7\xA4",
		"\xEC\x65" => "\xE9\xA7\xB0",
		"\xEC\x66" => "\xE9\xA7\xA3",
		"\xEC\x67" => "\xE9\xA7\xAA",
		"\xEC\x68" => "\xE9\xA7\xA9",
		"\xEC\x69" => "\xE9\xA7\xA7",
		"\xEC\x6A" => "\xE9\xAA\xB9",
		"\xEC\x6B" => "\xE9\xAA\xBF",
		"\xEC\x6C" => "\xE9\xAA\xB4",
		"\xEC\x6D" => "\xE9\xAA\xBB",
		"\xEC\x6E" => "\xE9\xAB\xB6",
		"\xEC\x6F" => "\xE9\xAB\xBA",
		"\xEC\x70" => "\xE9\xAB\xB9",
		"\xEC\x71" => "\xE9\xAB\xB7",
		"\xEC\x72" => "\xE9\xAC\xB3",
		"\xEC\x73" => "\xE9\xAE\x80",
		"\xEC\x74" => "\xE9\xAE\x85",
		"\xEC\x75" => "\xE9\xAE\x87",
		"\xEC\x76" => "\xE9\xAD\xBC",
		"\xEC\x77" => "\xE9\xAD\xBE",
		"\xEC\x78" => "\xE9\xAD\xBB",
		"\xEC\x79" => "\xE9\xAE\x82",
		"\xEC\x7A" => "\xE9\xAE\x93",
		"\xEC\x7B" => "\xE9\xAE\x92",
		"\xEC\x7C" => "\xE9\xAE\x90",
		"\xEC\x7D" => "\xE9\xAD\xBA",
		"\xEC\x7E" => "\xE9\xAE\x95",
		"\xEC\xA1" => "\xE9\xAD\xBD",
		"\xEC\xA2" => "\xE9\xAE\x88",
		"\xEC\xA3" => "\xE9\xB4\xA5",
		"\xEC\xA4" => "\xE9\xB4\x97",
		"\xEC\xA5" => "\xE9\xB4\xA0",
		"\xEC\xA6" => "\xE9\xB4\x9E",
		"\xEC\xA7" => "\xE9\xB4\x94",
		"\xEC\xA8" => "\xE9\xB4\xA9",
		"\xEC\xA9" => "\xE9\xB4\x9D",
		"\xEC\xAA" => "\xE9\xB4\x98",
		"\xEC\xAB" => "\xE9\xB4\xA2",
		"\xEC\xAC" => "\xE9\xB4\x90",
		"\xEC\xAD" => "\xE9\xB4\x99",
		"\xEC\xAE" => "\xE9\xB4\x9F",
		"\xEC\xAF" => "\xE9\xBA\x88",
		"\xEC\xB0" => "\xE9\xBA\x86",
		"\xEC\xB1" => "\xE9\xBA\x87",
		"\xEC\xB2" => "\xE9\xBA\xAE",
		"\xEC\xB3" => "\xE9\xBA\xAD",
		"\xEC\xB4" => "\xE9\xBB\x95",
		"\xEC\xB5" => "\xE9\xBB\x96",
		"\xEC\xB6" => "\xE9\xBB\xBA",
		"\xEC\xB7" => "\xE9\xBC\x92",
		"\xEC\xB8" => "\xE9\xBC\xBD",
		"\xEC\xB9" => "\xE5\x84\xA6",
		"\xEC\xBA" => "\xE5\x84\xA5",
		"\xEC\xBB" => "\xE5\x84\xA2",
		"\xEC\xBC" => "\xE5\x84\xA4",
		"\xEC\xBD" => "\xE5\x84\xA0",
		"\xEC\xBE" => "\xE5\x84\xA9",
		"\xEC\xBF" => "\xE5\x8B\xB4",
		"\xEC\xC0" => "\xE5\x9A\x93",
		"\xEC\xC1" => "\xE5\x9A\x8C",
		"\xEC\xC2" => "\xE5\x9A\x8D",
		"\xEC\xC3" => "\xE5\x9A\x86",
		"\xEC\xC4" => "\xE5\x9A\x84",
		"\xEC\xC5" => "\xE5\x9A\x83",
		"\xEC\xC6" => "\xE5\x99\xBE",
		"\xEC\xC7" => "\xE5\x9A\x82",
		"\xEC\xC8" => "\xE5\x99\xBF",
		"\xEC\xC9" => "\xE5\x9A\x81",
		"\xEC\xCA" => "\xE5\xA3\x96",
		"\xEC\xCB" => "\xE5\xA3\x94",
		"\xEC\xCC" => "\xE5\xA3\x8F",
		"\xEC\xCD" => "\xE5\xA3\x92",
		"\xEC\xCE" => "\xE5\xAC\xAD",
		"\xEC\xCF" => "\xE5\xAC\xA5",
		"\xEC\xD0" => "\xE5\xAC\xB2",
		"\xEC\xD1" => "\xE5\xAC\xA3",
		"\xEC\xD2" => "\xE5\xAC\xAC",
		"\xEC\xD3" => "\xE5\xAC\xA7",
		"\xEC\xD4" => "\xE5\xAC\xA6",
		"\xEC\xD5" => "\xE5\xAC\xAF",
		"\xEC\xD6" => "\xE5\xAC\xAE",
		"\xEC\xD7" => "\xE5\xAD\xBB",
		"\xEC\xD8" => "\xE5\xAF\xB1",
		"\xEC\xD9" => "\xE5\xAF\xB2",
		"\xEC\xDA" => "\xE5\xB6\xB7",
		"\xEC\xDB" => "\xE5\xB9\xAC",
		"\xEC\xDC" => "\xE5\xB9\xAA",
		"\xEC\xDD" => "\xE5\xBE\xBE",
		"\xEC\xDE" => "\xE5\xBE\xBB",
		"\xEC\xDF" => "\xE6\x87\x83",
		"\xEC\xE0" => "\xE6\x86\xB5",
		"\xEC\xE1" => "\xE6\x86\xBC",
		"\xEC\xE2" => "\xE6\x87\xA7",
		"\xEC\xE3" => "\xE6\x87\xA0",
		"\xEC\xE4" => "\xE6\x87\xA5",
		"\xEC\xE5" => "\xE6\x87\xA4",
		"\xEC\xE6" => "\xE6\x87\xA8",
		"\xEC\xE7" => "\xE6\x87\x9E",
		"\xEC\xE8" => "\xE6\x93\xAF",
		"\xEC\xE9" => "\xE6\x93\xA9",
		"\xEC\xEA" => "\xE6\x93\xA3",
		"\xEC\xEB" => "\xE6\x93\xAB",
		"\xEC\xEC" => "\xE6\x93\xA4",
		"\xEC\xED" => "\xE6\x93\xA8",
		"\xEC\xEE" => "\xE6\x96\x81",
		"\xEC\xEF" => "\xE6\x96\x80",
		"\xEC\xF0" => "\xE6\x96\xB6",
		"\xEC\xF1" => "\xE6\x97\x9A",
		"\xEC\xF2" => "\xE6\x9B\x92",
		"\xEC\xF3" => "\xE6\xAA\x8D",
		"\xEC\xF4" => "\xE6\xAA\x96",
		"\xEC\xF5" => "\xE6\xAA\x81",
		"\xEC\xF6" => "\xE6\xAA\xA5",
		"\xEC\xF7" => "\xE6\xAA\x89",
		"\xEC\xF8" => "\xE6\xAA\x9F",
		"\xEC\xF9" => "\xE6\xAA\x9B",
		"\xEC\xFA" => "\xE6\xAA\xA1",
		"\xEC\xFB" => "\xE6\xAA\x9E",
		"\xEC\xFC" => "\xE6\xAA\x87",
		"\xEC\xFD" => "\xE6\xAA\x93",
		"\xEC\xFE" => "\xE6\xAA\x8E",
		"\xED\x40" => "\xE6\xAA\x95",
		"\xED\x41" => "\xE6\xAA\x83",
		"\xED\x42" => "\xE6\xAA\xA8",
		"\xED\x43" => "\xE6\xAA\xA4",
		"\xED\x44" => "\xE6\xAA\x91",
		"\xED\x45" => "\xE6\xA9\xBF",
		"\xED\x46" => "\xE6\xAA\xA6",
		"\xED\x47" => "\xE6\xAA\x9A",
		"\xED\x48" => "\xE6\xAA\x85",
		"\xED\x49" => "\xE6\xAA\x8C",
		"\xED\x4A" => "\xE6\xAA\x92",
		"\xED\x4B" => "\xE6\xAD\x9B",
		"\xED\x4C" => "\xE6\xAE\xAD",
		"\xED\x4D" => "\xE6\xB0\x89",
		"\xED\x4E" => "\xE6\xBF\x8C",
		"\xED\x4F" => "\xE6\xBE\xA9",
		"\xED\x50" => "\xE6\xBF\xB4",
		"\xED\x51" => "\xE6\xBF\x94",
		"\xED\x52" => "\xE6\xBF\xA3",
		"\xED\x53" => "\xE6\xBF\x9C",
		"\xED\x54" => "\xE6\xBF\xAD",
		"\xED\x55" => "\xE6\xBF\xA7",
		"\xED\x56" => "\xE6\xBF\xA6",
		"\xED\x57" => "\xE6\xBF\x9E",
		"\xED\x58" => "\xE6\xBF\xB2",
		"\xED\x59" => "\xE6\xBF\x9D",
		"\xED\x5A" => "\xE6\xBF\xA2",
		"\xED\x5B" => "\xE6\xBF\xA8",
		"\xED\x5C" => "\xE7\x87\xA1",
		"\xED\x5D" => "\xE7\x87\xB1",
		"\xED\x5E" => "\xE7\x87\xA8",
		"\xED\x5F" => "\xE7\x87\xB2",
		"\xED\x60" => "\xE7\x87\xA4",
		"\xED\x61" => "\xE7\x87\xB0",
		"\xED\x62" => "\xE7\x87\xA2",
		"\xED\x63" => "\xE7\x8D\xB3",
		"\xED\x64" => "\xE7\x8D\xAE",
		"\xED\x65" => "\xE7\x8D\xAF",
		"\xED\x66" => "\xE7\x92\x97",
		"\xED\x67" => "\xE7\x92\xB2",
		"\xED\x68" => "\xE7\x92\xAB",
		"\xED\x69" => "\xE7\x92\x90",
		"\xED\x6A" => "\xE7\x92\xAA",
		"\xED\x6B" => "\xE7\x92\xAD",
		"\xED\x6C" => "\xE7\x92\xB1",
		"\xED\x6D" => "\xE7\x92\xA5",
		"\xED\x6E" => "\xE7\x92\xAF",
		"\xED\x6F" => "\xE7\x94\x90",
		"\xED\x70" => "\xE7\x94\x91",
		"\xED\x71" => "\xE7\x94\x92",
		"\xED\x72" => "\xE7\x94\x8F",
		"\xED\x73" => "\xE7\x96\x84",
		"\xED\x74" => "\xE7\x99\x83",
		"\xED\x75" => "\xE7\x99\x88",
		"\xED\x76" => "\xE7\x99\x89",
		"\xED\x77" => "\xE7\x99\x87",
		"\xED\x78" => "\xE7\x9A\xA4",
		"\xED\x79" => "\xE7\x9B\xA9",
		"\xED\x7A" => "\xE7\x9E\xB5",
		"\xED\x7B" => "\xE7\x9E\xAB",
		"\xED\x7C" => "\xE7\x9E\xB2",
		"\xED\x7D" => "\xE7\x9E\xB7",
		"\xED\x7E" => "\xE7\x9E\xB6",
		"\xED\xA1" => "\xE7\x9E\xB4",
		"\xED\xA2" => "\xE7\x9E\xB1",
		"\xED\xA3" => "\xE7\x9E\xA8",
		"\xED\xA4" => "\xE7\x9F\xB0",
		"\xED\xA5" => "\xE7\xA3\xB3",
		"\xED\xA6" => "\xE7\xA3\xBD",
		"\xED\xA7" => "\xE7\xA4\x82",
		"\xED\xA8" => "\xE7\xA3\xBB",
		"\xED\xA9" => "\xE7\xA3\xBC",
		"\xED\xAA" => "\xE7\xA3\xB2",
		"\xED\xAB" => "\xE7\xA4\x85",
		"\xED\xAC" => "\xE7\xA3\xB9",
		"\xED\xAD" => "\xE7\xA3\xBE",
		"\xED\xAE" => "\xE7\xA4\x84",
		"\xED\xAF" => "\xE7\xA6\xAB",
		"\xED\xB0" => "\xE7\xA6\xA8",
		"\xED\xB1" => "\xE7\xA9\x9C",
		"\xED\xB2" => "\xE7\xA9\x9B",
		"\xED\xB3" => "\xE7\xA9\x96",
		"\xED\xB4" => "\xE7\xA9\x98",
		"\xED\xB5" => "\xE7\xA9\x94",
		"\xED\xB6" => "\xE7\xA9\x9A",
		"\xED\xB7" => "\xE7\xAA\xBE",
		"\xED\xB8" => "\xE7\xAB\x80",
		"\xED\xB9" => "\xE7\xAB\x81",
		"\xED\xBA" => "\xE7\xB0\x85",
		"\xED\xBB" => "\xE7\xB0\x8F",
		"\xED\xBC" => "\xE7\xAF\xB2",
		"\xED\xBD" => "\xE7\xB0\x80",
		"\xED\xBE" => "\xE7\xAF\xBF",
		"\xED\xBF" => "\xE7\xAF\xBB",
		"\xED\xC0" => "\xE7\xB0\x8E",
		"\xED\xC1" => "\xE7\xAF\xB4",
		"\xED\xC2" => "\xE7\xB0\x8B",
		"\xED\xC3" => "\xE7\xAF\xB3",
		"\xED\xC4" => "\xE7\xB0\x82",
		"\xED\xC5" => "\xE7\xB0\x89",
		"\xED\xC6" => "\xE7\xB0\x83",
		"\xED\xC7" => "\xE7\xB0\x81",
		"\xED\xC8" => "\xE7\xAF\xB8",
		"\xED\xC9" => "\xE7\xAF\xBD",
		"\xED\xCA" => "\xE7\xB0\x86",
		"\xED\xCB" => "\xE7\xAF\xB0",
		"\xED\xCC" => "\xE7\xAF\xB1",
		"\xED\xCD" => "\xE7\xB0\x90",
		"\xED\xCE" => "\xE7\xB0\x8A",
		"\xED\xCF" => "\xE7\xB3\xA8",
		"\xED\xD0" => "\xE7\xB8\xAD",
		"\xED\xD1" => "\xE7\xB8\xBC",
		"\xED\xD2" => "\xE7\xB9\x82",
		"\xED\xD3" => "\xE7\xB8\xB3",
		"\xED\xD4" => "\xE9\xA1\x88",
		"\xED\xD5" => "\xE7\xB8\xB8",
		"\xED\xD6" => "\xE7\xB8\xAA",
		"\xED\xD7" => "\xE7\xB9\x89",
		"\xED\xD8" => "\xE7\xB9\x80",
		"\xED\xD9" => "\xE7\xB9\x87",
		"\xED\xDA" => "\xE7\xB8\xA9",
		"\xED\xDB" => "\xE7\xB9\x8C",
		"\xED\xDC" => "\xE7\xB8\xB0",
		"\xED\xDD" => "\xE7\xB8\xBB",
		"\xED\xDE" => "\xE7\xB8\xB6",
		"\xED\xDF" => "\xE7\xB9\x84",
		"\xED\xE0" => "\xE7\xB8\xBA",
		"\xED\xE1" => "\xE7\xBD\x85",
		"\xED\xE2" => "\xE7\xBD\xBF",
		"\xED\xE3" => "\xE7\xBD\xBE",
		"\xED\xE4" => "\xE7\xBD\xBD",
		"\xED\xE5" => "\xE7\xBF\xB4",
		"\xED\xE6" => "\xE7\xBF\xB2",
		"\xED\xE7" => "\xE8\x80\xAC",
		"\xED\xE8" => "\xE8\x86\xBB",
		"\xED\xE9" => "\xE8\x87\x84",
		"\xED\xEA" => "\xE8\x87\x8C",
		"\xED\xEB" => "\xE8\x87\x8A",
		"\xED\xEC" => "\xE8\x87\x85",
		"\xED\xED" => "\xE8\x87\x87",
		"\xED\xEE" => "\xE8\x86\xBC",
		"\xED\xEF" => "\xE8\x87\xA9",
		"\xED\xF0" => "\xE8\x89\x9B",
		"\xED\xF1" => "\xE8\x89\x9A",
		"\xED\xF2" => "\xE8\x89\x9C",
		"\xED\xF3" => "\xE8\x96\x83",
		"\xED\xF4" => "\xE8\x96\x80",
		"\xED\xF5" => "\xE8\x96\x8F",
		"\xED\xF6" => "\xE8\x96\xA7",
		"\xED\xF7" => "\xE8\x96\x95",
		"\xED\xF8" => "\xE8\x96\xA0",
		"\xED\xF9" => "\xE8\x96\x8B",
		"\xED\xFA" => "\xE8\x96\xA3",
		"\xED\xFB" => "\xE8\x95\xBB",
		"\xED\xFC" => "\xE8\x96\xA4",
		"\xED\xFD" => "\xE8\x96\x9A",
		"\xED\xFE" => "\xE8\x96\x9E",
		"\xEE\x40" => "\xE8\x95\xB7",
		"\xEE\x41" => "\xE8\x95\xBC",
		"\xEE\x42" => "\xE8\x96\x89",
		"\xEE\x43" => "\xE8\x96\xA1",
		"\xEE\x44" => "\xE8\x95\xBA",
		"\xEE\x45" => "\xE8\x95\xB8",
		"\xEE\x46" => "\xE8\x95\x97",
		"\xEE\x47" => "\xE8\x96\x8E",
		"\xEE\x48" => "\xE8\x96\x96",
		"\xEE\x49" => "\xE8\x96\x86",
		"\xEE\x4A" => "\xE8\x96\x8D",
		"\xEE\x4B" => "\xE8\x96\x99",
		"\xEE\x4C" => "\xE8\x96\x9D",
		"\xEE\x4D" => "\xE8\x96\x81",
		"\xEE\x4E" => "\xE8\x96\xA2",
		"\xEE\x4F" => "\xE8\x96\x82",
		"\xEE\x50" => "\xE8\x96\x88",
		"\xEE\x51" => "\xE8\x96\x85",
		"\xEE\x52" => "\xE8\x95\xB9",
		"\xEE\x53" => "\xE8\x95\xB6",
		"\xEE\x54" => "\xE8\x96\x98",
		"\xEE\x55" => "\xE8\x96\x90",
		"\xEE\x56" => "\xE8\x96\x9F",
		"\xEE\x57" => "\xE8\x99\xA8",
		"\xEE\x58" => "\xE8\x9E\xBE",
		"\xEE\x59" => "\xE8\x9E\xAA",
		"\xEE\x5A" => "\xE8\x9E\xAD",
		"\xEE\x5B" => "\xE8\x9F\x85",
		"\xEE\x5C" => "\xE8\x9E\xB0",
		"\xEE\x5D" => "\xE8\x9E\xAC",
		"\xEE\x5E" => "\xE8\x9E\xB9",
		"\xEE\x5F" => "\xE8\x9E\xB5",
		"\xEE\x60" => "\xE8\x9E\xBC",
		"\xEE\x61" => "\xE8\x9E\xAE",
		"\xEE\x62" => "\xE8\x9F\x89",
		"\xEE\x63" => "\xE8\x9F\x83",
		"\xEE\x64" => "\xE8\x9F\x82",
		"\xEE\x65" => "\xE8\x9F\x8C",
		"\xEE\x66" => "\xE8\x9E\xB7",
		"\xEE\x67" => "\xE8\x9E\xAF",
		"\xEE\x68" => "\xE8\x9F\x84",
		"\xEE\x69" => "\xE8\x9F\x8A",
		"\xEE\x6A" => "\xE8\x9E\xB4",
		"\xEE\x6B" => "\xE8\x9E\xB6",
		"\xEE\x6C" => "\xE8\x9E\xBF",
		"\xEE\x6D" => "\xE8\x9E\xB8",
		"\xEE\x6E" => "\xE8\x9E\xBD",
		"\xEE\x6F" => "\xE8\x9F\x9E",
		"\xEE\x70" => "\xE8\x9E\xB2",
		"\xEE\x71" => "\xE8\xA4\xB5",
		"\xEE\x72" => "\xE8\xA4\xB3",
		"\xEE\x73" => "\xE8\xA4\xBC",
		"\xEE\x74" => "\xE8\xA4\xBE",
		"\xEE\x75" => "\xE8\xA5\x81",
		"\xEE\x76" => "\xE8\xA5\x92",
		"\xEE\x77" => "\xE8\xA4\xB7",
		"\xEE\x78" => "\xE8\xA5\x82",
		"\xEE\x79" => "\xE8\xA6\xAD",
		"\xEE\x7A" => "\xE8\xA6\xAF",
		"\xEE\x7B" => "\xE8\xA6\xAE",
		"\xEE\x7C" => "\xE8\xA7\xB2",
		"\xEE\x7D" => "\xE8\xA7\xB3",
		"\xEE\x7E" => "\xE8\xAC\x9E",
		"\xEE\xA1" => "\xE8\xAC\x98",
		"\xEE\xA2" => "\xE8\xAC\x96",
		"\xEE\xA3" => "\xE8\xAC\x91",
		"\xEE\xA4" => "\xE8\xAC\x85",
		"\xEE\xA5" => "\xE8\xAC\x8B",
		"\xEE\xA6" => "\xE8\xAC\xA2",
		"\xEE\xA7" => "\xE8\xAC\x8F",
		"\xEE\xA8" => "\xE8\xAC\x92",
		"\xEE\xA9" => "\xE8\xAC\x95",
		"\xEE\xAA" => "\xE8\xAC\x87",
		"\xEE\xAB" => "\xE8\xAC\x8D",
		"\xEE\xAC" => "\xE8\xAC\x88",
		"\xEE\xAD" => "\xE8\xAC\x86",
		"\xEE\xAE" => "\xE8\xAC\x9C",
		"\xEE\xAF" => "\xE8\xAC\x93",
		"\xEE\xB0" => "\xE8\xAC\x9A",
		"\xEE\xB1" => "\xE8\xB1\x8F",
		"\xEE\xB2" => "\xE8\xB1\xB0",
		"\xEE\xB3" => "\xE8\xB1\xB2",
		"\xEE\xB4" => "\xE8\xB1\xB1",
		"\xEE\xB5" => "\xE8\xB1\xAF",
		"\xEE\xB6" => "\xE8\xB2\x95",
		"\xEE\xB7" => "\xE8\xB2\x94",
		"\xEE\xB8" => "\xE8\xB3\xB9",
		"\xEE\xB9" => "\xE8\xB5\xAF",
		"\xEE\xBA" => "\xE8\xB9\x8E",
		"\xEE\xBB" => "\xE8\xB9\x8D",
		"\xEE\xBC" => "\xE8\xB9\x93",
		"\xEE\xBD" => "\xE8\xB9\x90",
		"\xEE\xBE" => "\xE8\xB9\x8C",
		"\xEE\xBF" => "\xE8\xB9\x87",
		"\xEE\xC0" => "\xE8\xBD\x83",
		"\xEE\xC1" => "\xE8\xBD\x80",
		"\xEE\xC2" => "\xE9\x82\x85",
		"\xEE\xC3" => "\xE9\x81\xBE",
		"\xEE\xC4" => "\xE9\x84\xB8",
		"\xEE\xC5" => "\xE9\x86\x9A",
		"\xEE\xC6" => "\xE9\x86\xA2",
		"\xEE\xC7" => "\xE9\x86\x9B",
		"\xEE\xC8" => "\xE9\x86\x99",
		"\xEE\xC9" => "\xE9\x86\x9F",
		"\xEE\xCA" => "\xE9\x86\xA1",
		"\xEE\xCB" => "\xE9\x86\x9D",
		"\xEE\xCC" => "\xE9\x86\xA0",
		"\xEE\xCD" => "\xE9\x8E\xA1",
		"\xEE\xCE" => "\xE9\x8E\x83",
		"\xEE\xCF" => "\xE9\x8E\xAF",
		"\xEE\xD0" => "\xE9\x8D\xA4",
		"\xEE\xD1" => "\xE9\x8D\x96",
		"\xEE\xD2" => "\xE9\x8D\x87",
		"\xEE\xD3" => "\xE9\x8D\xBC",
		"\xEE\xD4" => "\xE9\x8D\x98",
		"\xEE\xD5" => "\xE9\x8D\x9C",
		"\xEE\xD6" => "\xE9\x8D\xB6",
		"\xEE\xD7" => "\xE9\x8D\x89",
		"\xEE\xD8" => "\xE9\x8D\x90",
		"\xEE\xD9" => "\xE9\x8D\x91",
		"\xEE\xDA" => "\xE9\x8D\xA0",
		"\xEE\xDB" => "\xE9\x8D\xAD",
		"\xEE\xDC" => "\xE9\x8E\x8F",
		"\xEE\xDD" => "\xE9\x8D\x8C",
		"\xEE\xDE" => "\xE9\x8D\xAA",
		"\xEE\xDF" => "\xE9\x8D\xB9",
		"\xEE\xE0" => "\xE9\x8D\x97",
		"\xEE\xE1" => "\xE9\x8D\x95",
		"\xEE\xE2" => "\xE9\x8D\x92",
		"\xEE\xE3" => "\xE9\x8D\x8F",
		"\xEE\xE4" => "\xE9\x8D\xB1",
		"\xEE\xE5" => "\xE9\x8D\xB7",
		"\xEE\xE6" => "\xE9\x8D\xBB",
		"\xEE\xE7" => "\xE9\x8D\xA1",
		"\xEE\xE8" => "\xE9\x8D\x9E",
		"\xEE\xE9" => "\xE9\x8D\xA3",
		"\xEE\xEA" => "\xE9\x8D\xA7",
		"\xEE\xEB" => "\xE9\x8E\x80",
		"\xEE\xEC" => "\xE9\x8D\x8E",
		"\xEE\xED" => "\xE9\x8D\x99",
		"\xEE\xEE" => "\xE9\x97\x87",
		"\xEE\xEF" => "\xE9\x97\x80",
		"\xEE\xF0" => "\xE9\x97\x89",
		"\xEE\xF1" => "\xE9\x97\x83",
		"\xEE\xF2" => "\xE9\x97\x85",
		"\xEE\xF3" => "\xE9\x96\xB7",
		"\xEE\xF4" => "\xE9\x9A\xAE",
		"\xEE\xF5" => "\xE9\x9A\xB0",
		"\xEE\xF6" => "\xE9\x9A\xAC",
		"\xEE\xF7" => "\xE9\x9C\xA0",
		"\xEE\xF8" => "\xE9\x9C\x9F",
		"\xEE\xF9" => "\xE9\x9C\x98",
		"\xEE\xFA" => "\xE9\x9C\x9D",
		"\xEE\xFB" => "\xE9\x9C\x99",
		"\xEE\xFC" => "\xE9\x9E\x9A",
		"\xEE\xFD" => "\xE9\x9E\xA1",
		"\xEE\xFE" => "\xE9\x9E\x9C",
		"\xEF\x40" => "\xE9\x9E\x9E",
		"\xEF\x41" => "\xE9\x9E\x9D",
		"\xEF\x42" => "\xE9\x9F\x95",
		"\xEF\x43" => "\xE9\x9F\x94",
		"\xEF\x44" => "\xE9\x9F\xB1",
		"\xEF\x45" => "\xE9\xA1\x81",
		"\xEF\x46" => "\xE9\xA1\x84",
		"\xEF\x47" => "\xE9\xA1\x8A",
		"\xEF\x48" => "\xE9\xA1\x89",
		"\xEF\x49" => "\xE9\xA1\x85",
		"\xEF\x4A" => "\xE9\xA1\x83",
		"\xEF\x4B" => "\xE9\xA4\xA5",
		"\xEF\x4C" => "\xE9\xA4\xAB",
		"\xEF\x4D" => "\xE9\xA4\xAC",
		"\xEF\x4E" => "\xE9\xA4\xAA",
		"\xEF\x4F" => "\xE9\xA4\xB3",
		"\xEF\x50" => "\xE9\xA4\xB2",
		"\xEF\x51" => "\xE9\xA4\xAF",
		"\xEF\x52" => "\xE9\xA4\xAD",
		"\xEF\x53" => "\xE9\xA4\xB1",
		"\xEF\x54" => "\xE9\xA4\xB0",
		"\xEF\x55" => "\xE9\xA6\x98",
		"\xEF\x56" => "\xE9\xA6\xA3",
		"\xEF\x57" => "\xE9\xA6\xA1",
		"\xEF\x58" => "\xE9\xA8\x82",
		"\xEF\x59" => "\xE9\xA7\xBA",
		"\xEF\x5A" => "\xE9\xA7\xB4",
		"\xEF\x5B" => "\xE9\xA7\xB7",
		"\xEF\x5C" => "\xE9\xA7\xB9",
		"\xEF\x5D" => "\xE9\xA7\xB8",
		"\xEF\x5E" => "\xE9\xA7\xB6",
		"\xEF\x5F" => "\xE9\xA7\xBB",
		"\xEF\x60" => "\xE9\xA7\xBD",
		"\xEF\x61" => "\xE9\xA7\xBE",
		"\xEF\x62" => "\xE9\xA7\xBC",
		"\xEF\x63" => "\xE9\xA8\x83",
		"\xEF\x64" => "\xE9\xAA\xBE",
		"\xEF\x65" => "\xE9\xAB\xBE",
		"\xEF\x66" => "\xE9\xAB\xBD",
		"\xEF\x67" => "\xE9\xAC\x81",
		"\xEF\x68" => "\xE9\xAB\xBC",
		"\xEF\x69" => "\xE9\xAD\x88",
		"\xEF\x6A" => "\xE9\xAE\x9A",
		"\xEF\x6B" => "\xE9\xAE\xA8",
		"\xEF\x6C" => "\xE9\xAE\x9E",
		"\xEF\x6D" => "\xE9\xAE\x9B",
		"\xEF\x6E" => "\xE9\xAE\xA6",
		"\xEF\x6F" => "\xE9\xAE\xA1",
		"\xEF\x70" => "\xE9\xAE\xA5",
		"\xEF\x71" => "\xE9\xAE\xA4",
		"\xEF\x72" => "\xE9\xAE\x86",
		"\xEF\x73" => "\xE9\xAE\xA2",
		"\xEF\x74" => "\xE9\xAE\xA0",
		"\xEF\x75" => "\xE9\xAE\xAF",
		"\xEF\x76" => "\xE9\xB4\xB3",
		"\xEF\x77" => "\xE9\xB5\x81",
		"\xEF\x78" => "\xE9\xB5\xA7",
		"\xEF\x79" => "\xE9\xB4\xB6",
		"\xEF\x7A" => "\xE9\xB4\xAE",
		"\xEF\x7B" => "\xE9\xB4\xAF",
		"\xEF\x7C" => "\xE9\xB4\xB1",
		"\xEF\x7D" => "\xE9\xB4\xB8",
		"\xEF\x7E" => "\xE9\xB4\xB0",
		"\xEF\xA1" => "\xE9\xB5\x85",
		"\xEF\xA2" => "\xE9\xB5\x82",
		"\xEF\xA3" => "\xE9\xB5\x83",
		"\xEF\xA4" => "\xE9\xB4\xBE",
		"\xEF\xA5" => "\xE9\xB4\xB7",
		"\xEF\xA6" => "\xE9\xB5\x80",
		"\xEF\xA7" => "\xE9\xB4\xBD",
		"\xEF\xA8" => "\xE7\xBF\xB5",
		"\xEF\xA9" => "\xE9\xB4\xAD",
		"\xEF\xAA" => "\xE9\xBA\x8A",
		"\xEF\xAB" => "\xE9\xBA\x89",
		"\xEF\xAC" => "\xE9\xBA\x8D",
		"\xEF\xAD" => "\xE9\xBA\xB0",
		"\xEF\xAE" => "\xE9\xBB\x88",
		"\xEF\xAF" => "\xE9\xBB\x9A",
		"\xEF\xB0" => "\xE9\xBB\xBB",
		"\xEF\xB1" => "\xE9\xBB\xBF",
		"\xEF\xB2" => "\xE9\xBC\xA4",
		"\xEF\xB3" => "\xE9\xBC\xA3",
		"\xEF\xB4" => "\xE9\xBC\xA2",
		"\xEF\xB5" => "\xE9\xBD\x94",
		"\xEF\xB6" => "\xE9\xBE\xA0",
		"\xEF\xB7" => "\xE5\x84\xB1",
		"\xEF\xB8" => "\xE5\x84\xAD",
		"\xEF\xB9" => "\xE5\x84\xAE",
		"\xEF\xBA" => "\xE5\x9A\x98",
		"\xEF\xBB" => "\xE5\x9A\x9C",
		"\xEF\xBC" => "\xE5\x9A\x97",
		"\xEF\xBD" => "\xE5\x9A\x9A",
		"\xEF\xBE" => "\xE5\x9A\x9D",
		"\xEF\xBF" => "\xE5\x9A\x99",
		"\xEF\xC0" => "\xE5\xA5\xB0",
		"\xEF\xC1" => "\xE5\xAC\xBC",
		"\xEF\xC2" => "\xE5\xB1\xA9",
		"\xEF\xC3" => "\xE5\xB1\xAA",
		"\xEF\xC4" => "\xE5\xB7\x80",
		"\xEF\xC5" => "\xE5\xB9\xAD",
		"\xEF\xC6" => "\xE5\xB9\xAE",
		"\xEF\xC7" => "\xE6\x87\x98",
		"\xEF\xC8" => "\xE6\x87\x9F",
		"\xEF\xC9" => "\xE6\x87\xAD",
		"\xEF\xCA" => "\xE6\x87\xAE",
		"\xEF\xCB" => "\xE6\x87\xB1",
		"\xEF\xCC" => "\xE6\x87\xAA",
		"\xEF\xCD" => "\xE6\x87\xB0",
		"\xEF\xCE" => "\xE6\x87\xAB",
		"\xEF\xCF" => "\xE6\x87\x96",
		"\xEF\xD0" => "\xE6\x87\xA9",
		"\xEF\xD1" => "\xE6\x93\xBF",
		"\xEF\xD2" => "\xE6\x94\x84",
		"\xEF\xD3" => "\xE6\x93\xBD",
		"\xEF\xD4" => "\xE6\x93\xB8",
		"\xEF\xD5" => "\xE6\x94\x81",
		"\xEF\xD6" => "\xE6\x94\x83",
		"\xEF\xD7" => "\xE6\x93\xBC",
		"\xEF\xD8" => "\xE6\x96\x94",
		"\xEF\xD9" => "\xE6\x97\x9B",
		"\xEF\xDA" => "\xE6\x9B\x9A",
		"\xEF\xDB" => "\xE6\x9B\x9B",
		"\xEF\xDC" => "\xE6\x9B\x98",
		"\xEF\xDD" => "\xE6\xAB\x85",
		"\xEF\xDE" => "\xE6\xAA\xB9",
		"\xEF\xDF" => "\xE6\xAA\xBD",
		"\xEF\xE0" => "\xE6\xAB\xA1",
		"\xEF\xE1" => "\xE6\xAB\x86",
		"\xEF\xE2" => "\xE6\xAA\xBA",
		"\xEF\xE3" => "\xE6\xAA\xB6",
		"\xEF\xE4" => "\xE6\xAA\xB7",
		"\xEF\xE5" => "\xE6\xAB\x87",
		"\xEF\xE6" => "\xE6\xAA\xB4",
		"\xEF\xE7" => "\xE6\xAA\xAD",
		"\xEF\xE8" => "\xE6\xAD\x9E",
		"\xEF\xE9" => "\xE6\xAF\x89",
		"\xEF\xEA" => "\xE6\xB0\x8B",
		"\xEF\xEB" => "\xE7\x80\x87",
		"\xEF\xEC" => "\xE7\x80\x8C",
		"\xEF\xED" => "\xE7\x80\x8D",
		"\xEF\xEE" => "\xE7\x80\x81",
		"\xEF\xEF" => "\xE7\x80\x85",
		"\xEF\xF0" => "\xE7\x80\x94",
		"\xEF\xF1" => "\xE7\x80\x8E",
		"\xEF\xF2" => "\xE6\xBF\xBF",
		"\xEF\xF3" => "\xE7\x80\x80",
		"\xEF\xF4" => "\xE6\xBF\xBB",
		"\xEF\xF5" => "\xE7\x80\xA6",
		"\xEF\xF6" => "\xE6\xBF\xBC",
		"\xEF\xF7" => "\xE6\xBF\xB7",
		"\xEF\xF8" => "\xE7\x80\x8A",
		"\xEF\xF9" => "\xE7\x88\x81",
		"\xEF\xFA" => "\xE7\x87\xBF",
		"\xEF\xFB" => "\xE7\x87\xB9",
		"\xEF\xFC" => "\xE7\x88\x83",
		"\xEF\xFD" => "\xE7\x87\xBD",
		"\xEF\xFE" => "\xE7\x8D\xB6",
		"\xF0\x40" => "\xE7\x92\xB8",
		"\xF0\x41" => "\xE7\x93\x80",
		"\xF0\x42" => "\xE7\x92\xB5",
		"\xF0\x43" => "\xE7\x93\x81",
		"\xF0\x44" => "\xE7\x92\xBE",
		"\xF0\x45" => "\xE7\x92\xB6",
		"\xF0\x46" => "\xE7\x92\xBB",
		"\xF0\x47" => "\xE7\x93\x82",
		"\xF0\x48" => "\xE7\x94\x94",
		"\xF0\x49" => "\xE7\x94\x93",
		"\xF0\x4A" => "\xE7\x99\x9C",
		"\xF0\x4B" => "\xE7\x99\xA4",
		"\xF0\x4C" => "\xE7\x99\x99",
		"\xF0\x4D" => "\xE7\x99\x90",
		"\xF0\x4E" => "\xE7\x99\x93",
		"\xF0\x4F" => "\xE7\x99\x97",
		"\xF0\x50" => "\xE7\x99\x9A",
		"\xF0\x51" => "\xE7\x9A\xA6",
		"\xF0\x52" => "\xE7\x9A\xBD",
		"\xF0\x53" => "\xE7\x9B\xAC",
		"\xF0\x54" => "\xE7\x9F\x82",
		"\xF0\x55" => "\xE7\x9E\xBA",
		"\xF0\x56" => "\xE7\xA3\xBF",
		"\xF0\x57" => "\xE7\xA4\x8C",
		"\xF0\x58" => "\xE7\xA4\x93",
		"\xF0\x59" => "\xE7\xA4\x94",
		"\xF0\x5A" => "\xE7\xA4\x89",
		"\xF0\x5B" => "\xE7\xA4\x90",
		"\xF0\x5C" => "\xE7\xA4\x92",
		"\xF0\x5D" => "\xE7\xA4\x91",
		"\xF0\x5E" => "\xE7\xA6\xAD",
		"\xF0\x5F" => "\xE7\xA6\xAC",
		"\xF0\x60" => "\xE7\xA9\x9F",
		"\xF0\x61" => "\xE7\xB0\x9C",
		"\xF0\x62" => "\xE7\xB0\xA9",
		"\xF0\x63" => "\xE7\xB0\x99",
		"\xF0\x64" => "\xE7\xB0\xA0",
		"\xF0\x65" => "\xE7\xB0\x9F",
		"\xF0\x66" => "\xE7\xB0\xAD",
		"\xF0\x67" => "\xE7\xB0\x9D",
		"\xF0\x68" => "\xE7\xB0\xA6",
		"\xF0\x69" => "\xE7\xB0\xA8",
		"\xF0\x6A" => "\xE7\xB0\xA2",
		"\xF0\x6B" => "\xE7\xB0\xA5",
		"\xF0\x6C" => "\xE7\xB0\xB0",
		"\xF0\x6D" => "\xE7\xB9\x9C",
		"\xF0\x6E" => "\xE7\xB9\x90",
		"\xF0\x6F" => "\xE7\xB9\x96",
		"\xF0\x70" => "\xE7\xB9\xA3",
		"\xF0\x71" => "\xE7\xB9\x98",
		"\xF0\x72" => "\xE7\xB9\xA2",
		"\xF0\x73" => "\xE7\xB9\x9F",
		"\xF0\x74" => "\xE7\xB9\x91",
		"\xF0\x75" => "\xE7\xB9\xA0",
		"\xF0\x76" => "\xE7\xB9\x97",
		"\xF0\x77" => "\xE7\xB9\x93",
		"\xF0\x78" => "\xE7\xBE\xB5",
		"\xF0\x79" => "\xE7\xBE\xB3",
		"\xF0\x7A" => "\xE7\xBF\xB7",
		"\xF0\x7B" => "\xE7\xBF\xB8",
		"\xF0\x7C" => "\xE8\x81\xB5",
		"\xF0\x7D" => "\xE8\x87\x91",
		"\xF0\x7E" => "\xE8\x87\x92",
		"\xF0\xA1" => "\xE8\x87\x90",
		"\xF0\xA2" => "\xE8\x89\x9F",
		"\xF0\xA3" => "\xE8\x89\x9E",
		"\xF0\xA4" => "\xE8\x96\xB4",
		"\xF0\xA5" => "\xE8\x97\x86",
		"\xF0\xA6" => "\xE8\x97\x80",
		"\xF0\xA7" => "\xE8\x97\x83",
		"\xF0\xA8" => "\xE8\x97\x82",
		"\xF0\xA9" => "\xE8\x96\xB3",
		"\xF0\xAA" => "\xE8\x96\xB5",
		"\xF0\xAB" => "\xE8\x96\xBD",
		"\xF0\xAC" => "\xE8\x97\x87",
		"\xF0\xAD" => "\xE8\x97\x84",
		"\xF0\xAE" => "\xE8\x96\xBF",
		"\xF0\xAF" => "\xE8\x97\x8B",
		"\xF0\xB0" => "\xE8\x97\x8E",
		"\xF0\xB1" => "\xE8\x97\x88",
		"\xF0\xB2" => "\xE8\x97\x85",
		"\xF0\xB3" => "\xE8\x96\xB1",
		"\xF0\xB4" => "\xE8\x96\xB6",
		"\xF0\xB5" => "\xE8\x97\x92",
		"\xF0\xB6" => "\xE8\x98\xA4",
		"\xF0\xB7" => "\xE8\x96\xB8",
		"\xF0\xB8" => "\xE8\x96\xB7",
		"\xF0\xB9" => "\xE8\x96\xBE",
		"\xF0\xBA" => "\xE8\x99\xA9",
		"\xF0\xBB" => "\xE8\x9F\xA7",
		"\xF0\xBC" => "\xE8\x9F\xA6",
		"\xF0\xBD" => "\xE8\x9F\xA2",
		"\xF0\xBE" => "\xE8\x9F\x9B",
		"\xF0\xBF" => "\xE8\x9F\xAB",
		"\xF0\xC0" => "\xE8\x9F\xAA",
		"\xF0\xC1" => "\xE8\x9F\xA5",
		"\xF0\xC2" => "\xE8\x9F\x9F",
		"\xF0\xC3" => "\xE8\x9F\xB3",
		"\xF0\xC4" => "\xE8\x9F\xA4",
		"\xF0\xC5" => "\xE8\x9F\x94",
		"\xF0\xC6" => "\xE8\x9F\x9C",
		"\xF0\xC7" => "\xE8\x9F\x93",
		"\xF0\xC8" => "\xE8\x9F\xAD",
		"\xF0\xC9" => "\xE8\x9F\x98",
		"\xF0\xCA" => "\xE8\x9F\xA3",
		"\xF0\xCB" => "\xE8\x9E\xA4",
		"\xF0\xCC" => "\xE8\x9F\x97",
		"\xF0\xCD" => "\xE8\x9F\x99",
		"\xF0\xCE" => "\xE8\xA0\x81",
		"\xF0\xCF" => "\xE8\x9F\xB4",
		"\xF0\xD0" => "\xE8\x9F\xA8",
		"\xF0\xD1" => "\xE8\x9F\x9D",
		"\xF0\xD2" => "\xE8\xA5\x93",
		"\xF0\xD3" => "\xE8\xA5\x8B",
		"\xF0\xD4" => "\xE8\xA5\x8F",
		"\xF0\xD5" => "\xE8\xA5\x8C",
		"\xF0\xD6" => "\xE8\xA5\x86",
		"\xF0\xD7" => "\xE8\xA5\x90",
		"\xF0\xD8" => "\xE8\xA5\x91",
		"\xF0\xD9" => "\xE8\xA5\x89",
		"\xF0\xDA" => "\xE8\xAC\xAA",
		"\xF0\xDB" => "\xE8\xAC\xA7",
		"\xF0\xDC" => "\xE8\xAC\xA3",
		"\xF0\xDD" => "\xE8\xAC\xB3",
		"\xF0\xDE" => "\xE8\xAC\xB0",
		"\xF0\xDF" => "\xE8\xAC\xB5",
		"\xF0\xE0" => "\xE8\xAD\x87",
		"\xF0\xE1" => "\xE8\xAC\xAF",
		"\xF0\xE2" => "\xE8\xAC\xBC",
		"\xF0\xE3" => "\xE8\xAC\xBE",
		"\xF0\xE4" => "\xE8\xAC\xB1",
		"\xF0\xE5" => "\xE8\xAC\xA5",
		"\xF0\xE6" => "\xE8\xAC\xB7",
		"\xF0\xE7" => "\xE8\xAC\xA6",
		"\xF0\xE8" => "\xE8\xAC\xB6",
		"\xF0\xE9" => "\xE8\xAC\xAE",
		"\xF0\xEA" => "\xE8\xAC\xA4",
		"\xF0\xEB" => "\xE8\xAC\xBB",
		"\xF0\xEC" => "\xE8\xAC\xBD",
		"\xF0\xED" => "\xE8\xAC\xBA",
		"\xF0\xEE" => "\xE8\xB1\x82",
		"\xF0\xEF" => "\xE8\xB1\xB5",
		"\xF0\xF0" => "\xE8\xB2\x99",
		"\xF0\xF1" => "\xE8\xB2\x98",
		"\xF0\xF2" => "\xE8\xB2\x97",
		"\xF0\xF3" => "\xE8\xB3\xBE",
		"\xF0\xF4" => "\xE8\xB4\x84",
		"\xF0\xF5" => "\xE8\xB4\x82",
		"\xF0\xF6" => "\xE8\xB4\x80",
		"\xF0\xF7" => "\xE8\xB9\x9C",
		"\xF0\xF8" => "\xE8\xB9\xA2",
		"\xF0\xF9" => "\xE8\xB9\xA0",
		"\xF0\xFA" => "\xE8\xB9\x97",
		"\xF0\xFB" => "\xE8\xB9\x96",
		"\xF0\xFC" => "\xE8\xB9\x9E",
		"\xF0\xFD" => "\xE8\xB9\xA5",
		"\xF0\xFE" => "\xE8\xB9\xA7",
		"\xF1\x40" => "\xE8\xB9\x9B",
		"\xF1\x41" => "\xE8\xB9\x9A",
		"\xF1\x42" => "\xE8\xB9\xA1",
		"\xF1\x43" => "\xE8\xB9\x9D",
		"\xF1\x44" => "\xE8\xB9\xA9",
		"\xF1\x45" => "\xE8\xB9\x94",
		"\xF1\x46" => "\xE8\xBD\x86",
		"\xF1\x47" => "\xE8\xBD\x87",
		"\xF1\x48" => "\xE8\xBD\x88",
		"\xF1\x49" => "\xE8\xBD\x8B",
		"\xF1\x4A" => "\xE9\x84\xA8",
		"\xF1\x4B" => "\xE9\x84\xBA",
		"\xF1\x4C" => "\xE9\x84\xBB",
		"\xF1\x4D" => "\xE9\x84\xBE",
		"\xF1\x4E" => "\xE9\x86\xA8",
		"\xF1\x4F" => "\xE9\x86\xA5",
		"\xF1\x50" => "\xE9\x86\xA7",
		"\xF1\x51" => "\xE9\x86\xAF",
		"\xF1\x52" => "\xE9\x86\xAA",
		"\xF1\x53" => "\xE9\x8E\xB5",
		"\xF1\x54" => "\xE9\x8E\x8C",
		"\xF1\x55" => "\xE9\x8E\x92",
		"\xF1\x56" => "\xE9\x8E\xB7",
		"\xF1\x57" => "\xE9\x8E\x9B",
		"\xF1\x58" => "\xE9\x8E\x9D",
		"\xF1\x59" => "\xE9\x8E\x89",
		"\xF1\x5A" => "\xE9\x8E\xA7",
		"\xF1\x5B" => "\xE9\x8E\x8E",
		"\xF1\x5C" => "\xE9\x8E\xAA",
		"\xF1\x5D" => "\xE9\x8E\x9E",
		"\xF1\x5E" => "\xE9\x8E\xA6",
		"\xF1\x5F" => "\xE9\x8E\x95",
		"\xF1\x60" => "\xE9\x8E\x88",
		"\xF1\x61" => "\xE9\x8E\x99",
		"\xF1\x62" => "\xE9\x8E\x9F",
		"\xF1\x63" => "\xE9\x8E\x8D",
		"\xF1\x64" => "\xE9\x8E\xB1",
		"\xF1\x65" => "\xE9\x8E\x91",
		"\xF1\x66" => "\xE9\x8E\xB2",
		"\xF1\x67" => "\xE9\x8E\xA4",
		"\xF1\x68" => "\xE9\x8E\xA8",
		"\xF1\x69" => "\xE9\x8E\xB4",
		"\xF1\x6A" => "\xE9\x8E\xA3",
		"\xF1\x6B" => "\xE9\x8E\xA5",
		"\xF1\x6C" => "\xE9\x97\x92",
		"\xF1\x6D" => "\xE9\x97\x93",
		"\xF1\x6E" => "\xE9\x97\x91",
		"\xF1\x6F" => "\xE9\x9A\xB3",
		"\xF1\x70" => "\xE9\x9B\x97",
		"\xF1\x71" => "\xE9\x9B\x9A",
		"\xF1\x72" => "\xE5\xB7\x82",
		"\xF1\x73" => "\xE9\x9B\x9F",
		"\xF1\x74" => "\xE9\x9B\x98",
		"\xF1\x75" => "\xE9\x9B\x9D",
		"\xF1\x76" => "\xE9\x9C\xA3",
		"\xF1\x77" => "\xE9\x9C\xA2",
		"\xF1\x78" => "\xE9\x9C\xA5",
		"\xF1\x79" => "\xE9\x9E\xAC",
		"\xF1\x7A" => "\xE9\x9E\xAE",
		"\xF1\x7B" => "\xE9\x9E\xA8",
		"\xF1\x7C" => "\xE9\x9E\xAB",
		"\xF1\x7D" => "\xE9\x9E\xA4",
		"\xF1\x7E" => "\xE9\x9E\xAA",
		"\xF1\xA1" => "\xE9\x9E\xA2",
		"\xF1\xA2" => "\xE9\x9E\xA5",
		"\xF1\xA3" => "\xE9\x9F\x97",
		"\xF1\xA4" => "\xE9\x9F\x99",
		"\xF1\xA5" => "\xE9\x9F\x96",
		"\xF1\xA6" => "\xE9\x9F\x98",
		"\xF1\xA7" => "\xE9\x9F\xBA",
		"\xF1\xA8" => "\xE9\xA1\x90",
		"\xF1\xA9" => "\xE9\xA1\x91",
		"\xF1\xAA" => "\xE9\xA1\x92",
		"\xF1\xAB" => "\xE9\xA2\xB8",
		"\xF1\xAC" => "\xE9\xA5\x81",
		"\xF1\xAD" => "\xE9\xA4\xBC",
		"\xF1\xAE" => "\xE9\xA4\xBA",
		"\xF1\xAF" => "\xE9\xA8\x8F",
		"\xF1\xB0" => "\xE9\xA8\x8B",
		"\xF1\xB1" => "\xE9\xA8\x89",
		"\xF1\xB2" => "\xE9\xA8\x8D",
		"\xF1\xB3" => "\xE9\xA8\x84",
		"\xF1\xB4" => "\xE9\xA8\x91",
		"\xF1\xB5" => "\xE9\xA8\x8A",
		"\xF1\xB6" => "\xE9\xA8\x85",
		"\xF1\xB7" => "\xE9\xA8\x87",
		"\xF1\xB8" => "\xE9\xA8\x86",
		"\xF1\xB9" => "\xE9\xAB\x80",
		"\xF1\xBA" => "\xE9\xAB\x9C",
		"\xF1\xBB" => "\xE9\xAC\x88",
		"\xF1\xBC" => "\xE9\xAC\x84",
		"\xF1\xBD" => "\xE9\xAC\x85",
		"\xF1\xBE" => "\xE9\xAC\xA9",
		"\xF1\xBF" => "\xE9\xAC\xB5",
		"\xF1\xC0" => "\xE9\xAD\x8A",
		"\xF1\xC1" => "\xE9\xAD\x8C",
		"\xF1\xC2" => "\xE9\xAD\x8B",
		"\xF1\xC3" => "\xE9\xAF\x87",
		"\xF1\xC4" => "\xE9\xAF\x86",
		"\xF1\xC5" => "\xE9\xAF\x83",
		"\xF1\xC6" => "\xE9\xAE\xBF",
		"\xF1\xC7" => "\xE9\xAF\x81",
		"\xF1\xC8" => "\xE9\xAE\xB5",
		"\xF1\xC9" => "\xE9\xAE\xB8",
		"\xF1\xCA" => "\xE9\xAF\x93",
		"\xF1\xCB" => "\xE9\xAE\xB6",
		"\xF1\xCC" => "\xE9\xAF\x84",
		"\xF1\xCD" => "\xE9\xAE\xB9",
		"\xF1\xCE" => "\xE9\xAE\xBD",
		"\xF1\xCF" => "\xE9\xB5\x9C",
		"\xF1\xD0" => "\xE9\xB5\x93",
		"\xF1\xD1" => "\xE9\xB5\x8F",
		"\xF1\xD2" => "\xE9\xB5\x8A",
		"\xF1\xD3" => "\xE9\xB5\x9B",
		"\xF1\xD4" => "\xE9\xB5\x8B",
		"\xF1\xD5" => "\xE9\xB5\x99",
		"\xF1\xD6" => "\xE9\xB5\x96",
		"\xF1\xD7" => "\xE9\xB5\x8C",
		"\xF1\xD8" => "\xE9\xB5\x97",
		"\xF1\xD9" => "\xE9\xB5\x92",
		"\xF1\xDA" => "\xE9\xB5\x94",
		"\xF1\xDB" => "\xE9\xB5\x9F",
		"\xF1\xDC" => "\xE9\xB5\x98",
		"\xF1\xDD" => "\xE9\xB5\x9A",
		"\xF1\xDE" => "\xE9\xBA\x8E",
		"\xF1\xDF" => "\xE9\xBA\x8C",
		"\xF1\xE0" => "\xE9\xBB\x9F",
		"\xF1\xE1" => "\xE9\xBC\x81",
		"\xF1\xE2" => "\xE9\xBC\x80",
		"\xF1\xE3" => "\xE9\xBC\x96",
		"\xF1\xE4" => "\xE9\xBC\xA5",
		"\xF1\xE5" => "\xE9\xBC\xAB",
		"\xF1\xE6" => "\xE9\xBC\xAA",
		"\xF1\xE7" => "\xE9\xBC\xA9",
		"\xF1\xE8" => "\xE9\xBC\xA8",
		"\xF1\xE9" => "\xE9\xBD\x8C",
		"\xF1\xEA" => "\xE9\xBD\x95",
		"\xF1\xEB" => "\xE5\x84\xB4",
		"\xF1\xEC" => "\xE5\x84\xB5",
		"\xF1\xED" => "\xE5\x8A\x96",
		"\xF1\xEE" => "\xE5\x8B\xB7",
		"\xF1\xEF" => "\xE5\x8E\xB4",
		"\xF1\xF0" => "\xE5\x9A\xAB",
		"\xF1\xF1" => "\xE5\x9A\xAD",
		"\xF1\xF2" => "\xE5\x9A\xA6",
		"\xF1\xF3" => "\xE5\x9A\xA7",
		"\xF1\xF4" => "\xE5\x9A\xAA",
		"\xF1\xF5" => "\xE5\x9A\xAC",
		"\xF1\xF6" => "\xE5\xA3\x9A",
		"\xF1\xF7" => "\xE5\xA3\x9D",
		"\xF1\xF8" => "\xE5\xA3\x9B",
		"\xF1\xF9" => "\xE5\xA4\x92",
		"\xF1\xFA" => "\xE5\xAC\xBD",
		"\xF1\xFB" => "\xE5\xAC\xBE",
		"\xF1\xFC" => "\xE5\xAC\xBF",
		"\xF1\xFD" => "\xE5\xB7\x83",
		"\xF1\xFE" => "\xE5\xB9\xB0",
		"\xF2\x40" => "\xE5\xBE\xBF",
		"\xF2\x41" => "\xE6\x87\xBB",
		"\xF2\x42" => "\xE6\x94\x87",
		"\xF2\x43" => "\xE6\x94\x90",
		"\xF2\x44" => "\xE6\x94\x8D",
		"\xF2\x45" => "\xE6\x94\x89",
		"\xF2\x46" => "\xE6\x94\x8C",
		"\xF2\x47" => "\xE6\x94\x8E",
		"\xF2\x48" => "\xE6\x96\x84",
		"\xF2\x49" => "\xE6\x97\x9E",
		"\xF2\x4A" => "\xE6\x97\x9D",
		"\xF2\x4B" => "\xE6\x9B\x9E",
		"\xF2\x4C" => "\xE6\xAB\xA7",
		"\xF2\x4D" => "\xE6\xAB\xA0",
		"\xF2\x4E" => "\xE6\xAB\x8C",
		"\xF2\x4F" => "\xE6\xAB\x91",
		"\xF2\x50" => "\xE6\xAB\x99",
		"\xF2\x51" => "\xE6\xAB\x8B",
		"\xF2\x52" => "\xE6\xAB\x9F",
		"\xF2\x53" => "\xE6\xAB\x9C",
		"\xF2\x54" => "\xE6\xAB\x90",
		"\xF2\x55" => "\xE6\xAB\xAB",
		"\xF2\x56" => "\xE6\xAB\x8F",
		"\xF2\x57" => "\xE6\xAB\x8D",
		"\xF2\x58" => "\xE6\xAB\x9E",
		"\xF2\x59" => "\xE6\xAD\xA0",
		"\xF2\x5A" => "\xE6\xAE\xB0",
		"\xF2\x5B" => "\xE6\xB0\x8C",
		"\xF2\x5C" => "\xE7\x80\x99",
		"\xF2\x5D" => "\xE7\x80\xA7",
		"\xF2\x5E" => "\xE7\x80\xA0",
		"\xF2\x5F" => "\xE7\x80\x96",
		"\xF2\x60" => "\xE7\x80\xAB",
		"\xF2\x61" => "\xE7\x80\xA1",
		"\xF2\x62" => "\xE7\x80\xA2",
		"\xF2\x63" => "\xE7\x80\xA3",
		"\xF2\x64" => "\xE7\x80\xA9",
		"\xF2\x65" => "\xE7\x80\x97",
		"\xF2\x66" => "\xE7\x80\xA4",
		"\xF2\x67" => "\xE7\x80\x9C",
		"\xF2\x68" => "\xE7\x80\xAA",
		"\xF2\x69" => "\xE7\x88\x8C",
		"\xF2\x6A" => "\xE7\x88\x8A",
		"\xF2\x6B" => "\xE7\x88\x87",
		"\xF2\x6C" => "\xE7\x88\x82",
		"\xF2\x6D" => "\xE7\x88\x85",
		"\xF2\x6E" => "\xE7\x8A\xA5",
		"\xF2\x6F" => "\xE7\x8A\xA6",
		"\xF2\x70" => "\xE7\x8A\xA4",
		"\xF2\x71" => "\xE7\x8A\xA3",
		"\xF2\x72" => "\xE7\x8A\xA1",
		"\xF2\x73" => "\xE7\x93\x8B",
		"\xF2\x74" => "\xE7\x93\x85",
		"\xF2\x75" => "\xE7\x92\xB7",
		"\xF2\x76" => "\xE7\x93\x83",
		"\xF2\x77" => "\xE7\x94\x96",
		"\xF2\x78" => "\xE7\x99\xA0",
		"\xF2\x79" => "\xE7\x9F\x89",
		"\xF2\x7A" => "\xE7\x9F\x8A",
		"\xF2\x7B" => "\xE7\x9F\x84",
		"\xF2\x7C" => "\xE7\x9F\xB1",
		"\xF2\x7D" => "\xE7\xA4\x9D",
		"\xF2\x7E" => "\xE7\xA4\x9B",
		"\xF2\xA1" => "\xE7\xA4\xA1",
		"\xF2\xA2" => "\xE7\xA4\x9C",
		"\xF2\xA3" => "\xE7\xA4\x97",
		"\xF2\xA4" => "\xE7\xA4\x9E",
		"\xF2\xA5" => "\xE7\xA6\xB0",
		"\xF2\xA6" => "\xE7\xA9\xA7",
		"\xF2\xA7" => "\xE7\xA9\xA8",
		"\xF2\xA8" => "\xE7\xB0\xB3",
		"\xF2\xA9" => "\xE7\xB0\xBC",
		"\xF2\xAA" => "\xE7\xB0\xB9",
		"\xF2\xAB" => "\xE7\xB0\xAC",
		"\xF2\xAC" => "\xE7\xB0\xBB",
		"\xF2\xAD" => "\xE7\xB3\xAC",
		"\xF2\xAE" => "\xE7\xB3\xAA",
		"\xF2\xAF" => "\xE7\xB9\xB6",
		"\xF2\xB0" => "\xE7\xB9\xB5",
		"\xF2\xB1" => "\xE7\xB9\xB8",
		"\xF2\xB2" => "\xE7\xB9\xB0",
		"\xF2\xB3" => "\xE7\xB9\xB7",
		"\xF2\xB4" => "\xE7\xB9\xAF",
		"\xF2\xB5" => "\xE7\xB9\xBA",
		"\xF2\xB6" => "\xE7\xB9\xB2",
		"\xF2\xB7" => "\xE7\xB9\xB4",
		"\xF2\xB8" => "\xE7\xB9\xA8",
		"\xF2\xB9" => "\xE7\xBD\x8B",
		"\xF2\xBA" => "\xE7\xBD\x8A",
		"\xF2\xBB" => "\xE7\xBE\x83",
		"\xF2\xBC" => "\xE7\xBE\x86",
		"\xF2\xBD" => "\xE7\xBE\xB7",
		"\xF2\xBE" => "\xE7\xBF\xBD",
		"\xF2\xBF" => "\xE7\xBF\xBE",
		"\xF2\xC0" => "\xE8\x81\xB8",
		"\xF2\xC1" => "\xE8\x87\x97",
		"\xF2\xC2" => "\xE8\x87\x95",
		"\xF2\xC3" => "\xE8\x89\xA4",
		"\xF2\xC4" => "\xE8\x89\xA1",
		"\xF2\xC5" => "\xE8\x89\xA3",
		"\xF2\xC6" => "\xE8\x97\xAB",
		"\xF2\xC7" => "\xE8\x97\xB1",
		"\xF2\xC8" => "\xE8\x97\xAD",
		"\xF2\xC9" => "\xE8\x97\x99",
		"\xF2\xCA" => "\xE8\x97\xA1",
		"\xF2\xCB" => "\xE8\x97\xA8",
		"\xF2\xCC" => "\xE8\x97\x9A",
		"\xF2\xCD" => "\xE8\x97\x97",
		"\xF2\xCE" => "\xE8\x97\xAC",
		"\xF2\xCF" => "\xE8\x97\xB2",
		"\xF2\xD0" => "\xE8\x97\xB8",
		"\xF2\xD1" => "\xE8\x97\x98",
		"\xF2\xD2" => "\xE8\x97\x9F",
		"\xF2\xD3" => "\xE8\x97\xA3",
		"\xF2\xD4" => "\xE8\x97\x9C",
		"\xF2\xD5" => "\xE8\x97\x91",
		"\xF2\xD6" => "\xE8\x97\xB0",
		"\xF2\xD7" => "\xE8\x97\xA6",
		"\xF2\xD8" => "\xE8\x97\xAF",
		"\xF2\xD9" => "\xE8\x97\x9E",
		"\xF2\xDA" => "\xE8\x97\xA2",
		"\xF2\xDB" => "\xE8\xA0\x80",
		"\xF2\xDC" => "\xE8\x9F\xBA",
		"\xF2\xDD" => "\xE8\xA0\x83",
		"\xF2\xDE" => "\xE8\x9F\xB6",
		"\xF2\xDF" => "\xE8\x9F\xB7",
		"\xF2\xE0" => "\xE8\xA0\x89",
		"\xF2\xE1" => "\xE8\xA0\x8C",
		"\xF2\xE2" => "\xE8\xA0\x8B",
		"\xF2\xE3" => "\xE8\xA0\x86",
		"\xF2\xE4" => "\xE8\x9F\xBC",
		"\xF2\xE5" => "\xE8\xA0\x88",
		"\xF2\xE6" => "\xE8\x9F\xBF",
		"\xF2\xE7" => "\xE8\xA0\x8A",
		"\xF2\xE8" => "\xE8\xA0\x82",
		"\xF2\xE9" => "\xE8\xA5\xA2",
		"\xF2\xEA" => "\xE8\xA5\x9A",
		"\xF2\xEB" => "\xE8\xA5\x9B",
		"\xF2\xEC" => "\xE8\xA5\x97",
		"\xF2\xED" => "\xE8\xA5\xA1",
		"\xF2\xEE" => "\xE8\xA5\x9C",
		"\xF2\xEF" => "\xE8\xA5\x98",
		"\xF2\xF0" => "\xE8\xA5\x9D",
		"\xF2\xF1" => "\xE8\xA5\x99",
		"\xF2\xF2" => "\xE8\xA6\x88",
		"\xF2\xF3" => "\xE8\xA6\xB7",
		"\xF2\xF4" => "\xE8\xA6\xB6",
		"\xF2\xF5" => "\xE8\xA7\xB6",
		"\xF2\xF6" => "\xE8\xAD\x90",
		"\xF2\xF7" => "\xE8\xAD\x88",
		"\xF2\xF8" => "\xE8\xAD\x8A",
		"\xF2\xF9" => "\xE8\xAD\x80",
		"\xF2\xFA" => "\xE8\xAD\x93",
		"\xF2\xFB" => "\xE8\xAD\x96",
		"\xF2\xFC" => "\xE8\xAD\x94",
		"\xF2\xFD" => "\xE8\xAD\x8B",
		"\xF2\xFE" => "\xE8\xAD\x95",
		"\xF3\x40" => "\xE8\xAD\x91",
		"\xF3\x41" => "\xE8\xAD\x82",
		"\xF3\x42" => "\xE8\xAD\x92",
		"\xF3\x43" => "\xE8\xAD\x97",
		"\xF3\x44" => "\xE8\xB1\x83",
		"\xF3\x45" => "\xE8\xB1\xB7",
		"\xF3\x46" => "\xE8\xB1\xB6",
		"\xF3\x47" => "\xE8\xB2\x9A",
		"\xF3\x48" => "\xE8\xB4\x86",
		"\xF3\x49" => "\xE8\xB4\x87",
		"\xF3\x4A" => "\xE8\xB4\x89",
		"\xF3\x4B" => "\xE8\xB6\xAC",
		"\xF3\x4C" => "\xE8\xB6\xAA",
		"\xF3\x4D" => "\xE8\xB6\xAD",
		"\xF3\x4E" => "\xE8\xB6\xAB",
		"\xF3\x4F" => "\xE8\xB9\xAD",
		"\xF3\x50" => "\xE8\xB9\xB8",
		"\xF3\x51" => "\xE8\xB9\xB3",
		"\xF3\x52" => "\xE8\xB9\xAA",
		"\xF3\x53" => "\xE8\xB9\xAF",
		"\xF3\x54" => "\xE8\xB9\xBB",
		"\xF3\x55" => "\xE8\xBB\x82",
		"\xF3\x56" => "\xE8\xBD\x92",
		"\xF3\x57" => "\xE8\xBD\x91",
		"\xF3\x58" => "\xE8\xBD\x8F",
		"\xF3\x59" => "\xE8\xBD\x90",
		"\xF3\x5A" => "\xE8\xBD\x93",
		"\xF3\x5B" => "\xE8\xBE\xB4",
		"\xF3\x5C" => "\xE9\x85\x80",
		"\xF3\x5D" => "\xE9\x84\xBF",
		"\xF3\x5E" => "\xE9\x86\xB0",
		"\xF3\x5F" => "\xE9\x86\xAD",
		"\xF3\x60" => "\xE9\x8F\x9E",
		"\xF3\x61" => "\xE9\x8F\x87",
		"\xF3\x62" => "\xE9\x8F\x8F",
		"\xF3\x63" => "\xE9\x8F\x82",
		"\xF3\x64" => "\xE9\x8F\x9A",
		"\xF3\x65" => "\xE9\x8F\x90",
		"\xF3\x66" => "\xE9\x8F\xB9",
		"\xF3\x67" => "\xE9\x8F\xAC",
		"\xF3\x68" => "\xE9\x8F\x8C",
		"\xF3\x69" => "\xE9\x8F\x99",
		"\xF3\x6A" => "\xE9\x8E\xA9",
		"\xF3\x6B" => "\xE9\x8F\xA6",
		"\xF3\x6C" => "\xE9\x8F\x8A",
		"\xF3\x6D" => "\xE9\x8F\x94",
		"\xF3\x6E" => "\xE9\x8F\xAE",
		"\xF3\x6F" => "\xE9\x8F\xA3",
		"\xF3\x70" => "\xE9\x8F\x95",
		"\xF3\x71" => "\xE9\x8F\x84",
		"\xF3\x72" => "\xE9\x8F\x8E",
		"\xF3\x73" => "\xE9\x8F\x80",
		"\xF3\x74" => "\xE9\x8F\x92",
		"\xF3\x75" => "\xE9\x8F\xA7",
		"\xF3\x76" => "\xE9\x95\xBD",
		"\xF3\x77" => "\xE9\x97\x9A",
		"\xF3\x78" => "\xE9\x97\x9B",
		"\xF3\x79" => "\xE9\x9B\xA1",
		"\xF3\x7A" => "\xE9\x9C\xA9",
		"\xF3\x7B" => "\xE9\x9C\xAB",
		"\xF3\x7C" => "\xE9\x9C\xAC",
		"\xF3\x7D" => "\xE9\x9C\xA8",
		"\xF3\x7E" => "\xE9\x9C\xA6",
		"\xF3\xA1" => "\xE9\x9E\xB3",
		"\xF3\xA2" => "\xE9\x9E\xB7",
		"\xF3\xA3" => "\xE9\x9E\xB6",
		"\xF3\xA4" => "\xE9\x9F\x9D",
		"\xF3\xA5" => "\xE9\x9F\x9E",
		"\xF3\xA6" => "\xE9\x9F\x9F",
		"\xF3\xA7" => "\xE9\xA1\x9C",
		"\xF3\xA8" => "\xE9\xA1\x99",
		"\xF3\xA9" => "\xE9\xA1\x9D",
		"\xF3\xAA" => "\xE9\xA1\x97",
		"\xF3\xAB" => "\xE9\xA2\xBF",
		"\xF3\xAC" => "\xE9\xA2\xBD",
		"\xF3\xAD" => "\xE9\xA2\xBB",
		"\xF3\xAE" => "\xE9\xA2\xBE",
		"\xF3\xAF" => "\xE9\xA5\x88",
		"\xF3\xB0" => "\xE9\xA5\x87",
		"\xF3\xB1" => "\xE9\xA5\x83",
		"\xF3\xB2" => "\xE9\xA6\xA6",
		"\xF3\xB3" => "\xE9\xA6\xA7",
		"\xF3\xB4" => "\xE9\xA8\x9A",
		"\xF3\xB5" => "\xE9\xA8\x95",
		"\xF3\xB6" => "\xE9\xA8\xA5",
		"\xF3\xB7" => "\xE9\xA8\x9D",
		"\xF3\xB8" => "\xE9\xA8\xA4",
		"\xF3\xB9" => "\xE9\xA8\x9B",
		"\xF3\xBA" => "\xE9\xA8\xA2",
		"\xF3\xBB" => "\xE9\xA8\xA0",
		"\xF3\xBC" => "\xE9\xA8\xA7",
		"\xF3\xBD" => "\xE9\xA8\xA3",
		"\xF3\xBE" => "\xE9\xA8\x9E",
		"\xF3\xBF" => "\xE9\xA8\x9C",
		"\xF3\xC0" => "\xE9\xA8\x94",
		"\xF3\xC1" => "\xE9\xAB\x82",
		"\xF3\xC2" => "\xE9\xAC\x8B",
		"\xF3\xC3" => "\xE9\xAC\x8A",
		"\xF3\xC4" => "\xE9\xAC\x8E",
		"\xF3\xC5" => "\xE9\xAC\x8C",
		"\xF3\xC6" => "\xE9\xAC\xB7",
		"\xF3\xC7" => "\xE9\xAF\xAA",
		"\xF3\xC8" => "\xE9\xAF\xAB",
		"\xF3\xC9" => "\xE9\xAF\xA0",
		"\xF3\xCA" => "\xE9\xAF\x9E",
		"\xF3\xCB" => "\xE9\xAF\xA4",
		"\xF3\xCC" => "\xE9\xAF\xA6",
		"\xF3\xCD" => "\xE9\xAF\xA2",
		"\xF3\xCE" => "\xE9\xAF\xB0",
		"\xF3\xCF" => "\xE9\xAF\x94",
		"\xF3\xD0" => "\xE9\xAF\x97",
		"\xF3\xD1" => "\xE9\xAF\xAC",
		"\xF3\xD2" => "\xE9\xAF\x9C",
		"\xF3\xD3" => "\xE9\xAF\x99",
		"\xF3\xD4" => "\xE9\xAF\xA5",
		"\xF3\xD5" => "\xE9\xAF\x95",
		"\xF3\xD6" => "\xE9\xAF\xA1",
		"\xF3\xD7" => "\xE9\xAF\x9A",
		"\xF3\xD8" => "\xE9\xB5\xB7",
		"\xF3\xD9" => "\xE9\xB6\x81",
		"\xF3\xDA" => "\xE9\xB6\x8A",
		"\xF3\xDB" => "\xE9\xB6\x84",
		"\xF3\xDC" => "\xE9\xB6\x88",
		"\xF3\xDD" => "\xE9\xB5\xB1",
		"\xF3\xDE" => "\xE9\xB6\x80",
		"\xF3\xDF" => "\xE9\xB5\xB8",
		"\xF3\xE0" => "\xE9\xB6\x86",
		"\xF3\xE1" => "\xE9\xB6\x8B",
		"\xF3\xE2" => "\xE9\xB6\x8C",
		"\xF3\xE3" => "\xE9\xB5\xBD",
		"\xF3\xE4" => "\xE9\xB5\xAB",
		"\xF3\xE5" => "\xE9\xB5\xB4",
		"\xF3\xE6" => "\xE9\xB5\xB5",
		"\xF3\xE7" => "\xE9\xB5\xB0",
		"\xF3\xE8" => "\xE9\xB5\xA9",
		"\xF3\xE9" => "\xE9\xB6\x85",
		"\xF3\xEA" => "\xE9\xB5\xB3",
		"\xF3\xEB" => "\xE9\xB5\xBB",
		"\xF3\xEC" => "\xE9\xB6\x82",
		"\xF3\xED" => "\xE9\xB5\xAF",
		"\xF3\xEE" => "\xE9\xB5\xB9",
		"\xF3\xEF" => "\xE9\xB5\xBF",
		"\xF3\xF0" => "\xE9\xB6\x87",
		"\xF3\xF1" => "\xE9\xB5\xA8",
		"\xF3\xF2" => "\xE9\xBA\x94",
		"\xF3\xF3" => "\xE9\xBA\x91",
		"\xF3\xF4" => "\xE9\xBB\x80",
		"\xF3\xF5" => "\xE9\xBB\xBC",
		"\xF3\xF6" => "\xE9\xBC\xAD",
		"\xF3\xF7" => "\xE9\xBD\x80",
		"\xF3\xF8" => "\xE9\xBD\x81",
		"\xF3\xF9" => "\xE9\xBD\x8D",
		"\xF3\xFA" => "\xE9\xBD\x96",
		"\xF3\xFB" => "\xE9\xBD\x97",
		"\xF3\xFC" => "\xE9\xBD\x98",
		"\xF3\xFD" => "\xE5\x8C\xB7",
		"\xF3\xFE" => "\xE5\x9A\xB2",
		"\xF4\x40" => "\xE5\x9A\xB5",
		"\xF4\x41" => "\xE5\x9A\xB3",
		"\xF4\x42" => "\xE5\xA3\xA3",
		"\xF4\x43" => "\xE5\xAD\x85",
		"\xF4\x44" => "\xE5\xB7\x86",
		"\xF4\x45" => "\xE5\xB7\x87",
		"\xF4\x46" => "\xE5\xBB\xAE",
		"\xF4\x47" => "\xE5\xBB\xAF",
		"\xF4\x48" => "\xE5\xBF\x80",
		"\xF4\x49" => "\xE5\xBF\x81",
		"\xF4\x4A" => "\xE6\x87\xB9",
		"\xF4\x4B" => "\xE6\x94\x97",
		"\xF4\x4C" => "\xE6\x94\x96",
		"\xF4\x4D" => "\xE6\x94\x95",
		"\xF4\x4E" => "\xE6\x94\x93",
		"\xF4\x4F" => "\xE6\x97\x9F",
		"\xF4\x50" => "\xE6\x9B\xA8",
		"\xF4\x51" => "\xE6\x9B\xA3",
		"\xF4\x52" => "\xE6\x9B\xA4",
		"\xF4\x53" => "\xE6\xAB\xB3",
		"\xF4\x54" => "\xE6\xAB\xB0",
		"\xF4\x55" => "\xE6\xAB\xAA",
		"\xF4\x56" => "\xE6\xAB\xA8",
		"\xF4\x57" => "\xE6\xAB\xB9",
		"\xF4\x58" => "\xE6\xAB\xB1",
		"\xF4\x59" => "\xE6\xAB\xAE",
		"\xF4\x5A" => "\xE6\xAB\xAF",
		"\xF4\x5B" => "\xE7\x80\xBC",
		"\xF4\x5C" => "\xE7\x80\xB5",
		"\xF4\x5D" => "\xE7\x80\xAF",
		"\xF4\x5E" => "\xE7\x80\xB7",
		"\xF4\x5F" => "\xE7\x80\xB4",
		"\xF4\x60" => "\xE7\x80\xB1",
		"\xF4\x61" => "\xE7\x81\x82",
		"\xF4\x62" => "\xE7\x80\xB8",
		"\xF4\x63" => "\xE7\x80\xBF",
		"\xF4\x64" => "\xE7\x80\xBA",
		"\xF4\x65" => "\xE7\x80\xB9",
		"\xF4\x66" => "\xE7\x81\x80",
		"\xF4\x67" => "\xE7\x80\xBB",
		"\xF4\x68" => "\xE7\x80\xB3",
		"\xF4\x69" => "\xE7\x81\x81",
		"\xF4\x6A" => "\xE7\x88\x93",
		"\xF4\x6B" => "\xE7\x88\x94",
		"\xF4\x6C" => "\xE7\x8A\xA8",
		"\xF4\x6D" => "\xE7\x8D\xBD",
		"\xF4\x6E" => "\xE7\x8D\xBC",
		"\xF4\x6F" => "\xE7\x92\xBA",
		"\xF4\x70" => "\xE7\x9A\xAB",
		"\xF4\x71" => "\xE7\x9A\xAA",
		"\xF4\x72" => "\xE7\x9A\xBE",
		"\xF4\x73" => "\xE7\x9B\xAD",
		"\xF4\x74" => "\xE7\x9F\x8C",
		"\xF4\x75" => "\xE7\x9F\x8E",
		"\xF4\x76" => "\xE7\x9F\x8F",
		"\xF4\x77" => "\xE7\x9F\x8D",
		"\xF4\x78" => "\xE7\x9F\xB2",
		"\xF4\x79" => "\xE7\xA4\xA5",
		"\xF4\x7A" => "\xE7\xA4\xA3",
		"\xF4\x7B" => "\xE7\xA4\xA7",
		"\xF4\x7C" => "\xE7\xA4\xA8",
		"\xF4\x7D" => "\xE7\xA4\xA4",
		"\xF4\x7E" => "\xE7\xA4\xA9",
		"\xF4\xA1" => "\xE7\xA6\xB2",
		"\xF4\xA2" => "\xE7\xA9\xAE",
		"\xF4\xA3" => "\xE7\xA9\xAC",
		"\xF4\xA4" => "\xE7\xA9\xAD",
		"\xF4\xA5" => "\xE7\xAB\xB7",
		"\xF4\xA6" => "\xE7\xB1\x89",
		"\xF4\xA7" => "\xE7\xB1\x88",
		"\xF4\xA8" => "\xE7\xB1\x8A",
		"\xF4\xA9" => "\xE7\xB1\x87",
		"\xF4\xAA" => "\xE7\xB1\x85",
		"\xF4\xAB" => "\xE7\xB3\xAE",
		"\xF4\xAC" => "\xE7\xB9\xBB",
		"\xF4\xAD" => "\xE7\xB9\xBE",
		"\xF4\xAE" => "\xE7\xBA\x81",
		"\xF4\xAF" => "\xE7\xBA\x80",
		"\xF4\xB0" => "\xE7\xBE\xBA",
		"\xF4\xB1" => "\xE7\xBF\xBF",
		"\xF4\xB2" => "\xE8\x81\xB9",
		"\xF4\xB3" => "\xE8\x87\x9B",
		"\xF4\xB4" => "\xE8\x87\x99",
		"\xF4\xB5" => "\xE8\x88\x8B",
		"\xF4\xB6" => "\xE8\x89\xA8",
		"\xF4\xB7" => "\xE8\x89\xA9",
		"\xF4\xB8" => "\xE8\x98\xA2",
		"\xF4\xB9" => "\xE8\x97\xBF",
		"\xF4\xBA" => "\xE8\x98\x81",
		"\xF4\xBB" => "\xE8\x97\xBE",
		"\xF4\xBC" => "\xE8\x98\x9B",
		"\xF4\xBD" => "\xE8\x98\x80",
		"\xF4\xBE" => "\xE8\x97\xB6",
		"\xF4\xBF" => "\xE8\x98\x84",
		"\xF4\xC0" => "\xE8\x98\x89",
		"\xF4\xC1" => "\xE8\x98\x85",
		"\xF4\xC2" => "\xE8\x98\x8C",
		"\xF4\xC3" => "\xE8\x97\xBD",
		"\xF4\xC4" => "\xE8\xA0\x99",
		"\xF4\xC5" => "\xE8\xA0\x90",
		"\xF4\xC6" => "\xE8\xA0\x91",
		"\xF4\xC7" => "\xE8\xA0\x97",
		"\xF4\xC8" => "\xE8\xA0\x93",
		"\xF4\xC9" => "\xE8\xA0\x96",
		"\xF4\xCA" => "\xE8\xA5\xA3",
		"\xF4\xCB" => "\xE8\xA5\xA6",
		"\xF4\xCC" => "\xE8\xA6\xB9",
		"\xF4\xCD" => "\xE8\xA7\xB7",
		"\xF4\xCE" => "\xE8\xAD\xA0",
		"\xF4\xCF" => "\xE8\xAD\xAA",
		"\xF4\xD0" => "\xE8\xAD\x9D",
		"\xF4\xD1" => "\xE8\xAD\xA8",
		"\xF4\xD2" => "\xE8\xAD\xA3",
		"\xF4\xD3" => "\xE8\xAD\xA5",
		"\xF4\xD4" => "\xE8\xAD\xA7",
		"\xF4\xD5" => "\xE8\xAD\xAD",
		"\xF4\xD6" => "\xE8\xB6\xAE",
		"\xF4\xD7" => "\xE8\xBA\x86",
		"\xF4\xD8" => "\xE8\xBA\x88",
		"\xF4\xD9" => "\xE8\xBA\x84",
		"\xF4\xDA" => "\xE8\xBD\x99",
		"\xF4\xDB" => "\xE8\xBD\x96",
		"\xF4\xDC" => "\xE8\xBD\x97",
		"\xF4\xDD" => "\xE8\xBD\x95",
		"\xF4\xDE" => "\xE8\xBD\x98",
		"\xF4\xDF" => "\xE8\xBD\x9A",
		"\xF4\xE0" => "\xE9\x82\x8D",
		"\xF4\xE1" => "\xE9\x85\x83",
		"\xF4\xE2" => "\xE9\x85\x81",
		"\xF4\xE3" => "\xE9\x86\xB7",
		"\xF4\xE4" => "\xE9\x86\xB5",
		"\xF4\xE5" => "\xE9\x86\xB2",
		"\xF4\xE6" => "\xE9\x86\xB3",
		"\xF4\xE7" => "\xE9\x90\x8B",
		"\xF4\xE8" => "\xE9\x90\x93",
		"\xF4\xE9" => "\xE9\x8F\xBB",
		"\xF4\xEA" => "\xE9\x90\xA0",
		"\xF4\xEB" => "\xE9\x90\x8F",
		"\xF4\xEC" => "\xE9\x90\x94",
		"\xF4\xED" => "\xE9\x8F\xBE",
		"\xF4\xEE" => "\xE9\x90\x95",
		"\xF4\xEF" => "\xE9\x90\x90",
		"\xF4\xF0" => "\xE9\x90\xA8",
		"\xF4\xF1" => "\xE9\x90\x99",
		"\xF4\xF2" => "\xE9\x90\x8D",
		"\xF4\xF3" => "\xE9\x8F\xB5",
		"\xF4\xF4" => "\xE9\x90\x80",
		"\xF4\xF5" => "\xE9\x8F\xB7",
		"\xF4\xF6" => "\xE9\x90\x87",
		"\xF4\xF7" => "\xE9\x90\x8E",
		"\xF4\xF8" => "\xE9\x90\x96",
		"\xF4\xF9" => "\xE9\x90\x92",
		"\xF4\xFA" => "\xE9\x8F\xBA",
		"\xF4\xFB" => "\xE9\x90\x89",
		"\xF4\xFC" => "\xE9\x8F\xB8",
		"\xF4\xFD" => "\xE9\x90\x8A",
		"\xF4\xFE" => "\xE9\x8F\xBF",
		"\xF5\x40" => "\xE9\x8F\xBC",
		"\xF5\x41" => "\xE9\x90\x8C",
		"\xF5\x42" => "\xE9\x8F\xB6",
		"\xF5\x43" => "\xE9\x90\x91",
		"\xF5\x44" => "\xE9\x90\x86",
		"\xF5\x45" => "\xE9\x97\x9E",
		"\xF5\x46" => "\xE9\x97\xA0",
		"\xF5\x47" => "\xE9\x97\x9F",
		"\xF5\x48" => "\xE9\x9C\xAE",
		"\xF5\x49" => "\xE9\x9C\xAF",
		"\xF5\x4A" => "\xE9\x9E\xB9",
		"\xF5\x4B" => "\xE9\x9E\xBB",
		"\xF5\x4C" => "\xE9\x9F\xBD",
		"\xF5\x4D" => "\xE9\x9F\xBE",
		"\xF5\x4E" => "\xE9\xA1\xA0",
		"\xF5\x4F" => "\xE9\xA1\xA2",
		"\xF5\x50" => "\xE9\xA1\xA3",
		"\xF5\x51" => "\xE9\xA1\x9F",
		"\xF5\x52" => "\xE9\xA3\x81",
		"\xF5\x53" => "\xE9\xA3\x82",
		"\xF5\x54" => "\xE9\xA5\x90",
		"\xF5\x55" => "\xE9\xA5\x8E",
		"\xF5\x56" => "\xE9\xA5\x99",
		"\xF5\x57" => "\xE9\xA5\x8C",
		"\xF5\x58" => "\xE9\xA5\x8B",
		"\xF5\x59" => "\xE9\xA5\x93",
		"\xF5\x5A" => "\xE9\xA8\xB2",
		"\xF5\x5B" => "\xE9\xA8\xB4",
		"\xF5\x5C" => "\xE9\xA8\xB1",
		"\xF5\x5D" => "\xE9\xA8\xAC",
		"\xF5\x5E" => "\xE9\xA8\xAA",
		"\xF5\x5F" => "\xE9\xA8\xB6",
		"\xF5\x60" => "\xE9\xA8\xA9",
		"\xF5\x61" => "\xE9\xA8\xAE",
		"\xF5\x62" => "\xE9\xA8\xB8",
		"\xF5\x63" => "\xE9\xA8\xAD",
		"\xF5\x64" => "\xE9\xAB\x87",
		"\xF5\x65" => "\xE9\xAB\x8A",
		"\xF5\x66" => "\xE9\xAB\x86",
		"\xF5\x67" => "\xE9\xAC\x90",
		"\xF5\x68" => "\xE9\xAC\x92",
		"\xF5\x69" => "\xE9\xAC\x91",
		"\xF5\x6A" => "\xE9\xB0\x8B",
		"\xF5\x6B" => "\xE9\xB0\x88",
		"\xF5\x6C" => "\xE9\xAF\xB7",
		"\xF5\x6D" => "\xE9\xB0\x85",
		"\xF5\x6E" => "\xE9\xB0\x92",
		"\xF5\x6F" => "\xE9\xAF\xB8",
		"\xF5\x70" => "\xE9\xB1\x80",
		"\xF5\x71" => "\xE9\xB0\x87",
		"\xF5\x72" => "\xE9\xB0\x8E",
		"\xF5\x73" => "\xE9\xB0\x86",
		"\xF5\x74" => "\xE9\xB0\x97",
		"\xF5\x75" => "\xE9\xB0\x94",
		"\xF5\x76" => "\xE9\xB0\x89",
		"\xF5\x77" => "\xE9\xB6\x9F",
		"\xF5\x78" => "\xE9\xB6\x99",
		"\xF5\x79" => "\xE9\xB6\xA4",
		"\xF5\x7A" => "\xE9\xB6\x9D",
		"\xF5\x7B" => "\xE9\xB6\x92",
		"\xF5\x7C" => "\xE9\xB6\x98",
		"\xF5\x7D" => "\xE9\xB6\x90",
		"\xF5\x7E" => "\xE9\xB6\x9B",
		"\xF5\xA1" => "\xE9\xB6\xA0",
		"\xF5\xA2" => "\xE9\xB6\x94",
		"\xF5\xA3" => "\xE9\xB6\x9C",
		"\xF5\xA4" => "\xE9\xB6\xAA",
		"\xF5\xA5" => "\xE9\xB6\x97",
		"\xF5\xA6" => "\xE9\xB6\xA1",
		"\xF5\xA7" => "\xE9\xB6\x9A",
		"\xF5\xA8" => "\xE9\xB6\xA2",
		"\xF5\xA9" => "\xE9\xB6\xA8",
		"\xF5\xAA" => "\xE9\xB6\x9E",
		"\xF5\xAB" => "\xE9\xB6\xA3",
		"\xF5\xAC" => "\xE9\xB6\xBF",
		"\xF5\xAD" => "\xE9\xB6\xA9",
		"\xF5\xAE" => "\xE9\xB6\x96",
		"\xF5\xAF" => "\xE9\xB6\xA6",
		"\xF5\xB0" => "\xE9\xB6\xA7",
		"\xF5\xB1" => "\xE9\xBA\x99",
		"\xF5\xB2" => "\xE9\xBA\x9B",
		"\xF5\xB3" => "\xE9\xBA\x9A",
		"\xF5\xB4" => "\xE9\xBB\xA5",
		"\xF5\xB5" => "\xE9\xBB\xA4",
		"\xF5\xB6" => "\xE9\xBB\xA7",
		"\xF5\xB7" => "\xE9\xBB\xA6",
		"\xF5\xB8" => "\xE9\xBC\xB0",
		"\xF5\xB9" => "\xE9\xBC\xAE",
		"\xF5\xBA" => "\xE9\xBD\x9B",
		"\xF5\xBB" => "\xE9\xBD\xA0",
		"\xF5\xBC" => "\xE9\xBD\x9E",
		"\xF5\xBD" => "\xE9\xBD\x9D",
		"\xF5\xBE" => "\xE9\xBD\x99",
		"\xF5\xBF" => "\xE9\xBE\x91",
		"\xF5\xC0" => "\xE5\x84\xBA",
		"\xF5\xC1" => "\xE5\x84\xB9",
		"\xF5\xC2" => "\xE5\x8A\x98",
		"\xF5\xC3" => "\xE5\x8A\x97",
		"\xF5\xC4" => "\xE5\x9B\x83",
		"\xF5\xC5" => "\xE5\x9A\xBD",
		"\xF5\xC6" => "\xE5\x9A\xBE",
		"\xF5\xC7" => "\xE5\xAD\x88",
		"\xF5\xC8" => "\xE5\xAD\x87",
		"\xF5\xC9" => "\xE5\xB7\x8B",
		"\xF5\xCA" => "\xE5\xB7\x8F",
		"\xF5\xCB" => "\xE5\xBB\xB1",
		"\xF5\xCC" => "\xE6\x87\xBD",
		"\xF5\xCD" => "\xE6\x94\x9B",
		"\xF5\xCE" => "\xE6\xAC\x82",
		"\xF5\xCF" => "\xE6\xAB\xBC",
		"\xF5\xD0" => "\xE6\xAC\x83",
		"\xF5\xD1" => "\xE6\xAB\xB8",
		"\xF5\xD2" => "\xE6\xAC\x80",
		"\xF5\xD3" => "\xE7\x81\x83",
		"\xF5\xD4" => "\xE7\x81\x84",
		"\xF5\xD5" => "\xE7\x81\x8A",
		"\xF5\xD6" => "\xE7\x81\x88",
		"\xF5\xD7" => "\xE7\x81\x89",
		"\xF5\xD8" => "\xE7\x81\x85",
		"\xF5\xD9" => "\xE7\x81\x86",
		"\xF5\xDA" => "\xE7\x88\x9D",
		"\xF5\xDB" => "\xE7\x88\x9A",
		"\xF5\xDC" => "\xE7\x88\x99",
		"\xF5\xDD" => "\xE7\x8D\xBE",
		"\xF5\xDE" => "\xE7\x94\x97",
		"\xF5\xDF" => "\xE7\x99\xAA",
		"\xF5\xE0" => "\xE7\x9F\x90",
		"\xF5\xE1" => "\xE7\xA4\xAD",
		"\xF5\xE2" => "\xE7\xA4\xB1",
		"\xF5\xE3" => "\xE7\xA4\xAF",
		"\xF5\xE4" => "\xE7\xB1\x94",
		"\xF5\xE5" => "\xE7\xB1\x93",
		"\xF5\xE6" => "\xE7\xB3\xB2",
		"\xF5\xE7" => "\xE7\xBA\x8A",
		"\xF5\xE8" => "\xE7\xBA\x87",
		"\xF5\xE9" => "\xE7\xBA\x88",
		"\xF5\xEA" => "\xE7\xBA\x8B",
		"\xF5\xEB" => "\xE7\xBA\x86",
		"\xF5\xEC" => "\xE7\xBA\x8D",
		"\xF5\xED" => "\xE7\xBD\x8D",
		"\xF5\xEE" => "\xE7\xBE\xBB",
		"\xF5\xEF" => "\xE8\x80\xB0",
		"\xF5\xF0" => "\xE8\x87\x9D",
		"\xF5\xF1" => "\xE8\x98\x98",
		"\xF5\xF2" => "\xE8\x98\xAA",
		"\xF5\xF3" => "\xE8\x98\xA6",
		"\xF5\xF4" => "\xE8\x98\x9F",
		"\xF5\xF5" => "\xE8\x98\xA3",
		"\xF5\xF6" => "\xE8\x98\x9C",
		"\xF5\xF7" => "\xE8\x98\x99",
		"\xF5\xF8" => "\xE8\x98\xA7",
		"\xF5\xF9" => "\xE8\x98\xAE",
		"\xF5\xFA" => "\xE8\x98\xA1",
		"\xF5\xFB" => "\xE8\x98\xA0",
		"\xF5\xFC" => "\xE8\x98\xA9",
		"\xF5\xFD" => "\xE8\x98\x9E",
		"\xF5\xFE" => "\xE8\x98\xA5",
		"\xF6\x40" => "\xE8\xA0\xA9",
		"\xF6\x41" => "\xE8\xA0\x9D",
		"\xF6\x42" => "\xE8\xA0\x9B",
		"\xF6\x43" => "\xE8\xA0\xA0",
		"\xF6\x44" => "\xE8\xA0\xA4",
		"\xF6\x45" => "\xE8\xA0\x9C",
		"\xF6\x46" => "\xE8\xA0\xAB",
		"\xF6\x47" => "\xE8\xA1\x8A",
		"\xF6\x48" => "\xE8\xA5\xAD",
		"\xF6\x49" => "\xE8\xA5\xA9",
		"\xF6\x4A" => "\xE8\xA5\xAE",
		"\xF6\x4B" => "\xE8\xA5\xAB",
		"\xF6\x4C" => "\xE8\xA7\xBA",
		"\xF6\x4D" => "\xE8\xAD\xB9",
		"\xF6\x4E" => "\xE8\xAD\xB8",
		"\xF6\x4F" => "\xE8\xAD\x85",
		"\xF6\x50" => "\xE8\xAD\xBA",
		"\xF6\x51" => "\xE8\xAD\xBB",
		"\xF6\x52" => "\xE8\xB4\x90",
		"\xF6\x53" => "\xE8\xB4\x94",
		"\xF6\x54" => "\xE8\xB6\xAF",
		"\xF6\x55" => "\xE8\xBA\x8E",
		"\xF6\x56" => "\xE8\xBA\x8C",
		"\xF6\x57" => "\xE8\xBD\x9E",
		"\xF6\x58" => "\xE8\xBD\x9B",
		"\xF6\x59" => "\xE8\xBD\x9D",
		"\xF6\x5A" => "\xE9\x85\x86",
		"\xF6\x5B" => "\xE9\x85\x84",
		"\xF6\x5C" => "\xE9\x85\x85",
		"\xF6\x5D" => "\xE9\x86\xB9",
		"\xF6\x5E" => "\xE9\x90\xBF",
		"\xF6\x5F" => "\xE9\x90\xBB",
		"\xF6\x60" => "\xE9\x90\xB6",
		"\xF6\x61" => "\xE9\x90\xA9",
		"\xF6\x62" => "\xE9\x90\xBD",
		"\xF6\x63" => "\xE9\x90\xBC",
		"\xF6\x64" => "\xE9\x90\xB0",
		"\xF6\x65" => "\xE9\x90\xB9",
		"\xF6\x66" => "\xE9\x90\xAA",
		"\xF6\x67" => "\xE9\x90\xB7",
		"\xF6\x68" => "\xE9\x90\xAC",
		"\xF6\x69" => "\xE9\x91\x80",
		"\xF6\x6A" => "\xE9\x90\xB1",
		"\xF6\x6B" => "\xE9\x97\xA5",
		"\xF6\x6C" => "\xE9\x97\xA4",
		"\xF6\x6D" => "\xE9\x97\xA3",
		"\xF6\x6E" => "\xE9\x9C\xB5",
		"\xF6\x6F" => "\xE9\x9C\xBA",
		"\xF6\x70" => "\xE9\x9E\xBF",
		"\xF6\x71" => "\xE9\x9F\xA1",
		"\xF6\x72" => "\xE9\xA1\xA4",
		"\xF6\x73" => "\xE9\xA3\x89",
		"\xF6\x74" => "\xE9\xA3\x86",
		"\xF6\x75" => "\xE9\xA3\x80",
		"\xF6\x76" => "\xE9\xA5\x98",
		"\xF6\x77" => "\xE9\xA5\x96",
		"\xF6\x78" => "\xE9\xA8\xB9",
		"\xF6\x79" => "\xE9\xA8\xBD",
		"\xF6\x7A" => "\xE9\xA9\x86",
		"\xF6\x7B" => "\xE9\xA9\x84",
		"\xF6\x7C" => "\xE9\xA9\x82",
		"\xF6\x7D" => "\xE9\xA9\x81",
		"\xF6\x7E" => "\xE9\xA8\xBA",
		"\xF6\xA1" => "\xE9\xA8\xBF",
		"\xF6\xA2" => "\xE9\xAB\x8D",
		"\xF6\xA3" => "\xE9\xAC\x95",
		"\xF6\xA4" => "\xE9\xAC\x97",
		"\xF6\xA5" => "\xE9\xAC\x98",
		"\xF6\xA6" => "\xE9\xAC\x96",
		"\xF6\xA7" => "\xE9\xAC\xBA",
		"\xF6\xA8" => "\xE9\xAD\x92",
		"\xF6\xA9" => "\xE9\xB0\xAB",
		"\xF6\xAA" => "\xE9\xB0\x9D",
		"\xF6\xAB" => "\xE9\xB0\x9C",
		"\xF6\xAC" => "\xE9\xB0\xAC",
		"\xF6\xAD" => "\xE9\xB0\xA3",
		"\xF6\xAE" => "\xE9\xB0\xA8",
		"\xF6\xAF" => "\xE9\xB0\xA9",
		"\xF6\xB0" => "\xE9\xB0\xA4",
		"\xF6\xB1" => "\xE9\xB0\xA1",
		"\xF6\xB2" => "\xE9\xB6\xB7",
		"\xF6\xB3" => "\xE9\xB6\xB6",
		"\xF6\xB4" => "\xE9\xB6\xBC",
		"\xF6\xB5" => "\xE9\xB7\x81",
		"\xF6\xB6" => "\xE9\xB7\x87",
		"\xF6\xB7" => "\xE9\xB7\x8A",
		"\xF6\xB8" => "\xE9\xB7\x8F",
		"\xF6\xB9" => "\xE9\xB6\xBE",
		"\xF6\xBA" => "\xE9\xB7\x85",
		"\xF6\xBB" => "\xE9\xB7\x83",
		"\xF6\xBC" => "\xE9\xB6\xBB",
		"\xF6\xBD" => "\xE9\xB6\xB5",
		"\xF6\xBE" => "\xE9\xB7\x8E",
		"\xF6\xBF" => "\xE9\xB6\xB9",
		"\xF6\xC0" => "\xE9\xB6\xBA",
		"\xF6\xC1" => "\xE9\xB6\xAC",
		"\xF6\xC2" => "\xE9\xB7\x88",
		"\xF6\xC3" => "\xE9\xB6\xB1",
		"\xF6\xC4" => "\xE9\xB6\xAD",
		"\xF6\xC5" => "\xE9\xB7\x8C",
		"\xF6\xC6" => "\xE9\xB6\xB3",
		"\xF6\xC7" => "\xE9\xB7\x8D",
		"\xF6\xC8" => "\xE9\xB6\xB2",
		"\xF6\xC9" => "\xE9\xB9\xBA",
		"\xF6\xCA" => "\xE9\xBA\x9C",
		"\xF6\xCB" => "\xE9\xBB\xAB",
		"\xF6\xCC" => "\xE9\xBB\xAE",
		"\xF6\xCD" => "\xE9\xBB\xAD",
		"\xF6\xCE" => "\xE9\xBC\x9B",
		"\xF6\xCF" => "\xE9\xBC\x98",
		"\xF6\xD0" => "\xE9\xBC\x9A",
		"\xF6\xD1" => "\xE9\xBC\xB1",
		"\xF6\xD2" => "\xE9\xBD\x8E",
		"\xF6\xD3" => "\xE9\xBD\xA5",
		"\xF6\xD4" => "\xE9\xBD\xA4",
		"\xF6\xD5" => "\xE9\xBE\x92",
		"\xF6\xD6" => "\xE4\xBA\xB9",
		"\xF6\xD7" => "\xE5\x9B\x86",
		"\xF6\xD8" => "\xE5\x9B\x85",
		"\xF6\xD9" => "\xE5\x9B\x8B",
		"\xF6\xDA" => "\xE5\xA5\xB1",
		"\xF6\xDB" => "\xE5\xAD\x8B",
		"\xF6\xDC" => "\xE5\xAD\x8C",
		"\xF6\xDD" => "\xE5\xB7\x95",
		"\xF6\xDE" => "\xE5\xB7\x91",
		"\xF6\xDF" => "\xE5\xBB\xB2",
		"\xF6\xE0" => "\xE6\x94\xA1",
		"\xF6\xE1" => "\xE6\x94\xA0",
		"\xF6\xE2" => "\xE6\x94\xA6",
		"\xF6\xE3" => "\xE6\x94\xA2",
		"\xF6\xE4" => "\xE6\xAC\x8B",
		"\xF6\xE5" => "\xE6\xAC\x88",
		"\xF6\xE6" => "\xE6\xAC\x89",
		"\xF6\xE7" => "\xE6\xB0\x8D",
		"\xF6\xE8" => "\xE7\x81\x95",
		"\xF6\xE9" => "\xE7\x81\x96",
		"\xF6\xEA" => "\xE7\x81\x97",
		"\xF6\xEB" => "\xE7\x81\x92",
		"\xF6\xEC" => "\xE7\x88\x9E",
		"\xF6\xED" => "\xE7\x88\x9F",
		"\xF6\xEE" => "\xE7\x8A\xA9",
		"\xF6\xEF" => "\xE7\x8D\xBF",
		"\xF6\xF0" => "\xE7\x93\x98",
		"\xF6\xF1" => "\xE7\x93\x95",
		"\xF6\xF2" => "\xE7\x93\x99",
		"\xF6\xF3" => "\xE7\x93\x97",
		"\xF6\xF4" => "\xE7\x99\xAD",
		"\xF6\xF5" => "\xE7\x9A\xAD",
		"\xF6\xF6" => "\xE7\xA4\xB5",
		"\xF6\xF7" => "\xE7\xA6\xB4",
		"\xF6\xF8" => "\xE7\xA9\xB0",
		"\xF6\xF9" => "\xE7\xA9\xB1",
		"\xF6\xFA" => "\xE7\xB1\x97",
		"\xF6\xFB" => "\xE7\xB1\x9C",
		"\xF6\xFC" => "\xE7\xB1\x99",
		"\xF6\xFD" => "\xE7\xB1\x9B",
		"\xF6\xFE" => "\xE7\xB1\x9A",
		"\xF7\x40" => "\xE7\xB3\xB4",
		"\xF7\x41" => "\xE7\xB3\xB1",
		"\xF7\x42" => "\xE7\xBA\x91",
		"\xF7\x43" => "\xE7\xBD\x8F",
		"\xF7\x44" => "\xE7\xBE\x87",
		"\xF7\x45" => "\xE8\x87\x9E",
		"\xF7\x46" => "\xE8\x89\xAB",
		"\xF7\x47" => "\xE8\x98\xB4",
		"\xF7\x48" => "\xE8\x98\xB5",
		"\xF7\x49" => "\xE8\x98\xB3",
		"\xF7\x4A" => "\xE8\x98\xAC",
		"\xF7\x4B" => "\xE8\x98\xB2",
		"\xF7\x4C" => "\xE8\x98\xB6",
		"\xF7\x4D" => "\xE8\xA0\xAC",
		"\xF7\x4E" => "\xE8\xA0\xA8",
		"\xF7\x4F" => "\xE8\xA0\xA6",
		"\xF7\x50" => "\xE8\xA0\xAA",
		"\xF7\x51" => "\xE8\xA0\xA5",
		"\xF7\x52" => "\xE8\xA5\xB1",
		"\xF7\x53" => "\xE8\xA6\xBF",
		"\xF7\x54" => "\xE8\xA6\xBE",
		"\xF7\x55" => "\xE8\xA7\xBB",
		"\xF7\x56" => "\xE8\xAD\xBE",
		"\xF7\x57" => "\xE8\xAE\x84",
		"\xF7\x58" => "\xE8\xAE\x82",
		"\xF7\x59" => "\xE8\xAE\x86",
		"\xF7\x5A" => "\xE8\xAE\x85",
		"\xF7\x5B" => "\xE8\xAD\xBF",
		"\xF7\x5C" => "\xE8\xB4\x95",
		"\xF7\x5D" => "\xE8\xBA\x95",
		"\xF7\x5E" => "\xE8\xBA\x94",
		"\xF7\x5F" => "\xE8\xBA\x9A",
		"\xF7\x60" => "\xE8\xBA\x92",
		"\xF7\x61" => "\xE8\xBA\x90",
		"\xF7\x62" => "\xE8\xBA\x96",
		"\xF7\x63" => "\xE8\xBA\x97",
		"\xF7\x64" => "\xE8\xBD\xA0",
		"\xF7\x65" => "\xE8\xBD\xA2",
		"\xF7\x66" => "\xE9\x85\x87",
		"\xF7\x67" => "\xE9\x91\x8C",
		"\xF7\x68" => "\xE9\x91\x90",
		"\xF7\x69" => "\xE9\x91\x8A",
		"\xF7\x6A" => "\xE9\x91\x8B",
		"\xF7\x6B" => "\xE9\x91\x8F",
		"\xF7\x6C" => "\xE9\x91\x87",
		"\xF7\x6D" => "\xE9\x91\x85",
		"\xF7\x6E" => "\xE9\x91\x88",
		"\xF7\x6F" => "\xE9\x91\x89",
		"\xF7\x70" => "\xE9\x91\x86",
		"\xF7\x71" => "\xE9\x9C\xBF",
		"\xF7\x72" => "\xE9\x9F\xA3",
		"\xF7\x73" => "\xE9\xA1\xAA",
		"\xF7\x74" => "\xE9\xA1\xA9",
		"\xF7\x75" => "\xE9\xA3\x8B",
		"\xF7\x76" => "\xE9\xA5\x94",
		"\xF7\x77" => "\xE9\xA5\x9B",
		"\xF7\x78" => "\xE9\xA9\x8E",
		"\xF7\x79" => "\xE9\xA9\x93",
		"\xF7\x7A" => "\xE9\xA9\x94",
		"\xF7\x7B" => "\xE9\xA9\x8C",
		"\xF7\x7C" => "\xE9\xA9\x8F",
		"\xF7\x7D" => "\xE9\xA9\x88",
		"\xF7\x7E" => "\xE9\xA9\x8A",
		"\xF7\xA1" => "\xE9\xA9\x89",
		"\xF7\xA2" => "\xE9\xA9\x92",
		"\xF7\xA3" => "\xE9\xA9\x90",
		"\xF7\xA4" => "\xE9\xAB\x90",
		"\xF7\xA5" => "\xE9\xAC\x99",
		"\xF7\xA6" => "\xE9\xAC\xAB",
		"\xF7\xA7" => "\xE9\xAC\xBB",
		"\xF7\xA8" => "\xE9\xAD\x96",
		"\xF7\xA9" => "\xE9\xAD\x95",
		"\xF7\xAA" => "\xE9\xB1\x86",
		"\xF7\xAB" => "\xE9\xB1\x88",
		"\xF7\xAC" => "\xE9\xB0\xBF",
		"\xF7\xAD" => "\xE9\xB1\x84",
		"\xF7\xAE" => "\xE9\xB0\xB9",
		"\xF7\xAF" => "\xE9\xB0\xB3",
		"\xF7\xB0" => "\xE9\xB1\x81",
		"\xF7\xB1" => "\xE9\xB0\xBC",
		"\xF7\xB2" => "\xE9\xB0\xB7",
		"\xF7\xB3" => "\xE9\xB0\xB4",
		"\xF7\xB4" => "\xE9\xB0\xB2",
		"\xF7\xB5" => "\xE9\xB0\xBD",
		"\xF7\xB6" => "\xE9\xB0\xB6",
		"\xF7\xB7" => "\xE9\xB7\x9B",
		"\xF7\xB8" => "\xE9\xB7\x92",
		"\xF7\xB9" => "\xE9\xB7\x9E",
		"\xF7\xBA" => "\xE9\xB7\x9A",
		"\xF7\xBB" => "\xE9\xB7\x8B",
		"\xF7\xBC" => "\xE9\xB7\x90",
		"\xF7\xBD" => "\xE9\xB7\x9C",
		"\xF7\xBE" => "\xE9\xB7\x91",
		"\xF7\xBF" => "\xE9\xB7\x9F",
		"\xF7\xC0" => "\xE9\xB7\xA9",
		"\xF7\xC1" => "\xE9\xB7\x99",
		"\xF7\xC2" => "\xE9\xB7\x98",
		"\xF7\xC3" => "\xE9\xB7\x96",
		"\xF7\xC4" => "\xE9\xB7\xB5",
		"\xF7\xC5" => "\xE9\xB7\x95",
		"\xF7\xC6" => "\xE9\xB7\x9D",
		"\xF7\xC7" => "\xE9\xBA\xB6",
		"\xF7\xC8" => "\xE9\xBB\xB0",
		"\xF7\xC9" => "\xE9\xBC\xB5",
		"\xF7\xCA" => "\xE9\xBC\xB3",
		"\xF7\xCB" => "\xE9\xBC\xB2",
		"\xF7\xCC" => "\xE9\xBD\x82",
		"\xF7\xCD" => "\xE9\xBD\xAB",
		"\xF7\xCE" => "\xE9\xBE\x95",
		"\xF7\xCF" => "\xE9\xBE\xA2",
		"\xF7\xD0" => "\xE5\x84\xBD",
		"\xF7\xD1" => "\xE5\x8A\x99",
		"\xF7\xD2" => "\xE5\xA3\xA8",
		"\xF7\xD3" => "\xE5\xA3\xA7",
		"\xF7\xD4" => "\xE5\xA5\xB2",
		"\xF7\xD5" => "\xE5\xAD\x8D",
		"\xF7\xD6" => "\xE5\xB7\x98",
		"\xF7\xD7" => "\xE8\xA0\xAF",
		"\xF7\xD8" => "\xE5\xBD\x8F",
		"\xF7\xD9" => "\xE6\x88\x81",
		"\xF7\xDA" => "\xE6\x88\x83",
		"\xF7\xDB" => "\xE6\x88\x84",
		"\xF7\xDC" => "\xE6\x94\xA9",
		"\xF7\xDD" => "\xE6\x94\xA5",
		"\xF7\xDE" => "\xE6\x96\x96",
		"\xF7\xDF" => "\xE6\x9B\xAB",
		"\xF7\xE0" => "\xE6\xAC\x91",
		"\xF7\xE1" => "\xE6\xAC\x92",
		"\xF7\xE2" => "\xE6\xAC\x8F",
		"\xF7\xE3" => "\xE6\xAF\x8A",
		"\xF7\xE4" => "\xE7\x81\x9B",
		"\xF7\xE5" => "\xE7\x81\x9A",
		"\xF7\xE6" => "\xE7\x88\xA2",
		"\xF7\xE7" => "\xE7\x8E\x82",
		"\xF7\xE8" => "\xE7\x8E\x81",
		"\xF7\xE9" => "\xE7\x8E\x83",
		"\xF7\xEA" => "\xE7\x99\xB0",
		"\xF7\xEB" => "\xE7\x9F\x94",
		"\xF7\xEC" => "\xE7\xB1\xA7",
		"\xF7\xED" => "\xE7\xB1\xA6",
		"\xF7\xEE" => "\xE7\xBA\x95",
		"\xF7\xEF" => "\xE8\x89\xAC",
		"\xF7\xF0" => "\xE8\x98\xBA",
		"\xF7\xF1" => "\xE8\x99\x80",
		"\xF7\xF2" => "\xE8\x98\xB9",
		"\xF7\xF3" => "\xE8\x98\xBC",
		"\xF7\xF4" => "\xE8\x98\xB1",
		"\xF7\xF5" => "\xE8\x98\xBB",
		"\xF7\xF6" => "\xE8\x98\xBE",
		"\xF7\xF7" => "\xE8\xA0\xB0",
		"\xF7\xF8" => "\xE8\xA0\xB2",
		"\xF7\xF9" => "\xE8\xA0\xAE",
		"\xF7\xFA" => "\xE8\xA0\xB3",
		"\xF7\xFB" => "\xE8\xA5\xB6",
		"\xF7\xFC" => "\xE8\xA5\xB4",
		"\xF7\xFD" => "\xE8\xA5\xB3",
		"\xF7\xFE" => "\xE8\xA7\xBE",
		"\xF8\x40" => "\xE8\xAE\x8C",
		"\xF8\x41" => "\xE8\xAE\x8E",
		"\xF8\x42" => "\xE8\xAE\x8B",
		"\xF8\x43" => "\xE8\xAE\x88",
		"\xF8\x44" => "\xE8\xB1\x85",
		"\xF8\x45" => "\xE8\xB4\x99",
		"\xF8\x46" => "\xE8\xBA\x98",
		"\xF8\x47" => "\xE8\xBD\xA4",
		"\xF8\x48" => "\xE8\xBD\xA3",
		"\xF8\x49" => "\xE9\x86\xBC",
		"\xF8\x4A" => "\xE9\x91\xA2",
		"\xF8\x4B" => "\xE9\x91\x95",
		"\xF8\x4C" => "\xE9\x91\x9D",
		"\xF8\x4D" => "\xE9\x91\x97",
		"\xF8\x4E" => "\xE9\x91\x9E",
		"\xF8\x4F" => "\xE9\x9F\x84",
		"\xF8\x50" => "\xE9\x9F\x85",
		"\xF8\x51" => "\xE9\xA0\x80",
		"\xF8\x52" => "\xE9\xA9\x96",
		"\xF8\x53" => "\xE9\xA9\x99",
		"\xF8\x54" => "\xE9\xAC\x9E",
		"\xF8\x55" => "\xE9\xAC\x9F",
		"\xF8\x56" => "\xE9\xAC\xA0",
		"\xF8\x57" => "\xE9\xB1\x92",
		"\xF8\x58" => "\xE9\xB1\x98",
		"\xF8\x59" => "\xE9\xB1\x90",
		"\xF8\x5A" => "\xE9\xB1\x8A",
		"\xF8\x5B" => "\xE9\xB1\x8D",
		"\xF8\x5C" => "\xE9\xB1\x8B",
		"\xF8\x5D" => "\xE9\xB1\x95",
		"\xF8\x5E" => "\xE9\xB1\x99",
		"\xF8\x5F" => "\xE9\xB1\x8C",
		"\xF8\x60" => "\xE9\xB1\x8E",
		"\xF8\x61" => "\xE9\xB7\xBB",
		"\xF8\x62" => "\xE9\xB7\xB7",
		"\xF8\x63" => "\xE9\xB7\xAF",
		"\xF8\x64" => "\xE9\xB7\xA3",
		"\xF8\x65" => "\xE9\xB7\xAB",
		"\xF8\x66" => "\xE9\xB7\xB8",
		"\xF8\x67" => "\xE9\xB7\xA4",
		"\xF8\x68" => "\xE9\xB7\xB6",
		"\xF8\x69" => "\xE9\xB7\xA1",
		"\xF8\x6A" => "\xE9\xB7\xAE",
		"\xF8\x6B" => "\xE9\xB7\xA6",
		"\xF8\x6C" => "\xE9\xB7\xB2",
		"\xF8\x6D" => "\xE9\xB7\xB0",
		"\xF8\x6E" => "\xE9\xB7\xA2",
		"\xF8\x6F" => "\xE9\xB7\xAC",
		"\xF8\x70" => "\xE9\xB7\xB4",
		"\xF8\x71" => "\xE9\xB7\xB3",
		"\xF8\x72" => "\xE9\xB7\xA8",
		"\xF8\x73" => "\xE9\xB7\xAD",
		"\xF8\x74" => "\xE9\xBB\x82",
		"\xF8\x75" => "\xE9\xBB\x90",
		"\xF8\x76" => "\xE9\xBB\xB2",
		"\xF8\x77" => "\xE9\xBB\xB3",
		"\xF8\x78" => "\xE9\xBC\x86",
		"\xF8\x79" => "\xE9\xBC\x9C",
		"\xF8\x7A" => "\xE9\xBC\xB8",
		"\xF8\x7B" => "\xE9\xBC\xB7",
		"\xF8\x7C" => "\xE9\xBC\xB6",
		"\xF8\x7D" => "\xE9\xBD\x83",
		"\xF8\x7E" => "\xE9\xBD\x8F",
		"\xF8\xA1" => "\xE9\xBD\xB1",
		"\xF8\xA2" => "\xE9\xBD\xB0",
		"\xF8\xA3" => "\xE9\xBD\xAE",
		"\xF8\xA4" => "\xE9\xBD\xAF",
		"\xF8\xA5" => "\xE5\x9B\x93",
		"\xF8\xA6" => "\xE5\x9B\x8D",
		"\xF8\xA7" => "\xE5\xAD\x8E",
		"\xF8\xA8" => "\xE5\xB1\xAD",
		"\xF8\xA9" => "\xE6\x94\xAD",
		"\xF8\xAA" => "\xE6\x9B\xAD",
		"\xF8\xAB" => "\xE6\x9B\xAE",
		"\xF8\xAC" => "\xE6\xAC\x93",
		"\xF8\xAD" => "\xE7\x81\x9F",
		"\xF8\xAE" => "\xE7\x81\xA1",
		"\xF8\xAF" => "\xE7\x81\x9D",
		"\xF8\xB0" => "\xE7\x81\xA0",
		"\xF8\xB1" => "\xE7\x88\xA3",
		"\xF8\xB2" => "\xE7\x93\x9B",
		"\xF8\xB3" => "\xE7\x93\xA5",
		"\xF8\xB4" => "\xE7\x9F\x95",
		"\xF8\xB5" => "\xE7\xA4\xB8",
		"\xF8\xB6" => "\xE7\xA6\xB7",
		"\xF8\xB7" => "\xE7\xA6\xB6",
		"\xF8\xB8" => "\xE7\xB1\xAA",
		"\xF8\xB9" => "\xE7\xBA\x97",
		"\xF8\xBA" => "\xE7\xBE\x89",
		"\xF8\xBB" => "\xE8\x89\xAD",
		"\xF8\xBC" => "\xE8\x99\x83",
		"\xF8\xBD" => "\xE8\xA0\xB8",
		"\xF8\xBE" => "\xE8\xA0\xB7",
		"\xF8\xBF" => "\xE8\xA0\xB5",
		"\xF8\xC0" => "\xE8\xA1\x8B",
		"\xF8\xC1" => "\xE8\xAE\x94",
		"\xF8\xC2" => "\xE8\xAE\x95",
		"\xF8\xC3" => "\xE8\xBA\x9E",
		"\xF8\xC4" => "\xE8\xBA\x9F",
		"\xF8\xC5" => "\xE8\xBA\xA0",
		"\xF8\xC6" => "\xE8\xBA\x9D",
		"\xF8\xC7" => "\xE9\x86\xBE",
		"\xF8\xC8" => "\xE9\x86\xBD",
		"\xF8\xC9" => "\xE9\x87\x82",
		"\xF8\xCA" => "\xE9\x91\xAB",
		"\xF8\xCB" => "\xE9\x91\xA8",
		"\xF8\xCC" => "\xE9\x91\xA9",
		"\xF8\xCD" => "\xE9\x9B\xA5",
		"\xF8\xCE" => "\xE9\x9D\x86",
		"\xF8\xCF" => "\xE9\x9D\x83",
		"\xF8\xD0" => "\xE9\x9D\x87",
		"\xF8\xD1" => "\xE9\x9F\x87",
		"\xF8\xD2" => "\xE9\x9F\xA5",
		"\xF8\xD3" => "\xE9\xA9\x9E",
		"\xF8\xD4" => "\xE9\xAB\x95",
		"\xF8\xD5" => "\xE9\xAD\x99",
		"\xF8\xD6" => "\xE9\xB1\xA3",
		"\xF8\xD7" => "\xE9\xB1\xA7",
		"\xF8\xD8" => "\xE9\xB1\xA6",
		"\xF8\xD9" => "\xE9\xB1\xA2",
		"\xF8\xDA" => "\xE9\xB1\x9E",
		"\xF8\xDB" => "\xE9\xB1\xA0",
		"\xF8\xDC" => "\xE9\xB8\x82",
		"\xF8\xDD" => "\xE9\xB7\xBE",
		"\xF8\xDE" => "\xE9\xB8\x87",
		"\xF8\xDF" => "\xE9\xB8\x83",
		"\xF8\xE0" => "\xE9\xB8\x86",
		"\xF8\xE1" => "\xE9\xB8\x85",
		"\xF8\xE2" => "\xE9\xB8\x80",
		"\xF8\xE3" => "\xE9\xB8\x81",
		"\xF8\xE4" => "\xE9\xB8\x89",
		"\xF8\xE5" => "\xE9\xB7\xBF",
		"\xF8\xE6" => "\xE9\xB7\xBD",
		"\xF8\xE7" => "\xE9\xB8\x84",
		"\xF8\xE8" => "\xE9\xBA\xA0",
		"\xF8\xE9" => "\xE9\xBC\x9E",
		"\xF8\xEA" => "\xE9\xBD\x86",
		"\xF8\xEB" => "\xE9\xBD\xB4",
		"\xF8\xEC" => "\xE9\xBD\xB5",
		"\xF8\xED" => "\xE9\xBD\xB6",
		"\xF8\xEE" => "\xE5\x9B\x94",
		"\xF8\xEF" => "\xE6\x94\xAE",
		"\xF8\xF0" => "\xE6\x96\xB8",
		"\xF8\xF1" => "\xE6\xAC\x98",
		"\xF8\xF2" => "\xE6\xAC\x99",
		"\xF8\xF3" => "\xE6\xAC\x97",
		"\xF8\xF4" => "\xE6\xAC\x9A",
		"\xF8\xF5" => "\xE7\x81\xA2",
		"\xF8\xF6" => "\xE7\x88\xA6",
		"\xF8\xF7" => "\xE7\x8A\xAA",
		"\xF8\xF8" => "\xE7\x9F\x98",
		"\xF8\xF9" => "\xE7\x9F\x99",
		"\xF8\xFA" => "\xE7\xA4\xB9",
		"\xF8\xFB" => "\xE7\xB1\xA9",
		"\xF8\xFC" => "\xE7\xB1\xAB",
		"\xF8\xFD" => "\xE7\xB3\xB6",
		"\xF8\xFE" => "\xE7\xBA\x9A",
		"\xF9\x40" => "\xE7\xBA\x98",
		"\xF9\x41" => "\xE7\xBA\x9B",
		"\xF9\x42" => "\xE7\xBA\x99",
		"\xF9\x43" => "\xE8\x87\xA0",
		"\xF9\x44" => "\xE8\x87\xA1",
		"\xF9\x45" => "\xE8\x99\x86",
		"\xF9\x46" => "\xE8\x99\x87",
		"\xF9\x47" => "\xE8\x99\x88",
		"\xF9\x48" => "\xE8\xA5\xB9",
		"\xF9\x49" => "\xE8\xA5\xBA",
		"\xF9\x4A" => "\xE8\xA5\xBC",
		"\xF9\x4B" => "\xE8\xA5\xBB",
		"\xF9\x4C" => "\xE8\xA7\xBF",
		"\xF9\x4D" => "\xE8\xAE\x98",
		"\xF9\x4E" => "\xE8\xAE\x99",
		"\xF9\x4F" => "\xE8\xBA\xA5",
		"\xF9\x50" => "\xE8\xBA\xA4",
		"\xF9\x51" => "\xE8\xBA\xA3",
		"\xF9\x52" => "\xE9\x91\xAE",
		"\xF9\x53" => "\xE9\x91\xAD",
		"\xF9\x54" => "\xE9\x91\xAF",
		"\xF9\x55" => "\xE9\x91\xB1",
		"\xF9\x56" => "\xE9\x91\xB3",
		"\xF9\x57" => "\xE9\x9D\x89",
		"\xF9\x58" => "\xE9\xA1\xB2",
		"\xF9\x59" => "\xE9\xA5\x9F",
		"\xF9\x5A" => "\xE9\xB1\xA8",
		"\xF9\x5B" => "\xE9\xB1\xAE",
		"\xF9\x5C" => "\xE9\xB1\xAD",
		"\xF9\x5D" => "\xE9\xB8\x8B",
		"\xF9\x5E" => "\xE9\xB8\x8D",
		"\xF9\x5F" => "\xE9\xB8\x90",
		"\xF9\x60" => "\xE9\xB8\x8F",
		"\xF9\x61" => "\xE9\xB8\x92",
		"\xF9\x62" => "\xE9\xB8\x91",
		"\xF9\x63" => "\xE9\xBA\xA1",
		"\xF9\x64" => "\xE9\xBB\xB5",
		"\xF9\x65" => "\xE9\xBC\x89",
		"\xF9\x66" => "\xE9\xBD\x87",
		"\xF9\x67" => "\xE9\xBD\xB8",
		"\xF9\x68" => "\xE9\xBD\xBB",
		"\xF9\x69" => "\xE9\xBD\xBA",
		"\xF9\x6A" => "\xE9\xBD\xB9",
		"\xF9\x6B" => "\xE5\x9C\x9E",
		"\xF9\x6C" => "\xE7\x81\xA6",
		"\xF9\x6D" => "\xE7\xB1\xAF",
		"\xF9\x6E" => "\xE8\xA0\xBC",
		"\xF9\x6F" => "\xE8\xB6\xB2",
		"\xF9\x70" => "\xE8\xBA\xA6",
		"\xF9\x71" => "\xE9\x87\x83",
		"\xF9\x72" => "\xE9\x91\xB4",
		"\xF9\x73" => "\xE9\x91\xB8",
		"\xF9\x74" => "\xE9\x91\xB6",
		"\xF9\x75" => "\xE9\x91\xB5",
		"\xF9\x76" => "\xE9\xA9\xA0",
		"\xF9\x77" => "\xE9\xB1\xB4",
		"\xF9\x78" => "\xE9\xB1\xB3",
		"\xF9\x79" => "\xE9\xB1\xB1",
		"\xF9\x7A" => "\xE9\xB1\xB5",
		"\xF9\x7B" => "\xE9\xB8\x94",
		"\xF9\x7C" => "\xE9\xB8\x93",
		"\xF9\x7D" => "\xE9\xBB\xB6",
		"\xF9\x7E" => "\xE9\xBC\x8A",
		"\xF9\xA1" => "\xE9\xBE\xA4",
		"\xF9\xA2" => "\xE7\x81\xA8",
		"\xF9\xA3" => "\xE7\x81\xA5",
		"\xF9\xA4" => "\xE7\xB3\xB7",
		"\xF9\xA5" => "\xE8\x99\xAA",
		"\xF9\xA6" => "\xE8\xA0\xBE",
		"\xF9\xA7" => "\xE8\xA0\xBD",
		"\xF9\xA8" => "\xE8\xA0\xBF",
		"\xF9\xA9" => "\xE8\xAE\x9E",
		"\xF9\xAA" => "\xE8\xB2\x9C",
		"\xF9\xAB" => "\xE8\xBA\xA9",
		"\xF9\xAC" => "\xE8\xBB\x89",
		"\xF9\xAD" => "\xE9\x9D\x8B",
		"\xF9\xAE" => "\xE9\xA1\xB3",
		"\xF9\xAF" => "\xE9\xA1\xB4",
		"\xF9\xB0" => "\xE9\xA3\x8C",
		"\xF9\xB1" => "\xE9\xA5\xA1",
		"\xF9\xB2" => "\xE9\xA6\xAB",
		"\xF9\xB3" => "\xE9\xA9\xA4",
		"\xF9\xB4" => "\xE9\xA9\xA6",
		"\xF9\xB5" => "\xE9\xA9\xA7",
		"\xF9\xB6" => "\xE9\xAC\xA4",
		"\xF9\xB7" => "\xE9\xB8\x95",
		"\xF9\xB8" => "\xE9\xB8\x97",
		"\xF9\xB9" => "\xE9\xBD\x88",
		"\xF9\xBA" => "\xE6\x88\x87",
		"\xF9\xBB" => "\xE6\xAC\x9E",
		"\xF9\xBC" => "\xE7\x88\xA7",
		"\xF9\xBD" => "\xE8\x99\x8C",
		"\xF9\xBE" => "\xE8\xBA\xA8",
		"\xF9\xBF" => "\xE9\x92\x82",
		"\xF9\xC0" => "\xE9\x92\x80",
		"\xF9\xC1" => "\xE9\x92\x81",
		"\xF9\xC2" => "\xE9\xA9\xA9",
		"\xF9\xC3" => "\xE9\xA9\xA8",
		"\xF9\xC4" => "\xE9\xAC\xAE",
		"\xF9\xC5" => "\xE9\xB8\x99",
		"\xF9\xC6" => "\xE7\x88\xA9",
		"\xF9\xC7" => "\xE8\x99\x8B",
		"\xF9\xC8" => "\xE8\xAE\x9F",
		"\xF9\xC9" => "\xE9\x92\x83",
		"\xF9\xCA" => "\xE9\xB1\xB9",
		"\xF9\xCB" => "\xE9\xBA\xB7",
		"\xF9\xCC" => "\xE7\x99\xB5",
		"\xF9\xCD" => "\xE9\xA9\xAB",
		"\xF9\xCE" => "\xE9\xB1\xBA",
		"\xF9\xCF" => "\xE9\xB8\x9D",
		"\xF9\xD0" => "\xE7\x81\xA9",
		"\xF9\xD1" => "\xE7\x81\xAA",
		"\xF9\xD2" => "\xE9\xBA\xA4",
		"\xF9\xD3" => "\xE9\xBD\xBE",
		"\xF9\xD4" => "\xE9\xBD\x89",
		"\xF9\xD5" => "\xE9\xBE\x98",
	);
	return strtr($string, $transform);
}

?>